/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var t=[],i=0,F=se.length;i<F;i++)t[i]=me[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ct,construct:Rt}=typeof Reflect<"u"&&Reflect;Ct||(Ct=function(t,i,F){return t.apply(i,F)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Lt=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var i=arguments.length,F=new Array(i>1?i-1:0),B=1;B<i;B++)F[B-1]=arguments[B];return Ct(se,t,F)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),F=0;F<t;F++)i[F]=arguments[F];return Rt(se,i)}}function He(se,t,i){var F;i=(F=i)!==null&&F!==void 0?F:yt,xt&&xt(se,null);let B=t.length;for(;B--;){let H=t[B];if(typeof H=="string"){const S=i(H);S!==H&&(ii(t)||(t[B]=S),H=S)}se[H]=!0}return se}function bt(se){const t=ri(null);for(const[i,F]of Bt(se))t[i]=F;return t}function Et(se,t){for(;se!==null;){const F=si(se,t);if(F){if(F.get)return ct(F.get);if(typeof F.value=="function")return ct(F.value)}se=ni(se)}function i(F){return console.warn("fallback value for",F),null}return i}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Mt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Nt=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=ft(/^html$/i);var Xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Gt});const vi=()=>typeof window>"u"?null:window,Di=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let F=null;const B="data-tt-policy-suffix";i&&i.hasAttribute(B)&&(F=i.getAttribute(B));const H="dompurify"+(F?"#"+F:"");try{return t.createPolicy(H,{createHTML(S){return S},createScriptURL(S){return S}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Yt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Yt(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,F=i.currentScript;let{document:B}=se;const{DocumentFragment:H,HTMLTemplateElement:S,Node:k,Element:f,NodeFilter:g,NamedNodeMap:w=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:P,DOMParser:u,trustedTypes:c}=se,e=f.prototype,n=Et(e,"cloneNode"),o=Et(e,"nextSibling"),l=Et(e,"childNodes"),d=Et(e,"parentNode");if(typeof S=="function"){const Be=B.createElement("template");Be.content&&Be.content.ownerDocument&&(B=Be.content.ownerDocument)}let N,b="";const{implementation:m,createNodeIterator:r,createDocumentFragment:y,getElementsByTagName:A}=B,{importNode:T}=i;let M={};t.isSupported=typeof Bt=="function"&&typeof d=="function"&&m&&m.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:q,ERB_EXPR:$,TMPLIT_EXPR:I,DATA_ATTR:V,ARIA_ATTR:R,IS_SCRIPT_OR_DATA:x,ATTR_WHITESPACE:O}=Xt;let{IS_ALLOWED_URI:X}=Xt,K=null;const ae=He({},[...Ht,...Mt,...It,...jt,...Wt]);let ie=null;const ee=He({},[...Vt,...Ot,...qt,...Nt]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ye=null,Ee=null,Me=!0,le=!0,_=!1,ue=!0,re=!1,De=!1,W=!1,Q=!1,ge=!1,we=!1,Ae=!1,Te=!0,Ie=!1;const z="user-content-";let h=!0,D=!1,a={},v=null;const C=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const E=He({},["audio","video","img","source","image","track"]);let p=null;const L=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),j="http://www.w3.org/1998/Math/MathML",Y="http://www.w3.org/2000/svg",J="http://www.w3.org/1999/xhtml";let oe=J,pe=!1,fe=null;const Le=He({},[j,Y,J],Lt);let ke;const Oe=["application/xhtml+xml","text/html"],Ne="text/html";let Fe,We=null;const Ue=B.createElement("form"),Ye=function(he){return he instanceof RegExp||he instanceof Function},_e=function(he){if(!(We&&We===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),ke=Oe.indexOf(he.PARSER_MEDIA_TYPE)===-1?ke=Ne:ke=he.PARSER_MEDIA_TYPE,Fe=ke==="application/xhtml+xml"?Lt:yt,K="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Fe):ae,ie="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Fe):ee,fe="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Lt):Le,p="ADD_URI_SAFE_ATTR"in he?He(bt(L),he.ADD_URI_SAFE_ATTR,Fe):L,s="ADD_DATA_URI_TAGS"in he?He(bt(E),he.ADD_DATA_URI_TAGS,Fe):E,v="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Fe):C,ye="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Fe):{},Ee="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Fe):{},a="USE_PROFILES"in he?he.USE_PROFILES:!1,Me=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,_=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ue=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,De=he.WHOLE_DOCUMENT||!1,ge=he.RETURN_DOM||!1,we=he.RETURN_DOM_FRAGMENT||!1,Ae=he.RETURN_TRUSTED_TYPE||!1,Q=he.FORCE_BODY||!1,Te=he.SANITIZE_DOM!==!1,Ie=he.SANITIZE_NAMED_PROPS||!1,h=he.KEEP_CONTENT!==!1,D=he.IN_PLACE||!1,X=he.ALLOWED_URI_REGEXP||Kt,oe=he.NAMESPACE||J,ce=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ye(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ye(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),we&&(ge=!0),a&&(K=He({},[...Wt]),ie=[],a.html===!0&&(He(K,Ht),He(ie,Vt)),a.svg===!0&&(He(K,Mt),He(ie,Ot),He(ie,Nt)),a.svgFilters===!0&&(He(K,It),He(ie,Ot),He(ie,Nt)),a.mathMl===!0&&(He(K,jt),He(ie,qt),He(ie,Nt))),he.ADD_TAGS&&(K===ae&&(K=bt(K)),He(K,he.ADD_TAGS,Fe)),he.ADD_ATTR&&(ie===ee&&(ie=bt(ie)),He(ie,he.ADD_ATTR,Fe)),he.ADD_URI_SAFE_ATTR&&He(p,he.ADD_URI_SAFE_ATTR,Fe),he.FORBID_CONTENTS&&(v===C&&(v=bt(v)),He(v,he.FORBID_CONTENTS,Fe)),h&&(K["#text"]=!0),De&&He(K,["html","head","body"]),K.table&&(He(K,["tbody"]),delete ye.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');N=he.TRUSTED_TYPES_POLICY,b=N.createHTML("")}else N===void 0&&(N=Di(c,F)),N!==null&&typeof b=="string"&&(b=N.createHTML(""));ot&&ot(he),We=he}},Z=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),$e=He({},["title","style","font","a","script"]),ve=He({},Mt);He(ve,It),He(ve,ci);const Re=He({},jt);He(Re,fi);const ze=function(he){let Ce=d(he);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:oe,tagName:"template"});const je=yt(he.tagName),Ge=yt(Ce.tagName);return fe[he.namespaceURI]?he.namespaceURI===Y?Ce.namespaceURI===J?je==="svg":Ce.namespaceURI===j?je==="svg"&&(Ge==="annotation-xml"||Z[Ge]):!!ve[je]:he.namespaceURI===j?Ce.namespaceURI===J?je==="math":Ce.namespaceURI===Y?je==="math"&&ne[Ge]:!!Re[je]:he.namespaceURI===J?Ce.namespaceURI===Y&&!ne[Ge]||Ce.namespaceURI===j&&!Z[Ge]?!1:!Re[je]&&($e[je]||!ve[je]):!!(ke==="application/xhtml+xml"&&fe[he.namespaceURI]):!1},Ve=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Ce){try{wt(t.removed,{attribute:Ce.getAttributeNode(he),from:Ce})}catch{wt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(he),he==="is"&&!ie[he])if(ge||we)try{Ve(Ce)}catch{}else try{Ce.setAttribute(he,"")}catch{}},it=function(he){let Ce,je;if(Q)he="<remove></remove>"+he;else{const lt=ai(he,/^[\r\n\t ]+/);je=lt&&lt[0]}ke==="application/xhtml+xml"&&oe===J&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ge=N?N.createHTML(he):he;if(oe===J)try{Ce=new u().parseFromString(Ge,ke)}catch{}if(!Ce||!Ce.documentElement){Ce=m.createDocument(oe,"template",null);try{Ce.documentElement.innerHTML=pe?b:Ge}catch{}}const nt=Ce.body||Ce.documentElement;return he&&je&&nt.insertBefore(B.createTextNode(je),nt.childNodes[0]||null),oe===J?A.call(Ce,De?"html":"body")[0]:De?Ce.documentElement:nt},st=function(he){return r.call(he.ownerDocument||he,he,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Qe=function(he){return he instanceof P&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof w)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof k=="object"?he instanceof k:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},tt=function(he,Ce,je){M[he]&&oi(M[he],Ge=>{Ge.call(t,Ce,je,We)})},mt=function(he){let Ce;if(tt("beforeSanitizeElements",he,null),Qe(he))return Ve(he),!0;const je=Fe(he.nodeName);if(tt("uponSanitizeElement",he,{tagName:je,allowedTags:K}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!K[je]||ye[je]){if(!ye[je]&&St(je)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je)))return!1;if(h&&!v[je]){const Ge=d(he)||he.parentNode,nt=l(he)||he.childNodes;if(nt&&Ge){const lt=nt.length;for(let Ze=lt-1;Ze>=0;--Ze)Ge.insertBefore(n(nt[Ze],!0),o(he))}}return Ve(he),!0}return he instanceof f&&!ze(he)||(je==="noscript"||je==="noembed"||je==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Ce=he.textContent,Ce=dt(Ce,q," "),Ce=dt(Ce,$," "),Ce=dt(Ce,I," "),he.textContent!==Ce&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Ce)),tt("afterSanitizeElements",he,null),!1)},gt=function(he,Ce,je){if(Te&&(Ce==="id"||Ce==="name")&&(je in B||je in Ue))return!1;if(!(le&&!Ee[Ce]&&ht(V,Ce))){if(!(Me&&ht(R,Ce))){if(!ie[Ce]||Ee[Ce]){if(!(St(he)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,he)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(he))&&(ce.attributeNameCheck instanceof RegExp&&ht(ce.attributeNameCheck,Ce)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Ce))||Ce==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je))))return!1}else if(!p[Ce]){if(!ht(X,dt(je,O,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&he!=="script"&&li(je,"data:")===0&&s[he])){if(!(_&&!ht(x,dt(je,O,"")))){if(je)return!1}}}}}}return!0},St=function(he){return he.indexOf("-")>0},At=function(he){let Ce,je,Ge,nt;tt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(nt=lt.length;nt--;){Ce=lt[nt];const{name:ut,namespaceURI:$t}=Ce;if(je=ut==="value"?Ce.value:hi(Ce.value),Ge=Fe(ut),Ze.attrName=Ge,Ze.attrValue=je,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,tt("uponSanitizeAttribute",he,Ze),je=Ze.attrValue,Ze.forceKeepAttr||(et(ut,he),!Ze.keepAttr))continue;if(!ue&&ht(/\/>/i,je)){et(ut,he);continue}re&&(je=dt(je,q," "),je=dt(je,$," "),je=dt(je,I," "));const Tt=Fe(he.nodeName);if(gt(Tt,Ge,je)){if(Ie&&(Ge==="id"||Ge==="name")&&(et(ut,he),je=z+je),N&&typeof c=="object"&&typeof c.getAttributeType=="function"&&!$t)switch(c.getAttributeType(Tt,Ge)){case"TrustedHTML":{je=N.createHTML(je);break}case"TrustedScriptURL":{je=N.createScriptURL(je);break}}try{$t?he.setAttributeNS($t,ut,je):he.setAttribute(ut,je),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",he,null)},kt=function Be(he){let Ce;const je=st(he);for(tt("beforeSanitizeShadowDOM",he,null);Ce=je.nextNode();)tt("uponSanitizeShadowNode",Ce,null),!mt(Ce)&&(Ce.content instanceof H&&Be(Ce.content),At(Ce));tt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Be){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ce,je,Ge,nt;if(pe=!Be,pe&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(W||_e(he),t.removed=[],typeof Be=="string"&&(D=!1),D){if(Be.nodeName){const ut=Fe(Be.nodeName);if(!K[ut]||ye[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof k)Ce=it("<!---->"),je=Ce.ownerDocument.importNode(Be,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Ce=je:Ce.appendChild(je);else{if(!ge&&!re&&!De&&Be.indexOf("<")===-1)return N&&Ae?N.createHTML(Be):Be;if(Ce=it(Be),!Ce)return ge?null:Ae?b:""}Ce&&Q&&Ve(Ce.firstChild);const lt=st(D?Be:Ce);for(;Ge=lt.nextNode();)mt(Ge)||(Ge.content instanceof H&&kt(Ge.content),At(Ge));if(D)return Be;if(ge){if(we)for(nt=y.call(Ce.ownerDocument);Ce.firstChild;)nt.appendChild(Ce.firstChild);else nt=Ce;return(ie.shadowroot||ie.shadowrootmode)&&(nt=T.call(i,nt,!0)),nt}let Ze=De?Ce.outerHTML:Ce.innerHTML;return De&&K["!doctype"]&&Ce.ownerDocument&&Ce.ownerDocument.doctype&&Ce.ownerDocument.doctype.name&&ht(Gt,Ce.ownerDocument.doctype.name)&&(Ze="<!DOCTYPE "+Ce.ownerDocument.doctype.name+`>
`+Ze),re&&(Ze=dt(Ze,q," "),Ze=dt(Ze,$," "),Ze=dt(Ze,I," ")),N&&Ae?N.createHTML(Ze):Ze},t.setConfig=function(Be){_e(Be),W=!0},t.clearConfig=function(){We=null,W=!1},t.isValidAttribute=function(Be,he,Ce){We||_e({});const je=Fe(Be),Ge=Fe(he);return gt(je,Ge,Ce)},t.addHook=function(Be,he){typeof he=="function"&&(M[Be]=M[Be]||[],wt(M[Be],he))},t.removeHook=function(Be){if(M[Be])return zt(M[Be])},t.removeHooks=function(Be){M[Be]&&(M[Be]=[])},t.removeAllHooks=function(){M={}},t}var yi=Yt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(me[51],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iT=void 0,t.$jT=B;class i{constructor(S){this.domNode=S,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(S){const k=F(S);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(S){const k=F(S);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(S){const k=F(S);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(S){const k=F(S);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(S){const k=F(S);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(S){const k=F(S);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(S){const k=F(S);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(S){const k=F(S);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(S){const k=F(S);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(S){const k=F(S);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(S){const k=F(S);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(S){this.l!==S&&(this.l=S,this.domNode.style.fontFamily=this.l)}setFontWeight(S){this.m!==S&&(this.m=S,this.domNode.style.fontWeight=this.m)}setFontSize(S){const k=F(S);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(S){this.o!==S&&(this.o=S,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(S){this.p!==S&&(this.p=S,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(S){this.q!==S&&(this.q=S,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(S){this.r!==S&&(this.r=S,this.domNode.style.textDecoration=this.r)}setLineHeight(S){const k=F(S);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(S){const k=F(S);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(S){this.u!==S&&(this.u=S,this.domNode.className=this.u)}toggleClassName(S,k){this.domNode.classList.toggle(S,k),this.u=this.domNode.className}setDisplay(S){this.v!==S&&(this.v=S,this.domNode.style.display=this.v)}setPosition(S){this.w!==S&&(this.w=S,this.domNode.style.position=this.w)}setVisibility(S){this.x!==S&&(this.x=S,this.domNode.style.visibility=this.x)}setColor(S){this.y!==S&&(this.y=S,this.domNode.style.color=this.y)}setBackgroundColor(S){this.z!==S&&(this.z=S,this.domNode.style.backgroundColor=this.z)}setLayerHinting(S){this.A!==S&&(this.A=S,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(S){this.C!==S&&(this.C=S,this.domNode.style.boxShadow=S)}setContain(S){this.B!==S&&(this.B=S,this.domNode.style.contain=this.B)}setAttribute(S,k){this.domNode.setAttribute(S,k)}removeAttribute(S){this.domNode.removeAttribute(S)}appendChild(S){this.domNode.appendChild(S.domNode)}removeChild(S){this.domNode.removeChild(S.domNode)}}t.$iT=i;function F(H){return typeof H=="number"?`${H}px`:H}function B(H){return new i(H)}}),define(me[79],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0,t.$BR=H;const i=new WeakMap;function F(k){if(!k.parent||k.parent===k)return null;try{const f=k.location,g=k.parent.location;if(f.origin!=="null"&&g.origin!=="null"&&f.origin!==g.origin)return null}catch{return null}return k.parent}class B{static a(f){let g=i.get(f);if(!g){g=[],i.set(f,g);let w=f,P;do P=F(w),P?g.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):g.push({window:new WeakRef(w),iframeElement:null}),w=P;while(w)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(f,g){if(!g||f===g)return{top:0,left:0};let w=0,P=0;const u=this.a(f);for(const c of u){const e=c.window.deref();if(w+=e?.scrollY??0,P+=e?.scrollX??0,e===g||!c.iframeElement)break;const n=c.iframeElement.getBoundingClientRect();w+=n.top,P+=n.left}return{top:w,left:P}}}t.$AR=B;async function H(k,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:k,salt:f}),P=new TextEncoder().encode(g),u=await crypto.subtle.digest("sha-256",P);return S(u)}function S(k){const g=Array.from(new Uint8Array(k)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(me[29],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=F,t.$oU=B;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function F(H){i=H}function B(){return i}}),define(me[80],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3T=t.$2T=t.$1T=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(S){S[S.Copy=0]="Copy",S[S.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var F;(function(S){S.Over="drop-target",S.Before="drop-target-before",S.After="drop-target-after"})(F||(t.ListDragOverEffectPosition=F={})),t.$1T={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(k,f){super(`ListError [${k}] ${f}`)}}t.$2T=B;class H{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,f){f>0&&this.c.set(k,f)}}t.$3T=H}),define(me[81],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=void 0;class i{constructor(B){this.a=B}splice(B,H,S){this.a.forEach(k=>k.splice(B,H,S))}}t.$QT=i}),define(me[52],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;const i=20;class F{constructor(H,S,k,f,g,w){this.a=Math.round(S),this.b=Math.round(k),this.c=Math.round(H),this.d=f,this.e=g,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new F(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const S=Math.round(H);return this.d!==S?(this.d=S,this.m(),!0):!1}setScrollSize(H){const S=Math.round(H);return this.e!==S?(this.e=S,this.m(),!0):!1}setScrollPosition(H){const S=Math.round(H);return this.f!==S?(this.f=S,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,S,k,f,g){const w=Math.max(0,k-H),P=Math.max(0,w-2*S),u=f>0&&f>k;if(!u)return{computedAvailableSize:Math.round(w),computedIsNeeded:u,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const c=Math.round(Math.max(i,Math.floor(k*P/f))),e=(P-c)/(f-k),n=g*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:u,computedSliderSize:Math.round(c),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const H=F.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const S=H-this.c-this.i/2;return Math.round(S/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const S=H-this.c;let k=this.f;return S<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const S=this.k+H;return Math.round(S/this.j)}}t.$oT=F}),define(me[30],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XV=t.$WV=t.$VV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var F;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(F||(t.ObjectTreeElementCollapseState=F={}));var B;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(B||(t.TreeMouseEventTarget=B={}));var H;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$VV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(f=!1){return{accept:!0,bubble:0,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:f}}};class S extends Error{constructor(g,w){super(`TreeError [${g}] ${w}`)}}t.$WV=S;class k{constructor(g){this.a=g,this.b=new WeakMap}map(g){let w=this.b.get(g);return w||(w=this.a(g),this.b.set(g,w)),w}}t.$XV=k}),define(me[22],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0,t.$dR=i,t.$fR=F;function i(B,H){const S=B;typeof S.vscodeWindowId!="number"&&Object.defineProperty(S,"vscodeWindowId",{get:()=>H})}t.$eR=window;function F(B){return B===t.$eR?!1:typeof B?.vscodeWindowId=="number"}}),define(me[82],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=F,t.$hb=B,t.$ib=H,t.$jb=S,t.$kb=k,t.$lb=f,t.$nb=w,t.$ob=P,t.$pb=u,t.$qb=c,t.$rb=e;function i(n,o){const l=F(n,o);if(l!==-1)return n[l]}function F(n,o,l=n.length-1){for(let d=l;d>=0;d--){const N=n[d];if(o(N))return d}return-1}function B(n,o){const l=H(n,o);return l===-1?void 0:n[l]}function H(n,o,l=0,d=n.length){let N=l,b=d;for(;N<b;){const m=Math.floor((N+b)/2);o(n[m])?N=m+1:b=m}return N-1}function S(n,o){const l=k(n,o);return l===n.length?void 0:n[l]}function k(n,o,l=0,d=n.length){let N=l,b=d;for(;N<b;){const m=Math.floor((N+b)/2);o(n[m])?b=m:N=m+1}return N}function f(n,o,l=0,d=n.length){const N=k(n,o,l,d);return N===n.length?-1:N}class g{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!o(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const l=H(this.e,o,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}t.$mb=g;function w(n,o){if(n.length===0)return;let l=n[0];for(let d=1;d<n.length;d++){const N=n[d];o(N,l)>0&&(l=N)}return l}function P(n,o){if(n.length===0)return;let l=n[0];for(let d=1;d<n.length;d++){const N=n[d];o(N,l)>=0&&(l=N)}return l}function u(n,o){return w(n,(l,d)=>-o(l,d))}function c(n,o){if(n.length===0)return-1;let l=0;for(let d=1;d<n.length;d++){const N=n[d];o(N,n[l])>0&&(l=d)}return l}function e(n,o){for(const l of n){const d=o(l);if(d!==void 0)return d}}}),define(me[83],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=F,t.$M=B,t.$N=H;function i(S,k){const f=Object.create(null);for(const g of S){const w=k(g);let P=f[w];P||(P=f[w]=[]),P.push(g)}return f}function F(S,k){const f=[],g=[];for(const w of S)k.has(w)||f.push(w);for(const w of k)S.has(w)||g.push(w);return{removed:f,added:g}}function B(S,k){const f=[],g=[];for(const[w,P]of S)k.has(w)||f.push(P);for(const[w,P]of k)S.has(w)||g.push(P);return{removed:f,added:g}}function H(S,k){const f=new Set;for(const g of k)S.has(g)&&f.add(g);return f}}),define(me[84],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kt=t.$Jt=t.$It=t.$Ht=void 0;function i(k,f){const g=Math.pow(10,f);return Math.round(k*g)/g}class F{constructor(f,g,w,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(f,g){return f.r===g.r&&f.g===g.g&&f.b===g.b&&f.a===g.a}}t.$Ht=F;class B{constructor(f,g,w,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.l===g.l&&f.a===g.a}static fromRGBA(f){const g=f.r/255,w=f.g/255,P=f.b/255,u=f.a,c=Math.max(g,w,P),e=Math.min(g,w,P);let n=0,o=0;const l=(e+c)/2,d=c-e;if(d>0){switch(o=Math.min(l<=.5?d/(2*l):d/(2-2*l),1),c){case g:n=(w-P)/d+(w<P?6:0);break;case w:n=(P-g)/d+2;break;case P:n=(g-w)/d+4;break}n*=60,n=Math.round(n)}return new B(n,o,l,u)}static i(f,g,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?f+(g-f)*6*w:w<1/2?g:w<2/3?f+(g-f)*(2/3-w)*6:f}static toRGBA(f){const g=f.h/360,{s:w,l:P,a:u}=f;let c,e,n;if(w===0)c=e=n=P;else{const o=P<.5?P*(1+w):P+w-P*w,l=2*P-o;c=B.i(l,o,g+1/3),e=B.i(l,o,g),n=B.i(l,o,g-1/3)}return new F(Math.round(c*255),Math.round(e*255),Math.round(n*255),u)}}t.$It=B;class H{constructor(f,g,w,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.v===g.v&&f.a===g.a}static fromRGBA(f){const g=f.r/255,w=f.g/255,P=f.b/255,u=Math.max(g,w,P),c=Math.min(g,w,P),e=u-c,n=u===0?0:e/u;let o;return e===0?o=0:u===g?o=((w-P)/e%6+6)%6:u===w?o=(P-g)/e+2:o=(g-w)/e+4,new H(Math.round(o*60),n,u,f.a)}static toRGBA(f){const{h:g,s:w,v:P,a:u}=f,c=P*w,e=c*(1-Math.abs(g/60%2-1)),n=P-c;let[o,l,d]=[0,0,0];return g<60?(o=c,l=e):g<120?(o=e,l=c):g<180?(l=c,d=e):g<240?(l=e,d=c):g<300?(o=e,d=c):g<=360&&(o=c,d=e),o=Math.round((o+n)*255),l=Math.round((l+n)*255),d=Math.round((d+n)*255),new F(o,l,d,u)}}t.$Jt=H;class S{static fromHex(f){return S.Format.CSS.parseHex(f)||S.red}static equals(f,g){return!f&&!g?!0:!f||!g?!1:f.equals(g)}get hsla(){return this.i?this.i:B.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof F)this.rgba=f;else if(f instanceof B)this.i=f,this.rgba=B.toRGBA(f);else if(f instanceof H)this.j=f,this.rgba=H.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&F.equals(this.rgba,f.rgba)&&B.equals(this.hsla,f.hsla)&&H.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=S.k(this.rgba.r),g=S.k(this.rgba.g),w=S.k(this.rgba.b),P=.2126*f+.7152*g+.0722*w;return i(P,4)}static k(f){const g=f/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(f){const g=this.getRelativeLuminance(),w=f.getRelativeLuminance();return g>w?(g+.05)/(w+.05):(w+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const g=this.getRelativeLuminance(),w=f.getRelativeLuminance();return g>w}isDarkerThan(f){const g=this.getRelativeLuminance(),w=f.getRelativeLuminance();return g<w}lighten(f){return new S(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new S(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:g,g:w,b:P,a:u}=this.rgba;return new S(new F(g,w,P,u*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const g=f.rgba,w=this.rgba.a,P=g.a,u=w+P*(1-w);if(u<1e-6)return S.transparent;const c=this.rgba.r*w/u+g.r*P*(1-w)/u,e=this.rgba.g*w/u+g.g*P*(1-w)/u,n=this.rgba.b*w/u+g.b*P*(1-w)/u;return new S(new F(c,e,n,u))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:g,g:w,b:P,a:u}=this.rgba;return new S(new F(f.rgba.r-u*(f.rgba.r-g),f.rgba.g-u*(f.rgba.g-w),f.rgba.b-u*(f.rgba.b-P),1))}flatten(...f){const g=f.reduceRight((w,P)=>S.o(P,w));return S.o(this,g)}static o(f,g){const w=1-f.rgba.a;return new S(new F(w*g.rgba.r+f.rgba.a*f.rgba.r,w*g.rgba.g+f.rgba.a*f.rgba.g,w*g.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(f,g,w){if(f.isLighterThan(g))return f;w=w||.5;const P=f.getRelativeLuminance(),u=g.getRelativeLuminance();return w=w*(u-P)/u,f.lighten(w)}static getDarkerColor(f,g,w){if(f.isDarkerThan(g))return f;w=w||.5;const P=f.getRelativeLuminance(),u=g.getRelativeLuminance();return w=w*(P-u)/P,f.darken(w)}static{this.white=new S(new F(255,255,255,1))}static{this.black=new S(new F(0,0,0,1))}static{this.red=new S(new F(255,0,0,1))}static{this.blue=new S(new F(0,0,255,1))}static{this.green=new S(new F(0,255,0,1))}static{this.cyan=new S(new F(0,255,255,1))}static{this.lightgrey=new S(new F(211,211,211,1))}static{this.transparent=new S(new F(0,0,0,0))}}t.$Kt=S,function(k){let f;(function(g){let w;(function(P){function u(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:k.Format.CSS.formatRGBA(r)}P.formatRGB=u;function c(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=c;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(r)}P.formatHSL=e;function n(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=n;function o(r){const y=r.toString(16);return y.length!==2?"0"+y:y}function l(r){return`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}`}P.formatHex=l;function d(r,y=!1){return y&&r.rgba.a===1?k.Format.CSS.formatHex(r):`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}${o(Math.round(r.rgba.a*255))}`}P.formatHexA=d;function N(r){return r.isOpaque()?k.Format.CSS.formatHex(r):k.Format.CSS.formatRGBA(r)}P.format=N;function b(r){const y=r.length;if(y===0||r.charCodeAt(0)!==35)return null;if(y===7){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),T=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),M=16*m(r.charCodeAt(5))+m(r.charCodeAt(6));return new k(new F(A,T,M,1))}if(y===9){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),T=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),M=16*m(r.charCodeAt(5))+m(r.charCodeAt(6)),q=16*m(r.charCodeAt(7))+m(r.charCodeAt(8));return new k(new F(A,T,M,q/255))}if(y===4){const A=m(r.charCodeAt(1)),T=m(r.charCodeAt(2)),M=m(r.charCodeAt(3));return new k(new F(16*A+A,16*T+T,16*M+M))}if(y===5){const A=m(r.charCodeAt(1)),T=m(r.charCodeAt(2)),M=m(r.charCodeAt(3)),q=m(r.charCodeAt(4));return new k(new F(16*A+A,16*T+T,16*M+M,(16*q+q)/255))}return null}P.parseHex=b;function m(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=g.CSS||(g.CSS={}))})(f=k.Format||(k.Format={}))}(S||(t.$Kt=S={}))}),define(me[31],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xh=F,t.$Yh=B,t.$Zh=H;function i(S){return(k,f,g)=>{let w=null,P=null;if(typeof g.value=="function"?(w="value",P=g.value):typeof g.get=="function"&&(w="get",P=g.get),!P)throw new Error("not supported");g[w]=S(P,f)}}function F(S,k,f){let g=null,w=null;if(typeof f.value=="function"?(g="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",w=f.get),!w)throw new Error("not supported");const P=`$memoize$${k}`;f[g]=function(...u){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,u)}),this[P]}}function B(S,k,f){return i((g,w)=>{const P=`$debounce$${w}`,u=`$debounce$result$${w}`;return function(...c){this[u]||(this[u]=f?f():void 0),clearTimeout(this[P]),k&&(this[u]=k(this[u],...c),c=[this[u]]),this[P]=setTimeout(()=>{g.apply(this,c),this[u]=f?f():void 0},S)}})}function H(S,k,f){return i((g,w)=>{const P=`$throttle$timer$${w}`,u=`$throttle$result$${w}`,c=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...n){if(this[u]||(this[u]=f?f():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...n)),this[e])return;const o=this[c]+S;o<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[u]]),this[u]=f?f():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[c]=Date.now(),g.apply(this,[this[u]]),this[u]=f?f():void 0},o-Date.now()))}})}}),define(me[85],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$st=void 0;class i{constructor(B,H,S,k){this.originalStart=B,this.originalLength=H,this.modifiedStart=S,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$st=i}),define(me[6],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=B,t.$1=H,t.$2=S,t.$3=k,t.$4=g,t.$6=P,t.$7=u,t.$8=c,t.$0=n;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?N.isErrorNoTelemetry(r)?new N(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(y=>{y(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function F(m){t.$X.setUnexpectedErrorHandler(m)}function B(m){if(!m||typeof m!="object")return!1;const r=m;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function H(m){g(m)||t.$X.onUnexpectedError(m)}function S(m){g(m)||t.$X.onUnexpectedExternalError(m)}function k(m){if(m instanceof Error){const{name:r,message:y}=m,A=m.stacktrace||m.stack;return{$isError:!0,name:r,message:y,stack:A,noTelemetry:N.isErrorNoTelemetry(m)}}return m}const f="Canceled";function g(m){return m instanceof w?!0:m instanceof Error&&m.name===f&&m.message===f}class w extends Error{constructor(){super(f),this.name=this.message}}t.$5=w;function P(){const m=new Error(f);return m.name=m.message,m}function u(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}function c(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=o;class l extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=d;class N extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof N)return r;const y=new N;return y.message=r.message,y.stack=r.stack,y}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=N;class b extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$cb=b}),define(me[8],be([1,0,6,82]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=B,t.$tb=H,t.$ub=S,t.$vb=k,t.$wb=f,t.$xb=g,t.$yb=w,t.$zb=P,t.$Ab=u,t.$Bb=c,t.$Cb=e,t.$Db=n,t.$Eb=o,t.top=l,t.$Gb=d,t.$Hb=b,t.$Ib=m,t.$Jb=r,t.$Kb=y,t.$Lb=A,t.$Mb=T,t.$Nb=M,t.$Ob=q,t.$Pb=$,t.$Qb=I,t.$Rb=V,t.$Sb=R,t.$Tb=x,t.$Ub=O,t.$Vb=X,t.$Wb=K,t.$Xb=ae,t.$Yb=ie,t.$Zb=ee,t.$1b=ce,t.$2b=ye,t.$3b=Ee,t.$4b=Me,t.$5b=le,t.$6b=_,t.$7b=De,t.$8b=W,t.$$b=we;function B(z,h=0){return z[z.length-(1+h)]}function H(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function S(z,h,D=(a,v)=>a===v){if(z===h)return!0;if(!z||!h||z.length!==h.length)return!1;for(let a=0,v=z.length;a<v;a++)if(!D(z[a],h[a]))return!1;return!0}function k(z,h){const D=z.length-1;h<D&&(z[h]=z[D]),z.pop()}function f(z,h,D){return g(z.length,a=>D(z[a],h))}function g(z,h){let D=0,a=z-1;for(;D<=a;){const v=(D+a)/2|0,C=h(v);if(C<0)D=v+1;else if(C>0)a=v-1;else return v}return-(D+1)}function w(z,h,D){if(z=z|0,z>=h.length)throw new TypeError("invalid index");const a=h[Math.floor(h.length*Math.random())],v=[],C=[],s=[];for(const E of h){const p=D(E,a);p<0?v.push(E):p>0?C.push(E):s.push(E)}return z<v.length?w(z,v,D):z<v.length+s.length?s[0]:w(z-(v.length+s.length),C,D)}function P(z,h){const D=[];let a;for(const v of z.slice(0).sort(h))!a||h(a[0],v)!==0?(a=[v],D.push(a)):a.push(v);return D}function*u(z,h){let D,a;for(const v of z)a!==void 0&&h(a,v)?D.push(v):(D&&(yield D),D=[v]),a=v;D&&(yield D)}function c(z,h){for(let D=0;D<=z.length;D++)h(D===0?void 0:z[D-1],D===z.length?void 0:z[D])}function e(z,h){for(let D=0;D<z.length;D++)h(D===0?void 0:z[D-1],z[D],D+1===z.length?void 0:z[D+1])}function n(z,h,D){const a=[];function v(E,p,L){if(p===0&&L.length===0)return;const j=a[a.length-1];j&&j.start+j.deleteCount===E?(j.deleteCount+=p,j.toInsert.push(...L)):a.push({start:E,deleteCount:p,toInsert:L})}let C=0,s=0;for(;;){if(C===z.length){v(C,0,h.slice(s));break}if(s===h.length){v(C,z.length-C,[]);break}const E=z[C],p=h[s],L=D(E,p);L===0?(C+=1,s+=1):L<0?(v(C,1,[]),C+=1):L>0&&(v(C,0,[p]),s+=1)}return a}function o(z,h,D){const a=n(z,h,D),v=[],C=[];for(const s of a)v.push(...z.slice(s.start,s.start+s.deleteCount)),C.push(...s.toInsert);return{removed:v,added:C}}function l(z,h,D){if(D===0)return[];const a=z.slice(0,D).sort(h);return N(z,h,a,D,z.length),a}function d(z,h,D,a,v){return D===0?Promise.resolve([]):new Promise((C,s)=>{(async()=>{const E=z.length,p=z.slice(0,D).sort(h);for(let L=D,j=Math.min(D+a,E);L<E;L=j,j=Math.min(j+a,E)){if(L>D&&await new Promise(Y=>setTimeout(Y)),v&&v.isCancellationRequested)throw new i.$5;N(z,h,p,L,j)}return p})().then(C,s)})}function N(z,h,D,a,v){for(const C=D.length;a<v;a++){const s=z[a];if(h(s,D[C-1])<0){D.pop();const E=(0,F.$kb)(D,p=>h(s,p)<0);D.splice(E,0,s)}}}function b(z){return z.filter(h=>!!h)}function m(z){let h=0;for(let D=0;D<z.length;D++)z[D]&&(z[h]=z[D],h+=1);z.length=h}function r(z,h,D){z.splice(D,0,z.splice(h,1)[0])}function y(z){return!Array.isArray(z)||z.length===0}function A(z){return Array.isArray(z)&&z.length>0}function T(z,h=D=>D){const D=new Set;return z.filter(a=>{const v=h(a);return D.has(v)?!1:(D.add(v),!0)})}function M(z){const h=new Set;return D=>{const a=z(D);return h.has(a)?!1:(h.add(a),!0)}}function q(z,h){return z.length>0?z[0]:h}function $(z,h){return z.length>0?z[z.length-1]:h}function I(z,h,D=(a,v)=>a===v){let a=0;for(let v=0,C=Math.min(z.length,h.length);v<C&&D(z[v],h[v]);v++)a++;return a}function V(z){return[].concat(...z)}function R(z,h){let D=typeof h=="number"?z:0;typeof h=="number"?D=z:(D=0,h=z);const a=[];if(D<=h)for(let v=D;v<h;v++)a.push(v);else for(let v=D;v>h;v--)a.push(v);return a}function x(z,h,D){return z.reduce((a,v)=>(a[h(v)]=D?D(v):v,a),Object.create(null))}function O(z,h){return z.push(h),()=>X(z,h)}function X(z,h){const D=z.indexOf(h);if(D>-1)return z.splice(D,1),h}function K(z,h,D){const a=z.slice(0,h),v=z.slice(h);return a.concat(D,v)}function ae(z,h){let D;if(typeof h=="number"){let a=h;D=()=>{const v=Math.sin(a++)*179426549;return v-Math.floor(v)}}else D=Math.random;for(let a=z.length-1;a>0;a-=1){const v=Math.floor(D()*(a+1)),C=z[a];z[a]=z[v],z[v]=C}}function ie(z,h){const D=z.indexOf(h);D>-1&&(z.splice(D,1),z.unshift(h))}function ee(z,h){const D=z.indexOf(h);D>-1&&(z.splice(D,1),z.push(h))}function ce(z,h){for(const D of h)z.push(D)}function ye(z,h){return Array.isArray(z)?z.map(h):h(z)}function Ee(z){return Array.isArray(z)?z:[z]}function Me(z){return z[Math.floor(Math.random()*z.length)]}function le(z,h,D){const a=ue(z,h),v=z.length,C=D.length;z.length=v+C;for(let s=v-1;s>=a;s--)z[s+C]=z[s];for(let s=0;s<C;s++)z[s+a]=D[s]}function _(z,h,D,a){const v=ue(z,h);let C=z.splice(v,D);return C===void 0&&(C=[]),le(z,v,a),C}function ue(z,h){return h<0?Math.max(h+z.length,0):Math.min(h,z.length)}var re;(function(z){function h(C){return C<0}z.isLessThan=h;function D(C){return C<=0}z.isLessThanOrEqual=D;function a(C){return C>0}z.isGreaterThan=a;function v(C){return C===0}z.isNeitherLessOrGreaterThan=v,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function De(z,h){return(D,a)=>h(z(D),z(a))}function W(...z){return(h,D)=>{for(const a of z){const v=a(h,D);if(!re.isNeitherLessOrGreaterThan(v))return v}return re.neitherLessOrGreaterThan}}const Q=(z,h)=>z-h;t.$9b=Q;const ge=(z,h)=>(0,t.$9b)(z?1:0,h?1:0);t.$0b=ge;function we(z){return(h,D)=>-z(h,D)}class Ae{constructor(h){this.g=h,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(h){let D=this.c;for(;D<this.g.length&&h(this.g[D]);)D++;const a=D===this.c?null:this.g.slice(this.c,D);return this.c=D,a}takeFromEndWhile(h){let D=this.d;for(;D>=0&&h(this.g[D]);)D--;const a=D===this.d?null:this.g.slice(D+1,this.d+1);return this.d=D,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const h=this.g[this.c];return this.c++,h}removeLast(){const h=this.g[this.d];return this.d--,h}takeCount(h){const D=this.g.slice(this.c,this.c+h);return this.c+=h,D}}t.$_b=Ae;class Te{static{this.empty=new Te(h=>{})}constructor(h){this.iterate=h}forEach(h){this.iterate(D=>(h(D),!0))}toArray(){const h=[];return this.iterate(D=>(h.push(D),!0)),h}filter(h){return new Te(D=>this.iterate(a=>h(a)?D(a):!0))}map(h){return new Te(D=>this.iterate(a=>D(h(a))))}some(h){let D=!1;return this.iterate(a=>(D=h(a),!D)),D}findFirst(h){let D;return this.iterate(a=>h(a)?(D=a,!1):!0),D}findLast(h){let D;return this.iterate(a=>(h(a)&&(D=a),!0)),D}findLastMaxBy(h){let D,a=!0;return this.iterate(v=>((a||re.isGreaterThan(h(v,D)))&&(a=!1,D=v),!0)),D}}t.$ac=Te;class Ie{constructor(h){this.c=h}static createSortPermutation(h,D){const a=Array.from(h.keys()).sort((v,C)=>D(h[v],h[C]));return new Ie(a)}apply(h){return h.map((D,a)=>h[this.c[a]])}inverse(){const h=this.c.slice();for(let D=0;D<this.c.length;D++)h[this.c[D]]=D;return new Ie(h)}}t.$bc=Ie}),define(me[37],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$dd=B,t.$ed=H,t.$fd=S,t.$gd=k,t.$hd=f;function F(g,w){if(!g)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function B(g,w="Unreachable"){throw new Error(w)}function H(g){if(!g)throw new i.$cb("Assertion Failed")}function S(g){g||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function k(g){if(!g()){debugger;g(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function f(g,w){let P=0;for(;P<g.length-1;){const u=g[P],c=g[P+1];if(!w(u,c))return!1;P++}return!0}}),define(me[38],be([1,0,8]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0,t.$8c=B,t.$9c=H,t.$0c=S,t.$$c=k;const F=(f,g)=>f===g;t.$7c=F;function B(f=t.$7c){return(g,w)=>i.$ub(g,w,f)}function H(){return(f,g)=>JSON.stringify(f)===JSON.stringify(g)}function S(){return(f,g)=>f.equals(g)}function k(f,g,w){return!f||!g?f===g:w(f,g)}}),define(me[53],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(F,B){const H=this;let S=!1,k;return function(){if(S)return k;if(S=!0,B)try{k=F.apply(H,arguments)}finally{B()}else k=F.apply(H,arguments);return k}}}),define(me[86],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nP=t.$mP=void 0;class i{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$mP=i,t.$nP=new i("id#")}),define(me[32],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function B(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}F.is=B;const H=Object.freeze([]);function S(){return H}F.empty=S;function*k(r){yield r}F.single=k;function f(r){return B(r)?r:k(r)}F.wrap=f;function g(r){return r||H}F.from=g;function*w(r){for(let y=r.length-1;y>=0;y--)yield r[y]}F.reverse=w;function P(r){return!r||r[Symbol.iterator]().next().done===!0}F.isEmpty=P;function u(r){return r[Symbol.iterator]().next().value}F.first=u;function c(r,y){for(const A of r)if(y(A))return!0;return!1}F.some=c;function e(r,y){for(const A of r)if(y(A))return A}F.find=e;function*n(r,y){for(const A of r)y(A)&&(yield A)}F.filter=n;function*o(r,y){let A=0;for(const T of r)yield y(T,A++)}F.map=o;function*l(...r){for(const y of r)yield*y}F.concat=l;function d(r,y,A){let T=A;for(const M of r)T=y(T,M);return T}F.reduce=d;function*N(r,y,A=r.length){for(y<0&&(y+=r.length),A<0?A+=r.length:A>r.length&&(A=r.length);y<A;y++)yield r[y]}F.slice=N;function b(r,y=Number.POSITIVE_INFINITY){const A=[];if(y===0)return[A,r];const T=r[Symbol.iterator]();for(let M=0;M<y;M++){const q=T.next();if(q.done)return[A,F.empty()];A.push(q.value)}return[A,{[Symbol.iterator](){return T}}]}F.consume=b;async function m(r){const y=[];for await(const A of r)y.push(A);return Promise.resolve(y)}F.asyncToArray=m})(i||(t.Iterable=i={}))}),define(me[54],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Ar=t.$zr=t.$yr=t.$xr=t.$wr=t.ScanCode=t.KeyCode=void 0,t.$Br=c;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,o){this._keyCodeToStr[n]=o,this._strToKeyCode[o.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const H=new B,S=new B,k=new B;t.$wr=new Array(230),t.$xr={};const f=[],g=Object.create(null),w=Object.create(null);t.$yr={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>g[e]||0,toString:e=>f[e]||"None"},t.$zr=[],t.$Ar=[];for(let e=0;e<=193;e++)t.$zr[e]=-1;for(let e=0;e<=132;e++)t.$Ar[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],l=[];for(const d of n){const[N,b,m,r,y,A,T,M,q]=d;if(l[b]||(l[b]=!0,f[b]=m,g[m]=b,w[m.toLowerCase()]=b,N&&(t.$zr[b]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$Ar[r]=b))),!o[r]){if(o[r]=!0,!y)throw new Error(`String representation missing for key code ${r} around scan code ${m}`);H.define(r,y),S.define(r,M||y),k.define(r,q||M||y)}A&&(t.$wr[A]=r),T&&(t.$xr[T]=r)}t.$Ar[3]=46})();var P;(function(e){function n(m){return H.keyCodeToStr(m)}e.toString=n;function o(m){return H.strToKeyCode(m)}e.fromString=o;function l(m){return S.keyCodeToStr(m)}e.toUserSettingsUS=l;function d(m){return k.keyCodeToStr(m)}e.toUserSettingsGeneral=d;function N(m){return S.strToKeyCode(m)||k.strToKeyCode(m)}e.fromUserSettings=N;function b(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(m)}e.toElectronAccelerator=b})(P||(t.KeyCodeUtils=P={}));var u;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(u||(t.KeyMod=u={}));function c(e,n){const o=(n&65535)<<16>>>0;return(e|o)>>>0}}),define(me[87],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ir=t.$Hr=t.$Gr=t.$Fr=t.$Er=void 0,t.$Cr=B,t.$Dr=H;var F;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(F||(F={}));function B(P,u){if(typeof P=="number"){if(P===0)return null;const c=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new f([H(c,u),H(e,u)]):new f([H(c,u)])}else{const c=[];for(let e=0;e<P.length;e++)c.push(H(P[e],u));return new f(c)}}function H(P,u){const c=!!(P&2048),e=!!(P&256),n=u===2?e:c,o=!!(P&1024),l=!!(P&512),d=u===2?c:e,N=P&255;return new S(n,o,l,d,N)}class S{constructor(u,c,e,n,o){this.ctrlKey=u,this.shiftKey=c,this.altKey=e,this.metaKey=n,this.keyCode=o}equals(u){return u instanceof S&&this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",c=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${u}${c}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new f([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Er=S;class k{constructor(u,c,e,n,o){this.ctrlKey=u,this.shiftKey=c,this.altKey=e,this.metaKey=n,this.scanCode=o}equals(u){return u instanceof k&&this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.scanCode===u.scanCode}getHashCode(){const u=this.ctrlKey?"1":"0",c=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${u}${c}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Fr=k;class f{constructor(u){if(u.length===0)throw(0,i.$7)("chords");this.chords=u}getHashCode(){let u="";for(let c=0,e=this.chords.length;c<e;c++)c!==0&&(u+=";"),u+=this.chords[c].getHashCode();return u}equals(u){if(u===null||this.chords.length!==u.chords.length)return!1;for(let c=0;c<this.chords.length;c++)if(!this.chords[c].equals(u.chords[c]))return!1;return!0}}t.$Gr=f;class g{constructor(u,c,e,n,o,l){this.ctrlKey=u,this.shiftKey=c,this.altKey=e,this.metaKey=n,this.keyLabel=o,this.keyAriaLabel=l}}t.$Hr=g;class w{}t.$Ir=w}),define(me[23],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(me[14],be([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=k,t.$CT=f,t.$DT=g;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new i.$V(()=>B("mouse",!1)),S=new i.$V(()=>B("element",!1));function k(w){B=w}function f(w){return w==="element"?S.value:H.value}function g(){return B("element",!0)}}),define(me[55],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(H){this.element=H,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let H=this.a;for(;H!==i.Undefined;){const S=H.next;H.prev=i.Undefined,H.next=i.Undefined,H=S}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,S){const k=new i(H);if(this.a===i.Undefined)this.a=k,this.b=k;else if(S){const g=this.b;this.b=k,k.prev=g,g.next=k}else{const g=this.a;this.a=k,k.next=g,g.prev=k}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(k))}}shift(){if(this.a!==i.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==i.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==i.Undefined&&H.next!==i.Undefined){const S=H.prev;S.next=H.next,H.next.prev=S}else H.prev===i.Undefined&&H.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):H.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):H.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==i.Undefined;)yield H.element,H=H.next}}t.$6c=F}),define(me[39],be([1,0]),function(se,t){"use strict";var i,F,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=H,t.$zc=S,t.$Ac=k,t.$Jc=b;function H(m,r,y){let A=m.get(r);return A===void 0&&(A=y,m.set(r,A)),A}function S(m){const r=[];return m.forEach((y,A)=>{r.push(`${A} => ${y}`)}),`Map(${m.size}) {${r.join(", ")}}`}function k(m){const r=[];return m.forEach(y=>{r.push(y)}),`Set(${m.size}) {${r.join(", ")}}`}class f{constructor(r,y){this.uri=r,this.value=y}}function g(m){return Array.isArray(m)}class w{static{this.c=r=>r.toString()}constructor(r,y){if(this[i]="ResourceMap",r instanceof w)this.d=new Map(r.d),this.e=y??w.c;else if(g(r)){this.d=new Map,this.e=y??w.c;for(const[A,T]of r)this.set(A,T)}else this.d=new Map,this.e=r??w.c}set(r,y){return this.d.set(this.e(r),new f(r,y)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,y){typeof y<"u"&&(r=r.bind(y));for(const[A,T]of this.d)r(T.value,T.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Bc=w;class P{constructor(r,y){this[F]="ResourceSet",!r||typeof r=="function"?this.c=new w(r):(this.c=new w(y),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,y){this.c.forEach((A,T)=>r.call(y,T,T,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=P;var u;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(u||(t.Touch=u={}));class c{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,y=0){const A=this.c.get(r);if(A)return y!==0&&this.m(A,y),A.value}set(r,y,A=0){let T=this.c.get(r);if(T)T.value=y,A!==0&&this.m(T,A);else{switch(T={key:r,value:y,next:void 0,previous:void 0},A){case 0:this.k(T);break;case 1:this.j(T);break;case 2:this.k(T);break;default:this.k(T);break}this.c.set(r,T),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const y=this.c.get(r);if(y)return this.c.delete(r),this.l(y),this.f--,y.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,y){const A=this.g;let T=this.d;for(;T;){if(y?r.bind(y)(T.value,T.key,this):r(T.value,T.key,this),this.g!==A)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const r=this,y=this.g;let A=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==y)throw new Error("LinkedMap got modified during iteration.");if(A){const M={value:A.key,done:!1};return A=A.next,M}else return{value:void 0,done:!0}}};return T}values(){const r=this,y=this.g;let A=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==y)throw new Error("LinkedMap got modified during iteration.");if(A){const M={value:A.value,done:!1};return A=A.next,M}else return{value:void 0,done:!0}}};return T}entries(){const r=this,y=this.g;let A=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==y)throw new Error("LinkedMap got modified during iteration.");if(A){const M={value:[A.key,A.value],done:!1};return A=A.next,M}else return{value:void 0,done:!0}}};return T}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let y=this.d,A=this.size;for(;y&&A>r;)this.c.delete(y.key),y=y.next,A--;this.d=y,this.f=A,y&&(y.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let y=this.e,A=this.size;for(;y&&A>r;)this.c.delete(y.key),y=y.previous,A--;this.e=y,this.f=A,y&&(y.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const y=r.next,A=r.previous;if(!y||!A)throw new Error("Invalid list");y.previous=A,A.next=y}r.next=void 0,r.previous=void 0,this.g++}m(r,y){if(!this.d||!this.e)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(r===this.d)return;const A=r.next,T=r.previous;r===this.e?(T.next=void 0,this.e=T):(A.previous=T,T.next=A),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(y===2){if(r===this.e)return;const A=r.next,T=r.previous;r===this.d?(A.previous=void 0,this.d=A):(A.previous=T,T.next=A),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((y,A)=>{r.push([A,y])}),r}fromJSON(r){this.clear();for(const[y,A]of r)this.set(y,A)}}t.$Dc=c;class e extends c{constructor(r,y=1){super(),this.n=r,this.o=Math.min(Math.max(0,y),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,y=2){return super.get(r,y)}peek(r){return super.get(r,0)}set(r,y){return super.set(r,y,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class n extends e{constructor(r,y=1){super(r,y)}q(r){this.h(r)}set(r,y){return super.set(r,y),this.p(),this}}t.$Ec=n;class o extends e{constructor(r,y=1){super(r,y)}q(r){this.i(r)}set(r,y){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,y),this}}t.$Fc=o;class l{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let y=this.c.get(r)||0;return y===0?!1:(y--,y===0?this.c.delete(r):this.c.set(r,y),!0)}has(r){return this.c.has(r)}}t.$Gc=l;class d{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[y,A]of r)this.set(y,A)}clear(){this.c.clear(),this.d.clear()}set(r,y){this.c.set(r,y),this.d.set(y,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const y=this.c.get(r);return y===void 0?!1:(this.c.delete(r),this.d.delete(y),!0)}forEach(r,y){this.c.forEach((A,T)=>{r.call(y,A,T,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=d;class N{constructor(){this.c=new Map}add(r,y){let A=this.c.get(r);A||(A=new Set,this.c.set(r,A)),A.add(y)}delete(r,y){const A=this.c.get(r);A&&(A.delete(y),A.size===0&&this.c.delete(r))}forEach(r,y){const A=this.c.get(r);A&&A.forEach(y)}get(r){const y=this.c.get(r);return y||new Set}}t.$Ic=N;function b(m,r){if(m===r)return!0;if(m.size!==r.size)return!1;for(const[y,A]of m)if(!r.has(y)||r.get(y)!==A)return!1;for(const[y]of r)if(!m.has(y))return!1;return!0}}),define(me[2],be([1,0,8,83,39,53,32]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=w,t.$Mc=P,t.$Nc=u,t.$Oc=n,t.$Pc=o,t.$Qc=l,t.$Rc=d,t.$Sc=N,t.$Tc=b,t.$4c=V;const k=!1;let f=null;class g{constructor(){this.b=new Map}static{this.a=0}c(O){let X=this.b.get(O);return X||(X={parent:null,source:null,isSingleton:!1,value:O,idx:g.a++},this.b.set(O,X)),X}trackDisposable(O){const X=this.c(O);X.source||(X.source=new Error().stack)}setParent(O,X){const K=this.c(O);K.parent=X}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,X){const K=X.get(O);if(K)return K;const ae=O.parent?this.f(this.c(O.parent),X):O;return X.set(O,ae),ae}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,K])=>K.source!==null&&!this.f(K,O).isSingleton).flatMap(([K])=>K)}computeLeakingDisposables(O=10,X){let K;if(X)K=X;else{const ye=new Map,Ee=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,ye).isSingleton);if(Ee.length===0)return;const Me=new Set(Ee.map(le=>le.value));if(K=Ee.filter(le=>!(le.parent&&Me.has(le.parent))),K.length===0)throw new Error("There are cyclic diposable chains!")}if(!K)return;function ae(ye){function Ee(le,_){for(;le.length>0&&_.some(ue=>typeof ue=="string"?ue===le[0]:le[0].match(ue));)le.shift()}const Me=ye.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ee(Me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Me.reverse()}const ie=new B.$Ic;for(const ye of K){const Ee=ae(ye);for(let Me=0;Me<=Ee.length;Me++)ie.add(Ee.slice(0,Me).join(`
`),ye)}K.sort((0,i.$7b)(ye=>ye.idx,i.$9b));let ee="",ce=0;for(const ye of K.slice(0,O)){ce++;const Ee=ae(ye),Me=[];for(let le=0;le<Ee.length;le++){let _=Ee[le];_=`(shared with ${ie.get(Ee.slice(0,le+1).join(`
`)).size}/${K.length} leaks) at ${_}`;const re=ie.get(Ee.slice(0,le).join(`
`)),De=(0,F.$K)([...re].map(W=>ae(W)[le]),W=>W);delete De[Ee[le]];for(const[W,Q]of Object.entries(De))Me.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${W}`);Me.unshift(_)}ee+=`


==================== Leaking disposable ${ce}/${K.length}: ${ye.value.constructor.name} ====================
${Me.join(`
`)}
============================================================

`}return K.length>O&&(ee+=`


... and ${K.length-O} more leaking disposables

`),{leaks:K,details:ee}}}t.$Kc=g;function w(x){f=x}if(k){const x="__is_disposable_tracked__";w(new class{trackDisposable(O){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[x]||console.log(X)},3e3)}setParent(O,X){if(O&&O!==r.None)try{O[x]=!0}catch{}}markAsDisposed(O){if(O&&O!==r.None)try{O[x]=!0}catch{}}markAsSingleton(O){}})}function P(x){return f?.trackDisposable(x),x}function u(x){f?.markAsDisposed(x)}function c(x,O){f?.setParent(x,O)}function e(x,O){if(f)for(const X of x)f.setParent(X,O)}function n(x){return f?.markAsSingleton(x),x}function o(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function l(x){if(S.Iterable.is(x)){const O=[];for(const X of x)if(X)try{X.dispose()}catch(K){O.push(K)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function d(x){for(const O of x)o(O)&&O.dispose();return[]}function N(...x){const O=b(()=>l(x));return e(x,O),O}function b(x){const O=P({dispose:(0,H.$db)(()=>{u(O),x()})});return O}class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return c(O,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),c(O,null))}}t.$Uc=m;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,P(this),c(this.q,this)}dispose(){u(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}t.$Vc=r;class y{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&c(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&c(O,null),O}}t.$Wc=y;class A{constructor(O){this.a=new y,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=A;class T{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=T;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(O){let X=O;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,u(this))},this}}t.$Zc=M;class q{constructor(){this.a=new Map}acquire(O,...X){let K=this.a.get(O);K||(K={counter:0,object:this.b(O,...X)},this.a.set(O,K));const{object:ae}=K,ie=(0,H.$db)(()=>{--K.counter===0&&(this.c(O,K.object),this.a.delete(O))});return K.counter++,{object:ae,dispose:ie}}}t.$1c=q;class ${constructor(O){this.a=O}async acquire(O,...X){const K=this.a.acquire(O,...X);try{return{object:await K.object,dispose:()=>K.dispose()}}catch(ae){throw K.dispose(),ae}}}t.$2c=$;class I{constructor(O){this.object=O}dispose(){}}t.$3c=I;function V(x){const O=new m;try{x(O)}finally{O.dispose()}}class R{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,X,K=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),K||this.a.get(O)?.dispose(),this.a.set(O,X)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=R}),function(se,t){typeof define=="function"&&define.amd?define(me[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(z,h){for(var D=0;D<h.length;D++){var a=h[D];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(z,a.key,a)}}function i(z,h,D){return h&&t(z.prototype,h),D&&t(z,D),Object.defineProperty(z,"prototype",{writable:!1}),z}function F(z,h){if(z){if(typeof z=="string")return B(z,h);var D=Object.prototype.toString.call(z).slice(8,-1);if(D==="Object"&&z.constructor&&(D=z.constructor.name),D==="Map"||D==="Set")return Array.from(z);if(D==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(D))return B(z,h)}}function B(z,h){(h==null||h>z.length)&&(h=z.length);for(var D=0,a=new Array(h);D<h;D++)a[D]=z[D];return a}function H(z,h){var D=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(D)return(D=D.call(z)).next.bind(D);if(Array.isArray(z)||(D=F(z))||h&&z&&typeof z.length=="number"){D&&(z=D);var a=0;return function(){return a>=z.length?{done:!0}:{done:!1,value:z[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=S();function k(z){se.defaults=z}var f=/[&<>"']/,g=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(h){return u[h]};function e(z,h){if(h){if(f.test(z))return z.replace(g,c)}else if(w.test(z))return z.replace(P,c);return z}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(z){return z.replace(n,function(h,D){return D=D.toLowerCase(),D==="colon"?":":D.charAt(0)==="#"?D.charAt(1)==="x"?String.fromCharCode(parseInt(D.substring(2),16)):String.fromCharCode(+D.substring(1)):""})}var l=/(^|[^\[])\^/g;function d(z,h){z=typeof z=="string"?z:z.source,h=h||"";var D={replace:function(v,C){return C=C.source||C,C=C.replace(l,"$1"),z=z.replace(v,C),D},getRegex:function(){return new RegExp(z,h)}};return D}var N=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(z,h,D){if(z){var a;try{a=decodeURIComponent(o(D)).replace(N,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}h&&!b.test(D)&&(D=M(h,D));try{D=encodeURI(D).replace(/%25/g,"%")}catch{return null}return D}var r={},y=/^[^:]+:\/*[^/]*$/,A=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function M(z,h){r[" "+z]||(y.test(z)?r[" "+z]=z+"/":r[" "+z]=V(z,"/",!0)),z=r[" "+z];var D=z.indexOf(":")===-1;return h.substring(0,2)==="//"?D?h:z.replace(A,"$1")+h:h.charAt(0)==="/"?D?h:z.replace(T,"$1")+h:z+h}var q={exec:function(){}};function $(z){for(var h=1,D,a;h<arguments.length;h++){D=arguments[h];for(a in D)Object.prototype.hasOwnProperty.call(D,a)&&(z[a]=D[a])}return z}function I(z,h){var D=z.replace(/\|/g,function(C,s,E){for(var p=!1,L=s;--L>=0&&E[L]==="\\";)p=!p;return p?"|":" |"}),a=D.split(/ \|/),v=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>h)a.splice(h);else for(;a.length<h;)a.push("");for(;v<a.length;v++)a[v]=a[v].trim().replace(/\\\|/g,"|");return a}function V(z,h,D){var a=z.length;if(a===0)return"";for(var v=0;v<a;){var C=z.charAt(a-v-1);if(C===h&&!D)v++;else if(C!==h&&D)v++;else break}return z.slice(0,a-v)}function R(z,h){if(z.indexOf(h[1])===-1)return-1;for(var D=z.length,a=0,v=0;v<D;v++)if(z[v]==="\\")v++;else if(z[v]===h[0])a++;else if(z[v]===h[1]&&(a--,a<0))return v;return-1}function x(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(z,h){if(h<1)return"";for(var D="";h>1;)h&1&&(D+=z),h>>=1,z+=z;return D+z}function X(z,h,D,a){var v=h.href,C=h.title?e(h.title):null,s=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){a.state.inLink=!0;var E={type:"link",raw:D,href:v,title:C,text:s,tokens:a.inlineTokens(s)};return a.state.inLink=!1,E}return{type:"image",raw:D,href:v,title:C,text:e(s)}}function K(z,h){var D=z.match(/^(\s+)(?:```)/);if(D===null)return h;var a=D[1];return h.split(`
`).map(function(v){var C=v.match(/^\s+/);if(C===null)return v;var s=C[0];return s.length>=a.length?v.slice(a.length):v}).join(`
`)}var ae=function(){function z(D){this.options=D||se.defaults}var h=z.prototype;return h.space=function(a){var v=this.rules.block.newline.exec(a);if(v&&v[0].length>0)return{type:"space",raw:v[0]}},h.code=function(a){var v=this.rules.block.code.exec(a);if(v){var C=v[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:v[0],codeBlockStyle:"indented",text:this.options.pedantic?C:V(C,`
`)}}},h.fences=function(a){var v=this.rules.block.fences.exec(a);if(v){var C=v[0],s=K(C,v[3]||"");return{type:"code",raw:C,lang:v[2]?v[2].trim():v[2],text:s}}},h.heading=function(a){var v=this.rules.block.heading.exec(a);if(v){var C=v[2].trim();if(/#$/.test(C)){var s=V(C,"#");(this.options.pedantic||!s||/ $/.test(s))&&(C=s.trim())}return{type:"heading",raw:v[0],depth:v[1].length,text:C,tokens:this.lexer.inline(C)}}},h.hr=function(a){var v=this.rules.block.hr.exec(a);if(v)return{type:"hr",raw:v[0]}},h.blockquote=function(a){var v=this.rules.block.blockquote.exec(a);if(v){var C=v[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:v[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},h.list=function(a){var v=this.rules.block.list.exec(a);if(v){var C,s,E,p,L,j,Y,J,oe,pe,fe,Le,ke=v[1].trim(),Oe=ke.length>1,Ne={type:"list",raw:"",ordered:Oe,start:Oe?+ke.slice(0,-1):"",loose:!1,items:[]};ke=Oe?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=Oe?ke:"[*+-]");for(var Fe=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Le=!1,!(!(v=Fe.exec(a))||this.rules.block.hr.test(a)));){if(C=v[0],a=a.substring(C.length),J=v[2].split(`
`,1)[0],oe=a.split(`
`,1)[0],this.options.pedantic?(p=2,fe=J.trimLeft()):(p=v[2].search(/[^ ]/),p=p>4?1:p,fe=J.slice(p),p+=v[1].length),j=!1,!J&&/^ *$/.test(oe)&&(C+=oe+`
`,a=a.substring(oe.length+1),Le=!0),!Le)for(var We=new RegExp("^ {0,"+Math.min(3,p-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,p-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,p-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,p-1)+"}#");a&&(pe=a.split(`
`,1)[0],J=pe,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(J)||_e.test(J)||We.test(J)||Ue.test(a)));){if(J.search(/[^ ]/)>=p||!J.trim())fe+=`
`+J.slice(p);else if(!j)fe+=`
`+J;else break;!j&&!J.trim()&&(j=!0),C+=pe+`
`,a=a.substring(pe.length+1)}Ne.loose||(Y?Ne.loose=!0:/\n *\n *$/.test(C)&&(Y=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(fe),s&&(E=s[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:C,task:!!s,checked:E,loose:!1,text:fe}),Ne.raw+=C}Ne.items[Ne.items.length-1].raw=C.trimRight(),Ne.items[Ne.items.length-1].text=fe.trimRight(),Ne.raw=Ne.raw.trimRight();var Z=Ne.items.length;for(L=0;L<Z;L++){this.lexer.state.top=!1,Ne.items[L].tokens=this.lexer.blockTokens(Ne.items[L].text,[]);var ne=Ne.items[L].tokens.filter(function(ve){return ve.type==="space"}),$e=ne.every(function(ve){for(var Re=ve.raw.split(""),ze=0,Ve=H(Re),et;!(et=Ve()).done;){var it=et.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Ne.loose&&ne.length&&$e&&(Ne.loose=!0,Ne.items[L].loose=!0)}return Ne}},h.html=function(a){var v=this.rules.block.html.exec(a);if(v){var C={type:"html",raw:v[0],pre:!this.options.sanitizer&&(v[1]==="pre"||v[1]==="script"||v[1]==="style"),text:v[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]);C.type="paragraph",C.text=s,C.tokens=this.lexer.inline(s)}return C}},h.def=function(a){var v=this.rules.block.def.exec(a);if(v){v[3]&&(v[3]=v[3].substring(1,v[3].length-1));var C=v[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:v[0],href:v[2],title:v[3]}}},h.table=function(a){var v=this.rules.block.table.exec(a);if(v){var C={type:"table",header:I(v[1]).map(function(Y){return{text:Y}}),align:v[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:v[3]&&v[3].trim()?v[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=v[0];var s=C.align.length,E,p,L,j;for(E=0;E<s;E++)/^ *-+: *$/.test(C.align[E])?C.align[E]="right":/^ *:-+: *$/.test(C.align[E])?C.align[E]="center":/^ *:-+ *$/.test(C.align[E])?C.align[E]="left":C.align[E]=null;for(s=C.rows.length,E=0;E<s;E++)C.rows[E]=I(C.rows[E],C.header.length).map(function(Y){return{text:Y}});for(s=C.header.length,p=0;p<s;p++)C.header[p].tokens=this.lexer.inline(C.header[p].text);for(s=C.rows.length,p=0;p<s;p++)for(j=C.rows[p],L=0;L<j.length;L++)j[L].tokens=this.lexer.inline(j[L].text);return C}}},h.lheading=function(a){var v=this.rules.block.lheading.exec(a);if(v)return{type:"heading",raw:v[0],depth:v[2].charAt(0)==="="?1:2,text:v[1],tokens:this.lexer.inline(v[1])}},h.paragraph=function(a){var v=this.rules.block.paragraph.exec(a);if(v){var C=v[1].charAt(v[1].length-1)===`
`?v[1].slice(0,-1):v[1];return{type:"paragraph",raw:v[0],text:C,tokens:this.lexer.inline(C)}}},h.text=function(a){var v=this.rules.block.text.exec(a);if(v)return{type:"text",raw:v[0],text:v[0],tokens:this.lexer.inline(v[0])}},h.escape=function(a){var v=this.rules.inline.escape.exec(a);if(v)return{type:"escape",raw:v[0],text:e(v[1])}},h.tag=function(a){var v=this.rules.inline.tag.exec(a);if(v)return!this.lexer.state.inLink&&/^<a /i.test(v[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(v[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(v[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(v[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:v[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]):v[0]}},h.link=function(a){var v=this.rules.inline.link.exec(a);if(v){var C=v[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var s=V(C.slice(0,-1),"\\");if((C.length-s.length)%2===0)return}else{var E=R(v[2],"()");if(E>-1){var p=v[0].indexOf("!")===0?5:4,L=p+v[1].length+E;v[2]=v[2].substring(0,E),v[0]=v[0].substring(0,L).trim(),v[3]=""}}var j=v[2],Y="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);J&&(j=J[1],Y=J[3])}else Y=v[3]?v[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(C)?j=j.slice(1):j=j.slice(1,-1)),X(v,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},v[0],this.lexer)}},h.reflink=function(a,v){var C;if((C=this.rules.inline.reflink.exec(a))||(C=this.rules.inline.nolink.exec(a))){var s=(C[2]||C[1]).replace(/\s+/g," ");if(s=v[s.toLowerCase()],!s||!s.href){var E=C[0].charAt(0);return{type:"text",raw:E,text:E}}return X(C,s,C[0],this.lexer)}},h.emStrong=function(a,v,C){C===void 0&&(C="");var s=this.rules.inline.emStrong.lDelim.exec(a);if(s&&!(s[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var E=s[1]||s[2]||"";if(!E||E&&(C===""||this.rules.inline.punctuation.exec(C))){var p=s[0].length-1,L,j,Y=p,J=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,v=v.slice(-1*a.length+p);(s=oe.exec(v))!=null;)if(L=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!L){if(j=L.length,s[3]||s[4]){Y+=j;continue}else if((s[5]||s[6])&&p%3&&!((p+j)%3)){J+=j;continue}if(Y-=j,!(Y>0)){if(j=Math.min(j,j+Y+J),Math.min(p,j)%2){var pe=a.slice(1,p+s.index+j);return{type:"em",raw:a.slice(0,p+s.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var fe=a.slice(2,p+s.index+j-1);return{type:"strong",raw:a.slice(0,p+s.index+j+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},h.codespan=function(a){var v=this.rules.inline.code.exec(a);if(v){var C=v[2].replace(/\n/g," "),s=/[^ ]/.test(C),E=/^ /.test(C)&&/ $/.test(C);return s&&E&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:v[0],text:C}}},h.br=function(a){var v=this.rules.inline.br.exec(a);if(v)return{type:"br",raw:v[0]}},h.del=function(a){var v=this.rules.inline.del.exec(a);if(v)return{type:"del",raw:v[0],text:v[2],tokens:this.lexer.inlineTokens(v[2])}},h.autolink=function(a,v){var C=this.rules.inline.autolink.exec(a);if(C){var s,E;return C[2]==="@"?(s=e(this.options.mangle?v(C[1]):C[1]),E="mailto:"+s):(s=e(C[1]),E=s),{type:"link",raw:C[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},h.url=function(a,v){var C;if(C=this.rules.inline.url.exec(a)){var s,E;if(C[2]==="@")s=e(this.options.mangle?v(C[0]):C[0]),E="mailto:"+s;else{var p;do p=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(p!==C[0]);s=e(C[0]),C[1]==="www."?E="http://"+s:E=s}return{type:"link",raw:C[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},h.inlineText=function(a,v){var C=this.rules.inline.text.exec(a);if(C){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:s=e(this.options.smartypants?v(C[0]):C[0]),{type:"text",raw:C[0],text:s}}},z}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=d(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=d(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=d(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=d(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=d(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=$({},ie),ie.gfm=$({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=d(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=$({},ie.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:q,paragraph:d(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=d(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=d(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=d(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=d(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=d(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=d(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=d(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=d(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=d(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=d(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=d(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=$({},ee),ee.pedantic=$({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=$({},ee.normal,{escape:d(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=d(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=$({},ee.gfm,{br:d(ee.br).replace("{2,}","*").getRegex(),text:d(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ye(z){var h="",D,a,v=z.length;for(D=0;D<v;D++)a=z.charCodeAt(D),Math.random()>.5&&(a="x"+a.toString(16)),h+="&#"+a+";";return h}var Ee=function(){function z(D){this.tokens=[],this.tokens.links=Object.create(null),this.options=D||se.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:ie.normal,inline:ee.normal};this.options.pedantic?(a.block=ie.pedantic,a.inline=ee.pedantic):this.options.gfm&&(a.block=ie.gfm,this.options.breaks?a.inline=ee.breaks:a.inline=ee.gfm),this.tokenizer.rules=a}z.lex=function(a,v){var C=new z(v);return C.lex(a)},z.lexInline=function(a,v){var C=new z(v);return C.inlineTokens(a)};var h=z.prototype;return h.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var v;v=this.inlineQueue.shift();)this.inlineTokens(v.src,v.tokens);return this.tokens},h.blockTokens=function(a,v){var C=this;v===void 0&&(v=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(Y,J,oe){return J+"    ".repeat(oe.length)});for(var s,E,p,L;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(s=Y.call({lexer:C},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.space(a)){a=a.substring(s.raw.length),s.raw.length===1&&v.length>0?v[v.length-1].raw+=`
`:v.push(s);continue}if(s=this.tokenizer.code(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s);continue}if(s=this.tokenizer.fences(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.heading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.hr(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.blockquote(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.list(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.html(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.def(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=E.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.lheading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(p=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,J=a.slice(1),oe=void 0;C.options.extensions.startBlock.forEach(function(pe){oe=pe.call({lexer:this},J),typeof oe=="number"&&oe>=0&&(Y=Math.min(Y,oe))}),Y<1/0&&Y>=0&&(p=a.substring(0,Y+1))}(),this.state.top&&(s=this.tokenizer.paragraph(p))){E=v[v.length-1],L&&E.type==="paragraph"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s),L=p.length!==a.length,a=a.substring(s.raw.length);continue}if(s=this.tokenizer.text(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&E.type==="text"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s);continue}if(a){var j="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,v},h.inline=function(a,v){return v===void 0&&(v=[]),this.inlineQueue.push({src:a,tokens:v}),v},h.inlineTokens=function(a,v){var C=this;v===void 0&&(v=[]);var s,E,p,L=a,j,Y,J;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)oe.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,j.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(Y||(J=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(s=fe.call({lexer:C},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.escape(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.tag(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(s=this.tokenizer.link(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(s.raw.length),E=v[v.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(s=this.tokenizer.emStrong(a,L,J)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.codespan(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.br(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.del(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.autolink(a,ye)){a=a.substring(s.raw.length),v.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(a,ye))){a=a.substring(s.raw.length),v.push(s);continue}if(p=a,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Le=a.slice(1),ke=void 0;C.options.extensions.startInline.forEach(function(Oe){ke=Oe.call({lexer:this},Le),typeof ke=="number"&&ke>=0&&(fe=Math.min(fe,ke))}),fe<1/0&&fe>=0&&(p=a.substring(0,fe+1))}(),s=this.tokenizer.inlineText(p,ce)){a=a.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(J=s.raw.slice(-1)),Y=!0,E=v[v.length-1],E&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(a){var pe="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return v},i(z,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),z}(),Me=function(){function z(D){this.options=D||se.defaults}var h=z.prototype;return h.code=function(a,v,C){var s=(v||"").match(/\S*/)[0];if(this.options.highlight){var E=this.options.highlight(a,s);E!=null&&E!==a&&(C=!0,a=E)}return a=a.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(C?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(C?a:e(a,!0))+`</code></pre>
`},h.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},h.html=function(a){return a},h.heading=function(a,v,C,s){if(this.options.headerIds){var E=this.options.headerPrefix+s.slug(C);return"<h"+v+' id="'+E+'">'+a+"</h"+v+`>
`}return"<h"+v+">"+a+"</h"+v+`>
`},h.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},h.list=function(a,v,C){var s=v?"ol":"ul",E=v&&C!==1?' start="'+C+'"':"";return"<"+s+E+`>
`+a+"</"+s+`>
`},h.listitem=function(a){return"<li>"+a+`</li>
`},h.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},h.paragraph=function(a){return"<p>"+a+`</p>
`},h.table=function(a,v){return v&&(v="<tbody>"+v+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+v+`</table>
`},h.tablerow=function(a){return`<tr>
`+a+`</tr>
`},h.tablecell=function(a,v){var C=v.header?"th":"td",s=v.align?"<"+C+' align="'+v.align+'">':"<"+C+">";return s+a+("</"+C+`>
`)},h.strong=function(a){return"<strong>"+a+"</strong>"},h.em=function(a){return"<em>"+a+"</em>"},h.codespan=function(a){return"<code>"+a+"</code>"},h.br=function(){return this.options.xhtml?"<br/>":"<br>"},h.del=function(a){return"<del>"+a+"</del>"},h.link=function(a,v,C){if(a=m(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var s='<a href="'+e(a)+'"';return v&&(s+=' title="'+v+'"'),s+=">"+C+"</a>",s},h.image=function(a,v,C){if(a=m(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var s='<img src="'+a+'" alt="'+C+'"';return v&&(s+=' title="'+v+'"'),s+=this.options.xhtml?"/>":">",s},h.text=function(a){return a},z}(),le=function(){function z(){}var h=z.prototype;return h.strong=function(a){return a},h.em=function(a){return a},h.codespan=function(a){return a},h.del=function(a){return a},h.html=function(a){return a},h.text=function(a){return a},h.link=function(a,v,C){return""+C},h.image=function(a,v,C){return""+C},h.br=function(){return""},z}(),_=function(){function z(){this.seen={}}var h=z.prototype;return h.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},h.getNextSafeSlug=function(a,v){var C=a,s=0;if(this.seen.hasOwnProperty(C)){s=this.seen[a];do s++,C=a+"-"+s;while(this.seen.hasOwnProperty(C))}return v||(this.seen[a]=s,this.seen[C]=0),C},h.slug=function(a,v){v===void 0&&(v={});var C=this.serialize(a);return this.getNextSafeSlug(C,v.dryrun)},z}(),ue=function(){function z(D){this.options=D||se.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}z.parse=function(a,v){var C=new z(v);return C.parse(a)},z.parseInline=function(a,v){var C=new z(v);return C.parseInline(a)};var h=z.prototype;return h.parse=function(a,v){v===void 0&&(v=!0);var C="",s,E,p,L,j,Y,J,oe,pe,fe,Le,ke,Oe,Ne,Fe,We,Ue,Ye,_e,Z=a.length;for(s=0;s<Z;s++){if(fe=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(_e=this.options.extensions.renderers[fe.type].call({parser:this},fe),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){C+=_e||"";continue}switch(fe.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,o(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(oe="",J="",L=fe.header.length,E=0;E<L;E++)J+=this.renderer.tablecell(this.parseInline(fe.header[E].tokens),{header:!0,align:fe.align[E]});for(oe+=this.renderer.tablerow(J),pe="",L=fe.rows.length,E=0;E<L;E++){for(Y=fe.rows[E],J="",j=Y.length,p=0;p<j;p++)J+=this.renderer.tablecell(this.parseInline(Y[p].tokens),{header:!1,align:fe.align[p]});pe+=this.renderer.tablerow(J)}C+=this.renderer.table(oe,pe);continue}case"blockquote":{pe=this.parse(fe.tokens),C+=this.renderer.blockquote(pe);continue}case"list":{for(Le=fe.ordered,ke=fe.start,Oe=fe.loose,L=fe.items.length,pe="",E=0;E<L;E++)Fe=fe.items[E],We=Fe.checked,Ue=Fe.task,Ne="",Fe.task&&(Ye=this.renderer.checkbox(We),Oe?Fe.tokens.length>0&&Fe.tokens[0].type==="paragraph"?(Fe.tokens[0].text=Ye+" "+Fe.tokens[0].text,Fe.tokens[0].tokens&&Fe.tokens[0].tokens.length>0&&Fe.tokens[0].tokens[0].type==="text"&&(Fe.tokens[0].tokens[0].text=Ye+" "+Fe.tokens[0].tokens[0].text)):Fe.tokens.unshift({type:"text",text:Ye}):Ne+=Ye),Ne+=this.parse(Fe.tokens,Oe),pe+=this.renderer.listitem(Ne,Ue,We);C+=this.renderer.list(pe,Le,ke);continue}case"html":{C+=this.renderer.html(fe.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(pe=fe.tokens?this.parseInline(fe.tokens):fe.text;s+1<Z&&a[s+1].type==="text";)fe=a[++s],pe+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);C+=v?this.renderer.paragraph(pe):pe;continue}default:{var ne='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return C},h.parseInline=function(a,v){v=v||this.renderer;var C="",s,E,p,L=a.length;for(s=0;s<L;s++){if(E=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[E.type]&&(p=this.options.extensions.renderers[E.type].call({parser:this},E),p!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(E.type))){C+=p||"";continue}switch(E.type){case"escape":{C+=v.text(E.text);break}case"html":{C+=v.html(E.text);break}case"link":{C+=v.link(E.href,E.title,this.parseInline(E.tokens,v));break}case"image":{C+=v.image(E.href,E.title,E.text);break}case"strong":{C+=v.strong(this.parseInline(E.tokens,v));break}case"em":{C+=v.em(this.parseInline(E.tokens,v));break}case"codespan":{C+=v.codespan(E.text);break}case"br":{C+=v.br();break}case"del":{C+=v.del(this.parseInline(E.tokens,v));break}case"text":{C+=v.text(E.text);break}default:{var j='Token with "'+E.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return C},z}();function re(z,h,D){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof h=="function"&&(D=h,h=null),h=$({},re.defaults,h||{}),x(h),D){var a=h.highlight,v;try{v=Ee.lex(z,h)}catch(L){return D(L)}var C=function(j){var Y;if(!j)try{h.walkTokens&&re.walkTokens(v,h.walkTokens),Y=ue.parse(v,h)}catch(J){j=J}return h.highlight=a,j?D(j):D(null,Y)};if(!a||a.length<3||(delete h.highlight,!v.length))return C();var s=0;re.walkTokens(v,function(L){L.type==="code"&&(s++,setTimeout(function(){a(L.text,L.lang,function(j,Y){if(j)return C(j);Y!=null&&Y!==L.text&&(L.text=Y,L.escaped=!0),s--,s===0&&C()})},0))}),s===0&&C();return}function E(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,h.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}try{var p=Ee.lex(z,h);if(h.walkTokens){if(h.async)return Promise.all(re.walkTokens(p,h.walkTokens)).then(function(){return ue.parse(p,h)}).catch(E);re.walkTokens(p,h.walkTokens)}return ue.parse(p,h)}catch(L){E(L)}}re.options=re.setOptions=function(z){return $(re.defaults,z),k(re.defaults),re},re.getDefaults=S,re.defaults=se.defaults,re.use=function(){for(var z=arguments.length,h=new Array(z),D=0;D<z;D++)h[D]=arguments[D];var a=$.apply(void 0,[{}].concat(h)),v=re.defaults.extensions||{renderers:{},childTokens:{}},C;h.forEach(function(s){if(s.extensions&&(C=!0,s.extensions.forEach(function(p){if(!p.name)throw new Error("extension name required");if(p.renderer){var L=v.renderers?v.renderers[p.name]:null;L?v.renderers[p.name]=function(){for(var j=arguments.length,Y=new Array(j),J=0;J<j;J++)Y[J]=arguments[J];var oe=p.renderer.apply(this,Y);return oe===!1&&(oe=L.apply(this,Y)),oe}:v.renderers[p.name]=p.renderer}if(p.tokenizer){if(!p.level||p.level!=="block"&&p.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");v[p.level]?v[p.level].unshift(p.tokenizer):v[p.level]=[p.tokenizer],p.start&&(p.level==="block"?v.startBlock?v.startBlock.push(p.start):v.startBlock=[p.start]:p.level==="inline"&&(v.startInline?v.startInline.push(p.start):v.startInline=[p.start]))}p.childTokens&&(v.childTokens[p.name]=p.childTokens)})),s.renderer&&function(){var p=re.defaults.renderer||new Me,L=function(J){var oe=p[J];p[J]=function(){for(var pe=arguments.length,fe=new Array(pe),Le=0;Le<pe;Le++)fe[Le]=arguments[Le];var ke=s.renderer[J].apply(p,fe);return ke===!1&&(ke=oe.apply(p,fe)),ke}};for(var j in s.renderer)L(j);a.renderer=p}(),s.tokenizer&&function(){var p=re.defaults.tokenizer||new ae,L=function(J){var oe=p[J];p[J]=function(){for(var pe=arguments.length,fe=new Array(pe),Le=0;Le<pe;Le++)fe[Le]=arguments[Le];var ke=s.tokenizer[J].apply(p,fe);return ke===!1&&(ke=oe.apply(p,fe)),ke}};for(var j in s.tokenizer)L(j);a.tokenizer=p}(),s.walkTokens){var E=re.defaults.walkTokens;a.walkTokens=function(p){var L=[];return L.push(s.walkTokens.call(this,p)),E&&(L=L.concat(E.call(this,p))),L}}C&&(a.extensions=v),re.setOptions(a)})},re.walkTokens=function(z,h){for(var D=[],a=function(){var E=C.value;switch(D=D.concat(h.call(re,E)),E.type){case"table":{for(var p=H(E.header),L;!(L=p()).done;){var j=L.value;D=D.concat(re.walkTokens(j.tokens,h))}for(var Y=H(E.rows),J;!(J=Y()).done;)for(var oe=J.value,pe=H(oe),fe;!(fe=pe()).done;){var Le=fe.value;D=D.concat(re.walkTokens(Le.tokens,h))}break}case"list":{D=D.concat(re.walkTokens(E.items,h));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[E.type]?re.defaults.extensions.childTokens[E.type].forEach(function(ke){D=D.concat(re.walkTokens(E[ke],h))}):E.tokens&&(D=D.concat(re.walkTokens(E.tokens,h)))}},v=H(z),C;!(C=v()).done;)a();return D},re.parseInline=function(z,h){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");h=$({},re.defaults,h||{}),x(h);try{var D=Ee.lexInline(z,h);return h.walkTokens&&re.walkTokens(D,h.walkTokens),ue.parseInline(D,h)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,h.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},re.Parser=ue,re.parser=ue.parse,re.Renderer=Me,re.TextRenderer=le,re.Lexer=Ee,re.lexer=Ee.lex,re.Tokenizer=ae,re.Slugger=_,re.parse=re;var De=re.options,W=re.setOptions,Q=re.use,ge=re.walkTokens,we=re.parseInline,Ae=re,Te=ue.parse,Ie=Ee.lex;se.Lexer=Ee,se.Parser=ue,se.Renderer=Me,se.Slugger=_,se.TextRenderer=le,se.Tokenizer=ae,se.getDefaults=S,se.lexer=Ie,se.marked=re,se.options=De,se.parse=Ae,se.parseInline=we,se.parser=Te,se.setOptions=W,se.use=Q,se.walkTokens=ge,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[89],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sk=i;function i(n){const o=H(n);if(o&&o.length>0)return new Uint32Array(o)}let F=0;const B=new Uint32Array(10);function H(n){if(F=0,S(n,P,4352),F>0||(S(n,u,4449),F>0)||(S(n,c,4520),F>0)||(S(n,e,12593),F))return B.subarray(0,F);if(n>=44032&&n<=55203){const o=n-44032,l=o%588,d=Math.floor(o/588),N=Math.floor(l/28),b=l%28-1;if(d<P.length?S(d,P,0):4352+d-12593<e.length&&S(4352+d,e,12593),N<u.length?S(N,u,0):4449+N-12593<e.length&&S(4449+N-12593,e,12593),b>=0&&(b<c.length?S(b,c,0):4520+b-12593<e.length&&S(4520+b-12593,e,12593)),F>0)return B.subarray(0,F)}}function S(n,o,l){n>=l&&n<l+o.length&&k(o[n-l])}function k(n){n!==0&&(B[F++]=n&255,n>>8&&(B[F++]=n>>8&255),n>>16&&(B[F++]=n>>16&255))}var f;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var g;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(g||(g={}));var w;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(w||(w={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),c=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[90],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cV=void 0;class i{constructor(B,H=0,S=B.length,k=H-1){this.a=B,this.b=H,this.c=S,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$cV=i}),define(me[91],be([1,0,90]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eV=t.$dV=void 0;class F{constructor(S=[],k=10){this.h(S),this.b=k,this.d()}getHistory(){return this.j}add(S){this.a.delete(S),this.a.add(S),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(S){return this.a.has(S)}clear(){this.h([]),this.d()}d(){this.f();const S=this.j;this.c=new i.$cV(S,0,S.length,S.length)}f(){const S=this.j;S.length>this.b&&this.h(S.slice(S.length-this.b))}g(){const S=this.c.current();return S?this.j.indexOf(S):-1}h(S){this.a=new Set;for(const k of S)this.a.add(k)}get j(){const S=[];return this.a.forEach(k=>S.push(k)),S}}t.$dV=F;class B{get size(){return this.f}constructor(S,k=10){if(this.g=k,S.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:S[0],previous:void 0,next:void 0},this.a=new Set([S[0]]);for(let f=1;f<S.length;f++)this.add(S[f])}add(S){const k={value:S,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(S)?this.h(S):this.a.add(S);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(S){if(this.c.value===S)return S;const k=this.c.value;return this.a.delete(k),this.c.value=S,this.a.has(S)?this.h(S):this.a.add(S),k}prepend(S){if(this.f===this.g||this.a.has(S))return;const k={value:S,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(S)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(S){return this.a.has(S)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let S=this.b;for(;S;)yield S.value,S=S.next}h(S){let k=this.b;for(;k!==this.c;)k.value===S&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$eV=B}),define(me[40],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cm=t.$Bm=t.$Am=void 0,t.$ym=i,t.rot=F;function i(k,f,g){return Math.min(Math.max(k,f),g)}function F(k,f){return(f+k%f)%f}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Am=B;class H{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Bm=H;class S{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const g=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Cm=S}),define(me[26],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_c=void 0,t.$ad=H,t.$bd=u;class i{constructor(e,n,o){this.owner=e,this.debugNameSource=n,this.referenceFn=o}getDebugName(e){return H(e,this)}}t.$_c=i;const F=new Map,B=new WeakMap;function H(c,e){const n=B.get(c);if(n)return n;const o=S(c,e);if(o){let l=F.get(o)??0;l++,F.set(o,l);const d=l===1?o:`${o}#${l}`;return B.set(c,d),d}}function S(c,e){const n=B.get(c);if(n)return n;const o=e.owner?w(e.owner)+".":"";let l;const d=e.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(l=d(),l!==void 0)return o+l}else return o+d;const N=e.referenceFn;if(N!==void 0&&(l=u(N),l!==void 0))return o+l;if(e.owner!==void 0){const b=k(e.owner,c);if(b!==void 0)return o+b}}function k(c,e){for(const n in c)if(c[n]===e)return n}const f=new Map,g=new WeakMap;function w(c){const e=g.get(c);if(e)return e;const n=P(c);let o=f.get(n)??0;o++,f.set(n,o);const l=o===1?n:`${n}#${o}`;return g.set(c,l),l}function P(c){const e=c.constructor;return e?e.name:"Object"}function u(c){const e=c.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(me[27],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Id=void 0,t.$Gd=F,t.$Hd=B;let i;function F(n){i=n}function B(){return i}class H{constructor(){this.a=0,this.d=new WeakMap}b(o){return S([k(c("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[k(" "),g(w(o.oldValue,70),{color:"red",strikeThrough:!0}),k(" "),g(w(o.newValue,60),{color:"green"})]:[k(" (unchanged)")]:[k(" "),g(w(o.newValue,60),{color:"green"}),k(" (initial)")]}handleObservableChanged(o,l){console.log(...this.b([f("observable value changed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(o){if(o.size!==0)return g(" (changed deps: "+[...o].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(d,N)=>(this.d.get(o).add(d),l.apply(o,[d,N]))}handleDerivedRecomputed(o,l){const d=this.d.get(o);console.log(...this.b([f("derived recomputed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(d),{data:[{fn:o._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(o,l){console.log(...this.b([f("observable from event triggered"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(d,N)=>(this.d.get(o).add(d),l.apply(o,[d,N]))}handleAutorunTriggered(o){const l=this.d.get(o);console.log(...this.b([f("autorun"),g(o.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:o._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let l=o.getDebugName();l===void 0&&(l=""),console.log(...this.b([f("transaction"),g(l,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Id=H;function S(n){const o=new Array,l=[];let d="";function N(m){if("length"in m)for(const r of m)r&&N(r);else"text"in m?(d+=`%c${m.text}`,o.push(m.style),m.data&&l.push(...m.data)):"data"in m&&l.push(...m.data)}N(n);const b=[d,...o];return b.push(...l),b}function k(n){return g(n,{color:"black"})}function f(n){return g(e(`${n}: `,10),{color:"black",bold:!0})}function g(n,o={color:"black"}){function l(N){return Object.entries(N).reduce((b,[m,r])=>`${b}${m}:${r};`,"")}const d={color:o.color};return o.strikeThrough&&(d["text-decoration"]="line-through"),o.bold&&(d["font-weight"]="bold"),{text:n,style:l(d)}}function w(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?P(n,o):u(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function P(n,o){let l="[ ",d=!0;for(const N of n){if(d||(l+=", "),l.length-5>o){l+="...";break}d=!1,l+=`${w(N,o-l.length)}`}return l+=" ]",l}function u(n,o){let l="{ ",d=!0;for(const[N,b]of Object.entries(n)){if(d||(l+=", "),l.length-5>o){l+="...";break}d=!1,l+=`${N}: ${w(b,o-l.length)}`}return l+=" }",l}function c(n,o){let l="";for(let d=1;d<=o;d++)l+=n;return l}function e(n,o){for(;n.length<o;)n+=" ";return n}}),define(me[41],be([1,0,37,2,26,27]),function(se,t,i,F,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=void 0,t.$id=S,t.$jd=k,t.$kd=f,t.$ld=g,t.$md=w,t.$nd=P;function S(e){return new c(new B.$_c(void 0,void 0,e),e,void 0,void 0)}function k(e,n){return new c(new B.$_c(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function f(e,n){return new c(new B.$_c(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function g(e,n){const o=new F.$Uc,l=f({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(d,N)=>{o.clear(),n(d,N,o)});return(0,F.$Tc)(()=>{l.dispose(),o.dispose()})}function w(e){const n=new F.$Uc,o=k({owner:void 0,debugName:void 0,debugReferenceFn:e},l=>{n.clear(),e(l,n)});return(0,F.$Tc)(()=>{o.dispose(),n.dispose()})}function P(e,n){let o;return k({debugReferenceFn:n},l=>{const d=e.read(l),N=o;o=d,n({lastValue:N,newValue:d})})}var u;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(u||(u={}));class c{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,o,l,d){this.h=n,this._runFn=o,this.i=l,this.j=d,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,H.$Hd)()?.handleAutorunCreated(this),this.k(),(0,F.$Mc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,F.$Nc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const o=this.c;try{if(!o){(0,H.$Hd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{o||(0,H.$Hd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$gd)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,o){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:o,didChange:d=>d===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const o=n.get();return this.e.add(n),this.f.delete(n),o}}t.$od=c,function(e){e.Observer=c}(S||(t.$id=S={}))}),define(me[33],be([1,0,38,26,27]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.$2d=t.$Yd=t.$Td=t.$Sd=void 0,t.$Pd=S,t.$Qd=f,t.$Rd=w,t.$Ud=c,t.$Vd=n,t.$Wd=o,t.$Xd=l,t.$Zd=N,t.$1d=b,t.$3d=r;let H;function S(A){H=A}let k;function f(A){k=A}let g;function w(A){g=A}class P{get TChange(){return null}reportChanges(){this.get()}read(T){return T?T.readObservable(this):this.get()}map(T,M){const q=M===void 0?void 0:T,$=M===void 0?T:M;return g({owner:q,debugName:()=>{const I=(0,F.$bd)($);if(I!==void 0)return I;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec($.toString());if(R)return`${this.debugName}.${R[2]}`;if(!q)return`${this.debugName} (mapped)`},debugReferenceFn:$},I=>$(this.read(I),I))}recomputeInitiallyAndOnChange(T,M){return T.add(H(this,M)),this}keepObserved(T){return T.add(k(this)),this}get a(){return this.get()}}t.$Sd=P;class u extends P{constructor(){super(...arguments),this.b=new Set}addObserver(T){const M=this.b.size;this.b.add(T),M===0&&this.c()}removeObserver(T){this.b.delete(T)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Td=u;function c(A,T){const M=new d(A,T);try{A(M)}finally{M.finish()}}let e;function n(A){if(e)A(e);else{const T=new d(A,void 0);e=T;try{A(T)}finally{T.finish(),e=void 0}}}async function o(A,T){const M=new d(A,T);try{await A(M)}finally{M.finish()}}function l(A,T,M){A?T(A):c(T,M)}class d{constructor(T,M){this._fn=T,this.b=M,this.a=[],(0,B.$Hd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,F.$bd)(this._fn)}updateObserver(T,M){this.a.push({observer:T,observable:M}),T.beginUpdate(M)}finish(){const T=this.a;for(let M=0;M<T.length;M++){const{observer:q,observable:$}=T[M];q.endUpdate($)}this.a=null,(0,B.$Hd)()?.handleEndTransaction()}}t.$Yd=d;function N(A,T){let M;return typeof A=="string"?M=new F.$_c(void 0,A,void 0):M=new F.$_c(A,void 0,void 0),new m(M,T,i.$7c)}function b(A,T){return new m(new F.$_c(A.owner,A.debugName,void 0),T,A.equalsFn??i.$7c)}class m extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(T,M,q){super(),this.e=T,this.g=q,this.d=M}get(){return this.d}set(T,M,q){if(this.g(this.d,T))return;let $;M||(M=$=new d(()=>{},()=>`Setting ${this.debugName}`));try{const I=this.d;this.h(T),(0,B.$Hd)()?.handleObservableChanged(this,{oldValue:I,newValue:T,change:q,didChange:!0,hadValue:!0});for(const V of this.b)M.updateObserver(V,this),V.handleChange(this,q)}finally{$&&$.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(T){this.d=T}}t.$2d=m;function r(A,T){let M;return typeof A=="string"?M=new F.$_c(void 0,A,void 0):M=new F.$_c(A,void 0,void 0),new y(M,T,i.$7c)}class y extends m{h(T){this.d!==T&&(this.d&&this.d.dispose(),this.d=T)}dispose(){this.d?.dispose()}}t.$4d=y}),define(me[42],be([1,0,37,38,2,33,26,27]),function(se,t,i,F,B,H,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0,t.$Jd=f,t.$Kd=g,t.$Ld=w,t.$Md=P,t.$Nd=u;function f(n,o){return o!==void 0?new e(new S.$_c(n,void 0,o),o,void 0,void 0,void 0,F.$7c):new e(new S.$_c(void 0,void 0,n),n,void 0,void 0,void 0,F.$7c)}function g(n,o){return new e(new S.$_c(n.owner,n.debugName,n.debugReferenceFn),o,void 0,void 0,n.onLastObserverRemoved,n.equalsFn??F.$7c)}(0,H.$Rd)(g);function w(n,o){return new e(new S.$_c(n.owner,n.debugName,void 0),o,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??F.$7c)}function P(n,o){let l,d;o===void 0?(l=n,d=void 0):(d=n,l=o);const N=new B.$Uc;return new e(new S.$_c(d,void 0,l),b=>(N.clear(),l(b,N)),void 0,void 0,()=>N.dispose(),F.$7c)}function u(n,o){let l,d;o===void 0?(l=n,d=void 0):(d=n,l=o);const N=new B.$Uc;return new e(new S.$_c(d,void 0,l),b=>{N.clear();const m=l(b);return m&&N.add(m),m},void 0,void 0,()=>N.dispose(),F.$7c)}var c;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class e extends H.$Td{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(o,l,d,N,b=void 0,m){super(),this.m=o,this._computeFn=l,this.n=d,this.p=N,this.q=b,this.s=m,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,k.$Hd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const o of this.j)o.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const o=this._computeFn(this,this.n?.());return this.f(),o}else{do{if(this.e===1){for(const o of this.j)if(o.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const o=this.k;this.k=this.j,this.j=o;const l=this.e!==0,d=this.g;this.e=3;const N=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,N)}finally{for(const m of this.k)m.removeObserver(this);this.k.clear()}const b=l&&!this.s(d,this.g);if((0,k.$Hd)()?.handleDerivedRecomputed(this,{oldValue:d,newValue:this.g,change:void 0,didChange:b,hadValue:l}),b)for(const m of this.b)m.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(o){this.h++;const l=this.h===1;if(this.e===3&&(this.e=1,!l))for(const d of this.b)d.handlePossibleChange(this);if(l)for(const d of this.b)d.beginUpdate(this)}endUpdate(o){if(this.h--,this.h===0){const l=[...this.b];for(const d of l)d.endUpdate(this)}(0,i.$gd)(()=>this.h>=0)}handlePossibleChange(o){if(this.e===3&&this.j.has(o)&&!this.k.has(o)){this.e=1;for(const l of this.b)l.handlePossibleChange(this)}}handleChange(o,l){if(this.j.has(o)&&!this.k.has(o)){const d=this.p?this.p({changedObservable:o,change:l,didChange:b=>b===o},this.l):!0,N=this.e===3;if(d&&(this.e===1||N)&&(this.e=2,N))for(const b of this.b)b.handlePossibleChange(this)}}readObservable(o){o.addObserver(this);const l=o.get();return this.j.add(o),this.k.delete(o),l}addObserver(o){const l=!this.b.has(o)&&this.h>0;super.addObserver(o),l&&o.beginUpdate(this)}removeObserver(o){const l=this.b.has(o)&&this.h>0;super.removeObserver(o),l&&o.endUpdate(this)}}t.$Od=e}),define(me[56],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(F){function B(f,g){if(f.start>=g.end||g.start>=f.end)return{start:0,end:0};const w=Math.max(f.start,g.start),P=Math.min(f.end,g.end);return P-w<=0?{start:0,end:0}:{start:w,end:P}}F.intersect=B;function H(f){return f.end-f.start<=0}F.isEmpty=H;function S(f,g){return!H(B(f,g))}F.intersects=S;function k(f,g){const w=[],P={start:f.start,end:Math.min(g.start,f.end)},u={start:Math.max(g.end,f.start),end:f.end};return H(P)||w.push(P),H(u)||w.push(u),w}F.relativeComplement=k})(i||(t.Range=i={}))}),define(me[92],be([1,0,56]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=void 0,t.$RT=F,t.$ST=B,t.$TT=H;function F(f,g){const w=[];for(const P of g){if(f.start>=P.range.end)continue;if(f.end<P.range.start)break;const u=i.Range.intersect(f,P.range);i.Range.isEmpty(u)||w.push({range:u,size:P.size})}return w}function B({start:f,end:g},w){return{start:f+w,end:g+w}}function H(f){const g=[];let w=null;for(const P of f){const u=P.range.start,c=P.range.end,e=P.size;if(w&&e===w.size){w.range.end=c;continue}w={range:{start:u,end:c},size:e},g.push(w)}return g}function S(...f){return H(f.reduce((g,w)=>g.concat(w),[]))}class k{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,w,P=[]){const u=P.length-w,c=F({start:0,end:g},this.a),e=F({start:g+w,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:B(o.range,u),size:o.size})),n=P.map((o,l)=>({range:{start:g+l,end:g+l+1},size:o.size}));this.a=S(c,n,e),this.b=this.c+this.a.reduce((o,l)=>o+l.size*(l.range.end-l.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let w=0,P=this.c;for(const u of this.a){const c=u.range.end-u.range.start,e=P+c*u.size;if(g<e)return w+Math.floor((g-P)/u.size);w+=c,P=e}return w}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let w=0,P=0;for(const u of this.a){const c=u.range.end-u.range.start,e=P+c;if(g<e)return this.c+w+(g-P)*u.size;w+=c*u.size,P=e}return-1}}t.$UT=k}),define(me[93],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(H){return new F(H)}constructor(H){this.c=i&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$$d=F}),define(me[3],be([1,0,6,53,2,55,93]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$ae=t.Event=void 0,t.$be=c;const k=!1,f=!1,g=!1;var w;(function(X){X.None=()=>B.$Vc.None;function K(E){if(g){const{onDidAddListener:p}=E,L=n.create();let j=0;E.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),L.print()),p?.()}}}function ae(E,p){return re(E,()=>{},0,void 0,!0,void 0,p)}X.defer=ae;function ie(E){return(p,L=null,j)=>{let Y=!1,J;return J=E(oe=>{if(!Y)return J?J.dispose():Y=!0,p.call(L,oe)},null,j),Y&&J.dispose(),J}}X.once=ie;function ee(E,p,L){return _((j,Y=null,J)=>E(oe=>j.call(Y,p(oe)),null,J),L)}X.map=ee;function ce(E,p,L){return _((j,Y=null,J)=>E(oe=>{p(oe),j.call(Y,oe)},null,J),L)}X.forEach=ce;function ye(E,p,L){return _((j,Y=null,J)=>E(oe=>p(oe)&&j.call(Y,oe),null,J),L)}X.filter=ye;function Ee(E){return E}X.signal=Ee;function Me(...E){return(p,L=null,j)=>{const Y=(0,B.$Sc)(...E.map(J=>J(oe=>p.call(L,oe))));return ue(Y,j)}}X.any=Me;function le(E,p,L,j){let Y=L;return ee(E,J=>(Y=p(Y,J),Y),j)}X.reduce=le;function _(E,p){let L;const j={onWillAddFirstListener(){L=E(Y.fire,Y)},onDidRemoveLastListener(){L?.dispose()}};p||K(j);const Y=new m(j);return p?.add(Y),Y.event}function ue(E,p){return p instanceof Array?p.push(E):p&&p.add(E),E}function re(E,p,L=100,j=!1,Y=!1,J,oe){let pe,fe,Le,ke=0,Oe;const Ne={leakWarningThreshold:J,onWillAddFirstListener(){pe=E(We=>{ke++,fe=p(fe,We),j&&!Le&&(Fe.fire(fe),fe=void 0),Oe=()=>{const Ue=fe;fe=void 0,Le=void 0,(!j||ke>1)&&Fe.fire(Ue),ke=0},typeof L=="number"?(clearTimeout(Le),Le=setTimeout(Oe,L)):Le===void 0&&(Le=0,queueMicrotask(Oe))})},onWillRemoveListener(){Y&&ke>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,pe.dispose()}};oe||K(Ne);const Fe=new m(Ne);return oe?.add(Fe),Fe.event}X.debounce=re;function De(E,p=0,L){return X.debounce(E,(j,Y)=>j?(j.push(Y),j):[Y],p,void 0,!0,void 0,L)}X.accumulate=De;function W(E,p=(j,Y)=>j===Y,L){let j=!0,Y;return ye(E,J=>{const oe=j||!p(J,Y);return j=!1,Y=J,oe},L)}X.latch=W;function Q(E,p,L){return[X.filter(E,p,L),X.filter(E,j=>!p(j),L)]}X.split=Q;function ge(E,p=!1,L=[],j){let Y=L.slice(),J=E(fe=>{Y?Y.push(fe):pe.fire(fe)});j&&j.add(J);const oe=()=>{Y?.forEach(fe=>pe.fire(fe)),Y=null},pe=new m({onWillAddFirstListener(){J||(J=E(fe=>pe.fire(fe)),j&&j.add(J))},onDidAddFirstListener(){Y&&(p?setTimeout(oe):oe())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return j&&j.add(pe),pe.event}X.buffer=ge;function we(E,p){return(j,Y,J)=>{const oe=p(new Te);return E(function(pe){const fe=oe.evaluate(pe);fe!==Ae&&j.call(Y,fe)},void 0,J)}}X.chain=we;const Ae=Symbol("HaltChainable");class Te{constructor(){this.f=[]}map(p){return this.f.push(p),this}forEach(p){return this.f.push(L=>(p(L),L)),this}filter(p){return this.f.push(L=>p(L)?L:Ae),this}reduce(p,L){let j=L;return this.f.push(Y=>(j=p(j,Y),j)),this}latch(p=(L,j)=>L===j){let L=!0,j;return this.f.push(Y=>{const J=L||!p(Y,j);return L=!1,j=Y,J?Y:Ae}),this}evaluate(p){for(const L of this.f)if(p=L(p),p===Ae)break;return p}}function Ie(E,p,L=j=>j){const j=(...pe)=>oe.fire(L(...pe)),Y=()=>E.on(p,j),J=()=>E.removeListener(p,j),oe=new m({onWillAddFirstListener:Y,onDidRemoveLastListener:J});return oe.event}X.fromNodeEventEmitter=Ie;function z(E,p,L=j=>j){const j=(...pe)=>oe.fire(L(...pe)),Y=()=>E.addEventListener(p,j),J=()=>E.removeEventListener(p,j),oe=new m({onWillAddFirstListener:Y,onDidRemoveLastListener:J});return oe.event}X.fromDOMEventEmitter=z;function h(E){return new Promise(p=>ie(E)(p))}X.toPromise=h;function D(E){const p=new m;return E.then(L=>{p.fire(L)},()=>{p.fire(void 0)}).finally(()=>{p.dispose()}),p.event}X.fromPromise=D;function a(E,p,L){return p(L),E(j=>p(j))}X.runAndSubscribe=a;class v{constructor(p,L){this._observable=p,this.f=0,this.g=!1;const j={onWillAddFirstListener:()=>{p.addObserver(this)},onDidRemoveLastListener:()=>{p.removeObserver(this)}};L||K(j),this.emitter=new m(j),L&&L.add(this.emitter)}beginUpdate(p){this.f++}handlePossibleChange(p){}handleChange(p,L){this.g=!0}endUpdate(p){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function C(E,p){return new v(E,p).emitter.event}X.fromObservable=C;function s(E){return(p,L,j)=>{let Y=0,J=!1;const oe={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(E.reportChanges(),J&&(J=!1,p.call(L)))},handlePossibleChange(){},handleChange(){J=!0}};E.addObserver(oe),E.reportChanges();const pe={dispose(){E.removeObserver(oe)}};return j instanceof B.$Uc?j.add(pe):Array.isArray(j)&&j.push(pe),pe}}X.fromObservableLight=s})(w||(t.Event=w={}));class P{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${P.f++}`,P.all.add(this)}start(K){this.g=new S.$$d,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}t.$ae=P;let u=-1;function c(X){const K=u;return u=X,{dispose(){u=K}}}class e{constructor(K,ae=Math.random().toString(18).slice(2,5)){this.threshold=K,this.name=ae,this.g=0}dispose(){this.f?.clear()}check(K,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this.f||(this.f=new Map);const ee=this.f.get(K.value)||0;if(this.f.set(K.value,ee+1),this.g-=1,this.g<=0){this.g=ie*.5;let ce,ye=0;for(const[Ee,Me]of this.f)(!ce||ye<Me)&&(ce=Ee,ye=Me);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${ye}):`),console.warn(ce)}return()=>{const ce=this.f.get(K.value)||0;this.f.set(K.value,ce-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let o=0;class l{constructor(K){this.value=K,this.id=o++}}const d=2,N=(X,K)=>{if(X instanceof l)K(X);else for(let ae=0;ae<X.length;ae++){const ie=X[ae];ie&&K(ie)}},b=k?new FinalizationRegistry(X=>{typeof X=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(X))}):void 0;class m{constructor(K){this.w=0,this.f=K,this.g=u>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const K=this.t;queueMicrotask(()=>{N(K,ae=>ae.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,ae,ie)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),B.$Vc.None;if(this.m)return B.$Vc.None;ae&&(K=K.bind(ae));const ee=new l(K);let ce,ye;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=n.create(),ce=this.g.check(ee.stack,this.w+1)),f&&(ee.stack=ye??n.create()),this.t?this.t instanceof l?(this.u??=new y,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const Ee=(0,B.$Tc)(()=>{b?.unregister(Ee),ce?.(),this.x(ee)});if(ie instanceof B.$Uc?ie.add(Ee):Array.isArray(ie)&&ie.push(Ee),b){const Me=new Error().stack.split(`
`).slice(2).join(`
`).trim();b.register(Ee,Me,Ee)}return Ee},this.q}x(K){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ae=this.t,ie=ae.indexOf(K);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ae[ie]=void 0;const ee=this.u.current===this;if(this.w*d<=ae.length){let ce=0;for(let ye=0;ye<ae.length;ye++)ae[ye]?ae[ce++]=ae[ye]:ee&&(this.u.end--,ce<this.u.i&&this.u.i--);ae.length=ce}}y(K,ae){if(!K)return;const ie=this.f?.onListenerError||i.$1;if(!ie){K.value(ae);return}try{K.value(ae)}catch(ee){ie(ee)}}z(K){const ae=K.current.t;for(;K.i<K.end;)this.y(ae[K.i++],K.value);K.reset()}fire(K){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,K);else{const ae=this.u;ae.enqueue(this,K,this.t.length),this.z(ae)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ce=m;const r=()=>new y;t.$de=r;class y{constructor(){this.i=-1,this.end=0}enqueue(K,ae,ie){this.i=0,this.end=ie,this.current=K,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class A extends m{async fireAsync(K,ae,ie){if(this.t)for(this.h||(this.h=new H.$6c),N(this.t,ee=>this.h.push([ee.value,K]));this.h.size>0&&!ae.isCancellationRequested;){const[ee,ce]=this.h.shift(),ye=[],Ee={...ce,token:ae,waitUntil:Me=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Me=ie(Me,ee)),ye.push(Me)}};try{ee(Ee)}catch(Me){(0,i.$1)(Me);continue}Object.freeze(ye),await Promise.allSettled(ye).then(Me=>{for(const le of Me)le.status==="rejected"&&(0,i.$1)(le.reason)})}}}t.$ee=A;class T extends m{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new H.$6c,this.A=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.A(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.w&&(this.h!==0?this.s.push(K):super.fire(K))}}t.$fe=T;class M extends T{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}t.$ge=M;class q extends m{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ae=>super.fire(ae)),this.h=[]}))}}t.$he=q;class ${constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const ae={event:K,listener:null};this.h.push(ae),this.g&&this.m(ae);const ie=()=>{this.g&&this.o(ae);const ee=this.h.indexOf(ae);this.h.splice(ee,1)};return(0,B.$Tc)((0,F.$db)(ie))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(ae=>this.f.fire(ae))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}t.$ie=$;class I{constructor(K,ae,ie,ee){this.f=new B.$Uc;const ce=this.f.add(new $),ye=this.f.add(new B.$5c);function Ee(Me){ye.set(Me,ce.add(ee(Me)))}for(const Me of K)Ee(Me);this.f.add(ae(Me=>{Ee(Me)})),this.f.add(ie(Me=>{ye.deleteAndDispose(Me)})),this.event=ce.event}dispose(){this.f.dispose()}}t.$je=I;class V{constructor(){this.f=[]}wrapEvent(K){return(ae,ie,ee)=>K(ce=>{const ye=this.f[this.f.length-1];ye?ye.push(()=>ae.call(ie,ce)):ae.call(ie,ce)},void 0,ee)}bufferEvents(K){const ae=[];this.f.push(ae);const ie=K();return this.f.pop(),ae.forEach(ee=>ee()),ie}}t.$ke=V;class R{constructor(){this.f=!1,this.g=w.None,this.h=B.$Vc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$le=R;class x{static const(K){return new O(K)}constructor(K){this.g=K,this.f=new m,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}t.$me=x;class O{constructor(K){this.value=K,this.onDidChange=w.None}}}),define(me[17],be([1,0,22,3]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=t.$vR=t.$uR=t.$tR=t.$sR=t.$rR=t.$qR=t.$pR=t.$kR=void 0,t.$hR=H,t.$iR=S,t.$jR=k,t.$lR=f,t.$mR=g,t.$nR=w,t.$oR=P,t.$xR=e,t.$yR=n;class B{constructor(){this.a=new Map,this.b=new F.$ce,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new F.$ce,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(l){return this.a.get(this.f(l))??0}setZoomLevel(l,d){if(this.getZoomLevel(d)===l)return;const N=this.f(d);this.a.set(N,l),this.b.fire(N)}getZoomFactor(l){return this.c.get(this.f(l))??1}setZoomFactor(l,d){this.c.set(this.f(d),l)}setFullscreen(l,d){if(this.isFullscreen(d)===l)return;const N=this.f(d);this.e.set(N,l),this.d.fire(N)}isFullscreen(l){return!!this.e.get(this.f(l))}f(l){return l.vscodeWindowId}}function H(o,l,d){typeof l=="string"&&(l=o.matchMedia(l)),l.addEventListener("change",d)}function S(o,l){B.INSTANCE.setZoomLevel(o,l)}function k(o){return B.INSTANCE.getZoomLevel(o)}t.$kR=B.INSTANCE.onDidChangeZoomLevel;function f(o){return B.INSTANCE.getZoomFactor(o)}function g(o,l){B.INSTANCE.setZoomFactor(o,l)}function w(o,l){B.INSTANCE.setFullscreen(o,l)}function P(o){return B.INSTANCE.isFullscreen(o)}t.$pR=B.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$qR=u.indexOf("Firefox")>=0,t.$rR=u.indexOf("AppleWebKit")>=0,t.$sR=u.indexOf("Chrome")>=0,t.$tR=!t.$sR&&u.indexOf("Safari")>=0,t.$uR=!t.$sR&&!t.$tR&&t.$rR,t.$vR=u.indexOf("Electron/")>=0,t.$wR=u.indexOf("Android")>=0;let c=!1;if(typeof i.$eR.matchMedia=="function"){const o=i.$eR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.$eR.matchMedia("(display-mode: fullscreen)");c=o.matches,H(i.$eR,o,({matches:d})=>{c&&l.matches||(c=d)})}function e(){return c}function n(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=void 0;class F{get event(){return this.a.event}constructor(H,S,k){const f=g=>this.a.fire(g);this.a=new i.$ce({onWillAddFirstListener:()=>H.addEventListener(S,f,k),onDidRemoveLastListener:()=>H.removeEventListener(S,f,k)})}dispose(){this.a.dispose()}}t.$MT=F}),define(me[34],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ne=t.CancellationToken=void 0;const F=Object.freeze(function(k,f){const g=setTimeout(k.bind(f),0);return{dispose(){clearTimeout(g)}}});var B;(function(k){function f(g){return g===k.None||g===k.Cancelled||g instanceof H?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}k.isCancellationToken=f,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(B||(t.CancellationToken=B={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$ce),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=B.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=B.None}}t.$ne=S}),define(me[94],be([1,0,34]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2e=t.$1e=t.$Ye=void 0,t.$Ze=B;class F{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new i.$ne,g=this.b(f.token);return this.a={promise:g,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Ye=F;function B(k){return k}class H{constructor(f,g){this.a=void 0,this.b=void 0,typeof f=="function"?(this.c=f,this.d=B):(this.c=g,this.d=f.getCacheKey)}get(f){const g=this.d(f);return this.b!==g&&(this.b=g,this.a=this.c(f)),this.a}}t.$1e=H;class S{get cachedValues(){return this.a}constructor(f,g){this.a=new Map,this.b=new Map,typeof f=="function"?(this.c=f,this.d=B):(this.c=g,this.d=f.getCacheKey)}get(f){const g=this.d(f);if(this.b.has(g))return this.b.get(g);const w=this.c(f);return this.a.set(f,w),this.b.set(g,w),w}}t.$2e=S}),define(me[95],be([1,0,41,33,42,34,26,38]),function(se,t,i,F,B,H,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8d=t.$7d=t.$6d=t.$5d=void 0,t.$9d=u,t.$0d=c;class f{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,F.$Zd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}t.$5d=f;class g{constructor(n){this.a=(0,F.$Zd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(o=>((0,F.$Ud)(l=>{this.a.set(new w(o,void 0),l)}),o),o=>{throw(0,F.$Ud)(l=>{this.a.set(new w(void 0,o),l)}),o})}}t.$6d=g;class w{constructor(n,o){this.data=n,this.error=o}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$7d=w;class P{constructor(n){this.b=n,this.a=new f(()=>new g(this.b())),this.cachedPromiseResult=(0,B.$Jd)(this,o=>this.a.cachedValue.read(o)?.promiseResult.read(o))}getPromise(){return this.a.getValue().promise}}t.$8d=P;function u(e,n,o){return n||(n=l=>l!=null),new Promise((l,d)=>{let N=!0,b=!1;const m=e.map(y=>({isFinished:n(y),error:o?o(y):!1,state:y})),r=(0,i.$id)(y=>{const{isFinished:A,error:T,state:M}=m.read(y);(A||T)&&(N?b=!0:r.dispose(),T?d(T===!0?M:T):l(M))});N=!1,b&&r.dispose()})}function c(e,n){let o,l;n===void 0?(o=e,l=void 0):(l=e,o=n);let d;return new B.$Od(new S.$_c(l,void 0,o),N=>(d&&d.dispose(!0),d=new H.$ne,o(N,d.token)),void 0,void 0,()=>d?.dispose(),k.$7c)}}),define(me[96],be([1,0,3,2,41,33,26,42,27]),function(se,t,i,F,B,H,S,k,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ed=t.$Ad=t.$sd=void 0,t.$pd=g,t.$qd=P,t.$rd=u,t.$td=e,t.$ud=o,t.$vd=d,t.$wd=N,t.$xd=b,t.$yd=m,t.$zd=r,t.$Bd=A,t.$Cd=T,t.$Dd=M,t.$Fd=I;function g(V){return new w(V)}class w extends H.$Sd{constructor(R){super(),this.b=R}get debugName(){return this.toString()}get(){return this.b}addObserver(R){}removeObserver(R){}toString(){return`Const: ${this.b}`}}function P(V){const R=(0,H.$Zd)("promiseValue",{});return V.then(x=>{R.set({value:x},void 0)}),R}function u(V,R){return new c(V,R)}class c extends H.$Td{constructor(R,x){super(),this.j=R,this._getValue=x,this.g=!1,this.n=O=>{const X=this._getValue(O),K=this.e,ae=!this.g||K!==X;let ie=!1;ae&&(this.e=X,this.g&&(ie=!0,(0,H.$Xd)(c.globalTransaction,ee=>{(0,f.$Hd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:X,change:void 0,didChange:ae,hadValue:this.g});for(const ce of this.b)ee.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),ie||(0,f.$Hd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:X,change:void 0,didChange:ae,hadValue:this.g})}}k(){return(0,S.$bd)(this._getValue)}get debugName(){const R=this.k();return"From Event"+(R?`: ${R}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$sd=c,function(V){V.Observer=c;function R(x,O){let X=!1;c.globalTransaction===void 0&&(c.globalTransaction=x,X=!0);try{O()}finally{X&&(c.globalTransaction=void 0)}}V.batchEventsGlobally=R}(u||(t.$rd=u={}));function e(V,R){return new n(V,R)}class n extends H.$Td{constructor(R,x){super(),this.debugName=R,this.g=x,this.j=()=>{(0,H.$Ud)(O=>{for(const X of this.b)O.updateObserver(X,this),X.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(V){return typeof V=="string"?new l(V):new l(void 0,V)}class l extends H.$Td{get debugName(){return new S.$_c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(R,x){super(),this.e=R,this.g=x}trigger(R,x){if(!R){(0,H.$Ud)(O=>{this.trigger(O,x)},()=>`Trigger signal ${this.debugName}`);return}for(const O of this.b)R.updateObserver(O,this),O.handleChange(this,x)}get(){}}function d(V,R,x){const O=(0,H.$Zd)("debounced",void 0);let X;return x.add((0,B.$id)(K=>{const ae=V.read(K);X&&clearTimeout(X),X=setTimeout(()=>{(0,H.$Ud)(ie=>{O.set(ae,ie)})},R)})),O}function N(V,R){let x=!1,O,X;return u(K=>{const ae=(0,B.$id)(ie=>{const ee=V.read(ie);x?(X&&clearTimeout(X),X=setTimeout(()=>{O=ee,K()},R)):(x=!0,O=ee)});return{dispose(){ae.dispose(),x=!1,O=void 0}}},()=>x?O:V.get())}function b(V,R,x){const O=(0,H.$Zd)("triggeredRecently",!1);let X;return x.add(V(()=>{O.set(!0,void 0),X&&clearTimeout(X),X=setTimeout(()=>{O.set(!1,void 0)},R)})),O}function m(V){const R=new y(!1,void 0);return V.addObserver(R),(0,F.$Tc)(()=>{V.removeObserver(R)})}(0,H.$Qd)(m);function r(V,R){const x=new y(!0,R);return V.addObserver(x),R?R(V.get()):V.reportChanges(),(0,F.$Tc)(()=>{V.removeObserver(x)})}(0,H.$Pd)(r);class y{constructor(R,x){this.b=R,this.c=x,this.a=0}beginUpdate(R){this.a++}endUpdate(R){this.a--,this.a===0&&this.b&&(this.c?this.c(R.get()):R.reportChanges())}handlePossibleChange(R){}handleChange(R,x){}}t.$Ad=y;function A(V,R){let x;return(0,k.$Jd)(V,X=>(x=R(X,x),x))}function T(V,R){let x;const O=o("derivedObservableWithWritableCache"),X=(0,k.$Jd)(V,K=>(O.read(K),x=R(K,x),x));return Object.assign(X,{clearCache:K=>{x=void 0,O.trigger(K)},setCache:(K,ae)=>{x=K,O.trigger(ae)}})}function M(V,R,x,O){let X=new q(x,O);return(0,k.$Kd)({debugReferenceFn:x,owner:V,onLastObserverRemoved:()=>{X.dispose(),X=new q(x)}},ae=>(X.setItems(R.read(ae)),X.getItems()))}class q{constructor(R,x){this.c=R,this.e=x,this.a=new Map,this.b=[]}dispose(){this.a.forEach(R=>R.store.dispose()),this.a.clear()}setItems(R){const x=[],O=new Set(this.a.keys());for(const X of R){const K=this.e?this.e(X):X;let ae=this.a.get(K);if(ae)O.delete(K);else{const ie=new F.$Uc;ae={out:this.c(X,ie),store:ie},this.a.set(K,ae)}x.push(ae.out)}for(const X of O)this.a.get(X).store.dispose(),this.a.delete(X);this.b=x}getItems(){return this.b}}class ${constructor(R){this.observable=R}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Ed=$;function I(V,R){return R instanceof $?R.observable:u(R.onDidChange,()=>R.value)}}),define(me[57],be([1,0,33,42,41,96,95,27]),function(se,t,i,F,B,H,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$Zd}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$3d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Ud}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$Xd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return F.$Jd}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return F.$Kd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return F.$Ld}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return F.$Md}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$id}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$jd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return H.$pd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return H.$vd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return H.$Bd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return H.$Cd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return H.$yd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return H.$zd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return H.$rd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return H.$qd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return H.$ud}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return H.$td}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return H.$xd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return S.$5d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return S.$8d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return S.$6d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return S.$7d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return S.$9d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return S.$0d}}),!1&&(0,k.$Gd)(new k.$Id)}),define(me[58],be([1,0,3,2]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Us=t.$Ts=t.$Ss=t.$Rs=t.ScrollbarVisibility=void 0;var B;(function(c){c[c.Auto=1]="Auto",c[c.Hidden=2]="Hidden",c[c.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class H{constructor(e,n,o,l,d,N,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,l=l|0,d=d|0,N=N|0,b=b|0),this.rawScrollLeft=l,this.rawScrollTop=b,n<0&&(n=0),l+n>o&&(l=o-n),l<0&&(l=0),d<0&&(d=0),b+d>N&&(b=N-d),b<0&&(b=0),this.width=n,this.scrollWidth=o,this.scrollLeft=l,this.height=d,this.scrollHeight=N,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const o=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,d=this.scrollLeft!==e.scrollLeft,N=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,m=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:l,scrollLeftChanged:d,heightChanged:N,scrollHeightChanged:b,scrollTopChanged:m}}}t.$Rs=H;class S extends F.$Vc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$ce),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const o=this.g.withScrollDimensions(e,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let l;n?l=new w(this.h.from,o,this.h.startTime,this.h.duration):l=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=l}else{const o=this.g.withScrollPosition(e);this.h=w.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,n)))}}t.$Ss=S;class k{constructor(e,n,o){this.scrollLeft=e,this.scrollTop=n,this.isDone=o}}t.$Ts=k;function f(c,e){const n=e-c;return function(o){return c+n*u(o)}}function g(c,e,n){return function(o){return o<n?c(o/n):e((o-n)/(1-n))}}class w{constructor(e,n,o,l){this.from=e,this.to=n,this.duration=l,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,o){if(Math.abs(e-n)>2.5*o){let d,N;return e<n?(d=e+.75*o,N=n-.75*o):(d=e-.75*o,N=n+.75*o),g(f(e,d),f(N,n),.33)}return f(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const o=this.c(n),l=this.d(n);return new k(o,l,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,o){return w.start(e,n,o)}static start(e,n,o){o=o+10;const l=Date.now()-10;return new w(e,n,l,o)}}t.$Us=w;function P(c){return Math.pow(c,3)}function u(c){return 1-P(1-c)}}),define(me[97],be([1,0,6,2]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oe=B,t.$pe=H,t.$qe=S,t.$re=k,t.$se=g,t.$te=w,t.$ue=P,t.$ve=u,t.$we=c,t.$xe=e,t.$ye=n,t.$ze=o,t.$Ae=l,t.$Be=d,t.$Ce=N;function B(b){const m=b;return m?typeof m.read=="function":!1}function H(b){const m=b;return m?[m.on,m.pause,m.resume,m.destroy].every(r=>typeof r=="function"):!1}function S(b){const m=b;return m?H(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function k(b,m){return new f(b,m)}class f{constructor(m,r){this.e=m,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(r=>r(m))}h(m){this.c.error.length===0?(0,i.$1)(m):this.c.error.slice(0).forEach(r=>r(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,r){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(m,r){if(this.a.destroyed)return;let y;switch(m){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const A=y.indexOf(r);A>=0&&y.splice(A,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,m){const r=[];let y;for(;(y=b.read())!==null;)r.push(y);return m(r)}function w(b,m,r){const y=[];let A;for(;(A=b.read())!==null&&y.length<r;)y.push(A);return A===null&&y.length>0?m(y):{read:()=>{if(y.length>0)return y.shift();if(typeof A<"u"){const T=A;return A=void 0,T}return b.read()}}}function P(b,m){return new Promise((r,y)=>{const A=[];u(b,{onData:T=>{m&&A.push(T)},onError:T=>{m?y(T):r(void 0)},onEnd:()=>{r(m?m(A):void 0)}})})}function u(b,m,r){b.on("error",y=>{r?.isCancellationRequested||m.onError(y)}),b.on("end",()=>{r?.isCancellationRequested||m.onEnd()}),b.on("data",y=>{r?.isCancellationRequested||m.onData(y)})}function c(b,m){return new Promise((r,y)=>{const A=new F.$Uc,T=[],M=I=>{if(T.push(I),T.length>m)return A.dispose(),b.pause(),r({stream:b,buffer:T,ended:!1})},q=I=>(A.dispose(),y(I)),$=()=>(A.dispose(),r({stream:b,buffer:T,ended:!0}));A.add((0,F.$Tc)(()=>b.removeListener("error",q))),b.on("error",q),A.add((0,F.$Tc)(()=>b.removeListener("end",$))),b.on("end",$),A.add((0,F.$Tc)(()=>b.removeListener("data",M))),b.on("data",M)})}function e(b,m){const r=k(m);return r.end(b),r}function n(){const b=k(()=>{throw new Error("not supported")});return b.end(),b}function o(b){let m=!1;return{read:()=>m?null:(m=!0,b)}}function l(b,m,r){const y=k(r);return u(b,{onData:A=>y.write(m.data(A)),onError:A=>y.error(m.error?m.error(A):A),onEnd:()=>y.end()}),y}function d(b,m,r){let y=!1;return{read:()=>{const A=m.read();return y?A:(y=!0,A!==null?r([b,A]):b)}}}function N(b,m,r){let y=!1;const A=k(r);return u(m,{onData:T=>y?A.write(T):(y=!0,A.write(r([b,T]))),onError:T=>A.error(T),onEnd:()=>{y||(y=!0,A.write(b)),A.end()}}),A}}),define(me[43],be([1,0,23,97]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=void 0,t.$Ee=g,t.$Fe=w,t.$Ge=P,t.$He=u,t.$Ie=c,t.$Je=e,t.$Ke=n,t.$Le=o,t.$Me=l,t.$Ne=d,t.$Oe=N,t.$Pe=b,t.$Qe=m,t.$Re=r,t.$Se=y,t.$Te=A,t.$Ue=T,t.$Ve=M,t.$We=q,t.$Xe=V;const B=typeof Buffer<"u",H=new i.$V(()=>new Uint8Array(256));let S,k;class f{static alloc(x){return B?new f(Buffer.allocUnsafe(x)):new f(new Uint8Array(x))}static wrap(x){return B&&!Buffer.isBuffer(x)&&(x=Buffer.from(x.buffer,x.byteOffset,x.byteLength)),new f(x)}static fromString(x,O){return!(O?.dontUseNodeBuffer||!1)&&B?new f(Buffer.from(x)):(S||(S=new TextEncoder),new f(S.encode(x)))}static fromByteArray(x){const O=f.alloc(x.length);for(let X=0,K=x.length;X<K;X++)O.buffer[X]=x[X];return O}static concat(x,O){if(typeof O>"u"){O=0;for(let ae=0,ie=x.length;ae<ie;ae++)O+=x[ae].byteLength}const X=f.alloc(O);let K=0;for(let ae=0,ie=x.length;ae<ie;ae++){const ee=x[ae];X.set(ee,K),K+=ee.byteLength}return X}constructor(x){this.buffer=x,this.byteLength=this.buffer.byteLength}clone(){const x=f.alloc(this.byteLength);return x.set(this),x}toString(){return B?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(x,O){return new f(this.buffer.subarray(x,O))}set(x,O){if(x instanceof f)this.buffer.set(x.buffer,O);else if(x instanceof Uint8Array)this.buffer.set(x,O);else if(x instanceof ArrayBuffer)this.buffer.set(new Uint8Array(x),O);else if(ArrayBuffer.isView(x))this.buffer.set(new Uint8Array(x.buffer,x.byteOffset,x.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(x){return u(this.buffer,x)}writeUInt32BE(x,O){c(this.buffer,x,O)}readUInt32LE(x){return e(this.buffer,x)}writeUInt32LE(x,O){n(this.buffer,x,O)}readUInt8(x){return o(this.buffer,x)}writeUInt8(x,O){l(this.buffer,x,O)}indexOf(x,O=0){return g(this.buffer,x instanceof f?x.buffer:x,O)}}t.$De=f;function g(R,x,O=0){const X=x.byteLength,K=R.byteLength;if(X===0)return 0;if(X===1)return R.indexOf(x[0]);if(X>K-O)return-1;const ae=H.value;ae.fill(x.length);for(let ye=0;ye<x.length;ye++)ae[x[ye]]=x.length-ye-1;let ie=O+x.length-1,ee=ie,ce=-1;for(;ie<K;)if(R[ie]===x[ee]){if(ee===0){ce=ie;break}ie--,ee--}else ie+=Math.max(x.length-ee,ae[R[ie]]),ee=x.length-1;return ce}function w(R,x){return R[x+0]<<0>>>0|R[x+1]<<8>>>0}function P(R,x,O){R[O+0]=x&255,x=x>>>8,R[O+1]=x&255}function u(R,x){return R[x]*2**24+R[x+1]*2**16+R[x+2]*2**8+R[x+3]}function c(R,x,O){R[O+3]=x,x=x>>>8,R[O+2]=x,x=x>>>8,R[O+1]=x,x=x>>>8,R[O]=x}function e(R,x){return R[x+0]<<0>>>0|R[x+1]<<8>>>0|R[x+2]<<16>>>0|R[x+3]<<24>>>0}function n(R,x,O){R[O+0]=x&255,x=x>>>8,R[O+1]=x&255,x=x>>>8,R[O+2]=x&255,x=x>>>8,R[O+3]=x&255}function o(R,x){return R[x]}function l(R,x,O){R[O]=x}function d(R){return F.$se(R,x=>f.concat(x))}function N(R){return F.$ze(R)}function b(R){return F.$ue(R,x=>f.concat(x))}async function m(R){return R.ended?f.concat(R.buffer):f.concat([...R.buffer,await b(R.stream)])}function r(R){return F.$xe(R,x=>f.concat(x))}function y(R){return F.$Ae(R,{data:x=>typeof x=="string"?f.fromString(x):f.wrap(x)},x=>f.concat(x))}function A(R){return F.$re(x=>f.concat(x),R)}function T(R,x){return F.$Be(R,x,O=>f.concat(O))}function M(R,x){return F.$Ce(R,x,O=>f.concat(O))}function q(R){let x=0,O=0,X=0;const K=new Uint8Array(Math.floor(R.length/4*3)),ae=ee=>{switch(O){case 3:K[X++]=x|ee,O=0;break;case 2:K[X++]=x|ee>>>2,x=ee<<6,O=3;break;case 1:K[X++]=x|ee>>>4,x=ee<<4,O=2;break;default:x=ee<<2,O=1}};for(let ee=0;ee<R.length;ee++){const ce=R.charCodeAt(ee);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${R[ee]}`)}}const ie=X;for(;O>0;)ae(0);return f.wrap(K).slice(0,ie)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:R},x=!0,O=!1){const X=O?I:$;let K="";const ae=R.byteLength%3;let ie=0;for(;ie<R.byteLength-ae;ie+=3){const ee=R[ie+0],ce=R[ie+1],ye=R[ie+2];K+=X[ee>>>2],K+=X[(ee<<4|ce>>>4)&63],K+=X[(ce<<2|ye>>>6)&63],K+=X[ye&63]}if(ae===1){const ee=R[ie+0];K+=X[ee>>>2],K+=X[ee<<4&63],x&&(K+="==")}else if(ae===2){const ee=R[ie+0],ce=R[ie+1];K+=X[ee>>>2],K+=X[(ee<<4|ce>>>4)&63],K+=X[ce<<2&63],x&&(K+="=")}return K}}),define(me[9],be([1,0,94,23]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5f=t.$4f=t.$3f=t.GraphemeBreakType=t.$Sf=t.$Lf=t.$Ef=t.$Df=void 0,t.$5e=B,t.$6e=S,t.$7e=f,t.$8e=g,t.$9e=w,t.$0e=P,t.$$e=u,t.$_e=c,t.$af=e,t.$bf=n,t.$cf=o,t.$df=l,t.$ef=d,t.$ff=N,t.$gf=b,t.$hf=m,t.$if=r,t.$jf=y,t.$kf=A,t.$lf=T,t.$mf=M,t.$nf=q,t.$of=$,t.$pf=I,t.$qf=V,t.$rf=R,t.$sf=x,t.$tf=O,t.$uf=X,t.$vf=K,t.$wf=ae,t.$xf=ie,t.$yf=ee,t.$zf=ce,t.$Af=ye,t.$Bf=Ee,t.$Cf=Me,t.$Ff=re,t.$Gf=De,t.$Hf=W,t.$If=Q,t.$Jf=Ae,t.$Kf=Ie,t.$Mf=z,t.$Nf=h,t.$Of=D,t.$Pf=a,t.$Qf=C,t.$Rf=s,t.$Tf=E,t.$Uf=p,t.$Vf=L,t.$Wf=j,t.$Xf=Y,t.$Yf=J,t.$Zf=oe,t.$1f=pe,t.$2f=Ne;function B(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const H=/{(\d+)}/g;function S(Z,...ne){return ne.length===0?Z:Z.replace(H,function($e,ve){const Re=parseInt(ve,10);return isNaN(Re)||Re<0||Re>=ne.length?$e:ne[Re]})}const k=/{([^}]+)}/g;function f(Z,ne){return Object.keys(ne).length===0?Z:Z.replace(k,($e,ve)=>ne[ve]??$e)}function g(Z){return Z.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function w(Z){return Z.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function P(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function u(Z,ne){let $e=0;const ve=ne.charCodeAt(0);for(let Re=Z.length-1;Re>=0;Re--)Z.charCodeAt(Re)===ve&&$e++;return $e}function c(Z,ne,$e="\u2026"){return Z.length<=ne?Z:`${Z.substr(0,ne)}${$e}`}function e(Z,ne,$e="\u2026"){if(Z.length<=ne)return Z;const ve=Math.ceil(ne/2)-$e.length/2,Re=Math.floor(ne/2)-$e.length/2;return`${Z.substr(0,ve)}${$e}${Z.substr(Z.length-Re)}`}function n(Z,ne=" "){const $e=o(Z,ne);return l($e,ne)}function o(Z,ne){if(!Z||!ne)return Z;const $e=ne.length;if($e===0||Z.length===0)return Z;let ve=0;for(;Z.indexOf(ne,ve)===ve;)ve=ve+$e;return Z.substring(ve)}function l(Z,ne){if(!Z||!ne)return Z;const $e=ne.length,ve=Z.length;if($e===0||ve===0)return Z;let Re=ve,ze=-1;for(;ze=Z.lastIndexOf(ne,Re-1),!(ze===-1||ze+$e!==Re);){if(ze===0)return"";Re=ze}return Z.substring(0,Re)}function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function N(Z){return Z.replace(/\*/g,"")}function b(Z,ne,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");ne||(Z=P(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(Z,ve)}function m(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function r(Z){return Z.split(/\r\n|\r|\n/)}function y(Z){const ne=[],$e=Z.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ne.push($e[2*ve]+($e[2*ve+1]??""));return ne}function A(Z){for(let ne=0,$e=Z.length;ne<$e;ne++){const ve=Z.charCodeAt(ne);if(ve!==32&&ve!==9)return ne}return-1}function T(Z,ne=0,$e=Z.length){for(let ve=ne;ve<$e;ve++){const Re=Z.charCodeAt(ve);if(Re!==32&&Re!==9)return Z.substring(ne,ve)}return Z.substring(ne,$e)}function M(Z,ne=Z.length-1){for(let $e=ne;$e>=0;$e--){const ve=Z.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}function q(Z,ne,$e){const ve=[];let Re=0;for(const ze of Z.matchAll(ne)){if(ve.push(Z.slice(Re,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Re=ze.index+ze[0].length,ve.push($e(ze[0],...ze.slice(1),ze.index,Z,ze.groups))}return ve.push(Z.slice(Re)),Promise.all(ve).then(ze=>ze.join(""))}function $(Z,ne){return Z<ne?-1:Z>ne?1:0}function I(Z,ne,$e=0,ve=Z.length,Re=0,ze=ne.length){for(;$e<ve&&Re<ze;$e++,Re++){const it=Z.charCodeAt($e),st=ne.charCodeAt(Re);if(it<st)return-1;if(it>st)return 1}const Ve=ve-$e,et=ze-Re;return Ve<et?-1:Ve>et?1:0}function V(Z,ne){return R(Z,ne,0,Z.length,0,ne.length)}function R(Z,ne,$e=0,ve=Z.length,Re=0,ze=ne.length){for(;$e<ve&&Re<ze;$e++,Re++){let it=Z.charCodeAt($e),st=ne.charCodeAt(Re);if(it===st)continue;if(it>=128||st>=128)return I(Z.toLowerCase(),ne.toLowerCase(),$e,ve,Re,ze);O(it)&&(it-=32),O(st)&&(st-=32);const Qe=it-st;if(Qe!==0)return Qe}const Ve=ve-$e,et=ze-Re;return Ve<et?-1:Ve>et?1:0}function x(Z){return Z>=48&&Z<=57}function O(Z){return Z>=97&&Z<=122}function X(Z){return Z>=65&&Z<=90}function K(Z,ne){return Z.length===ne.length&&R(Z,ne)===0}function ae(Z,ne){const $e=ne.length;return ne.length>Z.length?!1:R(Z,ne,0,$e)===0}function ie(Z,ne){const $e=Math.min(Z.length,ne.length);let ve;for(ve=0;ve<$e;ve++)if(Z.charCodeAt(ve)!==ne.charCodeAt(ve))return ve;return $e}function ee(Z,ne){const $e=Math.min(Z.length,ne.length);let ve;const Re=Z.length-1,ze=ne.length-1;for(ve=0;ve<$e;ve++)if(Z.charCodeAt(Re-ve)!==ne.charCodeAt(ze-ve))return ve;return $e}function ce(Z){return 55296<=Z&&Z<=56319}function ye(Z){return 56320<=Z&&Z<=57343}function Ee(Z,ne){return(Z-55296<<10)+(ne-56320)+65536}function Me(Z,ne,$e){const ve=Z.charCodeAt($e);if(ce(ve)&&$e+1<ne){const Re=Z.charCodeAt($e+1);if(ye(Re))return Ee(ve,Re)}return ve}function le(Z,ne){const $e=Z.charCodeAt(ne-1);if(ye($e)&&ne>1){const ve=Z.charCodeAt(ne-2);if(ce(ve))return Ee(ve,$e)}return $e}class _{get offset(){return this.e}constructor(ne,$e=0){this.c=ne,this.d=ne.length,this.e=$e}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Me(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$Df=_;class ue{get offset(){return this.c.offset}constructor(ne,$e=0){this.c=new _(ne,$e)}nextGraphemeLength(){const ne=ke.getInstance(),$e=this.c,ve=$e.offset;let Re=ne.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.nextCodePoint());if(fe(Re,Ve)){$e.setOffset(ze);break}Re=Ve}return $e.offset-ve}prevGraphemeLength(){const ne=ke.getInstance(),$e=this.c,ve=$e.offset;let Re=ne.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.prevCodePoint());if(fe(Ve,Re)){$e.setOffset(ze);break}Re=Ve}return ve-$e.offset}eol(){return this.c.eol()}}t.$Ef=ue;function re(Z,ne){return new ue(Z,ne).nextGraphemeLength()}function De(Z,ne){return new ue(Z,ne).prevGraphemeLength()}function W(Z,ne){ne>0&&ye(Z.charCodeAt(ne))&&ne--;const $e=ne+re(Z,ne);return[$e-De(Z,$e),$e]}function Q(Z){const ne=new ue(Z);let $e=0;for(;!ne.eol();)$e++,ne.nextGraphemeLength();return $e}let ge;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ae(Z){return ge||(ge=we()),ge.test(Z)}const Te=/^[\t\n\r\x20-\x7E]*$/;function Ie(Z){return Te.test(Z)}t.$Lf=/[\u2028\u2029]/;function z(Z){return t.$Lf.test(Z)}function h(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function D(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function a(Z,ne,$e=""){const ve=Z.trimStart();if(ve.length<ne)return ve;const Re=/\b/g;let ze=0;for(;Re.test(ve)&&!(ve.length-Re.lastIndex<ne);)ze=Re.lastIndex,Re.lastIndex+=1;return ze===0?ve:$e+ve.substring(ze).trimStart()}const v=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*C(Z){let ne=0;for(const $e of Z.matchAll(v))ne!==$e.index&&(yield{isCode:!1,str:Z.substring(ne,$e.index)}),yield{isCode:!0,str:$e[0]},ne=$e.index+$e[0].length;ne!==Z.length&&(yield{isCode:!1,str:Z.substring(ne)})}function s(Z){return Z&&(Z=Z.replace(v,"")),Z}t.$Sf="\uFEFF";function E(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}function p(Z){return E(Z)?Z.substr(1):Z}function L(Z,ne){if(!Z||!ne||Z.length<ne.length)return!1;const $e=ne.length,ve=Z.toLowerCase();let Re=0,ze=-1;for(;Re<$e;){const Ve=ve.indexOf(ne[Re],ze+1);if(Ve<0)return!1;ze=Ve,Re++}return!0}function j(Z,ne=!1){return Z?(ne&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function Y(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function J(Z,ne=1){if(ne===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),ne--;while(ne>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}function oe(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}function pe(Z){return ke.getInstance().getGraphemeBreakType(Z)}function fe(Z,ne){return Z===0?ne!==5&&ne!==7:Z===2&&ne===3?!1:Z===4||Z===2||Z===3||ne===4||ne===2||ne===3?!0:!(Z===8&&(ne===8||ne===9||ne===11||ne===12)||(Z===11||Z===9)&&(ne===9||ne===10)||(Z===12||Z===10)&&ne===10||ne===5||ne===13||ne===7||Z===1||Z===13&&ne===14||Z===6&&ne===6)}var Le;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(t.GraphemeBreakType=Le={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Oe()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const $e=this.d,ve=$e.length/3;let Re=1;for(;Re<=ve;)if(ne<$e[3*Re])Re=2*Re;else if(ne>$e[3*Re+1])Re=2*Re+1;else return $e[3*Re+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(Z,ne){if(Z===0)return 0;const $e=Fe(Z,ne);if($e!==void 0)return $e;const ve=new _(ne,Z);return ve.prevCodePoint(),ve.offset}function Fe(Z,ne){const $e=new _(ne,Z);let ve=$e.prevCodePoint();for(;We(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!D(ve))return;let Re=$e.offset;return Re>0&&$e.prevCodePoint()===8205&&(Re=$e.offset),Re}function We(Z){return 127995<=Z&&Z<=127999}var Ue;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.$3f="\xA0";class Ye{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$1e({getCacheKey:JSON.stringify},ne=>{function $e(Qe){const rt=new Map;for(let tt=0;tt<Qe.length;tt+=2)rt.set(Qe[tt],Qe[tt+1]);return rt}function ve(Qe,rt){const tt=new Map(Qe);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Re(Qe,rt){if(!Qe)return rt;const tt=new Map;for(const[mt,gt]of Qe)rt.has(mt)&&tt.set(mt,gt);return tt}const ze=this.c.value;let Ve=ne.filter(Qe=>!Qe.startsWith("_")&&Qe in ze);Ve.length===0&&(Ve=["_default"]);let et;for(const Qe of Ve){const rt=$e(ze[Qe]);et=Re(et,rt)}const it=$e(ze._common),st=ve(it,et);return new Ye(st)})}static getInstance(ne){return Ye.d.get(Array.from(ne))}static{this.e=new F.$V(()=>Object.keys(Ye.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$4f=Ye;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$5f=_e}),define(me[44],be([1,0,39,89,9]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gk=t.FuzzyScore=t.$vk=t.$uk=void 0,t.or=H,t.$wk=k,t.$xk=f,t.$yk=P,t.$zk=q,t.$Ak=$,t.$Bk=X,t.$Ck=K,t.$Dk=ae,t.$Ek=ie,t.$Fk=Ae,t.$Hk=h,t.$Ik=v,t.$Jk=C;function H(...p){return function(L,j){for(let Y=0,J=p.length;Y<J;Y++){const oe=p[Y](L,j);if(oe)return oe}return null}}t.$uk=S.bind(void 0,!1),t.$vk=S.bind(void 0,!0);function S(p,L,j){if(!j||j.length<L.length)return null;let Y;return p?Y=B.$wf(j,L):Y=j.indexOf(L)===0,Y?L.length>0?[{start:0,end:L.length}]:[]:null}function k(p,L){const j=L.toLowerCase().indexOf(p.toLowerCase());return j===-1?null:[{start:j,end:j+p.length}]}function f(p,L){return g(p.toLowerCase(),L.toLowerCase(),0,0)}function g(p,L,j,Y){if(j===p.length)return[];if(Y===L.length)return null;if(p[j]===L[Y]){let J=null;return(J=g(p,L,j+1,Y+1))?b({start:Y,end:Y+1},J):null}return g(p,L,j,Y+1)}function w(p){return 97<=p&&p<=122}function P(p){return 65<=p&&p<=90}function u(p){return 48<=p&&p<=57}function c(p){return p===32||p===9||p===10||p===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(p=>e.add(p.charCodeAt(0)));function n(p){return c(p)||e.has(p)}function o(p,L){return p===L||n(p)&&n(L)}const l=new Map;function d(p){if(l.has(p))return l.get(p);let L;const j=(0,F.$sk)(p);return j&&(L=j),l.set(p,L),L}function N(p){return w(p)||P(p)||u(p)}function b(p,L){return L.length===0?L=[p]:p.end===L[0].start?L[0].start=p.start:L.unshift(p),L}function m(p,L){for(let j=L;j<p.length;j++){const Y=p.charCodeAt(j);if(P(Y)||u(Y)||j>0&&!N(p.charCodeAt(j-1)))return j}return p.length}function r(p,L,j,Y){if(j===p.length)return[];if(Y===L.length)return null;if(p[j]!==L[Y].toLowerCase())return null;{let J=null,oe=Y+1;for(J=r(p,L,j+1,Y+1);!J&&(oe=m(L,oe))<L.length;)J=r(p,L,j+1,oe),oe++;return J===null?null:b({start:Y,end:Y+1},J)}}function y(p){let L=0,j=0,Y=0,J=0,oe=0;for(let Oe=0;Oe<p.length;Oe++)oe=p.charCodeAt(Oe),P(oe)&&L++,w(oe)&&j++,N(oe)&&Y++,u(oe)&&J++;const pe=L/p.length,fe=j/p.length,Le=Y/p.length,ke=J/p.length;return{upperPercent:pe,lowerPercent:fe,alphaPercent:Le,numericPercent:ke}}function A(p){const{upperPercent:L,lowerPercent:j}=p;return j===0&&L>.6}function T(p){const{upperPercent:L,lowerPercent:j,alphaPercent:Y,numericPercent:J}=p;return j>.2&&L<.8&&Y>.6&&J<.2}function M(p){let L=0,j=0,Y=0,J=0;for(let oe=0;oe<p.length;oe++)Y=p.charCodeAt(oe),P(Y)&&L++,w(Y)&&j++,c(Y)&&J++;return(L===0||j===0)&&J===0?p.length<=30:L<=5}function q(p,L){if(!L||(L=L.trim(),L.length===0)||!M(p))return null;L.length>60&&(L=L.substring(0,60));const j=y(L);if(!T(j)){if(!A(j))return null;L=L.toLowerCase()}let Y=null,J=0;for(p=p.toLowerCase();J<L.length&&(Y=r(p,L,0,J))===null;)J=m(L,J+1);return Y}function $(p,L,j=!1){if(!L||L.length===0)return null;let Y=null,J=0;for(p=p.toLowerCase(),L=L.toLowerCase();J<L.length&&(Y=I(p,L,0,J,j),Y===null);)J=V(L,J+1);return Y}function I(p,L,j,Y,J){let oe=0;if(j===p.length)return[];if(Y===L.length)return null;if(!o(p.charCodeAt(j),L.charCodeAt(Y))){const Le=d(p.charCodeAt(j));if(!Le)return null;for(let ke=0;ke<Le.length;ke++)if(!o(Le[ke],L.charCodeAt(Y+ke)))return null;oe+=Le.length-1}let pe=null,fe=Y+oe+1;if(pe=I(p,L,j+1,fe,J),!J)for(;!pe&&(fe=V(L,fe))<L.length;)pe=I(p,L,j+1,fe,J),fe++;if(!pe)return null;if(p.charCodeAt(j)!==L.charCodeAt(Y)){const Le=d(p.charCodeAt(j));if(!Le)return pe;for(let ke=0;ke<Le.length;ke++)if(Le[ke]!==L.charCodeAt(Y+ke))return pe}return b({start:Y,end:Y+oe+1},pe)}function V(p,L){for(let j=L;j<p.length;j++)if(n(p.charCodeAt(j))||j>0&&n(p.charCodeAt(j-1)))return j;return p.length}const R=H(t.$vk,q,k),x=H(t.$vk,q,f),O=new i.$Ec(1e4);function X(p,L,j=!1){if(typeof p!="string"||typeof L!="string")return null;let Y=O.get(p);Y||(Y=new RegExp(B.$ef(p),"i"),O.set(p,Y));const J=Y.exec(L);return J?[{start:J.index,end:J.index+J[0].length}]:j?x(p,L):R(p,L)}function K(p,L){const j=h(p,p.toLowerCase(),0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ie(j):null}function ae(p,L,j,Y,J,oe){const pe=Math.min(13,p.length);for(;j<pe;j++){const fe=h(p,L,j,Y,J,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,oe]}function ie(p){if(typeof p>"u")return[];const L=[],j=p[1];for(let Y=p.length-1;Y>1;Y--){const J=p[Y]+j,oe=L[L.length-1];oe&&oe.end===J?oe.end=J+1:L.push({start:J,end:J+1})}return L}const ee=128;function ce(){const p=[],L=[];for(let j=0;j<=ee;j++)L[j]=0;for(let j=0;j<=ee;j++)p.push(L.slice(0));return p}function ye(p){const L=[];for(let j=0;j<=p;j++)L[j]=0;return L}const Ee=ye(2*ee),Me=ye(2*ee),le=ce(),_=ce(),ue=ce(),re=!1;function De(p,L,j,Y,J){function oe(fe,Le,ke=" "){for(;fe.length<Le;)fe=ke+fe;return fe}let pe=` |   |${Y.split("").map(fe=>oe(fe,3)).join("|")}
`;for(let fe=0;fe<=j;fe++)fe===0?pe+=" |":pe+=`${L[fe-1]}|`,pe+=p[fe].slice(0,J+1).map(Le=>oe(Le.toString(),3)).join("|")+`
`;return pe}function W(p,L,j,Y){p=p.substr(L),j=j.substr(Y),console.log(De(_,p,p.length,j,j.length)),console.log(De(ue,p,p.length,j,j.length)),console.log(De(le,p,p.length,j,j.length))}function Q(p,L){if(L<0||L>=p.length)return!1;const j=p.codePointAt(L);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!B.$Of(j)}}function ge(p,L){if(L<0||L>=p.length)return!1;switch(p.charCodeAt(L)){case 32:case 9:return!0;default:return!1}}function we(p,L,j){return L[p]!==j[p]}function Ae(p,L,j,Y,J,oe,pe=!1){for(;L<j&&J<oe;)p[L]===Y[J]&&(pe&&(Ee[L]=J),L+=1),J+=1;return L===j}var Te;(function(p){p[p.Diag=1]="Diag",p[p.Left=2]="Left",p[p.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Ie;(function(p){p.Default=[-100,0];function L(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}p.isDefault=L})(Ie||(t.FuzzyScore=Ie={}));class z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(L,j){this.firstMatchCanBeWeak=L,this.boostFullMatch=j}}t.$Gk=z;function h(p,L,j,Y,J,oe,pe=z.default){const fe=p.length>ee?ee:p.length,Le=Y.length>ee?ee:Y.length;if(j>=fe||oe>=Le||fe-j>Le-oe||!Ae(L,j,fe,J,oe,Le,!0))return;D(fe,Le,j,oe,L,J);let ke=1,Oe=1,Ne=j,Fe=oe;const We=[!1];for(ke=1,Ne=j;Ne<fe;ke++,Ne++){const ne=Ee[Ne],$e=Me[Ne],ve=Ne+1<fe?Me[Ne+1]:Le;for(Oe=ne-oe+1,Fe=ne;Fe<ve;Oe++,Fe++){let Re=Number.MIN_SAFE_INTEGER,ze=!1;Fe<=$e&&(Re=a(p,L,Ne,j,Y,J,Fe,Le,oe,le[ke-1][Oe-1]===0,We));let Ve=0;Re!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Re+_[ke-1][Oe-1]);const et=Fe>ne,it=et?_[ke][Oe-1]+(le[ke][Oe-1]>0?-5:0):0,st=Fe>ne+1&&le[ke][Oe-1]>0,Qe=st?_[ke][Oe-2]+(le[ke][Oe-2]>0?-5:0):0;if(st&&(!et||Qe>=it)&&(!ze||Qe>=Ve))_[ke][Oe]=Qe,ue[ke][Oe]=3,le[ke][Oe]=0;else if(et&&(!ze||it>=Ve))_[ke][Oe]=it,ue[ke][Oe]=2,le[ke][Oe]=0;else if(ze)_[ke][Oe]=Ve,ue[ke][Oe]=1,le[ke][Oe]=le[ke-1][Oe-1]+1;else throw new Error("not possible")}}if(re&&W(p,j,Y,oe),!We[0]&&!pe.firstMatchCanBeWeak)return;ke--,Oe--;const Ue=[_[ke][Oe],oe];let Ye=0,_e=0;for(;ke>=1;){let ne=Oe;do{const $e=ue[ke][ne];if($e===3)ne=ne-2;else if($e===2)ne=ne-1;else break}while(ne>=1);Ye>1&&L[j+ke-1]===J[oe+Oe-1]&&!we(ne+oe-1,Y,J)&&Ye+1>le[ke][ne]&&(ne=Oe),ne===Oe?Ye++:Ye=1,_e||(_e=ne),ke--,Oe=ne-1,Ue.push(Oe)}Le===fe&&pe.boostFullMatch&&(Ue[0]+=2);const Z=_e-fe;return Ue[0]-=Z,Ue}function D(p,L,j,Y,J,oe){let pe=p-1,fe=L-1;for(;pe>=j&&fe>=Y;)J[pe]===oe[fe]&&(Me[pe]=fe,pe--),fe--}function a(p,L,j,Y,J,oe,pe,fe,Le,ke,Oe){if(L[j]!==oe[pe])return Number.MIN_SAFE_INTEGER;let Ne=1,Fe=!1;return pe===j-Y?Ne=p[j]===J[pe]?7:5:we(pe,J,oe)&&(pe===0||!we(pe-1,J,oe))?(Ne=p[j]===J[pe]?7:5,Fe=!0):Q(oe,pe)&&(pe===0||!Q(oe,pe-1))?Ne=5:(Q(oe,pe-1)||ge(oe,pe-1))&&(Ne=5,Fe=!0),Ne>1&&j===Y&&(Oe[0]=!0),Fe||(Fe=we(pe,J,oe)||Q(oe,pe-1)||ge(oe,pe-1)),j===Y?pe>Le&&(Ne-=Fe?3:5):ke?Ne+=Fe?2:0:Ne+=Fe?0:1,pe+1===fe&&(Ne-=Fe?3:5),Ne}function v(p,L,j,Y,J,oe,pe){return s(p,L,j,Y,J,oe,!0,pe)}function C(p,L,j,Y,J,oe,pe){return s(p,L,j,Y,J,oe,!1,pe)}function s(p,L,j,Y,J,oe,pe,fe){let Le=h(p,L,j,Y,J,oe,fe);if(Le&&!pe)return Le;if(p.length>=3){const ke=Math.min(7,p.length-1);for(let Oe=j+1;Oe<ke;Oe++){const Ne=E(p,Oe);if(Ne){const Fe=h(Ne,Ne.toLowerCase(),j,Y,J,oe,fe);Fe&&(Fe[0]-=3,(!Le||Fe[0]>Le[0])&&(Le=Fe))}}}return Le}function E(p,L){if(L+1>=p.length)return;const j=p[L],Y=p[L+1];if(j!==Y)return p.slice(0,L)+Y+j+p.slice(L+2)}}),define(me[59],be([1,0,9]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nj=t.$lj=void 0,t.$hj=F,t.$ij=B,t.$jj=H,t.$kj=k,t.$mj=n;function F(l){return B(l,0)}function B(l,d){switch(typeof l){case"object":return l===null?H(349,d):Array.isArray(l)?f(l,d):g(l,d);case"string":return k(l,d);case"boolean":return S(l,d);case"number":return H(l,d);case"undefined":return H(937,d);default:return H(617,d)}}function H(l,d){return(d<<5)-d+l|0}function S(l,d){return H(l?433:863,d)}function k(l,d){d=H(149417,d);for(let N=0,b=l.length;N<b;N++)d=H(l.charCodeAt(N),d);return d}function f(l,d){return d=H(104579,d),l.reduce((N,b)=>B(b,N),d)}function g(l,d){return d=H(181387,d),Object.keys(l).sort().reduce((N,b)=>(N=k(b,N),B(l[b],N)),d)}class w{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=B(d,this.g),this.g}}t.$lj=w;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function u(l,d,N=32){const b=N-d,m=~((1<<b)-1);return(l<<d|(m&l)>>>b)>>>0}function c(l,d=0,N=l.byteLength,b=0){for(let m=0;m<N;m++)l[d+m]=b}function e(l,d,N="0"){for(;l.length<d;)l=N+l;return l}function n(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(N=>N.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),d/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const N=d.length;if(N===0)return;const b=this.p;let m=this.r,r=this.u,y,A;for(r!==0?(y=r,A=-1,r=0):(y=d.charCodeAt(0),A=0);;){let T=y;if(i.$zf(y))if(A+1<N){const M=d.charCodeAt(A+1);i.$Af(M)?(A++,T=i.$Bf(y,M)):T=65533}else{r=y;break}else i.$Af(y)&&(T=65533);if(m=this.w(b,m,T),A++,A<N)y=d.charCodeAt(A);else break}this.r=m,this.u=r}w(d,N,b){return b<128?d[N++]=b:b<2048?(d[N++]=192|(b&1984)>>>6,d[N++]=128|(b&63)>>>0):b<65536?(d[N++]=224|(b&61440)>>>12,d[N++]=128|(b&4032)>>>6,d[N++]=128|(b&63)>>>0):(d[N++]=240|(b&1835008)>>>18,d[N++]=128|(b&258048)>>>12,d[N++]=128|(b&4032)>>>6,d[N++]=128|(b&63)>>>0),N>=64&&(this.y(),N-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),N}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=o.g,N=this.q;for(let $=0;$<64;$+=4)d.setUint32($,N.getUint32($,!1),!1);for(let $=64;$<320;$+=4)d.setUint32($,u(d.getUint32($-12,!1)^d.getUint32($-32,!1)^d.getUint32($-56,!1)^d.getUint32($-64,!1),1),!1);let b=this.h,m=this.l,r=this.m,y=this.n,A=this.o,T,M,q;for(let $=0;$<80;$++)$<20?(T=m&r|~m&y,M=1518500249):$<40?(T=m^r^y,M=1859775393):$<60?(T=m&r|m&y|r&y,M=2400959708):(T=m^r^y,M=3395469782),q=u(b,5)+T+A+M+d.getUint32($*4,!1)&4294967295,A=y,y=r,r=u(m,30),m=b,b=q;this.h=this.h+b&4294967295,this.l=this.l+m&4294967295,this.m=this.m+r&4294967295,this.n=this.n+y&4294967295,this.o=this.o+A&4294967295}}t.$nj=o}),define(me[98],be([1,0,85,59]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=t.$tt=void 0,t.$ut=H;class B{constructor(u){this.a=u}getElements(){const u=this.a,c=new Int32Array(u.length);for(let e=0,n=u.length;e<n;e++)c[e]=u.charCodeAt(e);return c}}t.$tt=B;function H(P,u,c){return new w(new B(P),new B(u)).ComputeDiff(c).changes}class S{static Assert(u,c){if(!u)throw new Error(c)}}class k{static Copy(u,c,e,n,o){for(let l=0;l<o;l++)e[n+l]=u[c+l]}static Copy2(u,c,e,n,o){for(let l=0;l<o;l++)e[n+l]=u[c+l]}}var f;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$st(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(u,c){this.b=Math.min(this.b,u),this.c=Math.min(this.c,c),this.d++}AddModifiedElement(u,c){this.b=Math.min(this.b,u),this.c=Math.min(this.c,c),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(u,c,e=null){this.a=e,this.b=u,this.c=c;const[n,o,l]=w.o(u),[d,N,b]=w.o(c);this.d=l&&b,this.e=n,this.f=o,this.g=d,this.h=N,this.k=[],this.m=[]}static n(u){return u.length>0&&typeof u[0]=="string"}static o(u){const c=u.getElements();if(w.n(c)){const e=new Int32Array(c.length);for(let n=0,o=c.length;n<o;n++)e[n]=(0,F.$kj)(c[n],0);return[c,e,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}p(u,c){return this.f[u]!==this.h[c]?!1:this.d?this.e[u]===this.g[c]:!0}q(u,c){if(!this.p(u,c))return!1;const e=w.r(this.b,u),n=w.r(this.c,c);return e===n}static r(u,c){return typeof u.getStrictElement=="function"?u.getStrictElement(c):null}s(u,c){return this.f[u]!==this.f[c]?!1:this.d?this.e[u]===this.e[c]:!0}u(u,c){return this.h[u]!==this.h[c]?!1:this.d?this.g[u]===this.g[c]:!0}ComputeDiff(u){return this.v(0,this.f.length-1,0,this.h.length-1,u)}v(u,c,e,n,o){const l=[!1];let d=this.w(u,c,e,n,l);return o&&(d=this.z(d)),{quitEarly:l[0],changes:d}}w(u,c,e,n,o){for(o[0]=!1;u<=c&&e<=n&&this.p(u,e);)u++,e++;for(;c>=u&&n>=e&&this.p(c,n);)c--,n--;if(u>c||e>n){let r;return e<=n?(S.Assert(u===c+1,"originalStart should only be one more than originalEnd"),r=[new i.$st(u,0,e,n-e+1)]):u<=c?(S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$st(u,c-u+1,e,0)]):(S.Assert(u===c+1,"originalStart should only be one more than originalEnd"),S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const l=[0],d=[0],N=this.y(u,c,e,n,l,d,o),b=l[0],m=d[0];if(N!==null)return N;if(!o[0]){const r=this.w(u,b,e,m,o);let y=[];return o[0]?y=[new i.$st(b+1,c-(b+1)+1,m+1,n-(m+1)+1)]:y=this.w(b+1,c,m+1,n,o),this.H(r,y)}return[new i.$st(u,c-u+1,e,n-e+1)]}x(u,c,e,n,o,l,d,N,b,m,r,y,A,T,M,q,$,I){let V=null,R=null,x=new g,O=c,X=e,K=A[0]-q[0]-n,ae=-1073741824,ie=this.k.length-1;do{const ee=K+u;ee===O||ee<X&&b[ee-1]<b[ee+1]?(r=b[ee+1],T=r-K-n,r<ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,T),K=ee+1-u):(r=b[ee-1]+1,T=r-K-n,r<ae&&x.MarkNextChange(),ae=r-1,x.AddOriginalElement(r,T+1),K=ee-1-u),ie>=0&&(b=this.k[ie],u=b[0],O=1,X=b.length-1)}while(--ie>=-1);if(V=x.getReverseChanges(),I[0]){let ee=A[0]+1,ce=q[0]+1;if(V!==null&&V.length>0){const ye=V[V.length-1];ee=Math.max(ee,ye.getOriginalEnd()),ce=Math.max(ce,ye.getModifiedEnd())}R=[new i.$st(ee,y-ee+1,ce,M-ce+1)]}else{x=new g,O=l,X=d,K=A[0]-q[0]-N,ae=1073741824,ie=$?this.m.length-1:this.m.length-2;do{const ee=K+o;ee===O||ee<X&&m[ee-1]>=m[ee+1]?(r=m[ee+1]-1,T=r-K-N,r>ae&&x.MarkNextChange(),ae=r+1,x.AddOriginalElement(r+1,T+1),K=ee+1-o):(r=m[ee-1],T=r-K-N,r>ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,T+1),K=ee-1-o),ie>=0&&(m=this.m[ie],o=m[0],O=1,X=m.length-1)}while(--ie>=-1);R=x.getChanges()}return this.H(V,R)}y(u,c,e,n,o,l,d){let N=0,b=0,m=0,r=0,y=0,A=0;u--,e--,o[0]=0,l[0]=0,this.k=[],this.m=[];const T=c-u+(n-e),M=T+1,q=new Int32Array(M),$=new Int32Array(M),I=n-e,V=c-u,R=u-e,x=c-n,X=(V-I)%2===0;q[I]=u,$[V]=c,d[0]=!1;for(let K=1;K<=T/2+1;K++){let ae=0,ie=0;m=this.J(I-K,K,I,M),r=this.J(I+K,K,I,M);for(let ce=m;ce<=r;ce+=2){ce===m||ce<r&&q[ce-1]<q[ce+1]?N=q[ce+1]:N=q[ce-1]+1,b=N-(ce-I)-R;const ye=N;for(;N<c&&b<n&&this.p(N+1,b+1);)N++,b++;if(q[ce]=N,N+b>ae+ie&&(ae=N,ie=b),!X&&Math.abs(ce-V)<=K-1&&N>=$[ce])return o[0]=N,l[0]=b,ye<=$[ce]&&1447>0&&K<=1448?this.x(I,m,r,R,V,y,A,x,q,$,N,c,o,b,n,l,X,d):null}const ee=(ae-u+(ie-e)-K)/2;if(this.a!==null&&!this.a(ae,ee))return d[0]=!0,o[0]=ae,l[0]=ie,ee>0&&1447>0&&K<=1448?this.x(I,m,r,R,V,y,A,x,q,$,N,c,o,b,n,l,X,d):(u++,e++,[new i.$st(u,c-u+1,e,n-e+1)]);y=this.J(V-K,K,V,M),A=this.J(V+K,K,V,M);for(let ce=y;ce<=A;ce+=2){ce===y||ce<A&&$[ce-1]>=$[ce+1]?N=$[ce+1]-1:N=$[ce-1],b=N-(ce-V)-x;const ye=N;for(;N>u&&b>e&&this.p(N,b);)N--,b--;if($[ce]=N,X&&Math.abs(ce-I)<=K&&N<=q[ce])return o[0]=N,l[0]=b,ye>=q[ce]&&1447>0&&K<=1448?this.x(I,m,r,R,V,y,A,x,q,$,N,c,o,b,n,l,X,d):null}if(K<=1447){let ce=new Int32Array(r-m+2);ce[0]=I-m+1,k.Copy2(q,m,ce,1,r-m+1),this.k.push(ce),ce=new Int32Array(A-y+2),ce[0]=V-y+1,k.Copy2($,y,ce,1,A-y+1),this.m.push(ce)}}return this.x(I,m,r,R,V,y,A,x,q,$,N,c,o,b,n,l,X,d)}z(u){for(let c=0;c<u.length;c++){const e=u[c],n=c<u.length-1?u[c+1].originalStart:this.f.length,o=c<u.length-1?u[c+1].modifiedStart:this.h.length,l=e.originalLength>0,d=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<o&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!d||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const N=[null];if(c<u.length-1&&this.I(u[c],u[c+1],N)){u[c]=N[0],u.splice(c+1,1),c--;continue}}for(let c=u.length-1;c>=0;c--){const e=u[c];let n=0,o=0;if(c>0){const r=u[c-1];n=r.originalStart+r.originalLength,o=r.modifiedStart+r.modifiedLength}const l=e.originalLength>0,d=e.modifiedLength>0;let N=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const y=e.originalStart-r,A=e.modifiedStart-r;if(y<n||A<o||l&&!this.s(y,y+e.originalLength)||d&&!this.u(A,A+e.modifiedLength))break;const M=(y===n&&A===o?5:0)+this.G(y,e.originalLength,A,e.modifiedLength);M>b&&(b=M,N=r)}e.originalStart-=N,e.modifiedStart-=N;const m=[null];if(c>0&&this.I(u[c-1],u[c],m)){u[c-1]=m[0],u.splice(c,1),c++;continue}}if(this.d)for(let c=1,e=u.length;c<e;c++){const n=u[c-1],o=u[c],l=o.originalStart-n.originalStart-n.originalLength,d=n.originalStart,N=o.originalStart+o.originalLength,b=N-d,m=n.modifiedStart,r=o.modifiedStart+o.modifiedLength,y=r-m;if(l<5&&b<20&&y<20){const A=this.A(d,b,m,y,l);if(A){const[T,M]=A;(T!==n.originalStart+n.originalLength||M!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=T-n.originalStart,n.modifiedLength=M-n.modifiedStart,o.originalStart=T+l,o.modifiedStart=M+l,o.originalLength=N-o.originalStart,o.modifiedLength=r-o.modifiedStart)}}}return u}A(u,c,e,n,o){if(c<o||n<o)return null;const l=u+c-o+1,d=e+n-o+1;let N=0,b=0,m=0;for(let r=u;r<l;r++)for(let y=e;y<d;y++){const A=this.B(r,y,o);A>0&&A>N&&(N=A,b=r,m=y)}return N>0?[b,m]:null}B(u,c,e){let n=0;for(let o=0;o<e;o++){if(!this.p(u+o,c+o))return 0;n+=this.e[u+o].length}return n}C(u){return u<=0||u>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[u])}D(u,c){if(this.C(u)||this.C(u-1))return!0;if(c>0){const e=u+c;if(this.C(e-1)||this.C(e))return!0}return!1}E(u){return u<=0||u>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[u])}F(u,c){if(this.E(u)||this.E(u-1))return!0;if(c>0){const e=u+c;if(this.E(e-1)||this.E(e))return!0}return!1}G(u,c,e,n){const o=this.D(u,c)?1:0,l=this.F(e,n)?1:0;return o+l}H(u,c){const e=[];if(u.length===0||c.length===0)return c.length>0?c:u;if(this.I(u[u.length-1],c[0],e)){const n=new Array(u.length+c.length-1);return k.Copy(u,0,n,0,u.length-1),n[u.length-1]=e[0],k.Copy(c,1,n,u.length,c.length-1),n}else{const n=new Array(u.length+c.length);return k.Copy(u,0,n,0,u.length),k.Copy(c,0,n,u.length,c.length),n}}I(u,c,e){if(S.Assert(u.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),S.Assert(u.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),u.originalStart+u.originalLength>=c.originalStart||u.modifiedStart+u.modifiedLength>=c.modifiedStart){const n=u.originalStart;let o=u.originalLength;const l=u.modifiedStart;let d=u.modifiedLength;return u.originalStart+u.originalLength>=c.originalStart&&(o=c.originalStart+c.originalLength-u.originalStart),u.modifiedStart+u.modifiedLength>=c.modifiedStart&&(d=c.modifiedStart+c.modifiedLength-u.modifiedStart),e[0]=new i.$st(n,o,l,d),!0}else return e[0]=null,!1}J(u,c,e,n){if(u>=0&&u<n)return u;const o=e,l=n-e-1,d=c%2===0;if(u<0){const N=o%2===0;return d===N?0:1}else{const N=l%2===0;return d===N?n-1:n-2}}}t.$vt=w}),define(me[60],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_d=void 0,t.$_d=Symbol("MicrotaskDelay")}),define(me[99],be([1,0,8,9]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=void 0;class B{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const e=c.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$vi=B;class H{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,F.$pf)(c,this.b,0,c.length,this.c,this.d):(0,F.$rf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$wi=H;class S{constructor(c=!0,e=!0){this.f=c,this.g=e}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let e=c.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,F.$pf)(c,this.b,0,c.length,this.d,this.e):(0,F.$rf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$xi=S;var k;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(c,e){this.f=c,this.g=e,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,F.$qf)(c,this.c.scheme);if(this.d[this.e]===2)return(0,F.$qf)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,F.$of)(c,this.c.query);if(this.d[this.e]===5)return(0,F.$of)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$yi=f;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(w||(w={}));class P{static forUris(c=()=>!1,e=()=>!1){return new P(new f(c,e))}static forPaths(c=!1){return new P(new S(void 0,!c))}static forStrings(){return new P(new B)}static forConfigKeys(){return new P(new H)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const o of n)this.set(o,c)}else{const n=c.slice(0);(0,i.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(c,e){const n=this.b.reset(c);let o;this.c||(this.c=new g,this.c.segment=n.value());const l=[];for(o=this.c;;){const N=n.cmp(o.segment);if(N>0)o.left||(o.left=new g,o.left.segment=n.value()),l.push([-1,o]),o=o.left;else if(N<0)o.right||(o.right=new g,o.right.segment=n.value()),l.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new g,o.mid.segment=n.value()),l.push([0,o]),o=o.mid;else break}const d=o.value;o.value=e,o.key=c;for(let N=l.length-1;N>=0;N--){const b=l[N][1];b.updateHeight();const m=b.balanceFactor();if(m<-1||m>1){const r=l[N][0],y=l[N+1][0];if(r===1&&y===1)l[N][1]=b.rotateLeft();else if(r===-1&&y===-1)l[N][1]=b.rotateRight();else if(r===1&&y===-1)b.right=l[N+1][1]=l[N+1][1].rotateRight(),l[N][1]=b.rotateLeft();else if(r===-1&&y===1)b.left=l[N+1][1]=l[N+1][1].rotateLeft(),l[N][1]=b.rotateRight();else throw new Error;if(N>0)switch(l[N-1][0]){case-1:l[N-1][1].left=l[N][1];break;case 1:l[N-1][1].right=l[N][1];break;case 0:l[N-1][1].mid=l[N][1];break}else this.c=l[0][1]}}return d}get(c){return this.d(c)?.value}d(c){const e=this.b.reset(c);let n=this.c;for(;n;){const o=e.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(c){const e=this.d(c);return!(e?.value===void 0&&e?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,e){const n=this.b.reset(c),o=[];let l=this.c;for(;l;){const d=n.cmp(l.segment);if(d>0)o.push([-1,l]),l=l.left;else if(d<0)o.push([1,l]),l=l.right;else if(n.hasNext())n.next(),o.push([0,l]),l=l.mid;else break}if(l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:N,value:b,segment:m}=d;this.e(d.key,!1),l.key=N,l.value=b,l.segment=m}}else{const d=l.left??l.right;if(o.length>0){const[N,b]=o[o.length-1];switch(N){case-1:b.left=d;break;case 0:b.mid=d;break;case 1:b.right=d;break}}else this.c=d}for(let d=o.length-1;d>=0;d--){const N=o[d][1];N.updateHeight();const b=N.balanceFactor();if(b>1?(N.right.balanceFactor()>=0||(N.right=N.right.rotateRight()),o[d][1]=N.rotateLeft()):b<-1&&(N.left.balanceFactor()<=0||(N.left=N.left.rotateLeft()),o[d][1]=N.rotateRight()),d>0)switch(o[d-1][0]){case-1:o[d-1][1].left=o[d][1];break;case 1:o[d-1][1].right=o[d][1];break;case 0:o[d-1][1].mid=o[d][1];break}else this.c=o[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const e=this.b.reset(c);let n=this.c,o;for(;n;){const l=e.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(e.hasNext())e.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(c){return this.g(c,!1)}g(c,e){const n=this.b.reset(c);let o=this.c;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[e,n]of this)c(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const e=[];return this.j(c,e),e[Symbol.iterator]()}j(c,e){c&&(c.left&&this.j(c.left,e),c.value&&e.push([c.key,c.value]),c.mid&&this.j(c.mid,e),c.right&&this.j(c.right,e))}_isBalanced(){const c=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:c(e.left)&&c(e.right)};return c(this.c)}}t.$zi=P}),define(me[10],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=i,t.$7f=F,t.$8f=B,t.$9f=H,t.$0f=S,t.$$f=k,t.$_f=f,t.$ag=g,t.$bg=w,t.$cg=P,t.$dg=u,t.$eg=c,t.$fg=e,t.$gg=o,t.$hg=l,t.$ig=d,t.$jg=N,t.$kg=b;function i(m){return typeof m=="string"}function F(m){return Array.isArray(m)&&m.every(r=>i(r))}function B(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}function H(m){const r=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof r}function S(m){return typeof m=="number"&&!isNaN(m)}function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}function f(m){return m===!0||m===!1}function g(m){return typeof m>"u"}function w(m){return!P(m)}function P(m){return g(m)||m===null}function u(m,r){if(!m)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function c(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}function e(...m){const r=[];for(let y=0;y<m.length;y++){const A=m[y];if(P(A))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);r.push(A)}return r}const n=Object.prototype.hasOwnProperty;function o(m){if(!B(m))return!1;for(const r in m)if(n.call(m,r))return!1;return!0}function l(m){return typeof m=="function"}function d(...m){return m.length>0&&m.every(l)}function N(m,r){const y=Math.min(m.length,r.length);for(let A=0;A<y;A++)b(m[A],r[A])}function b(m,r){if(i(r)){if(typeof m!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(l(r)){try{if(m instanceof r)return}catch{}if(!P(m)&&m.constructor===r||r.length===1&&r.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[45],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nj=B,t.$Oj=H;const F=Object.create(null);function B(S,k){if((0,i.$6f)(k)){const f=F[k];if(f===void 0)throw new Error(`${S} references an unknown codicon: ${k}`);k=f}return F[S]=k,{id:S}}function H(){return F}}),define(me[100],be([1,0,45]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=void 0,t.$Pj={add:(0,i.$Nj)("add",6e4),plus:(0,i.$Nj)("plus",6e4),gistNew:(0,i.$Nj)("gist-new",6e4),repoCreate:(0,i.$Nj)("repo-create",6e4),lightbulb:(0,i.$Nj)("lightbulb",60001),lightBulb:(0,i.$Nj)("light-bulb",60001),repo:(0,i.$Nj)("repo",60002),repoDelete:(0,i.$Nj)("repo-delete",60002),gistFork:(0,i.$Nj)("gist-fork",60003),repoForked:(0,i.$Nj)("repo-forked",60003),gitPullRequest:(0,i.$Nj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Nj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Nj)("record-keys",60005),keyboard:(0,i.$Nj)("keyboard",60005),tag:(0,i.$Nj)("tag",60006),gitPullRequestLabel:(0,i.$Nj)("git-pull-request-label",60006),tagAdd:(0,i.$Nj)("tag-add",60006),tagRemove:(0,i.$Nj)("tag-remove",60006),person:(0,i.$Nj)("person",60007),personFollow:(0,i.$Nj)("person-follow",60007),personOutline:(0,i.$Nj)("person-outline",60007),personFilled:(0,i.$Nj)("person-filled",60007),gitBranch:(0,i.$Nj)("git-branch",60008),gitBranchCreate:(0,i.$Nj)("git-branch-create",60008),gitBranchDelete:(0,i.$Nj)("git-branch-delete",60008),sourceControl:(0,i.$Nj)("source-control",60008),mirror:(0,i.$Nj)("mirror",60009),mirrorPublic:(0,i.$Nj)("mirror-public",60009),star:(0,i.$Nj)("star",60010),starAdd:(0,i.$Nj)("star-add",60010),starDelete:(0,i.$Nj)("star-delete",60010),starEmpty:(0,i.$Nj)("star-empty",60010),comment:(0,i.$Nj)("comment",60011),commentAdd:(0,i.$Nj)("comment-add",60011),alert:(0,i.$Nj)("alert",60012),warning:(0,i.$Nj)("warning",60012),search:(0,i.$Nj)("search",60013),searchSave:(0,i.$Nj)("search-save",60013),logOut:(0,i.$Nj)("log-out",60014),signOut:(0,i.$Nj)("sign-out",60014),logIn:(0,i.$Nj)("log-in",60015),signIn:(0,i.$Nj)("sign-in",60015),eye:(0,i.$Nj)("eye",60016),eyeUnwatch:(0,i.$Nj)("eye-unwatch",60016),eyeWatch:(0,i.$Nj)("eye-watch",60016),circleFilled:(0,i.$Nj)("circle-filled",60017),primitiveDot:(0,i.$Nj)("primitive-dot",60017),closeDirty:(0,i.$Nj)("close-dirty",60017),debugBreakpoint:(0,i.$Nj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Nj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Nj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Nj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Nj)("primitive-square",60018),edit:(0,i.$Nj)("edit",60019),pencil:(0,i.$Nj)("pencil",60019),info:(0,i.$Nj)("info",60020),issueOpened:(0,i.$Nj)("issue-opened",60020),gistPrivate:(0,i.$Nj)("gist-private",60021),gitForkPrivate:(0,i.$Nj)("git-fork-private",60021),lock:(0,i.$Nj)("lock",60021),mirrorPrivate:(0,i.$Nj)("mirror-private",60021),close:(0,i.$Nj)("close",60022),removeClose:(0,i.$Nj)("remove-close",60022),x:(0,i.$Nj)("x",60022),repoSync:(0,i.$Nj)("repo-sync",60023),sync:(0,i.$Nj)("sync",60023),clone:(0,i.$Nj)("clone",60024),desktopDownload:(0,i.$Nj)("desktop-download",60024),beaker:(0,i.$Nj)("beaker",60025),microscope:(0,i.$Nj)("microscope",60025),vm:(0,i.$Nj)("vm",60026),deviceDesktop:(0,i.$Nj)("device-desktop",60026),file:(0,i.$Nj)("file",60027),fileText:(0,i.$Nj)("file-text",60027),more:(0,i.$Nj)("more",60028),ellipsis:(0,i.$Nj)("ellipsis",60028),kebabHorizontal:(0,i.$Nj)("kebab-horizontal",60028),mailReply:(0,i.$Nj)("mail-reply",60029),reply:(0,i.$Nj)("reply",60029),organization:(0,i.$Nj)("organization",60030),organizationFilled:(0,i.$Nj)("organization-filled",60030),organizationOutline:(0,i.$Nj)("organization-outline",60030),newFile:(0,i.$Nj)("new-file",60031),fileAdd:(0,i.$Nj)("file-add",60031),newFolder:(0,i.$Nj)("new-folder",60032),fileDirectoryCreate:(0,i.$Nj)("file-directory-create",60032),trash:(0,i.$Nj)("trash",60033),trashcan:(0,i.$Nj)("trashcan",60033),history:(0,i.$Nj)("history",60034),clock:(0,i.$Nj)("clock",60034),folder:(0,i.$Nj)("folder",60035),fileDirectory:(0,i.$Nj)("file-directory",60035),symbolFolder:(0,i.$Nj)("symbol-folder",60035),logoGithub:(0,i.$Nj)("logo-github",60036),markGithub:(0,i.$Nj)("mark-github",60036),github:(0,i.$Nj)("github",60036),terminal:(0,i.$Nj)("terminal",60037),console:(0,i.$Nj)("console",60037),repl:(0,i.$Nj)("repl",60037),zap:(0,i.$Nj)("zap",60038),symbolEvent:(0,i.$Nj)("symbol-event",60038),error:(0,i.$Nj)("error",60039),stop:(0,i.$Nj)("stop",60039),variable:(0,i.$Nj)("variable",60040),symbolVariable:(0,i.$Nj)("symbol-variable",60040),array:(0,i.$Nj)("array",60042),symbolArray:(0,i.$Nj)("symbol-array",60042),symbolModule:(0,i.$Nj)("symbol-module",60043),symbolPackage:(0,i.$Nj)("symbol-package",60043),symbolNamespace:(0,i.$Nj)("symbol-namespace",60043),symbolObject:(0,i.$Nj)("symbol-object",60043),symbolMethod:(0,i.$Nj)("symbol-method",60044),symbolFunction:(0,i.$Nj)("symbol-function",60044),symbolConstructor:(0,i.$Nj)("symbol-constructor",60044),symbolBoolean:(0,i.$Nj)("symbol-boolean",60047),symbolNull:(0,i.$Nj)("symbol-null",60047),symbolNumeric:(0,i.$Nj)("symbol-numeric",60048),symbolNumber:(0,i.$Nj)("symbol-number",60048),symbolStructure:(0,i.$Nj)("symbol-structure",60049),symbolStruct:(0,i.$Nj)("symbol-struct",60049),symbolParameter:(0,i.$Nj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Nj)("symbol-type-parameter",60050),symbolKey:(0,i.$Nj)("symbol-key",60051),symbolText:(0,i.$Nj)("symbol-text",60051),symbolReference:(0,i.$Nj)("symbol-reference",60052),goToFile:(0,i.$Nj)("go-to-file",60052),symbolEnum:(0,i.$Nj)("symbol-enum",60053),symbolValue:(0,i.$Nj)("symbol-value",60053),symbolRuler:(0,i.$Nj)("symbol-ruler",60054),symbolUnit:(0,i.$Nj)("symbol-unit",60054),activateBreakpoints:(0,i.$Nj)("activate-breakpoints",60055),archive:(0,i.$Nj)("archive",60056),arrowBoth:(0,i.$Nj)("arrow-both",60057),arrowDown:(0,i.$Nj)("arrow-down",60058),arrowLeft:(0,i.$Nj)("arrow-left",60059),arrowRight:(0,i.$Nj)("arrow-right",60060),arrowSmallDown:(0,i.$Nj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Nj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Nj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Nj)("arrow-small-up",60064),arrowUp:(0,i.$Nj)("arrow-up",60065),bell:(0,i.$Nj)("bell",60066),bold:(0,i.$Nj)("bold",60067),book:(0,i.$Nj)("book",60068),bookmark:(0,i.$Nj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Nj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Nj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Nj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Nj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Nj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Nj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Nj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Nj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Nj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Nj)("briefcase",60076),broadcast:(0,i.$Nj)("broadcast",60077),browser:(0,i.$Nj)("browser",60078),bug:(0,i.$Nj)("bug",60079),calendar:(0,i.$Nj)("calendar",60080),caseSensitive:(0,i.$Nj)("case-sensitive",60081),check:(0,i.$Nj)("check",60082),checklist:(0,i.$Nj)("checklist",60083),chevronDown:(0,i.$Nj)("chevron-down",60084),chevronLeft:(0,i.$Nj)("chevron-left",60085),chevronRight:(0,i.$Nj)("chevron-right",60086),chevronUp:(0,i.$Nj)("chevron-up",60087),chromeClose:(0,i.$Nj)("chrome-close",60088),chromeMaximize:(0,i.$Nj)("chrome-maximize",60089),chromeMinimize:(0,i.$Nj)("chrome-minimize",60090),chromeRestore:(0,i.$Nj)("chrome-restore",60091),circleOutline:(0,i.$Nj)("circle-outline",60092),circle:(0,i.$Nj)("circle",60092),debugBreakpointUnverified:(0,i.$Nj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Nj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Nj)("circle-slash",60093),circuitBoard:(0,i.$Nj)("circuit-board",60094),clearAll:(0,i.$Nj)("clear-all",60095),clippy:(0,i.$Nj)("clippy",60096),closeAll:(0,i.$Nj)("close-all",60097),cloudDownload:(0,i.$Nj)("cloud-download",60098),cloudUpload:(0,i.$Nj)("cloud-upload",60099),code:(0,i.$Nj)("code",60100),collapseAll:(0,i.$Nj)("collapse-all",60101),colorMode:(0,i.$Nj)("color-mode",60102),commentDiscussion:(0,i.$Nj)("comment-discussion",60103),creditCard:(0,i.$Nj)("credit-card",60105),dash:(0,i.$Nj)("dash",60108),dashboard:(0,i.$Nj)("dashboard",60109),database:(0,i.$Nj)("database",60110),debugContinue:(0,i.$Nj)("debug-continue",60111),debugDisconnect:(0,i.$Nj)("debug-disconnect",60112),debugPause:(0,i.$Nj)("debug-pause",60113),debugRestart:(0,i.$Nj)("debug-restart",60114),debugStart:(0,i.$Nj)("debug-start",60115),debugStepInto:(0,i.$Nj)("debug-step-into",60116),debugStepOut:(0,i.$Nj)("debug-step-out",60117),debugStepOver:(0,i.$Nj)("debug-step-over",60118),debugStop:(0,i.$Nj)("debug-stop",60119),debug:(0,i.$Nj)("debug",60120),deviceCameraVideo:(0,i.$Nj)("device-camera-video",60121),deviceCamera:(0,i.$Nj)("device-camera",60122),deviceMobile:(0,i.$Nj)("device-mobile",60123),diffAdded:(0,i.$Nj)("diff-added",60124),diffIgnored:(0,i.$Nj)("diff-ignored",60125),diffModified:(0,i.$Nj)("diff-modified",60126),diffRemoved:(0,i.$Nj)("diff-removed",60127),diffRenamed:(0,i.$Nj)("diff-renamed",60128),diff:(0,i.$Nj)("diff",60129),diffSidebyside:(0,i.$Nj)("diff-sidebyside",60129),discard:(0,i.$Nj)("discard",60130),editorLayout:(0,i.$Nj)("editor-layout",60131),emptyWindow:(0,i.$Nj)("empty-window",60132),exclude:(0,i.$Nj)("exclude",60133),extensions:(0,i.$Nj)("extensions",60134),eyeClosed:(0,i.$Nj)("eye-closed",60135),fileBinary:(0,i.$Nj)("file-binary",60136),fileCode:(0,i.$Nj)("file-code",60137),fileMedia:(0,i.$Nj)("file-media",60138),filePdf:(0,i.$Nj)("file-pdf",60139),fileSubmodule:(0,i.$Nj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Nj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Nj)("file-symlink-file",60142),fileZip:(0,i.$Nj)("file-zip",60143),files:(0,i.$Nj)("files",60144),filter:(0,i.$Nj)("filter",60145),flame:(0,i.$Nj)("flame",60146),foldDown:(0,i.$Nj)("fold-down",60147),foldUp:(0,i.$Nj)("fold-up",60148),fold:(0,i.$Nj)("fold",60149),folderActive:(0,i.$Nj)("folder-active",60150),folderOpened:(0,i.$Nj)("folder-opened",60151),gear:(0,i.$Nj)("gear",60152),gift:(0,i.$Nj)("gift",60153),gistSecret:(0,i.$Nj)("gist-secret",60154),gist:(0,i.$Nj)("gist",60155),gitCommit:(0,i.$Nj)("git-commit",60156),gitCompare:(0,i.$Nj)("git-compare",60157),compareChanges:(0,i.$Nj)("compare-changes",60157),gitMerge:(0,i.$Nj)("git-merge",60158),githubAction:(0,i.$Nj)("github-action",60159),githubAlt:(0,i.$Nj)("github-alt",60160),globe:(0,i.$Nj)("globe",60161),grabber:(0,i.$Nj)("grabber",60162),graph:(0,i.$Nj)("graph",60163),gripper:(0,i.$Nj)("gripper",60164),heart:(0,i.$Nj)("heart",60165),home:(0,i.$Nj)("home",60166),horizontalRule:(0,i.$Nj)("horizontal-rule",60167),hubot:(0,i.$Nj)("hubot",60168),inbox:(0,i.$Nj)("inbox",60169),issueReopened:(0,i.$Nj)("issue-reopened",60171),issues:(0,i.$Nj)("issues",60172),italic:(0,i.$Nj)("italic",60173),jersey:(0,i.$Nj)("jersey",60174),json:(0,i.$Nj)("json",60175),kebabVertical:(0,i.$Nj)("kebab-vertical",60176),key:(0,i.$Nj)("key",60177),law:(0,i.$Nj)("law",60178),lightbulbAutofix:(0,i.$Nj)("lightbulb-autofix",60179),linkExternal:(0,i.$Nj)("link-external",60180),link:(0,i.$Nj)("link",60181),listOrdered:(0,i.$Nj)("list-ordered",60182),listUnordered:(0,i.$Nj)("list-unordered",60183),liveShare:(0,i.$Nj)("live-share",60184),loading:(0,i.$Nj)("loading",60185),location:(0,i.$Nj)("location",60186),mailRead:(0,i.$Nj)("mail-read",60187),mail:(0,i.$Nj)("mail",60188),markdown:(0,i.$Nj)("markdown",60189),megaphone:(0,i.$Nj)("megaphone",60190),mention:(0,i.$Nj)("mention",60191),milestone:(0,i.$Nj)("milestone",60192),gitPullRequestMilestone:(0,i.$Nj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Nj)("mortar-board",60193),move:(0,i.$Nj)("move",60194),multipleWindows:(0,i.$Nj)("multiple-windows",60195),mute:(0,i.$Nj)("mute",60196),noNewline:(0,i.$Nj)("no-newline",60197),note:(0,i.$Nj)("note",60198),octoface:(0,i.$Nj)("octoface",60199),openPreview:(0,i.$Nj)("open-preview",60200),package:(0,i.$Nj)("package",60201),paintcan:(0,i.$Nj)("paintcan",60202),pin:(0,i.$Nj)("pin",60203),play:(0,i.$Nj)("play",60204),run:(0,i.$Nj)("run",60204),plug:(0,i.$Nj)("plug",60205),preserveCase:(0,i.$Nj)("preserve-case",60206),preview:(0,i.$Nj)("preview",60207),project:(0,i.$Nj)("project",60208),pulse:(0,i.$Nj)("pulse",60209),question:(0,i.$Nj)("question",60210),quote:(0,i.$Nj)("quote",60211),radioTower:(0,i.$Nj)("radio-tower",60212),reactions:(0,i.$Nj)("reactions",60213),references:(0,i.$Nj)("references",60214),refresh:(0,i.$Nj)("refresh",60215),regex:(0,i.$Nj)("regex",60216),remoteExplorer:(0,i.$Nj)("remote-explorer",60217),remote:(0,i.$Nj)("remote",60218),remove:(0,i.$Nj)("remove",60219),replaceAll:(0,i.$Nj)("replace-all",60220),replace:(0,i.$Nj)("replace",60221),repoClone:(0,i.$Nj)("repo-clone",60222),repoForcePush:(0,i.$Nj)("repo-force-push",60223),repoPull:(0,i.$Nj)("repo-pull",60224),repoPush:(0,i.$Nj)("repo-push",60225),report:(0,i.$Nj)("report",60226),requestChanges:(0,i.$Nj)("request-changes",60227),rocket:(0,i.$Nj)("rocket",60228),rootFolderOpened:(0,i.$Nj)("root-folder-opened",60229),rootFolder:(0,i.$Nj)("root-folder",60230),rss:(0,i.$Nj)("rss",60231),ruby:(0,i.$Nj)("ruby",60232),saveAll:(0,i.$Nj)("save-all",60233),saveAs:(0,i.$Nj)("save-as",60234),save:(0,i.$Nj)("save",60235),screenFull:(0,i.$Nj)("screen-full",60236),screenNormal:(0,i.$Nj)("screen-normal",60237),searchStop:(0,i.$Nj)("search-stop",60238),server:(0,i.$Nj)("server",60240),settingsGear:(0,i.$Nj)("settings-gear",60241),settings:(0,i.$Nj)("settings",60242),shield:(0,i.$Nj)("shield",60243),smiley:(0,i.$Nj)("smiley",60244),sortPrecedence:(0,i.$Nj)("sort-precedence",60245),splitHorizontal:(0,i.$Nj)("split-horizontal",60246),splitVertical:(0,i.$Nj)("split-vertical",60247),squirrel:(0,i.$Nj)("squirrel",60248),starFull:(0,i.$Nj)("star-full",60249),starHalf:(0,i.$Nj)("star-half",60250),symbolClass:(0,i.$Nj)("symbol-class",60251),symbolColor:(0,i.$Nj)("symbol-color",60252),symbolConstant:(0,i.$Nj)("symbol-constant",60253),symbolEnumMember:(0,i.$Nj)("symbol-enum-member",60254),symbolField:(0,i.$Nj)("symbol-field",60255),symbolFile:(0,i.$Nj)("symbol-file",60256),symbolInterface:(0,i.$Nj)("symbol-interface",60257),symbolKeyword:(0,i.$Nj)("symbol-keyword",60258),symbolMisc:(0,i.$Nj)("symbol-misc",60259),symbolOperator:(0,i.$Nj)("symbol-operator",60260),symbolProperty:(0,i.$Nj)("symbol-property",60261),wrench:(0,i.$Nj)("wrench",60261),wrenchSubaction:(0,i.$Nj)("wrench-subaction",60261),symbolSnippet:(0,i.$Nj)("symbol-snippet",60262),tasklist:(0,i.$Nj)("tasklist",60263),telescope:(0,i.$Nj)("telescope",60264),textSize:(0,i.$Nj)("text-size",60265),threeBars:(0,i.$Nj)("three-bars",60266),thumbsdown:(0,i.$Nj)("thumbsdown",60267),thumbsup:(0,i.$Nj)("thumbsup",60268),tools:(0,i.$Nj)("tools",60269),triangleDown:(0,i.$Nj)("triangle-down",60270),triangleLeft:(0,i.$Nj)("triangle-left",60271),triangleRight:(0,i.$Nj)("triangle-right",60272),triangleUp:(0,i.$Nj)("triangle-up",60273),twitter:(0,i.$Nj)("twitter",60274),unfold:(0,i.$Nj)("unfold",60275),unlock:(0,i.$Nj)("unlock",60276),unmute:(0,i.$Nj)("unmute",60277),unverified:(0,i.$Nj)("unverified",60278),verified:(0,i.$Nj)("verified",60279),versions:(0,i.$Nj)("versions",60280),vmActive:(0,i.$Nj)("vm-active",60281),vmOutline:(0,i.$Nj)("vm-outline",60282),vmRunning:(0,i.$Nj)("vm-running",60283),watch:(0,i.$Nj)("watch",60284),whitespace:(0,i.$Nj)("whitespace",60285),wholeWord:(0,i.$Nj)("whole-word",60286),window:(0,i.$Nj)("window",60287),wordWrap:(0,i.$Nj)("word-wrap",60288),zoomIn:(0,i.$Nj)("zoom-in",60289),zoomOut:(0,i.$Nj)("zoom-out",60290),listFilter:(0,i.$Nj)("list-filter",60291),listFlat:(0,i.$Nj)("list-flat",60292),listSelection:(0,i.$Nj)("list-selection",60293),selection:(0,i.$Nj)("selection",60293),listTree:(0,i.$Nj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Nj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Nj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Nj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Nj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Nj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Nj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Nj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Nj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Nj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Nj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Nj)("symbol-string",60301),debugReverseContinue:(0,i.$Nj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Nj)("debug-step-back",60303),debugRestartFrame:(0,i.$Nj)("debug-restart-frame",60304),debugAlt:(0,i.$Nj)("debug-alt",60305),callIncoming:(0,i.$Nj)("call-incoming",60306),callOutgoing:(0,i.$Nj)("call-outgoing",60307),menu:(0,i.$Nj)("menu",60308),expandAll:(0,i.$Nj)("expand-all",60309),feedback:(0,i.$Nj)("feedback",60310),gitPullRequestReviewer:(0,i.$Nj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Nj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Nj)("ungroup-by-ref-type",60312),account:(0,i.$Nj)("account",60313),gitPullRequestAssignee:(0,i.$Nj)("git-pull-request-assignee",60313),bellDot:(0,i.$Nj)("bell-dot",60314),debugConsole:(0,i.$Nj)("debug-console",60315),library:(0,i.$Nj)("library",60316),output:(0,i.$Nj)("output",60317),runAll:(0,i.$Nj)("run-all",60318),syncIgnored:(0,i.$Nj)("sync-ignored",60319),pinned:(0,i.$Nj)("pinned",60320),githubInverted:(0,i.$Nj)("github-inverted",60321),serverProcess:(0,i.$Nj)("server-process",60322),serverEnvironment:(0,i.$Nj)("server-environment",60323),pass:(0,i.$Nj)("pass",60324),issueClosed:(0,i.$Nj)("issue-closed",60324),stopCircle:(0,i.$Nj)("stop-circle",60325),playCircle:(0,i.$Nj)("play-circle",60326),record:(0,i.$Nj)("record",60327),debugAltSmall:(0,i.$Nj)("debug-alt-small",60328),vmConnect:(0,i.$Nj)("vm-connect",60329),cloud:(0,i.$Nj)("cloud",60330),merge:(0,i.$Nj)("merge",60331),export:(0,i.$Nj)("export",60332),graphLeft:(0,i.$Nj)("graph-left",60333),magnet:(0,i.$Nj)("magnet",60334),notebook:(0,i.$Nj)("notebook",60335),redo:(0,i.$Nj)("redo",60336),checkAll:(0,i.$Nj)("check-all",60337),pinnedDirty:(0,i.$Nj)("pinned-dirty",60338),passFilled:(0,i.$Nj)("pass-filled",60339),circleLargeFilled:(0,i.$Nj)("circle-large-filled",60340),circleLarge:(0,i.$Nj)("circle-large",60341),circleLargeOutline:(0,i.$Nj)("circle-large-outline",60341),combine:(0,i.$Nj)("combine",60342),gather:(0,i.$Nj)("gather",60342),table:(0,i.$Nj)("table",60343),variableGroup:(0,i.$Nj)("variable-group",60344),typeHierarchy:(0,i.$Nj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Nj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Nj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Nj)("git-pull-request-create",60348),runAbove:(0,i.$Nj)("run-above",60349),runBelow:(0,i.$Nj)("run-below",60350),notebookTemplate:(0,i.$Nj)("notebook-template",60351),debugRerun:(0,i.$Nj)("debug-rerun",60352),workspaceTrusted:(0,i.$Nj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Nj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Nj)("workspace-unknown",60355),terminalCmd:(0,i.$Nj)("terminal-cmd",60356),terminalDebian:(0,i.$Nj)("terminal-debian",60357),terminalLinux:(0,i.$Nj)("terminal-linux",60358),terminalPowershell:(0,i.$Nj)("terminal-powershell",60359),terminalTmux:(0,i.$Nj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Nj)("terminal-ubuntu",60361),terminalBash:(0,i.$Nj)("terminal-bash",60362),arrowSwap:(0,i.$Nj)("arrow-swap",60363),copy:(0,i.$Nj)("copy",60364),personAdd:(0,i.$Nj)("person-add",60365),filterFilled:(0,i.$Nj)("filter-filled",60366),wand:(0,i.$Nj)("wand",60367),debugLineByLine:(0,i.$Nj)("debug-line-by-line",60368),inspect:(0,i.$Nj)("inspect",60369),layers:(0,i.$Nj)("layers",60370),layersDot:(0,i.$Nj)("layers-dot",60371),layersActive:(0,i.$Nj)("layers-active",60372),compass:(0,i.$Nj)("compass",60373),compassDot:(0,i.$Nj)("compass-dot",60374),compassActive:(0,i.$Nj)("compass-active",60375),azure:(0,i.$Nj)("azure",60376),issueDraft:(0,i.$Nj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Nj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Nj)("git-pull-request-draft",60379),debugAll:(0,i.$Nj)("debug-all",60380),debugCoverage:(0,i.$Nj)("debug-coverage",60381),runErrors:(0,i.$Nj)("run-errors",60382),folderLibrary:(0,i.$Nj)("folder-library",60383),debugContinueSmall:(0,i.$Nj)("debug-continue-small",60384),beakerStop:(0,i.$Nj)("beaker-stop",60385),graphLine:(0,i.$Nj)("graph-line",60386),graphScatter:(0,i.$Nj)("graph-scatter",60387),pieChart:(0,i.$Nj)("pie-chart",60388),bracket:(0,i.$Nj)("bracket",60175),bracketDot:(0,i.$Nj)("bracket-dot",60389),bracketError:(0,i.$Nj)("bracket-error",60390),lockSmall:(0,i.$Nj)("lock-small",60391),azureDevops:(0,i.$Nj)("azure-devops",60392),verifiedFilled:(0,i.$Nj)("verified-filled",60393),newline:(0,i.$Nj)("newline",60394),layout:(0,i.$Nj)("layout",60395),layoutActivitybarLeft:(0,i.$Nj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Nj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Nj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Nj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Nj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Nj)("layout-panel-right",60401),layoutPanel:(0,i.$Nj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Nj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Nj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Nj)("layout-statusbar",60405),layoutMenubar:(0,i.$Nj)("layout-menubar",60406),layoutCentered:(0,i.$Nj)("layout-centered",60407),target:(0,i.$Nj)("target",60408),indent:(0,i.$Nj)("indent",60409),recordSmall:(0,i.$Nj)("record-small",60410),errorSmall:(0,i.$Nj)("error-small",60411),terminalDecorationError:(0,i.$Nj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Nj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Nj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Nj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Nj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Nj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Nj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Nj)("layout-sidebar-left-off",60418),blank:(0,i.$Nj)("blank",60419),heartFilled:(0,i.$Nj)("heart-filled",60420),map:(0,i.$Nj)("map",60421),mapHorizontal:(0,i.$Nj)("map-horizontal",60421),foldHorizontal:(0,i.$Nj)("fold-horizontal",60421),mapFilled:(0,i.$Nj)("map-filled",60422),mapHorizontalFilled:(0,i.$Nj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Nj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Nj)("circle-small",60423),bellSlash:(0,i.$Nj)("bell-slash",60424),bellSlashDot:(0,i.$Nj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Nj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Nj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Nj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Nj)("search-fuzzy",60429),commentDraft:(0,i.$Nj)("comment-draft",60430),send:(0,i.$Nj)("send",60431),sparkle:(0,i.$Nj)("sparkle",60432),insert:(0,i.$Nj)("insert",60433),mic:(0,i.$Nj)("mic",60434),thumbsdownFilled:(0,i.$Nj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Nj)("thumbsup-filled",60436),coffee:(0,i.$Nj)("coffee",60437),snake:(0,i.$Nj)("snake",60438),game:(0,i.$Nj)("game",60439),vr:(0,i.$Nj)("vr",60440),chip:(0,i.$Nj)("chip",60441),piano:(0,i.$Nj)("piano",60442),music:(0,i.$Nj)("music",60443),micFilled:(0,i.$Nj)("mic-filled",60444),repoFetch:(0,i.$Nj)("repo-fetch",60445),copilot:(0,i.$Nj)("copilot",60446),lightbulbSparkle:(0,i.$Nj)("lightbulb-sparkle",60447),robot:(0,i.$Nj)("robot",60448),sparkleFilled:(0,i.$Nj)("sparkle-filled",60449),diffSingle:(0,i.$Nj)("diff-single",60450),diffMultiple:(0,i.$Nj)("diff-multiple",60451),surroundWith:(0,i.$Nj)("surround-with",60452),share:(0,i.$Nj)("share",60453),gitStash:(0,i.$Nj)("git-stash",60454),gitStashApply:(0,i.$Nj)("git-stash-apply",60455),gitStashPop:(0,i.$Nj)("git-stash-pop",60456),vscode:(0,i.$Nj)("vscode",60457),vscodeInsiders:(0,i.$Nj)("vscode-insiders",60458),codeOss:(0,i.$Nj)("code-oss",60459),runCoverage:(0,i.$Nj)("run-coverage",60460),runAllCoverage:(0,i.$Nj)("run-all-coverage",60461),coverage:(0,i.$Nj)("coverage",60462),githubProject:(0,i.$Nj)("github-project",60463),mapVertical:(0,i.$Nj)("map-vertical",60464),foldVertical:(0,i.$Nj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Nj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Nj)("fold-vertical-filled",60465),goToSearch:(0,i.$Nj)("go-to-search",60466),percentage:(0,i.$Nj)("percentage",60467),sortPercentage:(0,i.$Nj)("sort-percentage",60467)}}),define(me[18],be([1,0,45,100]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=void 0,t.$Qj=B;function B(){return Object.values(t.$Sj)}t.$Rj={dialogError:(0,i.$Nj)("dialog-error","error"),dialogWarning:(0,i.$Nj)("dialog-warning","warning"),dialogInfo:(0,i.$Nj)("dialog-info","info"),dialogClose:(0,i.$Nj)("dialog-close","close"),treeItemExpanded:(0,i.$Nj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Nj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Nj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Nj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Nj)("tree-item-loading","loading"),menuSelection:(0,i.$Nj)("menu-selection","check"),menuSubmenu:(0,i.$Nj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Nj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Nj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Nj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Nj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Nj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Nj)("toolbar-more","more"),quickInputBack:(0,i.$Nj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Nj)("drop-down-button",60084),symbolCustomColor:(0,i.$Nj)("symbol-customcolor",60252),exportIcon:(0,i.$Nj)("export",60332),workspaceUnspecified:(0,i.$Nj)("workspace-unspecified",60355),newLine:(0,i.$Nj)("newline",60394),thumbsDownFilled:(0,i.$Nj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Nj)("thumbsup-filled",60436),gitFetch:(0,i.$Nj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Nj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Nj)("debug-breakpoint-pending",60377)},t.$Sj={...F.$Pj,...t.$Rj}}),define(me[61],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=F,t.$1n=B,t.$2n=S,t.$3n=f,t.$4n=g,t.$5n=w,t.$6n=P,t.$7n=u,t.$8n=c,t.$9n=e,t.$0n=n,t.$$n=o;function F(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([N,b])=>{d[N]=b&&typeof b=="object"?F(b):b}),d}function B(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const N=d.shift();Object.freeze(N);for(const b in N)if(H.call(N,b)){const m=N[b];typeof m=="object"&&!Object.isFrozen(m)&&!(0,i.$9f)(m)&&d.push(m)}}return l}const H=Object.prototype.hasOwnProperty;function S(l,d){return k(l,d,new Set)}function k(l,d,N){if((0,i.$cg)(l))return l;const b=d(l);if(typeof b<"u")return b;if(Array.isArray(l)){const m=[];for(const r of l)m.push(k(r,d,N));return m}if((0,i.$8f)(l)){if(N.has(l))throw new Error("Cannot clone recursive data-structure");N.add(l);const m={};for(const r in l)H.call(l,r)&&(m[r]=k(l[r],d,N));return N.delete(l),m}return l}function f(l,d,N=!0){return(0,i.$8f)(l)?((0,i.$8f)(d)&&Object.keys(d).forEach(b=>{b in l?N&&((0,i.$8f)(l[b])&&(0,i.$8f)(d[b])?f(l[b],d[b],N):l[b]=d[b]):l[b]=d[b]}),l):d}function g(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let N,b;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(N=0;N<l.length;N++)if(!g(l[N],d[N]))return!1}else{const m=[];for(b in l)m.push(b);m.sort();const r=[];for(b in d)r.push(b);if(r.sort(),!g(m,r))return!1;for(N=0;N<m.length;N++)if(!g(l[m[N]],d[m[N]]))return!1}return!0}function w(l){const d=new Set;return JSON.stringify(l,(N,b)=>{if((0,i.$8f)(b)||Array.isArray(b)){if(d.has(b))return"[Circular]";d.add(b)}return typeof b=="bigint"?`[BigInt ${b.toString()}]`:b})}function P(l,d){const N=Object.create(null);return!l||!d||Object.keys(d).forEach(m=>{const r=l[m],y=d[m];g(r,y)||(N[m]=y)}),N}function u(l,d){const N=d.toLowerCase(),b=Object.keys(l).find(m=>m.toLowerCase()===N);return b?l[b]:l[d]}function c(l,d){const N=Object.create(null);for(const[b,m]of Object.entries(l))d(b,m)&&(N[b]=m);return N}function e(l){let d=[];for(;Object.prototype!==l;)d=d.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return d}function n(l){const d=[];for(const N of e(l))typeof l[N]=="function"&&d.push(N);return d}function o(l,d){const N=m=>function(){const r=Array.prototype.slice.call(arguments,0);return d(m,r)},b={};for(const m of l)b[m]=N(m);return b}}),define(me[19],be([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Tj=B;var F;(function(S){function k(f){return f&&typeof f=="object"&&typeof f.id=="string"}S.isThemeColor=k})(F||(t.ThemeColor=F={}));function B(S){return{id:S}}var H;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function f(d){const N=k.exec(d.id);if(!N)return f(i.$Sj.error);const[,b,m]=N,r=["codicon","codicon-"+b];return m&&r.push("codicon-modifier-"+m.substring(1)),r}S.asClassNameArray=f;function g(d){return f(d).join(" ")}S.asClassName=g;function w(d){return"."+f(d).join(".")}S.asCSSSelector=w;function P(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||F.isThemeColor(d.color))}S.isThemeIcon=P;const u=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function c(d){const N=u.exec(d);if(!N)return;const[,b]=N;return{id:b}}S.fromString=c;function e(d){return{id:d}}S.fromId=e;function n(d,N){let b=d.id;const m=b.lastIndexOf("~");return m!==-1&&(b=b.substring(0,m)),N&&(b=`${b}~${N}`),{id:b}}S.modify=n;function o(d){const N=d.id.lastIndexOf("~");if(N!==-1)return d.id.substring(N+1)}S.getModifier=o;function l(d,N){return d.id===N.id&&d.color?.id===N.color?.id}S.isEqual=l})(H||(t.ThemeIcon=H={}))}),define(me[62],be([1,0,44,9,19]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kk=f,t.$Lk=w,t.$Mk=u,t.$Nk=c,t.$Ok=n,t.$Pk=o;const H="$(",S=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${S.source}`,"g");function f(l){return l.replace(k,(d,N)=>N?d:`\\${d}`)}const g=new RegExp(`\\\\${S.source}`,"g");function w(l){return l.replace(g,d=>`\\${d}`)}const P=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function u(l){return l.indexOf(H)===-1?l:l.replace(P,(d,N,b,m)=>b?d:N||m||"")}function c(l){return l?l.replace(/\$\((.*?)\)/g,(d,N)=>` ${N} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(l){e.lastIndex=0;let d="";const N=[];let b=0;for(;;){const m=e.lastIndex,r=e.exec(l),y=l.substring(m,r?.index);if(y.length>0){d+=y;for(let A=0;A<y.length;A++)N.push(b)}if(!r)break;b+=r[0].length}return{text:d,iconOffsets:N}}function o(l,d,N=!1){const{text:b,iconOffsets:m}=d;if(!m||m.length===0)return(0,i.$Bk)(l,b,N);const r=(0,F.$cf)(b," "),y=b.length-r.length,A=(0,i.$Bk)(l,r,N);if(A)for(const T of A){const M=m[T.start+y]+y;T.start+=M,T.end+=M}return A}}),define(me[101],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HW=t.$GW=void 0,t.$GW="vscode:contextmenu",t.$HW="vscode:onCloseContextMenu"}),define(me[102],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OW=void 0;class i{constructor(B,H){this.a=B,this.onMessage=H}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$OW=i}),define(me[35],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(me[103],be([1,0,101,35]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KW=H;let B=0;function H(k,f,g){const w=[],P=B++,u=`vscode:onContextMenu${P}`,c=(e,n,o)=>{w[n].click?.(o)};F.$O.once(u,c),F.$O.once(i.$HW,(e,n)=>{n===P&&(F.$O.removeListener(u,c),g?.())}),F.$O.send(i.$GW,P,k.map(e=>S(e,w)),u,f)}function S(k,f){const g={id:f.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return f.push(k),Array.isArray(k.submenu)&&(g.submenu=k.submenu.map(w=>S(w,f))),g}}),define(me[63],be([7]),{}),define(me[104],be([7]),{}),define(me[105],be([7]),{}),define(me[106],be([7]),{}),define(me[107],be([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[108],be([7]),{}),define(me[109],be([7]),{}),define(me[110],be([7]),{}),define(me[111],be([7]),{}),define(me[112],be([7]),{}),define(me[113],be([7]),{}),define(me[114],be([7]),{}),define(me[115],be([7]),{}),define(me[116],be([7]),{}),define(me[117],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[118],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[119],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[120],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[121],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[122],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[123],be([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(me[46],be([1,0,3,2,123]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cj=t.$bj=t.$aj=t.$_i=t.$$i=void 0,t.$dj=w;class H extends F.$Vc{constructor(u,c="",e="",n=!0,o){super(),this.h=this.B(new i.$ce),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=c,this.u=e,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,c){this.C&&await this.C(u)}}t.$$i=H;class S extends F.$Vc{constructor(){super(...arguments),this.f=this.B(new i.$ce),this.onWillRun=this.f.event,this.m=this.B(new i.$ce),this.onDidRun=this.m.event}async run(u,c){if(!u.enabled)return;this.f.fire({action:u});let e;try{await this.u(u,c)}catch(n){e=n}this.m.fire({action:u,error:e})}async u(u,c){await u.run(c)}}t.$_i=S;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let c=[];for(const e of u)e.length&&(c.length?c=[...c,new k,...e]:c=e);return c}static{this.ID="vs.actions.separator"}async run(){}}t.$aj=k;class f{get actions(){return this.a}constructor(u,c,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=c,this.class=n,this.a=e}async run(){}}t.$bj=f;class g extends H{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,B.localize(0,null),void 0,!1)}}t.$cj=g;function w(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...u)=>P.run(...u),tooltip:P.label}}}),define(me[124],be([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(me[5],be([1,0,124]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=y,t.$D=I,t.$J=V,t.$g="en";let F=!1,B=!1,H=!1,S=!1,k=!1,f=!1,g=!1,w=!1,P=!1,u=!1,c,e=t.$g,n=t.$g,o,l;const d=globalThis;let N;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?N=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(N=process);const b=typeof N?.versions?.electron=="string",m=b&&N?.type==="renderer";if(typeof N=="object"){F=N.platform==="win32",B=N.platform==="darwin",H=N.platform==="linux",S=H&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,g=b,P=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=t.$g,e=t.$g;const R=N.env.VSCODE_NLS_CONFIG;if(R)try{const x=JSON.parse(R),O=x.availableLanguages["*"];c=x.locale,n=x.osLocale,e=O||t.$g,o=x._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!m?(l=navigator.userAgent,F=l.indexOf("Windows")>=0,B=l.indexOf("Macintosh")>=0,w=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=l.indexOf("Linux")>=0,u=l?.indexOf("Mobi")>=0,f=!0,c=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=c,n=navigator.language):console.error("Unable to resolve platform.");var r;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(r||(t.Platform=r={}));function y(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let A=0;B?A=1:F?A=3:H&&(A=2),t.$i=F,t.$j=B,t.$k=H,t.$l=S,t.$m=k,t.$n=g,t.$o=f,t.$p=f&&typeof d.importScripts=="function",t.$q=t.$p?d.origin:void 0,t.$r=w,t.$s=u,t.$t=P,t.$u=A,t.$v=l,t.$w=e;var T;(function(R){function x(){return t.$w}R.value=x;function O(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}R.isDefaultVariant=O;function X(){return t.$w==="en"}R.isDefault=X})(T||(t.Language=T={})),t.$x=c,t.$y=n,t.$z=o,t.$A=typeof d.postMessage=="function"&&!d.importScripts,t.$B=(()=>{if(t.$A){const R=[];d.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let X=0,K=R.length;X<K;X++){const ae=R[X];if(ae.id===O.data.vscodeScheduleAsyncWork){R.splice(X,1),ae.callback();return}}});let x=0;return O=>{const X=++x;R.push({id:X,callback:O}),d.postMessage({vscodeScheduleAsyncWork:X},"*")}}return R=>setTimeout(R)})();var M;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=B||w?2:F?1:3;let q=!0,$=!1;function I(){if(!$){$=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,q=new Uint16Array(R.buffer)[0]===513}return q}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(R){return parseFloat(R)>=20}}),define(me[125],be([1,0,17,22,5]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=t.KeyboardSupport=void 0;var H;(function(S){S[S.Always=0]="Always",S[S.FullScreen=1]="FullScreen",S[S.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$zR={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||i.$xR()?0:navigator.keyboard||i.$tR?1:2,touch:"ontouchstart"in F.$eR||navigator.maxTouchPoints>0,pointerEvents:F.$eR.PointerEvent&&("ontouchstart"in F.$eR||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,54,87,5]),function(se,t,i,F,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HR=void 0,t.$FR=P,t.$GR=u;function S(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return F.KeyCodeUtils.fromString(o)}const n=e.keyCode;if(n===3)return 7;if(i.$qR)switch(n){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(i.$rR){if(H.$j&&n===93)return 57;if(!H.$j&&n===92)return 57}return F.$wr[n]||0}const k=H.$j?256:2048,f=512,g=1024,w=H.$j?2048:256;function P(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function u(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${F.KeyCodeUtils.toString(e.keyCode)}')`}class c{constructor(n){this._standardKeyboardEventBrand=!0;const o=n;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=S(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let o=0;return this.ctrlKey&&(o|=k),this.altKey&&(o|=f),this.shiftKey&&(o|=g),this.metaKey&&(o|=w),o|=n,o}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new B.$Er(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$HR=c}),define(me[20],be([1,0,17,79,5]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=t.$DR=t.$CR=void 0;class H{constructor(g,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=F.$AR.getPositionOfChildWindowRelativeToAncestorWindow(g,w.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$CR=H;class S extends H{constructor(g,w){super(g,w),this.dataTransfer=w.dataTransfer}}t.$DR=S;class k{constructor(g,w=0,P=0){this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=P,this.deltaX=w;let u=!1;if(i.$sR){const c=navigator.userAgent.match(/Chrome\/(\d+)/);u=(c?parseInt(c[1]):123)<=122}if(g){const c=g,e=g,n=g.view?.devicePixelRatio||1;if(typeof c.wheelDeltaY<"u")u?this.deltaY=c.wheelDeltaY/(120*n):this.deltaY=c.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$qR&&!B.$j?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof c.wheelDeltaX<"u")i.$tR&&B.$i?this.deltaX=-(c.wheelDeltaX/120):u?this.deltaX=c.wheelDeltaX/(120*n):this.deltaX=c.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$qR&&!B.$j?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(u?this.deltaY=g.wheelDelta/(120*n):this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$ER=k}),define(me[126],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const H=B.process;F={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),define(me[25],be([1,0,126]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,B=97,H=90,S=122,k=46,f=47,g=92,w=58,P=63;class u extends Error{constructor(y,A,T){let M;typeof A=="string"&&A.indexOf("not ")===0?(M="must not be",A=A.replace(/^not /,"")):M="must be";const q=y.indexOf(".")!==-1?"property":"argument";let $=`The "${y}" ${q} ${M} of type ${A}`;$+=`. Received type ${typeof T}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function c(r,y){if(r===null||typeof r!="object")throw new u(y,"Object",r)}function e(r,y){if(typeof r!="string")throw new u(y,"string",r)}const n=i.$ec==="win32";function o(r){return r===f||r===g}function l(r){return r===f}function d(r){return r>=F&&r<=H||r>=B&&r<=S}function N(r,y,A,T){let M="",q=0,$=-1,I=0,V=0;for(let R=0;R<=r.length;++R){if(R<r.length)V=r.charCodeAt(R);else{if(T(V))break;V=f}if(T(V)){if(!($===R-1||I===1))if(I===2){if(M.length<2||q!==2||M.charCodeAt(M.length-1)!==k||M.charCodeAt(M.length-2)!==k){if(M.length>2){const x=M.lastIndexOf(A);x===-1?(M="",q=0):(M=M.slice(0,x),q=M.length-1-M.lastIndexOf(A)),$=R,I=0;continue}else if(M.length!==0){M="",q=0,$=R,I=0;continue}}y&&(M+=M.length>0?`${A}..`:"..",q=2)}else M.length>0?M+=`${A}${r.slice($+1,R)}`:M=r.slice($+1,R),q=R-$-1;$=R,I=0}else V===k&&I!==-1?++I:I=-1}return M}function b(r,y){c(y,"pathObject");const A=y.dir||y.root,T=y.base||`${y.name||""}${y.ext||""}`;return A?A===y.root?`${A}${T}`:`${A}${r}${T}`:T}t.$gc={resolve(...r){let y="",A="",T=!1;for(let M=r.length-1;M>=-1;M--){let q;if(M>=0){if(q=r[M],e(q,"path"),q.length===0)continue}else y.length===0?q=i.cwd():(q=i.env[`=${y}`]||i.cwd(),(q===void 0||q.slice(0,2).toLowerCase()!==y.toLowerCase()&&q.charCodeAt(2)===g)&&(q=`${y}\\`));const $=q.length;let I=0,V="",R=!1;const x=q.charCodeAt(0);if($===1)o(x)&&(I=1,R=!0);else if(o(x))if(R=!0,o(q.charCodeAt(1))){let O=2,X=O;for(;O<$&&!o(q.charCodeAt(O));)O++;if(O<$&&O!==X){const K=q.slice(X,O);for(X=O;O<$&&o(q.charCodeAt(O));)O++;if(O<$&&O!==X){for(X=O;O<$&&!o(q.charCodeAt(O));)O++;(O===$||O!==X)&&(V=`\\\\${K}\\${q.slice(X,O)}`,I=O)}}}else I=1;else d(x)&&q.charCodeAt(1)===w&&(V=q.slice(0,2),I=2,$>2&&o(q.charCodeAt(2))&&(R=!0,I=3));if(V.length>0)if(y.length>0){if(V.toLowerCase()!==y.toLowerCase())continue}else y=V;if(T){if(y.length>0)break}else if(A=`${q.slice(I)}\\${A}`,T=R,R&&y.length>0)break}return A=N(A,!T,"\\",o),T?`${y}\\${A}`:`${y}${A}`||"."},normalize(r){e(r,"path");const y=r.length;if(y===0)return".";let A=0,T,M=!1;const q=r.charCodeAt(0);if(y===1)return l(q)?"\\":r;if(o(q))if(M=!0,o(r.charCodeAt(1))){let I=2,V=I;for(;I<y&&!o(r.charCodeAt(I));)I++;if(I<y&&I!==V){const R=r.slice(V,I);for(V=I;I<y&&o(r.charCodeAt(I));)I++;if(I<y&&I!==V){for(V=I;I<y&&!o(r.charCodeAt(I));)I++;if(I===y)return`\\\\${R}\\${r.slice(V)}\\`;I!==V&&(T=`\\\\${R}\\${r.slice(V,I)}`,A=I)}}}else A=1;else d(q)&&r.charCodeAt(1)===w&&(T=r.slice(0,2),A=2,y>2&&o(r.charCodeAt(2))&&(M=!0,A=3));let $=A<y?N(r.slice(A),!M,"\\",o):"";return $.length===0&&!M&&($="."),$.length>0&&o(r.charCodeAt(y-1))&&($+="\\"),T===void 0?M?`\\${$}`:$:M?`${T}\\${$}`:`${T}${$}`},isAbsolute(r){e(r,"path");const y=r.length;if(y===0)return!1;const A=r.charCodeAt(0);return o(A)||y>2&&d(A)&&r.charCodeAt(1)===w&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let y,A;for(let q=0;q<r.length;++q){const $=r[q];e($,"path"),$.length>0&&(y===void 0?y=A=$:y+=`\\${$}`)}if(y===void 0)return".";let T=!0,M=0;if(typeof A=="string"&&o(A.charCodeAt(0))){++M;const q=A.length;q>1&&o(A.charCodeAt(1))&&(++M,q>2&&(o(A.charCodeAt(2))?++M:T=!1))}if(T){for(;M<y.length&&o(y.charCodeAt(M));)M++;M>=2&&(y=`\\${y.slice(M)}`)}return t.$gc.normalize(y)},relative(r,y){if(e(r,"from"),e(y,"to"),r===y)return"";const A=t.$gc.resolve(r),T=t.$gc.resolve(y);if(A===T||(r=A.toLowerCase(),y=T.toLowerCase(),r===y))return"";let M=0;for(;M<r.length&&r.charCodeAt(M)===g;)M++;let q=r.length;for(;q-1>M&&r.charCodeAt(q-1)===g;)q--;const $=q-M;let I=0;for(;I<y.length&&y.charCodeAt(I)===g;)I++;let V=y.length;for(;V-1>I&&y.charCodeAt(V-1)===g;)V--;const R=V-I,x=$<R?$:R;let O=-1,X=0;for(;X<x;X++){const ae=r.charCodeAt(M+X);if(ae!==y.charCodeAt(I+X))break;ae===g&&(O=X)}if(X!==x){if(O===-1)return T}else{if(R>x){if(y.charCodeAt(I+X)===g)return T.slice(I+X+1);if(X===2)return T.slice(I+X)}$>x&&(r.charCodeAt(M+X)===g?O=X:X===2&&(O=3)),O===-1&&(O=0)}let K="";for(X=M+O+1;X<=q;++X)(X===q||r.charCodeAt(X)===g)&&(K+=K.length===0?"..":"\\..");return I+=O,K.length>0?`${K}${T.slice(I,V)}`:(T.charCodeAt(I)===g&&++I,T.slice(I,V))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const y=t.$gc.resolve(r);if(y.length<=2)return r;if(y.charCodeAt(0)===g){if(y.charCodeAt(1)===g){const A=y.charCodeAt(2);if(A!==P&&A!==k)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(d(y.charCodeAt(0))&&y.charCodeAt(1)===w&&y.charCodeAt(2)===g)return`\\\\?\\${y}`;return r},dirname(r){e(r,"path");const y=r.length;if(y===0)return".";let A=-1,T=0;const M=r.charCodeAt(0);if(y===1)return o(M)?r:".";if(o(M)){if(A=T=1,o(r.charCodeAt(1))){let I=2,V=I;for(;I<y&&!o(r.charCodeAt(I));)I++;if(I<y&&I!==V){for(V=I;I<y&&o(r.charCodeAt(I));)I++;if(I<y&&I!==V){for(V=I;I<y&&!o(r.charCodeAt(I));)I++;if(I===y)return r;I!==V&&(A=T=I+1)}}}}else d(M)&&r.charCodeAt(1)===w&&(A=y>2&&o(r.charCodeAt(2))?3:2,T=A);let q=-1,$=!0;for(let I=y-1;I>=T;--I)if(o(r.charCodeAt(I))){if(!$){q=I;break}}else $=!1;if(q===-1){if(A===-1)return".";q=A}return r.slice(0,q)},basename(r,y){y!==void 0&&e(y,"ext"),e(r,"path");let A=0,T=-1,M=!0,q;if(r.length>=2&&d(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(A=2),y!==void 0&&y.length>0&&y.length<=r.length){if(y===r)return"";let $=y.length-1,I=-1;for(q=r.length-1;q>=A;--q){const V=r.charCodeAt(q);if(o(V)){if(!M){A=q+1;break}}else I===-1&&(M=!1,I=q+1),$>=0&&(V===y.charCodeAt($)?--$===-1&&(T=q):($=-1,T=I))}return A===T?T=I:T===-1&&(T=r.length),r.slice(A,T)}for(q=r.length-1;q>=A;--q)if(o(r.charCodeAt(q))){if(!M){A=q+1;break}}else T===-1&&(M=!1,T=q+1);return T===-1?"":r.slice(A,T)},extname(r){e(r,"path");let y=0,A=-1,T=0,M=-1,q=!0,$=0;r.length>=2&&r.charCodeAt(1)===w&&d(r.charCodeAt(0))&&(y=T=2);for(let I=r.length-1;I>=y;--I){const V=r.charCodeAt(I);if(o(V)){if(!q){T=I+1;break}continue}M===-1&&(q=!1,M=I+1),V===k?A===-1?A=I:$!==1&&($=1):A!==-1&&($=-1)}return A===-1||M===-1||$===0||$===1&&A===M-1&&A===T+1?"":r.slice(A,M)},format:b.bind(null,"\\"),parse(r){e(r,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return y;const A=r.length;let T=0,M=r.charCodeAt(0);if(A===1)return o(M)?(y.root=y.dir=r,y):(y.base=y.name=r,y);if(o(M)){if(T=1,o(r.charCodeAt(1))){let O=2,X=O;for(;O<A&&!o(r.charCodeAt(O));)O++;if(O<A&&O!==X){for(X=O;O<A&&o(r.charCodeAt(O));)O++;if(O<A&&O!==X){for(X=O;O<A&&!o(r.charCodeAt(O));)O++;O===A?T=O:O!==X&&(T=O+1)}}}}else if(d(M)&&r.charCodeAt(1)===w){if(A<=2)return y.root=y.dir=r,y;if(T=2,o(r.charCodeAt(2))){if(A===3)return y.root=y.dir=r,y;T=3}}T>0&&(y.root=r.slice(0,T));let q=-1,$=T,I=-1,V=!0,R=r.length-1,x=0;for(;R>=T;--R){if(M=r.charCodeAt(R),o(M)){if(!V){$=R+1;break}continue}I===-1&&(V=!1,I=R+1),M===k?q===-1?q=R:x!==1&&(x=1):q!==-1&&(x=-1)}return I!==-1&&(q===-1||x===0||x===1&&q===I-1&&q===$+1?y.base=y.name=r.slice($,I):(y.name=r.slice($,q),y.base=r.slice($,I),y.ext=r.slice(q,I))),$>0&&$!==T?y.dir=r.slice(0,$-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(n){const r=/\\/g;return()=>{const y=i.cwd().replace(r,"/");return y.slice(y.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let y="",A=!1;for(let T=r.length-1;T>=-1&&!A;T--){const M=T>=0?r[T]:m();e(M,"path"),M.length!==0&&(y=`${M}/${y}`,A=M.charCodeAt(0)===f)}return y=N(y,!A,"/",l),A?`/${y}`:y.length>0?y:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const y=r.charCodeAt(0)===f,A=r.charCodeAt(r.length-1)===f;return r=N(r,!y,"/",l),r.length===0?y?"/":A?"./":".":(A&&(r+="/"),y?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===f},join(...r){if(r.length===0)return".";let y;for(let A=0;A<r.length;++A){const T=r[A];e(T,"path"),T.length>0&&(y===void 0?y=T:y+=`/${T}`)}return y===void 0?".":t.$hc.normalize(y)},relative(r,y){if(e(r,"from"),e(y,"to"),r===y||(r=t.$hc.resolve(r),y=t.$hc.resolve(y),r===y))return"";const A=1,T=r.length,M=T-A,q=1,$=y.length-q,I=M<$?M:$;let V=-1,R=0;for(;R<I;R++){const O=r.charCodeAt(A+R);if(O!==y.charCodeAt(q+R))break;O===f&&(V=R)}if(R===I)if($>I){if(y.charCodeAt(q+R)===f)return y.slice(q+R+1);if(R===0)return y.slice(q+R)}else M>I&&(r.charCodeAt(A+R)===f?V=R:R===0&&(V=0));let x="";for(R=A+V+1;R<=T;++R)(R===T||r.charCodeAt(R)===f)&&(x+=x.length===0?"..":"/..");return`${x}${y.slice(q+V)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const y=r.charCodeAt(0)===f;let A=-1,T=!0;for(let M=r.length-1;M>=1;--M)if(r.charCodeAt(M)===f){if(!T){A=M;break}}else T=!1;return A===-1?y?"/":".":y&&A===1?"//":r.slice(0,A)},basename(r,y){y!==void 0&&e(y,"ext"),e(r,"path");let A=0,T=-1,M=!0,q;if(y!==void 0&&y.length>0&&y.length<=r.length){if(y===r)return"";let $=y.length-1,I=-1;for(q=r.length-1;q>=0;--q){const V=r.charCodeAt(q);if(V===f){if(!M){A=q+1;break}}else I===-1&&(M=!1,I=q+1),$>=0&&(V===y.charCodeAt($)?--$===-1&&(T=q):($=-1,T=I))}return A===T?T=I:T===-1&&(T=r.length),r.slice(A,T)}for(q=r.length-1;q>=0;--q)if(r.charCodeAt(q)===f){if(!M){A=q+1;break}}else T===-1&&(M=!1,T=q+1);return T===-1?"":r.slice(A,T)},extname(r){e(r,"path");let y=-1,A=0,T=-1,M=!0,q=0;for(let $=r.length-1;$>=0;--$){const I=r.charCodeAt($);if(I===f){if(!M){A=$+1;break}continue}T===-1&&(M=!1,T=$+1),I===k?y===-1?y=$:q!==1&&(q=1):y!==-1&&(q=-1)}return y===-1||T===-1||q===0||q===1&&y===T-1&&y===A+1?"":r.slice(y,T)},format:b.bind(null,"/"),parse(r){e(r,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return y;const A=r.charCodeAt(0)===f;let T;A?(y.root="/",T=1):T=0;let M=-1,q=0,$=-1,I=!0,V=r.length-1,R=0;for(;V>=T;--V){const x=r.charCodeAt(V);if(x===f){if(!I){q=V+1;break}continue}$===-1&&(I=!1,$=V+1),x===k?M===-1?M=V:R!==1&&(R=1):M!==-1&&(R=-1)}if($!==-1){const x=q===0&&A?1:q;M===-1||R===0||R===1&&M===$-1&&M===q+1?y.base=y.name=r.slice(x,$):(y.name=r.slice(x,M),y.base=r.slice(x,$),y.ext=r.slice(M,$))}return q>0?y.dir=r.slice(0,q-1):A&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(me[127],be([1,0,25,5,9,10]),function(se,t,i,F,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lg=S,t.$mg=k,t.$ng=f,t.$og=g,t.$pg=w,t.$qg=e,t.$rg=n,t.$sg=o,t.$tg=l,t.$ug=d,t.$vg=N,t.$wg=b,t.$xg=m,t.$yg=r,t.$zg=y,t.$Ag=A,t.$Bg=q;function S($){return $===47||$===92}function k($){return $.replace(/[\\/]/g,i.$hc.sep)}function f($){return $.indexOf("/")===-1&&($=k($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function g($,I=i.$hc.sep){if(!$)return"";const V=$.length,R=$.charCodeAt(0);if(S(R)){if(S($.charCodeAt(1))&&!S($.charCodeAt(2))){let O=3;const X=O;for(;O<V&&!S($.charCodeAt(O));O++);if(X!==O&&!S($.charCodeAt(O+1))){for(O+=1;O<V;O++)if(S($.charCodeAt(O)))return $.slice(0,O+1).replace(/[\\/]/g,I)}}return I}else if(l(R)&&$.charCodeAt(1)===58)return S($.charCodeAt(2))?$.slice(0,2)+I:$.slice(0,2);let x=$.indexOf("://");if(x!==-1){for(x+=3;x<V;x++)if(S($.charCodeAt(x)))return $.slice(0,x+1)}return""}function w($){if(!F.$i||!$||$.length<5)return!1;let I=$.charCodeAt(0);if(I!==92||(I=$.charCodeAt(1),I!==92))return!1;let V=2;const R=V;for(;V<$.length&&(I=$.charCodeAt(V),I!==92);V++);return!(R===V||(I=$.charCodeAt(V+1),isNaN(I)||I===92))}const P=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e($,I=F.$i){const V=I?P:u;return!(!$||$.length===0||/^\s+$/.test($)||(V.lastIndex=0,V.test($))||I&&c.test($)||$==="."||$===".."||I&&$[$.length-1]==="."||I&&$.length!==$.trim().length||$.length>255)}function n($,I,V){const R=$===I;return!V||R?R:!$||!I?!1:(0,B.$vf)($,I)}function o($,I,V,R=i.sep){if($===I)return!0;if(!$||!I||I.length>$.length)return!1;if(V){if(!(0,B.$wf)($,I))return!1;if(I.length===$.length)return!0;let O=I.length;return I.charAt(I.length-1)===R&&O--,$.charAt(O)===R}return I.charAt(I.length-1)!==R&&(I+=R),$.indexOf(I)===0}function l($){return $>=65&&$<=90||$>=97&&$<=122}function d($,I){return F.$i&&$.endsWith(":")&&($+=i.sep),(0,i.$jc)($)||($=(0,i.$kc)(I,$)),$=(0,i.$ic)($),N($)}function N($){return F.$i?($=(0,B.$df)($,i.sep),$.endsWith(":")&&($+=i.sep)):($=(0,B.$df)($,i.sep),$||($=i.sep)),$}function b($){const I=(0,i.$ic)($);return F.$i?$.length>3?!1:m(I)&&($.length===2||I.charCodeAt(2)===92):I===i.$hc.sep}function m($,I=F.$i){return I?l($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function r($,I=F.$i){return m($,I)?$[0]:void 0}function y($,I,V){return I.length>$.length?-1:$===I?0:(V&&($=$.toLowerCase(),I=I.toLowerCase()),$.indexOf(I))}function A($){const I=$.split(":");let V,R,x;for(const O of I){const X=Number(O);(0,H.$0f)(X)?R===void 0?R=X:x===void 0&&(x=X):V=V?[V,O].join(":"):O}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:R!==void 0?R:void 0,column:x!==void 0?x:R!==void 0?1:void 0}}const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function q($,I,V=8){let R="";for(let O=0;O<V;O++){let X;O===0&&F.$i&&!I&&(V===3||V===4)?X=M:X=T,R+=X.charAt(Math.floor(Math.random()*X.length))}let x;return I?x=`${I}-${R}`:x=R,$?(0,i.$kc)($,x):x}}),define(me[128],be([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=void 0,t.$Ns=H,t.$Os=S,t.$Ps=k,t.$Qs=g,t.$Ms=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(w){const P=(0,i.$pc)(w),u=F[P.toLowerCase()];return u!==void 0?u:S(w)}function S(w){const P=(0,i.$pc)(w);return B[P.toLowerCase()]}function k(w){for(const P in B)if(B[P]===w)return P}const f=/^(.+)\/(.+?)(;.+)?$/;function g(w,P){const u=f.exec(w);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:P?void 0:w}}),define(me[16],be([1,0,25,5]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=b;const B=/^\w[\w\d+.-]*$/,H=/^\//,S=/^\/\//;function k(T,M){if(!T.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!B.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!H.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(T,M){return!T&&!M?"file":T}function g(T,M){switch(T){case"https":case"http":case"file":M?M[0]!==P&&(M=P+M):M=P;break}return M}const w="",P="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(M){return M instanceof c?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,q,$,I,V,R=!1){typeof M=="object"?(this.scheme=M.scheme||w,this.authority=M.authority||w,this.path=M.path||w,this.query=M.query||w,this.fragment=M.fragment||w):(this.scheme=f(M,R),this.authority=q||w,this.path=g(this.scheme,$||w),this.query=I||w,this.fragment=V||w,k(this,R))}get fsPath(){return b(this,!1)}with(M){if(!M)return this;let{scheme:q,authority:$,path:I,query:V,fragment:R}=M;return q===void 0?q=this.scheme:q===null&&(q=w),$===void 0?$=this.authority:$===null&&($=w),I===void 0?I=this.path:I===null&&(I=w),V===void 0?V=this.query:V===null&&(V=w),R===void 0?R=this.fragment:R===null&&(R=w),q===this.scheme&&$===this.authority&&I===this.path&&V===this.query&&R===this.fragment?this:new o(q,$,I,V,R)}static parse(M,q=!1){const $=u.exec(M);return $?new o($[2]||w,A($[4]||w),A($[5]||w),A($[7]||w),A($[9]||w),q):new o(w,w,w,w,w)}static file(M){let q=w;if(F.$i&&(M=M.replace(/\\/g,P)),M[0]===P&&M[1]===P){const $=M.indexOf(P,2);$===-1?(q=M.substring(2),M=P):(q=M.substring(2,$),M=M.substring($)||P)}return new o("file",q,M,w,w)}static from(M,q){return new o(M.scheme,M.authority,M.path,M.query,M.fragment,q)}static joinPath(M,...q){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return F.$i&&M.scheme==="file"?$=c.file(i.$gc.join(b(M,!0),...q)).path:$=i.$hc.join(M.path,...q),M.with({path:$})}toString(M=!1){return m(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof c)return M;{const q=new o(M);return q._formatted=M.external??null,q._fsPath=M._sep===n?M.fsPath??null:null,q}}else return M}}t.URI=c;function e(T){return!T||typeof T!="object"?!1:typeof T.scheme=="string"&&(typeof T.authority=="string"||typeof T.authority>"u")&&(typeof T.path=="string"||typeof T.path>"u")&&(typeof T.query=="string"||typeof T.query>"u")&&(typeof T.fragment=="string"||typeof T.fragment>"u")}const n=F.$i?1:void 0;class o extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(M=!1){return M?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const M={$mid:1};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=n),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(T,M,q){let $,I=-1;for(let V=0;V<T.length;V++){const R=T.charCodeAt(V);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||M&&R===47||q&&R===91||q&&R===93||q&&R===58)I!==-1&&($+=encodeURIComponent(T.substring(I,V)),I=-1),$!==void 0&&($+=T.charAt(V));else{$===void 0&&($=T.substr(0,V));const x=l[R];x!==void 0?(I!==-1&&($+=encodeURIComponent(T.substring(I,V)),I=-1),$+=x):I===-1&&(I=V)}}return I!==-1&&($+=encodeURIComponent(T.substring(I))),$!==void 0?$:T}function N(T){let M;for(let q=0;q<T.length;q++){const $=T.charCodeAt(q);$===35||$===63?(M===void 0&&(M=T.substr(0,q)),M+=l[$]):M!==void 0&&(M+=T[q])}return M!==void 0?M:T}function b(T,M){let q;return T.authority&&T.path.length>1&&T.scheme==="file"?q=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?M?q=T.path.substr(1):q=T.path[1].toLowerCase()+T.path.substr(2):q=T.path,F.$i&&(q=q.replace(/\//g,"\\")),q}function m(T,M){const q=M?N:d;let $="",{scheme:I,authority:V,path:R,query:x,fragment:O}=T;if(I&&($+=I,$+=":"),(V||I==="file")&&($+=P,$+=P),V){let X=V.indexOf("@");if(X!==-1){const K=V.substr(0,X);V=V.substr(X+1),X=K.lastIndexOf(":"),X===-1?$+=q(K,!1,!1):($+=q(K.substr(0,X),!1,!1),$+=":",$+=q(K.substr(X+1),!1,!0)),$+="@"}V=V.toLowerCase(),X=V.lastIndexOf(":"),X===-1?$+=q(V,!1,!0):($+=q(V.substr(0,X),!1,!0),$+=V.substr(X))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const X=R.charCodeAt(1);X>=65&&X<=90&&(R=`/${String.fromCharCode(X+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const X=R.charCodeAt(0);X>=65&&X<=90&&(R=`${String.fromCharCode(X+32)}:${R.substr(2)}`)}$+=q(R,!0,!1)}return x&&($+="?",$+=q(x,!1,!1)),O&&($+="#",$+=M?O:d(O,!1,!1)),$}function r(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+r(T.substr(3)):T}}const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(T){return T.match(y)?T.replace(y,M=>r(M)):T}}),define(me[64],be([1,0,43,16]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1h=B,t.$2h=H,t.$3h=k;function B(f){return JSON.stringify(f,S)}function H(f){let g=JSON.parse(f);return g=k(g),g}function S(f,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function k(f,g=0){if(!f||g>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return F.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof i.$De||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let w=0;w<f.length;++w)f[w]=k(f[w],g+1);else for(const w in f)Object.hasOwnProperty.call(f,w)&&(f[w]=k(f[w],g+1))}return f}}),define(me[36],be([1,0,6,5,9,16,25]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Gg=t.$Fg=t.$Eg=t.Schemas=void 0,t.$Cg=f,t.$Dg=g,t.$Hg=P;var k;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(k||(t.Schemas=k={}));function f(e,n){return H.URI.isUri(e)?(0,B.$vf)(e.scheme,n):(0,B.$wf)(e,n+":")}function g(e,...n){return n.some(o=>f(e,o))}t.$Eg="vscode-tkn",t.$Fg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=P(n,o)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,k.vscodeRemoteResource)}set(n,o,l){this.a[n]=o,this.b[n]=l}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(m){return i.$1(m),n}const o=n.authority;let l=this.a[o];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const d=this.b[o],N=this.c[o];let b=`path=${encodeURIComponent(n.path)}`;return typeof N=="string"&&(b+=`&${t.$Fg}=${encodeURIComponent(N)}`),H.URI.from({scheme:F.$o?this.d:k.vscodeRemoteResource,authority:`${l}:${d}`,path:this.g,query:b})}}t.$Gg=new w;function P(e,n){return S.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Ig="vs/../../extensions",t.$Jg="vs/../../node_modules",t.$Kg="vs/../../node_modules.asar",t.$Lg="vs/../../node_modules.asar.unpacked",t.$Mg="vscode-app";class u{static{this.a=t.$Mg}asBrowserUri(n){const o=this.b(n,se);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===k.vscodeRemote?t.$Gg.rewrite(n):n.scheme===k.file&&(F.$m||F.$q===`${k.vscodeFileResource}://${u.a}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,se);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return H.URI.isUri(n)?n:H.URI.parse(o.toUrl(n))}}t.$Ng=new u;var c;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function l(N){let b;typeof N=="string"?b=new URL(N).searchParams:N instanceof URL?b=N.searchParams:H.URI.isUri(N)&&(b=new URL(N.toString(!0)).searchParams);const m=b?.get(o);if(m)return n.get(m)}e.getHeadersFromQuery=l;function d(N,b,m){if(!globalThis.crossOriginIsolated)return;const r=b&&m?"3":m?"2":"1";N instanceof URLSearchParams?N.set(o,r):N[o]=r}e.addSearchParam=d})(c||(t.COI=c={}))}),define(me[47],be([1,0,127,36,25,5,9,16]),function(se,t,i,F,B,H,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=void 0,t.$Ug=f,t.$dh=w,t.$eh=u;function f(c){return(0,k.$xc)(c,!0)}class g{constructor(e){this.a=e}compare(e,n,o=!1){return e===n?0:(0,S.$of)(this.getComparisonKey(e,o),this.getComparisonKey(n,o))}isEqual(e,n,o=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,o)===this.getComparisonKey(n,o)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,o=!1){if(e.scheme===n.scheme){if(e.scheme===F.Schemas.file)return i.$sg(f(e),f(n),this.a(e))&&e.query===n.query&&(o||e.fragment===n.fragment);if((0,t.$_g)(e.authority,n.authority))return i.$sg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(o||e.fragment===n.fragment)}return!1}joinPath(e,...n){return k.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$4g)(e)||e.authority}basename(e){return B.$hc.basename(e.path)}extname(e){return B.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===F.Schemas.file?n=k.URI.file(B.$nc(f(e))).path:(n=B.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===F.Schemas.file?n=k.URI.file(B.$ic(f(e))).path:n=B.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$_g)(e.authority,n.authority))return;if(e.scheme===F.Schemas.file){const d=B.$mc(f(e),f(n));return H.$i?i.$mg(d):d}let o=e.path||"/";const l=n.path||"/";if(this.a(e)){let d=0;for(const N=Math.min(o.length,l.length);d<N&&!(o.charCodeAt(d)!==l.charCodeAt(d)&&o.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);o=l.substr(0,d)+o.substr(d)}return B.$hc.relative(o,l)}resolvePath(e,n){if(e.scheme===F.Schemas.file){const o=k.URI.file(B.$lc(f(e),n));return e.with({authority:o.authority,path:o.path})}return n=i.$ng(n),e.with({path:B.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,S.$vf)(e,n)}hasTrailingPathSeparator(e,n=B.sep){if(e.scheme===F.Schemas.file){const o=f(e);return o.length>i.$og(o).length&&o[o.length-1]===n}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=B.sep){return(0,t.$ah)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=B.sep){let o=!1;if(e.scheme===F.Schemas.file){const l=f(e);o=l!==void 0&&l.length===i.$og(l).length&&l[l.length-1]===n}else{n="/";const l=e.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,t.$ah)(e,n)?e.with({path:e.path+"/"}):e}}t.$Vg=g,t.$Wg=new g(()=>!1),t.$Xg=new g(c=>c.scheme===F.Schemas.file?!H.$k:!0),t.$Yg=new g(c=>!0),t.$Zg=t.$Wg.isEqual.bind(t.$Wg),t.$1g=t.$Wg.isEqualOrParent.bind(t.$Wg),t.$2g=t.$Wg.getComparisonKey.bind(t.$Wg),t.$3g=t.$Wg.basenameOrAuthority.bind(t.$Wg),t.$4g=t.$Wg.basename.bind(t.$Wg),t.$5g=t.$Wg.extname.bind(t.$Wg),t.$6g=t.$Wg.dirname.bind(t.$Wg),t.$7g=t.$Wg.joinPath.bind(t.$Wg),t.$8g=t.$Wg.normalizePath.bind(t.$Wg),t.$9g=t.$Wg.relativePath.bind(t.$Wg),t.$0g=t.$Wg.resolvePath.bind(t.$Wg),t.$$g=t.$Wg.isAbsolutePath.bind(t.$Wg),t.$_g=t.$Wg.isEqualAuthority.bind(t.$Wg),t.$ah=t.$Wg.hasTrailingPathSeparator.bind(t.$Wg),t.$bh=t.$Wg.removeTrailingPathSeparator.bind(t.$Wg),t.$ch=t.$Wg.addTrailingPathSeparator.bind(t.$Wg);function w(c,e){const n=[];for(let o=0;o<c.length;o++){const l=e(c[o]);c.some((d,N)=>N===o?!1:(0,t.$1g)(l,e(d)))||n.push(c[o])}return n}var P;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function e(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(N=>{const[b,m]=N.split(":");b&&m&&o.set(b,m)});const d=n.path.substring(0,n.path.indexOf(";"));return d&&o.set(c.META_DATA_MIME,d),o}c.parseMetaData=e})(P||(t.DataUri=P={}));function u(c,e,n){if(e){let o=c.path;return o&&o[0]!==B.$hc.sep&&(o=B.$hc.sep+o),c.with({scheme:n,authority:e,path:o})}return c.with({scheme:n})}}),define(me[11],be([1,0,34,6,3,2,47,5,60,23]),function(se,t,i,F,B,H,S,k,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.Promises=t.$Qh=t.$Ph=t.$Oh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=void 0,t.$fh=w,t.$gh=P,t.$hh=u,t.$ih=c,t.$jh=e,t.$kh=n,t.$lh=o,t.$mh=l,t.$uh=q,t.$vh=$,t.$wh=I,t.$xh=V,t.$yh=R,t.$Nh=_,t.$Vh=z;function w(D){return!!D&&typeof D.then=="function"}function P(D){const a=new i.$ne,v=D(a.token),C=new Promise((s,E)=>{const p=a.token.onCancellationRequested(()=>{p.dispose(),E(new F.$5)});Promise.resolve(v).then(L=>{p.dispose(),a.dispose(),s(L)},L=>{p.dispose(),a.dispose(),E(L)})});return new class{cancel(){a.cancel(),a.dispose()}then(s,E){return C.then(s,E)}catch(s){return this.then(void 0,s)}finally(s){return C.finally(s)}}}function u(D,a,v){return new Promise((C,s)=>{const E=a.onCancellationRequested(()=>{E.dispose(),C(v)});D.then(C,s).finally(()=>E.dispose())})}function c(D,a){return new Promise((v,C)=>{const s=a.onCancellationRequested(()=>{s.dispose(),C(new F.$5)});D.then(v,C).finally(()=>s.dispose())})}async function e(D){let a=-1;const v=D.map((C,s)=>C.then(E=>(a=s,E)));try{return await Promise.race(v)}finally{D.forEach((C,s)=>{s!==a&&C.cancel()})}}function n(D,a,v){let C;const s=setTimeout(()=>{C?.(void 0),v?.()},a);return Promise.race([D.finally(()=>clearTimeout(s)),new Promise(E=>C=E)])}function o(D){return new Promise((a,v)=>{const C=D();w(C)?C.then(a,v):a(C)})}function l(){let D,a;return{promise:new Promise((C,s)=>{D=C,a=s}),resolve:D,reject:a}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const v=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(v,v).then(C)})}return new Promise((v,C)=>{this.b.then(v,C)})}return this.a=a(),new Promise((v,C)=>{this.a.then(s=>{this.a=null,v(s)},s=>{this.a=null,C(s)})})}dispose(){this.f=!0}}t.$nh=d;class N{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$oh=N;class b{constructor(){this.a=new Map}queue(a,v){const s=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(a)===s&&this.a.delete(a)});return this.a.set(a,s),s}}t.$ph=b;const m=(D,a)=>{let v=!0;const C=setTimeout(()=>{v=!1,a()},D);return{isTriggered:()=>v,dispose:()=>{clearTimeout(C),v=!1}}},r=D=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,D())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class y{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,v=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((s,E)=>{this.d=s,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=v===f.$_d?r(C):m(v,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$qh=y;class A{constructor(a){this.a=new y(a),this.b=new d}trigger(a,v){return this.a.trigger(()=>this.b.queue(a),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$rh=A;class T{constructor(){this.a=!1,this.b=new Promise((a,v)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$sh=T;class M extends T{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$th=M;function q(D,a){return a?new Promise((v,C)=>{const s=setTimeout(()=>{E.dispose(),v()},D),E=a.onCancellationRequested(()=>{clearTimeout(s),E.dispose(),C(new F.$5)})}):P(v=>q(D,v))}function $(D,a=0,v){const C=setTimeout(()=>{D(),v&&s.dispose()},a),s=(0,H.$Tc)(()=>{clearTimeout(C),v?.deleteAndLeak(s)});return v?.add(s),s}function I(D){const a=[];let v=0;const C=D.length;function s(){return v<C?D[v++]():null}function E(p){p!=null&&a.push(p);const L=s();return L?L.then(E):Promise.resolve(a)}return Promise.resolve(null).then(E)}function V(D,a=C=>!!C,v=null){let C=0;const s=D.length,E=()=>{if(C>=s)return Promise.resolve(v);const p=D[C++];return Promise.resolve(p()).then(j=>a(j)?Promise.resolve(j):E())};return E()}function R(D,a=C=>!!C,v=null){if(D.length===0)return Promise.resolve(v);let C=D.length;const s=()=>{C=-1;for(const E of D)E.cancel?.()};return new Promise((E,p)=>{for(const L of D)L.then(j=>{--C>=0&&a(j)?(s(),E(j)):C===0&&E(v)}).catch(j=>{--C>=0&&(s(),p(j))})})}class x{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new B.$ce}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,C)=>{this.g.push({factory:a,c:v,e:C}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const v=a.factory();v.then(a.c,a.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$zh=x;class O extends x{constructor(){super(1)}}t.$Ah=O;class X{constructor(){this.a=new ue,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$Bh=X;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new W;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,v=S.$Wg){const C=v.getComparisonKey(a);return this.a.get(C)?.size??0}queueFor(a,v,C=S.$Wg){const s=C.getComparisonKey(a);let E=this.a.get(s);if(!E){E=new O;const p=this.f++,L=B.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(p),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$5c),this.d.set(p,L),this.a.set(s,E)}return E.queue(v)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Ch=K;class ae{constructor(a,v){this.a=-1,typeof a=="function"&&typeof v=="number"&&this.setIfNotSet(a,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},v)}setIfNotSet(a,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},v))}}t.$Dh=ae;class ie{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,v,C=globalThis){this.cancel();const s=C.setInterval(()=>{a()},v);this.d=(0,H.$Tc)(()=>{C.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Eh=ie;class ee{constructor(a,v){this.b=-1,this.a=a,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Fh=ee;class ce{constructor(a,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=a,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Gh=ce;class ye extends ee{constructor(a,v){super(a,v),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$Hh=ye;class Ee extends H.$Vc{constructor(a,v){super(),this.g=a,this.h=v,this.a=[],this.b=this.B(new H.$Wc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of a)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Ih=Ee,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Kh=(D,a)=>{(0,k.$B)(()=>{if(v)return;const C=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:t.$Kh=(D,a,v)=>{const C=D.requestIdleCallback(a,typeof v=="number"?{timeout:v}:void 0);let s=!1;return{dispose(){s||(s=!0,D.cancelIdleCallback(C))}}},t.$Jh=D=>(0,t.$Kh)(globalThis,D)}();class Me{constructor(a,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(C){this.l=C}finally{this.g=!0}},this.f=(0,t.$Kh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Lh=Me;class le extends Me{constructor(a){super(globalThis,a)}}t.$Mh=le;async function _(D,a,v){let C;for(let s=0;s<v;s++)try{return await D()}catch(E){C=E,await q(a)}throw C}class ue{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,v,C){return this.a={taskId:a,cancel:()=>C?.(),promise:v},v.then(()=>this.d(a),()=>this.d(a)),v}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:v,resolve:C,reject:s}=l();this.b={run:a,promise:v,promiseResolve:C,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Oh=ue;class re{constructor(a,v=()=>Date.now()){this.d=a,this.f=v,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Ph=re;var De;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(De||(De={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,v)=>{this.a=a,this.b=v})}complete(a){return new Promise(v=>{this.a(a),this.d={outcome:0,value:a},v()})}error(a){return new Promise(v=>{this.b(a),this.d={outcome:1,value:a},v()})}cancel(){return this.error(new F.$5)}}t.$Qh=W;var Q;(function(D){async function a(C){let s;const E=await Promise.all(C.map(p=>p.then(L=>L,L=>{s||(s=L)})));if(typeof s<"u")throw s;return E}D.settled=a;function v(C){return new Promise(async(s,E)=>{try{await C(s,E)}catch(p){E(p)}})}D.withAsyncBody=v})(Q||(t.Promises=Q={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Rh=ge;class we{constructor(a){this.b=a,this.a=new g.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Sh=we;var Ae;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(Ae||(Ae={}));class Te{static fromArray(a){return new Te(v=>{v.emitMany(a)})}static fromPromise(a){return new Te(async v=>{v.emitMany(await a)})}static fromPromises(a){return new Te(async v=>{await Promise.all(a.map(async C=>v.emitOne(await C)))})}static merge(a){return new Te(async v=>{await Promise.all(a.map(async C=>{for await(const s of C)v.emitOne(s)}))})}static{this.EMPTY=Te.fromArray([])}constructor(a,v){this.a=0,this.b=[],this.d=null,this.f=v,this.g=new B.$ce,queueMicrotask(async()=>{const C={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(a(C)),this.k()}catch(s){this.l(s)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(a,v){return new Te(async C=>{for await(const s of a)C.emitOne(v(s))})}map(a){return Te.map(this,a)}static filter(a,v){return new Te(async C=>{for await(const s of a)v(s)&&C.emitOne(s)})}filter(a){return Te.filter(this,a)}static coalesce(a){return Te.filter(a,v=>!!v)}coalesce(){return Te.coalesce(this)}static async toPromise(a){const v=[];for await(const C of a)v.push(C);return v}toPromise(){return Te.toPromise(this)}h(a){this.a===0&&(this.b.push(a),this.g.fire())}j(a){this.a===0&&(this.b=this.b.concat(a),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(a){this.a===0&&(this.a=2,this.d=a,this.g.fire())}}t.$Th=Te;class Ie extends Te{constructor(a,v){super(v),this.m=a}cancel(){this.m.cancel()}}t.$Uh=Ie;function z(D){const a=new i.$ne,v=D(a.token);return new Ie(a,async C=>{const s=a.token.onCancellationRequested(()=>{s.dispose(),a.dispose(),C.reject(new F.$5)});try{for await(const E of v){if(a.token.isCancellationRequested)return;C.emitOne(E)}s.dispose(),a.dispose()}catch(E){s.dispose(),a.dispose(),C.reject(E)}})}class h{constructor(a){this.a=new W,this.b=new Te(s=>{if(v){s.reject(v);return}return C&&s.emitMany(C),this.d=E=>s.reject(E),this.f=E=>s.emitOne(E),this.a.p},a);let v,C;this.f=s=>{C||(C=[]),C.push(s)},this.d=s=>{v||(v=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$Wh=h}),define(me[4],be([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=t.$$S=t.$8S=t.DetectedFullscreenMode=t.Namespace=t.$FS=t.$DS=t.$uS=t.$3R=t.$WR=t.$UR=t.$TR=t.$SR=t.$NR=t.$MR=t.$LR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$JR=l,t.$KR=N,t.$OR=T,t.$PR=M,t.$QR=q,t.$RR=$,t.$VR=V,t.$XR=O,t.$YR=X,t.$ZR=ee,t.$1R=ce,t.$2R=ye,t.$4R=le,t.$5R=_,t.$6R=ue,t.$7R=re,t.$8R=De,t.$9R=W,t.$0R=Q,t.$$R=ge,t.$_R=we,t.$aS=Ae,t.$bS=Ie,t.$cS=z,t.$dS=D,t.$eS=v,t.$fS=C,t.$gS=s,t.$hS=E,t.$iS=p,t.$jS=L,t.$kS=j,t.$lS=Y,t.$mS=J,t.$nS=oe,t.$oS=pe,t.$pS=fe,t.$qS=ke,t.$rS=Oe,t.$sS=Fe,t.$tS=We,t.$vS=Ye,t.$wS=_e,t.$xS=Re,t.$yS=ze,t.$zS=et,t.$AS=it,t.$BS=st,t.$CS=Qe,t.$ES=rt,t.$GS=tt,t.$HS=mt,t.$IS=St,t.$JS=At,t.$KS=kt,t.$LS=Be,t.$MS=he,t.$=nt,t.$OS=lt,t.$PS=Ze,t.$QS=ut,t.$RS=$t,t.$SS=Ut,t.$TS=Ni,t.$US=Si,t.$VS=Ai,t.$WS=ki,t.$XS=Ti,t.$YS=Fi,t.$ZS=Ci,t.$1S=Ri,t.$2S=Li,t.$3S=Qt,t.$4S=Mi,t.$5S=Ii,t.$6S=ji,t.$7S=_t,t.$9S=Bi,t.$0S=zi,t.$_S=Hi,t.h=qi,t.$cT=ti,t.$dT=Gi,o=function(){const G=new Map;(0,n.$dR)(n.$eR,1);const U={window:n.$eR,disposables:new w.$Uc};G.set(n.$eR.vscodeWindowId,U);const te=new f.$ce,de=new f.$ce,Se=new f.$ce;function xe(Pe,qe){return(typeof Pe=="number"?G.get(Pe):void 0)??(qe?U:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:de.event,registerWindow(Pe){if(G.has(Pe.vscodeWindowId))return w.$Vc.None;const qe=new w.$Uc,Ke={window:Pe,disposables:qe.add(new w.$Uc)};return G.set(Pe.vscodeWindowId,Ke),qe.add((0,w.$Tc)(()=>{G.delete(Pe.vscodeWindowId),de.fire(Pe)})),qe.add(N(Pe,t.$DS.BEFORE_UNLOAD,()=>{Se.fire(Pe)})),te.fire(Ke),qe},getWindows(){return G.values()},getWindowsCount(){return G.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return G.has(Pe)},getWindowById:xe,getWindow(Pe){const qe=Pe;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Pe;return Ke?.view?Ke.view.window:n.$eR},getDocument(Pe){const qe=Pe;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function l(G){for(;G.firstChild;)G.firstChild.remove()}class d{constructor(U,te,de,Se){this.f=U,this.g=te,this.d=de,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function N(G,U,te,de){return new d(G,U,te,de)}function b(G,U){return function(te){return U(new H.$CR(G,te))}}function m(G){return function(U){return G(new B.$HR(U))}}const r=function(U,te,de,Se){let xe=de;return te==="click"||te==="mousedown"?xe=b((0,t.getWindow)(U),de):(te==="keydown"||te==="keypress"||te==="keyup")&&(xe=m(de)),N(U,te,xe,Se)};t.$LR=r;const y=function(U,te,de){const Se=b((0,t.getWindow)(U),te);return T(U,Se,de)};t.$MR=y;const A=function(U,te,de){const Se=b((0,t.getWindow)(U),te);return q(U,Se,de)};t.$NR=A;function T(G,U,te){return N(G,u.$r&&F.$zR.pointerEvents?t.$DS.POINTER_DOWN:t.$DS.MOUSE_DOWN,U,te)}function M(G,U,te){return N(G,u.$r&&F.$zR.pointerEvents?t.$DS.POINTER_MOVE:t.$DS.MOUSE_MOVE,U,te)}function q(G,U,te){return N(G,u.$r&&F.$zR.pointerEvents?t.$DS.POINTER_UP:t.$DS.MOUSE_UP,U,te)}function $(G,U,te){return(0,S.$Kh)(G,U,te)}class I extends S.$Lh{constructor(U,te){super(U,te)}}t.$SR=I;function V(G,U,te,de){let Se=0;const xe=G.setInterval(()=>{Se++,(typeof de=="number"&&Se>=de||U()===!0)&&Pe.dispose()},te),Pe=(0,w.$Tc)(()=>{G.clearInterval(xe)});return Pe}class R extends S.$Eh{constructor(U){super(),this.f=U&&(0,t.getWindow)(U)}cancelAndSet(U,te,de){return super.cancelAndSet(U,te,de??this.f)}}t.$WR=R;class x{constructor(U,te=0){this.d=U,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(U){(0,k.$1)(U)}}static sort(U,te){return te.priority-U.priority}}(function(){const G=new Map,U=new Map,te=new Map,de=new Map,Se=xe=>{te.set(xe,!1);const Pe=G.get(xe)??[];for(U.set(xe,Pe),G.set(xe,[]),de.set(xe,!0);Pe.length>0;)Pe.sort(x.sort),Pe.shift().execute();de.set(xe,!1)};t.$UR=(xe,Pe,qe=0)=>{const Ke=(0,t.getWindowId)(xe),Xe=new x(Pe,qe);let at=G.get(Ke);return at||(at=[],G.set(Ke,at)),at.push(Xe),te.get(Ke)||(te.set(Ke,!0),xe.requestAnimationFrame(()=>Se(Ke))),Xe},t.$TR=(xe,Pe,qe)=>{const Ke=(0,t.getWindowId)(xe);if(de.get(Ke)){const Xe=new x(Pe,qe);let at=U.get(Ke);return at||(at=[],U.set(Ke,at)),at.push(Xe),Xe}else return(0,t.$UR)(xe,Pe,qe)}})();function O(G,U){return(0,t.$UR)(G,U,1e4)}function X(G,U){return(0,t.$UR)(G,U,-1e4)}const K=8,ae=function(G,U){return U};class ie extends w.$Vc{constructor(U,te,de,Se=ae,xe=K){super();let Pe=null,qe=0;const Ke=this.B(new S.$Dh),Xe=()=>{qe=new Date().getTime(),de(Pe),Pe=null};this.B(N(U,te,at=>{Pe=Se(Pe,at);const Ft=new Date().getTime()-qe;Ft>=xe?(Ke.cancel(),Xe()):Ke.setIfNotSet(Xe,xe-Ft)}))}}function ee(G,U,te,de,Se){return new ie(G,U,te,de,Se)}function ce(G){return(0,t.getWindow)(G).getComputedStyle(G,null)}function ye(G,U){const te=(0,t.getWindow)(G),de=te.document;if(G!==de.body)return new Me(G.clientWidth,G.clientHeight);if(u.$r&&te?.visualViewport)return new Me(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Me(te.innerWidth,te.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Me(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Me(de.documentElement.clientWidth,de.documentElement.clientHeight);if(U)return ye(U);throw new Error("Unable to figure out browser width and height")}class Ee{static d(U,te){return parseFloat(te)||0}static f(U,te,de){const Se=ce(U),xe=Se?Se.getPropertyValue(te):"0";return Ee.d(U,xe)}static getBorderLeftWidth(U){return Ee.f(U,"border-left-width","borderLeftWidth")}static getBorderRightWidth(U){return Ee.f(U,"border-right-width","borderRightWidth")}static getBorderTopWidth(U){return Ee.f(U,"border-top-width","borderTopWidth")}static getBorderBottomWidth(U){return Ee.f(U,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(U){return Ee.f(U,"padding-left","paddingLeft")}static getPaddingRight(U){return Ee.f(U,"padding-right","paddingRight")}static getPaddingTop(U){return Ee.f(U,"padding-top","paddingTop")}static getPaddingBottom(U){return Ee.f(U,"padding-bottom","paddingBottom")}static getMarginLeft(U){return Ee.f(U,"margin-left","marginLeft")}static getMarginTop(U){return Ee.f(U,"margin-top","marginTop")}static getMarginRight(U){return Ee.f(U,"margin-right","marginRight")}static getMarginBottom(U){return Ee.f(U,"margin-bottom","marginBottom")}}class Me{static{this.None=new Me(0,0)}constructor(U,te){this.width=U,this.height=te}with(U=this.width,te=this.height){return U!==this.width||te!==this.height?new Me(U,te):this}static is(U){return typeof U=="object"&&typeof U.height=="number"&&typeof U.width=="number"}static lift(U){return U instanceof Me?U:new Me(U.width,U.height)}static equals(U,te){return U===te?!0:!U||!te?!1:U.width===te.width&&U.height===te.height}}t.$3R=Me;function le(G){let U=G.offsetParent,te=G.offsetTop,de=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==G.ownerDocument.body&&G!==G.ownerDocument.documentElement;){te-=G.scrollTop;const Se=E(G)?null:ce(G);Se&&(de-=Se.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===U&&(de+=Ee.getBorderLeftWidth(G),te+=Ee.getBorderTopWidth(G),te+=G.offsetTop,de+=G.offsetLeft,U=G.offsetParent)}return{left:de,top:te}}function _(G,U,te){typeof U=="number"&&(G.style.width=`${U}px`),typeof te=="number"&&(G.style.height=`${te}px`)}function ue(G,U,te,de,Se,xe="absolute"){typeof U=="number"&&(G.style.top=`${U}px`),typeof te=="number"&&(G.style.right=`${te}px`),typeof de=="number"&&(G.style.bottom=`${de}px`),typeof Se=="number"&&(G.style.left=`${Se}px`),G.style.position=xe}function re(G){const U=G.getBoundingClientRect(),te=(0,t.getWindow)(G);return{left:U.left+te.scrollX,top:U.top+te.scrollY,width:U.width,height:U.height}}function De(G){let U=G,te=1;do{const de=ce(U).zoom;de!=null&&de!=="1"&&(te*=de),U=U.parentElement}while(U!==null&&U!==U.ownerDocument.documentElement);return te}function W(G){const U=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.offsetWidth+U}function Q(G){const U=Ee.getBorderLeftWidth(G)+Ee.getBorderRightWidth(G),te=Ee.getPaddingLeft(G)+Ee.getPaddingRight(G);return G.offsetWidth-U-te}function ge(G){const U=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.scrollWidth+U}function we(G){const U=Ee.getBorderTopWidth(G)+Ee.getBorderBottomWidth(G),te=Ee.getPaddingTop(G)+Ee.getPaddingBottom(G);return G.offsetHeight-U-te}function Ae(G){const U=Ee.getMarginTop(G)+Ee.getMarginBottom(G);return G.offsetHeight+U}function Te(G,U){if(G===null)return 0;const te=le(G),de=le(U);return te.left-de.left}function Ie(G,U){const te=U.map(Se=>Math.max(ge(Se),W(Se))+Te(Se,G)||0);return Math.max(...te)}function z(G,U){return!!U?.contains(G)}const h="parentFlowToElementId";function D(G,U){G.dataset[h]=U.id}function a(G){const U=G.dataset[h];return typeof U=="string"?G.ownerDocument.getElementById(U):null}function v(G,U){let te=G;for(;te;){if(te===U)return!0;if(te instanceof HTMLElement){const de=a(te);if(de){te=de;continue}}te=te.parentNode}return!1}function C(G,U,te){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(U))return G;if(te){if(typeof te=="string"){if(G.classList.contains(te))return null}else if(G===te)return null}G=G.parentNode}return null}function s(G,U,te){return!!C(G,U,te)}function E(G){return G&&!!G.host&&!!G.mode}function p(G){return!!L(G)}function L(G){for(;G.parentNode;){if(G===G.ownerDocument?.body)return null;G=G.parentNode}return E(G)?G:null}function j(){let G=pe().activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}function Y(G){return j()===G}function J(G){return z(j(),G)}function oe(G){return G.ownerDocument===pe()}function pe(){return(0,t.getWindowsCount)()<=1?n.$eR.document:Array.from((0,t.getWindows)()).map(({window:U})=>U.document).find(U=>U.hasFocus())??n.$eR.document}function fe(){return pe().defaultView?.window??n.$eR}const Le=new Map;function ke(G){return Le.has(G)}function Oe(){return new Ne}class Ne{constructor(){this.d="",this.f=void 0}setStyle(U){U!==this.d&&(this.d=U,this.f?this.f.innerText=U:this.f=Fe(n.$eR.document.head,te=>te.innerText=U))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Fe(G=n.$eR.document.head,U,te){const de=document.createElement("style");if(de.type="text/css",de.media="screen",U?.(de),G.appendChild(de),te&&te.add((0,w.$Tc)(()=>G.removeChild(de))),G===n.$eR.document.head){const Se=new Set;Le.set(de,Se);for(const{window:xe,disposables:Pe}of(0,t.getWindows)()){if(xe===n.$eR)continue;const qe=Pe.add(Ue(de,Se,xe));te?.add(qe)}}return de}function We(G){const U=new w.$Uc;for(const[te,de]of Le)U.add(Ue(te,de,G));return U}function Ue(G,U,te){const de=new w.$Uc,Se=G.cloneNode(!0);te.document.head.appendChild(Se),de.add((0,w.$Tc)(()=>te.document.head.removeChild(Se)));for(const xe of ve(G))Se.sheet?.insertRule(xe.cssText,Se.sheet?.cssRules.length);return de.add(t.$uS.observe(G,de,{childList:!0})(()=>{Se.textContent=G.textContent})),U.add(Se),de.add((0,w.$Tc)(()=>U.delete(Se))),de}t.$uS=new class{constructor(){this.mutationObservers=new Map}observe(G,U,te){let de=this.mutationObservers.get(G);de||(de=new Map,this.mutationObservers.set(G,de));const Se=(0,e.$hj)(te);let xe=de.get(Se);if(xe)xe.users+=1;else{const Pe=new f.$ce,qe=new MutationObserver(Xe=>Pe.fire(Xe));qe.observe(G,te);const Ke=xe={users:1,observer:qe,onDidMutate:Pe.event};U.add((0,w.$Tc)(()=>{Ke.users-=1,Ke.users===0&&(Pe.dispose(),qe.disconnect(),de?.delete(Se),de?.size===0&&this.mutationObservers.delete(G))})),de.set(Se,xe)}return xe.onDidMutate}};function Ye(G=n.$eR.document.head){return Z("meta",G)}function _e(G=n.$eR.document.head){return Z("link",G)}function Z(G,U=n.$eR.document.head){const te=document.createElement(G);return U.appendChild(te),te}let ne=null;function $e(){return ne||(ne=Fe()),ne}function ve(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function Re(G,U,te=$e()){if(!(!te||!U)){te.sheet?.insertRule(`${G} {${U}}`,0);for(const de of Le.get(te)??[])Re(G,U,de)}}function ze(G,U=$e()){if(!U)return;const te=ve(U),de=[];for(let Se=0;Se<te.length;Se++){const xe=te[Se];Ve(xe)&&xe.selectorText.indexOf(G)!==-1&&de.push(Se)}for(let Se=de.length-1;Se>=0;Se--)U.sheet?.deleteRule(de[Se]);for(const Se of Le.get(U)??[])ze(G,Se)}function Ve(G){return typeof G.selectorText=="string"}function et(G){return G instanceof MouseEvent||G instanceof(0,t.getWindow)(G).MouseEvent}function it(G){return G instanceof KeyboardEvent||G instanceof(0,t.getWindow)(G).KeyboardEvent}function st(G){return G instanceof PointerEvent||G instanceof(0,t.getWindow)(G).PointerEvent}function Qe(G){return G instanceof DragEvent||G instanceof(0,t.getWindow)(G).DragEvent}t.$DS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$rR?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$rR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$rR?"webkitAnimationIteration":"animationiteration"};function rt(G){const U=G;return!!(U&&typeof U.preventDefault=="function"&&typeof U.stopPropagation=="function")}t.$FS={stop:(G,U)=>(G.preventDefault(),U&&G.stopPropagation(),G)};function tt(G){const U=[];for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)U[te]=G.scrollTop,G=G.parentNode;return U}function mt(G,U){for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)G.scrollTop!==U[te]&&(G.scrollTop=U[te]),G=G.parentNode}class gt extends w.$Vc{static m(U){if(U instanceof HTMLElement){const te=L(U),de=te?te.activeElement:U.ownerDocument.activeElement;return z(de,U)}else{const te=U;return z(te.document.activeElement,te.document)}}constructor(U){super(),this.f=this.B(new f.$ce),this.onDidFocus=this.f.event,this.g=this.B(new f.$ce),this.onDidBlur=this.g.event;let te=gt.m(U),de=!1;const Se=()=>{de=!1,te||(te=!0,this.f.fire())},xe=()=>{te&&(de=!0,(U instanceof HTMLElement?(0,t.getWindow)(U):U).setTimeout(()=>{de&&(de=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(U)!==te&&(te?xe():Se())},this.B(N(U,t.$DS.FOCUS,Se,!0)),this.B(N(U,t.$DS.BLUR,xe,!0)),U instanceof HTMLElement&&(this.B(N(U,t.$DS.FOCUS_IN,()=>this.j())),this.B(N(U,t.$DS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function St(G){return new gt(G)}function At(G,U){return G.after(U),U}function kt(G,...U){if(G.append(...U),U.length===1&&typeof U[0]!="string")return U[0]}function Be(G,U){return G.insertBefore(U,G.firstChild),U}function he(G,...U){G.innerText="",kt(G,...U)}const Ce=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function Ge(G,U,te,...de){const Se=Ce.exec(U);if(!Se)throw new Error("Bad use of emmet");const xe=Se[1]||"div";let Pe;return G!==je.HTML?Pe=document.createElementNS(G,xe):Pe=document.createElement(xe),Se[3]&&(Pe.id=Se[3]),Se[4]&&(Pe.className=Se[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Pe[qe]=Ke:qe==="selected"?Ke&&Pe.setAttribute(qe,"true"):Pe.setAttribute(qe,Ke))}),Pe.append(...de),Pe}function nt(G,U,...te){return Ge(je.HTML,G,U,...te)}nt.SVG=function(G,U,...te){return Ge(je.SVG,G,U,...te)};function lt(G,U){const te=[];return G.forEach((de,Se)=>{Se>0&&(U instanceof Node?te.push(U.cloneNode()):te.push(document.createTextNode(U))),te.push(de)}),te}function Ze(G,...U){G?ut(...U):$t(...U)}function ut(...G){for(const U of G)U.style.display="",U.removeAttribute("aria-hidden")}function $t(...G){for(const U of G)U.style.display="none",U.setAttribute("aria-hidden","true")}function Tt(G,U){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(U))return G;G=G.parentNode}return null}function Ut(G){!G||!G.hasAttribute("tabIndex")||(G.ownerDocument.activeElement===G&&Tt(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}function Ni(G){return U=>{U.preventDefault(),U.stopPropagation(),G(U)}}function Si(G){return new Promise(U=>{if(G.document.readyState==="complete"||G.document&&G.document.body!==null)U(void 0);else{const de=()=>{G.window.removeEventListener("DOMContentLoaded",de,!1),U()};G.window.addEventListener("DOMContentLoaded",de,!1)}})}function Ai(G,U){const te=G.devicePixelRatio*U;return Math.max(1,Math.floor(te))/G.devicePixelRatio}function ki(G){n.$eR.open(G,"_blank","noopener")}const Zt=780,Jt=640;function Ti(G){const U=Math.floor(n.$eR.screenLeft+n.$eR.innerWidth/2-Zt/2),te=Math.floor(n.$eR.screenTop+n.$eR.innerHeight/2-Jt/2);n.$eR.open(G,"_blank",`width=${Zt},height=${Jt},top=${te},left=${U}`)}function Fi(G,U=!0){const te=n.$eR.open();return te?(U&&(te.opener=null),te.location.href=G,!0):!1}function Ci(G,U){const te=()=>{U(),de=(0,t.$UR)(G,te)};let de=(0,t.$UR)(G,te);return(0,w.$Tc)(()=>de.dispose())}P.$Gg.setPreferredWebSchema(/^https:/.test(n.$eR.location.href)?"https":"http");function Ri(G){return G?`url('${P.$Ng.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Li(G){return`'${G.replace(/'/g,"%27")}'`}function Qt(G,U){if(G!==void 0){const te=G.match(/^\s*var\((.+)\)$/);if(te){const de=te[1].split(",",2);return de.length===2&&(U=Qt(de[1].trim(),U)),`var(${de[0]}, ${U})`}return G}return U}function Mi(G,U){let te;if(c.URI.isUri(G))te=G.toString(!0);else{const xe=new Blob([G]);te=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(te))}const de=fe(),Se=document.createElement("a");de.document.body.appendChild(Se),Se.download=U,Se.href=te,Se.click(),setTimeout(()=>de.document.body.removeChild(Se))}function Ii(){return new Promise(G=>{const U=fe(),te=document.createElement("input");U.document.body.appendChild(te),te.type="file",te.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(te,"input"))(()=>{G(te.files??void 0)}),te.click(),setTimeout(()=>U.document.body.removeChild(te))})}var Dt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function ji(G){return G.document.fullscreenElement||G.document.webkitFullscreenElement||G.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:G.innerHeight===G.screen.height?{mode:Dt.BROWSER,guess:!1}:(u.$j||u.$k)&&G.outerHeight===G.screen.height&&G.outerWidth===G.screen.width?{mode:Dt.BROWSER,guess:!0}:null}function _t(G,U=!1){const te=document.createElement("a");return g.addHook("afterSanitizeAttributes",de=>{for(const Se of["href","src"])if(de.hasAttribute(Se)){const xe=de.getAttribute(Se);if(Se==="href"&&xe.startsWith("#"))continue;if(te.href=xe,!G.includes(te.protocol.replace(/:$/,""))){if(U&&Se==="src"&&te.href.startsWith("data:"))continue;de.removeAttribute(Se)}}}),(0,w.$Tc)(()=>{g.removeHook("afterSanitizeAttributes")})}const Oi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$8S=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(G,U){const te=_t(Oi);try{const de=g.sanitize(U,Pi);G.innerHTML=de}finally{te.dispose()}}function xi(G){const U=new Uint16Array(G.length);for(let Se=0;Se<U.length;Se++)U[Se]=G.charCodeAt(Se);let te="";const de=new Uint8Array(U.buffer);for(let Se=0;Se<de.length;Se++)te+=String.fromCharCode(de[Se]);return te}function zi(G){return btoa(xi(G))}class pt extends f.$ce{constructor(){super(),this.o=new w.$Uc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(f.Event.runAndSubscribe(t.onDidRegisterWindow,({window:U,disposables:te})=>this.C(U,te),{window:n.$eR,disposables:this.o}))}C(U,te){te.add(N(U,"keydown",de=>{if(de.defaultPrevented)return;const Se=new B.$HR(de);if(!(Se.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),te.add(N(U,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),te.add(N(U.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(N(U.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(N(U.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(N(U,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$$S=pt;function Hi(G){const U=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return U?U.pop():void 0}class Wi extends w.$Vc{constructor(U,te){super(),this.j=U,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(N(this.j,t.$DS.DRAG_START,U=>{this.m.onDragStart?.(U)})),this.m.onDrag&&this.B(N(this.j,t.$DS.DRAG,U=>{this.m.onDrag?.(U)})),this.B(N(this.j,t.$DS.DRAG_ENTER,U=>{this.f++,this.g=U.timeStamp,this.m.onDragEnter?.(U)})),this.B(N(this.j,t.$DS.DRAG_OVER,U=>{U.preventDefault(),this.m.onDragOver?.(U,U.timeStamp-this.g)})),this.B(N(this.j,t.$DS.DRAG_LEAVE,U=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(U))})),this.B(N(this.j,t.$DS.DRAG_END,U=>{this.f=0,this.g=0,this.m.onDragEnd?.(U)})),this.B(N(this.j,t.$DS.DROP,U=>{this.f=0,this.g=0,this.m.onDrop?.(U)}))}}t.$aT=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(G,...U){let te,de;Array.isArray(U[0])?(te={},de=U[0]):(te=U[0]||{},de=U[1]);const Se=Vi.exec(G);if(!Se||!Se.groups)throw new Error("Bad use of h");const xe=Se.groups.tag||"div",Pe=document.createElement(xe);Se.groups.id&&(Pe.id=Se.groups.id);const qe=[];if(Se.groups.class)for(const Xe of Se.groups.class.split("."))Xe!==""&&qe.push(Xe);if(te.className!==void 0)for(const Xe of te.className.split("."))Xe!==""&&qe.push(Xe);qe.length>0&&(Pe.className=qe.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=Pe),de)for(const Xe of de)Xe instanceof HTMLElement?Pe.appendChild(Xe):typeof Xe=="string"?Pe.append(Xe):"root"in Xe&&(Object.assign(Ke,Xe),Pe.appendChild(Xe.root));for(const[Xe,at]of Object.entries(te))if(Xe!=="className")if(Xe==="style")for(const[Ft,Pt]of Object.entries(at))Pe.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Xe==="tabIndex"?Pe.tabIndex=at:Pe.setAttribute(ei(Xe),at.toString());return Ke.root=Pe,Ke}function ei(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(G,U,te){for(const{name:de,value:Se}of G.attributes)(!te||te.includes(de))&&U.setAttribute(de,Se)}function Ki(G,U,te){const de=G.getAttribute(te);de?U.setAttribute(te,de):U.removeAttribute(te)}function Gi(G,U,te){ti(G,U,te);const de=new w.$Uc;return de.add(t.$uS.observe(G,de,{attributes:!0,attributeFilter:te})(Se=>{for(const xe of Se)xe.type==="attributes"&&xe.attributeName&&Ki(G,U,xe.attributeName)})),de}}),define(me[65],be([1,0,4,2,128]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=t.$eT=void 0,t.$gT=S;class H extends F.$Vc{constructor(f,g){super(),this.B((0,i.$KR)(f,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$KR)(f,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$eT=H,t.$fT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$Ms.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function S(k,f,g,w,P){const u=document.createElement("div");if(u.className=g,u.textContent=f,P&&(u.style.color=P),w&&(u.style.background=w),k.dataTransfer){const c=(0,i.getWindow)(k).document;c.body.appendChild(u),k.dataTransfer.setDragImage(u,-10,-10),setTimeout(()=>c.body.removeChild(u),0)}}}),define(me[66],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=F,t.$KT=B,t.$LT=H;function F(u,c={}){const e=H(c);return e.textContent=u,e}function B(u,c={}){const e=H(c);return f(e,g(u,!!c.renderCodeSegments),c.actionHandler,c.renderCodeSegments),e}function H(u){const c=u.inline?"span":"div",e=document.createElement(c);return u.className&&(e.className=u.className),e}class S{constructor(c){this.b=c,this.c=0}eos(){return this.c>=this.b.length}next(){const c=this.peek();return this.advance(),c}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(u){u[u.Invalid=0]="Invalid",u[u.Root=1]="Root",u[u.Text=2]="Text",u[u.Bold=3]="Bold",u[u.Italics=4]="Italics",u[u.Action=5]="Action",u[u.ActionClose=6]="ActionClose",u[u.Code=7]="Code",u[u.NewLine=8]="NewLine"})(k||(k={}));function f(u,c,e,n){let o;if(c.type===2)o=document.createTextNode(c.content||"");else if(c.type===3)o=document.createElement("b");else if(c.type===4)o=document.createElement("i");else if(c.type===7&&n)o=document.createElement("code");else if(c.type===5&&e){const l=document.createElement("a");e.disposables.add(i.$LR(l,"click",d=>{e.callback(String(c.index),d)})),o=l}else c.type===8?o=document.createElement("br"):c.type===1&&(o=u);o&&u!==o&&u.appendChild(o),o&&Array.isArray(c.children)&&c.children.forEach(l=>{f(o,l,e,n)})}function g(u,c){const e={type:1,children:[]};let n=0,o=e;const l=[],d=new S(u);for(;!d.eos();){let N=d.next();const b=N==="\\"&&P(d.peek(),c)!==0;if(b&&(N=d.next()),!b&&w(N,c)&&N===d.peek()){d.advance(),o.type===2&&(o=l.pop());const m=P(N,c);if(o.type===m||o.type===5&&m===6)o=l.pop();else{const r={type:m,children:[]};m===5&&(r.index=n,n++),o.children.push(r),l.push(o),o=r}}else if(N===`
`)o.type===2&&(o=l.pop()),o.children.push({type:8});else if(o.type!==2){const m={type:2,content:N};o.children.push(m),l.push(o),o=m}else o.content+=N}return o.type===2&&(o=l.pop()),l.length,e}function w(u,c){return P(u,c)!==0}function P(u,c){switch(u){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return c?7:0;default:return 0}}}),define(me[67],be([1,0,4,2]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kT=void 0;class B{constructor(){this.a=new F.$Uc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(S,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const f=this.c;this.c=null,S&&f&&f(k)}isMonitoring(){return!!this.b}startMonitoring(S,k,f,g,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=w;let P=S;try{S.setPointerCapture(k),this.a.add((0,F.$Tc)(()=>{try{S.releasePointerCapture(k)}catch{}}))}catch{P=i.getWindow(S)}this.a.add(i.$KR(P,i.$DS.POINTER_MOVE,u=>{if(u.buttons!==f){this.stopMonitoring(!0);return}u.preventDefault(),this.b(u)})),this.a.add(i.$KR(P,i.$DS.POINTER_UP,u=>this.stopMonitoring(!0)))}}t.$kT=B});var Je=this&&this.__decorate||function(se,t,i,F){var B=arguments.length,H=B<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,i):F,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(se,t,i,F);else for(var k=se.length-1;k>=0;k--)(S=se[k])&&(H=(B<3?S(H):B>3?S(t,i,H):S(t,i))||H);return B>3&&H&&Object.defineProperty(t,i,H),H};define(me[28],be([1,0,4,22,8,31,3,2,55]),function(se,t,i,F,B,H,S,k,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hT=t.EventType=void 0;var g;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class w extends k.$Vc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new f.$6c,this.m=new f.$6c,this.r={},this.n=null,this.s=0,this.B(S.Event.runAndSubscribe(i.onDidRegisterWindow,({window:u,disposables:c})=>{c.add(i.$KR(u.document,"touchstart",e=>this.w(e),{passive:!1})),c.add(i.$KR(u.document,"touchend",e=>this.z(u,e))),c.add(i.$KR(u.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:F.$eR,disposables:this.q}))}static addTarget(u){if(!w.isTouchDevice())return k.$Vc.None;w.f||(w.f=(0,k.$Oc)(new w));const c=w.f.j.push(u);return(0,k.$Tc)(c)}static ignoreTarget(u){if(!w.isTouchDevice())return k.$Vc.None;w.f||(w.f=(0,k.$Oc)(new w));const c=w.f.m.push(u);return(0,k.$Tc)(c)}static isTouchDevice(){return"ontouchstart"in F.$eR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(u){const c=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=u.targetTouches.length;e<n;e++){const o=u.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:c,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[c],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const l=this.C(g.Start,o.target);l.pageX=o.pageX,l.pageY=o.pageY,this.D(l)}this.h&&(u.preventDefault(),u.stopPropagation(),this.h=!1)}z(u,c){const e=Date.now(),n=Object.keys(this.r).length;for(let o=0,l=c.changedTouches.length;o<l;o++){const d=c.changedTouches.item(o);if(!this.r.hasOwnProperty(String(d.identifier))){console.warn("move of an UNKNOWN touch",d);continue}const N=this.r[d.identifier],b=Date.now()-N.initialTimeStamp;if(b<w.g&&Math.abs(N.initialPageX-B.$sb(N.rollingPageX))<30&&Math.abs(N.initialPageY-B.$sb(N.rollingPageY))<30){const m=this.C(g.Tap,N.initialTarget);m.pageX=B.$sb(N.rollingPageX),m.pageY=B.$sb(N.rollingPageY),this.D(m)}else if(b>=w.g&&Math.abs(N.initialPageX-B.$sb(N.rollingPageX))<30&&Math.abs(N.initialPageY-B.$sb(N.rollingPageY))<30){const m=this.C(g.Contextmenu,N.initialTarget);m.pageX=B.$sb(N.rollingPageX),m.pageY=B.$sb(N.rollingPageY),this.D(m)}else if(n===1){const m=B.$sb(N.rollingPageX),r=B.$sb(N.rollingPageY),y=B.$sb(N.rollingTimestamps)-N.rollingTimestamps[0],A=m-N.rollingPageX[0],T=r-N.rollingPageY[0],M=[...this.j].filter(q=>N.initialTarget instanceof Node&&q.contains(N.initialTarget));this.F(u,M,e,Math.abs(A)/y,A>0?1:-1,m,Math.abs(T)/y,T>0?1:-1,r)}this.D(this.C(g.End,N.initialTarget)),delete this.r[d.identifier]}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}C(u,c){const e=document.createEvent("CustomEvent");return e.initEvent(u,!1,!0),e.initialTarget=c,e.tapCount=0,e}D(u){if(u.type===g.Tap){const c=new Date().getTime();let e=0;c-this.s>w.u?e=1:e=2,this.s=c,u.tapCount=e}else(u.type===g.Change||u.type===g.Contextmenu)&&(this.s=0);if(u.initialTarget instanceof Node){for(const e of this.m)if(e.contains(u.initialTarget))return;const c=[];for(const e of this.j)if(e.contains(u.initialTarget)){let n=0,o=u.initialTarget;for(;o&&o!==e;)n++,o=o.parentElement;c.push([n,e])}c.sort((e,n)=>e[0]-n[0]);for(const[e,n]of c)n.dispatchEvent(u),this.h=!0}}F(u,c,e,n,o,l,d,N,b){this.n=i.$UR(u,()=>{const m=Date.now(),r=m-e;let y=0,A=0,T=!0;n+=w.c*r,d+=w.c*r,n>0&&(T=!1,y=o*n*r),d>0&&(T=!1,A=N*d*r);const M=this.C(g.Change);M.translationX=y,M.translationY=A,c.forEach(q=>q.dispatchEvent(M)),T||this.F(u,c,m,n,o,l+y,d,N,b+A)})}G(u){const c=Date.now();for(let e=0,n=u.changedTouches.length;e<n;e++){const o=u.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const l=this.r[o.identifier],d=this.C(g.Change,l.initialTarget);d.translationX=o.pageX-B.$sb(l.rollingPageX),d.translationY=o.pageY-B.$sb(l.rollingPageY),d.pageX=o.pageX,d.pageY=o.pageY,this.D(d),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(o.pageX),l.rollingPageY.push(o.pageY),l.rollingTimestamps.push(c)}this.h&&(u.preventDefault(),u.stopPropagation(),this.h=!1)}}t.$hT=w,Je([H.$Xh],w,"isTouchDevice",null)}),define(me[68],be([1,0,4,104]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=g,t.$OT=w,t.$PT=P;const F=2e4;let B,H,S,k,f;function g(c){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};H=e(),S=e();const n=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};k=n(),f=n(),c.appendChild(B)}function w(c){B&&(H.textContent!==c?(i.$JR(S),u(H,c)):(i.$JR(H),u(S,c)))}function P(c){B&&(k.textContent!==c?(i.$JR(f),u(k,c)):(i.$JR(k),u(f,c)))}function u(c,e){i.$JR(c),e.length>F&&(e=e.substr(0,F)),c.textContent=e,c.style.visibility="hidden",c.style.visibility="visible"}}),define(me[130],be([1,0,4,19]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gU=H,t.$hU=S;const B=new RegExp(`(\\\\)?\\$\\((${F.ThemeIcon.iconNameExpression}(?:${F.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(k){const f=new Array;let g,w=0,P=0;for(;(g=B.exec(k))!==null;){P=g.index||0,w<P&&f.push(k.substring(w,P)),w=(g.index||0)+g[0].length;const[,u,c]=g;f.push(u?`$(${c})`:S({id:c}))}return w<k.length&&f.push(k.substring(w)),f}function S(k){const f=i.$("span");return f.classList.add(...F.ThemeIcon.asClassNameArray(k)),f}}),define(me[131],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VT=void 0;function F(H){try{H.parentElement?.removeChild(H)}catch{}}class B{constructor(S){this.d=S,this.a=new Map,this.b=new Set,this.c=!1}alloc(S){let k=this.h(S).pop(),f=!1;if(k)f=this.b.has(k.domNode),f&&this.b.delete(k.domNode);else{const g=(0,i.$)(".monaco-list-row"),P=this.i(S).renderTemplate(g);k={domNode:g,templateId:S,templateData:P}}return{row:k,isReusingConnectedDomNode:f}}release(S){S&&this.f(S)}transact(S){if(this.c)throw new Error("Already in transaction");this.c=!0;try{S()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(S){const{domNode:k,templateId:f}=S;k&&(this.c?this.b.add(k):this.g(k)),this.h(f).push(S)}g(S){S.classList.remove("scrolling"),F(S)}h(S){let k=this.a.get(S);return k||(k=[],this.a.set(S,k)),k}dispose(){this.a.forEach((S,k)=>{for(const f of S)this.i(k).disposeTemplate(f.templateData),f.templateData=null}),this.a.clear(),this.b.clear()}i(S){const k=this.d.get(S);if(!k)throw new Error(`No renderer found for ${S}`);return k}}t.$VT=B}),define(me[132],be([1,0,11,2]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class B extends F.$Vc{constructor(S,k,f){super(),this.a=S,this.b=k,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Dh)}setVisibility(S){this.a!==S&&(this.a=S,this.s())}setShouldBeVisible(S){this.g=S,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const S=this.r();this.h!==S&&(this.h=S,this.ensureVisibility())}setIsNeeded(S){this.j!==S&&(this.j=S,this.ensureVisibility())}setDomNode(S){this.f=S,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(S){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(S?" fade":"")))}}t.$pT=B}),define(me[133],be([1,0,4,28,8,3,2,5]),function(se,t,i,F,B,H,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=void 0;class f extends S.$Vc{constructor(w,P,u,c){super(),this.f=0,this.b=c||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$ce),this.h=u,this.j(),this.setOptions(w,P)}j(){this.B(F.$hT.addTarget(this.a)),[F.EventType.Tap].forEach(w=>{this.B(i.$KR(this.a,w,P=>{this.a.focus()}))}),this.B(i.$LR(this.a,"click",w=>{i.$FS.stop(w,!0)})),this.B(i.$LR(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$LR(this.a,"keydown",w=>{let P=!1;k.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(P=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(P=!0),P&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,P){(!this.c||!B.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((u,c)=>{this.a.add(this.m(u.text,c,u.isDisabled))})),P!==void 0&&this.select(P)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,P,u){const c=document.createElement("option");return c.value=w,c.text=w,c.disabled=!!u,c}}t.$qU=f}),define(me[69],be([1,0,30,8,11,60,98,3,32]),function(se,t,i,F,B,H,S,k,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1V=void 0,t.$YV=g,t.$ZV=w;function g(c){return typeof c=="object"&&"visibility"in c&&"data"in c}function w(c){switch(c){case!0:return 1;case!1:return 0;default:return c}}function P(c){return typeof c.collapsible=="boolean"}class u{constructor(e,n,o,l={}){this.p=e,this.q=n,this.rootRef=[],this.d=new k.$ke,this.f=new k.$ce,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$ce,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new k.$ce,this.onDidSplice=this.m.event,this.o=new B.$qh(H.$_d),this.h=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.j=l.allowNonCollapsibleParents??!1,this.k=l.filter,this.l=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,o=f.Iterable.empty(),l={}){if(e.length===0)throw new i.$WV(this.p,"Invalid tree location");l.diffIdentityProvider?this.s(l.diffIdentityProvider,e,n,o,l):this.t(e,n,o,l)}s(e,n,o,l=f.Iterable.empty(),d,N=d.diffDepth??0){const{parentNode:b}=this.H(n);if(!b.lastDiffIds)return this.t(n,o,l,d);const m=[...l],r=n[n.length-1],y=new S.$vt({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,r),...m,...b.children.slice(r+o)].map($=>e.getId($.element).toString())}).ComputeDiff(!1);if(y.quitEarly)return b.lastDiffIds=void 0,this.t(n,o,m,d);const A=n.slice(0,-1),T=($,I,V)=>{if(N>0)for(let R=0;R<V;R++)$--,I--,this.s(e,[...A,$,0],Number.MAX_SAFE_INTEGER,m[I].children,d,N-1)};let M=Math.min(b.children.length,r+o),q=m.length;for(const $ of y.changes.sort((I,V)=>V.originalStart-I.originalStart))T(M,q,M-($.originalStart+$.originalLength)),M=$.originalStart,q=$.modifiedStart-r,this.t([...A,M],$.originalLength,f.Iterable.slice(m,q,q+$.modifiedLength),d);T(M,q,M)}t(e,n,o=f.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:d,diffIdentityProvider:N}){const{parentNode:b,listIndex:m,revealed:r,visible:y}=this.H(e),A=[],T=f.Iterable.map(o,X=>this.x(X,b,b.visible?1:0,r,A,l)),M=e[e.length-1];let q=0;for(let X=M;X>=0&&X<b.children.length;X--){const K=b.children[X];if(K.visible){q=K.visibleChildIndex;break}}const $=[];let I=0,V=0;for(const X of T)$.push(X),V+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=q+I++);const R=(0,F.$6b)(b.children,M,n,$);N?b.lastDiffIds?(0,F.$6b)(b.lastDiffIds,M,n,$.map(X=>N.getId(X.element).toString())):b.lastDiffIds=b.children.map(X=>N.getId(X.element).toString()):b.lastDiffIds=void 0;let x=0;for(const X of R)X.visible&&x++;if(x!==0)for(let X=M+$.length;X<b.children.length;X++){const K=b.children[X];K.visible&&(K.visibleChildIndex-=x)}if(b.visibleChildrenCount+=I-x,r&&y){const X=R.reduce((K,ae)=>K+(ae.visible?ae.renderNodeCount:0),0);this.C(b,V-X),this.q.splice(m,X,A)}if(R.length>0&&d){const X=K=>{d(K),K.children.forEach(X)};R.forEach(X)}this.m.fire({insertedNodes:$,deletedNodes:R});let O=b;for(;O;){if(O.visibility===2){this.o.trigger(()=>this.refilter());break}O=O.parent}}rerender(e){if(e.length===0)throw new i.$WV(this.p,"Invalid tree location");const{node:n,listIndex:o,revealed:l}=this.G(e);n.visible&&l&&this.q.splice(o,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$WV(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:o,revealed:l}=this.G(e);return o&&l?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const o=this.F(e);typeof n>"u"&&(n=!o.collapsible);const l={collapsible:n};return this.d.bufferEvents(()=>this.u(e,l))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,o){const l=this.F(e);typeof n>"u"&&(n=!l.collapsed);const d={collapsed:n,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,d))}u(e,n){const{node:o,listIndex:l,revealed:d}=this.G(e),N=this.v(o,l,d,n);if(o!==this.c&&this.l&&N&&!P(n)&&o.collapsible&&!o.collapsed&&!n.recursive){let b=-1;for(let m=0;m<o.children.length;m++)if(o.children[m].visible)if(b>-1){b=-1;break}else b=m;b>-1&&this.u([...e,b],n)}return N}v(e,n,o,l){const d=this.w(e,l,!1);if(!o||!e.visible||!d)return d;const N=e.renderNodeCount,b=this.y(e),m=N-(n===-1?0:1);return this.q.splice(n+1,m,b.slice(1)),d}w(e,n,o){let l;if(e===this.c?l=!1:(P(n)?(l=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(l=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):l=!1,l&&this.f.fire({node:e,deep:o})),!P(n)&&n.recursive)for(const d of e.children)l=this.w(d,n,!0)||l;return l}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,o,l,d,N){const b={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},m=this.D(b,o);b.visibility=m,l&&d.push(b);const r=e.children||f.Iterable.empty(),y=l&&m!==0&&!b.collapsed;let A=0,T=1;for(const M of r){const q=this.x(M,b,m,y,d,N);b.children.push(q),T+=q.renderNodeCount,q.visible&&(q.visibleChildIndex=A++)}return this.j||(b.collapsible=b.collapsible||b.children.length>0),b.visibleChildrenCount=A,b.visible=m===2?A>0:m===1,b.visible?b.collapsed||(b.renderNodeCount=T):(b.renderNodeCount=0,l&&d.pop()),N?.(b),b}y(e){const n=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-n),o}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,o=[];return this.B(e,e.visible?1:0,o),this.C(e.parent,o.length-n),o}B(e,n,o,l=!0){let d;if(e!==this.c){if(d=this.D(e,n),d===0)return e.visible=!1,e.renderNodeCount=0,!1;l&&o.push(e)}const N=o.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||d!==0){let m=0;for(const r of e.children)b=this.B(r,d,o,l&&!e.collapsed)||b,r.visible&&(r.visibleChildIndex=m++);e.visibleChildrenCount=m}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=d===2?b:d===1,e.visibility=d),e.visible?e.collapsed||(e.renderNodeCount+=o.length-N):(e.renderNodeCount=0,l&&o.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const o=this.k?this.k.filter(e.element,n):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):g(o)?(e.filterData=o.data,w(o.visibility)):(e.filterData=void 0,w(o))}E(e,n=this.c){if(!e||e.length===0)return!0;const[o,...l]=e;return o<0||o>n.children.length?!1:this.E(l,n.children[o])}F(e,n=this.c){if(!e||e.length===0)return n;const[o,...l]=e;if(o<0||o>n.children.length)throw new i.$WV(this.p,"Invalid tree location");return this.F(l,n.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:o,revealed:l,visible:d}=this.H(e),N=e[e.length-1];if(N<0||N>n.children.length)throw new i.$WV(this.p,"Invalid tree location");const b=n.children[N];return{node:b,listIndex:o,revealed:l,visible:d&&b.visible}}H(e,n=this.c,o=0,l=!0,d=!0){const[N,...b]=e;if(N<0||N>n.children.length)throw new i.$WV(this.p,"Invalid tree location");for(let m=0;m<N;m++)o+=n.children[m].renderNodeCount;return l=l&&!n.collapsed,d=d&&n.visible,b.length===0?{parentNode:n,listIndex:o,revealed:l,visible:d}:this.H(b,n.children[N],o+1,l,d)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let o=e;for(;o.parent;)n.push(o.parent.children.indexOf(o)),o=o.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,F.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$1V=u}),define(me[134],be([1,0,69,30,32]),function(se,t,i,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8V=void 0;class H{get size(){return this.d.size}constructor(k,f,g={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$1V(k,f,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(w,P){return g.sorter.compare(w.element,P.element)}}),this.h=g.identityProvider}setChildren(k,f=B.Iterable.empty(),g={}){const w=this.o(k);this.l(w,this.m(f),g)}l(k,f=B.Iterable.empty(),g){const w=new Set,P=new Set,u=e=>{if(e.element===null)return;const n=e;if(w.add(n.element),this.d.set(n.element,n),this.h){const o=this.h.getId(n.element).toString();P.add(o),this.f.set(o,n)}g.onDidCreateNode?.(n)},c=e=>{if(e.element===null)return;const n=e;if(w.has(n.element)||this.d.delete(n.element),this.h){const o=this.h.getId(n.element).toString();P.has(o)||this.f.delete(o)}g.onDidDeleteNode?.(n)};this.c.splice([...k,0],Number.MAX_VALUE,f,{...g,onDidCreateNode:u,onDidDeleteNode:c})}m(k=B.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),B.Iterable.map(k,f=>{let g=this.d.get(f.element);if(!g&&this.h){const u=this.h.getId(f.element).toString();g=this.f.get(u)}if(!g){let u;return typeof f.collapsed>"u"?u=void 0:f.collapsed===F.ObjectTreeElementCollapseState.Collapsed||f.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed?u=!0:f.collapsed===F.ObjectTreeElementCollapseState.Expanded||f.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?u=!1:u=!!f.collapsed,{...f,children:this.m(f.children),collapsed:u}}const w=typeof f.collapsible=="boolean"?f.collapsible:g.collapsible;let P;return typeof f.collapsed>"u"||f.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed||f.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?P=g.collapsed:f.collapsed===F.ObjectTreeElementCollapseState.Collapsed?P=!0:f.collapsed===F.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!f.collapsed,{...f,collapsible:w,collapsed:P,children:this.m(f.children)}})}rerender(k){const f=this.o(k);this.c.rerender(f)}updateElementHeight(k,f){const g=this.o(k);this.c.updateElementHeight(g,f)}resort(k=null,f=!0){if(!this.j)return;const g=this.o(k),w=this.c.getNode(g);this.l(g,this.n(w,f),{})}n(k,f,g=!0){let w=[...k.children];return(f||g)&&(w=w.sort(this.j.compare.bind(this.j))),B.Iterable.map(w,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,f,!1)}))}getFirstElementChild(k=null){const f=this.o(k);return this.c.getFirstElementChild(f)}getLastElementAncestor(k=null){const f=this.o(k);return this.c.getLastElementAncestor(f)}has(k){return this.d.has(k)}getListIndex(k){const f=this.o(k);return this.c.getListIndex(f)}getListRenderCount(k){const f=this.o(k);return this.c.getListRenderCount(f)}isCollapsible(k){const f=this.o(k);return this.c.isCollapsible(f)}setCollapsible(k,f){const g=this.o(k);return this.c.setCollapsible(g,f)}isCollapsed(k){const f=this.o(k);return this.c.isCollapsed(f)}setCollapsed(k,f,g){const w=this.o(k);return this.c.setCollapsed(w,f,g)}expandTo(k){const f=this.o(k);this.c.expandTo(f)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const f=this.d.get(k);if(!f)throw new F.$WV(this.k,`Tree element not found: ${k}`);return f}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new F.$WV(this.k,"Invalid getParentNodeLocation call");const f=this.d.get(k);if(!f)throw new F.$WV(this.k,`Tree element not found: ${k}`);const g=this.c.getNodeLocation(f),w=this.c.getParentNodeLocation(g);return this.c.getNode(w).element}o(k){if(k===null)return[];const f=this.d.get(k);if(!f)throw new F.$WV(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(f)}}t.$8V=H}),define(me[21],be([1,0,4,15,20,28,2]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;class k extends S.$Vc{f(g,w){this.B(i.$KR(g,i.$DS.CLICK,P=>w(new B.$CR(i.getWindow(g),P))))}j(g,w){this.B(i.$KR(g,i.$DS.MOUSE_DOWN,P=>w(new B.$CR(i.getWindow(g),P))))}m(g,w){this.B(i.$KR(g,i.$DS.MOUSE_OVER,P=>w(new B.$CR(i.getWindow(g),P))))}u(g,w){this.B(i.$KR(g,i.$DS.MOUSE_LEAVE,P=>w(new B.$CR(i.getWindow(g),P))))}z(g,w){this.B(i.$KR(g,i.$DS.KEY_DOWN,P=>w(new F.$HR(P))))}C(g,w){this.B(i.$KR(g,i.$DS.KEY_UP,P=>w(new F.$HR(P))))}D(g,w){this.B(i.$KR(g,i.$DS.INPUT,w))}F(g,w){this.B(i.$KR(g,i.$DS.BLUR,w))}G(g,w){this.B(i.$KR(g,i.$DS.FOCUS,w))}H(g,w){this.B(i.$KR(g,i.$DS.CHANGE,w))}I(g){return H.$hT.ignoreTarget(g)}}t.$lT=k}),define(me[48],be([1,0,67,21,11,19,4]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=t.$mT=void 0,t.$mT=11;class k extends F.$lT{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$mT+"px",this.domNode.style.height=t.$mT+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new i.$kT),this.B(S.$LR(this.bgDomNode,S.$DS.POINTER_DOWN,w=>this.h(w))),this.B(S.$LR(this.domNode,S.$DS.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new S.$WR),this.c=this.B(new B.$Dh)}h(g){if(!g.target||!(g.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,S.getWindow(g))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$nT=k}),define(me[70],be([1,0,4,51,67,48,132,21,5]),function(se,t,i,F,B,H,S,k,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=void 0;const g=140;class w extends k.$lT{constructor(u){super(),this.g=u.lazyRender,this.a=u.host,this.b=u.scrollable,this.c=u.scrollByPage,this.h=u.scrollbarState,this.n=this.B(new S.$pT(u.visibility,"visible scrollbar "+u.extraScrollbarClassName,"invisible scrollbar "+u.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$kT),this.s=!0,this.domNode=(0,F.$jT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$KR(this.domNode.domNode,i.$DS.POINTER_DOWN,c=>this.M(c)))}t(u){const c=this.B(new H.$nT(u));this.domNode.domNode.appendChild(c.bgDomNode),this.domNode.domNode.appendChild(c.domNode)}w(u,c,e,n){this.slider=(0,F.$jT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(u),this.slider.setLeft(c),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$KR(this.slider.domNode,i.$DS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(u){return this.h.setVisibleSize(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(u){return this.h.setScrollSize(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(u){return this.h.setScrollPosition(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(u){u.target===this.domNode.domNode&&this.N(u)}delegatePointerDown(u){const c=this.domNode.domNode.getClientRects()[0].top,e=c+this.h.getSliderPosition(),n=c+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(u);e<=o&&o<=n?u.button===0&&(u.preventDefault(),this.O(u)):this.N(u)}N(u){let c,e;if(u.target===this.domNode.domNode&&typeof u.offsetX=="number"&&typeof u.offsetY=="number")c=u.offsetX,e=u.offsetY;else{const o=i.$7R(this.domNode.domNode);c=u.pageX-o.left,e=u.pageY-o.top}const n=this.S(c,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),u.button===0&&(u.preventDefault(),this.O(u))}O(u){if(!u.target||!(u.target instanceof Element))return;const c=this.U(u),e=this.W(u),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(u.target,u.pointerId,u.buttons,o=>{const l=this.W(o),d=Math.abs(l-e);if(f.$i&&d>g){this.P(n.getScrollPosition());return}const b=this.U(o)-c;this.P(n.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(u){const c={};this.writeScrollPosition(c,u),this.b.setScrollPositionNow(c)}updateScrollbarSize(u){this.X(u),this.h.setScrollbarSize(u),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$qT=w}),define(me[135],be([1,0,20,70,48,52,18]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=void 0;class k extends F.$qT{constructor(g,w,P){const u=g.getScrollDimensions(),c=g.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$oT(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,u.width,u.scrollWidth,c.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-B.$mT)/2,n=(w.horizontalScrollbarSize-B.$mT)/2;this.t({className:"scra",icon:S.$Sj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$ER(null,1,0))}),this.t({className:"scra",icon:S.$Sj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$ER(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R(g,w){this.slider.setWidth(g),this.slider.setLeft(w)}Q(g,w){this.domNode.setWidth(g),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,w){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,w){g.scrollLeft=w}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$rT=k}),define(me[136],be([1,0,20,70,48,52,18]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=void 0;class k extends F.$qT{constructor(g,w,P){const u=g.getScrollDimensions(),c=g.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$oT(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,u.height,u.scrollHeight,c.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-B.$mT)/2,n=(w.verticalScrollbarSize-B.$mT)/2;this.t({className:"scra",icon:S.$Sj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$ER(null,0,1))}),this.t({className:"scra",icon:S.$Sj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$ER(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R(g,w){this.slider.setHeight(g),this.slider.setTop(w)}Q(g,w){this.domNode.setWidth(w),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,w){return w}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,w){g.scrollTop=w}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$sT=k}),define(me[71],be([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=t.$wT=t.$vT=t.$uT=t.$tT=void 0;const e=500,n=50,o=!0;class l{constructor(T,M,q){this.timestamp=T,this.deltaX=M,this.deltaY=q,this.score=0}}class d{static{this.INSTANCE=new d}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,M=0,q=1,$=this.d;do{const I=$===this.c?T:Math.pow(2,-q);if(T-=I,M+=this.b[$].score*I,$===this.c)break;$=(this.a+$-1)%this.a,q++}while(!0);return M<=.5}acceptStandardWheelEvent(T){if(i.$sR){const M=F.getWindow(T.browserEvent),q=(0,i.$lR)(M);this.accept(Date.now(),T.deltaX*q,T.deltaY*q)}else this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,M,q){let $=null;const I=new l(T,M,q);this.c===-1&&this.d===-1?(this.b[0]=I,this.c=0,this.d=0):($=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=I),I.score=this.f(I,$)}f(T,M){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let q=.5;if((!this.g(T.deltaX)||!this.g(T.deltaY))&&(q+=.25),M){const $=Math.abs(T.deltaX),I=Math.abs(T.deltaY),V=Math.abs(M.deltaX),R=Math.abs(M.deltaY),x=Math.max(Math.min($,V),1),O=Math.max(Math.min(I,R),1),X=Math.max($,V),K=Math.max(I,R);X%x===0&&K%O===0&&(q-=.5)}return Math.min(Math.max(q,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$tT=d;class N extends f.$lT{get options(){return this.a}constructor(T,M,q){super(),this.O=this.B(new w.$ce),this.onScroll=this.O.event,this.P=this.B(new w.$ce),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=y(M),this.b=q,this.B(this.b.onScroll(I=>{this.P.fire(I),this.S(I),this.O.fire(I)}));const $={onMouseWheel:I=>this.R(I),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$sT(this.b,this.a,$)),this.g=this.B(new S.$rT(this.b,this.a,$)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$jT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$jT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$jT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,I=>this.Z(I)),this.u(this.t,I=>this.Y(I)),this.L=this.B(new g.$Dh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Qc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,u.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new H.$ER(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,P.$Qc)(this.w),T)){const q=$=>{this.R(new H.$ER($))};this.w.push(F.$KR(this.t,F.$DS.MOUSE_WHEEL,q,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const M=d.INSTANCE;o&&M.acceptStandardWheelEvent(T);let q=!1;if(T.deltaY||T.deltaX){let I=T.deltaY*this.a.mouseWheelScrollSensitivity,V=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+I===0?V=I=0:Math.abs(I)>=Math.abs(V)?V=0:I=0),this.a.flipAxes&&([I,V]=[V,I]);const R=!u.$j&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||R)&&!V&&(V=I,I=0),T.browserEvent&&T.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,I=I*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let O={};if(I){const X=n*I,K=x.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(O,K)}if(V){const X=n*V,K=x.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(O,K)}O=this.b.validateScrollPosition(O),(x.scrollLeft!==O.scrollLeft||x.scrollTop!==O.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&M.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(O):this.b.setScrollPositionNow(O),q=!0)}let $=q;!$&&this.a.alwaysConsumeMouseWheel&&($=!0),!$&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&($=!0),$&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),M=T.scrollTop>0,q=T.scrollLeft>0,$=q?" left":"",I=M?" top":"",V=q||M?" top-left-corner":"";this.n.setClassName(`shadow${$}`),this.r.setClassName(`shadow${I}`),this.s.setClassName(`shadow${V}${I}${$}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$uT=N;class b extends N{constructor(T,M){M=M||{},M.mouseWheelSmoothScroll=!1;const q=new c.$Ss({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$UR(F.getWindow(T),$)});super(T,M,q),this.B(q)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$vT=b;class m extends N{constructor(T,M,q){super(T,M,q)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$wT=m;class r extends N{constructor(T,M){M=M||{},M.mouseWheelSmoothScroll=!1;const q=new c.$Ss({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$UR(F.getWindow(T),$)});super(T,M,q),this.B(q),this.cb=T,this.B(this.onScroll($=>{$.scrollTopChanged&&(this.cb.scrollTop=$.scrollTop),$.scrollLeftChanged&&(this.cb.scrollLeft=$.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$xT=r;function y(A){const T={lazyRender:typeof A.lazyRender<"u"?A.lazyRender:!1,className:typeof A.className<"u"?A.className:"",useShadows:typeof A.useShadows<"u"?A.useShadows:!0,handleMouseWheel:typeof A.handleMouseWheel<"u"?A.handleMouseWheel:!0,flipAxes:typeof A.flipAxes<"u"?A.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof A.consumeMouseWheelIfScrollbarIsNeeded<"u"?A.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof A.alwaysConsumeMouseWheel<"u"?A.alwaysConsumeMouseWheel:!1,scrollYToX:typeof A.scrollYToX<"u"?A.scrollYToX:!1,mouseWheelScrollSensitivity:typeof A.mouseWheelScrollSensitivity<"u"?A.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof A.fastScrollSensitivity<"u"?A.fastScrollSensitivity:5,scrollPredominantAxis:typeof A.scrollPredominantAxis<"u"?A.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof A.mouseWheelSmoothScroll<"u"?A.mouseWheelSmoothScroll:!0,arrowSize:typeof A.arrowSize<"u"?A.arrowSize:11,listenOnDomNode:typeof A.listenOnDomNode<"u"?A.listenOnDomNode:null,horizontal:typeof A.horizontal<"u"?A.horizontal:1,horizontalScrollbarSize:typeof A.horizontalScrollbarSize<"u"?A.horizontalScrollbarSize:10,horizontalSliderSize:typeof A.horizontalSliderSize<"u"?A.horizontalSliderSize:0,horizontalHasArrows:typeof A.horizontalHasArrows<"u"?A.horizontalHasArrows:!1,vertical:typeof A.vertical<"u"?A.vertical:1,verticalScrollbarSize:typeof A.verticalScrollbarSize<"u"?A.verticalScrollbarSize:10,verticalHasArrows:typeof A.verticalHasArrows<"u"?A.verticalHasArrows:!1,verticalSliderSize:typeof A.verticalSliderSize<"u"?A.verticalSliderSize:0,scrollByPage:typeof A.scrollByPage<"u"?A.scrollByPage:!1};return T.horizontalSliderSize=typeof A.horizontalSliderSize<"u"?A.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof A.verticalSliderSize<"u"?A.verticalSliderSize:T.verticalScrollbarSize,u.$j&&(T.className+=" mac"),T}}),define(me[72],be([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZT=t.$YT=t.$XT=t.$WT=t.ListViewTargetSector=void 0;const d={CurrentDragAndDropData:void 0};var N;(function(q){q[q.TOP=0]="TOP",q[q.CENTER_TOP=1]="CENTER_TOP",q[q.CENTER_BOTTOM=2]="CENTER_BOTTOM",q[q.BOTTOM=3]="BOTTOM"})(N||(t.ListViewTargetSector=N={}));const b={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(q){return[q]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class m{get context(){return this.d}set context($){this.d=$}constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$WT=m;class r{constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$XT=r;class y{constructor(){this.types=[],this.files=[]}update($){if($.types&&this.types.splice(0,this.types.length,...$.types),$.files){this.files.splice(0,this.files.length);for(let I=0;I<$.files.length;I++){const V=$.files.item(I);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$YT=y;function A(q,$){return Array.isArray(q)&&Array.isArray($)?(0,k.$ub)(q,$):q===$}class T{constructor($){$?.getSetSize?this.getSetSize=$.getSetSize.bind($):this.getSetSize=(I,V,R)=>R,$?.getPosInSet?this.getPosInSet=$.getPosInSet.bind($):this.getPosInSet=(I,V)=>V+1,$?.getRole?this.getRole=$.getRole.bind($):this.getRole=I=>"listitem",$?.isChecked?this.isChecked=$.isChecked.bind($):this.isChecked=I=>{}}}class M{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q($){if($!==this.P){if($&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=$,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const I of this.d)this.ab(I);this.X(),this.q.setScrollDimensions({width:(0,F.$0R)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor($,I,V,R=b){if(this.R=I,this.domId=`list_id_${++M.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new f.$qh(50),this.v=!1,this.x=P.$Vc.None,this.y=0,this.G=!1,this.K=P.$Vc.None,this.L=P.$Vc.None,this.M=new P.$Uc,this.N=new w.$ce,this.O=new w.$ce,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,R.horizontalScrolling&&R.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(R.paddingTop??0);for(const O of V)this.j.set(O.templateId,O);this.h=this.M.add(new n.$VT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof R.mouseSupport=="boolean"?R.mouseSupport:!0),this.P=R.horizontalScrolling??b.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof R.paddingBottom>"u"?0:R.paddingBottom,this.D=new T(R.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(R.transformOptimization??b.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$hT.addTarget(this.o)),this.p=this.M.add(new c.$Ss({forceIntegerValues:!0,smoothScrollDuration:R.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:O=>(0,F.$UR)((0,F.getWindow)(this.domNode),O)})),this.q=this.M.add(new S.$wT(this.o,{alwaysConsumeMouseWheel:R.alwaysConsumeMouseWheel??b.alwaysConsumeMouseWheel,horizontal:1,vertical:R.verticalScrollMode??b.verticalScrollMode,useShadows:R.useShadows??b.useShadows,mouseWheelScrollSensitivity:R.mouseWheelScrollSensitivity,fastScrollSensitivity:R.fastScrollSensitivity,scrollByPage:R.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),$.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,F.$KR)(this.o,H.EventType.Change,O=>this.jb(O))),this.M.add((0,F.$KR)(this.q.getDomNode(),"scroll",O=>O.target.scrollTop=0)),this.M.add((0,F.$KR)(this.domNode,"dragover",O=>this.lb(this.hb(O)))),this.M.add((0,F.$KR)(this.domNode,"drop",O=>this.nb(this.hb(O)))),this.M.add((0,F.$KR)(this.domNode,"dragleave",O=>this.mb(this.hb(O)))),this.M.add((0,F.$KR)(this.domNode,"dragend",O=>this.ob(O))),this.z=R.setRowLineHeight??b.setRowLineHeight,this.A=R.setRowHeight??b.setRowHeight,this.B=R.supportDynamicHeights??b.supportDynamicHeights,this.F=R.dnd??this.M.add(b.dnd),this.layout(R.initialSize?.height,R.initialSize?.width)}updateOptions($){$.paddingBottom!==void 0&&(this.C=$.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),$.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration($.smoothScrolling?125:0),$.horizontalScrolling!==void 0&&(this.Q=$.horizontalScrolling);let I;if($.scrollByPage!==void 0&&(I={...I??{},scrollByPage:$.scrollByPage}),$.mouseWheelScrollSensitivity!==void 0&&(I={...I??{},mouseWheelScrollSensitivity:$.mouseWheelScrollSensitivity}),$.fastScrollSensitivity!==void 0&&(I={...I??{},fastScrollSensitivity:$.fastScrollSensitivity}),I&&this.q.updateOptions(I),$.paddingTop!==void 0&&$.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),R=$.paddingTop-this.g.paddingTop;this.g.paddingTop=$.paddingTop,this.Y(V,Math.max(0,this.k+R),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent($){this.q.delegateScrollFromMouseWheelEvent($)}delegateVerticalScrollbarPointerDown($){this.q.delegateVerticalScrollbarPointerDown($)}updateElementHeight($,I,V){if($<0||$>=this.d.length)return;const R=this.d[$].size;if(typeof I>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[$].lastDynamicHeightWidth=void 0,I=R+this.xb($)}if(R===I)return;const x=this.vb(this.k,this.m);let O=0;$<x.start||V!==null&&V>$&&V<x.end?O=I-R:O=0,this.g.splice($,1,[{size:I}]),this.d[$].size=I,this.Y(x,Math.max(0,this.k+O),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S($){return new e.$UT($)}splice($,I,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U($,I,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U($,I,V=[]){const R=this.vb(this.k,this.m),x={start:$,end:$+I},O=u.Range.intersect(R,x),X=new Map;for(let W=O.end-1;W>=O.start;W--){const Q=this.d[W];if(Q.dragStartDisposable.dispose(),Q.checkedDisposable.dispose(),Q.row){let ge=X.get(Q.templateId);ge||(ge=[],X.set(Q.templateId,ge));const we=this.j.get(Q.templateId);we&&we.disposeElement&&we.disposeElement(Q.element,W,Q.row.templateData,Q.size),ge.unshift(Q.row)}Q.row=null,Q.stale=!0}const K={start:$+I,end:this.d.length},ae=u.Range.intersect(K,R),ie=u.Range.relativeComplement(K,R),ee=V.map(W=>({id:String(this.f++),element:W,templateId:this.R.getTemplateId(W),size:this.R.getHeight(W),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(W),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Vc.None,checkedDisposable:P.$Vc.None,stale:!1}));let ce;$===0&&I>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),ce=this.d,this.d=ee):(this.g.splice($,I,ee),ce=this.d.splice($,I,...ee));const ye=V.length-I,Ee=this.vb(this.k,this.m),Me=(0,e.$ST)(ae,ye),le=u.Range.intersect(Ee,Me);for(let W=le.start;W<le.end;W++)this.bb(this.d[W],W);const _=u.Range.relativeComplement(Me,Ee);for(const W of _)for(let Q=W.start;Q<W.end;Q++)this.db(Q);const ue=ie.map(W=>(0,e.$ST)(W,ye)),De=[{start:$,end:$+V.length},...ue].map(W=>u.Range.intersect(Ee,W)).reverse();for(const W of De)for(let Q=W.end-1;Q>=W.start;Q--){const ge=this.d[Q],Ae=X.get(ge.templateId)?.pop();this.Z(Q,Ae)}for(const W of X.values())for(const Q of W)this.h.release(Q);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ce.map(W=>W.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,F.$UR)((0,F.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let $=0;for(const I of this.d)typeof I.width<"u"&&($=Math.max($,I.width));this.E=$,this.q.setScrollDimensions({scrollWidth:$===0?0:$+10}),this.O.fire(this.E)}updateWidth($){if(!this.Q||typeof this.E>"u")return;const I=this.d[$];this.ab(I),typeof I.width<"u"&&I.width>this.E&&(this.E=I.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const $ of this.d)$.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const $=this.firstVisibleIndex,I=this.g.positionAt($),V=this.g.positionAt($+1);return V!==-1&&(V-I)/2+I<this.scrollTop?$+1:$}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element($){return this.d[$].element}indexOf($){return this.d.findIndex(I=>I.element===$)}domElement($){const I=this.d[$].row;return I&&I.domNode}elementHeight($){return this.d[$].size}elementTop($){return this.g.positionAt($)}indexAt($){return this.g.indexAt($)}indexAfter($){return this.g.indexAfter($)}layout($,I){const V={height:typeof $=="number"?$:(0,F.$_R)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof I<"u"&&(this.n=I,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof I=="number"?I:(0,F.$0R)(this.domNode)})}Y($,I,V,R,x,O=!1){const X=this.vb(I,V),K=u.Range.relativeComplement(X,$).reverse(),ae=u.Range.relativeComplement($,X);if(O){const ie=u.Range.intersect($,X);for(let ee=ie.start;ee<ie.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.db(ee);for(const ie of K)for(let ee=ie.end-1;ee>=ie.start;ee--)this.Z(ee)}),R!==void 0&&(this.o.style.left=`-${R}px`),this.o.style.top=`-${I}px`,this.Q&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=I,this.m=V}Z($,I){const V=this.d[$];if(!V.row)if(I)V.row=I,V.stale=!0;else{const K=this.h.alloc(V.templateId);V.row=K.row,V.stale||=K.isReusingConnectedDomNode}const R=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",R);const x=this.D.isChecked(V.element);if(typeof x=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const K=ae=>V.row.domNode.setAttribute("aria-checked",String(!!ae));K(x.value),V.checkedDisposable=x.onDidChange(()=>K(x.value))}if(V.stale||!V.row.domNode.parentElement){const K=this.d.at($+1)?.row?.domNode??null;(V.row.domNode.parentElement!==this.o||V.row.domNode.nextElementSibling!==K)&&this.o.insertBefore(V.row.domNode,K),V.stale=!1}this.bb(V,$);const O=this.j.get(V.templateId);if(!O)throw new Error(`No renderer found for template id ${V.templateId}`);O?.renderElement(V.element,$,V.row.templateData,V.size);const X=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!X,X&&(V.dragStartDisposable=(0,F.$KR)(V.row.domNode,"dragstart",K=>this.kb(V.element,X,K))),this.Q&&(this.ab(V),this.W())}ab($){if(!$.row||!$.row.domNode)return;$.row.domNode.style.width="fit-content",$.width=(0,F.$0R)($.row.domNode);const I=(0,F.getWindow)($.row.domNode).getComputedStyle($.row.domNode);I.paddingLeft&&($.width+=parseFloat(I.paddingLeft)),I.paddingRight&&($.width+=parseFloat(I.paddingRight)),$.row.domNode.style.width=""}bb($,I){$.row.domNode.style.top=`${this.elementTop(I)}px`,this.A&&($.row.domNode.style.height=`${$.size}px`),this.z&&($.row.domNode.style.lineHeight=`${$.size}px`),$.row.domNode.setAttribute("data-index",`${I}`),$.row.domNode.setAttribute("data-last-element",I===this.length-1?"true":"false"),$.row.domNode.setAttribute("data-parity",I%2===0?"even":"odd"),$.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize($.element,I,this.length))),$.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet($.element,I))),$.row.domNode.setAttribute("id",this.getElementDomId(I)),$.row.domNode.classList.toggle("drop-target",$.dropTarget)}db($){const I=this.d[$];if(I.dragStartDisposable.dispose(),I.checkedDisposable.dispose(),I.row){const V=this.j.get(I.templateId);V&&V.disposeElement&&V.disposeElement(I.element,$,I.row.templateData,I.size),this.h.release(I.row),I.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop($,I){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:$,reuseAnimation:I})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft($){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:$})}get scrollTop(){return this.getScrollTop()}set scrollTop($){this.setScrollTop($)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"click")).event,$=>this.eb($),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"dblclick")).event,$=>this.eb($),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new B.$MT(this.domNode,"auxclick")).event,$=>this.eb($),this.M),$=>$.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"mouseup")).event,$=>this.eb($),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"mousedown")).event,$=>this.eb($),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"mouseover")).event,$=>this.eb($),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"mousemove")).event,$=>this.eb($),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"mouseout")).event,$=>this.eb($),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new B.$MT(this.domNode,"contextmenu")).event,$=>this.eb($),this.M),w.Event.map(this.M.add(new B.$MT(this.domNode,H.EventType.Contextmenu)).event,$=>this.gb($),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new B.$MT(this.domNode,"touchstart")).event,$=>this.fb($),this.M)}get onTap(){return w.Event.map(this.M.add(new B.$MT(this.o,H.EventType.Tap)).event,$=>this.gb($),this.M)}eb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:$,index:I,element:R}}fb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:$,index:I,element:R}}gb($){const I=this.ub($.initialTarget||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:$,index:I,element:R}}hb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element,x=this.tb($,I);return{browserEvent:$,index:I,element:R,sector:x}}ib($){try{const I=this.vb(this.k,this.m);this.Y(I,$.scrollTop,$.height,$.scrollLeft,$.scrollWidth),this.B&&this.wb($.scrollTop,$.height,$.inSmoothScrolling)}catch(I){throw console.error("Got bad scroll event:",$),I}}jb($){$.preventDefault(),$.stopPropagation(),this.scrollTop-=$.translationY}kb($,I,V){if(!V.dataTransfer)return;const R=this.F.getDragElements($);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.$fT.TEXT,I),V.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(R,V)),typeof x>"u"&&(x=String(R.length));const O=(0,F.$)(".monaco-drag-image");O.textContent=x;const K=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);K.appendChild(O),V.dataTransfer.setDragImage(O,-10,-10),setTimeout(()=>K.removeChild(O),0)}this.domNode.classList.add("dragging"),this.H=new m(R),d.CurrentDragAndDropData=new r(R),this.F.onDragStart?.(this.H,V)}lb($){if($.browserEvent.preventDefault(),this.L.dispose(),d.CurrentDragAndDropData&&d.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb($.browserEvent),!$.browserEvent.dataTransfer))return!1;if(!this.H)if(d.CurrentDragAndDropData)this.H=d.CurrentDragAndDropData;else{if(!$.browserEvent.dataTransfer.types)return!1;this.H=new y}const I=this.F.onDragOver(this.H,$.element,$.index,$.sector,$.browserEvent);if(this.G=typeof I=="boolean"?I:I.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;$.browserEvent.dataTransfer.dropEffect=typeof I!="boolean"&&I.effect?.type===0?"copy":"move";let V;typeof I!="boolean"&&I.feedback?V=I.feedback:typeof $.index>"u"?V=[-1]:V=[$.index],V=(0,k.$Mb)(V).filter(x=>x>=-1&&x<this.length).sort((x,O)=>x-O),V=V[0]===-1?[-1]:V;let R=typeof I!="boolean"&&I.effect&&I.effect.position?I.effect.position:"drop-target";if(A(this.I,V)&&this.J===R)return!0;if(this.I=V,this.J=R,this.K.dispose(),V[0]===-1)this.domNode.classList.add(R),this.o.classList.add(R),this.K=(0,P.$Tc)(()=>{this.domNode.classList.remove(R),this.o.classList.remove(R)});else{if(V.length>1&&R!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");R==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,R="drop-target-before");for(const x of V){const O=this.d[x];O.dropTarget=!0,O.row?.domNode.classList.add(R)}this.K=(0,P.$Tc)(()=>{for(const x of V){const O=this.d[x];O.dropTarget=!1,O.row?.domNode.classList.remove(R)}})}return!0}mb($){this.L.dispose(),this.L=(0,f.$vh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,$.element,$.index,$.browserEvent)}nb($){if(!this.G)return;const I=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,d.CurrentDragAndDropData=void 0,!(!I||!$.browserEvent.dataTransfer)&&($.browserEvent.preventDefault(),I.update($.browserEvent.dataTransfer),this.F.drop(I,$.element,$.index,$.sector,$.browserEvent))}ob($){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,d.CurrentDragAndDropData=void 0,this.F.onDragEnd?.($)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Vc.None}qb($){if(!this.w){const I=(0,F.$4R)(this.domNode).top;this.w=(0,F.$ZS)((0,F.getWindow)(this.domNode),this.rb.bind(this,I))}this.x.dispose(),this.x=(0,f.$vh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=$.pageY}rb($){if(this.y===void 0)return;const I=this.y-$,V=this.renderHeight-35;I<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(I-35))):I>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(I-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb($,I){if(I===void 0)return;const V=$.offsetY/this.d[I].size,R=Math.floor(V/.25);return(0,l.$ym)(R,0,3)}ub($){const I=this.q.getDomNode();let V=$;for(;V instanceof HTMLElement&&V!==this.o&&I.contains(V);){const R=V.getAttribute("data-index");if(R){const x=Number(R);if(!isNaN(x))return x}V=V.parentElement}}vb($,I){return{start:this.g.indexAt($),end:this.g.indexAfter($+I-1)}}wb($,I,V){const R=this.vb($,I);let x,O;$===this.elementTop(R.start)?(x=R.start,O=0):R.end-R.start>1&&(x=R.start+1,O=this.elementTop(x)-$);let X=0;for(;;){const K=this.vb($,I);let ae=!1;for(let ie=K.start;ie<K.end;ie++){const ee=this.xb(ie);ee!==0&&this.g.splice(ie,1,[this.d[ie]]),X+=ee,ae=ae||ee!==0}if(!ae){X!==0&&this.V();const ie=u.Range.relativeComplement(R,K);for(const ce of ie)for(let ye=ce.start;ye<ce.end;ye++)this.d[ye].row&&this.db(ye);const ee=u.Range.relativeComplement(K,R).reverse();for(const ce of ee)for(let ye=ce.end-1;ye>=ce.start;ye--)this.Z(ye);for(let ce=K.start;ce<K.end;ce++)this.d[ce].row&&this.bb(this.d[ce],ce);if(typeof x=="number"){const ce=this.p.getFutureScrollPosition().scrollTop-$,ye=this.elementTop(x)-O+ce;this.setScrollTop(ye,V)}this.N.fire(this.contentHeight);return}}}xb($){const I=this.d[$];if(this.R.getDynamicHeight){const O=this.R.getDynamicHeight(I.element);if(O!==null){const X=I.size;return I.size=O,I.lastDynamicHeightWidth=this.n,O-X}}if(!I.hasDynamicHeight||I.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(I.element))return 0;const V=I.size;if(I.row)return I.row.domNode.style.height="",I.size=I.row.domNode.offsetHeight,I.size===0&&!(0,F.$cS)(I.row.domNode,(0,F.getWindow)(I.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),I.lastDynamicHeightWidth=this.n,I.size-V;const{row:R}=this.h.alloc(I.templateId);R.domNode.style.height="",this.o.appendChild(R.domNode);const x=this.j.get(I.templateId);if(!x)throw new o.$cb("Missing renderer for templateId: "+I.templateId);return x.renderElement(I.element,$,R.templateData,void 0),I.size=R.domNode.offsetHeight,x.disposeElement?.(I.element,$,R.templateData,void 0),this.R.setDynamicHeight?.(I.element,I.size),I.lastDynamicHeightWidth=this.n,this.o.removeChild(R.domNode),this.h.release(R),I.size-V}getElementDomId($){return`${this.domId}_${$}`}dispose(){for(const $ of this.d)if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){const I=this.j.get($.row.templateId);I&&(I.disposeElement?.($.element,-1,$.row.templateData,void 0),I.disposeTemplate($.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$ZT=M,Je([g.$Xh],M.prototype,"onMouseClick",null),Je([g.$Xh],M.prototype,"onMouseDblClick",null),Je([g.$Xh],M.prototype,"onMouseMiddleClick",null),Je([g.$Xh],M.prototype,"onMouseUp",null),Je([g.$Xh],M.prototype,"onMouseDown",null),Je([g.$Xh],M.prototype,"onMouseOver",null),Je([g.$Xh],M.prototype,"onMouseMove",null),Je([g.$Xh],M.prototype,"onMouseOut",null),Je([g.$Xh],M.prototype,"onContextMenu",null),Je([g.$Xh],M.prototype,"onTouchStart",null),Je([g.$Xh],M.prototype,"onTap",null)}),define(me[49],be([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n,o,l,d,N,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=t.$eU=t.$dU=t.$cU=t.$_T=t.TypeNavigationMode=void 0,t.$4T=M,t.$5T=$,t.$6T=I,t.$7T=V,t.$8T=R,t.$9T=x,t.$0T=O,t.$$T=X,t.$aU=ye,t.$bU=Ee;class r{constructor(h){this.d=h,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(h){return h}renderElement(h,D,a){const v=this.c.findIndex(C=>C.templateData===a);if(v>=0){const C=this.c[v];this.d.unrender(a),C.index=D}else{const C={index:D,templateData:a};this.c.push(C)}this.d.renderIndex(D,a)}splice(h,D,a){const v=[];for(const C of this.c)C.index<h?v.push(C):C.index>=h+D&&v.push({index:C.index+a-D,templateData:C.templateData});this.c=v}renderIndexes(h){for(const{index:D,templateData:a}of this.c)h.indexOf(D)>-1&&this.d.renderIndex(D,a)}disposeTemplate(h){const D=this.c.findIndex(a=>a.templateData===h);D<0||this.c.splice(D,1)}}class y{get name(){return this.g}get renderer(){return new r(this)}constructor(h){this.g=h,this.c=[],this.d=[],this.f=new u.$ce,this.onChange=this.f.event}splice(h,D,a){const v=a.length-D,C=h+D,s=[];let E=0;for(;E<this.d.length&&this.d[E]<h;)s.push(this.d[E++]);for(let p=0;p<a.length;p++)a[p]&&s.push(p+h);for(;E<this.d.length&&this.d[E]>=C;)s.push(this.d[E++]+v);this.renderer.splice(h,D,a.length),this.h(s,s)}renderIndex(h,D){D.classList.toggle(this.g,this.contains(h))}unrender(h){h.classList.remove(this.g)}set(h,D){return this.h(h,[...h].sort(ge),D)}h(h,D,a){const v=this.c,C=this.d;this.c=h,this.d=D;const s=W(C,h);return this.renderer.renderIndexes(s),this.f.fire({indexes:h,browserEvent:a}),v}get(){return this.c}contains(h){return(0,f.$wb)(this.d,h,ge)>=0}dispose(){(0,e.$Qc)(this.f)}}Je([P.$Xh],y.prototype,"renderer",null);class A extends y{constructor(h){super("selected"),this.k=h}renderIndex(h,D){super.renderIndex(h,D),this.k&&(this.contains(h)?D.setAttribute("aria-selected","true"):D.setAttribute("aria-selected","false"))}}class T{constructor(h,D,a){this.c=h,this.d=D,this.f=a}splice(h,D,a){if(!this.f)return this.c.splice(h,D,new Array(a.length).fill(!1));const v=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(v.length===0)return this.c.splice(h,D,new Array(a.length).fill(!1));const C=new Set(v),s=a.map(E=>C.has(this.f.getId(E).toString()));this.c.splice(h,D,s)}}function M(z){return z.tagName==="INPUT"||z.tagName==="TEXTAREA"}function q(z,h){return z.classList.contains(h)?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:q(z.parentElement,h)}function $(z){return q(z,"monaco-editor")}function I(z){return q(z,"monaco-custom-toggle")}function V(z){return q(z,"action-item")}function R(z){return q(z,"monaco-tl-twistie")}function x(z){return q(z,"monaco-tree-sticky-row")}function O(z){return z.classList.contains("monaco-tree-sticky-container")}function X(z){return z.tagName==="A"&&z.classList.contains("monaco-button")||z.tagName==="DIV"&&z.classList.contains("monaco-button-dropdown")?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:X(z.parentElement)}class K{get g(){return u.Event.chain(this.c.add(new F.$MT(this.k.domNode,"keydown")).event,h=>h.filter(D=>!M(D.target)).map(D=>new B.$HR(D)))}constructor(h,D,a){this.h=h,this.k=D,this.c=new e.$Uc,this.d=new e.$Uc,this.f=a.multipleSelectionSupport,this.c.add(this.g(v=>{switch(v.keyCode){case 3:return this.l(v);case 16:return this.o(v);case 18:return this.p(v);case 11:return this.q(v);case 12:return this.s(v);case 9:return this.u(v);case 31:this.f&&(o.$j?v.metaKey:v.ctrlKey)&&this.t(v)}}))}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.f=h.multipleSelectionSupport)}l(h){h.preventDefault(),h.stopPropagation(),this.h.setSelection(this.h.getFocus(),h.browserEvent)}o(h){h.preventDefault(),h.stopPropagation(),this.h.focusPrevious(1,!1,h.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}p(h){h.preventDefault(),h.stopPropagation(),this.h.focusNext(1,!1,h.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}q(h){h.preventDefault(),h.stopPropagation(),this.h.focusPreviousPage(h.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}s(h){h.preventDefault(),h.stopPropagation(),this.h.focusNextPage(h.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}t(h){h.preventDefault(),h.stopPropagation(),this.h.setSelection((0,f.$Sb)(this.h.length),h.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(h){this.h.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.h.setSelection([],h.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([P.$Xh],K.prototype,"g",null);var ae;(function(z){z[z.Automatic=0]="Automatic",z[z.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(z){z[z.Idle=0]="Idle",z[z.Typing=1]="Typing"})(ie||(ie={})),t.$_T=new class{mightProducePrintableCharacter(z){return z.ctrlKey||z.metaKey||z.altKey?!1:z.keyCode>=31&&z.keyCode<=56||z.keyCode>=21&&z.keyCode<=30||z.keyCode>=98&&z.keyCode<=107||z.keyCode>=85&&z.keyCode<=95}};class ee{constructor(h,D,a,v,C){this.o=h,this.p=D,this.q=a,this.s=v,this.t=C,this.c=!1,this.d=ie.Idle,this.f=ae.Automatic,this.g=!1,this.h=-1,this.k=new e.$Uc,this.l=new e.$Uc,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.u():this.v(),this.f=h.typeNavigationMode??ae.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let h=!1;const D=u.Event.chain(this.k.add(new F.$MT(this.p.domNode,"keydown")).event,C=>C.filter(s=>!M(s.target)).filter(()=>this.f===ae.Automatic||this.g).map(s=>new B.$HR(s)).filter(s=>h||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$FS.stop(s,!0)).map(s=>s.browserEvent.key)),a=u.Event.debounce(D,()=>null,800,void 0,void 0,void 0,this.k);u.Event.reduce(u.Event.any(D,a),(C,s)=>s===null?null:(C||"")+s,void 0,this.k)(this.x,this,this.k),a(this.w,this,this.k),D(()=>h=!0,void 0,this.k),a(()=>h=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const h=this.o.getFocus();if(h.length>0&&h[0]===this.h){const D=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(h[0]));typeof D=="string"?(0,S.$OT)(D):D&&(0,S.$OT)(D.get())}this.h=-1}x(h){if(!h){this.d=ie.Idle,this.g=!1;return}const D=this.o.getFocus(),a=D.length>0?D[0]:0,v=this.d===ie.Idle?1:0;this.d=ie.Typing;for(let C=0;C<this.o.length;C++){const s=(a+C+v)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(s)),p=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof p<"u"){if((0,c.$vk)(h,p)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}const L=(0,c.$Ck)(h,p);if(L&&L[0].end-L[0].start>1&&L.length===1){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof p>"u"||(0,c.$vk)(h,p)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ce{constructor(h,D){this.d=h,this.f=D,this.c=new e.$Uc;const a=u.Event.chain(this.c.add(new F.$MT(D.domNode,"keydown")).event,C=>C.filter(s=>!M(s.target)).map(s=>new B.$HR(s)));u.Event.chain(a,C=>C.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(h){if(h.target!==this.f.domNode)return;const D=this.d.getFocus();if(D.length===0)return;const a=this.f.domElement(D[0]);if(!a)return;const v=a.querySelector("[tabIndex]");if(!v||!(v instanceof HTMLElement)||v.tabIndex===-1)return;const C=(0,i.getWindow)(v).getComputedStyle(v);C.visibility==="hidden"||C.display==="none"||(h.preventDefault(),h.stopPropagation(),v.focus())}dispose(){this.c.dispose()}}function ye(z){return o.$j?z.browserEvent.metaKey:z.browserEvent.ctrlKey}function Ee(z){return z.browserEvent.shiftKey}function Me(z){return(0,i.$zS)(z)&&z.button===2}const le={isSelectionSingleChangeEvent:ye,isSelectionRangeChangeEvent:Ee};class _{constructor(h){this.k=h,this.f=new e.$Uc,this.g=new u.$ce,this.onPointer=this.g.event,h.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.d&&(h.onMouseDown(this.s,this,this.f),h.onContextMenu(this.t,this,this.f),h.onMouseDblClick(this.v,this,this.f),h.onTouchStart(this.s,this,this.f),this.f.add(H.$hT.addTarget(h.getHTMLElement()))),u.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.u,this,this.f)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.c=void 0,h.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(h){return this.c?this.c.isSelectionSingleChangeEvent(h):!1}p(h){return this.c?this.c.isSelectionRangeChangeEvent(h):!1}q(h){return this.o(h)||this.p(h)}s(h){$(h.browserEvent.target)||(0,i.$kS)()!==h.browserEvent.target&&this.k.domFocus()}t(h){if(M(h.browserEvent.target)||$(h.browserEvent.target))return;const D=typeof h.index>"u"?[]:[h.index];this.k.setFocus(D,h.browserEvent)}u(h){if(!this.d||M(h.browserEvent.target)||$(h.browserEvent.target)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const D=h.index;if(typeof D>"u"){this.k.setFocus([],h.browserEvent),this.k.setSelection([],h.browserEvent),this.k.setAnchor(void 0);return}if(this.q(h))return this.w(h);this.k.setFocus([D],h.browserEvent),this.k.setAnchor(D),Me(h.browserEvent)||this.k.setSelection([D],h.browserEvent),this.g.fire(h)}v(h){if(M(h.browserEvent.target)||$(h.browserEvent.target)||this.q(h)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const D=this.k.getFocus();this.k.setSelection(D,h.browserEvent)}w(h){const D=h.index;let a=this.k.getAnchor();if(this.p(h)){typeof a>"u"&&(a=this.k.getFocus()[0]??D,this.k.setAnchor(a));const v=Math.min(a,D),C=Math.max(a,D),s=(0,f.$Sb)(v,C+1),E=this.k.getSelection(),p=De(W(E,[a]),a);if(p.length===0)return;const L=W(s,Q(E,p));this.k.setSelection(L,h.browserEvent),this.k.setFocus([D],h.browserEvent)}else if(this.o(h)){const v=this.k.getSelection(),C=v.filter(s=>s!==D);this.k.setFocus([D]),this.k.setAnchor(D),v.length===C.length?this.k.setSelection([...C,D],h.browserEvent):this.k.setSelection(C,h.browserEvent)}}dispose(){this.f.dispose()}}t.$cU=_;class ue{constructor(h,D){this.c=h,this.d=D}style(h){const D=this.d&&`.${this.d}`,a=[];h.listBackground&&a.push(`.monaco-list${D} .monaco-list-rows { background: ${h.listBackground}; }`),h.listFocusBackground&&(a.push(`.monaco-list${D}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),a.push(`.monaco-list${D}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&a.push(`.monaco-list${D}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(a.push(`.monaco-list${D}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),a.push(`.monaco-list${D}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&a.push(`.monaco-list${D}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&a.push(`.monaco-list${D}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(a.push(`.monaco-list${D} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),a.push(`.monaco-list${D} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&a.push(`.monaco-list${D} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(a.push(`.monaco-list${D} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),a.push(`.monaco-list${D} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(a.push(`.monaco-list${D} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${D} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&a.push(`.monaco-list${D} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&a.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&a.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`);const v=(0,i.$3S)(h.listFocusAndSelectionOutline,(0,i.$3S)(h.listSelectionOutline,h.listFocusOutline??""));v&&a.push(`.monaco-list${D}:focus .monaco-list-row.focused.selected { outline: 1px solid ${v}; outline-offset: -1px;}`),h.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`);const C=(0,i.$3S)(h.listSelectionOutline,h.listInactiveFocusOutline??"");C&&a.push(`.monaco-list${D} .monaco-list-row.focused.selected { outline: 1px dotted ${C}; outline-offset: -1px; }`),h.listSelectionOutline&&a.push(`.monaco-list${D} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listInactiveFocusOutline&&a.push(`.monaco-list${D} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&a.push(`.monaco-list${D} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropOverBackground&&a.push(`
				.monaco-list${D}.drop-target,
				.monaco-list${D} .monaco-list-rows.drop-target,
				.monaco-list${D} .monaco-list-row.drop-target { background-color: ${h.listDropOverBackground} !important; color: inherit !important; }
			`),h.listDropBetweenBackground&&(a.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${D} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${D} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`)),h.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),h.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=a.join(`
`)}}t.$dU=ue,t.$eU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Kt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Kt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Kt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function De(z,h){const D=z.indexOf(h);if(D===-1)return[];const a=[];let v=D-1;for(;v>=0&&z[v]===h-(D-v);)a.push(z[v--]);for(a.reverse(),v=D;v<z.length&&z[v]===h+(v-D);)a.push(z[v++]);return a}function W(z,h){const D=[];let a=0,v=0;for(;a<z.length||v<h.length;)if(a>=z.length)D.push(h[v++]);else if(v>=h.length)D.push(z[a++]);else if(z[a]===h[v]){D.push(z[a]),a++,v++;continue}else z[a]<h[v]?D.push(z[a++]):D.push(h[v++]);return D}function Q(z,h){const D=[];let a=0,v=0;for(;a<z.length||v<h.length;)if(a>=z.length)D.push(h[v++]);else if(v>=h.length)D.push(z[a++]);else if(z[a]===h[v]){a++,v++;continue}else z[a]<h[v]?D.push(z[a++]):v++;return D}const ge=(z,h)=>z-h;class we{constructor(h,D){this.c=h,this.d=D}get templateId(){return this.c}renderTemplate(h){return this.d.map(D=>D.renderTemplate(h))}renderElement(h,D,a,v){let C=0;for(const s of this.d)s.renderElement(h,D,a[C++],v)}disposeElement(h,D,a,v){let C=0;for(const s of this.d)s.disposeElement?.(h,D,a[C],v),C+=1}disposeTemplate(h){let D=0;for(const a of this.d)a.disposeTemplate(h[D++])}}class Ae{constructor(h){this.c=h,this.templateId="a18n"}renderTemplate(h){return{container:h,disposables:new e.$Uc}}renderElement(h,D,a){const v=this.c.getAriaLabel(h),C=v&&typeof v!="string"?v:(0,m.constObservable)(v);a.disposables.add((0,m.autorun)(E=>{this.d(E.readObservable(C),a.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(h);typeof s=="number"?a.container.setAttribute("aria-level",`${s}`):a.container.removeAttribute("aria-level")}d(h,D){h?D.setAttribute("aria-label",h):D.removeAttribute("aria-label")}disposeElement(h,D,a,v){a.disposables.clear()}disposeTemplate(h){h.disposables.dispose()}}class Te{constructor(h,D){this.c=h,this.d=D}getDragElements(h){const D=this.c.getSelectedElements();return D.indexOf(h)>-1?D:[h]}getDragURI(h){return this.d.getDragURI(h)}getDragLabel(h,D){if(this.d.getDragLabel)return this.d.getDragLabel(h,D)}onDragStart(h,D){this.d.onDragStart?.(h,D)}onDragOver(h,D,a,v,C){return this.d.onDragOver(h,D,a,v,C)}onDragLeave(h,D,a,v){this.d.onDragLeave?.(h,D,a,v)}onDragEnd(h){this.d.onDragEnd?.(h)}drop(h,D,a,v,C){this.d.drop(h,D,a,v,C)}dispose(){this.d.dispose()}}class Ie{get onDidChangeFocus(){return u.Event.map(this.g.wrapEvent(this.c.onChange),h=>this.G(h),this.y)}get onDidChangeSelection(){return u.Event.map(this.g.wrapEvent(this.d.onChange),h=>this.G(h),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let h=!1;const D=u.Event.chain(this.y.add(new F.$MT(this.k.domNode,"keydown")).event,C=>C.map(s=>new B.$HR(s)).filter(s=>h=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$FS.stop(s,!0)).filter(()=>!1)),a=u.Event.chain(this.y.add(new F.$MT(this.k.domNode,"keyup")).event,C=>C.forEach(()=>h=!1).map(s=>new B.$HR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$FS.stop(s,!0)).map(({browserEvent:s})=>{const E=this.getFocus(),p=E.length?E[0]:void 0,L=typeof p<"u"?this.k.element(p):void 0,j=typeof p<"u"?this.k.domElement(p):this.k.domNode;return{index:p,element:L,anchor:j,browserEvent:s}})),v=u.Event.chain(this.k.onContextMenu,C=>C.filter(s=>!h).map(({element:s,index:E,browserEvent:p})=>({element:s,index:E,anchor:new b.$CR((0,i.getWindow)(this.k.domNode),p),browserEvent:p})));return u.Event.any(D,a,v)}get onKeyDown(){return this.y.add(new F.$MT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new F.$MT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new F.$MT(this.k.domNode,"keypress")).event}get onDidFocus(){return u.Event.signal(this.y.add(new F.$MT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return u.Event.signal(this.y.add(new F.$MT(this.k.domNode,"blur",!0)).event)}constructor(h,D,a,v,C=re){this.A=h,this.B=C,this.c=new y("focused"),this.f=new y("anchor"),this.g=new u.$ke,this.x="",this.y=new e.$Uc,this.z=new u.$ce,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new A(s!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=C.accessibilityProvider,this.u&&(E.push(new Ae(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),v=v.map(L=>new we(L.templateId,[...E,L]));const p={...C,dnd:C.dnd&&new Te(this,C.dnd)};if(this.k=this.C(D,a,v,p),this.k.domNode.setAttribute("role",s),C.styleController)this.q=C.styleController(this.k.domId);else{const L=(0,i.$sS)(this.k.domNode);this.q=new ue(L,this.k.domId)}if(this.o=new k.$QT([new T(this.c,this.k,C.identityProvider),new T(this.d,this.k,C.identityProvider),new T(this.f,this.k,C.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ce(this,this.k)),(typeof C.keyboardSupport!="boolean"||C.keyboardSupport)&&(this.v=new K(this,this.k,C),this.y.add(this.v)),C.keyboardNavigationLabelProvider){const L=C.keyboardNavigationDelegate||t.$_T;this.t=new ee(this,this.k,C.keyboardNavigationLabelProvider,C.keyboardNavigationEventFilter??(()=>!0),L),this.y.add(this.t)}this.w=this.D(C),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(h,D,a,v){return new N.$ZT(h,D,a,v)}D(h){return new _(this)}updateOptions(h={}){this.B={...this.B,...h},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(h),this.v?.updateOptions(h),this.k.updateOptions(h)}get options(){return this.B}splice(h,D,a=[]){if(h<0||h>this.k.length)throw new d.$2T(this.A,`Invalid start index: ${h}`);if(D<0)throw new d.$2T(this.A,`Invalid delete count: ${D}`);D===0&&a.length===0||this.g.bufferEvents(()=>this.o.splice(h,D,a))}updateWidth(h){this.k.updateWidth(h)}updateElementHeight(h,D){this.k.updateElementHeight(h,D,null)}rerender(){this.k.rerender()}element(h){return this.k.element(h)}indexOf(h){return this.k.indexOf(h)}indexAt(h){return this.k.indexAt(h)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(h){this.k.setScrollTop(h)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(h){this.k.setScrollLeft(h)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(h){this.x=h,this.k.domNode.setAttribute("aria-label",h)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(h,D){this.k.layout(h,D)}triggerTypeNavigation(){this.t?.trigger()}setSelection(h,D){for(const a of h)if(a<0||a>=this.length)throw new d.$2T(this.A,`Invalid index ${a}`);this.d.set(h,D)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(h=>this.k.element(h))}setAnchor(h){if(typeof h>"u"){this.f.set([]);return}if(h<0||h>=this.length)throw new d.$2T(this.A,`Invalid index ${h}`);this.f.set([h])}getAnchor(){return(0,f.$Ob)(this.f.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,D){for(const a of h)if(a<0||a>=this.length)throw new d.$2T(this.A,`Invalid index ${a}`);this.c.set(h,D)}focusNext(h=1,D=!1,a,v){if(this.length===0)return;const C=this.c.get(),s=this.E(C.length>0?C[0]+h:0,D,v);s>-1&&this.setFocus([s],a)}focusPrevious(h=1,D=!1,a,v){if(this.length===0)return;const C=this.c.get(),s=this.F(C.length>0?C[0]-h:0,D,v);s>-1&&this.setFocus([s],a)}async focusNextPage(h,D){let a=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);a=a===0?0:a-1;const v=this.getFocus()[0];if(v!==a&&(v===void 0||a>v)){const C=this.F(a,!1,D);C>-1&&v!==C?this.setFocus([C],h):this.setFocus([a],h)}else{const C=this.k.getScrollTop();let s=C+this.k.renderHeight;a>v&&(s-=this.k.elementHeight(a)),this.k.setScrollTop(s),this.k.getScrollTop()!==C&&(this.setFocus([]),await(0,g.$uh)(0),await this.focusNextPage(h,D))}}async focusPreviousPage(h,D,a=()=>0){let v;const C=a(),s=this.k.getScrollTop()+C;s===0?v=this.k.indexAt(s):v=this.k.indexAfter(s-1);const E=this.getFocus()[0];if(E!==v&&(E===void 0||E>=v)){const p=this.E(v,!1,D);p>-1&&E!==p?this.setFocus([p],h):this.setFocus([v],h)}else{const p=s;this.k.setScrollTop(s-this.k.renderHeight-C),this.k.getScrollTop()+a()!==p&&(this.setFocus([]),await(0,g.$uh)(0),await this.focusPreviousPage(h,D,a))}}focusLast(h,D){if(this.length===0)return;const a=this.F(this.length-1,!1,D);a>-1&&this.setFocus([a],h)}focusFirst(h,D){this.focusNth(0,h,D)}focusNth(h,D,a){if(this.length===0)return;const v=this.E(h,!1,a);v>-1&&this.setFocus([v],D)}E(h,D=!1,a){for(let v=0;v<this.length;v++){if(h>=this.length&&!D)return-1;if(h=h%this.length,!a||a(this.element(h)))return h;h++}return-1}F(h,D=!1,a){for(let v=0;v<this.length;v++){if(h<0&&!D)return-1;if(h=(this.length+h%this.length)%this.length,!a||a(this.element(h)))return h;h--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(h=>this.k.element(h))}reveal(h,D,a=0){if(h<0||h>=this.length)throw new d.$2T(this.A,`Invalid index ${h}`);const v=this.k.getScrollTop(),C=this.k.elementTop(h),s=this.k.elementHeight(h);if((0,l.$0f)(D)){const E=s-this.k.renderHeight+a;this.k.setScrollTop(E*(0,n.$ym)(D,0,1)+C-a)}else{const E=C+s,p=v+this.k.renderHeight;C<v+a&&E>=p||(C<v+a||E>=p&&s>=this.k.renderHeight?this.k.setScrollTop(C-a):E>=p&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(h,D=0){if(h<0||h>=this.length)throw new d.$2T(this.A,`Invalid index ${h}`);const a=this.k.getScrollTop(),v=this.k.elementTop(h),C=this.k.elementHeight(h);if(v<a+D||v+C>a+this.k.renderHeight)return null;const s=C-this.k.renderHeight+D;return Math.abs((a+D-v)/s)}isDOMFocused(){return(0,i.$lS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(h){return this.k.getElementDomId(h)}getElementTop(h){return this.k.elementTop(h)}style(h){this.q.style(h)}G({indexes:h,browserEvent:D}){return{indexes:h,elements:h.map(a=>this.k.element(a)),browserEvent:D}}H(){const h=this.c.get();this.k.domNode.classList.toggle("element-focused",h.length>0),this.I()}I(){const h=this.c.get();if(h.length>0){let D;this.u?.getActiveDescendantId&&(D=this.u.getActiveDescendantId(this.k.element(h[0]))),this.k.domNode.setAttribute("aria-activedescendant",D||this.k.getElementDomId(h[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const h=this.d.get();this.k.domNode.classList.toggle("selection-none",h.length===0),this.k.domNode.classList.toggle("selection-single",h.length===1),this.k.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$fU=Ie,Je([P.$Xh],Ie.prototype,"onDidChangeFocus",null),Je([P.$Xh],Ie.prototype,"onDidChangeSelection",null),Je([P.$Xh],Ie.prototype,"onContextMenu",null),Je([P.$Xh],Ie.prototype,"onKeyDown",null),Je([P.$Xh],Ie.prototype,"onKeyUp",null),Je([P.$Xh],Ie.prototype,"onKeyPress",null),Je([P.$Xh],Ie.prototype,"onDidFocus",null),Je([P.$Xh],Ie.prototype,"onDidBlur",null)}),define(me[137],be([1,0,6,62,47,9,16]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qk=t.MarkdownStringTextNewlineStyle=void 0,t.$Rk=g,t.$Sk=w,t.$Tk=P,t.$Uk=u,t.$Vk=c,t.$Wk=e,t.$Xk=n,t.$Yk=o;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class f{constructor(d="",N=!1){if(this.value=d,typeof this.value!="string")throw(0,i.$7)("value");typeof N=="boolean"?(this.isTrusted=N,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=N.isTrusted??void 0,this.supportThemeIcons=N.supportThemeIcons??!1,this.supportHtml=N.supportHtml??!1)}appendText(d,N=0){return this.value+=u(this.supportThemeIcons?(0,F.$Kk)(d):d).replace(/([ \t]+)/g,(b,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,N===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,N){return this.value+=`
${c(N,d)}
`,this}appendLink(d,N,b){return this.value+="[",this.value+=this.c(N,"]"),this.value+="](",this.value+=this.c(String(d),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(d,N){const b=new RegExp((0,H.$0e)(N),"g");return d.replace(b,(m,r)=>d.charAt(r-1)!=="\\"?`\\${m}`:m)}}t.$Qk=f;function g(l){return w(l)?!l.value:Array.isArray(l)?l.every(g):!0}function w(l){return l instanceof f?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function P(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons&&l.supportHtml===d.supportHtml&&(l.baseUri===d.baseUri||!!l.baseUri&&!!d.baseUri&&(0,B.$Zg)(S.URI.from(l.baseUri),S.URI.from(d.baseUri)))}function u(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function c(l,d){const N=l.match(/^`+/gm)?.reduce((m,r)=>m.length>r.length?m:r).length??0,b=N>=3?N+1:3;return[`${"`".repeat(b)}${d}`,l,`${"`".repeat(b)}`].join(`
`)}function e(l){return l.replace(/"/g,"&quot;")}function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(l){const d=[],N=l.split("|").map(m=>m.trim());l=N[0];const b=N[1];if(b){const m=/height=(\d+)/.exec(b),r=/width=(\d+)/.exec(b),y=m?m[1]:"",A=r?r[1]:"",T=isFinite(parseInt(A)),M=isFinite(parseInt(y));T&&d.push(`width="${A}"`),M&&d.push(`height="${y}"`)}return{href:l,dimensions:d}}}),define(me[138],be([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n,o,l,d,N,b,m,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jU=void 0,t.$iU=A,t.$kU=I,t.$lU=V,t.$mU=ae;const y=Object.freeze({image:(W,Q,ge)=>{let we=[],Ae=[];return W&&({href:W,dimensions:we}=(0,P.$Yk)(W),Ae.push(`src="${(0,P.$Wk)(W)}"`)),ge&&Ae.push(`alt="${(0,P.$Wk)(ge)}"`),Q&&Ae.push(`title="${(0,P.$Wk)(Q)}"`),we.length&&(Ae=Ae.concat(we)),"<img "+Ae.join(" ")+">"},paragraph:W=>`<p>${W}</p>`,link:(W,Q,ge)=>typeof W!="string"?"":(W===ge&&(ge=(0,P.$Xk)(ge)),Q=typeof Q=="string"?(0,P.$Wk)((0,P.$Xk)(Q)):"",W=(0,P.$Xk)(W),W=W.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${W}" title="${Q||W}" draggable="false">${ge}</a>`)});function A(W,Q={},ge={}){const we=new n.$Uc;let Ae=!1;const Te=(0,H.$LT)(Q),Ie=function(p){let L;try{L=(0,l.$2h)(decodeURIComponent(p))}catch{}return L?(L=(0,N.$2n)(L,j=>{if(W.uris&&W.uris[j])return r.URI.revive(W.uris[j])}),encodeURIComponent(JSON.stringify(L))):p},z=function(p,L){const j=W.uris&&W.uris[p];let Y=r.URI.revive(j);return L?p.startsWith(d.Schemas.data+":")?p:(Y||(Y=r.URI.parse(p)),d.$Ng.uriToBrowserUri(Y).toString(!0)):!Y||r.URI.parse(p).toString()===Y.toString()?p:(Y.query&&(Y=Y.with({query:Ie(Y.query)})),Y.toString())},h=new o.marked.Renderer;h.image=y.image,h.link=y.link,h.paragraph=y.paragraph;const D=[],a=[];if(Q.codeBlockRendererSync?h.code=(p,L)=>{const j=c.$nP.nextId(),Y=Q.codeBlockRendererSync(T(L),p);return a.push([j,Y]),`<div class="code" data-code="${j}">${(0,m.$9e)(p)}</div>`}:Q.codeBlockRenderer&&(h.code=(p,L)=>{const j=c.$nP.nextId(),Y=Q.codeBlockRenderer(T(L),p);return D.push(Y.then(J=>[j,J])),`<div class="code" data-code="${j}">${(0,m.$9e)(p)}</div>`}),Q.actionHandler){const p=function(Y){let J=Y.target;if(!(J.tagName!=="A"&&(J=J.parentElement,!J||J.tagName!=="A")))try{let oe=J.dataset.href;oe&&(W.baseUri&&(oe=M(r.URI.from(W.baseUri),oe)),Q.actionHandler.callback(oe,Y))}catch(oe){(0,g.$1)(oe)}finally{Y.preventDefault()}},L=Q.actionHandler.disposables.add(new B.$MT(Te,"click")),j=Q.actionHandler.disposables.add(new B.$MT(Te,"auxclick"));Q.actionHandler.disposables.add(w.Event.any(L.event,j.event)(Y=>{const J=new k.$CR(i.getWindow(Te),Y);!J.leftButton&&!J.middleButton||p(J)})),Q.actionHandler.disposables.add(i.$KR(Te,"keydown",Y=>{const J=new S.$HR(Y);!J.equals(10)&&!J.equals(3)||p(J)}))}W.supportHtml||(ge.sanitizer=p=>(W.isTrusted?p.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?p:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=h;let v=W.value??"";v.length>1e5&&(v=`${v.substr(0,1e5)}\u2026`),W.supportThemeIcons&&(v=(0,u.$Lk)(v));let C;if(Q.fillInIncompleteTokens){const p={...o.marked.defaults,...ge},L=o.marked.lexer(v,p),j=ae(L);C=o.marked.parser(j,p)}else C=o.marked.parse(v,ge);W.supportThemeIcons&&(C=(0,f.$gU)(C).map(L=>typeof L=="string"?L:L.outerHTML).join(""));const E=new DOMParser().parseFromString(q(W,C),"text/html");if(E.body.querySelectorAll("img, audio, video, source").forEach(p=>{const L=p.getAttribute("src");if(L){let j=L;try{W.baseUri&&(j=M(r.URI.from(W.baseUri),j))}catch{}if(p.setAttribute("src",z(j,!0)),Q.disallowRemoteImages){const Y=r.URI.parse(j).scheme;Y!==d.Schemas.file&&Y!==d.Schemas.data&&p.replaceWith(i.$("",void 0,p.outerHTML))}}}),E.body.querySelectorAll("a").forEach(p=>{const L=p.getAttribute("href");if(p.setAttribute("href",""),!L||/^data:|javascript:/i.test(L)||/^command:/i.test(L)&&!W.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(L))p.replaceWith(...p.childNodes);else{let j=z(L,!1);W.baseUri&&(j=M(r.URI.from(W.baseUri),L)),p.dataset.href=j}}),Te.innerHTML=q(W,E.body.innerHTML),D.length>0)Promise.all(D).then(p=>{if(Ae)return;const L=new Map(p),j=Te.querySelectorAll("div[data-code]");for(const Y of j){const J=L.get(Y.dataset.code??"");J&&i.$MS(Y,J)}Q.asyncRenderCallback?.()});else if(a.length>0){const p=new Map(a),L=Te.querySelectorAll("div[data-code]");for(const j of L){const Y=p.get(j.dataset.code??"");Y&&i.$MS(j,Y)}}if(Q.asyncRenderCallback)for(const p of Te.getElementsByTagName("img")){const L=we.add(i.$KR(p,"load",()=>{L.dispose(),Q.asyncRenderCallback()}))}return{element:Te,dispose:()=>{Ae=!0,we.dispose()}}}function T(W){if(!W)return"";const Q=W.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:W}function M(W,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:W.path.endsWith("/")?(0,b.$0g)(W,Q).toString():(0,b.$0g)((0,b.$6g)(W),Q).toString()}function q(W,Q){const{config:ge,allowedSchemes:we}=$(W);F.addHook("uponSanitizeAttribute",(Te,Ie)=>{if(Ie.attrName==="style"||Ie.attrName==="class"){if(Te.tagName==="SPAN"){if(Ie.attrName==="style"){Ie.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ie.attrValue);return}else if(Ie.attrName==="class"){Ie.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ie.attrValue);return}}Ie.keepAttr=!1;return}else if(Te.tagName==="INPUT"&&Te.attributes.getNamedItem("type")?.value==="checkbox"){if(Ie.attrName==="type"&&Ie.attrValue==="checkbox"||Ie.attrName==="disabled"||Ie.attrName==="checked"){Ie.keepAttr=!0;return}Ie.keepAttr=!1}}),F.addHook("uponSanitizeElement",(Te,Ie)=>{Ie.tagName==="input"&&(Te.attributes.getNamedItem("type")?.value==="checkbox"?Te.setAttribute("disabled",""):Te.parentElement?.removeChild(Te))});const Ae=i.$7S(we);try{return F.sanitize(Q,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{F.removeHook("uponSanitizeAttribute"),Ae.dispose()}}t.$jU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function $(W){const Q=[d.Schemas.http,d.Schemas.https,d.Schemas.mailto,d.Schemas.data,d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemote,d.Schemas.vscodeRemoteResource];return W.isTrusted&&Q.push(d.Schemas.command),{config:{ALLOWED_TAGS:[...i.$8S],ALLOWED_ATTR:t.$jU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function I(W){return typeof W=="string"?W:V(W)}function V(W){let Q=W.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ge=o.marked.parse(Q,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,we=>R.get(we)??we);return q({isTrusted:!1},ge).toString()}const R=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.$V(()=>{const W=new o.marked.Renderer;return W.code=Q=>Q,W.blockquote=Q=>Q,W.html=Q=>"",W.heading=(Q,ge,we)=>Q+`
`,W.hr=()=>"",W.list=(Q,ge)=>Q,W.listitem=Q=>Q+`
`,W.paragraph=Q=>Q+`
`,W.table=(Q,ge)=>Q+ge+`
`,W.tablerow=Q=>Q,W.tablecell=(Q,ge)=>Q+" ",W.strong=Q=>Q,W.em=Q=>Q,W.codespan=Q=>Q,W.br=()=>`
`,W.del=Q=>Q,W.image=(Q,ge,we)=>"",W.text=Q=>Q,W.link=(Q,ge,we)=>we,W});function O(W){let Q="";return W.forEach(ge=>{Q+=ge.raw}),Q}function X(W){for(let Q=0;Q<W.tokens.length;Q++){const ge=W.tokens[Q];if(ge.type==="text"){const we=ge.raw.split(`
`),Ae=we[we.length-1];if(Ae.includes("`"))return ee(W);if(Ae.includes("**"))return _(W);if(Ae.match(/\*\w/))return ce(W);if(Ae.match(/(^|\s)__\w/))return ue(W);if(Ae.match(/(^|\s)_\w/))return ye(W);if(Ae.match(/(^|\s)\[.*\]\(\w*/)){const Te=W.tokens.slice(Q+1);return Te[0]?.type==="link"&&Te[1]?.type==="text"&&Te[1].raw.match(/^ *"[^"]*$/)?Me(W):Ee(W)}else{if(K(Ae))return Ee(W);if(Ae.match(/(^|\s)\[\w/)&&!W.tokens.slice(Q+1).some(Te=>K(Te.raw)))return le(W)}}}}function K(W){return!!W.match(/^[^\[]*\]\([^\)]*$/)}function ae(W){let Q,ge;for(Q=0;Q<W.length;Q++){const we=W[Q];let Ae;if(we.type==="paragraph"&&(Ae=we.raw.match(/(\n|^)(````*)/))){const Te=Ae[2];ge=ie(W.slice(Q),Te);break}if(we.type==="paragraph"&&we.raw.match(/(\n|^)\|/)){ge=De(W.slice(Q));break}if(Q===W.length-1&&we.type==="paragraph"){const Te=X(we);if(Te){ge=[Te];break}}}if(ge){const we=[...W.slice(0,Q),...ge];return we.links=W.links,we}return W}function ie(W,Q){const ge=O(W);return o.marked.lexer(ge+`
${Q}`)}function ee(W){return re(W,"`")}function ce(W){return re(W,"*")}function ye(W){return re(W,"_")}function Ee(W){return re(W,")")}function Me(W){return re(W,'")')}function le(W){return re(W,"](about:blank)")}function _(W){return re(W,"**")}function ue(W){return re(W,"__")}function re(W,Q){const ge=O(Array.isArray(W)?W:[W]);return o.marked.lexer(ge+Q)[0]}function De(W){const Q=O(W),ge=Q.split(`
`);let we,Ae=!1;for(let Te=0;Te<ge.length;Te++){const Ie=ge[Te].trim();if(typeof we>"u"&&Ie.match(/^\s*\|/)){const z=Ie.match(/(\|[^\|]+)(?=\||$)/g);z&&(we=z.length)}else if(typeof we=="number")if(Ie.match(/^\s*\|/)){if(Te!==ge.length-1)return;Ae=!0}else return}if(typeof we=="number"&&we>0){const Te=Ae?ge.slice(0,-1).join(`
`):Q,Ie=!!Te.match(/\|\s*$/),z=Te+(Ie?"":"|")+`
|${" --- |".repeat(we)}`;return o.marked.lexer(z)}}}),define(me[139],be([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=void 0;const n=i.$,o="selectOption.entry.template";class l{get templateId(){return o}renderTemplate(b){const m=Object.create(null);return m.root=b,m.text=i.$KS(b,n(".option-text")),m.detail=i.$KS(b,n(".option-detail")),m.decoratorRight=i.$KS(b,n(".option-decorator-right")),m}renderElement(b,m,r){const y=r,A=b.text,T=b.detail,M=b.decoratorRight,q=b.isDisabled;y.text.textContent=A,y.detail.textContent=T||"",y.decoratorRight.innerText=M||"",q?y.root.classList.add("option-disabled"):y.root.classList.remove("option-disabled")}disposeTemplate(b){}}class d extends u.$Vc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(b,m,r,y,A){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=y,this.g=A||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=d.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$ce,this.B(this.r),this.Q(),this.P(r),this.n=m||0,b&&this.setOptions(b,m),this.S()}O(b){!this.M&&b?this.M=this.B((0,S.$oU)().setupUpdatableHover((0,k.$CT)("mouse"),this.h,b)):this.M&&this.M.update(b)}getHeight(){return 22}getTemplateId(){return o}P(b){this.u=b,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$KS(this.w,n(".select-box-details-pane"));const m=i.$KS(this.w,n(".select-box-dropdown-container-width-control")),r=i.$KS(m,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$KS(r,this.D),this.G=0,this.y=i.$sS(this.w),this.w.setAttribute("draggable","true"),this.B(i.$KR(this.w,i.$DS.DRAG_START,y=>{i.$FS.stop(y,!0)}))}Q(){this.B(i.$LR(this.h,"change",m=>{this.n=m.target.selectedIndex,this.r.fire({index:m.target.selectedIndex,selected:m.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$KR(this.h,i.$DS.CLICK,m=>{i.$FS.stop(m),this.f?this.Z(!0):this.Y()})),this.B(i.$KR(this.h,i.$DS.MOUSE_DOWN,m=>{i.$FS.stop(m)}));let b;this.B(i.$KR(this.h,"touchstart",m=>{b=this.f})),this.B(i.$KR(this.h,"touchend",m=>{i.$FS.stop(m),b?this.Z(!0):this.Y()})),this.B(i.$KR(this.h,i.$DS.KEY_DOWN,m=>{const r=new B.$HR(m);let y=!1;c.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(y=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(y=!0),y&&(this.Y(),i.$FS.stop(m,!0))}))}get onDidSelect(){return this.r.event}setOptions(b,m){g.$ub(this.m,b)||(this.m=b,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,y)=>{this.h.add(this.X(r.text,y,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),m!==void 0&&(this.select(m),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(b){b>=0&&b<this.m.length?this.n=b:b>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(b){this.g.ariaLabel=b,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(b){this.h.tabIndex=b?0:-1}render(b){this.j=b,b.classList.add("select-container"),b.appendChild(this.h),this.U()}S(){const b=[];this.s.listFocusBackground&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(b.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),b.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),b.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(b.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),b.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&b.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),b.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),b.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=b.join(`
`)}U(){const b=this.s.selectBackground??"",m=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=b,this.h.style.color=m,this.h.style.borderColor=r}W(){const b=this.s.selectBackground??"",m=i.$3S(this.s.selectListBackground,b);this.C.style.backgroundColor=m,this.I.style.backgroundColor=m;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(b,m,r){const y=document.createElement("option");return y.value=b,y.text=b,y.disabled=!!r,y}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:b=>this.ab(b,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:b=>this.ab(b),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(b){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),b&&this.h.focus(),this.u.hideContextView())}ab(b,m){return b.appendChild(this.w),this.cb(m),{dispose:()=>{try{b.removeChild(this.w)}catch{}}}}bb(){let b=0;return this.m.forEach((m,r)=>{this.jb(r),this.I.offsetHeight>b&&(b=this.I.offsetHeight)}),b}cb(b){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const m=i.getWindow(this.h),r=i.$7R(this.h),y=i.getWindow(this.h).getComputedStyle(this.h),A=parseFloat(y.getPropertyValue("--dropdown-padding-top"))+parseFloat(y.getPropertyValue("--dropdown-padding-bottom")),T=m.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),M=r.top-d.b,q=this.h.offsetWidth,$=this.db(this.D),I=Math.max($,Math.round(q)).toString()+"px";this.w.style.width=I,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const R=this.H?this.L:0,x=V+A+R,O=Math.floor((T-A-R)/this.getHeight()),X=Math.floor((M-A-R)/this.getHeight());if(b)return r.top+r.height>m.innerHeight-22||r.top<d.b||O<1&&X<1?!1:(O<d.c&&X>O&&this.m.length>O?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>m.innerHeight-22||r.top<d.b||this.G===0&&O<1||this.G===1&&X<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&O+X<1)return this.Z(!0),!1;x>T&&(V=O*this.getHeight())}else x>M&&(V=X*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+A+"px",this.w.style.height=""):this.w.style.height=V+A+"px",this.jb(this.n),this.w.style.width=I,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(b){let m=0;if(b){let r=0,y=0;this.m.forEach((A,T)=>{const M=A.detail?A.detail.length:0,q=A.decoratorRight?A.decoratorRight.length:0,$=A.text.length+M+q;$>y&&(r=T,y=$)}),b.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),m=i.$9R(b)}return m}eb(b){if(this.z)return;this.C=i.$KS(b,n(".select-box-dropdown-list-container")),this.t=new l,this.z=new f.$fU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:y=>{let A=y.text;return y.detail&&(A+=`. ${y.detail}`),y.decoratorRight&&(A+=`. ${y.decoratorRight}`),y.description&&(A+=`. ${y.description}`),A},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>c.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const m=this.B(new F.$MT(this.C,"keydown")),r=w.Event.chain(m.event,y=>y.filter(()=>this.z.length>0).map(A=>new B.$HR(A)));this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,y=>y.filter(A=>A.keyCode>=21&&A.keyCode<=56||A.keyCode>=85&&A.keyCode<=113))(this.sb,this)),this.B(i.$KR(this.z.getHTMLElement(),i.$DS.POINTER_UP,y=>this.fb(y))),this.B(this.z.onMouseOver(y=>typeof y.index<"u"&&this.z.setFocus([y.index]))),this.B(this.z.onDidChangeFocus(y=>this.ib(y))),this.B(i.$KR(this.w,i.$DS.FOCUS_OUT,y=>{!this.f||i.$cS(y.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(b){if(!this.z.length)return;i.$FS.stop(b);const m=b.target;if(!m||m.classList.contains("slider"))return;const r=m.closest(".monaco-list-row");if(!r)return;const y=Number(r.getAttribute("data-index")),A=r.classList.contains("option-disabled");y>=0&&y<this.m.length&&!A&&(this.n=y,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(b,m){const r=A=>{for(let T=0;T<A.childNodes.length;T++){const M=A.childNodes.item(T);(M.tagName&&M.tagName.toLowerCase())==="img"?A.removeChild(M):r(M)}},y=(0,H.$iU)({value:b,supportThemeIcons:!0},{actionHandler:m});return y.element.classList.add("select-box-description-markdown"),r(y.element),y.element}ib(b){!this.f||!this.H||this.jb(b.indexes[0])}jb(b){this.I.innerText="";const m=this.m[b],r=m?.description??"",y=m?.descriptionIsMarkdown??!1;if(r){if(y){const A=m.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,A))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(b){i.$FS.stop(b),this.select(this.F),this.Z(!0)}lb(b){i.$FS.stop(b),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(b){if(this.n<this.m.length-1){i.$FS.stop(b,!0);const m=this.m[this.n+1].isDisabled;if(m&&this.m.length>this.n+2)this.n+=2;else{if(m)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(b){this.n>0&&(i.$FS.stop(b,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(b){i.$FS.stop(b),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(b){i.$FS.stop(b),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(b){i.$FS.stop(b),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(b){i.$FS.stop(b),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(b){const m=P.KeyCodeUtils.toString(b.keyCode);let r=-1;for(let y=0;y<this.m.length-1;y++)if(r=(y+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===m&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$FS.stop(b);break}}dispose(){this.Z(!1),super.dispose()}}t.$pU=d}),define(me[140],be([1,0,49,139,133,21,5,112]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=t.$rU=void 0,t.$rU={...i.$eU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends H.$lT{constructor(g,w,P,u,c){super(),S.$j&&!c?.useCustomDrawn?this.a=new B.$qU(g,w,u,c):this.a=new F.$pU(g,w,P,u,c),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,w){this.a.setOptions(g,w)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$sU=k}),define(me[73],be([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=t.$zU=t.$yU=void 0;class e extends g.$Vc{get action(){return this._action}constructor(d,N,b={}){super(),this.m=b,this._context=d||this,this._action=N,N instanceof f.$$i&&this.B(N.onDidChange(m=>{this.element&&this.t(m)}))}t(d){d.enabled!==void 0&&this.u(),d.checked!==void 0&&this.H(),d.class!==void 0&&this.G(),d.label!==void 0&&(this.w(),this.D()),d.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new f.$_i)),this.j}set actionRunner(d){this.j=d}isEnabled(){return this._action.enabled}setActionContext(d){this._context=d}render(d){const N=this.element=d;this.B(H.$hT.addTarget(d));const b=this.m&&this.m.draggable;b&&(d.draggable=!0,i.$qR&&this.B((0,B.$KR)(d,B.$DS.DRAG_START,m=>m.dataTransfer?.setData(F.$fT.TEXT,this._action.label)))),this.B((0,B.$KR)(N,H.EventType.Tap,m=>this.onClick(m,!0))),this.B((0,B.$KR)(N,B.$DS.MOUSE_DOWN,m=>{b||B.$FS.stop(m,!0),this._action.enabled&&m.button===0&&N.classList.add("active")})),w.$j&&this.B((0,B.$KR)(N,B.$DS.CONTEXT_MENU,m=>{m.button===0&&m.ctrlKey===!0&&this.onClick(m)})),this.B((0,B.$KR)(N,B.$DS.CLICK,m=>{B.$FS.stop(m,!0),this.m&&this.m.isMenu||this.onClick(m)})),this.B((0,B.$KR)(N,B.$DS.DBLCLICK,m=>{B.$FS.stop(m,!0)})),[B.$DS.MOUSE_UP,B.$DS.MOUSE_OUT].forEach(m=>{this.B((0,B.$KR)(N,m,r=>{B.$FS.stop(r),N.classList.remove("active")}))})}onClick(d,N=!1){B.$FS.stop(d,!0);const b=P.$cg(this._context)?this.m?.useEventAsContext?d:{preserveFocus:N}:this._context;this.actionRunner.run(this._action,b)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(d){this.element&&(this.element.tabIndex=d?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const d=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=d;else if(!this.f&&d!==""){const N=this.m.hoverDelegate??(0,S.$CT)("element");this.f=this.q.add((0,c.$oU)().setupUpdatableHover(N,this.element,d))}else this.f&&this.f.update(d)}F(){if(this.element){const d=this.C()??"";this.element.setAttribute("aria-label",d)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$yU=e;class n extends e{constructor(d,N,b){super(d,N,b),this.m=b,this.m.icon=b.icon!==void 0?b.icon:!1,this.m.label=b.label!==void 0?b.label:!0,this.L=""}render(d){super.render(d),P.$dg(this.element);const N=document.createElement("a");if(N.classList.add("action-label"),N.setAttribute("role",this.M()),this.I=N,this.element.appendChild(N),this.m.label&&this.m.keybinding){const b=document.createElement("span");b.classList.add("keybinding"),b.textContent=this.m.keybinding,this.element.appendChild(b)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===f.$aj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(d){this.I&&(this.I.tabIndex=d?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let d=null;return this.action.tooltip?d=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(d=this.action.label,this.m.keybinding&&(d=u.localize(0,null,d,this.m.keybinding))),d??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const d=this.C()??"";this.I.setAttribute("aria-label",d)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$zU=n;class o extends e{constructor(d,N,b,m,r,y,A){super(d,N),this.b=new k.$sU(b,m,r,y,A),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(d,N){this.b.setOptions(d,N)}select(d){this.b.select(d)}g(){this.B(this.b.onDidSelect(d=>this.n(d.selected,d.index)))}n(d,N){this.actionRunner.run(this._action,this.r(d,N))}r(d,N){return d}setFocusable(d){this.b.setFocusable(d)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(d){this.b.render(d)}}t.$AU=o}),define(me[74],be([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,i,F,B,H,S,k,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=t.ActionsOrientation=void 0,t.$FT=u;var w;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class P extends f.$Vc{constructor(e,n={}){super(),this.j=this.B(new f.$Uc),this.s=this.B(new f.$5c),this.y=!1,this.z=!0,this.D=this.B(new k.$ce),this.onDidBlur=this.D.event,this.F=this.B(new k.$ce({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new k.$ce),this.onDidRun=this.H.event,this.I=this.B(new k.$ce),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,H.$DT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new S.$_i,this.j.add(this.g)),this.j.add(this.g.onDidRun(d=>this.H.fire(d))),this.j.add(this.g.onWillRun(d=>this.I.fire(d))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let o,l;switch(this.n){case 0:o=[15],l=[17];break;case 1:o=[16],l=[18],this.domNode.className+=" vertical";break}this.B(i.$KR(this.domNode,i.$DS.KEY_DOWN,d=>{const N=new F.$HR(d);let b=!0;const m=typeof this.u=="number"?this.viewItems[this.u]:void 0;o&&(N.equals(o[0])||N.equals(o[1]))?b=this.Q():l&&(N.equals(l[0])||N.equals(l[1]))?b=this.P():N.equals(9)&&this.G?this.F.fire():N.equals(14)?b=this.N():N.equals(13)?b=this.O():N.equals(2)&&m instanceof B.$yU&&m.trapsArrowNavigation?b=this.P():this.L(N)?this.r.keyDown?this.S(N):this.y=!0:b=!1,b&&(N.preventDefault(),N.stopPropagation())})),this.B(i.$KR(this.domNode,i.$DS.KEY_UP,d=>{const N=new F.$HR(d);this.L(N)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(N)),N.preventDefault(),N.stopPropagation()):(N.equals(2)||N.equals(1026)||N.equals(16)||N.equals(18)||N.equals(15)||N.equals(17))&&this.M()})),this.w=this.B(i.$IS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$kS()===this.domNode||!i.$cS(i.$kS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(o=>o instanceof B.$yU&&o.isEnabled());n instanceof B.$yU&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof B.$yU&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(o=>{n=n||e.equals(o)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$cS(i.$kS(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const o=Array.isArray(e)?e:[e];let l=g.$0f(n.index)?n.index:null;o.forEach(d=>{const N=document.createElement("li");N.className="action-item",N.setAttribute("role","presentation");let b;const m={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(b=this.b.actionViewItemProvider(d,m)),b||(b=new B.$zU(this.context,d,m)),this.b.allowContextMenu||this.s.set(b,i.$KR(N,i.$DS.CONTEXT_MENU,r=>{i.$FS.stop(r,!0)})),b.actionRunner=this.g,b.setActionContext(this.context),b.render(N),this.z&&b instanceof B.$yU&&this.viewItems.length===0&&b.setFocusable(!0),l===null||l<0||l>=this.C.children.length?(this.C.appendChild(N),this.viewItems.push(b)):(this.C.insertBefore(N,this.C.children[l]),this.viewItems.splice(l,0,b),l++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,f.$Qc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,f.$Qc)(this.viewItems),this.s.clearAndDisposeAll(),i.$JR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,o;if(e===void 0?n=!0:typeof e=="number"?o=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const l=this.viewItems.findIndex(d=>d.isEnabled());this.u=l===-1?void 0:l,this.R(void 0,void 0,!0)}else o!==void 0&&(this.u=o),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===S.$aj.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===S.$aj.ID));return this.R(!0),!0}R(e,n,o=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const l=this.u!==void 0?this.viewItems[this.u]:void 0;if(l){let d=!0;g.$hg(l.focus)||(d=!1),this.b.focusOnlyEnabledItems&&g.$hg(l.isEnabled)&&!l.isEnabled()&&(d=!1),l.action.id===S.$aj.ID&&(d=!1),d?(o||this.t!==this.u)&&(l.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),d&&l.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof B.$yU){const o=n._context===null||n._context===void 0?e:n._context;this.run(n._action,o)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,f.$Qc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$ET=P;function u(c){if(!c.length)return c;let e=-1;for(let o=0;o<c.length;o++)if(c[o].id!==S.$aj.ID){e=o;break}if(e===-1)return[];c=c.slice(e);for(let o=c.length-1;o>=0&&c[o].id===S.$aj.ID;o--)c.splice(o,1);let n=!1;for(let o=c.length-1;o>=0;o--){const l=c[o].id===S.$aj.ID;l&&!n?c.splice(o,1):l?l&&(n=!1):n=!0}return c}}),define(me[75],be([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=t.$gV=t.$fV=t.MessageType=void 0;const n=i.$;var o;(function(N){N[N.INFO=1]="INFO",N[N.WARNING=2]="WARNING",N[N.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.$fV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends w.$lT{constructor(b,m,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$ce),this.onDidChange=this.P.event,this.Q=this.B(new P.$ce),this.onDidHeightChange=this.Q.event,this.a=m,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$KS(b,n(".monaco-inputbox.idle"));const y=this.g.flexibleHeight?"textarea":"input",A=i.$KS(this.element,n(".ibwrapper"));if(this.b=i.$KS(A,n(y+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$KS(A,n("div.mirror")),this.y.innerText="\xA0",this.N=new g.$vT(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$KS(b,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(q=>this.b.scrollTop=q.scrollTop));const T=this.B(new F.$MT(b.ownerDocument,"selectionchange")),M=P.Event.filter(T.event,()=>b.ownerDocument.getSelection()?.anchorNode===A);this.B(M(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$ET(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(b){this.n=b,this.b.setAttribute("placeholder",b)}setTooltip(b){this.r=b,this.O?this.O.update(b):this.O=this.B((0,k.$oU)().setupUpdatableHover((0,f.$CT)("mouse"),this.b,b))}setAriaLabel(b){this.s=b,b?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(b){this.b.value!==b&&(this.b.value=b,this.Z())}get step(){return this.b.step}set step(b){this.b.step=b}get height(){return typeof this.J=="number"?this.J:i.$aS(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$lS(this.b)}select(b=null){this.b.select(),b&&(this.b.setSelectionRange(b.start,b.end),b.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const b=this.b.selectionStart;if(b===null)return null;const m=this.b.selectionEnd??b;return{start:b,end:m}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(b){b?this.enable():this.disable()}get width(){return i.$9R(this.b)}set width(b){if(this.g.flexibleHeight&&this.g.flexibleWidth){let m=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,y=parseFloat(this.y.style.paddingRight||"")||0;m=r+y}this.b.style.width=b-m+"px"}else this.b.style.width=b+"px";this.y&&(this.y.style.width=b+"px")}set paddingRight(b){this.b.style.width=`calc(100% - ${b}px)`,this.y&&(this.y.style.paddingRight=b+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const b=this.L,m=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:b,height:m}),this.N.setScrollPosition({scrollTop:r})}showMessage(b,m){if(this.w==="open"&&(0,c.$4n)(this.h,b))return;this.h=b,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(b.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$3S(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||m)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let b=null;return this.t&&(b=this.t(this.value),b?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(b)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),b?.type}stylesForType(b){const m=this.g.inputBoxStyles;switch(b){case 1:return{border:m.inputValidationInfoBorder,background:m.inputValidationInfoBackground,foreground:m.inputValidationInfoForeground};case 2:return{border:m.inputValidationWarningBorder,background:m.inputValidationWarningBackground,foreground:m.inputValidationWarningForeground};default:return{border:m.inputValidationErrorBorder,background:m.inputValidationErrorBackground,foreground:m.inputValidationErrorForeground}}}W(b){switch(b){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let b;const m=()=>b.style.width=i.$9R(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:y=>{if(!this.h)return null;b=i.$KS(y,n(".monaco-inputbox-container")),m();const A={inline:!0,className:"monaco-inputbox-message"},T=this.h.formatContent?(0,B.$KT)(this.h.content,A):(0,B.$JT)(this.h.content,A);T.classList.add(this.W(this.h.type));const M=this.stylesForType(this.h.type);return T.style.backgroundColor=M.background??"",T.style.color=M.foreground??"",T.style.border=M.border?`1px solid ${M.border}`:"",i.$KS(b,T),null},onHide:()=>{this.w="closed"},layout:m});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),S.$OT(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const b=this.value,r=b.charCodeAt(b.length-1)===10?" ":"";(b+r).replace(/\u000c/g,"")?this.y.textContent=b+r:this.y.innerText="\xA0",this.layout()}bb(){const b=this.g.inputBoxStyles,m=b.inputBackground??"",r=b.inputForeground??"",y=b.inputBorder??"";this.element.style.backgroundColor=m,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$3S(y,"transparent")}`}layout(){if(!this.y)return;const b=this.L;this.L=i.$aS(this.y),b!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(b){const m=this.inputElement,r=m.selectionStart,y=m.selectionEnd,A=m.value;r!==null&&y!==null&&(this.value=A.substr(0,r)+b+A.substr(y),m.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$gV=l;class d extends l{constructor(b,m,r){const y=e.localize(3,null,"\u21C5"),A=e.localize(4,null,"\u21C5");super(b,m,r),this.eb=this.B(new P.$ce),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$ce),this.onDidBlur=this.fb.event,this.cb=new u.$dV(r.history,100);const T=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(y)&&!this.n.endsWith(A)&&this.cb.getHistory().length){const M=this.n.endsWith(")")?y:A,q=this.n+M;r.showPlaceholderOnFocus&&!i.$lS(this.b)?this.n=q:this.setPlaceHolder(q)}};this.db=new MutationObserver((M,q)=>{M.forEach($=>{$.target.textContent||T()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>T()),this.F(this.b,()=>{const M=q=>{if(this.n.endsWith(q)){const $=this.n.slice(0,this.n.length-q.length);return r.showPlaceholderOnFocus?this.n=$:this.setPlaceHolder($),!0}else return!1};M(A)||M(y)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(b){this.value&&(b||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(b){const m=this.getHistory();this.clearHistory(),b.forEach(r=>{this.cb.add(r)}),m.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let b=this.kb();b&&(b=b===this.value?this.kb():b),this.value=b??"",S.$PT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let b=this.jb();b&&(b=b===this.value?this.jb():b),b&&(this.value=b,S.$PT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(b){super.setPlaceHolder(b),this.setTooltip(b)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let b=this.cb.current();return b||(b=this.cb.last(),this.cb.next()),b}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$hV=d}),define(me[76],be([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,i,F,B,H,S,k,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=t.$vU=t.$uU=t.$tU=void 0,t.$tU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$yU{constructor(n,o,l){super(n,o,l),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$uU=w;class P extends F.$lT{constructor(n){super(),this.a=this.B(new S.$ce),this.onChange=this.a.event,this.b=this.B(new S.$ce),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,g.$oU)().setupUpdatableHover(n.hoverDelegate??(0,f.$CT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}set visible(n){this.domNode.style.display=n?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$vU=P;class u extends F.$lT{constructor(n,o,l){super(),this.g=n,this.h=o,this.a=this.B(new S.$ce),this.onChange=this.a.event,this.b=this.B(new P({title:this.g,isChecked:this.h,icon:B.$Sj.check,actionClassName:"monaco-checkbox",...t.$tU})),this.domNode=this.b.domNode,this.c=l,this.n(),this.B(this.b.onChange(d=>{this.n(),this.a.fire(d)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$lS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$wU=u;class c extends i.$yU{constructor(n,o,l){super(n,o,l),this.a=this.B(new u(this._action.label,!!this._action.checked,l.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const o=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$KR)(o,k.$DS.CLICK,l=>{this.a.checked=!this.a.checked,l.stopPropagation(),l.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$xU=c}),define(me[141],be([1,0,14,76,18,119]),function(se,t,i,F,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uV=t.$tV=t.$sV=void 0;const S=H.localize(0,null),k=H.localize(1,null),f=H.localize(2,null);class g extends F.$vU{constructor(c){super({icon:B.$Sj.caseSensitive,title:S+c.appendTitle,isChecked:c.isChecked,hoverDelegate:c.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:c.inputActiveOptionBorder,inputActiveOptionForeground:c.inputActiveOptionForeground,inputActiveOptionBackground:c.inputActiveOptionBackground})}}t.$sV=g;class w extends F.$vU{constructor(c){super({icon:B.$Sj.wholeWord,title:k+c.appendTitle,isChecked:c.isChecked,hoverDelegate:c.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:c.inputActiveOptionBorder,inputActiveOptionForeground:c.inputActiveOptionForeground,inputActiveOptionBackground:c.inputActiveOptionBackground})}}t.$tV=w;class P extends F.$vU{constructor(c){super({icon:B.$Sj.regex,title:f+c.appendTitle,isChecked:c.isChecked,hoverDelegate:c.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:c.inputActiveOptionBorder,inputActiveOptionForeground:c.inputActiveOptionForeground,inputActiveOptionBackground:c.inputActiveOptionBackground})}}t.$uV=P}),define(me[142],be([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,i,F,B,H,S,k,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vV=void 0;const w=k.localize(0,null);class P extends H.$lT{static{this.OPTION_CHANGE="optionChange"}constructor(c,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Wc),this.N=[],this.O=this.B(new S.$ce),this.onDidOptionChange=this.O.event,this.P=this.B(new S.$ce),this.onKeyDown=this.P.event,this.Q=this.B(new S.$ce),this.onMouseDown=this.Q.event,this.R=this.B(new S.$ce),this.onInput=this.R.event,this.S=this.B(new S.$ce),this.onKeyUp=this.S.event,this.U=this.B(new S.$ce),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new S.$ce),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||w,this.h=!!n.showCommonFindToggles;const o=n.appendCaseSensitiveLabel||"",l=n.appendWholeWordsLabel||"",d=n.appendRegexLabel||"",N=n.history||[],b=!!n.flexibleHeight,m=!!n.flexibleWidth,r=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$hV(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:N,showHistoryHint:n.showHistoryHint,flexibleHeight:b,flexibleWidth:m,flexibleMaxHeight:r,inputBoxStyles:n.inputBoxStyles}));const y=this.B((0,g.$DT)());if(this.h){this.J=this.B(new F.$uV({appendTitle:d,isChecked:!1,hoverDelegate:y,...n.toggleStyles})),this.B(this.J.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(T=>{this.W.fire(T)})),this.L=this.B(new F.$tV({appendTitle:l,isChecked:!1,hoverDelegate:y,...n.toggleStyles})),this.B(this.L.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new F.$sV({appendTitle:o,isChecked:!1,hoverDelegate:y,...n.toggleStyles})),this.B(this.M.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(T=>{this.U.fire(T)}));const A=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const M=A.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let q=-1;T.equals(17)?q=(M+1)%A.length:T.equals(15)&&(M===0?q=A.length-1:q=M-1),T.equals(9)?(A[M].blur(),this.inputBox.focus()):q>=0&&A[q].focus(),i.$FS.stop(T,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),c?.appendChild(this.domNode),this.B(i.$KR(this.inputBox.inputElement,"compositionstart",A=>{this.s=!0})),this.B(i.$KR(this.inputBox.inputElement,"compositionend",A=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,A=>this.P.fire(A)),this.C(this.inputBox.inputElement,A=>this.S.fire(A)),this.D(this.inputBox.inputElement,A=>this.R.fire()),this.j(this.inputBox.inputElement,A=>this.Q.fire(A))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(c){this.inputBox.layout(),this.X(c.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const c of this.N)c.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const c of this.N)c.disable()}setFocusInputOnOptionClick(c){this.n=c}setEnabled(c){c?this.enable():this.disable()}setAdditionalToggles(c){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new f.$Uc;for(const e of c??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(c=!1){c?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(c){this.inputBox.value!==c&&(this.inputBox.value=c)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(c){this.M&&(this.M.checked=c)}getWholeWords(){return this.L?.checked??!1}setWholeWords(c){this.L&&(this.L.checked=c)}getRegex(){return this.J?.checked??!1}setRegex(c){this.J&&(this.J.checked=c,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(c){this.inputBox.showMessage(c)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$vV=P}),define(me[143],be([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n,o,l,d,N,b,m,r,y,A,T,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7V=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$6V=t.$5V=t.$4V=t.RenderIndentGuides=t.$3V=t.$2V=void 0;class q extends f.$WT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(E=>E.element)),this.c=s}}function $(C){return C instanceof f.$WT?new q(C):C}class I{constructor(s,E){this.d=s,this.f=E,this.b=m.$Vc.None,this.c=new m.$Uc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,E){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(p=>p.element),E)}onDragStart(s,E){this.f.onDragStart?.($(s),E)}onDragOver(s,E,p,L,j,Y=!0){const J=this.f.onDragOver($(s),E&&E.element,p,L,j),oe=this.a!==E;if(oe&&(this.b.dispose(),this.a=E),typeof E>"u")return J;if(oe&&typeof J!="boolean"&&J.autoExpand&&(this.b=(0,n.$vh)(()=>{const Oe=this.d(),Ne=Oe.getNodeLocation(E);Oe.isCollapsed(Ne)&&Oe.setCollapsed(Ne,!1),this.a=void 0},500,this.c)),typeof J=="boolean"||!J.accept||typeof J.bubble>"u"||J.feedback){if(!Y){const Oe=typeof J=="boolean"?J:J.accept,Ne=typeof J=="boolean"?void 0:J.effect;return{accept:Oe,effect:Ne,feedback:[p]}}return J}if(J.bubble===1){const Oe=this.d(),Ne=Oe.getNodeLocation(E),Fe=Oe.getParentNodeLocation(Ne),We=Oe.getNode(Fe),Ue=Fe&&Oe.getListIndex(Fe);return this.onDragOver(s,We,Ue,L,j,!1)}const pe=this.d(),fe=pe.getNodeLocation(E),Le=pe.getListIndex(fe),ke=pe.getListRenderCount(fe);return{...J,feedback:(0,e.$Sb)(Le,Le+ke)}}drop(s,E,p,L,j){this.b.dispose(),this.a=void 0,this.f.drop($(s),E&&E.element,p,L,j)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function V(C,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(E){return s.identityProvider.getId(E.element)}},dnd:s.dnd&&new I(C,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return s.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return s.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(E){const p=C(),L=p.getNodeLocation(E),j=p.getParentNodeLocation(L);return p.getNode(j).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?E=>s.accessibilityProvider.isChecked(E.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?E=>s.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return s.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?E=>s.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(E=>s.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class R{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,E){this.a.setDynamicHeight?.(s.element,E)}}t.$2V=R;class x{static lift(s){return s instanceof x?s:new x(s)}static empty(s=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const E of s.expanded)this.expanded[E]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$3V=x;var O;(function(C){C.None="none",C.OnHover="onHover",C.Always="always"})(O||(t.RenderIndentGuides=O={}));class X{get elements(){return this.b}constructor(s,E=[]){this.b=E,this.a=new m.$Uc,this.onDidChange=N.Event.forEach(s,p=>this.b=p,this.a)}dispose(){this.a.dispose()}}class K{static{this.a=8}constructor(s,E,p,L,j,Y={}){this.o=s,this.p=E,this.q=L,this.s=j,this.b=new Map,this.c=new Map,this.d=K.a,this.f=!1,this.g=!1,this.j=new Set,this.k=m.$Vc.None,this.m=new m.$Uc,this.templateId=s.templateId,this.updateOptions(Y),N.Event.map(p,J=>J.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const E=(0,r.$ym)(s.indent,0,40);if(E!==this.d){this.d=E;for(const[p,L]of this.c)this.v(p,L)}}if(typeof s.renderIndentGuides<"u"){const E=s.renderIndentGuides!==O.None;if(E!==this.g){this.g=E;for(const[p,L]of this.c)this.w(p,L);if(this.k.dispose(),E){const p=new m.$Uc;this.q.onDidChange(this.x,this,p),this.k=p,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const E=(0,i.$KS)(s,(0,i.$)(".monaco-tl-row")),p=(0,i.$KS)(E,(0,i.$)(".monaco-tl-indent")),L=(0,i.$KS)(E,(0,i.$)(".monaco-tl-twistie")),j=(0,i.$KS)(E,(0,i.$)(".monaco-tl-contents")),Y=this.o.renderTemplate(j);return{container:s,indent:p,twistie:L,indentGuidesDisposable:m.$Vc.None,templateData:Y}}renderElement(s,E,p,L){this.c.set(s,p),this.b.set(s.element,s),this.v(s,p),this.o.renderElement(s,E,p.templateData,L)}disposeElement(s,E,p,L){p.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,E,p.templateData,L),typeof L=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const E=this.b.get(s);E&&this.u(E)}u(s){const E=this.c.get(s);E&&(this.x(this.q.elements),this.v(s,E))}v(s,E){const p=K.a+(s.depth-1)*this.d;E.twistie.style.paddingLeft=`${p}px`,E.indent.style.width=`${p+this.d-16}px`,s.collapsible?E.container.setAttribute("aria-expanded",String(!s.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...l.ThemeIcon.asClassNameArray(o.$Sj.treeItemExpanded));let L=!1;this.o.renderTwistie&&(L=this.o.renderTwistie(s.element,E.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(L||E.twistie.classList.add(...l.ThemeIcon.asClassNameArray(o.$Sj.treeItemExpanded)),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",s.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this.w(s,E)}w(s,E){if((0,i.$JR)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const p=new m.$Uc,L=this.p();for(;;){const j=L.getNodeLocation(s),Y=L.getParentNodeLocation(j);if(!Y)break;const J=L.getNode(Y),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(J)&&oe.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(oe):E.indent.insertBefore(oe,E.indent.firstElementChild),this.s.add(J,oe),p.add((0,m.$Tc)(()=>this.s.delete(J,oe))),s=J}E.indentGuidesDisposable=p}x(s){if(!this.g)return;const E=new Set,p=this.p();s.forEach(L=>{const j=p.getNodeLocation(L);try{const Y=p.getParentNodeLocation(j);L.collapsible&&L.children.length>0&&!L.collapsed?E.add(L):Y&&E.add(p.getNode(Y))}catch{}}),this.j.forEach(L=>{E.has(L)||this.s.forEach(L,j=>j.classList.remove("active"))}),E.forEach(L=>{this.j.has(L)||this.s.forEach(L,j=>j.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,m.$Qc)(this.m)}}t.$4V=K;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,E,p){this.g=s,this.j=E,this.k=p,this.a=0,this.b=0,this.c="",this.d="",this.f=new m.$Uc,s.onWillRefilter(this.m,this,this.f)}filter(s,E){let p=1;if(this.k){const Y=this.k.filter(s,E);if(typeof Y=="boolean"?p=Y?1:0:(0,P.$YV)(Y)?p=(0,P.$ZV)(Y.visibility):p=Y,p===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:p};const L=this.j.getKeyboardNavigationLabel(s),j=Array.isArray(L)?L:[L];for(const Y of j){const J=Y&&Y.toString();if(typeof J>"u")return{data:b.FuzzyScore.Default,visibility:p};let oe;if(this.g.findMatchType===Ee.Contiguous){const pe=J.toLowerCase().indexOf(this.d);if(pe>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let fe=this.d.length;fe>0;fe--)oe.push(pe+fe-1)}}else oe=(0,b.$Hk)(this.c,this.d,0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,j.length===1?{data:oe,visibility:p}:{data:{label:J,score:oe},visibility:p}}return this.g.findMode===ye.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:b.FuzzyScore.Default,visibility:p}}m(){this.a=0,this.b=0}dispose(){(0,m.$Qc)(this.f)}}class ie extends w.$vU{constructor(s){super({icon:o.$Sj.listFilter,title:(0,A.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,T.$CT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$5V=ie;class ee extends w.$vU{constructor(s){super({icon:o.$Sj.searchFuzzy,title:(0,A.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,T.$CT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$6V=ee;const ce={inputBoxStyles:k.$fV,toggleStyles:w.$tU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ye;(function(C){C[C.Highlight=0]="Highlight",C[C.Filter=1]="Filter"})(ye||(t.TreeFindMode=ye={}));var Ee;(function(C){C[C.Fuzzy=0]="Fuzzy",C[C.Contiguous=1]="Contiguous"})(Ee||(t.TreeFindMatchType=Ee={}));class Me extends m.$Vc{set mode(s){this.b.checked=s===ye.Filter,this.f.inputBox.setPlaceHolder(s===ye.Filter?(0,A.localize)(2,null):(0,A.localize)(3,null))}set matchType(s){this.c.checked=s===Ee.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,E,p,L,j,Y){super(),this.t=E,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new N.$ce,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,m.$Tc)(()=>s.removeChild(this.a.root)));const J=Y?.styles??ce;J.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=J.listFilterWidgetBackground),J.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${J.listFilterWidgetShadow}`);const oe=this.B((0,T.$DT)());this.b=this.B(new ie({...J.toggleStyles,isChecked:L===ye.Filter,hoverDelegate:oe})),this.c=this.B(new ee({...J.toggleStyles,isChecked:j===Ee.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=N.Event.map(this.b.onChange,()=>this.b.checked?ye.Filter:ye.Highlight,this.q),this.onDidChangeMatchType=N.Event.map(this.c.onChange,()=>this.c.checked?Ee.Fuzzy:Ee.Contiguous,this.q),this.f=this.B(new S.$vV(this.a.findInput,p,{label:(0,A.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:J.inputBoxStyles,toggleStyles:J.toggleStyles,history:Y?.history})),this.g=this.B(new H.$ET(this.a.actionbar)),this.mode=L;const pe=this.B(new F.$MT(this.f.inputBox.inputElement,"keydown")),fe=N.Event.chain(pe.event,Ne=>Ne.map(Fe=>new B.$HR(Fe)));this.B(fe(Ne=>{if(Ne.equals(3)){Ne.preventDefault(),Ne.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ne.equals(18)){Ne.preventDefault(),Ne.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ne.equals(16)){Ne.preventDefault(),Ne.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Le=this.B(new c.$$i("close",(0,A.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Le,{icon:!0,label:!1});const ke=this.B(new F.$MT(this.a.grab,"mousedown"));this.B(ke.event(Ne=>{const Fe=new m.$Uc,We=Fe.add(new F.$MT((0,i.getWindow)(Ne),"mousemove")),Ue=Fe.add(new F.$MT((0,i.getWindow)(Ne),"mouseup")),Ye=this.m,_e=Ne.pageX,Z=this.s,ne=Ne.pageY;this.a.grab.classList.add("grabbing");const $e=this.a.root.style.transition;this.a.root.style.transition="unset";const ve=Re=>{const ze=Re.pageX-_e;this.m=Ye-ze;const Ve=Re.pageY-ne;this.s=Z+Ve,this.layout()};Fe.add(We.event(ve)),Fe.add(Ue.event(Re=>{ve(Re),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=$e,Fe.dispose()}))}));const Oe=N.Event.chain(this.B(new F.$MT(this.a.grab,"keydown")).event,Ne=>Ne.map(Fe=>new B.$HR(Fe)));this.B(Oe(Ne=>{let Fe,We;if(Ne.keyCode===15?Fe=Number.POSITIVE_INFINITY:Ne.keyCode===17?Fe=0:Ne.keyCode===10&&(Fe=this.m===0?Number.POSITIVE_INFINITY:0),Ne.keyCode===16?We=0:Ne.keyCode===18&&(We=Number.POSITIVE_INFINITY),Fe!==void 0&&(Ne.preventDefault(),Ne.stopPropagation(),this.m=Fe,this.layout()),We!==void 0){Ne.preventDefault(),Ne.stopPropagation(),this.s=We;const Ue=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ue},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,r.$ym)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$ym)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$uh)(300),super.dispose()}}class le{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,E,p,L,j,Y={}){this.t=s,this.u=p,this.v=L,this.w=j,this.x=Y,this.b="",this.c="",this.j=0,this.k=new N.$ce,this.onDidChangeMode=this.k.event,this.m=new N.$ce,this.onDidChangeMatchType=this.m.event,this.o=new N.$ce,this.onDidChangePattern=this.o.event,this.p=new N.$ce,this.onDidChangeOpenState=this.p.event,this.q=new m.$Uc,this.s=new m.$Uc,this.d=s.options.defaultFindMode??ye.Highlight,this.f=s.options.defaultFindMatchType??Ee.Fuzzy,E.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Me(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,p=>!b.FuzzyScore.isDefault(p.filterData));const E=this.t.getFocus();if(E.length>0){const p=E[0];this.t.getRelativeTop(p)===null&&this.t.reveal(p,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,A.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(C,s){return C.position===s.position&&ue(C,s)}function ue(C,s){return C.node.element===s.node.element&&C.startIndex===s.startIndex&&C.height===s.height&&C.endIndex===s.endIndex}class re{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const E=this.stickyNodes[this.count-2];return E.position+E.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ue)||this.count===0)return!1;const E=this.stickyNodes[this.count-1],p=s.stickyNodes[s.count-1];return E.position!==p.position}}class De{constrainStickyScrollNodes(s,E,p){for(let L=0;L<s.length;L++){const j=s[L];if(j.position+j.height>p||L>=E)return s.slice(0,L)}return s}}class W extends m.$Vc{constructor(s,E,p,L,j,Y={}){super(),this.g=s,this.j=E,this.m=p,this.s=j,this.c=.4;const J=this.validateStickySettings(Y);this.b=J.stickyScrollMaxItemCount,this.a=Y.stickyScrollDelegate??new De,this.f=this.B(new Q(p.getScrollableElement(),p,s,L,j,Y.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(p.onDidScroll(()=>this.u())),this.B(p.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let E;if(s===0?E=this.m.firstVisibleIndex:E=this.m.indexAt(s+this.m.scrollTop),!(E<0||E>=this.m.length))return this.m.element(E)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const E=this.w(s);this.f.setState(E)}w(s){const E=[];let p=s,L=0,j=this.z(p,void 0,L);for(;j&&(E.push(j),L+=j.height,!(E.length<=this.b&&(p=this.y(j),!p)));)j=this.z(p,j.node,L);const Y=this.H(E);return Y.length?new re(Y):void 0}y(s){return this.t(s.position+s.height)}z(s,E,p){const L=this.F(s,E);if(L&&!(L===s&&(!this.J(s)||this.C(s,p))))return this.D(L,p)}C(s,E){const p=this.L(s),L=this.m.getElementTop(p),j=E;return this.m.scrollTop===L-j}D(s,E){const p=this.s.getHeight(s),{startIndex:L,endIndex:j}=this.M(s),Y=this.G(j,E,p);return{node:s,position:Y,height:p,startIndex:L,endIndex:j}}F(s,E=void 0){let p=s,L=this.I(p);for(;L;){if(L===E)return p;p=L,L=this.I(p)}if(E===void 0)return p}G(s,E,p){let L=this.m.getRelativeTop(s);if(L===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const pe=this.s.getHeight(this.m.element(s)),fe=this.m.getRelativeTop(s+1);L=fe?fe-pe/this.m.renderHeight:null}if(L===null)return E;const j=this.m.element(s),Y=this.s.getHeight(j),oe=L*this.m.renderHeight+Y;return E+p>oe&&E<=oe?oe-p:E}H(s){if(s.length===0)return[];const E=this.m.renderHeight*this.c,p=s[s.length-1];if(s.length<=this.b&&p.position+p.height<=E)return s;const L=this.a.constrainStickyScrollNodes(s,this.b,E);if(!L.length)return[];const j=L[L.length-1];if(L.length>this.b||j.position+j.height>E)throw new Error("stickyScrollDelegate violates constraints");return L}I(s){const E=this.j.getNodeLocation(s),p=this.j.getParentNodeLocation(E);return p?this.j.getNode(p):void 0}J(s){const E=this.j.getNodeLocation(s);return this.j.getListRenderCount(E)>1}L(s){const E=this.j.getNodeLocation(s);return this.j.getListIndex(E)}M(s){const E=this.j.getNodeLocation(s),p=this.j.getListIndex(E);if(p<0)throw new Error("Node not found in tree");const L=this.j.getListRenderCount(E),j=p+L-1;return{startIndex:p,endIndex:j}}nodePositionTopBelowWidget(s){const E=[];let p=this.I(s);for(;p;)E.push(p),p=this.I(p);let L=0;for(let j=0;j<E.length&&j<this.b;j++)L+=this.s.getHeight(E[j]);return L}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const E=this.validateStickySettings(s);this.b!==E.stickyScrollMaxItemCount&&(this.b=E.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let E=7;return typeof s.stickyScrollMaxItemCount=="number"&&(E=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:E}}}class Q{constructor(s,E,p,L,j,Y){this.g=E,this.j=p,this.k=L,this.m=j,this.o=Y,this.c=[],this.d=new m.$Uc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const J=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(J),this.f=new ge(this.a,E),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(E=>E.node===s)}setState(s){const E=!!this.b&&this.b.count>0,p=!!s&&s.count>0;if(!E&&!p||E&&p&&this.b.equal(s))return;if(E!==p&&this.s(p),!p){this.b=void 0,this.c=[],this.d.clear();return}const L=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${L.position}px`;else{this.d.clear();const j=Array(s.count);for(let Y=s.count-1;Y>=0;Y--){const J=s.stickyNodes[Y],{element:oe,disposable:pe}=this.p(J,Y,s.count);j[Y]=oe,this.a.appendChild(oe),this.d.add(pe)}this.f.updateElements(j,s),this.c=j}this.b=s,this.a.style.height=`${L.position+L.height}px`}p(s,E,p){const L=s.startIndex,j=document.createElement("div");j.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(j.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(j.style.lineHeight=`${s.height}px`),j.classList.add("monaco-tree-sticky-row"),j.classList.add("monaco-list-row"),j.setAttribute("data-index",`${L}`),j.setAttribute("data-parity",L%2===0?"even":"odd"),j.setAttribute("id",this.g.getElementID(L));const Y=this.q(j,s.node.element,E,p),J=this.m.getTemplateId(s.node),oe=this.k.find(ke=>ke.templateId===J);if(!oe)throw new Error(`No renderer found for template id ${J}`);let pe=s.node;pe===this.j.getNode(this.j.getNodeLocation(s.node))&&(pe=new Proxy(s.node,{}));const fe=oe.renderTemplate(j);oe.renderElement(pe,s.startIndex,fe,s.height);const Le=(0,m.$Tc)(()=>{Y.dispose(),oe.disposeElement(pe,s.startIndex,fe,s.height),oe.disposeTemplate(fe),j.remove()});return{element:j,disposable:Le}}q(s,E,p,L){if(!this.o)return m.$Vc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(E,p,L))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(E,p))),this.o.getRole&&s.setAttribute("role",this.o.getRole(E)??"treeitem");const j=this.o.getAriaLabel(E),Y=j&&typeof j!="string"?j:(0,M.constObservable)(j),J=(0,M.autorun)(pe=>{const fe=pe.readObservable(Y);fe?s.setAttribute("aria-label",fe):s.removeAttribute("aria-label")});typeof j=="string"||j&&s.setAttribute("aria-label",j.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(E);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),J}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ge extends m.$Vc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,E){super(),this.s=s,this.t=E,this.a=-1,this.b=[],this.f=new N.$ce,this.onDidChangeHasFocus=this.f.event,this.g=new N.$ce,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(p=>this.w(p))),this.B(this.t.onMouseDown(p=>this.y(p))),this.B(this.t.onContextMenu(p=>this.u(p)))}u(s){const E=s.browserEvent.target;if(!(0,g.$0T)(E)&&!(0,g.$9T)(E)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$AS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.c.stickyNodes.findIndex(J=>J.node.element===s.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(Y);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const L=this.c.stickyNodes[this.a].node.element,j=this.b[this.a];this.g.fire({element:L,anchor:j,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const E=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([E]),this.C(E,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const E=s.browserEvent.target;!(0,g.$0T)(E)&&!(0,g.$9T)(E)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,E){if(E&&E.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(E&&E.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const p=this.a;if(this.D(),this.b=s,this.c=E,E){const L=(0,r.$ym)(p,0,E.count-1);this.F(L)}else this.m&&this.t.domFocus();this.s.tabIndex=E?0:-1}z(s){const E=this.c;if(!E)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<E.count-1)&&E.lastNodePartiallyVisible()){const p=E.stickyNodes[s];this.C(p.endIndex+1,E)}}C(s,E){const p=E.stickyNodes[E.count-1],L=E.count>1?E.stickyNodes[E.count-2]:void 0,j=this.t.getElementTop(s),Y=L?L.position+L.height+p.height:p.height;this.t.scrollTop=j-Y}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const E=this.a;E>=0&&this.G(this.b[E],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,E){this.I(s,E&&this.m),this.J(s,E)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,E){s.classList.toggle("focused",E)}J(s,E){s.classList.toggle("passive-focused",E)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function we(C){let s=u.TreeMouseEventTarget.Unknown;return(0,i.$gS)(C.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=u.TreeMouseEventTarget.Twistie:(0,i.$gS)(C.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=u.TreeMouseEventTarget.Element:(0,i.$gS)(C.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=u.TreeMouseEventTarget.Filter),{browserEvent:C.browserEvent,element:C.element?C.element.element:null,target:s}}function Ae(C){const s=(0,g.$0T)(C.browserEvent.target);return{element:C.element?C.element.element:null,browserEvent:C.browserEvent,anchor:C.anchor,isStickyScroll:s}}function Te(C,s){s(C),C.children.forEach(E=>Te(E,s))}class Ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,E){this.g=s,this.j=E,this.a=[],this.c=new N.$ce,this.onDidChange=this.c.event}set(s,E){!E?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,E)}k(s,E,p){if(this.a=[...s],this.b=void 0,this.d=void 0,!E){const L=this;this.c.fire({get elements(){return L.get()},browserEvent:p})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:E}){if(!this.j){const oe=this.m(),pe=fe=>oe.delete(fe);E.forEach(fe=>Te(fe,pe)),this.set([...oe.values()]);return}const p=new Set,L=oe=>p.add(this.j.getId(oe.element).toString());E.forEach(oe=>Te(oe,L));const j=new Map,Y=oe=>j.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Te(oe,Y));const J=[];for(const oe of this.a){const pe=this.j.getId(oe.element).toString();if(!p.has(pe))J.push(oe);else{const Le=j.get(pe);Le&&Le.visible&&J.push(Le)}}if(this.a.length>0&&J.length===0){const oe=this.g();oe&&J.push(oe)}this.k(J,!0)}m(){const s=new Set;for(const E of this.a)s.add(E);return s}}class z extends g.$cU{constructor(s,E,p){super(s),this.x=E,this.y=p}u(s){if((0,g.$$T)(s.browserEvent.target)||(0,g.$4T)(s.browserEvent.target)||(0,g.$5T)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const E=s.element;if(!E)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const p=s.browserEvent.target,L=p.classList.contains("monaco-tl-twistie")||p.classList.contains("monaco-icon-label")&&p.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,j=(0,g.$9T)(s.browserEvent.target);let Y=!1;if(j?Y=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?Y=this.x.expandOnlyOnTwistieClick(E.element):Y=!!this.x.expandOnlyOnTwistieClick,j)this.A(s,E);else{if(Y&&!L&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(E.collapsible&&(!j||L)){const J=this.x.getNodeLocation(E),oe=s.browserEvent.altKey;if(this.x.setFocus([J]),this.x.toggleCollapsed(J,oe),L){s.browserEvent.isHandledByList=!0;return}}j||super.u(s)}A(s,E){if((0,g.$6T)(s.browserEvent.target)||(0,g.$7T)(s.browserEvent.target))return;const p=this.y();if(!p)throw new Error("Sticky scroll controller not found");const L=this.k.indexOf(E),j=this.k.getElementTop(L),Y=p.nodePositionTopBelowWidget(E);this.x.scrollTop=j-Y,this.k.domFocus(),this.k.setFocus([L]),this.k.setSelection([L])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const E=s.browserEvent.target;if(!(0,g.$0T)(E)&&!(0,g.$9T)(E)){super.s(s);return}}t(s){const E=s.browserEvent.target;if(!(0,g.$0T)(E)&&!(0,g.$9T)(E)){super.t(s);return}}}class h extends g.$fU{constructor(s,E,p,L,j,Y,J,oe){super(s,E,p,L,oe),this.p=j,this.s=Y,this.K=J}D(s){return new z(this,s.tree,s.stickyScrollProvider)}splice(s,E,p=[]){if(super.splice(s,E,p),p.length===0)return;const L=[],j=[];let Y;p.forEach((J,oe)=>{this.p.has(J)&&L.push(s+oe),this.s.has(J)&&j.push(s+oe),this.K.has(J)&&(Y=s+oe)}),L.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...L])),j.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...j])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(s,E,p=!1){super.setFocus(s,E),p||this.p.set(s.map(L=>this.element(L)),E)}setSelection(s,E,p=!1){super.setSelection(s,E),p||this.s.set(s.map(L=>this.element(L)),E)}setAnchor(s,E=!1){super.setAnchor(s),E||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var D;(function(C){C[C.Tree=0]="Tree",C[C.StickyScroll=1]="StickyScroll"})(D||(t.AbstractTreePart=D={}));class a{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return N.Event.map(this.j.onMouseClick,we)}get onMouseDblClick(){return N.Event.filter(N.Event.map(this.j.onMouseDblClick,we),s=>s.target!==u.TreeMouseEventTarget.Filter)}get onMouseOver(){return N.Event.map(this.j.onMouseOver,we)}get onMouseOut(){return N.Event.map(this.j.onMouseOut,we)}get onContextMenu(){return N.Event.any(N.Event.filter(N.Event.map(this.j.onContextMenu,Ae),s=>!s.isStickyScroll),this.B?.onContextMenu??N.Event.None)}get onTap(){return N.Event.map(this.j.onTap,we)}get onPointer(){return N.Event.map(this.j.onPointer,we)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return N.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ye.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Ee.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:N.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,E,p,L,j={}){this.G=s,this.H=j,this.y=new N.$ke,this.onDidChangeFindOpenState=N.Event.None,this.onDidChangeStickyScrollFocused=N.Event.None,this.D=new m.$Uc,this.E=new N.$ce,this.onWillRefilter=this.E.event,this.F=new N.$ce,this.onDidUpdateOptions=this.F.event,this.p=new R(p);const Y=new N.$le,J=new N.$le,oe=this.D.add(new X(J.event)),pe=new d.$Ic;this.k=L.map(Ne=>new K(Ne,()=>this.o,Y.event,oe,pe,j));for(const Ne of this.k)this.D.add(Ne);let fe;j.keyboardNavigationLabelProvider&&(fe=new ae(this,j.keyboardNavigationLabelProvider,j.filter),j={...j,filter:fe},this.D.add(fe)),this.q=new Ie(()=>this.j.getFocusedElements()[0],j.identityProvider),this.w=new Ie(()=>this.j.getSelectedElements()[0],j.identityProvider),this.x=new Ie(()=>this.j.getAnchorElement(),j.identityProvider),this.j=new h(s,E,this.p,this.k,this.q,this.w,this.x,{...V(()=>this.o,j),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,j),Y.input=this.o.onDidChangeCollapseState;const Le=N.Event.forEach(this.o.onDidSplice,Ne=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ne),this.w.onDidModelSplice(Ne)})},this.D);Le(()=>null,null,this.D);const ke=this.D.add(new N.$ce),Oe=this.D.add(new n.$qh(0));if(this.D.add(N.Event.any(Le,this.q.onDidChange,this.w.onDidChange)(()=>{Oe.trigger(()=>{const Ne=new Set;for(const Fe of this.q.getNodes())Ne.add(Fe);for(const Fe of this.w.getNodes())Ne.add(Fe);ke.fire([...Ne.values()])})})),J.input=ke.event,j.keyboardSupport!==!1){const Ne=N.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(We=>!(0,g.$4T)(We.target)).map(We=>new B.$HR(We)));N.Event.chain(Ne,Fe=>Fe.filter(We=>We.keyCode===15))(this.J,this,this.D),N.Event.chain(Ne,Fe=>Fe.filter(We=>We.keyCode===17))(this.K,this,this.D),N.Event.chain(Ne,Fe=>Fe.filter(We=>We.keyCode===10))(this.L,this,this.D)}if((j.findWidgetEnabled??!0)&&j.keyboardNavigationLabelProvider&&j.contextViewProvider){const Ne=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new le(this,this.o,this.j,fe,j.contextViewProvider,Ne),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=N.Event.None,this.onDidChangeFindMatchType=N.Event.None;j.enableStickyScroll&&(this.B=new W(this,this.o,this.j,this.k,this.p,j),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$sS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===O.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const E of this.k)E.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===O.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new W(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=N.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const E=this.o.getListIndex(s);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$lS)(this.getHTMLElement())}layout(s,E){this.j.layout(s,E),(0,y.$0f)(E)&&this.z?.layout(E)}style(s){const E=`.${this.j.domId}`,p=[];s.treeIndentGuidesStroke&&(p.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),p.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const L=s.treeStickyScrollBackground??s.listBackground;L&&(p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${L}; }`),p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${L}; }`)),s.treeStickyScrollBorder&&p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const j=(0,i.$3S)(s.listFocusAndSelectionOutline,(0,i.$3S)(s.listSelectionOutline,s.listFocusOutline??""));j&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${j}; outline-offset: -1px;}`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=p.join(`
`),this.j.style(s)}getParentElement(s){const E=this.o.getParentNodeLocation(s);return this.o.getNode(E).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,E=!1){return this.o.setCollapsed(s,!0,E)}expand(s,E=!1){return this.o.setCollapsed(s,!1,E)}toggleCollapsed(s,E=!1){return this.o.setCollapsed(s,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,E){return this.o.setCollapsible(s,E)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const E=this.o.getNode(s);this.x.set([E]);const p=this.o.getListIndex(s);p>-1&&this.j.setAnchor(p,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,E){this.y.bufferEvents(()=>{const p=s.map(j=>this.o.getNode(j));this.w.set(p,E);const L=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setSelection(L,E,!0)})}getSelection(){return this.w.get()}setFocus(s,E){this.y.bufferEvents(()=>{const p=s.map(j=>this.o.getNode(j));this.q.set(p,E);const L=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setFocus(L,E,!0)})}focusNext(s=1,E=!1,p,L=(0,i.$AS)(p)&&p.altKey?void 0:this.A){this.j.focusNext(s,E,p,L)}focusPrevious(s=1,E=!1,p,L=(0,i.$AS)(p)&&p.altKey?void 0:this.A){this.j.focusPrevious(s,E,p,L)}focusNextPage(s,E=(0,i.$AS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,E)}focusPreviousPage(s,E=(0,i.$AS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,E,()=>this.B?.height??0)}focusLast(s,E=(0,i.$AS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,E)}focusFirst(s,E=(0,i.$AS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,E)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,E){this.o.expandTo(s);const p=this.o.getListIndex(s);if(p!==-1)if(!this.B)this.j.reveal(p,E);else{const L=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(p,E,L)}}getRelativeTop(s){const E=this.o.getListIndex(s);if(E===-1)return null;const p=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(E,p?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new u.$WV(this.G,"Can't get tree view state without an identity provider");const E=Y=>s.getId(Y).toString(),p=x.empty(this.scrollTop);for(const Y of this.getFocus())p.focus.add(E(Y));for(const Y of this.getSelection())p.selection.add(E(Y));const L=this.o.getNode(),j=[L];for(;j.length>0;){const Y=j.shift();Y!==L&&Y.collapsible&&(p.expanded[E(Y.element)]=Y.collapsed?0:1),j.push(...Y.children)}return p}J(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],L=this.o.getNodeLocation(p);if(!this.o.setCollapsed(L,!0)){const Y=this.o.getParentNodeLocation(L);if(!Y)return;const J=this.o.getListIndex(Y);this.j.reveal(J),this.j.setFocus([J])}}K(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],L=this.o.getNodeLocation(p);if(!this.o.setCollapsed(L,!1)){if(!p.children.some(oe=>oe.visible))return;const[Y]=this.j.getFocus(),J=Y+1;this.j.reveal(J),this.j.setFocus([J])}}L(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],L=this.o.getNodeLocation(p),j=s.browserEvent.altKey;this.o.setCollapsed(L,void 0,j)}navigate(s){return new v(this.j,this.o,s)}dispose(){(0,m.$Qc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$7V=a;class v{constructor(s,E,p){this.b=s,this.c=E,p?this.a=this.c.getListIndex(p):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[144],be([1,0,143,134,30,32]),function(se,t,i,F,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fW=void 0;class S extends i.$7V{constructor(f,g,w,P,u,c={}){super(f,g,w,P,c),this.f=f,this.g=u,this.d=new Map,this.c=c.identityProvider}getInput(){return this.b}setInput(f,g){if(g&&!this.c)throw new B.$WV(this.f,"Can't restore tree view state without an identity provider");if(this.b=f,!f){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!g){this.m(f);return}const w=[],P=[],u=e=>{const n=this.c.getId(e).toString();return!g.expanded[n]},c=e=>{const n=this.c.getId(e.element).toString();g.focus.has(n)&&w.push(e.element),g.selection.has(n)&&P.push(e.element)};this.m(f,u,c),this.setFocus(w),this.setSelection(P),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(f=this.b){if(typeof this.b>"u")throw new B.$WV(this.f,"Tree input not set");let g;this.c&&(g=w=>{const P=this.c.getId(w).toString(),u=this.d.get(P);if(u)return u.collapsed}),this.m(f,g)}resort(f=this.b,g=!0){this.o.resort(f===this.b?null:f,g)}refresh(f){if(f===void 0){this.j.rerender();return}this.o.rerender(f)}m(f,g,w){let P;if(this.c){const u=new Set,c=w;w=e=>{const n=this.c.getId(e.element).toString();u.add(n),this.d.set(n,e),c?.(e)},P=e=>{const n=this.c.getId(e.element).toString();u.has(n)||this.d.delete(n)}}this.o.setChildren(f===this.b?null:f,this.s(f,g).elements,{onDidCreateNode:w,onDidDeleteNode:P})}s(f,g){const w=[...this.g.getChildren(f)];return{elements:H.Iterable.map(w,u=>{const{elements:c,size:e}=this.s(u,g),n=this.g.hasChildren?this.g.hasChildren(u):void 0,o=e===0?void 0:g&&g(u);return{element:u,children:c,collapsible:n,collapsed:o}}),size:w.length}}M(f,g,w){return new F.$8V(f,g,w)}}t.$fW=S}),define(me[77],be([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,i,F,B,H,S,k,f,g,w,P,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ci=t.ProxyChannel=t.$bi=t.$$h=t.$0h=t.$9h=t.RequestInitiator=t.$8h=t.$5h=t.$4h=void 0,t.$6h=q,t.$7h=$,t.$_h=X,t.$ai=K;var c;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(c||(c={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(n||(n={}));function o(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(l||(l={}));function d(le){let _=0;for(let ue=0;;ue+=7){const re=le.read(1);if(_|=(re.buffer[0]&127)<<ue,!(re.buffer[0]&128))return _}}const N=A(0);function b(le,_){if(_===0){le.write(N);return}let ue=0;for(let De=_;De!==0;De=De>>>7)ue++;const re=B.$De.alloc(ue);for(let De=0;_!==0;De++)re.buffer[De]=_&127,_=_>>>7,_>0&&(re.buffer[De]|=128);le.write(re)}class m{constructor(_){this.b=_,this.a=0}read(_){const ue=this.b.slice(this.a,this.a+_);return this.a+=ue.byteLength,ue}}t.$4h=m;class r{constructor(){this.a=[]}get buffer(){return B.$De.concat(this.a)}write(_){this.a.push(_)}}t.$5h=r;var y;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(y||(y={}));function A(le){const _=B.$De.alloc(1);return _.writeUInt8(le,0),_}const T={Undefined:A(y.Undefined),String:A(y.String),Buffer:A(y.Buffer),VSBuffer:A(y.VSBuffer),Array:A(y.Array),Object:A(y.Object),Uint:A(y.Int)},M=typeof Buffer<"u";function q(le,_){if(typeof _>"u")le.write(T.Undefined);else if(typeof _=="string"){const ue=B.$De.fromString(_);le.write(T.String),b(le,ue.byteLength),le.write(ue)}else if(M&&Buffer.isBuffer(_)){const ue=B.$De.wrap(_);le.write(T.Buffer),b(le,ue.byteLength),le.write(ue)}else if(_ instanceof B.$De)le.write(T.VSBuffer),b(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(T.Array),b(le,_.length);for(const ue of _)q(le,ue)}else if(typeof _=="number"&&(_|0)===_)le.write(T.Uint),b(le,_);else{const ue=B.$De.fromString(JSON.stringify(_));le.write(T.Object),b(le,ue.byteLength),le.write(ue)}}function $(le){switch(le.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return le.read(d(le)).toString();case y.Buffer:return le.read(d(le)).buffer;case y.VSBuffer:return le.read(d(le));case y.Array:{const ue=d(le),re=[];for(let De=0;De<ue;De++)re.push($(le));return re}case y.Object:return JSON.parse(le.read(d(le)).toString());case y.Int:return d(le)}}class I{constructor(_,ue,re=null,De=1e3){this.h=_,this.j=ue,this.k=re,this.l=De,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:200})}registerChannel(_,ue){this.b.set(_,ue),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ue=this.o([_.type]);this.k?.logOutgoing(ue,0,1,o(_.type));return}case 201:case 202:case 204:case 203:{const ue=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ue,_.id,1,o(_.type),_.data);return}}}o(_,ue=void 0){const re=new r;return q(re,_),q(re,ue),this.p(re.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ue=new m(_),re=$(ue),De=$(ue),W=re[0];switch(W){case 100:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}: ${re[2]}.${re[3]}`,De),this.s({type:W,id:re[1],channelName:re[2],name:re[3],arg:De});case 102:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}: ${re[2]}.${re[3]}`,De),this.t({type:W,id:re[1],channelName:re[2],name:re[3],arg:De});case 101:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}`),this.u({type:W,id:re[1]});case 103:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}`),this.u({type:W,id:re[1]})}}s(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=new H.$ne;let De;try{De=ue.call(this.j,_.name,_.arg,re.token)}catch(ge){De=Promise.reject(ge)}const W=_.id;De.then(ge=>{this.m({id:W,data:ge,type:201})},ge=>{ge instanceof Error?this.m({id:W,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:W,data:ge,type:203})}).finally(()=>{Q.dispose(),this.d.delete(_.id)});const Q=(0,g.$Tc)(()=>re.cancel());this.d.set(_.id,Q)}t(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=_.id,W=ue.listen(this.j,_.name,_.arg)(Q=>this.m({id:re,data:Q,type:204}));this.d.set(_.id,W)}u(_){const ue=this.d.get(_.id);ue&&(ue.dispose(),this.d.delete(_.id))}v(_){let ue=this.g.get(_.channelName);ue||(ue=[],this.g.set(_.channelName,ue));const re=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:_,timeoutTimer:re})}w(_){const ue=this.g.get(_);if(ue){for(const re of ue)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$8h=I;var V;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class R{constructor(_,ue=null){this.l=_,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$ce,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ue}getChannel(_){const ue=this;return{call(re,De,W){return ue.a?Promise.reject(new k.$5):ue.m(_,re,De,W)},listen(re,De){return ue.a?f.Event.None:ue.o(_,re,De)}}}m(_,ue,re,De=H.CancellationToken.None){const W=this.g++,ge={id:W,type:100,channelName:_,name:ue,arg:re};if(De.isCancellationRequested)return Promise.reject(new k.$5);let we;return new Promise((Te,Ie)=>{if(De.isCancellationRequested)return Ie(new k.$5);const z=()=>{const v=C=>{switch(C.type){case 201:this.f.delete(W),Te(C.data);break;case 202:{this.f.delete(W);const s=new Error(C.data.message);s.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,s.name=C.data.name,Ie(s);break}case 203:this.f.delete(W),Ie(C.data);break}};this.f.set(W,v),this.p(ge)};let h=null;this.b===l.Idle?z():(h=(0,F.$gh)(v=>this.u()),h.then(()=>{h=null,z()}));const D=()=>{h?(h.cancel(),h=null):this.p({id:W,type:101}),Ie(new k.$5)},a=De.onCancellationRequested(D);we=(0,g.$Sc)((0,g.$Tc)(D),a),this.d.add(we)}).finally(()=>{we.dispose(),this.d.delete(we)})}o(_,ue,re){const De=this.g++,Q={id:De,type:102,channelName:_,name:ue,arg:re};let ge=null;const we=new f.$ce({onWillAddFirstListener:()=>{ge=(0,F.$gh)(Te=>this.u()),ge.then(()=>{ge=null,this.d.add(we),this.p(Q)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(we),this.p({id:De,type:103}))}}),Ae=Te=>we.fire(Te.data);return this.f.set(De,Ae),we.event}p(_){switch(_.type){case 100:case 102:{const ue=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ue,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ue=this.q([_.type,_.id]);this.j?.logOutgoing(ue,_.id,0,e(_.type));return}}}q(_,ue=void 0){const re=new r;return q(re,_),q(re,ue),this.r(re.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ue=new m(_),re=$(ue),De=$(ue),W=re[0];switch(W){case 200:return this.j?.logIncoming(_.byteLength,0,0,o(W)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,re[1],0,o(W),De),this.t({type:re[0],id:re[1],data:De})}}t(_){if(_.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$9h=R,Je([S.$Xh],R.prototype,"onDidInitializePromise",null);class x{get connections(){const _=[];return this.f.forEach(ue=>_.push(ue)),_}constructor(_,ue,re){this.a=new Map,this.f=new Set,this.g=new f.$ce,this.onDidAddConnection=this.g.event,this.h=new f.$ce,this.onDidRemoveConnection=this.h.event,this.j=new g.$Uc,this.j.add(_(({protocol:De,onDidClientDisconnect:W})=>{const Q=f.Event.once(De.onMessage);this.j.add(Q(ge=>{const we=new m(ge),Ae=$(we),Te=new I(De,Ae,ue,re),Ie=new R(De,ue);this.a.forEach((h,D)=>Te.registerChannel(D,h));const z={channelServer:Te,channelClient:Ie,ctx:Ae};this.f.add(z),this.g.fire(z),this.j.add(W(()=>{Te.dispose(),Ie.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(_,ue){const re=this;return{call(De,W,Q){let ge;if((0,u.$hg)(ue)){const Ae=(0,i.$4b)(re.connections.filter(ue));ge=Ae?Promise.resolve(Ae):f.Event.toPromise(f.Event.filter(re.onDidAddConnection,ue))}else ge=ue.routeCall(re,De,W);const we=ge.then(Ae=>Ae.channelClient.getChannel(_));return X(we).call(De,W,Q)},listen(De,W){if((0,u.$hg)(ue))return re.k(_,ue,De,W);const Q=ue.routeEvent(re,De,W).then(ge=>ge.channelClient.getChannel(_));return X(Q).listen(De,W)}}}k(_,ue,re,De){const W=this;let Q;const ge=new f.$ce({onWillAddFirstListener:()=>{Q=new g.$Uc;const we=new f.$ie,Ae=new Map,Te=z=>{const D=z.channelClient.getChannel(_).listen(re,De),a=we.add(D);Ae.set(z,a)},Ie=z=>{const h=Ae.get(z);h&&(h.dispose(),Ae.delete(z))};W.connections.filter(ue).forEach(Te),f.Event.filter(W.onDidAddConnection,ue)(Te,void 0,Q),W.onDidRemoveConnection(Ie,void 0,Q),we.event(ge.fire,ge,Q),Q.add(we)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return ge.event}registerChannel(_,ue){this.a.set(_,ue);for(const re of this.f)re.channelServer.registerChannel(_,ue)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$0h=x;class O{constructor(_,ue,re=null){const De=new r;q(De,ue),_.send(De.buffer),this.a=new R(_,re),this.d=new I(_,ue,re)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ue){this.d.registerChannel(_,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.$$h=O;function X(le){return{call(_,ue,re){return le.then(De=>De.call(_,ue,re))},listen(_,ue){const re=new f.$le;return le.then(De=>re.input=De.listen(_,ue)),re.event}}}function K(le){let _=!1;return{call(ue,re,De){return _?le.call(ue,re,De):(0,F.$uh)(0).then(()=>_=!0).then(()=>le.call(ue,re,De))},listen(ue,re){if(_)return le.listen(ue,re);const De=new f.$le;return(0,F.$uh)(0).then(()=>_=!0).then(()=>De.input=le.listen(ue,re)),De.event}}}class ae{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ue of _.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await f.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$bi=ae;var ie;(function(le){function _(W,Q,ge){const we=W,Ae=ge&&ge.disableMarshalling,Te=new Map;for(const Ie in we)re(Ie)&&Te.set(Ie,f.Event.buffer(we[Ie],!0,void 0,Q));return new class{listen(Ie,z,h){const D=Te.get(z);if(D)return D;const a=we[z];if(typeof a=="function"){if(De(z))return a.call(we,h);if(re(z))return Te.set(z,f.Event.buffer(we[z],!0,void 0,Q)),Te.get(z)}throw new k.$bb(`Event not found: ${z}`)}call(Ie,z,h){const D=we[z];if(typeof D=="function"){if(!Ae&&Array.isArray(h))for(let v=0;v<h.length;v++)h[v]=(0,w.$3h)(h[v]);let a=D.apply(we,h);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new k.$bb(`Method not found: ${z}`)}}}le.fromService=_;function ue(W,Q){const ge=Q&&Q.disableMarshalling;return new Proxy({},{get(we,Ae){if(typeof Ae=="string")return Q?.properties?.has(Ae)?Q.properties.get(Ae):De(Ae)?function(Te){return W.listen(Ae,Te)}:re(Ae)?W.listen(Ae):async function(...Te){let Ie;Q&&!(0,u.$cg)(Q.context)?Ie=[Q.context,...Te]:Ie=Te;const z=await W.call(Ae,Ie);return ge?z:(0,w.$3h)(z)};throw new k.$bb(`Property not found: ${String(Ae)}`)}})}le.toService=ue;function re(W){return W[0]==="o"&&W[1]==="n"&&P.$uf(W.charCodeAt(2))}function De(W){return/^onDynamic/.test(W)&&P.$uf(W.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function ye(le){return Array.isArray(le)?le.map(ce):ce(le)}function Ee(le,_,ue,re,De,W,Q){Q=ye(Q);const ge=ee[De],we=ge[re%ge.length];let Ae=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(W)?(Ae=Ae.concat(Q),Ae.push(")")):Ae.push(Q),console.log.apply(console,Ae)}class Me{constructor(_,ue){this.d=_,this.f=ue,this.a=0,this.b=0}logOutgoing(_,ue,re,De,W){this.b+=_,Ee(this.d,this.b,_,ue,re,De,W)}logIncoming(_,ue,re,De,W){this.a+=_,Ee(this.f,this.a,_,ue,re,De,W)}}t.$ci=Me}),define(me[145],be([1,0,43,3,77,102,35]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SW=void 0;class k extends B.$$h{static f(){const g=F.Event.fromNodeEventEmitter(S.$O,"vscode:message",(w,P)=>i.$De.wrap(P));return S.$O.send("vscode:hello"),new H.$OW(S.$O,g)}constructor(g){const w=k.f();super(w,g),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$SW=k}),define(me[146],be([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(me[147],be([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(me[50],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$si=t._util=void 0,t.$ti=B,t.$ui=H;var i;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function k(f){return f[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=k})(i||(t._util=i={})),t.$si=B("instantiationService");function F(S,k,f){k[i.DI_TARGET]===k?k[i.DI_DEPENDENCIES].push({id:S,index:f}):(k[i.DI_DEPENDENCIES]=[{id:S,index:f}],k[i.DI_TARGET]=k)}function B(S){if(i.serviceIds.has(S))return i.serviceIds.get(S);const k=function(f,g,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(k,f,w)};return k.toString=()=>S,i.serviceIds.set(S,k),k}function H(S){return S}}),define(me[148],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cn=t.$an=t.ID=void 0,t.$bn=F,t.ID="diagnosticsService",t.$an=(0,i.$ti)(t.ID);function F(H){return!!H.hostName&&!!H.errorMessage}class B{async getPerformanceInfo(S,k){return{}}async getSystemInfo(S,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,k){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}t.$cn=B}),define(me[149],be([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,i,F,B,H,S,k,f,g,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vl=t.$sl=t.FileKind=t.$rl=t.$ql=t.$pl=t.$ol=t.$nl=t.$ml=t.$ll=t.FileOperationResult=t.$kl=t.$jl=t.$il=t.$gl=t.FileChangeType=t.$fl=t.FileOperation=t.$_k=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$Zk=void 0,t.$1k=u,t.$2k=o,t.$3k=d,t.$4k=N,t.$5k=b,t.$6k=m,t.$7k=r,t.$8k=y,t.$9k=A,t.$0k=T,t.$$k=M,t.$al=I,t.$bl=V,t.$cl=R,t.$dl=x,t.$el=O,t.$hl=ee,t.$tl=_,t.$ul=ue,t.$wl=De,t.$Zk=(0,f.$ti)("fileService");function u(W){return W.create===!0}var c;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(c||(t.FileType=c={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var n;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(n||(t.FileChangeFilter=n={}));function o(W){const Q=W;return!!Q&&typeof Q.onDidChange=="function"}var l;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function d(W){return!!(W.capabilities&2)}function N(W){return!!(W.capabilities&8)}function b(W){return!!(W.capabilities&131072)}function m(W){return!!(W.capabilities&4)}function r(W){return!!(W.capabilities&16)}function y(W){return d(W)?!!(W.capabilities&16384):!1}function A(W){return d(W)?!!(W.capabilities&32768):!1}function T(W){return!!(W.capabilities&65536)}function M(W){return!!(W.capabilities&2048)}var q;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(q||(t.FileSystemProviderErrorCode=q={}));class $ extends Error{static create(Q,ge){const we=new $(Q.toString(),ge);return R(we,ge),we}constructor(Q,ge){super(Q),this.code=ge}}t.$_k=$;function I(W,Q){return $.create(W,Q)}function V(W){return W||I((0,k.localize)(0,null),q.Unknown)}function R(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}function x(W){if(!W)return q.Unknown;if(W instanceof $)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return q.Unknown;switch(Q[1]){case q.FileExists:return q.FileExists;case q.FileIsADirectory:return q.FileIsADirectory;case q.FileNotADirectory:return q.FileNotADirectory;case q.FileNotFound:return q.FileNotFound;case q.FileTooLarge:return q.FileTooLarge;case q.FileWriteLocked:return q.FileWriteLocked;case q.NoPermissions:return q.NoPermissions;case q.Unavailable:return q.Unavailable}return q.Unknown}function O(W){if(W instanceof ce)return W.fileOperationResult;switch(x(W)){case q.FileNotFound:return 1;case q.FileIsADirectory:return 0;case q.FileNotADirectory:return 9;case q.FileWriteLocked:return 5;case q.NoPermissions:return 6;case q.FileExists:return 4;case q.FileTooLarge:return 7;default:return 10}}var X;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(X||(t.FileOperation=X={}));class K{constructor(Q,ge,we){this.resource=Q,this.operation=ge,this.target=we}isOperation(Q){return this.operation===Q}}t.$fl=K;var ae;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(ae||(t.FileChangeType=ae={}));class ie{static{this.a=null}constructor(Q,ge){this.c=ge,this.b=void 0,this.d=new P.$V(()=>{const we=i.$zi.forUris(()=>this.c);return we.fill(this.rawAdded.map(Ae=>[Ae,!0])),we}),this.f=new P.$V(()=>{const we=i.$zi.forUris(()=>this.c);return we.fill(this.rawUpdated.map(Ae=>[Ae,!0])),we}),this.g=new P.$V(()=>{const we=i.$zi.forUris(()=>this.c);return we.fill(this.rawDeleted.map(Ae=>[Ae,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Q){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==ie.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=ie.a):this.b!==void 0&&(this.b=ie.a))}}contains(Q,...ge){return this.h(Q,{includeChildren:!1},...ge)}affects(Q,...ge){return this.h(Q,{includeChildren:!0},...ge)}h(Q,ge,...we){if(!Q)return!1;const Ae=we.length>0;return!!((!Ae||we.includes(1))&&(this.d.value.get(Q)||ge.includeChildren&&this.d.value.findSuperstr(Q))||(!Ae||we.includes(0))&&(this.f.value.get(Q)||ge.includeChildren&&this.f.value.findSuperstr(Q))||(!Ae||we.includes(2))&&(this.g.value.findSubstr(Q)||ge.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}t.$gl=ie;function ee(W,Q,ge){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==F.sep&&(Q+=F.sep),ge?(0,B.$wf)(W,Q):W.indexOf(Q)===0)}class ce extends Error{constructor(Q,ge,we){super(Q),this.fileOperationResult=ge,this.options=we}}t.$il=ce;class ye extends ce{constructor(Q,ge,we,Ae){super(Q,ge,Ae),this.fileOperationResult=ge,this.size=we}}t.$jl=ye;class Ee extends ce{constructor(Q,ge,we){super(Q,2,we),this.stat=ge}}t.$kl=Ee;var Me;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Me||(t.FileOperationResult=Me={})),t.$ll={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$ml={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$nl="files.associations",t.$ol="files.exclude",t.$pl="files.readonlyInclude",t.$ql="files.readonlyExclude",t.$rl="files.readonlyFromPermissions";var le;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.$sl="";function _(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function ue(W,Q){if(!Q.hasProvider(S.URI.from({scheme:W.scheme})))return new Promise(ge=>{const we=Q.onDidChangeFileSystemProviderRegistrations(Ae=>{Ae.scheme===W.scheme&&Ae.added&&(we.dispose(),ge())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(Q){return(0,H.$0f)(Q)||(Q=0),Q<re.KB?(0,k.localize)(1,null,Q.toFixed(0)):Q<re.MB?(0,k.localize)(2,null,(Q/re.KB).toFixed(2)):Q<re.GB?(0,k.localize)(3,null,(Q/re.MB).toFixed(2)):Q<re.TB?(0,k.localize)(4,null,(Q/re.GB).toFixed(2)):(0,k.localize)(5,null,(Q/re.TB).toFixed(2))}}t.$vl=re;function De(W){const Q=typeof W=="string"||W?.scheme===w.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===w.Schemas.file?1024*re.MB:Q?10*re.MB:g.$o?50*re.MB:1024*re.MB}}),define(me[150],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fdc=t.$edc=void 0,t.$edc=(0,i.$ti)("mainProcessService");class F{constructor(H,S){this.a=H,this.b=S}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,S){this.a.registerChannel(H,S)}}t.$fdc=F}),define(me[151],be([1,0,2,145]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gdc=void 0;class B extends i.$Vc{constructor(S){super(),this.a=this.B(new F.$SW(`window:${S}`))}getChannel(S){return this.a.getChannel(S)}registerChannel(S,k){this.a.registerChannel(S,k)}}t.$gdc=B});var Ei=this&&this.__param||function(se,t){return function(i,F){t(i,F,se)}};define(me[152],be([1,0,77,150]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kdc=void 0;let B=class{constructor(S,k){return this.windowId=S,i.ProxyChannel.toService(k.getChannel("nativeHost"),{context:S,properties:(()=>{const f=new Map;return f.set("windowId",S),f})()})}};t.$kdc=B,t.$kdc=B=Je([Ei(1,F.$edc)],B)}),define(me[78],be([1,0,37,10]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_n=void 0;class B{constructor(){this.a=new Map}add(S,k){i.ok(F.$6f(S)),i.ok(F.$8f(k)),i.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,k)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}t.$_n=new B}),define(me[153],be([1,0,3,78]),function(se,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ao=void 0,t.$ao={JSONContribution:"base.contributions.json"};function B(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class H{constructor(){this.b=new i.$ce,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,g){this.a[B(f)]=g,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const S=new H;F.$_n.add(t.$ao.JSONContribution,S)}),define(me[154],be([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,i,F,B,H,S,k,f,g,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bx=t.$ax=t.$_w=t.$$w=t.$0w=t.$9w=t.IconFontDefinition=t.IconContribution=t.$6w=void 0,t.$7w=o,t.$8w=l,t.$6w={IconContribution:"base.contributions.icons"};var u;(function(m){function r(y,A){let T=y.defaults;for(;H.ThemeIcon.isThemeIcon(T);){const M=n.getIcon(T.id);if(!M)return;T=M.defaults}return T}m.getDefinition=r})(u||(t.IconContribution=u={}));var c;(function(m){function r(A){return{weight:A.weight,style:A.style,src:A.src.map(T=>({format:T.format,location:T.location.toString()}))}}m.toJSONObject=r;function y(A){const T=M=>(0,k.$6f)(M)?M:void 0;if(A&&Array.isArray(A.src)&&A.src.every(M=>(0,k.$6f)(M.format)&&(0,k.$6f)(M.location)))return{weight:T(A.weight),style:T(A.style),src:A.src.map(M=>({format:M.format,location:f.URI.parse(M.location)}))}}m.fromJSONObject=y})(c||(t.IconFontDefinition=c={}));class e{constructor(){this.a=new S.$ce,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,y,A,T){const M=this.b[r];if(M){if(A&&!M.description){M.description=A,this.d.properties[r].markdownDescription=`${A} $(${r})`;const I=this.e.enum.indexOf(r);I!==-1&&(this.e.enumDescriptions[I]=A),this.a.fire()}return M}const q={id:r,description:A,defaults:y,deprecationMessage:T};this.b[r]=q;const $={$ref:"#/definitions/icons"};return T&&($.deprecationMessage=T),A&&($.markdownDescription=`${A}: $(${r})`),this.d.properties[r]=$,this.e.enum.push(r),this.e.enumDescriptions.push(A||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const y=this.e.enum.indexOf(r);y!==-1&&(this.e.enum.splice(y,1),this.e.enumDescriptions.splice(y,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,y){const A=this.f[r];return A||(this.f[r]=y,this.a.fire(),y)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(M,q)=>M.id.localeCompare(q.id),y=M=>{for(;H.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},A=[];A.push("| preview     | identifier                        | default codicon ID                | description"),A.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.b).map(M=>this.b[M]);for(const M of T.filter(q=>!!q.description).sort(r))A.push(`|<i class="${y(M)}"></i>|${M.id}|${H.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);A.push("| preview     | identifier                        "),A.push("| ----------- | --------------------------------- |");for(const M of T.filter(q=>!H.ThemeIcon.isThemeIcon(q.defaults)).sort(r))A.push(`|<i class="${y(M)}"></i>|${M.id}|`);return A.join(`
`)}}const n=new e;P.$_n.add(t.$6w.IconContribution,n);function o(m,r,y,A){return n.registerIcon(m,r,y,A)}function l(){return n}function d(){const m=(0,B.$Oj)();for(const r in m){const y="\\"+m[r].toString(16);n.registerIcon(r,{fontCharacter:y})}}d(),t.$9w="vscode://schemas/icons";const N=P.$_n.as(w.$ao.JSONContribution);N.registerSchema(t.$9w,n.getIconSchema());const b=new i.$Fh(()=>N.notifySchemaChanged(t.$9w),200);n.onDidChange(()=>{b.isScheduled()||b.schedule()}),t.$0w=o("widget-close",F.$Sj.close,(0,g.localize)(2,null)),t.$$w=o("goto-previous-location",F.$Sj.arrowUp,(0,g.localize)(3,null)),t.$_w=o("goto-next-location",F.$Sj.arrowDown,(0,g.localize)(4,null)),t.$ax=H.ThemeIcon.modify(F.$Sj.sync,"spin"),t.$bx=H.ThemeIcon.modify(F.$Sj.loading,"spin")}),define(me[155],be([1,0,4,3,2,19,154]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wJb=void 0,t.$vJb=k;function k(g){const w=new B.$Uc,P=w.add(new F.$ce),u=(0,S.$8w)();return w.add(u.onDidChange(()=>P.fire())),g&&w.add(g.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>w.dispose(),onDidChange:P.event,getCSS(){const c=g?g.getProductIconTheme():new f,e={},n=[],o=[];for(const l of u.getIcons()){const d=c.getIcon(l);if(!d)continue;const N=d.font,b=`--vscode-icon-${l.id}-font-family`,m=`--vscode-icon-${l.id}-content`;N?(e[N.id]=N.definition,o.push(`${b}: ${(0,i.$2S)(N.id)};`,`${m}: '${d.fontCharacter}';`),n.push(`.codicon-${l.id}:before { content: '${d.fontCharacter}'; font-family: ${(0,i.$2S)(N.id)}; }`)):(o.push(`${m}: '${d.fontCharacter}'; ${b}: 'codicon';`),n.push(`.codicon-${l.id}:before { content: '${d.fontCharacter}'; }`))}for(const l in e){const d=e[l],N=d.weight?`font-weight: ${d.weight};`:"",b=d.style?`font-style: ${d.style};`:"",m=d.src.map(r=>`${(0,i.$1S)(r.location)} format('${r.format}')`).join(", ");n.push(`@font-face { src: ${m}; font-family: ${(0,i.$2S)(l)};${N}${b} font-display: block; }`)}return n.push(`:root { ${o.join(" ")} }`),n.join(`
`)}}}class f{getIcon(w){const P=(0,S.$8w)();let u=w.defaults;for(;H.ThemeIcon.isThemeIcon(u);){const c=P.getIcon(u.id);if(!c)return;u=c.defaults}return u}}t.$wJb=f}),define(me[156],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$pD=void 0,t.$qD=F,t.$rD=B,t.$sD=H,t.$tD=S,t.$uD=k,t.$vD=P,t.$wD=u,t.$xD=c,t.$yD=e,t.$zD=n,t.$AD=o,t.$pD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function F(l){return typeof l.parentId=="number"}function B(l){return!!l.workspaceUri}function H(l){return!!l.folderUri}function S(l){return!!l.fileUri}function k(l){const d=u(l),N=l.getValue("window.menuBarVisibility");return N==="default"||d&&N==="compact"||i.$j&&i.$m?"classic":N}var f;(function(l){l.TITLE_BAR_STYLE="window.titleBarStyle",l.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(f||(t.TitleBarSetting=f={}));var g;(function(l){l.NATIVE="native",l.CUSTOM="custom"})(g||(t.TitlebarStyle=g={}));var w;(function(l){l.AUTO="auto",l.WINDOWED="windowed",l.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function P(l,d){return!0}function u(l,d){return d||(d=c(l)),d==="native"}function c(l){if(i.$o)return"custom";const d=l.getValue("window");if(d){if(i.$j&&d.nativeTabs===!0||i.$j&&d.nativeFullScreen===!1)return"native";const m=d.titleBarStyle;if(m==="native"||m==="custom")return m}return i.$k?"native":"custom"}function e(l){return!(!i.$i||i.$o||u(l))}function n(l){const d=l.getValue("window");return!d||typeof d.nativeFullScreen!="boolean"||d.nativeTabs?!0:d.nativeFullScreen!==!1}function o(l=0){return Math.pow(1.2,l)}}),define(me[157],be([1,0,17,4,22,35,156]),function(se,t,i,F,B,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ndc=t.$mdc=t.ApplyZoomTarget=void 0,t.$odc=f,t.$pdc=w,t.$qdc=P;var k;(function(u){u[u.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",u[u.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={})),t.$mdc=8,t.$ndc=-8;function f(u,c){u=Math.min(Math.max(u,t.$ndc),t.$mdc);const e=[];c===k.ACTIVE_WINDOW?e.push((0,F.$pS)()):c===k.ALL_WINDOWS?e.push(...Array.from((0,F.getWindows)()).map(({window:n})=>n)):e.push(c);for(const n of e)g(n)?.webFrame?.setZoomLevel(u),(0,i.$mR)((0,S.$AD)(u),n),(0,i.$iR)(u,n)}function g(u){if(u===B.$eR)return{ipcRenderer:H.$O,webFrame:H.$Q};{const c=u;if(c?.vscode?.ipcRenderer&&c?.vscode?.webFrame)return c.vscode}}function w(u){f((0,i.$jR)(typeof u=="number"?(0,F.$pS)():u)+1,u)}function P(u){f((0,i.$jR)(typeof u=="number"?(0,F.$pS)():u)-1,u)}}),define(me[158],be([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,i,F,B,H,S,k,f,g,w,P,u,c,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=I;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class d{getHeight(R){return 22}getTemplateId(R){return M(R)?"process":A(R)?"machine":(0,f.$bn)(R)?"error":T(R)?"header":""}}class N{hasChildren(R){return(0,f.$bn)(R)?!1:M(R)?!!R.children?.length:!0}getChildren(R){return M(R)?R.children?R.children:[]:(0,f.$bn)(R)?[]:T(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:A(R)?[R.rootProcess]:[R.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(R){const x=(0,F.$KS)(R,(0,F.$)(".row")),O=(0,F.$KS)(x,(0,F.$)(".nameLabel")),X=(0,F.$KS)(x,(0,F.$)(".cpu")),K=(0,F.$KS)(x,(0,F.$)(".memory")),ae=(0,F.$KS)(x,(0,F.$)(".pid"));return{name:O,CPU:X,memory:K,PID:ae}}renderElement(R,x,O,X){O.name.textContent=(0,i.localize)(0,null),O.CPU.textContent=(0,i.localize)(1,null),O.PID.textContent=(0,i.localize)(2,null),O.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(R){}}class m{constructor(){this.templateId="machine"}renderTemplate(R){const x=Object.create(null),O=(0,F.$KS)(R,(0,F.$)(".row"));return x.name=(0,F.$KS)(O,(0,F.$)(".nameLabel")),x}renderElement(R,x,O,X){O.name.textContent=R.element.name}disposeTemplate(R){}}class r{constructor(){this.templateId="error"}renderTemplate(R){const x=Object.create(null),O=(0,F.$KS)(R,(0,F.$)(".row"));return x.name=(0,F.$KS)(O,(0,F.$)(".nameLabel")),x}renderElement(R,x,O,X){O.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class y{constructor(R,x,O){this.a=R,this.b=x,this.c=O,this.templateId="process"}renderTemplate(R){const x=(0,F.$KS)(R,(0,F.$)(".row")),O=(0,F.$KS)(x,(0,F.$)(".nameLabel")),X=(0,F.$KS)(x,(0,F.$)(".cpu")),K=(0,F.$KS)(x,(0,F.$)(".memory")),ae=(0,F.$KS)(x,(0,F.$)(".pid"));return{name:O,CPU:X,PID:ae,memory:K}}renderElement(R,x,O,X){const{element:K}=R,ae=K.pid.toFixed(0);let ie=K.name;this.c.has(K.pid)&&(ie=this.c.get(K.pid)),O.name.textContent=ie,O.name.title=K.cmd,O.CPU.textContent=K.load.toFixed(0),O.PID.textContent=ae,O.PID.parentElement.id=`pid-${ae}`;const ee=this.a==="win32"?K.mem:this.b*(K.mem/100);O.memory.textContent=(ee/g.$vl.MB).toFixed(0)}disposeTemplate(R){}}function A(V){return!!V.name&&!!V.rootProcess}function T(V){return!!V.processRoots}function M(V){return!!V.pid}class q{constructor(R,x){this.f=x,this.b=new Map;const O=new w.$gdc(R);this.c=new P.$kdc(R,O),this.k(x.styles),this.g(x),k.$O.on("vscode:pidToNameResponse",(X,K)=>{this.b.clear();for(const[ae,ie]of K)this.b.set(ae,ie)}),k.$O.on("vscode:listProcessesResponse",async(X,K)=>{K.forEach((ae,ie)=>{M(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:K}}),this.d.layout(n.$eR.innerHeight,n.$eR.innerWidth)):await this.h(K),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(R){n.$eR.document.onkeydown=x=>{const O=R.platform==="darwin"?x.metaKey:x.ctrlKey;O&&x.keyCode===87&&(x.stopPropagation(),x.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),O&&x.keyCode===187&&(0,c.$pdc)(n.$eR),O&&x.keyCode===189&&(0,c.$qdc)(n.$eR)}}async h(R){const x=n.$eR.document.getElementById("process-list");if(!x)return;const{totalmem:O}=await this.c.getOSStatistics(),X=[new y(this.f.platform,O,this.b),new b,new m,new r];this.d=new B.$fW("processExplorer",x,new d,X,new N,{identityProvider:{getId:K=>M(K)?K.pid.toString():(0,f.$bn)(K)?K.hostName:T(K)?"processes":A(K)?K.name:"header"}}),this.d.setInput({processes:{processRoots:R}}),this.d.layout(n.$eR.innerHeight,n.$eR.innerWidth),this.d.onKeyDown(K=>{const ae=new e.$HR(K);if(ae.keyCode===35&&ae.altKey){const ie=this.n();Promise.all(ie.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(K=>{M(K.element)&&this.l(K.element,!0)}),x.style.height=`${n.$eR.innerHeight}px`,n.$eR.addEventListener("resize",()=>{x.style.height=`${n.$eR.innerHeight}px`,this.d?.layout(n.$eR.innerHeight,n.$eR.innerWidth)})}i(R){const x=o.exec(R);return x&&x.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}j(R){const x={type:"node",request:"attach",name:`process ${R.pid}`};let O=o.exec(R.cmd);O?x.port=Number(O.groups.port):x.processId=String(R.pid),O=l.exec(R.cmd),O&&(x.port=Number(O.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[x]})}k(R){const x=(0,F.$sS)(),O=[];R.listFocusBackground&&(O.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),O.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&O.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(O.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),O.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&O.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&O.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&O.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&O.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&O.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&O.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),x.textContent=O.join(`
`),R.color&&(n.$eR.document.body.style.color=R.color)}l(R,x){const O=[],X=Number(R.pid);x&&(O.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),O.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),O.push({type:"separator"})),O.push({label:(0,i.localize)(6,null),click:()=>{const K=this.n();K?.includes(X)||(K.length=0,K.push(X));const ae=K?.map(ie=>n.$eR.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ie.join(`
`))}}}),O.push({label:(0,i.localize)(7,null),click:()=>{const K=n.$eR.document.getElementById("process-list");K&&this.c.writeClipboardText(K.innerText)}}),R&&x&&this.i(R.cmd)&&(O.push({type:"separator"}),O.push({label:(0,i.localize)(8,null),click:()=>{this.j(R)}})),(0,S.$KW)(O)}m(R){setTimeout(()=>{const x=Date.now(),O=R+x-this.a;this.a=x,O>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(O)},200)}n(){return this.d?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function $(){const V=(0,F.$sS)();V.id="codiconStyles";const R=(0,u.$vJb)(void 0);function x(){V.textContent=R.getCSS()}const O=new H.$Fh(x,0);R.onDidChange(()=>O.schedule()),O.schedule()}function I(V){const R=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";n.$eR.document.body.classList.add(R),$(),(0,c.$odc)(V.data.zoomLevel,n.$eR),new q(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/59d84c5c8cecf22b24e316c5443dc3ec49462589/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
