/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],se=function(Z){for(var e=[],j=0,O=Z.length;j<O;j++)e[j]=ne[Z[j]];return e};define(ne[72],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class j{static get(){const k=new Map,N=new Map,A=new Map,E=new Map;function l(w,p){w.has(p.detail)||w.set(p.detail,-p.timestamp)}function a(w,p){const I=w.get(p.detail);I&&(I>=0||w.set(p.detail,I+p.timestamp))}let f=[];typeof Z=="function"&&typeof Z.getStats=="function"&&(f=Z.getStats().slice(0).sort((w,p)=>w.timestamp-p.timestamp));for(const w of f)switch(w.type){case 10:l(k,w);break;case 11:case 12:a(k,w);break;case 21:l(N,w);break;case 22:a(N,w);break;case 33:l(A,w);break;case 34:a(A,w);break;case 31:l(E,w);break;case 32:a(E,w);break}let b=0;A.forEach(w=>b+=w);function y(w){const p=[];return w.forEach((I,g)=>p.push([g,I])),p}return{amdLoad:y(k),amdInvoke:y(N),nodeRequire:y(A),nodeEval:y(E),nodeRequireTotal:b}}static toMarkdownTable(k,N){let A="";const E=[];return k.forEach((l,a)=>{E[a]=l.length}),N.forEach(l=>{l.forEach((a,f)=>{typeof a>"u"&&(a=l[f]="-");const b=a.toString().length;E[f]=Math.max(b,E[f])})}),k.forEach((l,a)=>{A+=`| ${l+" ".repeat(E[a]-l.toString().length)} `}),A+=`|
`,k.forEach((l,a)=>{A+=`| ${"-".repeat(E[a])} `}),A+=`|
`,N.forEach(l=>{l.forEach((a,f)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(E[f]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=j}),define(ne[54],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=O,e.$Yh=k,e.$Zh=N;function j(A){return(E,l,a)=>{let f=null,b=null;if(typeof a.value=="function"?(f="value",b=a.value):typeof a.get=="function"&&(f="get",b=a.get),!b)throw new Error("not supported");a[f]=A(b,l)}}function O(A,E,l){let a=null,f=null;if(typeof l.value=="function"?(a="value",f=l.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",f=l.get),!f)throw new Error("not supported");const b=`$memoize$${E}`;l[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,y)}),this[b]}}function k(A,E,l){return j((a,f)=>{const b=`$debounce$${f}`,y=`$debounce$result$${f}`;return function(...w){this[y]||(this[y]=l?l():void 0),clearTimeout(this[b]),E&&(this[y]=E(this[y],...w),w=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,w),this[y]=l?l():void 0},A)}})}function N(A,E,l){return j((a,f)=>{const b=`$throttle$timer$${f}`,y=`$throttle$result$${f}`,w=`$throttle$lastRun$${f}`,p=`$throttle$pending$${f}`;return function(...I){if(this[y]||(this[y]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...I)),this[p])return;const g=this[w]+A;g<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0},g-Date.now()))}})}}),define(ne[73],se([0,1,9]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$dd=k,e.$ed=N,e.$fd=A,e.$gd=E,e.$hd=l;function O(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function k(a,f="Unreachable"){throw new Error(f)}function N(a){if(!a)throw new j.$cb("Assertion Failed")}function A(a){a||(0,j.$1)(new j.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,j.$1)(new j.$cb("Assertion Failed"))}}function l(a,f){let b=0;for(;b<a.length-1;){const y=a[b],w=a[b+1];if(!f(y,w))return!1;b++}return!0}}),define(ne[38],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$En=A,e.$Fn=b,e.$Gn=y,e.$Hn=w,e.$In=p,e.$Jn=I,e.$Kn=g,e.$Ln=c,e.$Mn=u,e.$Nn=v,e.$On=m,e.$Pn=$;var j;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(j||(e.ScanError=j={}));var O;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(n,r=!1){let t=0;const i=n.length;let s="",o=0,h=16,P=0;function D(ie){let he=0,le=0;for(;he<ie;){const ce=n.charCodeAt(t);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;t++,he++}return he<ie&&(le=-1),le}function R(ie){t=ie,s="",o=0,h=16,P=0}function z(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return P=3,n.substring(ie,t);let he=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;he=t}else P=3;return n.substring(ie,he)}function M(){let ie="",he=t;for(;;){if(t>=i){ie+=n.substring(he,t),P=2;break}const le=n.charCodeAt(t);if(le===34){ie+=n.substring(he,t),t++;break}if(le===92){if(ie+=n.substring(he,t),t++,t>=i){P=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const V=D(4);V>=0?ie+=String.fromCharCode(V):P=4;break}default:P=5}he=t;continue}if(le>=0&&le<=31)if(l(le)){ie+=n.substring(he,t),P=2;break}else P=6;t++}return ie}function T(){if(s="",P=0,o=t,t>=i)return o=i,h=17;let ie=n.charCodeAt(t);if(E(ie)){do t++,s+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(E(ie));return h=15}if(l(ie))return t++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),h=14;switch(ie){case 123:return t++,h=1;case 125:return t++,h=2;case 91:return t++,h=3;case 93:return t++,h=4;case 58:return t++,h=6;case 44:return t++,h=5;case 34:return t++,s=M(),h=10;case 47:{const he=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!l(n.charCodeAt(t));)t++;return s=n.substring(he,t),h=12}if(n.charCodeAt(t+1)===42){t+=2;const le=i-1;let ce=!1;for(;t<le;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,P=1),s=n.substring(he,t),h=13}return s+=String.fromCharCode(ie),t++,h=16}case 45:if(s+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=z(),h=11;default:for(;t<i&&Q(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(ie),t++,h=16}}function Q(ie){if(E(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=T();while(ie>=12&&ie<=15);return ie}return{setPosition:R,getPosition:()=>t,scan:r?re:T,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var f;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(f||(f={}));function b(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(D,R,z,M){o.value=D,o.offset=R,o.length=z,o.type=M,o.colonOffset=void 0,s=o}try{v(n,{onObjectBegin:(D,R)=>{if(r<=D)throw i;s=void 0,h=r>D,t.push("")},onObjectProperty:(D,R,z)=>{if(r<R||(P(D,R,z,"property"),t[t.length-1]=D,r<=R+z))throw i},onObjectEnd:(D,R)=>{if(r<=D)throw i;s=void 0,t.pop()},onArrayBegin:(D,R)=>{if(r<=D)throw i;s=void 0,t.push(0)},onArrayEnd:(D,R)=>{if(r<=D)throw i;s=void 0,t.pop()},onLiteralValue:(D,R,z)=>{if(r<R||(P(D,R,z,$(D)),r<=R+z))throw i},onSeparator:(D,R,z)=>{if(r<=R)throw i;if(D===":"&&s&&s.type==="property")s.colonOffset=R,h=!1,s=void 0;else if(D===","){const M=t[t.length-1];typeof M=="number"?t[t.length-1]=M+1:(h=!0,t[t.length-1]=""),s=void 0}}})}catch(D){if(D!==i)throw D}return{path:t,previousNode:s,isAtPropertyKey:h,matches:D=>{let R=0;for(let z=0;R<D.length&&z<t.length;z++)if(D[R]===t[z]||D[R]==="*")R++;else if(D[R]!=="**")return!1;return R===D.length}}}function y(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function h(D){Array.isArray(s)?s.push(D):i!==null&&(s[i]=D)}return v(n,{onObjectBegin:()=>{const D={};h(D),o.push(s),s=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const D=[];h(D),o.push(s),s=D,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:h,onError:(D,R,z)=>{r.push({error:D,offset:R,length:z})}},t),s[0]}function w(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function o(D){return i.children.push(D),D}v(n,{onObjectBegin:D=>{i=o({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,R,z)=>{i=o({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:R,length:z,parent:i})},onObjectEnd:(D,R)=>{i.length=D+R-i.offset,i=i.parent,s(D+R)},onArrayBegin:(D,R)=>{i=o({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,R)=>{i.length=D+R-i.offset,i=i.parent,s(D+R)},onLiteralValue:(D,R,z)=>{o({type:$(D),offset:R,length:z,parent:i,value:D}),s(R+z)},onSeparator:(D,R,z)=>{i.type==="property"&&(D===":"?i.colonOffset=R:D===","&&s(R))},onError:(D,R,z)=>{r.push({error:D,offset:R,length:z})}},t);const P=i.children[0];return P&&delete P.parent,P}function p(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function I(n){if(!n.parent||!n.parent.children)return[];const r=I(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=g(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function c(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function u(n,r,t=!1){if(c(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=u(i[s],r,t);if(o)return o}return n}}function v(n,r,t=N.DEFAULT){const i=A(n,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(r.onObjectBegin),P=o(r.onObjectProperty),D=s(r.onObjectEnd),R=s(r.onArrayBegin),z=s(r.onArrayEnd),M=o(r.onLiteralValue),T=o(r.onSeparator),Q=s(r.onComment),re=o(r.onError),ie=t&&t.disallowComments,he=t&&t.allowTrailingComma;function le(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):Q();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],U=[]){if(re(Y),_.length+U.length>0){let F=i.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){le();break}else if(U.indexOf(F)!==-1)break;F=le()}}}function V(Y){const _=i.getTokenValue();return Y?M(_):P(_),le(),!0}function J(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}M(Y);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return le(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(T(":"),le(),X()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){h(),le();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),T(","),le(),i.getToken()===2&&he)break}else Y&&ce(6,[],[]);B()||ce(4,[],[2,5]),Y=!0}return D(),i.getToken()!==2?ce(7,[2],[]):le(),!0}function W(){R(),le();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),T(","),le(),i.getToken()===4&&he)break}else Y&&ce(6,[],[]);X()||ce(4,[],[4,5]),Y=!0}return z(),i.getToken()!==4?ce(8,[4],[]):le(),!0}function X(){switch(i.getToken()){case 3:return W();case 1:return q();case 10:return V(!0);default:return J()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):X()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function m(n,r){const t=A(n),i=[];let s,o=0,h;do switch(h=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==h&&i.push(n.substring(o,h)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function $(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[74],se([0,1,38]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=O,e.$Rn=k,e.$Sn=E,e.$Tn=l;function O(a,f,b){let y,w,p,I,g;if(f){for(I=f.offset,g=I+f.length,p=I;p>0&&!l(a,p-1);)p--;let h=g;for(;h<a.length&&!l(a,h);)h++;w=a.substring(p,h),y=A(w,b)}else w=a,y=0,p=0,I=0,g=a.length;const c=E(b,a);let u=!1,v=0,m;b.insertSpaces?m=N(" ",b.tabSize||4):m="	";const $=(0,j.$En)(w,!1);let n=!1;function r(){return c+N(m,y+v)}function t(){let h=$.scan();for(u=!1;h===15||h===14;)u=u||h===14,h=$.scan();return n=h===16||$.getTokenError()!==0,h}const i=[];function s(h,P,D){!n&&P<g&&D>I&&a.substring(P,D)!==h&&i.push({offset:P,length:D-P,content:h})}let o=t();if(o!==17){const h=$.getTokenOffset()+p,P=N(m,y);s(P,p,h)}for(;o!==17;){let h=$.getTokenOffset()+$.getTokenLength()+p,P=t(),D="";for(;!u&&(P===12||P===13);){const z=$.getTokenOffset()+p;s(" ",h,z),h=$.getTokenOffset()+$.getTokenLength()+p,D=P===12?r():"",P=t()}if(P===2)o!==1&&(v--,D=r());else if(P===4)o!==3&&(v--,D=r());else{switch(o){case 3:case 1:v++,D=r();break;case 5:case 12:D=r();break;case 13:u?D=r():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(n=!0);break;case 16:n=!0;break}u&&(P===12||P===13)&&(D=r())}const R=$.getTokenOffset()+p;s(D,h,R),o=P}return i}function k(a,f){const b=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?b.replace(/\r\n|\r|\n/g,f.eol):b}function N(a,f){let b="";for(let y=0;y<f;y++)b+=a;return b}function A(a,f){let b=0,y=0;const w=f.tabSize||4;for(;b<a.length;){const p=a.charAt(b);if(p===" ")y++;else if(p==="	")y+=w;else break;b++}return Math.floor(y/w)}function E(a,f){for(let b=0;b<f.length;b++){const y=f.charAt(b);if(y==="\r")return b+1<f.length&&f.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function l(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(ne[75],se([0,1,38,74]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=k,e.$Vn=N,e.$Wn=A,e.$Xn=E,e.$Yn=l;function k(a,f,b){return N(a,f,void 0,b)}function N(a,f,b,y,w){const p=f.slice(),I=[],g=(0,j.$Hn)(a,I);let c,u;for(;p.length>0&&(u=p.pop(),c=(0,j.$In)(g,p),c===void 0&&b!==void 0);)typeof u=="string"?b={[u]:b}:b=[b];if(c)if(c.type==="object"&&typeof u=="string"&&Array.isArray(c.children)){const v=(0,j.$In)(c,[u]);if(v!==void 0)if(b===void 0){if(!v.parent)throw new Error("Malformed AST");const m=c.children.indexOf(v.parent);let $,n=v.parent.offset+v.parent.length;if(m>0){const r=c.children[m-1];$=r.offset+r.length}else $=c.offset+1,c.children.length>1&&(n=c.children[1].offset);return A(a,{offset:$,length:n-$,content:""},y)}else return A(a,{offset:v.offset,length:v.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const m=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,$=w?w(c.children.map(r=>r.children[0].value)):c.children.length;let n;if($>0){const r=c.children[$-1];n={offset:r.offset+r.length,length:0,content:","+m}}else c.children.length===0?n={offset:c.offset+1,length:0,content:m}:n={offset:c.offset+1,length:0,content:m+","};return A(a,n,y)}}else if(c.type==="array"&&typeof u=="number"&&Array.isArray(c.children))if(b!==void 0){const v=`${JSON.stringify(b)}`;let m;if(c.children.length===0||u===0)m={offset:c.offset+1,length:0,content:c.children.length===0?v:v+","};else{const $=u===-1||u>c.children.length?c.children.length:u,n=c.children[$-1];m={offset:n.offset+n.length,length:0,content:","+v}}return A(a,m,y)}else{const v=u,m=c.children[v];let $;if(c.children.length===1)$={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===v){const n=c.children[v-1],r=n.offset+n.length,t=c.offset+c.length;$={offset:r,length:t-2-r,content:""}}else $={offset:m.offset,length:c.children[v+1].offset-m.offset,content:""};return A(a,$,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${c.type}`);else return b===void 0?[]:A(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(b)},y)}function A(a,f,b){let y=E(a,f),w=f.offset,p=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;w>0&&!(0,O.$Tn)(y,w-1);)w--;for(;p<y.length&&!(0,O.$Tn)(y,p);)p++}const I=(0,O.$Qn)(y,{offset:w,length:p-w},b);for(let c=I.length-1;c>=0;c--){const u=I[c];y=E(y,u),w=Math.min(w,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const g=a.length-(y.length-p)-w;return[{offset:w,length:g,content:y.substring(w,p)}]}function E(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function l(a,f){const b=f.slice(0).sort((w,p)=>{const I=w.offset-p.offset;return I===0?w.length-p.length:I});let y=a.length;for(let w=b.length-1;w>=0;w--){const p=b[w];if(p.offset+p.length<=y)a=E(a,p);else throw new Error("Overlapping edit");y=p.offset}return a}}),define(ne[76],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0,e.$ym=j,e.rot=O;function j(E,l,a){return Math.min(Math.max(E,l),a)}function O(E,l){return(l+E%l)%l}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Am=k;class N{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Bm=N;class A{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Cm=A}),function(){function Z(k){const N=[];typeof k=="number"&&N.push("code/timeOrigin",k);function A(l){N.push(l,Date.now())}function E(){const l=[];for(let a=0;a<N.length;a+=2)l.push({name:N[a],startTime:N[a+1]});return l}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(k+A.startTime)});return N}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function j(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return j(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=j(O))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var j=e();for(var O in j)(typeof exports=="object"?exports:Z)[O]=j[O]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function j(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return Z[O].call(k.exports,k,k.exports,j),k.l=!0,k.exports}return j.m=Z,j.c=e,j.d=function(O,k,N){j.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:N})},j.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},j.t=function(O,k){if(1&k&&(O=j(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(j.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var A in O)j.d(N,A,function(E){return O[E]}.bind(null,A));return N},j.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return j.d(k,"a",k),k},j.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},j.p="",j(j.s=0)}([function(Z,e,j){(function(O){var k;e=Z.exports=U,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],a=0,f=a++;l[f]="0|[1-9]\\d*";var b=a++;l[b]="[0-9]+";var y=a++;l[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;l[w]="("+l[f]+")\\.("+l[f]+")\\.("+l[f]+")";var p=a++;l[p]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var I=a++;l[I]="(?:"+l[f]+"|"+l[y]+")";var g=a++;l[g]="(?:"+l[b]+"|"+l[y]+")";var c=a++;l[c]="(?:-("+l[I]+"(?:\\."+l[I]+")*))";var u=a++;l[u]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var v=a++;l[v]="[0-9A-Za-z-]+";var m=a++;l[m]="(?:\\+("+l[v]+"(?:\\."+l[v]+")*))";var $=a++,n="v?"+l[w]+l[c]+"?"+l[m]+"?";l[$]="^"+n+"$";var r="[v=\\s]*"+l[p]+l[u]+"?"+l[m]+"?",t=a++;l[t]="^"+r+"$";var i=a++;l[i]="((?:<|>)?=?)";var s=a++;l[s]=l[b]+"|x|X|\\*";var o=a++;l[o]=l[f]+"|x|X|\\*";var h=a++;l[h]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[m]+"?)?)?";var P=a++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[u]+")?"+l[m]+"?)?)?";var D=a++;l[D]="^"+l[i]+"\\s*"+l[h]+"$";var R=a++;l[R]="^"+l[i]+"\\s*"+l[P]+"$";var z=a++;l[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=a++;l[M]="(?:~>?)";var T=a++;l[T]="(\\s*)"+l[M]+"\\s+",E[T]=new RegExp(l[T],"g");var Q=a++;l[Q]="^"+l[M]+l[h]+"$";var re=a++;l[re]="^"+l[M]+l[P]+"$";var ie=a++;l[ie]="(?:\\^)";var he=a++;l[he]="(\\s*)"+l[ie]+"\\s+",E[he]=new RegExp(l[he],"g");var le=a++;l[le]="^"+l[ie]+l[h]+"$";var ce=a++;l[ce]="^"+l[ie]+l[P]+"$";var V=a++;l[V]="^"+l[i]+"\\s*("+r+")$|^$";var J=a++;l[J]="^"+l[i]+"\\s*("+n+")$|^$";var B=a++;l[B]="(\\s*)"+l[i]+"\\s*("+r+"|"+l[h]+")",E[B]=new RegExp(l[B],"g");var q=a++;l[q]="^\\s*("+l[h]+")\\s+-\\s+("+l[h]+")\\s*$";var W=a++;l[W]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var X=a++;l[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,l[Y]),E[Y]||(E[Y]=new RegExp(l[Y]));function _(x,K){if(x instanceof U)return x;if(typeof x!="string"||x.length>N||!(K?E[t]:E[$]).test(x))return null;try{return new U(x,K)}catch{return null}}function U(x,K){if(x instanceof U){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof U))return new U(x,K);k("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?E[t]:E[$]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<A)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof U||(x=new U(x,this.loose)),this.compareMain(x)||this.comparePre(x)},U.prototype.compareMain=function(x){return x instanceof U||(x=new U(x,this.loose)),d(this.major,x.major)||d(this.minor,x.minor)||d(this.patch,x.patch)},U.prototype.comparePre=function(x){if(x instanceof U||(x=new U(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(k("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return d(ee,ge)}while(++K)},U.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=d;var F=/^[0-9]+$/;function d(x,K){var ee=F.test(x),ge=F.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function S(x,K,ee){return new U(x,ee).compare(new U(K,ee))}function L(x,K,ee){return S(x,K,ee)>0}function C(x,K,ee){return S(x,K,ee)<0}function G(x,K,ee){return S(x,K,ee)===0}function H(x,K,ee){return S(x,K,ee)!==0}function te(x,K,ee){return S(x,K,ee)>=0}function ae(x,K,ee){return S(x,K,ee)<=0}function ue(x,K,ee,ge){var ve;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x!==ee;break;case"":case"=":case"==":ve=G(x,ee,ge);break;case"!=":ve=H(x,ee,ge);break;case">":ve=L(x,ee,ge);break;case">=":ve=te(x,ee,ge);break;case"<":ve=C(x,ee,ge);break;case"<=":ve=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);k("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,K){return d(K,x)},e.major=function(x,K){return new U(x,K).major},e.minor=function(x,K){return new U(x,K).minor},e.patch=function(x,K){return new U(x,K).patch},e.compare=S,e.compareLoose=function(x,K){return S(x,K,!0)},e.rcompare=function(x,K,ee){return S(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=L,e.lt=C,e.eq=G,e.neq=H,e.gte=te,e.lte=ae,e.cmp=ue,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,ve,je,Pe,Le,De,Ae,Me,Re,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(De)?"":me(Ae)?"<"+(+De+1)+".0.0":me(Me)?"<"+De+"."+(+Ae+1)+".0":Re?"<="+De+"."+Ae+"."+Me+"-"+Re:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(k(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function ke(x,K,ee,ge){var ve,je,Pe,Le,De;switch(x=new U(x,ge),K=new fe(K,ge),ee){case">":ve=L,je=ae,Pe=C,Le=">",De=">=";break;case"<":ve=C,je=te,Pe=L,Le="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Me=K.set[Ae],Re=null,Ne=null;if(Me.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),Re=Re||ze,Ne=Ne||ze,ve(ze.semver,Re.semver,ge)?Re=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),Re.operator===Le||Re.operator===De||(!Ne.operator||Ne.operator===Le)&&je(x,Ne.semver)||Ne.operator===De&&Pe(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?E[V]:E[J],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new U(x,this.loose)),ue(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),je=this.semver.version===x.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=ue(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),De=ue(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||je&&Pe||Le||De},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),k("range",x,K);var ee=K?E[W]:E[q];x=x.replace(ee,de),k("hyphen replace",x),x=x.replace(E[B],"$1$2$3"),k("comparator trim",x,E[B]),x=(x=(x=x.replace(E[T],"$1~")).replace(E[he],"$1^")).split(/\s+/).join(" ");var ge=K?E[V]:E[J],ve=x.split(" ").map(function(je){return function(Pe,Le){return k("comp",Pe),Pe=function(De,Ae){return De.trim().split(/\s+/).map(function(Me){return function(Re,Ne){k("caret",Re,Ne);var ze=Ne?E[ce]:E[le];return Re.replace(ze,function(Fe,be,Se,Ie,Oe){var Ue;return k("caret",Re,Fe,be,Se,Ie,Oe),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Oe?(k("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(k("no pr"),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("caret",Pe),Pe=function(De,Ae){return De.trim().split(/\s+/).map(function(Me){return function(Re,Ne){var ze=Ne?E[re]:E[Q];return Re.replace(ze,function(Fe,be,Se,Ie,Oe){var Ue;return k("tilde",Re,Fe,be,Se,Ie,Oe),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Oe?(k("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0"):Ue=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",k("tilde return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("tildes",Pe),Pe=function(De,Ae){return k("replaceXRanges",De,Ae),De.split(/\s+/).map(function(Me){return function(Re,Ne){Re=Re.trim();var ze=Ne?E[R]:E[D];return Re.replace(ze,function(Fe,be,Se,Ie,Oe,Ue){k("xRange",Re,Fe,be,Se,Ie,Oe,Ue);var Te=me(Se),Ce=Te||me(Ie),qe=Ce||me(Oe);return be==="="&&qe&&(be=""),Te?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&qe?(Ce&&(Ie=0),qe&&(Oe=0),be===">"?(be=">=",Ce?(Se=+Se+1,Ie=0,Oe=0):qe&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Ce?Se=+Se+1:Ie=+Ie+1),Fe=be+Se+"."+Ie+"."+Oe):Ce?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":qe&&(Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),k("xRange return",Fe),Fe})}(Me,Ae)}).join(" ")}(Pe,Le),k("xrange",Pe),Pe=function(De,Ae){return k("replaceStars",De,Ae),De.trim().replace(E[X],"")}(Pe,Le),k("stars",Pe),Pe}(je,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(je){return!!je.match(ge)})),ve=ve.map(function(je){return new pe(je,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(ve){return ve.every(function(je){return ge.intersects(je,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new U(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,ve=null;try{var je=new fe(K,ee)}catch{return null}return x.forEach(function(Pe){je.test(Pe)&&(ge&&ve.compare(Pe)!==-1||(ve=new U(ge=Pe,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,ve=null;try{var je=new fe(K,ee)}catch{return null}return x.forEach(function(Pe){je.test(Pe)&&(ge&&ve.compare(Pe)!==1||(ve=new U(ge=Pe,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return ke(x,K,"<",ee)},e.gtr=function(x,K,ee){return ke(x,K,">",ee)},e.outside=ke,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof U)return x;if(typeof x!="string")return null;var K=x.match(E[z]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,j(1))},function(Z,e){var j,O,k=Z.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(g){if(j===setTimeout)return setTimeout(g,0);if((j===N||!j)&&setTimeout)return j=setTimeout,setTimeout(g,0);try{return j(g,0)}catch{try{return j.call(null,g,0)}catch{return j.call(this,g,0)}}}(function(){try{j=typeof setTimeout=="function"?setTimeout:N}catch{j=N}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var l,a=[],f=!1,b=-1;function y(){f&&l&&(f=!1,l.length?a=l.concat(a):b=-1,a.length&&w())}function w(){if(!f){var g=E(y);f=!0;for(var c=a.length;c;){for(l=a,a=[];++b<c;)l&&l[b].run();b=-1,c=a.length}l=null,f=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(g)}}function p(g,c){this.fun=g,this.array=c}function I(){}k.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];a.push(new p(g,c)),a.length!==1||f||E(w)},p.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=I,k.addListener=I,k.once=I,k.off=I,k.removeListener=I,k.removeAllListeners=I,k.emit=I,k.prependListener=I,k.prependOnceListener=I,k.listeners=function(g){return[]},k.binding=function(g){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(g){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[77],se([0,1]),function(Z,e){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class O{constructor(E,l,a){this.level=E,this.key=l,this.value=a,this.forward=[]}}const k=void 0;class N{constructor(E,l=2**16){this.comparator=E,this[j]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k),this.f=0}has(E){return!!N.g(this,E,this.comparator)}get(E){return N.g(this,E,this.comparator)?.value}set(E,l){return N.h(this,E,l,this.comparator)&&(this.f+=1),this}delete(E){const l=N.k(this,E,this.comparator);return l&&(this.f-=1),l}forEach(E,l){let a=this.e.forward[0];for(;a;)E.call(l,a.value,a.key,this),a=a.forward[0]}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this.e.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static g(E,l,a){let f=E.e;for(let b=E.d-1;b>=0;b--)for(;f.forward[b]&&a(f.forward[b].key,l)<0;)f=f.forward[b];if(f=f.forward[0],f&&a(f.key,l)===0)return f}static h(E,l,a,f){const b=[];let y=E.e;for(let w=E.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,l)<0;)y=y.forward[w];b[w]=y}if(y=y.forward[0],y&&f(y.key,l)===0)return y.value=a,!1;{const w=N.j(E);if(w>E.d){for(let p=E.d;p<w;p++)b[p]=E.e;E.d=w}y=new O(w,l,a);for(let p=0;p<w;p++)y.forward[p]=b[p].forward[p],b[p].forward[p]=y;return!0}}static j(E,l=.5){let a=1;for(;Math.random()<l&&a<E.c;)a+=1;return a}static k(E,l,a){const f=[];let b=E.e;for(let y=E.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,l)<0;)b=b.forward[y];f[y]=b}if(b=b.forward[0],!b||a(b.key,l)!==0)return!1;for(let y=0;y<E.d&&f[y].forward[y]===b;y++)f[y].forward[y]=b.forward[y];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$vs=N}),define(ne[46],se([0,1,9,2]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=k,e.$pe=N,e.$qe=A,e.$re=E,e.$se=a,e.$te=f,e.$ue=b,e.$ve=y,e.$we=w,e.$xe=p,e.$ye=I,e.$ze=g,e.$Ae=c,e.$Be=u,e.$Ce=v;function k(m){const $=m;return $?typeof $.read=="function":!1}function N(m){const $=m;return $?[$.on,$.pause,$.resume,$.destroy].every(n=>typeof n=="function"):!1}function A(m){const $=m;return $?N($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function E(m,$){return new l(m,$)}class l{constructor($,n){this.e=$,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(n=>n($))}h($){this.c.error.length===0?(0,j.$1)($):this.c.error.slice(0).forEach(n=>n($))}i(){this.c.end.slice(0).forEach($=>$())}on($,n){if(!this.a.destroyed)switch($){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener($,n){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(m,$){const n=[];let r;for(;(r=m.read())!==null;)n.push(r);return $(n)}function f(m,$,n){const r=[];let t;for(;(t=m.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return m.read()}}}function b(m,$){return new Promise((n,r)=>{const t=[];y(m,{onData:i=>{$&&t.push(i)},onError:i=>{$?r(i):n(void 0)},onEnd:()=>{n($?$(t):void 0)}})})}function y(m,$,n){m.on("error",r=>{n?.isCancellationRequested||$.onError(r)}),m.on("end",()=>{n?.isCancellationRequested||$.onEnd()}),m.on("data",r=>{n?.isCancellationRequested||$.onData(r)})}function w(m,$){return new Promise((n,r)=>{const t=new O.$Uc,i=[],s=P=>{if(i.push(P),i.length>$)return t.dispose(),m.pause(),n({stream:m,buffer:i,ended:!1})},o=P=>(t.dispose(),r(P)),h=()=>(t.dispose(),n({stream:m,buffer:i,ended:!0}));t.add((0,O.$Tc)(()=>m.removeListener("error",o))),m.on("error",o),t.add((0,O.$Tc)(()=>m.removeListener("end",h))),m.on("end",h),t.add((0,O.$Tc)(()=>m.removeListener("data",s))),m.on("data",s)})}function p(m,$){const n=E($);return n.end(m),n}function I(){const m=E(()=>{throw new Error("not supported")});return m.end(),m}function g(m){let $=!1;return{read:()=>$?null:($=!0,m)}}function c(m,$,n){const r=E(n);return y(m,{onData:t=>r.write($.data(t)),onError:t=>r.error($.error?$.error(t):t),onEnd:()=>r.end()}),r}function u(m,$,n){let r=!1;return{read:()=>{const t=$.read();return r?t:(r=!0,t!==null?n([m,t]):m)}}}function v(m,$,n){let r=!1;const t=E(n);return y($,{onData:i=>r?t.write(i):(r=!0,t.write(n([m,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(m)),t.end()}}),t}}),define(ne[14],se([0,1,169,46]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=void 0,e.$Ee=a,e.$Fe=f,e.$Ge=b,e.$He=y,e.$Ie=w,e.$Je=p,e.$Ke=I,e.$Le=g,e.$Me=c,e.$Ne=u,e.$Oe=v,e.$Pe=m,e.$Qe=$,e.$Re=n,e.$Se=r,e.$Te=t,e.$Ue=i,e.$Ve=s,e.$We=o,e.$Xe=D;const k=typeof Buffer<"u",N=new j.$V(()=>new Uint8Array(256));let A,E;class l{static alloc(z){return k?new l(Buffer.allocUnsafe(z)):new l(new Uint8Array(z))}static wrap(z){return k&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new l(z)}static fromString(z,M){return!(M?.dontUseNodeBuffer||!1)&&k?new l(Buffer.from(z)):(A||(A=new TextEncoder),new l(A.encode(z)))}static fromByteArray(z){const M=l.alloc(z.length);for(let T=0,Q=z.length;T<Q;T++)M.buffer[T]=z[T];return M}static concat(z,M){if(typeof M>"u"){M=0;for(let re=0,ie=z.length;re<ie;re++)M+=z[re].byteLength}const T=l.alloc(M);let Q=0;for(let re=0,ie=z.length;re<ie;re++){const he=z[re];T.set(he,Q),Q+=he.byteLength}return T}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=l.alloc(this.byteLength);return z.set(this),z}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(z,M){return new l(this.buffer.subarray(z,M))}set(z,M){if(z instanceof l)this.buffer.set(z.buffer,M);else if(z instanceof Uint8Array)this.buffer.set(z,M);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),M);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return y(this.buffer,z)}writeUInt32BE(z,M){w(this.buffer,z,M)}readUInt32LE(z){return p(this.buffer,z)}writeUInt32LE(z,M){I(this.buffer,z,M)}readUInt8(z){return g(this.buffer,z)}writeUInt8(z,M){c(this.buffer,z,M)}indexOf(z,M=0){return a(this.buffer,z instanceof l?z.buffer:z,M)}}e.$De=l;function a(R,z,M=0){const T=z.byteLength,Q=R.byteLength;if(T===0)return 0;if(T===1)return R.indexOf(z[0]);if(T>Q-M)return-1;const re=N.value;re.fill(z.length);for(let ce=0;ce<z.length;ce++)re[z[ce]]=z.length-ce-1;let ie=M+z.length-1,he=ie,le=-1;for(;ie<Q;)if(R[ie]===z[he]){if(he===0){le=ie;break}ie--,he--}else ie+=Math.max(z.length-he,re[R[ie]]),he=z.length-1;return le}function f(R,z){return R[z+0]<<0>>>0|R[z+1]<<8>>>0}function b(R,z,M){R[M+0]=z&255,z=z>>>8,R[M+1]=z&255}function y(R,z){return R[z]*2**24+R[z+1]*2**16+R[z+2]*2**8+R[z+3]}function w(R,z,M){R[M+3]=z,z=z>>>8,R[M+2]=z,z=z>>>8,R[M+1]=z,z=z>>>8,R[M]=z}function p(R,z){return R[z+0]<<0>>>0|R[z+1]<<8>>>0|R[z+2]<<16>>>0|R[z+3]<<24>>>0}function I(R,z,M){R[M+0]=z&255,z=z>>>8,R[M+1]=z&255,z=z>>>8,R[M+2]=z&255,z=z>>>8,R[M+3]=z&255}function g(R,z){return R[z]}function c(R,z,M){R[M]=z}function u(R){return O.$se(R,z=>l.concat(z))}function v(R){return O.$ze(R)}function m(R){return O.$ue(R,z=>l.concat(z))}async function $(R){return R.ended?l.concat(R.buffer):l.concat([...R.buffer,await m(R.stream)])}function n(R){return O.$xe(R,z=>l.concat(z))}function r(R){return O.$Ae(R,{data:z=>typeof z=="string"?l.fromString(z):l.wrap(z)},z=>l.concat(z))}function t(R){return O.$re(z=>l.concat(z),R)}function i(R,z){return O.$Be(R,z,M=>l.concat(M))}function s(R,z){return O.$Ce(R,z,M=>l.concat(M))}function o(R){let z=0,M=0,T=0;const Q=new Uint8Array(Math.floor(R.length/4*3)),re=he=>{switch(M){case 3:Q[T++]=z|he,M=0;break;case 2:Q[T++]=z|he>>>2,z=he<<6,M=3;break;case 1:Q[T++]=z|he>>>4,z=he<<4,M=2;break;default:z=he<<2,M=1}};for(let he=0;he<R.length;he++){const le=R.charCodeAt(he);if(le>=65&&le<=90)re(le-65);else if(le>=97&&le<=122)re(le-97+26);else if(le>=48&&le<=57)re(le-48+52);else if(le===43||le===45)re(62);else if(le===47||le===95)re(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${R[he]}`)}}const ie=T;for(;M>0;)re(0);return l.wrap(Q).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:R},z=!0,M=!1){const T=M?P:h;let Q="";const re=R.byteLength%3;let ie=0;for(;ie<R.byteLength-re;ie+=3){const he=R[ie+0],le=R[ie+1],ce=R[ie+2];Q+=T[he>>>2],Q+=T[(he<<4|le>>>4)&63],Q+=T[(le<<2|ce>>>6)&63],Q+=T[ce&63]}if(re===1){const he=R[ie+0];Q+=T[he>>>2],Q+=T[he<<4&63],z&&(Q+="==")}else if(re===2){const he=R[ie+0],le=R[ie+1];Q+=T[he>>>2],Q+=T[(he<<4|le>>>4)&63],Q+=T[le<<2&63],z&&(Q+="=")}return Q}}),define(ne[43],se([0,1,31]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$lj=void 0,e.$hj=O,e.$ij=k,e.$jj=N,e.$kj=E,e.$mj=I;function O(c){return k(c,0)}function k(c,u){switch(typeof c){case"object":return c===null?N(349,u):Array.isArray(c)?l(c,u):a(c,u);case"string":return E(c,u);case"boolean":return A(c,u);case"number":return N(c,u);case"undefined":return N(937,u);default:return N(617,u)}}function N(c,u){return(u<<5)-u+c|0}function A(c,u){return N(c?433:863,u)}function E(c,u){u=N(149417,u);for(let v=0,m=c.length;v<m;v++)u=N(c.charCodeAt(v),u);return u}function l(c,u){return u=N(104579,u),c.reduce((v,m)=>k(m,v),u)}function a(c,u){return u=N(181387,u),Object.keys(c).sort().reduce((v,m)=>(v=E(m,v),k(c[m],v)),u)}class f{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=k(u,this.g),this.g}}e.$lj=f;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(c,u,v=32){const m=v-u,$=~((1<<m)-1);return(c<<u|($&c)>>>m)>>>0}function w(c,u=0,v=c.byteLength,m=0){for(let $=0;$<v;$++)c[u+$]=m}function p(c,u,v="0"){for(;c.length<u;)c=v+c;return c}function I(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(v=>v.toString(16).padStart(2,"0")).join(""):p((c>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const v=u.length;if(v===0)return;const m=this.p;let $=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=u.charCodeAt(0),t=0);;){let i=r;if(j.$zf(r))if(t+1<v){const s=u.charCodeAt(t+1);j.$Af(s)?(t++,i=j.$Bf(r,s)):i=65533}else{n=r;break}else j.$Af(r)&&(i=65533);if($=this.w(m,$,i),t++,t<v)r=u.charCodeAt(t);else break}this.r=$,this.u=n}w(u,v,m){return m<128?u[v++]=m:m<2048?(u[v++]=192|(m&1984)>>>6,u[v++]=128|(m&63)>>>0):m<65536?(u[v++]=224|(m&61440)>>>12,u[v++]=128|(m&4032)>>>6,u[v++]=128|(m&63)>>>0):(u[v++]=240|(m&1835008)>>>18,u[v++]=128|(m&258048)>>>12,u[v++]=128|(m&4032)>>>6,u[v++]=128|(m&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,v=this.q;for(let h=0;h<64;h+=4)u.setUint32(h,v.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)u.setUint32(h,y(u.getUint32(h-12,!1)^u.getUint32(h-32,!1)^u.getUint32(h-56,!1)^u.getUint32(h-64,!1),1),!1);let m=this.h,$=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let h=0;h<80;h++)h<20?(i=$&n|~$&r,s=1518500249):h<40?(i=$^n^r,s=1859775393):h<60?(i=$&n|$&r|n&r,s=2400959708):(i=$^n^r,s=3395469782),o=y(m,5)+i+t+s+u.getUint32(h*4,!1)&4294967295,t=r,r=n,n=y($,30),$=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+$&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$nj=g}),define(ne[55],se([0,1,31]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const N="error",A="warning",E="warn",l="info",a="ignore";function f(y){return y?j.$vf(N,y)?k.Error:j.$vf(A,y)||j.$vf(E,y)?k.Warning:j.$vf(l,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=f;function b(y){switch(y){case k.Error:return N;case k.Warning:return A;case k.Info:return l;default:return a}}k.toString=b}(O||(O={})),e.default=O}),define(ne[27],se([0,1,3]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=O,e.$1n=k,e.$2n=A,e.$3n=l,e.$4n=a,e.$5n=f,e.$6n=b,e.$7n=y,e.$8n=w,e.$9n=p,e.$0n=I,e.$$n=g;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([v,m])=>{u[v]=m&&typeof m=="object"?O(m):m}),u}function k(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const v=u.shift();Object.freeze(v);for(const m in v)if(N.call(v,m)){const $=v[m];typeof $=="object"&&!Object.isFrozen($)&&!(0,j.$9f)($)&&u.push($)}}return c}const N=Object.prototype.hasOwnProperty;function A(c,u){return E(c,u,new Set)}function E(c,u,v){if((0,j.$cg)(c))return c;const m=u(c);if(typeof m<"u")return m;if(Array.isArray(c)){const $=[];for(const n of c)$.push(E(n,u,v));return $}if((0,j.$8f)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const $={};for(const n in c)N.call(c,n)&&($[n]=E(c[n],u,v));return v.delete(c),$}return c}function l(c,u,v=!0){return(0,j.$8f)(c)?((0,j.$8f)(u)&&Object.keys(u).forEach(m=>{m in c?v&&((0,j.$8f)(c[m])&&(0,j.$8f)(u[m])?l(c[m],u[m],v):c[m]=u[m]):c[m]=u[m]}),c):u}function a(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let v,m;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(v=0;v<c.length;v++)if(!a(c[v],u[v]))return!1}else{const $=[];for(m in c)$.push(m);$.sort();const n=[];for(m in u)n.push(m);if(n.sort(),!a($,n))return!1;for(v=0;v<$.length;v++)if(!a(c[$[v]],u[$[v]]))return!1}return!0}function f(c){const u=new Set;return JSON.stringify(c,(v,m)=>{if((0,j.$8f)(m)||Array.isArray(m)){if(u.has(m))return"[Circular]";u.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function b(c,u){const v=Object.create(null);return!c||!u||Object.keys(u).forEach($=>{const n=c[$],r=u[$];a(n,r)||(v[$]=r)}),v}function y(c,u){const v=u.toLowerCase(),m=Object.keys(c).find($=>$.toLowerCase()===v);return m?c[m]:c[u]}function w(c,u){const v=Object.create(null);for(const[m,$]of Object.entries(c))u(m,$)&&(v[m]=$);return v}function p(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}function I(c){const u=[];for(const v of p(c))typeof c[v]=="function"&&u.push(v);return u}function g(c,u){const v=$=>function(){const n=Array.prototype.slice.call(arguments,0);return u($,n)},m={};for(const $ of c)m[$]=v($);return m}}),define(ne[28],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=O;const j=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return j.test(k)}e.$Pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const N=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){k(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let l=0,a="";return a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a}}()}),define(ne[78],se([0,1,33]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=N;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const E=A.replace(/\-/g,":").toLowerCase();return!O.has(E)}function N(){const A=(0,j.networkInterfaces)();for(const E in A){const l=A[E];if(l){for(const{mac:a}of l)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[79],se([7,4]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ne[80],se([0,1,79]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=a,e.$Zm=f,e.$1m=b;const O=60,k=O*60,N=k*24,A=N*7,E=N*30,l=N*365;function a(y,w,p,I){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,j.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!I&&g<30)return(0,j.localize)(1,null);let c;return g<O?(c=g,w?c===1?p?(0,j.localize)(2,null,c):(0,j.localize)(3,null,c):p?(0,j.localize)(4,null,c):(0,j.localize)(5,null,c):c===1?p?(0,j.localize)(6,null,c):(0,j.localize)(7,null,c):p?(0,j.localize)(8,null,c):(0,j.localize)(9,null,c)):g<k?(c=Math.floor(g/O),w?c===1?p?(0,j.localize)(10,null,c):(0,j.localize)(11,null,c):p?(0,j.localize)(12,null,c):(0,j.localize)(13,null,c):c===1?p?(0,j.localize)(14,null,c):(0,j.localize)(15,null,c):p?(0,j.localize)(16,null,c):(0,j.localize)(17,null,c)):g<N?(c=Math.floor(g/k),w?c===1?p?(0,j.localize)(18,null,c):(0,j.localize)(19,null,c):p?(0,j.localize)(20,null,c):(0,j.localize)(21,null,c):c===1?p?(0,j.localize)(22,null,c):(0,j.localize)(23,null,c):p?(0,j.localize)(24,null,c):(0,j.localize)(25,null,c)):g<A?(c=Math.floor(g/N),w?c===1?(0,j.localize)(26,null,c):(0,j.localize)(27,null,c):c===1?(0,j.localize)(28,null,c):(0,j.localize)(29,null,c)):g<E?(c=Math.floor(g/A),w?c===1?p?(0,j.localize)(30,null,c):(0,j.localize)(31,null,c):p?(0,j.localize)(32,null,c):(0,j.localize)(33,null,c):c===1?p?(0,j.localize)(34,null,c):(0,j.localize)(35,null,c):p?(0,j.localize)(36,null,c):(0,j.localize)(37,null,c)):g<l?(c=Math.floor(g/E),w?c===1?p?(0,j.localize)(38,null,c):(0,j.localize)(39,null,c):p?(0,j.localize)(40,null,c):(0,j.localize)(41,null,c):c===1?p?(0,j.localize)(42,null,c):(0,j.localize)(43,null,c):p?(0,j.localize)(44,null,c):(0,j.localize)(45,null,c)):(c=Math.floor(g/l),w?c===1?p?(0,j.localize)(46,null,c):(0,j.localize)(47,null,c):p?(0,j.localize)(48,null,c):(0,j.localize)(49,null,c):c===1?p?(0,j.localize)(50,null,c):(0,j.localize)(51,null,c):p?(0,j.localize)(52,null,c):(0,j.localize)(53,null,c))}function f(y,w){const p=Math.abs(y/1e3);return p<1?w?(0,j.localize)(54,null,y):(0,j.localize)(55,null,y):p<O?w?(0,j.localize)(56,null,Math.round(y)/1e3):(0,j.localize)(57,null,Math.round(y)/1e3):p<k?w?(0,j.localize)(58,null,Math.round(y/(1e3*O))):(0,j.localize)(59,null,Math.round(y/(1e3*O))):p<N?w?(0,j.localize)(60,null,Math.round(y/(1e3*k))):(0,j.localize)(61,null,Math.round(y/(1e3*k))):(0,j.localize)(62,null,Math.round(y/(1e3*N)))}function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[81],se([7,4]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ne[34],se([0,1,19,3,81]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=l,e.$fj=a,e.$gj=f;function N(b,y){return y&&(b.stack||b.stacktrace)?k.localize(0,null,E(b),A(b.stack)||A(b.stacktrace)):E(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function l(b=null,y=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const w=j.$Hb(b),p=l(w[0],y);return w.length>1?k.localize(4,null,p,w.length):p}if(O.$6f(b))return b;if(b.detail){const w=b.detail;if(w.error)return N(w.error,y);if(w.exception)return N(w.exception,y)}return b.stack?N(b,y):b.message?b.message:k.localize(5,null)}function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}function f(b,y){let w;return typeof b=="string"?w=new Error(b):w=b,w.actions=y,w}}),define(ne[82],se([7,4]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(ne[83],se([0,1,82]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=O;function O(k){switch(k){case 1:return(0,j.localize)(0,null);case 2:return(0,j.localize)(1,null);case 3:return(0,j.localize)(2,null);case 4:return(0,j.localize)(3,null);case 5:return(0,j.localize)(4,null);case 6:return(0,j.localize)(5,null);case 7:return(0,j.localize)(6,null);case 8:return(0,j.localize)(7,null);case 9:return(0,j.localize)(8,null);default:return""}}}),define(ne[56],se([0,1,12]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=N,e.$km=A;var O;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function N(E,...l){const a=l.reduce((y,w)=>(y[w]=!0,y),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!a[y]).forEach(y=>{for(let w=0;w<f.length;w++)if(y.search(f[w])!==-1){delete E[y];break}})}function A(E){E&&(delete E.DEBUG,j.$j&&delete E.DYLD_LIBRARY_PATH,j.$k&&delete E.LD_PRELOAD)}}),define(ne[84],se([0,1,11]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=O,e.$Tq=k,e.$Uq=N,e.log=E;function O(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function k(a){const f=[];let b;try{const y=JSON.parse(a.arguments),w=y[y.length-1];w&&w.__$stack&&(y.pop(),b=w.__$stack),f.push(...y)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:b}}function N(a){if(typeof a!="string")return N(k(a).stack);const f=a;if(f){const b=A(f),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:j.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function A(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function E(a,f){const{args:b,stack:y}=k(a),w=typeof b[0]=="string"&&b.length===1;let p=A(y);p&&(p=`(${p.trim()})`);let I=[];if(typeof b[0]=="string"?p&&w?I=[`%c[${f}] %c${b[0]} %c${p}`,l("blue"),l(""),l("grey")]:I=[`%c[${f}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:I=[`%c[${f}]%`,l("blue"),...b],p&&!w&&I.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function l(a){return`color: ${a}`}}),define(ne[47],se([0,1,14,11]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=k,e.$2h=N,e.$3h=E;function k(l){return JSON.stringify(l,A)}function N(l){let a=JSON.parse(l);return a=E(a),a}function A(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return O.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof j.$De||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=E(l[f],a+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=E(l[f],a+1))}return l}}),define(ne[85],se([0,1,72,15,12,11]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VD=f;class A{constructor(y,w,p){this.id=y,this.dependencies=w,this.callback=p}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,w,p)=>{typeof y!="string"&&(p=w,w=y,y=null),(typeof w!="object"||!Array.isArray(w))&&(p=w,w=null),this.c.push(new A(y,w,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const w=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!w)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(y){return new Promise((w,p)=>{const I=document.createElement("script");I.setAttribute("async","async"),I.setAttribute("type","text/javascript");const g=()=>{I.removeEventListener("load",c),I.removeEventListener("error",u)},c=v=>{g(),w(this.c.pop())},u=v=>{g(),p(v)};I.addEventListener("load",c),I.addEventListener("error",u),this.f&&(y=this.f.createScriptURL(y)),I.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(I)})}i(y){return new Promise((w,p)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),w(this.c.pop())}catch(I){p(I)}})}async j(y){try{const w=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,I=globalThis._VSCODE_NODE_MODULES.module,g=N.URI.parse(y).fsPath,c=w.readFileSync(g).toString(),u=I.wrap(c.replace(/^#!.*/,""));return new p.Script(u).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function f(b,y,w){if(j.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const p=`${b}/${y}`;if(l.has(p))return l.get(p);let I;if(/^\w[\w\d+.-]*:\/\//.test(p))I=p;else{const v=`${w&&!k.$o?O.$Kg:O.$Jg}/${p}`;I=O.$Ng.asBrowserUri(v).toString(!0)}const g=E.INSTANCE.load(I);return l.set(p,g),g}else return await new Promise((p,I)=>{Z([b],p,I)})}}),define(ne[86],se([0,1,33,48,28,78,12]),function(Z,e,j,O,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0,e.$Cn=l,e.$Dn=b,e.$Bn=new class{c(y){return this.a||(this.a=O.$zi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,w=0;const p=(0,j.networkInterfaces)();for(const I in p){const g=p[I];if(g)for(const{mac:c,internal:u}of g)u||(w+=1,this.c(c.toUpperCase())&&(y+=1))}this.b=w>0?y/w:0}return this.b}};let E;async function l(y){return E||(E=(async()=>await a(y)||k.$Pg())()),E}async function a(y){try{const w=await new Promise((I,g)=>{Z(["crypto"],I,g)}),p=(0,N.$An)();return w.createHash("sha256").update(p,"utf8").digest("hex")}catch(w){y(w);return}}const f="Software\\Microsoft\\SQMClient";async function b(y){if(A.$i){const w=await new Promise((p,I)=>{Z(["@vscode/windows-registry"],p,I)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(p){return y(p),""}}return""}}),define(ne[87],se([0,1,33,16,25]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=u,e.$im=v;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=1:f=0;class b{constructor($,n,r){this.exePath=$,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:m=!1}={}){return m?a===0?process.env["ProgramFiles(x86)"]||null:f===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:m=!1,findPreview:$=!1}={}){const n=y({useAlternateBitness:m});if(!n)return null;const r=O.$kc(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const h of await k.Promises.readdir(r)){let P=-1;if($){const R=h.indexOf("-");if(R<0)continue;const z=h.substring(0,R);if(!N.test(z)||h.substring(R+1)!=="preview")continue;P=parseInt(z,10)}else{if(!N.test(h))continue;P=parseInt(h,10)}if(P<=t)continue;const D=O.$kc(r,h,"pwsh.exe");await k.SymlinkSupport.existsFile(D)&&(i=D,t=P)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=$?" Preview":"";return new b(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const $=O.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory($))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=m?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir($))if(n.test(t)){const i=O.$kc($,t,"pwsh.exe");return new b(i,r)}return null}function I(){const m=O.$kc(j.homedir(),".dotnet","tools","pwsh.exe");return new b(m,".NET Core PowerShell Global Tool")}function g(){const m=O.$kc(process.env.windir,a===1&&f!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(m,"Windows PowerShell",!0)}async function*c(){let m=await w();m&&(yield m),m=await w({useAlternateBitness:!0}),m&&(yield m),m=await p(),m&&(yield m),m=I(),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await p({findPreview:!0}),m&&(yield m),m=await w({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=g(),m&&(yield m)}async function*u(){for await(const m of c())await m.exists()&&(yield m)}async function v(){for await(const m of u())return m;return null}}),define(ne[57],se([0,1,16,12,35,56,3,25]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$lm=l,e.$mm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function l(b=k.env){return b.comspec||"cmd.exe"}function a(b){let y=[],w=!1;const p=function(I){if(w){y.push(I);return}(!b.send(I,c=>{if(c&&console.error(c),w=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(v=>p(v))}})||O.$i)&&(w=!0)};return{send:p}}var f;(function(b){async function y(w,p,I){if(j.$jc(w))return w;if(p===void 0&&(p=k.cwd()),j.$nc(w)!=="."||(I===void 0&&A.$6f(k.env.PATH)&&(I=k.env.PATH.split(j.$uc)),I===void 0||I.length===0))return j.$kc(p,w);async function c(u){if(await E.Promises.exists(u)){let v;try{v=await E.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(v=await E.Promises.lstat(u))}return v?!v.isDirectory():!1}return!1}for(const u of I){let v;if(j.$jc(u)?v=j.$kc(u,w):v=j.$kc(p,u,w),await c(v))return v;let m=v+".com";if(await c(m)||(m=v+".exe",await c(m)))return m}return j.$kc(p,w)}b.findExecutable=y})(f||(e.win32=f={}))}),define(ne[88],se([0,1,33,12,87,57]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=A;async function A(b,y){return b===1?O.$i?f():N.$lm(y):l(b,y)}let E=null;function l(b,y){if(O.$k&&b===2||O.$j&&b===3)return"/bin/bash";if(!E){let w;if(O.$i)w="/bin/bash";else{if(w=y.SHELL,!w)try{w=(0,j.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}E=w}return E}let a=null;async function f(){return a||(a=(await(0,k.$im)()).exePath),a}});var $e=this&&this.__decorate||function(Z,e,j,O){var k=arguments.length,N=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,j):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(Z,e,j,O);else for(var E=Z.length-1;E>=0;E--)(A=Z[E])&&(N=(k<3?A(N):k>3?A(e,j,N):A(e,j))||N);return k>3&&N&&Object.defineProperty(e,j,N),N};define(ne[58],se([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.ProxyChannel=e.$bi=e.$$h=e.$0h=e.$9h=e.RequestInitiator=e.$8h=e.$5h=e.$4h=void 0,e.$6h=o,e.$7h=h,e.$_h=T,e.$ai=Q;var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(I||(I={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function u(B){let q=0;for(let W=0;;W+=7){const X=B.read(1);if(q|=(X.buffer[0]&127)<<W,!(X.buffer[0]&128))return q}}const v=t(0);function m(B,q){if(q===0){B.write(v);return}let W=0;for(let Y=q;Y!==0;Y=Y>>>7)W++;const X=k.$De.alloc(W);for(let Y=0;q!==0;Y++)X.buffer[Y]=q&127,q=q>>>7,q>0&&(X.buffer[Y]|=128);B.write(X)}class ${constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$4h=$;class n{constructor(){this.a=[]}get buffer(){return k.$De.concat(this.a)}write(q){this.a.push(q)}}e.$5h=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function t(B){const q=k.$De.alloc(1);return q.writeUInt8(B,0),q}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(B,q){if(typeof q>"u")B.write(i.Undefined);else if(typeof q=="string"){const W=k.$De.fromString(q);B.write(i.String),m(B,W.byteLength),B.write(W)}else if(s&&Buffer.isBuffer(q)){const W=k.$De.wrap(q);B.write(i.Buffer),m(B,W.byteLength),B.write(W)}else if(q instanceof k.$De)B.write(i.VSBuffer),m(B,q.byteLength),B.write(q);else if(Array.isArray(q)){B.write(i.Array),m(B,q.length);for(const W of q)o(B,W)}else if(typeof q=="number"&&(q|0)===q)B.write(i.Uint),m(B,q);else{const W=k.$De.fromString(JSON.stringify(q));B.write(i.Object),m(B,W.byteLength),B.write(W)}}function h(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(u(B)).toString();case r.Buffer:return B.read(u(B)).buffer;case r.VSBuffer:return B.read(u(B));case r.Array:{const W=u(B),X=[];for(let Y=0;Y<W;Y++)X.push(h(B));return X}case r.Object:return JSON.parse(B.read(u(B)).toString());case r.Int:return u(B)}}class P{constructor(q,W,X=null,Y=1e3){this.h=q,this.j=W,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,g(q.type),q.data);return}}}o(q,W=void 0){const X=new n;return o(X,q),o(X,W),this.p(X.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new $(q),X=h(W),Y=h(W),_=X[0];switch(_){case 100:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}: ${X[2]}.${X[3]}`,Y),this.s({type:_,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}: ${X[2]}.${X[3]}`,Y),this.t({type:_,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}`),this.u({type:_,id:X[1]});case 103:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}`),this.u({type:_,id:X[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=new N.$ne;let Y;try{Y=W.call(this.j,q.name,q.arg,X.token)}catch(F){Y=Promise.reject(F)}const _=q.id;Y.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{U.dispose(),this.d.delete(q.id)});const U=(0,a.$Tc)(()=>X.cancel());this.d.set(q.id,U)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=q.id,_=W.listen(this.j,q.name,q.arg)(U=>this.m({id:X,data:U,type:204}));this.d.set(q.id,_)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const X=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:X})}w(q){const W=this.g.get(q);if(W){for(const X of W)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Qc)(this.d.values()),this.d.clear()}}e.$8h=P;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class R{constructor(q,W=null){this.l=q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$ce,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=W}getChannel(q){const W=this;return{call(X,Y,_){return W.a?Promise.reject(new E.$5):W.m(q,X,Y,_)},listen(X,Y){return W.a?l.Event.None:W.o(q,X,Y)}}}m(q,W,X,Y=N.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:q,name:W,arg:X};if(Y.isCancellationRequested)return Promise.reject(new E.$5);let d;return new Promise((L,C)=>{if(Y.isCancellationRequested)return C(new E.$5);const G=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(_),L(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(_),C(pe.data);break}};this.f.set(_,ue),this.p(F)};let H=null;this.b===c.Idle?G():(H=(0,O.$gh)(ue=>this.u()),H.then(()=>{H=null,G()}));const te=()=>{H?(H.cancel(),H=null):this.p({id:_,type:101}),C(new E.$5)},ae=Y.onCancellationRequested(te);d=(0,a.$Sc)((0,a.$Tc)(te),ae),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(q,W,X){const Y=this.g++,U={id:Y,type:102,channelName:q,name:W,arg:X};let F=null;const d=new l.$ce({onWillAddFirstListener:()=>{F=(0,O.$gh)(L=>this.u()),F.then(()=>{F=null,this.d.add(d),this.p(U)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(d),this.p({id:Y,type:103}))}}),S=L=>d.fire(L.data);return this.f.set(Y,S),d.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${p(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,p(q.type));return}}}q(q,W=void 0){const X=new n;return o(X,q),o(X,W),this.r(X.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new $(q),X=h(W),Y=h(W),_=X[0];switch(_){case 200:return this.j?.logIncoming(q.byteLength,0,0,g(_)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,X[1],0,g(_),Y),this.t({type:X[0],id:X[1],data:Y})}}t(q){if(q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Qc)(this.d.values()),this.d.clear()}}e.$9h=R,$e([A.$Xh],R.prototype,"onDidInitializePromise",null);class z{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q,W,X){this.a=new Map,this.f=new Set,this.g=new l.$ce,this.onDidAddConnection=this.g.event,this.h=new l.$ce,this.onDidRemoveConnection=this.h.event,this.j=new a.$Uc,this.j.add(q(({protocol:Y,onDidClientDisconnect:_})=>{const U=l.Event.once(Y.onMessage);this.j.add(U(F=>{const d=new $(F),S=h(d),L=new P(Y,S,W,X),C=new R(Y,W);this.a.forEach((H,te)=>L.registerChannel(te,H));const G={channelServer:L,channelClient:C,ctx:S};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{L.dispose(),C.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,W){const X=this;return{call(Y,_,U){let F;if((0,y.$hg)(W)){const S=(0,j.$4b)(X.connections.filter(W));F=S?Promise.resolve(S):l.Event.toPromise(l.Event.filter(X.onDidAddConnection,W))}else F=W.routeCall(X,Y,_);const d=F.then(S=>S.channelClient.getChannel(q));return T(d).call(Y,_,U)},listen(Y,_){if((0,y.$hg)(W))return X.k(q,W,Y,_);const U=W.routeEvent(X,Y,_).then(F=>F.channelClient.getChannel(q));return T(U).listen(Y,_)}}}k(q,W,X,Y){const _=this;let U;const F=new l.$ce({onWillAddFirstListener:()=>{U=new a.$Uc;const d=new l.$ie,S=new Map,L=G=>{const te=G.channelClient.getChannel(q).listen(X,Y),ae=d.add(te);S.set(G,ae)},C=G=>{const H=S.get(G);H&&(H.dispose(),S.delete(G))};_.connections.filter(W).forEach(L),l.Event.filter(_.onDidAddConnection,W)(L,void 0,U),_.onDidRemoveConnection(C,void 0,U),d.event(F.fire,F,U),U.add(d)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return F.event}registerChannel(q,W){this.a.set(q,W);for(const X of this.f)X.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$0h=z;class M{constructor(q,W,X=null){const Y=new n;o(Y,W),q.send(Y.buffer),this.a=new R(q,X),this.d=new P(q,W,X)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$$h=M;function T(B){return{call(q,W,X){return B.then(Y=>Y.call(q,W,X))},listen(q,W){const X=new l.$le;return B.then(Y=>X.input=Y.listen(q,W)),X.event}}}function Q(B){let q=!1;return{call(W,X,Y){return q?B.call(W,X,Y):(0,O.$uh)(0).then(()=>q=!0).then(()=>B.call(W,X,Y))},listen(W,X){if(q)return B.listen(W,X);const Y=new l.$le;return(0,O.$uh)(0).then(()=>q=!0).then(()=>Y.input=B.listen(W,X)),Y.event}}}class re{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$bi=re;var ie;(function(B){function q(_,U,F){const d=_,S=F&&F.disableMarshalling,L=new Map;for(const C in d)X(C)&&L.set(C,l.Event.buffer(d[C],!0,void 0,U));return new class{listen(C,G,H){const te=L.get(G);if(te)return te;const ae=d[G];if(typeof ae=="function"){if(Y(G))return ae.call(d,H);if(X(G))return L.set(G,l.Event.buffer(d[G],!0,void 0,U)),L.get(G)}throw new E.$bb(`Event not found: ${G}`)}call(C,G,H){const te=d[G];if(typeof te=="function"){if(!S&&Array.isArray(H))for(let ue=0;ue<H.length;ue++)H[ue]=(0,f.$3h)(H[ue]);let ae=te.apply(d,H);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${G}`)}}}B.fromService=q;function W(_,U){const F=U&&U.disableMarshalling;return new Proxy({},{get(d,S){if(typeof S=="string")return U?.properties?.has(S)?U.properties.get(S):Y(S)?function(L){return _.listen(S,L)}:X(S)?_.listen(S):async function(...L){let C;U&&!(0,y.$cg)(U.context)?C=[U.context,...L]:C=L;const G=await _.call(S,C);return F?G:(0,f.$3h)(G)};throw new E.$bb(`Property not found: ${String(S)}`)}})}B.toService=W;function X(_){return _[0]==="o"&&_[1]==="n"&&b.$uf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&b.$uf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const q=B.toString();if(q!=="[object Object]")return q}return B}function ce(B){return Array.isArray(B)?B.map(le):le(B)}function V(B,q,W,X,Y,_,U){U=ce(U);const F=he[Y],d=F[X%F.length];let S=[`%c[${B}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(_)?(S=S.concat(U),S.push(")")):S.push(U),console.log.apply(console,S)}class J{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,X,Y,_){this.b+=q,V(this.d,this.b,q,W,X,Y,_)}logIncoming(q,W,X,Y,_){this.a+=q,V(this.f,this.a,q,W,X,Y,_)}}e.$ci=J}),define(ne[89],se([0,1,59,8,14,20,84,9,5,2,27,57,56,58]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class p extends w.$8h{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",u=>k.$De.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Wq=p;class I{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new l.$ce,this.onDidProcessExit=this.h.event;const v=u&&u.timeout?u.timeout:6e4;this.b=new O.$qh(v),this.d=null,this.f=null}getChannel(c){const u=this;return{call(v,m,$){return u.k(c,v,m,$)},listen(v,m){return u.l(c,v,m)}}}k(c,u,v,m=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const $=this.n(c),n=(0,O.$gh)(i=>$.call(u,v,i)),r=m.onCancellationRequested(()=>n.cancel()),t=(0,a.$Tc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,u,v){if(!this.b)return l.Event.None;this.b.cancel();let m;const $=new l.$ce({onWillAddFirstListener:()=>{m=this.n(c).listen(u,v)($.fire,$),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,f.$Zn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$km)(u.env),this.d=(0,j.fork)(this.i,c,u);const v=new l.$ce,$=l.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Sq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.$De.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,b.$mm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=v.event,i={send:r,onMessage:t};this.f=new w.$9h(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",s),$.dispose(),this.c.forEach(P=>(0,a.$Qc)(P)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Xq=I}),define(ne[90],se([0,1,8,5,2,47,3]),function(Z,e,j,O,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.StorageState=e.StorageHint=void 0,e.$Sp=l;var E;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function l(y){const w=y;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends k.$Vc{static{this.a=100}constructor(w,p=Object.create(null)){super(),this.r=w,this.s=p,this.b=this.B(new O.$fe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new j.$rh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((p,I)=>this.w(I,p)),w.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(w,p){if(this.c===a.Closed)return;let I=!1;(0,A.$cg)(p)?I=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),I=!0),I&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,p){const I=this.f.get(w);return(0,A.$cg)(I)?p:I}getBoolean(w,p){const I=this.get(w);return(0,A.$cg)(I)?p:I==="true"}getNumber(w,p){const I=this.get(w);return(0,A.$cg)(I)?p:parseInt(I,10)}getObject(w,p){const I=this.get(w);return(0,A.$cg)(I)?p:(0,N.$2h)(I)}async set(w,p,I=!1){if(this.c===a.Closed)return;if((0,A.$cg)(p))return this.delete(w,I);const g=(0,A.$8f)(p)||Array.isArray(p)?(0,N.$1h)(p):String(p);if(this.f.get(w)!==g)return this.f.set(w,g),this.j.set(w,g),this.h.delete(w),this.b.fire({key:w,external:I}),this.D()}async delete(w,p=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(this.z)return this.D(w)}async D(w){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Tp=f;class b{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,I)=>this.a.set(I,p)),w.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$Up=b}),define(ne[91],se([7,4]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(ne[49],se([0,1,60,8,16,3,25,91]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.zip=g,e.$gq=c,e.$hq=v,e.$dq="end of central directory record signature not found";const l=new RegExp(e.$dq);class a extends Error{constructor($,n){let r=n.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=n}}e.$eq=a;function f(m){const $=m.externalFileAttributes>>16||33188;return[448,56,7].map(n=>$&n).reduce((n,r)=>n+r,$&61440)}function b(m){if(m instanceof a)return m;let $;return l.test(m.message)&&($="CorruptZip"),new a($,m)}function y(m,$,n,r,t,i){const s=k.$nc($),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,$)));const h=k.$kc(r,$);let P;return i.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((D,R)=>{if(!i.isCancellationRequested)try{P=(0,j.createWriteStream)(h,{mode:n}),P.once("close",()=>D()),P.once("error",R),m.once("error",R),m.pipe(P)}catch(z){R(z)}}))}function w(m,$,n,r){let t=(0,O.$gh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),m.close()});return new Promise((o,h)=>{const P=new O.$oh,D=R=>{R.isCancellationRequested||(i++,m.readEntry())};m.once("error",h),m.once("close",()=>t.then(()=>{r.isCancellationRequested||m.entryCount===i?o():h(new a("Incomplete",new Error(E.localize(1,null,i,m.entryCount))))},h)),m.readEntry(),m.on("entry",R=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(R.fileName)){D(r);return}const z=R.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(z)){const Q=k.$kc($,z);t=(0,O.$gh)(re=>A.Promises.mkdir(Q,{recursive:!0}).then(()=>D(re)).then(void 0,h));return}const M=I(m,R),T=f(R);t=(0,O.$gh)(Q=>P.queue(()=>M.then(re=>y(re,z,T,$,n,Q).then(()=>D(Q)))).then(null,h))})}).finally(()=>s.dispose())}async function p(m,$=!1){const{open:n}=await new Promise((r,t)=>{Z(["yauzl"],r,t)});return new Promise((r,t)=>{n(m,$?{lazyEntries:!0}:void 0,(i,s)=>{i?t(b(i)):r((0,N.$eg)(s))})})}function I(m,$){return new Promise((n,r)=>{m.openReadStream($,(t,i)=>{t?r(b(t)):n((0,N.$eg)(i))})})}async function g(m,$){const{ZipFile:n}=await new Promise((r,t)=>{Z(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;$.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,j.createWriteStream)(m);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(m))})}function c(m,$,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=p(m,!0);return n.overwrite&&(i=i.then(s=>A.Promises.rm($).then(()=>s))),i.then(s=>w(s,$,{sourcePathRegex:t},r))}function u(m,$){return p(m).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===$&&I(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(E.localize(2,null,$))))}))}function v(m,$){return u(m,$).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(ne[92],se([7,4]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[93],se([7,4]),function(Z,e){return Z.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[94],se([7,4]),function(Z,e){return Z.create("vs/platform/contextkey/common/scanner",e)}),define(ne[95],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[96],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[97],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[98],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[99],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[100],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[101],se([7,4]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[102],se([7,4]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[103],se([7,4]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(ne[104],se([7,4]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(ne[105],se([7,4]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[106],se([7,4]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[107],se([7,4]),function(Z,e){return Z.create("vs/platform/log/common/log",e)}),define(ne[108],se([7,4]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(ne[109],se([7,4]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(ne[110],se([7,4]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[111],se([7,4]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[112],se([7,4]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(ne[113],se([0,1,9,94]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function N(...a){switch(a.length){case 1:return(0,O.localize)(0,null,a[0]);case 2:return(0,O.localize)(1,null,a[0],a[1]);case 3:return(0,O.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,O.localize)(3,null),E=(0,O.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return f.isTripleEq?"===":"==";case 4:return f.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return f.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return f.lexeme;case 18:return f.lexeme;case 19:return f.lexeme;case 20:return"EOF";default:throw(0,j.$8)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const b=this.d,y=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:f}),this.f.push(w)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const b=this.c.substring(this.d,this.e),y=l.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,b=!1,y=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(E);return}const p=this.c.charCodeAt(f);if(b)b=!1;else if(p===47&&!y){f++;break}else p===91?y=!0:p===92?b=!0:p===93&&(y=!1);f++}for(;f<this.c.length&&l.a.has(this.c.charCodeAt(f));)f++;this.e=f;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$oj=l}),define(ne[114],se([0,1,80,54,15,16,35,17,11]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=f,e.$5m=b,e.$2m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$nc)(k.$Ng.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,N.$kc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.$7g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$7g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,j.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$kc)(this.userDataPath,"logs",w)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$7g)(l.URI.file((0,N.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$7g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$7g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$7g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?l.URI.file((0,N.$kc)(w,"argv.json")):(0,E.$7g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,N.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,N.$lc)(w):(0,N.$ic)((0,N.$kc)(k.$Ng.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?l.URI.file((0,N.$lc)(w)):l.URI.file((0,N.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,N.$lc)(w);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const I=A.env.VSCODE_PORTABLE;return I?(0,N.$kc)(I,"extensions"):(0,E.$7g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,N.$ic)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?l.URI.parse(w):l.URI.file((0,N.$ic)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$2m.test(w))}get extensionLogLevel(){const w=[];for(const p of this.args.log||[]){const I=e.$2m.exec(p);I&&I[1]&&I[2]&&w.push([I[1],I[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,E.$7g)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?l.URI.file((0,N.$kc)(w,"policy.json")):(0,E.$7g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,p,I){this.a=w,this.b=p,this.c=I,this.editSessionId=this.args.editSessionId}}e.$3m=a,$e([O.$Xh],a.prototype,"appRoot",null),$e([O.$Xh],a.prototype,"userHome",null),$e([O.$Xh],a.prototype,"userDataPath",null),$e([O.$Xh],a.prototype,"appSettingsHome",null),$e([O.$Xh],a.prototype,"tmpDir",null),$e([O.$Xh],a.prototype,"cacheHome",null),$e([O.$Xh],a.prototype,"stateResource",null),$e([O.$Xh],a.prototype,"userRoamingDataHome",null),$e([O.$Xh],a.prototype,"userDataSyncHome",null),$e([O.$Xh],a.prototype,"sync",null),$e([O.$Xh],a.prototype,"machineSettingsResource",null),$e([O.$Xh],a.prototype,"workspaceStorageHome",null),$e([O.$Xh],a.prototype,"localHistoryHome",null),$e([O.$Xh],a.prototype,"keyboardLayoutResource",null),$e([O.$Xh],a.prototype,"argvResource",null),$e([O.$Xh],a.prototype,"isExtensionDevelopment",null),$e([O.$Xh],a.prototype,"untitledWorkspacesHome",null),$e([O.$Xh],a.prototype,"builtinExtensionsPath",null),$e([O.$Xh],a.prototype,"extensionsPath",null),$e([O.$Xh],a.prototype,"extensionDevelopmentLocationURI",null),$e([O.$Xh],a.prototype,"extensionDevelopmentKind",null),$e([O.$Xh],a.prototype,"extensionTestsLocationURI",null),$e([O.$Xh],a.prototype,"debugExtensionHost",null),$e([O.$Xh],a.prototype,"logLevel",null),$e([O.$Xh],a.prototype,"extensionLogLevel",null),$e([O.$Xh],a.prototype,"serviceMachineIdResource",null),$e([O.$Xh],a.prototype,"disableTelemetry",null),$e([O.$Xh],a.prototype,"disableWorkspaceTrust",null),$e([O.$Xh],a.prototype,"useInMemorySecretStorage",null),$e([O.$Xh],a.prototype,"policyFile",null);function f(y,w){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,w,y.debugId,y.extensionEnvironment)}function b(y,w,p,I,g,c){const v=Number(w||y)||(I?null:p),m=v?!!w:!1;let $;if(c)try{$=JSON.parse(c)}catch{}return{port:v,break:m,debugId:g,env:$}}}),function(){"use strict";function Z(e,j,O){function k(A,E){const l=N(A,E),a=[l];return e.isAbsolute(l)||a.unshift(O),e.resolve(...a)}function N(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const f=A["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(j.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(j.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[115],se([170,33,35]),function(e,j,O){return Z(e,j,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),j=require("os");module.exports=Z(e,j,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[116],se([0,1,33,114,115]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=A,e.$8m=E;class N extends O.$3m{constructor(a,f){super(a,{homeDir:(0,j.homedir)(),tmpDir:(0,j.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,f.nameShort)},f)}}e.$6m=N;function A(l,a){return(0,O.$5m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function E(l,a){return(0,O.$5m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(ne[117],se([0,1,3,98]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=k;function k(A,E,l,a){try{N(A,E,l,a)}catch(f){A.error(f?.message??f)}return E}function N(A,E,l,a){const f=(b,y,w)=>{const p=b[y];if((0,j.$6f)(p)){const I=p,g=I.length;if(g>1&&I[0]==="%"&&I[g-1]==="%"){const c=I.substr(1,g-2);let u=l[c];u===void 0&&a&&(u=a[c]);const v=typeof u=="string"?u:u?.message,m=a?.[c],$=typeof m=="string"?m:m?.message;if(!v){$||A.warn(`[${E.name}]: ${(0,O.localize)(0,null,c)}`);return}if(w&&(y==="title"||y==="category")&&$&&$!==v){const n={value:v,original:$};b[y]=n}else b[y]=v}}else if((0,j.$8f)(p))for(const I in p)p.hasOwnProperty(I)&&(I==="commands"?f(p,I,!0):f(p,I,w));else if(Array.isArray(p))for(let I=0;I<p.length;I++)f(p,I,w)};for(const b in E)E.hasOwnProperty(b)&&f(E,b)}}),define(ne[118],se([0,1,49,101]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=k;function k(N){return(0,j.$hq)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}}),define(ne[50],se([0,1,17,55,102,44]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=l,e.$Ep=a,e.$Fp=f,e.$Gp=b,e.$Hp=y,e.$Ip=w,e.$Jp=p;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||A.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function f(c){if(!c)return null;const u=c.majorBase,v=c.majorMustEqual,m=c.minorBase;let $=c.minorMustEqual;const n=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(u===0||($=!1),r=!1);let t=0;if(c.preRelease){const i=E.exec(c.preRelease);if(i){const[,s,o,h]=i;t=Date.UTC(Number(s),Number(o)-1,Number(h))}}return{majorBase:u,majorMustEqual:v,minorBase:m,minorMustEqual:$,patchBase:n,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function b(c,u,v){let m;typeof c=="string"?m=f(a(c)):m=c;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let n;if(typeof v=="string"?n=f(a(v)):n=v,!m||!n)return!1;const r=m.majorBase,t=m.minorBase,i=m.patchBase;let s=n.majorBase,o=n.minorBase,h=n.patchBase;const P=n.notBefore;let D=n.majorMustEqual,R=n.minorMustEqual,z=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||$&&$<P?!1:i>=h:(r===1&&s===0&&(!D||!R||!z)&&(s=1,o=0,h=0,D=!0,R=!1,z=!1),r<s?!1:r>s?!D:t<o?!1:t>o?!R:i<h?!1:i>h?!z:!($&&$<P))}function y(c,u,v,m,$){const n=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return n.push([O.default.Error,k.localize(0,null)]),n;if(typeof m.name!="string")return n.push([O.default.Error,k.localize(1,null,"name")]),n;if(typeof m.version!="string")return n.push([O.default.Error,k.localize(2,null,"version")]),n;if(!m.engines)return n.push([O.default.Error,k.localize(3,null,"engines")]),n;if(typeof m.engines.vscode!="string")return n.push([O.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof m.extensionDependencies<"u"&&!g(m.extensionDependencies))return n.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof m.activationEvents<"u"){if(!g(m.activationEvents))return n.push([O.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof m.main>"u"&&typeof m.browser>"u")return n.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),n}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&n.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return n.push([O.default.Error,k.localize(9,null,"main")]),n;{const i=(0,j.$7g)(v,m.main);(0,j.$1g)(i,v)||n.push([O.default.Warning,k.localize(10,null,i.path,v.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return n.push([O.default.Error,k.localize(11,null,"browser")]),n;{const i=(0,j.$7g)(v,m.browser);(0,j.$1g)(i,v)||n.push([O.default.Warning,k.localize(12,null,i.path,v.path)])}}if(!N.valid(m.version))return n.push([O.default.Error,k.localize(13,null)]),n;const r=[];if(!w(c,u,m,$,r))for(const i of r)n.push([O.default.Error,i]);return n}function w(c,u,v,m,$){return m||typeof v.main>"u"&&typeof v.browser>"u"?!0:I(c,u,v.engines.vscode,$)}function p(c,u,v){return c==="*"||I(u,v,c)}function I(c,u,v,m=[]){const $=f(a(v));if(!$)return m.push(k.localize(14,null,v)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return m.push(k.localize(15,null,v)),!1}else if(!$.majorMustEqual)return m.push(k.localize(16,null,v)),!1;return b(c,u,$)?!0:(m.push(k.localize(17,null,c,v)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let u=0,v=c.length;u<v;u++)if(typeof c[u]!="string")return!1;return!0}}),define(ne[119],se([0,1,14,28]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=k;async function k(N,A,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const f=(await A.readFile(N.serviceMachineIdResource)).value.toString();l=(0,O.$Og)(f)?f:null}catch{l=null}if(!l){l=(0,O.$Pg)();try{await A.writeFile(N.serviceMachineIdResource,j.$De.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}}),define(ne[51],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=void 0;class j{constructor(k,N=[],A=!1){this.ctor=k,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$qi=j}),define(ne[120],se([0,1,51]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ts=N,e.$us=A;const O=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function N(E,l,a){l instanceof j.$qi||(l=new j.$qi(l,[],!!a)),O.push([E,l])}function A(){return O}}),define(ne[121],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;class j{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$0q=j;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const E=this.lookupOrInsertNode(N),l=this.lookupOrInsertNode(A);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let E=this.a.get(A);return E||(E=new j(A,N),this.a.set(A,E)),E}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,E]of this.a)N.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const E=new Set([N]),l=this.c(A,E);if(l)return l}}c(N,A){for(const[E,l]of N.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const a=this.c(l,A);if(a)return a;A.delete(E)}}}e.$$q=O}),define(ne[29],se([0,1,3,11,10]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Zi=void 0,e.$1i=N,e.$2i=A,e.$3i=l,e.$4i=a,e.$5i=f,e.$6i=b,e.$7i=y,e.$8i=p,e.$9i=I,e.$0i=g,e.$Zi=(0,k.$ti)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function f(c,u){const v=Object.create(null);for(const m in c)b(v,m,c[m],u);return v}function b(c,u,v,m){const $=u.split("."),n=$.pop();let r=c;for(let t=0;t<$.length;t++){const i=$[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){m(`Ignoring ${u} as ${$.slice(0,t+1).join(".")} is null`);return}break;default:m(`Ignoring ${u} as ${$.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{m(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function y(c,u){const v=u.split(".");w(c,v)}function w(c,u){const v=u.shift();if(u.length===0){delete c[v];return}if(Object.keys(c).indexOf(v)!==-1){const m=c[v];typeof m=="object"&&!Array.isArray(m)&&(w(m,u),Object.keys(m).length===0&&delete c[v])}}function p(c,u,v){function m(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const $=u.split("."),n=m(c,$);return typeof n>"u"?v:n}function I(c,u,v){Object.keys(u).forEach(m=>{m!=="__proto__"&&(m in c?j.$8f(c[m])&&j.$8f(u[m])?I(c[m],u[m],v):v&&(c[m]=u[m]):c[m]=u[m])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(ne[122],se([0,1,12,31,113,10,93,9]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$rj=e.$qj=e.ContextKeyExprType=void 0,e.$pj=a,e.$sj=r,e.$tj=t,e.$Mj=Y;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",j.$j),l.set("isLinux",j.$k),l.set("isWindows",j.$i),l.set("isWeb",j.$o),l.set("isMacNative",j.$j&&!j.$o),l.set("isEdge",j.$H),l.set("isFirefox",j.$F),l.set("isChrome",j.$E),l.set("isSafari",j.$G);function a(F,d){if(l.get(F)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(F,d)}const f=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),p=(0,A.localize)(1,null),I=(0,A.localize)(2,null),g=(0,A.localize)(3,null),c=(0,A.localize)(4,null),u=(0,A.localize)(5,null),v=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=y){this.k=d,this.d=new k.$oj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const L=this.D(),C=L.type===17?u:void 0;throw this.h.push({message:c,offset:L.offset,lexeme:k.$oj.getLexeme(L),additionalInfo:C}),$.c}return S}catch(S){if(S!==$.c)throw S;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const S=this.o();d.push(S)}return d.length===1?d[0]:n.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const S=this.s();d.push(S)}return d.length===1?d[0]:n.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,g),S?.negate()}case 17:return this.z(),M.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const S=this.l();return this.A(1,g),S}case 17:{const S=d.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const G=C.lexeme,H=G.lastIndexOf("/"),te=H===G.length-1?void 0:this.w(G.substring(H+1));let ae;try{ae=new RegExp(G.substring(1,H),te)}catch{throw this.B("REGEX",C)}return le.create(S,ae)}switch(C.type){case 10:case 19:{const G=[C.lexeme];this.z();let H=this.D(),te=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(k.$oj.getLexeme(H)),this.z(),H=this.D()}const ae=G.join(""),ue=ae.lastIndexOf("/"),pe=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let ye;try{ye=new RegExp(ae.substring(1,ue),pe)}catch{throw this.B("REGEX",C)}return n.regex(S,ye)}case 18:{const G=C.lexeme;this.z();let H=null;if(!(0,O.$5e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const ue=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{H=new RegExp(ue,pe)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(S,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,I);const C=this.u();return n.notIn(S,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return n.equals(S,C);switch(C){case"true":return n.has(S);case"false":return n.not(S);default:return n.equals(S,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return n.notEquals(S,C);switch(C){case"true":return n.not(S);case"false":return n.has(S);default:return n.notEquals(S,C)}}case 5:return this.z(),ie.create(S,this.u());case 6:return this.z(),he.create(S,this.u());case 7:return this.z(),Q.create(S,this.u());case 8:return this.z(),re.create(S,this.u());case 13:return this.z(),n.in(S,this.u());default:return n.has(S)}}case 20:throw this.h.push({message:v,offset:d.offset,lexeme:"",additionalInfo:m}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,S){if(this.C(d))return this.z();throw this.B(S,this.D())}B(d,S,L){const C=(0,A.localize)(8,null,d,k.$oj.getLexeme(S)),G=S.offset,H=k.$oj.getLexeme(S);return this.h.push({message:C,offset:G,lexeme:H,additionalInfo:L}),$.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qj=$;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(d){return h.create(d)}static equals(d,S){return P.create(d,S)}static notEquals(d,S){return z.create(d,S)}static regex(d,S){return le.create(d,S)}static in(d,S){return D.create(d,S)}static notIn(d,S){return R.create(d,S)}static not(d){return M.create(d)}static and(...d){return J.create(d,null,!0)}static or(...d){return B.create(d,null,!0)}static greater(d,S){return Q.create(d,S)}static greaterEquals(d,S){return re.create(d,S)}static smaller(d,S){return ie.create(d,S)}static smallerEquals(d,S){return he.create(d,S)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$rj=n;function r(F){const d=new $({regexParsingWithErrorRecovery:!1});return F.map(S=>(d.parse(S),d.lexingErrors.length>0?d.lexingErrors.map(L=>({errorMessage:L.additionalInfo?(0,A.localize)(9,null,L.additionalInfo):(0,A.localize)(10,null),offset:L.offset,length:L.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(L=>({errorMessage:L.additionalInfo?`${L.message}. ${L.additionalInfo}`:L.message,offset:L.offset,length:L.lexeme.length})):[]))}function t(F,d){const S=F?F.substituteConstants():void 0,L=d?d.substituteConstants():void 0;return!S&&!L?!0:!S||!L?!1:S.equals(L)}function i(F,d){return F.cmp(d)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.$uj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return s.INSTANCE}}e.$vj=o;class h{static create(d,S=null){const L=l.get(d);return typeof L=="boolean"?L?o.INSTANCE:s.INSTANCE:new h(d,S)}constructor(d,S){this.key=d,this.c=S,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:W(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=l.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:s.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$wj=h;class P{static create(d,S,L=null){if(typeof S=="boolean")return S?h.create(d,L):M.create(d,L);const C=l.get(d);return typeof C=="boolean"?S===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new P(d,S,L)}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const S=d?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$xj=P;class D{static create(d,S){return new D(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:X(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const S=d.getValue(this.f),L=d.getValue(this.d);return Array.isArray(S)?S.includes(L):typeof L=="string"&&typeof S=="object"&&S!==null?f.call(S,L):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$yj=D;class R{static create(d,S){return new R(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=11,this.c=D.create(d,S)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zj=R;class z{static create(d,S,L=null){if(typeof S=="boolean")return S?M.create(d,L):h.create(d,L);const C=l.get(d);return typeof C=="boolean"?S===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new z(d,S,L)}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const S=d?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Aj=z;class M{static create(d,S=null){const L=l.get(d);return typeof L=="boolean"?L?s.INSTANCE:o.INSTANCE:new M(d,S)}constructor(d,S){this.c=d,this.d=S,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:W(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=l.get(this.c);return typeof d=="boolean"?d?s.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Bj=M;function T(F,d){if(typeof F=="string"){const S=parseFloat(F);isNaN(S)||(F=S)}return typeof F=="string"||typeof F=="number"?d(F):s.INSTANCE}class Q{static create(d,S,L=null){return T(S,C=>new Q(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Cj=Q;class re{static create(d,S,L=null){return T(S,C=>new re(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Dj=re;class ie{static create(d,S,L=null){return T(S,C=>new ie(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Ej=ie;class he{static create(d,S,L=null){return T(S,C=>new he(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Fj=he;class le{static create(d,S){return new le(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const S=this.f?this.f.source:"",L=d.f?d.f.source:"";return S<L?-1:S>L?1:0}equals(d){if(d.type===this.type){const S=this.f?this.f.source:"",L=d.f?d.f.source:"";return this.d===d.d&&S===L}return!1}substituteConstants(){return this}evaluate(d){const S=d.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Gj=le;class ce{static create(d){return new ce(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ce(this.c.map(d))}negate(){return this.c}}e.$Hj=ce;function V(F){let d=null;for(let S=0,L=F.length;S<L;S++){const C=F[S].substituteConstants();if(F[S]!==C&&d===null){d=[];for(let G=0;G<S;G++)d[G]=F[G]}d!==null&&(d[S]=C)}return d===null?F:d}class J{static create(d,S,L){return J.d(d,S,L)}constructor(d,S){this.expr=d,this.c=S,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let S=0,L=this.expr.length;S<L;S++){const C=i(this.expr[S],d.expr[S]);if(C!==0)return C}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].equals(d.expr[S]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:J.create(d,this.c,!1)}evaluate(d){for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].evaluate(d))return!1;return!0}static d(d,S,L){const C=[];let G=!1;for(const H of d)if(H){if(H.type===1){G=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&G)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const te=C.pop(),ae=C.length===0,ue=B.create(H.expr.map(pe=>J.create([pe,te],null,L)),null,ae);ue&&(C.push(ue),C.sort(i))}if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let te=H+1;te<C.length;te++)if(C[H].negate().equals(C[te]))return s.INSTANCE;if(C.length===1)return C[0]}return new J(C,S)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const S of this.expr)d.push(...S.keys());return d}map(d){return new J(this.expr.map(S=>S.map(d)),null)}negate(){if(!this.c){const d=[];for(const S of this.expr)d.push(S.negate());this.c=B.create(d,this,!0)}return this.c}}e.$Ij=J;class B{static create(d,S,L){return B.d(d,S,L)}constructor(d,S){this.expr=d,this.c=S,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let S=0,L=this.expr.length;S<L;S++){const C=i(this.expr[S],d.expr[S]);if(C!==0)return C}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].equals(d.expr[S]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:B.create(d,this.c,!1)}evaluate(d){for(let S=0,L=this.expr.length;S<L;S++)if(this.expr[S].evaluate(d))return!0;return!1}static d(d,S,L){let C=[],G=!1;if(d){for(let H=0,te=d.length;H<te;H++){const ae=d[H];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&G)return s.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let te=H+1;te<C.length;te++)if(C[H].negate().equals(C[te]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,S)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const S of this.expr)d.push(...S.keys());return d}map(d){return new B(this.expr.map(S=>S.map(d)),null)}negate(){if(!this.c){const d=[];for(const S of this.expr)d.push(S.negate());for(;d.length>1;){const S=d.shift(),L=d.shift(),C=[];for(const G of U(S))for(const H of U(L))C.push(J.create([G,H],null,!1));d.unshift(B.create(C,null,!1))}this.c=B.create(d,this,!0)}return this.c}}e.$Jj=B;class q extends h{static{this.d=[]}static all(){return q.d.values()}constructor(d,S,L){super(d,null),this.f=S,typeof L=="object"?q.d.push({...L,key:d}):L!==!0&&q.d.push({key:d,description:L,type:S!=null?typeof S:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return P.create(this.key,d)}notEqualsTo(d){return z.create(this.key,d)}}e.$Kj=q,e.$Lj=(0,N.$ti)("contextKeyService");function W(F,d){return F<d?-1:F>d?1:0}function X(F,d,S,L){return F<S?-1:F>S?1:d<L?-1:d>L?1:0}function Y(F,d){if(F.type===0||d.type===1)return!0;if(F.type===9)return d.type===9?_(F.expr,d.expr):!1;if(d.type===9){for(const S of d.expr)if(Y(F,S))return!0;return!1}if(F.type===6){if(d.type===6)return _(d.expr,F.expr);for(const S of F.expr)if(Y(S,d))return!0;return!1}return F.equals(d)}function _(F,d){let S=0,L=0;for(;S<F.length&&L<d.length;){const C=F[S].cmp(d[L]);if(C<0)return!1;C===0&&S++,L++}return S===F.length}function U(F){return F.type===9?F.expr:[F]}}),define(ne[61],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=void 0,e.$Ho=(0,j.$ti)("downloadService")}),define(ne[18],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=void 0,e.$Ai=(0,j.$ti)("environmentService"),e.$Bi=(0,j.$ui)(e.$Ai)}),define(ne[21],se([0,1,96,10]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.ExtensionGalleryErrorCode=e.$4o=e.ExtensionManagementErrorCode=e.$3o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Wo=k,e.$Xo=N,e.$Yo=A,e.$Zo=E,e.$1o=l,e.$2o=a,e.$Qo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ro=new RegExp(e.$Qo),e.$So="__web_extension",e.$To="skipWalkthrough",e.$Uo="extensionsSync",e.$Vo="dependecyOrPackExtensionInstall";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(u,v){return v==="web"&&!u.includes("web")}function l(u,v,m){return E(v,m)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===m}function a(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var f;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function(u){u.Install="install",u.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var w;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$3o=(0,O.$ti)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));class I extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.$4o=I;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class c extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.$5o=c,e.$6o=(0,O.$ti)("extensionManagementService"),e.$7o="extensionsIdentifiers/disabled",e.$8o="extensionsIdentifiers/enabled",e.$9o=(0,O.$ti)("IGlobalExtensionEnablementService"),e.$0o=(0,O.$ti)("IExtensionTipsService"),e.$$o=(0,j.localize2)(0,"Extensions"),e.$_o=(0,j.localize2)(1,"Preferences")}),define(ne[62],se([0,1,14,9,104,13]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=A;async function A(f,b,y,w,p,I){let g;try{await E(f,b,y,w,p,I)}catch(c){g=c}finally{g&&p.errorTransformer&&(g=p.errorTransformer(g)),typeof g<"u"&&y.error(g),y.end()}}async function E(f,b,y,w,p,I){l(I);const g=await f.open(b,{create:!1});try{l(I);let c=0,u=0,v=p&&typeof p.length=="number"?p.length:void 0,m=j.$De.alloc(Math.min(p.bufferSize,typeof v=="number"?v:p.bufferSize)),$=p&&typeof p.position=="number"?p.position:0,n=0;do u=await f.read(g,$,m.buffer,n,m.byteLength-n),$+=u,n+=u,c+=u,typeof v=="number"&&(v-=u),n===m.byteLength&&(await y.write(w(m)),m=j.$De.alloc(Math.min(p.bufferSize,typeof v=="number"?v:p.bufferSize)),n=0);while(u>0&&(typeof v!="number"||v>0)&&l(I)&&a(c,p));if(n>0){let r=n;typeof v=="number"&&(r=Math.min(n,v)),y.write(w(m.slice(0,r)))}}catch(c){throw(0,N.$bl)(c)}finally{await f.close(g)}}function l(f){if(f.isCancellationRequested)throw(0,O.$6)();return!0}function a(f,b){if(typeof b?.limits?.size=="number"&&f>b.limits.size)throw(0,N.$al)((0,k.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[123],se([0,1,60,2,52,5,11,8]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class l extends O.$Vc{constructor(){super(),this.a=this.B(new N.$ce),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$ce),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$ce),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$5c),this.m=new Set,this.n=5007,this.r=new E.$Qh,this.P=!1,this.B(this.f(f=>this.s(f)))}s(f){this.t(f)&&this.w(f)}t(f){return(0,k.$Gq)(f)}async watch(f){this.r.isSettled||this.r.complete(),this.r=new E.$Qh;try{this.h.clear(),this.g.clear();for(const b of f)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))])}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async w(f){if(this.j.has(f.correlationId))return;const b=new O.$Uc;this.j.set(f.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(f,b),this.u())}y(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.u()}z(f,b){this.C(f,b)?(this.N(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.D(f,b),this.m.add(f.correlationId))}C(f,b){const y=this.M?.subscribe(f.path,(w,p)=>{b.isDisposed||(w?this.z(f,b):p?.type===1&&this.F(f))});return y?(b.add(y),!0):!1}D(f,b){let y=!1;const w=(p,I)=>{if(b.isDisposed)return;const g=this.G(p),c=this.G(I),u=y;y=g,!g&&(c||u)&&this.F(f)};this.N(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,j.watchFile)(f.path,{persistent:!1,interval:this.n},w)}catch(p){this.O(`fs.watchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}b.add((0,O.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,j.unwatchFile)(f.path,w)}catch(p){this.O(`fs.unwatchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}F(f){this.N(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const b={resource:A.URI.file(f.path),type:1,cId:f.correlationId};this.a.fire([b]),this.H(b,f),this.y(f)}G(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(f,b){if(this.P){const y=` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.I(y,b)}}I(f,b){this.P&&this.N(`${f}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,k.$Qq)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.P=f}}e.$Zq=l}),define(ne[124],se([0,1,5,171,123,12,172,63]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class l extends k.$Zq{constructor(f){super(),this.M=f,this.onDidError=j.Event.None,this.watchers=new Set}async L(f){f=this.X(f);const b=[],y=new Set(Array.from(this.watchers));for(const w of f){const p=this.S(w);p&&(0,O.$rk)(p.request.excludes,w.excludes)&&(0,O.$rk)(p.request.includes,w.includes)?y.delete(p):b.push(w)}b.length&&this.N(`Request to start watching: ${b.map(w=>this.J(w)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(w=>this.J(w.request)).join(",")}`);for(const w of y)this.W(w);for(const w of b)this.U(w)}S(f){for(const b of this.watchers)if(typeof f.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===f.correlationId)return b}else if((0,E.$rg)(b.request.path,f.path,!N.$k))return b}U(f){const b=new A.$5q(f,this.M,w=>this.a.fire(w),()=>this.c.fire(f),w=>this.b.fire(w),this.P),y={request:f,instance:b};this.watchers.add(y)}async stop(){await super.stop();for(const f of this.watchers)this.W(f)}W(f){this.N("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}X(f){const b=new Map;for(const y of f){const w=N.$k?y.path:y.path.toLowerCase();let p=b.get(y.correlationId);p||(p=new Map,b.set(y.correlationId,p)),p.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),p.set(w,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const b of this.watchers)b.instance.setVerboseLogging(f)}N(f,b){this.P&&this.b.fire({type:"trace",message:this.$(f,b)})}O(f){this.b.fire({type:"warn",message:this.$(f)})}$(f,b){return b?`[File Watcher (node.js)] ${f} (${this.J(b.request)})`:`[File Watcher (node.js)] ${f}`}}e.$7q=l}),define(ne[125],se([0,1,52,124]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class k extends j.$Jq{constructor(A,E,l){super(A,E,l),this.s()}r(A){return A.add(new O.$7q(void 0))}}e.$8q=k}),define(ne[126],se([0,1,15,58,89,52]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class A extends N.$Kq{constructor(l,a,f){super(l,a,f),this.s()}r(l){const a=l.add(new k.$Xq(j.$Ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:f,signal:b})=>this.t(`terminated by itself with code ${f}, signal: ${b} (ETERM)`))),O.ProxyChannel.toService((0,O.$ai)(a.getChannel("watcher")))}}e.$Yq=A}),define(ne[64],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=void 0;class j{constructor(...k){this.a=new Map;for(const[N,A]of k)this.set(N,A)}set(k,N){const A=this.a.get(k);return this.a.set(k,N),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$ri=j}),define(ne[127],se([0,1,8,9,2,51,121,10,64,173]),function(Z,e,j,O,k,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;const f=!1;class b extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class y{constructor(g=new l.$ri,c=!1,u,v=f){this.i=g,this.j=c,this.k=u,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$si,this),this._globalGraph=v?u?._globalGraph??new A.$$q(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,k.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const c=new class extends y{dispose(){this.h.delete(c),super.dispose()}}(g,this.j,this,this.l);return this.h.add(c),c}invokeFunction(g,...c){this.m();const u=p.traceInvocation(this.l,g);let v=!1;try{return g({get:$=>{if(v)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const n=this.s($,u);if(!n)throw new Error(`[invokeFunction] unknown service '${$}'`);return n}},...c)}finally{v=!0,u.stop()}}createInstance(g,...c){this.m();let u,v;return g instanceof N.$qi?(u=p.traceCreation(this.l,g.ctor),v=this.o(g.ctor,g.staticArguments.concat(c),u)):(u=p.traceCreation(this.l,g),v=this.o(g,c,u)),u.stop(),v}o(g,c=[],u){const v=E._util.getServiceDependencies(g).sort((n,r)=>n.index-r.index),m=[];for(const n of v){const r=this.s(n.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),m.push(r)}const $=v.length>0?v[0].index:c.length;if(c.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${c.length} static arguments`);const n=$-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,$)}return Reflect.construct(g,c.concat(m))}q(g,c){if(this.i.get(g)instanceof N.$qi)this.i.set(g,c);else if(this.k)this.k.q(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const c=this.i.get(g);return!c&&this.k?this.k.r(g):c}s(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof N.$qi?this.u(g,u,c.branch(g,!0)):(c.branch(g,!1),u)}u(g,c,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,c,u)}finally{this.t.delete(g)}}v(g,c,u){const v=new A.$$q(n=>n.id.toString());let m=0;const $=[{id:g,desc:c,_trace:u}];for(;$.length;){const n=$.pop();if(v.lookupOrInsertNode(n),m++>1e3)throw new b(v);for(const r of E._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.$qi){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,i),$.push(i)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:r}of n){if(this.r(r.id)instanceof N.$qi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}v.removeNode(r)}}return this.r(g)}w(g,c,u=[],v,m){if(this.i.get(g)instanceof N.$qi)return this.x(g,c,u,v,m,this.g);if(this.k)return this.k.w(g,c,u,v,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(g,c,u=[],v,m,$){if(v){const n=new y(void 0,this.j,this,this.l);n.c=String(g);const r=new Map,t=new j.$Mh(()=>{const i=n.o(c,u,m);for(const[s,o]of r){const h=i[s];if(typeof h=="function")for(const P of o)P.disposable=h.apply(i,P.listener)}return r.clear(),$.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let P=r.get(s);return P||(P=new a.$6c,r.set(s,P)),(R,z,M)=>{if(t.isInitialized)return t.value[s](R,z,M);{const T={listener:[R,z,M],disposable:void 0},Q=P.push(T);return(0,k.$Tc)(()=>{Q(),T.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let h=o[s];return typeof h!="function"||(h=h.bind(o),i[s]=h),h},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return c.prototype}})}else{const n=this.o(c,u,m);return $.add(n),n}}y(g,c){if(c&&console.warn(g),this.j)throw new Error(g)}}e.$_q=y;var w;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(w||(w={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new p(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(g,c){return g?new p(1,c.name):p.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const u=new p(3,g.toString());return this.h.push([g,c,u]),u}stop(){const g=Date.now()-this.g;p.f+=g;let c=!1;function u(m,$){const n=[],r=new Array(m+1).join("	");for(const[t,i,s]of $.h)if(i&&s){c=!0,n.push(`${r}CREATES -> ${t}`);const o=u(m+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(g>2||c)&&p.all.add(v.join(`
`))}}e.$ar=p});var oe=this&&this.__param||function(Z,e){return function(j,O){e(j,O,Z)}};define(ne[65],se([0,1,20,2,12,106,21,10]),function(Z,e,j,O,k,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=void 0,e.$Nr=l;function l(f){return f.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Or=(0,E.$ti)("languagePackService");let a=class extends O.$Vc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new j.$ne;setTimeout(()=>b.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const p=y.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(g=>g.startsWith("lp-"))).map(I=>{const g=I.properties.localizedLanguages?.[0],c=l(I);return{...this.f(c,g,I),extensionId:I.identifier.id,galleryExtension:I}});return p.push(this.f("en","English")),p}f(b,y,w){const p=y??b;let I;if(p!==b&&(I=`(${b})`),b.toLowerCase()===k.$w.toLowerCase()&&(I??="",I+=(0,N.localize)(0,null)),w?.installCount){I??="";const g=w.installCount;let c;g>1e6?c=`${Math.floor(g/1e5)/10}M`:g>1e3?c=`${Math.floor(g/1e3)}K`:c=String(g),I+=` $(cloud-download) ${c}`}return{id:b,label:p,description:I}}};e.$Pr=a,e.$Pr=a=$e([oe(0,A.$3o)],a)}),define(ne[6],se([0,1,107,34,5,43,2,30,12,17,3,11,122,10]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$3j=e.LogLevel=e.$1j=e.$Zj=void 0,e.$2j=I,e.log=c,e.$bk=h,e.$ck=P,e.$dk=D,e.$ek=R,e.$Zj=(0,w.$ti)("logService"),e.$1j=(0,w.$ti)("loggerService");function p(){return new Date().toISOString()}function I(z){return(0,f.$0f)(z)}var g;(function(z){z[z.Off=0]="Off",z[z.Trace=1]="Trace",z[z.Debug=2]="Debug",z[z.Info=3]="Info",z[z.Warning=4]="Warning",z[z.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$3j=g.Info;function c(z,M,T){switch(M){case g.Trace:z.trace(T);break;case g.Debug:z.debug(T);break;case g.Info:z.info(T);break;case g.Warning:z.warn(T);break;case g.Error:z.error(T);break;case g.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function u(z,M=!1){let T="";for(let Q=0;Q<z.length;Q++){let re=z[Q];if(re instanceof Error&&(re=(0,O.$ej)(re,M)),typeof re=="object")try{re=JSON.stringify(re)}catch{}T+=(Q>0?" ":"")+re}return T}class v extends A.$Vc{constructor(){super(...arguments),this.b=e.$3j,this.c=this.B(new k.$ce),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==g.Off&&this.b<=M}}e.$5j=v;class m extends v{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...T){this.f(g.Trace)&&this.g(g.Trace,u([M,...T],!0))}debug(M,...T){this.f(g.Debug)&&this.g(g.Debug,u([M,...T]))}info(M,...T){this.f(g.Info)&&this.g(g.Info,u([M,...T]))}warn(M,...T){this.f(g.Warning)&&this.g(g.Warning,u([M,...T]))}error(M,...T){if(this.f(g.Error))if(M instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=M.stack,this.g(g.Error,u(Q))}else this.g(g.Error,u([M,...T]))}flush(){}}e.$6j=m;class $ extends v{constructor(M=e.$3j){super(),this.setLevel(M),this.g=!l.$i}trace(M,...T){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}debug(M,...T){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}info(M,...T){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}warn(M,...T){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,M,...T):console.warn(`[main ${p()}]`,M,...T))}error(M,...T){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,M,...T):console.error(`[main ${p()}]`,M,...T))}flush(){}}e.$7j=$;class n extends v{constructor(M=e.$3j,T=!0){super(),this.g=T,this.setLevel(M)}trace(M,...T){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...T):console.log(M,...T))}debug(M,...T){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...T):console.log(M,...T))}info(M,...T){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...T):console.log(M,...T))}warn(M,...T){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...T):console.log(M,...T))}error(M,...T){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...T):console.error(M,...T))}flush(){}}e.$8j=n;class r extends v{constructor(M,T=e.$3j){super(),this.g=M,this.setLevel(T)}trace(M,...T){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(M),...T])}debug(M,...T){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(M),...T])}info(M,...T){this.f(g.Info)&&this.g.log(g.Info,[this.h(M),...T])}warn(M,...T){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(M),...T])}error(M,...T){this.f(g.Error)&&this.g.log(g.Error,[this.h(M),...T])}h(M){return typeof M=="string"?M:(0,O.$ej)(M,this.f(g.Trace))}flush(){}}e.$9j=r;class t extends v{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const T of this.g)T.setLevel(M);super.setLevel(M)}trace(M,...T){for(const Q of this.g)Q.trace(M,...T)}debug(M,...T){for(const Q of this.g)Q.debug(M,...T)}info(M,...T){for(const Q of this.g)Q.info(M,...T)}warn(M,...T){for(const Q of this.g)Q.warn(M,...T)}error(M,...T){for(const Q of this.g)Q.error(M,...T)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$0j=t;class i extends A.$Vc{constructor(M,T,Q){if(super(),this.h=M,this.j=T,this.b=new E.$Bc,this.c=this.B(new k.$ce),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$ce),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$ce),this.onDidChangeVisibility=this.g.event,Q)for(const re of Q)this.b.set(re.resource,{logger:void 0,info:re})}m(M){return(0,f.$6f)(M)?[...this.b.values()].find(T=>T.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,T){const Q=this.n(M),re=(0,f.$6f)(M)?M:T?.id??(0,N.$hj)(Q.toString()).toString(16);let ie=this.b.get(Q)?.logger;const he=T?.logLevel==="always"?g.Trace:T?.logLevel;ie||(ie=this.s(Q,he??this.getLogLevel(Q)??this.h,{...T,id:re}));const le={logger:ie,info:{resource:Q,id:re,logLevel:he,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(le.info),this.b.set(Q,le),ie}n(M){return(0,f.$6f)(M)?(0,a.$7g)(this.j,`${M}.log`):M}setLogLevel(M,T){if(b.URI.isUri(M)){const Q=M,re=T,ie=this.b.get(Q);ie&&re!==ie.info.logLevel&&(ie.info.logLevel=re===this.h?void 0:re,ie.logger?.setLevel(re),this.b.set(ie.info.resource,ie),this.f.fire([Q,re]))}else{this.h=M;for(const[Q,re]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&re.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,T){const Q=this.m(M);Q&&T!==!Q.info.hidden&&(Q.info.hidden=!T,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,T]))}getLogLevel(M){let T;return M&&(T=this.b.get(M)?.info.logLevel),T??this.h}registerLogger(M){const T=this.b.get(M.resource);T?T.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const T=this.b.get(M);T&&(T.logger&&T.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$$j=i;class s{constructor(){this.onDidChangeLogLevel=new k.$ce().event}setLevel(M){}getLevel(){return g.Info}trace(M,...T){}debug(M,...T){}info(M,...T){}warn(M,...T){}error(M,...T){}critical(M,...T){}dispose(){}flush(){}}e.$_j=s;class o extends s{}e.$ak=o;function h(z){if(z.verbose)return g.Trace;if(typeof z.logLevel=="string"){const M=R(z.logLevel.toLowerCase());if(M!==void 0)return M}return e.$3j}function P(z){switch(z){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function D(z){switch(z){case g.Trace:return{original:"Trace",value:j.localize(0,null)};case g.Debug:return{original:"Debug",value:j.localize(1,null)};case g.Info:return{original:"Info",value:j.localize(2,null)};case g.Warning:return{original:"Warning",value:j.localize(3,null)};case g.Error:return{original:"Error",value:j.localize(4,null)};case g.Off:return{original:"Off",value:j.localize(5,null)}}}function R(z){switch(z){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$fk=new y.$Kj("logLevel",P(g.Info))}),define(ne[128],se([0,1,19,8,9,5,63,2,16,52,6]),function(Z,e,j,O,k,N,A,E,l,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class b extends E.$Vc{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new N.$ce),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$ce),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$rh(0)),this.w=[],this.y=this.B(new O.$rh(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(w,p):this.z(w,p)}n(w,p){const I={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},g=(0,j.$Ub)(this.j,I);return this.r(),(0,E.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,k.$1)(w))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$Lq)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,a.$Hq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,a.$Hq)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,p){const I={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},g=(0,j.$Ub)(this.w,I);return this.C(),(0,E.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,k.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$Lq)(w)),w=>this.G(w),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,l.$ic)(w.fsPath)}J(w){const p=this.I(w);return(0,A.$vg)(p)}}e.$Rq=b}),define(ne[129],se([0,1,19,8,14,20,5,43,66,2,48,15,130,17,46,103,13,62,6,9]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let $=class extends a.$Vc{static{m=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$ce),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$ce),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$ce),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$ce),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$ce),this.Y=this.B(new A.$ce),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$ce),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$Ch)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const i=new a.$Uc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new g.$gl(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Qc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await O.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return l.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,w.$$g)(r))throw new g.$il((0,I.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new v.$bb;throw i.message=(0,I.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,g.$6k)(t)||(0,g.$3k)(t)||(0,g.$7k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,g.$6k)(t)||(0,g.$3k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,g.$dl)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$il((0,I.localize)(2,null,this.sb(r)),1):(0,g.$bl)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,h=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,D=await i.stat(r);let R;return this.t(i,r,D,void 0,!!P,(z,M)=>(R||(R=f.$zi.forUris(()=>!s),R.set(r,!0),o&&R.fill(!0,o)),R.get(z.resource)||R.findSuperstr(z.resource.with({query:null,fragment:null}))?!0:z.isDirectory&&h?M===1:!1))}async t(r,t,i,s,o,h){const{providerExtUri:P}=this.R(r),D={resource:t,name:P.basename(t),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$tl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&h(D,s)){try{const R=await r.readdir(t),z=await O.Promises.settled(R.map(async([M,T])=>{try{const Q=P.joinPath(t,M),re=o?await r.stat(Q):{type:T};return await this.t(r,Q,re,R.length,o,h)}catch(Q){return this.b.trace(Q),null}}));D.children=(0,j.$Hb)(z)}catch(R){this.b.trace(R),D.children=[]}return D}return D}async resolveAll(r){return O.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new g.$il((0,I.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$De.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new g.$fl(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let h=i;if((0,g.$9k)(s)&&!h?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(h={...i,atomic:P})}try{await this.w(s,r,h)||await this.U(s,o.dirname(r));let D;if((0,g.$3k)(s)&&!(t instanceof k.$De))if((0,p.$pe)(t)){const R=await(0,p.$we)(t,3);R.ended?D=k.$De.concat(R.buffer):D=R}else D=(0,p.$te)(t,R=>k.$De.concat(R),3);else D=t;!(0,g.$6k)(s)||(0,g.$3k)(s)&&D instanceof k.$De||(0,g.$3k)(s)&&(0,g.$9k)(s)&&h?.atomic?await this.hb(s,r,h,D):await this.db(s,r,h,D instanceof k.$De?(0,k.$Oe)(D):D),this.r.fire(new g.$fl(r,4))}catch(P){throw new g.$il((0,I.localize)(4,null,this.sb(r),(0,g.$bl)(P).toString()),(0,g.$el)(P),h)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,I.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,I.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,I.localize)(7,null,this.sb(t)));if(s)throw new Error((0,I.localize)(8,null,this.sb(t)))}let h;try{h=await r.stat(t)}catch{return}if(h.type&g.FileType.Directory)throw new g.$il((0,I.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,h),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$sl&&typeof h.mtime=="number"&&typeof h.size=="number"&&i.mtime<h.mtime&&i.etag!==(0,g.$tl)({mtime:i.mtime,size:h.size}))throw new g.$il((0,I.localize)(10,null),3,i);return h}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,h)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,i,s);o(P)}catch(P){h(P)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Pe)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new N.$ne(s);let h=i;(0,g.$8k)(r)&&r.enforceAtomicReadFile?.(t)&&(h={...i,atomic:!0});const P=this.J(t,h).then(R=>R,R=>{throw o.dispose(!0),R});let D;try{return typeof h?.etag=="string"&&h.etag!==g.$sl&&await P,h?.atomic&&(0,g.$8k)(r)||!((0,g.$6k)(r)||(0,g.$7k)(r))||(0,g.$3k)(r)&&h?.preferUnbuffered?D=this.I(r,t,h):(0,g.$7k)(r)?D=this.G(r,t,o.token,h):D=this.H(r,t,o.token,h),D.on("end",()=>o.dispose()),D.on("error",()=>o.dispose()),{...await P,value:D}}catch(R){throw D&&await(0,p.$ue)(D),this.F(R,t,h)}}F(r,t,i){const s=(0,I.localize)(11,null,this.sb(t),(0,g.$bl)(r).toString());return r instanceof g.$kl?new g.$kl(s,r.stat,i):r instanceof g.$jl?new g.$jl(s,r.fileOperationResult,r.size,r.options):new g.$il(s,(0,g.$el)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,p.$Ae)(o,{data:h=>h instanceof k.$De?h:k.$De.wrap(h),error:h=>this.F(h,t,s)},h=>k.$De.concat(h))}H(r,t,i,s=Object.create(null)){const o=(0,k.$Te)();return(0,c.$Eq)(r,t,o,h=>h,{...s,bufferSize:this.a,errorTransformer:h=>this.F(h,t,s)},i),o}I(r,t,i){const s=(0,p.$re)(o=>k.$De.concat(o));return(async()=>{try{let o;i?.atomic&&(0,g.$8k)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(k.$De.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new g.$il((0,I.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.$sl&&t.etag===i.etag)throw new g.$kl((0,I.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new g.$jl((0,I.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),h=this.qb(await this.n(t),t);await this.Q(o,r,h,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"move",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,h==="move"?2:3,P)),P}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"copy",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,h==="copy"?3:2,P)),P}async N(r,t,i,s,o,h){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:D}=await this.Q(r,t,i,s,o,h);if(P&&!D&&h&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,g.$4k)(r))await r.copy(t,s,{overwrite:h});else{const R=await this.resolve(t);R.isDirectory?await this.P(r,R,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:h}),o):(await this.N(r,t,i,s,"copy",h),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,g.$6k)(r)&&(0,g.$6k)(i))return this.jb(r,t,i,s);if((0,g.$6k)(r)&&(0,g.$3k)(i))return this.pb(r,t,i,s);if((0,g.$3k)(r)&&(0,g.$6k)(i))return this.nb(r,t,i,s);if((0,g.$3k)(r)&&(0,g.$3k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async o=>{const h=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,h):this.O(r,o.resource,i,h)}))}async Q(r,t,i,s,o,h){let P=!1;if(r===i){const{providerExtUri:R,isPathCaseSensitive:z}=this.R(r);if(z||(P=R.isEqual(t,s)),P&&o==="copy")throw new Error((0,I.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&R.isEqualOrParent(s,t))throw new Error((0,I.localize)(16,null,this.sb(t),this.sb(s)))}const D=await this.exists(s);if(D&&!P){if(!h)throw new g.$il((0,I.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:R}=this.R(r);if(R.isEqualOrParent(t,s))throw new Error((0,I.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:D,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?w.$Wg:w.$Yg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&g.FileType.Directory))throw new Error((0,I.localize)(19,null,this.sb(t)));break}catch(o){if((0,g.$dl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(h){if((0,g.$dl)(h)!==g.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,I.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,I.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,I.localize)(22,null,this.sb(r)));let h;try{h=await i.stat(r)}catch{}if(h)this.rb(r,h);else throw new g.$il((0,I.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,I.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,g.$0k)(i)&&!s?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(s={...t,atomic:D})}const o=!!s?.useTrash,h=!!s?.recursive,P=s?.atomic??!1;await i.delete(r,{recursive:h,useTrash:o,atomic:P}),this.r.fire(new g.$fl(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,g.$5k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,g.$4k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:m.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Uc;let s=!1,o=()=>{s=!0};i.add((0,a.$Tc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Qc)(P):o=()=>(0,a.$Qc)(P)}catch(P){this.b.error(P)}})();const h=t.correlationId;if(typeof h=="number"){const P=i.add(new A.$ce);return i.add(this.X.event(R=>{R.correlates(h)&&P.fire(R)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,E.$hj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Qc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Qc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,p.$pe)(s)||(0,p.$qe)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(h){throw(0,g.$bl)(h)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,p.$qe)(i)){if(i.buffer.length>0){const h=k.$De.concat(i.buffer);await this.gb(r,t,h,h.byteLength,s,0),s+=h.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((h,P)=>{(0,p.$ve)(o,{onData:async D=>{o.pause();try{await this.gb(r,t,D,D.byteLength,s,0)}catch(R){return P(R)}s+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>P(D),onEnd:()=>h()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,h){let P=0;for(;P<s;){const D=await r.write(t,o+P,i.buffer,h+P,s-P);P+=D}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof k.$De?o=s:(0,p.$pe)(s)?o=await(0,k.$Pe)(s):(0,p.$qe)(s)?o=await(0,k.$Qe)(s):o=(0,k.$Ne)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,h;try{o=await r.open(t,{create:!1}),h=await i.open(s,{create:!0,unlock:!1});const P=k.$De.alloc(this.a);let D=0,R=0,z=0;do z=await r.read(o,D,P.buffer,R,P.byteLength-R),await this.gb(i,h,P,z,D,R),D+=z,R+=z,R===P.byteLength&&(R=0);while(z>0)}catch(P){throw(0,g.$bl)(P)}finally{await O.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const h=await r.readFile(t);await this.gb(i,o,k.$De.wrap(h),h.byteLength,0,0)}catch(h){throw(0,g.$bl)(h)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,k.$Pe)(this.H(r,t,N.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new g.$il((0,I.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.$il((0,I.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Fq=$,e.$Fq=$=m=$e([oe(0,u.$Zj)],$)}),define(ne[131],se([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,105,13,62,128,34,126,125]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0,(()=>{try{(0,O.gracefulify)(j)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.$ej)(r)}`)}})();class n extends u.$Rq{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.P=new N.$Bc(s=>y.$Xg.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await p.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.$7g)(t,o.name))).type:h=this.O(o),s.push([o.name,h])}catch(h){this.a.trace(h)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=g.FileType.Unknown:t.isFile()?s=g.FileType.File:t.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,i&&(s|=g.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new k.$sh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await p.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,w.$re)(h=>A.$De.concat(h.map(P=>A.$De.wrap(P))).buffer);return(0,c.$Eq)(this,t,o,h=>h.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,y.$7g)((0,y.$6g)(t),`${(0,y.$4g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await p.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const h=new a.$Uc;try{h.add(await this.Q(t)),h.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{h.dispose()}}async W(t,i,s,o){let h;try{const P=this.I(t);if(!s.create||!s.overwrite){if(await p.Promises.exists(P)){if(!s.overwrite)throw(0,g.$al)((0,I.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$al)((0,I.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(h,0,i,0,i.byteLength)}catch(P){throw await this.ib(t,P)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let h;(0,g.$1k)(i)&&!s&&(h=await this.Q(t));let P;try{if((0,g.$1k)(i)&&i.unlock)try{const{stat:R}=await p.SymlinkSupport.stat(o);R.mode&128||await p.Promises.chmod(o,R.mode|128)}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}let D;if((0,g.$1k)(i)){if(b.$i)try{await p.Promises.truncate(o,0),D="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}D||(D="w")}else D="r";P=await p.Promises.open(o,D)}catch(D){throw h?.dispose(),(0,g.$1k)(i)?await this.ib(t,D):this.hb(D)}if(this.X.set(P,0),(0,g.$1k)(i)&&this.Z.set(P,t),h){const D=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.Y.set(P,h),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),D.dispose())}return P}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await p.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,h){const P=this.ab(t,i);let D=null;try{D=(await p.Promises.read(t,s,o,h,P)).bytesRead}catch(R){throw this.hb(R)}finally{this.bb(t,P,D)}return D}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,h){return(0,k.$Nh)(()=>this.cb(t,i,s,o,h),100,3)}async cb(t,i,s,o,h){const P=this.ab(t,i);let D=null;try{D=(await p.Promises.write(t,s,o,h,P)).bytesWritten}catch(R){throw await this.ib(this.Z.get(t),R)}finally{this.bb(t,P,D)}return D}async mkdir(t){try{await p.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,f.$kc)((0,f.$nc)(s),`${(0,f.$oc)(s)}${i.atomic.postfix}`)),await p.Promises.rm(s,p.RimRafMode.MOVE,o)}else try{await p.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let h=!1;try{const{stat:P,symbolicLink:D}=await p.SymlinkSupport.stat(s);h=P.isDirectory()&&!D}catch{}if(h)await p.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"move",s.overwrite),await p.Promises.rename(o,h)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,I.localize)(2,null,(0,f.$oc)(o),(0,f.$oc)((0,f.$nc)(h)),P.toString()))),this.hb(P)}}async copy(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"copy",s.overwrite),await p.Promises.copy(o,h,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,I.localize)(3,null,(0,f.$oc)(o),(0,f.$oc)((0,f.$nc)(h)),P.toString()))),this.hb(P)}}async db(t,i,s,o){const h=this.I(t),P=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,l.$rg)(h,P,!0)),D){if(s==="copy")throw(0,g.$al)((0,I.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const z=await this.N(t);if(!z)throw(0,g.$al)((0,I.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!o)throw(0,g.$al)((0,I.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);z.type&g.FileType.File&&M.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),h=this.I(i),P=!!(this.capabilities&1024);if((0,l.$rg)(o,h,!P))return;const D=new a.$Uc;try{D.add(await this.Q(t)),D.add(await this.Q(i)),s&&await p.Promises.mkdir((0,f.$nc)(h),{recursive:!0}),await p.Promises.copyFile(o,h)}catch(R){if(R.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(R)}finally{D.dispose()}}t(t,i,s){return new m.$Yq(o=>t(o),o=>i(o),s)}F(t,i,s){return new $.$8q(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof g.$_k)return t;let i=t,s;switch(t.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$al)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,g.$al)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$9q=n}),define(ne[132],se([0,1,2,6]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=void 0;class k extends j.$Vc{constructor(A,E=[]){super(),this.a=new O.$0j([A,...E]),this.B(A.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$FQ=k}),define(ne[133],se([0,1,13,6]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function N(a,f,b,y,w){try{const p=await new Promise((g,c)=>{Z(["@vscode/spdlog"],g,c)});p.setFlushOn(k.Trace);const I=await p.createAsyncRotatingLogger(a,f,b,y);return w?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(p){console.error(p)}return null}function A(a,f,b){switch(f){case O.LogLevel.Trace:a.trace(b);break;case O.LogLevel.Debug:a.debug(b);break;case O.LogLevel.Info:a.info(b);break;case O.LogLevel.Warning:a.warn(b);break;case O.LogLevel.Error:a.error(b);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function E(a,f){switch(f){case O.LogLevel.Trace:a.setLevel(k.Trace);break;case O.LogLevel.Debug:a.setLevel(k.Debug);break;case O.LogLevel.Info:a.setLevel(k.Info);break;case O.LogLevel.Warning:a.setLevel(k.Warning);break;case O.LogLevel.Error:a.setLevel(k.Error);break;case O.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class l extends O.$6j{constructor(f,b,y,w,p){super(),this.m=[],this.setLevel(p),this.n=this.s(f,b,y,w),this.B(this.onDidChangeLogLevel(I=>{this.r&&E(this.r,I)}))}async s(f,b,y,w){const p=y?6:1,I=30/p*j.$vl.MB,g=await N(f,b,I,p,w);if(g){this.r=g,E(this.r,this.getLevel());for(const{level:c,message:u}of this.m)A(this.r,c,u);this.m=[]}}g(f,b){this.r?A(this.r,f,b):this.getLevel()<=f&&this.m.push({level:f,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$uQ=l}),define(ne[134],se([0,1,28,6,133]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class N extends O.$$j{s(E,l,a){return new k.$uQ((0,j.$Pg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$vQ=N}),define(ne[39],se([0,1,5,66,2,10]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=void 0,e.$bo=(0,N.$ti)("policy");class A extends k.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new j.$ce),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),O.Iterable.reduce(this.g.entries(),(b,[y,w])=>({...b,[y]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(a,[f,b])=>({...a,[f]:{definition:b,value:this.g.get(f)}}),{})}}e.$co=A;class E{constructor(){this.onDidChange=j.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$do=E}),define(ne[135],se([0,1,8,5,66,3,13,6,39]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;function a(b,y){const w=[];for(const p of new Set(k.Iterable.concat(b.keys(),y.keys())))b.get(p)!==y.get(p)&&w.push(p);return w}let f=class extends l.$co{constructor(y,w,p){super(),this.m=y,this.n=w,this.s=p,this.c=this.B(new j.$rh(500));const I=O.Event.filter(w.onDidFilesChange,g=>g.affects(y));this.B(w.watch(y)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const w=await this.n.readFile(this.m),p=JSON.parse(w.value.toString());if(!(0,N.$8f)(p))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(p))this.f[I]&&y.set(I,p[I])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return y}async w(){const y=await this.u(),w=a(this.g,y);this.g=y,w.length>0&&this.h.fire(w)}};e.$cdc=f,e.$cdc=f=$e([oe(1,A.$Zk),oe(2,E.$Zj)],f)}),define(ne[136],se([0,1,39,8,2,6]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;let A=class extends j.$co{constructor(l,a){super(),this.m=l,this.n=a,this.a=new O.$nh,this.b=this.B(new k.$Wc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((f,b)=>{Z(["@vscode/policy-watcher"],f,b)});await this.a.queue(()=>new Promise((f,b)=>{try{this.b.value=a(this.n,l,y=>{this.t(y),f()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const f=l[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(l))}};e.$bdc=A,e.$bdc=A=$e([oe(0,N.$Zj)],A)}),define(ne[32],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$gk=(0,j.$ti)("productService"),e.$hk="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,73,3]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class k{constructor(){this.a=new Map}add(A,E){j.ok(O.$6f(A)),j.ok(O.$8f(E)),j.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$_n=new k}),define(ne[137],se([0,1,5,36]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=void 0,e.$ao={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class N{constructor(){this.b=new j.$ce,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[k(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;O.$_n.add(e.$ao.JSONContribution,A)}),define(ne[40],se([0,1,19,5,3,92,29,137,36]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.ConfigurationScope=e.$eo=e.EditPresentationTypes=void 0,e.$po=I,e.$qo=g,e.$ro=c,e.$so=v,e.$to=m;var a;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$eo={Configuration:"base.contributions.configuration"};var f;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo="vscode://schemas/settings/resourceLanguage",e.$mo="vscode://schemas/settings/configurationDefaults";const b=l.$_n.as(E.$ao.JSONContribution);class y{constructor(){this.h=new Set,this.i=new O.$ce,this.onDidSchemaChange=this.i.event,this.j=new O.$ce,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$lo,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),b.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),b.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$oo.test(o)){const h=this.a.get(o),P=h?.valuesSources??new Map;if(s)for(const M of Object.keys(i[o]))P.set(M,s);const D={...h?.value||{},...i[o]};this.a.set(o,{source:s,value:D,valuesSources:P});const R=(0,A.$0i)(o),z={type:"object",default:D,description:N.localize(1,null,R),$ref:e.$lo,defaultDefaultValue:D,source:k.$6f(s)?void 0:s,defaultValueSource:s};t.push(...I(o)),this.d[o]=z,this.b.properties[o]=z}else{this.a.set(o,{value:i[o],source:s});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),h=k.$6f(i)?i:i?.id,P=k.$6f(o?.source)?o?.source:o?.source?.id;if(h===P)if(r.add(s),this.a.delete(s),e.$oo.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.w(s,D),this.r(s,D))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=k.$cg(n.scope)?s:n.scope;const h=n.properties;if(h)for(const D in h){const R=h[D];if(r&&v(D,R)){delete h[D];continue}if(R.source=t,R.defaultDefaultValue=h[D].default,this.w(D,R),e.$oo.test(D)?R.scope=void 0:(R.scope=k.$cg(R.scope)?s:R.scope,R.restricted=k.$cg(R.restricted)?!!i?.includes(D):R.restricted),h[D].hasOwnProperty("included")&&!h[D].included){this.f[D]=h[D],delete h[D];continue}else this.d[D]=h[D],h[D].policy?.name&&this.e.set(h[D].policy.name,D);!h[D].deprecationMessage&&h[D].markdownDeprecationMessage&&(h[D].deprecationMessage=h[D].markdownDeprecationMessage),o.add(D)}const P=n.allOf;if(P)for(const D of P)this.p(D,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$fo.properties[n]=r,r.scope){case 1:e.$go.properties[n]=r;break;case 2:e.$ho.properties[n]=r;break;case 6:e.$io.properties[n]=r;break;case 3:e.$jo.properties[n]=r;break;case 4:e.$ko.properties[n]=r;break;case 5:e.$ko.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$fo.properties[n],r.scope){case 1:delete e.$go.properties[n];break;case 2:delete e.$ho.properties[n];break;case 6:delete e.$io.properties[n];break;case 3:delete e.$jo.properties[n];break;case 4:case 5:delete e.$ko.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$lo};this.w(r,t),e.$fo.properties[r]=t,e.$go.properties[r]=t,e.$ho.properties[r]=t,e.$io.properties[r]=t,e.$jo.properties[r]=t,e.$ko.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$lo};e.$fo.patternProperties[e.$no]=n,e.$go.patternProperties[e.$no]=n,e.$ho.patternProperties[e.$no]=n,e.$io.patternProperties[e.$no]=n,e.$jo.patternProperties[e.$no]=n,e.$ko.patternProperties[e.$no]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;k.$ag(i)&&(i=r.defaultDefaultValue,s=void 0),k.$ag(i)&&(i=c(r.type)),r.default=i,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",p=new RegExp(w,"g");e.$no=`^(${w})+$`,e.$oo=new RegExp(e.$no);function I($){const n=[];if(e.$oo.test($)){let r=p.exec($);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=p.exec($)}}return(0,j.$Mb)(n)}function g($){return $.reduce((n,r)=>`${n}[${r}]`,"")}function c($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new y;l.$_n.add(e.$eo.Configuration,u);function v($,n){return $.trim()?e.$oo.test($)?N.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?N.localize(8,null,$):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,$,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}function m(){const $=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))$.push([r,n[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ne[67],se([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$yo=v;function w(r){return Object.isFrozen(r)?r:E.$1n(r)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,i,s,o,h){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const s=new I("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$8i)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return w(s.rawConfiguration.getValue(t))},get override(){return i?w(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return w(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:P,keys:D}of s.rawConfiguration.overrides){const R=new p(h,D,[],void 0,s.f).getValue(t);R!==void 0&&o.push({identifiers:P,value:R})}return o.length?w(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,f.$8i)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return j.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return j.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=E.$Zn(this.contents),s=E.$Zn(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const P of t)if(h.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const D of P.overrides){const[R]=s.filter(z=>j.$ub(z.identifiers,D.identifiers));R?(this.i(R.contents,D.contents),R.keys.push(...D.keys),R.keys=j.$Mb(R.keys)):s.push(E.$Zn(D))}for(const D of P.keys)o.indexOf(D)===-1&&o.push(D)}return new p(i,o,s,h.every(P=>P instanceof p)?void 0:h,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of j.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[o];const P=i[o];P&&(typeof h=="object"&&typeof P=="object"?(h=E.$Zn(h),this.i(h,P)):h=P),s[o]=h}return new p(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&l.$8f(t[s])&&l.$8f(i[s])){this.i(t[s],i[s]);continue}t[s]=E.$Zn(i[s])}}j(t){let i=null,s=null;const o=h=>{h&&(s?this.i(s,h):s=E.$Zn(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?i=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,f.$7i)(this.contents,t),b.$oo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>j.$ub(s.identifiers,(0,b.$po)(t))),1))}k(t,i,s){(0,f.$6i)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.$oo.test(t)&&this.overrides.push({identifiers:(0,b.$po)(t),keys:Object.keys(this.contents[t]),contents:(0,f.$5i)(this.contents[t],o=>this.f.error(o))})}}e.$uo=p;class I{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!l.$cg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:h,restricted:P,hasExcludedProperties:D}=this.i(t,i);this.b=new p(s,o,h,D?[t]:void 0,this.g),this.c=P||[]}h(t){let i={},s=null,o=[];const h=[],P=[];function D(z){Array.isArray(o)?o.push(z):s!==null&&(o[s]=z)}const R={onObjectBegin:()=>{const z={};D(z),h.push(o),o=z,s=null},onObjectProperty:z=>{s=z},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const z=[];D(z),h.push(o),o=z,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:D,onError:(z,M,T)=>{P.push({error:z,offset:M,length:T})}};if(t)try{k.$Nn(t,R),i=o[0]||{}}catch(z){this.g.error(`Error while parsing settings file ${this.f}: ${z}`),this.d=[z]}return i}i(t,i){const s=y.$_n.as(b.$eo.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const h=(0,f.$5i)(t,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`)),P=Object.keys(t),D=this.l(t,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:h,keys:P,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const P={},D=[];for(const R in t)if(b.$oo.test(R)&&s){const z=this.j(t[R],i,!1,o);P[R]=z.raw,h=h||z.hasExcludedProperties,D.push(...z.restricted)}else{const z=i[R],M=z?typeof z.scope<"u"?z.scope:3:void 0;z?.restricted&&D.push(R),!o.exclude?.includes(R)&&(o.include?.includes(R)||(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&!(o.skipRestricted&&z?.restricted))?P[R]=t[R]:h=!0}return{raw:P,restricted:D,hasExcludedProperties:h}}l(t,i){const s=[];for(const o of Object.keys(t))if(b.$oo.test(o)){const h={};for(const P in t[o])h[P]=t[o][P];s.push({identifiers:(0,b.$po)(o),keys:Object.keys(h),contents:(0,f.$5i)(h,i)})}return s}}e.$vo=I;class g extends N.$Vc{constructor(t,i,s,o,h){super(),this.c=t,this.f=i,this.g=o,this.h=h,this.b=this.B(new O.$ce),this.onDidChange=this.b.event,this.a=new I(this.c.toString(),h),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&s.isEqual(P.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$wo=g;class c{constructor(t,i,s,o,h,P,D,R,z,M,T,Q,re){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=h,this.f=P,this.g=D,this.h=R,this.i=z,this.j=M,this.k=T,this.l=Q,this.m=re}get value(){return w(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(t,i,s,o,h,P,D,R,z,M){this.j=t,this.l=i,this.m=s,this.n=o,this.p=h,this.q=P,this.r=D,this.s=R,this.t=z,this.u=M,this.h=null,this.i=new A.$Bc,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=p.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),h=this.A(i.resource,s),P=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const R of o.overrides)for(const z of R.identifiers)o.getOverrideValue(t,z)!==void 0&&D.add(z);return new c(t,i,o.getValue(t),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,h||void 0,P)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:h,removed:P}=$(this.j,t);i=[...o,...h,...P]}for(const o of i)for(const h of(0,b.$po)(o)){const P=this.j.getKeysForOverrideIdentifier(h),D=t.getKeysForOverrideIdentifier(h),R=[...D.filter(z=>P.indexOf(z)===-1),...P.filter(z=>D.indexOf(z)===-1),...P.filter(z=>!E.$4n(this.j.override(h).getValue(z),t.override(h).getValue(z)))];s.push([h,R])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=$(this.l,t),h=[...i,...s,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.applicationConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.localUserConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.remoteUserConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.workspaceConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:P,overrides:D}=$(s,i),R=[...o,...h,...P];return(R.length||!s)&&this.updateFolderConfiguration(t,i),{keys:R,overrides:D}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:P}=$(i,void 0);return{keys:[...s,...o,...h],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const h=this.t.get(t);h&&(s=s.merge(h))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:h}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),h=this.E(t.application,i),P=this.E(t.user,i),D=this.E(t.workspace,i),R=t.folders.reduce((z,M)=>(z.set(a.URI.revive(M[0]),this.E(M[1],i)),z),new A.$Bc);return new u(s,o,h,P,p.createEmptyModel(i),D,R,p.createEmptyModel(i),new A.$Bc,i)}static E(t,i){return new p(t.contents,t.keys,t.overrides,void 0,i)}}e.$xo=u;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,P])=>{const D=(0,A.$yc)(i,h,new Set);P.forEach(R=>D.add(R))});const s=[];return i.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}class m{constructor(t,i,s,o,h){this.change=t,this.f=i,this.g=s,this.h=o,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of t.keys)this.affectedKeys.add(P);for(const[,P]of t.overrides)for(const D of P)this.affectedKeys.add(D);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const h=o+s.length;if(h>=this.d.length)return!1;const P=this.d.charCodeAt(h);if(P!==this.b&&P!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,R=this.g.getValue(t,i,this.h);return!E.$4n(D,R)}return!0}}e.$zo=m;function $(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),h=[],P=r?.getAllOverrideIdentifiers()||[],D=t?.getAllOverrideIdentifiers()||[];if(t){const R=D.filter(z=>!P.includes(z));for(const z of R)h.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const R=P.filter(z=>!D.includes(z));for(const z of R)h.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const R of P)if(D.includes(R)){const z=n({contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)},{contents:t.getOverrideValue(void 0,R)||{},keys:t.getKeysForOverrideIdentifier(R)});h.push([R,[...z.added,...z.removed,...z.updated]])}}return{added:i,removed:s,updated:o,overrides:h}}function n(r,t){const i=r?t?r.keys.filter(h=>t.keys.indexOf(h)===-1):[...r.keys]:[],s=t?r?t.keys.filter(h=>r.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(r&&t){for(const h of t.keys)if(r.keys.indexOf(h)!==-1){const P=(0,f.$8i)(t.contents,h),D=(0,f.$8i)(r.contents,h);E.$4n(P,D)||o.push(h)}}return{added:i,removed:s,updated:o}}}),define(ne[138],se([0,1,19,5,2,27,3,67,40,6,39,36]),function(Z,e,j,O,k,N,A,E,l,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=void 0;class y extends k.$Vc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new O.$ce),this.onDidChangeConfiguration=this.a.event,this.b=E.$uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$_n.as(l.$eo.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.f(Array.from(g),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,c){this.j(g,b.$_n.as(l.$eo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=E.$uo.createEmptyModel(this.c);const g=b.$_n.as(l.$eo.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,c){const u=this.g();for(const v of g){const m=u[v],$=c[v];m!==void 0?this.b.addValue(v,m):$?this.b.addValue(v,$.default):this.b.removeValue(v)}}}e.$Ao=y;class w{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=E.$uo.createEmptyModel(new a.$ak)}async initialize(){return this.configurationModel}}e.$Bo=w;let p=class extends k.$Vc{get configurationModel(){return this.b}constructor(g,c,u){super(),this.c=g,this.f=c,this.g=u,this.a=this.B(new O.$ce),this.onDidChangeConfiguration=this.a.event,this.b=E.$uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},u=[],v=b.$_n.as(l.$eo.Configuration).getConfigurationProperties();for(const m of g){const $=v[m];if(!$){u.push(m);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(m),c[$.policy.name]={type:$.type}}}return(0,A.$gg)(c)||await this.f.updatePolicyDefinitions(c),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=b.$_n.as(l.$eo.Configuration).getPolicyConfigurations(),u=(0,j.$Hb)(g.map(v=>c.get(v)));this.m(u,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const u=b.$_n.as(l.$eo.Configuration).getConfigurationProperties(),v=[],m=this.b.isEmpty();for(const $ of g){const n=u[$]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(m?r!==void 0:!(0,N.$4n)(this.b.getValue($),r))&&v.push([$,r])}else this.b.getValue($)!==void 0&&v.push([$,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const $=this.b;this.b=E.$uo.createEmptyModel(this.g);for(const n of $.keys)this.b.setValue(n,$.getValue(n));for(const[n,r]of v)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);c&&this.a.fire(this.b)}}};e.$Co=p,e.$Co=p=$e([oe(1,f.$bo),oe(2,a.$Zj)],p)}),define(ne[139],se([0,1,19,8,14,5,38,75,2,30,27,12,17,29,67,40,138,39]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=void 0;class u extends l.$Vc{constructor($,n,r,t){super(),this.m=$,this.n=t,this.h=this.B(new N.$ce),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Ao(t)),this.c=r instanceof c.$do?new g.$Bo:this.B(new g.$Co(this.b,r,t)),this.f=this.B(new p.$wo(this.m,{},y.$Xg,n,t)),this.a=new p.$xo(this.b.configurationModel,this.c.configurationModel,p.$uo.createEmptyModel(t),p.$uo.createEmptyModel(t),p.$uo.createEmptyModel(t),p.$uo.createEmptyModel(t),new a.$Bc,p.$uo.createEmptyModel(t),new a.$Bc,t),this.j=new v($,n,this),this.g=this.B(new O.$Fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$xo($,n,p.$uo.createEmptyModel(this.n),r,p.$uo.createEmptyModel(this.n),p.$uo.createEmptyModel(this.n),new a.$Bc,p.$uo.createEmptyModel(this.n),new a.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue($,n){const r=typeof $=="string"?$:void 0,t=(0,w.$1i)($)?$:(0,w.$1i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue($,n,r,t,i){const s=(0,w.$2i)(r)?r:(0,w.$1i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,j.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const h=this.inspect($,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,f.$4n)(n,h.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const D=s.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(z=>(0,j.$ub)([...z.identifiers].sort(),D));R&&(s.overrideIdentifiers=R.identifiers)}const P=s?.overrideIdentifiers?.length?[(0,I.$qo)(s.overrideIdentifiers),$]:[$];await this.j.write(P,n),await this.reloadConfiguration()}inspect($,n={}){return this.a.inspect($,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,n,2)}s($,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration($,n);this.u(t,r,7)}t($){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,n,7)}u($,n,r){const t=new p.$zo($,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Do=u;class v{constructor($,n,r){this.b=$,this.c=n,this.d=r,this.a=new O.$Ah}write($,n){return this.a.queue(()=>this.e($,n))}async e($,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,A.$Gn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,$,n);r=(0,E.$Yn)(r,i),await this.c.writeFile(this.b,k.$De.fromString(r))}f($,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,E.$Vn)($,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let $=b.OS===3||b.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&($=n),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[68],se([0,1,15]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=O,e.$Fm=k,e.$Gm=N,e.$Hm=A;function O(l){return l.scheme===j.Schemas.vscodeRemote?l.authority:void 0}function k(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function N(l){const{host:a,port:f}=E(l);if(typeof f>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function A(l,a){let{host:f,port:b}=E(l);return typeof b>"u"&&(b=a),{host:f,port:b}}function E(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=l.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const b=l.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:l,port:void 0}}}),define(ne[37],se([0,1,31,10,68]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Qm=e.$Pm=e.$Om=e.TargetPlatform=e.ExtensionType=e.$Nm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0,e.$Mm=N,e.$Rm=b,e.$Sm=y,e.$Tm=w,e.$Um=p,e.$Im="extensions.user.cache",e.$Jm="extensions.builtin.cache",e.$Km="undefined_publisher",e.$Lm=["ui","workspace","web"];function N(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.$Nm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(I){I.WIN32_X64="win32-x64",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class l{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const u=typeof g=="string"?g:g.value,v=typeof c=="string"?c:c.value;return j.$vf(u,v)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Om=l;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(l.toKey(g))}delete(g){return this.c.delete(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}}e.$Pm=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(l.toKey(g))}get(g){return this.c.get(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}set(g,c){this.c.set(l.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Qm=f;function b(I){return y(I)}function y(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}function w(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}function p(I,g){if(g){const c=`onResolveRemoteAuthority:${(0,k.$Fm)(g)}`;return!!I.activationEvents?.includes(c)}return!1}e.$Vm=(0,O.$ti)("IBuiltinExtensionsScannerService")}),define(ne[140],se([0,1,2,37,13]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;class N extends j.$Vc{constructor(E,l,a,f,b){super(),this.a=E,this.b=l,this.c=a,this.f=b,this.B(f.onDidInstallExtensions(y=>this.g(y))),this.B(f.onDidUninstallExtension(y=>this.h(y)))}g(E){for(const l of E)l.local&&this.invalidate(l.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,E)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,O.$Im))}catch(l){(0,k.$el)(l)!==1&&this.f.error(l)}}}e.$yq=N}),define(ne[45],se([0,1,14,9,2,108,40,10,6,36]),function(Z,e,j,O,k,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=void 0,e.$Mp=y,e.$Np=w,e.$Op=p,e.$Pp=I,e.$Qp=g,e.$Rp=c,e.$Kp=(0,E.$ti)("requestService");class f{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?$[n]="*****":$[n]=this.b[n];this.a=$}return this.a}}class b extends k.$Vc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,N.localize)(0,null),when:l.$fk.isEqualTo((0,l.$ck)(l.LogLevel.Trace)).serialize()})}async c($,n,r){const t=`${$} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new f(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,O.$0)(i)),i}}}e.$Lp=b;function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function w(m){return m.res.statusCode===204}async function p(m){return w(m)?null:(await(0,j.$Pe)(m.stream)).toString()}async function I(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return p(m)}async function g(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(w(m))return null;const n=(await(0,j.$Pe)(m.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function c(m){v(m)}let u;function v(m){const $=a.$_n.as(A.$eo.Configuration),n=u;u={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:n?[n]:[]})}v(1)}),define(ne[141],se([0,1,20,15,13,45]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;let A=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,f=j.CancellationToken.None){if(l.scheme===O.Schemas.file||l.scheme===O.Schemas.vscodeRemote){await this.b.copy(l,a);return}const b={type:"GET",url:l.toString(!0)},y=await this.a.request(b,f);if(y.res.statusCode===200)await this.b.writeFile(a,y.stream);else{const w=await(0,N.$Pp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${w}`)}}};e.$UQ=A,e.$UQ=A=$e([oe(0,N.$Kp),oe(1,k.$Zk)],A)}),define(ne[142],se([0,1,143,3]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=N;function k(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function N(A,E,l={}){const a=(0,j.parse)(A),f=l.proxyUrl||k(a,E);if(!f)return null;const b=(0,j.parse)(f);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,O.$_f)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,p)=>{Z(["http-proxy-agent"],w,p)})).HttpProxyAgent(f,y):new(await new Promise((w,p)=>{Z(["https-proxy-agent"],w,p)})).HttpsProxyAgent(f,y)}}),define(ne[144],se([0,1,59,16,109,20,34,9,12,28,88,175,8,76]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=I;let p;async function I(c,u,v,m){return v["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$xm)(m)&&!v["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$xm)(m)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=y.Promises.withAsyncBody(async($,n)=>{const r=new N.$ne;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,w.$ym)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,k.localize)(0,null)))},t);try{$(await g(u,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,k.localize)(1,null,(0,A.$ej)(o)))):$({})}finally{clearTimeout(s),r.dispose()}})),p)}async function g(c,u){const v=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",v);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",m);const $=(0,a.$Pg)().replace(/-/g,"").substr(0,12),n=new RegExp($+"({.*})"+$),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,f.$nm)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(u.isCancellationRequested)return s(new E.$5);const o=(0,O.$oc)(t);let h,P;const D="";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${D} -p '''${$}'' + JSON.stringify(process.env) + ''${$}'''`,P=["-Login","-Command"]):o==="nu"?(h=`^'${process.execPath}' ${D} -p '"${$}" + JSON.stringify(process.env) + "${$}"'`,P=["-i","-l","-c"]):o==="xonsh"?(h=`import os, json; print("${$}", json.dumps(dict(os.environ)), "${$}")`,P=["-i","-l","-c"]):(h=`'${process.execPath}' ${D} -p '"${$}" + JSON.stringify(process.env) + "${$}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),h);const R=(0,j.spawn)(t,[...P,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(R.kill(),s(new E.$5))),R.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$ej)(T)),s(T)});const z=[];R.stdout.on("data",T=>z.push(T));const M=[];R.stderr.on("data",T=>M.push(T)),R.on("close",(T,Q)=>{const re=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(M).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),T||Q)return s(new Error((0,k.localize)(2,null,T,Q)));const he=n.exec(re),le=he?he[1]:"{}";try{const ce=JSON.parse(le);v?ce.ELECTRON_RUN_AS_NODE=v:delete ce.ELECTRON_RUN_AS_NODE,m?ce.ELECTRON_NO_ATTACH_CONSOLE=m:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,A.$ej)(ce)),s(ce)}})})}}),define(ne[145],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=void 0,e.$wQ=(0,j.$ti)("stateReadService"),e.$xQ=(0,j.$ti)("stateService")}),define(ne[69],se([0,1,8,14,2,3,18,13,6]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=e.$zQ=e.$yQ=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends k.$Vc{constructor(p,I,g,c){super(),this.h=p,this.j=I,this.m=g,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new j.$rh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,I){const g=this.a[p];return(0,N.$cg)(g)?I:g}setItem(p,I){this.setItems([{key:p,data:I}])}setItems(p){let I=!1;for(const{key:g,data:c}of p)this.a[g]!==c&&((0,N.$cg)(c)?(0,N.$ag)(this.a[g])||(this.a[g]=void 0,I=!0):(this.a[g]=c,I=!0));I&&this.s()}removeItem(p){(0,N.$ag)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,O.$De.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$yQ=f;let b=class extends k.$Vc{constructor(p,I,g,c){super(),this.a=this.B(new f(I.stateResource,p,g,c))}async init(){await this.a.init()}getItem(p,I){return this.a.getItem(p,I)}};e.$zQ=b,e.$zQ=b=$e([oe(1,A.$Ai),oe(2,l.$Zj),oe(3,E.$Zk)],b);class y extends b{setItem(p,I){this.a.setItem(p,I)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$AQ=y}),define(ne[70],se([0,1,12,35,28]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=A,e.$bp=E;function N(l){if(j.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function A(l,a,f,b,y,w,p,I,g){const c=Object.create(null);c["common.machineId"]=w,c["common.sqmId"]=p,c.sessionID=(0,k.$Pg)()+Date.now(),c.commitHash=b,c.version=y,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,j.$h)(j.$u),c["common.nodePlatform"]=O.$ec,c["common.nodeArch"]=f,c["common.product"]=g||"desktop",I&&(c["common.msftInternal"]=I);let u=0;const v=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),j.$l&&(c["common.snap"]="true");const m=N(a);return m&&(c["common.platformDetail"]=m),c}function E(l){const a=O.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return l.some(b=>f===b)}}),define(ne[22],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0,e.$Yl=(0,j.$ti)("telemetryService"),e.$Zl=(0,j.$ti)("customEndpointTelemetryService"),e.$1l="telemetry.currentSessionDate",e.$2l="telemetry.firstSessionDate",e.$3l="telemetry.lastSessionDate",e.$4l="telemetry.machineId",e.$5l="telemetry.sqmId",e.$6l="telemetry",e.$7l="telemetry.telemetryLevel",e.$8l="telemetry.enableCrashReporter",e.$9l="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[71],se([0,1,9,10,6,22]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.ExtensionSignatureVerificationCode=e.$9p=void 0,e.$9p=(0,O.$ti)("IExtensionSignatureVerificationService");var A;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class E extends Error{constructor(f){super(f),this.code=f}}e.$0p=E;let l=class{constructor(f,b){this.b=f,this.c=b}d(){return this.a||(this.a=new Promise((f,b)=>Z(["@vscode/vsce-sign"],async y=>f(y),b))),this.a}async verify(f,b,y){let w;try{w=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,j.$0)(c)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const p=new Date().getTime();let I;try{I=await w.verify(b,y,this.b.getLevel()===k.LogLevel.Trace)}catch(c){I={code:"UnknownError",didExecute:!1,output:(0,j.$0)(c)}}const g=new Date().getTime()-p;if(this.b.info(`Extension signature verification result for ${f}: ${I.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${I.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,code:I.code,duration:g,didExecute:I.didExecute}),I.code==="Success")return!0;throw new E(I.code)}};e.$$p=l,e.$$p=l=$e([oe(0,k.$Zj),oe(1,N.$Yl)],l)}),define(ne[41],se([0,1,27,3,68,70,22]),function(Z,e,j,O,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=f,e.$kp=b,e.$lp=y,e.$mp=w,e.$np=I,e.$op=c,e.$pp=u,e.$qp=$;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$cp=E;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$dp=l,e.$ep=new l;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$fp=a,e.$gp="telemetry",e.$hp="extensionTelemetryLog",e.$ip={log:()=>null,flush:()=>Promise.resolve(null)};function f(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function b(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const r=n.getValue(A.$7l),t=n.getValue(A.$8l);if(n.getValue(A.$9l)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(n){const r={},t={},i={};g(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(n){if(!n)return"none";const r=(0,k.$Fm)(n);return p.has(r)?r:"other"}function g(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],h=i?i+s:s;Array.isArray(o)?r[h]=(0,j.$5n)(o):o instanceof Date?r[h]=o.toISOString():(0,O.$8f)(o)?t<2?g(o,r,t+1,h+"."):r[h]=(0,j.$5n)(o):r[h]=o}}function c(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,N.$bp)(t)||i}function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function v(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const P of r)for(;;){const D=P.exec(n);if(!D)break;i.push([D.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(t="";;){const P=o.exec(n);if(!P)break;const D=i.some(([R,z])=>P.index<z&&R<o.lastIndex);!s.test(P[0])&&!D&&(t+=n.substring(h,P.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<n.length&&(t+=n.substr(h)),t}function m(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function $(n,r){return(0,j.$2n)(n,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=v(i,r);for(const s of r)i=i.replace(s,"");return i=m(i),i}})}}),define(ne[26],se([0,1,31,21,37,12,11,9,35,41]),function(Z,e,j,O,k,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$sp=void 0,e.$rp=f,e.$tp=p,e.$up=I,e.$vp=g,e.$wp=c,e.$xp=u,e.$yp=v,e.$zp=m,e.$Bp=$,e.$Cp=r;function f(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,j.$qf)(t.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,s,o)}static parse(i){const s=b.exec(i);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?f(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$sp=y;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=w.exec(t);return i&&i[1]?[g(i[1]),i[2]]:[g(t),void 0]}function I(t,i){return`${t}.${i}`}function g(t){return t.toLowerCase()}function c(t,i){return g(I(t??k.$Km,i))}function u(t,i){const s=[],o=h=>{for(const P of s)if(P.some(D=>f(i(D),i(h))))return P;return null};for(const h of t){const P=o(h);P?P.push(h):s.push([h])}return s}function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function m(t){return{id:new a.$cp(t.identifier.id),name:new a.$cp(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Ap=new k.$Om("pprice.better-merge");function $(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&s.every(P=>!f(P.identifier,{id:h}))){const P=t.filter(D=>f(D.identifier,{id:h}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,E.$0)(h))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,O.$Yo)(s?"alpine":N.$u,l.$fc);return i.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],se([0,1,20,9,15,17,44,11,97,21,26,37]),function(Z,e,j,O,k,N,A,E,l,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;const y=I=>(0,l.localize)(0,null,I),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(g,c,u){this.a=g,this.b=c,this.d=u}get f(){}async listExtensions(g,c,u){let v=await this.b.getInstalled(1,u);const m=b.$Nm.map(n=>n.toLowerCase());if(c&&c!==""){if(m.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),m.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),v=v.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let $;for(const n of v)$!==n.identifier.id&&($=n.identifier.id,this.a.info(g?`${$}@${n.manifest.version}`:$))}async installExtensions(g,c,u,v){const m=[];try{g.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const $=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...u,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||u.installPreReleaseVersion}})};for(const i of g)if(i instanceof E.URI)$.push({vsix:i,installOptions:u});else{const[s,o]=(0,f.$tp)(i);r(s,o,!1)}for(const i of c)if(i instanceof E.URI)$.push({vsix:i,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.$tp)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,u.profileLocation);if($.length&&await Promise.all($.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,v,t)}catch(o){this.a.error(o),m.push(i.toString())}})),n.length){const i=await this.g(n,t,v);m.push(...i)}}catch($){throw this.a.error((0,l.localize)(5,null,(0,O.$0)($))),$}if(m.length)throw new Error((0,l.localize)(6,null,m.join(", ")))}async updateExtensions(g){const c=await this.b.getInstalled(1,g),u=[];for(const n of c)n.identifier.uuid&&u.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,l.localize)(7,null,u.length));const v=await this.d.getExtensions(u,{compatible:!0},j.CancellationToken.None),m=[];for(const n of v)for(const r of c)(0,f.$rp)(r.identifier,n.identifier)&&(0,A.gt)(n.version,r.manifest.version)&&m.push({extension:n,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!m.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,m.map(n=>n.extension.identifier.id).join(", ")));const $=await this.b.installGalleryExtensions(m);for(const n of $)n.error?this.a.error((0,l.localize)(10,null,n.identifier.id,(0,O.$0)(n.error))):this.a.info((0,l.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(g,c,u){if(g=g.filter(({id:n,version:r})=>{const t=c.find(i=>(0,f.$rp)(i.identifier,{id:n}));if(t){if(!u&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,l.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${n}@${r}`)),!1}return!0}),!g.length)return[];const v=[],m=[],$=await this.j(g);if(await Promise.all(g.map(async({id:n,version:r,installOptions:t})=>{const i=$.get(n.toLowerCase());if(!i){this.a.error(`${y(r?`${n}@${r}`:n)}
${w}`),v.push(n);return}try{const o=await this.d.getManifest(i,j.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),v.push(n);return}const s=c.find(o=>(0,f.$rp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,l.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,l.localize)(16,null,n,r):(0,l.localize)(17,null,n)):this.a.info(r?(0,l.localize)(18,null,n,r):(0,l.localize)(19,null,n)),m.push({extension:i,options:{...t,installGivenVersion:!!r}})})),m.length){const n=await this.b.installGalleryExtensions(m);for(const r of n)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,O.$0)(r.error))),v.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return v}async h(g,c,u,v){const m=await this.b.getManifest(g);if(!m)throw new Error("Invalid vsix");if(await this.l(m,u,c.profileLocation,v))try{await this.b.install(g,c),this.a.info((0,l.localize)(22,null,(0,N.$4g)(g)))}catch(n){if((0,O.$4)(n))this.a.info((0,l.localize)(23,null,(0,N.$4g)(g)));else throw n}}async j(g){const c=new Map,u=g.some($=>$.installOptions.installPreReleaseVersion),v=await this.b.getTargetPlatform(),m=[];for(const $ of g)a.$Ro.test($.id)&&m.push({...$,preRelease:u});if(m.length){const $=await this.d.getExtensions(m,{targetPlatform:v},j.CancellationToken.None);for(const n of $)c.set(n.identifier.id.toLowerCase(),n)}return c}k(g){return!0}async l(g,c,u,v){if(!c){const m={id:(0,f.$wp)(g.publisher,g.name)},$=v.find(n=>(0,f.$rp)(m,n.identifier)&&(0,A.gt)(n.manifest.version,g.version));if($)return this.a.info((0,l.localize)(24,null,$.identifier.id,$.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,c,u){const v=async $=>{if($ instanceof E.URI){const n=await this.b.getManifest($);return(0,f.$up)(n.publisher,n.name)}return $},m=[];for(const $ of g){const n=await v($),t=(await this.b.getInstalled(void 0,u)).filter(i=>(0,f.$rp)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${w}`);if(t.some(i=>i.type===0)){this.a.info((0,l.localize)(25,null,n));return}if(!c&&t.some(i=>i.isBuiltin)){this.a.info((0,l.localize)(26,null,n));return}this.a.info((0,l.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:u}),m.push(i);this.f?this.a.info((0,l.localize)(28,null,n,this.f)):this.a.info((0,l.localize)(29,null,n))}}async locateExtension(g){const c=await this.b.getInstalled();g.forEach(u=>{c.forEach(v=>{if(v.identifier.id===u&&v.location.scheme===k.Schemas.file){this.a.info(v.location.fsPath);return}})})}m(g){return this.f?(0,l.localize)(30,null,g,this.f):(0,l.localize)(31,null,g)}};e.$_p=p,e.$_p=p=$e([oe(1,a.$6o),oe(2,a.$3o)],p)}),define(ne[147],se([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,71,13,6]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;let m=class extends k.$Vc{static{v=this}static{this.c=".sigzip"}constructor(n,r,t,i,s,o){super(),this.h=r,this.j=t,this.m=i,this.n=s,this.r=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,r,t){await this.g;const i=(0,A.$7g)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,i,o=>this.j.download(n,o,r))}catch(o){throw new p.$4o(o.message,p.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(n)){const o=await this.u(n);try{s=await this.n.verify(n.identifier.id,i.fsPath,o.fsPath)}catch(h){if(s=h.code,s==="PackageIsInvalidZip"||s==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(D){this.r.error(D)}throw new p.$4o(b.$dq,p.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(h){this.r.error(h)}}}return{location:i,verificationStatus:s}}t(n){if(!n.isSigned)return this.r.info(`Extension is not signed: ${n.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,l.$_f)(r)?r:!0}async u(n){await this.g;const r=(0,A.$7g)(this.extensionsDownloadDir,`${this.z(n)}${v.c}`);try{await this.w(n,r,t=>this.j.downloadSignatureArchive(n,t))}catch(t){throw new p.$4o(t.message,p.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const i=(0,A.$7g)(this.extensionsDownloadDir,`.${(0,a.$Pg)()}`);await this.h.exists(i)||await t(i);try{await f.Promises.rename(i.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,O.$0)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const h of n.children)if(h.name.endsWith(v.c))i.push(h.resource);else{const P=I.$sp.parse(h.name);P&&t.push([P,h])}const s=(0,I.$xp)(t,([h])=>h),o=[];for(const h of s)h.sort((P,D)=>E.rcompare(P[0].version,D[0].version)),r.push(...h.slice(1).map(P=>P[1].resource)),o.push(h[0][1]);o.sort((h,P)=>h.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(h=>h.resource)),r.push(...i),await j.Promises.settled(r.map(h=>(this.r.trace("Deleting from cache",h.path),this.h.del(h))))}}catch(n){this.r.error(n)}}z(n){return this.f?I.$sp.create(n).toString().toLowerCase():(0,a.$Pg)()}};e.$vq=m,e.$vq=m=v=$e([oe(0,w.$Bi),oe(1,c.$Zk),oe(2,p.$3o),oe(3,y.$Zi),oe(4,g.$9p),oe(5,u.$Zj)],m)}),define(ne[148],se([0,1,5,2,30,26,37]),function(Z,e,j,O,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class E extends O.$Vc{constructor(a,f,b,y,w,p,I){super(),this.f=a,this.g=f,this.h=b,this.j=y,this.m=w,this.n=p,this.r=I,this.a=this.B(new j.$ce),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$5c),this.s().then(null,g=>I.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(f=>(this.c.set(f.id,(0,O.$Sc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(a){for(const f of a.extensions)this.I(this.L(f.identifier,f.version),a.profileLocation)}async y(a){for(const f of a.extensions){const b=this.L(f.identifier,f.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const f of a.extensions)this.J(this.L(f.identifier,f.version),a.profileLocation)}async C(a){const f=[],b=[];for(const y of a.extensions){const w=this.L(y.identifier,y.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),b.push(this.f.scanInstalledExtensionAtLocation(y.location).then(p=>{p?f.push(p):this.r.info("Extension not found at the location",y.location.toString())},p=>this.r.error(p)))))}try{await Promise.all(b),f.length&&await this.H(f)}catch(y){this.r.error(y)}}D(a){for(const f of this.h.profiles)a.contains(f.extensionsResource,0,1)&&this.F(f.extensionsResource)}async F(a){const f=[],b=[],y=await this.j.scanProfileExtensions(a),w=new Set,p=new Set;for(const[I,g]of this.b)g.has(a)&&p.add(I);for(const I of y){const g=this.L(I.identifier,I.version);w.add(g),p.has(g)||(f.push(I.identifier),this.I(g,a))}for(const I of p)if(!w.has(I)){const g=this.M(I);g&&(b.push(g.identifier),this.J(I,a))}(f.length||b.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const f=await this.j.scanProfileExtensions(a);for(const b of f)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,f){let b=this.b.get(a);b||this.b.set(a,b=new k.$Cc(y=>this.m.extUri.getComparisonKey(y))),b.add(f)}J(a,f){const b=this.b.get(a);b&&b.delete(f),b?.size||this.b.delete(a)}L(a,f){return`${A.$Om.toKey(a.id)}@${f}`}M(a){const[f,b]=(0,N.$tp)(a);return b?{identifier:{id:f},version:b}:void 0}}e.$zq=E}),define(ne[149],se([0,1,119,41]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=k;async function k(N,A,E,l,a,f,b){const y={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,O.$jp)(A,E)&&(0,O.$lp)(l)===3){const w=await(0,j.$4p)(E,a,f);y["X-Market-User-Id"]=w,y["VSCode-SessionId"]=b.machineId||w}return y}}),define(ne[150],se([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;let I=class extends w.$Pr{constructor(v,m,$,n){super($),this.h=v,this.j=n,this.g=this.B(new g(m,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(v,m){const n=(await this.g.getLanguagePacks())[m];if(!n){this.j.warn(`No language pack found for ${m}`);return}const r=n.translations[v];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),m=Object.keys(v).map($=>{const n=v[$];return{...this.f($,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort(($,n)=>$.label.localeCompare(n.label)),m}async m(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",v.identifier.id),await this.update())}async n(v){const m=await this.g.getLanguagePacks();Object.keys(m).some($=>m[$]&&m[$].extensions.some(n=>(0,b.$rp)(n.extensionIdentifier,v.identifier)))&&(this.j.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(m);return!(0,O.$ub)(Object.keys(v),Object.keys($))}};e.$Qr=I,e.$Qr=I=$e([oe(0,f.$6o),oe(1,a.$Bi),oe(2,f.$3o),oe(3,y.$Zj)],I);let g=class extends N.$Vc{constructor(v,m){super(),this.j=m,this.c={},this.f=(0,E.$kc)(v.userDataPath,"languagepacks.json"),this.g=new k.$Ah}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.s(m=>{Object.keys(m).forEach($=>delete m[$]),this.m(m,...v)}).then(()=>this.c)}m(v,...m){for(const $ of m)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(v,$);Object.keys(v).forEach($=>this.r(v[$]))}n(v,m){const $=m.identifier,n=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const r of n)if(m.location.scheme===A.Schemas.file&&c(r)){let t=v[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},v[r.languageId]=t);const i=t.extensions.filter(s=>(0,b.$rp)(s.extensionIdentifier,$))[0];i?i.version=m.manifest.version:t.extensions.push({extensionIdentifier:$,version:m.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$kc)(m.location.fsPath,s.path)}}r(v){if(v){const m=(0,j.createHash)("md5");for(const $ of v.extensions)m.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);v.hash=m.digest("hex")}}s(v=()=>null){return this.g.queue(()=>{let m=null;return l.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(m=v($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>m,$=>this.j.error($))})}};g=$e([oe(0,a.$Bi),oe(1,y.$Zj)],g);function c(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const v of u.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ne[151],se([0,1,85,9,27,41]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function l(f,b,y){const w=await(0,j.$VD)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,j.$VD)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new w.AppInsightsCore,g=new p.PostChannel,c={instrumentationKey:f,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(y){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};c.extensionConfig[g.identifier]=u}return I.initialize(c,[]),I.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),I}class a{constructor(b,y,w,p,I){this.e=b,this.f=y,this.g=w,this.h=I,this.c=A,this.d=E,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(y=>{b(y)},y=>{(0,O.$1)(y),console.error(y)})}}log(b,y){if(!this.a)return;y=(0,k.$3n)(y,this.g),y=(0,N.$mp)(y);const w=this.f+"/"+b;try{this.i(p=>{p.pluginVersionString=y?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$sQ=a}),define(ne[152],se([0,1,2,27,12,31,110,29,40,153,32,36,22,41]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,u,v){this.k=u,this.l=v,this.d={},this.i=new j.$Uc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,N.$0e)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$0e)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(y.$7l)||m.affectsConfiguration(y.$9l)||m.affectsConfiguration(y.$8l))&&this.m()}))}setExperimentProperty(c,u){this.d[c]=u}m(){let c=(0,w.$lp)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const v=u.usage?3:u.error?2:0;c=Math.min(c,v)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,u,v){this.g<u||(v=(0,O.$3n)(v,this.d),v=(0,w.$qp)(v,this.j),v=(0,O.$3n)(v,this.c),this.b.forEach(m=>m.log(c,v)))}publicLog(c,u){this.n(c,3,u)}publicLog2(c,u){this.publicLog(c,u)}publicLogError(c,u){this.h&&this.n(c,2,u)}publicLogError2(c,u){this.publicLogError(c,u)}};e.$Wr=p,e.$Wr=p=$e([oe(1,E.$Zi),oe(2,f.$gk)],p);function I(){const g=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=k.$o?"":(0,A.localize)(3,null),v=(0,A.localize)(4,null),m=(0,A.localize)(5,null),$=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${v} | ${m} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${g} ${c} ${u}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}b.$_n.as(l.$eo.Configuration).registerConfiguration({id:y.$6l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[y.$7l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:I(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$_n.as(l.$eo.Configuration).registerConfiguration({id:y.$6l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.$9l]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.$7l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],se([0,1,14,20,177,151]),function(Z,e,j,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=void 0;async function A(f,b){const y=await b.request(f,O.CancellationToken.None),w=(await(0,j.$Pe)(y.stream)).toString(),p=y.res.statusCode??200;return{headers:y.res.headers,statusCode:p,responseData:w}}async function E(f){const b={method:f.type,headers:f.headers};return new Promise((w,p)=>{const I=k.request(f.url??"",b,g=>{g.on("data",function(c){w({headers:g.headers,statusCode:g.statusCode??200,responseData:c.toString()})}),g.on("error",function(c){p(c)})});I.write(f.data,g=>{g&&p(g)}),I.end()})}async function l(f,b,y){const w=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),p={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:w};try{const I=f?await A(p,f):await E(p);y(I.statusCode,I.headers,I.responseData)}catch{y(0,{})}}class a extends N.$sQ{constructor(b,y,w,p,I){const g={sendPOST:(c,u)=>{l(b,c,u)}};super(y,w,p,I,g)}}e.$tQ=a}),define(ne[155],se([0,1,16,25]),function(Z,e,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=k;async function k(N,A){const E=Object.create(null),l=(f,b)=>{const y=JSON.parse(f);E[b]=y};if(A){const f=[],b=await O.Promises.readdir(A);for(const w of b)try{(await O.Promises.stat((0,j.$kc)(A,w))).isDirectory()&&f.push(w)}catch{}const y=[];for(const w of f)(await O.Promises.readdir((0,j.$kc)(A,w))).filter(I=>I==="telemetry.json").length===1&&y.push(w);for(const w of y){const p=(await O.Promises.readFile((0,j.$kc)(A,w,"telemetry.json"))).toString();l(p,w)}}let a=(await O.Promises.readFile((0,j.$kc)(N,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await O.Promises.readFile((0,j.$kc)(N,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(ne[156],se([0,1,12,86,22]),function(Z,e,j,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=N,e.$Scc=A;async function N(E,l){let a=E.getItem(k.$4l);return(typeof a!="string"||j.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.$Cn)(l.error.bind(l))),a}async function A(E,l){let a=E.getItem(k.$5l);return typeof a!="string"&&(a=await(0,O.$Dn)(l.error.bind(l))),a}}),define(ne[23],se([0,1,10]),function(Z,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=void 0,e.$xl=(0,j.$ti)("IUriIdentityService")}),define(ne[157],se([0,1,23,120,13,17,77,5,2]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(y){this.g=y,this.c=new l.$Uc,this.f=2**16;const w=new Map,p=I=>{let g=w.get(I.scheme);return g===void 0&&(g=y.hasProvider(I)&&!this.g.hasCapability(I,1024),w.set(I.scheme,g)),g};this.c.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(I=>{w.delete(I.scheme)})),this.extUri=new N.$Vg(p),this.d=new A.$vs((I,g)=>this.extUri.compare(I,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,N.$8g)(y));const w=this.d.get(y);return w?w.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((p,I)=>p[1].time<I[1].time?1:p[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let p=0;p<w;p++)this.d.set(y[p][0],y[p][1].touch())}};e.$ws=f,e.$ws=f=$e([oe(0,k.$Zk)],f),(0,O.$ts)(j.$xl,f,1)}),define(ne[158],se([0,1,5,2,13,48,30]),function(Z,e,j,O,k,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class E extends O.$Vc{constructor(a,f,b,y,w,p){super(),this.f=a,this.g=f,this.h=b,this.j=y,this.m=w,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new j.$ce),this.onDidChangeFile=this.a.event,this.b=N.$zi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Cc(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,b,y,w){return this.g.read(a,f,b,y,w)}write(a,f,b,y,w){return this.g.write(a,f,b,y,w)}watch(a,f){this.b.set(a,a);const b=this.g.watch(this.t(a),f);return(0,O.$Tc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,b){return this.g.rename(this.t(a),this.t(f),b)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,b){return this.g.readFileStream(this.t(a),f,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,b){return this.g.writeFile(this.t(a),f,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,b){if((0,k.$4k)(this.g))return this.g.copy(this.t(a),this.t(f),b);throw new Error("copy not supported")}cloneFile(a,f){if((0,k.$5k)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&f.push({resource:y,type:b.type,cId:b.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$ddc=E}),define(ne[159],se([0,1,112,16,48,17,11,10,15]),function(Z,e,j,O,k,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Ni=e.$Mi=e.WorkbenchState=e.$Gi=e.$Fi=e.$Ci=void 0,e.$Di=a,e.$Ei=f,e.$Hi=b,e.$Ii=y,e.$Ji=w,e.$Ki=I,e.$Li=g,e.$Oi=v,e.$Ti=m,e.$Ui=$,e.$Wi=n,e.$Xi=r,e.$Yi=t,e.$Ci=(0,E.$ti)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function f(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.$Fi={id:"ext-dev"},e.$Gi={id:"empty-window"};function b(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$oc)(i)}:s?e.$Fi:e.$Gi;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function I(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,h,P,D){this.h=s,this.j=h,this.k=P,this.l=D,this.c=k.$zi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$zi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Mi=c;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$7g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ni=u;function v(i){return new u({uri:i,index:0,name:(0,N.$3g)(i)},{uri:i.toString()})}e.$Pi="code-workspace",e.$Qi=`.${e.$Pi}`,e.$Ri=[{name:(0,j.localize)(0,null),extensions:[e.$Pi]}],e.$Si="workspace.json";function m(i,s){return N.$Xg.isEqualOrParent(i,s.untitledWorkspacesHome)}function $(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===l.Schemas.tmp}e.$Vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$Vi}function r(i,s){return!m(i,s)&&!$(i)}function t(i){return(typeof i=="string"?(0,O.$pc)(i):(0,N.$5g)(i))===e.$Qi}}),define(ne[24],se([0,1,43,5,2,17,11,111,18,13,10,6,159,30,23,8,28,31,3]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$zl=e.ProfileResourceType=void 0,e.$yl=m,e.$Al=$,e.$Bl=n;var v;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function m(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$zl=(0,f.$ti)("IUserDataProfilesService");function $(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,h,P,D){return{id:i,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:D&&P?.useDefaultFlags?.globalState?D.globalStorageHome:(0,N.$7g)(o,"globalStorage"),settingsResource:D&&P?.useDefaultFlags?.settings?D.settingsResource:(0,N.$7g)(o,"settings.json"),keybindingsResource:D&&P?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,N.$7g)(o,"keybindings.json"),tasksResource:D&&P?.useDefaultFlags?.tasks?D.tasksResource:(0,N.$7g)(o,"tasks.json"),snippetsHome:D&&P?.useDefaultFlags?.snippets?D.snippetsHome:(0,N.$7g)(o,"snippets"),extensionsResource:D&&P?.useDefaultFlags?.extensions?D.extensionsResource:(0,N.$7g)(o,"extensions.json"),cacheHome:(0,N.$7g)(h,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,h,P){super(),this.t=s,this.u=o,this.w=h,this.y=P,this.f=!0,this.h=this.B(new O.$ce),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$ce),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$ce),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$ce),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Bc,emptyWindows:new Map},this.profilesHome=(0,N.$7g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$7g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,u.$6f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(n((0,N.$4g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},s))}}catch(D){this.y.error(D)}const h=new w.$Bc,P=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[R,z]of Object.entries(D.workspaces)){const M=A.URI.parse(R),T=o.find(Q=>Q.id===z);T&&h.set(M,T)}if(D.emptyWindows)for(const[R,z]of Object.entries(D.emptyWindows)){const M=o.find(T=>T.id===z);M&&P.set(R,M)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:h,emptyWindows:P}}return this.z}D(){const s=n("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",h=new RegExp(`${(0,c.$0e)(o)}\\s(\\d+)`);let P=0;for(const R of this.profiles){const z=h.exec(R.name),M=z?parseInt(z[1]):0;P=M>P?M:P}const D=`${o} ${P+1}`;return this.createProfile((0,j.$hj)((0,g.$Pg)()).toString(16),D,{transient:!0},s)}async createNamedProfile(s,o,h){return this.createProfile((0,j.$hj)((0,g.$Pg)()).toString(16),s,o,h)}async createProfile(s,o,h,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(s,o,h);return P&&await this.setProfileForWorkspace(P,D),D}async F(s,o,h){if(!(0,u.$6f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===o||M.id===s))throw new Error(`Profile with ${o} name already exists`);const R=n(s,o,(0,N.$7g)(this.profilesHome,s),this.g,h,this.defaultProfile);await this.u.createFolder(R.location);const z=[];return this.j.fire({profile:R,join(M){z.push(M)}}),await I.Promises.settled(z),this.I([R],[],[]),R}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(P=>P.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);return h=n(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const h=[];this.m.fire({profile:o,join(P){h.push(P)}});try{await Promise.allSettled(h)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$el)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(P=>P.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,h)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,y.$Di)(s)?s.uri:(0,y.$Ii)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,h){const P=[...this.profiles,...s],D=[];this.s.profiles=[];for(let R of P)R.isDefault||o.some(z=>R.id===z.id)||(R=h.find(z=>R.id===z.id)??R,R.isTransient?this.s.profiles.push(R):D.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags}));this.P(D),this.z=void 0,this.J(s,o,h)}J(s,o,h){this.h.fire({added:s,removed:o,updated:h,all:this.profiles})}L(s,o,h){h=o?.isTransient?!0:h,h||this.L(s,void 0,!0);const P=this.G(s),D=h?this.s:this.C;A.URI.isUri(P)?(D.workspaces.delete(P),o&&D.workspaces.set(P,o)):(D.emptyWindows.delete(P),o&&D.emptyWindows.set(P,o)),h||this.M()}M(){const s={};for(const[h,P]of this.C.workspaces.entries())s[h.toString()]=P.id;const o={};for(const[h,P]of this.C.emptyWindows.entries())o[h.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},h=this.D();if(s.workspaces)for(const[D,R]of Object.entries(s.workspaces)){const z=A.URI.parse(R);o[D]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}const P={};if(s.emptyWindows)for(const[D,R]of Object.entries(s.emptyWindows)){const z=A.URI.parse(R);P[D]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Cl=r,e.$Cl=r=$e([oe(0,l.$Ai),oe(1,a.$Zk),oe(2,p.$xl),oe(3,b.$Zj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Dl=t}),define(ne[160],se([0,1,19,8,20,9,5,2,12,3,11,95,21,26,37,6,32,22,23,24]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=void 0,e.$jq=$;let m=class extends E.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,h,P,D){super(),this.z=i,this.C=s,this.D=o,this.F=h,this.G=P,this.H=D,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$ce),this.s=this.B(new A.$ce),this.t=this.B(new A.$ce),this.u=this.B(new A.$ce),this.w=this.B(new A.$ce),this.y=[],this.B((0,E.$Tc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.$1o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const h=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:P})=>(0,w.$rp)(P,i.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new y.$4o(`Unknown error while installing extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new y.$4o(b.localize(0,null),y.ExtensionManagementErrorCode.NotAllowed);const s=[],o=[];return await Promise.allSettled(i.map(async({extension:h,options:P})=>{try{const D=await this.N(h,!!P?.installGivenVersion,!!P?.installPreReleaseVersion,P.productVersion??{version:this.G.version,date:this.G.date});o.push({...D,options:P})}catch(D){s.push({identifier:h.identifier,operation:2,source:h,error:D})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,p.$Rm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const h of this.H.profiles){const P=(await this.getInstalled(1,h.extensionsResource)).find(D=>(0,w.$rp)(D.identifier,i.identifier));P?this.w.fire(P):this.u.fire({identifier:i.identifier,profileLocation:h.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,h=[],P=(R,z)=>`${w.$sp.create(R).toString()}-${z.toString()}`,D=(R,z,M,T)=>{const Q=this.Y(R,z,M),re=`${(0,w.$wp)(R.publisher,R.name)}-${M.profileLocation.toString()}`;o.set(re,{task:Q,root:T}),this.n.fire({identifier:Q.identifier,source:z,profileLocation:M.profileLocation}),this.F.info("Installing extension:",Q.identifier.id),f.URI.isUri(z)||this.j.set(P(z,M.profileLocation),{task:Q,waitingTasks:[]})};try{for(const{manifest:R,extension:z,options:M}of i){const T=M.isApplicationScoped||M.isBuiltin||(0,p.$Rm)(R),Q={...M,installOnlyNewlyAddedFromExtensionPack:M.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(z),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:M.profileLocation??this.X(),productVersion:M.productVersion??{version:this.G.version,date:this.G.date}},re=f.URI.isUri(z)?void 0:this.j.get(P(z,Q.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id),h.push(re.task.waitUntilTaskIsFinished())):D(R,z,Q,void 0)}return await Promise.all([...o.values()].map(async({task:R})=>{if(R.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",R.identifier.id);else try{const z=await this.M(R.identifier,R.manifest,!!R.options.installOnlyNewlyAddedFromExtensionPack,!!R.options.installPreReleaseVersion,R.options.profileLocation,R.options.productVersion),M=await this.getInstalled(void 0,R.options.profileLocation,R.options.productVersion),T={...R.options,context:{...R.options.context,[y.$Vo]:!0}};for(const{gallery:Q,manifest:re}of(0,j.$Mb)(z,({gallery:ie})=>ie.identifier.id)){if(o.has(`${Q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const ie=this.j.get(P(Q,T.profileLocation));if(ie){if(this.J(R,ie.task)){const he=ie.task.identifier;this.F.info("Waiting for already requested installing extension",he.id,R.identifier.id),ie.waitingTasks.push(R),h.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,w.$rp)(ce.identifier,he)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",he.id,R.identifier.id),!le.find(V=>(0,w.$rp)(V.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else M.some(({identifier:he})=>(0,w.$rp)(he,Q.identifier))||D(re,Q,T,R)}}catch(z){if(f.URI.isUri(R.source))(0,j.$Lb)(R.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",R.identifier.id,z.message),(0,j.$Lb)(R.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",R.identifier.id,z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",R.identifier.id),z}})),await this.L([...o.entries()].map(async([R,{task:z}])=>{const M=new Date().getTime();try{const T=await z.run();if(await this.L(this.y.map(Q=>Q.postInstall(T,z.source,z.options,k.CancellationToken.None))),!f.URI.isUri(z.source)){const Q=z.operation===3,re=Q?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(n(this.C,Q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$zp)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-M,durationSinceUpdate:re}),l.$o&&z.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}s.set(R,{local:T,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){const Q=$(T);throw f.URI.isUri(z.source)||n(this.C,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$zp)(z.source),error:Q}),s.set(R,{error:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:z.options.isApplicationScoped}),this.F.error("Error while installing the extension",z.identifier.id,(0,N.$0)(Q)),Q}})),h.length&&await this.L(h),[...s.values()]}catch(R){const z=(Q,re,ie)=>{const he=[];Q.manifest.extensionDependencies?.length&&he.push(...Q.manifest.extensionDependencies),Q.manifest.extensionPack?.length&&he.push(...Q.manifest.extensionPack);for(const le of he){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${re.toString()}`);ce?.local&&(ie=z(ce.local,re,ie))}return ie},M=Q=>({identifier:Q.identifier,operation:2,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,error:R}),T=[];for(const[Q,{task:re,root:ie}]of o){const he=s.get(Q);he?he.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`)?.local&&(T.push(this.Z(he.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(Q,M(re))):(re.cancel(),s.set(Q,M(re)))}for(const[Q,{task:re}]of o){const ie=s.get(Q);if(!ie?.local||re.options.donotIncludePackAndDependencies)continue;z(ie.local,re.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${re.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${re.profileLocation.toString()}`)?.local)&&(T.push(this.Z(ie.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(Q,M(re)))}throw T.length&&await Promise.allSettled(T.map(async Q=>{try{await Q.run(),this.F.info("Rollback: Uninstalled extension",Q.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",Q.extension.identifier.id,(0,N.$0)(re))}})),R}finally{for(const{task:R}of o.values())R.source&&!f.URI.isUri(R.source)&&this.j.delete(P(R.source,R.profileLocation));if(s.size){const R=[...s.values()];for(const z of R)z.local&&this.F.info("Extension installed successfully:",z.identifier.id);this.s.fire(R)}}}J(i,s){for(const[,{task:o,waitingTasks:h}]of this.j.entries())if(o===i&&(h.includes(s)||h.some(P=>this.J(P,s)))||o===s&&h[0]&&!this.J(i,h[0]))return!1;return!0}async L(i){const s=[],o=[],h=await Promise.allSettled(i);for(const P of h)P.status==="fulfilled"?s.push(P.value):o.push(P.reason);if(o.length){if(o.length===1)throw o[0];let P=new y.$4o("",y.ExtensionManagementErrorCode.Unknown);for(const D of o){const R=D instanceof y.$4o?D.code:y.ExtensionManagementErrorCode.Unknown;P=new y.$4o(D.message?`${D.message}, ${P.message}`:P.message,R!==y.ExtensionManagementErrorCode.Unknown&&R!==y.ExtensionManagementErrorCode.Internal?R:P.code)}throw P}return s}async M(i,s,o,h,P,D){if(!this.z.isEnabled())return[];const R=await this.getInstalled(void 0,P,D),z=[],M=[],T=async(Q,re)=>{z.push(Q);const ie=re.extensionDependencies||[],he=[...ie];if(re.extensionPack){const le=o?R.find(ce=>(0,w.$rp)(ce.identifier,Q)):void 0;for(const ce of re.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,w.$rp)({id:V},{id:ce}))||he.every(V=>!(0,w.$rp)({id:V},{id:ce}))&&he.push(ce)}if(he.length){const le=he.filter(ce=>z.every(V=>!(0,w.$rp)(V,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(V=>({id:V,preRelease:h})),k.CancellationToken.None);for(const V of ce){if(z.find(q=>(0,w.$rp)(q,V.identifier)))continue;const J=ie.some(q=>(0,w.$rp)({id:q},V.identifier));let B;try{B=await this.N(V,!1,h,D)}catch(q){if(J)throw q;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,N.$0)(q));continue}M.push({gallery:B.extension,manifest:B.manifest}),await T(B.extension.identifier,B.manifest)}}}};return await T(i,s),M}async N(i,s,o,h){let P;const D=await this.getExtensionsControlManifest();if(D.malicious.some(M=>(0,w.$rp)(i.identifier,M)))throw new y.$4o(b.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);const R=D.deprecated[i.identifier.id.toLowerCase()];if(R?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${R.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:R.extension.id,preRelease:R.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},k.CancellationToken.None))[0],!P)throw new y.$4o(b.localize(2,null,i.identifier.id,R.extension.id),y.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const M=await this.getTargetPlatform();throw new y.$4o(b.localize(3,null,i.identifier.id,this.G.nameLong,(0,y.$Wo)(M)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.O(i,s,o,h),!P)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],k.CancellationToken.None))[0]?new y.$4o(b.localize(4,null,i.displayName??i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.$4o(b.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),y.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const z=await this.z.getManifest(P,k.CancellationToken.None);if(z===null)throw new y.$4o(`Missing manifest for extension ${P.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(z.version!==P.version)throw new y.$4o(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:z}}async O(i,s,o,h){const P=await this.getTargetPlatform();let D=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(D=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:P,compatible:!0,productVersion:h},k.CancellationToken.None))[0]||null),!D&&await this.z.isExtensionCompatible(i,o,P,h)&&(D=i),D||(s?D=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:P,compatible:!0,productVersion:h},k.CancellationToken.None))[0]||null:D=await this.z.getCompatibleExtension(i,o,P,h)),D}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},h=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,P=this.m.get(h(i.identifier));if(P)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),P.waitUntilTaskIsFinished();const D=T=>{const Q=this.Z(T,o);return this.m.set(h(Q.extension.identifier),Q),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),Q},R=(T,Q)=>{Q?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),Q.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,Q.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$yp)(T),error:Q}),this.u.fire({identifier:T.identifier,error:Q?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},z=[],M=[];try{z.push(D(i));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const Q=this.S(i,T);for(const re of Q)this.m.has(h(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):z.push(D(re))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(z.map(Q=>Q.extension),T,i),await this.L(z.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(re=>re.postUninstall(Q.extension,o,k.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,"uninstall")}catch{}R(Q.extension)}catch(re){const ie=$(re);throw R(Q.extension,ie),ie}finally{M.push(Q)}}))}catch(T){const Q=$(T);for(const re of z){try{re.cancel()}catch{}M.includes(re)||R(re.extension,Q)}throw Q}finally{for(const T of z)this.m.delete(h(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(i,s,o){for(const h of i){const P=this.U(h,s);if(P.length){const D=P.filter(R=>!i.some(z=>(0,w.$rp)(z.identifier,R.identifier)));if(D.length)throw new Error(this.R(h,D,o))}}}R(i,s,o){return o===i?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const P=s.filter(R=>!R.isBuiltin&&h.some(z=>(0,w.$rp)({id:z},R.identifier))),D=[];for(const R of P)D.push(...this.S(R,s,o));return[...P,...D]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(h=>(0,w.$rp)({id:h},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$iq=m,e.$iq=m=$e([oe(0,y.$3o),oe(1,c.$Yl),oe(2,u.$xl),oe(3,I.$Zj),oe(4,g.$gk),oe(5,v.$zl)],m);function $(t){if(t instanceof y.$4o)return t;if(t instanceof y.$5o){const s=new y.$4o(t.message,y.ExtensionManagementErrorCode.Gallery);return s.stack=t.stack,s}const i=new y.$4o(t.message,(0,N.$4)(t)?y.ExtensionManagementErrorCode.Cancelled:y.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:h,error:P,durationSinceUpdate:D}){let R,z;(0,a.$bg)(o)&&(o===!0?o="Verified":(o===!1||(R=y.ExtensionManagementErrorCode.Signature,z=o),o="Unverified")),P&&(R=P.code,P.code===y.ExtensionManagementErrorCode.Signature&&(z=P.message)),t.publicLog(i,{...s,verificationStatus:o,success:!P,duration:h,errorcode:R,errorcodeDetail:z,durationSinceUpdate:D})}class r{constructor(){this.d=new O.$sh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,O.$gh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$gh)(i=>new Promise((s,o)=>{const h=i.onCancellationRequested(()=>{h.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$kq=r}),define(ne[42],se([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class v extends Error{constructor(t,i){super(t),this.code=i}}e.$lq=v,e.$mq=(0,b.$ti)("IExtensionsProfileScannerService");let m=class extends k.$Vc{constructor(t,i,s,o,h,P){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=h,this.t=P,this.b=this.B(new N.$ce),this.onAddExtensions=this.b.event,this.c=this.B(new N.$ce),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$ce),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$ce),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Bc}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],h=[];try{return await this.u(i,P=>{const D=[];if(s)D.push(...P);else for(const R of P)t.some(([z])=>(0,a.$rp)(z.identifier,R.identifier)&&z.manifest.version!==R.version)?o.push(R):D.push(R);for(const[R,z]of t){const M=D.findIndex(Q=>(0,a.$rp)(Q.identifier,R.identifier)&&Q.version===R.manifest.version),T={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:z};M===-1?(h.push(T),D.push(T)):D.splice(M,1,T)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),D}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(P){throw h.length&&this.c.fire({extensions:h,error:P,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:i}),P}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const h=[];for(const P of o){const D=t.find(([R])=>(0,a.$rp)(R.identifier,P.identifier)&&R.manifest.version===P.version);D&&(P.metadata={...P.metadata,...D[1]},s.push(P)),h.push(P)}return h}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const h=[];for(const P of o)(0,a.$rp)(P.identifier,t.identifier)?s.push(P):h.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:i}),h}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],h;try{const P=await this.m.readFile(t);h=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,f.$el)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&s?.bailOutWhenFileNotFound)throw new v((0,g.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.w(t);let P=!1;for(const D of h){$(D)||this.w(t);let R;if((0,I.$6f)(D.relativeLocation)&&D.relativeLocation)R=this.z(D.relativeLocation);else if((0,I.$6f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{R=E.URI.revive(D.location);const z=this.y(R);z&&(P=!0,D.relativeLocation=z)}(0,I.$ag)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(P=!0,D.metadata.hasPreReleaseVersion=!0),o.push({identifier:D.identifier,location:R,version:D.version,metadata:D.metadata})}P&&await this.m.writeFile(t,O.$De.fromString(JSON.stringify(h)))}if(i){o=i(o);const P=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(t,O.$De.fromString(JSON.stringify(P)))}return o})}w(t){const i=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(h){if((0,f.$el)(h)===1)return;throw h}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const h=JSON.parse(s);Array.isArray(h)&&h.every(P=>$(P))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$De.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,f.$el)(h)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(t)}catch(h){(0,f.$el)(h)!==1&&this.t.error(h)}try{await this.m.del(i)}catch(h){(0,f.$el)(h)!==1&&this.t.error(h)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new j.$Ah,this.h.set(t,i)),i}};e.$nq=m,e.$nq=m=$e([oe(1,f.$Zk),oe(2,w.$zl),oe(3,p.$xl),oe(4,c.$Yl),oe(5,y.$Zj)],m);function $(r){return(0,I.$8f)(r)&&(0,l.$2o)(r.identifier)&&(n(r.location)||(0,I.$6f)(r.location)&&r.location)&&((0,I.$ag)(r.relativeLocation)||(0,I.$6f)(r.relativeLocation))&&r.version&&(0,I.$6f)(r.version)}function n(r){return r?(0,I.$6f)(r.path)&&(0,I.$6f)(r.scheme):!1}}),define(ne[53],se([0,1,19,8,27,14,9,38,83,2,15,16,12,17,44,55,3,11,99,18,26,37,50,13,10,6,32,5,47,42,24,23,117]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v,m,$,n,r,t,i,s,o,h,P,D,R,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$sq=e.$rq=e.$qq=e.Translations=void 0,e.$tq=he;var M;(function(ce){function V(J,B){if(J===B)return!0;const q=Object.keys(J),W=new Set;for(const X of Object.keys(B))W.add(X);if(q.length!==W.size)return!1;for(const X of q){if(J[X]!==B[X])return!1;W.delete(X)}return W.size===0}ce.equals=V})(M||(e.Translations=M={})),e.$qq=(0,t.$ti)("IExtensionsScannerService");let T=class extends a.$Vc{constructor(V,J,B,q,W,X,Y,_,U,F,d,S){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=J,this.r=B,this.s=q,this.t=W,this.u=X,this.w=Y,this.y=_,this.z=U,this.C=F,this.D=d,this.F=S,this.g=this.B(new o.$ce),this.onDidChangeCache=this.g.event,this.h=(0,w.$7g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Cp)(this.w,this.y)),this.G}async scanAllExtensions(V,J,B){const[q,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(J)]),X=B?await this.scanExtensionsUnderDevelopment(V,[...q,...W]):[];return this.L(q,W,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const J=[];J.push(this.M(!!V.useCache,V.language)),J.push(this.N(V.language,!!V.checkControlFile));const[B,q]=await Promise.all(J);return this.J([...B,...q],0,V,!1)}async scanUserExtensions(V){const J=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(J,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),W=V.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let X;try{X=await W.scanExtensions(q)}catch(Y){if(Y instanceof P.$lq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await W.scanExtensions(q);else throw Y}return X=await this.J(X,1,V,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(V,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===f.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=J.find(_=>(0,m.$rp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,W)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,J,B){const q=await this.P(V,!1,J,!0,B.language,!0,void 0,B.productVersion??this.R()),W=await this.n.scanExtension(q);return!W||!B.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,J,B){const q=await this.P(V,!1,J,!0,B.language,!0,void 0,B.productVersion??this.R()),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,J,B,!0)}async scanMultipleExtensions(V,J,B){const q=[];return await Promise.all(V.map(async W=>{const X=await this.scanOneOrMultipleExtensions(W,J,B);q.push(...X)})),this.J(q,J,B,!0)}async scanMetadata(V){const J=(0,w.$7g)(V,"package.json"),B=(await this.w.readFile(J)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,J){const B=(0,w.$7g)(V,"package.json"),q=(await this.w.readFile(B)).value.toString(),W=JSON.parse(q);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,W.__metadata={...W.__metadata,...J},await this.w.writeFile((0,w.$7g)(V,"package.json"),N.$De.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof P.$lq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$De.fromString(JSON.stringify([])))}catch(J){(0,r.$el)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,J,B,q){return B.includeAllVersions||(V=this.L(J===0?V:void 0,J===1?V:void 0,J==="development"?V:void 0,await this.getTargetPlatform(),q)),B.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,X)=>{const Y=b.$oc(W.location.fsPath),_=b.$oc(X.location.fsPath);return Y<_?-1:Y>_?1:0})}L(V,J,B,q,W){const X=(_,U,F)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(W&&p.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(p.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===q)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},Y=new $.$Qm;return V?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||X(U,_,!1))&&Y.set(_.identifier.id,_)}),J?.forEach(_=>{const U=Y.get(_.identifier.id);if(!U&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||X(U,_,!1))&&Y.set(_.identifier.id,_)}),B?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||X(U,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(V,J){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),W=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",W.length),W}async N(V,J){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const q=J?await this.O():{},W=[],X=c.URI.file(b.$ic(b.$kc(f.$Ng.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of B){const U=q[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":W.push((0,w.$7g)(X,_.name));break;default:W.push(c.URI.file(U));break}}const Y=await Promise.all(W.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,j.$Hb)(Y)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,J,B,q,W,X,Y,_){const U=await this.f(W??y.$w),F=await this.Q(V),d=J&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=d?await this.Q(d):void 0;return new Q(V,F,d,S,J,Y,B,q,X,_.version,_.date,this.C.commit,!this.z.isBuilt,W,U)}async Q(V){try{const J=await this.w.stat(V);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$rq=T,e.$rq=T=$e([oe(4,D.$zl),oe(5,P.$mq),oe(6,r.$Zk),oe(7,i.$Zj),oe(8,v.$Ai),oe(9,s.$gk),oe(10,R.$xl),oe(11,t.$si)],T);class Q{constructor(V,J,B,q,W,X,Y,_,U,F,d,S,L,C,G){this.location=V,this.mtime=J,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=_,this.validate=U,this.productVersion=F,this.productDate=d,this.productCommit=S,this.devMode=L,this.language=C,this.translations=G}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,J){return(0,w.$Zg)(V.location,J.location)&&V.mtime===J.mtime&&(0,w.$Zg)(V.applicationExtensionslocation,J.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&V.profile===J.profile&&k.$4n(V.profileScanOptions,J.profileScanOptions)&&V.type===J.type&&V.excludeObsolete===J.excludeObsolete&&V.validate===J.validate&&V.productVersion===J.productVersion&&V.productDate===J.productDate&&V.productCommit===J.productCommit&&V.devMode===J.devMode&&V.language===J.language&&M.equals(V.translations,J.translations)}}e.$sq=Q;let re=class extends a.$Vc{constructor(V,J,B,q,W){super(),this.f=V,this.g=J,this.h=B,this.j=q,this.m=W}async scanExtensions(V){const J=V.profile?await this.r(V):await this.n(V);let B={};if(V.excludeObsolete&&V.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(q)}catch{}return(0,g.$gg)(B)?J:J.filter(q=>!B[m.$sp.create(q).toString()])}async n(V){const J=await this.j.resolve(V.location);if(!J.children?.length)return[];const B=await Promise.all(J.children.map(async q=>{if(!q.isDirectory||V.type===1&&(0,w.$4g)(q.resource).indexOf(".")===0)return null;const W=new Q(q.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,j.$Hb)(B).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(V){let J=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){J=J.filter(q=>!q.metadata?.isApplicationScoped);const B=await this.s(V.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,V);J.push(...B)}return J}async s(V,J,B){const q=await this.g.scanProfileExtensions(V,B.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async X=>{if(J(X)){const Y=new Q(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,j.$Hb)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,w.$7g)(V.location,"package.json"))){const J=await this.scanExtension(V);return J?[J]:[]}else return await this.scanExtensions(V)}catch(J){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,A.$0)(J)),[]}}async scanExtension(V,J){try{let B=await this.scanExtensionManifest(V.location);if(B){B.publisher||(B.publisher=$.$Km),J=J??B.__metadata,delete B.__metadata;const q=(0,m.$wp)(B.publisher,B.name),W=J?.id?{id:q,uuid:J.id}:{id:q},X=J?.isSystem?0:V.type,Y=X===0||!!J?.isBuiltin;B=await this.t(V.location,B,Q.createNlsConfiguration(V));const _={type:X,identifier:W,manifest:B,location:V.location,isBuiltin:Y,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(B){V.type!==0&&this.m.error(B)}return null}validate(V,J){let B=!0;const q=(0,n.$Hp)(J.productVersion,J.productDate,J.location,V.manifest,V.isBuiltin);for(const[W,X]of q)W===I.default.Error&&(B=!1,this.m.error(this.z(J.location,X)));return V.isValid=B,V.validations=q,V}async scanExtensionManifest(V){const J=(0,w.$7g)(V,"package.json");let B;try{B=(await this.j.readFile(J)).value.toString()}catch(W){return(0,r.$el)(W)!==1&&this.m.error(this.z(V,(0,u.localize)(0,null,J.path,W.message))),null}let q;try{q=JSON.parse(B)}catch{const X=[];(0,E.$Gn)(B,X);for(const Y of X)this.m.error(this.z(V,(0,u.localize)(1,null,J.path,Y.offset,Y.length,(0,l.$oq)(Y.error))));return null}return(0,E.$Pn)(q)!=="object"?(this.m.error(this.z(V,(0,u.localize)(2,null,J.path))),null):q}async t(V,J,B){const q=await this.u(V,J,B);if(q)try{const W=[],X=await this.w(q.default,W);if(W.length>0)return W.forEach(_=>{this.m.error(this.z(V,(0,u.localize)(3,null,q.default?.path,(0,l.$oq)(_.error))))}),J;if((0,E.$Pn)(q)!=="object")return this.m.error(this.z(V,(0,u.localize)(4,null,q.default?.path))),J;const Y=q.values||Object.create(null);return(0,z.$pq)(this.m,J,Y,X)}catch{}return J}async u(V,J,B){const q=(0,w.$7g)(V,"package.nls.json"),W=(U,F)=>{F.forEach(d=>{this.m.error(this.z(V,(0,u.localize)(5,null,U?.path,(0,l.$oq)(d.error))))})},X=U=>{this.m.error(this.z(V,(0,u.localize)(6,null,U?.path)))},Y=`${J.publisher}.${J.name}`,_=B.translations[Y];if(_)try{const U=c.URI.file(_),F=(await this.j.readFile(U)).value.toString(),d=[],S=(0,E.$Gn)(F,d);return d.length>0?(W(U,d),{values:void 0,default:q}):(0,E.$Pn)(S)!=="object"?(X(U),{values:void 0,default:q}):{values:S.contents?S.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let F;try{F=await this.y(V,B)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const d=(await this.j.readFile(F.localized)).value.toString(),S=[],L=(0,E.$Gn)(d,S);return S.length>0?(W(F.localized,S),{values:void 0,default:F.original}):(0,E.$Pn)(L)!=="object"?(X(F.localized),{values:void 0,default:F.original}):{values:L,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(V,J){if(V)try{const B=(await this.j.readFile(V)).value.toString();return(0,E.$Gn)(B,J)}catch{}}y(V,J){return new Promise((B,q)=>{const W=X=>{const Y=(0,w.$7g)(V,`package.nls.${X}.json`);this.j.exists(Y).then(_=>{_&&B({localized:Y,original:(0,w.$7g)(V,"package.nls.json")});const U=X.lastIndexOf("-");U===-1?B({localized:(0,w.$7g)(V,"package.nls.json"),original:null}):(X=X.substring(0,U),W(X))})};if(J.devMode||J.pseudo||!J.language)return B({localized:(0,w.$7g)(V,"package.nls.json"),original:null});W(J.language)})}z(V,J){return`[${V.path}]: ${J}`}};re=$e([oe(1,P.$mq),oe(2,R.$xl),oe(3,r.$Zk),oe(4,i.$Zj)],re);let ie=class extends re{constructor(V,J,B,q,W,X,Y){super(J,q,W,X,Y),this.G=V,this.H=B,this.D=this.B(new O.$rh(3e3)),this.F=this.B(new o.$ce),this.onDidChangeCache=this.F.event}async scanExtensions(V){const J=this.M(V),B=await this.I(J);if(this.C=V,B&&B.input&&Q.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),B.result.map(W=>(W.location=c.URI.revive(W.location),W));const q=await super.scanExtensions(V);return await this.J(J,{input:V,result:q}),q}async I(V){try{const J=await this.j.readFile(V),B=JSON.parse(J.value.toString());return{result:B.result,input:(0,h.$3h)(B.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",V.path,(0,A.$0)(J))}return null}async J(V,J){try{await this.j.writeFile(V,N.$De.fromString(JSON.stringify(J)))}catch(B){this.m.debug("Error while writing the extension cache file:",V.path,(0,A.$0)(B))}}async L(){if(!this.C)return;const V=this.M(this.C),J=await this.I(V);if(!J)return;const B=J.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$4n(q,B))try{this.m.info("Invalidating Cache",B,q),await this.j.del(V),this.F.fire()}catch(W){this.m.error(W)}}M(V){const J=this.N(V);return this.h.extUri.joinPath(J.cacheHome,V.type===0?$.$Jm:$.$Im)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(V.location,J.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,D.$zl),oe(3,P.$mq),oe(4,R.$xl),oe(5,r.$Zk),oe(6,i.$Zj)],ie);function he(ce,V){const J=(0,m.$up)(ce.manifest.publisher,ce.manifest.name);return{id:J,identifier:new $.$Om(J),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:V,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends T{constructor(V,J,B,q,W,X,Y,_,U,F,d,S){super(V,J,(0,w.$7g)(B,".vscode-oss-dev","extensions","control.json"),q,W,X,Y,_,U,F,d,S),this.S=(async()=>{if(y.$z)try{const L=await this.w.readFile(c.URI.file(y.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$uq=le}),define(ne[161],se([0,1,59,8,34,5,2,15,16,25,6,24]),function(Z,e,j,O,k,N,A,E,l,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;let y=class extends A.$Vc{constructor(p,I){super(),this.b=p,this.f=I,this.a=new O.$zh(5)}async postUninstall(p){const I=this.g(p,"uninstall");I&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m(p))}catch(g){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(g)}}g(p,I){const g=`vscode:${I}`;if(p.location.scheme===E.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[g]=="string"){const c=p.manifest.scripts[g].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${g} should be a node script`),null):{script:(0,l.$kc)(p.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(p,I,g,c,u){return new Promise((v,m)=>{const $=this.j(p,I,g,u);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?m(t):v(void 0)};$.on("error",t=>{r((0,k.$ej)(t)||"Unknown")}),$.on("exit",(t,i)=>{r(t?`post-${I} process exited with code ${t}`:void 0)}),c&&(n=setTimeout(()=>{n=null,$.kill(),m("timed out")},5e3))})}j(p,I,g,c){const u={silent:!0,execArgv:void 0},v=(0,j.fork)(p,[`--type=extension-post-${I}`,...g],u);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const m=N.Event.fromNodeEventEmitter(v.stdout,"data"),$=N.Event.fromNodeEventEmitter(v.stderr,"data");m(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${I}`,t)),$(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${I}`,t));const n=N.Event.any(N.Event.map(m,t=>({data:`%c${t}`,format:[""]})),N.Event.map($,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}m(p){return(0,l.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$wq=y,e.$wq=y=$e([oe(0,b.$zl),oe(1,f.$Zj)],y)}),define(ne[162],se([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,100,61,18,160,21,26,42,53,147,161,118,140,148,50,13,10,6,32,22,23,24]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v,m,$,n,r,t,i,s,o,h,P,D,R,z,M,T,Q,re,ie,he,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0,e.$Aq=(0,Q.$ui)(t.$6o);const V=".vsctmp";let J=class extends r.$iq{constructor(U,F,d,S,L,C,G,H,te,ae,ue,pe){super(U,F,ue,d,ae,pe),this.eb=L,this.fb=C,this.gb=G,this.hb=te,this.db=new Map,this.qb=new f.$Cc;const ye=this.B(H.createInstance(P.$wq));this.ab=this.B(H.createInstance(B,me=>ye.postUninstall(me))),this.bb=this.B(new R.$yq(pe,te,ue,this,this.F)),this.cb=this.B(H.createInstance(h.$vq));const fe=this.B(new z.$zq(this,this.eb,pe,C,ue,te,d));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Cp)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const F=await this.ob(U),d=await(0,v.zip)((0,w.$7g)(this.cb.extensionsDownloadDir,(0,c.$Pg)()).fsPath,F);return g.URI.file(d)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:F,cleanup:d}=await this.kb(U),S=y.$lc(F.fsPath);try{return await(0,D.$xq)(S)}finally{await d()}}getInstalled(U,F=this.H.defaultProfile.extensionsResource,d={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(U??null,F,d)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,F={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:d,cleanup:S}=await this.kb(U);try{const L=await(0,D.$xq)(y.$lc(d.fsPath)),C=(0,i.$wp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,M.$Jp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:L,extension:d,options:F}])).find(({identifier:te})=>(0,i.$rp)(te,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,r.$jq)(new Error(`Unknown error while installing extension ${C}`))}finally{await S()}}async installFromLocation(U,F){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const d=await this.ab.scanUserExtensionAtLocation(U);if(!d||!d.manifest.name||!d.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[d,{source:"resource"}]],F),this.F.info("Successfully installed extension",d.identifier.id,F.toString()),d}async installExtensionsFromProfile(U,F,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,F.toString(),d.toString());const S=(await this.getInstalled(1,F)).filter(L=>U.some(C=>(0,i.$rp)(C,L.identifier)));if(S.length){const L=await Promise.all(S.map(C=>this.ab.scanMetadata(C,F)));await this.tb(S.map((C,G)=>[C,L[G]]),d),this.F.info("Successfully installed extensions",S.map(C=>C.identifier.id),d.toString())}return S}async updateMetadata(U,F,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),U=await this.ab.updateMetadata(U,F,d),this.bb.invalidate(d),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const F=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!d)throw new Error(m.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(S){throw new Error(m.localize(3,null,(0,N.$ej)(S)))}return this.installFromGallery(d)}$(U,F,d,S){return this.ab.copyExtension(U,F,d,S)}copyExtensions(U,F){return this.ab.copyExtensions(U,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,F,d){const{location:S}=await this.cb.download(U,F,!d);return S}async kb(U){if(U.scheme===b.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const F=(0,w.$7g)(this.cb.extensionsDownloadDir,(0,c.$Pg)());return await this.gb.download(U,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(S){this.F.error(S)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,F,d){if(g.URI.isUri(F))return new X(U,F,d,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const S=i.$sp.create(F).toString();let L=this.db.get(S);return L||(this.db.set(S,L=new W(U,F,d,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),L.waitUntilTaskIsFinished().finally(()=>this.db.delete(S))),L}Z(U,F){return new Y(U,F.profileLocation,this.fb)}async ob(U){const F=async S=>{let L=await u.Promises.readdir(S);L=L.map(H=>y.$kc(S,H));const C=await Promise.all(L.map(H=>u.Promises.stat(H)));let G=Promise.resolve([]);return C.forEach((H,te)=>{const ae=L[te];H.isFile()&&(G=G.then(ue=>[...ue,ae])),H.isDirectory()&&(G=G.then(ue=>F(ae).then(pe=>[...ue,...pe])))}),G};return(await F(U.location.fsPath)).map(S=>({path:`extension/${y.$mc(U.location.fsPath,S)}`,localPath:S}))}async pb({added:U,removed:F}){if(F){const d=U&&this.D.extUri.isEqual(F.profileLocation,U.profileLocation)?F.extensions.filter(S=>U.extensions.every(L=>!(0,i.$rp)(L,S))):F.extensions;for(const S of d)this.F.info("Extensions removed from another source",S.id,F.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:F.profileLocation})}if(U){const S=(await this.getInstalled(1,U.profileLocation)).filter(L=>U.extensions.some(C=>(0,i.$rp)(C,L.identifier)));this.s.fire(S.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,U.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of U.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const d of U.rawAdded){if(this.qb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.hb.stat(d)).isDirectory)continue;const S=await this.ab.scanUserExtensionAtLocation(d);S&&S.installedTimestamp===void 0&&(this.qb.add(d),F.push(S))}F.length&&(await this.tb(F.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(d=>d.identifier.id)))}async tb(U,F){const d=U.map(S=>S[0]);await this.ub(d),await this.fb.addExtensionsToProfile(U,F),this.s.fire(d.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:F})))}async ub(U){const F=await this.ab.getUninstalledExtensions();for(const d of U){const S=i.$sp.create(d);F[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.ab.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$Bq=J,e.$Bq=J=$e([oe(0,t.$3o),oe(1,he.$Yl),oe(2,re.$Zj),oe(3,n.$Bi),oe(4,o.$qq),oe(5,s.$mq),oe(6,$.$Ho),oe(7,Q.$si),oe(8,T.$Zk),oe(9,ie.$gk),oe(10,le.$xl),oe(11,ce.$zl)],J);let B=class extends a.$Vc{constructor(U,F,d,S,L,C){super(),this.j=U,this.m=F,this.n=d,this.s=S,this.t=L,this.u=C,this.h=this.B(new E.$ce),this.onExtract=this.h.event,this.c=(0,w.$7g)(this.n.userExtensionsLocation,".obsolete"),this.g=new j.$Ah}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,F,d){const S={includeInvalid:!0,profileLocation:F,productVersion:d};let L=[];return U===null||U===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},S,!1)):U===1&&L.push(...await this.n.scanUserExtensions(S)),L=U!==null?L.filter(C=>C.type===U):L,Promise.all(L.map(C=>this.F(C)))}async scanAllUserExtensions(U){const F=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(F.map(d=>this.F(d)))}async scanUserExtensionAtLocation(U){try{const F=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(U,F,d,S,L){const C=U.toString(),G=g.URI.file(y.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Pg)()}`)),H=g.URI.file(y.$kc(this.n.userExtensionsLocation.fsPath,C));let te=await this.m.exists(H);if(te&&S){try{await this.y(U.id,H,"removeExisting")}catch{throw new t.$4o(m.localize(4,null,H.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(H,d);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${H.fsPath}`),await(0,v.$gq)(F,G.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${H}:`,U.id)}catch(ae){let ue=t.ExtensionManagementErrorCode.Extract;throw ae instanceof v.$eq&&(ae.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$4o(ae.message,ue)}await this.n.updateMetadata(G,d);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${H.fsPath}`),await this.C(G.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(H)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(H,1)}async scanMetadata(U,F){return F?(await this.w(U,F))?.metadata:this.n.scanMetadata(U.location)}async w(U,F){return(await this.s.scanProfileExtensions(F)).find(S=>(0,i.$rp)(S.identifier,U.identifier))}async updateMetadata(U,F,d){return d?await this.s.updateMetadata([[U,F]],d):await this.n.updateMetadata(U.location,F),this.D(U.location,U.type,d)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const F=U.map(d=>i.$sp.create(d));await this.z(d=>F.forEach(S=>{d[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(U){await this.z(F=>delete F[U.toString()])}async removeExtension(U,F){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,F)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(F=>delete F[i.$sp.create(U).toString()])}async copyExtension(U,F,d,S){const L=await this.w(U,F),C=await this.w(U,d);if(S={...L?.metadata,...S},C)if(this.t.extUri.isEqual(C.location,U.location))await this.s.updateMetadata([[U,{...C.metadata,...S}]],d);else{const G=await this.D(C.location,U.type,d);await this.s.removeExtensionFromProfile(G,d),await this.s.addExtensionsToProfile([[U,{...C.metadata,...S}]],d)}else await this.s.addExtensionsToProfile([[U,S]],d);return this.D(U.location,U.type,d)}async copyExtensions(U,F,d){const S=await this.scanExtensions(1,U,d),L=await Promise.all(S.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,U)]));await this.s.addExtensionsToProfile(L,F)}async y(U,F,d){this.u.trace(`Deleting ${d} extension from disk`,U,F.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,l.$hj)((0,c.$Pg)()).toString(16)}${V}`);await this.C(F.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,U,F.fsPath)}async z(U){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,T.$el)(S)!==1)throw S}let d={};if(F)try{d=JSON.parse(F)}catch{}return U&&(U(d),Object.keys(d).length?await this.m.writeFile(this.c,O.$De.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(U,F){try{await u.Promises.rename(U,F,2*60*1e3)}catch(d){throw new t.$4o(d.message||m.localize(5,null,U,F),d.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,F,d){if(d){const L=(await this.n.scanUserExtensions({profileLocation:d})).find(C=>this.t.extUri.isEqual(C.location,U));if(L)return this.F(L)}else{const S=await this.n.scanExistingExtension(U,F,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(m.localize(6,null,U.path))}async F(U){const F=await this.m.resolve(U.location);let d,S;return F.children&&(d=F.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,S=F.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:d,changelogUrl:S,publisherDisplayName:U.metadata?.publisherDisplayName,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned,isWorkspaceScoped:!1,source:U.metadata?.source??(U.identifier.uuid?"gallery":"vsix")}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const L of F)U[i.$sp.create(L).toString()]||d.add(L.identifier.id.toLowerCase());try{const L=(0,i.$xp)(F,C=>C.identifier);await j.Promises.settled(L.map(async C=>{const G=C.sort((H,te)=>p.rcompare(H.manifest.version,te.manifest.version))[0];d.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(L){this.u.error(L)}const S=F.filter(L=>L.metadata&&U[i.$sp.create(L).toString()]);await Promise.allSettled(S.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,T.$el)(F)!==1&&this.u.error(F);return}if(U?.children)try{await Promise.allSettled(U.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(d){(0,T.$el)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$Cq=B,e.$Cq=B=$e([oe(1,T.$Zk),oe(2,o.$qq),oe(3,s.$mq),oe(4,le.$xl),oe(5,re.$Zj)],B);class q extends r.$kq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,I.$ag)(this.options.operation)?this.l:this.options.operation}constructor(U,F,d,S,L,C,G,H,te,ae){super(),this.manifest=U,this.identifier=F,this.source=d,this.options=S,this.m=L,this.n=C,this.o=G,this.p=H,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[F,d]=await this.x(U);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,d]],this.j,!F.isValid),F}async u({zipPath:U,key:F,metadata:d},S,L){let C=await this.v(F);return C?C=await this.m.updateMetadata(C,d):(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,U,d,S,L),this.s.info("Extracting extension completed.",F.id)),C}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(S=>i.$sp.create(S).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class W extends q{constructor(U,F,d,S,L,C,G,H,te,ae,ue){super(U,F.identifier,F,d,L,C,G,H,te,ae),this.y=F,this.z=S,this.A=ue}async x(U){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(L){throw new t.$4o(L,t.ExtensionManagementErrorCode.Scanning)}const d=F.find(L=>(0,i.$rp)(L.identifier,this.y.identifier));d&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,I.$_f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||d?.preRelease,source:"gallery"};if(d&&d.type!==0&&d.manifest.version===this.y.version)try{return[await this.m.updateMetadata(d,S),S]}catch(L){throw new t.$4o((0,A.$0)(L),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(S,U)}catch(L){if(L instanceof t.$4o&&(L.code===t.ExtensionManagementErrorCode.CorruptZip||L.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const C=await this.C(S,U);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),C}catch(C){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),C}}else throw L}}async C(U,F){const{location:d,verificationStatus:S}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=S,this.D(d.fsPath),[await this.u({zipPath:d.fsPath,key:i.$sp.create(this.y),metadata:U},!1,F),U]}catch(L){try{await this.z.delete(d)}catch(C){this.s.warn("Error while deleting the downloaded file",d.toString(),(0,A.$0)(C))}throw L}}async D(U){try{await(0,D.$xq)(U)}catch(F){throw new t.$4o(F.message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Dq=W;class X extends q{constructor(U,F,d,S,L,C,G,H,te,ae){super(U,{id:(0,i.$wp)(U.publisher,U.name)},F,d,L,C,G,H,te,ae),this.y=F,this.z=S}async h(U){const F=await super.h(U);return this.C(F,U),F}async x(U){const F=new i.$sp(this.identifier,this.manifest.version),S=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$rp)(this.identifier,G.identifier)),L={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned,source:"vsix"};if(S)if(this.l=3,F.equals(new i.$sp(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(S.manifest.version,this.manifest.version)&&await this.m.setUninstalled(S);else{const G=await this.v(F);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(m.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:y.$lc(this.y.fsPath),key:F,metadata:L},!0,U),L]}async C(U,F){try{let[d]=await this.z.getExtensions([{id:U.identifier.id,version:U.manifest.version}],F);if(d||([d]=await this.z.getExtensions([{id:U.identifier.id}],F)),d){const S={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,S,this.options.profileLocation)}}catch{}}}class Y extends r.$kq{constructor(U,F,d){super(),this.extension=U,this.j=F,this.k=d}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],se([0,1,6,24,23,22,42,13,18,11]),function(Z,e,j,O,k,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0;let f=class extends A.$nq{constructor(y,w,p,I,g,c){super(a.URI.file(y.extensionsPath),w,p,I,g,c)}};e.$EQ=f,e.$EQ=f=$e([oe(0,l.$Bi),oe(1,E.$Zk),oe(2,O.$zl),oe(3,k.$xl),oe(4,N.$Yl),oe(5,j.$Zj)],f)}),define(ne[164],se([0,1,11,18,42,53,13,10,6,32,23,24]),function(Z,e,j,O,k,N,A,E,l,a,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;let y=class extends N.$uq{constructor(p,I,g,c,u,v,m,$){super(j.URI.file(u.builtinExtensionsPath),j.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,I,g,c,u,v,m,$)}};e.$Occ=y,e.$Occ=y=$e([oe(0,b.$zl),oe(1,k.$mq),oe(2,A.$Zk),oe(3,l.$Zj),oe(4,O.$Bi),oe(5,a.$gk),oe(6,f.$xl),oe(7,E.$si)],y)}),define(ne[165],se([0,1,8,5,2,130,3,90,10,24]),function(Z,e,j,O,k,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Zp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Yp=w,e.$1p=I,e.$3p=c,e.$Vp="__$__isNewStorageMarker",e.$Wp="__$__targetStorageMarker",e.$Xp=(0,l.$ti)("storageService");var f;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var b;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function w(u){const v=u.get(e.$Wp);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class p extends k.$Vc{static{this.a=60*1e3}constructor(v={flushInterval:p.a}){super(),this.m=v,this.b=this.B(new O.$fe),this.c=this.B(new O.$fe),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$ce),this.onWillSaveState=this.f.event,this.h=this.B(new j.$Fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,m,$){return O.Event.filter(this.b.event,n=>n.scope===v&&(m===void 0||n.key===m),$)}n(){this.j.value=(0,j.$Jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,m){const{key:$,external:n}=m;if($===e.$Wp){switch(v){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:$,target:this.J(v)[$],external:n})}w(v){this.f.fire({reason:v})}get(v,m,$){return this.P(m)?.get(v,$)}getBoolean(v,m,$){return this.P(m)?.getBoolean(v,$)}getNumber(v,m,$){return this.P(m)?.getNumber(v,$)}getObject(v,m,$){return this.P(m)?.getObject(v,$)}storeAll(v,m){this.y(()=>{for(const $ of v)this.store($.key,$.value,$.scope,$.target,m)})}store(v,m,$,n,r=!1){if((0,A.$cg)(m)){this.remove(v,$,r);return}this.y(()=>{this.z(v,$,n),this.P($)?.set(v,m,r)})}remove(v,m,$=!1){this.y(()=>{this.z(v,m,void 0),this.P(m)?.delete(v,$)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,m){const $=[],n=this.J(v);for(const r of Object.keys(n))n[r]===m&&$.push(r);return $}z(v,m,$,n=!1){const r=this.J(m);typeof $=="number"?r[v]!==$&&(r[v]=$,this.P(m)?.set(e.$Wp,JSON.stringify(r),n)):typeof r[v]=="number"&&(delete r[v],this.P(m)?.set(e.$Wp,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(v){switch(v){case-1:return this.I;case 0:return this.G;default:return this.D}}L(v){const m=this.P(v);return m?w(m):Object.create(null)}isNew(v){return this.getBoolean(e.$Vp,v)===!0}async flush(v=f.NONE){this.f.fire({reason:v});const m=this.P(-1),$=this.P(0),n=this.P(1);switch(v){case f.NONE:await j.Promises.settled([m?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await j.Promises.settled([m?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return c(v,m,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,m){return this.w(f.NONE),(0,a.$yl)(v)?this.R(v,m):this.S(v,m)}M(v,m){return!(v.id===m.id||I(m)&&I(v))}N(v,m,$){this.y(()=>{const n=new Set;for(const[r,t]of v)n.add(r),m.get(r)!==t&&this.u($,{key:r,external:!0});for(const[r]of m.items)n.has(r)||this.u($,{key:r,external:!0})})}}e.$Zp=p;function I(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends p{constructor(){super(),this.U=this.B(new E.$Tp(new E.$Up,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Tp(new E.$Up,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Tp(new E.$Up,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(1,v))),this.B(this.W.onDidChangeStorage(v=>this.u(0,v))),this.B(this.U.onDidChangeStorage(v=>this.u(-1,v)))}P(v){switch(v){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$2p=g;async function c(u,v,m,$,n,r){const t=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,s=new Map;u.forEach((M,T)=>{i.set(T,M),s.set(T,t(M))});const o=new Map,h=new Map;v.forEach((M,T)=>{o.set(T,M),h.set(T,t(M))});const P=new Map,D=new Map;m.forEach((M,T)=>{P.set(T,M),D.set(T,t(M))}),console.group($!==n?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const R=[];if(i.forEach((M,T)=>{R.push({key:T,value:M})}),console.table(R),console.groupEnd(),console.log(s),$!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const M=[];o.forEach((T,Q)=>{M.push({key:Q,value:T})}),console.table(M),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${r})`);const z=[];P.forEach((M,T)=>{z.push({key:T,value:M})}),console.table(z),console.groupEnd(),console.log(D)}}),define(ne[166],se([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$6p=X;const n=N.$o?"web":(0,b.$Yo)(N.$u,A.$fc),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...S){return String(S.reduce((L,C)=>L|C,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class R{constructor(L=D){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,C=this.d.pageSize){return new R({...this.d,pageNumber:L,pageSize:C})}withFilter(L,...C){const G=[...this.d.criteria,...C.length?C.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new R({...this.d,criteria:G})}withSortBy(L){return new R({...this.d,sortBy:L})}withSortOrder(L){return new R({...this.d,sortOrder:L})}withFlags(...L){return new R({...this.d,flags:L.reduce((C,G)=>C|G,0)})}withAssetTypes(...L){return new R({...this.d,assetTypes:L})}withSource(L){return new R({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:te,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:te}],assetTypes:ue,flags:ae}}get searchText(){const L=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(S,L){const C=(S||[]).filter(G=>G.statisticName===L)[0];return C?C.value:0}function M(S){const L="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(G=>G.assetType.indexOf(L)===0).reduce((G,H)=>{const te=re(S,H.assetType);return te&&G.push([H.assetType.substring(L.length),te]),G},[])}function T(S){if(S.properties){const L=S.properties.filter(H=>H.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=L.filter(H=>C.test(H.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return re(S,o.Repository)}function Q(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function re(S,L){return S.files.filter(G=>G.assetType===L)[0]?{uri:`${S.assetUri}/${L}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${L}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function ie(S,L){const C=S.properties?S.properties.filter(H=>H.key===L):[],G=C.length>0&&C[0].value;return G?G.split(",").map(H=>(0,y.$vp)(H)):[]}function he(S){const L=S.properties?S.properties.filter(C=>C.key===h.Engine):[];return L.length>0&&L[0].value||""}function le(S){const L=S.properties?S.properties.filter(C=>C.key===h.PreRelease):[];return L.length>0&&L[0].value==="true"}function ce(S){const L=S.properties?S.properties.filter(G=>G.key===h.LocalizedLanguages):[],C=L.length>0&&L[0].value||"";return C?C.split(","):[]}function V(S){return S.properties?.find(L=>L.key===h.SponsorLink)?.value}function J(S){return S.properties?.find(L=>L.key===h.SupportLink)?.value}function B(S){return S.indexOf("preview")!==-1}function q(S){return S.targetPlatform?(0,b.$Xo)(S.targetPlatform):"undefined"}function W(S){const L=(0,j.$Mb)(S.versions.map(q)),C=!!S.tags?.includes(b.$So),G=L.indexOf("web");return C?G===-1&&L.push("web"):G!==-1&&L.splice(G,1),L}function X(S,L){for(let C=0;C<S.length;C++){const G=S[C];if(G.version===S[C-1]?.version){let H=C;if(q(G)===L)for(;H>0&&S[H-1].version===G.version;)H--;H!==C&&(S.splice(C,1),S.splice(H,0,G))}}return S}function Y(S,L,C){S.telemetryData={index:L,querySource:C,queryActivityId:S.queryContext?.[r]}}function _(S,L,C,G){const H=S.versions[0],te={manifest:re(L,o.Manifest),readme:re(L,o.Details),changelog:re(L,o.Changelog),license:re(L,o.License),repository:T(L),download:Q(L),icon:re(L,o.Icon),signature:re(L,o.Signature),coreTranslations:M(L)};return{identifier:{id:(0,y.$wp)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:L.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(H),description:S.shortDescription??"",installCount:z(S.statistics,"install"),rating:z(S.statistics,"averagerating"),ratingCount:z(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:C,assets:te,properties:{dependencies:ie(L,h.Dependency),extensionPack:ie(L,h.ExtensionPack),engine:he(L),localizedLanguages:ce(L),targetPlatform:q(L),isPreReleaseVersion:le(L)},hasPreReleaseVersion:le(H),hasReleaseVersion:!0,preview:B(S.flags),isSigned:!!te.signature,queryContext:G,supportLink:J(H)}}let U=class{constructor(L,C,G,H,te,ae,ue,pe){this.k=C,this.l=G,this.n=H,this.o=te,this.q=ae,this.u=ue,this.w=pe;const ye=ue.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,u.$5p)(ue.version,ue,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,C,G){const H=O.CancellationToken.isCancellationToken(C)?{}:C,te=O.CancellationToken.isCancellationToken(C)?C:G,ae=[],ue=[],pe=[],ye=[];let fe=!0;for(const we of L){we.uuid?ue.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!ue.length&&!ae.length)return[];let me=new R().withPage(1,L.length);ue.length&&(me=me.withFilter(s.ExtensionId,...ue)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(H.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),H.source&&(me=me.withSource(H.source));const{extensions:de}=await this.z(me,{targetPlatform:H.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!H.compatible,productVersion:H.productVersion??{version:this.u.version,date:this.u.date}},te);return H.source&&de.forEach((we,Ee)=>Y(we,Ee,H.source)),de}async getCompatibleExtension(L,C,G,H={version:this.u.version,date:this.u.date}){if((0,b.$Zo)(L.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(L,C,G))return L;const te=new R().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,L.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:C,productVersion:H},O.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(L,C,G,H={version:this.u.version,date:this.u.date}){if(!(0,b.$1o)(L.properties.targetPlatform,L.allTargetPlatforms,G)||!C&&L.properties.isPreReleaseVersion)return!1;let te=L.properties.engine;if(!te){const ae=await this.getManifest(L,O.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,w.$Jp)(te,H.version,H.date)}async y(L,C,G,H,te,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,b.$1o)(q(C),te,ae)||G!=="any"&&le(C)!==(G==="prerelease"))return!1;if(H)try{const pe=await this.E(L,C);if(!(0,w.$Jp)(pe,ue.version,ue.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,k.$0)(pe)),!1}return!0}async query(L,C){let G=L.text||"";const H=L.pageSize??50;let te=new R().withPage(1,H);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):L.ids?te=te.withFilter(s.ExtensionId,...L.ids):L.names?te=te.withFilter(s.ExtensionName,...L.names):te=te.withSortBy(4),typeof L.sortBy=="number"&&(te=te.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(te=te.withSortOrder(L.sortOrder)),L.source&&(te=te.withSource(L.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+ke,L.source)),{extensions:de,total:we}},{extensions:ue,total:pe}=await ae(te,C),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:ue,total:pe,pageSize:te.pageSize,getPage:ye}}async z(L,C,G){const H=L.flags;L.flags&t.IncludeLatestVersionOnly&&L.flags&t.IncludeVersions&&(L=L.withFlags(L.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(L.flags&t.IncludeLatestVersionOnly)&&!(L.flags&t.IncludeVersions)&&(L=L.withFlags(L.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(L=L.withFlags(L.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),L=L.withFlags(L.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:ue}=await this.B(L,G);if(!(L.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,C,ue);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,y.$wp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$_f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(x=>(0,y.$rp)(x,we))?.includePreRelease;if(C.compatible&&(0,b.$Zo)(W(de),C.targetPlatform))continue;const ke=await this.A(de,C,ue);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==C.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new $.$$d,de=new R().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,C,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(L,C,G){const H={id:(0,y.$wp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},te=C.versions?.find(ye=>(0,y.$rp)(ye,H))?.version,ae=(0,E.$_f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,y.$rp)(ye,H))?.includePreRelease,ue=W(L),pe=X(L.versions,C.targetPlatform);if(C.compatible&&(0,b.$Zo)(ue,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,y.$wp)(L.publisher.publisherName,L.extensionName),fe,ae?"any":"release",C.compatible,ue,C.targetPlatform,C.productVersion))return _(L,fe,ue,G);if(te&&fe.version===te)return null}}return te||C.compatible?null:_(L,L.versions[0],ue)}async B(L,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const G=await this.j,H=JSON.stringify(L.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new $.$$d;let ue,pe,ye=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&L.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:te},C),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Qp)(ue);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?b.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw pe=new b.$5o((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:ae.elapsed(),success:!!ue&&(0,c.$Mp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(L,C,G,H){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${L}.${C}/version/${G}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${C}/${G}/stats?statType=${H}`),ae=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},O.CancellationToken.None)}catch{}}async download(L,C,G){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,y.$zp)(L),te=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:me}),ue=G===2?"install":G===3?"update":"",pe=ue?{uri:`${L.assets.download.uri}${l.URI.parse(L.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${L.assets.download.fallbackUri}${l.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:L.assets.download,ye=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,fe=await this.D(L.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(C,fe.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(L,C){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const G=await this.D(L.identifier.id,L.assets.signature,o.Signature);await this.q.writeFile(C,G.stream)}async getReadme(L,C){if(L.assets.readme){const G=await this.D(L.identifier.id,L.assets.readme,o.Details,{},C);return await(0,c.$Pp)(G)||""}return""}async getManifest(L,C){if(L.assets.manifest){const G=await this.D(L.identifier.id,L.assets.manifest,o.Manifest,{},C),H=await(0,c.$Pp)(G);return H?JSON.parse(H):null}return null}async C(L,C,G){const H=re(C,o.Manifest);if(!H)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(L,H,o.Manifest,{headers:te});return await(0,c.$Qp)(ae)}async getCoreTranslation(L,C){const G=L.assets.coreTranslations.filter(H=>H[0]===C.toUpperCase())[0];if(G){const H=await this.D(L.identifier.id,G[1],G[0]),te=await(0,c.$Pp)(H);return te?JSON.parse(te):null}return null}async getChangelog(L,C){if(L.assets.changelog){const G=await this.D(L.identifier.id,L.assets.changelog,o.Changelog,{},C);return await(0,c.$Pp)(G)||""}return""}async getAllCompatibleVersions(L,C,G){let H=new R().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(s.ExtensionId,L.identifier.uuid):H=H.withFilter(s.ExtensionName,L.identifier.id);const{galleryExtensions:te}=await this.B(H,O.CancellationToken.None);if(!te.length)return[];const ae=W(te[0]);if((0,b.$Zo)(ae,G))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(L.identifier.id,fe,C?"any":"release",!0,ae,G)&&ue.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of X(ue,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(L,C,G,H={},te=O.CancellationToken.None){const ae=await this.j,ue={type:"GET"},pe={...ae,...H.headers||{}};H={...H,...ue,headers:pe};const ye=C.uri,fe=C.fallbackUri,me={...H,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Pp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:G,message:we});const Ee={...H,url:fe};return this.k.request(Ee,te)}}async E(L,C){let G=he(C);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:C.version});const H=await this.C(L,C,O.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Qp)(L),G=[],H={},te=[];if(C){for(const ae of C.malicious)G.push({id:ae});if(C.migrateToPreRelease)for(const[ae,ue]of Object.entries(C.migrateToPreRelease))(!ue.engine||(0,w.$Jp)(ue.engine,this.u.version,this.u.date))&&(H[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ae,ue]of Object.entries(C.deprecated))ue&&(H[ae.toLowerCase()]=(0,E.$_f)(ue)?{}:ue);if(C.search)for(const ae of C.search)te.push(ae)}return{malicious:G,deprecated:H,search:te}}};U=$e([oe(1,c.$Kp),oe(2,I.$Zj),oe(3,f.$Ai),oe(4,m.$Yl),oe(5,p.$Zk),oe(6,g.$gk),oe(7,a.$Zi)],U);let F=class extends U{constructor(L,C,G,H,te,ae,ue,pe){super(L,C,G,H,te,ae,ue,pe)}};e.$7p=F,e.$7p=F=$e([oe(0,v.$Xp),oe(1,c.$Kp),oe(2,I.$Zj),oe(3,f.$Ai),oe(4,m.$Yl),oe(5,p.$Zk),oe(6,g.$gk),oe(7,a.$Zi)],F);let d=class extends U{constructor(L,C,G,H,te,ae,ue){super(void 0,L,C,G,H,te,ae,ue)}};e.$8p=d,e.$8p=d=$e([oe(0,c.$Kp),oe(1,I.$Zj),oe(2,f.$Ai),oe(3,m.$Yl),oe(4,p.$Zk),oe(5,g.$gk),oe(6,a.$Zi)],d)}),define(ne[167],se([0,1,11,18,13,6,145,23,24,3,69]),function(Z,e,j,O,k,N,A,E,l,a,f){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=e.$BQ=void 0;let w=class extends l.$Cl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(c,u,v,m,$){super(v,m,u,$),this.U=c,this.W=v}O(){return this.U.getItem(b.b,[]).map(u=>({...u,location:(0,a.$6f)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):j.URI.revive(u.location)}))}Q(){const c=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(j.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$BQ=w,e.$BQ=w=b=$e([oe(0,A.$wQ),oe(1,E.$xl),oe(2,O.$Bi),oe(3,k.$Zk),oe(4,N.$Zj)],w);let p=y=class extends w{constructor(c,u,v,m,$){super(c,u,v,m,$),this.$=c}P(c){c.length?this.$.setItem(y.b,c.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(y.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(y.c,c):this.$.removeItem(y.c)}Q(){const c="workspaceAndProfileInfo",u=this.$.getItem(c,void 0);if(u){this.$.removeItem(c);const m=u.reduce(($,{workspace:n,profile:r})=>($[j.URI.revive(n).toString()]=j.URI.revive(r).toString(),$),{});this.$.setItem(y.c,{workspaces:m})}const v=super.Q();return this.$.getItem(y.a,!1)||(this.R(v),this.$.setItem(y.a,!0)),v}};e.$CQ=p,e.$CQ=p=y=$e([oe(0,A.$xQ),oe(1,E.$xl),oe(2,O.$Bi),oe(3,k.$Zk),oe(4,N.$Zj)],p);let I=class extends p{constructor(c,u,v,m){super(new f.$AQ(0,u,m,v),c,u,v,m)}async init(){return await this.$.init(),super.init()}};e.$DQ=I,e.$DQ=I=$e([oe(0,E.$xl),oe(1,O.$Bi),oe(2,k.$Zk),oe(3,N.$Zj)],I)}),define(ne[168],se([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0,e.$Vr=g;let p=class extends b.$Lp{constructor(u,v,m,$){super($),this.m=u,this.n=v,this.r=m,this.s(),this.B(u.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,v){const{f:m,g:$}=this;let n;try{n=await(0,a.$Dm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const r={...process.env,...n},t=u.agent?u.agent:await(0,y.$Tr)(u.url||"",r,{proxyUrl:m,strictSSL:$});return u.agent=t,u.strictSSL=$,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>g(u,v))}async resolveProxy(u){}async loadCertificates(){return(await new Promise((v,m)=>{Z(["@vscode/proxy-agent"],v,m)})).loadSystemCertificates({log:this.r})}};e.$Ur=p,e.$Ur=p=$e([oe(0,E.$Zi),oe(1,l.$Bi),oe(2,f.$Zj),oe(3,f.$1j)],p);async function I(c){return((0,j.parse)(c.url).protocol==="https:"?await new Promise((m,$)=>{Z(["https"],m,$)}):await new Promise((m,$)=>{Z(["http"],m,$)})).request}async function g(c,u){return O.Promises.withAsyncBody(async(v,m)=>{const $=(0,j.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await I(c),r={hostname:$.hostname,port:$.port?parseInt($.port):$.protocol==="https:"?443:80,protocol:$.protocol,path:$.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$_f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=n(r,i=>{const s=(0,A.$0f)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)g({...c,url:i.headers.location,followRedirects:s-1},u).then(v,m);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),v({res:i,stream:(0,k.$Se)(o)})}});t.on("error",m),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),u.onCancellationRequested(()=>{t.abort(),m(new N.$5)})})}}),define(ne[180],se([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,116,166,21,71,146,42,53,162,164,13,129,131,51,127,64,65,150,6,135,39,136,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(Z,e,j,O,k,N,A,E,l,a,f,b,y,w,p,I,g,c,u,v,m,$,n,r,t,i,s,o,h,P,D,R,z,M,T,Q,re,ie,he,le,ce,V,J,B,q,W,X,Y,_,U,F,d,S,L,C,G,H,te,ae,ue,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends A.$Vc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(Q.$Zj),x=Ee.get(o.$Zk),K=Ee.get(c.$Bi),ee=Ee.get(S.$zl);ke.info("CLI main",this.b),this.h(ke),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,O.$kh)(ge.flush(),1e3)}))})}async f(){const de=new z.$ri,we={_serviceBrand:void 0,...le.default};de.set(ce.$gk,we);const Ee=new u.$6m(this.b,we);de.set(c.$Bi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?y.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new te.$vQ((0,Q.$bk)(Ee),Ee.logsHome);de.set(Q.$1j,ke);const x=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];ke.getLogLevel()===Q.LogLevel.Trace&&K.push(new Q.$8j(ke.getLogLevel()));const ee=this.B(new H.$FQ(x,K));de.set(Q.$Zj,ee);const ge=this.B(new h.$Fq(ee));de.set(o.$Zk,ge);const ve=this.B(new P.$9q(ee));ge.registerProvider(E.Schemas.file,ve);const je=new d.$ws(ge);de.set(F.$xl,je);const Pe=new B.$zQ(1,Ee,ee,ge),Le=new L.$BQ(Pe,je,Ee,ge,ee);de.set(S.$zl,Le),ge.registerProvider(E.Schemas.vscodeUserData,new ue.$ddc(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,je,ee));const De=a.$i&&we.win32RegValueName?this.B(new he.$bdc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new re.$cdc(Ee.policyFile,ge,ee)):new ie.$do;de.set(ie.$bo,De);const Ae=this.B(new p.$Do(Le.defaultProfile.settingsResource,ge,De,ee));de.set(w.$Zi,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Me;try{Me=await(0,C.$Rcc)(Pe,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const Re=await(0,C.$Scc)(Pe,ee);Le.init(),de.set(F.$xl,new d.$ws(ge));const Ne=new J.$Ur(Ae,Ee,ee,ke);de.set(V.$Kp,Ne),de.set(I.$Ho,new D.$qi(g.$UQ,void 0,!0)),de.set(r.$mq,new D.$qi(G.$EQ,void 0,!0)),de.set(t.$qq,new D.$qi(s.$Occ,void 0,!0)),de.set($.$9p,new D.$qi($.$$p,void 0,!0)),de.set(i.$Aq,new D.$qi(i.$Bq,void 0,!0)),de.set(m.$3o,new D.$qi(v.$8p,void 0,!0)),de.set(M.$Or,new D.$qi(T.$Qr,void 0,!1));const ze=[],Fe=(0,Y.$op)(we,Ae);if((0,Y.$jp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$tQ(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,q.$ap)((0,j.release)(),(0,j.hostname)(),process.arch,we.commit,we.version,Me,Re,Fe),piiPaths:(0,Y.$pp)(Ee)};de.set(W.$Yl,new D.$qi(X.$Wr,[be],!1))}else de.set(W.$Yl,Y.$ep);return[new R.$_q(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,N.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$ej)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async j(de,we,Ee,ke){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(n.$_p,new Q.$8j(Q.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return ke.createInstance(n.$_p,new Q.$8j(Q.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(n.$_p,new Q.$8j(Q.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return ke.createInstance(n.$_p,new Q.$8j(Q.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return ke.createInstance(n.$_p,new Q.$8j(Q.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$Bdc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,l.$jc)(we)?we:(0,l.$kc)((0,f.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/59d84c5c8cecf22b24e316c5443dc3ec49462589/core/vs/code/node/cliProcessMain.js.map
