/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],A=0,N=ne.length;A<N;A++)e[A]=ae[ne[A]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const L=new Map,j=new Map,O=new Map,I=new Map;function P(h,c){h.has(c.detail)||h.set(c.detail,-c.timestamp)}function f(h,c){const p=h.get(c.detail);p&&(p>=0||h.set(c.detail,p+c.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((h,c)=>h.timestamp-c.timestamp));for(const h of E)switch(h.type){case 10:P(L,h);break;case 11:case 12:f(L,h);break;case 21:P(j,h);break;case 22:f(j,h);break;case 33:P(O,h);break;case 34:f(O,h);break;case 31:P(I,h);break;case 32:f(I,h);break}let y=0;O.forEach(h=>y+=h);function w(h){const c=[];return h.forEach((p,g)=>c.push([g,p])),c}return{amdLoad:w(L),amdInvoke:w(j),nodeRequire:w(O),nodeEval:w(I),nodeRequireTotal:y}}static toMarkdownTable(L,j){let O="";const I=[];return L.forEach((P,f)=>{I[f]=P.length}),j.forEach(P=>{P.forEach((f,E)=>{typeof f>"u"&&(f=P[E]="-");const y=f.toString().length;I[E]=Math.max(y,I[E])})}),L.forEach((P,f)=>{O+=`| ${P+" ".repeat(I[f]-P.toString().length)} `}),O+=`|
`,L.forEach((P,f)=>{O+=`| ${"-".repeat(I[f])} `}),O+=`|
`,j.forEach(P=>{P.forEach((f,E)=>{typeof f<"u"&&(O+=`| ${f+" ".repeat(I[E]-f.toString().length)} `)}),O+=`|
`}),O}}e.$U=A}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=A,e.$gb=N,e.$hb=L,e.$ib=j,e.$jb=O,e.$kb=I,e.$lb=P,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=h,e.$rb=c;function A(p,g){const l=N(p,g);if(l!==-1)return p[l]}function N(p,g,l=p.length-1){for(let u=l;u>=0;u--){const m=p[u];if(g(m))return u}return-1}function L(p,g){const l=j(p,g);return l===-1?void 0:p[l]}function j(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?m=$+1:d=$}return m-1}function O(p,g){const l=I(p,g);return l===p.length?void 0:p[l]}function I(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?d=$:m=$+1}return m}function P(p,g,l=0,u=p.length){const m=I(p,g,l,u);return m===p.length?-1:m}class f{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(f.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!g(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const l=j(this.e,g,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=f;function E(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>0&&(l=m)}return l}function y(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>=0&&(l=m)}return l}function w(p,g){return E(p,(l,u)=>-g(l,u))}function h(p,g){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const m=p[u];g(m,p[l])>0&&(l=u)}return l}function c(p,g){for(const l of p){const u=g(l);if(u!==void 0)return u}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=A,e.$L=N,e.$M=L,e.$N=j;function A(O,I){const P=Object.create(null);for(const f of O){const E=I(f);let y=P[E];y||(y=P[E]=[]),y.push(f)}return P}function N(O,I){const P=[],f=[];for(const E of O)I.has(E)||P.push(E);for(const E of I)O.has(E)||f.push(E);return{removed:P,added:f}}function L(O,I){const P=[],f=[];for(const[E,y]of O)I.has(E)||P.push(y);for(const[E,y]of I)O.has(E)||f.push(y);return{removed:P,added:f}}function j(O,I){const P=new Set;for(const f of I)O.has(f)&&P.add(f);return P}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=N,e.$Yh=L,e.$Zh=j;function A(O){return(I,P,f)=>{let E=null,y=null;if(typeof f.value=="function"?(E="value",y=f.value):typeof f.get=="function"&&(E="get",y=f.get),!y)throw new Error("not supported");f[E]=O(y,P)}}function N(O,I,P){let f=null,E=null;if(typeof P.value=="function"?(f="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(f="get",E=P.get),!E)throw new Error("not supported");const y=`$memoize$${I}`;P[f]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function L(O,I,P){return A((f,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...h){this[w]||(this[w]=P?P():void 0),clearTimeout(this[y]),I&&(this[w]=I(this[w],...h),h=[this[w]]),this[y]=setTimeout(()=>{f.apply(this,h),this[w]=P?P():void 0},O)}})}function j(O,I,P){return A((f,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,h=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...p){if(this[w]||(this[w]=P?P():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...p)),this[c])return;const g=this[h]+O;g<=Date.now()?(this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=P?P():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=P?P():void 0},g-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=j,e.$2=O,e.$3=I,e.$4=f,e.$6=y,e.$7=w,e.$8=h,e.$0=p;class A{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=A,e.$X=new A;function N($){e.$X.setUnexpectedErrorHandler($)}function L($){if(!$||typeof $!="object")return!1;const t=$;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function j($){f($)||e.$X.onUnexpectedError($)}function O($){f($)||e.$X.onUnexpectedExternalError($)}function I($){if($ instanceof Error){const{name:t,message:r}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:m.isErrorNoTelemetry($)}}return $}const P="Canceled";function f($){return $ instanceof E?!0:$ instanceof Error&&$.name===P&&$.message===P}class E extends Error{constructor(){super(P),this.name=this.message}}e.$5=E;function y(){const $=new Error(P);return $.name=$.message,$}function w($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function p($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class l extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(ae[17],ce([0,1,7,125]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=j,e.$ub=O,e.$vb=I,e.$wb=P,e.$xb=f,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=h,e.$Cb=c,e.$Db=p,e.$Eb=g,e.top=l,e.$Gb=u,e.$Hb=d,e.$Ib=$,e.$Jb=t,e.$Kb=r,e.$Lb=n,e.$Mb=s,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=b,e.$Rb=S,e.$Sb=v,e.$Tb=k,e.$Ub=C,e.$Vb=R,e.$Wb=M,e.$Xb=T,e.$Yb=q,e.$Zb=Y,e.$1b=G,e.$2b=X,e.$3b=W,e.$4b=J,e.$5b=H,e.$6b=B,e.$7b=he,e.$8b=te,e.$$b=D;function L(K,ee=0){return K[K.length-(1+ee)]}function j(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function O(K,ee,_=(Q,se)=>Q===se){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let Q=0,se=K.length;Q<se;Q++)if(!_(K[Q],ee[Q]))return!1;return!0}function I(K,ee){const _=K.length-1;ee<_&&(K[ee]=K[_]),K.pop()}function P(K,ee,_){return f(K.length,Q=>_(K[Q],ee))}function f(K,ee){let _=0,Q=K-1;for(;_<=Q;){const se=(_+Q)/2|0,ue=ee(se);if(ue<0)_=se+1;else if(ue>0)Q=se-1;else return se}return-(_+1)}function E(K,ee,_){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const Q=ee[Math.floor(ee.length*Math.random())],se=[],ue=[],ge=[];for(const fe of ee){const $e=_(fe,Q);$e<0?se.push(fe):$e>0?ue.push(fe):ge.push(fe)}return K<se.length?E(K,se,_):K<se.length+ge.length?ge[0]:E(K-(se.length+ge.length),ue,_)}function y(K,ee){const _=[];let Q;for(const se of K.slice(0).sort(ee))!Q||ee(Q[0],se)!==0?(Q=[se],_.push(Q)):Q.push(se);return _}function*w(K,ee){let _,Q;for(const se of K)Q!==void 0&&ee(Q,se)?_.push(se):(_&&(yield _),_=[se]),Q=se;_&&(yield _)}function h(K,ee){for(let _=0;_<=K.length;_++)ee(_===0?void 0:K[_-1],_===K.length?void 0:K[_])}function c(K,ee){for(let _=0;_<K.length;_++)ee(_===0?void 0:K[_-1],K[_],_+1===K.length?void 0:K[_+1])}function p(K,ee,_){const Q=[];function se(fe,$e,ye){if($e===0&&ye.length===0)return;const ve=Q[Q.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=$e,ve.toInsert.push(...ye)):Q.push({start:fe,deleteCount:$e,toInsert:ye})}let ue=0,ge=0;for(;;){if(ue===K.length){se(ue,0,ee.slice(ge));break}if(ge===ee.length){se(ue,K.length-ue,[]);break}const fe=K[ue],$e=ee[ge],ye=_(fe,$e);ye===0?(ue+=1,ge+=1):ye<0?(se(ue,1,[]),ue+=1):ye>0&&(se(ue,0,[$e]),ge+=1)}return Q}function g(K,ee,_){const Q=p(K,ee,_),se=[],ue=[];for(const ge of Q)se.push(...K.slice(ge.start,ge.start+ge.deleteCount)),ue.push(...ge.toInsert);return{removed:se,added:ue}}function l(K,ee,_){if(_===0)return[];const Q=K.slice(0,_).sort(ee);return m(K,ee,Q,_,K.length),Q}function u(K,ee,_,Q,se){return _===0?Promise.resolve([]):new Promise((ue,ge)=>{(async()=>{const fe=K.length,$e=K.slice(0,_).sort(ee);for(let ye=_,ve=Math.min(_+Q,fe);ye<fe;ye=ve,ve=Math.min(ve+Q,fe)){if(ye>_&&await new Promise(Pe=>setTimeout(Pe)),se&&se.isCancellationRequested)throw new A.$5;m(K,ee,$e,ye,ve)}return $e})().then(ue,ge)})}function m(K,ee,_,Q,se){for(const ue=_.length;Q<se;Q++){const ge=K[Q];if(ee(ge,_[ue-1])<0){_.pop();const fe=(0,N.$kb)(_,$e=>ee(ge,$e)<0);_.splice(fe,0,ge)}}}function d(K){return K.filter(ee=>!!ee)}function $(K){let ee=0;for(let _=0;_<K.length;_++)K[_]&&(K[ee]=K[_],ee+=1);K.length=ee}function t(K,ee,_){K.splice(_,0,K.splice(ee,1)[0])}function r(K){return!Array.isArray(K)||K.length===0}function n(K){return Array.isArray(K)&&K.length>0}function s(K,ee=_=>_){const _=new Set;return K.filter(Q=>{const se=ee(Q);return _.has(se)?!1:(_.add(se),!0)})}function i(K){const ee=new Set;return _=>{const Q=K(_);return ee.has(Q)?!1:(ee.add(Q),!0)}}function o(K,ee){return K.length>0?K[0]:ee}function a(K,ee){return K.length>0?K[K.length-1]:ee}function b(K,ee,_=(Q,se)=>Q===se){let Q=0;for(let se=0,ue=Math.min(K.length,ee.length);se<ue&&_(K[se],ee[se]);se++)Q++;return Q}function S(K){return[].concat(...K)}function v(K,ee){let _=typeof ee=="number"?K:0;typeof ee=="number"?_=K:(_=0,ee=K);const Q=[];if(_<=ee)for(let se=_;se<ee;se++)Q.push(se);else for(let se=_;se>ee;se--)Q.push(se);return Q}function k(K,ee,_){return K.reduce((Q,se)=>(Q[ee(se)]=_?_(se):se,Q),Object.create(null))}function C(K,ee){return K.push(ee),()=>R(K,ee)}function R(K,ee){const _=K.indexOf(ee);if(_>-1)return K.splice(_,1),ee}function M(K,ee,_){const Q=K.slice(0,ee),se=K.slice(ee);return Q.concat(_,se)}function T(K,ee){let _;if(typeof ee=="number"){let Q=ee;_=()=>{const se=Math.sin(Q++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let Q=K.length-1;Q>0;Q-=1){const se=Math.floor(_()*(Q+1)),ue=K[Q];K[Q]=K[se],K[se]=ue}}function q(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.unshift(ee))}function Y(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.push(ee))}function G(K,ee){for(const _ of ee)K.push(_)}function X(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}function W(K){return Array.isArray(K)?K:[K]}function J(K){return K[Math.floor(Math.random()*K.length)]}function H(K,ee,_){const Q=ie(K,ee),se=K.length,ue=_.length;K.length=se+ue;for(let ge=se-1;ge>=Q;ge--)K[ge+ue]=K[ge];for(let ge=0;ge<ue;ge++)K[ge+Q]=_[ge]}function B(K,ee,_,Q){const se=ie(K,ee);let ue=K.splice(se,_);return ue===void 0&&(ue=[]),H(K,se,Q),ue}function ie(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var re;(function(K){function ee(ue){return ue<0}K.isLessThan=ee;function _(ue){return ue<=0}K.isLessThanOrEqual=_;function Q(ue){return ue>0}K.isGreaterThan=Q;function se(ue){return ue===0}K.isNeitherLessOrGreaterThan=se,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function he(K,ee){return(_,Q)=>ee(K(_),K(Q))}function te(...K){return(ee,_)=>{for(const Q of K){const se=Q(ee,_);if(!re.isNeitherLessOrGreaterThan(se))return se}return re.neitherLessOrGreaterThan}}const V=(K,ee)=>K-ee;e.$9b=V;const U=(K,ee)=>(0,e.$9b)(K?1:0,ee?1:0);e.$0b=U;function D(K){return(ee,_)=>-K(ee,_)}class F{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Q=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Q}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Q=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=F;class z{static{this.empty=new z(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new z(_=>this.iterate(Q=>ee(Q)?_(Q):!0))}map(ee){return new z(_=>this.iterate(Q=>_(ee(Q))))}some(ee){let _=!1;return this.iterate(Q=>(_=ee(Q),!_)),_}findFirst(ee){let _;return this.iterate(Q=>ee(Q)?(_=Q,!1):!0),_}findLast(ee){let _;return this.iterate(Q=>(ee(Q)&&(_=Q),!0)),_}findLastMaxBy(ee){let _,Q=!0;return this.iterate(se=>((Q||re.isGreaterThan(ee(se,_)))&&(Q=!1,_=se),!0)),_}}e.$ac=z;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Q=Array.from(ee.keys()).sort((se,ue)=>_(ee[se],ee[ue]));return new x(Q)}apply(ee){return ee.map((_,Q)=>ee[this.c[Q]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(ae[127],ce([0,1,7]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$dd=L,e.$ed=j,e.$fd=O,e.$gd=I,e.$hd=P;function N(f,E){if(!f)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function L(f,E="Unreachable"){throw new Error(E)}function j(f){if(!f)throw new A.$cb("Assertion Failed")}function O(f){f||(0,A.$1)(new A.$cb("Soft Assertion Failed"))}function I(f){if(!f()){debugger;f(),(0,A.$1)(new A.$cb("Assertion Failed"))}}function P(f,E){let y=0;for(;y<f.length-1;){const w=f[y],h=f[y+1];if(!E(w,h))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=A;function A(N,L){const j=this;let O=!1,I;return function(){if(O)return I;if(O=!0,L)try{I=N.apply(j,arguments)}finally{L()}else I=N.apply(j,arguments);return I}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const j=Object.freeze([]);function O(){return j}N.empty=O;function*I(t){yield t}N.single=I;function P(t){return L(t)?t:I(t)}N.wrap=P;function f(t){return t||j}N.from=f;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function h(t,r){for(const n of t)if(r(n))return!0;return!1}N.some=h;function c(t,r){for(const n of t)if(r(n))return n}N.find=c;function*p(t,r){for(const n of t)r(n)&&(yield n)}N.filter=p;function*g(t,r){let n=0;for(const s of t)yield r(s,n++)}N.map=g;function*l(...t){for(const r of t)yield*r}N.concat=l;function u(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}N.reduce=u;function*m(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}N.slice=m;function d(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,N.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=d;async function $(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}N.asyncToArray=$})(A||(e.Iterable=A={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$En=O,e.$Fn=y,e.$Gn=w,e.$Hn=h,e.$In=c,e.$Jn=p,e.$Kn=g,e.$Ln=l,e.$Mn=u,e.$Nn=m,e.$On=d,e.$Pn=$;var A;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,b=0;function S(q){let Y=0,G=0;for(;Y<q;){const X=t.charCodeAt(n);if(X>=48&&X<=57)G=G*16+X-48;else if(X>=65&&X<=70)G=G*16+X-65+10;else if(X>=97&&X<=102)G=G*16+X-97+10;else break;n++,Y++}return Y<q&&(G=-1),G}function v(q){n=q,i="",o=0,a=16,b=0}function k(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return b=3,t.substring(q,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;Y=n}else b=3;return t.substring(q,Y)}function C(){let q="",Y=n;for(;;){if(n>=s){q+=t.substring(Y,n),b=2;break}const G=t.charCodeAt(n);if(G===34){q+=t.substring(Y,n),n++;break}if(G===92){if(q+=t.substring(Y,n),n++,n>=s){b=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const W=S(4);W>=0?q+=String.fromCharCode(W):b=4;break}default:b=5}Y=n;continue}if(G>=0&&G<=31)if(P(G)){q+=t.substring(Y,n),b=2;break}else b=6;n++}return q}function R(){if(i="",b=0,o=n,n>=s)return o=s,a=17;let q=t.charCodeAt(n);if(I(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(I(q));return a=15}if(P(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=C(),a=10;case 47:{const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(t.charCodeAt(n));)n++;return i=t.substring(Y,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const G=s-1;let X=!1;for(;n<G;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,b=1),i=t.substring(Y,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!f(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&M(q);)n++,q=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function M(q){if(I(q)||P(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:r?T:R,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>b}}function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function b(S,v,k,C){o.value=S,o.offset=v,o.length=k,o.type=C,o.colonOffset=void 0,i=o}try{m(t,{onObjectBegin:(S,v)=>{if(r<=S)throw s;i=void 0,a=r>S,n.push("")},onObjectProperty:(S,v,k)=>{if(r<v||(b(S,v,k,"property"),n[n.length-1]=S,r<=v+k))throw s},onObjectEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onArrayBegin:(S,v)=>{if(r<=S)throw s;i=void 0,n.push(0)},onArrayEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onLiteralValue:(S,v,k)=>{if(r<v||(b(S,v,k,$(S)),r<=v+k))throw s},onSeparator:(S,v,k)=>{if(r<=v)throw s;if(S===":"&&i&&i.type==="property")i.colonOffset=v,a=!1,i=void 0;else if(S===","){const C=n[n.length-1];typeof C=="number"?n[n.length-1]=C+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:i,isAtPropertyKey:a,matches:S=>{let v=0;for(let k=0;v<S.length&&k<n.length;k++)if(S[v]===n[k]||S[v]==="*")v++;else if(S[v]!=="**")return!1;return v===S.length}}}function w(t,r=[],n=j.DEFAULT){let s=null,i=[];const o=[];function a(S){Array.isArray(i)?i.push(S):s!==null&&(i[s]=S)}return m(t,{onObjectBegin:()=>{const S={};a(S),o.push(i),i=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const S=[];a(S),o.push(i),i=S,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n),i[0]}function h(t,r=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function o(S){return s.children.push(S),S}m(t,{onObjectBegin:S=>{s=o({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,v,k)=>{s=o({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:v,length:k,parent:s})},onObjectEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onArrayBegin:(S,v)=>{s=o({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onLiteralValue:(S,v,k)=>{o({type:$(S),offset:v,length:k,parent:s,value:S}),i(v+k)},onSeparator:(S,v,k)=>{s.type==="property"&&(S===":"?s.colonOffset=v:S===","&&i(v))},onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n);const b=s.children[0];return b&&delete b.parent,b}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function u(t,r,n=!1){if(l(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=u(s[i],r,n);if(o)return o}return t}}function m(t,r,n=j.DEFAULT){const s=O(t,!1);function i(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(he){return he?te=>he(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),b=o(r.onObjectProperty),S=i(r.onObjectEnd),v=i(r.onArrayBegin),k=i(r.onArrayEnd),C=o(r.onLiteralValue),R=o(r.onSeparator),M=i(r.onComment),T=o(r.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function G(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(he){case 12:case 13:q?X(10):M();break;case 16:X(1);break;case 15:case 14:break;default:return he}}}function X(he,te=[],V=[]){if(T(he),te.length+V.length>0){let U=s.getToken();for(;U!==17;){if(te.indexOf(U)!==-1){G();break}else if(V.indexOf(U)!==-1)break;U=G()}}}function W(he){const te=s.getTokenValue();return he?C(te):b(te),G(),!0}function J(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(X(2),he=0)}catch{X(2)}C(he);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return G(),!0}function H(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(R(":"),G(),re()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function B(){a(),G();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),G(),s.getToken()===2&&Y)break}else he&&X(6,[],[]);H()||X(4,[],[2,5]),he=!0}return S(),s.getToken()!==2?X(7,[2],[]):G(),!0}function ie(){v(),G();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),G(),s.getToken()===4&&Y)break}else he&&X(6,[],[]);re()||X(4,[],[4,5]),he=!0}return k(),s.getToken()!==4?X(8,[4],[]):G(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return J()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):re()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}function d(t,r){const n=O(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function $(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=N,e.$Rn=L,e.$Sn=I,e.$Tn=P;function N(f,E,y){let w,h,c,p,g;if(E){for(p=E.offset,g=p+E.length,c=p;c>0&&!P(f,c-1);)c--;let a=g;for(;a<f.length&&!P(f,a);)a++;h=f.substring(c,a),w=O(h,y)}else h=f,w=0,c=0,p=0,g=f.length;const l=I(y,f);let u=!1,m=0,d;y.insertSpaces?d=j(" ",y.tabSize||4):d="	";const $=(0,A.$En)(h,!1);let t=!1;function r(){return l+j(d,w+m)}function n(){let a=$.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=$.scan();return t=a===16||$.getTokenError()!==0,a}const s=[];function i(a,b,S){!t&&b<g&&S>p&&f.substring(b,S)!==a&&s.push({offset:b,length:S-b,content:a})}let o=n();if(o!==17){const a=$.getTokenOffset()+c,b=j(d,w);i(b,c,a)}for(;o!==17;){let a=$.getTokenOffset()+$.getTokenLength()+c,b=n(),S="";for(;!u&&(b===12||b===13);){const k=$.getTokenOffset()+c;i(" ",a,k),a=$.getTokenOffset()+$.getTokenLength()+c,S=b===12?r():"",b=n()}if(b===2)o!==1&&(m--,S=r());else if(b===4)o!==3&&(m--,S=r());else{switch(o){case 3:case 1:m++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(b===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?S=" ":b!==5&&b!==17&&(t=!0);break;case 16:t=!0;break}u&&(b===12||b===13)&&(S=r())}const v=$.getTokenOffset()+c;i(S,a,v),o=b}return s}function L(f,E){const y=JSON.stringify(f,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function j(f,E){let y="";for(let w=0;w<E;w++)y+=f;return y}function O(f,E){let y=0,w=0;const h=E.tabSize||4;for(;y<f.length;){const c=f.charAt(y);if(c===" ")w++;else if(c==="	")w+=h;else break;y++}return Math.floor(w/h)}function I(f,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return f&&f.eol||`
`}function P(f,E){return`\r
`.indexOf(f.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=L,e.$Vn=j,e.$Wn=O,e.$Xn=I,e.$Yn=P;function L(f,E,y){return j(f,E,void 0,y)}function j(f,E,y,w,h){const c=E.slice(),p=[],g=(0,A.$Hn)(f,p);let l,u;for(;c.length>0&&(u=c.pop(),l=(0,A.$In)(g,c),l===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const m=(0,A.$In)(l,[u]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const d=l.children.indexOf(m.parent);let $,t=m.parent.offset+m.parent.length;if(d>0){const r=l.children[d-1];$=r.offset+r.length}else $=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return O(f,{offset:$,length:t-$,content:""},w)}else return O(f,{offset:m.offset,length:m.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,$=h?h(l.children.map(r=>r.children[0].value)):l.children.length;let t;if($>0){const r=l.children[$-1];t={offset:r.offset+r.length,length:0,content:","+d}}else l.children.length===0?t={offset:l.offset+1,length:0,content:d}:t={offset:l.offset+1,length:0,content:d+","};return O(f,t,w)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const $=u===-1||u>l.children.length?l.children.length:u,t=l.children[$-1];d={offset:t.offset+t.length,length:0,content:","+m}}return O(f,d,w)}else{const m=u,d=l.children[m];let $;if(l.children.length===1)$={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const t=l.children[m-1],r=t.offset+t.length,n=l.offset+l.length;$={offset:r,length:n-2-r,content:""}}else $={offset:d.offset,length:l.children[m+1].offset-d.offset,content:""};return O(f,$,w)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else return y===void 0?[]:O(f,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(y)},w)}function O(f,E,y){let w=I(f,E),h=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;h>0&&!(0,N.$Tn)(w,h-1);)h--;for(;c<w.length&&!(0,N.$Tn)(w,c);)c++}const p=(0,N.$Qn)(w,{offset:h,length:c-h},y);for(let l=p.length-1;l>=0;l--){const u=p[l];w=I(w,u),h=Math.min(h,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const g=f.length-(w.length-c)-h;return[{offset:h,length:g,content:w.substring(h,c)}]}function I(f,E){return f.substring(0,E.offset)+E.content+f.substring(E.offset+E.length)}function P(f,E){const y=E.slice(0).sort((h,c)=>{const p=h.offset-c.offset;return p===0?h.length-c.length:p});let w=f.length;for(let h=y.length-1;h>=0;h--){const c=y[h];if(c.offset+c.length<=w)f=I(f,c);else throw new Error("Overlapping edit");w=c.offset}return f}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(j){this.element=j,this.next=A.Undefined,this.prev=A.Undefined}}class N{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let j=this.a;for(;j!==A.Undefined;){const O=j.next;j.prev=A.Undefined,j.next=A.Undefined,j=O}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const I=new A(j);if(this.a===A.Undefined)this.a=I,this.b=I;else if(O){const f=this.b;this.b=I,I.prev=f,f.next=I}else{const f=this.a;this.a=I,I.next=f,f.prev=I}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(I))}}shift(){if(this.a!==A.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==A.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==A.Undefined&&j.next!==A.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===A.Undefined&&j.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):j.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):j.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==A.Undefined;)yield j.element,j=j.next}}e.$6c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var A,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=j,e.$zc=O,e.$Ac=I,e.$Jc=d;function j($,t,r){let n=$.get(t);return n===void 0&&(n=r,$.set(t,n)),n}function O($){const t=[];return $.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${$.size}) {${t.join(", ")}}`}function I($){const t=[];return $.forEach(r=>{t.push(r)}),`Set(${$.size}) {${t.join(", ")}}`}class P{constructor(t,r){this.uri=t,this.value=r}}function f($){return Array.isArray($)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[A]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(f(t)){this.d=new Map,this.e=r??E.c;for(const[n,s]of t)this.set(n,s)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new P(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=E;class y{constructor(t,r){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var w;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const n=this.c.get(t);if(n)return r!==0&&this.m(n,r),n.value}set(t,r,n=0){let s=this.c.get(t);if(s)s.value=r,n!==0&&this.m(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const n=this.g;let s=this.d;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.next,n--;this.d=r,this.f=n,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.previous,n--;this.e=r,this.f=n,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const n=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const n=t.next,s=t.previous;t===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.$Dc=h;class c extends h{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Ec=p;class g extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Fc=g;class l{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Gc=l;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=u;class m{constructor(){this.c=new Map}add(t,r){let n=this.c.get(t);n||(n=new Set,this.c.set(t,n)),n.add(r)}delete(t,r){const n=this.c.get(t);n&&(n.delete(r),n.size===0&&this.c.delete(t))}forEach(t,r){const n=this.c.get(t);n&&n.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Ic=m;function d($,t){if($===t)return!0;if($.size!==t.size)return!1;for(const[r,n]of $)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!$.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=E,e.$Mc=y,e.$Nc=w,e.$Oc=p,e.$Pc=g,e.$Qc=l,e.$Rc=u,e.$Sc=m,e.$Tc=d,e.$4c=S;const I=!1;let P=null;class f{constructor(){this.b=new Map}static{this.a=0}c(C){let R=this.b.get(C);return R||(R={parent:null,source:null,isSingleton:!1,value:C,idx:f.a++},this.b.set(C,R)),R}trackDisposable(C){const R=this.c(C);R.source||(R.source=new Error().stack)}setParent(C,R){const M=this.c(C);M.parent=R}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,R){const M=R.get(C);if(M)return M;const T=C.parent?this.f(this.c(C.parent),R):C;return R.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,C).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(C=10,R){let M;if(R)M=R;else{const X=new Map,W=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,X).isSingleton);if(W.length===0)return;const J=new Set(W.map(H=>H.value));if(M=W.filter(H=>!(H.parent&&J.has(H.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(X){function W(H,B){for(;H.length>0&&B.some(ie=>typeof ie=="string"?ie===H[0]:H[0].match(ie));)H.shift()}const J=X.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const q=new L.$Ic;for(const X of M){const W=T(X);for(let J=0;J<=W.length;J++)q.add(W.slice(0,J).join(`
`),X)}M.sort((0,A.$7b)(X=>X.idx,A.$9b));let Y="",G=0;for(const X of M.slice(0,C)){G++;const W=T(X),J=[];for(let H=0;H<W.length;H++){let B=W[H];B=`(shared with ${q.get(W.slice(0,H+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const re=q.get(W.slice(0,H).join(`
`)),he=(0,N.$K)([...re].map(te=>T(te)[H]),te=>te);delete he[W[H]];for(const[te,V]of Object.entries(he))J.unshift(`    - stacktraces of ${V.length} other leaks continue with ${te}`);J.unshift(B)}Y+=`


==================== Leaking disposable ${G}/${M.length}: ${X.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return M.length>C&&(Y+=`


... and ${M.length-C} more leaking disposables

`),{leaks:M,details:Y}}}e.$Kc=f;function E(k){P=k}if(I){const k="__is_disposable_tracked__";E(new class{trackDisposable(C){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[k]||console.log(R)},3e3)}setParent(C,R){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsSingleton(C){}})}function y(k){return P?.trackDisposable(k),k}function w(k){P?.markAsDisposed(k)}function h(k,C){P?.setParent(k,C)}function c(k,C){if(P)for(const R of k)P.setParent(R,C)}function p(k){return P?.markAsSingleton(k),k}function g(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function l(k){if(O.Iterable.is(k)){const C=[];for(const R of k)if(R)try{R.dispose()}catch(M){C.push(M)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function u(k){for(const C of k)g(C)&&C.dispose();return[]}function m(...k){const C=d(()=>l(k));return c(k,C),C}function d(k){const C=y({dispose:(0,j.$db)(()=>{w(C),k()})});return C}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return h(C,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),h(C,null))}}e.$Uc=$;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,y(this),h(this.q,this)}dispose(){w(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Vc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&h(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&h(C,null),C}}e.$Wc=r;class n{constructor(C){this.a=new r,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=n;class s{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(C){let R=C;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,w(this))},this}}e.$Zc=i;class o{constructor(){this.a=new Map}acquire(C,...R){let M=this.a.get(C);M||(M={counter:0,object:this.b(C,...R)},this.a.set(C,M));const{object:T}=M,q=(0,j.$db)(()=>{--M.counter===0&&(this.c(C,M.object),this.a.delete(C))});return M.counter++,{object:T,dispose:q}}}e.$1c=o;class a{constructor(C){this.a=C}async acquire(C,...R){const M=this.a.acquire(C,...R);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$2c=a;class b{constructor(C){this.object=C}dispose(){}}e.$3c=b;function S(k){const C=new $;try{k(C)}finally{C.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,R,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(C)?.dispose(),this.a.set(C,R)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=v}),define(ae[87],ce([0,1,34]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=void 0,e.$$l=L,e.$_l=O;const N=new A.$Ec(1e4);function L(f){return P(f,"NFC",N)}const j=new A.$Ec(1e4);function O(f){return P(f,"NFD",j)}const I=/[^\u0000-\u0080]/;function P(f,E,y){if(!f)return f;const w=y.get(f);if(w)return w;let h;return I.test(f)?h=f.normalize(E):h=f,y.set(f,h),h}e.$am=function(){const f=/[\u0300-\u036f]/g;return function(E){return O(E).replace(f,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(P){j.push(P,Date.now())}function I(){const P=[];for(let f=0;f<j.length;f+=2)P.push({name:j[f],startTime:j[f+1]});return P}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function A(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=A(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var N in A)(typeof exports=="object"?exports:ne)[N]=A[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function A(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,A),L.l=!0,L.exports}return A.m=ne,A.c=e,A.d=function(N,L,j){A.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:j})},A.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},A.t=function(N,L){if(1&L&&(N=A(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(A.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)A.d(j,O,function(I){return N[I]}.bind(null,O));return j},A.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return A.d(L,"a",L),L},A.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},A.p="",A(A.s=0)}([function(ne,e,A){(function(N){var L;e=ne.exports=V,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],f=0,E=f++;P[E]="0|[1-9]\\d*";var y=f++;P[y]="[0-9]+";var w=f++;P[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=f++;P[h]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var c=f++;P[c]="("+P[y]+")\\.("+P[y]+")\\.("+P[y]+")";var p=f++;P[p]="(?:"+P[E]+"|"+P[w]+")";var g=f++;P[g]="(?:"+P[y]+"|"+P[w]+")";var l=f++;P[l]="(?:-("+P[p]+"(?:\\."+P[p]+")*))";var u=f++;P[u]="(?:-?("+P[g]+"(?:\\."+P[g]+")*))";var m=f++;P[m]="[0-9A-Za-z-]+";var d=f++;P[d]="(?:\\+("+P[m]+"(?:\\."+P[m]+")*))";var $=f++,t="v?"+P[h]+P[l]+"?"+P[d]+"?";P[$]="^"+t+"$";var r="[v=\\s]*"+P[c]+P[u]+"?"+P[d]+"?",n=f++;P[n]="^"+r+"$";var s=f++;P[s]="((?:<|>)?=?)";var i=f++;P[i]=P[y]+"|x|X|\\*";var o=f++;P[o]=P[E]+"|x|X|\\*";var a=f++;P[a]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[l]+")?"+P[d]+"?)?)?";var b=f++;P[b]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[u]+")?"+P[d]+"?)?)?";var S=f++;P[S]="^"+P[s]+"\\s*"+P[a]+"$";var v=f++;P[v]="^"+P[s]+"\\s*"+P[b]+"$";var k=f++;P[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=f++;P[C]="(?:~>?)";var R=f++;P[R]="(\\s*)"+P[C]+"\\s+",I[R]=new RegExp(P[R],"g");var M=f++;P[M]="^"+P[C]+P[a]+"$";var T=f++;P[T]="^"+P[C]+P[b]+"$";var q=f++;P[q]="(?:\\^)";var Y=f++;P[Y]="(\\s*)"+P[q]+"\\s+",I[Y]=new RegExp(P[Y],"g");var G=f++;P[G]="^"+P[q]+P[a]+"$";var X=f++;P[X]="^"+P[q]+P[b]+"$";var W=f++;P[W]="^"+P[s]+"\\s*("+r+")$|^$";var J=f++;P[J]="^"+P[s]+"\\s*("+t+")$|^$";var H=f++;P[H]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[a]+")",I[H]=new RegExp(P[H],"g");var B=f++;P[B]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=f++;P[ie]="^\\s*("+P[b]+")\\s+-\\s+("+P[b]+")\\s*$";var re=f++;P[re]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)L(he,P[he]),I[he]||(I[he]=new RegExp(P[he]));function te(le,me){if(le instanceof V)return le;if(typeof le!="string"||le.length>j||!(me?I[n]:I[$]).test(le))return null;try{return new V(le,me)}catch{return null}}function V(le,me){if(le instanceof V){if(le.loose===me)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof V))return new V(le,me);L("SemVer",le,me),this.loose=me;var we=le.trim().match(me?I[n]:I[$]);if(!we)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Re=+Ce;if(Re>=0&&Re<O)return Re}return Ce}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=te,e.valid=function(le,me){var we=te(le,me);return we?we.version:null},e.clean=function(le,me){var we=te(le.trim().replace(/^[=v]+/,""),me);return we?we.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof V||(le=new V(le,this.loose)),this.compareMain(le)||this.comparePre(le)},V.prototype.compareMain=function(le){return le instanceof V||(le=new V(le,this.loose)),D(this.major,le.major)||D(this.minor,le.minor)||D(this.patch,le.patch)},V.prototype.comparePre=function(le){if(le instanceof V||(le=new V(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var me=0;do{var we=this.prerelease[me],Ce=le.prerelease[me];if(L("prerelease compare",me,we,Ce),we===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(we===void 0)return-1;if(we!==Ce)return D(we,Ce)}while(++me)},V.prototype.inc=function(le,me){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,me,we,Ce){typeof we=="string"&&(Ce=we,we=void 0);try{return new V(le,we).inc(me,Ce).version}catch{return null}},e.diff=function(le,me){if(K(le,me))return null;var we=te(le),Ce=te(me);if(we.prerelease.length||Ce.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return Re},e.compareIdentifiers=D;var U=/^[0-9]+$/;function D(le,me){var we=U.test(le),Ce=U.test(me);return we&&Ce&&(le=+le,me=+me),we&&!Ce?-1:Ce&&!we?1:le<me?-1:le>me?1:0}function F(le,me,we){return new V(le,we).compare(new V(me,we))}function z(le,me,we){return F(le,me,we)>0}function x(le,me,we){return F(le,me,we)<0}function K(le,me,we){return F(le,me,we)===0}function ee(le,me,we){return F(le,me,we)!==0}function _(le,me,we){return F(le,me,we)>=0}function Q(le,me,we){return F(le,me,we)<=0}function se(le,me,we,Ce){var Re;switch(me){case"===":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Re=le===we;break;case"!==":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Re=le!==we;break;case"":case"=":case"==":Re=K(le,we,Ce);break;case"!=":Re=ee(le,we,Ce);break;case">":Re=z(le,we,Ce);break;case">=":Re=_(le,we,Ce);break;case"<":Re=x(le,we,Ce);break;case"<=":Re=Q(le,we,Ce);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function ue(le,me){if(le instanceof ue){if(le.loose===me)return le;le=le.value}if(!(this instanceof ue))return new ue(le,me);L("comparator",le,me),this.loose=me,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,me){return D(me,le)},e.major=function(le,me){return new V(le,me).major},e.minor=function(le,me){return new V(le,me).minor},e.patch=function(le,me){return new V(le,me).patch},e.compare=F,e.compareLoose=function(le,me){return F(le,me,!0)},e.rcompare=function(le,me,we){return F(me,le,we)},e.sort=function(le,me){return le.sort(function(we,Ce){return e.compare(we,Ce,me)})},e.rsort=function(le,me){return le.sort(function(we,Ce){return e.rcompare(we,Ce,me)})},e.gt=z,e.lt=x,e.eq=K,e.neq=ee,e.gte=_,e.lte=Q,e.cmp=se,e.Comparator=ue;var ge={};function fe(le,me){if(le instanceof fe)return le.loose===me?le:new fe(le.raw,me);if(le instanceof ue)return new fe(le.value,me);if(!(this instanceof fe))return new fe(le,me);if(this.loose=me,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function $e(le){return!le||le.toLowerCase()==="x"||le==="*"}function ye(le,me,we,Ce,Re,Me,Oe,qe,Fe,ze,Ue,je,oe){return((me=$e(we)?"":$e(Ce)?">="+we+".0.0":$e(Re)?">="+we+"."+Ce+".0":">="+me)+" "+(qe=$e(Fe)?"":$e(ze)?"<"+(+Fe+1)+".0.0":$e(Ue)?"<"+Fe+"."+(+ze+1)+".0":je?"<="+Fe+"."+ze+"."+Ue+"-"+je:"<="+qe)).trim()}function ve(le,me){for(var we=0;we<le.length;we++)if(!le[we].test(me))return!1;if(me.prerelease.length){for(we=0;we<le.length;we++)if(L(le[we].semver),le[we].semver!==ge&&le[we].semver.prerelease.length>0){var Ce=le[we].semver;if(Ce.major===me.major&&Ce.minor===me.minor&&Ce.patch===me.patch)return!0}return!1}return!0}function Pe(le,me,we){try{me=new fe(me,we)}catch{return!1}return me.test(le)}function Ae(le,me,we,Ce){var Re,Me,Oe,qe,Fe;switch(le=new V(le,Ce),me=new fe(me,Ce),we){case">":Re=z,Me=Q,Oe=x,qe=">",Fe=">=";break;case"<":Re=x,Me=_,Oe=z,qe="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(le,me,Ce))return!1;for(var ze=0;ze<me.set.length;++ze){var Ue=me.set[ze],je=null,oe=null;if(Ue.forEach(function(de){de.semver===ge&&(de=new ue(">=0.0.0")),je=je||de,oe=oe||de,Re(de.semver,je.semver,Ce)?je=de:Oe(de.semver,oe.semver,Ce)&&(oe=de)}),je.operator===qe||je.operator===Fe||(!oe.operator||oe.operator===qe)&&Me(le,oe.semver)||oe.operator===Fe&&Oe(le,oe.semver))return!1}return!0}ue.prototype.parse=function(le){var me=this.loose?I[W]:I[J],we=le.match(me);if(!we)throw new TypeError("Invalid comparator: "+le);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new V(we[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new V(le,this.loose)),se(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,me){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new fe(le.value,me),Pe(this.value,we,me);if(le.operator==="")return we=new fe(this.value,me),Pe(le.semver,we,me);var Ce=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=se(this.semver,"<",le.semver,me)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Fe=se(this.semver,">",le.semver,me)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ce||Re||Me&&Oe||qe||Fe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(le){var me=this.loose;le=le.trim(),L("range",le,me);var we=me?I[ie]:I[B];le=le.replace(we,ye),L("hyphen replace",le),le=le.replace(I[H],"$1$2$3"),L("comparator trim",le,I[H]),le=(le=(le=le.replace(I[R],"$1~")).replace(I[Y],"$1^")).split(/\s+/).join(" ");var Ce=me?I[W]:I[J],Re=le.split(" ").map(function(Me){return function(Oe,qe){return L("comp",Oe),Oe=function(Fe,ze){return Fe.trim().split(/\s+/).map(function(Ue){return function(je,oe){L("caret",je,oe);var de=oe?I[X]:I[G];return je.replace(de,function(pe,be,Se,Ie,De){var Ne;return L("caret",je,pe,be,Se,Ie,De),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":De?(L("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+De+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+De+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+De+" <"+(+be+1)+".0.0"):(L("no pr"),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),L("caret return",Ne),Ne})}(Ue,ze)}).join(" ")}(Oe,qe),L("caret",Oe),Oe=function(Fe,ze){return Fe.trim().split(/\s+/).map(function(Ue){return function(je,oe){var de=oe?I[T]:I[M];return je.replace(de,function(pe,be,Se,Ie,De){var Ne;return L("tilde",je,pe,be,Se,Ie,De),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":De?(L("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=">="+be+"."+Se+"."+Ie+De+" <"+be+"."+(+Se+1)+".0"):Ne=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",L("tilde return",Ne),Ne})}(Ue,ze)}).join(" ")}(Oe,qe),L("tildes",Oe),Oe=function(Fe,ze){return L("replaceXRanges",Fe,ze),Fe.split(/\s+/).map(function(Ue){return function(je,oe){je=je.trim();var de=oe?I[v]:I[S];return je.replace(de,function(pe,be,Se,Ie,De,Ne){L("xRange",je,pe,be,Se,Ie,De,Ne);var We=$e(Se),Be=We||$e(Ie),Te=Be||$e(De);return be==="="&&Te&&(be=""),We?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Be&&(Ie=0),Te&&(De=0),be===">"?(be=">=",Be?(Se=+Se+1,Ie=0,De=0):Te&&(Ie=+Ie+1,De=0)):be==="<="&&(be="<",Be?Se=+Se+1:Ie=+Ie+1),pe=be+Se+"."+Ie+"."+De):Be?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te&&(pe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),L("xRange return",pe),pe})}(Ue,ze)}).join(" ")}(Oe,qe),L("xrange",Oe),Oe=function(Fe,ze){return L("replaceStars",Fe,ze),Fe.trim().replace(I[re],"")}(Oe,qe),L("stars",Oe),Oe}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Ce)})),Re=Re.map(function(Me){return new ue(Me,me)})},fe.prototype.intersects=function(le,me){if(!(le instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ce){return le.set.some(function(Re){return Re.every(function(Me){return Ce.intersects(Me,me)})})})})},e.toComparators=function(le,me){return new fe(le,me).set.map(function(we){return we.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new V(le,this.loose));for(var me=0;me<this.set.length;me++)if(ve(this.set[me],le))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(le,me,we){var Ce=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return le.forEach(function(Oe){Me.test(Oe)&&(Ce&&Re.compare(Oe)!==-1||(Re=new V(Ce=Oe,we)))}),Ce},e.minSatisfying=function(le,me,we){var Ce=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return le.forEach(function(Oe){Me.test(Oe)&&(Ce&&Re.compare(Oe)!==1||(Re=new V(Ce=Oe,we)))}),Ce},e.validRange=function(le,me){try{return new fe(le,me).range||"*"}catch{return null}},e.ltr=function(le,me,we){return Ae(le,me,"<",we)},e.gtr=function(le,me,we){return Ae(le,me,">",we)},e.outside=Ae,e.prerelease=function(le,me){var we=te(le,me);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(le,me,we){return le=new fe(le,we),me=new fe(me,we),le.intersects(me)},e.coerce=function(le){if(le instanceof V)return le;if(typeof le!="string")return null;var me=le.match(I[k]);return me==null?null:te((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,A(1))},function(ne,e){var A,N,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(g){if(A===setTimeout)return setTimeout(g,0);if((A===j||!A)&&setTimeout)return A=setTimeout,setTimeout(g,0);try{return A(g,0)}catch{try{return A.call(null,g,0)}catch{return A.call(this,g,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:j}catch{A=j}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var P,f=[],E=!1,y=-1;function w(){E&&P&&(E=!1,P.length?f=P.concat(f):y=-1,f.length&&h())}function h(){if(!E){var g=I(w);E=!0;for(var l=f.length;l;){for(P=f,f=[];++y<l;)P&&P[y].run();y=-1,l=f.length}P=null,E=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(g)}}function c(g,l){this.fun=g,this.array=l}function p(){}L.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];f.push(new c(g,l)),f.length!==1||E||I(h)},c.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class N{constructor(I,P,f){this.level=I,this.key=P,this.value=f,this.forward=[]}}const L=void 0;class j{constructor(I,P=2**16){this.comparator=I,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(I){return!!j.g(this,I,this.comparator)}get(I){return j.g(this,I,this.comparator)?.value}set(I,P){return j.h(this,I,P,this.comparator)&&(this.f+=1),this}delete(I){const P=j.k(this,I,this.comparator);return P&&(this.f-=1),P}forEach(I,P){let f=this.e.forward[0];for(;f;)I.call(P,f.value,f.key,this),f=f.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this.e.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static g(I,P,f){let E=I.e;for(let y=I.d-1;y>=0;y--)for(;E.forward[y]&&f(E.forward[y].key,P)<0;)E=E.forward[y];if(E=E.forward[0],E&&f(E.key,P)===0)return E}static h(I,P,f,E){const y=[];let w=I.e;for(let h=I.d-1;h>=0;h--){for(;w.forward[h]&&E(w.forward[h].key,P)<0;)w=w.forward[h];y[h]=w}if(w=w.forward[0],w&&E(w.key,P)===0)return w.value=f,!1;{const h=j.j(I);if(h>I.d){for(let c=I.d;c<h;c++)y[c]=I.e;I.d=h}w=new N(h,P,f);for(let c=0;c<h;c++)w.forward[c]=y[c].forward[c],y[c].forward[c]=w;return!0}}static j(I,P=.5){let f=1;for(;Math.random()<P&&f<I.c;)f+=1;return f}static k(I,P,f){const E=[];let y=I.e;for(let w=I.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,P)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||f(y.key,P)!==0)return!1;for(let w=0;w<I.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;I.d>0&&I.e.forward[I.d-1]===L;)I.d-=1;return!0}}e.$vs=j}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=A&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$$d=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$ae=e.Event=void 0,e.$be=h;const I=!1,P=!1,f=!1;var E;(function(R){R.None=()=>L.$Vc.None;function M(fe){if(f){const{onDidAddListener:$e}=fe,ye=p.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),$e?.()}}}function T(fe,$e){return re(fe,()=>{},0,void 0,!0,void 0,$e)}R.defer=T;function q(fe){return($e,ye=null,ve)=>{let Pe=!1,Ae;return Ae=fe(le=>{if(!Pe)return Ae?Ae.dispose():Pe=!0,$e.call(ye,le)},null,ve),Pe&&Ae.dispose(),Ae}}R.once=q;function Y(fe,$e,ye){return B((ve,Pe=null,Ae)=>fe(le=>ve.call(Pe,$e(le)),null,Ae),ye)}R.map=Y;function G(fe,$e,ye){return B((ve,Pe=null,Ae)=>fe(le=>{$e(le),ve.call(Pe,le)},null,Ae),ye)}R.forEach=G;function X(fe,$e,ye){return B((ve,Pe=null,Ae)=>fe(le=>$e(le)&&ve.call(Pe,le),null,Ae),ye)}R.filter=X;function W(fe){return fe}R.signal=W;function J(...fe){return($e,ye=null,ve)=>{const Pe=(0,L.$Sc)(...fe.map(Ae=>Ae(le=>$e.call(ye,le))));return ie(Pe,ve)}}R.any=J;function H(fe,$e,ye,ve){let Pe=ye;return Y(fe,Ae=>(Pe=$e(Pe,Ae),Pe),ve)}R.reduce=H;function B(fe,$e){let ye;const ve={onWillAddFirstListener(){ye=fe(Pe.fire,Pe)},onDidRemoveLastListener(){ye?.dispose()}};$e||M(ve);const Pe=new $(ve);return $e?.add(Pe),Pe.event}function ie(fe,$e){return $e instanceof Array?$e.push(fe):$e&&$e.add(fe),fe}function re(fe,$e,ye=100,ve=!1,Pe=!1,Ae,le){let me,we,Ce,Re=0,Me;const Oe={leakWarningThreshold:Ae,onWillAddFirstListener(){me=fe(Fe=>{Re++,we=$e(we,Fe),ve&&!Ce&&(qe.fire(we),we=void 0),Me=()=>{const ze=we;we=void 0,Ce=void 0,(!ve||Re>1)&&qe.fire(ze),Re=0},typeof ye=="number"?(clearTimeout(Ce),Ce=setTimeout(Me,ye)):Ce===void 0&&(Ce=0,queueMicrotask(Me))})},onWillRemoveListener(){Pe&&Re>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,me.dispose()}};le||M(Oe);const qe=new $(Oe);return le?.add(qe),qe.event}R.debounce=re;function he(fe,$e=0,ye){return R.debounce(fe,(ve,Pe)=>ve?(ve.push(Pe),ve):[Pe],$e,void 0,!0,void 0,ye)}R.accumulate=he;function te(fe,$e=(ve,Pe)=>ve===Pe,ye){let ve=!0,Pe;return X(fe,Ae=>{const le=ve||!$e(Ae,Pe);return ve=!1,Pe=Ae,le},ye)}R.latch=te;function V(fe,$e,ye){return[R.filter(fe,$e,ye),R.filter(fe,ve=>!$e(ve),ye)]}R.split=V;function U(fe,$e=!1,ye=[],ve){let Pe=ye.slice(),Ae=fe(we=>{Pe?Pe.push(we):me.fire(we)});ve&&ve.add(Ae);const le=()=>{Pe?.forEach(we=>me.fire(we)),Pe=null},me=new $({onWillAddFirstListener(){Ae||(Ae=fe(we=>me.fire(we)),ve&&ve.add(Ae))},onDidAddFirstListener(){Pe&&($e?setTimeout(le):le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ve&&ve.add(me),me.event}R.buffer=U;function D(fe,$e){return(ve,Pe,Ae)=>{const le=$e(new z);return fe(function(me){const we=le.evaluate(me);we!==F&&ve.call(Pe,we)},void 0,Ae)}}R.chain=D;const F=Symbol("HaltChainable");class z{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ye=>($e(ye),ye)),this}filter($e){return this.f.push(ye=>$e(ye)?ye:F),this}reduce($e,ye){let ve=ye;return this.f.push(Pe=>(ve=$e(ve,Pe),ve)),this}latch($e=(ye,ve)=>ye===ve){let ye=!0,ve;return this.f.push(Pe=>{const Ae=ye||!$e(Pe,ve);return ye=!1,ve=Pe,Ae?Pe:F}),this}evaluate($e){for(const ye of this.f)if($e=ye($e),$e===F)break;return $e}}function x(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Pe=()=>fe.on($e,ve),Ae=()=>fe.removeListener($e,ve),le=new $({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ae});return le.event}R.fromNodeEventEmitter=x;function K(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Pe=()=>fe.addEventListener($e,ve),Ae=()=>fe.removeEventListener($e,ve),le=new $({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ae});return le.event}R.fromDOMEventEmitter=K;function ee(fe){return new Promise($e=>q(fe)($e))}R.toPromise=ee;function _(fe){const $e=new $;return fe.then(ye=>{$e.fire(ye)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}R.fromPromise=_;function Q(fe,$e,ye){return $e(ye),fe(ve=>$e(ve))}R.runAndSubscribe=Q;class se{constructor($e,ye){this._observable=$e,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ye||M(ve),this.emitter=new $(ve),ye&&ye.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ye){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(fe,$e){return new se(fe,$e).emitter.event}R.fromObservable=ue;function ge(fe){return($e,ye,ve)=>{let Pe=0,Ae=!1;const le={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(fe.reportChanges(),Ae&&(Ae=!1,$e.call(ye)))},handlePossibleChange(){},handleChange(){Ae=!0}};fe.addObserver(le),fe.reportChanges();const me={dispose(){fe.removeObserver(le)}};return ve instanceof L.$Uc?ve.add(me):Array.isArray(ve)&&ve.push(me),me}}R.fromObservableLight=ge})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${y.f++}`,y.all.add(this)}start(M){this.g=new O.$$d,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ae=y;let w=-1;function h(R){const M=w;return w=R,{dispose(){w=M}}}class c{constructor(M,T=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=T,this.g=0}dispose(){this.f?.clear()}check(M,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const Y=this.f.get(M.value)||0;if(this.f.set(M.value,Y+1),this.g-=1,this.g<=0){this.g=q*.5;let G,X=0;for(const[W,J]of this.f)(!G||X<J)&&(G=W,X=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${X}):`),console.warn(G)}return()=>{const G=this.f.get(M.value)||0;this.f.set(M.value,G-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class l{constructor(M){this.value=M,this.id=g++}}const u=2,m=(R,M)=>{if(R instanceof l)M(R);else for(let T=0;T<R.length;T++){const q=R[T];q&&M(q)}},d=I?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class ${constructor(M){this.w=0,this.f=M,this.g=w>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const M=this.t;queueMicrotask(()=>{m(M,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Vc.None;if(this.m)return L.$Vc.None;T&&(M=M.bind(T));const Y=new l(M);let G,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=p.create(),G=this.g.check(Y.stack,this.w+1)),P&&(Y.stack=X??p.create()),this.t?this.t instanceof l?(this.u??=new r,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Tc)(()=>{d?.unregister(W),G?.(),this.x(Y)});if(q instanceof L.$Uc?q.add(W):Array.isArray(q)&&q.push(W),d){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(W,J,W)}return W},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(M);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const Y=this.u.current===this;if(this.w*u<=T.length){let G=0;for(let X=0;X<T.length;X++)T[X]?T[G++]=T[X]:Y&&(this.u.end--,G<this.u.i&&this.u.i--);T.length=G}}y(M,T){if(!M)return;const q=this.f?.onListenerError||A.$1;if(!q){M.value(T);return}try{M.value(T)}catch(Y){q(Y)}}z(M){const T=M.current.t;for(;M.i<M.end;)this.y(T[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,M);else{const T=this.u;T.enqueue(this,M,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ce=$;const t=()=>new r;e.$de=t;class r{constructor(){this.i=-1,this.end=0}enqueue(M,T,q){this.i=0,this.end=q,this.current=M,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(M,T,q){if(this.t)for(this.h||(this.h=new j.$6c),m(this.t,Y=>this.h.push([Y.value,M]));this.h.size>0&&!T.isCancellationRequested;){const[Y,G]=this.h.shift(),X=[],W={...G,token:T,waitUntil:J=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");q&&(J=q(J,Y)),X.push(J)}};try{Y(W)}catch(J){(0,A.$1)(J);continue}Object.freeze(X),await Promise.allSettled(X).then(J=>{for(const H of J)H.status==="rejected"&&(0,A.$1)(H.reason)})}}}e.$ee=n;class s extends ${get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new j.$6c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$fe=s;class i extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$ge=i;class o extends ${constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$he=o;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const T={event:M,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const Y=this.h.indexOf(T);this.h.splice(Y,1)};return(0,L.$Tc)((0,N.$db)(q))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(T=>this.f.fire(T))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$ie=a;class b{constructor(M,T,q,Y){this.f=new L.$Uc;const G=this.f.add(new a),X=this.f.add(new L.$5c);function W(J){X.set(J,G.add(Y(J)))}for(const J of M)W(J);this.f.add(T(J=>{W(J)})),this.f.add(q(J=>{X.deleteAndDispose(J)})),this.event=G.event}dispose(){this.f.dispose()}}e.$je=b;class S{constructor(){this.f=[]}wrapEvent(M){return(T,q,Y)=>M(G=>{const X=this.f[this.f.length-1];X?X.push(()=>T.call(q,G)):T.call(q,G)},void 0,Y)}bufferEvents(M){const T=[];this.f.push(T);const q=M();return this.f.pop(),T.forEach(Y=>Y()),q}}e.$ke=S;class v{constructor(){this.f=!1,this.g=E.None,this.h=L.$Vc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$le=v;class k{static const(M){return new C(M)}constructor(M){this.g=M,this.f=new $,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$me=k;class C{constructor(M){this.value=M,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.CancellationToken=void 0;const N=Object.freeze(function(I,P){const f=setTimeout(I.bind(P),0);return{dispose(){clearTimeout(f)}}});var L;(function(I){function P(f){return f===I.None||f===I.Cancelled||f instanceof j?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=P,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new A.$ce),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$ne=O}),define(ae[129],ce([0,1,26]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2e=e.$1e=e.$Ye=void 0,e.$Ze=L;class N{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new A.$ne,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ye=N;function L(I){return I}class j{constructor(P,f){this.a=void 0,this.b=void 0,typeof P=="function"?(this.c=P,this.d=L):(this.c=f,this.d=P.getCacheKey)}get(P){const f=this.d(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$1e=j;class O{get cachedValues(){return this.a}constructor(P,f){this.a=new Map,this.b=new Map,typeof P=="function"?(this.c=P,this.d=L):(this.c=f,this.d=P.getCacheKey)}get(P){const f=this.d(P);if(this.b.has(f))return this.b.get(f);const E=this.c(P);return this.a.set(P,E),this.b.set(f,E),E}}e.$2e=O}),define(ae[50],ce([0,1,7,2]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=L,e.$pe=j,e.$qe=O,e.$re=I,e.$se=f,e.$te=E,e.$ue=y,e.$ve=w,e.$we=h,e.$xe=c,e.$ye=p,e.$ze=g,e.$Ae=l,e.$Be=u,e.$Ce=m;function L(d){const $=d;return $?typeof $.read=="function":!1}function j(d){const $=d;return $?[$.on,$.pause,$.resume,$.destroy].every(t=>typeof t=="function"):!1}function O(d){const $=d;return $?j($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function I(d,$){return new P(d,$)}class P{constructor($,t){this.e=$,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(t=>t($))}h($){this.c.error.length===0?(0,A.$1)($):this.c.error.slice(0).forEach(t=>t($))}i(){this.c.end.slice(0).forEach($=>$())}on($,t){if(!this.a.destroyed)switch($){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener($,t){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(d,$){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return $(t)}function E(d,$,t){const r=[];let n;for(;(n=d.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return d.read()}}}function y(d,$){return new Promise((t,r)=>{const n=[];w(d,{onData:s=>{$&&n.push(s)},onError:s=>{$?r(s):t(void 0)},onEnd:()=>{t($?$(n):void 0)}})})}function w(d,$,t){d.on("error",r=>{t?.isCancellationRequested||$.onError(r)}),d.on("end",()=>{t?.isCancellationRequested||$.onEnd()}),d.on("data",r=>{t?.isCancellationRequested||$.onData(r)})}function h(d,$){return new Promise((t,r)=>{const n=new N.$Uc,s=[],i=b=>{if(s.push(b),s.length>$)return n.dispose(),d.pause(),t({stream:d,buffer:s,ended:!1})},o=b=>(n.dispose(),r(b)),a=()=>(n.dispose(),t({stream:d,buffer:s,ended:!0}));n.add((0,N.$Tc)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,N.$Tc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Tc)(()=>d.removeListener("data",i))),d.on("data",i)})}function c(d,$){const t=I($);return t.end(d),t}function p(){const d=I(()=>{throw new Error("not supported")});return d.end(),d}function g(d){let $=!1;return{read:()=>$?null:($=!0,d)}}function l(d,$,t){const r=I(t);return w(d,{onData:n=>r.write($.data(n)),onError:n=>r.error($.error?$.error(n):n),onEnd:()=>r.end()}),r}function u(d,$,t){let r=!1;return{read:()=>{const n=$.read();return r?n:(r=!0,n!==null?t([d,n]):d)}}}function m(d,$,t){let r=!1;const n=I(t);return w($,{onData:s=>r?n.write(s):(r=!0,n.write(t([d,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(d)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=void 0,e.$Ee=f,e.$Fe=E,e.$Ge=y,e.$He=w,e.$Ie=h,e.$Je=c,e.$Ke=p,e.$Le=g,e.$Me=l,e.$Ne=u,e.$Oe=m,e.$Pe=d,e.$Qe=$,e.$Re=t,e.$Se=r,e.$Te=n,e.$Ue=s,e.$Ve=i,e.$We=o,e.$Xe=S;const L=typeof Buffer<"u",j=new A.$V(()=>new Uint8Array(256));let O,I;class P{static alloc(k){return L?new P(Buffer.allocUnsafe(k)):new P(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new P(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(k)):(O||(O=new TextEncoder),new P(O.encode(k)))}static fromByteArray(k){const C=P.alloc(k.length);for(let R=0,M=k.length;R<M;R++)C.buffer[R]=k[R];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let T=0,q=k.length;T<q;T++)C+=k[T].byteLength}const R=P.alloc(C);let M=0;for(let T=0,q=k.length;T<q;T++){const Y=k[T];R.set(Y,M),M+=Y.byteLength}return R}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=P.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(k,C){return new P(this.buffer.subarray(k,C))}set(k,C){if(k instanceof P)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return w(this.buffer,k)}writeUInt32BE(k,C){h(this.buffer,k,C)}readUInt32LE(k){return c(this.buffer,k)}writeUInt32LE(k,C){p(this.buffer,k,C)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,C){l(this.buffer,k,C)}indexOf(k,C=0){return f(this.buffer,k instanceof P?k.buffer:k,C)}}e.$De=P;function f(v,k,C=0){const R=k.byteLength,M=v.byteLength;if(R===0)return 0;if(R===1)return v.indexOf(k[0]);if(R>M-C)return-1;const T=j.value;T.fill(k.length);for(let X=0;X<k.length;X++)T[k[X]]=k.length-X-1;let q=C+k.length-1,Y=q,G=-1;for(;q<M;)if(v[q]===k[Y]){if(Y===0){G=q;break}q--,Y--}else q+=Math.max(k.length-Y,T[v[q]]),Y=k.length-1;return G}function E(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}function y(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255}function w(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}function h(v,k,C){v[C+3]=k,k=k>>>8,v[C+2]=k,k=k>>>8,v[C+1]=k,k=k>>>8,v[C]=k}function c(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}function p(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255,k=k>>>8,v[C+2]=k&255,k=k>>>8,v[C+3]=k&255}function g(v,k){return v[k]}function l(v,k,C){v[C]=k}function u(v){return N.$se(v,k=>P.concat(k))}function m(v){return N.$ze(v)}function d(v){return N.$ue(v,k=>P.concat(k))}async function $(v){return v.ended?P.concat(v.buffer):P.concat([...v.buffer,await d(v.stream)])}function t(v){return N.$xe(v,k=>P.concat(k))}function r(v){return N.$Ae(v,{data:k=>typeof k=="string"?P.fromString(k):P.wrap(k)},k=>P.concat(k))}function n(v){return N.$re(k=>P.concat(k),v)}function s(v,k){return N.$Be(v,k,C=>P.concat(C))}function i(v,k){return N.$Ce(v,k,C=>P.concat(C))}function o(v){let k=0,C=0,R=0;const M=new Uint8Array(Math.floor(v.length/4*3)),T=Y=>{switch(C){case 3:M[R++]=k|Y,C=0;break;case 2:M[R++]=k|Y>>>2,k=Y<<6,C=3;break;case 1:M[R++]=k|Y>>>4,k=Y<<4,C=2;break;default:k=Y<<2,C=1}};for(let Y=0;Y<v.length;Y++){const G=v.charCodeAt(Y);if(G>=65&&G<=90)T(G-65);else if(G>=97&&G<=122)T(G-97+26);else if(G>=48&&G<=57)T(G-48+52);else if(G===43||G===45)T(62);else if(G===47||G===95)T(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${v[Y]}`)}}const q=R;for(;C>0;)T(0);return P.wrap(M).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:v},k=!0,C=!1){const R=C?b:a;let M="";const T=v.byteLength%3;let q=0;for(;q<v.byteLength-T;q+=3){const Y=v[q+0],G=v[q+1],X=v[q+2];M+=R[Y>>>2],M+=R[(Y<<4|G>>>4)&63],M+=R[(G<<2|X>>>6)&63],M+=R[X&63]}if(T===1){const Y=v[q+0];M+=R[Y>>>2],M+=R[Y<<4&63],k&&(M+="==")}else if(T===2){const Y=v[q+0],G=v[q+1];M+=R[Y>>>2],M+=R[(Y<<4|G>>>4)&63],M+=R[G<<2&63],k&&(M+="=")}return M}}),define(ae[27],ce([0,1,129,53]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.GraphemeBreakType=e.$Sf=e.$Lf=e.$Ef=e.$Df=void 0,e.$5e=L,e.$6e=O,e.$7e=P,e.$8e=f,e.$9e=E,e.$0e=y,e.$$e=w,e.$_e=h,e.$af=c,e.$bf=p,e.$cf=g,e.$df=l,e.$ef=u,e.$ff=m,e.$gf=d,e.$hf=$,e.$if=t,e.$jf=r,e.$kf=n,e.$lf=s,e.$mf=i,e.$nf=o,e.$of=a,e.$pf=b,e.$qf=S,e.$rf=v,e.$sf=k,e.$tf=C,e.$uf=R,e.$vf=M,e.$wf=T,e.$xf=q,e.$yf=Y,e.$zf=G,e.$Af=X,e.$Bf=W,e.$Cf=J,e.$Ff=re,e.$Gf=he,e.$Hf=te,e.$If=V,e.$Jf=F,e.$Kf=x,e.$Mf=K,e.$Nf=ee,e.$Of=_,e.$Pf=Q,e.$Qf=ue,e.$Rf=ge,e.$Tf=fe,e.$Uf=$e,e.$Vf=ye,e.$Wf=ve,e.$Xf=Pe,e.$Yf=Ae,e.$Zf=le,e.$1f=me,e.$2f=Oe;function L(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const j=/{(\d+)}/g;function O(oe,...de){return de.length===0?oe:oe.replace(j,function(pe,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=de.length?pe:de[Se]})}const I=/{([^}]+)}/g;function P(oe,de){return Object.keys(de).length===0?oe:oe.replace(I,(pe,be)=>de[be]??pe)}function f(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function E(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function y(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(oe,de){let pe=0;const be=de.charCodeAt(0);for(let Se=oe.length-1;Se>=0;Se--)oe.charCodeAt(Se)===be&&pe++;return pe}function h(oe,de,pe="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${pe}`}function c(oe,de,pe="\u2026"){if(oe.length<=de)return oe;const be=Math.ceil(de/2)-pe.length/2,Se=Math.floor(de/2)-pe.length/2;return`${oe.substr(0,be)}${pe}${oe.substr(oe.length-Se)}`}function p(oe,de=" "){const pe=g(oe,de);return l(pe,de)}function g(oe,de){if(!oe||!de)return oe;const pe=de.length;if(pe===0||oe.length===0)return oe;let be=0;for(;oe.indexOf(de,be)===be;)be=be+pe;return oe.substring(be)}function l(oe,de){if(!oe||!de)return oe;const pe=de.length,be=oe.length;if(pe===0||be===0)return oe;let Se=be,Ie=-1;for(;Ie=oe.lastIndexOf(de,Se-1),!(Ie===-1||Ie+pe!==Se);){if(Ie===0)return"";Se=Ie}return oe.substring(0,Se)}function u(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(oe){return oe.replace(/\*/g,"")}function d(oe,de,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=y(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(oe,be)}function $(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function t(oe){return oe.split(/\r\n|\r|\n/)}function r(oe){const de=[],pe=oe.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)de.push(pe[2*be]+(pe[2*be+1]??""));return de}function n(oe){for(let de=0,pe=oe.length;de<pe;de++){const be=oe.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function s(oe,de=0,pe=oe.length){for(let be=de;be<pe;be++){const Se=oe.charCodeAt(be);if(Se!==32&&Se!==9)return oe.substring(de,be)}return oe.substring(de,pe)}function i(oe,de=oe.length-1){for(let pe=de;pe>=0;pe--){const be=oe.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function o(oe,de,pe){const be=[];let Se=0;for(const Ie of oe.matchAll(de)){if(be.push(oe.slice(Se,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Se=Ie.index+Ie[0].length,be.push(pe(Ie[0],...Ie.slice(1),Ie.index,oe,Ie.groups))}return be.push(oe.slice(Se)),Promise.all(be).then(Ie=>Ie.join(""))}function a(oe,de){return oe<de?-1:oe>de?1:0}function b(oe,de,pe=0,be=oe.length,Se=0,Ie=de.length){for(;pe<be&&Se<Ie;pe++,Se++){const We=oe.charCodeAt(pe),Be=de.charCodeAt(Se);if(We<Be)return-1;if(We>Be)return 1}const De=be-pe,Ne=Ie-Se;return De<Ne?-1:De>Ne?1:0}function S(oe,de){return v(oe,de,0,oe.length,0,de.length)}function v(oe,de,pe=0,be=oe.length,Se=0,Ie=de.length){for(;pe<be&&Se<Ie;pe++,Se++){let We=oe.charCodeAt(pe),Be=de.charCodeAt(Se);if(We===Be)continue;if(We>=128||Be>=128)return b(oe.toLowerCase(),de.toLowerCase(),pe,be,Se,Ie);C(We)&&(We-=32),C(Be)&&(Be-=32);const Te=We-Be;if(Te!==0)return Te}const De=be-pe,Ne=Ie-Se;return De<Ne?-1:De>Ne?1:0}function k(oe){return oe>=48&&oe<=57}function C(oe){return oe>=97&&oe<=122}function R(oe){return oe>=65&&oe<=90}function M(oe,de){return oe.length===de.length&&v(oe,de)===0}function T(oe,de){const pe=de.length;return de.length>oe.length?!1:v(oe,de,0,pe)===0}function q(oe,de){const pe=Math.min(oe.length,de.length);let be;for(be=0;be<pe;be++)if(oe.charCodeAt(be)!==de.charCodeAt(be))return be;return pe}function Y(oe,de){const pe=Math.min(oe.length,de.length);let be;const Se=oe.length-1,Ie=de.length-1;for(be=0;be<pe;be++)if(oe.charCodeAt(Se-be)!==de.charCodeAt(Ie-be))return be;return pe}function G(oe){return 55296<=oe&&oe<=56319}function X(oe){return 56320<=oe&&oe<=57343}function W(oe,de){return(oe-55296<<10)+(de-56320)+65536}function J(oe,de,pe){const be=oe.charCodeAt(pe);if(G(be)&&pe+1<de){const Se=oe.charCodeAt(pe+1);if(X(Se))return W(be,Se)}return be}function H(oe,de){const pe=oe.charCodeAt(de-1);if(X(pe)&&de>1){const be=oe.charCodeAt(de-2);if(G(be))return W(be,pe)}return pe}class B{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=H(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Df=B;class ie{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new B(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ie=pe.offset,De=de.getGraphemeBreakType(pe.nextCodePoint());if(we(Se,De)){pe.setOffset(Ie);break}Se=De}return pe.offset-be}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ie=pe.offset,De=de.getGraphemeBreakType(pe.prevCodePoint());if(we(De,Se)){pe.setOffset(Ie);break}Se=De}return be-pe.offset}eol(){return this.c.eol()}}e.$Ef=ie;function re(oe,de){return new ie(oe,de).nextGraphemeLength()}function he(oe,de){return new ie(oe,de).prevGraphemeLength()}function te(oe,de){de>0&&X(oe.charCodeAt(de))&&de--;const pe=de+re(oe,de);return[pe-he(oe,pe),pe]}function V(oe){const de=new ie(oe);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let U;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(oe){return U||(U=D()),U.test(oe)}const z=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return z.test(oe)}e.$Lf=/[\u2028\u2029]/;function K(oe){return e.$Lf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function _(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Q(oe,de,pe=""){const be=oe.trimStart();if(be.length<de)return be;const Se=/\b/g;let Ie=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<de);)Ie=Se.lastIndex,Se.lastIndex+=1;return Ie===0?be:pe+be.substring(Ie).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(oe){let de=0;for(const pe of oe.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:oe.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==oe.length&&(yield{isCode:!1,str:oe.substring(de)})}function ge(oe){return oe&&(oe=oe.replace(se,"")),oe}e.$Sf="\uFEFF";function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return fe(oe)?oe.substr(1):oe}function ye(oe,de){if(!oe||!de||oe.length<de.length)return!1;const pe=de.length,be=oe.toLowerCase();let Se=0,Ie=-1;for(;Se<pe;){const De=be.indexOf(de[Se],Ie+1);if(De<0)return!1;Ie=De,Se++}return!0}function ve(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Pe(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Ae(oe,de=1){if(de===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}function le(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Re.getInstance().getGraphemeBreakType(oe)}function we(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var Ce;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Me()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,be=pe.length/3;let Se=1;for(;Se<=be;)if(de<pe[3*Se])Se=2*Se;else if(de>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(oe,de){if(oe===0)return 0;const pe=qe(oe,de);if(pe!==void 0)return pe;const be=new B(de,oe);return be.prevCodePoint(),be.offset}function qe(oe,de){const pe=new B(de,oe);let be=pe.prevCodePoint();for(;Fe(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Fe(oe){return 127995<=oe&&oe<=127999}var ze;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$3f="\xA0";class Ue{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$1e({getCacheKey:JSON.stringify},de=>{function pe(Te){const Ze=new Map;for(let Ge=0;Ge<Te.length;Ge+=2)Ze.set(Te[Ge],Te[Ge+1]);return Ze}function be(Te,Ze){const Ge=new Map(Te);for(const[_e,tt]of Ze)Ge.set(_e,tt);return Ge}function Se(Te,Ze){if(!Te)return Ze;const Ge=new Map;for(const[_e,tt]of Te)Ze.has(_e)&&Ge.set(_e,tt);return Ge}const Ie=this.c.value;let De=de.filter(Te=>!Te.startsWith("_")&&Te in Ie);De.length===0&&(De=["_default"]);let Ne;for(const Te of De){const Ze=pe(Ie[Te]);Ne=Se(Ne,Ze)}const We=pe(Ie._common),Be=be(We,Ne);return new Ue(Be)})}static getInstance(de){return Ue.d.get(Array.from(de))}static{this.e=new N.$V(()=>Object.keys(Ue.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$4f=Ue;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(de){return je.e().has(de)}static get codePoints(){return je.e()}}e.$5f=je}),define(ae[54],ce([0,1,27]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$lj=void 0,e.$hj=N,e.$ij=L,e.$jj=j,e.$kj=I,e.$mj=p;function N(l){return L(l,0)}function L(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?P(l,u):f(l,u);case"string":return I(l,u);case"boolean":return O(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}function j(l,u){return(u<<5)-u+l|0}function O(l,u){return j(l?433:863,u)}function I(l,u){u=j(149417,u);for(let m=0,d=l.length;m<d;m++)u=j(l.charCodeAt(m),u);return u}function P(l,u){return u=j(104579,u),l.reduce((m,d)=>L(d,m),u)}function f(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((m,d)=>(m=I(d,m),L(l[d],m)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$lj=E;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(l,u,m=32){const d=m-u,$=~((1<<d)-1);return(l<<u|($&l)>>>d)>>>0}function h(l,u=0,m=l.byteLength,d=0){for(let $=0;$<m;$++)l[u+$]=d}function c(l,u,m="0"){for(;l.length<u;)l=m+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((l>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const m=u.length;if(m===0)return;const d=this.p;let $=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=u.charCodeAt(0),n=0);;){let s=r;if(A.$zf(r))if(n+1<m){const i=u.charCodeAt(n+1);A.$Af(i)?(n++,s=A.$Bf(r,i)):s=65533}else{t=r;break}else A.$Af(r)&&(s=65533);if($=this.w(d,$,s),n++,n<m)r=u.charCodeAt(n);else break}this.r=$,this.u=t}w(u,m,d){return d<128?u[m++]=d:d<2048?(u[m++]=192|(d&1984)>>>6,u[m++]=128|(d&63)>>>0):d<65536?(u[m++]=224|(d&61440)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0):(u[m++]=240|(d&1835008)>>>18,u[m++]=128|(d&258048)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,m=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,w(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,$=this.l,t=this.m,r=this.n,n=this.o,s,i,o;for(let a=0;a<80;a++)a<20?(s=$&t|~$&r,i=1518500249):a<40?(s=$^t^r,i=1859775393):a<60?(s=$&t|$&r|t&r,i=2400959708):(s=$^t^r,i=3395469782),o=w(d,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=r,r=t,t=w($,30),$=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+$&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.$nj=g}),define(ae[88],ce([0,1,27]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const j="error",O="warning",I="warn",P="info",f="ignore";function E(w){return w?A.$vf(j,w)?L.Error:A.$vf(O,w)||A.$vf(I,w)?L.Warning:A.$vf(P,w)?L.Info:L.Ignore:L.Ignore}L.fromValue=E;function y(w){switch(w){case L.Error:return j;case L.Warning:return O;case L.Info:return P;default:return f}}L.toString=y}(N||(N={})),e.default=N}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0,e.$_d=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class L{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const c=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return c-p}value(){return this.b[this.c]}}e.$vi=L;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$pf)(h,this.b,0,h.length,this.c,this.d):(0,N.$rf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$wi=j;class O{constructor(h=!0,c=!0){this.f=h,this.g=c}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let c=h.length-1;c>=0;c--,this.c--){const p=this.b.charCodeAt(c);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$pf)(h,this.b,0,h.length,this.d,this.e):(0,N.$rf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$xi=O;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(h,c){this.f=h,this.g=c,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$qf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$qf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$of)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$of)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$yi=P;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(h=()=>!1,c=()=>!1){return new y(new P(h,c))}static forPaths(h=!1){return new y(new O(void 0,!h))}static forStrings(){return new y(new L)}static forConfigKeys(){return new y(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,c){if(c){const p=c.slice(0);(0,A.$Xb)(p);for(const g of p)this.set(g,h)}else{const p=h.slice(0);(0,A.$Xb)(p);for(const g of p)this.set(g[0],g[1])}}set(h,c){const p=this.b.reset(h);let g;this.c||(this.c=new f,this.c.segment=p.value());const l=[];for(g=this.c;;){const m=p.cmp(g.segment);if(m>0)g.left||(g.left=new f,g.left.segment=p.value()),l.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new f,g.right.segment=p.value()),l.push([1,g]),g=g.right;else if(p.hasNext())p.next(),g.mid||(g.mid=new f,g.mid.segment=p.value()),l.push([0,g]),g=g.mid;else break}const u=g.value;g.value=c,g.key=h;for(let m=l.length-1;m>=0;m--){const d=l[m][1];d.updateHeight();const $=d.balanceFactor();if($<-1||$>1){const t=l[m][0],r=l[m+1][0];if(t===1&&r===1)l[m][1]=d.rotateLeft();else if(t===-1&&r===-1)l[m][1]=d.rotateRight();else if(t===1&&r===-1)d.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=d.rotateLeft();else if(t===-1&&r===1)d.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=d.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const c=this.b.reset(h);let p=this.c;for(;p;){const g=c.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(c.hasNext())c.next(),p=p.mid;else break}return p}has(h){const c=this.d(h);return!(c?.value===void 0&&c?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,c){const p=this.b.reset(h),g=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)g.push([-1,l]),l=l.left;else if(u<0)g.push([1,l]),l=l.right;else if(p.hasNext())p.next(),g.push([0,l]),l=l.mid;else break}if(l){if(c?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:m,value:d,segment:$}=u;this.e(u.key,!1),l.key=m,l.value=d,l.segment=$}}else{const u=l.left??l.right;if(g.length>0){const[m,d]=g[g.length-1];switch(m){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=g.length-1;u>=0;u--){const m=g[u][1];m.updateHeight();const d=m.balanceFactor();if(d>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[u][1]=m.rotateLeft()):d<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[u][1]=m.rotateRight()),u>0)switch(g[u-1][0]){case-1:g[u-1][1].left=g[u][1];break;case 1:g[u-1][1].right=g[u][1];break;case 0:g[u-1][1].mid=g[u][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const c=this.b.reset(h);let p=this.c,g;for(;p;){const l=c.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(c.hasNext())c.next(),g=p.value||g,p=p.mid;else break}return p&&p.value||g}findSuperstr(h){return this.g(h,!1)}g(h,c){const p=this.b.reset(h);let g=this.c;for(;g;){const l=p.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this.h(g.mid):c?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[c,p]of this)h(p,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const c=[];return this.j(h,c),c[Symbol.iterator]()}j(h,c){h&&(h.left&&this.j(h.left,c),h.value&&c.push([h.key,h.value]),h.mid&&this.j(h.mid,c),h.right&&this.j(h.right,c))}_isBalanced(){const h=c=>{if(!c)return!0;const p=c.balanceFactor();return p<-1||p>1?!1:h(c.left)&&h(c.right)};return h(this.c)}}e.$zi=y}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=A,e.$7f=N,e.$8f=L,e.$9f=j,e.$0f=O,e.$$f=I,e.$_f=P,e.$ag=f,e.$bg=E,e.$cg=y,e.$dg=w,e.$eg=h,e.$fg=c,e.$gg=g,e.$hg=l,e.$ig=u,e.$jg=m,e.$kg=d;function A($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(t=>A(t))}function L($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function j($){const t=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof t}function O($){return typeof $=="number"&&!isNaN($)}function I($){return!!$&&typeof $[Symbol.iterator]=="function"}function P($){return $===!0||$===!1}function f($){return typeof $>"u"}function E($){return!y($)}function y($){return f($)||$===null}function w($,t){if(!$)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function h($){if(y($))throw new Error("Assertion Failed: argument is undefined or null");return $}function c(...$){const t=[];for(let r=0;r<$.length;r++){const n=$[r];if(y(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const p=Object.prototype.hasOwnProperty;function g($){if(!L($))return!1;for(const t in $)if(p.call($,t))return!1;return!0}function l($){return typeof $=="function"}function u(...$){return $.length>0&&$.every(l)}function m($,t){const r=Math.min($.length,t.length);for(let n=0;n<r;n++)d($[n],t[n])}function d($,t){if(A(t)){if(typeof $!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if($ instanceof t)return}catch{}if(!y($)&&$.constructor===t||t.length===1&&t.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=N,e.$1n=L,e.$2n=O,e.$3n=P,e.$4n=f,e.$5n=E,e.$6n=y,e.$7n=w,e.$8n=h,e.$9n=c,e.$0n=p,e.$$n=g;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,d])=>{u[m]=d&&typeof d=="object"?N(d):d}),u}function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const d in m)if(j.call(m,d)){const $=m[d];typeof $=="object"&&!Object.isFrozen($)&&!(0,A.$9f)($)&&u.push($)}}return l}const j=Object.prototype.hasOwnProperty;function O(l,u){return I(l,u,new Set)}function I(l,u,m){if((0,A.$cg)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const $=[];for(const t of l)$.push(I(t,u,m));return $}if((0,A.$8f)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const $={};for(const t in l)j.call(l,t)&&($[t]=I(l[t],u,m));return m.delete(l),$}return l}function P(l,u,m=!0){return(0,A.$8f)(l)?((0,A.$8f)(u)&&Object.keys(u).forEach(d=>{d in l?m&&((0,A.$8f)(l[d])&&(0,A.$8f)(u[d])?P(l[d],u[d],m):l[d]=u[d]):l[d]=u[d]}),l):u}function f(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let m,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(m=0;m<l.length;m++)if(!f(l[m],u[m]))return!1}else{const $=[];for(d in l)$.push(d);$.sort();const t=[];for(d in u)t.push(d);if(t.sort(),!f($,t))return!1;for(m=0;m<$.length;m++)if(!f(l[$[m]],u[$[m]]))return!1}return!0}function E(l){const u=new Set;return JSON.stringify(l,(m,d)=>{if((0,A.$8f)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function y(l,u){const m=Object.create(null);return!l||!u||Object.keys(u).forEach($=>{const t=l[$],r=u[$];f(t,r)||(m[$]=r)}),m}function w(l,u){const m=u.toLowerCase(),d=Object.keys(l).find($=>$.toLowerCase()===m);return d?l[d]:l[u]}function h(l,u){const m=Object.create(null);for(const[d,$]of Object.entries(l))u(d,$)&&(m[d]=$);return m}function c(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}function p(l){const u=[];for(const m of c(l))typeof l[m]=="function"&&u.push(m);return u}function g(l,u){const m=$=>function(){const t=Array.prototype.slice.call(arguments,0);return u($,t)},d={};for(const $ of l)d[$]=m($);return d}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return A.test(L)}e.$Pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const j=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let P=0,f="";return f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f+="-",f+=O[j[P++]],f+=O[j[P++]],f+="-",f+=O[j[P++]],f+=O[j[P++]],f+="-",f+=O[j[P++]],f+=O[j[P++]],f+="-",f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f+=O[j[P++]],f}}()}),define(ae[131],ce([0,1,37]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=j;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function j(){const O=(0,A.networkInterfaces)();for(const I in O){const P=O[I];if(P){for(const{mac:f}of P)if(L(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CW=void 0;class L extends A.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,P){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let f=0;for(;f<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,f):(0,N.$Ee)(this.a,this.b,f);if(E===-1)break;this.push(this.a.slice(f,E+this.c)),f=E+this.c}this.a=f===this.a.length?void 0:this.a.slice(f),P()}_flush(O){this.a&&this.push(this.a),O()}}e.$CW=L}),define(ae[133],ce([0,1,64]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=N,e.$Tg=j;function N(I,P,f,E=1){let y=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!y)return y=!0,w(0)},f);L(I,P,E,c=>{if(!y)return y=!0,clearTimeout(h),w(c)})})}function L(I,P,f,E){if(P===0)return E(0);const y=new A.Socket;y.once("connect",()=>(O(y),L(I+f,P-1,f,E))),y.once("data",()=>{}),y.once("error",w=>(O(y),w.code!=="ECONNREFUSED"?L(I+f,P-1,f,E):E(I))),y.connect(I,"127.0.0.1")}e.$Sg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(I,P,f,E="127.0.0.1"){let y=!1,w,h=1;const c=A.createServer({pauseOnConnect:!0});function p(g,l){y||(y=!0,c.removeAllListeners(),c.close(),w&&clearTimeout(w),l(g))}return new Promise(g=>{w=setTimeout(()=>{p(0,g)},f),c.on("listening",()=>{p(I,g)}),c.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<P?(I++,h++,c.listen(I,E)):p(0,g)}),c.on("close",()=>{p(0,g)}),c.listen(I,E)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UW=A;function A(N){return!!N.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=f,e.$Zm=E,e.$1m=y;const N=60,L=N*60,j=L*24,O=j*7,I=j*30,P=j*365;function f(w,h,c,p){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,A.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,A.localize)(1,null);let l;return g<N?(l=g,h?l===1?c?(0,A.localize)(2,null,l):(0,A.localize)(3,null,l):c?(0,A.localize)(4,null,l):(0,A.localize)(5,null,l):l===1?c?(0,A.localize)(6,null,l):(0,A.localize)(7,null,l):c?(0,A.localize)(8,null,l):(0,A.localize)(9,null,l)):g<L?(l=Math.floor(g/N),h?l===1?c?(0,A.localize)(10,null,l):(0,A.localize)(11,null,l):c?(0,A.localize)(12,null,l):(0,A.localize)(13,null,l):l===1?c?(0,A.localize)(14,null,l):(0,A.localize)(15,null,l):c?(0,A.localize)(16,null,l):(0,A.localize)(17,null,l)):g<j?(l=Math.floor(g/L),h?l===1?c?(0,A.localize)(18,null,l):(0,A.localize)(19,null,l):c?(0,A.localize)(20,null,l):(0,A.localize)(21,null,l):l===1?c?(0,A.localize)(22,null,l):(0,A.localize)(23,null,l):c?(0,A.localize)(24,null,l):(0,A.localize)(25,null,l)):g<O?(l=Math.floor(g/j),h?l===1?(0,A.localize)(26,null,l):(0,A.localize)(27,null,l):l===1?(0,A.localize)(28,null,l):(0,A.localize)(29,null,l)):g<I?(l=Math.floor(g/O),h?l===1?c?(0,A.localize)(30,null,l):(0,A.localize)(31,null,l):c?(0,A.localize)(32,null,l):(0,A.localize)(33,null,l):l===1?c?(0,A.localize)(34,null,l):(0,A.localize)(35,null,l):c?(0,A.localize)(36,null,l):(0,A.localize)(37,null,l)):g<P?(l=Math.floor(g/I),h?l===1?c?(0,A.localize)(38,null,l):(0,A.localize)(39,null,l):c?(0,A.localize)(40,null,l):(0,A.localize)(41,null,l):l===1?c?(0,A.localize)(42,null,l):(0,A.localize)(43,null,l):c?(0,A.localize)(44,null,l):(0,A.localize)(45,null,l)):(l=Math.floor(g/P),h?l===1?c?(0,A.localize)(46,null,l):(0,A.localize)(47,null,l):c?(0,A.localize)(48,null,l):(0,A.localize)(49,null,l):l===1?c?(0,A.localize)(50,null,l):(0,A.localize)(51,null,l):c?(0,A.localize)(52,null,l):(0,A.localize)(53,null,l))}function E(w,h){const c=Math.abs(w/1e3);return c<1?h?(0,A.localize)(54,null,w):(0,A.localize)(55,null,w):c<N?h?(0,A.localize)(56,null,Math.round(w)/1e3):(0,A.localize)(57,null,Math.round(w)/1e3):c<L?h?(0,A.localize)(58,null,Math.round(w/(1e3*N))):(0,A.localize)(59,null,Math.round(w/(1e3*N))):c<j?h?(0,A.localize)(60,null,Math.round(w/(1e3*L))):(0,A.localize)(61,null,Math.round(w/(1e3*L))):(0,A.localize)(62,null,Math.round(w/(1e3*j)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=P,e.$fj=f,e.$gj=E;function j(y,w){return w&&(y.stack||y.stacktrace)?L.localize(0,null,I(y),O(y.stack)||O(y.stacktrace)):I(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?L.localize(1,null,y.message):y.message||L.localize(2,null)}function P(y=null,w=!1){if(!y)return L.localize(3,null);if(Array.isArray(y)){const h=A.$Hb(y),c=P(h[0],w);return h.length>1?L.localize(4,null,c,h.length):c}if(N.$6f(y))return y;if(y.detail){const h=y.detail;if(h.error)return j(h.error,w);if(h.exception)return j(h.exception,w)}return y.stack?j(y,w):y.message?y.message:L.localize(5,null)}function f(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=w,h}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=N;function N(L){switch(L){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=b,e.$J=S,e.$g="en";let N=!1,L=!1,j=!1,O=!1,I=!1,P=!1,f=!1,E=!1,y=!1,w=!1,h,c=e.$g,p=e.$g,g,l;const u=globalThis;let m;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?m=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const d=typeof m?.versions?.electron=="string",$=d&&m?.type==="renderer";if(typeof m=="object"){N=m.platform==="win32",L=m.platform==="darwin",j=m.platform==="linux",O=j&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,f=d,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,c=e.$g;const v=m.env.VSCODE_NLS_CONFIG;if(v)try{const k=JSON.parse(v),C=k.availableLanguages["*"];h=k.locale,p=k.osLocale,c=C||e.$g,g=k._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!$?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,E=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,P=!0,h=A.getConfiguredDefaultLocale(A.localize(0,null))||e.$g,c=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=L,e.$k=j,e.$l=O,e.$m=I,e.$n=f,e.$o=P,e.$p=P&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=w,e.$t=y,e.$u=n,e.$v=l,e.$w=c;var s;(function(v){function k(){return e.$w}v.value=k;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=C;function R(){return e.$w==="en"}v.isDefault=R})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=g,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const v=[];u.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let R=0,M=v.length;R<M;R++){const T=v[R];if(T.id===C.data.vscodeScheduleAsyncWork){v.splice(R,1),T.callback();return}}});let k=0;return C=>{const R=++k;v.push({id:R,callback:C}),u.postMessage({vscodeScheduleAsyncWork:R},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||E?2:N?1:3;let o=!0,a=!1;function b(){if(!a){a=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,o=new Uint16Array(v.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(v){return parseFloat(v)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ae[140],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jW=O;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function O(){const I=A.env[L];if(I){const f=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of f)switch(E){case"Unity":{const y=A.env.DESKTOP_SESSION;return y&&y.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const y=A.env[j];return y==="5"?N.KDE5:y==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const P=A.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return j in A.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in A.env?N.GNOME:"KDE_FULL_SESSION"in A.env?j in A.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,j=90,O=122,I=46,P=47,f=92,E=58,y=63;class w extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new w(r,"string",t)}const p=A.$ec==="win32";function g(t){return t===P||t===f}function l(t){return t===P}function u(t){return t>=N&&t<=j||t>=L&&t<=O}function m(t,r,n,s){let i="",o=0,a=-1,b=0,S=0;for(let v=0;v<=t.length;++v){if(v<t.length)S=t.charCodeAt(v);else{if(s(S))break;S=P}if(s(S)){if(!(a===v-1||b===1))if(b===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",o=0):(i=i.slice(0,k),o=i.length-1-i.lastIndexOf(n)),a=v,b=0;continue}else if(i.length!==0){i="",o=0,a=v,b=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,v)}`:i=t.slice(a+1,v),o=v-a-1;a=v,b=0}else S===I&&b!==-1?++b:b=-1}return i}function d(t,r){h(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.$gc={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=A.cwd():(o=A.env[`=${r}`]||A.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===f)&&(o=`${r}\\`));const a=o.length;let b=0,S="",v=!1;const k=o.charCodeAt(0);if(a===1)g(k)&&(b=1,v=!0);else if(g(k))if(v=!0,g(o.charCodeAt(1))){let C=2,R=C;for(;C<a&&!g(o.charCodeAt(C));)C++;if(C<a&&C!==R){const M=o.slice(R,C);for(R=C;C<a&&g(o.charCodeAt(C));)C++;if(C<a&&C!==R){for(R=C;C<a&&!g(o.charCodeAt(C));)C++;(C===a||C!==R)&&(S=`\\\\${M}\\${o.slice(R,C)}`,b=C)}}}else b=1;else u(k)&&o.charCodeAt(1)===E&&(S=o.slice(0,2),b=2,a>2&&g(o.charCodeAt(2))&&(v=!0,b=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(s){if(r.length>0)break}else if(n=`${o.slice(b)}\\${n}`,s=v,v&&r.length>0)break}return n=m(n,!s,"\\",g),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return l(o)?"\\":t;if(g(o))if(i=!0,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){const v=t.slice(S,b);for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return`\\\\${v}\\${t.slice(S)}\\`;b!==S&&(s=`\\\\${v}\\${t.slice(S,b)}`,n=b)}}}else n=1;else u(o)&&t.charCodeAt(1)===E&&(s=t.slice(0,2),n=2,r>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?m(t.slice(n),!i,"\\",g):"";return a.length===0&&!i&&(a="."),a.length>0&&g(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return g(n)||r>2&&u(n)&&t.charCodeAt(1)===E&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const o=n.length;o>1&&g(n.charCodeAt(1))&&(++i,o>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&g(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.$gc.resolve(t),s=e.$gc.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===f;)o--;const a=o-i;let b=0;for(;b<r.length&&r.charCodeAt(b)===f;)b++;let S=r.length;for(;S-1>b&&r.charCodeAt(S-1)===f;)S--;const v=S-b,k=a<v?a:v;let C=-1,R=0;for(;R<k;R++){const T=t.charCodeAt(i+R);if(T!==r.charCodeAt(b+R))break;T===f&&(C=R)}if(R!==k){if(C===-1)return s}else{if(v>k){if(r.charCodeAt(b+R)===f)return s.slice(b+R+1);if(R===2)return s.slice(b+R)}a>k&&(t.charCodeAt(i+R)===f?C=R:R===2&&(C=3)),C===-1&&(C=0)}let M="";for(R=i+C+1;R<=o;++R)(R===o||t.charCodeAt(R)===f)&&(M+=M.length===0?"..":"\\..");return b+=C,M.length>0?`${M}${s.slice(b,S)}`:(s.charCodeAt(b)===f&&++b,s.slice(b,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return t;b!==S&&(n=s=b+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(n=r>2&&g(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let b=r-1;b>=s;--b)if(g(t.charCodeAt(b))){if(!a){o=b;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=n;--o){const S=t.charCodeAt(o);if(g(S)){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(g(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=s=2);for(let b=t.length-1;b>=r;--b){const S=t.charCodeAt(b);if(g(S)){if(!o){s=b+1;break}continue}i===-1&&(o=!1,i=b+1),S===I?n===-1?n=b:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:d.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(i)){if(s=1,g(t.charCodeAt(1))){let C=2,R=C;for(;C<n&&!g(t.charCodeAt(C));)C++;if(C<n&&C!==R){for(R=C;C<n&&g(t.charCodeAt(C));)C++;if(C<n&&C!==R){for(R=C;C<n&&!g(t.charCodeAt(C));)C++;C===n?s=C:C!==R&&(s=C+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(n<=2)return r.root=r.dir=t,r;if(s=2,g(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,b=-1,S=!0,v=t.length-1,k=0;for(;v>=s;--v){if(i=t.charCodeAt(v),g(i)){if(!S){a=v+1;break}continue}b===-1&&(S=!1,b=v+1),i===I?o===-1?o=v:k!==1&&(k=1):o!==-1&&(k=-1)}return b!==-1&&(o===-1||k===0||k===1&&o===b-1&&o===a+1?r.base=r.name=t.slice(a,b):(r.name=t.slice(a,o),r.base=t.slice(a,b),r.ext=t.slice(o,b))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(p){const t=/\\/g;return()=>{const r=A.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>A.cwd()})();e.$hc={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:$();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===P)}return r=m(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P,n=t.charCodeAt(t.length-1)===P;return t=m(t,!r,"/",l),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,b=i<a?i:a;let S=-1,v=0;for(;v<b;v++){const C=t.charCodeAt(n+v);if(C!==r.charCodeAt(o+v))break;C===P&&(S=v)}if(v===b)if(a>b){if(r.charCodeAt(o+v)===P)return r.slice(o+v+1);if(v===0)return r.slice(o+v)}else i>b&&(t.charCodeAt(n+v)===P?S=v:v===0&&(S=0));let k="";for(v=n+S+1;v<=s;++v)(v===s||t.charCodeAt(v)===P)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===P){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===P){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const b=t.charCodeAt(a);if(b===P){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),b===I?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:d.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===P;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,b=!0,S=t.length-1,v=0;for(;S>=s;--S){const k=t.charCodeAt(S);if(k===P){if(!b){o=S+1;break}continue}a===-1&&(b=!1,a=S+1),k===I?i===-1?i=S:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const k=o===0&&n?1:o;i===-1||v===0||v===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(k,a):(r.name=t.slice(k,i),r.base=t.slice(k,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=p?e.$gc.normalize:e.$hc.normalize,e.$jc=p?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=p?e.$gc.join:e.$hc.join,e.$lc=p?e.$gc.resolve:e.$hc.resolve,e.$mc=p?e.$gc.relative:e.$hc.relative,e.$nc=p?e.$gc.dirname:e.$hc.dirname,e.$oc=p?e.$gc.basename:e.$hc.basename,e.$pc=p?e.$gc.extname:e.$hc.extname,e.$qc=p?e.$gc.format:e.$hc.format,e.$rc=p?e.$gc.parse:e.$hc.parse,e.$sc=p?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=p?e.$gc.sep:e.$hc.sep,e.$uc=p?e.$gc.delimiter:e.$hc.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=O,e.$mg=I,e.$ng=P,e.$og=f,e.$pg=E,e.$qg=c,e.$rg=p,e.$sg=g,e.$tg=l,e.$ug=u,e.$vg=m,e.$wg=d,e.$xg=$,e.$yg=t,e.$zg=r,e.$Ag=n,e.$Bg=o;function O(a){return a===47||a===92}function I(a){return a.replace(/[\\/]/g,A.$hc.sep)}function P(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function f(a,b=A.$hc.sep){if(!a)return"";const S=a.length,v=a.charCodeAt(0);if(O(v)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let C=3;const R=C;for(;C<S&&!O(a.charCodeAt(C));C++);if(R!==C&&!O(a.charCodeAt(C+1))){for(C+=1;C<S;C++)if(O(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if(l(v)&&a.charCodeAt(1)===58)return O(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(O(a.charCodeAt(k)))return a.slice(0,k+1)}return""}function E(a){if(!N.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let S=2;const v=S;for(;S<a.length&&(b=a.charCodeAt(S),b!==92);S++);return!(v===S||(b=a.charCodeAt(S+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,b=N.$i){const S=b?y:w;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||b&&h.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}function p(a,b,S){const v=a===b;return!S||v?v:!a||!b?!1:(0,L.$vf)(a,b)}function g(a,b,S,v=A.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(S){if(!(0,L.$wf)(a,b))return!1;if(b.length===a.length)return!0;let C=b.length;return b.charAt(b.length-1)===v&&C--,a.charAt(C)===v}return b.charAt(b.length-1)!==v&&(b+=v),a.indexOf(b)===0}function l(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,b){return N.$i&&a.endsWith(":")&&(a+=A.sep),(0,A.$jc)(a)||(a=(0,A.$kc)(b,a)),a=(0,A.$ic)(a),m(a)}function m(a){return N.$i?(a=(0,L.$df)(a,A.sep),a.endsWith(":")&&(a+=A.sep)):(a=(0,L.$df)(a,A.sep),a||(a=A.sep)),a}function d(a){const b=(0,A.$ic)(a);return N.$i?a.length>3?!1:$(b)&&(a.length===2||b.charCodeAt(2)===92):b===A.$hc.sep}function $(a,b=N.$i){return b?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,b=N.$i){return $(a,b)?a[0]:void 0}function r(a,b,S){return b.length>a.length?-1:a===b?0:(S&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}function n(a){const b=a.split(":");let S,v,k;for(const C of b){const R=Number(C);(0,j.$0f)(R)?v===void 0?v=R:k===void 0&&(k=R):S=S?[S,C].join(":"):C}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:v!==void 0?v:void 0,column:k!==void 0?k:v!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,b,S=8){let v="";for(let C=0;C<S;C++){let R;C===0&&N.$i&&!b&&(S===3||S===4)?R=i:R=s,v+=R.charAt(Math.floor(Math.random()*R.length))}let k;return b?k=`${b}-${v}`:k=v,a?(0,A.$kc)(a,k):k}}),define(ae[141],ce([0,1,14]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ns=j,e.$Os=O,e.$Ps=I,e.$Qs=f,e.$Ms=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(E){const y=(0,A.$pc)(E),w=N[y.toLowerCase()];return w!==void 0?w:O(E)}function O(E){const y=(0,A.$pc)(E);return L[y.toLowerCase()]}function I(E){for(const y in L)if(L[y]===E)return y}const P=/^(.+)\/(.+?)(;.+)?$/;function f(E,y){const w=P.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=j,e.$km=O;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(I,...P){const f=P.reduce((w,h)=>(w[h]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!f[w]).forEach(w=>{for(let h=0;h<E.length;h++)if(w.search(E[h])!==-1){delete I[w];break}})}function O(I){I&&(delete I.DEBUG,A.$j&&delete I.DYLD_LIBRARY_PATH,A.$k&&delete I.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=c,e.$xc=d;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,b,S,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,v),this.authority=o||E,this.path=f(this.scheme,a||E),this.query=b||E,this.fragment=S||E,I(this,v))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:b,query:S,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),b===void 0?b=this.path:b===null&&(b=E),S===void 0?S=this.query:S===null&&(S=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&b===this.path&&S===this.query&&v===this.fragment?this:new g(o,a,b,S,v)}static parse(i,o=!1){const a=w.exec(i);return a?new g(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),o):new g(E,E,E,E,E)}static file(i){let o=E;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(o=i.substring(2),i=y):(o=i.substring(2,a),i=i.substring(a)||y)}return new g("file",o,i,E,E)}static from(i,o){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=h.file(A.$gc.join(d(i,!0),...o)).path:a=A.$hc.join(i.path,...o),i.with({path:a})}toString(i=!1){return $(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const o=new g(i);return o._formatted=i.external??null,o._fsPath=i._sep===p?i.fsPath??null:null,o}}else return i}}e.URI=h;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=N.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,i,o){let a,b=-1;for(let S=0;S<s.length;S++){const v=s.charCodeAt(S);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47||o&&v===91||o&&v===93||o&&v===58)b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a!==void 0&&(a+=s.charAt(S));else{a===void 0&&(a=s.substr(0,S));const k=l[v];k!==void 0?(b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a+=k):b===-1&&(b=S)}}return b!==-1&&(a+=encodeURIComponent(s.substring(b))),a!==void 0?a:s}function m(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=l[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function d(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,N.$i&&(o=o.replace(/\//g,"\\")),o}function $(s,i){const o=i?m:u;let a="",{scheme:b,authority:S,path:v,query:k,fragment:C}=s;if(b&&(a+=b,a+=":"),(S||b==="file")&&(a+=y,a+=y),S){let R=S.indexOf("@");if(R!==-1){const M=S.substr(0,R);S=S.substr(R+1),R=M.lastIndexOf(":"),R===-1?a+=o(M,!1,!1):(a+=o(M.substr(0,R),!1,!1),a+=":",a+=o(M.substr(R+1),!1,!0)),a+="@"}S=S.toLowerCase(),R=S.lastIndexOf(":"),R===-1?a+=o(S,!1,!0):(a+=o(S.substr(0,R),!1,!0),a+=S.substr(R))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const R=v.charCodeAt(1);R>=65&&R<=90&&(v=`/${String.fromCharCode(R+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const R=v.charCodeAt(0);R>=65&&R<=90&&(v=`${String.fromCharCode(R+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),C&&(a+="#",a+=i?C:u(C,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=N,e.$Tq=L,e.$Uq=j,e.log=I;function N(f){const E=f;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function L(f){const E=[];let y;try{const w=JSON.parse(f.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),y=h.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",f.arguments)}return{args:E,stack:y}}function j(f){if(typeof f!="string")return j(L(f).stack);const E=f;if(E){const y=O(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:A.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function O(f){if(!f)return f;const E=f.indexOf(`
`);return E===-1?f:f.substring(0,E)}function I(f,E){const{args:y,stack:w}=L(f),h=typeof y[0]=="string"&&y.length===1;let c=O(w);c&&(c=`(${c.trim()})`);let p=[];if(typeof y[0]=="string"?c&&h?p=[`%c[${E}] %c${y[0]} %c${c}`,P("blue"),P(""),P("grey")]:p=[`%c[${E}] %c${y[0]}`,P("blue"),P(""),...y.slice(1)]:p=[`%c[${E}]%`,P("blue"),...y],c&&!h&&p.push(c),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,p)}function P(f){return`color: ${f}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=L,e.$2h=j,e.$3h=I;function L(P){return JSON.stringify(P,O)}function j(P){let f=JSON.parse(P);return f=I(f),f}function O(P,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function I(P,f=0){if(!P||f>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return N.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof A.$De||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=I(P[E],f+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=I(P[E],f+1))}return P}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Gg=e.$Fg=e.$Eg=e.Schemas=void 0,e.$Cg=P,e.$Dg=f,e.$Hg=y;var I;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(I||(e.Schemas=I={}));function P(c,p){return j.URI.isUri(c)?(0,L.$vf)(c.scheme,p):(0,L.$wf)(c,p+":")}function f(c,...p){return p.some(g=>P(c,g))}e.$Eg="vscode-tkn",e.$Fg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,g){this.f=y(p,g)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,I.vscodeRemoteResource)}set(p,g,l){this.a[p]=g,this.b[p]=l}setConnectionToken(p,g){this.c[p]=g}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch($){return A.$1($),p}const g=p.authority;let l=this.a[g];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const u=this.b[g],m=this.c[g];let d=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(d+=`&${e.$Fg}=${encodeURIComponent(m)}`),j.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${l}:${u}`,path:this.g,query:d})}}e.$Gg=new E;function y(c,p){return O.$hc.join(p??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Ig="vs/../../extensions",e.$Jg="vs/../../node_modules",e.$Kg="vs/../../node_modules.asar",e.$Lg="vs/../../node_modules.asar.unpacked",e.$Mg="vscode-app";class w{static{this.a=e.$Mg}asBrowserUri(p){const g=this.b(p,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Gg.rewrite(p):p.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${w.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||w.a,query:null,fragment:null}):p}asFileUri(p){const g=this.b(p,ne);return this.uriToFileUri(g)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==w.a?p.authority:null,query:null,fragment:null}):p}b(p,g){return j.URI.isUri(p)?p:j.URI.parse(g.toUrl(p))}}e.$Ng=new w;var h;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const g="vscode-coi";function l(m){let d;typeof m=="string"?d=new URL(m).searchParams:m instanceof URL?d=m.searchParams:j.URI.isUri(m)&&(d=new URL(m.toString(!0)).searchParams);const $=d?.get(g);if($)return p.get($)}c.getHeadersFromQuery=l;function u(m,d,$){if(!globalThis.crossOriginIsolated)return;const t=d&&$?"3":$?"2":"1";m instanceof URLSearchParams?m.set(g,t):m[g]=t}c.addSearchParam=u})(h||(e.COI=h={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VD=E;class O{constructor(w,h,c){this.id=w,this.dependencies=h,this.callback=c}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,h,c)=>{typeof w!="string"&&(c=h,h=w,w=null),(typeof h!="object"||!Array.isArray(h))&&(c=h,h=null),this.c.push(new O(w,h,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const h=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!h)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(w){return new Promise((h,c)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const g=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=m=>{g(),h(this.c.pop())},u=m=>{g(),c(m)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((h,c)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),h(this.c.pop())}catch(p){c(p)}})}async j(w){try{const h=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,g=j.URI.parse(w).fsPath,l=h.readFileSync(g).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const P=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function E(y,w,h){if(A.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[y]&&(y=f[y]);const c=`${y}/${w}`;if(P.has(c))return P.get(c);let p;if(/^\w[\w\d+.-]*:\/\//.test(c))p=c;else{const m=`${h&&!L.$o?N.$Kg:N.$Jg}/${c}`;p=N.$Ng.asBrowserUri(m).toString(!0)}const g=I.INSTANCE.load(p);return P.set(c,g),g}else return await new Promise((c,p)=>{ne([y],c,p)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0,e.$Ug=P,e.$dh=E,e.$eh=w;function P(h){return(0,I.$xc)(h,!0)}class f{constructor(c){this.a=c}compare(c,p,g=!1){return c===p?0:(0,O.$of)(this.getComparisonKey(c,g),this.getComparisonKey(p,g))}isEqual(c,p,g=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,g)===this.getComparisonKey(p,g)}getComparisonKey(c,p=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,p,g=!1){if(c.scheme===p.scheme){if(c.scheme===N.Schemas.file)return A.$sg(P(c),P(p),this.a(c))&&c.query===p.query&&(g||c.fragment===p.fragment);if((0,e.$_g)(c.authority,p.authority))return A.$sg(c.path,p.path,this.a(c),"/")&&c.query===p.query&&(g||c.fragment===p.fragment)}return!1}joinPath(c,...p){return I.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.$4g)(c)||c.authority}basename(c){return L.$hc.basename(c.path)}extname(c){return L.$hc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(L.$nc(P(c))).path:(p=L.$hc.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(L.$ic(P(c))).path:p=L.$hc.normalize(c.path),c.with({path:p})}relativePath(c,p){if(c.scheme!==p.scheme||!(0,e.$_g)(c.authority,p.authority))return;if(c.scheme===N.Schemas.file){const u=L.$mc(P(c),P(p));return j.$i?A.$mg(u):u}let g=c.path||"/";const l=p.path||"/";if(this.a(c)){let u=0;for(const m=Math.min(g.length,l.length);u<m&&!(g.charCodeAt(u)!==l.charCodeAt(u)&&g.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);g=l.substr(0,u)+g.substr(u)}return L.$hc.relative(g,l)}resolvePath(c,p){if(c.scheme===N.Schemas.file){const g=I.URI.file(L.$lc(P(c),p));return c.with({authority:g.authority,path:g.path})}return p=A.$ng(p),c.with({path:L.$hc.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||c!==void 0&&p!==void 0&&(0,O.$vf)(c,p)}hasTrailingPathSeparator(c,p=L.sep){if(c.scheme===N.Schemas.file){const g=P(c);return g.length>A.$og(g).length&&g[g.length-1]===p}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=L.sep){return(0,e.$ah)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=L.sep){let g=!1;if(c.scheme===N.Schemas.file){const l=P(c);g=l!==void 0&&l.length===A.$og(l).length&&l[l.length-1]===p}else{p="/";const l=c.path;g=l.length===1&&l.charCodeAt(l.length-1)===47}return!g&&!(0,e.$ah)(c,p)?c.with({path:c.path+"/"}):c}}e.$Vg=f,e.$Wg=new f(()=>!1),e.$Xg=new f(h=>h.scheme===N.Schemas.file?!j.$k:!0),e.$Yg=new f(h=>!0),e.$Zg=e.$Wg.isEqual.bind(e.$Wg),e.$1g=e.$Wg.isEqualOrParent.bind(e.$Wg),e.$2g=e.$Wg.getComparisonKey.bind(e.$Wg),e.$3g=e.$Wg.basenameOrAuthority.bind(e.$Wg),e.$4g=e.$Wg.basename.bind(e.$Wg),e.$5g=e.$Wg.extname.bind(e.$Wg),e.$6g=e.$Wg.dirname.bind(e.$Wg),e.$7g=e.$Wg.joinPath.bind(e.$Wg),e.$8g=e.$Wg.normalizePath.bind(e.$Wg),e.$9g=e.$Wg.relativePath.bind(e.$Wg),e.$0g=e.$Wg.resolvePath.bind(e.$Wg),e.$$g=e.$Wg.isAbsolutePath.bind(e.$Wg),e.$_g=e.$Wg.isEqualAuthority.bind(e.$Wg),e.$ah=e.$Wg.hasTrailingPathSeparator.bind(e.$Wg),e.$bh=e.$Wg.removeTrailingPathSeparator.bind(e.$Wg),e.$ch=e.$Wg.addTrailingPathSeparator.bind(e.$Wg);function E(h,c){const p=[];for(let g=0;g<h.length;g++){const l=c(h[g]);h.some((u,m)=>m===g?!1:(0,e.$1g)(l,c(u)))||p.push(h[g])}return p}var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(p){const g=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[d,$]=m.split(":");d&&$&&g.set(d,$)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&g.set(h.META_DATA_MIME,u),g}h.parseMetaData=c})(y||(e.DataUri=y={}));function w(h,c,p){if(c){let g=h.path;return g&&g[0]!==L.$hc.sep&&(g=L.$hc.sep+g),h.with({scheme:p,authority:c,path:g})}return h.with({scheme:p})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.Promises=e.$Qh=e.$Ph=e.$Oh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0,e.$fh=E,e.$gh=y,e.$hh=w,e.$ih=h,e.$jh=c,e.$kh=p,e.$lh=g,e.$mh=l,e.$uh=o,e.$vh=a,e.$wh=b,e.$xh=S,e.$yh=v,e.$Nh=B,e.$Vh=K;function E(_){return!!_&&typeof _.then=="function"}function y(_){const Q=new A.$ne,se=_(Q.token),ue=new Promise((ge,fe)=>{const $e=Q.token.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});Promise.resolve(se).then(ye=>{$e.dispose(),Q.dispose(),ge(ye)},ye=>{$e.dispose(),Q.dispose(),fe(ye)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ge,fe){return ue.then(ge,fe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function w(_,Q,se){return new Promise((ue,ge)=>{const fe=Q.onCancellationRequested(()=>{fe.dispose(),ue(se)});_.then(ue,ge).finally(()=>fe.dispose())})}function h(_,Q){return new Promise((se,ue)=>{const ge=Q.onCancellationRequested(()=>{ge.dispose(),ue(new N.$5)});_.then(se,ue).finally(()=>ge.dispose())})}async function c(_){let Q=-1;const se=_.map((ue,ge)=>ue.then(fe=>(Q=ge,fe)));try{return await Promise.race(se)}finally{_.forEach((ue,ge)=>{ge!==Q&&ue.cancel()})}}function p(_,Q,se){let ue;const ge=setTimeout(()=>{ue?.(void 0),se?.()},Q);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(fe=>ue=fe)])}function g(_){return new Promise((Q,se)=>{const ue=_();E(ue)?ue.then(Q,se):Q(ue)})}function l(){let _,Q;return{promise:new Promise((ue,ge)=>{_=ue,Q=ge}),resolve:_,reject:Q}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=Q(),new Promise((se,ue)=>{this.a.then(ge=>{this.a=null,se(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$nh=u;class m{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$oh=m;class d{constructor(){this.a=new Map}queue(Q,se){const ge=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Q)===ge&&this.a.delete(Q)});return this.a.set(Q,ge),ge}}e.$ph=d;const $=(_,Q)=>{let se=!0;const ue=setTimeout(()=>{se=!1,Q()},_);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},t=_=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,_())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class r{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,se=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ge,fe)=>{this.d=ge,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===P.$_d?t(ue):$(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qh=r;class n{constructor(Q){this.a=new r(Q),this.b=new u}trigger(Q,se){return this.a.trigger(()=>this.b.queue(Q),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rh=n;class s{constructor(){this.a=!1,this.b=new Promise((Q,se)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sh=s;class i extends s{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$th=i;function o(_,Q){return Q?new Promise((se,ue)=>{const ge=setTimeout(()=>{fe.dispose(),se()},_),fe=Q.onCancellationRequested(()=>{clearTimeout(ge),fe.dispose(),ue(new N.$5)})}):y(se=>o(_,se))}function a(_,Q=0,se){const ue=setTimeout(()=>{_(),se&&ge.dispose()},Q),ge=(0,j.$Tc)(()=>{clearTimeout(ue),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function b(_){const Q=[];let se=0;const ue=_.length;function ge(){return se<ue?_[se++]():null}function fe($e){$e!=null&&Q.push($e);const ye=ge();return ye?ye.then(fe):Promise.resolve(Q)}return Promise.resolve(null).then(fe)}function S(_,Q=ue=>!!ue,se=null){let ue=0;const ge=_.length,fe=()=>{if(ue>=ge)return Promise.resolve(se);const $e=_[ue++];return Promise.resolve($e()).then(ve=>Q(ve)?Promise.resolve(ve):fe())};return fe()}function v(_,Q=ue=>!!ue,se=null){if(_.length===0)return Promise.resolve(se);let ue=_.length;const ge=()=>{ue=-1;for(const fe of _)fe.cancel?.()};return new Promise((fe,$e)=>{for(const ye of _)ye.then(ve=>{--ue>=0&&Q(ve)?(ge(),fe(ve)):ue===0&&fe(se)}).catch(ve=>{--ue>=0&&(ge(),$e(ve))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new L.$ce}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:Q,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const se=Q.factory();se.then(Q.c,Q.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$zh=k;class C extends k{constructor(){super(1)}}e.$Ah=C;class R{constructor(){this.a=new ie,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Bh=R;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new te;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,se=O.$Wg){const ue=se.getComparisonKey(Q);return this.a.get(ue)?.size??0}queueFor(Q,se,ue=O.$Wg){const ge=ue.getComparisonKey(Q);let fe=this.a.get(ge);if(!fe){fe=new C;const $e=this.f++,ye=L.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$5c),this.d.set($e,ye),this.a.set(ge,fe)}return fe.queue(se)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ch=M;class T{constructor(Q,se){this.a=-1,typeof Q=="function"&&typeof se=="number"&&this.setIfNotSet(Q,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},se)}setIfNotSet(Q,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},se))}}e.$Dh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,se,ue=globalThis){this.cancel();const ge=ue.setInterval(()=>{Q()},se);this.d=(0,j.$Tc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel()}}e.$Eh=q;class Y{constructor(Q,se){this.b=-1,this.a=Q,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Fh=Y;class G{constructor(Q,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Q,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Gh=G;class X extends Y{constructor(Q,se){super(Q,se),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Hh=X;class W extends j.$Vc{constructor(Q,se){super(),this.g=Q,this.h=se,this.a=[],this.b=this.B(new j.$Wc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Q)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ih=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Kh=(_,Q)=>{(0,I.$B)(()=>{if(se)return;const ue=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Kh=(_,Q,se)=>{const ue=_.requestIdleCallback(Q,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Jh=_=>(0,e.$Kh)(globalThis,_)}();class J{constructor(Q,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Kh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Lh=J;class H extends J{constructor(Q){super(globalThis,Q)}}e.$Mh=H;async function B(_,Q,se){let ue;for(let ge=0;ge<se;ge++)try{return await _()}catch(fe){ue=fe,await o(Q)}throw ue}class ie{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,se,ue){return this.a={taskId:Q,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(Q),()=>this.d(Q)),se}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:se,resolve:ue,reject:ge}=l();this.b={run:Q,promise:se,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Oh=ie;class re{constructor(Q,se=()=>Date.now()){this.d=Q,this.f=se,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Ph=re;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,se)=>{this.a=Q,this.b=se})}complete(Q){return new Promise(se=>{this.a(Q),this.d={outcome:0,value:Q},se()})}error(Q){return new Promise(se=>{this.b(Q),this.d={outcome:1,value:Q},se()})}cancel(){return this.error(new N.$5)}}e.$Qh=te;var V;(function(_){async function Q(ue){let ge;const fe=await Promise.all(ue.map($e=>$e.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return fe}_.settled=Q;function se(ue){return new Promise(async(ge,fe)=>{try{await ue(ge,fe)}catch($e){fe($e)}})}_.withAsyncBody=se})(V||(e.Promises=V={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Rh=U;class D{constructor(Q){this.b=Q,this.a=new f.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Sh=D;var F;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(F||(F={}));class z{static fromArray(Q){return new z(se=>{se.emitMany(Q)})}static fromPromise(Q){return new z(async se=>{se.emitMany(await Q)})}static fromPromises(Q){return new z(async se=>{await Promise.all(Q.map(async ue=>se.emitOne(await ue)))})}static merge(Q){return new z(async se=>{await Promise.all(Q.map(async ue=>{for await(const ge of ue)se.emitOne(ge)}))})}static{this.EMPTY=z.fromArray([])}constructor(Q,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$ce,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Q(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,se){return new z(async ue=>{for await(const ge of Q)ue.emitOne(se(ge))})}map(Q){return z.map(this,Q)}static filter(Q,se){return new z(async ue=>{for await(const ge of Q)se(ge)&&ue.emitOne(ge)})}filter(Q){return z.filter(this,Q)}static coalesce(Q){return z.filter(Q,se=>!!se)}coalesce(){return z.coalesce(this)}static async toPromise(Q){const se=[];for await(const ue of Q)se.push(ue);return se}toPromise(){return z.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Th=z;class x extends z{constructor(Q,se){super(se),this.m=Q}cancel(){this.m.cancel()}}e.$Uh=x;function K(_){const Q=new A.$ne,se=_(Q.token);return new x(Q,async ue=>{const ge=Q.token.onCancellationRequested(()=>{ge.dispose(),Q.dispose(),ue.reject(new N.$5)});try{for await(const fe of se){if(Q.token.isCancellationRequested)return;ue.emitOne(fe)}ge.dispose(),Q.dispose()}catch(fe){ge.dispose(),Q.dispose(),ue.reject(fe)}})}class ee{constructor(Q){this.a=new te,this.b=new z(ge=>{if(se){ge.reject(se);return}return ue&&ge.emitMany(ue),this.d=fe=>ge.reject(fe),this.f=fe=>ge.emitOne(fe),this.a.p},Q);let se,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{se||(se=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Wh=ee}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$ik=f,e.$lk=c,e.$mk=C,e.$nk=R,e.$ok=M,e.$pk=T,e.$qk=q,e.$rk=W;function f(){return Object.create(null)}e.$jk="**",e.$kk="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function h(J,H){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${H?`|${E}${y}+`:""})*?`}}function c(J,H){if(!J)return[];const B=[];let ie=!1,re=!1,he="";for(const te of J){switch(te){case H:if(!ie&&!re){B.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}he+=te}return he&&B.push(he),B}function p(J){if(!J)return"";let H="";const B=c(J,e.$kk);if(B.every(ie=>ie===e.$jk))H=".*";else{let ie=!1;B.forEach((re,he)=>{if(re===e.$jk){if(ie)return;H+=h(2,he===B.length-1)}else{let te=!1,V="",U=!1,D="";for(const F of re){if(F!=="}"&&te){V+=F;continue}if(U&&(F!=="]"||!D)){let z;F==="-"?z=F:(F==="^"||F==="!")&&!D?z="^":F===e.$kk?z="":z=(0,P.$0e)(F),D+=z;continue}switch(F){case"{":te=!0;continue;case"[":U=!0;continue;case"}":{const x=`(?:${c(V,",").map(K=>p(K)).join("|")})`;H+=x,te=!1,V="";break}case"]":{H+="["+D+"]",U=!1,D="";break}case"?":H+=y;continue;case"*":H+=h(1);continue;default:H+=(0,P.$0e)(F)}}he<B.length-1&&(B[he+1]!==e.$jk||he+2<B.length)&&(H+=E)}ie=re===e.$jk})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Ec(1e4),r=function(){return!1},n=function(){return null};function s(J,H){if(!J)return n;let B;typeof J!="string"?B=J.pattern:B=J,B=B.trim();const ie=`${B}_${!!H.trimForExclusions}`;let re=t.get(ie);if(re)return i(re,J);let he;return g.test(B)?re=a(B.substr(4),B):(he=l.exec(o(B,H)))?re=b(he[1],B):(H.trimForExclusions?m:u).test(B)?re=S(B,H):(he=d.exec(o(B,H)))?re=v(he[1].substr(1),B,!0):(he=$.exec(o(B,H)))?re=v(he[1],B,!1):re=k(B),t.set(ie,re),i(re,J)}function i(J,H){if(typeof H=="string")return J;const B=function(ie,re){return(0,L.$sg)(ie,H.base,!I.$k)?J((0,P.$cf)(ie.substr(H.base.length),O.sep),re):null};return B.allBasenames=J.allBasenames,B.allPaths=J.allPaths,B.basenames=J.basenames,B.patterns=J.patterns,B}function o(J,H){return H.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,H){return function(B,ie){return typeof B=="string"&&B.endsWith(J)?H:null}}function b(J,H){const B=`/${J}`,ie=`\\${J}`,re=function(te,V){return typeof te!="string"?null:V?V===J?H:null:te===J||te.endsWith(B)||te.endsWith(ie)?H:null},he=[J];return re.basenames=he,re.patterns=[H],re.allBasenames=he,re}function S(J,H){const B=X(J.slice(1,-1).split(",").map(V=>s(V,H)).filter(V=>V!==n),J),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const re=function(V,U){for(let D=0,F=B.length;D<F;D++)if(B[D](V,U))return J;return null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,U)=>U.allPaths?V.concat(U.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function v(J,H,B){const ie=O.sep===O.$hc.sep,re=ie?J:J.replace(w,O.sep),he=O.sep+re,te=O.$hc.sep+J;let V;return B?V=function(U,D){return typeof U=="string"&&(U===re||U.endsWith(he)||!ie&&(U===J||U.endsWith(te)))?H:null}:V=function(U,D){return typeof U=="string"&&(U===re||!ie&&U===J)?H:null},V.allPaths=[(B?"*/":"./")+J],V}function k(J){try{const H=new RegExp(`^${p(J)}$`);return function(B){return H.lastIndex=0,typeof B=="string"&&H.test(B)?J:null}}catch{return n}}function C(J,H,B){return!J||typeof H!="string"?!1:R(J)(H,void 0,B)}function R(J,H={}){if(!J)return r;if(typeof J=="string"||M(J)){const B=s(J,H);if(B===n)return r;const ie=function(re,he){return!!B(re,he)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return Y(J,H)}function M(J){const H=J;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function T(J){return J.allBasenames||[]}function q(J){return J.allPaths||[]}function Y(J,H){const B=X(Object.getOwnPropertyNames(J).map(V=>G(V,J[V],H)).filter(V=>V!==n)),ie=B.length;if(!ie)return n;if(!B.some(V=>!!V.requiresSiblings)){if(ie===1)return B[0];const V=function(F,z){let x;for(let K=0,ee=B.length;K<ee;K++){const _=B[K](F,z);if(typeof _=="string")return _;(0,N.$fh)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const K of x){const ee=await K;if(typeof ee=="string")return ee}return null})():null},U=B.find(F=>!!F.allBasenames);U&&(V.allBasenames=U.allBasenames);const D=B.reduce((F,z)=>z.allPaths?F.concat(z.allPaths):F,[]);return D.length&&(V.allPaths=D),V}const re=function(V,U,D){let F,z;for(let x=0,K=B.length;x<K;x++){const ee=B[x];ee.requiresSiblings&&D&&(U||(U=(0,O.$oc)(V)),F||(F=U.substr(0,U.length-(0,O.$pc)(V).length)));const _=ee(V,U,F,D);if(typeof _=="string")return _;(0,N.$fh)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const x of z){const K=await x;if(typeof K=="string")return K}return null})():null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,U)=>U.allPaths?V.concat(U.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function G(J,H,B){if(H===!1)return n;const ie=s(J,B);if(ie===n)return n;if(typeof H=="boolean")return ie;if(H){const re=H.when;if(typeof re=="string"){const he=(te,V,U,D)=>{if(!D||!ie(te,V))return null;const F=re.replace("$(basename)",()=>U),z=D(F);return(0,N.$fh)(z)?z.then(x=>x?J:null):z?J:null};return he.requiresSiblings=!0,he}}return ie}function X(J,H){const B=J.filter(V=>!!V.basenames);if(B.length<2)return J;const ie=B.reduce((V,U)=>{const D=U.basenames;return D?V.concat(D):V},[]);let re;if(H){re=[];for(let V=0,U=ie.length;V<U;V++)re.push(H)}else re=B.reduce((V,U)=>{const D=U.patterns;return D?V.concat(D):V},[]);const he=function(V,U){if(typeof V!="string")return null;if(!U){let F;for(F=V.length;F>0;F--){const z=V.charCodeAt(F-1);if(z===47||z===92)break}U=V.substr(F)}const D=ie.indexOf(U);return D!==-1?re[D]:null};he.basenames=ie,he.patterns=re,he.allBasenames=ie;const te=J.filter(V=>!V.basenames);return te.push(he),te}function W(J,H){return(0,A.$ub)(J,H,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=void 0,e.$xn=I,e.$yn=f,e.$zn=E;function L(y){return y.toJSON()}class j{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:L(N.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:L(N.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:N.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$vn=j,e.$wn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function O(y,w,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return w.transformOutgoing(y);for(const c in y)if(Object.hasOwnProperty.call(y,c)){const p=O(y[c],w,h+1);p!==null&&(y[c]=p)}}return null}function I(y,w){const h=O(y,w,0);return h===null?y:h}function P(y,w,h,c){if(!y||c>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?N.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof A.$De)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const g=P(y[p],w,h,c+1);g!==null&&(y[p]=g)}}return null}function f(y,w){const h=P(y,w,!1,0);return h===null?y:h}function E(y,w){const h=P(y,w,!0,0);return h===null?y:h}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0,e.$Cn=P,e.$Dn=y,e.$Bn=new class{c(w){return this.a||(this.a=N.$zi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const c=(0,A.networkInterfaces)();for(const p in c){const g=c[p];if(g)for(const{mac:l,internal:u}of g)u||(h+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let I;async function P(w){return I||(I=(async()=>await f(w)||L.$Pg())()),I}async function f(w){try{const h=await new Promise((p,g)=>{ne(["crypto"],p,g)}),c=(0,j.$An)();return h.createHash("sha256").update(c,"utf8").digest("hex")}catch(h){w(h);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(O.$i){const h=await new Promise((c,p)=>{ne(["@vscode/windows-registry"],c,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return w(c),""}}return""}}),define(ae[145],ce([0,1,41,146,14,36]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DW=E,e.$EW=y;const O="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var f;(function(w){w.Wayland="wayland",w.XWayland="xwayland",w.X11="x11",w.Unknown="unknown"})(f||(f={}));async function E(w){const h=j.env[O];if(h)return h==="wayland"||h==="x11"?h:"unknown";if(j.env[I]){const p=j.env[P];if(p){const g=(0,L.$kc)(p,"wayland-0");try{return await(0,N.access)(g,A.constants.R_OK),"wayland"}catch(l){return w(l),"unknown"}}else return"unknown"}else return"x11"}function y(w,h){if(h)switch(h){case"auto":return w;case"x11":return w==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return w==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,41,146,274,5]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=O;async function O(I){if(j.$j||j.$i)return;let P;for(const f of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,N.open)(f,A.constants.R_OK);break}catch{}if(!P){I("Unable to retrieve release information from known identifier paths.");return}try{const f=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,L.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if(f.has(w)){const h=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=h:w==="ID_LIKE"?E.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=h)}}return E}catch(f){I(f)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=b;var w;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(G,X=w.UNLINK,W){if((0,O.$wg)(G))throw new Error("rimraf - will refuse to recursively delete root");return X===w.UNLINK?p(G):c(G,W)}async function c(G,X=(0,O.$Bg)((0,N.tmpdir)())){try{try{await A.promises.rename(G,X)}catch(W){return W.code==="ENOENT"?void 0:p(G)}p(X).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(G){return(0,L.promisify)(A.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function g(G){if((0,O.$wg)(G))throw new Error("rimraf - will refuse to recursively delete root");A.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function l(G,X){return d(await(X?u(G):(0,L.promisify)(A.readdir)(G)))}async function u(G){try{return await(0,L.promisify)(A.readdir)(G,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const X=[],W=await l(G);for(const J of W){let H=!1,B=!1,ie=!1;try{const re=await e.Promises.lstat((0,P.$kc)(G,J));H=re.isFile(),B=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}X.push({name:J,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>ie})}return X}function m(G){return d(A.readdirSync(G))}function d(G){return G.map(X=>typeof X=="string"?f.$j?(0,I.$$l)(X):X:(X.name=f.$j?(0,I.$$l)(X.name):X.name,X))}async function $(G){const X=await l(G),W=[];for(const J of X)await r.existsDirectory((0,P.$kc)(G,J))&&W.push(J);return W}function t(G,X=1e3){return new Promise(W=>{let J=!1;const H=setInterval(()=>{J||(J=!0,A.access(G,B=>{J=!1,B&&(clearInterval(H),W(void 0))}))},X)})}var r;(function(G){async function X(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(f.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw re}throw ie}}G.stat=X;async function W(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}G.existsFile=W;async function J(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}G.existsDirectory=J})(r||(e.SymlinkSupport=r={}));const n=new j.$Ch;function s(G,X,W){return n.queueFor(y.URI.file(G),()=>{const J=S(W);return new Promise((H,B)=>a(G,X,J,ie=>ie?B(ie):H()))},E.$Xg)}let i=!0;function o(G){i=G}function a(G,X,W,J){if(!i)return A.writeFile(G,X,{mode:W.mode,flag:W.flag},J);A.open(G,W.flag,W.mode,(H,B)=>{if(H)return J(H);A.writeFile(B,X,ie=>{if(ie)return A.close(B,()=>J(ie));A.fdatasync(B,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),A.close(B,he=>J(he))))})})}function b(G,X,W){const J=S(W);if(!i)return A.writeFileSync(G,X,{mode:J.mode,flag:J.flag});const H=A.openSync(G,J.flag,J.mode);try{A.writeFileSync(H,X);try{A.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{A.closeSync(H)}}function S(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function v(G,X,W=6e4){if(G!==X)try{f.$i&&typeof W=="number"?await k(G,X,Date.now(),W):await(0,L.promisify)(A.rename)(G,X)}catch(J){if(G.toLowerCase()!==X.toLowerCase()&&J.code==="EXDEV"||G.endsWith("."))await C(G,X,{preserveSymlinks:!1}),await h(G,w.MOVE);else throw J}}async function k(G,X,W,J,H=0){try{return await(0,L.promisify)(A.rename)(G,X)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${B}`),B;if(H===0){let ie=!1;try{const{stat:re}=await r.stat(X);re.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$uh)(Math.min(100,H*10)),k(G,X,W,J,H+1)}}async function C(G,X,W){return M(G,X,{root:{source:G,target:X},options:W,handledSourcePaths:new Set})}const R=511;async function M(G,X,W){if(W.handledSourcePaths.has(G))return;W.handledSourcePaths.add(G);const{stat:J,symbolicLink:H}=await r.stat(G);if(H){if(W.options.preserveSymlinks)try{return await Y(G,X,W)}catch{}if(H.dangling)return}return J.isDirectory()?T(G,X,J.mode&R,W):q(G,X,J.mode&R)}async function T(G,X,W,J){await e.Promises.mkdir(X,{recursive:!0,mode:W});const H=await l(G);for(const B of H)await M((0,P.$kc)(G,B),(0,P.$kc)(X,B),J)}async function q(G,X,W){await e.Promises.copyFile(G,X),await e.Promises.chmod(X,W)}async function Y(G,X,W){let J=await e.Promises.readlink(G);(0,O.$sg)(J,W.root.source,!f.$k)&&(J=(0,P.$kc)(W.root.target,J.substr(W.root.source.length+1))),await e.Promises.symlink(J,X)}e.Promises=new class{get access(){return(0,L.promisify)(A.access)}get stat(){return(0,L.promisify)(A.stat)}get lstat(){return(0,L.promisify)(A.lstat)}get utimes(){return(0,L.promisify)(A.utimes)}get read(){return(G,X,W,J,H)=>new Promise((B,ie)=>{A.read(G,X,W,J,H,(re,he,te)=>re?ie(re):B({bytesRead:he,buffer:te}))})}get readFile(){return(0,L.promisify)(A.readFile)}get write(){return(G,X,W,J,H)=>new Promise((B,ie)=>{A.write(G,X,W,J,H,(re,he,te)=>re?ie(re):B({bytesWritten:he,buffer:te}))})}get appendFile(){return(0,L.promisify)(A.appendFile)}get fdatasync(){return(0,L.promisify)(A.fdatasync)}get truncate(){return(0,L.promisify)(A.truncate)}get copyFile(){return(0,L.promisify)(A.copyFile)}get open(){return(0,L.promisify)(A.open)}get close(){return(0,L.promisify)(A.close)}get symlink(){return(0,L.promisify)(A.symlink)}get readlink(){return(0,L.promisify)(A.readlink)}get chmod(){return(0,L.promisify)(A.chmod)}get mkdir(){return(0,L.promisify)(A.mkdir)}get unlink(){return(0,L.promisify)(A.unlink)}get rmdir(){return(0,L.promisify)(A.rmdir)}get realpath(){return(0,L.promisify)(A.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return h}get rename(){return v}get copy(){return C}}}),define(ae[148],ce([0,1,41,14,5,27,31]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=I,e.$2q=P,e.$3q=f,e.$4q=E;function I(w){if(L.$k)return w;const h=(0,N.$nc)(w);if(w===h)return w;const c=((0,N.$oc)(w)||w).toLowerCase();try{const g=(0,O.readdirSync)(h).filter(l=>l.toLowerCase()===c);if(g.length===1){const l=I(h);if(l)return(0,N.$kc)(l,g[0])}else if(g.length>1){const l=g.indexOf(c);if(l>=0){const u=I(h);if(u)return(0,N.$kc)(u,g[l])}}}catch{}return null}async function P(w,h){if(L.$k)return w;const c=(0,N.$nc)(w);if(w===c)return w;const p=((0,N.$oc)(w)||w).toLowerCase();try{if(h?.isCancellationRequested)return null;const l=(await O.Promises.readdir(c)).filter(u=>u.toLowerCase()===p);if(l.length===1){const u=await P(c,h);if(u)return(0,N.$kc)(u,l[0])}else if(l.length>1){const u=l.indexOf(p);if(u>=0){const m=await P(c,h);if(m)return(0,N.$kc)(m,l[u])}}}catch{}return null}async function f(w){try{return await O.Promises.realpath(w)}catch{const c=y(w);return await O.Promises.access(c,A.constants.R_OK),c}}function E(w){try{return A.realpathSync(w)}catch{const c=y(w);return A.accessSync(c,A.constants.R_OK),c}}function y(w){return(0,j.$df)((0,N.$ic)(w),N.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$lm=P,e.$mm=f,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function P(y=L.env){return y.comspec||"cmd.exe"}function f(y){let w=[],h=!1;const c=function(p){if(h){w.push(p);return}(!y.send(p,l=>{if(l&&console.error(l),h=!1,w.length>0){const u=w.slice(0);w=[],u.forEach(m=>c(m))}})||N.$i)&&(h=!0)};return{send:c}}var E;(function(y){async function w(h,c,p){if(A.$jc(h))return h;if(c===void 0&&(c=L.cwd()),A.$nc(h)!=="."||(p===void 0&&O.$6f(L.env.PATH)&&(p=L.env.PATH.split(A.$uc)),p===void 0||p.length===0))return A.$kc(c,h);async function l(u){if(await I.Promises.exists(u)){let m;try{m=await I.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(m=await I.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(const u of p){let m;if(A.$jc(u)?m=A.$kc(u,h):m=A.$kc(c,u,h),await l(m))return m;let d=m+".com";if(await l(d)||(d=m+".exe",await l(d)))return d}return A.$kc(c,h)}y.findExecutable=w})(E||(e.win32=E={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=L;function L(O){return new Promise((I,P)=>{let f;const E=new Map;function y(h,c,p,g,l){const u=E.get(c);if(h===O||u){const m={name:w(p),cmd:p,pid:h,ppid:c,load:g,mem:l};E.set(h,m),h===O&&(f=m),u&&(u.children||(u.children=[]),u.children.push(m),u.children.length>1&&(u.children=u.children.sort((d,$)=>d.pid-$.pid)))}}function w(h){const c=/--utility-sub-type=network/i,p=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let m=u.exec(h);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(h)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const d=/[a-zA-Z-]+\.js/g;let $="";do m=d.exec(h),m&&($+=m+" ");while(m);return $&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${$})`:h}if(process.platform==="win32"){const h=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,p)=>{ne(["@vscode/windows-process-tree"],c,p)}).then(c=>{c.getProcessList(O,p=>{if(!p){P(new Error(`Root process ${O} not found`));return}c.getProcessCpuUsage(p,g=>{const l=new Map;g.forEach(u=>{const m=h(u.commandLine||"");l.set(u.pid,{name:w(m),cmd:m,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),f=l.get(O),f?(l.forEach(u=>{const m=l.get(u.ppid);m&&(m.children||(m.children=[]),m.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((m,d)=>m.pid-d.pid))}),I(f)):P(new Error(`Root process ${O} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let h=function(){let c=[f];const p=[];for(;c.length;){const l=c.shift();l&&(p.push(l.pid),l.children&&(c=c.concat(l.children)))}let g=JSON.stringify(N.$Ng.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+p.join(" "),(0,A.exec)(g,{},(l,u,m)=>{if(l||m)P(l||new Error(m.toString()));else{const d=u.toString().split(`
`);for(let $=0;$<p.length;$++){const t=E.get(p[$]);t.load=parseFloat(d[$])}if(!f){P(new Error(`Root process ${O} not found`));return}I(f)}})};(0,A.exec)("which ps",{},(c,p,g)=>{if(c||g)if(process.platform!=="linux")P(c||new Error(g.toString()));else{const l=JSON.stringify(N.$Ng.asFileUri("vs/base/node/ps.sh").fsPath);(0,A.exec)(l,{},(u,m,d)=>{u||d?P(u||new Error(d.toString())):(j(m,y),h())})}else{const l=p.toString().trim();(0,A.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,d,$)=>{m||$&&!$.includes("screen size is bogus")?P(m||new Error($.toString())):(j(d,y),process.platform==="linux"?h():f?I(f):P(new Error(`Root process ${O} not found`)))})}})}})}function j(O,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=O.toString().split(`
`);for(const E of f){const y=P.exec(E.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var Ee=this&&this.__decorate||function(ne,e,A,N){var L=arguments.length,j=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,A):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,A,N);else for(var I=ne.length-1;I>=0;I--)(O=ne[I])&&(j=(L<3?O(j):L>3?O(e,A,j):O(e,A))||j);return L>3&&j&&Object.defineProperty(e,A,j),j};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.ProxyChannel=e.$bi=e.$$h=e.$0h=e.$9h=e.RequestInitiator=e.$8h=e.$5h=e.$4h=void 0,e.$6h=o,e.$7h=a,e.$_h=R,e.$ai=M;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function c(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function g(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function u(H){let B=0;for(let ie=0;;ie+=7){const re=H.read(1);if(B|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return B}}const m=n(0);function d(H,B){if(B===0){H.write(m);return}let ie=0;for(let he=B;he!==0;he=he>>>7)ie++;const re=L.$De.alloc(ie);for(let he=0;B!==0;he++)re.buffer[he]=B&127,B=B>>>7,B>0&&(re.buffer[he]|=128);H.write(re)}class ${constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$4h=$;class t{constructor(){this.a=[]}get buffer(){return L.$De.concat(this.a)}write(B){this.a.push(B)}}e.$5h=t;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function n(H){const B=L.$De.alloc(1);return B.writeUInt8(H,0),B}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(H,B){if(typeof B>"u")H.write(s.Undefined);else if(typeof B=="string"){const ie=L.$De.fromString(B);H.write(s.String),d(H,ie.byteLength),H.write(ie)}else if(i&&Buffer.isBuffer(B)){const ie=L.$De.wrap(B);H.write(s.Buffer),d(H,ie.byteLength),H.write(ie)}else if(B instanceof L.$De)H.write(s.VSBuffer),d(H,B.byteLength),H.write(B);else if(Array.isArray(B)){H.write(s.Array),d(H,B.length);for(const ie of B)o(H,ie)}else if(typeof B=="number"&&(B|0)===B)H.write(s.Uint),d(H,B);else{const ie=L.$De.fromString(JSON.stringify(B));H.write(s.Object),d(H,ie.byteLength),H.write(ie)}}function a(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(u(H)).toString();case r.Buffer:return H.read(u(H)).buffer;case r.VSBuffer:return H.read(u(H));case r.Array:{const ie=u(H),re=[];for(let he=0;he<ie;he++)re.push(a(H));return re}case r.Object:return JSON.parse(H.read(u(H)).toString());case r.Int:return u(H)}}class b{constructor(B,ie,re=null,he=1e3){this.h=B,this.j=ie,this.k=re,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,g(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,g(B.type),B.data);return}}}o(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.p(re.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 100:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.s({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 102:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.t({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 101:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]});case 103:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=new j.$ne;let he;try{he=ie.call(this.j,B.name,B.arg,re.token)}catch(U){he=Promise.reject(U)}const te=B.id;he.then(U=>{this.m({id:te,data:U,type:201})},U=>{U instanceof Error?this.m({id:te,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:te,data:U,type:203})}).finally(()=>{V.dispose(),this.d.delete(B.id)});const V=(0,f.$Tc)(()=>re.cancel());this.d.set(B.id,V)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=B.id,te=ie.listen(this.j,B.name,B.arg)(V=>this.m({id:re,data:V,type:204}));this.d.set(B.id,te)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:re})}w(B){const ie=this.g.get(B);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$8h=b;var S;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class v{constructor(B,ie=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$ce,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(B){const ie=this;return{call(re,he,te){return ie.a?Promise.reject(new I.$5):ie.m(B,re,he,te)},listen(re,he){return ie.a?P.Event.None:ie.o(B,re,he)}}}m(B,ie,re,he=j.CancellationToken.None){const te=this.g++,U={id:te,type:100,channelName:B,name:ie,arg:re};if(he.isCancellationRequested)return Promise.reject(new I.$5);let D;return new Promise((z,x)=>{if(he.isCancellationRequested)return x(new I.$5);const K=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(te),z(ue.data);break;case 202:{this.f.delete(te);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(te),x(ue.data);break}};this.f.set(te,se),this.p(U)};let ee=null;this.b===l.Idle?K():(ee=(0,N.$gh)(se=>this.u()),ee.then(()=>{ee=null,K()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:te,type:101}),x(new I.$5)},Q=he.onCancellationRequested(_);D=(0,f.$Sc)((0,f.$Tc)(_),Q),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(B,ie,re){const he=this.g++,V={id:he,type:102,channelName:B,name:ie,arg:re};let U=null;const D=new P.$ce({onWillAddFirstListener:()=>{U=(0,N.$gh)(z=>this.u()),U.then(()=>{U=null,this.d.add(D),this.p(V)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(D),this.p({id:he,type:103}))}}),F=z=>D.fire(z.data);return this.f.set(he,F),D.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${c(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,c(B.type));return}}}q(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.r(re.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 200:return this.j?.logIncoming(B.byteLength,0,0,g(te)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,re[1],0,g(te),he),this.t({type:re[0],id:re[1],data:he})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$9h=v,Ee([O.$Xh],v.prototype,"onDidInitializePromise",null);class k{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,re){this.a=new Map,this.f=new Set,this.g=new P.$ce,this.onDidAddConnection=this.g.event,this.h=new P.$ce,this.onDidRemoveConnection=this.h.event,this.j=new f.$Uc,this.j.add(B(({protocol:he,onDidClientDisconnect:te})=>{const V=P.Event.once(he.onMessage);this.j.add(V(U=>{const D=new $(U),F=a(D),z=new b(he,F,ie,re),x=new v(he,ie);this.a.forEach((ee,_)=>z.registerChannel(_,ee));const K={channelServer:z,channelClient:x,ctx:F};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{z.dispose(),x.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(B,ie){const re=this;return{call(he,te,V){let U;if((0,w.$hg)(ie)){const F=(0,A.$4b)(re.connections.filter(ie));U=F?Promise.resolve(F):P.Event.toPromise(P.Event.filter(re.onDidAddConnection,ie))}else U=ie.routeCall(re,he,te);const D=U.then(F=>F.channelClient.getChannel(B));return R(D).call(he,te,V)},listen(he,te){if((0,w.$hg)(ie))return re.k(B,ie,he,te);const V=ie.routeEvent(re,he,te).then(U=>U.channelClient.getChannel(B));return R(V).listen(he,te)}}}k(B,ie,re,he){const te=this;let V;const U=new P.$ce({onWillAddFirstListener:()=>{V=new f.$Uc;const D=new P.$ie,F=new Map,z=K=>{const _=K.channelClient.getChannel(B).listen(re,he),Q=D.add(_);F.set(K,Q)},x=K=>{const ee=F.get(K);ee&&(ee.dispose(),F.delete(K))};te.connections.filter(ie).forEach(z),P.Event.filter(te.onDidAddConnection,ie)(z,void 0,V),te.onDidRemoveConnection(x,void 0,V),D.event(U.fire,U,V),V.add(D)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return U.event}registerChannel(B,ie){this.a.set(B,ie);for(const re of this.f)re.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$0h=k;class C{constructor(B,ie,re=null){const he=new t;o(he,ie),B.send(he.buffer),this.a=new v(B,re),this.d=new b(B,ie,re)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$$h=C;function R(H){return{call(B,ie,re){return H.then(he=>he.call(B,ie,re))},listen(B,ie){const re=new P.$le;return H.then(he=>re.input=he.listen(B,ie)),re.event}}}function M(H){let B=!1;return{call(ie,re,he){return B?H.call(ie,re,he):(0,N.$uh)(0).then(()=>B=!0).then(()=>H.call(ie,re,he))},listen(ie,re){if(B)return H.listen(ie,re);const he=new P.$le;return(0,N.$uh)(0).then(()=>B=!0).then(()=>he.input=H.listen(ie,re)),he.event}}}class T{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$bi=T;var q;(function(H){function B(te,V,U){const D=te,F=U&&U.disableMarshalling,z=new Map;for(const x in D)re(x)&&z.set(x,P.Event.buffer(D[x],!0,void 0,V));return new class{listen(x,K,ee){const _=z.get(K);if(_)return _;const Q=D[K];if(typeof Q=="function"){if(he(K))return Q.call(D,ee);if(re(K))return z.set(K,P.Event.buffer(D[K],!0,void 0,V)),z.get(K)}throw new I.$bb(`Event not found: ${K}`)}call(x,K,ee){const _=D[K];if(typeof _=="function"){if(!F&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,E.$3h)(ee[se]);let Q=_.apply(D,ee);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new I.$bb(`Method not found: ${K}`)}}}H.fromService=B;function ie(te,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(D,F){if(typeof F=="string")return V?.properties?.has(F)?V.properties.get(F):he(F)?function(z){return te.listen(F,z)}:re(F)?te.listen(F):async function(...z){let x;V&&!(0,w.$cg)(V.context)?x=[V.context,...z]:x=z;const K=await te.call(F,x);return U?K:(0,E.$3h)(K)};throw new I.$bb(`Property not found: ${String(F)}`)}})}H.toService=ie;function re(te){return te[0]==="o"&&te[1]==="n"&&y.$uf(te.charCodeAt(2))}function he(te){return/^onDynamic/.test(te)&&y.$uf(te.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function X(H){return Array.isArray(H)?H.map(G):G(H)}function W(H,B,ie,re,he,te,V){V=X(V);const U=Y[he],D=U[re%U.length];let F=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(te)?(F=F.concat(V),F.push(")")):F.push(V),console.log.apply(console,F)}class J{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,re,he,te){this.b+=B,W(this.d,this.b,B,ie,re,he,te)}logIncoming(B,ie,re,he,te){this.a+=B,W(this.f,this.a,B,ie,re,he,te)}}e.$ci=J}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.ProtocolConstants=e.$di=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(S,v){if(!i.has(S)){const k=String(++o);i.set(S,k)}return i.get(S)}function b(S,v,k,C){if(!s.enableDiagnostics)return;const R=a(S,v);if(C instanceof A.$De||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const M=A.$De.alloc(C.byteLength);M.set(C),s.records.push({timestamp:Date.now(),id:R,label:v,type:k,buff:M})}else s.records.push({timestamp:Date.now(),id:R,label:v,type:k,data:C})}s.traceSocketEvent=b})(I||(e.SocketDiagnostics=I={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let f=null;function E(){return f||(f=A.$De.alloc(0)),f}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const v=this.a[0];return o&&(this.a.shift(),this.b-=i),v}if(this.a[0].byteLength>i){const v=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),v}const a=A.$De.alloc(i);let b=0,S=0;for(;i>0;){const v=this.a[S];if(v.byteLength>i){const k=v.slice(0,i);a.set(k,b),b+=i,o&&(this.a[S]=v.slice(i),this.b-=i),i-=i}else a.set(v,b),b+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):S++,i-=v.byteLength}return a}}e.$di=y;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class p{constructor(i,o,a,b){this.type=i,this.id=o,this.ack=a,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Vc{constructor(i){super(),this.f=this.B(new N.$ce),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,b=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new p(a,b,S,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=A.$De.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=A.$De.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends L.$Vc{constructor(i){super(),this.f=new N.$ce,this.onMessage=this.f.event,this.g=new N.$ce,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$ei=u;class m extends j.$$h{static fromSocket(i,o){return new m(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$fi=m;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ce({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$gi=d;class ${constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new $(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let b=0;b<r.a;b++)i-this.c[b]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Uc,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,E());this.p.write(i)}sendResume(){const i=new p(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new L.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new p(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new p(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new p(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,b=Date.now()-this.n;if(o>=2e4&&a>=2e4&&b>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-o,2e4-a,2e4-b,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,E());this.p.write(i)}}e.$hi=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,42]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class c extends h.$8h{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",u=>L.$De.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Wq=c;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new P.$ce,this.onDidProcessExit=this.h.event;const m=u&&u.timeout?u.timeout:6e4;this.b=new N.$qh(m),this.d=null,this.f=null}getChannel(l){const u=this;return{call(m,d,$){return u.k(l,m,d,$)},listen(m,d){return u.l(l,m,d)}}}k(l,u,m,d=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const $=this.n(l),t=(0,N.$gh)(s=>$.call(u,m,s)),r=d.onCancellationRequested(()=>t.cancel()),n=(0,f.$Tc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,m){if(!this.b)return P.Event.None;this.b.cancel();let d;const $=new P.$ce({onWillAddFirstListener:()=>{d=this.n(l).listen(u,m)($.fire,$),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$Zn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$km)(u.env),this.d=(0,A.fork)(this.i,l,u);const m=new P.$ce,$=P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Sq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(L.$De.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,y.$mm)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),n=m.event,s={send:r,onMessage:n};this.f=new h.$9h(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),$.dispose(),this.c.forEach(b=>(0,f.$Qc)(b)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Xq=p}),define(ae[151],ce([0,1,134,15,42,3,13,17]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VW=void 0,e.$WW=E;class P{constructor(w){this.a=w,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?N.$De.wrap(h.data):N.$De.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class f extends L.$0h{static b(w){(0,O.$dg)((0,A.$UW)(process),"Electron Utility Process");const h=new j.$ce;return process.parentPort.on("message",c=>{if(w?.handledClientConnection(c))return;const p=(0,I.$Ob)(c.ports);p&&h.fire(p)}),j.Event.map(h.event,c=>({protocol:new P(c),onDidClientDisconnect:j.Event.fromNodeEventEmitter(c,"close")}))}constructor(w){super(f.b(w))}}e.$VW=f;function E(y,w,h){const c=p=>{p.data===w&&(y.removeListener("message",c),h())};y.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.StorageState=e.StorageHint=void 0,e.$Sp=P;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function P(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}var f;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(f||(e.StorageState=f={}));class E extends L.$Vc{static{this.a=100}constructor(h,c=Object.create(null)){super(),this.r=h,this.s=c,this.b=this.B(new N.$fe),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=this.B(new A.$rh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((c,p)=>this.w(p,c)),h.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(h,c){if(this.c===f.Closed)return;let p=!1;(0,O.$cg)(c)?p=this.f.delete(h):this.f.get(h)!==c&&(this.f.set(h,c),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,c){const p=this.f.get(h);return(0,O.$cg)(p)?c:p}getBoolean(h,c){const p=this.get(h);return(0,O.$cg)(p)?c:p==="true"}getNumber(h,c){const p=this.get(h);return(0,O.$cg)(p)?c:parseInt(p,10)}getObject(h,c){const p=this.get(h);return(0,O.$cg)(p)?c:(0,j.$2h)(p)}async set(h,c,p=!1){if(this.c===f.Closed)return;if((0,O.$cg)(c))return this.delete(h,p);const g=(0,O.$8f)(c)||Array.isArray(c)?(0,j.$1h)(c):String(c);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,c=!1){if(!(this.c===f.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:c}),this.D()}async optimize(){if(this.c!==f.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=f.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Tp=E;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((c,p)=>this.a.set(p,c)),h.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$Up=y}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,152]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.zip=g,e.$gq=l,e.$hq=m,e.$dq="end of central directory record signature not found";const P=new RegExp(e.$dq);class f extends Error{constructor($,t){let r=t.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=t}}e.$eq=f;function E(d){const $=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>$&t).reduce((t,r)=>t+r,$&61440)}function y(d){if(d instanceof f)return d;let $;return P.test(d.message)&&($="CorruptZip"),new f($,d)}function w(d,$,t,r,n,s){const i=L.$nc($),o=L.$kc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(I.localize(0,null,$)));const a=L.$kc(r,$);let b;return s.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((S,v)=>{if(!s.isCancellationRequested)try{b=(0,A.createWriteStream)(a,{mode:t}),b.once("close",()=>S()),b.once("error",v),d.once("error",v),d.pipe(b)}catch(k){v(k)}}))}function h(d,$,t,r){let n=(0,N.$gh)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((o,a)=>{const b=new N.$oh,S=v=>{v.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===s?o():a(new f("Incomplete",new Error(I.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",v=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(v.fileName)){S(r);return}const k=v.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(k)){const M=L.$kc($,k);n=(0,N.$gh)(T=>O.Promises.mkdir(M,{recursive:!0}).then(()=>S(T)).then(void 0,a));return}const C=p(d,v),R=E(v);n=(0,N.$gh)(M=>b.queue(()=>C.then(T=>w(T,k,R,$,t,M).then(()=>S(M)))).then(null,a))})}).finally(()=>i.dispose())}async function c(d,$=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(d,$?{lazyEntries:!0}:void 0,(s,i)=>{s?n(y(s)):r((0,j.$eg)(i))})})}function p(d,$){return new Promise((t,r)=>{d.openReadStream($,(n,s)=>{n?r(y(n)):t((0,j.$eg)(s))})})}async function g(d,$){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;$.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,A.createWriteStream)(d);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(d))})}function l(d,$,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(d,!0);return t.overwrite&&(s=s.then(i=>O.Promises.rm($).then(()=>i))),s.then(i=>h(i,$,{sourcePathRegex:n},r))}function u(d,$){return c(d).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===$&&p(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(I.localize(2,null,$))))}))}function m(d,$){return u(d,$).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.TokenType=void 0;var L;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...f){switch(f.length){case 1:return(0,N.localize)(0,null,f[0]);case 2:return(0,N.localize)(1,null,f[0],f[1]);case 3:return(0,N.localize)(2,null,f[0],f[1],f[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,A.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(h)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=P.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const c=this.c.charCodeAt(E);if(y)y=!1;else if(c===47&&!w){E++;break}else c===91?w=!0:c===92?y=!0:c===93&&(w=!1);E++}for(;E<this.c.length&&P.a.has(this.c.charCodeAt(E));)E++;this.e=E;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$oj=P}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=E,e.$5m=y,e.$2m=/^([^.]+\..+)[:=](.+)$/;class f{get appRoot(){return(0,j.$nc)(L.$Ng.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.$7g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$7g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,A.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",h)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$7g)(P.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$7g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$7g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$7g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,j.$kc)(h,"argv.json")):(0,I.$7g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$lc)(h):(0,j.$ic)((0,j.$kc)(L.$Ng.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,j.$lc)(h)):P.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$lc)(h);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const p=O.env.VSCODE_PORTABLE;return p?(0,j.$kc)(p,"extensions"):(0,I.$7g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(c=>/^[^:/?#]+?:\/\//.test(c)?P.URI.parse(c):P.URI.file((0,j.$ic)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,j.$ic)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$2m.test(h))}get extensionLogLevel(){const h=[];for(const c of this.args.log||[]){const p=e.$2m.exec(c);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,I.$7g)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,j.$kc)(h,"policy.json")):(0,I.$7g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,c,p){this.a=h,this.b=c,this.c=p,this.editSessionId=this.args.editSessionId}}e.$3m=f,Ee([N.$Xh],f.prototype,"appRoot",null),Ee([N.$Xh],f.prototype,"userHome",null),Ee([N.$Xh],f.prototype,"userDataPath",null),Ee([N.$Xh],f.prototype,"appSettingsHome",null),Ee([N.$Xh],f.prototype,"tmpDir",null),Ee([N.$Xh],f.prototype,"cacheHome",null),Ee([N.$Xh],f.prototype,"stateResource",null),Ee([N.$Xh],f.prototype,"userRoamingDataHome",null),Ee([N.$Xh],f.prototype,"userDataSyncHome",null),Ee([N.$Xh],f.prototype,"sync",null),Ee([N.$Xh],f.prototype,"machineSettingsResource",null),Ee([N.$Xh],f.prototype,"workspaceStorageHome",null),Ee([N.$Xh],f.prototype,"localHistoryHome",null),Ee([N.$Xh],f.prototype,"keyboardLayoutResource",null),Ee([N.$Xh],f.prototype,"argvResource",null),Ee([N.$Xh],f.prototype,"isExtensionDevelopment",null),Ee([N.$Xh],f.prototype,"untitledWorkspacesHome",null),Ee([N.$Xh],f.prototype,"builtinExtensionsPath",null),Ee([N.$Xh],f.prototype,"extensionsPath",null),Ee([N.$Xh],f.prototype,"extensionDevelopmentLocationURI",null),Ee([N.$Xh],f.prototype,"extensionDevelopmentKind",null),Ee([N.$Xh],f.prototype,"extensionTestsLocationURI",null),Ee([N.$Xh],f.prototype,"debugExtensionHost",null),Ee([N.$Xh],f.prototype,"logLevel",null),Ee([N.$Xh],f.prototype,"extensionLogLevel",null),Ee([N.$Xh],f.prototype,"serviceMachineIdResource",null),Ee([N.$Xh],f.prototype,"disableTelemetry",null),Ee([N.$Xh],f.prototype,"disableWorkspaceTrust",null),Ee([N.$Xh],f.prototype,"useInMemorySecretStorage",null),Ee([N.$Xh],f.prototype,"policyFile",null);function E(w,h){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}function y(w,h,c,p,g,l){const m=Number(h||w)||(p?null:c),d=m?!!h:!1;let $;if(l)try{$=JSON.parse(l)}catch{}return{port:m,break:d,debugId:g,env:$}}}),function(){"use strict";function ne(e,A,N){function L(O,I){const P=j(O,I),f=[P];return e.isAbsolute(P)||f.unshift(N),e.resolve(...f)}function j(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,I);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(y,"AppData","Roaming")}break;case"darwin":f=e.join(A.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,I)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,A,N){return ne(e,A,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=ne(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=O,e.$8m=I;class j extends N.$3m{constructor(f,E){super(f,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,L.getUserDataPath)(f,E.nameShort)},E)}}e.$6m=j;function O(P,f){return(0,N.$5m)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,f,P.extensionEnvironment)}function I(P,f){return(0,N.$5m)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,f,P.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=L;function L(O,I,P,f){try{j(O,I,P,f)}catch(E){O.error(E?.message??E)}return I}function j(O,I,P,f){const E=(y,w,h)=>{const c=y[w];if((0,A.$6f)(c)){const p=c,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const l=p.substr(1,g-2);let u=P[l];u===void 0&&f&&(u=f[l]);const m=typeof u=="string"?u:u?.message,d=f?.[l],$=typeof d=="string"?d:d?.message;if(!m){$||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,l)}`);return}if(h&&(w==="title"||w==="category")&&$&&$!==m){const t={value:m,original:$};y[w]=t}else y[w]=m}}else if((0,A.$8f)(c))for(const p in c)c.hasOwnProperty(p)&&(p==="commands"?E(c,p,!0):E(c,p,h));else if(Array.isArray(c))for(let p=0;p<c.length;p++)E(c,p,h)};for(const y in I)I.hasOwnProperty(y)&&E(I,y)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=L;function L(j){return(0,A.$hq)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;class A{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$9dc=A;class N{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$0dc=N}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=P,e.$Ep=f,e.$Fp=E,e.$Gp=y,e.$Hp=w,e.$Ip=h,e.$Jp=c;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||O.test(l)}function f(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(l){if(!l)return null;const u=l.majorBase,m=l.majorMustEqual,d=l.minorBase;let $=l.minorMustEqual;const t=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(u===0||($=!1),r=!1);let n=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:m,minorBase:d,minorMustEqual:$,patchBase:t,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}function y(l,u,m){let d;typeof l=="string"?d=E(f(l)):d=l;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let t;if(typeof m=="string"?t=E(f(m)):t=m,!d||!t)return!1;const r=d.majorBase,n=d.minorBase,s=d.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const b=t.notBefore;let S=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||$&&$<b?!1:s>=a:(r===1&&i===0&&(!S||!v||!k)&&(i=1,o=0,a=0,S=!0,v=!1,k=!1),r<i?!1:r>i?!S:n<o?!1:n>o?!v:s<a?!1:s>a?!k:!($&&$<b))}function w(l,u,m,d,$){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof d.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!d.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const s=(0,A.$7g)(m,d.main);(0,A.$1g)(s,m)||t.push([N.default.Warning,L.localize(10,null,s.path,m.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const s=(0,A.$7g)(m,d.browser);(0,A.$1g)(s,m)||t.push([N.default.Warning,L.localize(12,null,s.path,m.path)])}}if(!j.valid(d.version))return t.push([N.default.Error,L.localize(13,null)]),t;const r=[];if(!h(l,u,d,$,r))for(const s of r)t.push([N.default.Error,s]);return t}function h(l,u,m,d,$){return d||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(l,u,m.engines.vscode,$)}function c(l,u,m){return l==="*"||p(u,m,l)}function p(l,u,m,d=[]){const $=E(f(m));if(!$)return d.push(L.localize(14,null,m)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return d.push(L.localize(15,null,m)),!1}else if(!$.majorMustEqual)return d.push(L.localize(16,null,m)),!1;return y(l,u,$)?!0:(d.push(L.localize(17,null,l,m)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let u=0,m=l.length;u<m;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=L;async function L(j,O,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await O.readFile(j.serviceMachineIdResource)).value.toString();P=(0,N.$Og)(E)?E:null}catch{P=null}if(!P){P=(0,N.$Pg)();try{await O.writeFile(j.serviceMachineIdResource,A.$De.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=void 0;class A{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$qi=A}),define(ae[191],ce([0,1,72]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ts=j,e.$us=O;const N=[];var L;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(I,P,f){P instanceof A.$qi||(P=new A.$qi(P,[],!!f)),N.push([I,P])}function O(){return N}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;class A{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$0q=A;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const I=this.lookupOrInsertNode(j),P=this.lookupOrInsertNode(O);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let I=this.a.get(O);return I||(I=new A(O,j),this.a.set(O,I)),I}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,I]of this.a)j.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const I=new Set([j]),P=this.c(O,I);if(P)return P}}c(j,O){for(const[I,P]of j.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const f=this.c(P,O);if(f)return f;O.delete(I)}}}e.$$q=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e._util=void 0,e.$ti=L,e.$ui=j;var A;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(A||(e._util=A={})),e.$si=L("instantiationService");function N(O,I,P){I[A.DI_TARGET]===I?I[A.DI_DEPENDENCIES].push({id:O,index:P}):(I[A.DI_DEPENDENCIES]=[{id:O,index:P}],I[A.DI_TARGET]=I)}function L(O){if(A.serviceIds.has(O))return A.serviceIds.get(O);const I=function(P,f,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,P,E)};return I.toString=()=>O,A.serviceIds.set(O,I),I}function j(O){return O}}),define(ae[193],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0,e.$Idc=(0,A.$ti)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Zi=void 0,e.$1i=j,e.$2i=O,e.$3i=P,e.$4i=f,e.$5i=E,e.$6i=y,e.$7i=w,e.$8i=c,e.$9i=p,e.$0i=g,e.$Zi=(0,L.$ti)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function f(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function E(l,u){const m=Object.create(null);for(const d in l)y(m,d,l[d],u);return m}function y(l,u,m,d){const $=u.split("."),t=$.pop();let r=l;for(let n=0;n<$.length;n++){const s=$[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is null`);return}break;default:d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function w(l,u){const m=u.split(".");h(l,m)}function h(l,u){const m=u.shift();if(u.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const d=l[m];typeof d=="object"&&!Array.isArray(d)&&(h(d,u),Object.keys(d).length===0&&delete l[m])}}function c(l,u,m){function d(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const $=u.split("."),t=d(l,$);return typeof t>"u"?m:t}function p(l,u,m){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?A.$8f(l[d])&&A.$8f(u[d])?p(l[d],u[d],m):m&&(l[d]=u[d]):l[d]=u[d])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$rj=e.$qj=e.ContextKeyExprType=void 0,e.$pj=f,e.$sj=r,e.$tj=n,e.$Mj=he;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",A.$j),P.set("isLinux",A.$k),P.set("isWindows",A.$i),P.set("isWeb",A.$o),P.set("isMacNative",A.$j&&!A.$o),P.set("isEdge",A.$H),P.set("isFirefox",A.$F),P.set("isChrome",A.$E),P.set("isSafari",A.$G);function f(U,D){if(P.get(U)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(U,D)}const E=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),c=(0,O.localize)(1,null),p=(0,O.localize)(2,null),g=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),m=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=w){this.k=D,this.d=new L.$oj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const z=this.D(),x=z.type===17?u:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:L.$oj.getLexeme(z),additionalInfo:x}),$.c}return F}catch(F){if(F!==$.c)throw F;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const F=this.o();D.push(F)}return D.length===1?D[0]:t.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const F=this.s();D.push(F)}return D.length===1?D[0]:t.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,g),F?.negate()}case 17:return this.z(),C.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,g),F}case 17:{const F=D.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const K=x.lexeme,ee=K.lastIndexOf("/"),_=ee===K.length-1?void 0:this.w(K.substring(ee+1));let Q;try{Q=new RegExp(K.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return G.create(F,Q)}switch(x.type){case 10:case 19:{const K=[x.lexeme];this.z();let ee=this.D(),_=0;for(let fe=0;fe<x.lexeme.length;fe++)x.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--}if(_<0)break;K.push(L.$oj.getLexeme(ee)),this.z(),ee=this.D()}const Q=K.join(""),se=Q.lastIndexOf("/"),ue=se===Q.length-1?void 0:this.w(Q.substring(se+1));let ge;try{ge=new RegExp(Q.substring(1,se),ue)}catch{throw this.B("REGEX",x)}return t.regex(F,ge)}case 18:{const K=x.lexeme;this.z();let ee=null;if(!(0,N.$5e)(K)){const _=K.indexOf("/"),Q=K.lastIndexOf("/");if(_!==Q&&_>=0){const se=K.slice(_+1,Q),ue=K[Q+1]==="i"?"i":"";try{ee=new RegExp(se,ue)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return G.create(F,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const x=this.u();return t.notIn(F,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return t.equals(F,x);switch(x){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return t.notEquals(F,x);switch(x){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,x)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),M.create(F,this.u());case 8:return this.z(),T.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:d}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,F){if(this.C(D))return this.z();throw this.B(F,this.D())}B(D,F,z){const x=(0,O.localize)(8,null,D,L.$oj.getLexeme(F)),K=F.offset,ee=L.$oj.getLexeme(F);return this.h.push({message:x,offset:K,lexeme:ee,additionalInfo:z}),$.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qj=$;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(D){return a.create(D)}static equals(D,F){return b.create(D,F)}static notEquals(D,F){return k.create(D,F)}static regex(D,F){return G.create(D,F)}static in(D,F){return S.create(D,F)}static notIn(D,F){return v.create(D,F)}static not(D){return C.create(D)}static and(...D){return J.create(D,null,!0)}static or(...D){return H.create(D,null,!0)}static greater(D,F){return M.create(D,F)}static greaterEquals(D,F){return T.create(D,F)}static smaller(D,F){return q.create(D,F)}static smallerEquals(D,F){return Y.create(D,F)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$rj=t;function r(U){const D=new $({regexParsingWithErrorRecovery:!1});return U.map(F=>(D.parse(F),D.lexingErrors.length>0?D.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(U,D){const F=U?U.substituteConstants():void 0,z=D?D.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}function s(U,D){return U.cmp(D)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$uj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return i.INSTANCE}}e.$vj=o;class a{static create(D,F=null){const z=P.get(D);return typeof z=="boolean"?z?o.INSTANCE:i.INSTANCE:new a(D,F)}constructor(D,F){this.key=D,this.c=F,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=P.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:i.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$wj=a;class b{static create(D,F,z=null){if(typeof F=="boolean")return F?a.create(D,z):C.create(D,z);const x=P.get(D);return typeof x=="boolean"?F===(x?"true":"false")?o.INSTANCE:i.INSTANCE:new b(D,F,z)}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=P.get(this.c);if(typeof D=="boolean"){const F=D?"true":"false";return this.d===F?o.INSTANCE:i.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$xj=b;class S{static create(D,F){return new S(D,F)}constructor(D,F){this.d=D,this.f=F,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:re(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.f),z=D.getValue(this.d);return Array.isArray(F)?F.includes(z):typeof z=="string"&&typeof F=="object"&&F!==null?E.call(F,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$yj=S;class v{static create(D,F){return new v(D,F)}constructor(D,F){this.d=D,this.f=F,this.type=11,this.c=S.create(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zj=v;class k{static create(D,F,z=null){if(typeof F=="boolean")return F?C.create(D,z):a.create(D,z);const x=P.get(D);return typeof x=="boolean"?F===(x?"true":"false")?i.INSTANCE:o.INSTANCE:new k(D,F,z)}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=P.get(this.c);if(typeof D=="boolean"){const F=D?"true":"false";return this.d===F?i.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Aj=k;class C{static create(D,F=null){const z=P.get(D);return typeof z=="boolean"?z?i.INSTANCE:o.INSTANCE:new C(D,F)}constructor(D,F){this.c=D,this.d=F,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=P.get(this.c);return typeof D=="boolean"?D?i.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Bj=C;function R(U,D){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?D(U):i.INSTANCE}class M{static create(D,F,z=null){return R(F,x=>new M(D,x,z))}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Cj=M;class T{static create(D,F,z=null){return R(F,x=>new T(D,x,z))}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Dj=T;class q{static create(D,F,z=null){return R(F,x=>new q(D,x,z))}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Ej=q;class Y{static create(D,F,z=null){return R(F,x=>new Y(D,x,z))}constructor(D,F,z){this.c=D,this.d=F,this.f=z,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Fj=Y;class G{static create(D,F){return new G(D,F)}constructor(D,F){this.d=D,this.f=F,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const F=this.f?this.f.source:"",z=D.f?D.f.source:"";return F<z?-1:F>z?1:0}equals(D){if(D.type===this.type){const F=this.f?this.f.source:"",z=D.f?D.f.source:"";return this.d===D.d&&F===z}return!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Gj=G;class X{static create(D){return new X(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new X(this.c.map(D))}negate(){return this.c}}e.$Hj=X;function W(U){let D=null;for(let F=0,z=U.length;F<z;F++){const x=U[F].substituteConstants();if(U[F]!==x&&D===null){D=[];for(let K=0;K<F;K++)D[K]=U[K]}D!==null&&(D[F]=x)}return D===null?U:D}class J{static create(D,F,z){return J.d(D,F,z)}constructor(D,F){this.expr=D,this.c=F,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const x=s(this.expr[F],D.expr[F]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:J.create(D,this.c,!1)}evaluate(D){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(D))return!1;return!0}static d(D,F,z){const x=[];let K=!1;for(const ee of D)if(ee){if(ee.type===1){K=!0;continue}if(ee.type===0)return i.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&K)return o.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Q=x.length===0,se=H.create(ee.expr.map(ue=>J.create([ue,_],null,z)),null,Q);se&&(x.push(se),x.sort(s))}if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return i.INSTANCE;if(x.length===1)return x[0]}return new J(x,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const F of this.expr)D.push(...F.keys());return D}map(D){return new J(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.c){const D=[];for(const F of this.expr)D.push(F.negate());this.c=H.create(D,this,!0)}return this.c}}e.$Ij=J;class H{static create(D,F,z){return H.d(D,F,z)}constructor(D,F){this.expr=D,this.c=F,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const x=s(this.expr[F],D.expr[F]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(D))return!0;return!1}static d(D,F,z){let x=[],K=!1;if(D){for(let ee=0,_=D.length;ee<_;ee++){const Q=D[ee];if(Q){if(Q.type===0){K=!0;continue}if(Q.type===1)return o.INSTANCE;if(Q.type===9){x=x.concat(Q.expr);continue}x.push(Q)}}if(x.length===0&&K)return i.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return o.INSTANCE;if(x.length===1)return x[0]}return new H(x,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const F of this.expr)D.push(...F.keys());return D}map(D){return new H(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.c){const D=[];for(const F of this.expr)D.push(F.negate());for(;D.length>1;){const F=D.shift(),z=D.shift(),x=[];for(const K of V(F))for(const ee of V(z))x.push(J.create([K,ee],null,!1));D.unshift(H.create(x,null,!1))}this.c=H.create(D,this,!0)}return this.c}}e.$Jj=H;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(D,F,z){super(D,null),this.f=F,typeof z=="object"?B.d.push({...z,key:D}):z!==!0&&B.d.push({key:D,description:z,type:F!=null?typeof F:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return b.create(this.key,D)}notEqualsTo(D){return k.create(this.key,D)}}e.$Kj=B,e.$Lj=(0,j.$ti)("contextKeyService");function ie(U,D){return U<D?-1:U>D?1:0}function re(U,D,F,z){return U<F?-1:U>F?1:D<z?-1:D>z?1:0}function he(U,D){if(U.type===0||D.type===1)return!0;if(U.type===9)return D.type===9?te(U.expr,D.expr):!1;if(D.type===9){for(const F of D.expr)if(he(U,F))return!0;return!1}if(U.type===6){if(D.type===6)return te(D.expr,U.expr);for(const F of U.expr)if(he(F,D))return!0;return!1}return U.equals(D)}function te(U,D){let F=0,z=0;for(;F<U.length&&z<D.length;){const x=U[F].cmp(D[z]);if(x<0)return!1;x===0&&F++,z++}return F===U.length}function V(U){return U.type===9?U.expr:[U]}}),define(ae[94],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$an=e.ID=void 0,e.$bn=N,e.ID="diagnosticsService",e.$an=(0,A.$ti)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}class L{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$cn=L}),define(ae[95],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=void 0,e.$Ho=(0,A.$ti)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=void 0,e.$Ai=(0,A.$ti)("environmentService"),e.$Bi=(0,A.$ui)(e.$Ai)}),define(ae[29],ce([0,1,157,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.ExtensionGalleryErrorCode=e.$4o=e.ExtensionManagementErrorCode=e.$3o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Wo=L,e.$Xo=j,e.$Yo=O,e.$Zo=I,e.$1o=P,e.$2o=f,e.$Qo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ro=new RegExp(e.$Qo),e.$So="__web_extension",e.$To="skipWalkthrough",e.$Uo="extensionsSync",e.$Vo="dependecyOrPackExtensionInstall";function L(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(u,m){return m==="web"&&!u.includes("web")}function P(u,m,d){return I(m,d)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===d}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(u){u.Install="install",u.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$3o=(0,N.$ti)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class p extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$4o=p;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$5o=l,e.$6o=(0,N.$ti)("extensionManagementService"),e.$7o="extensionsIdentifiers/disabled",e.$8o="extensionsIdentifiers/enabled",e.$9o=(0,N.$ti)("IGlobalExtensionEnablementService"),e.$0o=(0,N.$ti)("IExtensionTipsService"),e.$$o=(0,A.localize2)(0,"Extensions"),e.$_o=(0,A.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=void 0;function P(g,l){return g?j.URI.revive(l?l.transformIncoming(g):g):void 0}function f(g,l){return l?l.transformOutgoingURI(g):g}function E(g,l){l=l||O.$wn;const u=g.manifest;return{...(0,O.$zn)({...g,manifest:void 0},l),manifest:u}}function y(g,l){return g?.profileLocation?(0,O.$zn)(g,l??O.$wn):g}function w(g,l){return l?(0,L.$2n)(g,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):g}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=A.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=A.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=A.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=A.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=A.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const m=this.b(l);switch(u){case"onInstallExtension":return A.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidInstallExtensions":return A.Event.map(this.onDidInstallExtensions,d=>d.map($=>({...$,local:$.local?w($.local,m):$.local,profileLocation:$.profileLocation?f($.profileLocation,m):$.profileLocation})));case"onUninstallExtension":return A.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUninstallExtension":return A.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUpdateExtensionMetadata":return A.Event.map(this.onDidUpdateExtensionMetadata,d=>w(d,m))}throw new Error("Invalid listen")}async call(l,u,m){const d=this.b(l);switch(u){case"zip":{const $=E(m[0],d),t=await this.a.zip($);return f(t,d)}case"unzip":return this.a.unzip(P(m[0],d));case"install":return this.a.install(P(m[0],d),y(m[1],d));case"installFromLocation":return this.a.installFromLocation(P(m[0],d),P(m[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],P(m[1],d),P(m[2],d));case"getManifest":return this.a.getManifest(P(m[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],d));case"installGalleryExtensions":{const $=m[0];return this.a.installGalleryExtensions($.map(({extension:t,options:r})=>({extension:t,options:y(r,d)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],d),y(m[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],d));case"getInstalled":return(await this.a.getInstalled(m[0],P(m[1],d),m[2])).map(t=>w(t,d));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(E(m[0],d),P(m[1],d));return w($,d)}case"copyExtensions":return this.a.copyExtensions(P(m[0],d),P(m[1],d));case"updateMetadata":{const $=await this.a.updateMetadata(E(m[0],d),m[1],P(m[2],d));return w($,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$aq=h;class c extends N.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new A.$ce),this.f=this.B(new A.$ce),this.g=this.B(new A.$ce),this.h=this.B(new A.$ce),this.j=this.B(new A.$ce),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,I.$1o)(m,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(m=>E(m,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(m=>E(m,null))}async installExtensionsFromProfile(l,u,m){return(await this.m.call("installExtensionsFromProfile",[l,u,m])).map($=>E($,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(m=>E(m,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))}uninstall(l,u){if(l.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>E(u,null))}getInstalled(l=null,u,m){return Promise.resolve(this.m.call("getInstalled",[l,u,m])).then(d=>d.map($=>E($,null)))}updateMetadata(l,u,m){return Promise.resolve(this.m.call("updateMetadata",[l,u,m])).then(d=>E(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(m=>E(m,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,m){const d=await this.m.call("download",[l,u,m]);return j.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$bq=c;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,m){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$cq=p}),define(ae[96],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$X3b=L;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$Y3b=(0,A.$ti)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$sl=e.FileKind=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.FileOperationResult=e.$kl=e.$jl=e.$il=e.$gl=e.FileChangeType=e.$fl=e.FileOperation=e.$_k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Zk=void 0,e.$1k=w,e.$2k=g,e.$3k=u,e.$4k=m,e.$5k=d,e.$6k=$,e.$7k=t,e.$8k=r,e.$9k=n,e.$0k=s,e.$$k=i,e.$al=b,e.$bl=S,e.$cl=v,e.$dl=k,e.$el=C,e.$hl=Y,e.$tl=B,e.$ul=ie,e.$wl=he,e.$Zk=(0,P.$ti)("fileService");function w(te){return te.create===!0}var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var c;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function g(te){const V=te;return!!V&&typeof V.onDidChange=="function"}var l;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function u(te){return!!(te.capabilities&2)}function m(te){return!!(te.capabilities&8)}function d(te){return!!(te.capabilities&131072)}function $(te){return!!(te.capabilities&4)}function t(te){return!!(te.capabilities&16)}function r(te){return u(te)?!!(te.capabilities&16384):!1}function n(te){return u(te)?!!(te.capabilities&32768):!1}function s(te){return!!(te.capabilities&65536)}function i(te){return!!(te.capabilities&2048)}var o;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(V,U){const D=new a(V.toString(),U);return v(D,U),D}constructor(V,U){super(V),this.code=U}}e.$_k=a;function b(te,V){return a.create(te,V)}function S(te){return te||b((0,I.localize)(0,null),o.Unknown)}function v(te,V){return te.name=V?`${V} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return o.Unknown;if(te instanceof a)return te.code;const V=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!V)return o.Unknown;switch(V[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function C(te){if(te instanceof G)return te.fileOperationResult;switch(k(te)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var R;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class M{constructor(V,U,D){this.resource=V,this.operation=U,this.target=D}isOperation(V){return this.operation===V}}e.$fl=M;var T;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(V,U){this.c=U,this.b=void 0,this.d=new y.$V(()=>{const D=A.$zi.forUris(()=>this.c);return D.fill(this.rawAdded.map(F=>[F,!0])),D}),this.f=new y.$V(()=>{const D=A.$zi.forUris(()=>this.c);return D.fill(this.rawUpdated.map(F=>[F,!0])),D}),this.g=new y.$V(()=>{const D=A.$zi.forUris(()=>this.c);return D.fill(this.rawDeleted.map(F=>[F,!0])),D}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const D of V){switch(D.type){case 1:this.rawAdded.push(D.resource);break;case 0:this.rawUpdated.push(D.resource);break;case 2:this.rawDeleted.push(D.resource);break}this.b!==q.a&&(typeof D.cId=="number"?this.b===void 0?this.b=D.cId:this.b!==D.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(V,...U){return this.h(V,{includeChildren:!1},...U)}affects(V,...U){return this.h(V,{includeChildren:!0},...U)}h(V,U,...D){if(!V)return!1;const F=D.length>0;return!!((!F||D.includes(1))&&(this.d.value.get(V)||U.includeChildren&&this.d.value.findSuperstr(V))||(!F||D.includes(0))&&(this.f.value.get(V)||U.includeChildren&&this.f.value.findSuperstr(V))||(!F||D.includes(2))&&(this.g.value.findSubstr(V)||U.includeChildren&&this.g.value.findSuperstr(V)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(V){return this.b===V}hasCorrelation(){return typeof this.b=="number"}}e.$gl=q;function Y(te,V,U){return!te||!V||te===V||V.length>te.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),U?(0,L.$wf)(te,V):te.indexOf(V)===0)}class G extends Error{constructor(V,U,D){super(V),this.fileOperationResult=U,this.options=D}}e.$il=G;class X extends G{constructor(V,U,D,F){super(V,U,F),this.fileOperationResult=U,this.size=D}}e.$jl=X;class W extends G{constructor(V,U,D){super(V,2,D),this.stat=U}}e.$kl=W;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$ll={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ml={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$nl="files.associations",e.$ol="files.exclude",e.$pl="files.readonlyInclude",e.$ql="files.readonlyExclude",e.$rl="files.readonlyFromPermissions";var H;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$sl="";function B(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ie(te,V){if(!V.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(U=>{const D=V.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===te.scheme&&F.added&&(D.dispose(),U())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(V){return(0,j.$0f)(V)||(V=0),V<re.KB?(0,I.localize)(1,null,V.toFixed(0)):V<re.MB?(0,I.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,I.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,I.localize)(4,null,(V/re.GB).toFixed(2)):(0,I.localize)(5,null,(V/re.TB).toFixed(2))}}e.$vl=re;function he(te){const V=typeof te=="string"||te?.scheme===E.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===E.Schemas.file?1024*re.MB:V?10*re.MB:f.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(A,N){e(A,N,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;let j=class{constructor(I){this.a=I}async checksum(I){const P=(await this.a.readFileStream(I)).value;return new Promise((f,E)=>{const y=(0,A.createHash)("sha256");(0,N.$ve)(P,{onData:w=>y.update(w.buffer),onError:w=>E(w),onEnd:()=>f(y.digest("base64").replace(/=+$/,""))})})}};e.$Jdc=j,e.$Jdc=j=Ee([Z(0,L.$Zk)],j)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=O;async function O(E,y,w,h,c,p){let g;try{await I(E,y,w,h,c,p)}catch(l){g=l}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function I(E,y,w,h,c,p){P(p);const g=await E.open(y,{create:!1});try{P(p);let l=0,u=0,m=c&&typeof c.length=="number"?c.length:void 0,d=A.$De.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),$=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read(g,$,d.buffer,t,d.byteLength-t),$+=u,t+=u,l+=u,typeof m=="number"&&(m-=u),t===d.byteLength&&(await w.write(h(d)),d=A.$De.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),t=0);while(u>0&&(typeof m!="number"||m>0)&&P(p)&&f(l,c));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),w.write(h(d.slice(0,r)))}}catch(l){throw(0,j.$bl)(l)}finally{await E.close(g)}}function P(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function f(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,j.$al)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=void 0,e.$Gq=P,e.$Hq=f,e.$Lq=h,e.$Mq=c,e.$Nq=p,e.$Oq=g,e.$Pq=u,e.$Qq=m;function P(d){return typeof d.correlationId=="number"}function f(d){return d.recursive===!0}class E extends N.$Vc{static{this.a=5}constructor($,t,r,n){super(),this.h=$,this.j=t,this.m=r,this.n=n,this.c=this.B(new N.$Wc),this.f=void 0,this.g=0}s(){const $=new N.$Uc;this.c.value=$,this.b=this.r($),this.b.setVerboseLogging(this.m),$.add(this.b.onDidChangeFile(t=>this.h(t))),$.add(this.b.onDidLogMessage(t=>this.j(t))),$.add(this.b.onDidError(t=>this.t(t)))}t($){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${$}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${$}`):this.w($)}u($){this.g++,this.s(),this.watch($)}async watch($){this.f=$,await this.b?.watch($)}async setVerboseLogging($){this.m=$,await this.b?.setVerboseLogging($)}w($){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${$}`})}y($){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${$}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Iq=E;class y extends E{constructor($,t,r){super($,t,r,{type:"node.js",restartOnError:!1})}}e.$Jq=y;class w extends E{constructor($,t,r){super($,t,r,{type:"universal",restartOnError:!0})}}e.$Kq=w;function h(d){return d.map($=>({type:$.type,resource:O.URI.revive($.resource),cId:$.cId}))}function c(d){const $=new l;for(const t of d)$.processEvent(t);return $.coalesce()}function p(d,$){return typeof $=="string"&&!$.startsWith(A.$jk)&&!(0,L.$jc)($)?{base:d,pattern:$}:$}function g(d,$){const t=[];for(const r of $)t.push((0,A.$nk)(p(d,r)));return t}class l{constructor(){this.a=new Set,this.b=new Map}c($){return j.$k?$.resource.fsPath:$.resource.fsPath.toLowerCase()}processEvent($){const t=this.b.get(this.c($));let r=!1;if(t){const n=t.type,s=$.type;t.resource.fsPath!==$.resource.fsPath&&($.type===2||$.type===1)?r=!0:n===1&&s===2?(this.b.delete(this.c($)),this.a.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.a.add($),this.b.set(this.c($),$))}coalesce(){const $=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?($.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,I.$hl)(r.resource.fsPath,n,!j.$k))?!1:(t.push(r.resource.fsPath),!0)).concat($)}}function u(d,$){if(typeof $=="number")switch(d.type){case 1:return($&4)===0;case 2:return($&8)===0;case 0:return($&2)===0}return!1}function m(d){if(typeof d=="number"){const $=[];return d&4&&$.push("Added"),d&8&&$.push("Deleted"),d&2&&$.push("Updated"),$.length===0?"<all>":$.join(", ")}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=void 0,e.$nQ="localFilesystem";class y extends O.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$ce),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$ce),this.onDidWatchError=this.g.event,this.h=(0,P.$Pg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,c){const{buffer:p}=await this.a.call("readFile",[h,c]);return p}readFileStream(h,c,p){const g=(0,I.$re)(u=>A.$De.concat(u.map(m=>A.$De.wrap(m))).buffer),l=new O.$Uc;return l.add(this.a.listen("readFileStream",[h,c])(u=>{if(u instanceof A.$De)g.write(u.buffer);else{if(u==="end")g.end();else{let m;if(u instanceof Error)m=u;else{const d=u;m=(0,f.$al)(d.message??(0,N.$ej)(d),d.code??f.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{g.error((0,L.$6)()),g.end(),l.dispose()})),g}writeFile(h,c,p){return this.a.call("writeFile",[h,A.$De.wrap(c),p])}open(h,c){return this.a.call("open",[h,c])}close(h){return this.a.call("close",[h])}async read(h,c,p,g,l){const[u,m]=await this.a.call("read",[h,c,l]);return p.set(u.buffer.slice(0,m),g),m}write(h,c,p,g,l){return this.a.call("write",[h,c,A.$De.wrap(p),g,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,c){return this.a.call("delete",[h,c])}rename(h,c,p){return this.a.call("rename",[h,c,p])}copy(h,c,p){return this.a.call("copy",[h,c,p])}cloneFile(h,c){return this.a.call("cloneFile",[h,c])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const c=h;this.f.fire((0,E.$Lq)(c))}else{const c=h;this.g.fire(c)}}))}watch(h,c){const p=(0,P.$Pg)();return this.a.call("watch",[this.h,p,h,c]),(0,O.$Tc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$oQ=y}),define(ae[197],ce([0,1,41,2,46,3,8,6]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class P extends N.$Vc{constructor(){super(),this.a=this.B(new j.$ce),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$ce),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$ce),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$5c),this.m=new Set,this.n=5007,this.r=new I.$Qh,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,L.$Gq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Qh;try{this.h.clear(),this.g.clear();for(const y of E)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const y=new N.$Uc;this.j.set(E.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(E,y),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,y){this.C(E,y)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,y),this.m.add(E.correlationId))}C(E,y){const w=this.M?.subscribe(E.path,(h,c)=>{y.isDisposed||(h?this.z(E,y):c?.type===1&&this.F(E))});return w?(y.add(w),!0):!1}D(E,y){let w=!1;const h=(c,p)=>{if(y.isDisposed)return;const g=this.G(c),l=this.G(p),u=w;w=g,!g&&(l||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,A.watchFile)(E.path,{persistent:!1,interval:this.n},h)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,N.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,A.unwatchFile)(E.path,h)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:O.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([y]),this.H(y,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,y){if(this.P){const w=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(w,y)}}I(E,y){this.P&&this.N(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,L.$Qq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$Zq=P}),define(ae[198],ce([0,1,41,6,26,40,2,87,14,5,20,8,148,31,46]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0,e.$6q=g;class p extends O.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,m,d,$,t,r){super(),this.s=u,this.t=m,this.u=d,this.w=$,this.y=t,this.z=r,this.c=this.B(new N.$Ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Hh(n=>this.M(n),p.b)),this.g=(0,c.$Oq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Oq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Gq)(this.s)?this.s.filter:void 0,this.m=new L.$ne,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await h.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,m.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let m=u.path;try{m=await h.Promises.realpath(u.path),u.path===m&&(m=await(0,w.$2q)(u.path,this.m.token)??u.path),u.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${m})`)}catch{}return m}async G(u,m){const d=new O.$Uc;return this.H(u,m,d)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,m,d)),d}H(u,m,d){if(m)return!1;const $=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,n)=>{if(!d.isDisposed)if(r){const s=await this.G(u,m);d.isDisposed?s.dispose():d.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:$,type:n.type,cId:this.s.correlationId},!0)});return t?(d.add(t),!0):!1}async I(u,m,d){if(f.$j&&(0,j.$sg)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const $=new L.$ne(this.m.token);d.add((0,O.$Tc)(()=>$.dispose(!0)));const t=new O.$Uc;d.add(t);try{const r=y.URI.file(this.s.path),n=(0,P.$oc)(u),s=(0,A.watch)(u);t.add((0,O.$Tc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(m)try{for(const a of await h.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if($.token.isCancellationRequested)return;const o=new Map;t.add((0,O.$Tc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,b)=>{$.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${b})`),this.D())}),s.on("change",(a,b)=>{if($.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${b}`);let S="";if(b&&(S=b.toString(),f.$j&&(S=(0,I.$$l)(S))),!(!S||a!=="change"&&a!=="rename"))if(m)if(a==="rename"){o.get(S)?.dispose();const v=setTimeout(async()=>{if(o.delete(S),S===n&&!await h.Promises.exists(u)){this.J(r);return}if($.token.isCancellationRequested)return;const k=await this.N((0,P.$kc)(u,S));if($.token.isCancellationRequested)return;let C;k?i.has(S)?C=0:(C=1,i.add(S)):(i.delete(S),C=2),this.L({resource:(0,E.$7g)(r,S),type:C,cId:this.s.correlationId})},p.a);o.set(S,(0,O.$Tc)(()=>clearTimeout(v)))}else{let v;i.has(S)?v=0:(v=1,i.add(S)),this.L({resource:(0,E.$7g)(r,S),type:v,cId:this.s.correlationId})}else if(a==="rename"||S!==n){const v=setTimeout(async()=>{const k=await h.Promises.exists(u);$.token.isCancellationRequested||(k?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},p.a);t.clear(),t.add((0,O.$Tc)(()=>clearTimeout(v)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){$.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!m&&this.g.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const m=(0,c.$Mq)(u),d=[];for(const t of m){if((0,c.$Pq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}d.push(t)}if(d.length===0)return;if(this.z)for(const t of d)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(f.$k)return h.Promises.exists(u);try{const m=(0,P.$oc)(u);return(await h.Promises.readdir((0,P.$nc)(u))).some($=>$===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$5q=p;async function g(l,u,m,d,$=512){const t=await h.Promises.open(l,"r"),r=Buffer.allocUnsafe($),n=new L.$ne(d);let s,i=!1;const o={path:l,excludes:[],recursive:!1},a=new p(o,void 0,b=>{(async()=>{for(const{type:S}of b)if(S===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await h.Promises.read(t,r,0,$,null);if(!v||n.token.isCancellationRequested)break;u(r.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,m(),new Promise((b,S)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(t)}catch(v){s=new Error(v)}s?S(s):b()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,40]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class P extends L.$Zq{constructor(E){super(),this.M=E,this.onDidError=A.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],w=new Set(Array.from(this.watchers));for(const h of E){const c=this.S(h);c&&(0,N.$rk)(c.request.excludes,h.excludes)&&(0,N.$rk)(c.request.includes,h.includes)?w.delete(c):y.push(h)}y.length&&this.N(`Request to start watching: ${y.map(h=>this.J(h)).join(",")}`),w.size&&this.N(`Request to stop watching: ${Array.from(w).map(h=>this.J(h.request)).join(",")}`);for(const h of w)this.W(h);for(const h of y)this.U(h)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,I.$rg)(y.request.path,E.path,!j.$k))return y}U(E){const y=new O.$5q(E,this.M,h=>this.a.fire(h),()=>this.c.fire(E),h=>this.b.fire(h),this.P),w={request:E,instance:y};this.watchers.add(w)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const w of E){const h=j.$k?w.path:w.path.toLowerCase();let c=y.get(w.correlationId);c||(c=new Map,y.set(w.correlationId,c)),c.has(h)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(w)}`),c.set(h,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$7q=P}),define(ae[200],ce([0,1,46,199]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class L extends A.$Jq{constructor(O,I,P){super(O,I,P),this.s()}r(O){return O.add(new N.$7q(void 0))}}e.$8q=L}),define(ae[201],ce([0,1,23,42,92,46]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class O extends j.$Kq{constructor(P,f,E){super(P,f,E),this.s()}r(P){const f=P.add(new L.$Xq(A.$Ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(f.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),N.ProxyChannel.toService((0,N.$ai)(f.getChannel("watcher")))}}e.$Yq=O}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=void 0;class A{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ri=A}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;const E=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new P.$ri,l=!1,u,m=E){this.i=g,this.j=l,this.k=u,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$si,this),this._globalGraph=m?u?._globalGraph??new O.$$q(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const l=new class extends w{dispose(){this.h.delete(l),super.dispose()}}(g,this.j,this,this.l);return this.h.add(l),l}invokeFunction(g,...l){this.m();const u=c.traceInvocation(this.l,g);let m=!1;try{return g({get:$=>{if(m)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s($,u);if(!t)throw new Error(`[invokeFunction] unknown service '${$}'`);return t}},...l)}finally{m=!0,u.stop()}}createInstance(g,...l){this.m();let u,m;return g instanceof j.$qi?(u=c.traceCreation(this.l,g.ctor),m=this.o(g.ctor,g.staticArguments.concat(l),u)):(u=c.traceCreation(this.l,g),m=this.o(g,l,u)),u.stop(),m}o(g,l=[],u){const m=I._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),d=[];for(const t of m){const r=this.s(t.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const $=m.length>0?m[0].index:l.length;if(l.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${l.length} static arguments`);const t=$-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,$)}return Reflect.construct(g,l.concat(d))}q(g,l){if(this.i.get(g)instanceof j.$qi)this.i.set(g,l);else if(this.k)this.k.q(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const l=this.i.get(g);return!l&&this.k?this.k.r(g):l}s(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof j.$qi?this.u(g,u,l.branch(g,!0)):(l.branch(g,!1),u)}u(g,l,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,l,u)}finally{this.t.delete(g)}}v(g,l,u){const m=new O.$$q(t=>t.id.toString());let d=0;const $=[{id:g,desc:l,_trace:u}];for(;$.length;){const t=$.pop();if(m.lookupOrInsertNode(t),d++>1e3)throw new y(m);for(const r of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(r.id);if(n||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof j.$qi){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,s),$.push(s)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:r}of t){if(this.r(r.id)instanceof j.$qi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}m.removeNode(r)}}return this.r(g)}w(g,l,u=[],m,d){if(this.i.get(g)instanceof j.$qi)return this.x(g,l,u,m,d,this.g);if(this.k)return this.k.w(g,l,u,m,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(g,l,u=[],m,d,$){if(m){const t=new w(void 0,this.j,this,this.l);t.c=String(g);const r=new Map,n=new A.$Mh(()=>{const s=t.o(l,u,d);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const b of o)b.disposable=a.apply(s,b.listener)}return r.clear(),$.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=r.get(i);return b||(b=new f.$6c,r.set(i,b)),(v,k,C)=>{if(n.isInitialized)return n.value[i](v,k,C);{const R={listener:[v,k,C],disposable:void 0},M=b.push(R);return(0,L.$Tc)(()=>{M(),R.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return l.prototype}})}else{const t=this.o(l,u,d);return $.add(t),t}}y(g,l){if(l&&console.warn(g),this.j)throw new Error(g)}}e.$_q=w;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new c(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(g,l){return g?new c(1,l.name):c.c}static{this.f=0}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const u=new c(3,g.toString());return this.h.push([g,l,u]),u}stop(){const g=Date.now()-this.g;c.f+=g;let l=!1;function u(d,$){const t=[],r=new Array(d+1).join("	");for(const[n,s,i]of $.h)if(s&&i){l=!0,t.push(`${r}CREATES -> ${n}`);const o=u(d+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(g>2||l)&&c.all.add(m.join(`
`))}}e.$ar=c}),define(ae[56],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,A.$ti)("mainProcessService");class N{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$fdc=N}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=void 0,e.$Nr=P;function P(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Or=(0,I.$ti)("languagePackService");let f=class extends N.$Vc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new A.$ne;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const c=w.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(g=>g.startsWith("lp-"))).map(p=>{const g=p.properties.localizedLanguages?.[0],l=P(p);return{...this.f(l,g,p),extensionId:p.identifier.id,galleryExtension:p}});return c.push(this.f("en","English")),c}f(y,w,h){const c=w??y;let p;if(c!==y&&(p=`(${y})`),y.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,j.localize)(0,null)),h?.installCount){p??="";const g=h.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),p+=` $(cloud-download) ${l}`}return{id:y,label:c,description:p}}};e.$Pr=f,e.$Pr=f=Ee([Z(0,O.$3o)],f)}),define(ae[203],ce([0,1,2,75]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let L=class extends A.$Vc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$Fdc=L,e.$Fdc=L=Ee([Z(0,N.$Or)],L)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$3j=e.LogLevel=e.$1j=e.$Zj=void 0,e.$2j=p,e.log=l,e.$bk=a,e.$ck=b,e.$dk=S,e.$ek=v,e.$Zj=(0,h.$ti)("logService"),e.$1j=(0,h.$ti)("loggerService");function c(){return new Date().toISOString()}function p(k){return(0,E.$0f)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$3j=g.Info;function l(k,C,R){switch(C){case g.Trace:k.trace(R);break;case g.Debug:k.debug(R);break;case g.Info:k.info(R);break;case g.Warning:k.warn(R);break;case g.Error:k.error(R);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function u(k,C=!1){let R="";for(let M=0;M<k.length;M++){let T=k[M];if(T instanceof Error&&(T=(0,N.$ej)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}R+=(M>0?" ":"")+T}return R}class m extends O.$Vc{constructor(){super(...arguments),this.b=e.$3j,this.c=this.B(new L.$ce),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}e.$5j=m;class d extends m{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...R){this.f(g.Trace)&&this.g(g.Trace,u([C,...R],!0))}debug(C,...R){this.f(g.Debug)&&this.g(g.Debug,u([C,...R]))}info(C,...R){this.f(g.Info)&&this.g(g.Info,u([C,...R]))}warn(C,...R){this.f(g.Warning)&&this.g(g.Warning,u([C,...R]))}error(C,...R){if(this.f(g.Error))if(C instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=C.stack,this.g(g.Error,u(M))}else this.g(g.Error,u([C,...R]))}flush(){}}e.$6j=d;class $ extends m{constructor(C=e.$3j){super(),this.setLevel(C),this.g=!P.$i}trace(C,...R){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}debug(C,...R){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}info(C,...R){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}warn(C,...R){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,C,...R):console.warn(`[main ${c()}]`,C,...R))}error(C,...R){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,C,...R):console.error(`[main ${c()}]`,C,...R))}flush(){}}e.$7j=$;class t extends m{constructor(C=e.$3j,R=!0){super(),this.g=R,this.setLevel(C)}trace(C,...R){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...R):console.log(C,...R))}debug(C,...R){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...R):console.log(C,...R))}info(C,...R){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...R):console.log(C,...R))}warn(C,...R){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...R):console.log(C,...R))}error(C,...R){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...R):console.error(C,...R))}flush(){}}e.$8j=t;class r extends m{constructor(C,R=e.$3j){super(),this.g=C,this.setLevel(R)}trace(C,...R){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...R])}debug(C,...R){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...R])}info(C,...R){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...R])}warn(C,...R){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...R])}error(C,...R){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...R])}h(C){return typeof C=="string"?C:(0,N.$ej)(C,this.f(g.Trace))}flush(){}}e.$9j=r;class n extends m{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const R of this.g)R.setLevel(C);super.setLevel(C)}trace(C,...R){for(const M of this.g)M.trace(C,...R)}debug(C,...R){for(const M of this.g)M.debug(C,...R)}info(C,...R){for(const M of this.g)M.info(C,...R)}warn(C,...R){for(const M of this.g)M.warn(C,...R)}error(C,...R){for(const M of this.g)M.error(C,...R)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$0j=n;class s extends O.$Vc{constructor(C,R,M){if(super(),this.h=C,this.j=R,this.b=new I.$Bc,this.c=this.B(new L.$ce),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$ce),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$ce),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,E.$6f)(C)?[...this.b.values()].find(R=>R.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,R){const M=this.n(C),T=(0,E.$6f)(C)?C:R?.id??(0,j.$hj)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const Y=R?.logLevel==="always"?g.Trace:R?.logLevel;q||(q=this.s(M,Y??this.getLogLevel(M)??this.h,{...R,id:T}));const G={logger:q,info:{resource:M,id:T,logLevel:Y,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(G.info),this.b.set(M,G),q}n(C){return(0,E.$6f)(C)?(0,f.$7g)(this.j,`${C}.log`):C}setLogLevel(C,R){if(y.URI.isUri(C)){const M=C,T=R,q=this.b.get(M);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([M,T]))}else{this.h=C;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,R){const M=this.m(C);M&&R!==!M.info.hidden&&(M.info.hidden=!R,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,R]))}getLogLevel(C){let R;return C&&(R=this.b.get(C)?.info.logLevel),R??this.h}registerLogger(C){const R=this.b.get(C.resource);R?R.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const R=this.b.get(C);R&&(R.logger&&R.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$$j=s;class i{constructor(){this.onDidChangeLogLevel=new L.$ce().event}setLevel(C){}getLevel(){return g.Info}trace(C,...R){}debug(C,...R){}info(C,...R){}warn(C,...R){}error(C,...R){}critical(C,...R){}dispose(){}flush(){}}e.$_j=i;class o extends i{}e.$ak=o;function a(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const C=v(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$3j}function b(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function S(k){switch(k){case g.Trace:return{original:"Trace",value:A.localize(0,null)};case g.Debug:return{original:"Debug",value:A.localize(1,null)};case g.Info:return{original:"Info",value:A.localize(2,null)};case g.Warning:return{original:"Warning",value:A.localize(3,null)};case g.Error:return{original:"Error",value:A.localize(4,null)};case g.Off:return{original:"Off",value:A.localize(5,null)}}}function v(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$fk=new w.$Kj("logLevel",b(g.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let y=class extends L.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.B(new A.$Fh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,I.$4g)(this.a.logsHome),c=(0,I.$6g)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await P.Promises.readdir(c)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(m=>P.Promises.rm((0,O.$kc)(c,m)))))}catch(h){(0,N.$1)(h)}}};e.$Gdc=y,e.$Gdc=y=Ee([Z(0,f.$Ai),Z(1,E.$Zj)],y)}),define(ae[205],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class y extends I.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.c=this.B(new j.$ce),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$ce),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$rh(0)),this.w=[],this.y=this.B(new N.$rh(0))}watch(h,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(h,c):this.z(h,c)}n(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},g=(0,A.$Ub)(this.j,p);return this.r(),(0,I.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(h=>(0,L.$1)(h))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,f.$Lq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const c of this.j)(0,f.$Hq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const c of this.j)(0,f.$Hq)(c)&&h.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},g=(0,A.$Ub)(this.w,p);return this.C(),(0,I.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(h=>(0,L.$1)(h))}D(){return this.u||(this.u=this.B(this.F(h=>this.c.fire((0,f.$Lq)(h)),h=>this.G(h),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(h){h.type==="error"&&this.g.fire(h.message),this.H(h)}H(h){this.a[h.type](h.message)}I(h){return(0,P.$ic)(h.fsPath)}J(h){const c=this.I(h);return(0,O.$vg)(c)}}e.$Rq=y}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let $=class extends f.$Vc{static{d=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$ce),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$ce),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$ce),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$ce),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$ce),this.Y=this.B(new O.$ce),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$ce),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Ch)}registerProvider(r,n){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${r}`);const s=new f.$Uc;return this.h.set(r,n),this.c.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new g.$gl(i,!this.S(n));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:r}))),(0,f.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:n}),this.h.delete(r),(0,f.$Qc)(s)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const n=[];this.f.fire({scheme:r,join(s){n.push(s)}}),!this.h.has(r)&&await N.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,n){const s=this.h.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async j(r){if(!(0,h.$$g)(r))throw new g.$il((0,p.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const n=this.h.get(r.scheme);if(!n){const s=new m.$bb;throw s.message=(0,p.localize)(1,null,r.toString()),s}return n}async m(r){const n=await this.j(r);if((0,g.$6k)(n)||(0,g.$3k)(n)||(0,g.$7k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const n=await this.j(r);if((0,g.$6k)(n)||(0,g.$3k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.s(r,n)}catch(s){throw(0,g.$dl)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.$il((0,p.localize)(2,null,this.sb(r)),1):(0,g.$bl)(s)}}async s(r,n){const s=await this.j(r),i=this.S(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,b=n?.resolveMetadata,S=await s.stat(r);let v;return this.t(s,r,S,void 0,!!b,(k,C)=>(v||(v=E.$zi.forUris(()=>!i),v.set(r,!0),o&&v.fill(!0,o)),v.get(k.resource)||v.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?C===1:!1))}async t(r,n,s,i,o,a){const{providerExtUri:b}=this.R(r),S={resource:n,name:b.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.$tl)({mtime:s.mtime,size:s.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const v=await r.readdir(n),k=await N.Promises.settled(v.map(async([C,R])=>{try{const M=b.joinPath(n,C),T=o?await r.stat(M):{type:R};return await this.t(r,M,T,v.length,o,a)}catch(M){return this.b.trace(M),null}}));S.children=(0,A.$Hb)(k)}catch(v){this.b.trace(v),S.children=[]}return S}return S}async resolveAll(r){return N.Promises.settled(r.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.j(r),s=await n.stat(r);return this.t(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.j(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.u(r,n)}catch(s){return s}return!0}async u(r,n){if(!n?.overwrite&&await this.exists(r))throw new g.$il((0,p.localize)(3,null,this.sb(r)),3,n)}async createFile(r,n=L.$De.fromString(""),s){await this.u(r,s);const i=await this.writeFile(r,n);return this.r.fire(new g.$fl(r,0,i)),i}async writeFile(r,n,s){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=s;if((0,g.$9k)(i)&&!a?.atomic){const b=i.enforceAtomicWriteFile?.(r);b&&(a={...s,atomic:b})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let S;if((0,g.$3k)(i)&&!(n instanceof L.$De))if((0,c.$pe)(n)){const v=await(0,c.$we)(n,3);v.ended?S=L.$De.concat(v.buffer):S=v}else S=(0,c.$te)(n,v=>L.$De.concat(v),3);else S=n;!(0,g.$6k)(i)||(0,g.$3k)(i)&&S instanceof L.$De||(0,g.$3k)(i)&&(0,g.$9k)(i)&&a?.atomic?await this.hb(i,r,a,S):await this.db(i,r,a,S instanceof L.$De?(0,L.$Oe)(S):S),this.r.fire(new g.$fl(r,4))}catch(b){throw new g.$il((0,p.localize)(4,null,this.sb(r),(0,g.$bl)(b).toString()),(0,g.$el)(b),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(r.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(i)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&g.FileType.Directory)throw new g.$il((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.$sl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,g.$tl)({mtime:s.mtime,size:a.size}))throw new g.$il((0,p.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.m(r);return n?.atomic?this.z(i,r,n,s):this.C(i,r,n,s)}async z(r,n,s,i){return new Promise((o,a)=>{this.cb.queueFor(n,async()=>{try{const b=await this.C(r,n,s,i);o(b)}catch(b){a(b)}},this.R(r).providerExtUri)})}async C(r,n,s,i){const o=await this.D(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,L.$Pe)(o.value)}}async readFileStream(r,n,s){const i=await this.m(r);return this.D(i,r,n,s)}async D(r,n,s,i){const o=new j.$ne(i);let a=s;(0,g.$8k)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const b=this.J(n,a).then(v=>v,v=>{throw o.dispose(!0),v});let S;try{return typeof a?.etag=="string"&&a.etag!==g.$sl&&await b,a?.atomic&&(0,g.$8k)(r)||!((0,g.$6k)(r)||(0,g.$7k)(r))||(0,g.$3k)(r)&&a?.preferUnbuffered?S=this.I(r,n,a):(0,g.$7k)(r)?S=this.G(r,n,o.token,a):S=this.H(r,n,o.token,a),S.on("end",()=>o.dispose()),S.on("error",()=>o.dispose()),{...await b,value:S}}catch(v){throw S&&await(0,c.$ue)(S),this.F(v,n,a)}}F(r,n,s){const i=(0,p.localize)(11,null,this.sb(n),(0,g.$bl)(r).toString());return r instanceof g.$kl?new g.$kl(i,r.stat,s):r instanceof g.$jl?new g.$jl(i,r.fileOperationResult,r.size,r.options):new g.$il(i,(0,g.$el)(r),s)}G(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.$Ae)(o,{data:a=>a instanceof L.$De?a:L.$De.wrap(a),error:a=>this.F(a,n,i)},a=>L.$De.concat(a))}H(r,n,s,i=Object.create(null)){const o=(0,L.$Te)();return(0,l.$Eq)(r,n,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,n,i)},s),o}I(r,n,s){const i=(0,c.$re)(o=>L.$De.concat(o));return(async()=>{try{let o;s?.atomic&&(0,g.$8k)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.L(n,o.byteLength,s),i.end(L.$De.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new g.$il((0,p.localize)(12,null,this.sb(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$sl&&n.etag===s.etag)throw new g.$kl((0,p.localize)(13,null),s,n);return this.L(r,s.size,n),s}L(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.$jl((0,p.localize)(14,null,this.sb(r)),7,n,s)}async canMove(r,n,s){return this.M(r,n,"move",s)}async canCopy(r,n,s){return this.M(r,n,"copy",s)}async M(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(n),n);await this.Q(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"move",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,a==="move"?2:3,b)),b}async copy(r,n,s){const i=await this.m(r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"copy",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,a==="copy"?3:2,b)),b}async N(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:S}=await this.Q(r,n,s,i,o,a);if(b&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,g.$4k)(r))await r.copy(n,i,{overwrite:a});else{const v=await this.resolve(n);v.isDirectory?await this.P(r,v,s,i):await this.O(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.N(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(r,n,s,i){if((0,g.$6k)(r)&&(0,g.$6k)(s))return this.jb(r,n,s,i);if((0,g.$6k)(r)&&(0,g.$3k)(s))return this.pb(r,n,s,i);if((0,g.$3k)(r)&&(0,g.$6k)(s))return this.nb(r,n,s,i);if((0,g.$3k)(r)&&(0,g.$3k)(s))return this.lb(r,n,s,i)}async P(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async o=>{const a=this.R(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),s,a):this.O(r,o.resource,s,a)}))}async Q(r,n,s,i,o,a){let b=!1;if(r===s){const{providerExtUri:v,isPathCaseSensitive:k}=this.R(r);if(k||(b=v.isEqual(n,i)),b&&o==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(i)));if(!b&&v.isEqualOrParent(i,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(i)))}const S=await this.exists(i);if(S&&!b){if(!a)throw new g.$il((0,p.localize)(17,null,this.sb(n),this.sb(i)),4);if(r===s){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(n,i))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:b}}R(r){const n=this.S(r);return{providerExtUri:n?h.$Wg:h.$Yg,isPathCaseSensitive:n}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.qb(await this.j(r),r);await this.U(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$fl(r,0,s)),s}async U(r,n){const s=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&g.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(o){if((0,g.$dl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,g.$dl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.W(r,n)}catch(s){return s}return!0}async W(r,n){const s=this.qb(await this.j(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,p.localize)(22,null,this.sb(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.rb(r,a);else throw new g.$il((0,p.localize)(23,null,this.sb(r)),1);if(!!!n?.recursive){const S=await this.resolve(r);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(r)))}return s}async del(r,n){const s=await this.W(r,n);let i=n;if((0,g.$0k)(s)&&!i?.atomic){const S=s.enforceAtomicDelete?.(r);S&&(i={...n,atomic:S})}const o=!!i?.useTrash,a=!!i?.recursive,b=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:b}),this.r.fire(new g.$fl(r,1))}async cloneFile(r,n){const s=await this.j(r),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(r,n)))return s===i&&(0,g.$5k)(s)?s.cloneFile(r,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,g.$4k)(s)?this.cb.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(r,()=>this.O(s,r,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:d.ab++})}watch(r,n={recursive:!1,excludes:[]}){const s=new f.$Uc;let i=!1,o=()=>{i=!0};s.add((0,f.$Tc)(()=>o())),(async()=>{try{const b=await this.bb(r,n);i?(0,f.$Qc)(b):o=()=>(0,f.$Qc)(b)}catch(b){this.b.error(b)}})();const a=n.correlationId;if(typeof a=="number"){const b=s.add(new O.$ce);return s.add(this.X.event(v=>{v.correlates(a)&&b.fire(v)})),{onDidChange:b.event,dispose:()=>s.dispose()}}return s}async bb(r,n){const s=await this.j(r),i=(0,I.$hj)([this.R(s).providerExtUri.getComparisonKey(r),n]);let o=this.$.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.$.set(i,o)),o.count+=1,(0,f.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,f.$Qc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,f.$Qc)(r.disposable);this.$.clear()}async db(r,n,s,i){return this.cb.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.$pe)(i)||(0,c.$qe)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,g.$bl)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,n,s){let i=0,o;if((0,c.$qe)(s)){if(s.buffer.length>0){const a=L.$De.concat(s.buffer);await this.gb(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,b)=>{(0,c.$ve)(o,{onData:async S=>{o.pause();try{await this.gb(r,n,S,S.byteLength,i,0)}catch(v){return b(v)}i+=S.byteLength,setTimeout(()=>o.resume())},onError:S=>b(S),onEnd:()=>a()})})}async fb(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.gb(r,n,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,n,s,i,o,a){let b=0;for(;b<i;){const S=await r.write(n,o+b,s.buffer,a+b,i-b);b+=S}}async hb(r,n,s,i){return this.cb.queueFor(n,()=>this.ib(r,n,s,i),this.R(r).providerExtUri)}async ib(r,n,s,i){let o;i instanceof L.$De?o=i:(0,c.$pe)(i)?o=await(0,L.$Pe)(i):(0,c.$qe)(i)?o=await(0,L.$Qe)(i):o=(0,L.$Ne)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(r,n,s,i){return this.cb.queueFor(i,()=>this.kb(r,n,s,i),this.R(s).providerExtUri)}async kb(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const b=L.$De.alloc(this.a);let S=0,v=0,k=0;do k=await r.read(o,S,b.buffer,v,b.byteLength-v),await this.gb(s,a,b,k,S,v),S+=k,v+=k,v===b.byteLength&&(v=0);while(k>0)}catch(b){throw(0,g.$bl)(b)}finally{await N.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(r,n,s,i){return this.cb.queueFor(i,()=>this.mb(r,n,s,i),this.R(s).providerExtUri)}async mb(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,n,s,i){return this.cb.queueFor(i,()=>this.ob(r,n,s,i),this.R(s).providerExtUri)}async ob(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.gb(s,o,L.$De.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.$bl)(a)}finally{await s.close(o)}}async pb(r,n,s,i){const o=await(0,L.$Pe)(this.H(r,n,j.CancellationToken.None));await this.hb(s,i,void 0,o)}qb(r,n){if(r.capabilities&2048)throw new g.$il((0,p.localize)(25,null,this.sb(n)),6);return r}rb(r,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$il((0,p.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Fq=$,e.$Fq=$=d=Ee([Z(0,u.$Zj)],$)}),define(ae[207],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0,(()=>{try{(0,N.gracefulify)(A)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$ej)(r)}`)}})();class t extends u.$Rq{static{this.L=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.P=new j.$Bc(i=>w.$Xg.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,y.$k&&(this.M|=1024)),this.M}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(n));return{type:this.O(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.I(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,w.$7g)(n,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.hb(s)}}O(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async Q(n){const s=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new L.$sh;return this.P.set(n,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(n)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),i=await this.Q(n));const o=this.I(n);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(n){t.L&&this.a.trace(n)}readFileStream(n,s,i){const o=(0,h.$re)(a=>O.$De.concat(a.map(b=>O.$De.wrap(b))).buffer);return(0,l.$Eq)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(n)?this.U(n,(0,w.$7g)((0,w.$6g)(n),`${(0,w.$4g)(n)}${i.atomic.postfix}`),s,i):this.W(n,s,i)}async S(n){try{const s=this.I(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async U(n,s,i,o){const a=new f.$Uc;try{a.add(await this.Q(n)),a.add(await this.Q(s)),await this.W(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(b){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{a.dispose()}}async W(n,s,i,o){let a;try{const b=this.I(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(b)){if(!i.overwrite)throw(0,g.$al)((0,p.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$al)((0,p.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(b){throw await this.ib(n,b)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(n){t.$=n}async open(n,s,i){const o=this.I(n);let a;(0,g.$1k)(s)&&!i&&(a=await this.Q(n));let b;try{if((0,g.$1k)(s)&&s.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(o);v.mode&128||await c.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let S;if((0,g.$1k)(s)){if(y.$i)try{await c.Promises.truncate(o,0),S="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}S||(S="w")}else S="r";b=await c.Promises.open(o,S)}catch(S){throw a?.dispose(),(0,g.$1k)(s)?await this.ib(n,S):this.hb(S)}if(this.X.set(b,0),(0,g.$1k)(s)&&this.Z.set(b,n),a){const S=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.Y.set(b,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),S.dispose())}return b}async close(n){const s=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&t.$)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(n)}catch(i){throw this.hb(i)}finally{s&&(this.Y.get(n)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.read(n,i,o,a,b)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(n,b,S)}return S}ab(n,s){return s===this.X.get(n)?null:s}bb(n,s,i){const o=this.X.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.X.set(n,o+i):this.X.delete(n)))}async write(n,s,i,o,a){return(0,L.$Nh)(()=>this.cb(n,s,i,o,a),100,3)}async cb(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.write(n,i,o,a,b)).bytesWritten}catch(v){throw await this.ib(this.Z.get(n),v)}finally{this.bb(n,b,S)}return S}async mkdir(n){try{await c.Promises.mkdir(this.I(n))}catch(s){throw this.hb(s)}}async delete(n,s){try{const i=this.I(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,E.$kc)((0,E.$nc)(i),`${(0,E.$oc)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:b,symbolicLink:S}=await c.SymlinkSupport.stat(i);a=b.isDirectory()&&!S}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(2,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async copy(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(3,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async db(n,s,i,o){const a=this.I(n),b=this.I(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,P.$rg)(a,b,!0)),S){if(i==="copy")throw(0,g.$al)((0,p.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.N(n);if(!k)throw(0,g.$al)((0,p.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(s);if(C){if(!o)throw(0,g.$al)((0,p.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.eb(n,s,!1)}async eb(n,s,i){const o=this.I(n),a=this.I(s),b=!!(this.capabilities&1024);if((0,P.$rg)(o,a,!b))return;const S=new f.$Uc;try{S.add(await this.Q(n)),S.add(await this.Q(s)),i&&await c.Promises.mkdir((0,E.$nc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(v){if(v.code==="ENOENT"&&!i)return this.eb(n,s,!0);throw this.hb(v)}finally{S.dispose()}}t(n,s,i){return new d.$Yq(o=>n(o),o=>s(o),i)}F(n,s,i){return new $.$8q(o=>n(o),o=>s(o),i)}hb(n){if(n instanceof g.$_k)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$al)(s,i)}async ib(n,s){let i=this.hb(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(n));o.mode&128||(i=(0,g.$al)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$9q=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0,e.$6dc=(0,L.$ti)("sharedProcessLifecycleService");let O=class extends N.$Vc{constructor(P){super(),this.b=P,this.a=this.B(new A.$ce),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$7dc=O,e.$7dc=O=Ee([Z(0,j.$Zj)],O)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=e.$8r=void 0;class O extends L.$$j{constructor(y,w,h,c,p){super(w,h,c),this.r=y,this.t=p,this.B(p.listen("onDidChangeLogLevel",y)(g=>{(0,L.$2j)(g)?super.setLogLevel(g):super.setLogLevel(A.URI.revive(g[0]),g[1])})),this.B(p.listen("onDidChangeVisibility",y)(([g,l])=>super.setVisibility(A.URI.revive(g),l))),this.B(p.listen("onDidChangeLoggers",y)(({added:g,removed:l})=>{for(const u of g)super.registerLogger({...u,resource:A.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$9j({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,h){return new I(this.t,y,w,h,this.r)}static setLogLevel(y,w,h){return y.call("setLogLevel",[w,h])}}e.$8r=O;class I extends L.$6j{constructor(y,w,h,c,p){super(c?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[w,c,p]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const h=[[y,w]];this.m?this.u(h):this.n.push(...h)}u(y){this.r.call("log",[this.s,y])}}class P{constructor(y,w){this.a=y,this.b=w}listen(y,w){const h=this.b(y);switch(w){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(p=>this.c(p,h)),removed:[...c.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,c=>[h.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,c=>(0,L.$2j)(c)?c:[h.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,h){const c=this.b(y);switch(w){case"setLogLevel":return(0,L.$2j)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(A.URI.revive(c.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,c)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$9r=P;class f extends j.$Vc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const c of h)y.registerLogger({...c,resource:A.URI.revive(c.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,c])=>y.setVisibility(A.URI.revive(h),c))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:c})=>{for(const p of h)y.registerLogger({...p,resource:A.URI.revive(p.resource)});for(const p of c)y.deregisterLogger(p.resource)}))}}e.$0r=f}),define(ae[209],ce([0,1,2,9]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=void 0;class L extends A.$Vc{constructor(O,I=[]){super(),this.a=new N.$0j([O,...I]),this.B(O.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$FQ=L}),define(ae[57],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0,e.$2bc=(0,A.$ti)("nativeHostService")}),define(ae[210],ce([0,1,42,56]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let L=class{constructor(O,I){return this.windowId=O,A.ProxyChannel.toService(I.getChannel("nativeHost"),{context:O,properties:(()=>{const P=new Map;return P.set("windowId",O),P})()})}};e.$kdc=L,e.$kdc=L=Ee([Z(1,N.$edc)],L)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=void 0,e.$bo=(0,j.$ti)("policy");class O extends L.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.$ce),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const E=Object.keys(this.f).length;return this.f={...f,...this.f},E!==Object.keys(this.f).length&&await this.j(f),N.Iterable.reduce(this.g.entries(),(y,[w,h])=>({...y,[w]:h}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(f,[E,y])=>({...f,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$co=O;class I{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$do=I}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0;class j{constructor(P){this.b=P,this.a=new N.$Uc}listen(P,f){switch(f){case"onDidChange":return A.Event.map(this.b.onDidChange,E=>E.reduce((y,w)=>({...y,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(P,f,E){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.$Mcc=j;class O extends L.$co{constructor(P,f){super(),this.a=f;for(const E in P){const{definition:y,value:w}=P[E];this.f[E]=y,w!==void 0&&this.g.set(E,w)}this.a.listen("onDidChange")(E=>{for(const y in E){const w=E[y];w===null?this.g.delete(y):this.g.set(y,w)}this.h.fire(Object.keys(E))})}async j(P){const f=await this.a.call("updatePolicyDefinitions",P);for(const E in f)this.g.set(E,f[E])}}e.$Ncc=O}),define(ae[100],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$gk=(0,A.$ti)("productService"),e.$hk="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;let f=class extends L.$Vc{constructor(y,w,h){super(),this.b=w,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new A.$Fh(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),h=(0,j.$nc)(y),c=(0,j.$oc)(y),p=await O.Promises.readdir(h);await Promise.all(p.map(async g=>{if(g===c)return;const l=(0,j.$kc)(h,g),u=await O.Promises.stat(l);if(u.isDirectory()&&w-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(l)}))}catch(w){(0,N.$1)(w)}}};e.$Ddc=f,e.$Ddc=f=Ee([Z(1,P.$gk),Z(2,I.$Zj)],f)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let E=class extends L.$Vc{constructor(w,h,c){super(),this.b=w,this.c=h,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new A.$Fh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),h=JSON.parse(await O.Promises.readFile((0,j.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const m=h[u];w[`${m.hash}.${u}`]=!0}const c=(0,j.$kc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(c))return;const g=await O.Promises.readdir(c);for(const u of g){if(w[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$kc)(c,u))}const l=Date.now();for(const u of Object.keys(w)){const m=(0,j.$kc)(c,u),d=await O.Promises.readdir(m);for(const $ of d){if($==="tcf.json")continue;const t=(0,j.$kc)(m,$),r=await O.Promises.stat(t);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$kc)(u,$)}`),await O.Promises.rm(t))}}}catch(w){(0,N.$1)(w)}}};e.$Edc=E,e.$Edc=E=Ee([Z(0,I.$Bi),Z(1,P.$Zj),Z(2,f.$gk)],E)}),define(ae[214],ce([0,1,14,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$iG=void 0,e.$iG=(0,N.$ti)("IV8InspectProfilingService");var L;(function(j){function O(P){return!!(P.samples&&P.timeDeltas)}j.isValidProfile=O;function I(P,f="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,A.$jc)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,A.$kc)(f,(0,A.$oc)(E.callFrame.url)));return P}j.rewriteAbsolutePaths=I})(L||(e.Utils=L={}))}),define(ae[215],ce([0,1,32]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const I=await(await new Promise((f,E)=>{ne(["v8-inspect-profiler"],f,E)})).startProfiling({host:j.host,port:j.port,checkForPaused:!0}),P=(0,A.$Pg)();return this.a.set(P,I),P}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const I=await O.stop();return this.a.delete(j),I.profile}}e.$Vdc=N}),define(ae[43],ce([0,1,127,13]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class L{constructor(){this.a=new Map}add(O,I){A.ok(N.$6f(O)),A.ok(N.$8f(I)),A.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$_n=new L}),define(ae[101],ce([0,1,3,43]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=void 0,e.$ao={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class j{constructor(){this.b=new A.$ce,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,f){this.a[L(P)]=f,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;N.$_n.add(e.$ao.JSONContribution,O)}),define(ae[47],ce([0,1,17,3,13,153,21,101,43]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.ConfigurationScope=e.$eo=e.EditPresentationTypes=void 0,e.$po=p,e.$qo=g,e.$ro=l,e.$so=m,e.$to=d;var f;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$eo={Configuration:"base.contributions.configuration"};var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo="vscode://schemas/settings/resourceLanguage",e.$mo="vscode://schemas/settings/configurationDefaults";const y=P.$_n.as(I.$ao.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$ce,this.onDidSchemaChange=this.i.event,this.j=new N.$ce,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$lo,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.$oo.test(o)){const a=this.a.get(o),b=a?.valuesSources??new Map;if(i)for(const C of Object.keys(s[o]))b.set(C,i);const S={...a?.value||{},...s[o]};this.a.set(o,{source:i,value:S,valuesSources:b});const v=(0,O.$0i)(o),k={type:"object",default:S,description:j.localize(1,null,v),$ref:e.$lo,defaultDefaultValue:S,source:L.$6f(i)?void 0:i,defaultValueSource:i};n.push(...p(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:s[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.a.get(i),a=L.$6f(s)?s:s?.id,b=L.$6f(o?.source)?o?.source:o?.source?.id;if(a===b)if(r.add(i),this.a.delete(i),e.$oo.test(i))delete this.d[i],delete this.b.properties[i];else{const S=this.d[i];S&&(this.w(i,S),this.r(i,S))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,n,s,i=3,o){i=L.$cg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const v=a[S];if(r&&m(S,v)){delete a[S];continue}if(v.source=n,v.defaultDefaultValue=a[S].default,this.w(S,v),e.$oo.test(S)?v.scope=void 0:(v.scope=L.$cg(v.scope)?i:v.scope,v.restricted=L.$cg(v.restricted)?!!s?.includes(S):v.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),o.add(S)}const b=t.allOf;if(b)for(const S of b)this.p(S,r,n,s,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.r(o,s[o]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$fo.properties[t]=r,r.scope){case 1:e.$go.properties[t]=r;break;case 2:e.$ho.properties[t]=r;break;case 6:e.$io.properties[t]=r;break;case 3:e.$jo.properties[t]=r;break;case 4:e.$ko.properties[t]=r;break;case 5:e.$ko.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$fo.properties[t],r.scope){case 1:delete e.$go.properties[t];break;case 2:delete e.$ho.properties[t];break;case 6:delete e.$io.properties[t];break;case 3:delete e.$jo.properties[t];break;case 4:case 5:delete e.$ko.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$lo};this.w(r,n),e.$fo.properties[r]=n,e.$go.properties[r]=n,e.$ho.properties[r]=n,e.$io.properties[r]=n,e.$jo.properties[r]=n,e.$ko.properties[r]=n}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$lo};e.$fo.patternProperties[e.$no]=t,e.$go.patternProperties[e.$no]=t,e.$ho.patternProperties[e.$no]=t,e.$io.patternProperties[e.$no]=t,e.$jo.patternProperties[e.$no]=t,e.$ko.patternProperties[e.$no]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let s=n?.value,i=n?.source;L.$ag(s)&&(s=r.defaultDefaultValue,i=void 0),L.$ag(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",c=new RegExp(h,"g");e.$no=`^(${h})+$`,e.$oo=new RegExp(e.$no);function p($){const t=[];if(e.$oo.test($)){let r=c.exec($);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec($)}}return(0,A.$Mb)(t)}function g($){return $.reduce((t,r)=>`${t}[${r}]`,"")}function l($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new w;P.$_n.add(e.$eo.Configuration,u);function m($,t){return $.trim()?e.$oo.test($)?j.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?j.localize(8,null,$):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,$,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}function d(){const $=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))$.push([r,t[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$yo=m;function h(r){return Object.isFrozen(r)?r:I.$1n(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this.b=n,this.c=s,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new p("",this.f);return i.parseRaw(s),i.configurationModel});this.g=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$8i)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return h(i.rawConfiguration.getValue(n))},get override(){return s?h(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:b,keys:S}of i.rawConfiguration.overrides){const v=new c(a,S,[],void 0,i.f).getValue(n);v!==void 0&&o.push({identifiers:b,value:v})}return o.length?h(o):void 0}}}getOverrideValue(n,s){const i=this.j(s);return i?n?(0,E.$8i)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return A.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return A.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$Zn(this.contents),i=I.$Zn(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const b of n)if(a.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const S of b.overrides){const[v]=i.filter(k=>A.$ub(k.identifiers,S.identifiers));v?(this.i(v.contents,S.contents),v.keys.push(...S.keys),v.keys=A.$Mb(v.keys)):i.push(I.$Zn(S))}for(const S of b.keys)o.indexOf(S)===-1&&o.push(S)}return new c(s,o,i,a.every(b=>b instanceof c)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of A.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const b=s[o];b&&(typeof a=="object"&&typeof b=="object"?(a=I.$Zn(a),this.i(a,b)):a=b),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const i of Object.keys(s)){if(i in n&&P.$8f(n[i])&&P.$8f(s[i])){this.i(n[i],s[i]);continue}n[i]=I.$Zn(s[i])}}j(n){let s=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=I.$Zn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$7i)(this.contents,n),y.$oo.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>A.$ub(i.identifiers,(0,y.$po)(n))),1))}k(n,s,i){(0,E.$6i)(this.contents,n,s,o=>this.f.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),y.$oo.test(n)&&this.overrides.push({identifiers:(0,y.$po)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$5i)(this.contents[n],o=>this.f.error(o))})}}e.$uo=c;class p{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$cg(n)){const i=this.h(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:o,overrides:a,restricted:b,hasExcludedProperties:S}=this.i(n,s);this.b=new c(i,o,a,S?[n]:void 0,this.g),this.c=b||[]}h(n){let s={},i=null,o=[];const a=[],b=[];function S(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}const v={onObjectBegin:()=>{const k={};S(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];S(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:S,onError:(k,C,R)=>{b.push({error:k,offset:C,length:R})}};if(n)try{L.$Nn(n,v),s=o[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}i(n,s){const i=w.$_n.as(y.$eo.Configuration).getConfigurationProperties(),o=this.j(n,i,!0,s);n=o.raw;const a=(0,E.$5i)(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),b=Object.keys(n),S=this.l(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:b,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const b={},S=[];for(const v in n)if(y.$oo.test(v)&&i){const k=this.j(n[v],s,!1,o);b[v]=k.raw,a=a||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=s[v],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&!(o.skipRestricted&&k?.restricted))?b[v]=n[v]:a=!0}return{raw:b,restricted:S,hasExcludedProperties:a}}l(n,s){const i=[];for(const o of Object.keys(n))if(y.$oo.test(o)){const a={};for(const b in n[o])a[b]=n[o][b];i.push({identifiers:(0,y.$po)(o),keys:Object.keys(a),contents:(0,E.$5i)(a,s)})}return i}}e.$vo=p;class g extends j.$Vc{constructor(n,s,i,o,a){super(),this.c=n,this.f=s,this.g=o,this.h=a,this.b=this.B(new N.$ce),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&i.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$wo=g;class l{constructor(n,s,i,o,a,b,S,v,k,C,R,M,T){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=b,this.g=S,this.h=v,this.i=k,this.j=C,this.k=R,this.l=M,this.m=T}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,i,o,a,b,S,v,k,C){this.j=n,this.l=s,this.m=i,this.n=o,this.p=a,this.q=b,this.r=S,this.s=v,this.t=k,this.u=C,this.h=null,this.i=new O.$Bc,this.v=null}getValue(n,s,i){return this.w(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this.h=null)}inspect(n,s,i){const o=this.w(n,s,i),a=this.A(s.resource,i),b=s.resource?this.t.get(s.resource)||this.s:this.s,S=new Set;for(const v of o.overrides)for(const k of v.identifiers)o.getOverrideValue(n,k)!==void 0&&S.add(k);return new l(n,s,o.getValue(n),S.size?[...S]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,b)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:b}=$(this.j,n);s=[...o,...a,...b]}for(const o of s)for(const a of(0,y.$po)(o)){const b=this.j.getKeysForOverrideIdentifier(a),S=n.getKeysForOverrideIdentifier(a),v=[...S.filter(k=>b.indexOf(k)===-1),...b.filter(k=>S.indexOf(k)===-1),...b.filter(k=>!I.$4n(this.j.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,v])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=$(this.l,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.applicationConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateApplicationConfiguration(n),{keys:b,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.localUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateLocalUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.remoteUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateRemoteUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.workspaceConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateWorkspaceConfiguration(n),{keys:b,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:b,overrides:S}=$(i,s),v=[...o,...a,...b];return(v.length||!i)&&this.updateFolderConfiguration(n,s),{keys:v,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:b}=$(s,void 0);return{keys:[...i,...o,...a],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,i){let o=this.x(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(o=o.merge(this.l)),o}x({resource:n},s){let i=this.y();if(s&&n){const o=s.getFolder(n);o&&(i=this.z(o.uri)||i);const a=this.t.get(n);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const i=this.y(),o=this.r.get(n);o?(s=i.merge(o),this.i.set(n,s)):s=i}return s}A(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this.r.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.q.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.E(n.defaults,s),o=this.E(n.policy,s),a=this.E(n.application,s),b=this.E(n.user,s),S=this.E(n.workspace,s),v=n.folders.reduce((k,C)=>(k.set(f.URI.revive(C[0]),this.E(C[1],s)),k),new O.$Bc);return new u(i,o,a,b,c.createEmptyModel(s),S,v,c.createEmptyModel(s),new O.$Bc,s)}static E(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.$xo=u;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,b])=>{const S=(0,O.$yc)(s,a,new Set);b.forEach(v=>S.add(v))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class d{constructor(n,s,i,o,a){this.change=n,this.f=s,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const S of b)this.affectedKeys.add(S);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const i=this.a+n,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const b=this.d.charCodeAt(a);if(b!==this.b&&b!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,v=this.g.getValue(n,s,this.h);return!I.$4n(S,v)}return!0}}e.$zo=d;function $(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],b=r?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const v=S.filter(k=>!b.includes(k));for(const k of v)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(r){const v=b.filter(k=>!S.includes(k));for(const k of v)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(n&&r){for(const v of b)if(S.includes(v)){const k=t({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const b=(0,E.$8i)(n.contents,a),S=(0,E.$8i)(r.contents,a);I.$4n(b,S)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=void 0;class w extends L.$Vc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new N.$ce),this.onDidChangeConfiguration=this.a.event,this.b=I.$uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$_n.as(P.$eo.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.f(Array.from(g),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,l){this.j(g,y.$_n.as(P.$eo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=I.$uo.createEmptyModel(this.c);const g=y.$_n.as(P.$eo.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,l){const u=this.g();for(const m of g){const d=u[m],$=l[m];d!==void 0?this.b.addValue(m,d):$?this.b.addValue(m,$.default):this.b.removeValue(m)}}}e.$Ao=w;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$uo.createEmptyModel(new f.$ak)}async initialize(){return this.configurationModel}}e.$Bo=h;let c=class extends L.$Vc{get configurationModel(){return this.b}constructor(g,l,u){super(),this.c=g,this.f=l,this.g=u,this.a=this.B(new N.$ce),this.onDidChangeConfiguration=this.a.event,this.b=I.$uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},u=[],m=y.$_n.as(P.$eo.Configuration).getConfigurationProperties();for(const d of g){const $=m[d];if(!$){u.push(d);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(d),l[$.policy.name]={type:$.type}}}return(0,O.$gg)(l)||await this.f.updatePolicyDefinitions(l),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const l=y.$_n.as(P.$eo.Configuration).getPolicyConfigurations(),u=(0,A.$Hb)(g.map(m=>l.get(m)));this.m(u,!0)}m(g,l){this.g.trace("PolicyConfiguration#update",g);const u=y.$_n.as(P.$eo.Configuration).getConfigurationProperties(),m=[],d=this.b.isEmpty();for(const $ of g){const t=u[$]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(d?r!==void 0:!(0,j.$4n)(this.b.getValue($),r))&&m.push([$,r])}else this.b.getValue($)!==void 0&&m.push([$,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const $=this.b;this.b=I.$uo.createEmptyModel(this.g);for(const t of $.keys)this.b.setValue(t,$.getValue(t));for(const[t,r]of m)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);l&&this.a.fire(this.b)}}};e.$Co=c,e.$Co=c=Ee([Z(1,E.$bo),Z(2,f.$Zj)],c)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=void 0;class u extends P.$Vc{constructor($,t,r,n){super(),this.m=$,this.n=n,this.h=this.B(new j.$ce),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Ao(n)),this.c=r instanceof l.$do?new g.$Bo:this.B(new g.$Co(this.b,r,n)),this.f=this.B(new c.$wo(this.m,{},w.$Xg,t,n)),this.a=new c.$xo(this.b.configurationModel,this.c.configurationModel,c.$uo.createEmptyModel(n),c.$uo.createEmptyModel(n),c.$uo.createEmptyModel(n),c.$uo.createEmptyModel(n),new f.$Bc,c.$uo.createEmptyModel(n),new f.$Bc,n),this.j=new m($,t,this),this.g=this.B(new N.$Fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:i})=>this.s(s,i))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$xo($,t,c.$uo.createEmptyModel(this.n),r,c.$uo.createEmptyModel(this.n),c.$uo.createEmptyModel(this.n),new f.$Bc,c.$uo.createEmptyModel(this.n),new f.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue($,t){const r=typeof $=="string"?$:void 0,n=(0,h.$1i)($)?$:(0,h.$1i)(t)?t:{};return this.a.getValue(r,n,void 0)}async updateValue($,t,r,n,s){const i=(0,h.$2i)(r)?r:(0,h.$1i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,A.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,E.$4n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const S=i.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(k=>(0,A.$ub)([...k.identifiers].sort(),S));v&&(i.overrideIdentifiers=v.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,p.$qo)(i.overrideIdentifiers),$]:[$];await this.j.write(b,t),await this.reloadConfiguration()}inspect($,t={}){return this.a.inspect($,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,t,2)}s($,t){const r=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration($,t);this.u(n,r,7)}t($){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,t,7)}u($,t,r){const n=new c.$zo($,{data:t},this.a,void 0,this.n);n.source=r,this.h.fire(n)}}e.$Do=u;class m{constructor($,t,r){this.b=$,this.c=t,this.d=r,this.a=new N.$Ah}write($,t){return this.a.queue(()=>this.e($,t))}async e($,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,O.$Gn)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,$,t);r=(0,I.$Yn)(r,s),await this.c.writeFile(this.b,L.$De.fromString(r))}f($,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,I.$Vn)($,t,r,{tabSize:n,insertSpaces:s,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&($=t),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsb=e.$Tsb=e.$Ssb=void 0,e.$Usb=I;const O=(f,E,y)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const h=(0,A.$Xe)(A.$De.wrap(w));return[`GET ws://localhost${f}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$Ssb=O,e.$Tsb=A.$De.fromString(`\r
\r
`);async function I(f,E,y,w,h){f.write(A.$De.fromString((0,e.$Ssb)(E,y,w)));const c=new L.$Uc;try{return await new Promise((p,g)=>{let l;c.add(f.onData(u=>{l?l=A.$De.concat([l,u],l.byteLength+u.byteLength):l=u;const m=l.indexOf(e.$Tsb);if(m===-1)return;p(f),f.pauseData();const d=l.slice(m+e.$Tsb.byteLength);d.byteLength&&h.onData.fire(d)})),c.add(f.onClose(u=>g(u??new Error("socket closed")))),c.add(f.onEnd(()=>g(new Error("socket ended"))))})}catch(p){throw f.dispose(),p}finally{c.dispose()}}class P extends L.$Vc{constructor(E,y){super(),this.g=E,this.a=this.B(new N.$fe),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$ce),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(w=>this.a.fire(w))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,y){j.SocketDiagnostics.traceSocketEvent(this,this.g,E,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Vsb=P}),define(ae[219],ce([0,1,7,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.RemoteAuthorityResolverErrorCode=e.$Gl=e.$Fl=e.RemoteConnectionType=e.$El=void 0,e.$Il=f,e.$El=(0,N.$ti)("remoteAuthorityResolverService");var L;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Fl=j;class O{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Gl=O;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class P extends A.$bb{static isNotAvailable(y){return y instanceof P&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof P&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof P&&y._code===I.NoResolverFound}static isInvalidAuthority(y){return y instanceof P&&y._code===I.InvalidAuthority}static isHandled(y){return y instanceof P&&y.isHandled}constructor(y,w=I.Unknown,h){super(y),this._message=y,this._code=w,this._detail=h,this.isHandled=w===I.NotAvailable&&h===!0,Object.setPrototypeOf(this,P.prototype)}}e.$Hl=P;function f(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Nl=b,e.$Ol=S,e.$Pl=k;const c=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function g(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const D=new L.$ne;return setTimeout(()=>D.cancel(),U),D.token}function u(U,D){if(U.isCancellationRequested||D.isCancellationRequested)return L.CancellationToken.Cancelled;const F=new L.$ne;return U.onCancellationRequested(()=>F.cancel()),D.onCancellationRequested(()=>F.cancel()),F.token}class m{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new I.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,A.$mh)(),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function d(U,D){const F=new m(D);return F.registerDisposable(U.onControlMessage(z=>{const x=JSON.parse(z.toString()),K=B(x);K?F.reject(K):F.resolve(x)})),F.promise}function $(U,D,F,z,x,K,ee,_){const Q=new m(_),se=E.$$d.create(!1);return U.info(`Creating a socket (${ee})...`),f.mark(`code/willCreateSocket/${K}`),D.connect(F,z,x,ee).then(ue=>{Q.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),U.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(f.mark(`code/didCreateSocketOK/${K}`),U.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),Q.resolve(ue))},ue=>{f.mark(`code/didCreateSocketError/${K}`),U.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),U.error(ue),Q.reject(ue)}),Q.promise}function t(U,D){const F=new m(D);return U.then(z=>{F.didTimeout||F.resolve(z)},z=>{F.didTimeout||F.reject(z)}),F.promise}async function r(U,D,F,z){const x=te(U,D);U.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let K;try{K=await $(U.logService,U.remoteSocketFactoryService,U.connectTo,P.$Gg.getServerRootPath(),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,g(D),`renderer-${g(D)}-${U.reconnectionToken}`,z)}catch(ue){throw U.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ue),ue}U.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(K,null),ee=U.reconnectionProtocol,_=!1):(ee=new w.$hi({socket:K}),_=!0),U.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Q=await t(U.signService.createNewMessage((0,y.$Pg)()),z),se={type:"auth",auth:U.connectionToken||"00000000000000000000",data:Q.data};ee.sendControl(N.$De.fromString(JSON.stringify(se)));try{const ue=await d(ee,u(z,l(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(U.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(U.signService.validate(Q,ue.signedData),z)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const fe=await t(U.signService.sign(ue.data),z),$e={type:"connectionType",commit:U.commit,signedData:fe,desiredConnectionType:D};return F&&($e.args=F),U.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$De.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(U.logService.error(`${x} the handshake timed out. Error:`),U.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${x} received error control message when negotiating connection. Error:`),U.logService.error(ue)),_&&H(ee),ue}}async function n(U,D,F,z){const x=Date.now(),K=te(U,D),{protocol:ee,ownsProtocol:_}=await r(U,D,F,z),Q=new m(z);return Q.registerDisposable(ee.onControlMessage(se=>{const ue=JSON.parse(se.toString()),ge=B(ue);ge?(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(ge),_&&H(ee),Q.reject(ge)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${V(x)}!`),Q.resolve({protocol:ee,firstMessage:ue}))})),Q.promise}async function s(U,D){const{protocol:F}=await n(U,1,void 0,D);return{protocol:F}}async function i(U,D,F){const{protocol:z,firstMessage:x}=await n(U,2,D,F),K=x&&x.debugPort;return{protocol:z,debugPort:K}}async function o(U,D,F){const z=Date.now(),x=te(U,3),{protocol:K}=await r(U,3,D,F);return U.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${V(z)}!`),K}async function a(U,D,F){const{connectTo:z,connectionToken:x}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:z,connectionToken:x,reconnectionToken:D,reconnectionProtocol:F,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function b(U,D,F){return v(U,async z=>{const{protocol:x}=await s(z,L.CancellationToken.None);return new W(U,D,F,z.reconnectionToken,x)})}async function S(U,D){return v(U,async F=>{const{protocol:z,debugPort:x}=await i(F,D,L.CancellationToken.None);return new J(U,D,F.reconnectionToken,z,x)})}async function v(U,D){for(let z=1;;z++)try{const x=(0,y.$Pg)(),K=await a(U,x,null);return await D(K)}catch(x){if(z<5)U.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(x);else throw U.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(x),X.triggerPermanentFailure(0,0,h.$Hl.isHandled(x)),x}}async function k(U,D,F){const z=await a(U,(0,y.$Pg)(),null);return await o(z,{host:D,port:F},L.CancellationToken.None)}function C(U){return(0,A.$gh)(D=>new Promise((F,z)=>{const x=setTimeout(F,U*1e3);D.onCancellationRequested(()=>{clearTimeout(x),F()})}))}var R;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(R||(e.PersistentConnectionEventType=R={}));class M{constructor(D,F){this.reconnectionToken=D,this.millisSinceLastIncomingData=F,this.type=0}}e.$Ql=M;class T{constructor(D,F,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=F,this.durationSeconds=z,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Rl=T;class q{constructor(D,F,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=F,this.attempt=z,this.type=2}}e.$Sl=q;class Y{constructor(D,F,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=F,this.attempt=z,this.type=4}}e.$Tl=Y;class G{constructor(D,F,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=F,this.attempt=z,this.handled=x,this.type=3}}e.$Ul=G;class X extends I.$Vc{static triggerPermanentFailure(D,F,z){this._permanentFailure=!0,this.f=D,this.g=F,this.h=z,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||X._permanentFailure}constructor(D,F,z,x,K){super(),this.t=D,this.u=F,this.reconnectionToken=z,this.protocol=x,this.w=K,this.m=this.B(new O.$ce),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=he(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),X.j.push(this),this.B((0,I.$Tc)(()=>{const ee=X.j.indexOf(this);ee>=0&&X.j.splice(ee,1)})),this.n&&this.D(X.f,X.g,X.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const x=z<F.length?F[z]:F[F.length-1];try{if(x>0){const ee=C(x);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${D} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${D} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${K.connectTo}...`),await this.G(K,l(c)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(h.$Hl.isTemporarilyNotAvailable(K)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,j.$4)(K)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof h.$Hl){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,h.$Hl.isHandled(K));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(D,F,z){this.w?X.triggerPermanentFailure(D,F,z):this.D(D,F,z)}D(D,F,z){this.m.fire(new G(this.reconnectionToken,D,F,z)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Vl=X;class W extends X{constructor(D,F,z,x,K){super(1,D,x,K,!0),this.client=this.B(new w.$fi(K,{remoteAuthority:F,clientId:z},D.ipcLogger))}async G(D,F){await s(D,F)}}e.$Wl=W;class J extends X{constructor(D,F,z,x,K){super(2,D,z,x,!1),this.H=F,this.debugPort=K}async G(D,F){await i(D,this.H,F)}}e.$Xl=J;function H(U){try{U.acceptDisconnect();const D=U.getSocket();U.dispose(),D.dispose()}catch(D){(0,j.$1)(D)}}function B(U){if(U&&U.type==="error"){const D=new Error(`Connection error: ${U.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function ie(U,D){for(;U.length<D;)U+=" ";return U}function re(U,D){return`[remote-connection][${ie(g(U),13)}][${D.substr(0,5)}\u2026]`}function he(U,D,F){return`${re(U,D)}[${F?"reconnect":"initial"}]`}function te(U,D){return`${he(D,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function V(U){return`${Date.now()-U} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=N,e.$Fm=L,e.$Gm=j,e.$Hm=O;function N(P){return P.scheme===A.Schemas.vscodeRemote?P.authority:void 0}function L(P){if(!P)return;const f=P.indexOf("+");return f<0?P:P.substr(0,f)}function j(P){const{host:f,port:E}=I(P);if(typeof E>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:f,port:E}}function O(P,f){let{host:E,port:y}=I(P);return typeof y>"u"&&(y=f),{host:E,port:y}}function I(P){const f=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(f)return{host:f[1],port:parseInt(f[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=P.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:P,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Qm=e.$Pm=e.$Om=e.TargetPlatform=e.ExtensionType=e.$Nm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0,e.$Mm=j,e.$Rm=y,e.$Sm=w,e.$Tm=h,e.$Um=c,e.$Im="extensions.user.cache",e.$Jm="extensions.builtin.cache",e.$Km="undefined_publisher",e.$Lm=["ui","workspace","web"];function j(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Nm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class P{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const u=typeof g=="string"?g:g.value,m=typeof l=="string"?l:l.value;return A.$vf(u,m)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Om=P;class f{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const l of g)this.add(l)}add(g){this.c.add(P.toKey(g))}delete(g){return this.c.delete(P.toKey(g))}has(g){return this.c.has(P.toKey(g))}}e.$Pm=f;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(P.toKey(g))}get(g){return this.c.get(P.toKey(g))}has(g){return this.c.has(P.toKey(g))}set(g,l){this.c.set(P.toKey(g),l)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Qm=E;function y(p){return w(p)}function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function c(p,g){if(g){const l=`onResolveRemoteAuthority:${(0,L.$Fm)(g)}`;return!!p.activationEvents?.includes(l)}return!1}e.$Vm=(0,N.$ti)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;class j extends A.$Vc{constructor(I,P,f,E,y){super(),this.a=I,this.b=P,this.c=f,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(I){for(const P of I)P.local&&this.invalidate(P.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,I)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Im))}catch(P){(0,L.$el)(P)!==1&&this.f.error(P)}}}e.$yq=j}),define(ae[103],ce([0,1,2,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0,e.$Jl=(0,N.$ti)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,A.$Tc)(()=>{const P=this.a[O]?.indexOf(I);typeof P=="number"&&P>=0&&this.a[O]?.splice(P,1)})}b(O){return(this.a[O.type]||[]).find(P=>P.supports(O))}connect(O,I,P,f){const E=this.b(O);if(!E)throw new Error(`No socket factory found for ${O}`);return E.connect(O,I,P,f)}}e.$Kl=L}),define(ae[222],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=void 0,e.$Sdc=(0,A.$ti)("sharedProcessTunnelService"),e.$Tdc="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=e.$2dc=e.$1dc=e.$Zdc=e.TunnelStates=e.$Ydc=e.$Xdc=void 0,e.$Xdc=(0,A.$ti)("IRemoteTunnelService"),e.$Ydc={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Zdc="remote.tunnels.access",e.$1dc=e.$Zdc+".hostNameOverride",e.$2dc=e.$Zdc+".preventSleep",e.$3dc="remoteTunnelService",e.$4dc=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,43]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=void 0,e.$Mp=w,e.$Np=h,e.$Op=c,e.$Pp=p,e.$Qp=g,e.$Rp=l,e.$Kp=(0,I.$ti)("requestService");class E{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?$[t]="*****":$[t]=this.b[t];this.a=$}return this.a}}class y extends L.$Vc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,j.localize)(0,null),when:P.$fk.isEqualTo((0,P.$ck)(P.LogLevel.Trace)).serialize()})}async c($,t,r){const n=`${$} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new E(t.headers??{}));try{const s=await r();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$0)(s)),s}}}e.$Lp=y;function w(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function h(d){return d.res.statusCode===204}async function c(d){return h(d)?null:(await(0,A.$Pe)(d.stream)).toString()}async function p(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function g(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const t=(await(0,A.$Pe)(d.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function l(d){m(d)}let u;function m(d){const $=f.$_n.as(O.$eo.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:t?[t]:[]})}m(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;let O=class{constructor(P,f){this.a=P,this.b=f}async download(P,f,E=A.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.b.copy(P,f);return}const y={type:"GET",url:P.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile(f,w.stream);else{const h=await(0,j.$Pp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$UQ=O,e.$UQ=O=Ee([Z(0,j.$Kp),Z(1,L.$Zk)],O)}),define(ae[224],ce([0,1,15,26]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=void 0;class L{constructor(I){this.a=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,f,E=N.CancellationToken.None){switch(P){case"request":return this.a.request(f[0],E).then(async({res:y,stream:w})=>{const h=await(0,A.$Pe)(w);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(f[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Rr=L;class j{constructor(I){this.a=I}async request(I,P){const[f,E]=await this.a.call("request",[I],P);return{res:f,stream:(0,A.$Re)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Sr=j}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=e.$kcc=void 0,e.$kcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$lcc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$mcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;class A{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(A.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$e$b=A}),define(ae[105],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0,e.$Ll="signService",e.$Ml=(0,A.$ti)(e.$Ll)}),define(ae[227],ce([0,1,226]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class N extends A.$e$b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$adc=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cKb=e.$bKb=e.$aKb=e.$_Jb=void 0;class L extends N.$Vc{constructor(y,w,h){super(),this.a=y,this.b=w,this.c=h}async getItems(){const y={profile:this.b,workspace:this.c},w=await this.a.call("getItems",y);return new Map(w)}updateItems(y){const w={profile:this.b,workspace:this.c};return y.insert&&(w.insert=Array.from(y.insert.entries())),y.delete&&(w.delete=Array.from(y.delete.values())),this.a.call("updateItems",w)}optimize(){const y={profile:this.b,workspace:this.c};return this.a.call("optimize",y)}}class j extends L{constructor(y,w){super(y,w,void 0),this.f=this.B(new A.$ce),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class O extends j{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$_Jb=O;class I extends j{constructor(y,w){super(y,w)}async close(){this.dispose()}}e.$aKb=I;class P extends L{constructor(y,w){super(y,void 0,w),this.onDidChangeItemsExternal=A.Event.None}async close(){this.dispose()}}e.$bKb=P;class f{constructor(y){this.a=y}isUsed(y){const w={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$cKb=f}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=O,e.$bp=I;function j(P){if(A.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function O(P,f,E,y,w,h,c,p,g){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=c,l.sessionID=(0,L.$Pg)()+Date.now(),l.commitHash=y,l.version=w,l["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,A.$h)(A.$u),l["common.nodePlatform"]=N.$ec,l["common.nodeArch"]=E,l["common.product"]=g||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const m=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),A.$l&&(l["common.snap"]="true");const d=j(f);return d&&(l["common.platformDetail"]=d),l}function I(P){const f=N.env.USERDNSDOMAIN;if(!f)return!1;const E=f.toLowerCase();return P.some(y=>E===y)}}),define(ae[22],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0,e.$Yl=(0,A.$ti)("telemetryService"),e.$Zl=(0,A.$ti)("customEndpointTelemetryService"),e.$1l="telemetry.currentSessionDate",e.$2l="telemetry.firstSessionDate",e.$3l="telemetry.lastSessionDate",e.$4l="telemetry.machineId",e.$5l="telemetry.sqmId",e.$6l="telemetry",e.$7l="telemetry.telemetryLevel",e.$8l="telemetry.enableCrashReporter",e.$9l="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0,e.$As=l,e.$Bs=m,e.$Cs=d;const g=new Map;async function l(t,r){const n=`${t}::${r.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,b=2e4;function S(k,C,R,M){const T=C.substring(k.length+1);return N.Promises.withAsyncBody(async q=>{let Y;try{Y=await E.Promises.readdir(C,{withFileTypes:!0})}catch{q();return}if(M.count>=b){M.count+=Y.length,M.maxReached=!0,q();return}let G=Y.length;if(G===0){q();return}let X=Y;M.count+Y.length>b&&(M.maxReached=!0,G=b-M.count,X=Y.slice(0,G)),M.count+=Y.length;for(const W of X)if(W.isDirectory()){if(R.includes(W.name)||await S(k,(0,O.$kc)(C,W.name),R,M),--G===0){q();return}}else{const J=W.name.lastIndexOf(".");if(J>=0){const H=W.name.substring(J+1);H&&o.set(H,(o.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(T)!==!1&&H.filePattern.test(W.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--G===0){q();return}}})}const v=N.Promises.withAsyncBody(async k=>{const C={count:0,maxReached:!1};await S(t,t,r,C);const R=await d(t);k({configFiles:u(a),fileTypes:u(o),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:R})});return g.set(n,v),v}function u(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function m(){const t={os:`${A.type()} ${A.arch()} ${A.release()}`,memory:`${(A.totalmem()/h.$vl.GB).toFixed(2)}GB (${(A.freemem()/h.$vl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$Bn.value()*100)}%`},r=A.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function d(t){try{const r=new Map,n=(0,O.$kc)(t,".vscode","launch.json"),s=await E.Promises.readFile(n),i=[],o=(0,L.$Gn)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Pn)(o)==="object"&&o.configurations)for(const a of o.configurations){const b=a.type;b&&(r.has(b)?r.set(b,r.get(b)+1):r.set(b,1))}return u(r)}catch{return[]}}let $=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${A.type()} ${A.arch()} ${A.release()}`);const s=A.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(A.totalmem()/h.$vl.GB).toFixed(2)}GB (${(A.freemem()/h.$vl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${A.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.$Bn.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.$zs)(r.mainPID),this.k(r)]).then(async s=>{let[i,o]=s,a=this.m(r,i);return n.forEach(b=>{if((0,w.$bn)(b))a+=`
${b.errorMessage}`,o+=`
${b.errorMessage}`;else if(a+=`

Remote: ${b.hostName}`,b.processes&&(a+=`
${this.m(r,b.processes)}`),b.workspaceMetadata){o+=`
|  Remote: ${b.hostName}`;for(const S of Object.keys(b.workspaceMetadata)){const v=b.workspaceMetadata[S];let k=`${v.fileCount} files`;v.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${S}): ${k}`,o+=this.h(v)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=m(),b={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(b.load=`${A.loadavg().map(S=>Math.round(S)).join(", ")}`),I.$k&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(r,n){const s=[];return(0,y.$zs)(r.mainPID).then(async i=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),n.forEach(o=>{if((0,w.$bn)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const b=o.workspaceMetadata[a];let S=`${b.fileCount} files`;b.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${a}): ${S}`),s.push(this.h(b))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const n=[];let i=0;const o=(v,k)=>{const C=` ${v}(${k})`;i+C.length>60?(n.push(a),a="|                 ",i=a.length):i+=C.length,a+=C};let a="|      File types:";const b=10,S=r.fileTypes.length>b?b:r.fileTypes.length;for(let v=0;v<S;v++){const k=r.fileTypes[v];o(k.name,k.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(v=>{o(v.name,v.count)}),n.push(a)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{const C=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;v+=C}),n.push(v)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=P.URI.revive(o);if(a.scheme===j.Schemas.file){const b=a.fsPath;s.push(l(b,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,O.$oc)(b)}): ${v}`),n.push(this.h(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${b} (${S.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,s,i,n,0),i.join(`
`)}n(r,n,s,i,o){const a=o===0;let b;a?b=i.pid===r?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?b=n.get(i.pid):b=`${"  ".repeat(o)} ${i.name}`;const S=process.platform==="win32"?i.mem:A.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/h.$vl.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(i.children)&&i.children.forEach(v=>this.n(r,n,s,v,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=P.URI.revive(s);if(i.scheme!==j.Schemas.file)continue;const o=i.fsPath;try{(await l(o,["node_modules",".git"])).fileTypes.forEach(b=>n.add(b.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=P.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const i=s.fsPath;try{const o=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Ds=$,e.$Ds=$=Ee([Z(0,p.$Yl),Z(1,c.$gk)],$)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.ExtensionSignatureVerificationCode=e.$9p=void 0,e.$9p=(0,N.$ti)("IExtensionSignatureVerificationService");var O;(function(f){f.None="None",f.RequiredArgumentMissing="RequiredArgumentMissing",f.InvalidArgument="InvalidArgument",f.PackageIsUnreadable="PackageIsUnreadable",f.UnhandledException="UnhandledException",f.SignatureManifestIsMissing="SignatureManifestIsMissing",f.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",f.SignatureIsMissing="SignatureIsMissing",f.SignatureIsUnreadable="SignatureIsUnreadable",f.CertificateIsUnreadable="CertificateIsUnreadable",f.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",f.FileAlreadyExists="FileAlreadyExists",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",f.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",f.Success="Success",f.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",f.SignatureIsInvalid="SignatureIsInvalid",f.SignatureManifestIsInvalid="SignatureManifestIsInvalid",f.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",f.EntryIsMissing="EntryIsMissing",f.EntryIsTampered="EntryIsTampered",f.Untrusted="Untrusted",f.CertificateRevoked="CertificateRevoked",f.SignatureIsNotValid="SignatureIsNotValid",f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class I extends Error{constructor(E){super(E),this.code=E}}e.$0p=I;let P=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>ne(["@vscode/vsce-sign"],async w=>E(w),y))),this.a}async verify(E,y,w){let h;try{h=await this.d()}catch(l){return this.b.error("Could not load vsce-sign module",(0,A.$0)(l)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const c=new Date().getTime();let p;try{p=await h.verify(y,w,this.b.getLevel()===L.LogLevel.Trace)}catch(l){p={code:"UnknownError",didExecute:!1,output:(0,A.$0)(l)}}const g=new Date().getTime()-c;if(this.b.info(`Extension signature verification result for ${E}: ${p.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${p.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,code:p.code,duration:g,didExecute:p.didExecute}),p.code==="Success")return!0;throw new I(p.code)}};e.$$p=P,e.$$p=P=Ee([Z(0,L.$Zj),Z(1,j.$Yl)],P)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class A{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:I,data:P}){return this.b.forEach(f=>f.log(I,P)),Promise.resolve(null)}}e.$pcc=A;class N{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$qcc=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=E,e.$kp=y,e.$lp=w,e.$mp=h,e.$np=p,e.$op=l,e.$pp=u,e.$qp=$;class I{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$cp=I;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$dp=P,e.$ep=new P;class f{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.$fp=f,e.$gp="telemetry",e.$hp="extensionTelemetryLog",e.$ip={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const r=t.getValue(O.$7l),n=t.getValue(O.$8l);if(t.getValue(O.$9l)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function h(t){const r={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const r=(0,L.$Fm)(t);return c.has(r)?r:"other"}function g(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,A.$5n)(o):o instanceof Date?r[a]=o.toISOString():(0,N.$8f)(o)?n<2?g(o,r,n+1,a+"."):r[a]=(0,A.$5n)(o):r[a]=o}}function l(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,j.$bp)(n)||s}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const b of r)for(;;){const S=b.exec(t);if(!S)break;s.push([S.index,b.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const b=o.exec(t);if(!b)break;const S=s.some(([v,k])=>b.index<k&&v<o.lastIndex);!i.test(b[0])&&!S&&(n+=t.substring(a,b.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function d(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function $(t,r){return(0,A.$2n)(t,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=m(s,r);for(const i of r)s=s.replace(i,"");return s=d(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$sp=void 0,e.$rp=E,e.$tp=c,e.$up=p,e.$vp=g,e.$wp=l,e.$xp=u,e.$yp=m,e.$zp=d,e.$Bp=$,e.$Cp=r;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,A.$qf)(n.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,i,o)}static parse(s){const i=y.exec(s);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$sp=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=h.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}function p(n,s){return`${n}.${s}`}function g(n){return n.toLowerCase()}function l(n,s){return g(p(n??L.$Km,s))}function u(n,s){const i=[],o=a=>{for(const b of i)if(b.some(S=>E(s(S),s(a))))return b;return null};for(const a of n){const b=o(a);b?b.push(a):i.push([a])}return i}function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function d(n){return{id:new f.$cp(n.identifier.id),name:new f.$cp(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Ap=new L.$Om("pprice.better-merge");function $(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(b=>!E(b.identifier,{id:a}))){const b=n.filter(S=>E(S.identifier,{id:a}));b.length===1&&(i.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!j.$k)return!1;let i;try{i=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,N.$Yo)(i?"alpine":j.$u,P.$fc);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0;let c=class extends N.$Vc{constructor(m,d){super(),this.b=m,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const d=[];for(const[$,t]of this.a)if(!(t.configScheme&&t.configScheme!==m.scheme))try{const r=(await this.b.readFile((0,L.$7g)(m,$))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&d.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return d}};e.$nac=c,e.$nac=c=Ee([Z(0,O.$Zk),Z(1,I.$gk)],c);const p="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class l extends c{constructor(m,d,$,t,r,n,s,i){super(s,i),this.r=m,this.s=d,this.t=$,this.u=t,this.w=r,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const b=[],S=[],v=[];Object.entries(a.recommendations).forEach(([k,C])=>{C.important?a.important?b.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):S.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):v.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack})}),b.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),S.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),v.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v})}),(0,P.$vh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),d=await this.O(this.h);return[...m,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),d=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(m,$),this.n=this.D(d,$)}D(m,d){const $=new Map;m.forEach(i=>$.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...$.keys()],d);for(const i of t){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.L(),s=new Map;for(const i of r){const o=$.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}F(){if(this.m.size===0)return;const[m,d]=[...this.m.entries()][0];this.H(d).then($=>{switch($){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Wc);t.value=(0,P.$vh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),d=Date.now()-m,$=7*24*60*60*1e3;if(d<$){const n=this.B(new N.$Wc);n.value=(0,P.$vh)(()=>{n.dispose(),this.G()},$-d);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const s=this.B(new N.$Wc);s.value=(0,P.$vh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Wc);s.value=(0,P.$vh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const d=await this.u.getInstalled(1),$=m.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>d.every(n=>!(0,h.$rp)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(g,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(g,m,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(m,d){const $=this.L();$[m]=d.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify($),-1,0)}N(m,d){const $=[],t=[],r=d.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return m.forEach(n=>{r.has(n.toLowerCase())?$.push(n):t.push(n)}),{installed:$,uninstalled:t}}async O(m){const d=[],$=new Map;for(const t of m.keys()){const r=m.get(t);if(!r||!(0,A.$Lb)(r.recommendations))continue;const n=[];y.$i?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,E.$kc)("/usr/local/bin",t)),n.push((0,E.$kc)("/usr/bin",t)),n.push((0,E.$kc)(this.r.fsPath,t)));for(const s of n){let i=$.get(s);if(i===void 0&&(i=await this.b.exists(j.URI.file(s)),$.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:b,whenNotInstalled:S}of r.recommendations)d.push({extensionId:o,extensionName:a,isExtensionPack:b,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return d}}e.$oac=l}),define(ae[230],ce([0,1,26,33]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=L;async function L(j,O,I,P,f){try{const E=await j.getExtensionsControlManifest();if(!E.deprecated)return;const y=await j.getInstalled(1);for(const[w,h]of Object.entries(E.deprecated)){if(!h?.extension)continue;const{id:c,autoMigrate:p,preRelease:g}=h.extension;if(!p)continue;const l=y.find(m=>(0,N.$rp)(m.identifier,{id:w}));if(!l)continue;const u=(await O.getExtensions([{id:c,preRelease:g}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0];if(!u){f.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{f.info(`Migrating '${l.identifier.id}' extension to '${c}' extension...`);const m=!P.getDisabledExtensions().some($=>(0,N.$rp)($,l.identifier));await j.uninstall(l),f.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=y.find($=>(0,N.$rp)($.identifier,{id:c}));(!d||!d.isPreReleaseVersion&&m)&&(d=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${d.identifier.id}'`),m||(await P.disableExtension(d.identifier),f.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$up)(l.manifest.publisher,l.manifest.name),(0,N.$up)(d.manifest.publisher,d.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${l.identifier.id}' extension to '${c}' extension.`)}catch(m){f.error(m)}}}catch(E){f.error(E)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;let d=class extends L.$Vc{static{m=this}static{this.c=".sigzip"}constructor(t,r,n,s,i,o){super(),this.h=r,this.j=n,this.m=s,this.n=i,this.r=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,r,n){await this.g;const s=(0,O.$7g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,o=>this.j.download(t,o,r))}catch(o){throw new c.$4o(o.message,c.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const o=await this.u(t);try{i=await this.n.verify(t.identifier.id,s.fsPath,o.fsPath)}catch(a){if(i=a.code,i==="PackageIsInvalidZip"||i==="SignatureArchiveIsInvalidZip"){try{await this.delete(s)}catch(S){this.r.error(S)}throw new c.$4o(y.$dq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(a){this.r.error(a)}}}return{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,P.$_f)(r)?r:!0}async u(t){await this.g;const r=(0,O.$7g)(this.extensionsDownloadDir,`${this.z(t)}${m.c}`);try{await this.w(t,r,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new c.$4o(n.message,c.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(t,r,n){if(await this.h.exists(r))return;if(r.scheme!==j.Schemas.file){await n(r);return}const s=(0,O.$7g)(this.extensionsDownloadDir,`.${(0,f.$Pg)()}`);await this.h.exists(s)||await n(s);try{await E.Promises.rename(s.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(m.c))s.push(a.resource);else{const b=p.$sp.parse(a.name);b&&n.push([b,a])}const i=(0,p.$xp)(n,([a])=>a),o=[];for(const a of i)a.sort((b,S)=>I.rcompare(b[0].version,S[0].version)),r.push(...a.slice(1).map(b=>b[1].resource)),o.push(a[0][1]);o.sort((a,b)=>a.mtime-b.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),r.push(...s),await A.Promises.settled(r.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$sp.create(t).toString().toLowerCase():(0,f.$Pg)()}};e.$vq=d,e.$vq=d=m=Ee([Z(0,h.$Bi),Z(1,l.$Zk),Z(2,c.$3o),Z(3,w.$Zi),Z(4,g.$9p),Z(5,u.$Zj)],d)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class I extends N.$Vc{constructor(f,E,y,w,h,c,p){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.r=p,this.a=this.B(new A.$ce),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$5c),this.s().then(null,g=>p.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map(E=>(this.c.set(E.id,(0,N.$Sc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(f){for(const E of f.extensions)this.I(this.L(E.identifier,E.version),f.profileLocation)}async y(f){for(const E of f.extensions){const y=this.L(E.identifier,E.version);f.error?this.J(y,f.profileLocation):this.I(y,f.profileLocation)}}async z(f){for(const E of f.extensions)this.J(this.L(E.identifier,E.version),f.profileLocation)}async C(f){const E=[],y=[];for(const w of f.extensions){const h=this.L(w.identifier,w.version);f.error?this.I(h,f.profileLocation):(this.J(h,f.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",w.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D(f){for(const E of this.h.profiles)f.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(f){const E=[],y=[],w=await this.j.scanProfileExtensions(f),h=new Set,c=new Set;for(const[p,g]of this.b)g.has(f)&&c.add(p);for(const p of w){const g=this.L(p.identifier,p.version);h.add(g),c.has(g)||(E.push(p.identifier),this.I(g,f))}for(const p of c)if(!h.has(p)){const g=this.M(p);g&&(y.push(g.identifier),this.J(p,f))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:f}:void 0,removed:y.length?{extensions:y,profileLocation:f}:void 0})}async G(f){const E=await this.j.scanProfileExtensions(f);for(const y of E)this.I(this.L(y.identifier,y.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,E){let y=this.b.get(f);y||this.b.set(f,y=new L.$Cc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J(f,E){const y=this.b.get(f);y&&y.delete(E),y?.size||this.b.delete(f)}L(f,E){return`${O.$Om.toKey(f.id)}@${E}`}M(f){const[E,y]=(0,j.$tp)(f);return y?{identifier:{id:E},version:y}:void 0}}e.$zq=I}),define(ae[233],ce([0,1,45,49]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=L;async function L(j,O,I,P,f,E,y){const w={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,N.$jp)(O,I)&&(0,N.$lp)(P)===3){const h=await(0,A.$4p)(I,f,E);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=y.machineId||h}return w}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;let p=class extends h.$Pr{constructor(m,d,$,t){super($),this.h=m,this.j=t,this.g=this.B(new g(d,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,d){const t=(await this.g.getLanguagePacks())[d];if(!t){this.j.warn(`No language pack found for ${d}`);return}const r=t.translations[m];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),d=Object.keys(m).map($=>{const t=m[$];return{...this.f($,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort(($,t)=>$.label.localeCompare(t.label)),d}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const d=await this.g.getLanguagePacks();Object.keys(d).some($=>d[$]&&d[$].extensions.some(t=>(0,y.$rp)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(d);return!(0,N.$ub)(Object.keys(m),Object.keys($))}};e.$Qr=p,e.$Qr=p=Ee([Z(0,E.$6o),Z(1,f.$Bi),Z(2,E.$3o),Z(3,w.$Zj)],p);let g=class extends j.$Vc{constructor(m,d){super(),this.j=d,this.c={},this.f=(0,I.$kc)(m.userDataPath,"languagepacks.json"),this.g=new L.$Ah}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(d=>{Object.keys(d).forEach($=>delete d[$]),this.m(d,...m)}).then(()=>this.c)}m(m,...d){for(const $ of d)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(m,$);Object.keys(m).forEach($=>this.r(m[$]))}n(m,d){const $=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of t)if(d.location.scheme===O.Schemas.file&&l(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const s=n.extensions.filter(i=>(0,y.$rp)(i.extensionIdentifier,$))[0];s?s.version=d.manifest.version:n.extensions.push({extensionIdentifier:$,version:d.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,I.$kc)(d.location.fsPath,i.path)}}r(m){if(m){const d=(0,A.createHash)("md5");for(const $ of m.extensions)d.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);m.hash=d.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let d=null;return P.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(d=m($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),P.Promises.writeFile(this.f,t)}).then(()=>d,$=>this.j.error($))})}};g=Ee([Z(0,f.$Bi),Z(1,w.$Zj)],g);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const m of u.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(E,y,w){const h=await(0,A.$VD)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,A.$VD)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,g=new c.PostChannel,l={instrumentationKey:E,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(w){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[g.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class f{constructor(y,w,h,c,p){this.e=y,this.f=w,this.g=h,this.h=p,this.c=O,this.d=I,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,N.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,L.$3n)(w,this.g),w=(0,j.$mp)(w);const h=this.f+"/"+y;try{this.i(c=>{c.pluginVersionString=w?.properties.version??"Unknown",c.track({name:h,baseData:{name:h,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$sQ=f}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=void 0;let P=class extends A.$Vc{constructor(E,y,w,h,c=""){super(),this.b=c;const p=y.getLogger(I.$gp);if(p)this.a=this.B(p);else{const l=(0,I.$kp)(h,w)?" (Not Sent)":"",u=()=>(0,I.$jp)(h,w)&&E.getLevel()===j.LogLevel.Trace;this.a=this.B(y.createLogger(I.$gp,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>y.setVisibility(I.$gp,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,y){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$mp)(y))}};e.$N_b=P,e.$N_b=P=Ee([Z(0,j.$Zj),Z(1,j.$1j),Z(2,L.$Ai),Z(3,O.$gk)],P)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,43,22,49]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,m){this.k=u,this.l=m,this.d={},this.i=new A.$Uc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,j.$0e)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$0e)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(w.$7l)||d.affectsConfiguration(w.$9l)||d.affectsConfiguration(w.$8l))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$lp)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const m=u.usage?3:u.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,m){this.g<u||(m=(0,N.$3n)(m,this.d),m=(0,h.$qp)(m,this.j),m=(0,N.$3n)(m,this.c),this.b.forEach(d=>d.log(l,m)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Wr=c,e.$Wr=c=Ee([Z(1,I.$Zi),Z(2,E.$gk)],c);function p(){const g=(0,O.localize)(0,null,f.default.nameLong),l=f.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),d=(0,O.localize)(5,null),$=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${m} | ${d} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${g} ${l} ${u}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}y.$_n.as(P.$eo.Configuration).registerConfiguration({id:w.$6l,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$7l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$_n.as(P.$eo.Configuration).registerConfiguration({id:w.$6l,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$9l]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,O.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,O.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$7l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=void 0;async function O(E,y){const w=await y.request(E,N.CancellationToken.None),h=(await(0,A.$Pe)(w.stream)).toString(),c=w.res.statusCode??200;return{headers:w.res.headers,statusCode:c,responseData:h}}async function I(E){const y={method:E.type,headers:E.headers};return new Promise((h,c)=>{const p=L.request(E.url??"",y,g=>{g.on("data",function(l){h({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){c(l)})});p.write(E.data,g=>{g&&c(g)}),p.end()})}async function P(E,y,w){const h=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),c={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:h};try{const p=E?await O(c,E):await I(c);w(p.statusCode,p.headers,p.responseData)}catch{w(0,{})}}class f extends j.$sQ{constructor(y,w,h,c,p){const g={sendPOST:(l,u)=>{P(y,l,u)}};super(w,h,c,p,g)}}e.$tQ=f}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let w=class{constructor(c,p,g,l,u,m){this.b=c,this.c=p,this.d=g,this.e=l,this.f=u,this.g=m,this.a=new Map}h(c){if(!this.a.has(c.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const g=[c.id,JSON.stringify(p),c.aiKey],u=new N.$Xq(A.$Ng.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new f.$qcc(u),new E.$N_b(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new y.$Wr({appenders:m,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,p,g){this.h(c).publicLog(p,g)}publicLogError(c,p,g){this.h(c).publicLogError(p,g)}};e.$Kdc=w,e.$Kdc=w=Ee([Z(0,L.$Zi),Z(1,P.$Yl),Z(2,O.$Zj),Z(3,O.$1j),Z(4,j.$Ai),Z(5,I.$gk)],w)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$ew=e.$cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$$v=e.$0v=void 0,e.$_v=f,e.$aw=y,e.$bw=w,e.$dw=h,e.$fw=c,e.$gw=p,e.$0v=(0,j.$ti)("tunnelService"),e.$$v=(0,j.$ti)("sharedTunnelsService");var I;(function(u){u.Http="http",u.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function y(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(m)return{address:m[1],port:+m[2]}}function w(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const m=u.query.split("&");for(const d of m){const $=d.split("=")[1];if(/^https?:/.exec($)){const t=y(N.URI.parse($));if(t)return t}}}e.$cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(u){return e.$cw.indexOf(u)>=0}e.$ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$ew.indexOf(u)>=0}function p(u,m,d,$){if(d===1)return!1;if(d===2&&c(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class g{constructor(m,d,$){this.remoteAddress=m,this.localAddress=d,this.b=$,this.a=new A.$ce,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$hw=g;let l=class{constructor(m,d){this.k=m,this.l=d,this.a=new A.$ce,this.onTunnelOpened=this.a.event,this.b=new A.$ce,this.onTunnelClosed=this.b.event,this.c=new A.$ce,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const m=this.l.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.i=m.privacyOptions,this.h=m.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const m=[],d=Array.from(this.e.values());for(const $ of d){const t=Array.from($.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&m.push(n)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:d}of m.values())await d.then($=>typeof $!="string"?$?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,d,$,t,r){this.q(m,d,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:d,localAddress:$,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,d){(c(m)||h(m))&&(m=e.$cw[0]);const $=this.s(m,d);if($)return++$.refcount,$.value}openTunnel(m,d,$,t,r,n=!1,s,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${$} on local port ${r}.`);const o=this.f??m;if(!o)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,d,$,t,r,n,s,i);return a?a.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,$),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(b);return(b.tunnelRemoteHost!==d||b.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this.e.get(m.tunnelRemoteHost);if(d){const $=d.get(m.tunnelRemotePort);$&&($.refcount--,await this.p(m.tunnelRemoteHost,m.tunnelRemotePort,$))}}}}async p(m,d,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const t=$.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(d),t}}async closeTunnel(m,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const $=this.e.get(m);if($&&$.has(d)){const t=$.get(d);t.refcount=0,await this.p(m,d,t)}}q(m,d,$){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(d,{refcount:1,value:$})}async r(m,d){const $=this.e.get(m);if($){const t=$.get(d),r=t?await t.value:void 0;(!r||typeof r=="string")&&$.delete(d),$.size===0&&this.e.delete(m)}}s(m,d){const $=[m];h(m)?($.push(...e.$cw),$.push(...e.$ew)):c(m)&&$.push(...e.$ew);const t=$.map(r=>this.e.get(r));for(const r of t){const n=r?.get(d);if(n)return n}}canTunnel(m){return!!y(m)}u(m,d,$,t,r,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${$} on local port ${t}.`);const i=$;this.j.add(i);const o=t===void 0?$:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},b={remoteAddress:{host:d,port:$},localAddressPort:t,privacy:n,public:n?n!==P.Private:void 0,protocol:s},S=m.forwardPort(b,a);return S?(this.q(d,$,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$iw=l,e.$iw=l=Ee([Z(0,O.$Zj),Z(1,L.$Zi)],l)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,A,N,L,j,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class P extends L.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Qh),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let f=class extends L.$Vc{static{I=this}static{this.a=0}constructor(y,w){super(),this.f=y,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(y,w,h,c,p,g,l){const u=new P,m=await Promise.resolve(this.f.openTunnel(y,u,h,c,p,g,l));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await m.dispose(),(0,j.$6)();return u.setTunnel(m),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${h}:${c} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(y,w){const h=this.b.get(y);h&&h.setAddress(w)}async destroyTunnel(y){const w=this.b.get(y);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await w.dispose();return}this.c.add(y)}};e.$Udc=f,e.$Udc=f=I=Ee([Z(0,N.$$v),Z(1,A.$Zj)],f)}),define(ae[28],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=void 0,e.$xl=(0,A.$ti)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class f{static{this._clock=0}constructor(w){this.uri=w,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let E=class{constructor(w){this.g=w,this.c=new P.$Uc,this.f=2**16;const h=new Map,c=p=>{let g=h.get(p.scheme);return g===void 0&&(g=w.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,g)),g};this.c.add(I.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new j.$Vg(c),this.d=new O.$vs((p,g)=>this.extUri.compare(p,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,j.$8g)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new f(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((c,p)=>c[1].time<p[1].time?1:c[1].time>p[1].time?-1:0);f._clock=0,this.d.clear();const h=this.f*.5;for(let c=0;c<h;c++)this.d.set(w[c][0],w[c][1].touch())}};e.$ws=E,e.$ws=E=Ee([Z(0,L.$Zk)],E),(0,N.$ts)(A.$xl,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class I extends N.$Vc{constructor(f,E,y,w,h,c){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new A.$ce),this.onDidChangeFile=this.a.event,this.b=j.$zi.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const f of this.j.profiles)this.c.add(f.settingsResource),this.c.add(f.keybindingsResource),this.c.add(f.tasksResource),this.c.add(f.extensionsResource)}open(f,E){return this.g.open(this.t(f),E)}close(f){return this.g.close(f)}read(f,E,y,w,h){return this.g.read(f,E,y,w,h)}write(f,E,y,w,h){return this.g.write(f,E,y,w,h)}watch(f,E){this.b.set(f,f);const y=this.g.watch(this.t(f),E);return(0,N.$Tc)(()=>{this.b.delete(f),y.dispose()})}stat(f){return this.g.stat(this.t(f))}mkdir(f){return this.g.mkdir(this.t(f))}rename(f,E,y){return this.g.rename(this.t(f),this.t(E),y)}readFile(f,E){return this.g.readFile(this.t(f),E)}readFileStream(f,E,y){return this.g.readFileStream(this.t(f),E,y)}readdir(f){return this.g.readdir(this.t(f))}enforceAtomicReadFile(f){return this.c.has(f)}writeFile(f,E,y){return this.g.writeFile(this.t(f),E,y)}enforceAtomicWriteFile(f){return this.c.has(f)?{postfix:".vsctmp"}:!1}delete(f,E){return this.g.delete(this.t(f),E)}copy(f,E,y){if((0,L.$4k)(this.g))return this.g.copy(this.t(f),this.t(E),y);throw new Error("copy not supported")}cloneFile(f,E){if((0,L.$5k)(this.g))return this.g.cloneFile(this.t(f),this.t(E));throw new Error("clone not supported")}s(f){const E=[];for(const y of f){if(y.resource.scheme!==this.f)continue;const w=this.u(y.resource);this.b.findSubstr(w)&&E.push({resource:w,type:y.type,cId:y.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(f){return f.with({scheme:this.f})}u(f){return f.with({scheme:this.h})}}e.$ddc=I}),define(ae[79],ce([0,1,62]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$RJb=L,e.$SJb=j;function N(O,I,P,f){const E=(0,A.$Vn)(O,I,P,f)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}function L(O,I,P){let f=P;for(;f>=0;){if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1)return f+1;if(f--,I.length===2&&f>=0&&O.charAt(f)===I.charAt(0))return f+2}return 0}function j(O,I,P){let f=P;for(;f>=0;)if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1||(f++,I.length===2&&f>=0&&O.charAt(f)===I.charAt(1)))return f;return O.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=j;function j(h,c,p,g,l,u){const m=[],d=[],$=[];if(!c){const q=h.filter(({identifier:Y})=>l.every(G=>G.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:m,removed:d,updated:$},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(y),c=c.map(y),p=p?p.map(y):null;const t=new Map,r=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>r(q)),c.forEach(({identifier:q})=>r(q)),p?.forEach(({identifier:q})=>r(q)),g?.forEach(({identifier:q})=>r(q)),u?.forEach(q=>r(q));const n=q=>{const Y=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Y)=>(q.set(n(Y),Y),q),i=h.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((q,Y)=>s(q,(0,A.$Zn)(Y)),new Map),b=p?p.reduce(s,new Map):null,S=g.reduce(s,new Map),v=l.reduce((q,Y)=>{const G=t.get(Y.toLowerCase());return q.add(G?`uuid:${G}`:`id:${Y.toLowerCase()}`)},new Set),k=u?u.reduce((q,{id:Y,uuid:G})=>(G=G??t.get(Y.toLowerCase()),q.add(G?`uuid:${G}`:`id:${Y.toLowerCase()}`)),new Set):null,C=O(i,o,v,!1);if(C.added.size>0||C.removed.size>0||C.updated.size>0){const q=O(b,i,v,!1),Y=O(b,o,v,!0),G=(X,W,J,H)=>{let B,ie,re;return W.installed?(B=H.pinned,re=H.preRelease,B&&(ie=H.version)):(B=J.pinned,re=J.preRelease,B&&(ie=J.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),re===void 0&&(re=W.preRelease),{...H,installed:W.installed||J.installed,pinned:B,preRelease:re,version:ie??(J.version&&(!W.installed||N.gt(J.version,W.version))?J.version:W.version),state:P(W,J,b?.get(X))}};for(const X of Y.removed.values()){const W=i.get(X);if(!W)continue;const J=(0,L.$eg)(b?.get(X)),H=k&&!k.has(X)&&J.installed;W.installed&&H?d.push(W.identifier):a.set(X,W)}for(const X of Y.added.values()){const W=(0,L.$eg)(o.get(X)),J=i.get(X);if(J){if(C.updated.has(X)){const H=G(X,J,W,W);I(J,W,!1,!1)||$.push(w(H,X)),a.set(X,H)}}else W.installed&&m.push(w(W,X))}for(const X of Y.updated.values()){const W=(0,L.$eg)(o.get(X)),J=(0,L.$eg)(b?.get(X)),H=i.get(X);if(H)if(k&&!k.has(X)&&J.installed&&H.installed&&!W.installed)d.push(H.identifier);else{const ie=G(X,H,W,W);$.push(w(ie,X)),a.set(X,ie)}else W.installed&&m.push(w(W,X))}for(const X of q.added.values())Y.added.has(X)||a.set(X,(0,L.$eg)(i.get(X)));for(const X of q.updated.values()){if(Y.removed.has(X)||Y.updated.has(X))continue;const W=(0,L.$eg)(i.get(X)),J=(0,L.$eg)(o.get(X));a.set(X,G(X,W,J,W))}for(const X of q.removed.values())Y.updated.has(X)||Y.removed.has(X)||S.has(X)||(0,L.$eg)(o.get(X)).installed&&k&&(k.has(X)||!(0,L.$eg)(b?.get(X)).installed||a.delete(X))}const R=[],M=O(o,a,new Set,!0),T=M.added.size>0||M.updated.size>0||M.removed.size>0;return T&&a.forEach((q,Y)=>R.push(w(q,Y))),{local:{added:m,removed:d,updated:$},remote:T?{added:[...M.added].map(q=>a.get(q)),updated:[...M.updated].map(q=>a.get(q)),removed:[...M.removed].map(q=>o.get(q)),all:R}:null}}function O(h,c,p,g){const l=h?[...h.keys()].filter(t=>!p.has(t)):[],u=[...c.keys()].filter(t=>!p.has(t)),m=u.filter(t=>!l.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),d=l.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),$=new Set;for(const t of l){if(d.has(t))continue;const r=h.get(t),n=c.get(t);(!n||!I(r,n,g,!0))&&$.add(t)}return{added:m,removed:d,updated:$}}function I(h,c,p,g){return!(h.disabled!==c.disabled||!!h.isApplicationScoped!=!!c.isApplicationScoped||g&&h.installed!==c.installed||h.installed&&c.installed&&(h.preRelease!==c.preRelease||h.pinned!==c.pinned||c.pinned&&h.version!==c.version)||!E(h.state,c.state)||p&&h.version!==c.version)}function P(h,c,p){const g=h.state,l=c.state,u=p?.state;if(!c.version||g&&N.gt(h.version,c.version))return g;if(l&&N.gt(c.version,h.version)||!g)return l;if(!l)return g;const m=(0,A.$Zn)(g),d=u?f(u,l):{added:Object.keys(l).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},$=u?f(u,g):{added:Object.keys(g).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])m[t]=l[t];for(const t of d.removed.values())$.updated.has(t)||delete m[t];return m}function f(h,c){const p=Object.keys(h),g=Object.keys(c),l=g.filter(d=>!p.includes(d)).reduce((d,$)=>(d.add($),d),new Set),u=p.filter(d=>!g.includes(d)).reduce((d,$)=>(d.add($),d),new Set),m=new Set;for(const d of p){if(u.has(d))continue;const $=h[d],t=c[d];(0,A.$4n)($,t)||m.add(d)}return{added:l,removed:u,updated:m}}function E(h={},c={}){const{added:p,removed:g,updated:l}=f(h,c);return p.size===0&&g.size===0&&l.size===0}function y(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function w(h,c){const p={...h,identifier:{id:h.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Lb=e.$ZLb=void 0,e.$ZLb=(0,L.$ti)("IIgnoredExtensionsManagementService");let j=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),P&&f.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(I,P){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),P&&f.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(I){const P=I.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),f=this.b().map(w=>w.toLowerCase()),E=[],y=[];if(Array.isArray(f))for(const w of f)w.startsWith("-")?y.push(w.substring(1)):E.push(w);return(0,A.$Mb)([...P,...E].filter(w=>!y.includes(w)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$1Lb=j,e.$1Lb=j=Ee([Z(0,N.$Zi)],j)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=P;function I(d){return(0,N.$Gn)(d)||[]}async function P(d,$,t,r,n){const s=I(d),i=I($),o=t?I(t):null,a=[...s,...i,...o||[]].map(G=>G.key),b=await n.resolveUserBindings(a),S=E(s,i,o,b);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const v=w(s),k=w(i),C=o?w(o):null,R=c(v,k,b),M=C?c(C,v,b):{added:[...v.keys()].reduce((G,X)=>(G.add(X),G),new Set),removed:new Set,updated:new Set},T=C?c(C,k,b):{added:[...k.keys()].reduce((G,X)=>(G.add(X),G),new Set),removed:new Set,updated:new Set},q=f(R,M,T);let Y=d;for(const G of q.removed.values())q.conflicts.has(G)||(Y=u(Y,G,r));for(const G of q.added.values()){if(q.conflicts.has(G))continue;const X=k.get(G);if(X.some(W=>W.command!==`-${G}`&&S.conflicts.has(b[W.key]))){q.conflicts.add(G);continue}Y=l(Y,X,r)}for(const G of q.updated.values()){if(q.conflicts.has(G))continue;const X=k.get(G);if(X.some(W=>W.command!==`-${G}`&&S.conflicts.has(b[W.key]))){q.conflicts.add(G);continue}Y=m(Y,G,X,r)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function f(d,$,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of $.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||($.updated.has(o)?i.add(o):n.add(o));for(const o of $.added.values())i.has(o)||t.added.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||($.added.has(o)?d.updated.has(o)&&i.add(o):r.add(o));for(const o of $.updated.values())i.has(o)||t.updated.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||($.updated.has(o)?d.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function E(d,$,t,r){const n=new Set,s=y(d,r),i=y($,r),o=t?y(t,r):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const b=o?h(o,s):{added:[...s.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?h(o,i):{added:[...i.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:k,updated:C,conflicts:R}=f(a,b,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:k,updated:C,conflicts:R}}function y(d,$){const t=new Map;for(const r of d){const n=$[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function w(d){const $=new Map;for(const t of d){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=$.get(r);n||(n=[],$.set(r,n)),n.push(t)}return $}function h(d,$){const t=[...d.keys()],r=[...$.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=d.get(o).map(S=>({...S,key:o})),b=$.get(o).map(S=>({...S,key:o}));(0,A.$ub)(a,b,(S,v)=>g(S,v))||i.add(o)}return{added:n,removed:s,updated:i}}function c(d,$,t){const r=[...d.keys()],n=[...$.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const b=d.get(a).map(v=>({...v,key:t[v.key]})),S=$.get(a).map(v=>({...v,key:t[v.key]}));p(b,S)||o.add(a)}return{added:s,removed:i,updated:o}}function p(d,$){return!(!(0,A.$ub)(d.filter(({command:t})=>t[0]!=="-"),$.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,A.$ub)(d.filter(({command:t})=>t[0]==="-"),$.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(d,$){if(d.command!==$.command||d.key!==$.key)return!1;const t=j.$rj.deserialize(d.when),r=j.$rj.deserialize($.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!L.$4n(d.args,$.args))}function l(d,$,t){for(const r of $)d=O.edit(d,[-1],r,t);return d}function u(d,$,t){const r=I(d);for(let n=r.length-1;n>=0;n--)(r[n].command===$||r[n].command===`-${$}`)&&(d=O.edit(d,[n],void 0,t));return d}function m(d,$,t,r){const n=I(d),s=n.findIndex(i=>i.command===$||i.command===`-${$}`);for(let i=n.length-1;i>=0;i--)(n[i].command===$||n[i].command===`-${$}`)&&(d=O.edit(d,[i],void 0,r));for(let i=t.length-1;i>=0;i--)d=O.edit(d,[s],t[i],r);return d}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=A,e.$F$b=L;function A(j,O,I){const P={},f={},E=new Set;if(!O)return{local:{added:P,updated:f,removed:[...E.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const y=N(j,O);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:P,updated:f,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=N(I,j),h=N(I,O),c={},p={},g=new Set,l=new Set;for(const u of w.removed.values())h.updated.has(u)?P[u]=O[u]:g.add(u);for(const u of h.removed.values())l.has(u)||(w.updated.has(u)?l.add(u):E.add(u));for(const u of w.updated.values())l.has(u)||(h.updated.has(u)?y.updated.has(u)&&l.add(u):p[u]=j[u]);for(const u of h.updated.values())l.has(u)||(w.updated.has(u)?y.updated.has(u)&&l.add(u):j[u]!==void 0&&(f[u]=O[u]));for(const u of w.added.values())l.has(u)||(h.added.has(u)?y.updated.has(u)&&l.add(u):c[u]=j[u]);for(const u of h.added.values())l.has(u)||(w.added.has(u)?y.updated.has(u)&&l.add(u):P[u]=O[u]);return{local:{added:P,removed:[...E.values()],updated:f},remote:{added:c,removed:[...g.values()],updated:p},conflicts:[...l.values()]}}function N(j,O){const I=j?Object.keys(j):[],P=O?Object.keys(O):[],f=P.filter(w=>!I.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),E=I.filter(w=>!P.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),y=new Set;for(const w of I){if(E.has(w))continue;const h=j[w],c=O[w];h!==c&&y.add(w)}return{added:f,removed:E,updated:y}}function L(j,O){const{added:I,removed:P,updated:f}=N(j,O);return I.size===0&&P.size===0&&f.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=N;function N(j,O,I,P){const f={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!O){const w=j.filter(({id:h})=>!P.includes(h));return w.length?E.added=w:E=null,{local:f,remote:E}}const y=L(j,O,P);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const w=L(I,j,P),h=L(I,O,P);for(const c of h.removed){const p=j.find(g=>g.id===c);p&&f.removed.push(p)}for(const c of h.added){const p=O.find(g=>g.id===c);w.added.includes(c)?y.updated.includes(c)&&f.updated.push(p):f.added.push(p)}for(const c of h.updated)f.updated.push(O.find(p=>p.id===c));for(const c of w.added)h.added.includes(c)||E.added.push(j.find(p=>p.id===c));for(const c of w.updated)h.removed.includes(c)||h.updated.includes(c)||E.updated.push(j.find(p=>p.id===c));for(const c of w.removed){const p=O.find(g=>g.id===c);p&&E.removed.push(p)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:f,remote:E}}function L(j,O,I){j=j?j.filter(({id:h})=>!I.includes(h)):[],O=O.filter(({id:h})=>!I.includes(h));const P=j.map(({id:h})=>h),f=O.map(({id:h})=>h),E=f.filter(h=>!P.includes(h)),y=P.filter(h=>!f.includes(h)),w=[];for(const{id:h,name:c,shortName:p,icon:g,useDefaultFlags:l}of j){if(y.includes(h))continue;const u=O.find(m=>m.id===h);(!u||u.name!==c||u.shortName!==p||u.icon!==g||!(0,A.$4n)(u.useDefaultFlags,l))&&w.push(h)}return{added:E,removed:y,updated:w}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,43]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yAb=e.$xAb=e.$wAb=e.$vAb=e.$uAb=e.$tAb=e.$sAb=e.$rAb=e.$qAb=e.$oAb=e.MergeState=e.Change=e.SyncStatus=e.$nAb=e.$mAb=e.$lAb=e.UserDataSyncErrorCode=e.$jAb=e.$iAb=e.$hAb=e.$gAb=e.$fAb=e.$cAb=e.SyncResource=e.$_zb=e.$$zb=void 0,e.$9zb=E,e.$0zb=y,e.$aAb=w,e.$bAb=h,e.$dAb=p,e.$eAb=g,e.$kAb=l,e.$pAb=s;function E(){const i=f.$_n.as(j.$eo.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function y(){const i=f.$_n.as(j.$eo.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),b=E();return(0,A.$Mb)([...o,...a,...b])}e.$$zb="settingsSync",e.$_zb="settingsSync.keybindingsPerPlatform";function w(){const i="vscode://schemas/ignoredSettings",o=f.$_n.as(j.$eo.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$_zb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$Qo,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.$_n.as(P.$ao.JSONContribution),b=()=>{const S=E(),v=y(),k=Object.keys(j.$fo.properties).filter(M=>!v.includes(M)),C=v.filter(M=>!S.includes(M)),R={items:{type:"string",enum:[...k,...C.map(M=>`-${M}`)]}};a.registerSchema(i,R)};return o.onDidUpdateConfiguration(()=>b())}function h(i){return i&&(0,N.$8f)(i)&&(0,N.$6f)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$cAb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...o){return i?[i,...o]:o}function g(i,o,a,b){return b.joinPath(a.userDataSyncHome,...p(i,o,`lastSync${o}.json`))}e.$fAb=(0,I.$ti)("IUserDataSyncStoreManagementService"),e.$gAb=(0,I.$ti)("IUserDataSyncStoreService"),e.$hAb=(0,I.$ti)("IUserDataSyncLocalStoreService"),e.$iAb="x-operation-id",e.$jAb="X-Execution-Id";function l(i){const o={};return o[e.$jAb]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class m extends Error{constructor(o,a,b,S){super(o),this.code=a,this.resource=b,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$lAb=m;class d extends m{constructor(o,a,b,S,v){super(o,b,void 0,v),this.url=a,this.serverCode=S}}e.$mAb=d;class $ extends m{constructor(o,a){super(o,a)}}e.$nAb=$,function(i){function o(a){if(a instanceof i)return a;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(b&&b[1]){const S=b[2]==="unknown"?void 0:b[2],v=b[3]==="unknown"?void 0:b[3];return new i(a.message,b[1],S,v)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(m||(e.$lAb=m={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$oAb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$qAb=(0,I.$ti)("IUserDataSyncEnablementService"),e.$rAb=(0,I.$ti)("IUserDataSyncService"),e.$sAb=(0,I.$ti)("IUserDataSyncResourceProviderService"),e.$tAb=(0,I.$ti)("IUserDataAutoSyncService"),e.$uAb=(0,I.$ti)("IUserDataSyncUtilService"),e.$vAb=(0,I.$ti)("IUserDataSyncLogService"),e.$wAb="userDataSync",e.$xAb="vscode-userdata-sync",e.$yAb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fLb=L;function L(O,I,P,f,E){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const y=j(O,I);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=P?j(P,I):{added:Object.keys(I).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},h=P?j(P,O):{added:Object.keys(O).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},p=A.$Zn(I),g=!P;for(const u of h.added.values())u!==N.$oAb&&g&&w.added.has(u)||(p[u]=O[u]);for(const u of h.updated.values())p[u]=O[u];for(const u of h.removed.values())f.unregistered.includes(u)||delete p[u];for(const u of w.added.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(P&&h.added.has(u))continue;const d=O[u];d&&d.value===m.value||u===N.$oAb&&g&&h.added.has(u)||(d?c.updated[u]=m:c.added[u]=m)}for(const u of w.updated.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const d=O[u];d&&d.value===m.value||(c.updated[u]=m)}for(const u of w.removed.values()){if(f.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||c.removed.push(u)}const l=j(I,p);return{local:c,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}function j(O,I){const P=Object.keys(O),f=Object.keys(I),E=f.filter(h=>!P.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),y=P.filter(h=>!f.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),w=new Set;for(const h of P){if(y.has(h))continue;const c=O[h],p=I[h];A.$4n(c,p)||w.add(h)}return{added:E,removed:y,updated:w}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJb=f,e.$UJb=w,e.$VJb=h,e.$WJb=c,e.$XJb=g,e.$YJb=u;function f(a,b,S){let v=[];S?v=y(S):v=E(b);const k=[],C=[...(0,P.$9zb)()];if(Array.isArray(v))for(const R of v)R.startsWith("-")?C.push(R.substring(1)):k.push(R);return(0,A.$Mb)([...a,...k].filter(R=>!C.includes(R)))}function E(a){let b=a.inspect("settingsSync.ignoredSettings").userValue;return b!==void 0||(b=a.inspect("sync.ignoredSettings").userValue,b!==void 0)?b:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const b=(0,N.$Gn)(a);return b?b["settingsSync.ignoredSettings"]||b["sync.ignoredSettings"]||[]:[]}function w(a,b){const S=(0,N.$Gn)(a)||{};let v="{}";for(const k of Object.keys(S)){const C=(0,L.$Vn)(v,[k],S[k],b);v=(0,L.$Yn)(v,C)}return v}function h(a,b,S,v){if(S.length){const k=o(b),C=(0,N.$Gn)(b)||{},R=(0,N.$Gn)(a);if(!R)return a;const M=[];for(const T of S){const q=C[T],Y=R[T];q===void 0?a=I.edit(a,[T],void 0,v):Y!==void 0?a=I.edit(a,[T],q,v):M.push(t(T,k))}M.sort((T,q)=>T.startOffset-q.startOffset),M.forEach(T=>a=u(T.setting.key,b,a,v))}return a}function c(a,b,S,v,k,C){const R=h(a,b,v,C),M=S!==R,T=S!==b;if(!M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:R,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:h(b,a,v,C),remoteContent:null,hasConflicts:!1};if(S===null&&g(a)){const F=p(a,b,v)?null:h(b,a,v,C);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let q=a,Y=b;const G=(0,N.$Gn)(a),X=(0,N.$Gn)(b),W=S?(0,N.$Gn)(S):null,J=v.reduce((F,z)=>(F.add(z),F),new Set),H=l(G,X,J),B=l(W,G,J),ie=l(W,X,J),re=new Map,he=new Set,te=F=>{he.add(F);const z=k.filter(({key:x})=>x===F)[0];z?(q=I.edit(q,[F],z.value,C),Y=I.edit(Y,[F],z.value,C)):re.set(F,{key:F,localValue:G[F],remoteValue:X[F]})};for(const F of B.removed.values())ie.updated.has(F)?te(F):Y=I.edit(Y,[F],void 0,C);for(const F of ie.removed.values())he.has(F)||(B.updated.has(F)?te(F):q=I.edit(q,[F],void 0,C));for(const F of B.updated.values())he.has(F)||(ie.updated.has(F)?H.updated.has(F)&&te(F):Y=I.edit(Y,[F],G[F],C));for(const F of ie.updated.values())he.has(F)||(B.updated.has(F)?H.updated.has(F)&&te(F):q=I.edit(q,[F],X[F],C));for(const F of B.added.values())he.has(F)||(ie.added.has(F)?H.updated.has(F)&&te(F):Y=u(F,q,Y,C));for(const F of ie.added.values())he.has(F)||(B.added.has(F)?H.updated.has(F)&&te(F):q=u(F,Y,q,C));const V=re.size>0||!p(q,Y,v),U=V||!p(q,a,[]),D=V||!p(Y,b,[]);return{localContent:U?q:null,remoteContent:D?Y:null,conflictsSettings:[...re.values()],hasConflicts:V}}function p(a,b,S){if(a===b)return!0;const v=(0,N.$Gn)(a),k=(0,N.$Gn)(b),C=S.reduce((T,q)=>(T.add(q),T),new Set),R=o(a).filter(T=>!(T.setting&&C.has(T.setting.key))),M=o(b).filter(T=>!(T.setting&&C.has(T.setting.key)));if(R.length!==M.length)return!1;for(let T=0;T<R.length;T++){const q=R[T],Y=M[T];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$4n(v[q.setting.key],k[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function g(a){return a?o(a).length===0:!0}function l(a,b,S){const v=a?Object.keys(a).filter(T=>!S.has(T)):[],k=Object.keys(b).filter(T=>!S.has(T)),C=k.filter(T=>!v.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),R=v.filter(T=>!k.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),M=new Set;if(a)for(const T of v){if(R.has(T))continue;const q=a[T],Y=b[T];O.$4n(q,Y)||M.add(T)}return{added:C,removed:R,updated:M}}function u(a,b,S,v){const k=(0,N.$Gn)(b),C=o(b),R=o(S),M=m(a,C,R);return d(S,a,k[a],M,R,v)}function m(a,b,S){const v=b.findIndex(C=>C.setting?.key===a),k=b[v-1];if(k){if(k.setting){const R=t(k.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!0}}else{const R=r(v,b);if(R){const M=t(R.setting.key,S);if(M){const T=n(S.indexOf(M),S),q=s(b,R,b[v]);if(T){const Y=s(S,M,T),G=i(q,Y);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.indexOf(T),insertAfter:!1}}else{const Y=s(S,M,S[S.length-1]),G=i(q,Y);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const C=b[v+1];if(C)if(C.setting){const R=t(C.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!1}}else{const R=n(v,b);if(R){const M=t(R.setting.key,S);if(M){const T=r(S.indexOf(M),S),q=s(b,b[v],R);if(T){const Y=s(S,T,M),G=i(q.reverse(),Y.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:S.indexOf(T),insertAfter:!0}}else{const Y=s(S,S[0],M),G=i(q.reverse(),Y.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function d(a,b,S,v,k,C){let R;return v.index===-1?R=(0,L.$Vn)(a,[b],S,C):R=$(a,b,S,v,k,C).map(M=>(0,L.$Wn)(a,M,C)[0]),(0,L.$Yn)(a,R)}function $(a,b,S,v,k,C){const R=`${JSON.stringify(b)}: ${JSON.stringify(S)}`,M=(0,j.$Sn)(C,a),T=k[v.index];if(v.insertAfter){const q=[];if(T.setting)q.push({offset:T.endOffset,length:0,content:","+R});else{const Y=n(v.index,k),G=r(v.index,k),X=G?.setting?.commaOffset;G&&X===void 0&&q.push({offset:G.endOffset,length:0,content:","});const W=X!==void 0&&X>T.endOffset;q.push({offset:W?X+1:T.endOffset,length:0,content:Y?M+R+",":M+R})}return q}else{if(T.setting)return[{offset:T.startOffset,length:0,content:R+","}];const q=(k[v.index-1]&&!k[v.index-1].setting?M:"")+R+(n(v.index,k)?",":"")+M;return[{offset:T.startOffset,length:0,content:q}]}}function t(a,b){return b.filter(S=>S.setting?.key===a)[0]}function r(a,b){for(let S=a-1;S>=0;S--)if(b[S].setting)return b[S]}function n(a,b){for(let S=a+1;S<b.length;S++)if(b[S].setting)return b[S]}function s(a,b,S){const v=a.indexOf(b),k=a.indexOf(S);return a.filter((C,R)=>v<R&&R<k)}function i(a,b){if(a.length&&b.length){let S=0;for(;S<b.length&&S<a.length;S++)if(a[S].value!==b[S].value)return b[S-1];return b[S-1]}}function o(a){const b=[];let S=-1,v,k;const C={onObjectBegin:R=>{S++},onObjectProperty:(R,M,T)=>{S===0&&(v=M,k=R)},onObjectEnd:(R,M)=>{S--,S===0&&b.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(R,M)=>{S++},onArrayEnd:(R,M)=>{S--,S===0&&b.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(R,M,T)=>{S===0&&b.push({startOffset:v,endOffset:M+T,value:a.substring(v,M+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(R,M,T)=>{if(S===0&&R===","){let q=b.length-1;for(;q>=0&&!b[q].setting;q--);const Y=b[q];Y&&b.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(R,M)=>{S===0&&b.push({startOffset:R,endOffset:R+M,value:a.substring(R,R+M)})}};return(0,N.$Nn)(a,C),b}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJb=e.$BJb=void 0,e.$BJb=(0,L.$ti)("IUserDataSyncAccountService");let O=class extends N.$Vc{get account(){return this.a}constructor(P,f){super(),this.g=P,this.h=f,this.b=this.B(new A.$ce),this.onDidChangeAccount=this.b.event,this.c=this.B(new A.$ce),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$CJb=O,e.$CJb=O=Ee([Z(0,j.$gAb),Z(1,j.$vAb)],O)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Lb=void 0;let I=class extends j.$5j{constructor(f,E){super(),this.g=this.B(f.createLogger((0,A.$7g)(E.logsHome,`${O.$wAb}.log`),{id:O.$wAb,name:(0,N.localize)(0,null)}))}trace(f,...E){this.g.trace(f,...E)}debug(f,...E){this.g.debug(f,...E)}info(f,...E){this.g.info(f,...E)}warn(f,...E){this.g.warn(f,...E)}error(f,...E){this.g.error(f,...E)}flush(){this.g.flush()}};e.$2Lb=I,e.$2Lb=I=Ee([Z(0,j.$1j),Z(1,L.$Ai)],I)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class j extends L.$Vc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:P,getActiveWindowId:f}){super(),this.a=this.B(new L.$Uc),N.Event.latch(N.Event.any(I,P))(this.f,this,this.a),this.b=(0,A.$gh)(()=>f()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Kcc=j}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Ni=e.$Mi=e.WorkbenchState=e.$Gi=e.$Fi=e.$Ci=void 0,e.$Di=f,e.$Ei=E,e.$Hi=y,e.$Ii=w,e.$Ji=h,e.$Ki=p,e.$Li=g,e.$Oi=m,e.$Ti=d,e.$Ui=$,e.$Wi=t,e.$Xi=r,e.$Yi=n,e.$Ci=(0,I.$ti)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}function E(s){return typeof s?.id=="string"&&!f(s)&&!w(s)}e.$Fi={id:"ext-dev"},e.$Gi={id:"empty-window"};function y(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:i?e.$Fi:e.$Gi;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function w(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}function h(s){const i=s;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function g(s){const i=s;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class l{constructor(i,o,a,b,S){this.h=i,this.j=a,this.k=b,this.l=S,this.c=L.$zi.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=L.$zi.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Mi=l;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$7g)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ni=u;function m(s){return new u({uri:s,index:0,name:(0,j.$3g)(s)},{uri:s.toString()})}e.$Pi="code-workspace",e.$Qi=`.${e.$Pi}`,e.$Ri=[{name:(0,A.localize)(0,null),extensions:[e.$Pi]}],e.$Si="workspace.json";function d(s,i){return j.$Xg.isEqualOrParent(s,i.untitledWorkspacesHome)}function $(s){let i;return O.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===P.Schemas.tmp}e.$Vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Vi}function r(s,i){return!d(s,i)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,j.$5g)(s))===e.$Qi}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$zl=e.ProfileResourceType=void 0,e.$yl=d,e.$Al=$,e.$Bl=t;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function d(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$zl=(0,E.$ti)("IUserDataProfilesService");function $(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:i}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,b,S){return{id:s,name:i,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:S&&b?.useDefaultFlags?.globalState?S.globalStorageHome:(0,j.$7g)(o,"globalStorage"),settingsResource:S&&b?.useDefaultFlags?.settings?S.settingsResource:(0,j.$7g)(o,"settings.json"),keybindingsResource:S&&b?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,j.$7g)(o,"keybindings.json"),tasksResource:S&&b?.useDefaultFlags?.tasks?S.tasksResource:(0,j.$7g)(o,"tasks.json"),snippetsHome:S&&b?.useDefaultFlags?.snippets?S.snippetsHome:(0,j.$7g)(o,"snippets"),extensionsResource:S&&b?.useDefaultFlags?.extensions?S.extensionsResource:(0,j.$7g)(o,"extensions.json"),cacheHome:(0,j.$7g)(a,s),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let r=class extends L.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,b){super(),this.t=i,this.u=o,this.w=a,this.y=b,this.f=!0,this.h=this.B(new N.$ce),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ce),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ce),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ce),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$7g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$7g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,u.$6f)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}o.push(t((0,j.$4g)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.y.error(S)}const a=new h.$Bc,b=new Map;if(o.length)try{const S=this.Q();if(S.workspaces)for(const[v,k]of Object.entries(S.workspaces)){const C=O.URI.parse(v),R=o.find(M=>M.id===k);R&&a.set(C,R)}if(S.emptyWindows)for(const[v,k]of Object.entries(S.emptyWindows)){const C=o.find(R=>R.id===k);C&&b.set(v,C)}}catch(S){this.y.error(S)}this.z={profiles:o,workspaces:a,emptyWindows:b}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,l.$0e)(o)}\\s(\\d+)`);let b=0;for(const v of this.profiles){const k=a.exec(v.name),C=k?parseInt(k[1]):0;b=C>b?C:b}const S=`${o} ${b+1}`;return this.createProfile((0,A.$hj)((0,g.$Pg)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,A.$hj)((0,g.$Pg)()).toString(16),i,o,a)}async createProfile(i,o,a,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(i,o,a);return b&&await this.setProfileForWorkspace(b,S),S}async F(i,o,a){if(!(0,u.$6f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===i))throw new Error(`Profile with ${o} name already exists`);const v=t(i,o,(0,j.$7g)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(v.location);const k=[];return this.j.fire({profile:v,join(C){k.push(C)}}),await p.Promises.settled(k),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(b=>b.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(b){a.push(b)}});try{await Promise.allSettled(a)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,f.$el)(b)!==1&&this.y.error(b)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(b=>b.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,w.$Di)(i)?i.uri:(0,w.$Ii)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const b=[...this.profiles,...i],S=[];this.s.profiles=[];for(let v of b)v.isDefault||o.some(k=>v.id===k.id)||(v=a.find(k=>v.id===k.id)??v,v.isTransient?this.s.profiles.push(v):S.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(S),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const b=this.G(i),S=a?this.s:this.C;O.URI.isUri(b)?(S.workspaces.delete(b),o&&S.workspaces.set(b,o)):(S.emptyWindows.delete(b),o&&S.emptyWindows.set(b,o)),a||this.M()}M(){const i={};for(const[a,b]of this.C.workspaces.entries())i[a.toString()]=b.id;const o={};for(const[a,b]of this.C.emptyWindows.entries())o[a.toString()]=b.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[S,v]of Object.entries(i.workspaces)){const k=O.URI.parse(v);o[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const b={};if(i.emptyWindows)for(const[S,v]of Object.entries(i.emptyWindows)){const k=O.URI.parse(v);b[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Cl=r,e.$Cl=r=Ee([Z(0,P.$Ai),Z(1,f.$Zk),Z(2,c.$xl),Z(3,y.$Zj)],r);class n extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Dl=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let j=class extends N.$Vc{constructor(I){super(),this.B(new A.$Fh(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$Wdc=j,e.$Wdc=j=Ee([Z(0,L.$zl)],j)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=void 0,e.$jq=$;let d=class extends I.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,o,a,b,S){super(),this.z=s,this.C=i,this.D=o,this.F=a,this.G=b,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$ce),this.s=this.B(new O.$ce),this.t=this.B(new O.$ce),this.u=this.B(new O.$ce),this.w=this.B(new O.$ce),this.y=[],this.B((0,I.$Tc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,w.$1o)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:b})=>(0,h.$rp)(b,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new w.$4o(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$4o(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:b})=>{try{const S=await this.N(a,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.G.version,date:this.G.date});o.push({...S,options:b})}catch(S){i.push({identifier:a.identifier,operation:2,source:a,error:S})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,c.$Rm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const b=(await this.getInstalled(1,a.extensionsResource)).find(S=>(0,h.$rp)(S.identifier,s.identifier));b?this.w.fire(b):this.u.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=new Map,o=new Map,a=[],b=(v,k)=>`${h.$sp.create(v).toString()}-${k.toString()}`,S=(v,k,C,R)=>{const M=this.Y(v,k,C),T=`${(0,h.$wp)(v.publisher,v.name)}-${C.profileLocation.toString()}`;o.set(T,{task:M,root:R}),this.n.fire({identifier:M.identifier,source:k,profileLocation:C.profileLocation}),this.F.info("Installing extension:",M.identifier.id),E.URI.isUri(k)||this.j.set(b(k,C.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:v,extension:k,options:C}of s){const R=C.isApplicationScoped||C.isBuiltin||(0,c.$Rm)(v),M={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:R,profileLocation:R?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},T=E.URI.isUri(k)?void 0:this.j.get(b(k,M.profileLocation));T?(this.F.info("Extension is already requested to install",T.task.identifier.id),a.push(T.task.waitUntilTaskIsFinished())):S(v,k,M,void 0)}return await Promise.all([...o.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const k=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),C=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),R={...v.options,context:{...v.options.context,[w.$Vo]:!0}};for(const{gallery:M,manifest:T}of(0,A.$Mb)(k,({gallery:q})=>q.identifier.id)){if(o.has(`${M.identifier.id.toLowerCase()}-${R.profileLocation.toString()}`))continue;const q=this.j.get(b(M,R.profileLocation));if(q){if(this.J(v,q.task)){const Y=q.task.identifier;this.F.info("Waiting for already requested installing extension",Y.id,v.identifier.id),q.waitingTasks.push(v),a.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,G=>G.some(X=>(0,h.$rp)(X.identifier,Y)))).then(G=>{if(this.F.info("Finished waiting for already requested installing extension",Y.id,v.identifier.id),!G.find(W=>(0,h.$rp)(W.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else C.some(({identifier:Y})=>(0,h.$rp)(Y,M.identifier))||S(T,M,R,v)}}catch(k){if(E.URI.isUri(v.source))(0,A.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,k.message),(0,A.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),k}})),await this.L([...o.entries()].map(async([v,{task:k}])=>{const C=new Date().getTime();try{const R=await k.run();if(await this.L(this.y.map(M=>M.postInstall(R,k.source,k.options,L.CancellationToken.None))),!E.URI.isUri(k.source)){const M=k.operation===3,T=M?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(t(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$zp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:T}),P.$o&&k.operation!==3)try{await this.z.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"install")}catch{}}i.set(v,{local:R,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:R.isApplicationScoped})}catch(R){const M=$(R);throw E.URI.isUri(k.source)||t(this.C,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$zp)(k.source),error:M}),i.set(v,{error:M,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,j.$0)(M)),M}})),a.length&&await this.L(a),[...i.values()]}catch(v){const k=(M,T,q)=>{const Y=[];M.manifest.extensionDependencies?.length&&Y.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&Y.push(...M.manifest.extensionPack);for(const G of Y){if(q.includes(G.toLowerCase()))continue;q.push(G.toLowerCase());const X=i.get(`${G.toLowerCase()}-${T.toString()}`);X?.local&&(q=k(X.local,T,q))}return q},C=M=>({identifier:M.identifier,operation:2,source:M.source,context:M.options.context,profileLocation:M.profileLocation,error:v}),R=[];for(const[M,{task:T,root:q}]of o){const Y=i.get(M);Y?Y.local&&q&&!i.get(`${q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`)?.local&&(R.push(this.Z(Y.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(M,C(T))):(T.cancel(),i.set(M,C(T)))}for(const[M,{task:T}]of o){const q=i.get(M);if(!q?.local||T.options.donotIncludePackAndDependencies)continue;k(q.local,T.profileLocation,[q.local.identifier.id.toLowerCase()]).slice(1).some(G=>o.has(`${G.toLowerCase()}-${T.profileLocation.toString()}`)&&!i.get(`${G.toLowerCase()}-${T.profileLocation.toString()}`)?.local)&&(R.push(this.Z(q.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(M,C(T)))}throw R.length&&await Promise.allSettled(R.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,j.$0)(T))}})),v}finally{for(const{task:v}of o.values())v.source&&!E.URI.isUri(v.source)&&this.j.delete(b(v.source,v.profileLocation));if(i.size){const v=[...i.values()];for(const k of v)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(v)}}}J(s,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===s&&(a.includes(i)||a.some(b=>this.J(b,i)))||o===i&&a[0]&&!this.J(s,a[0]))return!1;return!0}async L(s){const i=[],o=[],a=await Promise.allSettled(s);for(const b of a)b.status==="fulfilled"?i.push(b.value):o.push(b.reason);if(o.length){if(o.length===1)throw o[0];let b=new w.$4o("",w.ExtensionManagementErrorCode.Unknown);for(const S of o){const v=S instanceof w.$4o?S.code:w.ExtensionManagementErrorCode.Unknown;b=new w.$4o(S.message?`${S.message}, ${b.message}`:b.message,v!==w.ExtensionManagementErrorCode.Unknown&&v!==w.ExtensionManagementErrorCode.Internal?v:b.code)}throw b}return i}async M(s,i,o,a,b,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,b,S),k=[],C=[],R=async(M,T)=>{k.push(M);const q=T.extensionDependencies||[],Y=[...q];if(T.extensionPack){const G=o?v.find(X=>(0,h.$rp)(X.identifier,M)):void 0;for(const X of T.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(W=>(0,h.$rp)({id:W},{id:X}))||Y.every(W=>!(0,h.$rp)({id:W},{id:X}))&&Y.push(X)}if(Y.length){const G=Y.filter(X=>k.every(W=>!(0,h.$rp)(W,{id:X})));if(G.length){const X=await this.z.getExtensions(G.map(W=>({id:W,preRelease:a})),L.CancellationToken.None);for(const W of X){if(k.find(B=>(0,h.$rp)(B,W.identifier)))continue;const J=q.some(B=>(0,h.$rp)({id:B},W.identifier));let H;try{H=await this.N(W,!1,a,S)}catch(B){if(J)throw B;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,j.$0)(B));continue}C.push({gallery:H.extension,manifest:H.manifest}),await R(H.extension.identifier,H.manifest)}}}};return await R(s,i),C}async N(s,i,o,a){let b;const S=await this.getExtensionsControlManifest();if(S.malicious.some(C=>(0,h.$rp)(s.identifier,C)))throw new w.$4o(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),b=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},L.CancellationToken.None))[0],!b)throw new w.$4o(y.localize(2,null,s.identifier.id,v.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const C=await this.getTargetPlatform();throw new w.$4o(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Wo)(C)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.O(s,i,o,a),!b)throw!o&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],L.CancellationToken.None))[0]?new w.$4o(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$4o(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",b.identifier.id);const k=await this.z.getManifest(b,L.CancellationToken.None);if(k===null)throw new w.$4o(`Missing manifest for extension ${b.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(k.version!==b.version)throw new w.$4o(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:k}}async O(s,i,o,a){const b=await this.getTargetPlatform();let S=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(S=(await this.z.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(s,o,b,a)&&(S=s),S||(i?S=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(s,o,b,a)),S}async P(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=R=>`${R.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,b=this.m.get(a(s.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),b.waitUntilTaskIsFinished();const S=R=>{const M=this.Z(R,o);return this.m.set(a(M.extension.identifier),M),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this.t.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),M},v=(R,M)=>{M?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,M.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$yp)(R),error:M}),this.u.fire({identifier:R.identifier,error:M?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},k=[],C=[];try{k.push(S(s));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const M=this.S(s,R);for(const T of M)this.m.has(a(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):k.push(S(T))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(k.map(M=>M.extension),R,s),await this.L(k.map(async M=>{try{if(await M.run(),await this.L(this.y.map(T=>T.postUninstall(M.extension,o,L.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}v(M.extension)}catch(T){const q=$(T);throw v(M.extension,q),q}finally{C.push(M)}}))}catch(R){const M=$(R);for(const T of k){try{T.cancel()}catch{}C.includes(T)||v(T.extension,M)}throw M}finally{for(const R of k)this.m.delete(a(R.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}Q(s,i,o){for(const a of s){const b=this.U(a,i);if(b.length){const S=b.filter(v=>!s.some(k=>(0,h.$rp)(k.identifier,v.identifier)));if(S.length)throw new Error(this.R(a,S,o))}}}R(s,i,o){return o===s?i.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const b=i.filter(v=>!v.isBuiltin&&a.some(k=>(0,h.$rp)({id:k},v.identifier))),S=[];for(const v of b)S.push(...this.S(v,i,o));return[...b,...S]}return[]}U(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,h.$rp)({id:a},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$iq=d,e.$iq=d=Ee([Z(0,w.$3o),Z(1,l.$Yl),Z(2,u.$xl),Z(3,p.$Zj),Z(4,g.$gk),Z(5,m.$zl)],d);function $(n){if(n instanceof w.$4o)return n;if(n instanceof w.$5o){const i=new w.$4o(n.message,w.ExtensionManagementErrorCode.Gallery);return i.stack=n.stack,i}const s=new w.$4o(n.message,(0,j.$4)(n)?w.ExtensionManagementErrorCode.Cancelled:w.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:b,durationSinceUpdate:S}){let v,k;(0,f.$bg)(o)&&(o===!0?o="Verified":(o===!1||(v=w.ExtensionManagementErrorCode.Signature,k=o),o="Unverified")),b&&(v=b.code,b.code===w.ExtensionManagementErrorCode.Signature&&(k=b.message)),n.publicLog(s,{...i,verificationStatus:o,success:!b,duration:a,errorcode:v,errorcodeDetail:k,durationSinceUpdate:S})}class r{constructor(){this.d=new N.$sh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$gh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$gh)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$kq=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class m extends Error{constructor(n,s){super(n),this.code=s}}e.$lq=m,e.$mq=(0,y.$ti)("IExtensionsProfileScannerService");let d=class extends L.$Vc{constructor(n,s,i,o,a,b){super(),this.j=n,this.m=s,this.n=i,this.r=o,this.s=a,this.t=b,this.b=this.B(new j.$ce),this.onAddExtensions=this.b.event,this.c=this.B(new j.$ce),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$ce),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$ce),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.u(s,b=>{const S=[];if(i)S.push(...b);else for(const v of b)n.some(([k])=>(0,f.$rp)(k.identifier,v.identifier)&&k.manifest.version!==v.version)?o.push(v):S.push(v);for(const[v,k]of n){const C=S.findIndex(M=>(0,f.$rp)(M.identifier,v.identifier)&&M.version===v.manifest.version),R={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:k};C===-1?(a.push(R),S.push(R)):S.splice(C,1,R)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:s}),b}}async updateMetadata(n,s){const i=[];return await this.u(s,o=>{const a=[];for(const b of o){const S=n.find(([v])=>(0,f.$rp)(v.identifier,b.identifier)&&v.manifest.version===b.version);S&&(b.metadata={...b.metadata,...S[1]},i.push(b)),a.push(b)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,o=>{const a=[];for(const b of o)(0,f.$rp)(b.identifier,n.identifier)?i.push(b):a.push(b);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:s}),o}}async u(n,s,i){return this.F(n).queue(async()=>{let o=[],a;try{const b=await this.m.readFile(n);a=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,E.$el)(b)!==1)throw b;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new m((0,g.$0)(b),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let b=!1;for(const S of a){$(S)||this.w(n);let v;if((0,p.$6f)(S.relativeLocation)&&S.relativeLocation)v=this.z(S.relativeLocation);else if((0,p.$6f)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{v=I.URI.revive(S.location);const k=this.y(v);k&&(b=!0,S.relativeLocation=k)}(0,p.$ag)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(b=!0,S.metadata.hasPreReleaseVersion=!0),o.push({identifier:S.identifier,location:v,version:S.version,metadata:S.metadata})}b&&await this.m.writeFile(n,N.$De.fromString(JSON.stringify(a)))}if(s){o=s(o);const b=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(n,N.$De.fromString(JSON.stringify(b)))}return o})}w(n){const s=new m(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$el)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(b=>$(b))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$De.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$el)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$el)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$el)(a)!==1&&this.t.error(a)}return o})()),this.C}F(n){let s=this.h.get(n);return s||(s=new A.$Ah,this.h.set(n,s)),s}};e.$nq=d,e.$nq=d=Ee([Z(1,E.$Zk),Z(2,h.$zl),Z(3,c.$xl),Z(4,l.$Yl),Z(5,w.$Zj)],d);function $(r){return(0,p.$8f)(r)&&(0,P.$2o)(r.identifier)&&(t(r.location)||(0,p.$6f)(r.location)&&r.location)&&((0,p.$ag)(r.relativeLocation)||(0,p.$6f)(r.relativeLocation))&&r.version&&(0,p.$6f)(r.version)}function t(r){return r?(0,p.$6f)(r.path)&&(0,p.$6f)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$sq=e.$rq=e.$qq=e.Translations=void 0,e.$tq=Y;var C;(function(X){function W(J,H){if(J===H)return!0;const B=Object.keys(J),ie=new Set;for(const re of Object.keys(H))ie.add(re);if(B.length!==ie.size)return!1;for(const re of B){if(J[re]!==H[re])return!1;ie.delete(re)}return ie.size===0}X.equals=W})(C||(e.Translations=C={})),e.$qq=(0,n.$ti)("IExtensionsScannerService");let R=class extends f.$Vc{constructor(W,J,H,B,ie,re,he,te,V,U,D,F){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=J,this.r=H,this.s=B,this.t=ie,this.u=re,this.w=he,this.y=te,this.z=V,this.C=U,this.D=D,this.F=F,this.g=this.B(new o.$ce),this.onDidChangeCache=this.g.event,this.h=(0,h.$7g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Cp)(this.w,this.y)),this.G}async scanAllExtensions(W,J,H){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(J)]),re=H?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const J=[];J.push(this.M(!!W.useCache,W.language)),J.push(this.N(W.language,!!W.checkControlFile));const[H,B]=await Promise.all(J);return this.J([...H,...B],0,W,!1)}async scanUserExtensions(W){const J=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(J,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(B)}catch(he){if(he instanceof b.$lq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(B);else throw he}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=J.find(te=>(0,d.$rp)(te.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!H.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,J,H,!0)}async scanMultipleExtensions(W,J,H){const B=[];return await Promise.all(W.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,J,H);B.push(...re)})),this.J(B,J,H,!0)}async scanMetadata(W){const J=(0,h.$7g)(W,"package.json"),H=(await this.w.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,J){const H=(0,h.$7g)(W,"package.json"),B=(await this.w.readFile(H)).value.toString(),ie=JSON.parse(B);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,h.$7g)(W,"package.json"),j.$De.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof b.$lq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$De.fromString(JSON.stringify([])))}catch(J){(0,r.$el)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,J,H,B){return H.includeAllVersions||(W=this.L(J===0?W:void 0,J===1?W:void 0,J==="development"?W:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,re)=>{const he=y.$oc(ie.location.fsPath),te=y.$oc(re.location.fsPath);return he<te?-1:he>te?1:0})}L(W,J,H,B,ie){const re=(te,V,U)=>{if(te.isValid&&!V.isValid)return!1;if(te.isValid===V.isValid){if(ie&&c.gt(te.manifest.version,V.manifest.version))return this.y.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(c.eq(te.manifest.version,V.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${V.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===B)return this.y.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${te.location.path} with ${V.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${V.location.path}.`),!0},he=new $.$Qm;return W?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),J?.forEach(te=>{const V=he.get(te.identifier.id);if(!V&&W&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),H?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!0))&&he.set(te.identifier.id,te),he.set(te.identifier.id,te)}),[...he.values()]}async M(W,J){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,J){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const B=J?await this.O():{},ie=[],re=l.URI.file(y.$ic(y.$kc(E.$Ng.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const V=B[te.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,h.$7g)(re,te.name));break;default:ie.push(l.URI.file(V));break}}const he=await Promise.all(ie.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,A.$Hb)(he)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,J,H,B,ie,re,he,te){const V=await this.f(ie??w.$w),U=await this.Q(W),D=J&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=D?await this.Q(D):void 0;return new M(W,U,D,F,J,he,H,B,re,te.version,te.date,this.C.commit,!this.z.isBuilt,ie,V)}async Q(W){try{const J=await this.w.stat(W);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$rq=R,e.$rq=R=Ee([Z(4,S.$zl),Z(5,b.$mq),Z(6,r.$Zk),Z(7,s.$Zj),Z(8,m.$Ai),Z(9,i.$gk),Z(10,v.$xl),Z(11,n.$si)],R);class M{constructor(W,J,H,B,ie,re,he,te,V,U,D,F,z,x,K){this.location=W,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=re,this.type=he,this.excludeObsolete=te,this.validate=V,this.productVersion=U,this.productDate=D,this.productCommit=F,this.devMode=z,this.language=x,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,J){return(0,h.$Zg)(W.location,J.location)&&W.mtime===J.mtime&&(0,h.$Zg)(W.applicationExtensionslocation,J.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&W.profile===J.profile&&L.$4n(W.profileScanOptions,J.profileScanOptions)&&W.type===J.type&&W.excludeObsolete===J.excludeObsolete&&W.validate===J.validate&&W.productVersion===J.productVersion&&W.productDate===J.productDate&&W.productCommit===J.productCommit&&W.devMode===J.devMode&&W.language===J.language&&C.equals(W.translations,J.translations)}}e.$sq=M;let T=class extends f.$Vc{constructor(W,J,H,B,ie){super(),this.f=W,this.g=J,this.h=H,this.j=B,this.m=ie}async scanExtensions(W){const J=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(B)}catch{}return(0,g.$gg)(H)?J:J.filter(B=>!H[d.$sp.create(B).toString()])}async n(W){const J=await this.j.resolve(W.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,h.$4g)(B.resource).indexOf(".")===0)return null;const ie=new M(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,A.$Hb)(H).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let J=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);J.push(...H)}return J}async s(W,J,H){const B=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async re=>{if(J(re)){const he=new M(re.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(he,re.metadata)}return null}));return(0,A.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$7g)(W.location,"package.json"))){const J=await this.scanExtension(W);return J?[J]:[]}else return await this.scanExtensions(W)}catch(J){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(J)),[]}}async scanExtension(W,J){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=$.$Km),J=J??H.__metadata,delete H.__metadata;const B=(0,d.$wp)(H.publisher,H.name),ie=J?.id?{id:B,uuid:J.id}:{id:B},re=J?.isSystem?0:W.type,he=re===0||!!J?.isBuiltin;H=await this.t(W.location,H,M.createNlsConfiguration(W));const te={type:re,identifier:ie,manifest:H,location:W.location,isBuiltin:he,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return W.validate?this.validate(te,W):te}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,J){let H=!0;const B=(0,t.$Hp)(J.productVersion,J.productDate,J.location,W.manifest,W.isBuiltin);for(const[ie,re]of B)ie===p.default.Error&&(H=!1,this.m.error(this.z(J.location,re)));return W.isValid=H,W.validations=B,W}async scanExtensionManifest(W){const J=(0,h.$7g)(W,"package.json");let H;try{H=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,r.$el)(ie)!==1&&this.m.error(this.z(W,(0,u.localize)(0,null,J.path,ie.message))),null}let B;try{B=JSON.parse(H)}catch{const re=[];(0,I.$Gn)(H,re);for(const he of re)this.m.error(this.z(W,(0,u.localize)(1,null,J.path,he.offset,he.length,(0,P.$oq)(he.error))));return null}return(0,I.$Pn)(B)!=="object"?(this.m.error(this.z(W,(0,u.localize)(2,null,J.path))),null):B}async t(W,J,H){const B=await this.u(W,J,H);if(B)try{const ie=[],re=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(te=>{this.m.error(this.z(W,(0,u.localize)(3,null,B.default?.path,(0,P.$oq)(te.error))))}),J;if((0,I.$Pn)(B)!=="object")return this.m.error(this.z(W,(0,u.localize)(4,null,B.default?.path))),J;const he=B.values||Object.create(null);return(0,k.$pq)(this.m,J,he,re)}catch{}return J}async u(W,J,H){const B=(0,h.$7g)(W,"package.nls.json"),ie=(V,U)=>{U.forEach(D=>{this.m.error(this.z(W,(0,u.localize)(5,null,V?.path,(0,P.$oq)(D.error))))})},re=V=>{this.m.error(this.z(W,(0,u.localize)(6,null,V?.path)))},he=`${J.publisher}.${J.name}`,te=H.translations[he];if(te)try{const V=l.URI.file(te),U=(await this.j.readFile(V)).value.toString(),D=[],F=(0,I.$Gn)(U,D);return D.length>0?(ie(V,D),{values:void 0,default:B}):(0,I.$Pn)(F)!=="object"?(re(V),{values:void 0,default:B}):{values:F.contents?F.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let U;try{U=await this.y(W,H)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const D=(await this.j.readFile(U.localized)).value.toString(),F=[],z=(0,I.$Gn)(D,F);return F.length>0?(ie(U.localized,F),{values:void 0,default:U.original}):(0,I.$Pn)(z)!=="object"?(re(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(W,J){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,I.$Gn)(H,J)}catch{}}y(W,J){return new Promise((H,B)=>{const ie=re=>{const he=(0,h.$7g)(W,`package.nls.${re}.json`);this.j.exists(he).then(te=>{te&&H({localized:he,original:(0,h.$7g)(W,"package.nls.json")});const V=re.lastIndexOf("-");V===-1?H({localized:(0,h.$7g)(W,"package.nls.json"),original:null}):(re=re.substring(0,V),ie(re))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,h.$7g)(W,"package.nls.json"),original:null});ie(J.language)})}z(W,J){return`[${W.path}]: ${J}`}};T=Ee([Z(1,b.$mq),Z(2,v.$xl),Z(3,r.$Zk),Z(4,s.$Zj)],T);let q=class extends T{constructor(W,J,H,B,ie,re,he){super(J,B,ie,re,he),this.G=W,this.H=H,this.D=this.B(new N.$rh(3e3)),this.F=this.B(new o.$ce),this.onDidChangeCache=this.F.event}async scanExtensions(W){const J=this.M(W),H=await this.I(J);if(this.C=W,H&&H.input&&M.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(ie=>(ie.location=l.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(J,{input:W,result:B}),B}async I(W){try{const J=await this.j.readFile(W),H=JSON.parse(J.value.toString());return{result:H.result,input:(0,a.$3h)(H.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(J))}return null}async J(W,J){try{await this.j.writeFile(W,j.$De.fromString(JSON.stringify(J)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),J=await this.I(W);if(!J)return;const H=J.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$4n(B,H))try{this.m.info("Invalidating Cache",H,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const J=this.N(W);return this.h.extUri.joinPath(J.cacheHome,W.type===0?$.$Jm:$.$Im)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(W.location,J.extensionsResource))??this.G:this.H.defaultProfile}};q=Ee([Z(2,S.$zl),Z(3,b.$mq),Z(4,v.$xl),Z(5,r.$Zk),Z(6,s.$Zj)],q);function Y(X,W){const J=(0,d.$up)(X.manifest.publisher,X.manifest.name);return{id:J,identifier:new $.$Om(J),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:W,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class G extends R{constructor(W,J,H,B,ie,re,he,te,V,U,D,F){super(W,J,(0,h.$7g)(H,".vscode-oss-dev","extensions","control.json"),B,ie,re,he,te,V,U,D,F),this.S=(async()=>{if(w.$z)try{const z=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$uq=G}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;let w=class extends O.$Vc{constructor(c,p){super(),this.b=c,this.f=p,this.a=new N.$zh(5)}async postUninstall(c){const p=this.g(c,"uninstall");p&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(g)}}));try{await f.Promises.rm(this.m(c))}catch(g){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(g)}}g(c,p){const g=`vscode:${p}`;if(c.location.scheme===I.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const l=c.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,P.$kc)(c.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(c,p,g,l,u){return new Promise((m,d)=>{const $=this.j(c,p,g,u);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?d(n):m(void 0)};$.on("error",n=>{r((0,L.$ej)(n)||"Unknown")}),$.on("exit",(n,s)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,$.kill(),d("timed out")},5e3))})}j(c,p,g,l){const u={silent:!0,execArgv:void 0},m=(0,A.fork)(c,[`--type=extension-post-${p}`,...g],u);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const d=j.Event.fromNodeEventEmitter(m.stdout,"data"),$=j.Event.fromNodeEventEmitter(m.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),$(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const t=j.Event.any(j.Event.map(d,n=>({data:`%c${n}`,format:[""]})),j.Event.map($,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}m(c){return(0,P.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$wq=w,e.$wq=w=Ee([Z(0,y.$zl),Z(1,E.$Zj)],w)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,C,R,M,T,q,Y,G,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0,e.$Aq=(0,M.$ui)(n.$6o);const W=".vsctmp";let J=class extends r.$iq{constructor(V,U,D,F,z,x,K,ee,_,Q,se,ue){super(V,U,se,D,Q,ue),this.eb=z,this.fb=x,this.gb=K,this.hb=_,this.db=new Map,this.qb=new E.$Cc;const ge=this.B(ee.createInstance(b.$wq));this.ab=this.B(ee.createInstance(H,$e=>ge.postUninstall($e))),this.bb=this.B(new v.$yq(ue,_,se,this,this.F)),this.cb=this.B(ee.createInstance(a.$vq));const fe=this.B(new k.$zq(this,this.eb,ue,x,se,_,D));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Cp)(this.hb,this.F)),this.ib}async zip(V){this.F.trace("ExtensionManagementService#zip",V.identifier.id);const U=await this.ob(V),D=await(0,m.zip)((0,h.$7g)(this.cb.extensionsDownloadDir,(0,l.$Pg)()).fsPath,U);return g.URI.file(D)}async unzip(V){return this.F.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:U,cleanup:D}=await this.kb(V),F=w.$lc(U.fsPath);try{return await(0,S.$xq)(F)}finally{await D()}}getInstalled(V,U=this.H.defaultProfile.extensionsResource,D={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(V??null,U,D)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.ab.scanUserExtensionAtLocation(V)}async install(V,U={}){this.F.trace("ExtensionManagementService#install",V.toString());const{location:D,cleanup:F}=await this.kb(V);try{const z=await(0,S.$xq)(w.$lc(D.fsPath)),x=(0,s.$wp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,C.$Jp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:z,extension:D,options:U}])).find(({identifier:_})=>(0,s.$rp)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,r.$jq)(new Error(`Unknown error while installing extension ${x}`))}finally{await F()}}async installFromLocation(V,U){this.F.trace("ExtensionManagementService#installFromLocation",V.toString());const D=await this.ab.scanUserExtensionAtLocation(V);if(!D||!D.manifest.name||!D.manifest.version)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.tb([[D,{source:"resource"}]],U),this.F.info("Successfully installed extension",D.identifier.id,U.toString()),D}async installExtensionsFromProfile(V,U,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",V,U.toString(),D.toString());const F=(await this.getInstalled(1,U)).filter(z=>V.some(x=>(0,s.$rp)(x,z.identifier)));if(F.length){const z=await Promise.all(F.map(x=>this.ab.scanMetadata(x,U)));await this.tb(F.map((x,K)=>[x,z[K]]),D),this.F.info("Successfully installed extensions",F.map(x=>x.identifier.id),D.toString())}return F}async updateMetadata(V,U,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",V.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),V=await this.ab.updateMetadata(V,U,D),this.bb.invalidate(D),this.w.fire(V),V}async reinstallFromGallery(V){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const U=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:U,compatible:!0},L.CancellationToken.None);if(!D)throw new Error(d.localize(2,null));await this.ab.setUninstalled(V);try{await this.ab.removeUninstalledExtension(V)}catch(F){throw new Error(d.localize(3,null,(0,j.$ej)(F)))}return this.installFromGallery(D)}$(V,U,D,F){return this.ab.copyExtension(V,U,D,F)}copyExtensions(V,U){return this.ab.copyExtensions(V,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...V){return this.ab.setUninstalled(...V)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(V){this.F.error(V)}}async download(V,U,D){const{location:F}=await this.cb.download(V,U,!D);return F}async kb(V){if(V.scheme===y.Schemas.file)return{location:V,async cleanup(){}};this.F.trace("Downloading extension from",V.toString());const U=(0,h.$7g)(this.cb.extensionsDownloadDir,(0,l.$Pg)());return await this.gb.download(V,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(F){this.F.error(F)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(V,U,D){if(g.URI.isUri(U))return new re(V,U,D,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const F=s.$sp.create(U).toString();let z=this.db.get(F);return z||(this.db.set(F,z=new ie(V,U,D,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(F))),z}Z(V,U){return new he(V,U.profileLocation,this.fb)}async ob(V){const U=async F=>{let z=await u.Promises.readdir(F);z=z.map(ee=>w.$kc(F,ee));const x=await Promise.all(z.map(ee=>u.Promises.stat(ee)));let K=Promise.resolve([]);return x.forEach((ee,_)=>{const Q=z[_];ee.isFile()&&(K=K.then(se=>[...se,Q])),ee.isDirectory()&&(K=K.then(se=>U(Q).then(ue=>[...se,...ue])))}),K};return(await U(V.location.fsPath)).map(F=>({path:`extension/${w.$mc(V.location.fsPath,F)}`,localPath:F}))}async pb({added:V,removed:U}){if(U){const D=V&&this.D.extUri.isEqual(U.profileLocation,V.profileLocation)?U.extensions.filter(F=>V.extensions.every(z=>!(0,s.$rp)(z,F))):U.extensions;for(const F of D)this.F.info("Extensions removed from another source",F.id,U.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:U.profileLocation})}if(V){const F=(await this.getInstalled(1,V.profileLocation)).filter(z=>V.extensions.some(x=>(0,s.$rp)(x,z.identifier)));this.s.fire(F.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,V.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:V.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const V=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of V.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(V){if(!V.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const D of V.rawAdded){if(this.qb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.hb.stat(D)).isDirectory)continue;const F=await this.ab.scanUserExtensionAtLocation(D);F&&F.installedTimestamp===void 0&&(this.qb.add(D),U.push(F))}U.length&&(await this.tb(U.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(D=>D.identifier.id)))}async tb(V,U){const D=V.map(F=>F[0]);await this.ub(D),await this.fb.addExtensionsToProfile(V,U),this.s.fire(D.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:U})))}async ub(V){const U=await this.ab.getUninstalledExtensions();for(const D of V){const F=s.$sp.create(D);U[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.ab.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$Bq=J,e.$Bq=J=Ee([Z(0,n.$3o),Z(1,Y.$Yl),Z(2,T.$Zj),Z(3,t.$Bi),Z(4,o.$qq),Z(5,i.$mq),Z(6,$.$Ho),Z(7,M.$si),Z(8,R.$Zk),Z(9,q.$gk),Z(10,G.$xl),Z(11,X.$zl)],J);let H=class extends f.$Vc{constructor(V,U,D,F,z,x){super(),this.j=V,this.m=U,this.n=D,this.s=F,this.t=z,this.u=x,this.h=this.B(new I.$ce),this.onExtract=this.h.event,this.c=(0,h.$7g)(this.n.userExtensionsLocation,".obsolete"),this.g=new A.$Ah}async cleanUp(){await this.H(),await this.G()}async scanExtensions(V,U,D){const F={includeInvalid:!0,profileLocation:U,productVersion:D};let z=[];return V===null||V===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},F,!1)):V===1&&z.push(...await this.n.scanUserExtensions(F)),z=V!==null?z.filter(x=>x.type===V):z,Promise.all(z.map(x=>this.F(x)))}async scanAllUserExtensions(V){const U=await this.n.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(U.map(D=>this.F(D)))}async scanUserExtensionAtLocation(V){try{const U=await this.n.scanExistingExtension(V,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(V,U,D,F,z){const x=V.toString(),K=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Pg)()}`)),ee=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&F){try{await this.y(V.id,ee,"removeExisting")}catch{throw new n.$4o(d.localize(4,null,ee.fsPath,V.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,D);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${ee.fsPath}`),await(0,m.$gq)(U,K.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${ee}:`,V.id)}catch(Q){let se=n.ExtensionManagementErrorCode.Extract;throw Q instanceof m.$eq&&(Q.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:Q.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$4o(Q.message,se)}await this.n.updateMetadata(K,D);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${ee.fsPath}`),await this.C(K.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Q){if(Q.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(Q)}. Deleted from extracted location`,K),Q}this.h.fire(ee)}catch(Q){try{await this.m.del(K,{recursive:!0})}catch{}throw Q}return this.D(ee,1)}async scanMetadata(V,U){return U?(await this.w(V,U))?.metadata:this.n.scanMetadata(V.location)}async w(V,U){return(await this.s.scanProfileExtensions(U)).find(F=>(0,s.$rp)(F.identifier,V.identifier))}async updateMetadata(V,U,D){return D?await this.s.updateMetadata([[V,U]],D):await this.n.updateMetadata(V.location,U),this.D(V.location,V.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...V){const U=V.map(D=>s.$sp.create(D));await this.z(D=>U.forEach(F=>{D[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(V){await this.z(U=>delete U[V.toString()])}async removeExtension(V,U){if(this.t.extUri.isEqualOrParent(V.location,this.n.userExtensionsLocation))return this.y(V.identifier.id,V.location,U)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.z(U=>delete U[s.$sp.create(V).toString()])}async copyExtension(V,U,D,F){const z=await this.w(V,U),x=await this.w(V,D);if(F={...z?.metadata,...F},x)if(this.t.extUri.isEqual(x.location,V.location))await this.s.updateMetadata([[V,{...x.metadata,...F}]],D);else{const K=await this.D(x.location,V.type,D);await this.s.removeExtensionFromProfile(K,D),await this.s.addExtensionsToProfile([[V,{...x.metadata,...F}]],D)}else await this.s.addExtensionsToProfile([[V,F]],D);return this.D(V.location,V.type,D)}async copyExtensions(V,U,D){const F=await this.scanExtensions(1,V,D),z=await Promise.all(F.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,V)]));await this.s.addExtensionsToProfile(z,U)}async y(V,U,D){this.u.trace(`Deleting ${D} extension from disk`,V,U.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,P.$hj)((0,l.$Pg)()).toString(16)}${W}`);await this.C(U.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,V,U.fsPath)}async z(V){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,R.$el)(F)!==1)throw F}let D={};if(U)try{D=JSON.parse(U)}catch{}return V&&(V(D),Object.keys(D).length?await this.m.writeFile(this.c,N.$De.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(V,U){try{await u.Promises.rename(V,U,2*60*1e3)}catch(D){throw new n.$4o(D.message||d.localize(5,null,V,U),D.code||n.ExtensionManagementErrorCode.Rename)}}async D(V,U,D){if(D){const z=(await this.n.scanUserExtensions({profileLocation:D})).find(x=>this.t.extUri.isEqual(x.location,V));if(z)return this.F(z)}else{const F=await this.n.scanExistingExtension(V,U,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(d.localize(6,null,V.path))}async F(V){const U=await this.m.resolve(V.location);let D,F;return U.children&&(D=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,F=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:D,changelogUrl:F,publisherDisplayName:V.metadata?.publisherDisplayName,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!V.metadata?.hasPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned,isWorkspaceScoped:!1,source:V.metadata?.source??(V.identifier.uuid?"gallery":"vsix")}}async G(){const V=await this.getUninstalledExtensions();if(Object.keys(V).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(V));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const z of U)V[s.$sp.create(z).toString()]||D.add(z.identifier.id.toLowerCase());try{const z=(0,s.$xp)(U,x=>x.identifier);await A.Promises.settled(z.map(async x=>{const K=x.sort((ee,_)=>c.rcompare(ee.manifest.version,_.manifest.version))[0];D.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(z){this.u.error(z)}const F=U.filter(z=>z.metadata&&V[s.$sp.create(z).toString()]);await Promise.allSettled(F.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let V;try{V=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,R.$el)(U)!==1&&this.u.error(U);return}if(V?.children)try{await Promise.allSettled(V.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(D){(0,R.$el)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$Cq=H,e.$Cq=H=Ee([Z(1,R.$Zk),Z(2,o.$qq),Z(3,i.$mq),Z(4,G.$xl),Z(5,T.$Zj)],H);class B extends r.$kq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$ag)(this.options.operation)?this.l:this.options.operation}constructor(V,U,D,F,z,x,K,ee,_,Q){super(),this.manifest=V,this.identifier=U,this.source=D,this.options=F,this.m=z,this.n=x,this.o=K,this.p=ee,this.q=_,this.s=Q,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(V){const[U,D]=await this.x(V);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,D]],this.j,!U.isValid),U}async u({zipPath:V,key:U,metadata:D},F,z){let x=await this.v(U);return x?x=await this.m.updateMetadata(x,D):(this.s.trace("Extracting extension...",U.id),x=await this.m.extractUserExtension(U,V,D,F,z),this.s.info("Extracting extension completed.",U.id)),x}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find(F=>s.$sp.create(F).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class ie extends B{constructor(V,U,D,F,z,x,K,ee,_,Q,se){super(V,U.identifier,U,D,z,x,K,ee,_,Q),this.y=U,this.z=F,this.A=se}async x(V){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(z){throw new n.$4o(z,n.ExtensionManagementErrorCode.Scanning)}const D=U.find(z=>(0,s.$rp)(z.identifier,this.y.identifier));D&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:D?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:(0,p.$_f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||D?.preRelease,source:"gallery"};if(D&&D.type!==0&&D.manifest.version===this.y.version)try{return[await this.m.updateMetadata(D,F),F]}catch(z){throw new n.$4o((0,O.$0)(z),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(F,V)}catch(z){if(z instanceof n.$4o&&(z.code===n.ExtensionManagementErrorCode.CorruptZip||z.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(F,V);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw z}}async C(V,U){const{location:D,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.D(D.fsPath),[await this.u({zipPath:D.fsPath,key:s.$sp.create(this.y),metadata:V},!1,U),V]}catch(z){try{await this.z.delete(D)}catch(x){this.s.warn("Error while deleting the downloaded file",D.toString(),(0,O.$0)(x))}throw z}}async D(V){try{await(0,S.$xq)(V)}catch(U){throw new n.$4o(U.message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Dq=ie;class re extends B{constructor(V,U,D,F,z,x,K,ee,_,Q){super(V,{id:(0,s.$wp)(V.publisher,V.name)},U,D,z,x,K,ee,_,Q),this.y=U,this.z=F}async h(V){const U=await super.h(V);return this.C(U,V),U}async x(V){const U=new s.$sp(this.identifier,this.manifest.version),F=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(K=>(0,s.$rp)(this.identifier,K.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned,source:"vsix"};if(F)if(this.l=3,U.equals(new s.$sp(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(F.manifest.version,this.manifest.version)&&await this.m.setUninstalled(F);else{const K=await this.v(U);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(d.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:w.$lc(this.y.fsPath),key:U,metadata:z},!0,V),z]}async C(V,U){try{let[D]=await this.z.getExtensions([{id:V.identifier.id,version:V.manifest.version}],U);if(D||([D]=await this.z.getExtensions([{id:V.identifier.id}],U)),D){const F={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,hasPreReleaseVersion:V.hasPreReleaseVersion||D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(V,F,this.options.profileLocation)}}catch{}}}class he extends r.$kq{constructor(V,U,D){super(),this.extension=V,this.j=U,this.k=D}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0;let E=class extends O.$nq{constructor(w,h,c,p,g,l){super(f.URI.file(w.extensionsPath),h,c,p,g,l)}};e.$EQ=E,e.$EQ=E=Ee([Z(0,P.$Bi),Z(1,I.$Zk),Z(2,N.$zl),Z(3,L.$xl),Z(4,j.$Yl),Z(5,A.$Zj)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;let w=class extends j.$uq{constructor(c,p,g,l,u,m,d,$){super(A.URI.file(u.builtinExtensionsPath),A.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,p,g,l,u,m,d,$)}};e.$Occ=w,e.$Occ=w=Ee([Z(0,y.$zl),Z(1,L.$mq),Z(2,O.$Zk),Z(3,P.$Zj),Z(4,N.$Bi),Z(5,f.$gk),Z(6,E.$xl),Z(7,I.$si)],w)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Zp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Yp=h,e.$1p=p,e.$3p=l,e.$Vp="__$__isNewStorageMarker",e.$Wp="__$__targetStorageMarker",e.$Xp=(0,P.$ti)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(u){const m=u.get(e.$Wp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class c extends L.$Vc{static{this.a=60*1e3}constructor(m={flushInterval:c.a}){super(),this.m=m,this.b=this.B(new N.$fe),this.c=this.B(new N.$fe),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ce),this.onWillSaveState=this.f.event,this.h=this.B(new A.$Fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,d,$){return N.Event.filter(this.b.event,t=>t.scope===m&&(d===void 0||t.key===d),$)}n(){this.j.value=(0,A.$Jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,d){const{key:$,external:t}=d;if($===e.$Wp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:$,target:this.J(m)[$],external:t})}w(m){this.f.fire({reason:m})}get(m,d,$){return this.P(d)?.get(m,$)}getBoolean(m,d,$){return this.P(d)?.getBoolean(m,$)}getNumber(m,d,$){return this.P(d)?.getNumber(m,$)}getObject(m,d,$){return this.P(d)?.getObject(m,$)}storeAll(m,d){this.y(()=>{for(const $ of m)this.store($.key,$.value,$.scope,$.target,d)})}store(m,d,$,t,r=!1){if((0,O.$cg)(d)){this.remove(m,$,r);return}this.y(()=>{this.z(m,$,t),this.P($)?.set(m,d,r)})}remove(m,d,$=!1){this.y(()=>{this.z(m,d,void 0),this.P(d)?.delete(m,$)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,d){const $=[],t=this.J(m);for(const r of Object.keys(t))t[r]===d&&$.push(r);return $}z(m,d,$,t=!1){const r=this.J(d);typeof $=="number"?r[m]!==$&&(r[m]=$,this.P(d)?.set(e.$Wp,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.P(d)?.set(e.$Wp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const d=this.P(m);return d?h(d):Object.create(null)}isNew(m){return this.getBoolean(e.$Vp,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const d=this.P(-1),$=this.P(0),t=this.P(1);switch(m){case E.NONE:await A.Promises.settled([d?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await A.Promises.settled([d?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return l(m,d,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,d){return this.w(E.NONE),(0,f.$yl)(m)?this.R(m,d):this.S(m,d)}M(m,d){return!(m.id===d.id||p(d)&&p(m))}N(m,d,$){this.y(()=>{const t=new Set;for(const[r,n]of m)t.add(r),d.get(r)!==n&&this.u($,{key:r,external:!0});for(const[r]of d.items)t.has(r)||this.u($,{key:r,external:!0})})}}e.$Zp=c;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends c{constructor(){super(),this.U=this.B(new I.$Tp(new I.$Up,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Tp(new I.$Up,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Tp(new I.$Up,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$2p=g;async function l(u,m,d,$,t,r){const n=C=>{try{return JSON.parse(C)}catch{return C}},s=new Map,i=new Map;u.forEach((C,R)=>{s.set(R,C),i.set(R,n(C))});const o=new Map,a=new Map;m.forEach((C,R)=>{o.set(R,C),a.set(R,n(C))});const b=new Map,S=new Map;d.forEach((C,R)=>{b.set(R,C),S.set(R,n(C))}),console.group($!==t?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const v=[];if(s.forEach((C,R)=>{v.push({key:R,value:C})}),console.table(v),console.groupEnd(),console.log(i),$!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];o.forEach((R,M)=>{C.push({key:M,value:R})}),console.table(C),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const k=[];b.forEach((C,R)=>{k.push({key:R,value:C})}),console.table(k),console.groupEnd(),console.log(S)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,A,N,L,j,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJb=e.$zJb=void 0;let P=class extends N.$Vc{constructor(y,w){super(),this.a=new A.$ce,this.onDidChangeEnablement=this.a.event,this.b=this.B(new f(y)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(w.onDidInstallExtensions(h=>h.forEach(({local:c,operation:p})=>{c&&p===4&&this.f(c.identifier)})))}async enableExtension(y,w){return this.f(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}async disableExtension(y,w){return this.c(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}getDisabledExtensions(){return this.h(j.$7o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const w=this.getDisabledExtensions();return w.every(h=>!(0,O.$rp)(h,y))?(w.push(y),this.g(w),!0):!1}f(y){const w=this.getDisabledExtensions();for(let h=0;h<w.length;h++){const c=w[h];if((0,O.$rp)(c,y))return w.splice(h,1),this.g(w),!0}return!1}g(y){this.j(j.$7o,y)}h(y){return this.b.get(y,0)}j(y,w){this.b.set(y,w,0)}};e.$zJb=P,e.$zJb=P=Ee([Z(0,I.$Xp),Z(1,j.$6o)],P);class f extends N.$Vc{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new A.$ce),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$Uc))(w=>this.f(w)))}get(y,w){let h;return w===0?((0,L.$cg)(this.a[y])&&(this.a[y]=this.g(y,w)),h=this.a[y]):h=this.g(y,w),JSON.parse(h)}set(y,w,h){const c=JSON.stringify(w.map(({id:g,uuid:l})=>({id:g,uuid:l})));this.g(y,h)!==c&&(h===0&&(w.length?this.a[y]=c:delete this.a[y]),this.h(y,w.length?c:void 0,h))}f(y){if(!(0,L.$cg)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const h=this.get(y.key,y.scope);delete this.a[y.key];const c=this.get(y.key,y.scope),p=h.filter(l=>!c.some(u=>(0,O.$rp)(l,u))),g=c.filter(l=>!h.some(u=>(0,O.$rp)(u,l)));(p.length||g.length)&&this.b.fire([...p,...g])}}g(y,w){return this.c.get(y,w,"[]")}h(y,w,h){w?this.c.store(y,w,h,1):this.c.remove(y,h)}}e.$AJb=f}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$6p=re;const t=j.$o?"web":(0,y.$Yo)(j.$u,O.$fc),r="X-Market-Search-Activity-Id";var n;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...F){return String(F.reduce((z,x)=>z|x,0))}var i;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class v{constructor(z=S){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,x=this.d.pageSize){return new v({...this.d,pageNumber:z,pageSize:x})}withFilter(z,...x){const K=[...this.d.criteria,...x.length?x.map(ee=>({filterType:z,value:ee})):[{filterType:z}]];return new v({...this.d,criteria:K})}withSortBy(z){return new v({...this.d,sortBy:z})}withSortOrder(z){return new v({...this.d,sortOrder:z})}withFlags(...z){return new v({...this.d,flags:z.reduce((x,K)=>x|K,0)})}withAssetTypes(...z){return new v({...this.d,assetTypes:z})}withSource(z){return new v({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_,flags:Q,assetTypes:se}=this.d;return{filters:[{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_}],assetTypes:se,flags:Q}}get searchText(){const z=this.d.criteria.filter(x=>x.filterType===i.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(F,z){const x=(F||[]).filter(K=>K.statisticName===z)[0];return x?x.value:0}function C(F){const z="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(K=>K.assetType.indexOf(z)===0).reduce((K,ee)=>{const _=T(F,ee.assetType);return _&&K.push([ee.assetType.substring(z.length),_]),K},[])}function R(F){if(F.properties){const z=F.properties.filter(ee=>ee.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=z.filter(ee=>x.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return T(F,o.Repository)}function M(F){return{uri:`${F.fallbackAssetUri}/${o.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${o.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function T(F,z){return F.files.filter(K=>K.assetType===z)[0]?{uri:`${F.assetUri}/${z}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${z}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function q(F,z){const x=F.properties?F.properties.filter(ee=>ee.key===z):[],K=x.length>0&&x[0].value;return K?K.split(",").map(ee=>(0,w.$vp)(ee)):[]}function Y(F){const z=F.properties?F.properties.filter(x=>x.key===a.Engine):[];return z.length>0&&z[0].value||""}function G(F){const z=F.properties?F.properties.filter(x=>x.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function X(F){const z=F.properties?F.properties.filter(K=>K.key===a.LocalizedLanguages):[],x=z.length>0&&z[0].value||"";return x?x.split(","):[]}function W(F){return F.properties?.find(z=>z.key===a.SponsorLink)?.value}function J(F){return F.properties?.find(z=>z.key===a.SupportLink)?.value}function H(F){return F.indexOf("preview")!==-1}function B(F){return F.targetPlatform?(0,y.$Xo)(F.targetPlatform):"undefined"}function ie(F){const z=(0,A.$Mb)(F.versions.map(B)),x=!!F.tags?.includes(y.$So),K=z.indexOf("web");return x?K===-1&&z.push("web"):K!==-1&&z.splice(K,1),z}function re(F,z){for(let x=0;x<F.length;x++){const K=F[x];if(K.version===F[x-1]?.version){let ee=x;if(B(K)===z)for(;ee>0&&F[ee-1].version===K.version;)ee--;ee!==x&&(F.splice(x,1),F.splice(ee,0,K))}}return F}function he(F,z,x){F.telemetryData={index:z,querySource:x,queryActivityId:F.queryContext?.[r]}}function te(F,z,x,K){const ee=F.versions[0],_={manifest:T(z,o.Manifest),readme:T(z,o.Details),changelog:T(z,o.Changelog),license:T(z,o.License),repository:R(z),download:M(z),icon:T(z,o.Icon),signature:T(z,o.Signature),coreTranslations:C(z)};return{identifier:{id:(0,w.$wp)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:z.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:F.shortDescription??"",installCount:k(F.statistics,"install"),rating:k(F.statistics,"averagerating"),ratingCount:k(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:q(z,a.Dependency),extensionPack:q(z,a.ExtensionPack),engine:Y(z),localizedLanguages:X(z),targetPlatform:B(z),isPreReleaseVersion:G(z)},hasPreReleaseVersion:G(ee),hasReleaseVersion:!0,preview:H(F.flags),isSigned:!!_.signature,queryContext:K,supportLink:J(ee)}}let V=class{constructor(z,x,K,ee,_,Q,se,ue){this.k=x,this.l=K,this.n=ee,this.o=_,this.q=Q,this.u=se,this.w=ue;const ge=se.extensionsGallery,fe=ge?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=fe?ge.servicePPEUrl:ge?.serviceUrl,this.g=fe?void 0:ge?.searchUrl,this.h=ge?.controlUrl,this.j=(0,u.$5p)(se.version,se,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,x,K){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:K,Q=[],se=[],ue=[],ge=[];let fe=!0;for(const ve of z){ve.uuid?se.push(ve.uuid):Q.push(ve.id);const Pe=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Pe}),ve.version&&ge.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Pe}if(!se.length&&!Q.length)return[];let $e=new v().withPage(1,z.length);se.length&&($e=$e.withFilter(i.ExtensionId,...se)),Q.length&&($e=$e.withFilter(i.ExtensionName,...Q)),(ee.queryAllVersions||fe)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??t,includePreRelease:ue,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((ve,Pe)=>he(ve,Pe,ee.source)),ye}async getCompatibleExtension(z,x,K,ee={version:this.u.version,date:this.u.date}){if((0,y.$Zo)(z.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(z,x,K))return z;const _=new v().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,z.identifier.uuid),{extensions:Q}=await this.z(_,{targetPlatform:K,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Q[0]||null}async isExtensionCompatible(z,x,K,ee={version:this.u.version,date:this.u.date}){if(!(0,y.$1o)(z.properties.targetPlatform,z.allTargetPlatforms,K)||!x&&z.properties.isPreReleaseVersion)return!1;let _=z.properties.engine;if(!_){const Q=await this.getManifest(z,N.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");_=Q.engines.vscode}return(0,h.$Jp)(_,ee.version,ee.date)}async y(z,x,K,ee,_,Q,se={version:this.u.version,date:this.u.date}){if(!(0,y.$1o)(B(x),_,Q)||K!=="any"&&G(x)!==(K==="prerelease"))return!1;if(ee)try{const ue=await this.E(z,x);if(!(0,h.$Jp)(ue,se.version,se.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,L.$0)(ue)),!1}return!0}async query(z,x){let K=z.text||"";const ee=z.pageSize??50;let _=new v().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Category,ye||$e),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Tag,ye||$e),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),_=_.withFilter(i.SearchText,K)),_=_.withSortBy(0)):z.ids?_=_.withFilter(i.ExtensionId,...z.ids):z.names?_=_.withFilter(i.ExtensionName,...z.names):_=_.withSortBy(4),typeof z.sortBy=="number"&&(_=_.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(_=_.withSortOrder(z.sortOrder)),z.source&&(_=_.withSource(z.source));const Q=async(fe,$e)=>{const{extensions:ye,total:ve}=await this.z(fe,{targetPlatform:t,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Pe,Ae)=>he(Pe,(fe.pageNumber-1)*fe.pageSize+Ae,z.source)),{extensions:ye,total:ve}},{extensions:se,total:ue}=await Q(_,x),ge=async(fe,$e)=>{if($e.isCancellationRequested)throw new L.$5;const{extensions:ye}=await Q(_.withPage(fe+1),$e);return ye};return{firstPage:se,total:ue,pageSize:_.pageSize,getPage:ge}}async z(z,x,K){const ee=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Q,context:se}=await this.B(z,K);if(!(z.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const ve=await this.A(ye,x,se);ve&&$e.push(ve)}return{extensions:$e,total:Q}}const ge=[],fe=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],ve={id:(0,w.$wp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Pe=(0,I.$_f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(le=>(0,w.$rp)(le,ve))?.includePreRelease;if(x.compatible&&(0,y.$Zo)(ie(ye),x.targetPlatform))continue;const Ae=await this.A(ye,x,se);!Ae||Ae.properties.isPreReleaseVersion&&(!Pe||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==x.targetPlatform&&Ae.hasPreReleaseVersion?fe.set(ye.extensionId,$e):ge.push([$e,Ae])}if(fe.size){const $e=new $.$$d,ye=new v().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(ye,x,K);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:fe.size});for(const Pe of ve){const Ae=fe.get(Pe.identifier.uuid);ge.push([Ae,Pe])}}return{extensions:ge.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Q}}async A(z,x,K){const ee={id:(0,w.$wp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},_=x.versions?.find(ge=>(0,w.$rp)(ge,ee))?.version,Q=(0,I.$_f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ge=>(0,w.$rp)(ge,ee))?.includePreRelease,se=ie(z),ue=re(z.versions,x.targetPlatform);if(x.compatible&&(0,y.$Zo)(se,x.targetPlatform))return null;for(let ge=0;ge<ue.length;ge++){const fe=ue[ge];if(!(_&&fe.version!==_)){if(await this.y((0,w.$wp)(z.publisher.publisherName,z.extensionName),fe,Q?"any":"release",x.compatible,se,x.targetPlatform,x.productVersion))return te(z,fe,se,K);if(_&&fe.version===_)return null}}return _||x.compatible?null:te(z,z.versions[0],se)}async B(z,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,ee=JSON.stringify(z.raw),_={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Q=new $.$$d;let se,ue,ge=0;try{if(se=await this.k.request({type:"POST",url:this.g&&z.criteria.some($e=>$e.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const fe=await(0,l.$Qp)(se);if(fe){const $e=fe.results[0],ye=$e.extensions,ve=$e.resultMetadata&&$e.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ge=ve&&ve.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge,context:{[r]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(fe){const $e=(0,L.$4)(fe)?y.ExtensionGalleryErrorCode.Cancelled:(0,L.$0)(fe).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw ue=new y.$5o((0,L.$0)(fe),$e),ue}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(ee.length),duration:Q.elapsed(),success:!!se&&(0,l.$Mp)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?.code,count:String(ge)})}}async reportStatistic(z,x,K,ee){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${z}.${x}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${x}/${K}/stats?statType=${ee}`),Q=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:_,headers:ue},N.CancellationToken.None)}catch{}}async download(z,x,K){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const ee=(0,w.$zp)(z),_=new Date().getTime(),Q=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),se=K===2?"install":K===3?"update":"",ue=se?{uri:`${z.assets.download.uri}${P.URI.parse(z.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${z.assets.download.fallbackUri}${P.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:z.assets.download,ge=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,fe=await this.D(z.identifier.id,ue,o.VSIX,ge?{headers:ge}:void 0);await this.q.writeFile(x,fe.stream),Q(new Date().getTime()-_)}async downloadSignatureArchive(z,x){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const K=await this.D(z.identifier.id,z.assets.signature,o.Signature);await this.q.writeFile(x,K.stream)}async getReadme(z,x){if(z.assets.readme){const K=await this.D(z.identifier.id,z.assets.readme,o.Details,{},x);return await(0,l.$Pp)(K)||""}return""}async getManifest(z,x){if(z.assets.manifest){const K=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},x),ee=await(0,l.$Pp)(K);return ee?JSON.parse(ee):null}return null}async C(z,x,K){const ee=T(x,o.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Q=await this.D(z,ee,o.Manifest,{headers:_});return await(0,l.$Qp)(Q)}async getCoreTranslation(z,x){const K=z.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(K){const ee=await this.D(z.identifier.id,K[1],K[0]),_=await(0,l.$Pp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(z,x){if(z.assets.changelog){const K=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},x);return await(0,l.$Pp)(K)||""}return""}async getAllCompatibleVersions(z,x,K){let ee=new v().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?ee=ee.withFilter(i.ExtensionId,z.identifier.uuid):ee=ee.withFilter(i.ExtensionName,z.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Q=ie(_[0]);if((0,y.$Zo)(Q,K))return[];const se=[];await Promise.all(_[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,x?"any":"release",!0,Q,K)&&se.push(fe)}catch{}}));const ue=[],ge=new Set;for(const fe of re(se,K))ge.has(fe.version)||(ge.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:G(fe)}));return ue}async D(z,x,K,ee={},_=N.CancellationToken.None){const Q=await this.j,se={type:"GET"},ue={...Q,...ee.headers||{}};ee={...ee,...se,headers:ue};const ge=x.uri,fe=x.fallbackUri,$e={...ee,url:ge};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const ve=await(0,l.$Pp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ve}`)}catch(ye){if((0,L.$4)(ye))throw ye;const ve=(0,L.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:K,message:ve});const Pe={...ee,url:fe};return this.k.request(Pe,_)}}async E(z,x){let K=Y(x);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:x.version});const ee=await this.C(z,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");K=ee.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,l.$Qp)(z),K=[],ee={},_=[];if(x){for(const Q of x.malicious)K.push({id:Q});if(x.migrateToPreRelease)for(const[Q,se]of Object.entries(x.migrateToPreRelease))(!se.engine||(0,h.$Jp)(se.engine,this.u.version,this.u.date))&&(ee[Q.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Q,se]of Object.entries(x.deprecated))se&&(ee[Q.toLowerCase()]=(0,I.$_f)(se)?{}:se);if(x.search)for(const Q of x.search)_.push(Q)}return{malicious:K,deprecated:ee,search:_}}};V=Ee([Z(1,l.$Kp),Z(2,p.$Zj),Z(3,E.$Ai),Z(4,d.$Yl),Z(5,c.$Zk),Z(6,g.$gk),Z(7,f.$Zi)],V);let U=class extends V{constructor(z,x,K,ee,_,Q,se,ue){super(z,x,K,ee,_,Q,se,ue)}};e.$7p=U,e.$7p=U=Ee([Z(0,m.$Xp),Z(1,l.$Kp),Z(2,p.$Zj),Z(3,E.$Ai),Z(4,d.$Yl),Z(5,c.$Zk),Z(6,g.$gk),Z(7,f.$Zi)],U);let D=class extends V{constructor(z,x,K,ee,_,Q,se){super(void 0,z,x,K,ee,_,Q,se)}};e.$8p=D,e.$8p=D=Ee([Z(0,l.$Kp),Z(1,p.$Zj),Z(2,E.$Ai),Z(3,d.$Yl),Z(4,c.$Zk),Z(5,g.$gk),Z(6,f.$Zi)],D)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=void 0,e.$Vv=(0,A.$ti)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends L.$Vc{static{y=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$vp)(p.id)}@${p.version}`}static c(p){const g=w.exec(p);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(p,g){const l=await p.getInstalled(),u=[];for(const[m,d]of y.f(g)){const $=l.find(t=>(0,O.$rp)(t.identifier,{id:m}))?.manifest.version;for(const t of d)$!==t&&u.push(y.b({id:m,version:t}))}for(const m of u)g.remove(m,0)}static f(p){const g=new Map,l=p.keys(0,1);for(const u of l){const m=y.c(u);if(m){let d=g.get(m.id.toLowerCase());d||g.set(m.id.toLowerCase(),d=[]),d.push(m.version)}}return g}constructor(p,g,l){super(),this.j=p,this.m=g,this.n=l,this.g=this.B(new N.$ce),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Uc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const g=y.c(p.key);if(g){if(this.j.get(p.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let l=this.h.get(g.id.toLowerCase());l||this.h.set(g.id.toLowerCase(),l=[]),l.push(g.version),this.g.fire()}return}}s(p){if((0,E.$6f)(p))return p;const g=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$up)(g,l)}getExtensionState(p,g){const l=this.s(p),u=this.getExtensionStateRaw(p,g);if(u)try{return JSON.parse(u)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${g}): ${m}`)}}getExtensionStateRaw(p,g){const l=this.s(p),u=this.j.get(l,g?0:1);return u&&u?.length>y.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,g,l){const u=this.s(p);g===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(g),l?0:1,1)}setKeysForSync(p,g){this.j.store(y.b(p),JSON.stringify(g),0,1)}getKeysForSync(p){const g=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(y.b(p),0),u=l?JSON.parse(l):void 0;return u&&g?(0,P.$Mb)([...u,...g]):u||g}addToMigrationList(p,g){if(p!==g){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(g));l.push([p,g]),this.t=l}}getSourceExtensionToMigrate(p){const g=this.t.find(([,l])=>p===l);return g?g[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(p);if(Array.isArray(g))return g}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Wv=h,e.$Wv=h=y=Ee([Z(0,j.$Xp),Z(1,I.$gk),Z(2,f.$Zj)],h)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;let f=class extends A.$Vc{constructor(y,w,h,c,p,g){super(),y.cleanUp(),(0,j.$c4b)(y,w,h,c,g),L.$Wv.removeOutdatedExtensionVersions(y,p)}};e.$5dc=f,e.$5dc=f=Ee([Z(0,O.$Aq),Z(1,N.$3o),Z(2,L.$Vv),Z(3,N.$9o),Z(4,P.$Xp),Z(5,I.$Zj)],f)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let y=class extends E.$oac{constructor(h,c,p,g,l,u,m,d){super(h.userHome,l,c,p,g,u,m,d)}};e.$_dc=y,e.$_dc=y=Ee([Z(0,j.$Bi),Z(1,f.$Yl),Z(2,A.$6o),Z(3,P.$Xp),Z(4,I.$2bc),Z(5,O.$Y3b),Z(6,N.$Zk),Z(7,L.$gk)],y)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;const $=[A.$1dc,A.$2dc],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends O.$Vc{constructor(a,b,S,v,k,C,R){super(),this.y=a,this.z=b,this.C=S,this.D=C,this.F=R,this.f=new N.$ce,this.onDidTokenFailed=this.f.event,this.g=new N.$ce,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ce,this.onDidChangeMode=this.h.event,this.n=A.$Ydc,this.w=!1,this.I=(M,T)=>{T?this.j.error(M):this.j.info(M)},this.j=this.B(v.createLogger((0,d.$7g)(S.logsHome,`${A.$3dc}.log`),{id:A.$3dc,name:A.$4dc})),this.t=new w.$qh(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$ck)(M)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(C.onDidChangeConfiguration(M=>{$.some(T=>M.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=A.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}J(){if(!this.u){let a;y.$j?a=this.C.appRoot:a=(0,P.$nc)((0,P.$nc)(this.C.appRoot)),this.u=(0,P.$kc)(a,"bin",`${this.z.tunnelApplicationName}${y.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(A.$Ydc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(b){this.j.error(b)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(A.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",b=!1;const S=(T,q)=>{q?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(A.TunnelStates.connecting((0,p.localize)(0,null)))},v=this.O("status",["status"],S);this.r=v;try{if(await v,this.r!==v)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(A.TunnelStates.disconnected());return}if(b=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(A.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(A.TunnelStates.disconnected());return}finally{this.r===v&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const T=k.token;this.G(A.TunnelStates.connecting((0,p.localize)(1,null,k.accountLabel,k.providerId)));const q=(G,X)=>{G=G.replaceAll(T,"*".repeat(4)),S(G,X)},Y=this.O("login",["user","login","--provider",k.providerId,"--access-token",T,"--log",(0,I.$ck)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(G){this.j.error(G),this.r=void 0,this.f.fire(k),this.G(A.TunnelStates.disconnected(k));return}}const C=this.Q();C?this.G(A.TunnelStates.connecting((0,p.localize)(2,null,C))):this.G(A.TunnelStates.connecting((0,p.localize)(3,null)));const R=["--accept-server-license-terms","--log",(0,I.$ck)(this.j.getLevel())];C?R.push("--name",C):R.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!b&&(M=await this.M(R)===!1),this.N(k,R,M)}async M(a){let b;try{b=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),b=1}if(b!==0){const S=(0,p.localize)(4,null);return this.j.warn(S),this.G(A.TunnelStates.connecting(S)),!1}return!0}async N(a,b,S){b.push("--parent-process-id",String(process.pid)),this.P()&&b.push("--no-sleep");let v=!1;const k=this.O("tunnel",b,(C,R)=>{R?this.j.error(C):this.j.info(C),C.includes("Connected to an existing tunnel process")&&(v=!0);const M=C.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const T={link:M[1],domain:M[2],tunnelName:M[4],isAttached:v};this.G(A.TunnelStates.connected(T,S))}else C.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(A.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=A.$Ydc,this.G(A.TunnelStates.disconnected()))})}O(a,b,S=this.I){return(0,w.$gh)(v=>new Promise((k,C)=>{v.isCancellationRequested&&k(-1);let R;const M=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{R&&(this.j.info(`${a} terminating(${R.pid})`),R.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)("cargo",["run","--","tunnel",...b],{cwd:(0,P.$kc)(this.C.appRoot,"cli"),stdio:M});else{S(`Running tunnel CLI
`,!1);const T=this.J();S(`${a} Spawning: ${T} tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)(T,["tunnel",...b],{cwd:(0,g.homedir)(),stdio:M})}R.stdout.pipe(new m.$CW(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!1)}}),R.stderr.pipe(new m.$CW(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!0)}}),R.on("exit",T=>{R&&(S(`${a} exit(${R.pid}): + ${T} `,!1),R=void 0,k(T||0))}),R.on("error",T=>{R&&(S(`${a} error(${R.pid}): + ${T} `,!0),R=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(A.$2dc)}Q(){let a=this.D.getValue(A.$1dc)||(0,g.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),b=this.F.getBoolean(r,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,u.$6f)(S.accountLabel)&&(0,u.$6f)(S.sessionId)&&(0,u.$6f)(S.providerId))return{active:!0,session:S,asService:b};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return A.$Ydc}S(a){if(a.active){const b={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(b),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$8dc=n,e.$8dc=n=Ee([Z(0,L.$Yl),Z(1,E.$gk),Z(2,j.$Bi),Z(3,I.$1j),Z(4,h.$6dc),Z(5,c.$Zi),Z(6,l.$Xp)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,A,N,L,j,O,I,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class E extends I.$Zp{constructor(w,h,c,p){super(),this.bb=w,this.cb=h,this.db=c,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Uc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new P.$_Jb(this.db.getChannel("storage"))),h=this.B(new O.$Tp(w));return this.B(h.onDidChangeStorage(c=>this.u(-1,c))),h}gb(w){this.X.clear(),this.W=w;let h;if((0,I.$1p)(w))h=this.U;else{const c=this.X.add(new P.$aKb(this.db.getChannel("storage"),w));h=this.X.add(new O.$Tp(c))}return this.X.add(h.onDidChangeStorage(c=>this.u(0,c))),h}hb(w){this.$.clear(),this.Z=w?.id;let h;if(w){const c=this.$.add(new P.$bKb(this.db.getChannel("storage"),w));h=this.$.add(new O.$Tp(c)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await A.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$7g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const h=this.Y,c=h.items;h!==this.U&&await h.close(),this.Y=this.gb(w),await this.Y.init(),this.N(c,this.Y,0)}async S(w,h){const c=this.ab,p=c?.items??new Map;await c?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(p,this.ab,1)}hasScope(w){return(0,f.$yl)(w)?this.W.id===w.id:this.Z===w.id}}e.$aec=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0;class O{constructor(f,E){this.a=f,this.b=E}listen(f,E){const y=this.b(f);switch(E){case"onDidChangeProfiles":return A.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,j.$xn)({...h},y)),added:w.added.map(h=>(0,j.$xn)({...h},y)),removed:w.removed.map(h=>(0,j.$xn)({...h},y)),updated:w.updated.map(h=>(0,j.$xn)({...h},y))}))}throw new Error(`Invalid listen ${E}`)}async call(f,E,y){const w=this.b(f);switch(E){case"createProfile":{const h=await this.a.createProfile(y[0],y[1],y[2]);return(0,j.$xn)({...h},w)}case"updateProfile":{let h=(0,L.$Al)((0,j.$yn)(y[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,y[1]),(0,j.$xn)({...h},w)}case"removeProfile":{const h=(0,L.$Al)((0,j.$yn)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${E}`)}}e.$LQ=O;class I extends N.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(f,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new A.$ce),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=f.map(w=>(0,L.$Al)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(g=>(0,L.$Al)(g,this.profilesHome.scheme)),c=w.removed.map(g=>(0,L.$Al)(g,this.profilesHome.scheme)),p=w.updated.map(g=>(0,L.$Al)(g,this.profilesHome.scheme));this.a=w.all.map(g=>(0,L.$Al)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:c,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(f){this.c=f}isEnabled(){return this.c}async createNamedProfile(f,E,y){const w=await this.f.call("createNamedProfile",[f,E,y]);return(0,L.$Al)(w,this.profilesHome.scheme)}async createProfile(f,E,y,w){const h=await this.f.call("createProfile",[f,E,y,w]);return(0,L.$Al)(h,this.profilesHome.scheme)}async createTransientProfile(f){const E=await this.f.call("createTransientProfile",[f]);return(0,L.$Al)(E,this.profilesHome.scheme)}async setProfileForWorkspace(f,E){await this.f.call("setProfileForWorkspace",[f,E])}removeProfile(f){return this.f.call("removeProfile",[f])}async updateProfile(f,E){const y=await this.f.call("updateProfile",[f,E]);return(0,L.$Al)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$MQ=I}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fKb=e.$eKb=e.$dKb=void 0,e.$dKb=(0,L.$ti)("IUserDataProfileStorageService");let f=class extends A.$Vc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async c=>this.b(c))}async updateStorageData(h,c,p){return this.withProfileScopedStorageService(h,async g=>this.c(g,c,p))}async withProfileScopedStorageService(h,c){if(this.a.hasScope(h))return c(this.a);const p=await this.g(h),g=new y(p);try{await g.initialize();const l=await c(g);return await g.flush(),l}finally{g.dispose(),await this.f(p)}}b(h){const c=new Map,p=g=>{for(const l of h.keys(0,g))c.set(l,{value:h.get(l,0),target:g})};return p(0),p(1),c}c(h,c,p){h.storeAll(Array.from(c.entries()).map(([g,l])=>({key:g,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,A.$Pc)(h)&&h.dispose()}}};e.$eKb=f,e.$eKb=f=Ee([Z(0,j.$Xp)],f);class E extends f{constructor(h,c,p,g){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new A.$Wc);this.h=this.B(new O.$ce({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(d=>(0,P.$Al)(d,c.profilesHome.scheme)),valueChanges:m.valueChanges.map(d=>({...d,profile:(0,P.$Al)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const c=this.j.getChannel("storage");return(0,j.$1p)(h)?new I.$_Jb(c):new I.$aKb(c,h)}}e.$fKb=E;class y extends j.$Zp{constructor(h){super({flushInterval:100}),this.s=this.B(new N.$Tp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let I=class extends O.$fKb{constructor(f,E,y,w){super(f,E,y,w)}};e.$Rdc=I,e.$Rdc=I=Ee([Z(0,j.$edc),Z(1,L.$zl),Z(2,A.$Xp),Z(3,N.$Zj)],I)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eLb=e.$dLb=e.$cLb=e.$bLb=void 0,e.$$Kb=t,e.$_Kb=r,e.$aLb=n;function t(b){return!!(b&&b.ref!==void 0&&typeof b.ref=="string"&&b.ref!==""&&b.syncData!==void 0&&(b.syncData===null||r(b.syncData)))}function r(b){return!!(b&&b.version!==void 0&&typeof b.version=="number"&&b.content!==void 0&&typeof b.content=="string"&&(Object.keys(b).length===2||Object.keys(b).length===3&&b.machineId!==void 0&&typeof b.machineId=="string"))}function n(b,S){return`${(0,f.$Xf)(b)}${S.isDefault?"":` (${S.name})`}`}let s=class extends P.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,v,k,C,R,M,T,q,Y,G,X,W){super(),this.syncResource=S,this.collection=v,this.G=k,this.H=C,this.I=R,this.J=M,this.L=T,this.M=q,this.N=Y,this.O=G,this.P=X,this.c=null,this.m="idle",this.n=this.B(new O.$ce),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$ce),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$rh(50)),this.w=this.B(new O.$ce),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(S.syncResource,S.profile),this.h=W.extUri,this.f=this.h.joinPath(C.userDataSyncHome,...(0,d.$dAb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,d.$yAb),this.y=(0,d.$eAb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,C,this.h),this.j=(0,g.$4p)(C,k,R)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const v=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(v)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,v={}){await this.U(S,!0,this.ob(),v)}async preview(S,v,k={}){return this.U(S,!1,v,k)}async apply(S,v={}){try{this.F={...v};const k=await this.ab(S);return this.S(k),this.c}finally{this.F={}}}async U(S,v,k,C){try{if(this.F={...C},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let R="idle";try{const M=await this.getLastSyncUserData(),T=await this.X(S,M);return R=await this.Y(T,M,v,k),R==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):R==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(R)}}finally{this.F={}}}async replace(S){const v=this.kb(S);if(!v)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),C=await this.X(null,k),R=await this.W(C),M=await this.qb({ref:C.ref,syncData:v},k,R,this.ob(),j.CancellationToken.None),T=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:G}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);T.push([q,{...Y,remoteChange:G!==0?G:2}])}await this.tb(C,k,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const v=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===v}async X(S,v){if(v){const k=S?S[this.resource]:void 0;if(v.ref===k||k===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async Y(S,v,k,C){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$lAb((0,y.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,v,k,C)}catch(R){if(R instanceof d.$lAb)switch(R.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,v,k,C);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.Y(S,v,k,C)}throw R}}async Z(S,v,k,C){try{const R=await this.W(S),M=!R&&v===null&&this.gb()!==void 0,T=k&&!M;this.c||(this.c=(0,N.$gh)(Y=>this.eb(S,v,R,T,C,Y)));let q=await this.c;if(k&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(R){throw this.c=null,R}}async merge(S){return await this.$(S,async v=>{const k=await this.rb(v,j.CancellationToken.None);await this.G.writeFile(v.previewResource,L.$De.fromString(k?.content||""));const C=k&&!k.hasConflicts?await this.sb(v,v.previewResource,void 0,j.CancellationToken.None):void 0;return v.acceptResult=C,v.mergeState=k.hasConflicts?"conflict":C?"accepted":"preview",v.localChange=C?C.localChange:k.localChange,v.remoteChange=C?C.remoteChange:k.remoteChange,v}),this.c}async accept(S,v){return await this.$(S,async k=>{const C=await this.sb(k,S,v,j.CancellationToken.None);return k.acceptResult=C,k.mergeState="accepted",k.localChange=C.localChange,k.remoteChange=C.remoteChange,k}),this.c}async discard(S){return await this.$(S,async v=>{const k=await this.rb(v,j.CancellationToken.None);return await this.G.writeFile(v.previewResource,L.$De.fromString(k.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=k.localChange,v.remoteChange=k.remoteChange,v}),this.c}async $(S,v){if(!this.c)return;let k=await this.c;const C=k.resourcePreviews.findIndex(({localResource:R,remoteResource:M,previewResource:T})=>this.h.isEqual(R,S)||this.h.isEqual(M,S)||this.h.isEqual(T,S));C!==-1&&(this.c=(0,N.$gh)(async R=>{const M=[...k.resourcePreviews];return M[C]=await v(M[C]),{...k,resourcePreviews:M}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:R})=>R==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(k=>[k,k.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const v=S.filter(({mergeState:k})=>k==="conflict");(0,A.$ub)(this.s,v,(k,C)=>this.h.isEqual(k.previewResource,C.previewResource))||(this.s=v,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const v=this.c?await this.c:null;if(v)for(const k of v.resourcePreviews){if(this.h.isEqual(k.acceptedResource,S))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,S))return k.remoteContent;if(this.h.isEqual(k.localResource,S))return k.localContent;if(this.h.isEqual(k.baseResource,S))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,c.$el)(S)!==1&&this.O.error(S)}}async eb(S,v,k,C,R,M){const T=await this.qb(S,v,k,R,M),q=[];for(const Y of T){const G=Y.previewResource.with({scheme:d.$xAb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=C?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$De.fromString(X?.content||""));const W=X&&!X.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:W,mergeState:X?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:X?X.localChange:Y.localChange,remoteChange:W?W.remoteChange:X?X.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const v=JSON.parse(S),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!v.version&&!!k&&v.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let C,R=1;for(;C===void 0&&R++<6;)try{const M=await this.hb();M&&(M.ref===v.ref?C=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof c.$il&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof d.$lAb)throw M;this.O.error(M,R)}}if(C===void 0)try{const M=await this.J.resolveResourceContent(this.resource,v.ref,this.collection,this.F);C=M===null?null:this.kb(M),await this.ib({ref:v.ref,syncData:C})}catch(M){if(M instanceof d.$lAb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return C===void 0?null:{...v,syncData:C}}async fb(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),C={ref:S.ref,version:k,...v};this.I.store(this.z,JSON.stringify(C),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const v=S?JSON.parse(S):void 0;if(t(v))return v}catch(v){this.O.error(v)}}async ib(S){await this.G.writeFile(this.y,L.$De.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),v=JSON.parse(S.value.toString());await this.G.del(this.y),v.ref&&v.content!==void 0?(this.I.store(this.z,JSON.stringify({...v,content:void 0}),-1,1),await this.ib({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,v)}catch(S){S instanceof c.$il&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:v,content:k}=await this.lb(S);let C=null;return k!==null&&(C=this.kb(k)),{ref:v,syncData:C}}kb(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.O.error(v)}throw new d.$lAb((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const v=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,v,this.collection,this.F)}async mb(S,v){const k=await this.j,C={version:this.pb,machineId:k,content:S};try{return v=await this.J.writeResource(this.resource,JSON.stringify(C),v,this.collection,this.F),{ref:v,syncData:C}}catch(R){throw R instanceof d.$lAb&&R.code==="TooLarge"&&(R=new d.$lAb(R.message,R.code,this.resource)),R}}async nb(S){const v={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(v),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$$zb)}};e.$bLb=s,e.$bLb=s=Ee([Z(2,c.$Zk),Z(3,h.$Ai),Z(4,l.$Xp),Z(5,d.$gAb),Z(6,d.$hAb),Z(7,d.$qAb),Z(8,u.$Yl),Z(9,d.$vAb),Z(10,w.$Zi),Z(11,m.$xl)],s);let i=class extends s{constructor(S,v,k,C,R,M,T,q,Y,G,X,W,J){super(v,k,C,R,M,T,q,Y,G,X,W,J),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,v,k){try{v?await this.G.writeFile(this.r,L.$De.fromString(S),k?void 0:v):await this.G.createFile(this.r,L.$De.fromString(S),{overwrite:k})}catch(C){throw C instanceof c.$il&&C.fileOperationResult===1||C instanceof c.$il&&C.fileOperationResult===3?new d.$lAb(C.message,"LocalPreconditionFailed"):C}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof c.$il&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$cLb=i,e.$cLb=i=Ee([Z(3,c.$Zk),Z(4,h.$Ai),Z(5,l.$Xp),Z(6,d.$gAb),Z(7,d.$hAb),Z(8,d.$qAb),Z(9,u.$Yl),Z(10,d.$vAb),Z(11,w.$Zi),Z(12,m.$xl)],i);let o=class extends i{constructor(S,v,k,C,R,M,T,q,Y,G,X,W,J,H){super(S,v,k,C,R,M,T,q,Y,G,X,J,H),this.zb=W,this.Bb=void 0}Ab(S,v){const k=[],C=(0,I.$Gn)(S,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,E.$ag)(C)&&v!==Array.isArray(C)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$dLb=o,e.$dLb=o=Ee([Z(3,c.$Zk),Z(4,h.$Ai),Z(5,l.$Xp),Z(6,d.$gAb),Z(7,d.$hAb),Z(8,d.$qAb),Z(9,u.$Yl),Z(10,d.$vAb),Z(11,d.$uAb),Z(12,w.$Zi),Z(13,m.$xl)],o);let a=class{constructor(S,v,k,C,R,M,T){this.resource=S,this.g=v,this.h=k,this.j=C,this.k=R,this.l=M,this.d=T.extUri,this.f=(0,d.$eAb)(void 0,this.resource,k,this.d)}async initialize({ref:S,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(v);if(k)try{await this.o({ref:S,syncData:k})}catch(C){this.j.error(C)}}m(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k={ref:S.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,L.$De.fromString(JSON.stringify(S)))}};e.$eLb=a,e.$eLb=a=Ee([Z(1,$.$zl),Z(2,h.$Ai),Z(3,p.$Zj),Z(4,c.$Zk),Z(5,l.$Xp),Z(6,m.$xl)],a)}),define(ae[115],ce([0,1,6,26,7,3,44,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=e.$u$b=void 0,e.$s$b=S,e.$t$b=v;async function b(M,T){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await T.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of q)M.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),M.version===2&&Y.every(X=>!(0,h.$rp)(X.identifier,G.identifier))&&(G.installed=!0)}return q}function S(M){return JSON.parse(M.content)}function v(M,T){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,P.$of)(q.identifier.id,Y.identifier.id)),T?(0,O.$Rn)(M,{}):JSON.stringify(M)}let k=class extends n.$bLb{constructor(T,q,Y,G,X,W,J,H,B,ie,re,he,te,V,U,D,F){super({syncResource:"extensions",profile:T},q,G,Y,X,W,J,he,te,ie,re,U),this.Cb=H,this.Db=B,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$xAb,authority:"base"}),this.yb=this.wb.with({scheme:o.$xAb,authority:"local"}),this.zb=this.wb.with({scheme:o.$xAb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$xAb,authority:"accepted"}),this.Bb=this.Eb.createInstance(C),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:x})=>!!x)),j.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),j.Event.filter(D.onDidChange,z=>z.valueChanges.some(({profile:x,changes:K})=>this.syncResource.profile.id===x.id&&K.some(ee=>ee.key===w.$7o))),V.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,q){const Y=T.syncData?await b(T.syncData,this.Cb):null,G=q?.skippedExtensions??[],X=q?.builtinExtensions??null,W=q?.syncData?await b(q.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$r$b)(J,Y,W,G,H,X),re={local:B,remote:ie,content:this.Hb(J,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(J,!1);return[{skippedExtensions:G,builtinExtensions:X,baseResource:this.xb,baseContent:W?this.Ob(W,!1):he,localResource:this.yb,localContent:he,localExtensions:J,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(T){const q=T.syncData?await b(T.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.$r$b)(Y,q,q,T.skippedExtensions||[],G,T.builtinExtensions||[]);return X!==null}Hb(T,q,Y,G){const X=[...q,...Y],W=new Set,J=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};X.forEach(({identifier:H})=>J(H)),G.forEach(J);for(const H of T)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||X.push(H);return this.Ob(X,!1)}async rb(T,q){return{...T.previewResult,hasConflicts:!1}}async sb(T,q,Y,G){if(this.h.isEqual(q,this.yb))return this.Kb(T);if(this.h.isEqual(q,this.zb))return this.Lb(T);if(this.h.isEqual(q,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),G=(0,s.$r$b)(T.localExtensions,null,null,T.skippedExtensions,Y,T.builtinExtensions),{local:X,remote:W}=G;return{content:T.localContent,local:X,remote:W,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),G=T.remoteContent?JSON.parse(T.remoteContent):null;if(G!==null){const X=(0,s.$r$b)(T.localExtensions,G,T.localExtensions,[],Y,T.builtinExtensions),{local:W,remote:J}=X;return{content:T.remoteContent,local:W,remote:J,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,q,Y,G){let{skippedExtensions:X,builtinExtensions:W,localExtensions:J}=Y[0][0];const{local:H,remote:B,localChange:ie,remoteChange:re}=Y[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),X=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,X,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(B.all);T=await this.mb(he,G?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(te=>te.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(te=>te.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(te=>te.identifier.id))}.`:""}`)}q?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(J,W),await this.fb(T,{skippedExtensions:X,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(he=>he.identifier.id))}.`:""}`))}Nb(T,q){const Y=new Set,G=[];for(const X of T)Y.add(X.identifier.id.toLowerCase()),X.installed||G.push(X.identifier);if(q)for(const X of q)Y.has(X.id.toLowerCase())||G.push(X);return G}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const q=await this.db(T);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(T,q){return v(T,q)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$u$b=k,e.$u$b=k=Ee([Z(2,E.$Ai),Z(3,g.$Zk),Z(4,d.$Xp),Z(5,o.$gAb),Z(6,o.$hAb),Z(7,w.$6o),Z(8,i.$ZLb),Z(9,o.$vAb),Z(10,f.$Zi),Z(11,o.$qAb),Z(12,$.$Yl),Z(13,c.$Vv),Z(14,t.$xl),Z(15,a.$dKb),Z(16,l.$si)],k);let C=class{constructor(T,q,Y,G,X,W){this.a=T,this.b=q,this.c=Y,this.d=G,this.f=X,this.g=W}async getLocalExtensions(T){const q=await this.a.getInstalled(void 0,T.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(T,async(X,W)=>{const J=X.getDisabledExtensions();return q.map(H=>{const{identifier:B,isBuiltin:ie,manifest:re,preRelease:he,pinned:te,isApplicationScoped:V}=H,U={identifier:B,preRelease:he,version:re.version,pinned:!!te};V&&!(0,p.$Rm)(re)&&(U.isApplicationScoped=V),J.some(D=>(0,h.$rp)(D,B))&&(U.disabled=!0),ie||(U.installed=!0);try{const D=W.getKeysForSync({id:B.id,version:re.version});if(D){const F=W.getExtensionState(H,!0)||{};U.state=Object.keys(F).reduce((z,x)=>(D.includes(x)&&(z[x]=F[x]),z),{})}}catch(D){this.g.info(`${(0,n.$aLb)("extensions",T)}: Error while parsing extension state`,(0,L.$0)(D))}return U})}),ignoredExtensions:Y}}async updateLocalExtensions(T,q,Y,G,X){const W=(0,n.$aLb)("extensions",X),J=[],H=new Map,B=[],ie=[],re=await this.a.getInstalled(void 0,X.extensionsResource);if((T.length||Y.length)&&await this.j(X,async(V,U)=>{await A.Promises.settled([...T,...Y].map(async D=>{const F=re.find(K=>(0,h.$rp)(K.identifier,D.identifier));if(F&&F.isBuiltin){D.state&&F.manifest.version===D.version&&this.h(D.state,F,F.manifest.version,U),V.getDisabledExtensions().some(ee=>(0,h.$rp)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id),await V.disableExtension(D.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id),await V.enableExtension(D.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id))),B.push(D.identifier);return}const z=D.pinned?D.version:void 0,x=(await this.c.getExtensions([{...D.identifier,version:z,preRelease:z?void 0:D.preRelease}],N.CancellationToken.None))[0];if(D.state&&(F?F.manifest.version===D.version:x)&&this.h(D.state,F||x,F?.manifest.version,U),x)try{V.getDisabledExtensions().some(ee=>(0,h.$rp)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id,x.version),await V.disableExtension(x.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id,x.version)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id,x.version),await V.enableExtension(x.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id,x.version))),(!F||F.preRelease!==D.preRelease||F.pinned!==D.pinned||z&&F.manifest.version!==z)&&(await this.a.canInstall(x)?(J.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[w.$To]:!0,[w.$Uo]:!0}}}),H.set(x.identifier.id.toLowerCase(),D)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(D)))}catch(K){ie.push(D),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(D),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),q.length){const V=re.filter(({identifier:U,isBuiltin:D})=>!D&&q.some(F=>(0,h.$rp)(U,F)));await A.Promises.settled(V.map(async U=>{this.g.trace(`${W}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,U.identifier.id),B.push(U.identifier)}))}const he=await this.a.installGalleryExtensions(J);for(const{identifier:V,local:U,error:D,source:F}of he){const z=F;if(U)this.g.info(`${W}: Installed extension.`,V.id,z.version),B.push(V);else{const x=H.get(V.id.toLowerCase());x&&(ie.push(x),this.g.info(`${W}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),D instanceof w.$4o&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):D&&this.g.error(D)}}const te=[];for(const V of G)B.some(U=>(0,h.$rp)(U,V.identifier))||te.push(V);for(const V of ie)te.some(U=>(0,h.$rp)(U.identifier,V.identifier))||te.push(V);return te}h(T,q,Y,G){const X=G.getExtensionState(q,!0)||{},W=Y?G.getKeysForSync({id:q.identifier.id,version:Y}):void 0;W?W.forEach(J=>{X[J]=T[J]}):Object.keys(T).forEach(J=>X[J]=T[J]),G.setExtensionState(q,X,!0)}async j(T,q){return this.b.withProfileScopedStorageService(T,async Y=>{const G=new I.$Uc,X=this.f.createChild(new u.$ri([d.$Xp,Y])),W=G.add(X.createInstance(y.$zJb)),J=G.add(X.createInstance(c.$Wv));try{return await q(W,J)}finally{G.dispose()}})}};e.$v$b=C,e.$v$b=C=Ee([Z(0,w.$6o),Z(1,a.$dKb),Z(2,w.$3o),Z(3,i.$ZLb),Z(4,l.$si),Z(5,o.$vAb)],C);let R=class extends n.$eLb{constructor(T,q,Y,G,X,W,J,H){super("extensions",G,X,W,Y,J,H),this.p=T,this.q=q}async t(T){return T.syncData?await b(T.syncData,this.p):null}u(T,q){const Y=[],G=[],X=[];for(const W of T){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const J=q.find(H=>(0,h.$rp)(H.identifier,W.identifier));J?(Y.push(J),W.disabled&&X.push(W.identifier)):W.installed&&(G.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&X.push(W.identifier))}return{installedExtensions:Y,newExtensions:G,disabledExtensions:X,remoteExtensions:T}}};e.$w$b=R,e.$w$b=R=Ee([Z(0,w.$6o),Z(1,i.$ZLb),Z(2,g.$Zk),Z(3,r.$zl),Z(4,E.$Ai),Z(5,m.$Zj),Z(6,d.$Xp),Z(7,t.$xl)],R)}),define(ae[116],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kLb=e.$jLb=e.$iLb=e.$hLb=void 0,e.$gLb=i;const n="globalState.argv.",s=["locale"];function i(k,C){const R=k.storage?Object.keys(k.storage).sort():[],M={};return R.forEach(T=>M[T]=k.storage[T]),k.storage=M,C?(0,O.$Rn)(k,{}):JSON.stringify(k)}const o=1;let a=class extends l.$bLb{constructor(C,R,M,T,q,Y,G,X,W,J,H,B,ie,re){super({syncResource:"globalState",profile:C},R,T,X,B,q,Y,W,J,G,H,ie),this.Bb=M,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$xAb,authority:"base"}),this.xb=this.vb.with({scheme:d.$xAb,authority:"local"}),this.yb=this.vb.with({scheme:d.$xAb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$xAb,authority:"accepted"}),this.Ab=re.createInstance(b),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(T.onDidFilesChange,he=>he.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,he=>!!(he.targetChanges.some(te=>this.syncResource.profile.id===te.id)||he.valueChanges.some(({profile:te,changes:V})=>this.syncResource.profile.id===te.id&&V.some(U=>U.target===0)))))(()=>this.Q()))}async qb(C,R,M){const T=C.syncData?JSON.parse(C.syncData.content):null;R=R===null&&M?C:R;const q=R&&R.syncData?JSON.parse(R.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Jb(q),{local:X,remote:W}=(0,m.$fLb)(Y.storage,T?T.storage:null,q?q.storage:null,G,this.O),J={content:null,local:X,remote:W,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=i(Y,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):H,localResource:this.xb,localContent:H,localUserData:Y,remoteResource:this.yb,remoteContent:T?i(T,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:G}]}async ub(C){const R=C.syncData?JSON.parse(C.syncData.content):null;if(R===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(R),{remote:q}=(0,m.$fLb)(M.storage,R.storage,R.storage,T,this.O);return q.all!==null}async rb(C,R){return{...C.previewResult,hasConflicts:!1}}async sb(C,R,M,T){if(this.h.isEqual(R,this.xb))return this.Gb(C);if(this.h.isEqual(R,this.yb))return this.Hb(C);if(this.h.isEqual(R,this.vb))return C.previewResult;throw new Error(`Invalid Resource: ${R.toString()}`)}async Gb(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(C.localUserData.storage),removed:[],updated:[],all:C.localUserData.storage},localChange:0,remoteChange:2}}async Hb(C){if(C.remoteContent!==null){const R=JSON.parse(C.remoteContent),{local:M,remote:T}=(0,m.$fLb)(C.localUserData.storage,R.storage,null,C.storageKeys,this.O);return{content:C.remoteContent,local:M,remote:T,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(C,R,M,T){const{localUserData:q}=M[0][0],{local:Y,remote:G,localChange:X,remoteChange:W}=M[0][1];if(X===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),X!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:G.all});C=await this.mb(J,T?null:C.ref),this.O.info(`${this.D}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}R?.ref!==C.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(C),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(C){if(this.h.isEqual(this.yb,C)||this.h.isEqual(this.wb,C)||this.h.isEqual(this.xb,C)||this.h.isEqual(this.zb,C)){const R=await this.db(C);return R&&i(JSON.parse(R),!0)}return null}async hasLocalData(){try{const{storage:C}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(C).length>1||C[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(C){const R=await this.Bb.readStorageData(this.syncResource.profile),M=[],T=[];for(const[G,X]of R)X.target===0?M.push(G):X.target===1&&T.push(G);const q=[...M,...T],Y=C?.storage?Object.keys(C.storage).filter(G=>!G.startsWith(n)&&!q.includes(G)&&R.get(G)!==void 0):[];if(!I.$o){const G=[...d.$cAb.map(X=>(0,d.$pAb)(X)),d.$oAb];Y.push(...G),T.push(...G)}return{user:M,machine:T,unregistered:Y}}};e.$hLb=a,e.$hLb=a=Ee([Z(2,t.$dKb),Z(3,y.$Zk),Z(4,d.$gAb),Z(5,d.$hAb),Z(6,d.$vAb),Z(7,E.$Ai),Z(8,d.$qAb),Z(9,p.$Yl),Z(10,f.$Zi),Z(11,c.$Xp),Z(12,g.$xl),Z(13,r.$si)],a);let b=class{constructor(C,R,M,T){this.a=C,this.b=R,this.c=M,this.d=T}async getLocalGlobalState(C){const R={};if(C.isDefault){const T=await this.f(),q=(0,j.$Gn)(T);for(const Y of s)q[Y]!==void 0&&(R[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(C);for(const[T,q]of M)q.value&&q.target===0&&(R[T]={version:1,value:q.value});return{storage:R}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const C=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),C.value.toString()}catch(C){this.d.debug((0,N.$0)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:R,updated:M},T){const q=(0,l.$aLb)("globalState",T),Y={},G=new Map,X=await this.c.readStorageData(T),W=(J,H)=>{for(const B of J){if(B.startsWith(n)){Y[B.substring(n.length)]=H?H[B].value:void 0;continue}if(H){const ie=H[B];ie.value!==X.get(B)?.value&&G.set(B,ie.value)}else X.get(B)!==void 0&&G.set(B,void 0)}};if(W(Object.keys(C),C),W(Object.keys(M),M),W(R),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const J=await this.f();let H=J;for(const B of Object.keys(Y))H=(0,u.edit)(H,[B],Y[B],{});J!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,A.$De.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}G.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(T,G,0),this.d.info(`${q}: Updated global state`,[...G.keys()]))}};e.$iLb=b,e.$iLb=b=Ee([Z(0,y.$Zk),Z(1,E.$Ai),Z(2,t.$dKb),Z(3,d.$vAb)],b);let S=class extends l.$eLb{constructor(C,R,M,T,q,Y){super("globalState",M,T,q,R,C,Y)}async o(C){const R=C.syncData?JSON.parse(C.syncData.content):null;if(!R){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},T={};for(const q of Object.keys(R.storage))q.startsWith(n)?M[q.substring(n.length)]=R.storage[q].value:this.l.get(q,0)===void 0&&(T[q]=R.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,u.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,A.$De.fromString(q))}if(Object.keys(T).length){const q=[];for(const Y of Object.keys(T))q.push({key:Y,value:T[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$jLb=S,e.$jLb=S=Ee([Z(0,c.$Xp),Z(1,y.$Zk),Z(2,$.$zl),Z(3,E.$Ai),Z(4,d.$vAb),Z(5,g.$xl)],S);let v=class{constructor(C,R,M,T,q){this.a=C,this.b=R,this.c=M,this.d=T,this.f=q}getSyncStoreType(C){return this.h(C)?.storage[d.$oAb]?.value}async sync(C){const R=(0,d.$kAb)((0,P.$Pg)());try{return await this.g(C,R)}catch(M){if(M instanceof d.$lAb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(C,R)}throw M}}async g(C,R){const M=await this.a.readResource("globalState",null,void 0,R),T=this.h(M)||{storage:{}};T.storage[d.$oAb]={value:C,version:o};const q=await(0,h.$4p)(this.c,this.d,this.b),Y={version:o,machineId:q,content:i(T,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,R)}h({content:C}){if(!C)return null;const R=JSON.parse(C);if((0,l.$_Kb)(R))return R?JSON.parse(R.content):null;throw new Error("Invalid remote data")}};e.$kLb=v,e.$kLb=v=Ee([Z(1,c.$Xp),Z(2,E.$Ai),Z(3,y.$Zk),Z(4,w.$Zj)],v)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=void 0,e.$y$b=m;function m(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,I.$ag)(s.all)?null:s.all;switch(O.OS){case 2:return(0,I.$ag)(s.mac)?null:s.mac;case 3:return(0,I.$ag)(s.linux)?null:s.linux;case 1:return(0,I.$ag)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let d=class extends g.$dLb{constructor(r,n,s,i,o,a,b,S,v,k,C,R,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,S,v,k,s,i,b,R,o,C,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$xAb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$xAb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$xAb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$xAb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,n,s,i){const o=r.syncData?m(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?r:n;const a=n?this.Ob(n):null,b=await this.vb(),S=await this.Cb();let v=null,k=!1,C=!1,R=!1;if(o){let q=b?b.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$lAb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$x$b)(q,o,a,S,this.zb);Y.hasChanges&&(v=Y.mergeContent,R=Y.hasConflicts,k=R||Y.mergeContent!==q,C=R||Y.mergeContent!==o)}}else b&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=b.value.toString(),C=!0);const M={content:R?a:v,localChange:k?b?2:1:0,remoteChange:C?2:0,hasConflicts:R},T=b?b.value.toString():null;return[{fileContent:b,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:M.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(r){const n=this.Ob(r);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",o=await this.Cb(),a=await(0,l.$x$b)(i||"[]",n,n,o,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(r,n){return r.previewResult}async sb(r,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:b,remoteChange:S}=s[0][1];if(b===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$lAb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(b!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const v=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(v,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const n=(0,j.$Gn)(r.value.toString());if((0,A.$Lb)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:m(r.syncData.content,this.Qb(),this.O)}Pb(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=r,O.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$_zb)}};e.$z$b=d,e.$z$b=d=Ee([Z(2,u.$gAb),Z(3,u.$hAb),Z(4,u.$vAb),Z(5,f.$Zi),Z(6,u.$qAb),Z(7,y.$Zk),Z(8,E.$Ai),Z(9,w.$Xp),Z(10,u.$uAb),Z(11,h.$Yl),Z(12,c.$xl)],d);let $=class extends g.$eLb{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async o(r){const n=r.syncData?this.p(r.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$De.fromString(n)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$Gn)(r.value.toString());return!(0,A.$Lb)(n)}catch(r){return r.fileOperationResult===1}}p(r){try{return m(r,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$A$b=$,e.$A$b=$=Ee([Z(0,y.$Zk),Z(1,p.$zl),Z(2,E.$Ai),Z(3,u.$vAb),Z(4,w.$Xp),Z(5,c.$xl)],$)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=void 0,e.$B$b=u;function l($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function u($){const t=JSON.parse($);return l(t)?t:{settings:$}}let m=class extends c.$dLb{constructor(t,r,n,s,i,o,a,b,S,v,k,C,R,M){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,k,C,b,S,v,M),this.Eb=R,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.$xAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$xAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$xAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$xAb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.X(t,r),s=this.Lb(n),i=new O.$vo(g.$$zb,this.O);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(g.$$zb)||{}}async qb(t,r,n){const s=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&n?t:r;const a=r?this.Lb(r):null,b=await this.Pb();let S=null,v=!1,k=!1,C=!1;if(o){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$WJb)(q,o.settings,a?a.settings:null,b,[],i);S=Y.localContent||Y.remoteContent,v=Y.localContent!==null,k=Y.remoteContent!==null,C=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=s.value.toString().trim()||"{}",this.Qb(S),k=!0);const R=s?s.value.toString():null,M=a?.settings??null,T={content:C?M:S,localChange:v?2:0,remoteChange:k?2:0,hasConflicts:C};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:R,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,p.$WJb)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$VJb)(t.previewResult.content,"{}",s,n):null}}async sb(t,r,n,s){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.$VJb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$VJb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.$VJb)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:b}=n[0][1];if(a===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),b!==0){const S=await this.Cb(),v=this.Lb(t),k=await this.Pb(o);o=(0,p.$VJb)(o,v?v.settings:"{}",k,S),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$XJb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const n=await this.Cb(),s=await this.Pb();r=(0,p.$VJb)(r,"{}",s,n)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,p.$TJb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new g.$lAb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$C$b=m,e.$C$b=m=Ee([Z(2,f.$Zk),Z(3,I.$Ai),Z(4,E.$Xp),Z(5,g.$gAb),Z(6,g.$hAb),Z(7,g.$vAb),Z(8,g.$uAb),Z(9,j.$Zi),Z(10,g.$qAb),Z(11,y.$Yl),Z(12,P.$6o),Z(13,w.$xl)],m);let d=class extends c.$eLb{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,A.$De.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$XJb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$D$b=d,e.$D$b=d=Ee([Z(0,f.$Zk),Z(1,h.$zl),Z(2,I.$Ai),Z(3,g.$vAb),Z(4,E.$Xp),Z(5,w.$xl)],d)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=void 0,e.$G$b=p;function p(u){return JSON.parse(u.content)}let g=class extends w.$bLb{constructor(m,d,$,t,r,n,s,i,o,a,b,S){super({syncResource:"snippets",profile:m},d,t,$,r,n,s,a,b,i,o,S),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,v=>v.affects(this.vb))(()=>this.Q()))}async qb(m,d,$){const t=await this.Hb(),r=this.Gb(t),n=m.syncData?this.Fb(m.syncData):null;d=d===null&&$?m:d;const s=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$E$b)(r,n,s);return this.Bb(i,t,n||{},s||{})}async ub(m){const d=m.syncData?this.Fb(m.syncData):null;if(d===null)return!0;const $=await this.Hb(),t=this.Gb($),r=(0,h.$E$b)(t,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(m,d){return m.previewResult}async sb(m,d,$,t){if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$xAb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$xAb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return $===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:$,localChange:$===null?m.fileContent!==null?3:0:2,remoteChange:$===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(m,d,$,t){const r=$.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.Eb(r,m,t)),d?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.G.del(n)}catch{}}Bb(m,d,$,t){const r=new Map;for(const n of Object.keys(m.local.added)){const s={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const s={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const s={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const s={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of m.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:$[n]?2:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}for(const n of Object.keys(d))if(!r.has(n)){const s={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$xAb,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:c.$xAb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$xAb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$xAb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$xAb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const d={};for(const $ of m)$.fileContent&&(d[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(m,d){for(const{fileContent:$,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.h.basename(n):this.h.basename(r),o=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,A.$De.fromString(t.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,A.$De.fromString(t.content),d?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(m,d,$){const t=d.syncData?this.Fb(d.syncData):{},r=(0,L.$Zn)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of m)if(o!==0){const a=s?this.h.basename(s):this.h.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,h.$F$b)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(r),$?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(m){return p(m)}Gb(m){const d={};for(const $ of Object.keys(m))d[$]=m[$].value.toString();return d}async Hb(){const m={};let d;try{d=await this.G.resolve(this.vb)}catch($){if($ instanceof I.$il&&$.fileOperationResult===1)return m;throw $}for(const $ of d.children||[]){const t=$.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);m[n]=s}}return m}};e.$H$b=g,e.$H$b=g=Ee([Z(2,O.$Ai),Z(3,I.$Zk),Z(4,P.$Xp),Z(5,c.$gAb),Z(6,c.$hAb),Z(7,c.$vAb),Z(8,j.$Zi),Z(9,c.$qAb),Z(10,f.$Yl),Z(11,E.$xl)],g);let l=class extends w.$eLb{constructor(m,d,$,t,r,n){super("snippets",d,$,t,m,r,n)}async o(m){const d=m.syncData?JSON.parse(m.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const r=d[t];if(r){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,A.$De.fromString(r)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$I$b=l,e.$I$b=l=Ee([Z(0,I.$Zk),Z(1,y.$zl),Z(2,O.$Ai),Z(3,c.$vAb),Z(4,P.$Xp),Z(5,E.$xl)],l)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=e.$K$b=void 0,e.$J$b=w;function w(g,l){try{return JSON.parse(g).tasks??null}catch(u){return l.error(u),null}}let h=class extends E.$cLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,m,d,r,o,$,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:y.$xAb,authority:"base"}),this.Cb=this.Ab.with({scheme:y.$xAb,authority:"local"}),this.Db=this.Ab.with({scheme:y.$xAb,authority:"remote"}),this.Eb=this.Ab.with({scheme:y.$xAb,authority:"accepted"})}async qb(l,u,m,d){const $=l.syncData?w(l.syncData.content,this.O):null;u=u===null&&m?l:u;const t=u?.syncData?w(u.syncData.content,this.O):null,r=await this.vb();let n=null,s=!1,i=!1,o=!1;if(l.syncData){const S=r?r.value.toString():null;if(!t||t!==S||t!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const v=p(S,$,t);n=v.content,o=v.hasConflicts,s=v.hasLocalChanged,i=v.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},b=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:b,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?w(l.syncData.content,this.O):null;if(u===null)return!0;const m=await this.vb(),d=m?m.value.toString():null,$=p(d,u,u);return $.hasLocalChanged||$.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,m,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,m,d){const{fileContent:$}=m[0][0],{content:t,localChange:r,remoteChange:n}=m[0][1];if(r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),t?await this.wb(t,$,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));l=await this.mb(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$K$b=h,e.$K$b=h=Ee([Z(2,y.$gAb),Z(3,y.$hAb),Z(4,y.$vAb),Z(5,N.$Zi),Z(6,y.$qAb),Z(7,j.$Zk),Z(8,L.$Ai),Z(9,O.$Xp),Z(10,I.$Yl),Z(11,P.$xl)],h);let c=class extends E.$eLb{constructor(l,u,m,d,$,t){super("tasks",u,m,d,l,$,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?w(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,A.$De.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$L$b=c,e.$L$b=c=Ee([Z(0,j.$Zk),Z(1,f.$zl),Z(2,L.$Ai),Z(3,y.$vAb),Z(4,O.$Xp),Z(5,P.$xl)],c);function p(g,l,u){if(g===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=u!==g,d=u!==l;return!m&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!d?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0,e.$tac=c,e.$uac=p;let h=class extends E.$bLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a,b){super({syncResource:"profiles",profile:l},u,d,$,t,r,n,o,a,s,i,b),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$xAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$xAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$xAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$xAb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),m=await this.X(l,u);return m?.syncData?p(m.syncData):null}async qb(l,u,m){if(!this.vb.isEnabled())throw new w.$lAb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,$=u?.syncData?p(u.syncData):null,t=this.Db(),{local:r,remote:n}=(0,y.$rac)(t,d,$,[]),s={local:r,remote:n,content:$?this.Eb($):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,m=this.Db(),{remote:d}=(0,y.$rac)(m,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,m,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),m=(0,y.$rac)(u,null,null,[]),{local:d,remote:$}=m;return{content:l.localContent,local:d,remote:$,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],d=[];for(const $ of this.Db()){const t=u?.find(r=>r.id===$.id);t&&(m.push({id:$.id,name:$.name,collection:t.collection}),d.push($))}if(u!==null){const $=(0,y.$rac)(d,u,m,[]),{local:t,remote:r}=$;return{content:l.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,m,d){const{local:$,remote:t,localChange:r,remoteChange:n}=m[0][1];r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new w.$lAb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all($.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all($.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all($.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const b=await this.J.createCollection(this.F);i.push(b),s.push({id:a.id,name:a.name,collection:b,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:b})=>a.id===b),1);for(const a of t?.updated||[]){const b=s.find(({id:S})=>a.id===S);b&&s.splice(s.indexOf(b),1,{...b,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const b of i)await this.J.deleteCollection(b,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,A.$Rn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,m)=>u.name.localeCompare(m.name)))}};e.$sac=h,e.$sac=h=Ee([Z(2,f.$zl),Z(3,j.$Zk),Z(4,L.$Ai),Z(5,O.$Xp),Z(6,w.$gAb),Z(7,w.$hAb),Z(8,w.$vAb),Z(9,N.$Zi),Z(10,w.$qAb),Z(11,I.$Yl),Z(12,P.$xl)],h);function c(g,l){const u=[...g].sort((m,d)=>m.name.localeCompare(d.name)).map(m=>({id:m.id,name:m.name}));return l?(0,A.$Rn)(u,{}):JSON.stringify(u)}function p(g){return JSON.parse(g.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=void 0;const f="sync.enable";let E=class extends N.$Vc{constructor(w,h,c,p){super(),this.c=w,this.f=h,this.g=c,this.h=p,this.a=new A.$ce,this.onDidChangeEnablement=this.a.event,this.b=new A.$ce,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new N.$Uc))(g=>this.m(g)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(f,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(f,{enabled:w}),this.c.store(f,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,P.$pAb)(w),-1,!0)}setResourceEnablement(w,h){if(this.isResourceEnabled(w)!==h){const c=(0,P.$pAb)(w);this.j(c,h)}}getResourceSyncStateVersion(w){}j(w,h){this.c.store(w,h,-1,L.$o?0:1)}m(w){if(f===w.key){this.a.fire(this.isEnabled());return}const h=P.$cAb.filter(c=>(0,P.$pAb)(c)===w.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$fac=E,e.$fac=E=Ee([Z(0,O.$Xp),Z(1,I.$Yl),Z(2,j.$Ai),Z(3,P.$fAb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;let w=class extends j.$Vc{constructor(c,p,g,l,u){super(),this.a=c,this.b=p,this.c=g,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const g of y.$cAb)try{await this.m(this.j(g,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,f.$el)(p)!==1&&this.f.error(p);return}if(c.children){for(const p of c.children)if(p.isDirectory&&!this.g.profiles.some(g=>g.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(g){this.f.error(g)}}}async getAllResourceRefs(c,p,g){const l=this.j(c,p,g);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,f.$el)(u)!==1)throw u}return[]}async resolveResourceContent(c,p,g,l){const u=this.j(c,g,l),m=(0,O.$7g)(u,p);try{return(await this.b.readFile(m)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(c,p,g,l,u){const m=this.j(c,l,u),d=(0,O.$7g)(m,`${(0,L.$1m)(g).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$De.fromString(p))}catch($){this.f.error($)}}j(c,p,g=this.a.userDataSyncHome){return(0,O.$7g)(g,...p?[p,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const p=await this.b.resolve(c);if(p.children){const g=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=g.filter(d=>Date.now()-this.n(d)>l);const m=g.length-u.length;m<10&&(u=u.slice(10-m)),await A.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$qac=w,e.$qac=w=Ee([Z(0,P.$Ai),Z(1,f.$Zk),Z(2,I.$Zi),Z(3,y.$vAb),Z(4,E.$zl)],w)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$8zb=e.$6zb=void 0,e.$7zb=$,e.$6zb=(0,f.$ti)("IUserDataSyncMachinesService");const p="sync.currentMachineName",g="Safari",l="Chrome",u="Edge",m="Firefox",d="Android";function $(n){switch(n){case g:case l:case u:case m:case d:case(0,L.$h)(0):return!0}return!1}function t(){return L.$G?g:L.$E?l:L.$H?u:L.$F?m:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let r=class extends N.$Vc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(s,i,o,a,b,S){super(),this.h=o,this.j=a,this.m=b,this.n=S,this.c=this.B(new A.$ce),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$4p)(s,i,o)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,o=await this.s(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(s){const i=await this.f,o=await this.s(s),a=o.machines.filter(({id:b})=>b!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(s,i,o){const a=await this.s(o),b=a.machines.find(({id:S})=>S===s);if(b){b.name=i,await this.t(a);const S=await this.f;s===S&&this.h.store(p,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[o,a]of s){const b=i.machines.find(S=>S.id===o);b&&(b.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(p,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$0e)(o)}\\s#(\\d+)`);let b=0;for(const S of s){const v=a.exec(S.name),k=v?parseInt(v[1]):0;b=k>b?k:b}return`${o} #${b+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$8zb=r,e.$8zb=r=c=Ee([Z(0,I.$Ai),Z(1,P.$Zk),Z(2,w.$Xp),Z(3,h.$gAb),Z(4,h.$vAb),Z(5,E.$gk)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;const u="sync.disableMachineEventually",m="sync.sessionId",d="sync.storeUrl",$="sync.productQuality";let t=class extends I.$Vc{get n(){const s=this.H.get(d,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(d,s.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,i,o,a,b,S,v,k,C,R){super(),this.u=i,this.w=o,this.y=a,this.z=b,this.C=S,this.D=v,this.F=k,this.G=C,this.H=R,this.a=this.B(new I.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$ce),this.onError=this.h.event,this.S=[],this.f=this.B(new A.$rh(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,f.$Zg)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(v.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(b.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$1m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=p.$lAb.toUserDataSyncError(s);i instanceof p.$nAb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,A.$uh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$wac=t,e.$wac=t=Ee([Z(0,w.$gk),Z(1,p.$fAb),Z(2,p.$gAb),Z(3,p.$qAb),Z(4,p.$rAb),Z(5,p.$vAb),Z(6,g.$BJb),Z(7,c.$Yl),Z(8,l.$6zb),Z(9,h.$Xp)],t);class r extends I.$Vc{static{this.a="Interval"}constructor(s,i,o,a,b,S,v,k,C){super(),this.m=s,this.n=i,this.r=o,this.s=a,this.u=b,this.w=S,this.y=v,this.z=k,this.C=C,this.b=this.B(new I.$Wc),this.c=this.B(new O.$ce),this.onDidStartSync=this.c.event,this.f=this.B(new O.$ce),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,A.$vh)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(s,i){const o=(0,A.$gh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(b){if((0,j.$4)(b))return}return this.H(s,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,f.$Zg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,f.$Zg)(i.defaultUrl,s.defaultUrl)||!(0,f.$Zg)(i.insidersUrl,s.insidersUrl)||!(0,f.$Zg)(i.stableUrl,s.stableUrl))}async H(s,i,o){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,o)}catch(b){if(this.y.error(b),a=b,p.$lAb.toUserDataSyncError(b).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$nAb((0,y.localize)(0,null),"DefaultServiceChanged"):new p.$nAb((0,y.localize)(1,null),"ServiceChanged"):new p.$nAb((0,y.localize)(2,null),"TurnedOff");const o=this.C.get(m,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new p.$nAb((0,y.localize)(3,null),"DefaultServiceChanged"):new p.$nAb((0,y.localize)(4,null),"ServiceChanged"):new p.$nAb((0,y.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const b=a.find(v=>v.isCurrent);if(b?.disabled)throw new p.$nAb((0,y.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(v){throw new p.$nAb((0,L.$ej)(v),v instanceof p.$lAb?v.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(m,this.g.session,-1,1),!i.isCancellationRequested&&(b||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,44,27]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;let n=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,b,S,v,k,C,R,M){this.e=i,this.f=o,this.g=a,this.h=S,this.i=v,this.j=k,this.k=C,this.l=R,this.n=M,this.d=b.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,d.$uac)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const b=this.L(a,"profiles");return(0,d.$uac)(b)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:b,ref:S})=>({created:b,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:S,ref:v})=>({created:S,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:v,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(b=>b.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(b=>b.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,O.$4p)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,b,S){if(i){const{content:v}=await this.M(o,b,a);return v}return this.f.resolveResourceContent(o,b,a,S)}q(i,o,a){const b=this.L(o,i);switch(i){case"settings":return this.t(b,a);case"keybindings":return this.v(b,a);case"tasks":return this.x(b,a);case"snippets":return this.z(b,a);case"globalState":return this.E(b,a);case"extensions":return this.B(b,a);case"profiles":return this.H(b,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(b=>b.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),b=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}t(i,o){switch(o){case"settings.json":return(0,h.$B$b)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),b=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$y$b)(i.content,!!this.l.getValue(f.$_zb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),b=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}x(i,o){switch(o){case"tasks.json":return(0,g.$J$b)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const b=this.L(a,"snippets");if(b){const S=(0,w.$G$b)(b),v=[];for(const k of Object.keys(S)){const C=this.d.joinPath(i,k),R=o?this.d.joinPath(o.snippetsHome,k):this.d.joinPath(i,r.a);v.push({resource:C,comparableResource:R})}return v}}return[]}z(i,o){return(0,w.$G$b)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),b=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}B(i,o){switch(o){case"extensions.json":return(0,l.$t$b)((0,l.$s$b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(l.$v$b).getLocalExtensions(i);return(0,l.$t$b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),b=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}E(i,o){switch(o){case"globalState.json":return(0,u.$gLb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$iLb).getLocalGlobalState(i);return(0,u.$gLb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),b=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:b}]}H(i,o){switch(o){case"profiles.json":return(0,$.$Rn)(JSON.parse(i.content),{})}return null}async I(i){return(0,d.$tac)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$bf)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(A.URI.from({scheme:f.$xAb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==f.$xAb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let b,S;const v=[];let k,C,R,M,T;for(;o.length;){const q=o.shift();q.startsWith("scheme:")?b=q.substring(7):q.startsWith("authority:")?S=q.substring(10):q.startsWith("syncResource:")?k=q.substring(13):q.startsWith("profile:")?C=q.substring(8):q.startsWith("collection:")?R=q.substring(11):q.startsWith("ref:")?M=q.substring(4):k?T=q:v.push(q)}return{remote:a,syncResource:k,profile:C,collection:R,ref:M,node:T,location:b&&S!==void 0?this.d.joinPath(A.URI.from({scheme:b,authority:S,query:i.query,fragment:i.fragment,path:"/"}),...v):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,y.$_Kb)(a))return a}catch(a){this.g.error(a)}throw new f.$lAb((0,N.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const b=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:b}}};e.$5ac=n,e.$5ac=n=r=Ee([Z(0,f.$gAb),Z(1,f.$hAb),Z(2,f.$vAb),Z(3,P.$xl),Z(4,L.$Ai),Z(5,I.$Xp),Z(6,j.$Zk),Z(7,E.$zl),Z(8,p.$Zi),Z(9,m.$si)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;const i="sync.lastSyncTime";let o=class extends I.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,C,R,M,T,q,Y,G,X,W,J){super(),this.C=k,this.D=C,this.F=R,this.G=M,this.H=T,this.I=q,this.J=Y,this.L=G,this.M=X,this.N=W,this.O=J,this.f="uninitialized",this.g=this.B(new O.$ce),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$ce),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$ce),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$ce),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$ce),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$ce),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$ce),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=R.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Tc)(()=>this.bb()))}async createSyncTask(k,C){this.cb(),this.H.info("Sync started.");const R=new Date().getTime(),M=(0,E.$Pg)();try{const G=(0,s.$kAb)(M);C&&(G["Cache-Control"]="no-cache"),k=await this.D.manifest(k,G)}catch(G){const X=s.$lAb.toUserDataSyncError(G);throw S(X,M,this.F,this.I),X}const T=!1,q=this;let Y;return{manifest:k,async run(){if(T)throw new Error("Can run a task only once");Y=(0,N.$gh)(G=>q.P(k,!1,M,G)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-R}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$lAb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),C=(0,E.$Pg)(),R=(0,s.$kAb)(C);let M;try{M=await this.D.manifest(null,R)}catch(Y){const G=s.$lAb.toUserDataSyncError(Y);throw S(G,C,this.F,this.I),G}await this.resetLocal();const T=this,q=new L.$ne;return{id:C,async merge(){return T.P(M,!0,C,q.token)},async apply(){try{try{await T.R(M,C,q.token)}catch(Y){if(s.$lAb.toUserDataSyncError(Y).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(M,C,q.token);else throw Y}}catch(Y){throw T.H.error(Y),Y}T.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),T.$()},async stop(){q.cancel(),await T.U(),await T.resetLocal()}}}async P(k,C,R,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,k,C,R,M));const q=T.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,k,C,R,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(k,C,R,M,T){for(const q of k){if(T.isCancellationRequested)return;const Y=this.M.profiles.find(X=>X.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const G=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(G,C,R,M,T))}for(const[q,Y]of this.z.entries())this.M.profiles.some(G=>G.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(k,C,R){const M=this.ab();for(const X of M){if(R.isCancellationRequested)return;await X.apply(C,R)}const T=M.find(X=>X.profile.isDefault);if(!T)return;const q=T.enabled.find(X=>X.resource==="profiles");if(!q)return;const G=(await q.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(X=>M.every(W=>W.profile.id!==X.id));G.length&&await this.Q(G,k,!1,C,R)}async S(k,C,R,M,T){return(await k.sync(C,R,M,T)).map(([Y,G])=>({profile:k.profile,syncResource:Y,error:G}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(k=>k.stop()))}async resolveContent(k){const C=await this.N.resolveContent(k);if(C)return C;for(const R of this.ab())for(const M of R.enabled){const T=await M.resolveContent(k);if(T)return T}return null}async replace(k){this.cb();const C=this.N.resolveUserDataSyncResource(k);if(!C)return;const R=await this.resolveContent(k.uri);R&&await this.W(C.profile,async M=>{if(C.syncResource===M.resource)return await M.replace(R),!0})}async accept(k,C,R,M){this.cb(),await this.W(k.profile,async T=>{if(k.syncResource===T.resource)return await T.accept(C,R),M&&await T.apply((0,f.$_f)(M)?!1:M.force,(0,s.$kAb)((0,E.$Pg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(C){this.H.error(C)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),C=k.map(q=>q.collection),R=await this.D.getAllCollections(),M=R.filter(q=>!C.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const T=k.filter(q=>R.includes(q.collection));if(T.length!==k.length){const q=this.G.createInstance(n.$sac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(k){this.cb();const C=await this.D.getActivityData();await this.C.writeFile(k,C)}async extractActivityData(k,C){const R=(await this.C.readFile(k)).value.toString(),M=JSON.parse(R);if(M.resources)for(const T in M.resources)for(const q of M.resources[T])await this.O.writeResource(T,q.content,new Date(q.created*1e3),void 0,C);if(M.collections)for(const T in M.collections)for(const q in M.collections[T].resources)for(const Y of M.collections[T].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),T,C)}async W(k,C){const R=new I.$Uc;try{const M=this.z.get(k.id);if(M){const X=await this.X(M[0],C,R);return(0,f.$ag)(X)?null:X}if(k.isDefault){const X=R.add(this.G.createInstance(a,k,void 0)),W=await this.X(X,C,R);return(0,f.$ag)(W)?null:W}if(this.M.isEnabled())return null;const T=R.add(this.G.createInstance(n.$sac,k,void 0)),q=await this.D.manifest(null),G=(await T.getRemoteSyncedProfiles(q?.latest??null)||[]).find(X=>X.id===k.id);if(G){const X=R.add(this.G.createInstance(a,k,G.collection)),W=await this.X(X,C,R);return(0,f.$ag)(W)?null:W}return null}finally{R.dispose()}}async X(k,C,R){const M=[...k.enabled,...k.disabled.reduce((T,q)=>(q!=="workspaceState"&&T.push(R.add(k.createSynchronizer(q))),T),[])];for(const T of M){const q=await C(T);if(!(0,f.$ag)(q))return q}}Y(k){const C=this.f;this.f!==k&&(this.f=k,this.g.fire(k),C==="hasConflicts"&&this.$())}Z(){const k=this.ab().map(C=>C.conflicts).flat();(0,A.$ub)(this.j,k,(C,R)=>C.profile.id===R.profile.id&&C.syncResource===R.syncResource&&(0,A.$ub)(C.conflicts,R.conflicts,(M,T)=>(0,P.$Zg)(M.previewResource,T.previewResource)))||(this.j=k,this.m.fire(k))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,C){let R=this.z.get(k.id);if(R&&R[0].collection!==C?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.z.delete(k.id)),!R){const M=new I.$Uc,T=M.add(this.G.createInstance(a,k,C?.collection));M.add(T.onDidChangeStatus(q=>this.Y(q))),M.add(T.onDidChangeConflicts(q=>this.Z())),M.add(T.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(k.id,R=[T,M])}return R[0]}ab(){const k=[];for(const[C]of this.z.values())k.push(C);return k}bb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$vac=o,e.$vac=o=Ee([Z(0,h.$Zk),Z(1,s.$gAb),Z(2,s.$fAb),Z(3,c.$si),Z(4,s.$vAb),Z(5,g.$Yl),Z(6,p.$Xp),Z(7,s.$qAb),Z(8,l.$zl),Z(9,s.$sAb),Z(10,s.$hAb)],o);let a=class extends I.$Vc{get enabled(){return this.f.sort((k,C)=>k[1]-C[1]).map(([k])=>k)}get disabled(){return s.$cAb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,C,R,M,T,q,Y,G,X,W){super(),this.profile=k,this.collection=C,this.r=R,this.t=M,this.u=T,this.w=q,this.y=Y,this.z=G,this.C=X,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$ce),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$ce),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$ce),this.onDidChangeConflicts=this.n.event,this.B(R.onDidChangeResourceEnablement(([J,H])=>this.F(J,H))),this.B((0,I.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$cAb)R.isResourceEnabled(J)&&this.G(J)}F(k,C){C?this.G(k):this.H(k)}G(k){if(this.f.some(([T])=>T.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const C=new I.$Uc,R=C.add(this.createSynchronizer(k));C.add(R.onDidChangeStatus(()=>this.L())),C.add(R.onDidChangeConflicts(()=>this.M())),C.add(R.onDidChangeLocal(()=>this.j.fire(k)));const M=this.N(k);this.f.push([R,M,C])}H(k){const C=this.f.findIndex(([R])=>R.resource===k);if(C!==-1){const[[R,,M]]=this.f.splice(C,1);M.dispose(),this.L(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance($.$C$b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$z$b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$H$b,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$K$b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$hLb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$u$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$sac,this.profile,this.collection)}}async sync(k,C,R,M){if(M.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const q=[],Y=(0,s.$kAb)(R),G=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,X=C?await this.I(G):{};for(const W of T){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(C){const J=await W.preview(G,X,Y);if(J)for(const H of J.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(G,Y)}catch(J){const H=s.$lAb.toUserDataSyncError(J);if(S(H,R,this.w,this.y),b(J))throw H;this.z.error(J),this.z.error(`${W.resource}: ${(0,j.$ej)(J)}`),q.push([W.resource,H])}}return q}finally{this.L()}}async apply(k,C){const R=(0,s.$kAb)(k);for(const M of this.enabled){if(C.isCancellationRequested)return;try{await M.apply(!1,R)}catch(T){const q=s.$lAb.toUserDataSyncError(T);if(S(q,k,this.w,this.y),b(T))throw q;this.z.error(T),this.z.error(`${M.resource}: ${(0,j.$ej)(T)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(C){this.z.error(C)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(C){this.z.error(`${k.resource}: ${(0,j.$ej)(C)}`),this.z.error(C)}}async I(k){if(!this.profile.isDefault)return{};const C=this.D.getValue(s.$$zb),R=this.enabled.find(M=>M instanceof $.$C$b);if(R){const M=await R.getRemoteUserDataSyncConfiguration(k);return{...C,...M}}return C}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,A.$ub)(this.m,k,(C,R)=>C.syncResource===R.syncResource&&(0,A.$ub)(C.conflicts,R.conflicts,(M,T)=>(0,P.$Zg)(M.previewResource,T.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([Z(2,s.$qAb),Z(3,c.$si),Z(4,w.$3o),Z(5,s.$fAb),Z(6,g.$Yl),Z(7,s.$vAb),Z(8,l.$zl),Z(9,y.$Zi)],a);function b(v){if(v instanceof s.$lAb)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(v,k,C,R){R.publicLog2("sync/error",{code:v.code,serverCode:v instanceof s.$mAb?String(v.serverCode):void 0,url:v instanceof s.$mAb?v.url:void 0,resource:v.resource,executionId:k,service:C.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0;function I(w,h){return{...w,profile:(0,j.$Al)(w.profile,h.profilesHome.scheme)}}function P(w){return{created:w.created,uri:L.URI.revive(w.uri)}}class f{constructor(h,c,p){this.c=h,this.d=c,this.f=p,this.a=new Map,this.b=new A.$ce}listen(h,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(h,c,p){try{return await this.g(h,c,p)}catch(g){throw this.f.error(g),g}}async g(h,c,p){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(P(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const g=c.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),g){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const c=this.a.get(this.j(h));if(!c)throw new Error(`Manual sync taks not found: ${h}`);return c}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$Pdc=f;let E=class extends N.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new A.$ce),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new A.$ce),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new A.$ce),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new A.$ce),this.onSyncErrors=this.m.event,this.a={call(p,g,l){return h.call(p,g,l).then(null,u=>{throw O.$lAb.toUserDataSyncError(u)})},listen(p,g){return h.listen(p,g)}},this.a.call("_getInitialData").then(([p,g,l])=>{this.s(p),this.t(g),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(g=>({...g,error:O.$lAb.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),c=this;return new y(h,{async call(g,l,u){return c.a.call(`manualSync/${g}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,c,p,g){return this.a.call("accept",[h,c,p,g])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,c){return this.a.call("extractActivityData",[h,c])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(c=>({syncResource:c.syncResource,profile:(0,j.$Al)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$Qdc=E,e.$Qdc=E=Ee([Z(1,j.$zl)],E);class y extends N.$Vc{constructor(h,c){super(),this.id=h,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Kb=e.$9Kb=e.$8Kb=e.$7Kb=e.$6Kb=void 0;const $="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends O.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$oAb,-1)}set c(R){this.h.store(d.$oAb,R,-1,P.$o?0:1)}constructor(R,M,T){super(),this.f=R,this.g=M,this.h=T,this.a=this.B(new j.$ce),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Uc);this.B(j.Event.filter(T.onDidChangeValue(-1,d.$oAb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(R){if(R&&(R=P.$o&&R.web?{...R,...R.web}:R,(0,E.$6f)(R.url)&&(0,E.$8f)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(M=>Array.isArray(R.authenticationProviders[M].scopes)))){const M=R,T=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(T?this.c:void 0)||q,G=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:y.URI.parse(G),type:Y,defaultType:q,defaultUrl:y.URI.parse(M.url),stableUrl:y.URI.parse(M.stableUrl),insidersUrl:y.URI.parse(M.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(M.authenticationProviders).reduce((X,W)=>(X.push({id:W,scopes:M.authenticationProviders[W].scopes}),X),[])}}}};e.$6Kb=a,e.$6Kb=a=Ee([Z(0,g.$gk),Z(1,h.$Zi),Z(2,m.$Xp)],a);let b=class extends a{constructor(R,M,T){super(R,M,T);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const Y=this.f[$];Y?this.h.store(t,JSON.stringify(Y),-1,1):this.h.remove(t,-1)}async switch(R){R!==this.c&&(this.c=R,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$7Kb=b,e.$7Kb=b=Ee([Z(0,g.$gk),Z(1,h.$Zi),Z(2,m.$Xp)],b);let S=class extends O.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(R,M,T,q,Y,G,X){super(),this.n=T,this.r=q,this.s=X,this.g=this.B(new j.$ce),this.onTokenFailed=this.g.event,this.h=this.B(new j.$ce),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$ce),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(R),this.c=(0,u.$4p)(Y,G,X).then(W=>{const J={"X-Client-Name":`${M.applicationName}${P.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(J["X-Client-Commit"]=M.commit),J}),this.f=new k(i,o,this.n,this.r),this.u(),this.B((0,O.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(R,M){this.b={token:R,type:M}}t(R){this.a=R?(0,f.$7g)(R,"v1"):void 0}u(){const R=this.s.getNumber(r,-1);R&&Date.now()<R&&this.y(new Date(R))}y(R){this.j?.getTime()!==R?.getTime()&&(this.j=R,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,A.$gh)(M=>(0,A.$uh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,f.$7g)(this.a,"collection").toString();R={...R},R["Content-Type"]="application/json";const T=await this.D(M,{type:"GET",headers:R},[],N.CancellationToken.None);return(await(0,l.$Qp)(T))?.map(({id:q})=>q)||[]}async createCollection(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,f.$7g)(this.a,"collection").toString();R={...R},R["Content-Type"]=I.$Ms.text;const T=await this.D(M,{type:"POST",headers:R},[],N.CancellationToken.None),q=await(0,l.$Pp)(T);if(!q)throw new d.$mAb("Server did not return the collection id",M,"NoCollection",T.res.statusCode,T.res.headers[d.$iAb]);return q}async deleteCollection(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=R?(0,f.$7g)(this.a,"collection",R).toString():(0,f.$7g)(this.a,"collection").toString();M={...M},await this.D(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(R,M){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,M,R),q={},Y=await this.D(T.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,l.$Qp)(Y)||[]).map(({url:X,created:W})=>({ref:(0,f.$9g)(T,T.with({path:X})),created:W*1e3}))}async resolveResourceContent(R,M,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$7g)(this.z(this.a,T,R),M).toString();q={...q},q["Cache-Control"]="no-cache";const G=await this.D(Y,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,l.$Pp)(G)}async deleteResource(R,M,T){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,f.$7g)(this.z(this.a,T,R),M).toString():this.z(this.a,T,R).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$7g)(this.a,"resource").toString(),M={"Content-Type":I.$Ms.text};await this.D(R,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(R,M,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$7g)(this.z(this.a,T,R),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const G=await this.D(Y,{type:"GET",headers:q},[304],N.CancellationToken.None);let X=null;if(G.res.statusCode===304&&(X=M),X===null){const W=G.res.headers.etag;if(!W)throw new d.$mAb("Server did not return the ref",Y,"NoRef",G.res.statusCode,G.res.headers[d.$iAb]);const J=await(0,l.$Pp)(G);if(!J&&G.res.statusCode===304)throw new d.$mAb("Empty response",Y,"EmptyResponse",G.res.statusCode,G.res.headers[d.$iAb]);X={ref:W,content:J}}return X}async writeResource(R,M,T,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=this.z(this.a,q,R).toString();Y={...Y},Y["Content-Type"]=I.$Ms.text,T&&(Y["If-Match"]=T);const X=await this.D(G,{type:"POST",data:M,headers:Y},[],N.CancellationToken.None),W=X.res.headers.etag;if(!W)throw new d.$mAb("Server did not return the ref",G,"NoRef",X.res.statusCode,X.res.headers[d.$iAb]);return W}async manifest(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,f.$7g)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",R&&(M["If-None-Match"]=R.ref);const q=await this.D(T,{type:"GET",headers:M},[304],N.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=R),!Y){const X=q.res.headers.etag;if(!X)throw new d.$mAb("Server did not return the ref",T,"NoRef",q.res.statusCode,q.res.headers[d.$iAb]);const W=await(0,l.$Pp)(q);if(!W&&q.res.statusCode===304)throw new d.$mAb("Empty response",T,"EmptyResponse",q.res.statusCode,q.res.headers[d.$iAb]);W&&(Y={...JSON.parse(W),ref:X})}const G=this.s.get(n,-1);return G&&Y&&G!==Y.session&&this.C(),Y===null&&G&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$7g)(this.a,"download").toString(),M={},T=await this.D(R,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,l.$Mp)(T))throw new d.$mAb("Server returned "+T.res.statusCode,R,"EmptyResponse",T.res.statusCode,T.res.headers[d.$iAb]);if((0,l.$Np)(T))throw new d.$mAb("Empty response",R,"EmptyResponse",T.res.statusCode,T.res.headers[d.$iAb]);return T.stream}z(R,M,T){return M?(0,f.$7g)(R,"collection",M,"resource",T):(0,f.$7g)(R,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(R,M,T,q){if(!this.b)throw new d.$mAb("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$mAb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:R,type:M.type,headers:{...M.headers,authorization:void 0}});let G;try{G=await this.f.request(R,M,q)}catch(B){if(!(B instanceof d.$mAb)){let ie="RequestFailed";const re=(0,L.$0)(B).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,L.$4)(B)&&(ie="RequestCanceled"),B=new d.$mAb(`Connection refused for the request '${R}'.`,R,ie,void 0,void 0)}throw this.r.info("Request failed",R),B}const X=G.res.headers[d.$iAb],W={url:R,status:G.res.statusCode,"execution-id":M.headers[d.$jAb],"operation-id":X},J=(0,l.$Mp)(G)||G.res.statusCode&&T.includes(G.res.statusCode);let H="";if(J?this.r.trace("Request succeeded",W):(H=await(0,l.$Op)(G)||"",this.r.info("Request failed",W,H)),G.res.statusCode===401||G.res.statusCode===403){if(this.b=void 0,G.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$mAb(`${M.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",G.res.statusCode,X);if(G.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$mAb(`${M.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",G.res.statusCode,X)}if(this.h.fire(),G.res.statusCode===404)throw new d.$mAb(`${M.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",G.res.statusCode,X);if(G.res.statusCode===405)throw new d.$mAb(`${M.type} request '${R}' failed because the requested endpoint is not found (405). ${H}`,R,"MethodNotFound",G.res.statusCode,X);if(G.res.statusCode===409)throw new d.$mAb(`${M.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",G.res.statusCode,X);if(G.res.statusCode===410)throw new d.$mAb(`${M.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",G.res.statusCode,X);if(G.res.statusCode===412)throw new d.$mAb(`${M.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",G.res.statusCode,X);if(G.res.statusCode===413)throw new d.$mAb(`${M.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",G.res.statusCode,X);if(G.res.statusCode===426)throw new d.$mAb(`${M.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",G.res.statusCode,X);if(G.res.statusCode===429){const B=G.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new d.$mAb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",G.res.statusCode,X)):new d.$mAb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",G.res.statusCode,X)}if(!J)throw new d.$mAb("Server returned "+G.res.statusCode,R,"Unknown",G.res.statusCode,X);return G}F(R){let M=this.s.get(s,-1);M===void 0&&(M=(0,w.$Pg)(),this.s.store(s,M,-1,1)),R["X-Machine-Session-Id"]=M;const T=this.s.get(n,-1);T!==void 0&&(R["X-User-Session-Id"]=T)}};e.$8Kb=S,e.$8Kb=S=Ee([Z(1,g.$gk),Z(2,l.$Kp),Z(3,d.$vAb),Z(4,c.$Ai),Z(5,p.$Zk),Z(6,m.$Xp)],S);let v=class extends S{constructor(R,M,T,q,Y,G,X){super(R.userDataSyncStore?.url,M,T,q,Y,G,X),this.B(R.onDidChangeUserDataSyncStore(()=>this.t(R.userDataSyncStore?.url)))}};e.$9Kb=v,e.$9Kb=v=Ee([Z(0,d.$fAb),Z(1,g.$gk),Z(2,l.$Kp),Z(3,d.$vAb),Z(4,c.$Ai),Z(5,p.$Zk),Z(6,m.$Xp)],v);class k{constructor(R,M,T,q){this.c=R,this.d=M,this.f=T,this.g=q,this.a=[],this.b=void 0}request(R,M,T){if(this.h()&&this.i(),M.url=R,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$mAb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(R),this.f.request(M,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$0Kb=k}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,A,N,L,j,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0;class f{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$Ldc=f;class E extends N.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new A.$ce),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(g=>{this.a=g,this.b.fire(g)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$Mdc=E;class y{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Ndc=y;let w=class extends P.$6Kb{constructor(c,p,g,l){super(p,g,l),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:L.URI.revive(c.url),type:c.type,defaultUrl:L.URI.revive(c.defaultUrl),insidersUrl:L.URI.revive(c.insidersUrl),stableUrl:L.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$Odc=w,e.$Odc=w=Ee([Z(1,O.$gk),Z(2,j.$Zi),Z(3,I.$Xp)],w)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,A,N,L,j,O,I,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;let y=class extends I.$wac{constructor(h,c,p,g,l,u,m,d,$,t,r){super(h,c,p,g,l,m,d,$,t,r),this.B(A.Event.debounce(A.Event.any(A.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),A.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$$dc=y,e.$$dc=y=Ee([Z(0,L.$gk),Z(1,P.$fAb),Z(2,P.$gAb),Z(3,P.$qAb),Z(4,P.$rAb),Z(5,N.$2bc),Z(6,P.$vAb),Z(7,f.$BJb),Z(8,O.$Yl),Z(9,E.$6zb),Z(10,j.$Xp)],y)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0,e.$qbc=O,e.$rbc=I,e.$sbc=P,e.$pbc=128/4;function O(f){function E(){let y=f.scheme===N.Schemas.file?(0,j.$Ug)(f):f.toString();return L.$k||(y=y.toLowerCase()),(0,A.createHash)("md5").update(y).digest("hex")}return{id:E(),configPath:f}}function I(f,E){function y(){if(f.scheme!==N.Schemas.file)return(0,A.createHash)("md5").update(f.toString()).digest("hex");if(!E)return;let h;return L.$k?h=E.ino:L.$j?h=E.birthtime.getTime():L.$i&&(typeof E.birthtimeMs=="number"?h=Math.floor(E.birthtimeMs):h=E.birthtime.getTime()),(0,A.createHash)("md5").update(f.fsPath).update(h?String(h):"").digest("hex")}const w=y();if(typeof w=="string")return{id:w,uri:f}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let p=class extends L.$Vc{constructor(l,u,m,d){super(),this.a=l,this.b=u,this.c=m,this.f=d,this.B(new A.$Fh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await O.Promises.readdir(l),m=new f.$cKb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const $=(0,j.$kc)(l,d);d.length===y.$pbc||d===E.$Fi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await m.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm($))}))}catch(l){(0,N.$1)(l)}}};e.$Hdc=p,e.$Hdc=p=Ee([Z(0,I.$Bi),Z(1,P.$Zj),Z(2,w.$2bc),Z(3,h.$edc)],p)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$ki=e.$ji=e.$ii=void 0,e.$li=n,e.$mi=s,e.$oi=a,e.$pi=b;class p{traceSocketEvent(v,k){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,k)}constructor(v,k=""){this.f=!0,this.debugLabel=k,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,I.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const k=C=>{this.traceSocketEvent("read",C),v(O.$De.wrap(C))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(v){const k=C=>{v({type:0,hadError:C,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(v){const k=()=>{v()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ii=p;var g;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var l;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(l||(l={}));class u extends f.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,k){this.socket.traceSocketEvent(v,k)}constructor(v,k,C,R){super(),this.f=this.B(new P.$ce),this.g=this.B(new P.$ce),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:C?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new m(this,k,C,R,this.f,(M,T)=>this.m(M,T))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new c.$di,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let k=0;for(;k<v.byteLength;)this.a.writeMessage(v.slice(k,Math.min(k+262144,v.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(v,{compressed:k,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const M=O.$De.alloc(R),T=k?64:0,q=C&15;if(M.writeUInt8(128|T|q,0),v.byteLength<126)M.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(v.byteLength>>>24&255,++Y),M.writeUInt8(v.byteLength>>>16&255,++Y),M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}this.socket.write(O.$De.concat([M,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),C=k.readUInt8(0),R=(C&128)>>>7,M=(C&64)>>>6,T=C&15,q=k.readUInt8(1),Y=(q&128)>>>7,G=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!R,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),C=k.readUInt8(1),R=(C&128)>>>7;let M=C&127,T=1;M===126?M=k.readUInt8(++T)*2**8+k.readUInt8(++T):M===127&&(M=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let q=0;R&&(q=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ji=u;class m extends f.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$De.alloc(0)}constructor(v,k,C,R,M,T){super(),this.n=v,this.r=M,this.s=T,this.a=this.B(new P.$ce),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$ce),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$ce),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new d(this.n,R,C,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(v,k){this.g.push({data:v,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:k}=this.g.shift();if(this.f&&k.compressed){const C=await this.w(this.f,v);this.s(C,k)}else this.s(v,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,k){return new Promise((C,R)=>{v.write(k),v.flush(M=>C(M))})}acceptFrame(v,k,C){this.h.push({data:v,isCompressed:k,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const k=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,k,C){return new Promise((R,M)=>{v.write(k),C&&v.write(O.$De.fromByteArray([0,0,255,255])),v.flush(T=>R(T))})}}class d extends f.$Vc{get recordedInflateBytes(){return this.j?O.$De.concat(this.f):O.$De.alloc(0)}constructor(v,k,C,R){super(),this.h=v,this.j=k,this.a=this.B(new P.$ce),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(R),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$De.wrap(M))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$De.concat(this.g);this.g.length=0,v(k)})}}class $ extends f.$Vc{constructor(v,k){super(),this.g=v,this.a=this.B(new P.$ce),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(O.$De.wrap(C))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$De.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),v(k)})}}function t(S,v){if(v===0)return;const k=S.byteLength>>>2;for(let Y=0;Y<k;Y++){const G=S.readUInt32BE(Y*4);S.writeUInt32BE(G^v,Y*4)}const C=k*4,R=S.byteLength-C,M=v>>>24&255,T=v>>>16&255,q=v>>>8&255;R>=1&&S.writeUInt8(S.readUInt8(C)^M,C),R>=2&&S.writeUInt8(S.readUInt8(C+1)^T,C+1),R>=3&&S.writeUInt8(S.readUInt8(C+2)^q,C+2)}e.$ki=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const S=(0,w.$Pg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const v=process.platform!=="darwin"&&e.$ki?e.$ki:(0,L.tmpdir)(),k=(0,E.$kc)(v,`vscode-ipc-${S}.sock`);return i(k),k}function s(S,v,k){const R=(0,A.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${v}-sock`;const M=k.substr(0,4),T=v.substr(0,6);let q;return process.platform!=="darwin"&&e.$ki&&!process.env.VSCODE_PORTABLE?q=(0,E.$kc)(e.$ki,`vscode-${R}-${M}-${T}.sock`):q=(0,E.$kc)(S,`${M}-${T}.sock`),i(q),q}function i(S){const v=r[y.$u];typeof v=="number"&&S.length>=v&&console.warn(`WARNING: IPC handle "${S}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends h.$0h{static b(v){const k=P.Event.fromNodeEventEmitter(v,"connection");return P.Event.map(k,C=>({protocol:new c.$ei(new p(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ni=o;function a(S){return new Promise((v,k)=>{const C=(0,N.createServer)();C.on("error",k),C.listen(S,()=>{C.removeListener("error",k),v(new o(C))})})}function b(S,v){return new Promise((k,C)=>{const R=(0,N.createConnection)(S,()=>{R.removeListener("error",C),k(c.$fi.fromSocket(new p(R,`ipc-client${v}`),v))});R.once("error",C)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0,e.$bec=new class{supports(j){return!0}connect({host:j,port:O},I,P,f){return new Promise((E,y)=>{const w=A.createConnection({host:j,port:O},()=>{w.removeListener("error",y),w.write((0,L.$Ssb)(I,P,f));const h=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",h),E(new N.$ii(w,f)))};w.on("data",h)});w.setNoDelay(!0),w.once("error",y)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=e.$9cc=e.$8cc=void 0;async function l(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,n,s,i).waitForReady(),!(i&&L.$Sg[i]||!L.$Sg[o.tunnelLocalPort]));a--);return o}class u extends I.$Vc{constructor(r,n,s,i,o){super(),this.m=n,this.n=o,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=A.createServer(),this.c=new O.$sh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,n=(0,p.$fw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Tg)(r,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const n=(0,p.$dw)(this.tunnelRemoteHost)||(0,p.$fw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Pl)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof j.$ii?i.socket.destroy():i.end()}),i instanceof j.$ii?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(g.$De.wrap(s))),r.resume()}t(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.$8cc=u;let m=class extends p.$iw{constructor(r,n,s,i,o){super(n,o),this.v=r,this.w=s,this.y=i}isPortPrivileged(r){return(0,p.$gw)(r,this.m,P.OS,N.release())}t(r,n,s,i,o,a,b,S){const v=this.s(n,s);if(v)return++v.refcount,v.value;if((0,p.$_v)(r))return this.u(r,n,s,o,a,b,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=l(k,i,n,s,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,C),C}}};e.$9cc=m,e.$9cc=m=Ee([Z(0,h.$Jl),Z(1,E.$Zj),Z(2,c.$Ml),Z(3,y.$gk),Z(4,f.$Zi)],m);let d=class extends m{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.$0cc=d,e.$0cc=d=Ee([Z(0,h.$Jl),Z(1,E.$Zj),Z(2,c.$Ml),Z(3,y.$gk),Z(4,f.$Zi)],d);let $=class extends I.$Vc{constructor(r,n,s,i,o){super(),this.b=r,this.c=n,this.f=s,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,n,s,i,o,a,b,S,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(r)){const k=new d(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(n,s,i,o,a,b,S,v)}};e.$$cc=$,e.$$cc=$=Ee([Z(0,h.$Jl),Z(1,E.$Zj),Z(2,y.$gk),Z(3,c.$Ml),Z(4,f.$Zi)],$)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,A,N,L,j,O,I,P,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,C,R,M,T,q,Y,G,X,W,J,H,B,ie,re,he,te,V,U,D,F,z,x,K,ee,_,Q,se,ue,ge,fe,$e,ye,ve,Pe,Ae,le,me,we,Ce,Re,Me,Oe,qe,Fe,ze,Ue,je,oe,de,pe,be,Se,Ie,De,Ne,We,Be,Te,Ze,Ge,_e,tt,St,kt,gt,Pt,Ct,It,Rt,At,Dt,Ot,Lt,$t,jt,mt,Nt,Mt,st,Ft,Tt,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class qt extends j.$Vc{constructor(ke){super(),this.f=ke,this.a=this.B(new y.$VW(this)),this.b=void 0,this.c=this.B(new f.$ce),this.g()}g(){let ke=!1;const Le=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,y.$WW)(process.parentPort,st.$kcc.exit,Le)}async init(){const ke=await this.h();(0,_.$aAb)(),ke.invokeFunction(Le=>{const He=Le.get(J.$Zj),Ve=Le.get(V.$Yl),Xe=Le.get(Ie.$zl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(He),this.n(Ve,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(Ve,Xe))),this.r(Ve,He)}),this.B((0,j.$Sc)(ke.createInstance(w.$Ddc,this.f.codeCachePath),ke.createInstance(h.$Edc),ke.createInstance(g.$Hdc),ke.createInstance(p.$Gdc),ke.createInstance(c.$Fdc),ke.createInstance(tt.$5dc),ke.createInstance(Ze.$Wdc)))}async h(){const ke=new G.$ri,Le={_serviceBrand:void 0,...B.default};ke.set(ie.$gk,Le);const He=new E.$bi(Ke=>Ke==="main"),Ve=new $t.$fdc(this.a,He);ke.set($t.$edc,Ve);const Xe=this.f.policiesData?new Ne.$Ncc(this.f.policiesData,Ve.getChannel("policy")):new We.$do;ke.set(We.$bo,Xe);const Je=new Mt.$6m(this.f.args,Le);ke.set(s.$Bi,Je);const et=new H.$8r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),Ve.getChannel("logger"));ke.set(J.$1j,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new J.$8j(ot.getLevel())),Qe=this.B(new kt.$FQ(ot,[ht]));ke.set(J.$Zj,Qe),this.b=this.B(new gt.$7dc(Qe)),ke.set(gt.$6dc,this.b);const Ye=this.B(new R.$Fq(Qe));ke.set(C.$Zk,Ye);const ut=this.B(new M.$9q(Qe));Ye.registerProvider(O.Schemas.file,ut);const at=new ze.$ws(Ye);ke.set(Fe.$xl,at);const xe=this.B(new Be.$MQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Ie.$zl,xe);const ft=this.B(new je.$ddc(O.Schemas.file,this.B(new oe.$oQ(Ve.getChannel(oe.$nQ),{pathCaseSensitive:Ue.$k})),O.Schemas.vscodeUserData,xe,at,Qe));Ye.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new d.$Do(xe.defaultProfile.settingsResource,Ye,Xe,Qe));ke.set(m.$Zi,it);const dt=new jt.$aec(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);ke.set(he.$Xp,dt),this.B((0,j.$Tc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new It.$Sr(Ve.getChannel("request"));ke.set(re.$Kp,bt),ke.set(l.$Idc,new T.$qi(u.$Jdc,void 0,!1)),ke.set(pe.$iG,new T.$qi(de.$Vdc,void 0,!1));const yt=new Dt.$kdc(-1,Ve);ke.set(At.$2bc,yt),ke.set(r.$Ho,new T.$qi(n.$UQ,void 0,!0));const Ut=this.B(new me.$Kcc(yt)),Bt=new E.$bi(Ke=>Ut.getActiveClientId().then(lt=>Ke===lt));ke.set(k.$Y3b,new Rt.$9dc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,z.$op)(Le,it);if((0,z.$jp)(Le,Je)){const Ke=new D.$N_b(Qe,et,Je,Le);if(nt.push(Ke),!(0,z.$kp)(Le,Je)&&Le.aiConfig?.ariaKey){const lt=new Te.$tQ(bt,vt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Tc)(()=>lt.flush())),nt.push(lt)}ct=new F.$Wr({appenders:nt,commonProperties:(0,te.$ap)((0,A.release)(),(0,A.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,z.$pp)(Je)},it,Le)}else{ct=z.$ep;const Ke=z.$ip;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new U.$pcc(nt)),ke.set(V.$Yl,ct);const Vt=new x.$Kdc(it,ct,Qe,et,Je,Le);ke.set(V.$Zl,Vt),ke.set(De.$mq,new T.$qi(Ct.$EQ,void 0,!0)),ke.set(be.$qq,new T.$qi(Se.$Occ,void 0,!0)),ke.set(b.$9p,new T.$qi(b.$$p,void 0,!0)),ke.set(v.$Aq,new T.$qi(v.$Bq,void 0,!0)),ke.set(a.$3o,new T.$qi(o.$7p,void 0,!0)),ke.set(a.$0o,new T.$qi(Lt.$_dc,void 0,!1)),ke.set(X.$Or,new T.$qi(W.$Qr,void 0,!1)),ke.set($.$an,new T.$qi(t.$Ds,void 0,!1)),ke.set(Q.$BJb,new T.$qi(Q.$CJb,void 0,!0)),ke.set(_.$vAb,new T.$qi(ge.$2Lb,void 0,!0)),ke.set(_.$uAb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$9o,new T.$qi(i.$zJb,void 0,!1)),ke.set(ee.$ZLb,new T.$qi(ee.$1Lb,void 0,!0)),ke.set(K.$Vv,new T.$qi(K.$Wv)),ke.set(_.$fAb,new T.$qi(Pe.$7Kb,void 0,!0)),ke.set(_.$gAb,new T.$qi(Pe.$9Kb,void 0,!0)),ke.set(fe.$6zb,new T.$qi(fe.$8zb,void 0,!0)),ke.set(_.$hAb,new T.$qi(se.$qac,void 0,!1)),ke.set(_.$qAb,new T.$qi($e.$fac,void 0,!0)),ke.set(_.$rAb,new T.$qi(ye.$vac,void 0,!1)),ke.set(Ae.$dKb,new T.$qi(le.$Rdc,void 0,!0)),ke.set(_.$sAb,new T.$qi(_e.$5ac,void 0,!0)),ke.set(we.$Ml,new T.$qi(Ce.$adc,void 0,!1));const Et=new mt.$Kl;return ke.set(mt.$Jl,Et),Et.register(0,Nt.$bec),ke.set(Re.$$v,new T.$qi(Me.$$cc)),ke.set(Oe.$Sdc,new T.$qi(qe.$Udc)),ke.set(Ge.$Xdc,new T.$qi(Pt.$8dc)),new Y.$_q(ke)}j(ke){const Le=new S.$aq(ke.get(a.$6o),()=>null);this.a.registerChannel("extensions",Le);const He=E.ProxyChannel.fromService(ke.get(X.$Or),this.q);this.a.registerChannel("languagePacks",He);const Ve=E.ProxyChannel.fromService(ke.get($.$an),this.q);this.a.registerChannel("diagnostics",Ve);const Xe=new S.$cq(ke.get(a.$0o));this.a.registerChannel("extensionTipsService",Xe);const Je=E.ProxyChannel.fromService(ke.get(l.$Idc),this.q);this.a.registerChannel("checksum",Je);const et=E.ProxyChannel.fromService(ke.get(pe.$iG),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=E.ProxyChannel.fromService(ke.get(fe.$6zb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=E.ProxyChannel.fromService(ke.get(V.$Zl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Qe=new ue.$Ldc(ke.get(Q.$BJb));this.a.registerChannel("userDataSyncAccount",Qe);const Ye=new ue.$Ndc(ke.get(_.$fAb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new ve.$Pdc(ke.get(_.$rAb),ke.get(Ie.$zl),ke.get(J.$Zj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(q.$si).createInstance(Ot.$$dc));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(ke.get(_.$sAb),this.q));const xe=E.ProxyChannel.fromService(ke.get(Oe.$Sdc),this.q);this.a.registerChannel(Oe.$Tdc,xe);const ft=E.ProxyChannel.fromService(ke.get(Ge.$Xdc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",Le=>(0,L.$1)(Le)),process.on("unhandledRejection",Le=>(0,L.$1)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const He=(0,N.$ej)(Le,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,Le){ke.publicLog2("profilesInfo",{count:Le.profiles.length})}async r(ke,Le){if(Ue.$k){const[He,Ve]=await Promise.all([(0,Ft.$Qg)(Le.error.bind(Le)),(0,wt.$DW)(Le.error.bind(Le))]),Xe=(0,Tt.$jW)(),Je=(0,wt.$EW)(Ve,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Xe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$mcc.response)return!1;const Le=(0,P.$Ob)(ke.ports);return Le?(this.c.fire(Le),!0):!1}}async function pt(rt){try{const ke=new qt(rt);process.parentPort.postMessage(st.$kcc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$kcc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const zt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(zt),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/59d84c5c8cecf22b24e316c5443dc3ec49462589/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
