/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(le){for(var e=[],l=0,M=le.length;l<M;l++)e[l]=ke[le[l]];return e};define(ke[162],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const L=new Map,A=new Map,R=new Map,b=new Map;function $(y,w){y.has(w.detail)||y.set(w.detail,-w.timestamp)}function S(y,w){const d=y.get(w.detail);d&&(d>=0||y.set(w.detail,d+w.timestamp))}let N=[];typeof le=="function"&&typeof le.getStats=="function"&&(N=le.getStats().slice(0).sort((y,w)=>y.timestamp-w.timestamp));for(const y of N)switch(y.type){case 10:$(L,y);break;case 11:case 12:S(L,y);break;case 21:$(A,y);break;case 22:S(A,y);break;case 33:$(R,y);break;case 34:S(R,y);break;case 31:$(b,y);break;case 32:S(b,y);break}let C=0;R.forEach(y=>C+=y);function m(y){const w=[];return y.forEach((d,g)=>w.push([g,d])),w}return{amdLoad:m(L),amdInvoke:m(A),nodeRequire:m(R),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(L,A){let R="";const b=[];return L.forEach(($,S)=>{b[S]=$.length}),A.forEach($=>{$.forEach((S,N)=>{typeof S>"u"&&(S=$[N]="-");const C=S.toString().length;b[N]=Math.max(C,b[N])})}),L.forEach(($,S)=>{R+=`| ${$+" ".repeat(b[S]-$.toString().length)} `}),R+=`|
`,L.forEach(($,S)=>{R+=`| ${"-".repeat(b[S])} `}),R+=`|
`,A.forEach($=>{$.forEach((S,N)=>{typeof S<"u"&&(R+=`| ${S+" ".repeat(b[N]-S.toString().length)} `)}),R+=`|
`}),R}}e.$U=l}),define(ke[163],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=l,e.$gb=M,e.$hb=L,e.$ib=A,e.$jb=R,e.$kb=b,e.$lb=$,e.$nb=N,e.$ob=C,e.$pb=m,e.$qb=y,e.$rb=w;function l(d,g){const a=M(d,g);if(a!==-1)return d[a]}function M(d,g,a=d.length-1){for(let i=a;i>=0;i--){const n=d[i];if(g(n))return i}return-1}function L(d,g){const a=A(d,g);return a===-1?void 0:d[a]}function A(d,g,a=0,i=d.length){let n=a,u=i;for(;n<u;){const o=Math.floor((n+u)/2);g(d[o])?n=o+1:u=o}return n-1}function R(d,g){const a=b(d,g);return a===d.length?void 0:d[a]}function b(d,g,a=0,i=d.length){let n=a,u=i;for(;n<u;){const o=Math.floor((n+u)/2);g(d[o])?u=o:n=o+1}return n}function $(d,g,a=0,i=d.length){const n=b(d,g,a,i);return n===d.length?-1:n}class S{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(S.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!g(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const a=A(this.e,g,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=S;function N(d,g){if(d.length===0)return;let a=d[0];for(let i=1;i<d.length;i++){const n=d[i];g(n,a)>0&&(a=n)}return a}function C(d,g){if(d.length===0)return;let a=d[0];for(let i=1;i<d.length;i++){const n=d[i];g(n,a)>=0&&(a=n)}return a}function m(d,g){return N(d,(a,i)=>-g(a,i))}function y(d,g){if(d.length===0)return-1;let a=0;for(let i=1;i<d.length;i++){const n=d[i];g(n,d[a])>0&&(a=i)}return a}function w(d,g){for(const a of d){const i=g(a);if(i!==void 0)return i}}}),define(ke[73],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=l,e.$L=M,e.$M=L,e.$N=A;function l(R,b){const $=Object.create(null);for(const S of R){const N=b(S);let C=$[N];C||(C=$[N]=[]),C.push(S)}return $}function M(R,b){const $=[],S=[];for(const N of R)b.has(N)||$.push(N);for(const N of b)R.has(N)||S.push(N);return{removed:$,added:S}}function L(R,b){const $=[],S=[];for(const[N,C]of R)b.has(N)||$.push(C);for(const[N,C]of b)R.has(N)||S.push(C);return{removed:$,added:S}}function A(R,b){const $=new Set;for(const S of b)R.has(S)&&$.add(S);return $}}),define(ke[55],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=M,e.$Yh=L,e.$Zh=A;function l(R){return(b,$,S)=>{let N=null,C=null;if(typeof S.value=="function"?(N="value",C=S.value):typeof S.get=="function"&&(N="get",C=S.get),!C)throw new Error("not supported");S[N]=R(C,$)}}function M(R,b,$){let S=null,N=null;if(typeof $.value=="function"?(S="value",N=$.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(S="get",N=$.get),!N)throw new Error("not supported");const C=`$memoize$${b}`;$[S]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,m)}),this[C]}}function L(R,b,$){return l((S,N)=>{const C=`$debounce$${N}`,m=`$debounce$result$${N}`;return function(...y){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...y),y=[this[m]]),this[C]=setTimeout(()=>{S.apply(this,y),this[m]=$?$():void 0},R)}})}function A(R,b,$){return l((S,N)=>{const C=`$throttle$timer$${N}`,m=`$throttle$result$${N}`,y=`$throttle$lastRun$${N}`,w=`$throttle$pending$${N}`;return function(...d){if(this[m]||(this[m]=$?$():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...d)),this[w])return;const g=this[y]+R;g<=Date.now()?(this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0):(this[w]=!0,this[C]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0},g-Date.now()))}})}}),define(ke[13],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=M,e.$Z=L,e.$1=A,e.$2=R,e.$3=b,e.$4=S,e.$6=C,e.$7=m,e.$8=y,e.$0=d;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function M(o){e.$X.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(o){S(o)||e.$X.onUnexpectedError(o)}function R(o){S(o)||e.$X.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:h}=o,s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:h,stack:s,noTelemetry:n.isErrorNoTelemetry(o)}}return o}const $="Canceled";function S(o){return o instanceof N?!0:o instanceof Error&&o.name===$&&o.message===$}class N extends Error{constructor(){super($),this.name=this.message}}e.$5=N;function C(){const o=new Error($);return o.name=o.message,o}function m(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class w extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=w;function d(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const h=new n;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(ke[19],Se([1,0,13,163]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=A,e.$ub=R,e.$vb=b,e.$wb=$,e.$xb=S,e.$yb=N,e.$zb=C,e.$Ab=m,e.$Bb=y,e.$Cb=w,e.$Db=d,e.$Eb=g,e.top=a,e.$Gb=i,e.$Hb=u,e.$Ib=o,e.$Jb=t,e.$Kb=h,e.$Lb=s,e.$Mb=c,e.$Nb=r,e.$Ob=v,e.$Pb=f,e.$Qb=D,e.$Rb=p,e.$Sb=E,e.$Tb=k,e.$Ub=P,e.$Vb=I,e.$Wb=T,e.$Xb=j,e.$Yb=z,e.$Zb=O,e.$1b=F,e.$2b=B,e.$3b=W,e.$4b=Z,e.$5b=X,e.$6b=Y,e.$7b=ge,e.$8b=ue,e.$$b=U;function L(se,re=0){return se[se.length-(1+re)]}function A(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function R(se,re,oe=(K,ie)=>K===ie){if(se===re)return!0;if(!se||!re||se.length!==re.length)return!1;for(let K=0,ie=se.length;K<ie;K++)if(!oe(se[K],re[K]))return!1;return!0}function b(se,re){const oe=se.length-1;re<oe&&(se[re]=se[oe]),se.pop()}function $(se,re,oe){return S(se.length,K=>oe(se[K],re))}function S(se,re){let oe=0,K=se-1;for(;oe<=K;){const ie=(oe+K)/2|0,$e=re(ie);if($e<0)oe=ie+1;else if($e>0)K=ie-1;else return ie}return-(oe+1)}function N(se,re,oe){if(se=se|0,se>=re.length)throw new TypeError("invalid index");const K=re[Math.floor(re.length*Math.random())],ie=[],$e=[],we=[];for(const Ne of re){const fe=oe(Ne,K);fe<0?ie.push(Ne):fe>0?$e.push(Ne):we.push(Ne)}return se<ie.length?N(se,ie,oe):se<ie.length+we.length?we[0]:N(se-(ie.length+we.length),$e,oe)}function C(se,re){const oe=[];let K;for(const ie of se.slice(0).sort(re))!K||re(K[0],ie)!==0?(K=[ie],oe.push(K)):K.push(ie);return oe}function*m(se,re){let oe,K;for(const ie of se)K!==void 0&&re(K,ie)?oe.push(ie):(oe&&(yield oe),oe=[ie]),K=ie;oe&&(yield oe)}function y(se,re){for(let oe=0;oe<=se.length;oe++)re(oe===0?void 0:se[oe-1],oe===se.length?void 0:se[oe])}function w(se,re){for(let oe=0;oe<se.length;oe++)re(oe===0?void 0:se[oe-1],se[oe],oe+1===se.length?void 0:se[oe+1])}function d(se,re,oe){const K=[];function ie(Ne,fe,De){if(fe===0&&De.length===0)return;const Ie=K[K.length-1];Ie&&Ie.start+Ie.deleteCount===Ne?(Ie.deleteCount+=fe,Ie.toInsert.push(...De)):K.push({start:Ne,deleteCount:fe,toInsert:De})}let $e=0,we=0;for(;;){if($e===se.length){ie($e,0,re.slice(we));break}if(we===re.length){ie($e,se.length-$e,[]);break}const Ne=se[$e],fe=re[we],De=oe(Ne,fe);De===0?($e+=1,we+=1):De<0?(ie($e,1,[]),$e+=1):De>0&&(ie($e,0,[fe]),we+=1)}return K}function g(se,re,oe){const K=d(se,re,oe),ie=[],$e=[];for(const we of K)ie.push(...se.slice(we.start,we.start+we.deleteCount)),$e.push(...we.toInsert);return{removed:ie,added:$e}}function a(se,re,oe){if(oe===0)return[];const K=se.slice(0,oe).sort(re);return n(se,re,K,oe,se.length),K}function i(se,re,oe,K,ie){return oe===0?Promise.resolve([]):new Promise(($e,we)=>{(async()=>{const Ne=se.length,fe=se.slice(0,oe).sort(re);for(let De=oe,Ie=Math.min(oe+K,Ne);De<Ne;De=Ie,Ie=Math.min(Ie+K,Ne)){if(De>oe&&await new Promise(Fe=>setTimeout(Fe)),ie&&ie.isCancellationRequested)throw new l.$5;n(se,re,fe,De,Ie)}return fe})().then($e,we)})}function n(se,re,oe,K,ie){for(const $e=oe.length;K<ie;K++){const we=se[K];if(re(we,oe[$e-1])<0){oe.pop();const Ne=(0,M.$kb)(oe,fe=>re(we,fe)<0);oe.splice(Ne,0,we)}}}function u(se){return se.filter(re=>!!re)}function o(se){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]&&(se[re]=se[oe],re+=1);se.length=re}function t(se,re,oe){se.splice(oe,0,se.splice(re,1)[0])}function h(se){return!Array.isArray(se)||se.length===0}function s(se){return Array.isArray(se)&&se.length>0}function c(se,re=oe=>oe){const oe=new Set;return se.filter(K=>{const ie=re(K);return oe.has(ie)?!1:(oe.add(ie),!0)})}function r(se){const re=new Set;return oe=>{const K=se(oe);return re.has(K)?!1:(re.add(K),!0)}}function v(se,re){return se.length>0?se[0]:re}function f(se,re){return se.length>0?se[se.length-1]:re}function D(se,re,oe=(K,ie)=>K===ie){let K=0;for(let ie=0,$e=Math.min(se.length,re.length);ie<$e&&oe(se[ie],re[ie]);ie++)K++;return K}function p(se){return[].concat(...se)}function E(se,re){let oe=typeof re=="number"?se:0;typeof re=="number"?oe=se:(oe=0,re=se);const K=[];if(oe<=re)for(let ie=oe;ie<re;ie++)K.push(ie);else for(let ie=oe;ie>re;ie--)K.push(ie);return K}function k(se,re,oe){return se.reduce((K,ie)=>(K[re(ie)]=oe?oe(ie):ie,K),Object.create(null))}function P(se,re){return se.push(re),()=>I(se,re)}function I(se,re){const oe=se.indexOf(re);if(oe>-1)return se.splice(oe,1),re}function T(se,re,oe){const K=se.slice(0,re),ie=se.slice(re);return K.concat(oe,ie)}function j(se,re){let oe;if(typeof re=="number"){let K=re;oe=()=>{const ie=Math.sin(K++)*179426549;return ie-Math.floor(ie)}}else oe=Math.random;for(let K=se.length-1;K>0;K-=1){const ie=Math.floor(oe()*(K+1)),$e=se[K];se[K]=se[ie],se[ie]=$e}}function z(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.unshift(re))}function O(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.push(re))}function F(se,re){for(const oe of re)se.push(oe)}function B(se,re){return Array.isArray(se)?se.map(re):re(se)}function W(se){return Array.isArray(se)?se:[se]}function Z(se){return se[Math.floor(Math.random()*se.length)]}function X(se,re,oe){const K=x(se,re),ie=se.length,$e=oe.length;se.length=ie+$e;for(let we=ie-1;we>=K;we--)se[we+$e]=se[we];for(let we=0;we<$e;we++)se[we+K]=oe[we]}function Y(se,re,oe,K){const ie=x(se,re);let $e=se.splice(ie,oe);return $e===void 0&&($e=[]),X(se,ie,K),$e}function x(se,re){return re<0?Math.max(re+se.length,0):Math.min(re,se.length)}var ne;(function(se){function re($e){return $e<0}se.isLessThan=re;function oe($e){return $e<=0}se.isLessThanOrEqual=oe;function K($e){return $e>0}se.isGreaterThan=K;function ie($e){return $e===0}se.isNeitherLessOrGreaterThan=ie,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function ge(se,re){return(oe,K)=>re(se(oe),se(K))}function ue(...se){return(re,oe)=>{for(const K of se){const ie=K(re,oe);if(!ne.isNeitherLessOrGreaterThan(ie))return ie}return ne.neitherLessOrGreaterThan}}const ve=(se,re)=>se-re;e.$9b=ve;const te=(se,re)=>(0,e.$9b)(se?1:0,re?1:0);e.$0b=te;function U(se){return(re,oe)=>-se(re,oe)}class _{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let oe=this.c;for(;oe<this.g.length&&re(this.g[oe]);)oe++;const K=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,K}takeFromEndWhile(re){let oe=this.d;for(;oe>=0&&re(this.g[oe]);)oe--;const K=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const oe=this.g.slice(this.c,this.c+re);return this.c+=re,oe}}e.$_b=_;class pe{static{this.empty=new pe(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(oe=>(re(oe),!0))}toArray(){const re=[];return this.iterate(oe=>(re.push(oe),!0)),re}filter(re){return new pe(oe=>this.iterate(K=>re(K)?oe(K):!0))}map(re){return new pe(oe=>this.iterate(K=>oe(re(K))))}some(re){let oe=!1;return this.iterate(K=>(oe=re(K),!oe)),oe}findFirst(re){let oe;return this.iterate(K=>re(K)?(oe=K,!1):!0),oe}findLast(re){let oe;return this.iterate(K=>(re(K)&&(oe=K),!0)),oe}findLastMaxBy(re){let oe,K=!0;return this.iterate(ie=>((K||ne.isGreaterThan(re(ie,oe)))&&(K=!1,oe=ie),!0)),oe}}e.$ac=pe;class Pe{constructor(re){this.c=re}static createSortPermutation(re,oe){const K=Array.from(re.keys()).sort((ie,$e)=>oe(re[ie],re[$e]));return new Pe(K)}apply(re){return re.map((oe,K)=>re[this.c[K]])}inverse(){const re=this.c.slice();for(let oe=0;oe<this.c.length;oe++)re[this.c[oe]]=oe;return new Pe(re)}}e.$bc=Pe}),define(ke[62],Se([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=M,e.$dd=L,e.$ed=A,e.$fd=R,e.$gd=b,e.$hd=$;function M(S,N){if(!S)throw new Error(N?`Assertion failed (${N})`:"Assertion Failed")}function L(S,N="Unreachable"){throw new Error(N)}function A(S){if(!S)throw new l.$cb("Assertion Failed")}function R(S){S||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}function b(S){if(!S()){debugger;S(),(0,l.$1)(new l.$cb("Assertion Failed"))}}function $(S,N){let C=0;for(;C<S.length-1;){const m=S[C],y=S[C+1];if(!N(m,y))return!1;C++}return!0}}),define(ke[74],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=l;function l(M,L){const A=this;let R=!1,b;return function(){if(R)return b;if(R=!0,L)try{b=M.apply(A,arguments)}finally{L()}else b=M.apply(A,arguments);return b}}}),define(ke[124],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class l{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$mP=l,e.$nP=new l("id#")}),define(ke[39],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(M){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}M.is=L;const A=Object.freeze([]);function R(){return A}M.empty=R;function*b(t){yield t}M.single=b;function $(t){return L(t)?t:b(t)}M.wrap=$;function S(t){return t||A}M.from=S;function*N(t){for(let h=t.length-1;h>=0;h--)yield t[h]}M.reverse=N;function C(t){return!t||t[Symbol.iterator]().next().done===!0}M.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}M.first=m;function y(t,h){for(const s of t)if(h(s))return!0;return!1}M.some=y;function w(t,h){for(const s of t)if(h(s))return s}M.find=w;function*d(t,h){for(const s of t)h(s)&&(yield s)}M.filter=d;function*g(t,h){let s=0;for(const c of t)yield h(c,s++)}M.map=g;function*a(...t){for(const h of t)yield*h}M.concat=a;function i(t,h,s){let c=s;for(const r of t)c=h(c,r);return c}M.reduce=i;function*n(t,h,s=t.length){for(h<0&&(h+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);h<s;h++)yield t[h]}M.slice=n;function u(t,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,t];const c=t[Symbol.iterator]();for(let r=0;r<h;r++){const v=c.next();if(v.done)return[s,M.empty()];s.push(v.value)}return[s,{[Symbol.iterator](){return c}}]}M.consume=u;async function o(t){const h=[];for await(const s of t)h.push(s);return Promise.resolve(h)}M.asyncToArray=o})(l||(e.Iterable=l={}))}),define(ke[164],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$En=R,e.$Fn=C,e.$Gn=m,e.$Hn=y,e.$In=w,e.$Jn=d,e.$Kn=g,e.$Ln=a,e.$Mn=i,e.$Nn=n,e.$On=u,e.$Pn=o;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,h=!1){let s=0;const c=t.length;let r="",v=0,f=16,D=0;function p(z){let O=0,F=0;for(;O<z;){const B=t.charCodeAt(s);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;s++,O++}return O<z&&(F=-1),F}function E(z){s=z,r="",v=0,f=16,D=0}function k(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&S(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&S(t.charCodeAt(s)))for(s++;s<t.length&&S(t.charCodeAt(s));)s++;else return D=3,t.substring(z,s);let O=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&S(t.charCodeAt(s))){for(s++;s<t.length&&S(t.charCodeAt(s));)s++;O=s}else D=3;return t.substring(z,O)}function P(){let z="",O=s;for(;;){if(s>=c){z+=t.substring(O,s),D=2;break}const F=t.charCodeAt(s);if(F===34){z+=t.substring(O,s),s++;break}if(F===92){if(z+=t.substring(O,s),s++,s>=c){D=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=p(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=s;continue}if(F>=0&&F<=31)if($(F)){z+=t.substring(O,s),D=2;break}else D=6;s++}return z}function I(){if(r="",D=0,v=s,s>=c)return v=c,f=17;let z=t.charCodeAt(s);if(b(z)){do s++,r+=String.fromCharCode(z),z=t.charCodeAt(s);while(b(z));return f=15}if($(z))return s++,r+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),f=14;switch(z){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,r=P(),f=10;case 47:{const O=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<c&&!$(t.charCodeAt(s));)s++;return r=t.substring(O,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const F=c-1;let B=!1;for(;s<F;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,D=1),r=t.substring(O,s),f=13}return r+=String.fromCharCode(z),s++,f=16}case 45:if(r+=String.fromCharCode(z),s++,s===c||!S(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=k(),f=11;default:for(;s<c&&T(z);)s++,z=t.charCodeAt(s);if(v!==s){switch(r=t.substring(v,s),r){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return r+=String.fromCharCode(z),s++,f=16}}function T(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>s,scan:h?j:I,getToken:()=>f,getTokenValue:()=>r,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function C(t,h){const s=[],c=new Object;let r;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function D(p,E,k,P){v.value=p,v.offset=E,v.length=k,v.type=P,v.colonOffset=void 0,r=v}try{n(t,{onObjectBegin:(p,E)=>{if(h<=p)throw c;r=void 0,f=h>p,s.push("")},onObjectProperty:(p,E,k)=>{if(h<E||(D(p,E,k,"property"),s[s.length-1]=p,h<=E+k))throw c},onObjectEnd:(p,E)=>{if(h<=p)throw c;r=void 0,s.pop()},onArrayBegin:(p,E)=>{if(h<=p)throw c;r=void 0,s.push(0)},onArrayEnd:(p,E)=>{if(h<=p)throw c;r=void 0,s.pop()},onLiteralValue:(p,E,k)=>{if(h<E||(D(p,E,k,o(p)),h<=E+k))throw c},onSeparator:(p,E,k)=>{if(h<=E)throw c;if(p===":"&&r&&r.type==="property")r.colonOffset=E,f=!1,r=void 0;else if(p===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(f=!0,s[s.length-1]=""),r=void 0}}})}catch(p){if(p!==c)throw p}return{path:s,previousNode:r,isAtPropertyKey:f,matches:p=>{let E=0;for(let k=0;E<p.length&&k<s.length;k++)if(p[E]===s[k]||p[E]==="*")E++;else if(p[E]!=="**")return!1;return E===p.length}}}function m(t,h=[],s=A.DEFAULT){let c=null,r=[];const v=[];function f(p){Array.isArray(r)?r.push(p):c!==null&&(r[c]=p)}return n(t,{onObjectBegin:()=>{const p={};f(p),v.push(r),r=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{const p=[];f(p),v.push(r),r=p,c=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:f,onError:(p,E,k)=>{h.push({error:p,offset:E,length:k})}},s),r[0]}function y(t,h=[],s=A.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){c.type==="property"&&(c.length=p-c.offset,c=c.parent)}function v(p){return c.children.push(p),p}n(t,{onObjectBegin:p=>{c=v({type:"object",offset:p,length:-1,parent:c,children:[]})},onObjectProperty:(p,E,k)=>{c=v({type:"property",offset:E,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:p,offset:E,length:k,parent:c})},onObjectEnd:(p,E)=>{c.length=p+E-c.offset,c=c.parent,r(p+E)},onArrayBegin:(p,E)=>{c=v({type:"array",offset:p,length:-1,parent:c,children:[]})},onArrayEnd:(p,E)=>{c.length=p+E-c.offset,c=c.parent,r(p+E)},onLiteralValue:(p,E,k)=>{v({type:o(p),offset:E,length:k,parent:c,value:p}),r(E+k)},onSeparator:(p,E,k)=>{c.type==="property"&&(p===":"?c.colonOffset=E:p===","&&r(E))},onError:(p,E,k)=>{h.push({error:p,offset:E,length:k})}},s);const D=c.children[0];return D&&delete D.parent,D}function w(t,h){if(!t)return;let s=t;for(const c of h)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===c){s=v.children[1],r=!0;break}if(!r)return}else{const r=c;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}function d(t){if(!t.parent||!t.parent.children)return[];const h=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const h=Object.create(null);for(const s of t.children){const c=s.children[1];c&&(h[s.children[0].value]=g(c))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}function i(t,h,s=!1){if(a(t,h,s)){const c=t.children;if(Array.isArray(c))for(let r=0;r<c.length&&c[r].offset<=h;r++){const v=i(c[r],h,s);if(v)return v}return t}}function n(t,h,s=A.DEFAULT){const c=R(t,!1);function r(ge){return ge?()=>ge(c.getTokenOffset(),c.getTokenLength()):()=>!0}function v(ge){return ge?ue=>ge(ue,c.getTokenOffset(),c.getTokenLength()):()=>!0}const f=r(h.onObjectBegin),D=v(h.onObjectProperty),p=r(h.onObjectEnd),E=r(h.onArrayBegin),k=r(h.onArrayEnd),P=v(h.onLiteralValue),I=v(h.onSeparator),T=r(h.onComment),j=v(h.onError),z=s&&s.disallowComments,O=s&&s.allowTrailingComma;function F(){for(;;){const ge=c.scan();switch(c.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ge){case 12:case 13:z?B(10):T();break;case 16:B(1);break;case 15:case 14:break;default:return ge}}}function B(ge,ue=[],ve=[]){if(j(ge),ue.length+ve.length>0){let te=c.getToken();for(;te!==17;){if(ue.indexOf(te)!==-1){F();break}else if(ve.indexOf(te)!==-1)break;te=F()}}}function W(ge){const ue=c.getTokenValue();return ge?P(ue):D(ue),F(),!0}function Z(){switch(c.getToken()){case 11:{let ge=0;try{ge=JSON.parse(c.getTokenValue()),typeof ge!="number"&&(B(2),ge=0)}catch{B(2)}P(ge);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return F(),!0}function X(){return c.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),c.getToken()===6?(I(":"),F(),ne()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Y(){f(),F();let ge=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ge||B(4,[],[]),I(","),F(),c.getToken()===2&&O)break}else ge&&B(6,[],[]);X()||B(4,[],[2,5]),ge=!0}return p(),c.getToken()!==2?B(7,[2],[]):F(),!0}function x(){E(),F();let ge=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ge||B(4,[],[]),I(","),F(),c.getToken()===4&&O)break}else ge&&B(6,[],[]);ne()||B(4,[],[4,5]),ge=!0}return k(),c.getToken()!==4?B(8,[4],[]):F(),!0}function ne(){switch(c.getToken()){case 3:return x();case 1:return Y();case 10:return W(!0);default:return Z()}}return F(),c.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):ne()?(c.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function u(t,h){const s=R(t),c=[];let r,v=0,f;do switch(f=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:v!==f&&c.push(t.substring(v,f)),h!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,h)),v=s.getPosition();break}while(r!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(ke[75],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(A){this.element=A,this.next=l.Undefined,this.prev=l.Undefined}}class M{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let A=this.a;for(;A!==l.Undefined;){const R=A.next;A.prev=l.Undefined,A.next=l.Undefined,A=R}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const b=new l(A);if(this.a===l.Undefined)this.a=b,this.b=b;else if(R){const S=this.b;this.b=b,b.prev=S,S.next=b}else{const S=this.a;this.a=b,b.next=S,S.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==l.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==l.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==l.Undefined&&A.next!==l.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===l.Undefined&&A.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):A.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):A.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==l.Undefined;)yield A.element,A=A.next}}e.$6c=M}),define(ke[27],Se([1,0]),function(le,e){"use strict";var l,M,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=R,e.$Ac=b,e.$Jc=u;function A(o,t,h){let s=o.get(t);return s===void 0&&(s=h,o.set(t,s)),s}function R(o){const t=[];return o.forEach((h,s)=>{t.push(`${s} => ${h}`)}),`Map(${o.size}) {${t.join(", ")}}`}function b(o){const t=[];return o.forEach(h=>{t.push(h)}),`Set(${o.size}) {${t.join(", ")}}`}class ${constructor(t,h){this.uri=t,this.value=h}}function S(o){return Array.isArray(o)}class N{static{this.c=t=>t.toString()}constructor(t,h){if(this[l]="ResourceMap",t instanceof N)this.d=new Map(t.d),this.e=h??N.c;else if(S(t)){this.d=new Map,this.e=h??N.c;for(const[s,c]of t)this.set(s,c)}else this.d=new Map,this.e=t??N.c}set(t,h){return this.d.set(this.e(t),new $(t,h)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,h){typeof h<"u"&&(t=t.bind(h));for(const[s,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=N;class C{constructor(t,h){this[M]="ResourceSet",!t||typeof t=="function"?this.c=new N(t):(this.c=new N(h),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,h){this.c.forEach((s,c)=>t.call(h,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=C;var m;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class y{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,h=0){const s=this.c.get(t);if(s)return h!==0&&this.m(s,h),s.value}set(t,h,s=0){let c=this.c.get(t);if(c)c.value=h,s!==0&&this.m(c,s);else{switch(c={key:t,value:h,next:void 0,previous:void 0},s){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const h=this.c.get(t);if(h)return this.c.delete(t),this.l(h),this.f--,h.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,h){const s=this.g;let c=this.d;for(;c;){if(h?t.bind(h)(c.value,c.key,this):t(c.value,c.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,h=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:s.key,done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return c}values(){const t=this,h=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:s.value,done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return c}entries(){const t=this,h=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:[s.key,s.value],done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let h=this.d,s=this.size;for(;h&&s>t;)this.c.delete(h.key),h=h.next,s--;this.d=h,this.f=s,h&&(h.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let h=this.e,s=this.size;for(;h&&s>t;)this.c.delete(h.key),h=h.previous,s--;this.e=h,this.f=s,h&&(h.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const h=t.next,s=t.previous;if(!h||!s)throw new Error("Invalid list");h.previous=s,s.next=h}t.next=void 0,t.previous=void 0,this.g++}m(t,h){if(!this.d||!this.e)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(t===this.d)return;const s=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(s.previous=c,c.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(h===2){if(t===this.e)return;const s=t.next,c=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=c,c.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((h,s)=>{t.push([s,h])}),t}fromJSON(t){this.clear();for(const[h,s]of t)this.set(h,s)}}e.$Dc=y;class w extends y{constructor(t,h=1){super(),this.n=t,this.o=Math.min(Math.max(0,h),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,h=2){return super.get(t,h)}peek(t){return super.get(t,0)}set(t,h){return super.set(t,h,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends w{constructor(t,h=1){super(t,h)}q(t){this.h(t)}set(t,h){return super.set(t,h),this.p(),this}}e.$Ec=d;class g extends w{constructor(t,h=1){super(t,h)}q(t){this.i(t)}set(t,h){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,h),this}}e.$Fc=g;class a{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let h=this.c.get(t)||0;return h===0?!1:(h--,h===0?this.c.delete(t):this.c.set(t,h),!0)}has(t){return this.c.has(t)}}e.$Gc=a;class i{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[h,s]of t)this.set(h,s)}clear(){this.c.clear(),this.d.clear()}set(t,h){this.c.set(t,h),this.d.set(h,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const h=this.c.get(t);return h===void 0?!1:(this.c.delete(t),this.d.delete(h),!0)}forEach(t,h){this.c.forEach((s,c)=>{t.call(h,s,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=i;class n{constructor(){this.c=new Map}add(t,h){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(h)}delete(t,h){const s=this.c.get(t);s&&(s.delete(h),s.size===0&&this.c.delete(t))}forEach(t,h){const s=this.c.get(t);s&&s.forEach(h)}get(t){const h=this.c.get(t);return h||new Set}}e.$Ic=n;function u(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[h,s]of o)if(!t.has(h)||t.get(h)!==s)return!1;for(const[h]of t)if(!o.has(h))return!1;return!0}}),define(ke[3],Se([1,0,19,73,27,74,39]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=N,e.$Mc=C,e.$Nc=m,e.$Oc=d,e.$Pc=g,e.$Qc=a,e.$Rc=i,e.$Sc=n,e.$Tc=u,e.$4c=p;const b=!1;let $=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const T=this.c(P);T.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const T=I.get(P);if(T)return T;const j=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,j),j}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,P).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(P=10,I){let T;if(I)T=I;else{const B=new Map,W=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,B).isSingleton);if(W.length===0)return;const Z=new Set(W.map(X=>X.value));if(T=W.filter(X=>!(X.parent&&Z.has(X.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function j(B){function W(X,Y){for(;X.length>0&&Y.some(x=>typeof x=="string"?x===X[0]:X[0].match(x));)X.shift()}const Z=B.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return W(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const z=new L.$Ic;for(const B of T){const W=j(B);for(let Z=0;Z<=W.length;Z++)z.add(W.slice(0,Z).join(`
`),B)}T.sort((0,l.$7b)(B=>B.idx,l.$9b));let O="",F=0;for(const B of T.slice(0,P)){F++;const W=j(B),Z=[];for(let X=0;X<W.length;X++){let Y=W[X];Y=`(shared with ${z.get(W.slice(0,X+1).join(`
`)).size}/${T.length} leaks) at ${Y}`;const ne=z.get(W.slice(0,X).join(`
`)),ge=(0,M.$K)([...ne].map(ue=>j(ue)[X]),ue=>ue);delete ge[W[X]];for(const[ue,ve]of Object.entries(ge))Z.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${ue}`);Z.unshift(Y)}O+=`


==================== Leaking disposable ${F}/${T.length}: ${B.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return T.length>P&&(O+=`


... and ${T.length-P} more leaking disposables

`),{leaks:T,details:O}}}e.$Kc=S;function N(k){$=k}if(b){const k="__is_disposable_tracked__";N(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function C(k){return $?.trackDisposable(k),k}function m(k){$?.markAsDisposed(k)}function y(k,P){$?.setParent(k,P)}function w(k,P){if($)for(const I of k)$.setParent(I,P)}function d(k){return $?.markAsSingleton(k),k}function g(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function a(k){if(R.Iterable.is(k)){const P=[];for(const I of k)if(I)try{I.dispose()}catch(T){P.push(T)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function i(k){for(const P of k)g(P)&&P.dispose();return[]}function n(...k){const P=u(()=>a(k));return w(k,P),P}function u(k){const P=C({dispose:(0,A.$db)(()=>{m(P),k()})});return P}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return y(P,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),y(P,null))}}e.$Uc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),y(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Vc=t;class h{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&y(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&y(P,null),P}}e.$Wc=h;class s{constructor(P){this.a=new h,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=s;class c{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}e.$Zc=r;class v{constructor(){this.a=new Map}acquire(P,...I){let T=this.a.get(P);T||(T={counter:0,object:this.b(P,...I)},this.a.set(P,T));const{object:j}=T,z=(0,A.$db)(()=>{--T.counter===0&&(this.c(P,T.object),this.a.delete(P))});return T.counter++,{object:j,dispose:z}}}e.$1c=v;class f{constructor(P){this.a=P}async acquire(P,...I){const T=this.a.acquire(P,...I);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(j){throw T.dispose(),j}}}e.$2c=f;class D{constructor(P){this.object=P}dispose(){}}e.$3c=D;function p(k){const P=new o;try{k(P)}finally{P.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=E}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(se,re){for(var oe=0;oe<re.length;oe++){var K=re[oe];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(se,K.key,K)}}function l(se,re,oe){return re&&e(se.prototype,re),oe&&e(se,oe),Object.defineProperty(se,"prototype",{writable:!1}),se}function M(se,re){if(se){if(typeof se=="string")return L(se,re);var oe=Object.prototype.toString.call(se).slice(8,-1);if(oe==="Object"&&se.constructor&&(oe=se.constructor.name),oe==="Map"||oe==="Set")return Array.from(se);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return L(se,re)}}function L(se,re){(re==null||re>se.length)&&(re=se.length);for(var oe=0,K=new Array(re);oe<re;oe++)K[oe]=se[oe];return K}function A(se,re){var oe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(oe)return(oe=oe.call(se)).next.bind(oe);if(Array.isArray(se)||(oe=M(se))||re&&se&&typeof se.length=="number"){oe&&(se=oe);var K=0;return function(){return K>=se.length?{done:!0}:{done:!1,value:se[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function b(se){le.defaults=se}var $=/[&<>"']/,S=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return m[re]};function w(se,re){if(re){if($.test(se))return se.replace(S,y)}else if(N.test(se))return se.replace(C,y);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(se){return se.replace(d,function(re,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(se,re){se=typeof se=="string"?se:se.source,re=re||"";var oe={replace:function(ie,$e){return $e=$e.source||$e,$e=$e.replace(a,"$1"),se=se.replace(ie,$e),oe},getRegex:function(){return new RegExp(se,re)}};return oe}var n=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(se,re,oe){if(se){var K;try{K=decodeURIComponent(g(oe)).replace(n,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}re&&!u.test(oe)&&(oe=r(re,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(se,re){t[" "+se]||(h.test(se)?t[" "+se]=se+"/":t[" "+se]=p(se,"/",!0)),se=t[" "+se];var oe=se.indexOf(":")===-1;return re.substring(0,2)==="//"?oe?re:se.replace(s,"$1")+re:re.charAt(0)==="/"?oe?re:se.replace(c,"$1")+re:se+re}var v={exec:function(){}};function f(se){for(var re=1,oe,K;re<arguments.length;re++){oe=arguments[re];for(K in oe)Object.prototype.hasOwnProperty.call(oe,K)&&(se[K]=oe[K])}return se}function D(se,re){var oe=se.replace(/\|/g,function($e,we,Ne){for(var fe=!1,De=we;--De>=0&&Ne[De]==="\\";)fe=!fe;return fe?"|":" |"}),K=oe.split(/ \|/),ie=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>re)K.splice(re);else for(;K.length<re;)K.push("");for(;ie<K.length;ie++)K[ie]=K[ie].trim().replace(/\\\|/g,"|");return K}function p(se,re,oe){var K=se.length;if(K===0)return"";for(var ie=0;ie<K;){var $e=se.charAt(K-ie-1);if($e===re&&!oe)ie++;else if($e!==re&&oe)ie++;else break}return se.slice(0,K-ie)}function E(se,re){if(se.indexOf(re[1])===-1)return-1;for(var oe=se.length,K=0,ie=0;ie<oe;ie++)if(se[ie]==="\\")ie++;else if(se[ie]===re[0])K++;else if(se[ie]===re[1]&&(K--,K<0))return ie;return-1}function k(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(se,re){if(re<1)return"";for(var oe="";re>1;)re&1&&(oe+=se),re>>=1,se+=se;return oe+se}function I(se,re,oe,K){var ie=re.href,$e=re.title?w(re.title):null,we=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){K.state.inLink=!0;var Ne={type:"link",raw:oe,href:ie,title:$e,text:we,tokens:K.inlineTokens(we)};return K.state.inLink=!1,Ne}return{type:"image",raw:oe,href:ie,title:$e,text:w(we)}}function T(se,re){var oe=se.match(/^(\s+)(?:```)/);if(oe===null)return re;var K=oe[1];return re.split(`
`).map(function(ie){var $e=ie.match(/^\s+/);if($e===null)return ie;var we=$e[0];return we.length>=K.length?ie.slice(K.length):ie}).join(`
`)}var j=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.space=function(K){var ie=this.rules.block.newline.exec(K);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},re.code=function(K){var ie=this.rules.block.code.exec(K);if(ie){var $e=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:p($e,`
`)}}},re.fences=function(K){var ie=this.rules.block.fences.exec(K);if(ie){var $e=ie[0],we=T($e,ie[3]||"");return{type:"code",raw:$e,lang:ie[2]?ie[2].trim():ie[2],text:we}}},re.heading=function(K){var ie=this.rules.block.heading.exec(K);if(ie){var $e=ie[2].trim();if(/#$/.test($e)){var we=p($e,"#");(this.options.pedantic||!we||/ $/.test(we))&&($e=we.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:$e,tokens:this.lexer.inline($e)}}},re.hr=function(K){var ie=this.rules.block.hr.exec(K);if(ie)return{type:"hr",raw:ie[0]}},re.blockquote=function(K){var ie=this.rules.block.blockquote.exec(K);if(ie){var $e=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},re.list=function(K){var ie=this.rules.block.list.exec(K);if(ie){var $e,we,Ne,fe,De,Ie,Fe,V,q,J,Q,he,be=ie[1].trim(),ze=be.length>1,qe={type:"list",raw:"",ordered:ze,start:ze?+be.slice(0,-1):"",loose:!1,items:[]};be=ze?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=ze?be:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(he=!1,!(!(ie=Ye.exec(K))||this.rules.block.hr.test(K)));){if($e=ie[0],K=K.substring($e.length),V=ie[2].split(`
`,1)[0],q=K.split(`
`,1)[0],this.options.pedantic?(fe=2,Q=V.trimLeft()):(fe=ie[2].search(/[^ ]/),fe=fe>4?1:fe,Q=V.slice(fe),fe+=ie[1].length),Ie=!1,!V&&/^ *$/.test(q)&&($e+=q+`
`,K=K.substring(q.length+1),he=!0),!he)for(var it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");K&&(J=K.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||st.test(V)||it.test(V)||ot.test(K)));){if(V.search(/[^ ]/)>=fe||!V.trim())Q+=`
`+V.slice(fe);else if(!Ie)Q+=`
`+V;else break;!Ie&&!V.trim()&&(Ie=!0),$e+=J+`
`,K=K.substring(J.length+1)}qe.loose||(Fe?qe.loose=!0:/\n *\n *$/.test($e)&&(Fe=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Q),we&&(Ne=we[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!we,checked:Ne,loose:!1,text:Q}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=Q.trimRight(),qe.raw=qe.raw.trimRight();var Ce=qe.items.length;for(De=0;De<Ce;De++){this.lexer.state.top=!1,qe.items[De].tokens=this.lexer.blockTokens(qe.items[De].text,[]);var Be=qe.items[De].tokens.filter(function(Me){return Me.type==="space"}),Ge=Be.every(function(Me){for(var Ze=Me.raw.split(""),ae=0,ce=A(Ze),Ae;!(Ae=ce()).done;){var Ke=Ae.value;if(Ke===`
`&&(ae+=1),ae>1)return!0}return!1});!qe.loose&&Be.length&&Ge&&(qe.loose=!0,qe.items[De].loose=!0)}return qe}},re.html=function(K){var ie=this.rules.block.html.exec(K);if(ie){var $e={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(ie[0]):w(ie[0]);$e.type="paragraph",$e.text=we,$e.tokens=this.lexer.inline(we)}return $e}},re.def=function(K){var ie=this.rules.block.def.exec(K);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var $e=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ie[0],href:ie[2],title:ie[3]}}},re.table=function(K){var ie=this.rules.block.table.exec(K);if(ie){var $e={type:"table",header:D(ie[1]).map(function(Fe){return{text:Fe}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ie[0];var we=$e.align.length,Ne,fe,De,Ie;for(Ne=0;Ne<we;Ne++)/^ *-+: *$/.test($e.align[Ne])?$e.align[Ne]="right":/^ *:-+: *$/.test($e.align[Ne])?$e.align[Ne]="center":/^ *:-+ *$/.test($e.align[Ne])?$e.align[Ne]="left":$e.align[Ne]=null;for(we=$e.rows.length,Ne=0;Ne<we;Ne++)$e.rows[Ne]=D($e.rows[Ne],$e.header.length).map(function(Fe){return{text:Fe}});for(we=$e.header.length,fe=0;fe<we;fe++)$e.header[fe].tokens=this.lexer.inline($e.header[fe].text);for(we=$e.rows.length,fe=0;fe<we;fe++)for(Ie=$e.rows[fe],De=0;De<Ie.length;De++)Ie[De].tokens=this.lexer.inline(Ie[De].text);return $e}}},re.lheading=function(K){var ie=this.rules.block.lheading.exec(K);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},re.paragraph=function(K){var ie=this.rules.block.paragraph.exec(K);if(ie){var $e=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:$e,tokens:this.lexer.inline($e)}}},re.text=function(K){var ie=this.rules.block.text.exec(K);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},re.escape=function(K){var ie=this.rules.inline.escape.exec(K);if(ie)return{type:"escape",raw:ie[0],text:w(ie[1])}},re.tag=function(K){var ie=this.rules.inline.tag.exec(K);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):w(ie[0]):ie[0]}},re.link=function(K){var ie=this.rules.inline.link.exec(K);if(ie){var $e=ie[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var we=p($e.slice(0,-1),"\\");if(($e.length-we.length)%2===0)return}else{var Ne=E(ie[2],"()");if(Ne>-1){var fe=ie[0].indexOf("!")===0?5:4,De=fe+ie[1].length+Ne;ie[2]=ie[2].substring(0,Ne),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var Ie=ie[2],Fe="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);V&&(Ie=V[1],Fe=V[3])}else Fe=ie[3]?ie[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test($e)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),I(ie,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},re.reflink=function(K,ie){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var we=($e[2]||$e[1]).replace(/\s+/g," ");if(we=ie[we.toLowerCase()],!we||!we.href){var Ne=$e[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return I($e,we,$e[0],this.lexer)}},re.emStrong=function(K,ie,$e){$e===void 0&&($e="");var we=this.rules.inline.emStrong.lDelim.exec(K);if(we&&!(we[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=we[1]||we[2]||"";if(!Ne||Ne&&($e===""||this.rules.inline.punctuation.exec($e))){var fe=we[0].length-1,De,Ie,Fe=fe,V=0,q=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ie=ie.slice(-1*K.length+fe);(we=q.exec(ie))!=null;)if(De=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!De){if(Ie=De.length,we[3]||we[4]){Fe+=Ie;continue}else if((we[5]||we[6])&&fe%3&&!((fe+Ie)%3)){V+=Ie;continue}if(Fe-=Ie,!(Fe>0)){if(Ie=Math.min(Ie,Ie+Fe+V),Math.min(fe,Ie)%2){var J=K.slice(1,fe+we.index+Ie);return{type:"em",raw:K.slice(0,fe+we.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Q=K.slice(2,fe+we.index+Ie-1);return{type:"strong",raw:K.slice(0,fe+we.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},re.codespan=function(K){var ie=this.rules.inline.code.exec(K);if(ie){var $e=ie[2].replace(/\n/g," "),we=/[^ ]/.test($e),Ne=/^ /.test($e)&&/ $/.test($e);return we&&Ne&&($e=$e.substring(1,$e.length-1)),$e=w($e,!0),{type:"codespan",raw:ie[0],text:$e}}},re.br=function(K){var ie=this.rules.inline.br.exec(K);if(ie)return{type:"br",raw:ie[0]}},re.del=function(K){var ie=this.rules.inline.del.exec(K);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},re.autolink=function(K,ie){var $e=this.rules.inline.autolink.exec(K);if($e){var we,Ne;return $e[2]==="@"?(we=w(this.options.mangle?ie($e[1]):$e[1]),Ne="mailto:"+we):(we=w($e[1]),Ne=we),{type:"link",raw:$e[0],text:we,href:Ne,tokens:[{type:"text",raw:we,text:we}]}}},re.url=function(K,ie){var $e;if($e=this.rules.inline.url.exec(K)){var we,Ne;if($e[2]==="@")we=w(this.options.mangle?ie($e[0]):$e[0]),Ne="mailto:"+we;else{var fe;do fe=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(fe!==$e[0]);we=w($e[0]),$e[1]==="www."?Ne="http://"+we:Ne=we}return{type:"link",raw:$e[0],text:we,href:Ne,tokens:[{type:"text",raw:we,text:we}]}}},re.inlineText=function(K,ie){var $e=this.rules.inline.text.exec(K);if($e){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):w($e[0]):$e[0]:we=w(this.options.smartypants?ie($e[0]):$e[0]),{type:"text",raw:$e[0],text:we}}},se}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=i(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=i(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=i(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=i(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=i(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=f({},z),z.gfm=f({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=i(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=f({},z.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:i(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=i(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=i(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=i(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=i(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=i(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=i(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=i(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=i(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=i(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=i(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=i(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=f({},O),O.pedantic=f({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=f({},O.normal,{escape:i(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=i(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=f({},O.gfm,{br:i(O.br).replace("{2,}","*").getRegex(),text:i(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var re="",oe,K,ie=se.length;for(oe=0;oe<ie;oe++)K=se.charCodeAt(oe),Math.random()>.5&&(K="x"+K.toString(16)),re+="&#"+K+";";return re}var W=function(){function se(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:O.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=O.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=O.breaks:K.inline=O.gfm),this.tokenizer.rules=K}se.lex=function(K,ie){var $e=new se(ie);return $e.lex(K)},se.lexInline=function(K,ie){var $e=new se(ie);return $e.inlineTokens(K)};var re=se.prototype;return re.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},re.blockTokens=function(K,ie){var $e=this;ie===void 0&&(ie=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Fe,V,q){return V+"    ".repeat(q.length)});for(var we,Ne,fe,De;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(we=Fe.call({lexer:$e},K,ie))?(K=K.substring(we.raw.length),ie.push(we),!0):!1}))){if(we=this.tokenizer.space(K)){K=K.substring(we.raw.length),we.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(we);continue}if(we=this.tokenizer.code(K)){K=K.substring(we.raw.length),Ne=ie[ie.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):ie.push(we);continue}if(we=this.tokenizer.fences(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.heading(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.hr(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.blockquote(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.list(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.html(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.def(K)){K=K.substring(we.raw.length),Ne=ie[ie.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.lheading(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(fe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,V=K.slice(1),q=void 0;$e.options.extensions.startBlock.forEach(function(J){q=J.call({lexer:this},V),typeof q=="number"&&q>=0&&(Fe=Math.min(Fe,q))}),Fe<1/0&&Fe>=0&&(fe=K.substring(0,Fe+1))}(),this.state.top&&(we=this.tokenizer.paragraph(fe))){Ne=ie[ie.length-1],De&&Ne.type==="paragraph"?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):ie.push(we),De=fe.length!==K.length,K=K.substring(we.raw.length);continue}if(we=this.tokenizer.text(K)){K=K.substring(we.raw.length),Ne=ie[ie.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):ie.push(we);continue}if(K){var Ie="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ie},re.inline=function(K,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:K,tokens:ie}),ie},re.inlineTokens=function(K,ie){var $e=this;ie===void 0&&(ie=[]);var we,Ne,fe,De=K,Ie,Fe,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ie.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Fe||(V=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(we=Q.call({lexer:$e},K,ie))?(K=K.substring(we.raw.length),ie.push(we),!0):!1}))){if(we=this.tokenizer.escape(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.tag(K)){K=K.substring(we.raw.length),Ne=ie[ie.length-1],Ne&&we.type==="text"&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):ie.push(we);continue}if(we=this.tokenizer.link(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(we.raw.length),Ne=ie[ie.length-1],Ne&&we.type==="text"&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):ie.push(we);continue}if(we=this.tokenizer.emStrong(K,De,V)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.codespan(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.br(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.del(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.autolink(K,B)){K=K.substring(we.raw.length),ie.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(K,B))){K=K.substring(we.raw.length),ie.push(we);continue}if(fe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,he=K.slice(1),be=void 0;$e.options.extensions.startInline.forEach(function(ze){be=ze.call({lexer:this},he),typeof be=="number"&&be>=0&&(Q=Math.min(Q,be))}),Q<1/0&&Q>=0&&(fe=K.substring(0,Q+1))}(),we=this.tokenizer.inlineText(fe,F)){K=K.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(V=we.raw.slice(-1)),Fe=!0,Ne=ie[ie.length-1],Ne&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):ie.push(we);continue}if(K){var J="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ie},l(se,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),se}(),Z=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.code=function(K,ie,$e){var we=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(K,we);Ne!=null&&Ne!==K&&($e=!0,K=Ne)}return K=K.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+($e?K:w(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:w(K,!0))+`</code></pre>
`},re.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},re.html=function(K){return K},re.heading=function(K,ie,$e,we){if(this.options.headerIds){var Ne=this.options.headerPrefix+we.slug($e);return"<h"+ie+' id="'+Ne+'">'+K+"</h"+ie+`>
`}return"<h"+ie+">"+K+"</h"+ie+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(K,ie,$e){var we=ie?"ol":"ul",Ne=ie&&$e!==1?' start="'+$e+'"':"";return"<"+we+Ne+`>
`+K+"</"+we+`>
`},re.listitem=function(K){return"<li>"+K+`</li>
`},re.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(K){return"<p>"+K+`</p>
`},re.table=function(K,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ie+`</table>
`},re.tablerow=function(K){return`<tr>
`+K+`</tr>
`},re.tablecell=function(K,ie){var $e=ie.header?"th":"td",we=ie.align?"<"+$e+' align="'+ie.align+'">':"<"+$e+">";return we+K+("</"+$e+`>
`)},re.strong=function(K){return"<strong>"+K+"</strong>"},re.em=function(K){return"<em>"+K+"</em>"},re.codespan=function(K){return"<code>"+K+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(K){return"<del>"+K+"</del>"},re.link=function(K,ie,$e){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var we='<a href="'+w(K)+'"';return ie&&(we+=' title="'+ie+'"'),we+=">"+$e+"</a>",we},re.image=function(K,ie,$e){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var we='<img src="'+K+'" alt="'+$e+'"';return ie&&(we+=' title="'+ie+'"'),we+=this.options.xhtml?"/>":">",we},re.text=function(K){return K},se}(),X=function(){function se(){}var re=se.prototype;return re.strong=function(K){return K},re.em=function(K){return K},re.codespan=function(K){return K},re.del=function(K){return K},re.html=function(K){return K},re.text=function(K){return K},re.link=function(K,ie,$e){return""+$e},re.image=function(K,ie,$e){return""+$e},re.br=function(){return""},se}(),Y=function(){function se(){this.seen={}}var re=se.prototype;return re.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(K,ie){var $e=K,we=0;if(this.seen.hasOwnProperty($e)){we=this.seen[K];do we++,$e=K+"-"+we;while(this.seen.hasOwnProperty($e))}return ie||(this.seen[K]=we,this.seen[$e]=0),$e},re.slug=function(K,ie){ie===void 0&&(ie={});var $e=this.serialize(K);return this.getNextSafeSlug($e,ie.dryrun)},se}(),x=function(){function se(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Y}se.parse=function(K,ie){var $e=new se(ie);return $e.parse(K)},se.parseInline=function(K,ie){var $e=new se(ie);return $e.parseInline(K)};var re=se.prototype;return re.parse=function(K,ie){ie===void 0&&(ie=!0);var $e="",we,Ne,fe,De,Ie,Fe,V,q,J,Q,he,be,ze,qe,Ye,it,ot,nt,st,Ce=K.length;for(we=0;we<Ce;we++){if(Q=K[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(st=this.options.extensions.renderers[Q.type].call({parser:this},Q),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){$e+=st||"";continue}switch(Q.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,g(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(q="",V="",De=Q.header.length,Ne=0;Ne<De;Ne++)V+=this.renderer.tablecell(this.parseInline(Q.header[Ne].tokens),{header:!0,align:Q.align[Ne]});for(q+=this.renderer.tablerow(V),J="",De=Q.rows.length,Ne=0;Ne<De;Ne++){for(Fe=Q.rows[Ne],V="",Ie=Fe.length,fe=0;fe<Ie;fe++)V+=this.renderer.tablecell(this.parseInline(Fe[fe].tokens),{header:!1,align:Q.align[fe]});J+=this.renderer.tablerow(V)}$e+=this.renderer.table(q,J);continue}case"blockquote":{J=this.parse(Q.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(he=Q.ordered,be=Q.start,ze=Q.loose,De=Q.items.length,J="",Ne=0;Ne<De;Ne++)Ye=Q.items[Ne],it=Ye.checked,ot=Ye.task,qe="",Ye.task&&(nt=this.renderer.checkbox(it),ze?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=nt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=nt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Ye.tokens,ze),J+=this.renderer.listitem(qe,ot,it);$e+=this.renderer.list(J,he,be);continue}case"html":{$e+=this.renderer.html(Q.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(J=Q.tokens?this.parseInline(Q.tokens):Q.text;we+1<Ce&&K[we+1].type==="text";)Q=K[++we],J+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);$e+=ie?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return $e},re.parseInline=function(K,ie){ie=ie||this.renderer;var $e="",we,Ne,fe,De=K.length;for(we=0;we<De;we++){if(Ne=K[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(fe=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){$e+=fe||"";continue}switch(Ne.type){case"escape":{$e+=ie.text(Ne.text);break}case"html":{$e+=ie.html(Ne.text);break}case"link":{$e+=ie.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,ie));break}case"image":{$e+=ie.image(Ne.href,Ne.title,Ne.text);break}case"strong":{$e+=ie.strong(this.parseInline(Ne.tokens,ie));break}case"em":{$e+=ie.em(this.parseInline(Ne.tokens,ie));break}case"codespan":{$e+=ie.codespan(Ne.text);break}case"br":{$e+=ie.br();break}case"del":{$e+=ie.del(this.parseInline(Ne.tokens,ie));break}case"text":{$e+=ie.text(Ne.text);break}default:{var Ie='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return $e},se}();function ne(se,re,oe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof re=="function"&&(oe=re,re=null),re=f({},ne.defaults,re||{}),k(re),oe){var K=re.highlight,ie;try{ie=W.lex(se,re)}catch(De){return oe(De)}var $e=function(Ie){var Fe;if(!Ie)try{re.walkTokens&&ne.walkTokens(ie,re.walkTokens),Fe=x.parse(ie,re)}catch(V){Ie=V}return re.highlight=K,Ie?oe(Ie):oe(null,Fe)};if(!K||K.length<3||(delete re.highlight,!ie.length))return $e();var we=0;ne.walkTokens(ie,function(De){De.type==="code"&&(we++,setTimeout(function(){K(De.text,De.lang,function(Ie,Fe){if(Ie)return $e(Ie);Fe!=null&&Fe!==De.text&&(De.text=Fe,De.escaped=!0),we--,we===0&&$e()})},0))}),we===0&&$e();return}function Ne(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+w(De.message+"",!0)+"</pre>";throw De}try{var fe=W.lex(se,re);if(re.walkTokens){if(re.async)return Promise.all(ne.walkTokens(fe,re.walkTokens)).then(function(){return x.parse(fe,re)}).catch(Ne);ne.walkTokens(fe,re.walkTokens)}return x.parse(fe,re)}catch(De){Ne(De)}}ne.options=ne.setOptions=function(se){return f(ne.defaults,se),b(ne.defaults),ne},ne.getDefaults=R,ne.defaults=le.defaults,ne.use=function(){for(var se=arguments.length,re=new Array(se),oe=0;oe<se;oe++)re[oe]=arguments[oe];var K=f.apply(void 0,[{}].concat(re)),ie=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;re.forEach(function(we){if(we.extensions&&($e=!0,we.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ie.renderers?ie.renderers[fe.name]:null;De?ie.renderers[fe.name]=function(){for(var Ie=arguments.length,Fe=new Array(Ie),V=0;V<Ie;V++)Fe[V]=arguments[V];var q=fe.renderer.apply(this,Fe);return q===!1&&(q=De.apply(this,Fe)),q}:ie.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[fe.level]?ie[fe.level].unshift(fe.tokenizer):ie[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ie.startBlock?ie.startBlock.push(fe.start):ie.startBlock=[fe.start]:fe.level==="inline"&&(ie.startInline?ie.startInline.push(fe.start):ie.startInline=[fe.start]))}fe.childTokens&&(ie.childTokens[fe.name]=fe.childTokens)})),we.renderer&&function(){var fe=ne.defaults.renderer||new Z,De=function(V){var q=fe[V];fe[V]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var be=we.renderer[V].apply(fe,Q);return be===!1&&(be=q.apply(fe,Q)),be}};for(var Ie in we.renderer)De(Ie);K.renderer=fe}(),we.tokenizer&&function(){var fe=ne.defaults.tokenizer||new j,De=function(V){var q=fe[V];fe[V]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var be=we.tokenizer[V].apply(fe,Q);return be===!1&&(be=q.apply(fe,Q)),be}};for(var Ie in we.tokenizer)De(Ie);K.tokenizer=fe}(),we.walkTokens){var Ne=ne.defaults.walkTokens;K.walkTokens=function(fe){var De=[];return De.push(we.walkTokens.call(this,fe)),Ne&&(De=De.concat(Ne.call(this,fe))),De}}$e&&(K.extensions=ie),ne.setOptions(K)})},ne.walkTokens=function(se,re){for(var oe=[],K=function(){var Ne=$e.value;switch(oe=oe.concat(re.call(ne,Ne)),Ne.type){case"table":{for(var fe=A(Ne.header),De;!(De=fe()).done;){var Ie=De.value;oe=oe.concat(ne.walkTokens(Ie.tokens,re))}for(var Fe=A(Ne.rows),V;!(V=Fe()).done;)for(var q=V.value,J=A(q),Q;!(Q=J()).done;){var he=Q.value;oe=oe.concat(ne.walkTokens(he.tokens,re))}break}case"list":{oe=oe.concat(ne.walkTokens(Ne.items,re));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Ne.type]?ne.defaults.extensions.childTokens[Ne.type].forEach(function(be){oe=oe.concat(ne.walkTokens(Ne[be],re))}):Ne.tokens&&(oe=oe.concat(ne.walkTokens(Ne.tokens,re)))}},ie=A(se),$e;!($e=ie()).done;)K();return oe},ne.parseInline=function(se,re){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");re=f({},ne.defaults,re||{}),k(re);try{var oe=W.lexInline(se,re);return re.walkTokens&&ne.walkTokens(oe,re.walkTokens),x.parseInline(oe,re)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+w(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=Z,ne.TextRenderer=X,ne.Lexer=W,ne.lexer=W.lex,ne.Tokenizer=j,ne.Slugger=Y,ne.parse=ne;var ge=ne.options,ue=ne.setOptions,ve=ne.use,te=ne.walkTokens,U=ne.parseInline,_=ne,pe=x.parse,Pe=W.lex;le.Lexer=W,le.Parser=x,le.Renderer=Z,le.Slugger=Y,le.TextRenderer=X,le.Tokenizer=j,le.getDefaults=R,le.lexer=Pe,le.marked=ne,le.options=ge,le.parse=_,le.parseInline=U,le.parser=pe,le.setOptions=ue,le.use=ve,le.walkTokens=te,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=l;function l(d){const g=A(d);if(g&&g.length>0)return new Uint32Array(g)}let M=0;const L=new Uint32Array(10);function A(d){if(M=0,R(d,C,4352),M>0||(R(d,m,4449),M>0)||(R(d,y,4520),M>0)||(R(d,w,12593),M))return L.subarray(0,M);if(d>=44032&&d<=55203){const g=d-44032,a=g%588,i=Math.floor(g/588),n=Math.floor(a/28),u=a%28-1;if(i<C.length?R(i,C,0):4352+i-12593<w.length&&R(4352+i,w,12593),n<m.length?R(n,m,0):4449+n-12593<w.length&&R(4449+n-12593,w,12593),u>=0&&(u<y.length?R(u,y,0):4520+u-12593<w.length&&R(4520+u-12593,w,12593)),M>0)return L.subarray(0,M)}}function R(d,g,a){d>=a&&d<a+g.length&&b(g[d-a])}function b(d){d!==0&&(L[M++]=d&255,d>>8&&(L[M++]=d>>8&255),d>>16&&(L[M++]=d>>16&255))}var $;(function(d){d[d.InitialConsonant=4352]="InitialConsonant",d[d.Vowel=4449]="Vowel",d[d.FinalConsonant=4520]="FinalConsonant",d[d.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var S;(function(d){d[d.NUL=0]="NUL",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z"})(S||(S={}));var N;(function(d){d[d.fa=24934]="fa",d[d.fg=26470]="fg",d[d.fq=29030]="fq",d[d.fr=29286]="fr",d[d.ft=29798]="ft",d[d.fv=30310]="fv",d[d.fx=30822]="fx",d[d.hk=27496]="hk",d[d.hl=27752]="hl",d[d.ho=28520]="ho",d[d.ml=27757]="ml",d[d.nj=27246]="nj",d[d.nl=27758]="nl",d[d.np=28782]="np",d[d.qt=29809]="qt",d[d.rt=29810]="rt",d[d.sg=26483]="sg",d[d.sw=30579]="sw"})(N||(N={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,27]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=void 0,e.$$l=L,e.$_l=R;const M=new l.$Ec(1e4);function L(S){return $(S,"NFC",M)}const A=new l.$Ec(1e4);function R(S){return $(S,"NFD",A)}const b=/[^\u0000-\u0080]/;function $(S,N,C){if(!S)return S;const m=C.get(S);if(m)return m;let y;return b.test(S)?y=S.normalize(N):y=S,C.set(S,y),y}e.$am=function(){const S=/[\u0300-\u036f]/g;return function(N){return R(N).replace(S,"")}}()}),define(ke[125],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0,e.$ym=l,e.rot=M;function l(b,$,S){return Math.min(Math.max(b,$),S)}function M(b,$){return($+b%$)%$}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$Am=L;class A{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Bm=A;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const S=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Cm=R}),function(){function le(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function R($){A.push($,Date.now())}function b(){const $=[];for(let S=0;S<A.length;S+=2)$.push({name:A[S],startTime:A[S+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(L+R.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function l(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=l(M))}(),define(ke[167],Se([1,0,39]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=void 0;const M=Symbol("unset");class L{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||l.Iterable.empty()}insert($,S,N){this.d($,C=>C._value=S,N)}mutate($,S){this.d($,N=>N._value=S(N._value===M?void 0:N._value))}delete($){const S=this.c($);if(!S)return;let N=S.length-1;const C=S[N].node._value;if(C!==M){for(this.b--,S[N].node._value=M;N>0;N--){const{node:m,part:y}=S[N];if(m.children?.size||m._value!==M)break;S[N-1].node.children.delete(y)}return C}}*deleteRecursive($){const S=this.c($);if(!S)return;const N=S[S.length-1].node;for(let C=S.length-1;C>0;C--){const m=S[C-1];if(m.node.children.delete(S[C].part),m.node.children.size>0||m.node._value!==M)break}for(const C of A(N))C._value!==M&&(this.b--,yield C._value)}find($){let S=this.a;for(const N of $){const C=S.children?.get(N);if(!C)return;S=C}return S._value===M?void 0:S._value}hasKeyOrParent($){let S=this.a;for(const N of $){const C=S.children?.get(N);if(!C)return!1;if(C._value!==M)return!0;S=C}return!1}hasKeyOrChildren($){let S=this.a;for(const N of $){const C=S.children?.get(N);if(!C)return!1;S=C}return!0}hasKey($){let S=this.a;for(const N of $){const C=S.children?.get(N);if(!C)return!1;S=C}return S._value!==M}c($){const S=[{part:"",node:this.a}];let N=0;for(const C of $){const m=S[N].node.children?.get(C);if(!m)return;S.push({part:C,node:m}),N++}return S}d($,S,N){let C=this.a;for(const w of $){if(C.children)if(C.children.has(w))C=C.children.get(w);else{const d=new R;C.children.set(w,d),C=d}else{const d=new R;C.children=new Map([[w,d]]),C=d}N?.(C)}const m=C._value===M?0:1;S(C);const y=C._value===M?0:1;this.b+=y-m}*values(){for(const{_value:$}of A(this.a))$!==M&&(yield $)}}e.$9O=L;function*A(b){const $=[b];for(;$.length>0;){const S=$.pop();if(yield S,S.children)for(const N of S.children.values())$.push(N)}}class R{constructor(){this._value=M}get value(){return this._value===M?void 0:this._value}set value($){this._value=$===void 0?M:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var M in l)(typeof exports=="object"?exports:le)[M]=l[M]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function l(M){if(e[M])return e[M].exports;var L=e[M]={i:M,l:!1,exports:{}};return le[M].call(L.exports,L,L.exports,l),L.l=!0,L.exports}return l.m=le,l.c=e,l.d=function(M,L,A){l.o(M,L)||Object.defineProperty(M,L,{enumerable:!0,get:A})},l.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},l.t=function(M,L){if(1&L&&(M=l(M)),8&L||4&L&&typeof M=="object"&&M&&M.__esModule)return M;var A=Object.create(null);if(l.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:M}),2&L&&typeof M!="string")for(var R in M)l.d(A,R,function(b){return M[b]}.bind(null,R));return A},l.n=function(M){var L=M&&M.__esModule?function(){return M.default}:function(){return M};return l.d(L,"a",L),L},l.o=function(M,L){return Object.prototype.hasOwnProperty.call(M,L)},l.p="",l(l.s=0)}([function(le,e,l){(function(M){var L;e=le.exports=ve,L=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],S=0,N=S++;$[N]="0|[1-9]\\d*";var C=S++;$[C]="[0-9]+";var m=S++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=S++;$[y]="("+$[N]+")\\.("+$[N]+")\\.("+$[N]+")";var w=S++;$[w]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var d=S++;$[d]="(?:"+$[N]+"|"+$[m]+")";var g=S++;$[g]="(?:"+$[C]+"|"+$[m]+")";var a=S++;$[a]="(?:-("+$[d]+"(?:\\."+$[d]+")*))";var i=S++;$[i]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var n=S++;$[n]="[0-9A-Za-z-]+";var u=S++;$[u]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var o=S++,t="v?"+$[y]+$[a]+"?"+$[u]+"?";$[o]="^"+t+"$";var h="[v=\\s]*"+$[w]+$[i]+"?"+$[u]+"?",s=S++;$[s]="^"+h+"$";var c=S++;$[c]="((?:<|>)?=?)";var r=S++;$[r]=$[C]+"|x|X|\\*";var v=S++;$[v]=$[N]+"|x|X|\\*";var f=S++;$[f]="[v=\\s]*("+$[v]+")(?:\\.("+$[v]+")(?:\\.("+$[v]+")(?:"+$[a]+")?"+$[u]+"?)?)?";var D=S++;$[D]="[v=\\s]*("+$[r]+")(?:\\.("+$[r]+")(?:\\.("+$[r]+")(?:"+$[i]+")?"+$[u]+"?)?)?";var p=S++;$[p]="^"+$[c]+"\\s*"+$[f]+"$";var E=S++;$[E]="^"+$[c]+"\\s*"+$[D]+"$";var k=S++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;$[P]="(?:~>?)";var I=S++;$[I]="(\\s*)"+$[P]+"\\s+",b[I]=new RegExp($[I],"g");var T=S++;$[T]="^"+$[P]+$[f]+"$";var j=S++;$[j]="^"+$[P]+$[D]+"$";var z=S++;$[z]="(?:\\^)";var O=S++;$[O]="(\\s*)"+$[z]+"\\s+",b[O]=new RegExp($[O],"g");var F=S++;$[F]="^"+$[z]+$[f]+"$";var B=S++;$[B]="^"+$[z]+$[D]+"$";var W=S++;$[W]="^"+$[c]+"\\s*("+h+")$|^$";var Z=S++;$[Z]="^"+$[c]+"\\s*("+t+")$|^$";var X=S++;$[X]="(\\s*)"+$[c]+"\\s*("+h+"|"+$[f]+")",b[X]=new RegExp($[X],"g");var Y=S++;$[Y]="^\\s*("+$[f]+")\\s+-\\s+("+$[f]+")\\s*$";var x=S++;$[x]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ne=S++;$[ne]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)L(ge,$[ge]),b[ge]||(b[ge]=new RegExp($[ge]));function ue(q,J){if(q instanceof ve)return q;if(typeof q!="string"||q.length>A||!(J?b[s]:b[o]).test(q))return null;try{return new ve(q,J)}catch{return null}}function ve(q,J){if(q instanceof ve){if(q.loose===J)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ve))return new ve(q,J);L("SemVer",q,J),this.loose=J;var Q=q.trim().match(J?b[s]:b[o]);if(!Q)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var be=+he;if(be>=0&&be<R)return be}return he}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=ue,e.valid=function(q,J){var Q=ue(q,J);return Q?Q.version:null},e.clean=function(q,J){var Q=ue(q.trim().replace(/^[=v]+/,""),J);return Q?Q.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return L("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),U(this.major,q.major)||U(this.minor,q.minor)||U(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var J=0;do{var Q=this.prerelease[J],he=q.prerelease[J];if(L("prerelease compare",J,Q,he),Q===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Q===void 0)return-1;if(Q!==he)return U(Q,he)}while(++J)},ve.prototype.inc=function(q,J){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,J,Q,he){typeof Q=="string"&&(he=Q,Q=void 0);try{return new ve(q,Q).inc(J,he).version}catch{return null}},e.diff=function(q,J){if(se(q,J))return null;var Q=ue(q),he=ue(J);if(Q.prerelease.length||he.prerelease.length){for(var be in Q)if((be==="major"||be==="minor"||be==="patch")&&Q[be]!==he[be])return"pre"+be;return"prerelease"}for(var be in Q)if((be==="major"||be==="minor"||be==="patch")&&Q[be]!==he[be])return be},e.compareIdentifiers=U;var te=/^[0-9]+$/;function U(q,J){var Q=te.test(q),he=te.test(J);return Q&&he&&(q=+q,J=+J),Q&&!he?-1:he&&!Q?1:q<J?-1:q>J?1:0}function _(q,J,Q){return new ve(q,Q).compare(new ve(J,Q))}function pe(q,J,Q){return _(q,J,Q)>0}function Pe(q,J,Q){return _(q,J,Q)<0}function se(q,J,Q){return _(q,J,Q)===0}function re(q,J,Q){return _(q,J,Q)!==0}function oe(q,J,Q){return _(q,J,Q)>=0}function K(q,J,Q){return _(q,J,Q)<=0}function ie(q,J,Q,he){var be;switch(J){case"===":typeof q=="object"&&(q=q.version),typeof Q=="object"&&(Q=Q.version),be=q===Q;break;case"!==":typeof q=="object"&&(q=q.version),typeof Q=="object"&&(Q=Q.version),be=q!==Q;break;case"":case"=":case"==":be=se(q,Q,he);break;case"!=":be=re(q,Q,he);break;case">":be=pe(q,Q,he);break;case">=":be=oe(q,Q,he);break;case"<":be=Pe(q,Q,he);break;case"<=":be=K(q,Q,he);break;default:throw new TypeError("Invalid operator: "+J)}return be}function $e(q,J){if(q instanceof $e){if(q.loose===J)return q;q=q.value}if(!(this instanceof $e))return new $e(q,J);L("comparator",q,J),this.loose=J,this.parse(q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(q,J){return U(J,q)},e.major=function(q,J){return new ve(q,J).major},e.minor=function(q,J){return new ve(q,J).minor},e.patch=function(q,J){return new ve(q,J).patch},e.compare=_,e.compareLoose=function(q,J){return _(q,J,!0)},e.rcompare=function(q,J,Q){return _(J,q,Q)},e.sort=function(q,J){return q.sort(function(Q,he){return e.compare(Q,he,J)})},e.rsort=function(q,J){return q.sort(function(Q,he){return e.rcompare(Q,he,J)})},e.gt=pe,e.lt=Pe,e.eq=se,e.neq=re,e.gte=oe,e.lte=K,e.cmp=ie,e.Comparator=$e;var we={};function Ne(q,J){if(q instanceof Ne)return q.loose===J?q:new Ne(q.raw,J);if(q instanceof $e)return new Ne(q.value,J);if(!(this instanceof Ne))return new Ne(q,J);if(this.loose=J,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function fe(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,J,Q,he,be,ze,qe,Ye,it,ot,nt,st,Ce){return((J=fe(Q)?"":fe(he)?">="+Q+".0.0":fe(be)?">="+Q+"."+he+".0":">="+J)+" "+(Ye=fe(it)?"":fe(ot)?"<"+(+it+1)+".0.0":fe(nt)?"<"+it+"."+(+ot+1)+".0":st?"<="+it+"."+ot+"."+nt+"-"+st:"<="+Ye)).trim()}function Ie(q,J){for(var Q=0;Q<q.length;Q++)if(!q[Q].test(J))return!1;if(J.prerelease.length){for(Q=0;Q<q.length;Q++)if(L(q[Q].semver),q[Q].semver!==we&&q[Q].semver.prerelease.length>0){var he=q[Q].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function Fe(q,J,Q){try{J=new Ne(J,Q)}catch{return!1}return J.test(q)}function V(q,J,Q,he){var be,ze,qe,Ye,it;switch(q=new ve(q,he),J=new Ne(J,he),Q){case">":be=pe,ze=K,qe=Pe,Ye=">",it=">=";break;case"<":be=Pe,ze=oe,qe=pe,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(q,J,he))return!1;for(var ot=0;ot<J.set.length;++ot){var nt=J.set[ot],st=null,Ce=null;if(nt.forEach(function(Be){Be.semver===we&&(Be=new $e(">=0.0.0")),st=st||Be,Ce=Ce||Be,be(Be.semver,st.semver,he)?st=Be:qe(Be.semver,Ce.semver,he)&&(Ce=Be)}),st.operator===Ye||st.operator===it||(!Ce.operator||Ce.operator===Ye)&&ze(q,Ce.semver)||Ce.operator===it&&qe(q,Ce.semver))return!1}return!0}$e.prototype.parse=function(q){var J=this.loose?b[W]:b[Z],Q=q.match(J);if(!Q)throw new TypeError("Invalid comparator: "+q);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new ve(Q[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(q){return L("Comparator.test",q,this.loose),this.semver===we||(typeof q=="string"&&(q=new ve(q,this.loose)),ie(q,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(q,J){if(!(q instanceof $e))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ne(q.value,J),Fe(this.value,Q,J);if(q.operator==="")return Q=new Ne(this.value,J),Fe(q.semver,Q,J);var he=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),ze=this.semver.version===q.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ye=ie(this.semver,"<",q.semver,J)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),it=ie(this.semver,">",q.semver,J)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return he||be||ze&&qe||Ye||it},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(q){var J=this.loose;q=q.trim(),L("range",q,J);var Q=J?b[x]:b[Y];q=q.replace(Q,De),L("hyphen replace",q),q=q.replace(b[X],"$1$2$3"),L("comparator trim",q,b[X]),q=(q=(q=q.replace(b[I],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var he=J?b[W]:b[Z],be=q.split(" ").map(function(ze){return function(qe,Ye){return L("comp",qe),qe=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){L("caret",st,Ce);var Be=Ce?b[B]:b[F];return st.replace(Be,function(Ge,Me,Ze,ae,ce){var Ae;return L("caret",st,Ge,Me,Ze,ae,ce),fe(Me)?Ae="":fe(Ze)?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":fe(ae)?Ae=Me==="0"?">="+Me+"."+Ze+".0 <"+Me+"."+(+Ze+1)+".0":">="+Me+"."+Ze+".0 <"+(+Me+1)+".0.0":ce?(L("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ae=Me==="0"?Ze==="0"?">="+Me+"."+Ze+"."+ae+ce+" <"+Me+"."+Ze+"."+(+ae+1):">="+Me+"."+Ze+"."+ae+ce+" <"+Me+"."+(+Ze+1)+".0":">="+Me+"."+Ze+"."+ae+ce+" <"+(+Me+1)+".0.0"):(L("no pr"),Ae=Me==="0"?Ze==="0"?">="+Me+"."+Ze+"."+ae+" <"+Me+"."+Ze+"."+(+ae+1):">="+Me+"."+Ze+"."+ae+" <"+Me+"."+(+Ze+1)+".0":">="+Me+"."+Ze+"."+ae+" <"+(+Me+1)+".0.0"),L("caret return",Ae),Ae})}(nt,ot)}).join(" ")}(qe,Ye),L("caret",qe),qe=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){var Be=Ce?b[j]:b[T];return st.replace(Be,function(Ge,Me,Ze,ae,ce){var Ae;return L("tilde",st,Ge,Me,Ze,ae,ce),fe(Me)?Ae="":fe(Ze)?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":fe(ae)?Ae=">="+Me+"."+Ze+".0 <"+Me+"."+(+Ze+1)+".0":ce?(L("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ae=">="+Me+"."+Ze+"."+ae+ce+" <"+Me+"."+(+Ze+1)+".0"):Ae=">="+Me+"."+Ze+"."+ae+" <"+Me+"."+(+Ze+1)+".0",L("tilde return",Ae),Ae})}(nt,ot)}).join(" ")}(qe,Ye),L("tildes",qe),qe=function(it,ot){return L("replaceXRanges",it,ot),it.split(/\s+/).map(function(nt){return function(st,Ce){st=st.trim();var Be=Ce?b[E]:b[p];return st.replace(Be,function(Ge,Me,Ze,ae,ce,Ae){L("xRange",st,Ge,Me,Ze,ae,ce,Ae);var Ke=fe(Ze),Re=Ke||fe(ae),tt=Re||fe(ce);return Me==="="&&tt&&(Me=""),Ke?Ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&tt?(Re&&(ae=0),tt&&(ce=0),Me===">"?(Me=">=",Re?(Ze=+Ze+1,ae=0,ce=0):tt&&(ae=+ae+1,ce=0)):Me==="<="&&(Me="<",Re?Ze=+Ze+1:ae=+ae+1),Ge=Me+Ze+"."+ae+"."+ce):Re?Ge=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":tt&&(Ge=">="+Ze+"."+ae+".0 <"+Ze+"."+(+ae+1)+".0"),L("xRange return",Ge),Ge})}(nt,ot)}).join(" ")}(qe,Ye),L("xrange",qe),qe=function(it,ot){return L("replaceStars",it,ot),it.trim().replace(b[ne],"")}(qe,Ye),L("stars",qe),qe}(ze,J)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(ze){return!!ze.match(he)})),be=be.map(function(ze){return new $e(ze,J)})},Ne.prototype.intersects=function(q,J){if(!(q instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(he){return q.set.some(function(be){return be.every(function(ze){return he.intersects(ze,J)})})})})},e.toComparators=function(q,J){return new Ne(q,J).set.map(function(Q){return Q.map(function(he){return he.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],q))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(q,J,Q){var he=null,be=null;try{var ze=new Ne(J,Q)}catch{return null}return q.forEach(function(qe){ze.test(qe)&&(he&&be.compare(qe)!==-1||(be=new ve(he=qe,Q)))}),he},e.minSatisfying=function(q,J,Q){var he=null,be=null;try{var ze=new Ne(J,Q)}catch{return null}return q.forEach(function(qe){ze.test(qe)&&(he&&be.compare(qe)!==1||(be=new ve(he=qe,Q)))}),he},e.validRange=function(q,J){try{return new Ne(q,J).range||"*"}catch{return null}},e.ltr=function(q,J,Q){return V(q,J,"<",Q)},e.gtr=function(q,J,Q){return V(q,J,">",Q)},e.outside=V,e.prerelease=function(q,J){var Q=ue(q,J);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(q,J,Q){return q=new Ne(q,Q),J=new Ne(J,Q),q.intersects(J)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var J=q.match(b[k]);return J==null?null:ue((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,l(1))},function(le,e){var l,M,L=le.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(g){if(l===setTimeout)return setTimeout(g,0);if((l===A||!l)&&setTimeout)return l=setTimeout,setTimeout(g,0);try{return l(g,0)}catch{try{return l.call(null,g,0)}catch{return l.call(this,g,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:A}catch{l=A}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var $,S=[],N=!1,C=-1;function m(){N&&$&&(N=!1,$.length?S=$.concat(S):C=-1,S.length&&y())}function y(){if(!N){var g=b(m);N=!0;for(var a=S.length;a;){for($=S,S=[];++C<a;)$&&$[C].run();C=-1,a=S.length}$=null,N=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(g)}}function w(g,a){this.fun=g,this.array=a}function d(){}L.nextTick=function(g){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];S.push(new w(g,a)),S.length!==1||N||b(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=d,L.addListener=d,L.once=d,L.off=d,L.removeListener=d,L.removeAllListeners=d,L.emit=d,L.prependListener=d,L.prependOnceListener=d,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[40],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(A){return new M(A)}constructor(A){this.c=l&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$$d=M}),define(ke[4],Se([1,0,13,74,3,75,40]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$ae=e.Event=void 0,e.$be=y;const b=!1,$=!1,S=!1;var N;(function(I){I.None=()=>L.$Vc.None;function T(Ne){if(S){const{onDidAddListener:fe}=Ne,De=d.create();let Ie=0;Ne.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function j(Ne,fe){return ne(Ne,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Ne){return(fe,De=null,Ie)=>{let Fe=!1,V;return V=Ne(q=>{if(!Fe)return V?V.dispose():Fe=!0,fe.call(De,q)},null,Ie),Fe&&V.dispose(),V}}I.once=z;function O(Ne,fe,De){return Y((Ie,Fe=null,V)=>Ne(q=>Ie.call(Fe,fe(q)),null,V),De)}I.map=O;function F(Ne,fe,De){return Y((Ie,Fe=null,V)=>Ne(q=>{fe(q),Ie.call(Fe,q)},null,V),De)}I.forEach=F;function B(Ne,fe,De){return Y((Ie,Fe=null,V)=>Ne(q=>fe(q)&&Ie.call(Fe,q),null,V),De)}I.filter=B;function W(Ne){return Ne}I.signal=W;function Z(...Ne){return(fe,De=null,Ie)=>{const Fe=(0,L.$Sc)(...Ne.map(V=>V(q=>fe.call(De,q))));return x(Fe,Ie)}}I.any=Z;function X(Ne,fe,De,Ie){let Fe=De;return O(Ne,V=>(Fe=fe(Fe,V),Fe),Ie)}I.reduce=X;function Y(Ne,fe){let De;const Ie={onWillAddFirstListener(){De=Ne(Fe.fire,Fe)},onDidRemoveLastListener(){De?.dispose()}};fe||T(Ie);const Fe=new o(Ie);return fe?.add(Fe),Fe.event}function x(Ne,fe){return fe instanceof Array?fe.push(Ne):fe&&fe.add(Ne),Ne}function ne(Ne,fe,De=100,Ie=!1,Fe=!1,V,q){let J,Q,he,be=0,ze;const qe={leakWarningThreshold:V,onWillAddFirstListener(){J=Ne(it=>{be++,Q=fe(Q,it),Ie&&!he&&(Ye.fire(Q),Q=void 0),ze=()=>{const ot=Q;Q=void 0,he=void 0,(!Ie||be>1)&&Ye.fire(ot),be=0},typeof De=="number"?(clearTimeout(he),he=setTimeout(ze,De)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){Fe&&be>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,J.dispose()}};q||T(qe);const Ye=new o(qe);return q?.add(Ye),Ye.event}I.debounce=ne;function ge(Ne,fe=0,De){return I.debounce(Ne,(Ie,Fe)=>Ie?(Ie.push(Fe),Ie):[Fe],fe,void 0,!0,void 0,De)}I.accumulate=ge;function ue(Ne,fe=(Ie,Fe)=>Ie===Fe,De){let Ie=!0,Fe;return B(Ne,V=>{const q=Ie||!fe(V,Fe);return Ie=!1,Fe=V,q},De)}I.latch=ue;function ve(Ne,fe,De){return[I.filter(Ne,fe,De),I.filter(Ne,Ie=>!fe(Ie),De)]}I.split=ve;function te(Ne,fe=!1,De=[],Ie){let Fe=De.slice(),V=Ne(Q=>{Fe?Fe.push(Q):J.fire(Q)});Ie&&Ie.add(V);const q=()=>{Fe?.forEach(Q=>J.fire(Q)),Fe=null},J=new o({onWillAddFirstListener(){V||(V=Ne(Q=>J.fire(Q)),Ie&&Ie.add(V))},onDidAddFirstListener(){Fe&&(fe?setTimeout(q):q())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Ie&&Ie.add(J),J.event}I.buffer=te;function U(Ne,fe){return(Ie,Fe,V)=>{const q=fe(new pe);return Ne(function(J){const Q=q.evaluate(J);Q!==_&&Ie.call(Fe,Q)},void 0,V)}}I.chain=U;const _=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(De=>(fe(De),De)),this}filter(fe){return this.f.push(De=>fe(De)?De:_),this}reduce(fe,De){let Ie=De;return this.f.push(Fe=>(Ie=fe(Ie,Fe),Ie)),this}latch(fe=(De,Ie)=>De===Ie){let De=!0,Ie;return this.f.push(Fe=>{const V=De||!fe(Fe,Ie);return De=!1,Ie=Fe,V?Fe:_}),this}evaluate(fe){for(const De of this.f)if(fe=De(fe),fe===_)break;return fe}}function Pe(Ne,fe,De=Ie=>Ie){const Ie=(...J)=>q.fire(De(...J)),Fe=()=>Ne.on(fe,Ie),V=()=>Ne.removeListener(fe,Ie),q=new o({onWillAddFirstListener:Fe,onDidRemoveLastListener:V});return q.event}I.fromNodeEventEmitter=Pe;function se(Ne,fe,De=Ie=>Ie){const Ie=(...J)=>q.fire(De(...J)),Fe=()=>Ne.addEventListener(fe,Ie),V=()=>Ne.removeEventListener(fe,Ie),q=new o({onWillAddFirstListener:Fe,onDidRemoveLastListener:V});return q.event}I.fromDOMEventEmitter=se;function re(Ne){return new Promise(fe=>z(Ne)(fe))}I.toPromise=re;function oe(Ne){const fe=new o;return Ne.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=oe;function K(Ne,fe,De){return fe(De),Ne(Ie=>fe(Ie))}I.runAndSubscribe=K;class ie{constructor(fe,De){this._observable=fe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||T(Ie),this.emitter=new o(Ie),De&&De.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,De){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Ne,fe){return new ie(Ne,fe).emitter.event}I.fromObservable=$e;function we(Ne){return(fe,De,Ie)=>{let Fe=0,V=!1;const q={beginUpdate(){Fe++},endUpdate(){Fe--,Fe===0&&(Ne.reportChanges(),V&&(V=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){V=!0}};Ne.addObserver(q),Ne.reportChanges();const J={dispose(){Ne.removeObserver(q)}};return Ie instanceof L.$Uc?Ie.add(J):Array.isArray(Ie)&&Ie.push(J),J}}I.fromObservableLight=we})(N||(e.Event=N={}));class C{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${C.f++}`,C.all.add(this)}start(T){this.g=new R.$$d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$ae=C;let m=-1;function y(I){const T=m;return m=I,{dispose(){m=T}}}class w{constructor(T,j=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=j,this.g=0}dispose(){this.f?.clear()}check(T,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const O=this.f.get(T.value)||0;if(this.f.set(T.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let F,B=0;for(const[W,Z]of this.f)(!F||B<Z)&&(F=W,B=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(F)}return()=>{const F=this.f.get(T.value)||0;this.f.set(T.value,F-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class a{constructor(T){this.value=T,this.id=g++}}const i=2,n=(I,T)=>{if(I instanceof a)T(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&T(z)}},u=b?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(T){this.w=0,this.f=T,this.g=m>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const T=this.t;queueMicrotask(()=>{n(T,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Vc.None;if(this.m)return L.$Vc.None;j&&(T=T.bind(j));const O=new a(T);let F,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=d.create(),F=this.g.check(O.stack,this.w+1)),$&&(O.stack=B??d.create()),this.t?this.t instanceof a?(this.u??=new h,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Tc)(()=>{u?.unregister(W),F?.(),this.x(O)});if(z instanceof L.$Uc?z.add(W):Array.isArray(z)&&z.push(W),u){const Z=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(W,Z,W)}return W},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(T);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const O=this.u.current===this;if(this.w*i<=j.length){let F=0;for(let B=0;B<j.length;B++)j[B]?j[F++]=j[B]:O&&(this.u.end--,F<this.u.i&&this.u.i--);j.length=F}}y(T,j){if(!T)return;const z=this.f?.onListenerError||l.$1;if(!z){T.value(j);return}try{T.value(j)}catch(O){z(O)}}z(T){const j=T.current.t;for(;T.i<T.end;)this.y(j[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,T);else{const j=this.u;j.enqueue(this,T,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ce=o;const t=()=>new h;e.$de=t;class h{constructor(){this.i=-1,this.end=0}enqueue(T,j,z){this.i=0,this.end=z,this.current=T,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends o{async fireAsync(T,j,z){if(this.t)for(this.h||(this.h=new A.$6c),n(this.t,O=>this.h.push([O.value,T]));this.h.size>0&&!j.isCancellationRequested;){const[O,F]=this.h.shift(),B=[],W={...F,token:j,waitUntil:Z=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(Z=z(Z,O)),B.push(Z)}};try{O(W)}catch(Z){(0,l.$1)(Z);continue}Object.freeze(B),await Promise.allSettled(B).then(Z=>{for(const X of Z)X.status==="rejected"&&(0,l.$1)(X.reason)})}}}e.$ee=s;class c extends o{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new A.$6c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$fe=c;class r extends c{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$ge=r;class v extends o{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$he=v;class f{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const j={event:T,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const O=this.h.indexOf(j);this.h.splice(O,1)};return(0,L.$Tc)((0,M.$db)(z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(j=>this.f.fire(j))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$ie=f;class D{constructor(T,j,z,O){this.f=new L.$Uc;const F=this.f.add(new f),B=this.f.add(new L.$5c);function W(Z){B.set(Z,F.add(O(Z)))}for(const Z of T)W(Z);this.f.add(j(Z=>{W(Z)})),this.f.add(z(Z=>{B.deleteAndDispose(Z)})),this.event=F.event}dispose(){this.f.dispose()}}e.$je=D;class p{constructor(){this.f=[]}wrapEvent(T){return(j,z,O)=>T(F=>{const B=this.f[this.f.length-1];B?B.push(()=>j.call(z,F)):j.call(z,F)},void 0,O)}bufferEvents(T){const j=[];this.f.push(j);const z=T();return this.f.pop(),j.forEach(O=>O()),z}}e.$ke=p;class E{constructor(){this.f=!1,this.g=N.None,this.h=L.$Vc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$le=E;class k{static const(T){return new P(T)}constructor(T){this.g=T,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$me=k;class P{constructor(T){this.value=T,this.onDidChange=N.None}}}),define(ke[22],Se([1,0,4]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.CancellationToken=void 0;const M=Object.freeze(function(b,$){const S=setTimeout(b.bind($),0);return{dispose(){clearTimeout(S)}}});var L;(function(b){function $(S){return S===b.None||S===b.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new l.$ce),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$ne=R}),define(ke[168],Se([1,0,22]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2e=e.$1e=e.$Ye=void 0,e.$Ze=L;class M{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new l.$ne,S=this.b($.token);return this.a={promise:S,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$Ye=M;function L(b){return b}class A{constructor($,S){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=L):(this.c=S,this.d=$.getCacheKey)}get($){const S=this.d($);return this.b!==S&&(this.b=S,this.a=this.c($)),this.a}}e.$1e=A;class R{get cachedValues(){return this.a}constructor($,S){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=L):(this.c=S,this.d=$.getCacheKey)}get($){const S=this.d($);if(this.b.has(S))return this.b.get(S);const N=this.c($);return this.a.set($,N),this.b.set(S,N),N}}e.$2e=R}),define(ke[98],Se([1,0,13,3]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=L,e.$pe=A,e.$qe=R,e.$re=b,e.$se=S,e.$te=N,e.$ue=C,e.$ve=m,e.$we=y,e.$xe=w,e.$ye=d,e.$ze=g,e.$Ae=a,e.$Be=i,e.$Ce=n;function L(u){const o=u;return o?typeof o.read=="function":!1}function A(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function R(u){const o=u;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(u,o){return new $(u,o)}class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,l.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let h;switch(o){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const s=h.indexOf(t);s>=0&&h.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(u,o){const t=[];let h;for(;(h=u.read())!==null;)t.push(h);return o(t)}function N(u,o,t){const h=[];let s;for(;(s=u.read())!==null&&h.length<t;)h.push(s);return s===null&&h.length>0?o(h):{read:()=>{if(h.length>0)return h.shift();if(typeof s<"u"){const c=s;return s=void 0,c}return u.read()}}}function C(u,o){return new Promise((t,h)=>{const s=[];m(u,{onData:c=>{o&&s.push(c)},onError:c=>{o?h(c):t(void 0)},onEnd:()=>{t(o?o(s):void 0)}})})}function m(u,o,t){u.on("error",h=>{t?.isCancellationRequested||o.onError(h)}),u.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),u.on("data",h=>{t?.isCancellationRequested||o.onData(h)})}function y(u,o){return new Promise((t,h)=>{const s=new M.$Uc,c=[],r=D=>{if(c.push(D),c.length>o)return s.dispose(),u.pause(),t({stream:u,buffer:c,ended:!1})},v=D=>(s.dispose(),h(D)),f=()=>(s.dispose(),t({stream:u,buffer:c,ended:!0}));s.add((0,M.$Tc)(()=>u.removeListener("error",v))),u.on("error",v),s.add((0,M.$Tc)(()=>u.removeListener("end",f))),u.on("end",f),s.add((0,M.$Tc)(()=>u.removeListener("data",r))),u.on("data",r)})}function w(u,o){const t=b(o);return t.end(u),t}function d(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}function g(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}function a(u,o,t){const h=b(t);return m(u,{onData:s=>h.write(o.data(s)),onError:s=>h.error(o.error?o.error(s):s),onEnd:()=>h.end()}),h}function i(u,o,t){let h=!1;return{read:()=>{const s=o.read();return h?s:(h=!0,s!==null?t([u,s]):u)}}}function n(u,o,t){let h=!1;const s=b(t);return m(o,{onData:c=>h?s.write(c):(h=!0,s.write(t([u,c]))),onError:c=>s.error(c),onEnd:()=>{h||(h=!0,s.write(u)),s.end()}}),s}}),define(ke[21],Se([1,0,46,98]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=void 0,e.$Ee=S,e.$Fe=N,e.$Ge=C,e.$He=m,e.$Ie=y,e.$Je=w,e.$Ke=d,e.$Le=g,e.$Me=a,e.$Ne=i,e.$Oe=n,e.$Pe=u,e.$Qe=o,e.$Re=t,e.$Se=h,e.$Te=s,e.$Ue=c,e.$Ve=r,e.$We=v,e.$Xe=p;const L=typeof Buffer<"u",A=new l.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(k){return L?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&L?new $(Buffer.from(k)):(R||(R=new TextEncoder),new $(R.encode(k)))}static fromByteArray(k){const P=$.alloc(k.length);for(let I=0,T=k.length;I<T;I++)P.buffer[I]=k[I];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let j=0,z=k.length;j<z;j++)P+=k[j].byteLength}const I=$.alloc(P);let T=0;for(let j=0,z=k.length;j<z;j++){const O=k[j];I.set(O,T),T+=O.byteLength}return I}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,P){return new $(this.buffer.subarray(k,P))}set(k,P){if(k instanceof $)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return m(this.buffer,k)}writeUInt32BE(k,P){y(this.buffer,k,P)}readUInt32LE(k){return w(this.buffer,k)}writeUInt32LE(k,P){d(this.buffer,k,P)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,P){a(this.buffer,k,P)}indexOf(k,P=0){return S(this.buffer,k instanceof $?k.buffer:k,P)}}e.$De=$;function S(E,k,P=0){const I=k.byteLength,T=E.byteLength;if(I===0)return 0;if(I===1)return E.indexOf(k[0]);if(I>T-P)return-1;const j=A.value;j.fill(k.length);for(let B=0;B<k.length;B++)j[k[B]]=k.length-B-1;let z=P+k.length-1,O=z,F=-1;for(;z<T;)if(E[z]===k[O]){if(O===0){F=z;break}z--,O--}else z+=Math.max(k.length-O,j[E[z]]),O=k.length-1;return F}function N(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function C(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255}function m(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function y(E,k,P){E[P+3]=k,k=k>>>8,E[P+2]=k,k=k>>>8,E[P+1]=k,k=k>>>8,E[P]=k}function w(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function d(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255,k=k>>>8,E[P+2]=k&255,k=k>>>8,E[P+3]=k&255}function g(E,k){return E[k]}function a(E,k,P){E[P]=k}function i(E){return M.$se(E,k=>$.concat(k))}function n(E){return M.$ze(E)}function u(E){return M.$ue(E,k=>$.concat(k))}async function o(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await u(E.stream)])}function t(E){return M.$xe(E,k=>$.concat(k))}function h(E){return M.$Ae(E,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function s(E){return M.$re(k=>$.concat(k),E)}function c(E,k){return M.$Be(E,k,P=>$.concat(P))}function r(E,k){return M.$Ce(E,k,P=>$.concat(P))}function v(E){let k=0,P=0,I=0;const T=new Uint8Array(Math.floor(E.length/4*3)),j=O=>{switch(P){case 3:T[I++]=k|O,P=0;break;case 2:T[I++]=k|O>>>2,k=O<<6,P=3;break;case 1:T[I++]=k|O>>>4,k=O<<4,P=2;break;default:k=O<<2,P=1}};for(let O=0;O<E.length;O++){const F=E.charCodeAt(O);if(F>=65&&F<=90)j(F-65);else if(F>=97&&F<=122)j(F-97+26);else if(F>=48&&F<=57)j(F-48+52);else if(F===43||F===45)j(62);else if(F===47||F===95)j(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${E[O]}`)}}const z=I;for(;P>0;)j(0);return $.wrap(T).slice(0,z)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:E},k=!0,P=!1){const I=P?D:f;let T="";const j=E.byteLength%3;let z=0;for(;z<E.byteLength-j;z+=3){const O=E[z+0],F=E[z+1],B=E[z+2];T+=I[O>>>2],T+=I[(O<<4|F>>>4)&63],T+=I[(F<<2|B>>>6)&63],T+=I[B&63]}if(j===1){const O=E[z+0];T+=I[O>>>2],T+=I[O<<4&63],k&&(T+="==")}else if(j===2){const O=E[z+0],F=E[z+1];T+=I[O>>>2],T+=I[(O<<4|F>>>4)&63],T+=I[F<<2&63],k&&(T+="=")}return T}}),define(ke[14],Se([1,0,168,46]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.GraphemeBreakType=e.$Sf=e.$Lf=e.$Ef=e.$Df=void 0,e.$5e=L,e.$6e=R,e.$7e=$,e.$8e=S,e.$9e=N,e.$0e=C,e.$$e=m,e.$_e=y,e.$af=w,e.$bf=d,e.$cf=g,e.$df=a,e.$ef=i,e.$ff=n,e.$gf=u,e.$hf=o,e.$if=t,e.$jf=h,e.$kf=s,e.$lf=c,e.$mf=r,e.$nf=v,e.$of=f,e.$pf=D,e.$qf=p,e.$rf=E,e.$sf=k,e.$tf=P,e.$uf=I,e.$vf=T,e.$wf=j,e.$xf=z,e.$yf=O,e.$zf=F,e.$Af=B,e.$Bf=W,e.$Cf=Z,e.$Ff=ne,e.$Gf=ge,e.$Hf=ue,e.$If=ve,e.$Jf=_,e.$Kf=Pe,e.$Mf=se,e.$Nf=re,e.$Of=oe,e.$Pf=K,e.$Qf=$e,e.$Rf=we,e.$Tf=Ne,e.$Uf=fe,e.$Vf=De,e.$Wf=Ie,e.$Xf=Fe,e.$Yf=V,e.$Zf=q,e.$1f=J,e.$2f=qe;function L(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const A=/{(\d+)}/g;function R(Ce,...Be){return Be.length===0?Ce:Ce.replace(A,function(Ge,Me){const Ze=parseInt(Me,10);return isNaN(Ze)||Ze<0||Ze>=Be.length?Ge:Be[Ze]})}const b=/{([^}]+)}/g;function $(Ce,Be){return Object.keys(Be).length===0?Ce:Ce.replace(b,(Ge,Me)=>Be[Me]??Ge)}function S(Ce){return Ce.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function N(Ce){return Ce.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(Ce,Be){let Ge=0;const Me=Be.charCodeAt(0);for(let Ze=Ce.length-1;Ze>=0;Ze--)Ce.charCodeAt(Ze)===Me&&Ge++;return Ge}function y(Ce,Be,Ge="\u2026"){return Ce.length<=Be?Ce:`${Ce.substr(0,Be)}${Ge}`}function w(Ce,Be,Ge="\u2026"){if(Ce.length<=Be)return Ce;const Me=Math.ceil(Be/2)-Ge.length/2,Ze=Math.floor(Be/2)-Ge.length/2;return`${Ce.substr(0,Me)}${Ge}${Ce.substr(Ce.length-Ze)}`}function d(Ce,Be=" "){const Ge=g(Ce,Be);return a(Ge,Be)}function g(Ce,Be){if(!Ce||!Be)return Ce;const Ge=Be.length;if(Ge===0||Ce.length===0)return Ce;let Me=0;for(;Ce.indexOf(Be,Me)===Me;)Me=Me+Ge;return Ce.substring(Me)}function a(Ce,Be){if(!Ce||!Be)return Ce;const Ge=Be.length,Me=Ce.length;if(Ge===0||Me===0)return Ce;let Ze=Me,ae=-1;for(;ae=Ce.lastIndexOf(Be,Ze-1),!(ae===-1||ae+Ge!==Ze);){if(ae===0)return"";Ze=ae}return Ce.substring(0,Ze)}function i(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(Ce){return Ce.replace(/\*/g,"")}function u(Ce,Be,Ge={}){if(!Ce)throw new Error("Cannot create regex from empty string");Be||(Ce=C(Ce)),Ge.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Me="";return Ge.global&&(Me+="g"),Ge.matchCase||(Me+="i"),Ge.multiline&&(Me+="m"),Ge.unicode&&(Me+="u"),new RegExp(Ce,Me)}function o(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function h(Ce){const Be=[],Ge=Ce.split(/(\r\n|\r|\n)/);for(let Me=0;Me<Math.ceil(Ge.length/2);Me++)Be.push(Ge[2*Me]+(Ge[2*Me+1]??""));return Be}function s(Ce){for(let Be=0,Ge=Ce.length;Be<Ge;Be++){const Me=Ce.charCodeAt(Be);if(Me!==32&&Me!==9)return Be}return-1}function c(Ce,Be=0,Ge=Ce.length){for(let Me=Be;Me<Ge;Me++){const Ze=Ce.charCodeAt(Me);if(Ze!==32&&Ze!==9)return Ce.substring(Be,Me)}return Ce.substring(Be,Ge)}function r(Ce,Be=Ce.length-1){for(let Ge=Be;Ge>=0;Ge--){const Me=Ce.charCodeAt(Ge);if(Me!==32&&Me!==9)return Ge}return-1}function v(Ce,Be,Ge){const Me=[];let Ze=0;for(const ae of Ce.matchAll(Be)){if(Me.push(Ce.slice(Ze,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Ze=ae.index+ae[0].length,Me.push(Ge(ae[0],...ae.slice(1),ae.index,Ce,ae.groups))}return Me.push(Ce.slice(Ze)),Promise.all(Me).then(ae=>ae.join(""))}function f(Ce,Be){return Ce<Be?-1:Ce>Be?1:0}function D(Ce,Be,Ge=0,Me=Ce.length,Ze=0,ae=Be.length){for(;Ge<Me&&Ze<ae;Ge++,Ze++){const Ke=Ce.charCodeAt(Ge),Re=Be.charCodeAt(Ze);if(Ke<Re)return-1;if(Ke>Re)return 1}const ce=Me-Ge,Ae=ae-Ze;return ce<Ae?-1:ce>Ae?1:0}function p(Ce,Be){return E(Ce,Be,0,Ce.length,0,Be.length)}function E(Ce,Be,Ge=0,Me=Ce.length,Ze=0,ae=Be.length){for(;Ge<Me&&Ze<ae;Ge++,Ze++){let Ke=Ce.charCodeAt(Ge),Re=Be.charCodeAt(Ze);if(Ke===Re)continue;if(Ke>=128||Re>=128)return D(Ce.toLowerCase(),Be.toLowerCase(),Ge,Me,Ze,ae);P(Ke)&&(Ke-=32),P(Re)&&(Re-=32);const tt=Ke-Re;if(tt!==0)return tt}const ce=Me-Ge,Ae=ae-Ze;return ce<Ae?-1:ce>Ae?1:0}function k(Ce){return Ce>=48&&Ce<=57}function P(Ce){return Ce>=97&&Ce<=122}function I(Ce){return Ce>=65&&Ce<=90}function T(Ce,Be){return Ce.length===Be.length&&E(Ce,Be)===0}function j(Ce,Be){const Ge=Be.length;return Be.length>Ce.length?!1:E(Ce,Be,0,Ge)===0}function z(Ce,Be){const Ge=Math.min(Ce.length,Be.length);let Me;for(Me=0;Me<Ge;Me++)if(Ce.charCodeAt(Me)!==Be.charCodeAt(Me))return Me;return Ge}function O(Ce,Be){const Ge=Math.min(Ce.length,Be.length);let Me;const Ze=Ce.length-1,ae=Be.length-1;for(Me=0;Me<Ge;Me++)if(Ce.charCodeAt(Ze-Me)!==Be.charCodeAt(ae-Me))return Me;return Ge}function F(Ce){return 55296<=Ce&&Ce<=56319}function B(Ce){return 56320<=Ce&&Ce<=57343}function W(Ce,Be){return(Ce-55296<<10)+(Be-56320)+65536}function Z(Ce,Be,Ge){const Me=Ce.charCodeAt(Ge);if(F(Me)&&Ge+1<Be){const Ze=Ce.charCodeAt(Ge+1);if(B(Ze))return W(Me,Ze)}return Me}function X(Ce,Be){const Ge=Ce.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Me=Ce.charCodeAt(Be-2);if(F(Me))return W(Me,Ge)}return Ge}class Y{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=X(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Z(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Df=Y;class x{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new Y(Be,Ge)}nextGraphemeLength(){const Be=be.getInstance(),Ge=this.c,Me=Ge.offset;let Ze=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.nextCodePoint());if(Q(Ze,ce)){Ge.setOffset(ae);break}Ze=ce}return Ge.offset-Me}prevGraphemeLength(){const Be=be.getInstance(),Ge=this.c,Me=Ge.offset;let Ze=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.prevCodePoint());if(Q(ce,Ze)){Ge.setOffset(ae);break}Ze=ce}return Me-Ge.offset}eol(){return this.c.eol()}}e.$Ef=x;function ne(Ce,Be){return new x(Ce,Be).nextGraphemeLength()}function ge(Ce,Be){return new x(Ce,Be).prevGraphemeLength()}function ue(Ce,Be){Be>0&&B(Ce.charCodeAt(Be))&&Be--;const Ge=Be+ne(Ce,Be);return[Ge-ge(Ce,Ge),Ge]}function ve(Ce){const Be=new x(Ce);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let te;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Ce){return te||(te=U()),te.test(Ce)}const pe=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ce){return pe.test(Ce)}e.$Lf=/[\u2028\u2029]/;function se(Ce){return e.$Lf.test(Ce)}function re(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function oe(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function K(Ce,Be,Ge=""){const Me=Ce.trimStart();if(Me.length<Be)return Me;const Ze=/\b/g;let ae=0;for(;Ze.test(Me)&&!(Me.length-Ze.lastIndex<Be);)ae=Ze.lastIndex,Ze.lastIndex+=1;return ae===0?Me:Ge+Me.substring(ae).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Ce){let Be=0;for(const Ge of Ce.matchAll(ie))Be!==Ge.index&&(yield{isCode:!1,str:Ce.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==Ce.length&&(yield{isCode:!1,str:Ce.substring(Be)})}function we(Ce){return Ce&&(Ce=Ce.replace(ie,"")),Ce}e.$Sf="\uFEFF";function Ne(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function fe(Ce){return Ne(Ce)?Ce.substr(1):Ce}function De(Ce,Be){if(!Ce||!Be||Ce.length<Be.length)return!1;const Ge=Be.length,Me=Ce.toLowerCase();let Ze=0,ae=-1;for(;Ze<Ge;){const ce=Me.indexOf(Be[Ze],ae+1);if(ce<0)return!1;ae=ce,Ze++}return!0}function Ie(Ce,Be=!1){return Ce?(Be&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function Fe(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function V(Ce,Be=1){if(Be===0)return"";let Ge=-1;do Ge=Ce.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?Ce:(Ce[Ge-1]==="\r"&&Ge--,Ce.substr(0,Ge))}function q(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function J(Ce){return be.getInstance().getGraphemeBreakType(Ce)}function Q(Ce,Be){return Ce===0?Be!==5&&Be!==7:Ce===2&&Be===3?!1:Ce===4||Ce===2||Ce===3||Be===4||Be===2||Be===3?!0:!(Ce===8&&(Be===8||Be===9||Be===11||Be===12)||(Ce===11||Ce===9)&&(Be===9||Be===10)||(Ce===12||Ce===10)&&Be===10||Be===5||Be===13||Be===7||Ce===1||Ce===13&&Be===14||Ce===6&&Be===6)}var he;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class be{static{this.c=null}static getInstance(){return be.c||(be.c=new be),be.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Me=Ge.length/3;let Ze=1;for(;Ze<=Me;)if(Be<Ge[3*Ze])Ze=2*Ze;else if(Be>Ge[3*Ze+1])Ze=2*Ze+1;else return Ge[3*Ze+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Ce,Be){if(Ce===0)return 0;const Ge=Ye(Ce,Be);if(Ge!==void 0)return Ge;const Me=new Y(Be,Ce);return Me.prevCodePoint(),Me.offset}function Ye(Ce,Be){const Ge=new Y(Be,Ce);let Me=Ge.prevCodePoint();for(;it(Me)||Me===65039||Me===8419;){if(Ge.offset===0)return;Me=Ge.prevCodePoint()}if(!oe(Me))return;let Ze=Ge.offset;return Ze>0&&Ge.prevCodePoint()===8205&&(Ze=Ge.offset),Ze}function it(Ce){return 127995<=Ce&&Ce<=127999}var ot;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$3f="\xA0";class nt{static{this.c=new M.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$1e({getCacheKey:JSON.stringify},Be=>{function Ge(tt){const ht=new Map;for(let wt=0;wt<tt.length;wt+=2)ht.set(tt[wt],tt[wt+1]);return ht}function Me(tt,ht){const wt=new Map(tt);for(const[Mt,At]of ht)wt.set(Mt,At);return wt}function Ze(tt,ht){if(!tt)return ht;const wt=new Map;for(const[Mt,At]of tt)ht.has(Mt)&&wt.set(Mt,At);return wt}const ae=this.c.value;let ce=Be.filter(tt=>!tt.startsWith("_")&&tt in ae);ce.length===0&&(ce=["_default"]);let Ae;for(const tt of ce){const ht=Ge(ae[tt]);Ae=Ze(Ae,ht)}const Ke=Ge(ae._common),Re=Me(Ke,Ae);return new nt(Re)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new M.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$4f=nt;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$5f=st}),define(ke[126],Se([1,0,27,166,14]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.FuzzyScore=e.$vk=e.$uk=void 0,e.or=A,e.$wk=b,e.$xk=$,e.$yk=C,e.$zk=v,e.$Ak=f,e.$Bk=I,e.$Ck=T,e.$Dk=j,e.$Ek=z,e.$Fk=_,e.$Hk=re,e.$Ik=ie,e.$Jk=$e;function A(...fe){return function(De,Ie){for(let Fe=0,V=fe.length;Fe<V;Fe++){const q=fe[Fe](De,Ie);if(q)return q}return null}}e.$uk=R.bind(void 0,!1),e.$vk=R.bind(void 0,!0);function R(fe,De,Ie){if(!Ie||Ie.length<De.length)return null;let Fe;return fe?Fe=L.$wf(Ie,De):Fe=Ie.indexOf(De)===0,Fe?De.length>0?[{start:0,end:De.length}]:[]:null}function b(fe,De){const Ie=De.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}function $(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}function S(fe,De,Ie,Fe){if(Ie===fe.length)return[];if(Fe===De.length)return null;if(fe[Ie]===De[Fe]){let V=null;return(V=S(fe,De,Ie+1,Fe+1))?u({start:Fe,end:Fe+1},V):null}return S(fe,De,Ie,Fe+1)}function N(fe){return 97<=fe&&fe<=122}function C(fe){return 65<=fe&&fe<=90}function m(fe){return 48<=fe&&fe<=57}function y(fe){return fe===32||fe===9||fe===10||fe===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>w.add(fe.charCodeAt(0)));function d(fe){return y(fe)||w.has(fe)}function g(fe,De){return fe===De||d(fe)&&d(De)}const a=new Map;function i(fe){if(a.has(fe))return a.get(fe);let De;const Ie=(0,M.$sk)(fe);return Ie&&(De=Ie),a.set(fe,De),De}function n(fe){return N(fe)||C(fe)||m(fe)}function u(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function o(fe,De){for(let Ie=De;Ie<fe.length;Ie++){const Fe=fe.charCodeAt(Ie);if(C(Fe)||m(Fe)||Ie>0&&!n(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,De,Ie,Fe){if(Ie===fe.length)return[];if(Fe===De.length)return null;if(fe[Ie]!==De[Fe].toLowerCase())return null;{let V=null,q=Fe+1;for(V=t(fe,De,Ie+1,Fe+1);!V&&(q=o(De,q))<De.length;)V=t(fe,De,Ie+1,q),q++;return V===null?null:u({start:Fe,end:Fe+1},V)}}function h(fe){let De=0,Ie=0,Fe=0,V=0,q=0;for(let ze=0;ze<fe.length;ze++)q=fe.charCodeAt(ze),C(q)&&De++,N(q)&&Ie++,n(q)&&Fe++,m(q)&&V++;const J=De/fe.length,Q=Ie/fe.length,he=Fe/fe.length,be=V/fe.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:he,numericPercent:be}}function s(fe){const{upperPercent:De,lowerPercent:Ie}=fe;return Ie===0&&De>.6}function c(fe){const{upperPercent:De,lowerPercent:Ie,alphaPercent:Fe,numericPercent:V}=fe;return Ie>.2&&De<.8&&Fe>.6&&V<.2}function r(fe){let De=0,Ie=0,Fe=0,V=0;for(let q=0;q<fe.length;q++)Fe=fe.charCodeAt(q),C(Fe)&&De++,N(Fe)&&Ie++,y(Fe)&&V++;return(De===0||Ie===0)&&V===0?fe.length<=30:De<=5}function v(fe,De){if(!De||(De=De.trim(),De.length===0)||!r(fe))return null;De.length>60&&(De=De.substring(0,60));const Ie=h(De);if(!c(Ie)){if(!s(Ie))return null;De=De.toLowerCase()}let Fe=null,V=0;for(fe=fe.toLowerCase();V<De.length&&(Fe=t(fe,De,0,V))===null;)V=o(De,V+1);return Fe}function f(fe,De,Ie=!1){if(!De||De.length===0)return null;let Fe=null,V=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();V<De.length&&(Fe=D(fe,De,0,V,Ie),Fe===null);)V=p(De,V+1);return Fe}function D(fe,De,Ie,Fe,V){let q=0;if(Ie===fe.length)return[];if(Fe===De.length)return null;if(!g(fe.charCodeAt(Ie),De.charCodeAt(Fe))){const he=i(fe.charCodeAt(Ie));if(!he)return null;for(let be=0;be<he.length;be++)if(!g(he[be],De.charCodeAt(Fe+be)))return null;q+=he.length-1}let J=null,Q=Fe+q+1;if(J=D(fe,De,Ie+1,Q,V),!V)for(;!J&&(Q=p(De,Q))<De.length;)J=D(fe,De,Ie+1,Q,V),Q++;if(!J)return null;if(fe.charCodeAt(Ie)!==De.charCodeAt(Fe)){const he=i(fe.charCodeAt(Ie));if(!he)return J;for(let be=0;be<he.length;be++)if(he[be]!==De.charCodeAt(Fe+be))return J}return u({start:Fe,end:Fe+q+1},J)}function p(fe,De){for(let Ie=De;Ie<fe.length;Ie++)if(d(fe.charCodeAt(Ie))||Ie>0&&d(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const E=A(e.$vk,v,b),k=A(e.$vk,v,$),P=new l.$Ec(1e4);function I(fe,De,Ie=!1){if(typeof fe!="string"||typeof De!="string")return null;let Fe=P.get(fe);Fe||(Fe=new RegExp(L.$ef(fe),"i"),P.set(fe,Fe));const V=Fe.exec(De);return V?[{start:V.index,end:V.index+V[0].length}]:Ie?k(fe,De):E(fe,De)}function T(fe,De){const Ie=re(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?z(Ie):null}function j(fe,De,Ie,Fe,V,q){const J=Math.min(13,fe.length);for(;Ie<J;Ie++){const Q=re(fe,De,Ie,Fe,V,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}function z(fe){if(typeof fe>"u")return[];const De=[],Ie=fe[1];for(let Fe=fe.length-1;Fe>1;Fe--){const V=fe[Fe]+Ie,q=De[De.length-1];q&&q.end===V?q.end=V+1:De.push({start:V,end:V+1})}return De}const O=128;function F(){const fe=[],De=[];for(let Ie=0;Ie<=O;Ie++)De[Ie]=0;for(let Ie=0;Ie<=O;Ie++)fe.push(De.slice(0));return fe}function B(fe){const De=[];for(let Ie=0;Ie<=fe;Ie++)De[Ie]=0;return De}const W=B(2*O),Z=B(2*O),X=F(),Y=F(),x=F(),ne=!1;function ge(fe,De,Ie,Fe,V){function q(Q,he,be=" "){for(;Q.length<he;)Q=be+Q;return Q}let J=` |   |${Fe.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=Ie;Q++)Q===0?J+=" |":J+=`${De[Q-1]}|`,J+=fe[Q].slice(0,V+1).map(he=>q(he.toString(),3)).join("|")+`
`;return J}function ue(fe,De,Ie,Fe){fe=fe.substr(De),Ie=Ie.substr(Fe),console.log(ge(Y,fe,fe.length,Ie,Ie.length)),console.log(ge(x,fe,fe.length,Ie,Ie.length)),console.log(ge(X,fe,fe.length,Ie,Ie.length))}function ve(fe,De){if(De<0||De>=fe.length)return!1;const Ie=fe.codePointAt(De);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Of(Ie)}}function te(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function U(fe,De,Ie){return De[fe]!==Ie[fe]}function _(fe,De,Ie,Fe,V,q,J=!1){for(;De<Ie&&V<q;)fe[De]===Fe[V]&&(J&&(W[De]=V),De+=1),V+=1;return De===Ie}var pe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Pe;(function(fe){fe.Default=[-100,0];function De(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=De})(Pe||(e.FuzzyScore=Pe={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ie){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ie}}e.$Gk=se;function re(fe,De,Ie,Fe,V,q,J=se.default){const Q=fe.length>O?O:fe.length,he=Fe.length>O?O:Fe.length;if(Ie>=Q||q>=he||Q-Ie>he-q||!_(De,Ie,Q,V,q,he,!0))return;oe(Q,he,Ie,q,De,V);let be=1,ze=1,qe=Ie,Ye=q;const it=[!1];for(be=1,qe=Ie;qe<Q;be++,qe++){const Be=W[qe],Ge=Z[qe],Me=qe+1<Q?Z[qe+1]:he;for(ze=Be-q+1,Ye=Be;Ye<Me;ze++,Ye++){let Ze=Number.MIN_SAFE_INTEGER,ae=!1;Ye<=Ge&&(Ze=K(fe,De,qe,Ie,Fe,V,Ye,he,q,X[be-1][ze-1]===0,it));let ce=0;Ze!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Ze+Y[be-1][ze-1]);const Ae=Ye>Be,Ke=Ae?Y[be][ze-1]+(X[be][ze-1]>0?-5:0):0,Re=Ye>Be+1&&X[be][ze-1]>0,tt=Re?Y[be][ze-2]+(X[be][ze-2]>0?-5:0):0;if(Re&&(!Ae||tt>=Ke)&&(!ae||tt>=ce))Y[be][ze]=tt,x[be][ze]=3,X[be][ze]=0;else if(Ae&&(!ae||Ke>=ce))Y[be][ze]=Ke,x[be][ze]=2,X[be][ze]=0;else if(ae)Y[be][ze]=ce,x[be][ze]=1,X[be][ze]=X[be-1][ze-1]+1;else throw new Error("not possible")}}if(ne&&ue(fe,Ie,Fe,q),!it[0]&&!J.firstMatchCanBeWeak)return;be--,ze--;const ot=[Y[be][ze],q];let nt=0,st=0;for(;be>=1;){let Be=ze;do{const Ge=x[be][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);nt>1&&De[Ie+be-1]===V[q+ze-1]&&!U(Be+q-1,Fe,V)&&nt+1>X[be][Be]&&(Be=ze),Be===ze?nt++:nt=1,st||(st=Be),be--,ze=Be-1,ot.push(ze)}he===Q&&J.boostFullMatch&&(ot[0]+=2);const Ce=st-Q;return ot[0]-=Ce,ot}function oe(fe,De,Ie,Fe,V,q){let J=fe-1,Q=De-1;for(;J>=Ie&&Q>=Fe;)V[J]===q[Q]&&(Z[J]=Q,J--),Q--}function K(fe,De,Ie,Fe,V,q,J,Q,he,be,ze){if(De[Ie]!==q[J])return Number.MIN_SAFE_INTEGER;let qe=1,Ye=!1;return J===Ie-Fe?qe=fe[Ie]===V[J]?7:5:U(J,V,q)&&(J===0||!U(J-1,V,q))?(qe=fe[Ie]===V[J]?7:5,Ye=!0):ve(q,J)&&(J===0||!ve(q,J-1))?qe=5:(ve(q,J-1)||te(q,J-1))&&(qe=5,Ye=!0),qe>1&&Ie===Fe&&(ze[0]=!0),Ye||(Ye=U(J,V,q)||ve(q,J-1)||te(q,J-1)),Ie===Fe?J>he&&(qe-=Ye?3:5):be?qe+=Ye?2:0:qe+=Ye?0:1,J+1===Q&&(qe-=Ye?3:5),qe}function ie(fe,De,Ie,Fe,V,q,J){return we(fe,De,Ie,Fe,V,q,!0,J)}function $e(fe,De,Ie,Fe,V,q,J){return we(fe,De,Ie,Fe,V,q,!1,J)}function we(fe,De,Ie,Fe,V,q,J,Q){let he=re(fe,De,Ie,Fe,V,q,Q);if(he&&!J)return he;if(fe.length>=3){const be=Math.min(7,fe.length-1);for(let ze=Ie+1;ze<be;ze++){const qe=Ne(fe,ze);if(qe){const Ye=re(qe,qe.toLowerCase(),Ie,Fe,V,q,Q);Ye&&(Ye[0]-=3,(!he||Ye[0]>he[0])&&(he=Ye))}}}return he}function Ne(fe,De){if(De+1>=fe.length)return;const Ie=fe[De],Fe=fe[De+1];if(Ie!==Fe)return fe.slice(0,De)+Fe+Ie+fe.slice(De+2)}}),define(ke[56],Se([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$lj=void 0,e.$hj=M,e.$ij=L,e.$jj=A,e.$kj=b,e.$mj=d;function M(a){return L(a,0)}function L(a,i){switch(typeof a){case"object":return a===null?A(349,i):Array.isArray(a)?$(a,i):S(a,i);case"string":return b(a,i);case"boolean":return R(a,i);case"number":return A(a,i);case"undefined":return A(937,i);default:return A(617,i)}}function A(a,i){return(i<<5)-i+a|0}function R(a,i){return A(a?433:863,i)}function b(a,i){i=A(149417,i);for(let n=0,u=a.length;n<u;n++)i=A(a.charCodeAt(n),i);return i}function $(a,i){return i=A(104579,i),a.reduce((n,u)=>L(u,n),i)}function S(a,i){return i=A(181387,i),Object.keys(a).sort().reduce((n,u)=>(n=b(u,n),L(a[u],n)),i)}class N{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=L(i,this.g),this.g}}e.$lj=N;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(a,i,n=32){const u=n-i,o=~((1<<u)-1);return(a<<i|(o&a)>>>u)>>>0}function y(a,i=0,n=a.byteLength,u=0){for(let o=0;o<n;o++)a[i+o]=u}function w(a,i,n="0"){for(;a.length<i;)a=n+a;return a}function d(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(n=>n.toString(16).padStart(2,"0")).join(""):w((a>>>0).toString(16),i/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const u=this.p;let o=this.r,t=this.u,h,s;for(t!==0?(h=t,s=-1,t=0):(h=i.charCodeAt(0),s=0);;){let c=h;if(l.$zf(h))if(s+1<n){const r=i.charCodeAt(s+1);l.$Af(r)?(s++,c=l.$Bf(h,r)):c=65533}else{t=h;break}else l.$Af(h)&&(c=65533);if(o=this.w(u,o,c),s++,s<n)h=i.charCodeAt(s);else break}this.r=o,this.u=t}w(i,n,u){return u<128?i[n++]=u:u<2048?(i[n++]=192|(u&1984)>>>6,i[n++]=128|(u&63)>>>0):u<65536?(i[n++]=224|(u&61440)>>>12,i[n++]=128|(u&4032)>>>6,i[n++]=128|(u&63)>>>0):(i[n++]=240|(u&1835008)>>>18,i[n++]=128|(u&258048)>>>12,i[n++]=128|(u&4032)>>>6,i[n++]=128|(u&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=g.g,n=this.q;for(let f=0;f<64;f+=4)i.setUint32(f,n.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)i.setUint32(f,m(i.getUint32(f-12,!1)^i.getUint32(f-32,!1)^i.getUint32(f-56,!1)^i.getUint32(f-64,!1),1),!1);let u=this.h,o=this.l,t=this.m,h=this.n,s=this.o,c,r,v;for(let f=0;f<80;f++)f<20?(c=o&t|~o&h,r=1518500249):f<40?(c=o^t^h,r=1859775393):f<60?(c=o&t|o&h|t&h,r=2400959708):(c=o^t^h,r=3395469782),v=m(u,5)+c+s+r+i.getUint32(f*4,!1)&4294967295,s=h,h=t,t=m(o,30),o=u,u=v;this.h=this.h+u&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}e.$nj=g}),define(ke[41],Se([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(M||(M={})),function(L){const A="error",R="warning",b="warn",$="info",S="ignore";function N(m){return m?l.$vf(A,m)?L.Error:l.$vf(R,m)||l.$vf(b,m)?L.Warning:l.$vf($,m)?L.Info:L.Ignore:L.Ignore}L.fromValue=N;function C(m){switch(m){case L.Error:return A;case L.Warning:return R;case L.Info:return $;default:return S}}L.toString=C}(M||(M={})),e.default=M}),define(ke[169],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0,e.$_d=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,14]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class L{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const w=y.charCodeAt(0),d=this.b.charCodeAt(this.c);return w-d}value(){return this.b[this.c]}}e.$vi=L;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,M.$pf)(y,this.b,0,y.length,this.c,this.d):(0,M.$rf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$wi=A;class R{constructor(y=!0,w=!0){this.f=y,this.g=w}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let w=y.length-1;w>=0;w--,this.c--){const d=this.b.charCodeAt(w);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,M.$pf)(y,this.b,0,y.length,this.d,this.e):(0,M.$rf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$xi=R;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(y,w){this.f=y,this.g=w,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,M.$qf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,M.$qf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,M.$of)(y,this.c.query);if(this.d[this.e]===5)return(0,M.$of)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$yi=$;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(N||(N={}));class C{static forUris(y=()=>!1,w=()=>!1){return new C(new $(y,w))}static forPaths(y=!1){return new C(new R(void 0,!y))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,w){if(w){const d=w.slice(0);(0,l.$Xb)(d);for(const g of d)this.set(g,y)}else{const d=y.slice(0);(0,l.$Xb)(d);for(const g of d)this.set(g[0],g[1])}}set(y,w){const d=this.b.reset(y);let g;this.c||(this.c=new S,this.c.segment=d.value());const a=[];for(g=this.c;;){const n=d.cmp(g.segment);if(n>0)g.left||(g.left=new S,g.left.segment=d.value()),a.push([-1,g]),g=g.left;else if(n<0)g.right||(g.right=new S,g.right.segment=d.value()),a.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new S,g.mid.segment=d.value()),a.push([0,g]),g=g.mid;else break}const i=g.value;g.value=w,g.key=y;for(let n=a.length-1;n>=0;n--){const u=a[n][1];u.updateHeight();const o=u.balanceFactor();if(o<-1||o>1){const t=a[n][0],h=a[n+1][0];if(t===1&&h===1)a[n][1]=u.rotateLeft();else if(t===-1&&h===-1)a[n][1]=u.rotateRight();else if(t===1&&h===-1)u.right=a[n+1][1]=a[n+1][1].rotateRight(),a[n][1]=u.rotateLeft();else if(t===-1&&h===1)u.left=a[n+1][1]=a[n+1][1].rotateLeft(),a[n][1]=u.rotateRight();else throw new Error;if(n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const w=this.b.reset(y);let d=this.c;for(;d;){const g=w.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else break}return d}has(y){const w=this.d(y);return!(w?.value===void 0&&w?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,w){const d=this.b.reset(y),g=[];let a=this.c;for(;a;){const i=d.cmp(a.segment);if(i>0)g.push([-1,a]),a=a.left;else if(i<0)g.push([1,a]),a=a.right;else if(d.hasNext())d.next(),g.push([0,a]),a=a.mid;else break}if(a){if(w?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:n,value:u,segment:o}=i;this.e(i.key,!1),a.key=n,a.value=u,a.segment=o}}else{const i=a.left??a.right;if(g.length>0){const[n,u]=g[g.length-1];switch(n){case-1:u.left=i;break;case 0:u.mid=i;break;case 1:u.right=i;break}}else this.c=i}for(let i=g.length-1;i>=0;i--){const n=g[i][1];n.updateHeight();const u=n.balanceFactor();if(u>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),g[i][1]=n.rotateLeft()):u<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),g[i][1]=n.rotateRight()),i>0)switch(g[i-1][0]){case-1:g[i-1][1].left=g[i][1];break;case 1:g[i-1][1].right=g[i][1];break;case 0:g[i-1][1].mid=g[i][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const w=this.b.reset(y);let d=this.c,g;for(;d;){const a=w.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(w.hasNext())w.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(y){return this.g(y,!1)}g(y,w){const d=this.b.reset(y);let g=this.c;for(;g;){const a=d.cmp(g.segment);if(a>0)g=g.left;else if(a<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this.h(g.mid):w?g.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[w,d]of this)y(d,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const w=[];return this.j(y,w),w[Symbol.iterator]()}j(y,w){y&&(y.left&&this.j(y.left,w),y.value&&w.push([y.key,y.value]),y.mid&&this.j(y.mid,w),y.right&&this.j(y.right,w))}_isBalanced(){const y=w=>{if(!w)return!0;const d=w.balanceFactor();return d<-1||d>1?!1:y(w.left)&&y(w.right)};return y(this.c)}}e.$zi=C}),define(ke[18],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=l,e.$7f=M,e.$8f=L,e.$9f=A,e.$0f=R,e.$$f=b,e.$_f=$,e.$ag=S,e.$bg=N,e.$cg=C,e.$dg=m,e.$eg=y,e.$fg=w,e.$gg=g,e.$hg=a,e.$ig=i,e.$jg=n,e.$kg=u;function l(o){return typeof o=="string"}function M(o){return Array.isArray(o)&&o.every(t=>l(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function R(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function $(o){return o===!0||o===!1}function S(o){return typeof o>"u"}function N(o){return!C(o)}function C(o){return S(o)||o===null}function m(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const t=[];for(let h=0;h<o.length;h++){const s=o[h];if(C(s))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(s)}return t}const d=Object.prototype.hasOwnProperty;function g(o){if(!L(o))return!1;for(const t in o)if(d.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function i(...o){return o.length>0&&o.every(a)}function n(o,t){const h=Math.min(o.length,t.length);for(let s=0;s<h;s++)u(o[s],t[s])}function u(o,t){if(l(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Se([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=L,e.$Oj=A;const M=Object.create(null);function L(R,b){if((0,l.$6f)(b)){const $=M[b];if($===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=$}return M[R]=b,{id:R}}function A(){return M}}),define(ke[170],Se([1,0,99]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=void 0,e.$Pj={add:(0,l.$Nj)("add",6e4),plus:(0,l.$Nj)("plus",6e4),gistNew:(0,l.$Nj)("gist-new",6e4),repoCreate:(0,l.$Nj)("repo-create",6e4),lightbulb:(0,l.$Nj)("lightbulb",60001),lightBulb:(0,l.$Nj)("light-bulb",60001),repo:(0,l.$Nj)("repo",60002),repoDelete:(0,l.$Nj)("repo-delete",60002),gistFork:(0,l.$Nj)("gist-fork",60003),repoForked:(0,l.$Nj)("repo-forked",60003),gitPullRequest:(0,l.$Nj)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$Nj)("git-pull-request-abandoned",60004),recordKeys:(0,l.$Nj)("record-keys",60005),keyboard:(0,l.$Nj)("keyboard",60005),tag:(0,l.$Nj)("tag",60006),gitPullRequestLabel:(0,l.$Nj)("git-pull-request-label",60006),tagAdd:(0,l.$Nj)("tag-add",60006),tagRemove:(0,l.$Nj)("tag-remove",60006),person:(0,l.$Nj)("person",60007),personFollow:(0,l.$Nj)("person-follow",60007),personOutline:(0,l.$Nj)("person-outline",60007),personFilled:(0,l.$Nj)("person-filled",60007),gitBranch:(0,l.$Nj)("git-branch",60008),gitBranchCreate:(0,l.$Nj)("git-branch-create",60008),gitBranchDelete:(0,l.$Nj)("git-branch-delete",60008),sourceControl:(0,l.$Nj)("source-control",60008),mirror:(0,l.$Nj)("mirror",60009),mirrorPublic:(0,l.$Nj)("mirror-public",60009),star:(0,l.$Nj)("star",60010),starAdd:(0,l.$Nj)("star-add",60010),starDelete:(0,l.$Nj)("star-delete",60010),starEmpty:(0,l.$Nj)("star-empty",60010),comment:(0,l.$Nj)("comment",60011),commentAdd:(0,l.$Nj)("comment-add",60011),alert:(0,l.$Nj)("alert",60012),warning:(0,l.$Nj)("warning",60012),search:(0,l.$Nj)("search",60013),searchSave:(0,l.$Nj)("search-save",60013),logOut:(0,l.$Nj)("log-out",60014),signOut:(0,l.$Nj)("sign-out",60014),logIn:(0,l.$Nj)("log-in",60015),signIn:(0,l.$Nj)("sign-in",60015),eye:(0,l.$Nj)("eye",60016),eyeUnwatch:(0,l.$Nj)("eye-unwatch",60016),eyeWatch:(0,l.$Nj)("eye-watch",60016),circleFilled:(0,l.$Nj)("circle-filled",60017),primitiveDot:(0,l.$Nj)("primitive-dot",60017),closeDirty:(0,l.$Nj)("close-dirty",60017),debugBreakpoint:(0,l.$Nj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$Nj)("debug-breakpoint-disabled",60017),debugHint:(0,l.$Nj)("debug-hint",60017),terminalDecorationSuccess:(0,l.$Nj)("terminal-decoration-success",60017),primitiveSquare:(0,l.$Nj)("primitive-square",60018),edit:(0,l.$Nj)("edit",60019),pencil:(0,l.$Nj)("pencil",60019),info:(0,l.$Nj)("info",60020),issueOpened:(0,l.$Nj)("issue-opened",60020),gistPrivate:(0,l.$Nj)("gist-private",60021),gitForkPrivate:(0,l.$Nj)("git-fork-private",60021),lock:(0,l.$Nj)("lock",60021),mirrorPrivate:(0,l.$Nj)("mirror-private",60021),close:(0,l.$Nj)("close",60022),removeClose:(0,l.$Nj)("remove-close",60022),x:(0,l.$Nj)("x",60022),repoSync:(0,l.$Nj)("repo-sync",60023),sync:(0,l.$Nj)("sync",60023),clone:(0,l.$Nj)("clone",60024),desktopDownload:(0,l.$Nj)("desktop-download",60024),beaker:(0,l.$Nj)("beaker",60025),microscope:(0,l.$Nj)("microscope",60025),vm:(0,l.$Nj)("vm",60026),deviceDesktop:(0,l.$Nj)("device-desktop",60026),file:(0,l.$Nj)("file",60027),fileText:(0,l.$Nj)("file-text",60027),more:(0,l.$Nj)("more",60028),ellipsis:(0,l.$Nj)("ellipsis",60028),kebabHorizontal:(0,l.$Nj)("kebab-horizontal",60028),mailReply:(0,l.$Nj)("mail-reply",60029),reply:(0,l.$Nj)("reply",60029),organization:(0,l.$Nj)("organization",60030),organizationFilled:(0,l.$Nj)("organization-filled",60030),organizationOutline:(0,l.$Nj)("organization-outline",60030),newFile:(0,l.$Nj)("new-file",60031),fileAdd:(0,l.$Nj)("file-add",60031),newFolder:(0,l.$Nj)("new-folder",60032),fileDirectoryCreate:(0,l.$Nj)("file-directory-create",60032),trash:(0,l.$Nj)("trash",60033),trashcan:(0,l.$Nj)("trashcan",60033),history:(0,l.$Nj)("history",60034),clock:(0,l.$Nj)("clock",60034),folder:(0,l.$Nj)("folder",60035),fileDirectory:(0,l.$Nj)("file-directory",60035),symbolFolder:(0,l.$Nj)("symbol-folder",60035),logoGithub:(0,l.$Nj)("logo-github",60036),markGithub:(0,l.$Nj)("mark-github",60036),github:(0,l.$Nj)("github",60036),terminal:(0,l.$Nj)("terminal",60037),console:(0,l.$Nj)("console",60037),repl:(0,l.$Nj)("repl",60037),zap:(0,l.$Nj)("zap",60038),symbolEvent:(0,l.$Nj)("symbol-event",60038),error:(0,l.$Nj)("error",60039),stop:(0,l.$Nj)("stop",60039),variable:(0,l.$Nj)("variable",60040),symbolVariable:(0,l.$Nj)("symbol-variable",60040),array:(0,l.$Nj)("array",60042),symbolArray:(0,l.$Nj)("symbol-array",60042),symbolModule:(0,l.$Nj)("symbol-module",60043),symbolPackage:(0,l.$Nj)("symbol-package",60043),symbolNamespace:(0,l.$Nj)("symbol-namespace",60043),symbolObject:(0,l.$Nj)("symbol-object",60043),symbolMethod:(0,l.$Nj)("symbol-method",60044),symbolFunction:(0,l.$Nj)("symbol-function",60044),symbolConstructor:(0,l.$Nj)("symbol-constructor",60044),symbolBoolean:(0,l.$Nj)("symbol-boolean",60047),symbolNull:(0,l.$Nj)("symbol-null",60047),symbolNumeric:(0,l.$Nj)("symbol-numeric",60048),symbolNumber:(0,l.$Nj)("symbol-number",60048),symbolStructure:(0,l.$Nj)("symbol-structure",60049),symbolStruct:(0,l.$Nj)("symbol-struct",60049),symbolParameter:(0,l.$Nj)("symbol-parameter",60050),symbolTypeParameter:(0,l.$Nj)("symbol-type-parameter",60050),symbolKey:(0,l.$Nj)("symbol-key",60051),symbolText:(0,l.$Nj)("symbol-text",60051),symbolReference:(0,l.$Nj)("symbol-reference",60052),goToFile:(0,l.$Nj)("go-to-file",60052),symbolEnum:(0,l.$Nj)("symbol-enum",60053),symbolValue:(0,l.$Nj)("symbol-value",60053),symbolRuler:(0,l.$Nj)("symbol-ruler",60054),symbolUnit:(0,l.$Nj)("symbol-unit",60054),activateBreakpoints:(0,l.$Nj)("activate-breakpoints",60055),archive:(0,l.$Nj)("archive",60056),arrowBoth:(0,l.$Nj)("arrow-both",60057),arrowDown:(0,l.$Nj)("arrow-down",60058),arrowLeft:(0,l.$Nj)("arrow-left",60059),arrowRight:(0,l.$Nj)("arrow-right",60060),arrowSmallDown:(0,l.$Nj)("arrow-small-down",60061),arrowSmallLeft:(0,l.$Nj)("arrow-small-left",60062),arrowSmallRight:(0,l.$Nj)("arrow-small-right",60063),arrowSmallUp:(0,l.$Nj)("arrow-small-up",60064),arrowUp:(0,l.$Nj)("arrow-up",60065),bell:(0,l.$Nj)("bell",60066),bold:(0,l.$Nj)("bold",60067),book:(0,l.$Nj)("book",60068),bookmark:(0,l.$Nj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$Nj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$Nj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$Nj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$Nj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$Nj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$Nj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$Nj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$Nj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$Nj)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$Nj)("briefcase",60076),broadcast:(0,l.$Nj)("broadcast",60077),browser:(0,l.$Nj)("browser",60078),bug:(0,l.$Nj)("bug",60079),calendar:(0,l.$Nj)("calendar",60080),caseSensitive:(0,l.$Nj)("case-sensitive",60081),check:(0,l.$Nj)("check",60082),checklist:(0,l.$Nj)("checklist",60083),chevronDown:(0,l.$Nj)("chevron-down",60084),chevronLeft:(0,l.$Nj)("chevron-left",60085),chevronRight:(0,l.$Nj)("chevron-right",60086),chevronUp:(0,l.$Nj)("chevron-up",60087),chromeClose:(0,l.$Nj)("chrome-close",60088),chromeMaximize:(0,l.$Nj)("chrome-maximize",60089),chromeMinimize:(0,l.$Nj)("chrome-minimize",60090),chromeRestore:(0,l.$Nj)("chrome-restore",60091),circleOutline:(0,l.$Nj)("circle-outline",60092),circle:(0,l.$Nj)("circle",60092),debugBreakpointUnverified:(0,l.$Nj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,l.$Nj)("terminal-decoration-incomplete",60092),circleSlash:(0,l.$Nj)("circle-slash",60093),circuitBoard:(0,l.$Nj)("circuit-board",60094),clearAll:(0,l.$Nj)("clear-all",60095),clippy:(0,l.$Nj)("clippy",60096),closeAll:(0,l.$Nj)("close-all",60097),cloudDownload:(0,l.$Nj)("cloud-download",60098),cloudUpload:(0,l.$Nj)("cloud-upload",60099),code:(0,l.$Nj)("code",60100),collapseAll:(0,l.$Nj)("collapse-all",60101),colorMode:(0,l.$Nj)("color-mode",60102),commentDiscussion:(0,l.$Nj)("comment-discussion",60103),creditCard:(0,l.$Nj)("credit-card",60105),dash:(0,l.$Nj)("dash",60108),dashboard:(0,l.$Nj)("dashboard",60109),database:(0,l.$Nj)("database",60110),debugContinue:(0,l.$Nj)("debug-continue",60111),debugDisconnect:(0,l.$Nj)("debug-disconnect",60112),debugPause:(0,l.$Nj)("debug-pause",60113),debugRestart:(0,l.$Nj)("debug-restart",60114),debugStart:(0,l.$Nj)("debug-start",60115),debugStepInto:(0,l.$Nj)("debug-step-into",60116),debugStepOut:(0,l.$Nj)("debug-step-out",60117),debugStepOver:(0,l.$Nj)("debug-step-over",60118),debugStop:(0,l.$Nj)("debug-stop",60119),debug:(0,l.$Nj)("debug",60120),deviceCameraVideo:(0,l.$Nj)("device-camera-video",60121),deviceCamera:(0,l.$Nj)("device-camera",60122),deviceMobile:(0,l.$Nj)("device-mobile",60123),diffAdded:(0,l.$Nj)("diff-added",60124),diffIgnored:(0,l.$Nj)("diff-ignored",60125),diffModified:(0,l.$Nj)("diff-modified",60126),diffRemoved:(0,l.$Nj)("diff-removed",60127),diffRenamed:(0,l.$Nj)("diff-renamed",60128),diff:(0,l.$Nj)("diff",60129),diffSidebyside:(0,l.$Nj)("diff-sidebyside",60129),discard:(0,l.$Nj)("discard",60130),editorLayout:(0,l.$Nj)("editor-layout",60131),emptyWindow:(0,l.$Nj)("empty-window",60132),exclude:(0,l.$Nj)("exclude",60133),extensions:(0,l.$Nj)("extensions",60134),eyeClosed:(0,l.$Nj)("eye-closed",60135),fileBinary:(0,l.$Nj)("file-binary",60136),fileCode:(0,l.$Nj)("file-code",60137),fileMedia:(0,l.$Nj)("file-media",60138),filePdf:(0,l.$Nj)("file-pdf",60139),fileSubmodule:(0,l.$Nj)("file-submodule",60140),fileSymlinkDirectory:(0,l.$Nj)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$Nj)("file-symlink-file",60142),fileZip:(0,l.$Nj)("file-zip",60143),files:(0,l.$Nj)("files",60144),filter:(0,l.$Nj)("filter",60145),flame:(0,l.$Nj)("flame",60146),foldDown:(0,l.$Nj)("fold-down",60147),foldUp:(0,l.$Nj)("fold-up",60148),fold:(0,l.$Nj)("fold",60149),folderActive:(0,l.$Nj)("folder-active",60150),folderOpened:(0,l.$Nj)("folder-opened",60151),gear:(0,l.$Nj)("gear",60152),gift:(0,l.$Nj)("gift",60153),gistSecret:(0,l.$Nj)("gist-secret",60154),gist:(0,l.$Nj)("gist",60155),gitCommit:(0,l.$Nj)("git-commit",60156),gitCompare:(0,l.$Nj)("git-compare",60157),compareChanges:(0,l.$Nj)("compare-changes",60157),gitMerge:(0,l.$Nj)("git-merge",60158),githubAction:(0,l.$Nj)("github-action",60159),githubAlt:(0,l.$Nj)("github-alt",60160),globe:(0,l.$Nj)("globe",60161),grabber:(0,l.$Nj)("grabber",60162),graph:(0,l.$Nj)("graph",60163),gripper:(0,l.$Nj)("gripper",60164),heart:(0,l.$Nj)("heart",60165),home:(0,l.$Nj)("home",60166),horizontalRule:(0,l.$Nj)("horizontal-rule",60167),hubot:(0,l.$Nj)("hubot",60168),inbox:(0,l.$Nj)("inbox",60169),issueReopened:(0,l.$Nj)("issue-reopened",60171),issues:(0,l.$Nj)("issues",60172),italic:(0,l.$Nj)("italic",60173),jersey:(0,l.$Nj)("jersey",60174),json:(0,l.$Nj)("json",60175),kebabVertical:(0,l.$Nj)("kebab-vertical",60176),key:(0,l.$Nj)("key",60177),law:(0,l.$Nj)("law",60178),lightbulbAutofix:(0,l.$Nj)("lightbulb-autofix",60179),linkExternal:(0,l.$Nj)("link-external",60180),link:(0,l.$Nj)("link",60181),listOrdered:(0,l.$Nj)("list-ordered",60182),listUnordered:(0,l.$Nj)("list-unordered",60183),liveShare:(0,l.$Nj)("live-share",60184),loading:(0,l.$Nj)("loading",60185),location:(0,l.$Nj)("location",60186),mailRead:(0,l.$Nj)("mail-read",60187),mail:(0,l.$Nj)("mail",60188),markdown:(0,l.$Nj)("markdown",60189),megaphone:(0,l.$Nj)("megaphone",60190),mention:(0,l.$Nj)("mention",60191),milestone:(0,l.$Nj)("milestone",60192),gitPullRequestMilestone:(0,l.$Nj)("git-pull-request-milestone",60192),mortarBoard:(0,l.$Nj)("mortar-board",60193),move:(0,l.$Nj)("move",60194),multipleWindows:(0,l.$Nj)("multiple-windows",60195),mute:(0,l.$Nj)("mute",60196),noNewline:(0,l.$Nj)("no-newline",60197),note:(0,l.$Nj)("note",60198),octoface:(0,l.$Nj)("octoface",60199),openPreview:(0,l.$Nj)("open-preview",60200),package:(0,l.$Nj)("package",60201),paintcan:(0,l.$Nj)("paintcan",60202),pin:(0,l.$Nj)("pin",60203),play:(0,l.$Nj)("play",60204),run:(0,l.$Nj)("run",60204),plug:(0,l.$Nj)("plug",60205),preserveCase:(0,l.$Nj)("preserve-case",60206),preview:(0,l.$Nj)("preview",60207),project:(0,l.$Nj)("project",60208),pulse:(0,l.$Nj)("pulse",60209),question:(0,l.$Nj)("question",60210),quote:(0,l.$Nj)("quote",60211),radioTower:(0,l.$Nj)("radio-tower",60212),reactions:(0,l.$Nj)("reactions",60213),references:(0,l.$Nj)("references",60214),refresh:(0,l.$Nj)("refresh",60215),regex:(0,l.$Nj)("regex",60216),remoteExplorer:(0,l.$Nj)("remote-explorer",60217),remote:(0,l.$Nj)("remote",60218),remove:(0,l.$Nj)("remove",60219),replaceAll:(0,l.$Nj)("replace-all",60220),replace:(0,l.$Nj)("replace",60221),repoClone:(0,l.$Nj)("repo-clone",60222),repoForcePush:(0,l.$Nj)("repo-force-push",60223),repoPull:(0,l.$Nj)("repo-pull",60224),repoPush:(0,l.$Nj)("repo-push",60225),report:(0,l.$Nj)("report",60226),requestChanges:(0,l.$Nj)("request-changes",60227),rocket:(0,l.$Nj)("rocket",60228),rootFolderOpened:(0,l.$Nj)("root-folder-opened",60229),rootFolder:(0,l.$Nj)("root-folder",60230),rss:(0,l.$Nj)("rss",60231),ruby:(0,l.$Nj)("ruby",60232),saveAll:(0,l.$Nj)("save-all",60233),saveAs:(0,l.$Nj)("save-as",60234),save:(0,l.$Nj)("save",60235),screenFull:(0,l.$Nj)("screen-full",60236),screenNormal:(0,l.$Nj)("screen-normal",60237),searchStop:(0,l.$Nj)("search-stop",60238),server:(0,l.$Nj)("server",60240),settingsGear:(0,l.$Nj)("settings-gear",60241),settings:(0,l.$Nj)("settings",60242),shield:(0,l.$Nj)("shield",60243),smiley:(0,l.$Nj)("smiley",60244),sortPrecedence:(0,l.$Nj)("sort-precedence",60245),splitHorizontal:(0,l.$Nj)("split-horizontal",60246),splitVertical:(0,l.$Nj)("split-vertical",60247),squirrel:(0,l.$Nj)("squirrel",60248),starFull:(0,l.$Nj)("star-full",60249),starHalf:(0,l.$Nj)("star-half",60250),symbolClass:(0,l.$Nj)("symbol-class",60251),symbolColor:(0,l.$Nj)("symbol-color",60252),symbolConstant:(0,l.$Nj)("symbol-constant",60253),symbolEnumMember:(0,l.$Nj)("symbol-enum-member",60254),symbolField:(0,l.$Nj)("symbol-field",60255),symbolFile:(0,l.$Nj)("symbol-file",60256),symbolInterface:(0,l.$Nj)("symbol-interface",60257),symbolKeyword:(0,l.$Nj)("symbol-keyword",60258),symbolMisc:(0,l.$Nj)("symbol-misc",60259),symbolOperator:(0,l.$Nj)("symbol-operator",60260),symbolProperty:(0,l.$Nj)("symbol-property",60261),wrench:(0,l.$Nj)("wrench",60261),wrenchSubaction:(0,l.$Nj)("wrench-subaction",60261),symbolSnippet:(0,l.$Nj)("symbol-snippet",60262),tasklist:(0,l.$Nj)("tasklist",60263),telescope:(0,l.$Nj)("telescope",60264),textSize:(0,l.$Nj)("text-size",60265),threeBars:(0,l.$Nj)("three-bars",60266),thumbsdown:(0,l.$Nj)("thumbsdown",60267),thumbsup:(0,l.$Nj)("thumbsup",60268),tools:(0,l.$Nj)("tools",60269),triangleDown:(0,l.$Nj)("triangle-down",60270),triangleLeft:(0,l.$Nj)("triangle-left",60271),triangleRight:(0,l.$Nj)("triangle-right",60272),triangleUp:(0,l.$Nj)("triangle-up",60273),twitter:(0,l.$Nj)("twitter",60274),unfold:(0,l.$Nj)("unfold",60275),unlock:(0,l.$Nj)("unlock",60276),unmute:(0,l.$Nj)("unmute",60277),unverified:(0,l.$Nj)("unverified",60278),verified:(0,l.$Nj)("verified",60279),versions:(0,l.$Nj)("versions",60280),vmActive:(0,l.$Nj)("vm-active",60281),vmOutline:(0,l.$Nj)("vm-outline",60282),vmRunning:(0,l.$Nj)("vm-running",60283),watch:(0,l.$Nj)("watch",60284),whitespace:(0,l.$Nj)("whitespace",60285),wholeWord:(0,l.$Nj)("whole-word",60286),window:(0,l.$Nj)("window",60287),wordWrap:(0,l.$Nj)("word-wrap",60288),zoomIn:(0,l.$Nj)("zoom-in",60289),zoomOut:(0,l.$Nj)("zoom-out",60290),listFilter:(0,l.$Nj)("list-filter",60291),listFlat:(0,l.$Nj)("list-flat",60292),listSelection:(0,l.$Nj)("list-selection",60293),selection:(0,l.$Nj)("selection",60293),listTree:(0,l.$Nj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$Nj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$Nj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$Nj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$Nj)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$Nj)("circle-small-filled",60298),debugStackframeDot:(0,l.$Nj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,l.$Nj)("terminal-decoration-mark",60298),debugStackframe:(0,l.$Nj)("debug-stackframe",60299),debugStackframeFocused:(0,l.$Nj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$Nj)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$Nj)("symbol-string",60301),debugReverseContinue:(0,l.$Nj)("debug-reverse-continue",60302),debugStepBack:(0,l.$Nj)("debug-step-back",60303),debugRestartFrame:(0,l.$Nj)("debug-restart-frame",60304),debugAlt:(0,l.$Nj)("debug-alt",60305),callIncoming:(0,l.$Nj)("call-incoming",60306),callOutgoing:(0,l.$Nj)("call-outgoing",60307),menu:(0,l.$Nj)("menu",60308),expandAll:(0,l.$Nj)("expand-all",60309),feedback:(0,l.$Nj)("feedback",60310),gitPullRequestReviewer:(0,l.$Nj)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$Nj)("group-by-ref-type",60311),ungroupByRefType:(0,l.$Nj)("ungroup-by-ref-type",60312),account:(0,l.$Nj)("account",60313),gitPullRequestAssignee:(0,l.$Nj)("git-pull-request-assignee",60313),bellDot:(0,l.$Nj)("bell-dot",60314),debugConsole:(0,l.$Nj)("debug-console",60315),library:(0,l.$Nj)("library",60316),output:(0,l.$Nj)("output",60317),runAll:(0,l.$Nj)("run-all",60318),syncIgnored:(0,l.$Nj)("sync-ignored",60319),pinned:(0,l.$Nj)("pinned",60320),githubInverted:(0,l.$Nj)("github-inverted",60321),serverProcess:(0,l.$Nj)("server-process",60322),serverEnvironment:(0,l.$Nj)("server-environment",60323),pass:(0,l.$Nj)("pass",60324),issueClosed:(0,l.$Nj)("issue-closed",60324),stopCircle:(0,l.$Nj)("stop-circle",60325),playCircle:(0,l.$Nj)("play-circle",60326),record:(0,l.$Nj)("record",60327),debugAltSmall:(0,l.$Nj)("debug-alt-small",60328),vmConnect:(0,l.$Nj)("vm-connect",60329),cloud:(0,l.$Nj)("cloud",60330),merge:(0,l.$Nj)("merge",60331),export:(0,l.$Nj)("export",60332),graphLeft:(0,l.$Nj)("graph-left",60333),magnet:(0,l.$Nj)("magnet",60334),notebook:(0,l.$Nj)("notebook",60335),redo:(0,l.$Nj)("redo",60336),checkAll:(0,l.$Nj)("check-all",60337),pinnedDirty:(0,l.$Nj)("pinned-dirty",60338),passFilled:(0,l.$Nj)("pass-filled",60339),circleLargeFilled:(0,l.$Nj)("circle-large-filled",60340),circleLarge:(0,l.$Nj)("circle-large",60341),circleLargeOutline:(0,l.$Nj)("circle-large-outline",60341),combine:(0,l.$Nj)("combine",60342),gather:(0,l.$Nj)("gather",60342),table:(0,l.$Nj)("table",60343),variableGroup:(0,l.$Nj)("variable-group",60344),typeHierarchy:(0,l.$Nj)("type-hierarchy",60345),typeHierarchySub:(0,l.$Nj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$Nj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$Nj)("git-pull-request-create",60348),runAbove:(0,l.$Nj)("run-above",60349),runBelow:(0,l.$Nj)("run-below",60350),notebookTemplate:(0,l.$Nj)("notebook-template",60351),debugRerun:(0,l.$Nj)("debug-rerun",60352),workspaceTrusted:(0,l.$Nj)("workspace-trusted",60353),workspaceUntrusted:(0,l.$Nj)("workspace-untrusted",60354),workspaceUnknown:(0,l.$Nj)("workspace-unknown",60355),terminalCmd:(0,l.$Nj)("terminal-cmd",60356),terminalDebian:(0,l.$Nj)("terminal-debian",60357),terminalLinux:(0,l.$Nj)("terminal-linux",60358),terminalPowershell:(0,l.$Nj)("terminal-powershell",60359),terminalTmux:(0,l.$Nj)("terminal-tmux",60360),terminalUbuntu:(0,l.$Nj)("terminal-ubuntu",60361),terminalBash:(0,l.$Nj)("terminal-bash",60362),arrowSwap:(0,l.$Nj)("arrow-swap",60363),copy:(0,l.$Nj)("copy",60364),personAdd:(0,l.$Nj)("person-add",60365),filterFilled:(0,l.$Nj)("filter-filled",60366),wand:(0,l.$Nj)("wand",60367),debugLineByLine:(0,l.$Nj)("debug-line-by-line",60368),inspect:(0,l.$Nj)("inspect",60369),layers:(0,l.$Nj)("layers",60370),layersDot:(0,l.$Nj)("layers-dot",60371),layersActive:(0,l.$Nj)("layers-active",60372),compass:(0,l.$Nj)("compass",60373),compassDot:(0,l.$Nj)("compass-dot",60374),compassActive:(0,l.$Nj)("compass-active",60375),azure:(0,l.$Nj)("azure",60376),issueDraft:(0,l.$Nj)("issue-draft",60377),gitPullRequestClosed:(0,l.$Nj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$Nj)("git-pull-request-draft",60379),debugAll:(0,l.$Nj)("debug-all",60380),debugCoverage:(0,l.$Nj)("debug-coverage",60381),runErrors:(0,l.$Nj)("run-errors",60382),folderLibrary:(0,l.$Nj)("folder-library",60383),debugContinueSmall:(0,l.$Nj)("debug-continue-small",60384),beakerStop:(0,l.$Nj)("beaker-stop",60385),graphLine:(0,l.$Nj)("graph-line",60386),graphScatter:(0,l.$Nj)("graph-scatter",60387),pieChart:(0,l.$Nj)("pie-chart",60388),bracket:(0,l.$Nj)("bracket",60175),bracketDot:(0,l.$Nj)("bracket-dot",60389),bracketError:(0,l.$Nj)("bracket-error",60390),lockSmall:(0,l.$Nj)("lock-small",60391),azureDevops:(0,l.$Nj)("azure-devops",60392),verifiedFilled:(0,l.$Nj)("verified-filled",60393),newline:(0,l.$Nj)("newline",60394),layout:(0,l.$Nj)("layout",60395),layoutActivitybarLeft:(0,l.$Nj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$Nj)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$Nj)("layout-panel-left",60398),layoutPanelCenter:(0,l.$Nj)("layout-panel-center",60399),layoutPanelJustify:(0,l.$Nj)("layout-panel-justify",60400),layoutPanelRight:(0,l.$Nj)("layout-panel-right",60401),layoutPanel:(0,l.$Nj)("layout-panel",60402),layoutSidebarLeft:(0,l.$Nj)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$Nj)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$Nj)("layout-statusbar",60405),layoutMenubar:(0,l.$Nj)("layout-menubar",60406),layoutCentered:(0,l.$Nj)("layout-centered",60407),target:(0,l.$Nj)("target",60408),indent:(0,l.$Nj)("indent",60409),recordSmall:(0,l.$Nj)("record-small",60410),errorSmall:(0,l.$Nj)("error-small",60411),terminalDecorationError:(0,l.$Nj)("terminal-decoration-error",60411),arrowCircleDown:(0,l.$Nj)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$Nj)("arrow-circle-left",60413),arrowCircleRight:(0,l.$Nj)("arrow-circle-right",60414),arrowCircleUp:(0,l.$Nj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,l.$Nj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$Nj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$Nj)("layout-sidebar-left-off",60418),blank:(0,l.$Nj)("blank",60419),heartFilled:(0,l.$Nj)("heart-filled",60420),map:(0,l.$Nj)("map",60421),mapHorizontal:(0,l.$Nj)("map-horizontal",60421),foldHorizontal:(0,l.$Nj)("fold-horizontal",60421),mapFilled:(0,l.$Nj)("map-filled",60422),mapHorizontalFilled:(0,l.$Nj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,l.$Nj)("fold-horizontal-filled",60422),circleSmall:(0,l.$Nj)("circle-small",60423),bellSlash:(0,l.$Nj)("bell-slash",60424),bellSlashDot:(0,l.$Nj)("bell-slash-dot",60425),commentUnresolved:(0,l.$Nj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$Nj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$Nj)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$Nj)("search-fuzzy",60429),commentDraft:(0,l.$Nj)("comment-draft",60430),send:(0,l.$Nj)("send",60431),sparkle:(0,l.$Nj)("sparkle",60432),insert:(0,l.$Nj)("insert",60433),mic:(0,l.$Nj)("mic",60434),thumbsdownFilled:(0,l.$Nj)("thumbsdown-filled",60435),thumbsupFilled:(0,l.$Nj)("thumbsup-filled",60436),coffee:(0,l.$Nj)("coffee",60437),snake:(0,l.$Nj)("snake",60438),game:(0,l.$Nj)("game",60439),vr:(0,l.$Nj)("vr",60440),chip:(0,l.$Nj)("chip",60441),piano:(0,l.$Nj)("piano",60442),music:(0,l.$Nj)("music",60443),micFilled:(0,l.$Nj)("mic-filled",60444),repoFetch:(0,l.$Nj)("repo-fetch",60445),copilot:(0,l.$Nj)("copilot",60446),lightbulbSparkle:(0,l.$Nj)("lightbulb-sparkle",60447),robot:(0,l.$Nj)("robot",60448),sparkleFilled:(0,l.$Nj)("sparkle-filled",60449),diffSingle:(0,l.$Nj)("diff-single",60450),diffMultiple:(0,l.$Nj)("diff-multiple",60451),surroundWith:(0,l.$Nj)("surround-with",60452),share:(0,l.$Nj)("share",60453),gitStash:(0,l.$Nj)("git-stash",60454),gitStashApply:(0,l.$Nj)("git-stash-apply",60455),gitStashPop:(0,l.$Nj)("git-stash-pop",60456),vscode:(0,l.$Nj)("vscode",60457),vscodeInsiders:(0,l.$Nj)("vscode-insiders",60458),codeOss:(0,l.$Nj)("code-oss",60459),runCoverage:(0,l.$Nj)("run-coverage",60460),runAllCoverage:(0,l.$Nj)("run-all-coverage",60461),coverage:(0,l.$Nj)("coverage",60462),githubProject:(0,l.$Nj)("github-project",60463),mapVertical:(0,l.$Nj)("map-vertical",60464),foldVertical:(0,l.$Nj)("fold-vertical",60464),mapVerticalFilled:(0,l.$Nj)("map-vertical-filled",60465),foldVerticalFilled:(0,l.$Nj)("fold-vertical-filled",60465),goToSearch:(0,l.$Nj)("go-to-search",60466),percentage:(0,l.$Nj)("percentage",60467),sortPercentage:(0,l.$Nj)("sort-percentage",60467)}}),define(ke[78],Se([1,0,99,170]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=void 0,e.$Qj=L;function L(){return Object.values(e.$Sj)}e.$Rj={dialogError:(0,l.$Nj)("dialog-error","error"),dialogWarning:(0,l.$Nj)("dialog-warning","warning"),dialogInfo:(0,l.$Nj)("dialog-info","info"),dialogClose:(0,l.$Nj)("dialog-close","close"),treeItemExpanded:(0,l.$Nj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$Nj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$Nj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$Nj)("tree-filter-clear","close"),treeItemLoading:(0,l.$Nj)("tree-item-loading","loading"),menuSelection:(0,l.$Nj)("menu-selection","check"),menuSubmenu:(0,l.$Nj)("menu-submenu","chevron-right"),menuBarMore:(0,l.$Nj)("menubar-more","more"),scrollbarButtonLeft:(0,l.$Nj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$Nj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$Nj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$Nj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$Nj)("toolbar-more","more"),quickInputBack:(0,l.$Nj)("quick-input-back","arrow-left"),dropDownButton:(0,l.$Nj)("drop-down-button",60084),symbolCustomColor:(0,l.$Nj)("symbol-customcolor",60252),exportIcon:(0,l.$Nj)("export",60332),workspaceUnspecified:(0,l.$Nj)("workspace-unspecified",60355),newLine:(0,l.$Nj)("newline",60394),thumbsDownFilled:(0,l.$Nj)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$Nj)("thumbsup-filled",60436),gitFetch:(0,l.$Nj)("git-fetch",60445),lightbulbSparkleAutofix:(0,l.$Nj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,l.$Nj)("debug-breakpoint-pending",60377)},e.$Sj={...M.$Pj,...e.$Rj}}),define(ke[24],Se([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=M,e.$1n=L,e.$2n=R,e.$3n=$,e.$4n=S,e.$5n=N,e.$6n=C,e.$7n=m,e.$8n=y,e.$9n=w,e.$0n=d,e.$$n=g;function M(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([n,u])=>{i[n]=u&&typeof u=="object"?M(u):u}),i}function L(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const u in n)if(A.call(n,u)){const o=n[u];typeof o=="object"&&!Object.isFrozen(o)&&!(0,l.$9f)(o)&&i.push(o)}}return a}const A=Object.prototype.hasOwnProperty;function R(a,i){return b(a,i,new Set)}function b(a,i,n){if((0,l.$cg)(a))return a;const u=i(a);if(typeof u<"u")return u;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,i,n));return o}if((0,l.$8f)(a)){if(n.has(a))throw new Error("Cannot clone recursive data-structure");n.add(a);const o={};for(const t in a)A.call(a,t)&&(o[t]=b(a[t],i,n));return n.delete(a),o}return a}function $(a,i,n=!0){return(0,l.$8f)(a)?((0,l.$8f)(i)&&Object.keys(i).forEach(u=>{u in a?n&&((0,l.$8f)(a[u])&&(0,l.$8f)(i[u])?$(a[u],i[u],n):a[u]=i[u]):a[u]=i[u]}),a):i}function S(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let n,u;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(n=0;n<a.length;n++)if(!S(a[n],i[n]))return!1}else{const o=[];for(u in a)o.push(u);o.sort();const t=[];for(u in i)t.push(u);if(t.sort(),!S(o,t))return!1;for(n=0;n<o.length;n++)if(!S(a[o[n]],i[o[n]]))return!1}return!0}function N(a){const i=new Set;return JSON.stringify(a,(n,u)=>{if((0,l.$8f)(u)||Array.isArray(u)){if(i.has(u))return"[Circular]";i.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function C(a,i){const n=Object.create(null);return!a||!i||Object.keys(i).forEach(o=>{const t=a[o],h=i[o];S(t,h)||(n[o]=h)}),n}function m(a,i){const n=i.toLowerCase(),u=Object.keys(a).find(o=>o.toLowerCase()===n);return u?a[u]:a[i]}function y(a,i){const n=Object.create(null);for(const[u,o]of Object.entries(a))i(u,o)&&(n[u]=o);return n}function w(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}function d(a){const i=[];for(const n of w(a))typeof a[n]=="function"&&i.push(n);return i}function g(a,i){const n=o=>function(){const t=Array.prototype.slice.call(arguments,0);return i(o,t)},u={};for(const o of a)u[o]=n(o);return u}}),define(ke[57],Se([1,0,78]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Tj=L;var M;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(M||(e.ThemeColor=M={}));function L(R){return{id:R}}var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(l.$Sj.error);const[,u,o]=n,t=["codicon","codicon-"+u];return o&&t.push("codicon-modifier-"+o.substring(1)),t}R.asClassNameArray=$;function S(i){return $(i).join(" ")}R.asClassName=S;function N(i){return"."+$(i).join(".")}R.asCSSSelector=N;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(i){const n=m.exec(i);if(!n)return;const[,u]=n;return{id:u}}R.fromString=y;function w(i){return{id:i}}R.fromId=w;function d(i,n){let u=i.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),n&&(u=`${u}~${n}`),{id:u}}R.modify=d;function g(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=g;function a(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=a})(A||(e.ThemeIcon=A={}))}),define(ke[171],Se([1,0,126,14,57]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=$,e.$Lk=N,e.$Mk=m,e.$Nk=y,e.$Ok=d,e.$Pk=g;const A="$(",R=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(a){return a.replace(b,(i,n)=>n?i:`\\${i}`)}const S=new RegExp(`\\\\${R.source}`,"g");function N(a){return a.replace(S,i=>`\\${i}`)}const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(a){return a.indexOf(A)===-1?a:a.replace(C,(i,n,u,o)=>u?i:n||o||"")}function y(a){return a?a.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const w=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){w.lastIndex=0;let i="";const n=[];let u=0;for(;;){const o=w.lastIndex,t=w.exec(a),h=a.substring(o,t?.index);if(h.length>0){i+=h;for(let s=0;s<h.length;s++)n.push(u)}if(!t)break;u+=t[0].length}return{text:i,iconOffsets:n}}function g(a,i,n=!1){const{text:u,iconOffsets:o}=i;if(!o||o.length===0)return(0,l.$Bk)(a,u,n);const t=(0,M.$cf)(u," "),h=u.length-t.length,s=(0,l.$Bk)(a,t,n);if(s)for(const c of s){const r=o[c.start+h]+h;c.start+=r,c.end+=r}return s}}),define(ke[127],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$3e=M,e.$4e=L;var l;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function M(A){return A<0?0:A>255?255:A|0}function L(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(ke[30],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=M;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(L){return l.test(L)}e.$Pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let $=0,S="";return S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S}}()}),define(ke[172],Se([1,0,19,39,30]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.$Nt=void 0,e.$Lt=A,e.$Mt=R,e.$Ot=S;function A(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function R(C,m,y){const w={id:(0,L.$Pg)(),name:C,uri:m,data:y};return{asString:async()=>"",asFile:()=>w,value:void 0}}class b{constructor(){this.a=new Map}get size(){let m=0;for(const y of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const y=[...this.a.keys()];return M.Iterable.some(this,([w,d])=>d.asFile())&&y.push("files"),N($(m),y)}get(m){return this.a.get(this.b(m))?.[0]}append(m,y){const w=this.a.get(m);w?w.push(y):this.a.set(this.b(m),[y])}replace(m,y){this.a.set(this.b(m),[y])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,y]of this.a)for(const w of y)yield[m,w]}b(m){return $(m)}}e.$Nt=b;function $(C){return C.toLowerCase()}function S(C,m){return N($(C),m.map($))}function N(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const y=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[w,d,g]=y;return g==="*"?m.some(a=>a.startsWith(d+"/")):!1}e.$Pt=Object.freeze({create:C=>(0,l.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Pt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[173],Se([1,0,63]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=M,e.$Tg=A;function M(b,$,S,N=1){let C=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!C)return C=!0,m(0)},S);L(b,$,N,w=>{if(!C)return C=!0,clearTimeout(y),m(w)})})}function L(b,$,S,N){if($===0)return N(0);const C=new l.Socket;C.once("connect",()=>(R(C),L(b+S,$-1,S,N))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?L(b+S,$-1,S,N):N(b))),C.connect(b,"127.0.0.1")}e.$Sg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,$,S,N="127.0.0.1"){let C=!1,m,y=1;const w=l.createServer({pauseOnConnect:!0});function d(g,a){C||(C=!0,w.removeAllListeners(),w.close(),m&&clearTimeout(m),a(g))}return new Promise(g=>{m=setTimeout(()=>{d(0,g)},S),w.on("listening",()=>{d(b,g)}),w.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&y<$?(b++,y++,w.listen(b,N)):d(0,g)}),w.on("close",()=>{d(0,g)}),w.listen(b,N)})}function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[128],Se([1,0,127]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=void 0;class M{constructor(b){const $=(0,l.$3e)(b);this.c=$,this.a=M.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const S=(0,l.$3e)($);b>=0&&b<256?this.a[b]=S:this.b.set(b,S)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Dt=M;var L;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(L||(L={}));class A{constructor(){this.a=new M(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Et=A}),define(ke[174],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$St=M;var l;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function M(L){let A=0,R=0,b=0,$=0;for(let S=0,N=L.length;S<N;S++){const C=L.charCodeAt(S);C===13?(A===0&&(R=S),A++,S+1<N&&L.charCodeAt(S+1)===10?($|=2,S++):$|=3,b=S+1):C===10&&($|=1,A===0&&(R=S),A++,b=S+1)}return A===0&&(R=L.length),[A,R,L.length-b,$]}}),define(ke[50],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;class l{constructor(L,A){this.lineNumber=L,this.column=A}with(L=this.lineNumber,A=this.column){return L===this.lineNumber&&A===this.column?this:new l(L,A)}delta(L=0,A=0){return this.with(this.lineNumber+L,this.column+A)}equals(L){return l.equals(this,L)}static equals(L,A){return!L&&!A?!0:!!L&&!!A&&L.lineNumber===A.lineNumber&&L.column===A.column}isBefore(L){return l.isBefore(this,L)}static isBefore(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<A.column}isBeforeOrEqual(L){return l.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<=A.column}static compare(L,A){const R=L.lineNumber|0,b=A.lineNumber|0;if(R===b){const $=L.column|0,S=A.column|0;return $-S}return R-b}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new l(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ot=l}),define(ke[29],Se([1,0,50]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=void 0;class M{constructor(A,R,b,$){A>b||A===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return M.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return M.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return M.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return M.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return M.plusRange(this,A)}static plusRange(A,R){let b,$,S,N;return R.startLineNumber<A.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===A.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,A.startColumn)):(b=A.startLineNumber,$=A.startColumn),R.endLineNumber>A.endLineNumber?(S=R.endLineNumber,N=R.endColumn):R.endLineNumber===A.endLineNumber?(S=R.endLineNumber,N=Math.max(R.endColumn,A.endColumn)):(S=A.endLineNumber,N=A.endColumn),new M(b,$,S,N)}intersectRanges(A){return M.intersectRanges(this,A)}static intersectRanges(A,R){let b=A.startLineNumber,$=A.startColumn,S=A.endLineNumber,N=A.endColumn;const C=R.startLineNumber,m=R.startColumn,y=R.endLineNumber,w=R.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),S>y?(S=y,N=w):S===y&&(N=Math.min(N,w)),b>S||b===S&&$>N?null:new M(b,$,S,N)}equalsRange(A){return M.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(A){return new l.$ot(A.endLineNumber,A.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(A){return new l.$ot(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new M(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new M(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(A){return new M(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(A){return new M(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new M(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new M(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new M(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const S=A.startLineNumber|0,N=R.startLineNumber|0;if(S===N){const C=A.startColumn|0,m=R.startColumn|0;if(C===m){const y=A.endLineNumber|0,w=R.endLineNumber|0;if(y===w){const d=A.endColumn|0,g=R.endColumn|0;return d-g}return y-w}return C-m}return S-N}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$pt=M}),define(ke[175],Se([1,0,29]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=void 0;class M{static insert(A,R){return{range:new l.$pt(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$qt=M}),define(ke[176],Se([1,0,50,29]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.SelectionDirection=void 0;var L;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class A extends M.$pt{constructor(b,$,S,N){super(b,$,S,N),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=S,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,$):new A(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new l.$ot(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$ot(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new A(b,$,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new A(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let S=0,N=b.length;S<N;S++)if(!this.selectionsEqual(b[S],$[S]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,S,N,C){return C===0?new A(b,$,S,N):new A(S,N,b,$)}}e.$rt=A}),define(ke[177],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Zs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Se([1,0,27,128]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.WordCharacterClass=void 0,e.$Gt=b;var L;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class A extends M.$Dt{constructor(S,N){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=N,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,m=S.length;C<m;C++)this.set(S.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,N){let C=null;for(const m of this.h(S)){if(m.index>N)break;C=m}return C}findNextIntlWordAtOrAfterOffset(S,N){for(const C of this.h(S))if(!(C.index<N))return C;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const N=[];for(const C of S)this.k(C)&&N.push(C);return N}k(S){return!!S.isWordLike}}e.$Ft=A;const R=new l.$Ec(10);function b($,S){const N=`${$}/${S.join(",")}`;let C=R.get(N);return C||(C=new A($,S),R.set(N,C)),C}}),define(ke[129],Se([1,0,39,3,75]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0,e.$3s=R,e.$4s=$,e.$5s=S,e.$1s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$1s)C.indexOf(y)>=0||(m+="\\"+y);return m+="\\s]+)",new RegExp(m,"g")}e.$2s=A();function R(C){let m=e.$2s;if(C&&C instanceof RegExp)if(C.global)m=C;else{let y="g";C.ignoreCase&&(y+="i"),C.multiline&&(y+="m"),C.unicode&&(y+="u"),m=new RegExp(C.source,y)}return m.lastIndex=0,m}const b=new L.$6c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,M.$Tc)(m)}function S(C,m,y,w,d){if(m=R(m),d||(d=l.Iterable.first(b)),y.length>d.maxLen){let u=C-d.maxLen/2;return u<0?u=0:w+=u,y=y.substring(u,C+d.maxLen/2),S(C,m,y,w,d)}const g=Date.now(),a=C-1-w;let i=-1,n=null;for(let u=1;!(Date.now()-g>=d.timeBudget);u++){const o=a-d.windowSize*u;m.lastIndex=Math.max(0,o);const t=N(m,y,a,i);if(!t&&n||(n=t,o<=0))break;i=o}if(n){const u={word:n[0],startColumn:w+1+n.index,endColumn:w+1+n.index+n[0].length};return m.lastIndex=0,u}return null}function N(C,m,y,w){let d;for(;d=C.exec(m);){const g=d.index||0;if(g<=y&&C.lastIndex>=y)return d;if(w>0&&g>w)return null}return null}}),define(ke[179],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.$fu=e.IndentAction=void 0;var l;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class M{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,S=b.notIn.length;$<S;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const S=b.findTokenIndexAtOffset($-2),N=b.getStandardTokenType(S);return this.isOK(N)}g(b,$){for(let S=b;S<=$;S++){const N=String.fromCharCode(S);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$fu=M;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)A(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),A(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),A(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),A(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&A(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$gu=L;function A(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(ke[180],Se([1,0,128]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$92=e.$82=e.State=void 0,e.$02=m;var M;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class L{constructor(w,d,g){const a=new Uint8Array(w*d);for(let i=0,n=w*d;i<n;i++)a[i]=g;this.a=a,this.rows=w,this.cols=d}get(w,d){return this.a[w*this.cols+d]}set(w,d,g){this.a[w*this.cols+d]=g}}class A{constructor(w){let d=0,g=0;for(let i=0,n=w.length;i<n;i++){const[u,o,t]=w[i];o>d&&(d=o),u>g&&(g=u),t>g&&(g=t)}d++,g++;const a=new L(g,d,0);for(let i=0,n=w.length;i<n;i++){const[u,o,t]=w[i];a.set(u,o,t)}this.a=a,this.b=d}nextState(w,d){return d<0||d>=this.b?0:this.a.get(w,d)}}e.$82=A;let R=null;function b(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})($||($={}));let S=null;function N(){if(S===null){S=new l.$Dt(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<y.length;d++)S.set(y.charCodeAt(d),1);const w=".,;:";for(let d=0;d<w.length;d++)S.set(w.charCodeAt(d),2)}return S}class C{static a(w,d,g,a,i){let n=i-1;do{const u=d.charCodeAt(n);if(w.get(u)!==2)break;n--}while(n>a);if(a>0){const u=d.charCodeAt(a-1),o=d.charCodeAt(n);(u===40&&o===41||u===91&&o===93||u===123&&o===125)&&n--}return{range:{startLineNumber:g,startColumn:a+1,endLineNumber:g,endColumn:n+2},url:d.substring(a,n+1)}}static computeLinks(w,d=b()){const g=N(),a=[];for(let i=1,n=w.getLineCount();i<=n;i++){const u=w.getLineContent(i),o=u.length;let t=0,h=0,s=0,c=1,r=!1,v=!1,f=!1,D=!1;for(;t<o;){let p=!1;const E=u.charCodeAt(t);if(c===13){let k;switch(E){case 40:r=!0,k=0;break;case 41:k=r?0:1;break;case 91:f=!0,v=!0,k=0;break;case 93:f=!1,k=v?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:case 34:case 96:s===E?k=1:s===39||s===34||s===96?k=0:k=1;break;case 42:k=s===42?1:0;break;case 124:k=s===124?1:0;break;case 32:k=f?0:1;break;default:k=g.get(E)}k===1&&(a.push(C.a(g,u,i,h,t)),p=!0)}else if(c===12){let k;E===91?(v=!0,k=0):k=g.get(E),k===1?p=!0:c=13}else c=d.nextState(c,E),c===0&&(p=!0);p&&(c=1,r=!1,v=!1,D=!1,h=t+1,s=E),t++}c===13&&a.push(C.a(g,u,i,h,o))}return a}}e.$92=C;function m(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:C.computeLinks(y)}}),define(ke[79],Se([1,0,24]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Av=e.$zv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Bv=w,e.$Fv=u;var M;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var A;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var b;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var S;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var N;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(N||(e.EndOfLineSequence=N={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,l.$4n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$zv=C;class m{constructor(t,h){this._findMatchBrand=void 0,this.range=t,this.matches=h}}e.$Av=m;var y;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function w(o){return o&&typeof o.read=="function"}var d;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(d||(e.PositionAffinity=d={}));var g;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class a{constructor(t,h,s,c,r,v){this.identifier=t,this.range=h,this.text=s,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=r,this._isTracked=v}}e.$Cv=a;class i{constructor(t,h,s){this.regex=t,this.wordSeparators=h,this.simpleSearch=s}}e.$Dv=i;class n{constructor(t,h,s){this.reverseEdits=t,this.changes=h,this.trimAutoWhitespaceLineNumbers=s}}e.$Ev=n;function u(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[181],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.NodeColor=e.$uC=void 0,e.$wC=L,e.$xC=A,e.$yC=S,e.$zC=N,e.$AC=C,e.$BC=m,e.$CC=y,e.$DC=w;class l{constructor(g,a){this.piece=g,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$vC)return L(this.right);let g=this;for(;g.parent!==e.$vC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$vC?e.$vC:g.parent}prev(){if(this.left!==e.$vC)return A(this.left);let g=this;for(;g.parent!==e.$vC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$vC?e.$vC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$uC=l;var M;(function(d){d[d.Black=0]="Black",d[d.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$vC=new l(null,0),e.$vC.parent=e.$vC,e.$vC.left=e.$vC,e.$vC.right=e.$vC,e.$vC.color=0;function L(d){for(;d.left!==e.$vC;)d=d.left;return d}function A(d){for(;d.right!==e.$vC;)d=d.right;return d}function R(d){return d===e.$vC?0:d.size_left+d.piece.length+R(d.right)}function b(d){return d===e.$vC?0:d.lf_left+d.piece.lineFeedCnt+b(d.right)}function $(){e.$vC.parent=e.$vC}function S(d,g){const a=g.right;a.size_left+=g.size_left+(g.piece?g.piece.length:0),a.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=a.left,a.left!==e.$vC&&(a.left.parent=g),a.parent=g.parent,g.parent===e.$vC?d.root=a:g.parent.left===g?g.parent.left=a:g.parent.right=a,a.left=g,g.parent=a}function N(d,g){const a=g.left;g.left=a.right,a.right!==e.$vC&&(a.right.parent=g),a.parent=g.parent,g.size_left-=a.size_left+(a.piece?a.piece.length:0),g.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),g.parent===e.$vC?d.root=a:g===g.parent.right?g.parent.right=a:g.parent.left=a,a.right=g,g.parent=a}function C(d,g){let a,i;if(g.left===e.$vC?(i=g,a=i.right):g.right===e.$vC?(i=g,a=i.left):(i=L(g.right),a=i.right),i===d.root){d.root=a,a.color=0,g.detach(),$(),d.root.parent=e.$vC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===g?(a.parent=i.parent,w(d,a)):(i.parent===g?a.parent=i:a.parent=i.parent,w(d,a),i.left=g.left,i.right=g.right,i.parent=g.parent,i.color=g.color,g===d.root?d.root=i:g===g.parent.left?g.parent.left=i:g.parent.right=i,i.left!==e.$vC&&(i.left.parent=i),i.right!==e.$vC&&(i.right.parent=i),i.size_left=g.size_left,i.lf_left=g.lf_left,w(d,i)),g.detach(),a.parent.left===a){const o=R(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const h=o-a.parent.size_left,s=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,y(d,a.parent,h,s)}}if(w(d,a.parent),n){$();return}let u;for(;a!==d.root&&a.color===0;)a===a.parent.left?(u=a.parent.right,u.color===1&&(u.color=0,a.parent.color=1,S(d,a.parent),u=a.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.right.color===0&&(u.left.color=0,u.color=1,N(d,u),u=a.parent.right),u.color=a.parent.color,a.parent.color=0,u.right.color=0,S(d,a.parent),a=d.root)):(u=a.parent.left,u.color===1&&(u.color=0,a.parent.color=1,N(d,a.parent),u=a.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.left.color===0&&(u.right.color=0,u.color=1,S(d,u),u=a.parent.left),u.color=a.parent.color,a.parent.color=0,u.left.color=0,N(d,a.parent),a=d.root));a.color=0,$()}function m(d,g){for(w(d,g);g!==d.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const a=g.parent.parent.right;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,S(d,g)),g.parent.color=0,g.parent.parent.color=1,N(d,g.parent.parent))}else{const a=g.parent.parent.left;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,N(d,g)),g.parent.color=0,g.parent.parent.color=1,S(d,g.parent.parent))}d.root.color=0}function y(d,g,a,i){for(;g!==d.root&&g!==e.$vC;)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=i),g=g.parent}function w(d,g){let a=0,i=0;if(g!==d.root){for(;g!==d.root&&g===g.parent.right;)g=g.parent;if(g!==d.root)for(g=g.parent,a=R(g.left)-g.size_left,i=b(g.left)-g.lf_left,g.size_left+=a,g.lf_left+=i;g!==d.root&&(a!==0||i!==0);)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=i),g=g.parent}}}),define(ke[182],Se([1,0,19,127]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=void 0;class L{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,S){$=(0,M.$4e)($);const N=this.a,C=this.b,m=S.length;return m===0?!1:(this.a=new Uint32Array(N.length+m),this.a.set(N.subarray(0,$),0),this.a.set(N.subarray($),$+m),this.a.set(S,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,S){return $=(0,M.$4e)($),S=(0,M.$4e)(S),this.a[$]===S?!1:(this.a[$]=S,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,S){$=(0,M.$4e)($),S=(0,M.$4e)(S);const N=this.a,C=this.b;if($>=N.length)return!1;const m=N.length-$;return S>=m&&(S=m),S===0?!1:(this.a=new Uint32Array(N.length-S),this.a.set(N.subarray(0,$),0),this.a.set(N.subarray($+S),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,M.$4e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),$>=this.a.length&&($=this.a.length-1);for(let N=S;N<=$;N++)this.b[N]=this.b[N-1]+this.a[N];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let S=0,N=this.a.length-1,C=0,m=0,y=0;for(;S<=N;)if(C=S+(N-S)/2|0,m=this.b[C],y=m-this.a[C],$<y)N=C-1;else if($>=m)S=C+1;else break;return new R(C,$-y)}}e.$Rv=L;class A{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const S=this.e[$],N=S>0?this.d[S-1]:0;return new R(S,$-N)}removeValues($,S){this.a.splice($,S),this.f($)}insertValues($,S){this.a=(0,l.$Wb)(this.a,$,S),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,S=this.a.length;$<S;$++){const N=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+N;for(let m=0;m<N;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,S){this.a[$]!==S&&(this.a[$]=S,this.f($))}}e.$Sv=A;class R{constructor($,S){this.index=$,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=S}}e.$Tv=R}),define(ke[183],Se([1,0,14,50,182]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=void 0;class A{constructor(b,$,S,N){this.d=b,this.f=$,this.g=S,this.h=N,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const S of $)this.o(S.range),this.p(new M.$ot(S.range.startLineNumber,S.range.startColumn),S.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,S=new Uint32Array($);for(let N=0;N<$;N++)S[N]=this.f[N].length+b;this.j=new L.$Rv(S)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const S=(0,l.$if)($);if(S.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]+this.f[b.lineNumber-1].substring(b.column-1));return}S[S.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]);const N=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(b.lineNumber+C-1,0,S[C]),N[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,N)}}e.$Uv=A}),define(ke[100],Se([1,0,14,178,50,29,79]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$HC=e.$EC=void 0,e.$FC=S,e.$GC=N,e.$IC=d;const b=999;class ${constructor(i,n,u,o){this.searchString=i,this.isRegex=n,this.matchCase=u,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=S(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=l.$gf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let u=!this.isRegex&&!i;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new R.$Dv(n,this.wordSeparators?(0,M.$Gt)(this.wordSeparators,[]):null,u?this.searchString:null)}}e.$EC=$;function S(a){if(!a||a.length===0)return!1;for(let i=0,n=a.length;i<n;i++){const u=a.charCodeAt(i);if(u===10)return!0;if(u===92){if(i++,i>=n)break;const o=a.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}function N(a,i,n){if(!n)return new R.$Av(a,null);const u=[];for(let o=0,t=i.length;o<t;o++)u[o]=i[o];return new R.$Av(a,u)}class C{constructor(i){const n=[];let u=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(n[u++]=o);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let u=0,o=n.length-1;if(o===-1||i<=n[0])return 0;for(;u<o;){const t=u+((o-u)/2>>0);n[t]>=i?o=t-1:n[t+1]>=i?(u=t,o=t):u=t+1}return u+1}}class m{static findMatches(i,n,u,o,t){const h=n.parseSearchRequest();return h?h.regex.multiline?this.b(i,u,new g(h.wordSeparators,h.regex),o,t):this.c(i,u,h,o,t):[]}static a(i,n,u,o,t,h){let s,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),s=n+t+c):s=n+t;let r;if(o){const p=o.findLineFeedCountBeforeOffset(t+h.length)-c;r=s+h.length+p}else r=s+h.length;const v=i.getPositionAt(s),f=i.getPositionAt(r);return new A.$pt(v.lineNumber,v.column,f.lineNumber,f.column)}static b(i,n,u,o,t){const h=i.getOffsetAt(n.getStartPosition()),s=i.getValueInRange(n,1),c=i.getEOL()===`\r
`?new C(s):null,r=[];let v=0,f;for(u.reset(0);f=u.next(s);)if(r[v++]=N(this.a(i,h,s,c,f.index,f[0]),f,o),v>=t)return r;return r}static c(i,n,u,o,t){const h=[];let s=0;if(n.startLineNumber===n.endLineNumber){const r=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return s=this.d(u,r,n.startLineNumber,n.startColumn-1,s,h,o,t),h}const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);s=this.d(u,c,n.startLineNumber,n.startColumn-1,s,h,o,t);for(let r=n.startLineNumber+1;r<n.endLineNumber&&s<t;r++)s=this.d(u,i.getLineContent(r),r,0,s,h,o,t);if(s<t){const r=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);s=this.d(u,r,n.endLineNumber,0,s,h,o,t)}return h}static d(i,n,u,o,t,h,s,c){const r=i.wordSeparators;if(!s&&i.simpleSearch){const D=i.simpleSearch,p=D.length,E=n.length;let k=-p;for(;(k=n.indexOf(D,k+p))!==-1;)if((!r||d(r,n,E,k,p))&&(h[t++]=new R.$Av(new A.$pt(u,k+1+o,u,k+1+p+o),null),t>=c))return t;return t}const v=new g(i.wordSeparators,i.regex);let f;v.reset(0);do if(f=v.next(n),f&&(h[t++]=N(new A.$pt(u,f.index+1+o,u,f.index+1+f[0].length+o),f,s),t>=c))return t;while(f);return t}static findNextMatch(i,n,u,o){const t=n.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,u,h,o):this.f(i,u,h,o)}static e(i,n,u,o){const t=new L.$ot(n.lineNumber,1),h=i.getOffsetAt(t),s=i.getLineCount(),c=i.getValueInRange(new A.$pt(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),r=i.getEOL()===`\r
`?new C(c):null;u.reset(n.column-1);const v=u.next(c);return v?N(this.a(i,h,c,r,v.index,v[0]),v,o):n.lineNumber!==1||n.column!==1?this.e(i,new L.$ot(1,1),u,o):null}static f(i,n,u,o){const t=i.getLineCount(),h=n.lineNumber,s=i.getLineContent(h),c=this.g(u,s,h,n.column,o);if(c)return c;for(let r=1;r<=t;r++){const v=(h+r-1)%t,f=i.getLineContent(v+1),D=this.g(u,f,v+1,1,o);if(D)return D}return null}static g(i,n,u,o,t){i.reset(o-1);const h=i.next(n);return h?N(new A.$pt(u,h.index+1,u,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,n,u,o){const t=n.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,u,h,o):this.j(i,u,h,o)}static h(i,n,u,o){const t=this.b(i,new A.$pt(1,1,n.lineNumber,n.column),u,o,10*b);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return n.lineNumber!==h||n.column!==i.getLineMaxColumn(h)?this.h(i,new L.$ot(h,i.getLineMaxColumn(h)),u,o):null}static j(i,n,u,o){const t=i.getLineCount(),h=n.lineNumber,s=i.getLineContent(h).substring(0,n.column-1),c=this.k(u,s,h,o);if(c)return c;for(let r=1;r<=t;r++){const v=(t+h-r-1)%t,f=i.getLineContent(v+1),D=this.k(u,f,v+1,o);if(D)return D}return null}static k(i,n,u,o){let t=null,h;for(i.reset(0);h=i.next(n);)t=N(new A.$pt(u,h.index+1,u,h.index+1+h[0].length),h,o);return t}}e.$HC=m;function y(a,i,n,u,o){if(u===0)return!0;const t=i.charCodeAt(u-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(u);if(a.get(h)!==0)return!0}return!1}function w(a,i,n,u,o){if(u+o===n)return!0;const t=i.charCodeAt(u+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(u+o-1);if(a.get(h)!==0)return!0}return!1}function d(a,i,n,u,o){return y(a,i,n,u,o)&&w(a,i,n,u,o)}class g{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let u;do{if(this.b+this.c===n||(u=this.a.exec(i),!u))return null;const o=u.index,t=u[0].length;if(o===this.b&&t===this.c){if(t===0){l.$Cf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||d(this._wordSeparators,i,n,o,t))return u}while(u);return null}}e.$JC=g}),define(ke[130],Se([1,0,50,29,79,181,100]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=e.$NC=e.$MC=void 0,e.$KC=N,e.$LC=C;const b=65535;function $(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class S{constructor(i,n,u,o,t){this.lineStarts=i,this.cr=n,this.lf=u,this.crlf=o,this.isBasicASCII=t}}function N(a,i=!0){const n=[0];let u=1;for(let o=0,t=a.length;o<t;o++){const h=a.charCodeAt(o);h===13?o+1<t&&a.charCodeAt(o+1)===10?(n[u++]=o+2,o++):n[u++]=o+1:h===10&&(n[u++]=o+1)}return i?$(n):n}function C(a,i){a.length=0,a[0]=0;let n=1,u=0,o=0,t=0,h=!0;for(let c=0,r=i.length;c<r;c++){const v=i.charCodeAt(c);v===13?c+1<r&&i.charCodeAt(c+1)===10?(t++,a[n++]=c+2,c++):(u++,a[n++]=c+1):v===10?(o++,a[n++]=c+1):h&&v!==9&&(v<32||v>126)&&(h=!1)}const s=new S($(a),u,o,t,h);return a.length=0,s}class m{constructor(i,n,u,o,t){this.bufferIndex=i,this.start=n,this.end=u,this.lineFeedCnt=o,this.length=t}}e.$MC=m;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$NC=y;class w{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$vC&&i.iterate(i.root,u=>(u!==A.$vC&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class d{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const u=this.b[n];if(u.nodeStartOffset<=i&&u.nodeStartOffset+u.node.piece.length>=i)return u}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const u=this.b[n];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<i&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=i)return u}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const u=this.b;for(let o=0;o<u.length;o++){const t=u[o];if(t.node.parent===null||t.nodeStartOffset>=i){u[o]=null,n=!0;continue}}if(n){const o=[];for(const t of u)t!==null&&o.push(t);this.b=o}}}class g{constructor(i,n,u){this.create(i,n,u)}create(i,n,u){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=A.$vC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=u;let o=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=N(i[t].buffer));const s=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),o=this.S(o,s)}this.h=new d(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,u=n-Math.floor(n/3),o=u*2;let t="",h=0;const s=[];if(this.iterate(this.root,c=>{const r=this.R(c),v=r.length;if(h<=u||h+v<o)return t+=r,h+=v,!0;const f=t.replace(/\r\n|\r|\n/g,i);return s.push(new y(f,N(f))),t=r,h=v,!0}),h>0){const c=t.replace(/\r\n|\r|\n/g,i);s.push(new y(c,N(c)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new w(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===A.$vC)return!0;const t=this.R(o),h=t.length,s=i.G(n),c=i.G(n+h),r=i.getValueInRange2(s,c);return n+=h,t===r})}getOffsetAt(i,n){let u=0,o=this.root;for(;o!==A.$vC;)if(o.left!==A.$vC&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){u+=o.size_left;const t=this.B(o,i-o.lf_left-2);return u+=t+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,u+=o.size_left+o.piece.length,o=o.right;return u}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,u=0;const o=i;for(;n!==A.$vC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(u+=n.lf_left+t.index,t.index===0){const h=this.getOffsetAt(u+1,1),s=o-h;return new l.$ot(u+1,s+1)}return new l.$ot(u+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,u+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$vC){const t=this.getOffsetAt(u+1,1),h=o-i-t;return new l.$ot(u+1,h+1)}else n=n.right;return new l.$ot(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const u=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(u,o);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const s=i.node,c=this.a[s.piece.bufferIndex].buffer,r=this.u(s.piece.bufferIndex,s.piece.start);return c.substring(r+i.remainder,r+n.remainder)}let u=i.node;const o=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let h=o.substring(t+i.remainder,t+u.piece.length);for(u=u.next();u!==A.$vC;){const s=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(u===n.node){h+=s.substring(c,c+n.remainder);break}else h+=s.substr(c,u.piece.length);u=u.next()}return h}getLinesContent(){const i=[];let n=0,u="",o=!1;return this.iterate(this.root,t=>{if(t===A.$vC)return!0;const h=t.piece;let s=h.length;if(s===0)return!0;const c=this.a[h.bufferIndex].buffer,r=this.a[h.bufferIndex].lineStarts,v=h.start.line,f=h.end.line;let D=r[v]+h.start.column;if(o&&(c.charCodeAt(D)===10&&(D++,s--),i[n++]=u,u="",o=!1,s===0))return!0;if(v===f)return!this.f&&c.charCodeAt(D+s-1)===13?(o=!0,u+=c.substr(D,s-1)):u+=c.substr(D,s),!0;u+=this.f?c.substring(D,Math.max(D,r[v+1]-this.e)):c.substring(D,r[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=u;for(let p=v+1;p<f;p++)u=this.f?c.substring(r[p],r[p+1]-this.e):c.substring(r[p],r[p+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=u;return!this.f&&c.charCodeAt(r[f]+h.end.column-1)===13?(o=!0,h.end.column===0?n--:u=c.substr(r[f],h.end.column-1)):u=c.substr(r[f],h.end.column),!0}),o&&(i[n++]=u,u=""),i[n++]=u,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const u=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return u.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const u=this.H(i,n+1);return this.l(u)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,u,o,t,h,s,c,r,v,f){const D=this.a[i.piece.bufferIndex],p=this.u(i.piece.bufferIndex,i.piece.start),E=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,h);let P;const I={line:0,column:0};let T,j;n._wordSeparators?(T=D.buffer.substring(E,k),j=z=>z+E,n.reset(0)):(T=D.buffer,j=z=>z,n.reset(E));do if(P=n.next(T),P){if(j(P.index)>=k)return v;this.s(i,j(P.index)-p,I);const z=this.t(i.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+o:I.column+1,F=O+P[0].length;if(f[v++]=(0,R.$GC)(new M.$pt(u+z,O,u+z,F),P,c),j(P.index)+P[0].length>=k||v>=r)return v}while(P);return v}findMatchesLineByLine(i,n,u,o){const t=[];let h=0;const s=new R.$JC(n.wordSeparators,n.regex);let c=this.H(i.startLineNumber,i.startColumn);if(c===null)return[];const r=this.H(i.endLineNumber,i.endColumn);if(r===null)return[];let v=this.s(c.node,c.remainder);const f=this.s(r.node,r.remainder);if(c.node===r.node)return this.findMatchesInNode(c.node,s,i.startLineNumber,i.startColumn,v,f,n,u,o,h,t),t;let D=i.startLineNumber,p=c.node;for(;p!==r.node;){const k=this.t(p.piece.bufferIndex,v,p.piece.end);if(k>=1){const I=this.a[p.piece.bufferIndex].lineStarts,T=this.u(p.piece.bufferIndex,p.piece.start),j=I[v.line+k],z=D===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(p,s,D,z,v,this.s(p,j-T),n,u,o,h,t),h>=o)return t;D+=k}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const I=this.getLineContent(D).substring(P,i.endColumn-1);return h=this.n(n,s,I,i.endLineNumber,P,h,t,u,o),t}if(h=this.n(n,s,this.getLineContent(D).substr(P),D,P,h,t,u,o),h>=o)return t;D++,c=this.H(D,1),p=c.node,v=this.s(c.node,c.remainder)}if(D===i.endLineNumber){const k=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(k,i.endColumn-1);return h=this.n(n,s,P,i.endLineNumber,k,h,t,u,o),t}const E=D===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(r.node,s,D,E,v,f,n,u,o,h,t),t}n(i,n,u,o,t,h,s,c,r){const v=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,p=D.length,E=u.length;let k=-p;for(;(k=u.indexOf(D,k+p))!==-1;)if((!v||(0,R.$IC)(v,u,E,k,p))&&(s[h++]=new L.$Av(new M.$pt(o,k+1+t,o,k+1+p+t),null),h>=r))return h;return h}let f;n.reset(0);do if(f=n.next(u),f&&(s[h++]=(0,R.$GC)(new M.$pt(o,f.index+1+t,o,f.index+1+f[0].length+t),f,c),h>=r))return h;while(f);return h}insert(i,n,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==A.$vC){const{node:o,remainder:t,nodeStartOffset:h}=this.G(i),s=o.piece,c=s.bufferIndex,r=this.s(o,t);if(o.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&n.length<b){this.F(o,n),this.y();return}if(h===i)this.o(n,o),this.h.validate(i);else if(h+o.piece.length>i){const v=[];let f=new m(s.bufferIndex,r,s.end,this.t(s.bufferIndex,r,s.end),this.u(c,s.end)-this.u(c,r));if(this.K()&&this.M(n)&&this.I(o,t)===10){const k={line:f.start.line+1,column:0};f=new m(f.bufferIndex,k,f.end,this.t(f.bufferIndex,k,f.end),f.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,t-1)===13){const k=this.s(o,t-1);this.C(o,k),n="\r"+n,o.piece.length===0&&v.push(o)}else this.C(o,r);else this.C(o,r);const D=this.w(n);f.length>0&&this.S(o,f);let p=o;for(let E=0;E<D.length;E++)p=this.S(p,D[E]);this.v(v)}else this.q(n,o)}else{const o=this.w(n);let t=this.T(null,o[0]);for(let h=1;h<o.length;h++)t=this.S(t,o[h])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$vC)return;const u=this.G(i),o=this.G(i+n),t=u.node,h=o.node;if(t===h){const D=this.s(t,u.remainder),p=this.s(t,o.remainder);if(u.nodeStartOffset===i){if(n===t.piece.length){const E=t.next();(0,A.$AC)(this,t),this.N(E),this.y();return}this.D(t,p),this.h.validate(i),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,p),this.y();return}const s=[],c=this.s(t,u.remainder);this.C(t,c),this.h.validate(i),t.piece.length===0&&s.push(t);const r=this.s(h,o.remainder);this.D(h,r),h.piece.length===0&&s.push(h);const v=t.next();for(let D=v;D!==A.$vC&&D!==h;D=D.next())s.push(D);const f=t.piece.length===0?t.prev():t;this.v(s),this.O(f),this.y()}o(i,n){const u=[];if(this.K()&&this.M(i)&&this.L(n)){const h=n.piece,s={line:h.start.line+1,column:0},c=new m(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);n.piece=c,i+=`
`,(0,A.$CC)(this,n,-1,-1),n.piece.length===0&&u.push(n)}const o=this.w(i);let t=this.T(n,o[o.length-1]);for(let h=o.length-2;h>=0;h--)t=this.T(t,o[h]);this.N(t),this.v(u)}q(i,n){this.Q(i,n)&&(i+=`
`);const u=this.w(i),o=this.S(n,u[0]);let t=o;for(let h=1;h<u.length;h++)t=this.S(t,u[h]);this.N(o)}s(i,n,u){const o=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,c=h[o.start.line]+o.start.column+n;let r=o.start.line,v=o.end.line,f=0,D=0,p=0;for(;r<=v&&(f=r+(v-r)/2|0,p=h[f],f!==v);)if(D=h[f+1],c<p)v=f-1;else if(c>=D)r=f+1;else break;return u?(u.line=f,u.column=c-p,null):{line:f,column:c-p}}t(i,n,u){if(u.column===0)return u.line-n.line;const o=this.a[i].lineStarts;if(u.line===o.length-1)return u.line-n.line;const t=o[u.line+1],h=o[u.line]+u.column;if(t>h+1)return u.line-n.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?u.line-n.line+1:u.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$AC)(this,i[n])}w(i){if(i.length>b){const v=[];for(;i.length>b;){const D=i.charCodeAt(b-1);let p;D===13||D>=55296&&D<=56319?(p=i.substring(0,b-1),i=i.substring(b-1)):(p=i.substring(0,b),i=i.substring(b));const E=N(p);v.push(new m(this.a.length,{line:0,column:0},{line:E.length-1,column:p.length-E[E.length-1]},E.length-1,p.length)),this.a.push(new y(p,E))}const f=N(i);return v.push(new m(this.a.length,{line:0,column:0},{line:f.length-1,column:i.length-f[f.length-1]},f.length-1,i.length)),this.a.push(new y(i,f)),v}let n=this.a[0].buffer.length;const u=N(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let v=0;v<u.length;v++)u[v]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let v=0;v<u.length;v++)u[v]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[h],c={line:h,column:s},r=new m(0,o,c,this.t(0,o,c),t-n);return this.g=c,[r]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let u=this.root,o="";const t=this.h.get2(i);if(t){u=t.node;const h=this.B(u,i-t.nodeStartLineNumber-1),s=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===i)o=s.substring(c+h,c+u.piece.length);else{const r=this.B(u,i-t.nodeStartLineNumber);return s.substring(c+h,c+r-n)}}else{let h=0;const s=i;for(;u!==A.$vC;)if(u.left!==A.$vC&&u.lf_left>=i-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>i-1){const c=this.B(u,i-u.lf_left-2),r=this.B(u,i-u.lf_left-1),v=this.a[u.piece.bufferIndex].buffer,f=this.u(u.piece.bufferIndex,u.piece.start);return h+=u.size_left,this.h.set({node:u,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-u.lf_left)}),v.substring(f+c,f+r-n)}else if(u.lf_left+u.piece.lineFeedCnt===i-1){const c=this.B(u,i-u.lf_left-2),r=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);o=r.substring(v+c,v+u.piece.length);break}else i-=u.lf_left+u.piece.lineFeedCnt,h+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==A.$vC;){const h=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const s=this.B(u,0),c=this.u(u.piece.bufferIndex,u.piece.start);return o+=h.substring(c,c+s-n),o}else{const s=this.u(u.piece.bufferIndex,u.piece.start);o+=h.substr(s,u.piece.length)}u=u.next()}return o}y(){let i=this.root,n=1,u=0;for(;i!==A.$vC;)n+=i.lf_left+i.piece.lineFeedCnt,u+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=u,this.h.validate(this.c)}A(i,n){const u=i.piece,o=this.s(i,n),t=o.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===n){const h=this.t(i.piece.bufferIndex,u.start,o);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:o.column}}B(i,n){if(n<0)return 0;const u=i.piece,o=this.a[u.bufferIndex].lineStarts,t=u.start.line+n+1;return t>u.end.line?o[u.end.line]+u.end.column-o[u.start.line]-u.start.column:o[t]-o[u.start.line]-u.start.column}C(i,n){const u=i.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),h=n,s=this.u(u.bufferIndex,h),c=this.t(u.bufferIndex,u.start,h),r=c-o,v=s-t,f=u.length+v;i.piece=new m(u.bufferIndex,u.start,h,c,f),(0,A.$CC)(this,i,v,r)}D(i,n){const u=i.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),h=n,s=this.t(u.bufferIndex,h,u.end),c=this.u(u.bufferIndex,h),r=s-o,v=t-c,f=u.length+v;i.piece=new m(u.bufferIndex,h,u.end,s,f),(0,A.$CC)(this,i,v,r)}E(i,n,u){const o=i.piece,t=o.start,h=o.end,s=o.length,c=o.lineFeedCnt,r=n,v=this.t(o.bufferIndex,o.start,r),f=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,t);i.piece=new m(o.bufferIndex,o.start,r,v,f),(0,A.$CC)(this,i,f-s,v-c);const D=new m(o.bufferIndex,u,h,this.t(o.bufferIndex,u,h),this.u(o.bufferIndex,h)-this.u(o.bufferIndex,u)),p=this.S(i,D);this.N(p)}F(i,n){this.Q(n,i)&&(n+=`
`);const u=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const t=N(n,!1);for(let p=0;p<t.length;p++)t[p]+=o;if(u){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],c={line:h,column:s},r=i.piece.length+n.length,v=i.piece.lineFeedCnt,f=this.t(0,i.piece.start,c),D=f-v;i.piece=new m(i.piece.bufferIndex,i.piece.start,c,f,r),this.g=c,(0,A.$CC)(this,i,n.length,D)}G(i){let n=this.root;const u=this.h.get(i);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:i-u.nodeStartOffset};let o=0;for(;n!==A.$vC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(t),t}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let u=this.root,o=0;for(;u!==A.$vC;)if(u.left!==A.$vC&&u.lf_left>=i-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>i-1){const t=this.B(u,i-u.lf_left-2),h=this.B(u,i-u.lf_left-1);return o+=u.size_left,{node:u,remainder:Math.min(t+n-1,h),nodeStartOffset:o}}else if(u.lf_left+u.piece.lineFeedCnt===i-1){const t=this.B(u,i-u.lf_left-2);if(t+n-1<=u.piece.length)return{node:u,remainder:t+n-1,nodeStartOffset:o};n-=u.piece.length-t;break}else i-=u.lf_left+u.piece.lineFeedCnt,o+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==A.$vC;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),h=this.J(u);return{node:u,remainder:Math.min(n-1,t),nodeStartOffset:h}}else if(u.piece.length>=n-1){const t=this.J(u);return{node:u,remainder:n-1,nodeStartOffset:t}}else n-=u.piece.length;u=u.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const u=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return u.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$vC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,u=this.a[n.bufferIndex].lineStarts,o=n.start.line,t=u[o]+n.start.column;return o===u.length-1||u[o+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$vC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const u=[],o=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,s,h),(0,A.$CC)(this,i,-1,-1),i.piece.length===0&&u.push(i);const c={line:n.piece.start.line+1,column:0},r=n.piece.length-1,v=this.t(n.piece.bufferIndex,c,n.piece.end);n.piece=new m(n.piece.bufferIndex,c,n.piece.end,v,r),(0,A.$CC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const f=this.w(`\r
`);this.S(i,f[0]);for(let D=0;D<u.length;D++)(0,A.$AC)(this,u[D])}Q(i,n){if(this.K()&&this.M(i)){const u=n.next();if(this.L(u)){if(i+=`
`,u.piece.length===1)(0,A.$AC)(this,u);else{const o=u.piece,t={line:o.start.line+1,column:0},h=o.length-1,s=this.t(o.bufferIndex,t,o.end);u.piece=new m(o.bufferIndex,t,o.end,s,h),(0,A.$CC)(this,u,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$vC)return n(A.$vC);const u=this.iterate(i.left,n);return u&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$vC)return"";const n=this.a[i.piece.bufferIndex],u=i.piece,o=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return n.buffer.substring(o,t)}getPieceContent(i){const n=this.a[i.bufferIndex],u=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(u,o)}S(i,n){const u=new A.$uC(n,1);if(u.left=A.$vC,u.right=A.$vC,u.parent=A.$vC,u.size_left=0,u.lf_left=0,this.root===A.$vC)this.root=u,u.color=0;else if(i.right===A.$vC)i.right=u,u.parent=i;else{const t=(0,A.$wC)(i.right);t.left=u,u.parent=t}return(0,A.$BC)(this,u),u}T(i,n){const u=new A.$uC(n,1);if(u.left=A.$vC,u.right=A.$vC,u.parent=A.$vC,u.size_left=0,u.lf_left=0,this.root===A.$vC)this.root=u,u.color=0;else if(i.left===A.$vC)i.left=u,u.parent=i;else{const o=(0,A.$xC)(i.left);o.right=u,u.parent=o}return(0,A.$BC)(this,u),u}U(i){let n="";return this.iterate(i,u=>(n+=this.R(u),!0)),n}}e.$OC=g}),define(ke[184],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9=e.$x9=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$x9=l;class M{constructor(A){this.identifier=A}}e.$y9=M}),define(ke[185],Se([1,0,4,3]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$ce,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,M.$Tc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const S=new A(this,b,$);return this.b.set(b,S),(0,M.$Tc)(()=>{const N=this.b.get(b);!N||N!==S||(this.b.delete(b),N.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const S=this.b.get(b);return!S||S.isResolved?null:(await S.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const S=this.b.get(b);return!!(!S||S.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Rt=L;class A extends M.$Vc{get isResolved(){return this.c}constructor(b,$,S){super(),this.f=b,this.g=$,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[186],Se([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Se([1,0,4,3,186]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=void 0,e.$dj=N;class A extends M.$Vc{constructor(m,y="",w="",d=!0,g){super(),this.h=this.B(new l.$ce),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=y,this.u=w,this.w=d,this.C=g}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,y){this.C&&await this.C(m)}}e.$$i=A;class R extends M.$Vc{constructor(){super(...arguments),this.f=this.B(new l.$ce),this.onWillRun=this.f.event,this.m=this.B(new l.$ce),this.onDidRun=this.m.event}async run(m,y){if(!m.enabled)return;this.f.fire({action:m});let w;try{await this.u(m,y)}catch(d){w=d}this.m.fire({action:m,error:w})}async u(m,y){await m.run(y)}}e.$_i=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let y=[];for(const w of m)w.length&&(y.length?y=[...y,new b,...w]:y=w);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$aj=b;class ${get actions(){return this.a}constructor(m,y,w,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=y,this.class=d,this.a=w}async run(){}}e.$bj=$;class S extends A{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$cj=S;function N(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...m)=>C.run(...m),tooltip:C.label}}}),define(ke[188],Se([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Se([1,0,188]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=S,e.$Zm=N,e.$1m=C;const M=60,L=M*60,A=L*24,R=A*7,b=A*30,$=A*365;function S(m,y,w,d){typeof m!="number"&&(m=m.getTime());const g=Math.round((new Date().getTime()-m)/1e3);if(g<-30)return(0,l.localize)(0,null,S(new Date().getTime()+g*1e3,!1));if(!d&&g<30)return(0,l.localize)(1,null);let a;return g<M?(a=g,y?a===1?w?(0,l.localize)(2,null,a):(0,l.localize)(3,null,a):w?(0,l.localize)(4,null,a):(0,l.localize)(5,null,a):a===1?w?(0,l.localize)(6,null,a):(0,l.localize)(7,null,a):w?(0,l.localize)(8,null,a):(0,l.localize)(9,null,a)):g<L?(a=Math.floor(g/M),y?a===1?w?(0,l.localize)(10,null,a):(0,l.localize)(11,null,a):w?(0,l.localize)(12,null,a):(0,l.localize)(13,null,a):a===1?w?(0,l.localize)(14,null,a):(0,l.localize)(15,null,a):w?(0,l.localize)(16,null,a):(0,l.localize)(17,null,a)):g<A?(a=Math.floor(g/L),y?a===1?w?(0,l.localize)(18,null,a):(0,l.localize)(19,null,a):w?(0,l.localize)(20,null,a):(0,l.localize)(21,null,a):a===1?w?(0,l.localize)(22,null,a):(0,l.localize)(23,null,a):w?(0,l.localize)(24,null,a):(0,l.localize)(25,null,a)):g<R?(a=Math.floor(g/A),y?a===1?(0,l.localize)(26,null,a):(0,l.localize)(27,null,a):a===1?(0,l.localize)(28,null,a):(0,l.localize)(29,null,a)):g<b?(a=Math.floor(g/R),y?a===1?w?(0,l.localize)(30,null,a):(0,l.localize)(31,null,a):w?(0,l.localize)(32,null,a):(0,l.localize)(33,null,a):a===1?w?(0,l.localize)(34,null,a):(0,l.localize)(35,null,a):w?(0,l.localize)(36,null,a):(0,l.localize)(37,null,a)):g<$?(a=Math.floor(g/b),y?a===1?w?(0,l.localize)(38,null,a):(0,l.localize)(39,null,a):w?(0,l.localize)(40,null,a):(0,l.localize)(41,null,a):a===1?w?(0,l.localize)(42,null,a):(0,l.localize)(43,null,a):w?(0,l.localize)(44,null,a):(0,l.localize)(45,null,a)):(a=Math.floor(g/$),y?a===1?w?(0,l.localize)(46,null,a):(0,l.localize)(47,null,a):w?(0,l.localize)(48,null,a):(0,l.localize)(49,null,a):a===1?w?(0,l.localize)(50,null,a):(0,l.localize)(51,null,a):w?(0,l.localize)(52,null,a):(0,l.localize)(53,null,a))}function N(m,y){const w=Math.abs(m/1e3);return w<1?y?(0,l.localize)(54,null,m):(0,l.localize)(55,null,m):w<M?y?(0,l.localize)(56,null,Math.round(m)/1e3):(0,l.localize)(57,null,Math.round(m)/1e3):w<L?y?(0,l.localize)(58,null,Math.round(m/(1e3*M))):(0,l.localize)(59,null,Math.round(m/(1e3*M))):w<A?y?(0,l.localize)(60,null,Math.round(m/(1e3*L))):(0,l.localize)(61,null,Math.round(m/(1e3*L))):(0,l.localize)(62,null,Math.round(m/(1e3*A)))}function C(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Se([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Se([1,0,19,18,190]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=$,e.$fj=S,e.$gj=N;function A(C,m){return m&&(C.stack||C.stacktrace)?L.localize(0,null,b(C),R(C.stack)||R(C.stacktrace)):b(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function $(C=null,m=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const y=l.$Hb(C),w=$(y[0],m);return y.length>1?L.localize(4,null,w,y.length):w}if(M.$6f(C))return C;if(C.detail){const y=C.detail;if(y.error)return A(y.error,m);if(y.exception)return A(y.exception,m)}return C.stack?A(C,m):C.message?C.message:L.localize(5,null)}function S(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}function N(C,m){let y;return typeof C=="string"?y=new Error(C):y=C,y.actions=m,y}}),define(ke[191],Se([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,191]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=h,e.$D=D,e.$J=p,e.$g="en";let M=!1,L=!1,A=!1,R=!1,b=!1,$=!1,S=!1,N=!1,C=!1,m=!1,y,w=e.$g,d=e.$g,g,a;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const u=typeof n?.versions?.electron=="string",o=u&&n?.type==="renderer";if(typeof n=="object"){M=n.platform==="win32",L=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,S=u,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,w=e.$g;const E=n.env.VSCODE_NLS_CONFIG;if(E)try{const k=JSON.parse(E),P=k.availableLanguages["*"];y=k.locale,d=k.osLocale,w=P||e.$g,g=k._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,M=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,N=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=a.indexOf("Linux")>=0,m=a?.indexOf("Mobi")>=0,$=!0,y=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,w=y,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;L?s=1:M?s=3:A&&(s=2),e.$i=M,e.$j=L,e.$k=A,e.$l=R,e.$m=b,e.$n=S,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=N,e.$s=m,e.$t=C,e.$u=s,e.$v=a,e.$w=w;var c;(function(E){function k(){return e.$w}E.value=k;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=P;function I(){return e.$w==="en"}E.isDefault=I})(c||(e.Language=c={})),e.$x=y,e.$y=d,e.$z=g,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const E=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,T=E.length;I<T;I++){const j=E[I];if(j.id===P.data.vscodeScheduleAsyncWork){E.splice(I,1),j.callback();return}}});let k=0;return P=>{const I=++k;E.push({id:I,callback:P}),i.postMessage({vscodeScheduleAsyncWork:I},"*")}}return E=>setTimeout(E)})();var r;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=L||N?2:M?1:3;let v=!0,f=!1;function D(){if(!f){f=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,v=new Uint16Array(E.buffer)[0]===513}return v}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(E){return parseFloat(E)>=20}}),define(ke[51],Se([1,0,11]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let M;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;M={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$ec=M.platform,e.$fc=M.arch}),define(ke[17],Se([1,0,51]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const M=65,L=97,A=90,R=122,b=46,$=47,S=92,N=58,C=63;class m extends Error{constructor(h,s,c){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const v=h.indexOf(".")!==-1?"property":"argument";let f=`The "${h}" ${v} ${r} of type ${s}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,h){if(t===null||typeof t!="object")throw new m(h,"Object",t)}function w(t,h){if(typeof t!="string")throw new m(h,"string",t)}const d=l.$ec==="win32";function g(t){return t===$||t===S}function a(t){return t===$}function i(t){return t>=M&&t<=A||t>=L&&t<=R}function n(t,h,s,c){let r="",v=0,f=-1,D=0,p=0;for(let E=0;E<=t.length;++E){if(E<t.length)p=t.charCodeAt(E);else{if(c(p))break;p=$}if(c(p)){if(!(f===E-1||D===1))if(D===2){if(r.length<2||v!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const k=r.lastIndexOf(s);k===-1?(r="",v=0):(r=r.slice(0,k),v=r.length-1-r.lastIndexOf(s)),f=E,D=0;continue}else if(r.length!==0){r="",v=0,f=E,D=0;continue}}h&&(r+=r.length>0?`${s}..`:"..",v=2)}else r.length>0?r+=`${s}${t.slice(f+1,E)}`:r=t.slice(f+1,E),v=E-f-1;f=E,D=0}else p===b&&D!==-1?++D:D=-1}return r}function u(t,h){y(h,"pathObject");const s=h.dir||h.root,c=h.base||`${h.name||""}${h.ext||""}`;return s?s===h.root?`${s}${c}`:`${s}${t}${c}`:c}e.$gc={resolve(...t){let h="",s="",c=!1;for(let r=t.length-1;r>=-1;r--){let v;if(r>=0){if(v=t[r],w(v,"path"),v.length===0)continue}else h.length===0?v=l.cwd():(v=l.env[`=${h}`]||l.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==h.toLowerCase()&&v.charCodeAt(2)===S)&&(v=`${h}\\`));const f=v.length;let D=0,p="",E=!1;const k=v.charCodeAt(0);if(f===1)g(k)&&(D=1,E=!0);else if(g(k))if(E=!0,g(v.charCodeAt(1))){let P=2,I=P;for(;P<f&&!g(v.charCodeAt(P));)P++;if(P<f&&P!==I){const T=v.slice(I,P);for(I=P;P<f&&g(v.charCodeAt(P));)P++;if(P<f&&P!==I){for(I=P;P<f&&!g(v.charCodeAt(P));)P++;(P===f||P!==I)&&(p=`\\\\${T}\\${v.slice(I,P)}`,D=P)}}}else D=1;else i(k)&&v.charCodeAt(1)===N&&(p=v.slice(0,2),D=2,f>2&&g(v.charCodeAt(2))&&(E=!0,D=3));if(p.length>0)if(h.length>0){if(p.toLowerCase()!==h.toLowerCase())continue}else h=p;if(c){if(h.length>0)break}else if(s=`${v.slice(D)}\\${s}`,c=E,E&&h.length>0)break}return s=n(s,!c,"\\",g),c?`${h}\\${s}`:`${h}${s}`||"."},normalize(t){w(t,"path");const h=t.length;if(h===0)return".";let s=0,c,r=!1;const v=t.charCodeAt(0);if(h===1)return a(v)?"\\":t;if(g(v))if(r=!0,g(t.charCodeAt(1))){let D=2,p=D;for(;D<h&&!g(t.charCodeAt(D));)D++;if(D<h&&D!==p){const E=t.slice(p,D);for(p=D;D<h&&g(t.charCodeAt(D));)D++;if(D<h&&D!==p){for(p=D;D<h&&!g(t.charCodeAt(D));)D++;if(D===h)return`\\\\${E}\\${t.slice(p)}\\`;D!==p&&(c=`\\\\${E}\\${t.slice(p,D)}`,s=D)}}}else s=1;else i(v)&&t.charCodeAt(1)===N&&(c=t.slice(0,2),s=2,h>2&&g(t.charCodeAt(2))&&(r=!0,s=3));let f=s<h?n(t.slice(s),!r,"\\",g):"";return f.length===0&&!r&&(f="."),f.length>0&&g(t.charCodeAt(h-1))&&(f+="\\"),c===void 0?r?`\\${f}`:f:r?`${c}\\${f}`:`${c}${f}`},isAbsolute(t){w(t,"path");const h=t.length;if(h===0)return!1;const s=t.charCodeAt(0);return g(s)||h>2&&i(s)&&t.charCodeAt(1)===N&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,s;for(let v=0;v<t.length;++v){const f=t[v];w(f,"path"),f.length>0&&(h===void 0?h=s=f:h+=`\\${f}`)}if(h===void 0)return".";let c=!0,r=0;if(typeof s=="string"&&g(s.charCodeAt(0))){++r;const v=s.length;v>1&&g(s.charCodeAt(1))&&(++r,v>2&&(g(s.charCodeAt(2))?++r:c=!1))}if(c){for(;r<h.length&&g(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.$gc.normalize(h)},relative(t,h){if(w(t,"from"),w(h,"to"),t===h)return"";const s=e.$gc.resolve(t),c=e.$gc.resolve(h);if(s===c||(t=s.toLowerCase(),h=c.toLowerCase(),t===h))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===S;)r++;let v=t.length;for(;v-1>r&&t.charCodeAt(v-1)===S;)v--;const f=v-r;let D=0;for(;D<h.length&&h.charCodeAt(D)===S;)D++;let p=h.length;for(;p-1>D&&h.charCodeAt(p-1)===S;)p--;const E=p-D,k=f<E?f:E;let P=-1,I=0;for(;I<k;I++){const j=t.charCodeAt(r+I);if(j!==h.charCodeAt(D+I))break;j===S&&(P=I)}if(I!==k){if(P===-1)return c}else{if(E>k){if(h.charCodeAt(D+I)===S)return c.slice(D+I+1);if(I===2)return c.slice(D+I)}f>k&&(t.charCodeAt(r+I)===S?P=I:I===2&&(P=3)),P===-1&&(P=0)}let T="";for(I=r+P+1;I<=v;++I)(I===v||t.charCodeAt(I)===S)&&(T+=T.length===0?"..":"\\..");return D+=P,T.length>0?`${T}${c.slice(D,p)}`:(c.charCodeAt(D)===S&&++D,c.slice(D,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$gc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===S){if(h.charCodeAt(1)===S){const s=h.charCodeAt(2);if(s!==C&&s!==b)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===N&&h.charCodeAt(2)===S)return`\\\\?\\${h}`;return t},dirname(t){w(t,"path");const h=t.length;if(h===0)return".";let s=-1,c=0;const r=t.charCodeAt(0);if(h===1)return g(r)?t:".";if(g(r)){if(s=c=1,g(t.charCodeAt(1))){let D=2,p=D;for(;D<h&&!g(t.charCodeAt(D));)D++;if(D<h&&D!==p){for(p=D;D<h&&g(t.charCodeAt(D));)D++;if(D<h&&D!==p){for(p=D;D<h&&!g(t.charCodeAt(D));)D++;if(D===h)return t;D!==p&&(s=c=D+1)}}}}else i(r)&&t.charCodeAt(1)===N&&(s=h>2&&g(t.charCodeAt(2))?3:2,c=s);let v=-1,f=!0;for(let D=h-1;D>=c;--D)if(g(t.charCodeAt(D))){if(!f){v=D;break}}else f=!1;if(v===-1){if(s===-1)return".";v=s}return t.slice(0,v)},basename(t,h){h!==void 0&&w(h,"ext"),w(t,"path");let s=0,c=-1,r=!0,v;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===N&&(s=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let f=h.length-1,D=-1;for(v=t.length-1;v>=s;--v){const p=t.charCodeAt(v);if(g(p)){if(!r){s=v+1;break}}else D===-1&&(r=!1,D=v+1),f>=0&&(p===h.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=D))}return s===c?c=D:c===-1&&(c=t.length),t.slice(s,c)}for(v=t.length-1;v>=s;--v)if(g(t.charCodeAt(v))){if(!r){s=v+1;break}}else c===-1&&(r=!1,c=v+1);return c===-1?"":t.slice(s,c)},extname(t){w(t,"path");let h=0,s=-1,c=0,r=-1,v=!0,f=0;t.length>=2&&t.charCodeAt(1)===N&&i(t.charCodeAt(0))&&(h=c=2);for(let D=t.length-1;D>=h;--D){const p=t.charCodeAt(D);if(g(p)){if(!v){c=D+1;break}continue}r===-1&&(v=!1,r=D+1),p===b?s===-1?s=D:f!==1&&(f=1):s!==-1&&(f=-1)}return s===-1||r===-1||f===0||f===1&&s===r-1&&s===c+1?"":t.slice(s,r)},format:u.bind(null,"\\"),parse(t){w(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.length;let c=0,r=t.charCodeAt(0);if(s===1)return g(r)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(g(r)){if(c=1,g(t.charCodeAt(1))){let P=2,I=P;for(;P<s&&!g(t.charCodeAt(P));)P++;if(P<s&&P!==I){for(I=P;P<s&&g(t.charCodeAt(P));)P++;if(P<s&&P!==I){for(I=P;P<s&&!g(t.charCodeAt(P));)P++;P===s?c=P:P!==I&&(c=P+1)}}}}else if(i(r)&&t.charCodeAt(1)===N){if(s<=2)return h.root=h.dir=t,h;if(c=2,g(t.charCodeAt(2))){if(s===3)return h.root=h.dir=t,h;c=3}}c>0&&(h.root=t.slice(0,c));let v=-1,f=c,D=-1,p=!0,E=t.length-1,k=0;for(;E>=c;--E){if(r=t.charCodeAt(E),g(r)){if(!p){f=E+1;break}continue}D===-1&&(p=!1,D=E+1),r===b?v===-1?v=E:k!==1&&(k=1):v!==-1&&(k=-1)}return D!==-1&&(v===-1||k===0||k===1&&v===D-1&&v===f+1?h.base=h.name=t.slice(f,D):(h.name=t.slice(f,v),h.base=t.slice(f,D),h.ext=t.slice(v,D))),f>0&&f!==c?h.dir=t.slice(0,f-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(d){const t=/\\/g;return()=>{const h=l.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>l.cwd()})();e.$hc={resolve(...t){let h="",s=!1;for(let c=t.length-1;c>=-1&&!s;c--){const r=c>=0?t[c]:o();w(r,"path"),r.length!==0&&(h=`${r}/${h}`,s=r.charCodeAt(0)===$)}return h=n(h,!s,"/",a),s?`/${h}`:h.length>0?h:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=n(t,!h,"/",a),t.length===0?h?"/":s?"./":".":(s&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let h;for(let s=0;s<t.length;++s){const c=t[s];w(c,"path"),c.length>0&&(h===void 0?h=c:h+=`/${c}`)}return h===void 0?".":e.$hc.normalize(h)},relative(t,h){if(w(t,"from"),w(h,"to"),t===h||(t=e.$hc.resolve(t),h=e.$hc.resolve(h),t===h))return"";const s=1,c=t.length,r=c-s,v=1,f=h.length-v,D=r<f?r:f;let p=-1,E=0;for(;E<D;E++){const P=t.charCodeAt(s+E);if(P!==h.charCodeAt(v+E))break;P===$&&(p=E)}if(E===D)if(f>D){if(h.charCodeAt(v+E)===$)return h.slice(v+E+1);if(E===0)return h.slice(v+E)}else r>D&&(t.charCodeAt(s+E)===$?p=E:E===0&&(p=0));let k="";for(E=s+p+1;E<=c;++E)(E===c||t.charCodeAt(E)===$)&&(k+=k.length===0?"..":"/..");return`${k}${h.slice(v+p)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$;let s=-1,c=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===$){if(!c){s=r;break}}else c=!1;return s===-1?h?"/":".":h&&s===1?"//":t.slice(0,s)},basename(t,h){h!==void 0&&w(h,"ext"),w(t,"path");let s=0,c=-1,r=!0,v;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let f=h.length-1,D=-1;for(v=t.length-1;v>=0;--v){const p=t.charCodeAt(v);if(p===$){if(!r){s=v+1;break}}else D===-1&&(r=!1,D=v+1),f>=0&&(p===h.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=D))}return s===c?c=D:c===-1&&(c=t.length),t.slice(s,c)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===$){if(!r){s=v+1;break}}else c===-1&&(r=!1,c=v+1);return c===-1?"":t.slice(s,c)},extname(t){w(t,"path");let h=-1,s=0,c=-1,r=!0,v=0;for(let f=t.length-1;f>=0;--f){const D=t.charCodeAt(f);if(D===$){if(!r){s=f+1;break}continue}c===-1&&(r=!1,c=f+1),D===b?h===-1?h=f:v!==1&&(v=1):h!==-1&&(v=-1)}return h===-1||c===-1||v===0||v===1&&h===c-1&&h===s+1?"":t.slice(h,c)},format:u.bind(null,"/"),parse(t){w(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.charCodeAt(0)===$;let c;s?(h.root="/",c=1):c=0;let r=-1,v=0,f=-1,D=!0,p=t.length-1,E=0;for(;p>=c;--p){const k=t.charCodeAt(p);if(k===$){if(!D){v=p+1;break}continue}f===-1&&(D=!1,f=p+1),k===b?r===-1?r=p:E!==1&&(E=1):r!==-1&&(E=-1)}if(f!==-1){const k=v===0&&s?1:v;r===-1||E===0||E===1&&r===f-1&&r===v+1?h.base=h.name=t.slice(k,f):(h.name=t.slice(k,r),h.base=t.slice(k,f),h.ext=t.slice(r,f))}return v>0?h.dir=t.slice(0,v-1):s&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=d?e.$gc.normalize:e.$hc.normalize,e.$jc=d?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=d?e.$gc.join:e.$hc.join,e.$lc=d?e.$gc.resolve:e.$hc.resolve,e.$mc=d?e.$gc.relative:e.$hc.relative,e.$nc=d?e.$gc.dirname:e.$hc.dirname,e.$oc=d?e.$gc.basename:e.$hc.basename,e.$pc=d?e.$gc.extname:e.$hc.extname,e.$qc=d?e.$gc.format:e.$hc.format,e.$rc=d?e.$gc.parse:e.$hc.parse,e.$sc=d?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=d?e.$gc.sep:e.$hc.sep,e.$uc=d?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Se([1,0,46,17]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=b,e.$er=$,e.$fr=S,e.$gr=N,e.$hr=C,e.$ir=m,e.$jr=y,e.$kr=w,e.$lr=d,e.$mr=g,e.$nr=r,e.$or=v,e.$pr=f;const L=new l.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,p,E=!1){const k=D||"",P=p||"",I=L.value.collator.compare(k,P);return L.value.collatorIsNumeric&&I===0&&k!==P?k<P?-1:1:I}function $(D,p){const E=A.value.collator;return D=D||"",p=p||"",u(E,D,p)}function S(D,p){const E=A.value.collator;return D=D||"",p=p||"",s(D,p)||u(E,D,p)}function N(D,p){const E=A.value.collator;return D=D||"",p=p||"",h(D,p)||u(E,D,p)}function C(D,p){return D=D||"",p=p||"",D===p?0:D<p?-1:1}function m(D,p){const[E,k]=i(D),[P,I]=i(p);let T=L.value.collator.compare(k,I);if(T===0){if(L.value.collatorIsNumeric&&k!==I)return k<I?-1:1;if(T=L.value.collator.compare(E,P),L.value.collatorIsNumeric&&T===0&&E!==P)return E<P?-1:1}return T}function y(D,p){D=D||"",p=p||"";const E=n(D),k=n(p),P=A.value.collator,I=R.value.collator;return u(I,E,k)||u(P,D,p)}function w(D,p){D=D||"",p=p||"";const E=n(D),k=n(p),P=A.value.collator,I=R.value.collator;return u(I,E,k)||s(D,p)||u(P,D,p)}function d(D,p){D=D||"",p=p||"";const E=n(D),k=n(p),P=A.value.collator,I=R.value.collator;return u(I,E,k)||h(D,p)||u(P,D,p)}function g(D,p){D=D||"",p=p||"";const E=n(D).toLowerCase(),k=n(p).toLowerCase();return E!==k?E<k?-1:1:D!==p?D<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function i(D,p=!1){const E=D?a.exec(D):[];let k=[E&&E[1]||"",E&&E[3]||""];return p&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(D){const p=D?a.exec(D):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function u(D,p,E){const k=D.compare(p,E);return k!==0?k:p.length!==E.length?p.length<E.length?-1:1:0}function o(D){const p=D.charAt(0);return p.toLocaleUpperCase()!==p}function t(D){const p=D.charAt(0);return p.toLocaleLowerCase()!==p}function h(D,p){return o(D)&&t(p)?-1:t(D)&&o(p)?1:0}function s(D,p){return t(D)&&o(p)?-1:o(D)&&t(p)?1:0}function c(D,p,E=!1){return E||(D=D&&D.toLowerCase(),p=p&&p.toLowerCase()),D===p?0:D<p?-1:1}function r(D,p,E=!1){const k=D.split(M.sep),P=p.split(M.sep),I=k.length-1,T=P.length-1;let j,z;for(let O=0;;O++){if(j=I===O,z=T===O,j&&z)return b(k[O],P[O],E);if(j)return-1;if(z)return 1;const F=c(k[O],P[O],E);if(F!==0)return F}}function v(D,p,E){const k=D.toLowerCase(),P=p.toLowerCase(),I=f(D,p,E);if(I)return I;const T=k.endsWith(E),j=P.endsWith(E);if(T!==j)return T?-1:1;const z=b(k,P);return z!==0?z:k.localeCompare(P)}function f(D,p,E){const k=D.toLowerCase(),P=p.toLowerCase(),I=k.startsWith(E),T=P.startsWith(E);if(I!==T)return I?-1:1;if(I&&T){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}}),define(ke[31],Se([1,0,17,11,14,18]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=R,e.$mg=b,e.$ng=$,e.$og=S,e.$pg=N,e.$qg=w,e.$rg=d,e.$sg=g,e.$tg=a,e.$ug=i,e.$vg=n,e.$wg=u,e.$xg=o,e.$yg=t,e.$zg=h,e.$Ag=s,e.$Bg=v;function R(f){return f===47||f===92}function b(f){return f.replace(/[\\/]/g,l.$hc.sep)}function $(f){return f.indexOf("/")===-1&&(f=b(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function S(f,D=l.$hc.sep){if(!f)return"";const p=f.length,E=f.charCodeAt(0);if(R(E)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let P=3;const I=P;for(;P<p&&!R(f.charCodeAt(P));P++);if(I!==P&&!R(f.charCodeAt(P+1))){for(P+=1;P<p;P++)if(R(f.charCodeAt(P)))return f.slice(0,P+1).replace(/[\\/]/g,D)}}return D}else if(a(E)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+D:f.slice(0,2);let k=f.indexOf("://");if(k!==-1){for(k+=3;k<p;k++)if(R(f.charCodeAt(k)))return f.slice(0,k+1)}return""}function N(f){if(!M.$i||!f||f.length<5)return!1;let D=f.charCodeAt(0);if(D!==92||(D=f.charCodeAt(1),D!==92))return!1;let p=2;const E=p;for(;p<f.length&&(D=f.charCodeAt(p),D!==92);p++);return!(E===p||(D=f.charCodeAt(p+1),isNaN(D)||D===92))}const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(f,D=M.$i){const p=D?C:m;return!(!f||f.length===0||/^\s+$/.test(f)||(p.lastIndex=0,p.test(f))||D&&y.test(f)||f==="."||f===".."||D&&f[f.length-1]==="."||D&&f.length!==f.trim().length||f.length>255)}function d(f,D,p){const E=f===D;return!p||E?E:!f||!D?!1:(0,L.$vf)(f,D)}function g(f,D,p,E=l.sep){if(f===D)return!0;if(!f||!D||D.length>f.length)return!1;if(p){if(!(0,L.$wf)(f,D))return!1;if(D.length===f.length)return!0;let P=D.length;return D.charAt(D.length-1)===E&&P--,f.charAt(P)===E}return D.charAt(D.length-1)!==E&&(D+=E),f.indexOf(D)===0}function a(f){return f>=65&&f<=90||f>=97&&f<=122}function i(f,D){return M.$i&&f.endsWith(":")&&(f+=l.sep),(0,l.$jc)(f)||(f=(0,l.$kc)(D,f)),f=(0,l.$ic)(f),n(f)}function n(f){return M.$i?(f=(0,L.$df)(f,l.sep),f.endsWith(":")&&(f+=l.sep)):(f=(0,L.$df)(f,l.sep),f||(f=l.sep)),f}function u(f){const D=(0,l.$ic)(f);return M.$i?f.length>3?!1:o(D)&&(f.length===2||D.charCodeAt(2)===92):D===l.$hc.sep}function o(f,D=M.$i){return D?a(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function t(f,D=M.$i){return o(f,D)?f[0]:void 0}function h(f,D,p){return D.length>f.length?-1:f===D?0:(p&&(f=f.toLowerCase(),D=D.toLowerCase()),f.indexOf(D))}function s(f){const D=f.split(":");let p,E,k;for(const P of D){const I=Number(P);(0,A.$0f)(I)?E===void 0?E=I:k===void 0&&(k=I):p=p?[p,P].join(":"):P}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,D,p=8){let E="";for(let P=0;P<p;P++){let I;P===0&&M.$i&&!D&&(p===3||p===4)?I=r:I=c,E+=I.charAt(Math.floor(Math.random()*I.length))}let k;return D?k=`${D}-${E}`:k=E,f?(0,l.$kc)(f,k):k}}),define(ke[132],Se([1,0,131,126,56,17,11,14]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=N,e.$rr=g,e.$sr=s,e.$tr=E,e.$ur=z,e.$vr=F;const $=0,S=[$,[]];function N(B,W,Z,X){if(!B||!W)return S;const Y=B.length,x=W.length;if(Y<x)return S;const ne=B.toLowerCase();return C(W,Z,x,B,ne,Y,X)}function C(B,W,Z,X,Y,x,ne){const ge=[],ue=[];for(let _=0;_<Z;_++){const pe=_*x,Pe=pe-x,se=_>0,re=B[_],oe=W[_];for(let K=0;K<x;K++){const ie=K>0,$e=pe+K,we=$e-1,Ne=Pe+K-1,fe=ie?ge[we]:0,De=se&&ie?ge[Ne]:0,Ie=se&&ie?ue[Ne]:0;let Fe;!De&&se?Fe=0:Fe=m(re,oe,X,Y,K,Ie),Fe&&De+Fe>=fe&&(ne||se||Y.startsWith(W,K))?(ue[$e]=Ie+1,ge[$e]=De+Fe):(ue[$e]=$,ge[$e]=fe)}}const ve=[];let te=Z-1,U=x-1;for(;te>=0&&U>=0;){const _=te*x+U;ue[_]===$||(ve.push(U),te--),U--}return[ge[Z*x-1],ve.reverse()]}function m(B,W,Z,X,Y,x){let ne=0;if(!y(W,X[Y]))return ne;if(ne+=1,x>0&&(ne+=x*5),B===Z[Y]&&(ne+=1),Y===0)ne+=8;else{const ge=w(Z.charCodeAt(Y-1));ge?ne+=ge:(0,M.$yk)(Z.charCodeAt(Y))&&x===0&&(ne+=2)}return ne}function y(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function w(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function g(B,W,Z=0,X=0){const Y=W;return Y.values&&Y.values.length>1?a(B,Y.values,Z,X):i(B,W,Z,X)}function a(B,W,Z,X){let Y=0;const x=[];for(const ne of W){const[ge,ue]=i(B,ne,Z,X);if(typeof ge!="number")return d;Y+=ge,x.push(...ue)}return[Y,D(x)]}function i(B,W,Z,X){const Y=(0,M.$Hk)(W.original,W.originalLowercase,Z,B,B.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,M.$Ek)(Y)]:d}const n=Object.freeze({score:0}),u=1<<18,o=1<<17,t=65536;function h(B,W,Z,X){const Y=X.values?X.values:[X];return(0,L.$hj)({[X.normalized]:{values:Y.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:Z}})}function s(B,W,Z,X,Y){if(!B||!W.normalized)return n;const x=X.getItemLabel(B);if(!x)return n;const ne=X.getItemDescription(B),ge=h(x,ne,Z,W),ue=Y[ge];if(ue)return ue;const ve=c(x,ne,X.getItemPath(B),W,Z);return Y[ge]=ve,ve}function c(B,W,Z,X,Y){const x=!Z||!X.containsPathSeparator;return Z&&(R.$k?X.pathNormalized===Z:(0,b.$vf)(X.pathNormalized,Z))?{score:u,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:X.values&&X.values.length>1?r(B,W,Z,X.values,x,Y):v(B,W,Z,X,x,Y)}function r(B,W,Z,X,Y,x){let ne=0;const ge=[],ue=[];for(const ve of X){const{score:te,labelMatch:U,descriptionMatch:_}=v(B,W,Z,ve,Y,x);if(te===$)return n;ne+=te,U&&ge.push(...U),_&&ue.push(..._)}return{score:ne,labelMatch:D(ge),descriptionMatch:D(ue)}}function v(B,W,Z,X,Y,x){if(Y||!W){const[ne,ge]=N(B,X.normalized,X.normalizedLowercase,x&&!X.expectContiguousMatch);if(ne){const ue=(0,M.$vk)(X.normalized,B);let ve;if(ue){ve=o;const te=Math.round(X.normalized.length/B.length*100);ve+=te}else ve=t;return{score:ve+ne,labelMatch:ue||f(ge)}}}if(W){let ne=W;Z&&(ne=`${W}${A.sep}`);const ge=ne.length,ue=`${ne}${B}`,[ve,te]=N(ue,X.normalized,X.normalizedLowercase,x&&!X.expectContiguousMatch);if(ve){const U=f(te),_=[],pe=[];return U.forEach(Pe=>{Pe.start<ge&&Pe.end>ge?(_.push({start:0,end:Pe.end-ge}),pe.push({start:Pe.start,end:ge})):Pe.start>=ge?_.push({start:Pe.start-ge,end:Pe.end-ge}):pe.push(Pe)}),{score:ve,labelMatch:_,descriptionMatch:pe}}}return n}function f(B){const W=[];if(!B)return W;let Z;for(const X of B)Z&&Z.end===X?Z.end+=1:(Z={start:X,end:X+1},W.push(Z));return W}function D(B){const W=B.sort((Y,x)=>Y.start-x.start),Z=[];let X;for(const Y of W)!X||!p(X,Y)?(X=Y,Z.push(Y)):(X.start=Math.min(X.start,Y.start),X.end=Math.max(X.end,Y.end));return Z}function p(B,W){return!(B.end<W.start||W.end<B.start)}function E(B,W,Z,X,Y,x){const ne=s(B,Z,X,Y,x),ge=s(W,Z,X,Y,x),ue=ne.score,ve=ge.score;if((ue===u||ve===u)&&ue!==ve)return ue===u?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<o&&ve<o){const re=P(ne.labelMatch,ge.labelMatch);if(re!==0)return re}const Pe=Y.getItemLabel(B)||"",se=Y.getItemLabel(W)||"";if(Pe.length!==se.length)return Pe.length-se.length}if(ue!==ve)return ue>ve?-1:1;const te=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(te&&!U)return-1;if(U&&!te)return 1;const _=k(B,ne,Y),pe=k(W,ge,Y);return _&&pe&&_!==pe?pe>_?-1:1:I(B,W,Z,Y)}function k(B,W,Z){let X=-1,Y=-1;if(W.descriptionMatch&&W.descriptionMatch.length?X=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(X=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(Y=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const x=Z.getItemDescription(B);x&&(Y+=x.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(Y=W.descriptionMatch[W.descriptionMatch.length-1].end);return Y-X}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const Z=B[0].start,Y=B[B.length-1].end-Z,x=W[0].start,ge=W[W.length-1].end-x;return Y===ge?0:ge<Y?1:-1}function I(B,W,Z,X){const Y=X.getItemLabel(B)||"",x=X.getItemLabel(W)||"",ne=X.getItemDescription(B),ge=X.getItemDescription(W),ue=Y.length+(ne?ne.length:0),ve=x.length+(ge?ge.length:0);if(ue!==ve)return ue-ve;const te=X.getItemPath(B),U=X.getItemPath(W);return te&&U&&te.length!==U.length?te.length-U.length:Y!==x?(0,l.$or)(Y,x,Z.normalized):ne&&ge&&ne!==ge?(0,l.$or)(ne,ge,Z.normalized):te&&U&&te!==U?(0,l.$or)(te,U,Z.normalized):0}function T(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:Z,normalized:X,normalizedLowercase:Y}=O(B),x=Z.indexOf(A.sep)>=0,ne=T(B);let ge;const ue=B.split(j);if(ue.length>1)for(const ve of ue){const te=T(ve),{pathNormalized:U,normalized:_,normalizedLowercase:pe}=O(ve);_&&(ge||(ge=[]),ge.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:_,normalizedLowercase:pe,expectContiguousMatch:te}))}return{original:B,originalLowercase:W,pathNormalized:Z,normalized:X,normalizedLowercase:Y,values:ge,containsPathSeparator:x,expectContiguousMatch:ne}}function O(B){let W;R.$i?W=B.replace(/\//g,A.sep):W=B.replace(/\\/g,A.sep);const Z=(0,b.$ff)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function F(B){return Array.isArray(B)?z(B.map(W=>W.original).join(j)):z(B.original)}}),define(ke[101],Se([1,0,17]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ns=A,e.$Os=R,e.$Ps=b,e.$Qs=S,e.$Ms=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(N){const C=(0,l.$pc)(N),m=M[C.toLowerCase()];return m!==void 0?m:R(N)}function R(N){const C=(0,l.$pc)(N);return L[C.toLowerCase()]}function b(N){for(const C in L)if(L[C]===N)return C}const $=/^(.+)\/(.+?)(;.+)?$/;function S(N,C){const m=$.exec(N);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:N}}),define(ke[102],Se([1,0,11]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=A,e.$km=R;var M;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(M||(e.Source=M={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(b,...$){const S=$.reduce((m,y)=>(m[y]=!0,m),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!S[m]).forEach(m=>{for(let y=0;y<N.length;y++)if(m.search(N[y])!==-1){delete b[m];break}})}function R(b){b&&(delete b.DEBUG,l.$j&&delete b.DYLD_LIBRARY_PATH,l.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Se([1,0,17,11]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=w,e.$xc=u;const L=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function b(c,r){if(!c.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!L.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(c,r){return!c&&!r?"file":c}function S(c,r){switch(c){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const N="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(r){return r instanceof y?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,v,f,D,p,E=!1){typeof r=="object"?(this.scheme=r.scheme||N,this.authority=r.authority||N,this.path=r.path||N,this.query=r.query||N,this.fragment=r.fragment||N):(this.scheme=$(r,E),this.authority=v||N,this.path=S(this.scheme,f||N),this.query=D||N,this.fragment=p||N,b(this,E))}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:v,authority:f,path:D,query:p,fragment:E}=r;return v===void 0?v=this.scheme:v===null&&(v=N),f===void 0?f=this.authority:f===null&&(f=N),D===void 0?D=this.path:D===null&&(D=N),p===void 0?p=this.query:p===null&&(p=N),E===void 0?E=this.fragment:E===null&&(E=N),v===this.scheme&&f===this.authority&&D===this.path&&p===this.query&&E===this.fragment?this:new g(v,f,D,p,E)}static parse(r,v=!1){const f=m.exec(r);return f?new g(f[2]||N,s(f[4]||N),s(f[5]||N),s(f[7]||N),s(f[9]||N),v):new g(N,N,N,N,N)}static file(r){let v=N;if(M.$i&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const f=r.indexOf(C,2);f===-1?(v=r.substring(2),r=C):(v=r.substring(2,f),r=r.substring(f)||C)}return new g("file",v,r,N,N)}static from(r,v){return new g(r.scheme,r.authority,r.path,r.query,r.fragment,v)}static joinPath(r,...v){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return M.$i&&r.scheme==="file"?f=y.file(l.$gc.join(u(r,!0),...v)).path:f=l.$hc.join(r.path,...v),r.with({path:f})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof y)return r;{const v=new g(r);return v._formatted=r.external??null,v._fsPath=r._sep===d?r.fsPath??null:null,v}}else return r}}e.URI=y;function w(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const d=M.$i?1:void 0;class g extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(c,r,v){let f,D=-1;for(let p=0;p<c.length;p++){const E=c.charCodeAt(p);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||r&&E===47||v&&E===91||v&&E===93||v&&E===58)D!==-1&&(f+=encodeURIComponent(c.substring(D,p)),D=-1),f!==void 0&&(f+=c.charAt(p));else{f===void 0&&(f=c.substr(0,p));const k=a[E];k!==void 0?(D!==-1&&(f+=encodeURIComponent(c.substring(D,p)),D=-1),f+=k):D===-1&&(D=p)}}return D!==-1&&(f+=encodeURIComponent(c.substring(D))),f!==void 0?f:c}function n(c){let r;for(let v=0;v<c.length;v++){const f=c.charCodeAt(v);f===35||f===63?(r===void 0&&(r=c.substr(0,v)),r+=a[f]):r!==void 0&&(r+=c[v])}return r!==void 0?r:c}function u(c,r){let v;return c.authority&&c.path.length>1&&c.scheme==="file"?v=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?r?v=c.path.substr(1):v=c.path[1].toLowerCase()+c.path.substr(2):v=c.path,M.$i&&(v=v.replace(/\//g,"\\")),v}function o(c,r){const v=r?n:i;let f="",{scheme:D,authority:p,path:E,query:k,fragment:P}=c;if(D&&(f+=D,f+=":"),(p||D==="file")&&(f+=C,f+=C),p){let I=p.indexOf("@");if(I!==-1){const T=p.substr(0,I);p=p.substr(I+1),I=T.lastIndexOf(":"),I===-1?f+=v(T,!1,!1):(f+=v(T.substr(0,I),!1,!1),f+=":",f+=v(T.substr(I+1),!1,!0)),f+="@"}p=p.toLowerCase(),I=p.lastIndexOf(":"),I===-1?f+=v(p,!1,!0):(f+=v(p.substr(0,I),!1,!0),f+=p.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const I=E.charCodeAt(1);I>=65&&I<=90&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const I=E.charCodeAt(0);I>=65&&I<=90&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}f+=v(E,!0,!1)}return k&&(f+="?",f+=v(k,!1,!1)),P&&(f+="#",f+=r?P:i(P,!1,!1)),f}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(c){return c.match(h)?c.replace(h,r=>t(r)):c}}),define(ke[192],Se([1,0,2]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=M,e.$Tq=L,e.$Uq=A,e.log=b;function M(S){const N=S;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function L(S){const N=[];let C;try{const m=JSON.parse(S.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),C=y.__$stack),N.push(...m)}catch{N.push("Unable to log remote console arguments",S.arguments)}return{args:N,stack:C}}function A(S){if(typeof S!="string")return A(L(S).stack);const N=S;if(N){const C=R(N),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:l.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function R(S){if(!S)return S;const N=S.indexOf(`
`);return N===-1?S:S.substring(0,N)}function b(S,N){const{args:C,stack:m}=L(S),y=typeof C[0]=="string"&&C.length===1;let w=R(m);w&&(w=`(${w.trim()})`);let d=[];if(typeof C[0]=="string"?w&&y?d=[`%c[${N}] %c${C[0]} %c${w}`,$("blue"),$(""),$("grey")]:d=[`%c[${N}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:d=[`%c[${N}]%`,$("blue"),...C],w&&!y&&d.push(w),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,d)}function $(S){return`color: ${S}`}}),define(ke[58],Se([1,0,21,2]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=L,e.$2h=A,e.$3h=b;function L($){return JSON.stringify($,R)}function A($){let S=JSON.parse($);return S=b(S),S}function R($,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function b($,S=0){if(!$||S>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return M.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof l.$De||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let N=0;N<$.length;++N)$[N]=b($[N],S+1);else for(const N in $)Object.hasOwnProperty.call($,N)&&($[N]=b($[N],S+1))}return $}}),define(ke[15],Se([1,0,13,11,14,2,17]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Gg=e.$Fg=e.$Eg=e.Schemas=void 0,e.$Cg=$,e.$Dg=S,e.$Hg=C;var b;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(w,d){return A.URI.isUri(w)?(0,L.$vf)(w.scheme,d):(0,L.$wf)(w,d+":")}function S(w,...d){return d.some(g=>$(w,g))}e.$Eg="vscode-tkn",e.$Fg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,g){this.f=C(d,g)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,b.vscodeRemoteResource)}set(d,g,a){this.a[d]=g,this.b[d]=a}setConnectionToken(d,g){this.c[d]=g}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(o){return l.$1(o),d}const g=d.authority;let a=this.a[g];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const i=this.b[g],n=this.c[g];let u=`path=${encodeURIComponent(d.path)}`;return typeof n=="string"&&(u+=`&${e.$Fg}=${encodeURIComponent(n)}`),A.URI.from({scheme:M.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${i}`,path:this.g,query:u})}}e.$Gg=new N;function C(w,d){return R.$hc.join(d??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Ig="vs/../../extensions",e.$Jg="vs/../../node_modules",e.$Kg="vs/../../node_modules.asar",e.$Lg="vs/../../node_modules.asar.unpacked",e.$Mg="vscode-app";class m{static{this.a=e.$Mg}asBrowserUri(d){const g=this.b(d,le);return this.uriToBrowserUri(g)}uriToBrowserUri(d){return d.scheme===b.vscodeRemote?e.$Gg.rewrite(d):d.scheme===b.file&&(M.$m||M.$q===`${b.vscodeFileResource}://${m.a}`)?d.with({scheme:b.vscodeFileResource,authority:d.authority||m.a,query:null,fragment:null}):d}asFileUri(d){const g=this.b(d,le);return this.uriToFileUri(g)}uriToFileUri(d){return d.scheme===b.vscodeFileResource?d.with({scheme:b.file,authority:d.authority!==m.a?d.authority:null,query:null,fragment:null}):d}b(d,g){return A.URI.isUri(d)?d:A.URI.parse(g.toUrl(d))}}e.$Ng=new m;var y;(function(w){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(d.get("3"));const g="vscode-coi";function a(n){let u;typeof n=="string"?u=new URL(n).searchParams:n instanceof URL?u=n.searchParams:A.URI.isUri(n)&&(u=new URL(n.toString(!0)).searchParams);const o=u?.get(g);if(o)return d.get(o)}w.getHeadersFromQuery=a;function i(n,u,o){if(!globalThis.crossOriginIsolated)return;const t=u&&o?"3":o?"2":"1";n instanceof URLSearchParams?n.set(g,t):n[g]=t}w.addSearchParam=i})(y||(e.COI=y={}))}),define(ke[193],Se([1,0,162,15,11,2]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VD=N;class R{constructor(m,y,w){this.id=m,this.dependencies=y,this.callback=w}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,y,w)=>{typeof m!="string"&&(w=y,y=m,m=null),(typeof y!="object"||!Array.isArray(y))&&(w=y,y=null),this.c.push(new R(m,y,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const y=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!y)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(m){return new Promise((y,w)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const g=()=>{d.removeEventListener("load",a),d.removeEventListener("error",i)},a=n=>{g(),y(this.c.pop())},i=n=>{g(),w(n)};d.addEventListener("load",a),d.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),d.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(m){return new Promise((y,w)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),y(this.c.pop())}catch(d){w(d)}})}async j(m){try{const y=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(m).fsPath,a=y.readFileSync(g).toString(),i=d.wrap(a.replace(/^#!.*/,""));return new w.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const $=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function N(C,m,y){if(l.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const w=`${C}/${m}`;if($.has(w))return $.get(w);let d;if(/^\w[\w\d+.-]*:\/\//.test(w))d=w;else{const n=`${y&&!L.$o?M.$Kg:M.$Jg}/${w}`;d=M.$Ng.asBrowserUri(n).toString(!0)}const g=b.INSTANCE.load(d);return $.set(w,g),g}else return await new Promise((w,d)=>{le([C],w,d)})}}),define(ke[23],Se([1,0,31,15,17,11,14,2]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0,e.$Ug=$,e.$dh=N,e.$eh=m;function $(y){return(0,b.$xc)(y,!0)}class S{constructor(w){this.a=w}compare(w,d,g=!1){return w===d?0:(0,R.$of)(this.getComparisonKey(w,g),this.getComparisonKey(d,g))}isEqual(w,d,g=!1){return w===d?!0:!w||!d?!1:this.getComparisonKey(w,g)===this.getComparisonKey(d,g)}getComparisonKey(w,d=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,d,g=!1){if(w.scheme===d.scheme){if(w.scheme===M.Schemas.file)return l.$sg($(w),$(d),this.a(w))&&w.query===d.query&&(g||w.fragment===d.fragment);if((0,e.$_g)(w.authority,d.authority))return l.$sg(w.path,d.path,this.a(w),"/")&&w.query===d.query&&(g||w.fragment===d.fragment)}return!1}joinPath(w,...d){return b.URI.joinPath(w,...d)}basenameOrAuthority(w){return(0,e.$4g)(w)||w.authority}basename(w){return L.$hc.basename(w.path)}extname(w){return L.$hc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let d;return w.scheme===M.Schemas.file?d=b.URI.file(L.$nc($(w))).path:(d=L.$hc.dirname(w.path),w.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),d="/")),w.with({path:d})}normalizePath(w){if(!w.path.length)return w;let d;return w.scheme===M.Schemas.file?d=b.URI.file(L.$ic($(w))).path:d=L.$hc.normalize(w.path),w.with({path:d})}relativePath(w,d){if(w.scheme!==d.scheme||!(0,e.$_g)(w.authority,d.authority))return;if(w.scheme===M.Schemas.file){const i=L.$mc($(w),$(d));return A.$i?l.$mg(i):i}let g=w.path||"/";const a=d.path||"/";if(this.a(w)){let i=0;for(const n=Math.min(g.length,a.length);i<n&&!(g.charCodeAt(i)!==a.charCodeAt(i)&&g.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);g=a.substr(0,i)+g.substr(i)}return L.$hc.relative(g,a)}resolvePath(w,d){if(w.scheme===M.Schemas.file){const g=b.URI.file(L.$lc($(w),d));return w.with({authority:g.authority,path:g.path})}return d=l.$ng(d),w.with({path:L.$hc.resolve(w.path,d)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,d){return w===d||w!==void 0&&d!==void 0&&(0,R.$vf)(w,d)}hasTrailingPathSeparator(w,d=L.sep){if(w.scheme===M.Schemas.file){const g=$(w);return g.length>l.$og(g).length&&g[g.length-1]===d}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,d=L.sep){return(0,e.$ah)(w,d)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,d=L.sep){let g=!1;if(w.scheme===M.Schemas.file){const a=$(w);g=a!==void 0&&a.length===l.$og(a).length&&a[a.length-1]===d}else{d="/";const a=w.path;g=a.length===1&&a.charCodeAt(a.length-1)===47}return!g&&!(0,e.$ah)(w,d)?w.with({path:w.path+"/"}):w}}e.$Vg=S,e.$Wg=new S(()=>!1),e.$Xg=new S(y=>y.scheme===M.Schemas.file?!A.$k:!0),e.$Yg=new S(y=>!0),e.$Zg=e.$Wg.isEqual.bind(e.$Wg),e.$1g=e.$Wg.isEqualOrParent.bind(e.$Wg),e.$2g=e.$Wg.getComparisonKey.bind(e.$Wg),e.$3g=e.$Wg.basenameOrAuthority.bind(e.$Wg),e.$4g=e.$Wg.basename.bind(e.$Wg),e.$5g=e.$Wg.extname.bind(e.$Wg),e.$6g=e.$Wg.dirname.bind(e.$Wg),e.$7g=e.$Wg.joinPath.bind(e.$Wg),e.$8g=e.$Wg.normalizePath.bind(e.$Wg),e.$9g=e.$Wg.relativePath.bind(e.$Wg),e.$0g=e.$Wg.resolvePath.bind(e.$Wg),e.$$g=e.$Wg.isAbsolutePath.bind(e.$Wg),e.$_g=e.$Wg.isEqualAuthority.bind(e.$Wg),e.$ah=e.$Wg.hasTrailingPathSeparator.bind(e.$Wg),e.$bh=e.$Wg.removeTrailingPathSeparator.bind(e.$Wg),e.$ch=e.$Wg.addTrailingPathSeparator.bind(e.$Wg);function N(y,w){const d=[];for(let g=0;g<y.length;g++){const a=w(y[g]);y.some((i,n)=>n===g?!1:(0,e.$1g)(a,w(i)))||d.push(y[g])}return d}var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function w(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(n=>{const[u,o]=n.split(":");u&&o&&g.set(u,o)});const i=d.path.substring(0,d.path.indexOf(";"));return i&&g.set(y.META_DATA_MIME,i),g}y.parseMetaData=w})(C||(e.DataUri=C={}));function m(y,w,d){if(w){let g=y.path;return g&&g[0]!==L.$hc.sep&&(g=L.$hc.sep+g),y.with({scheme:d,authority:w,path:g})}return y.with({scheme:d})}}),define(ke[8],Se([1,0,22,13,4,3,23,11,169,46]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.Promises=e.$Qh=e.$Ph=e.$Oh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0,e.$fh=N,e.$gh=C,e.$hh=m,e.$ih=y,e.$jh=w,e.$kh=d,e.$lh=g,e.$mh=a,e.$uh=v,e.$vh=f,e.$wh=D,e.$xh=p,e.$yh=E,e.$Nh=Y,e.$Vh=se;function N(oe){return!!oe&&typeof oe.then=="function"}function C(oe){const K=new l.$ne,ie=oe(K.token),$e=new Promise((we,Ne)=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),Ne(new M.$5)});Promise.resolve(ie).then(De=>{fe.dispose(),K.dispose(),we(De)},De=>{fe.dispose(),K.dispose(),Ne(De)})});return new class{cancel(){K.cancel(),K.dispose()}then(we,Ne){return $e.then(we,Ne)}catch(we){return this.then(void 0,we)}finally(we){return $e.finally(we)}}}function m(oe,K,ie){return new Promise(($e,we)=>{const Ne=K.onCancellationRequested(()=>{Ne.dispose(),$e(ie)});oe.then($e,we).finally(()=>Ne.dispose())})}function y(oe,K){return new Promise((ie,$e)=>{const we=K.onCancellationRequested(()=>{we.dispose(),$e(new M.$5)});oe.then(ie,$e).finally(()=>we.dispose())})}async function w(oe){let K=-1;const ie=oe.map(($e,we)=>$e.then(Ne=>(K=we,Ne)));try{return await Promise.race(ie)}finally{oe.forEach(($e,we)=>{we!==K&&$e.cancel()})}}function d(oe,K,ie){let $e;const we=setTimeout(()=>{$e?.(void 0),ie?.()},K);return Promise.race([oe.finally(()=>clearTimeout(we)),new Promise(Ne=>$e=Ne)])}function g(oe){return new Promise((K,ie)=>{const $e=oe();N($e)?$e.then(K,ie):K($e)})}function a(){let oe,K;return{promise:new Promise(($e,we)=>{oe=$e,K=we}),resolve:oe,reject:K}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ie=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(ie,ie).then($e)})}return new Promise((ie,$e)=>{this.b.then(ie,$e)})}return this.a=K(),new Promise((ie,$e)=>{this.a.then(we=>{this.a=null,ie(we)},we=>{this.a=null,$e(we)})})}dispose(){this.f=!0}}e.$nh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$oh=n;class u{constructor(){this.a=new Map}queue(K,ie){const we=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(K)===we&&this.a.delete(K)});return this.a.set(K,we),we}}e.$ph=u;const o=(oe,K)=>{let ie=!0;const $e=setTimeout(()=>{ie=!1,K()},oe);return{isTriggered:()=>ie,dispose:()=>{clearTimeout($e),ie=!1}}},t=oe=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,oe())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class h{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ie=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((we,Ne)=>{this.d=we,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=ie===$.$_d?t($e):o(ie,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qh=h;class s{constructor(K){this.a=new h(K),this.b=new i}trigger(K,ie){return this.a.trigger(()=>this.b.queue(K),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rh=s;class c{constructor(){this.a=!1,this.b=new Promise((K,ie)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sh=c;class r extends c{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$th=r;function v(oe,K){return K?new Promise((ie,$e)=>{const we=setTimeout(()=>{Ne.dispose(),ie()},oe),Ne=K.onCancellationRequested(()=>{clearTimeout(we),Ne.dispose(),$e(new M.$5)})}):C(ie=>v(oe,ie))}function f(oe,K=0,ie){const $e=setTimeout(()=>{oe(),ie&&we.dispose()},K),we=(0,A.$Tc)(()=>{clearTimeout($e),ie?.deleteAndLeak(we)});return ie?.add(we),we}function D(oe){const K=[];let ie=0;const $e=oe.length;function we(){return ie<$e?oe[ie++]():null}function Ne(fe){fe!=null&&K.push(fe);const De=we();return De?De.then(Ne):Promise.resolve(K)}return Promise.resolve(null).then(Ne)}function p(oe,K=$e=>!!$e,ie=null){let $e=0;const we=oe.length,Ne=()=>{if($e>=we)return Promise.resolve(ie);const fe=oe[$e++];return Promise.resolve(fe()).then(Ie=>K(Ie)?Promise.resolve(Ie):Ne())};return Ne()}function E(oe,K=$e=>!!$e,ie=null){if(oe.length===0)return Promise.resolve(ie);let $e=oe.length;const we=()=>{$e=-1;for(const Ne of oe)Ne.cancel?.()};return new Promise((Ne,fe)=>{for(const De of oe)De.then(Ie=>{--$e>=0&&K(Ie)?(we(),Ne(Ie)):$e===0&&Ne(ie)}).catch(Ie=>{--$e>=0&&(we(),fe(Ie))})})}class k{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new L.$ce}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,$e)=>{this.g.push({factory:K,c:ie,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ie=K.factory();ie.then(K.c,K.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$zh=k;class P extends k{constructor(){super(1)}}e.$Ah=P;class I{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Bh=I;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ue;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ie=R.$Wg){const $e=ie.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,ie,$e=R.$Wg){const we=$e.getComparisonKey(K);let Ne=this.a.get(we);if(!Ne){Ne=new P;const fe=this.f++,De=L.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$5c),this.d.set(fe,De),this.a.set(we,Ne)}return Ne.queue(ie)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ch=T;class j{constructor(K,ie){this.a=-1,typeof K=="function"&&typeof ie=="number"&&this.setIfNotSet(K,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ie)}setIfNotSet(K,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ie))}}e.$Dh=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ie,$e=globalThis){this.cancel();const we=$e.setInterval(()=>{K()},ie);this.d=(0,A.$Tc)(()=>{$e.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Eh=z;class O{constructor(K,ie){this.b=-1,this.a=K,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Fh=O;class F{constructor(K,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=K,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Gh=F;class B extends O{constructor(K,ie){super(K,ie),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Hh=B;class W extends A.$Vc{constructor(K,ie){super(),this.g=K,this.h=ie,this.a=[],this.b=this.B(new A.$Wc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of K)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ih=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Kh=(oe,K)=>{(0,b.$B)(()=>{if(ie)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Kh=(oe,K,ie)=>{const $e=oe.requestIdleCallback(K,typeof ie=="number"?{timeout:ie}:void 0);let we=!1;return{dispose(){we||(we=!0,oe.cancelIdleCallback($e))}}},e.$Jh=oe=>(0,e.$Kh)(globalThis,oe)}();class Z{constructor(K,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Kh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Lh=Z;class X extends Z{constructor(K){super(globalThis,K)}}e.$Mh=X;async function Y(oe,K,ie){let $e;for(let we=0;we<ie;we++)try{return await oe()}catch(Ne){$e=Ne,await v(K)}throw $e}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ie,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:ie},ie.then(()=>this.d(K),()=>this.d(K)),ie}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ie,resolve:$e,reject:we}=a();this.b={run:K,promise:ie,promiseResolve:$e,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Oh=x;class ne{constructor(K,ie=()=>Date.now()){this.d=K,this.f=ie,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Ph=ne;var ge;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(ge||(ge={}));class ue{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ie)=>{this.a=K,this.b=ie})}complete(K){return new Promise(ie=>{this.a(K),this.d={outcome:0,value:K},ie()})}error(K){return new Promise(ie=>{this.b(K),this.d={outcome:1,value:K},ie()})}cancel(){return this.error(new M.$5)}}e.$Qh=ue;var ve;(function(oe){async function K($e){let we;const Ne=await Promise.all($e.map(fe=>fe.then(De=>De,De=>{we||(we=De)})));if(typeof we<"u")throw we;return Ne}oe.settled=K;function ie($e){return new Promise(async(we,Ne)=>{try{await $e(we,Ne)}catch(fe){Ne(fe)}})}oe.withAsyncBody=ie})(ve||(e.Promises=ve={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Rh=te;class U{constructor(K){this.b=K,this.a=new S.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Sh=U;var _;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(_||(_={}));class pe{static fromArray(K){return new pe(ie=>{ie.emitMany(K)})}static fromPromise(K){return new pe(async ie=>{ie.emitMany(await K)})}static fromPromises(K){return new pe(async ie=>{await Promise.all(K.map(async $e=>ie.emitOne(await $e)))})}static merge(K){return new pe(async ie=>{await Promise.all(K.map(async $e=>{for await(const we of $e)ie.emitOne(we)}))})}static{this.EMPTY=pe.fromArray([])}constructor(K,ie){this.a=0,this.b=[],this.d=null,this.f=ie,this.g=new L.$ce,queueMicrotask(async()=>{const $e={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(K($e)),this.k()}catch(we){this.l(we)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,ie){return new pe(async $e=>{for await(const we of K)$e.emitOne(ie(we))})}map(K){return pe.map(this,K)}static filter(K,ie){return new pe(async $e=>{for await(const we of K)ie(we)&&$e.emitOne(we)})}filter(K){return pe.filter(this,K)}static coalesce(K){return pe.filter(K,ie=>!!ie)}coalesce(){return pe.coalesce(this)}static async toPromise(K){const ie=[];for await(const $e of K)ie.push($e);return ie}toPromise(){return pe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Th=pe;class Pe extends pe{constructor(K,ie){super(ie),this.m=K}cancel(){this.m.cancel()}}e.$Uh=Pe;function se(oe){const K=new l.$ne,ie=oe(K.token);return new Pe(K,async $e=>{const we=K.token.onCancellationRequested(()=>{we.dispose(),K.dispose(),$e.reject(new M.$5)});try{for await(const Ne of ie){if(K.token.isCancellationRequested)return;$e.emitOne(Ne)}we.dispose(),K.dispose()}catch(Ne){we.dispose(),K.dispose(),$e.reject(Ne)}})}class re{constructor(K){this.a=new ue,this.b=new pe(we=>{if(ie){we.reject(ie);return}return $e&&we.emitMany($e),this.d=Ne=>we.reject(Ne),this.f=Ne=>we.emitOne(Ne),this.a.p},K);let ie,$e;this.f=we=>{$e||($e=[]),$e.push(we)},this.d=we=>{ie||(ie=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Wh=re}),define(ke[35],Se([1,0,19,8,31,27,17,11,14]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$ik=S,e.$lk=w,e.$mk=P,e.$nk=I,e.$ok=T,e.$pk=j,e.$qk=z,e.$rk=W;function S(){return Object.create(null)}e.$jk="**",e.$kk="/";const N="[/\\\\]",C="[^/\\\\]",m=/\//g;function y(Z,X){switch(Z){case 0:return"";case 1:return`${C}*?`;default:return`(?:${N}|${C}+${N}${X?`|${N}${C}+`:""})*?`}}function w(Z,X){if(!Z)return[];const Y=[];let x=!1,ne=!1,ge="";for(const ue of Z){switch(ue){case X:if(!x&&!ne){Y.push(ge),ge="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ge+=ue}return ge&&Y.push(ge),Y}function d(Z){if(!Z)return"";let X="";const Y=w(Z,e.$kk);if(Y.every(x=>x===e.$jk))X=".*";else{let x=!1;Y.forEach((ne,ge)=>{if(ne===e.$jk){if(x)return;X+=y(2,ge===Y.length-1)}else{let ue=!1,ve="",te=!1,U="";for(const _ of ne){if(_!=="}"&&ue){ve+=_;continue}if(te&&(_!=="]"||!U)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!U?pe="^":_===e.$kk?pe="":pe=(0,$.$0e)(_),U+=pe;continue}switch(_){case"{":ue=!0;continue;case"[":te=!0;continue;case"}":{const Pe=`(?:${w(ve,",").map(se=>d(se)).join("|")})`;X+=Pe,ue=!1,ve="";break}case"]":{X+="["+U+"]",te=!1,U="";break}case"?":X+=C;continue;case"*":X+=y(1);continue;default:X+=(0,$.$0e)(_)}}ge<Y.length-1&&(Y[ge+1]!==e.$jk||ge+2<Y.length)&&(X+=N)}x=ne===e.$jk})}return X}const g=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Ec(1e4),h=function(){return!1},s=function(){return null};function c(Z,X){if(!Z)return s;let Y;typeof Z!="string"?Y=Z.pattern:Y=Z,Y=Y.trim();const x=`${Y}_${!!X.trimForExclusions}`;let ne=t.get(x);if(ne)return r(ne,Z);let ge;return g.test(Y)?ne=f(Y.substr(4),Y):(ge=a.exec(v(Y,X)))?ne=D(ge[1],Y):(X.trimForExclusions?n:i).test(Y)?ne=p(Y,X):(ge=u.exec(v(Y,X)))?ne=E(ge[1].substr(1),Y,!0):(ge=o.exec(v(Y,X)))?ne=E(ge[1],Y,!1):ne=k(Y),t.set(x,ne),r(ne,Z)}function r(Z,X){if(typeof X=="string")return Z;const Y=function(x,ne){return(0,L.$sg)(x,X.base,!b.$k)?Z((0,$.$cf)(x.substr(X.base.length),R.sep),ne):null};return Y.allBasenames=Z.allBasenames,Y.allPaths=Z.allPaths,Y.basenames=Z.basenames,Y.patterns=Z.patterns,Y}function v(Z,X){return X.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function f(Z,X){return function(Y,x){return typeof Y=="string"&&Y.endsWith(Z)?X:null}}function D(Z,X){const Y=`/${Z}`,x=`\\${Z}`,ne=function(ue,ve){return typeof ue!="string"?null:ve?ve===Z?X:null:ue===Z||ue.endsWith(Y)||ue.endsWith(x)?X:null},ge=[Z];return ne.basenames=ge,ne.patterns=[X],ne.allBasenames=ge,ne}function p(Z,X){const Y=B(Z.slice(1,-1).split(",").map(ve=>c(ve,X)).filter(ve=>ve!==s),Z),x=Y.length;if(!x)return s;if(x===1)return Y[0];const ne=function(ve,te){for(let U=0,_=Y.length;U<_;U++)if(Y[U](ve,te))return Z;return null},ge=Y.find(ve=>!!ve.allBasenames);ge&&(ne.allBasenames=ge.allBasenames);const ue=Y.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ne.allPaths=ue),ne}function E(Z,X,Y){const x=R.sep===R.$hc.sep,ne=x?Z:Z.replace(m,R.sep),ge=R.sep+ne,ue=R.$hc.sep+Z;let ve;return Y?ve=function(te,U){return typeof te=="string"&&(te===ne||te.endsWith(ge)||!x&&(te===Z||te.endsWith(ue)))?X:null}:ve=function(te,U){return typeof te=="string"&&(te===ne||!x&&te===Z)?X:null},ve.allPaths=[(Y?"*/":"./")+Z],ve}function k(Z){try{const X=new RegExp(`^${d(Z)}$`);return function(Y){return X.lastIndex=0,typeof Y=="string"&&X.test(Y)?Z:null}}catch{return s}}function P(Z,X,Y){return!Z||typeof X!="string"?!1:I(Z)(X,void 0,Y)}function I(Z,X={}){if(!Z)return h;if(typeof Z=="string"||T(Z)){const Y=c(Z,X);if(Y===s)return h;const x=function(ne,ge){return!!Y(ne,ge)};return Y.allBasenames&&(x.allBasenames=Y.allBasenames),Y.allPaths&&(x.allPaths=Y.allPaths),x}return O(Z,X)}function T(Z){const X=Z;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}function j(Z){return Z.allBasenames||[]}function z(Z){return Z.allPaths||[]}function O(Z,X){const Y=B(Object.getOwnPropertyNames(Z).map(ve=>F(ve,Z[ve],X)).filter(ve=>ve!==s)),x=Y.length;if(!x)return s;if(!Y.some(ve=>!!ve.requiresSiblings)){if(x===1)return Y[0];const ve=function(_,pe){let Pe;for(let se=0,re=Y.length;se<re;se++){const oe=Y[se](_,pe);if(typeof oe=="string")return oe;(0,M.$fh)(oe)&&(Pe||(Pe=[]),Pe.push(oe))}return Pe?(async()=>{for(const se of Pe){const re=await se;if(typeof re=="string")return re}return null})():null},te=Y.find(_=>!!_.allBasenames);te&&(ve.allBasenames=te.allBasenames);const U=Y.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return U.length&&(ve.allPaths=U),ve}const ne=function(ve,te,U){let _,pe;for(let Pe=0,se=Y.length;Pe<se;Pe++){const re=Y[Pe];re.requiresSiblings&&U&&(te||(te=(0,R.$oc)(ve)),_||(_=te.substr(0,te.length-(0,R.$pc)(ve).length)));const oe=re(ve,te,_,U);if(typeof oe=="string")return oe;(0,M.$fh)(oe)&&(pe||(pe=[]),pe.push(oe))}return pe?(async()=>{for(const Pe of pe){const se=await Pe;if(typeof se=="string")return se}return null})():null},ge=Y.find(ve=>!!ve.allBasenames);ge&&(ne.allBasenames=ge.allBasenames);const ue=Y.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ne.allPaths=ue),ne}function F(Z,X,Y){if(X===!1)return s;const x=c(Z,Y);if(x===s)return s;if(typeof X=="boolean")return x;if(X){const ne=X.when;if(typeof ne=="string"){const ge=(ue,ve,te,U)=>{if(!U||!x(ue,ve))return null;const _=ne.replace("$(basename)",()=>te),pe=U(_);return(0,M.$fh)(pe)?pe.then(Pe=>Pe?Z:null):pe?Z:null};return ge.requiresSiblings=!0,ge}}return x}function B(Z,X){const Y=Z.filter(ve=>!!ve.basenames);if(Y.length<2)return Z;const x=Y.reduce((ve,te)=>{const U=te.basenames;return U?ve.concat(U):ve},[]);let ne;if(X){ne=[];for(let ve=0,te=x.length;ve<te;ve++)ne.push(X)}else ne=Y.reduce((ve,te)=>{const U=te.patterns;return U?ve.concat(U):ve},[]);const ge=function(ve,te){if(typeof ve!="string")return null;if(!te){let _;for(_=ve.length;_>0;_--){const pe=ve.charCodeAt(_-1);if(pe===47||pe===92)break}te=ve.substr(_)}const U=x.indexOf(te);return U!==-1?ne[U]:null};ge.basenames=x,ge.patterns=ne,ge.allBasenames=x;const ue=Z.filter(ve=>!ve.basenames);return ue.push(ge),ue}function W(Z,X){return(0,l.$ub)(Z,X,(Y,x)=>typeof Y=="string"&&typeof x=="string"?Y===x:typeof Y!="string"&&typeof x!="string"?Y.base===x.base&&Y.pattern===x.pattern:!1)}}),define(ke[80],Se([1,0,13,171,23,14,2]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.MarkdownStringTextNewlineStyle=void 0,e.$Rk=S,e.$Sk=N,e.$Tk=C,e.$Uk=m,e.$Vk=y,e.$Wk=w,e.$Xk=d,e.$Yk=g;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,l.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=m(this.supportThemeIcons?(0,M.$Kk)(i):i).replace(/([ \t]+)/g,(u,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${y(n,i)}
`,this}appendLink(i,n,u){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,n){const u=new RegExp((0,A.$0e)(n),"g");return i.replace(u,(o,t)=>i.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Qk=$;function S(a){return N(a)?!a.value:Array.isArray(a)?a.every(S):!0}function N(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function C(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,L.$Zg)(R.URI.from(a.baseUri),R.URI.from(i.baseUri)))}function m(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(a,i){const n=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,u=n>=3?n+1:3;return[`${"`".repeat(u)}${i}`,a,`${"`".repeat(u)}`].join(`
`)}function w(a){return a.replace(/"/g,"&quot;")}function d(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(a){const i=[],n=a.split("|").map(o=>o.trim());a=n[0];const u=n[1];if(u){const o=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),h=o?o[1]:"",s=t?t[1]:"",c=isFinite(parseInt(s)),r=isFinite(parseInt(h));c&&i.push(`width="${s}"`),r&&i.push(`height="${h}"`)}return{href:a,dimensions:i}}}),define(ke[103],Se([1,0,19,31,17,11,23,14]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=$,e.$tw=N,e.$uw=m,e.$vw=y,e.$ww=a,e.$xw=n,e.$yw=u,e.$zw=o,e.$Aw=t,e.$Bw=h;function $(c,r){const{os:v,tildify:f,relative:D}=r;if(D){const k=S(c,D,v);if(typeof k=="string")return k}let p=c.fsPath;if(v===1&&!A.$i?p=p.replace(/\//g,"\\"):v!==1&&A.$i&&(p=p.replace(/\\/g,"/")),v!==1&&f?.userHome){const k=f.userHome.fsPath;let P;c.scheme!==f.userHome.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep?P=f.userHome.with({path:c.path}).fsPath:P=p,p=m(P,k,v)}return(v===1?L.$gc:L.$hc).normalize(N(p,v===1))}function S(c,r,v){const f=v===1?L.$gc:L.$hc,D=v===3?R.$Wg:R.$Yg,p=r.getWorkspace(),E=(0,l.$Ob)(p.folders);if(!E)return;c.scheme!==E.uri.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep&&(c=E.uri.with({path:c.path}));const k=r.getWorkspaceFolder(c);if(!k)return;let P;if(D.isEqual(k.uri,c)?P="":P=D.relativePath(k.uri,c)??"",P&&(P=f.normalize(P)),p.folders.length>1&&!r.noPrefix){const I=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${I} \u2022 ${P}`:I}return P}function N(c,r=A.$i){return(0,M.$xg)(c,r)?c.charAt(0).toUpperCase()+c.slice(1):c}let C=Object.create(null);function m(c,r,v=A.OS){if(v===1||!c||!r)return c;let f=C.original===r?C.normalized:void 0;f||(f=r,A.$i&&(f=(0,M.$mg)(f)),f=`${(0,b.$df)(f,L.$hc.sep)}${L.$hc.sep}`,C={original:r,normalized:f});let D=c;return A.$i&&(D=(0,M.$mg)(D)),(v===3?D.startsWith(f):(0,b.$wf)(D,f))?`~/${D.substr(f.length)}`:c}function y(c,r){return c.replace(/^~($|\/|\\)/,`${r}$1`)}const w="\u2026",d="\\\\",g="~";function a(c,r=L.sep){const v=new Array(c.length);let f=!1;for(let D=0;D<c.length;D++){const p=c[D];if(p===""){v[D]=`.${r}`;continue}if(!p){v[D]=p;continue}f=!0;let E="",k=p;k.indexOf(d)===0?(E=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(r)===0?(E=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(g)===0&&(E=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const P=k.split(r);for(let I=1;f&&I<=P.length;I++)for(let T=P.length-I;f&&T>=0;T--){f=!1;let j=P.slice(T,T+I).join(r);for(let z=0;!f&&z<c.length;z++)if(z!==D&&c[z]&&c[z].indexOf(j)>-1){const O=T+I===P.length,F=T>0&&c[z].indexOf(r)>-1?r+j:j,B=c[z].endsWith(F);f=!O||B}if(!f){let z="";(P[0].endsWith(":")||E!=="")&&(T===1&&(T=0,I++,j=P[0]+r+j),T>0&&(z=P[0]+r),z=E+z),T>0&&(z=z+w+r),z=z+j,T+I<P.length&&(z=z+r+w),v[D]=z}}f&&(v[D]=p)}return v}var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,r=Object.create(null)){const v=[];let f=!1,D="";for(const p of c)if(p==="$"||f&&p==="{")D&&v.push({value:D,type:i.TEXT}),D="",f=!0;else if(p==="}"&&f){const E=r[D];if(typeof E=="string")E.length&&v.push({value:E,type:i.VARIABLE});else if(E){const k=v[v.length-1];(!k||k.type!==i.SEPARATOR)&&v.push({value:E.label,type:i.SEPARATOR})}D="",f=!1}else D+=p;return D&&!f&&v.push({value:D,type:i.TEXT}),v.filter((p,E)=>{if(p.type===i.SEPARATOR){const k=v[E-1],P=v[E+1];return[k,P].every(I=>I&&(I.type===i.VARIABLE||I.type===i.TEXT)&&I.value.length>0)}return!0}).map(p=>p.value).join("")}function u(c,r){return A.$j||r?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):c.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function o(c,r){return A.$j||r?c.replace(/\(&&\w\)|&&/g,""):A.$i?c.replace(/&&|&/g,v=>v==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function h(c){if(c.endsWith("]")){const r=c.lastIndexOf(" [",c.length-2);if(r!==-1){const v=s(c.substring(0,r)),f=c.substring(r);return{name:v.name+f,parentPath:v.parentPath}}}return s(c)}function s(c){const r=c.indexOf("/")!==-1?L.$hc:L.$gc,v=r.basename(c),f=r.dirname(c);return v.length?{name:v,parentPath:f}:{name:f,parentPath:""}}}),define(ke[133],Se([1,0,21,2]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=void 0,e.$xn=b,e.$yn=S,e.$zn=N;function L(C){return C.toJSON()}class A{constructor(m){this.a=m}transformIncoming(m){const y=this.a.transformIncoming(m);return y===m?m:L(M.URI.from(y))}transformOutgoing(m){const y=this.a.transformOutgoing(m);return y===m?m:L(M.URI.from(y))}transformOutgoingURI(m){const y=this.a.transformOutgoing(m);return y===m?m:M.URI.from(y)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$vn=A,e.$wn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof M.URI)return m.transformOutgoing(C);for(const w in C)if(Object.hasOwnProperty.call(C,w)){const d=R(C[w],m,y+1);d!==null&&(C[w]=d)}}return null}function b(C,m){const y=R(C,m,0);return y===null?C:y}function $(C,m,y,w){if(!C||w>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?M.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof l.$De)return null;for(const d in C)if(Object.hasOwnProperty.call(C,d)){const g=$(C[d],m,y,w+1);g!==null&&(C[d]=g)}}return null}function S(C,m){const y=$(C,m,!1,0);return y===null?C:y}function N(C,m){const y=$(C,m,!0,0);return y===null?C:y}}),define(ke[32],Se([1,0,52,64,394,8,31,76,17,11,23,2]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=D;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function y(F,B=m.UNLINK,W){if((0,R.$wg)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?d(F):w(F,W)}async function w(F,B=(0,R.$Bg)((0,M.tmpdir)())){try{try{await l.promises.rename(F,B)}catch(W){return W.code==="ENOENT"?void 0:d(F)}d(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function d(F){return(0,L.promisify)(l.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,R.$wg)(F))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function a(F,B){return u(await(B?i(F):(0,L.promisify)(l.readdir)(F)))}async function i(F){try{return await(0,L.promisify)(l.readdir)(F,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const B=[],W=await a(F);for(const Z of W){let X=!1,Y=!1,x=!1;try{const ne=await e.Promises.lstat((0,$.$kc)(F,Z));X=ne.isFile(),Y=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}B.push({name:Z,isFile:()=>X,isDirectory:()=>Y,isSymbolicLink:()=>x})}return B}function n(F){return u(l.readdirSync(F))}function u(F){return F.map(B=>typeof B=="string"?S.$j?(0,b.$$l)(B):B:(B.name=S.$j?(0,b.$$l)(B.name):B.name,B))}async function o(F){const B=await a(F),W=[];for(const Z of B)await h.existsDirectory((0,$.$kc)(F,Z))&&W.push(Z);return W}function t(F,B=1e3){return new Promise(W=>{let Z=!1;const X=setInterval(()=>{Z||(Z=!0,l.access(F,Y=>{Z=!1,Y&&(clearInterval(X),W(void 0))}))},B)})}var h;(function(F){async function B(X){let Y;try{if(Y=await e.Promises.lstat(X),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(S.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ne}throw x}}F.stat=B;async function W(X){try{const{stat:Y,symbolicLink:x}=await F.stat(X);return Y.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=W;async function Z(X){try{const{stat:Y,symbolicLink:x}=await F.stat(X);return Y.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=Z})(h||(e.SymlinkSupport=h={}));const s=new A.$Ch;function c(F,B,W){return s.queueFor(C.URI.file(F),()=>{const Z=p(W);return new Promise((X,Y)=>f(F,B,Z,x=>x?Y(x):X()))},N.$Xg)}let r=!0;function v(F){r=F}function f(F,B,W,Z){if(!r)return l.writeFile(F,B,{mode:W.mode,flag:W.flag},Z);l.open(F,W.flag,W.mode,(X,Y)=>{if(X)return Z(X);l.writeFile(Y,B,x=>{if(x)return l.close(Y,()=>Z(x));l.fdatasync(Y,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),v(!1)),l.close(Y,ge=>Z(ge))))})})}function D(F,B,W){const Z=p(W);if(!r)return l.writeFileSync(F,B,{mode:Z.mode,flag:Z.flag});const X=l.openSync(F,Z.flag,Z.mode);try{l.writeFileSync(X,B);try{l.fdatasyncSync(X)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),v(!1)}}finally{l.closeSync(X)}}function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function E(F,B,W=6e4){if(F!==B)try{S.$i&&typeof W=="number"?await k(F,B,Date.now(),W):await(0,L.promisify)(l.rename)(F,B)}catch(Z){if(F.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||F.endsWith("."))await P(F,B,{preserveSymlinks:!1}),await y(F,m.MOVE);else throw Z}}async function k(F,B,W,Z,X=0){try{return await(0,L.promisify)(l.rename)(F,B)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-W>=Z)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Y}`),Y;if(X===0){let x=!1;try{const{stat:ne}=await h.stat(B);ne.isFile()||(x=!0)}catch{}if(x)throw Y}return await(0,A.$uh)(Math.min(100,X*10)),k(F,B,W,Z,X+1)}}async function P(F,B,W){return T(F,B,{root:{source:F,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function T(F,B,W){if(W.handledSourcePaths.has(F))return;W.handledSourcePaths.add(F);const{stat:Z,symbolicLink:X}=await h.stat(F);if(X){if(W.options.preserveSymlinks)try{return await O(F,B,W)}catch{}if(X.dangling)return}return Z.isDirectory()?j(F,B,Z.mode&I,W):z(F,B,Z.mode&I)}async function j(F,B,W,Z){await e.Promises.mkdir(B,{recursive:!0,mode:W});const X=await a(F);for(const Y of X)await T((0,$.$kc)(F,Y),(0,$.$kc)(B,Y),Z)}async function z(F,B,W){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,W)}async function O(F,B,W){let Z=await e.Promises.readlink(F);(0,R.$sg)(Z,W.root.source,!S.$k)&&(Z=(0,$.$kc)(W.root.target,Z.substr(W.root.source.length+1))),await e.Promises.symlink(Z,B)}e.Promises=new class{get access(){return(0,L.promisify)(l.access)}get stat(){return(0,L.promisify)(l.stat)}get lstat(){return(0,L.promisify)(l.lstat)}get utimes(){return(0,L.promisify)(l.utimes)}get read(){return(F,B,W,Z,X)=>new Promise((Y,x)=>{l.read(F,B,W,Z,X,(ne,ge,ue)=>ne?x(ne):Y({bytesRead:ge,buffer:ue}))})}get readFile(){return(0,L.promisify)(l.readFile)}get write(){return(F,B,W,Z,X)=>new Promise((Y,x)=>{l.write(F,B,W,Z,X,(ne,ge,ue)=>ne?x(ne):Y({bytesWritten:ge,buffer:ue}))})}get appendFile(){return(0,L.promisify)(l.appendFile)}get fdatasync(){return(0,L.promisify)(l.fdatasync)}get truncate(){return(0,L.promisify)(l.truncate)}get copyFile(){return(0,L.promisify)(l.copyFile)}get open(){return(0,L.promisify)(l.open)}get close(){return(0,L.promisify)(l.close)}get symlink(){return(0,L.promisify)(l.symlink)}get readlink(){return(0,L.promisify)(l.readlink)}get chmod(){return(0,L.promisify)(l.chmod)}get mkdir(){return(0,L.promisify)(l.mkdir)}get unlink(){return(0,L.promisify)(l.unlink)}get rmdir(){return(0,L.promisify)(l.rmdir)}get realpath(){return(0,L.promisify)(l.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return y}get rename(){return E}get copy(){return P}}}),define(ke[104],Se([1,0,52,17,11,14,32]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=b,e.$2q=$,e.$3q=S,e.$4q=N;function b(m){if(L.$k)return m;const y=(0,M.$nc)(m);if(m===y)return m;const w=((0,M.$oc)(m)||m).toLowerCase();try{const g=(0,R.readdirSync)(y).filter(a=>a.toLowerCase()===w);if(g.length===1){const a=b(y);if(a)return(0,M.$kc)(a,g[0])}else if(g.length>1){const a=g.indexOf(w);if(a>=0){const i=b(y);if(i)return(0,M.$kc)(i,g[a])}}}catch{}return null}async function $(m,y){if(L.$k)return m;const w=(0,M.$nc)(m);if(m===w)return m;const d=((0,M.$oc)(m)||m).toLowerCase();try{if(y?.isCancellationRequested)return null;const a=(await R.Promises.readdir(w)).filter(i=>i.toLowerCase()===d);if(a.length===1){const i=await $(w,y);if(i)return(0,M.$kc)(i,a[0])}else if(a.length>1){const i=a.indexOf(d);if(i>=0){const n=await $(w,y);if(n)return(0,M.$kc)(n,a[i])}}}catch{}return null}async function S(m){try{return await R.Promises.realpath(m)}catch{const w=C(m);return await R.Promises.access(w,l.constants.R_OK),w}}function N(m){try{return l.realpathSync(m)}catch{const w=C(m);return l.accessSync(w,l.constants.R_OK),w}}function C(m){return(0,A.$df)((0,M.$ic)(m),M.sep)}}),define(ke[105],Se([1,0,17,11,51,102,18,32]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$lm=$,e.$mm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function $(C=L.env){return C.comspec||"cmd.exe"}function S(C){let m=[],y=!1;const w=function(d){if(y){m.push(d);return}(!C.send(d,a=>{if(a&&console.error(a),y=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>w(n))}})||M.$i)&&(y=!0)};return{send:w}}var N;(function(C){async function m(y,w,d){if(l.$jc(y))return y;if(w===void 0&&(w=L.cwd()),l.$nc(y)!=="."||(d===void 0&&R.$6f(L.env.PATH)&&(d=L.env.PATH.split(l.$uc)),d===void 0||d.length===0))return l.$kc(w,y);async function a(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(u){u.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of d){let n;if(l.$jc(i)?n=l.$kc(i,y):n=l.$kc(w,i,y),await a(n))return n;let u=n+".com";if(await a(u)||(u=n+".exe",await a(u)))return u}return l.$kc(w,y)}C.findExecutable=m})(N||(e.win32=N={}))});var Je=this&&this.__decorate||function(le,e,l,M){var L=arguments.length,A=L<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,l):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(le,e,l,M);else for(var b=le.length-1;b>=0;b--)(R=le[b])&&(A=(L<3?R(A):L>3?R(e,l,A):R(e,l))||A);return L>3&&A&&Object.defineProperty(e,l,A),A};define(ke[81],Se([1,0,19,8,21,22,55,13,4,3,58,14,18]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.ProxyChannel=e.$bi=e.$$h=e.$0h=e.$9h=e.RequestInitiator=e.$8h=e.$5h=e.$4h=void 0,e.$6h=v,e.$7h=f,e.$_h=I,e.$ai=T;var y;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(y||(y={}));function w(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(d||(d={}));function g(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(a||(a={}));function i(X){let Y=0;for(let x=0;;x+=7){const ne=X.read(1);if(Y|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return Y}}const n=s(0);function u(X,Y){if(Y===0){X.write(n);return}let x=0;for(let ge=Y;ge!==0;ge=ge>>>7)x++;const ne=L.$De.alloc(x);for(let ge=0;Y!==0;ge++)ne.buffer[ge]=Y&127,Y=Y>>>7,Y>0&&(ne.buffer[ge]|=128);X.write(ne)}class o{constructor(Y){this.b=Y,this.a=0}read(Y){const x=this.b.slice(this.a,this.a+Y);return this.a+=x.byteLength,x}}e.$4h=o;class t{constructor(){this.a=[]}get buffer(){return L.$De.concat(this.a)}write(Y){this.a.push(Y)}}e.$5h=t;var h;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(h||(h={}));function s(X){const Y=L.$De.alloc(1);return Y.writeUInt8(X,0),Y}const c={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object),Uint:s(h.Int)},r=typeof Buffer<"u";function v(X,Y){if(typeof Y>"u")X.write(c.Undefined);else if(typeof Y=="string"){const x=L.$De.fromString(Y);X.write(c.String),u(X,x.byteLength),X.write(x)}else if(r&&Buffer.isBuffer(Y)){const x=L.$De.wrap(Y);X.write(c.Buffer),u(X,x.byteLength),X.write(x)}else if(Y instanceof L.$De)X.write(c.VSBuffer),u(X,Y.byteLength),X.write(Y);else if(Array.isArray(Y)){X.write(c.Array),u(X,Y.length);for(const x of Y)v(X,x)}else if(typeof Y=="number"&&(Y|0)===Y)X.write(c.Uint),u(X,Y);else{const x=L.$De.fromString(JSON.stringify(Y));X.write(c.Object),u(X,x.byteLength),X.write(x)}}function f(X){switch(X.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return X.read(i(X)).toString();case h.Buffer:return X.read(i(X)).buffer;case h.VSBuffer:return X.read(i(X));case h.Array:{const x=i(X),ne=[];for(let ge=0;ge<x;ge++)ne.push(f(X));return ne}case h.Object:return JSON.parse(X.read(i(X)).toString());case h.Int:return i(X)}}class D{constructor(Y,x,ne=null,ge=1e3){this.h=Y,this.j=x,this.k=ne,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Y,x){this.b.set(Y,x),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const x=this.o([Y.type]);this.k?.logOutgoing(x,0,1,g(Y.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(x,Y.id,1,g(Y.type),Y.data);return}}}o(Y,x=void 0){const ne=new t;return v(ne,Y),v(ne,x),this.p(ne.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const x=new o(Y),ne=f(x),ge=f(x),ue=ne[0];switch(ue){case 100:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${w(ue)}: ${ne[2]}.${ne[3]}`,ge),this.s({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ge});case 102:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${w(ue)}: ${ne[2]}.${ne[3]}`,ge),this.t({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ge});case 101:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${w(ue)}`),this.u({type:ue,id:ne[1]});case 103:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${w(ue)}`),this.u({type:ue,id:ne[1]})}}s(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ne=new A.$ne;let ge;try{ge=x.call(this.j,Y.name,Y.arg,ne.token)}catch(te){ge=Promise.reject(te)}const ue=Y.id;ge.then(te=>{this.m({id:ue,data:te,type:201})},te=>{te instanceof Error?this.m({id:ue,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:ue,data:te,type:203})}).finally(()=>{ve.dispose(),this.d.delete(Y.id)});const ve=(0,S.$Tc)(()=>ne.cancel());this.d.set(Y.id,ve)}t(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ne=Y.id,ue=x.listen(this.j,Y.name,Y.arg)(ve=>this.m({id:ne,data:ve,type:204}));this.d.set(Y.id,ue)}u(Y){const x=this.d.get(Y.id);x&&(x.dispose(),this.d.delete(Y.id))}v(Y){let x=this.g.get(Y.channelName);x||(x=[],this.g.set(Y.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Y,timeoutTimer:ne})}w(Y){const x=this.g.get(Y);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Qc)(this.d.values()),this.d.clear()}}e.$8h=D;var p;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class E{constructor(Y,x=null){this.l=Y,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$ce,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(Y){const x=this;return{call(ne,ge,ue){return x.a?Promise.reject(new b.$5):x.m(Y,ne,ge,ue)},listen(ne,ge){return x.a?$.Event.None:x.o(Y,ne,ge)}}}m(Y,x,ne,ge=A.CancellationToken.None){const ue=this.g++,te={id:ue,type:100,channelName:Y,name:x,arg:ne};if(ge.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((pe,Pe)=>{if(ge.isCancellationRequested)return Pe(new b.$5);const se=()=>{const ie=$e=>{switch($e.type){case 201:this.f.delete(ue),pe($e.data);break;case 202:{this.f.delete(ue);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,Pe(we);break}case 203:this.f.delete(ue),Pe($e.data);break}};this.f.set(ue,ie),this.p(te)};let re=null;this.b===a.Idle?se():(re=(0,M.$gh)(ie=>this.u()),re.then(()=>{re=null,se()}));const oe=()=>{re?(re.cancel(),re=null):this.p({id:ue,type:101}),Pe(new b.$5)},K=ge.onCancellationRequested(oe);U=(0,S.$Sc)((0,S.$Tc)(oe),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,x,ne){const ge=this.g++,ve={id:ge,type:102,channelName:Y,name:x,arg:ne};let te=null;const U=new $.$ce({onWillAddFirstListener:()=>{te=(0,M.$gh)(pe=>this.u()),te.then(()=>{te=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),_=pe=>U.fire(pe.data);return this.f.set(ge,_),U.event}p(Y){switch(Y.type){case 100:case 102:{const x=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(x,Y.id,0,`${w(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const x=this.q([Y.type,Y.id]);this.j?.logOutgoing(x,Y.id,0,w(Y.type));return}}}q(Y,x=void 0){const ne=new t;return v(ne,Y),v(ne,x),this.r(ne.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const x=new o(Y),ne=f(x),ge=f(x),ue=ne[0];switch(ue){case 200:return this.j?.logIncoming(Y.byteLength,0,0,g(ue)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ne[1],0,g(ue),ge),this.t({type:ne[0],id:ne[1],data:ge})}}t(Y){if(Y.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Qc)(this.d.values()),this.d.clear()}}e.$9h=E,Je([R.$Xh],E.prototype,"onDidInitializePromise",null);class k{get connections(){const Y=[];return this.f.forEach(x=>Y.push(x)),Y}constructor(Y,x,ne){this.a=new Map,this.f=new Set,this.g=new $.$ce,this.onDidAddConnection=this.g.event,this.h=new $.$ce,this.onDidRemoveConnection=this.h.event,this.j=new S.$Uc,this.j.add(Y(({protocol:ge,onDidClientDisconnect:ue})=>{const ve=$.Event.once(ge.onMessage);this.j.add(ve(te=>{const U=new o(te),_=f(U),pe=new D(ge,_,x,ne),Pe=new E(ge,x);this.a.forEach((re,oe)=>pe.registerChannel(oe,re));const se={channelServer:pe,channelClient:Pe,ctx:_};this.f.add(se),this.g.fire(se),this.j.add(ue(()=>{pe.dispose(),Pe.dispose(),this.f.delete(se),this.h.fire(se)}))}))}))}getChannel(Y,x){const ne=this;return{call(ge,ue,ve){let te;if((0,m.$hg)(x)){const _=(0,l.$4b)(ne.connections.filter(x));te=_?Promise.resolve(_):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,x))}else te=x.routeCall(ne,ge,ue);const U=te.then(_=>_.channelClient.getChannel(Y));return I(U).call(ge,ue,ve)},listen(ge,ue){if((0,m.$hg)(x))return ne.k(Y,x,ge,ue);const ve=x.routeEvent(ne,ge,ue).then(te=>te.channelClient.getChannel(Y));return I(ve).listen(ge,ue)}}}k(Y,x,ne,ge){const ue=this;let ve;const te=new $.$ce({onWillAddFirstListener:()=>{ve=new S.$Uc;const U=new $.$ie,_=new Map,pe=se=>{const oe=se.channelClient.getChannel(Y).listen(ne,ge),K=U.add(oe);_.set(se,K)},Pe=se=>{const re=_.get(se);re&&(re.dispose(),_.delete(se))};ue.connections.filter(x).forEach(pe),$.Event.filter(ue.onDidAddConnection,x)(pe,void 0,ve),ue.onDidRemoveConnection(Pe,void 0,ve),U.event(te.fire,te,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return te.event}registerChannel(Y,x){this.a.set(Y,x);for(const ne of this.f)ne.channelServer.registerChannel(Y,x)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$0h=k;class P{constructor(Y,x,ne=null){const ge=new t;v(ge,x),Y.send(ge.buffer),this.a=new E(Y,ne),this.d=new D(Y,x,ne)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,x){this.d.registerChannel(Y,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$$h=P;function I(X){return{call(Y,x,ne){return X.then(ge=>ge.call(Y,x,ne))},listen(Y,x){const ne=new $.$le;return X.then(ge=>ne.input=ge.listen(Y,x)),ne.event}}}function T(X){let Y=!1;return{call(x,ne,ge){return Y?X.call(x,ne,ge):(0,M.$uh)(0).then(()=>Y=!0).then(()=>X.call(x,ne,ge))},listen(x,ne){if(Y)return X.listen(x,ne);const ge=new $.$le;return(0,M.$uh)(0).then(()=>Y=!0).then(()=>ge.input=X.listen(x,ne)),ge.event}}}class j{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const x of Y.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$bi=j;var z;(function(X){function Y(ue,ve,te){const U=ue,_=te&&te.disableMarshalling,pe=new Map;for(const Pe in U)ne(Pe)&&pe.set(Pe,$.Event.buffer(U[Pe],!0,void 0,ve));return new class{listen(Pe,se,re){const oe=pe.get(se);if(oe)return oe;const K=U[se];if(typeof K=="function"){if(ge(se))return K.call(U,re);if(ne(se))return pe.set(se,$.Event.buffer(U[se],!0,void 0,ve)),pe.get(se)}throw new b.$bb(`Event not found: ${se}`)}call(Pe,se,re){const oe=U[se];if(typeof oe=="function"){if(!_&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,N.$3h)(re[ie]);let K=oe.apply(U,re);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${se}`)}}}X.fromService=Y;function x(ue,ve){const te=ve&&ve.disableMarshalling;return new Proxy({},{get(U,_){if(typeof _=="string")return ve?.properties?.has(_)?ve.properties.get(_):ge(_)?function(pe){return ue.listen(_,pe)}:ne(_)?ue.listen(_):async function(...pe){let Pe;ve&&!(0,m.$cg)(ve.context)?Pe=[ve.context,...pe]:Pe=pe;const se=await ue.call(_,Pe);return te?se:(0,N.$3h)(se)};throw new b.$bb(`Property not found: ${String(_)}`)}})}X.toService=x;function ne(ue){return ue[0]==="o"&&ue[1]==="n"&&C.$uf(ue.charCodeAt(2))}function ge(ue){return/^onDynamic/.test(ue)&&C.$uf(ue.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Y=X.toString();if(Y!=="[object Object]")return Y}return X}function B(X){return Array.isArray(X)?X.map(F):F(X)}function W(X,Y,x,ne,ge,ue,ve){ve=B(ve);const te=O[ge],U=te[ne%te.length];let _=[`%c[${X}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(_=_.concat(ve),_.push(")")):_.push(ve),console.log.apply(console,_)}class Z{constructor(Y,x){this.d=Y,this.f=x,this.a=0,this.b=0}logOutgoing(Y,x,ne,ge,ue){this.b+=Y,W(this.d,this.b,Y,x,ne,ge,ue)}logIncoming(Y,x,ne,ge,ue){this.a+=Y,W(this.f,this.a,Y,x,ne,ge,ue)}}e.$ci=Z}),define(ke[82],Se([1,0,21,4,3,81]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.ProtocolConstants=e.$di=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const r=new WeakMap;let v=0;function f(p,E){if(!r.has(p)){const k=String(++v);r.set(p,k)}return r.get(p)}function D(p,E,k,P){if(!c.enableDiagnostics)return;const I=f(p,E);if(P instanceof l.$De||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const T=l.$De.alloc(P.byteLength);T.set(P),c.records.push({timestamp:Date.now(),id:I,label:E,type:k,buff:T})}else c.records.push({timestamp:Date.now(),id:I,label:E,type:k,data:P})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var $;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let S=null;function N(){return S||(S=l.$De.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,v){if(r===0)return N();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const E=this.a[0];return v&&(this.a.shift(),this.b-=r),E}if(this.a[0].byteLength>r){const E=this.a[0].slice(0,r);return v&&(this.a[0]=this.a[0].slice(r),this.b-=r),E}const f=l.$De.alloc(r);let D=0,p=0;for(;r>0;){const E=this.a[p];if(E.byteLength>r){const k=E.slice(0,r);f.set(k,D),D+=r,v&&(this.a[p]=E.slice(r),this.b-=r),r-=r}else f.set(E,D),D+=E.byteLength,v?(this.a.shift(),this.b-=E.byteLength):p++,r-=E.byteLength}return f}}e.$di=C;var m;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(m||(m={}));function y(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class d{constructor(r,v,f,D){this.type=r,this.id=v,this.ack=f,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Vc{constructor(r){super(),this.f=this.B(new M.$ce),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new C,this.B(this.a.onData(v=>this.acceptChunk(v))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const v=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=v.readUInt32BE(9),this.g.messageType=v.readUInt8(0),this.g.id=v.readUInt32BE(1),this.g.ack=v.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,D=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",v),this.f.fire(new d(f,D,p,v)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const v=l.$De.alloc(13);v.writeUInt8(r.type,0),v.writeUInt32BE(r.id,1),v.writeUInt32BE(r.ack,5),v.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(v,r.data)}g(r,v){const f=this.f===0;return this.d.push(r,v),this.f+=r.byteLength+v.byteLength,f}h(){const r=l.$De.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,v){this.g(r,v)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class i extends L.$Vc{constructor(r){super(),this.f=new M.$ce,this.onMessage=this.f.event,this.g=new M.$ce,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new a(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(v=>{v.type===1&&this.f.fire(v.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new d(1,0,0,r))}}e.$ei=i;class n extends A.$$h{static fromSocket(r,v){return new n(new i(r),v)}get onDidDispose(){return this.b.onDidDispose}constructor(r,v,f=null){super(r,v,f),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$fi=n;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$ce({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$gi=u;class o{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,v=this.a;for(;v;)v=v.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let v=0,f=this.a;for(;f;)r[v++]=f.data,f=f.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const v=new o(r);if(!this.a){this.a=v,this.b=v;return}this.b.next=v,this.b=v}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const r=Date.now();for(let v=0;v<h.a;v++)this.c[v]=r-1e3*v;setInterval(()=>{for(let v=h.a;v>=1;v--)this.c[v]=this.c[v-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),v=(1+h.a)*1e3;let f=0;for(let D=0;D<h.a;D++)r-this.c[D]<=v&&f++;return 1-f/h.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??h.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Uc,this.o=r.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new d(5,0,0,N());this.p.write(r),this.p.flush()}sendPause(){const r=new d(7,0,0,N());this.p.write(r)}sendResume(){const r=new d(8,0,0,N());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,v){this.a=!0,this.r.dispose(),this.r=new L.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(v)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new d(3,0,this.h,N());this.p.write(r);const v=this.b.toArray();for(let f=0,D=v.length;f<D;f++)this.p.write(v[f]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const v=this.b.peek();if(v&&v.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const v=Date.now();v-this.m>1e4&&(this.m=v,this.p.write(new d(6,0,0,N())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const v=this.b.toArray();for(let f=0,D=v.length;f<D;f++)this.p.write(v[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const v=++this.c;this.h=this.g;const f=new d(1,v,this.h,r);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(r){const v=new d(2,0,0,r);this.p.write(v)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),v=Date.now()-r.writtenTime,f=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(v>=2e4&&f>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:v,timeSinceLastReceivedSomeData:f});return}const p=Math.max(2e4-v,2e4-f,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new d(3,0,this.h,N());this.p.write(r)}D(){this.h=this.g;const r=new d(9,0,this.h,N());this.p.write(r)}}e.$hi=s}),define(ke[194],Se([1,0,53,8,21,22,192,13,4,3,24,105,102,81]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class w extends y.$8h{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>L.$De.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Wq=w;class d{constructor(a,i){this.i=a,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$ce,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new M.$qh(n),this.d=null,this.f=null}getChannel(a){const i=this;return{call(n,u,o){return i.k(a,n,u,o)},listen(n,u){return i.l(a,n,u)}}}k(a,i,n,u=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const o=this.n(a),t=(0,M.$gh)(c=>o.call(i,n,c)),h=u.onCancellationRequested(()=>t.cancel()),s=(0,S.$Tc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{h.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,i,n){if(!this.b)return $.Event.None;this.b.cancel();let u;const o=new $.$ce({onWillAddFirstListener:()=>{u=this.n(a).listen(i,n)(o.fire,o),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,N.$Zn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,m.$km)(i.env),this.d=(0,l.fork)(this.i,a,i);const n=new $.$ce,o=$.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,R.$Sq)(v)){(0,R.log)(v,`IPC Library: ${this.j.serverName}`);return}n.fire(L.$De.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,C.$mm)(this.d):this.d,h=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),s=n.event,c={send:h,onMessage:s};this.f=new y.$9h(c);const r=()=>this.o();process.once("exit",r),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,f)=>{process.removeListener("exit",r),o.dispose(),this.c.forEach(D=>(0,S.$Qc)(D)),this.c.clear(),v!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:f})})}return this.f}n(a){let i=this.g.get(a);return i||(i=this.m.getChannel(a),this.g.set(a,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Xq=d}),define(ke[195],Se([1,0,8,4,3,58,18]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.StorageState=e.StorageHint=void 0,e.$Sp=$;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const y=m;return y?.changed instanceof Map||y?.deleted instanceof Set}var S;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(S||(e.StorageState=S={}));class N extends L.$Vc{static{this.a=100}constructor(y,w=Object.create(null)){super(),this.r=y,this.s=w,this.b=this.B(new M.$fe),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new l.$rh(N.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((w,d)=>this.w(d,w)),y.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(y,w){if(this.c===S.Closed)return;let d=!1;(0,R.$cg)(w)?d=this.f.delete(y):this.f.get(y)!==w&&(this.f.set(y,w),d=!0),d&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,w){const d=this.f.get(y);return(0,R.$cg)(d)?w:d}getBoolean(y,w){const d=this.get(y);return(0,R.$cg)(d)?w:d==="true"}getNumber(y,w){const d=this.get(y);return(0,R.$cg)(d)?w:parseInt(d,10)}getObject(y,w){const d=this.get(y);return(0,R.$cg)(d)?w:(0,A.$2h)(d)}async set(y,w,d=!1){if(this.c===S.Closed)return;if((0,R.$cg)(w))return this.delete(y,d);const g=(0,R.$8f)(w)||Array.isArray(w)?(0,A.$1h)(w):String(w);if(this.f.get(y)!==g)return this.f.set(y,g),this.j.set(y,g),this.h.delete(y),this.b.fire({key:y,external:d}),this.D()}async delete(y,w=!1){if(!(this.c===S.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:w}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Tp=N;class C{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((w,d)=>this.a.set(d,w)),y.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Up=C}),define(ke[196],Se([1,0,14,11,21]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0,e.$yt=N,e.$zt=C;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let S;function N(){return S||(S=M.$D()?R():$()),S}function C(w,d,g){const a=new Uint16Array(w.buffer,d,g);return g>0&&(a[0]===65279||a[0]===65534)?m(w,d,g):R().decode(a)}function m(w,d,g){const a=[];let i=0;for(let n=0;n<g;n++){const u=L.$Fe(w,d);d+=2,a[i++]=String.fromCharCode(u)}return a.join("")}class y{constructor(d){this.a=d|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const d=new Uint16Array(this.b.buffer,0,this.d);return N().decode(d)}f(){const d=this.e();this.d=0,this.c===null?this.c=[d]:this.c[this.c.length]=d}appendCharCode(d){const g=this.a-this.d;g<=1&&(g===0||l.$zf(d))&&this.f(),this.b[this.d++]=d}appendASCIICharCode(d){this.d===this.a&&this.f(),this.b[this.d++]=d}appendString(d){const g=d.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=d;return}for(let a=0;a<g;a++)this.b[this.d++]=d.charCodeAt(a)}}e.$At=y}),define(ke[197],Se([1,0,21,196]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0,e.$Ct=R;function L($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,N,C,m){this.oldPosition=S,this.oldText=N,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,N,C){const m=N.length;l.$Ie(S,m,C),C+=4;for(let y=0;y<m;y++)l.$Ge(S,N.charCodeAt(y),C),C+=2;return C}static d(S,N){const C=l.$He(S,N);return N+=4,(0,M.$zt)(S,N,C)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(S,N){return l.$Ie(S,this.oldPosition,N),N+=4,l.$Ie(S,this.newPosition,N),N+=4,N=A.c(S,this.oldText,N),N=A.c(S,this.newText,N),N}static read(S,N,C){const m=l.$He(S,N);N+=4;const y=l.$He(S,N);N+=4;const w=A.d(S,N);N+=A.a(w);const d=A.d(S,N);return N+=A.a(d),C.push(new A(m,w,y,d)),N}}e.$Bt=A;function R($,S){return $===null||$.length===0?S:new b($,S).compress()}class b{constructor(S,N){this.a=S,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,N=0,C=this.n(S),m=this.l(N);for(;S<this.f||N<this.h;){if(C===null){this.k(m),m=this.l(++N);continue}if(m===null){this.m(C),C=this.n(++S);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++N);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++S);continue}if(m.oldPosition<C.newPosition){const[a,i]=b.r(m,C.newPosition-m.oldPosition);this.k(a),m=i;continue}if(C.newPosition<m.oldPosition){const[a,i]=b.q(C,m.oldPosition-C.newPosition);this.m(a),C=i;continue}let d,g;if(m.oldEnd===C.newEnd)d=C,g=m,C=this.n(++S),m=this.l(++N);else if(m.oldEnd<C.newEnd){const[a,i]=b.q(C,m.oldLength);d=a,g=m,C=i,m=this.l(++N)}else{const[a,i]=b.r(m,C.newLength);d=C,g=a,C=this.n(++S),m=i}this.d[this.e++]=new A(d.oldPosition,d.oldText,g.newPosition,g.newText),this.g+=d.newLength-d.oldLength,this.j+=g.newLength-g.oldLength}const y=b.s(this.d);return b.t(y)}k(S){this.d[this.e++]=b.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=b.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,N){return new A(N.oldPosition-S,N.oldText,N.newPosition,N.newText)}static p(S,N){return new A(N.oldPosition,N.oldText,N.newPosition+S,N.newText)}static q(S,N){const C=S.newText.substr(0,N),m=S.newText.substr(N);return[new A(S.oldPosition,S.oldText,S.newPosition,C),new A(S.oldEnd,"",S.newPosition+N,m)]}static r(S,N){const C=S.oldText.substr(0,N),m=S.oldText.substr(N);return[new A(S.oldPosition,C,S.newPosition,S.newText),new A(S.oldPosition+N,m,S.newEnd,"")]}static s(S){if(S.length===0)return S;const N=[];let C=0,m=S[0];for(let y=1;y<S.length;y++){const w=S[y];m.oldEnd===w.oldPosition?m=new A(m.oldPosition,m.oldText+w.oldText,m.newPosition,m.newText+w.newText):(N[C++]=m,m=w)}return N[C++]=m,N}static t(S){if(S.length===0)return S;const N=[];let C=0;for(let m=0;m<S.length;m++){const y=S[m];y.oldText!==y.newText&&(N[C++]=y)}return N}}}),define(ke[198],Se([1,0,35,17]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=L,e.$1t=A;function L(R,b,$,S,N,C){if(Array.isArray(R)){let m=0;for(const y of R){const w=L(y,b,$,S,N,C);if(w===10)return w;w>m&&(m=w)}return m}else{if(typeof R=="string")return S?R==="*"?5:R===$?10:0:0;if(R){const{language:m,pattern:y,scheme:w,hasAccessToAllModels:d,notebookType:g}=R;if(!S&&!d)return 0;g&&N&&(b=N);let a=0;if(w)if(w===b.scheme)a=10;else if(w==="*")a=5;else return 0;if(m)if(m===$)a=10;else if(m==="*")a=Math.max(a,5);else return 0;if(g)if(g===C)a=10;else if(g==="*"&&C!==void 0)a=Math.max(a,5);else return 0;if(y){let i;if(typeof y=="string"?i=y:i={...y,base:(0,M.$ic)(y.base)},i===b.fsPath||(0,l.$mk)(i,b.fsPath))a=10;else return 0}return a}else return 0}}function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}}),define(ke[199],Se([1,0,4,14,29,79,130,174,197,3]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=void 0;class N extends S.$Vc{constructor(m,y,w,d,g,a,i){super(),this.m=this.B(new l.$ce),this.onDidChangeContent=this.m.event,this.f=y,this.j=!a,this.g=d,this.h=g,this.c=new R.$OC(m,w,i)}equals(m){return!(m instanceof N)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,y){return this.c.getOffsetAt(m,y)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,y){const w=m+y,d=this.getPositionAt(m),g=this.getPositionAt(w);return new L.$pt(d.lineNumber,d.column,g.lineNumber,g.column)}getValueInRange(m,y=0){if(m.isEmpty())return"";const w=this.n(y);return this.c.getValueInRange(m,w)}getValueLengthInRange(m,y=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const w=this.getOffsetAt(m.startLineNumber,m.startColumn),d=this.getOffsetAt(m.endLineNumber,m.endColumn);let g=0;const a=this.n(y),i=this.getEOL();if(a.length!==i.length){const n=a.length-i.length,u=m.endLineNumber-m.startLineNumber;g=n*u}return d-w+g}getCharacterCountInRange(m,y=0){if(this.j){let w=0;const d=m.startLineNumber,g=m.endLineNumber;for(let a=d;a<=g;a++){const i=this.getLineContent(a),n=a===d?m.startColumn-1:0,u=a===g?m.endColumn-1:i.length;for(let o=n;o<u;o++)M.$zf(i.charCodeAt(o))?(w=w+1,o=o+1):w=w+1}return w+=this.n(y).length*(g-d),w}return this.getValueLengthInRange(m,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,y){return this.c.getLineCharCode(m,y)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const y=M.$kf(this.getLineContent(m));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(m){const y=M.$mf(this.getLineContent(m));return y===-1?0:y+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,y,w){let d=this.g,g=this.h,a=this.j,i=!0,n=[];for(let r=0;r<m.length;r++){const v=m[r];i&&v._isTracked&&(i=!1);const f=v.range;if(v.text){let P=!0;a||(P=!M.$Kf(v.text),a=P),!d&&P&&(d=M.$Jf(v.text)),!g&&P&&(g=M.$Mf(v.text))}let D="",p=0,E=0,k=0;if(v.text){let P;[p,E,k,P]=(0,b.$St)(v.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=v.text:D=v.text.replace(/\r\n|\r|\n/g,I)}n[r]={sortIndex:r,identifier:v.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:D,eolCount:p,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}n.sort(N.u);let u=!1;for(let r=0,v=n.length-1;r<v;r++){const f=n[r].range.getEndPosition(),D=n[r+1].range.getStartPosition();if(D.isBeforeOrEqual(f)){if(D.isBefore(f))throw new Error("Overlapping ranges are not allowed!");u=!0}}i&&(n=this.s(n));const o=w||y?N._getInverseEditRanges(n):[],t=[];if(y)for(let r=0;r<n.length;r++){const v=n[r],f=o[r];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let D=f.startLineNumber;D<=f.endLineNumber;D++){let p="";D===f.startLineNumber&&(p=this.getLineContent(v.range.startLineNumber),M.$kf(p)!==-1)||t.push({lineNumber:D,oldContent:p})}}let h=null;if(w){let r=0;h=[];for(let v=0;v<n.length;v++){const f=n[v],D=o[v],p=this.getValueInRange(f.range),E=f.rangeOffset+r;r+=f.text.length-p.length,h[v]={sortIndex:f.sortIndex,identifier:f.identifier,range:D,text:p,textChange:new $.$Bt(f.rangeOffset,p,E,f.text)}}u||h.sort((v,f)=>v.sortIndex-f.sortIndex)}this.g=d,this.h=g,this.j=a;const s=this.t(n);let c=null;if(y&&t.length>0){t.sort((r,v)=>v.lineNumber-r.lineNumber),c=[];for(let r=0,v=t.length;r<v;r++){const f=t[r].lineNumber;if(r>0&&t[r-1].lineNumber===f)continue;const D=t[r].oldContent,p=this.getLineContent(f);p.length===0||p===D||M.$kf(p)!==-1||c.push(f)}}return this.m.fire(),new A.$Ev(h,s,c)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let y=!1;const w=m[0].range,d=m[m.length-1].range,g=new L.$pt(w.startLineNumber,w.startColumn,d.endLineNumber,d.endColumn);let a=w.startLineNumber,i=w.startColumn;const n=[];for(let s=0,c=m.length;s<c;s++){const r=m[s],v=r.range;y=y||r.forceMoveMarkers,n.push(this.getValueInRange(new L.$pt(a,i,v.startLineNumber,v.startColumn))),r.text.length>0&&n.push(r.text),a=v.endLineNumber,i=v.endColumn}const u=n.join(""),[o,t,h]=(0,b.$St)(u);return{sortIndex:0,identifier:m[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:u,eolCount:o,firstLineLength:t,lastLineLength:h,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(m){m.sort(N.w);const y=[];for(let w=0;w<m.length;w++){const d=m[w],g=d.range.startLineNumber,a=d.range.startColumn,i=d.range.endLineNumber,n=d.range.endColumn;if(g===i&&a===n&&d.text.length===0)continue;d.text?(this.c.delete(d.rangeOffset,d.rangeLength),this.c.insert(d.rangeOffset,d.text,!0)):this.c.delete(d.rangeOffset,d.rangeLength);const u=new L.$pt(g,a,i,n);y.push({range:u,rangeLength:d.rangeLength,text:d.text,rangeOffset:d.rangeOffset,forceMoveMarkers:d.forceMoveMarkers})}return y}findMatchesLineByLine(m,y,w,d){return this.c.findMatchesLineByLine(m,y,w,d)}getPieceTree(){return this.c}static _getInverseEditRange(m,y){const w=m.startLineNumber,d=m.startColumn,[g,a,i]=(0,b.$St)(y);let n;if(y.length>0){const u=g+1;u===1?n=new L.$pt(w,d,w,d+a):n=new L.$pt(w,d,w+u-1,i+1)}else n=new L.$pt(w,d,w,d);return n}static _getInverseEditRanges(m){const y=[];let w=0,d=0,g=null;for(let a=0,i=m.length;a<i;a++){const n=m[a];let u,o;g?g.range.endLineNumber===n.range.startLineNumber?(u=w,o=d+(n.range.startColumn-g.range.endColumn)):(u=w+(n.range.startLineNumber-g.range.endLineNumber),o=n.range.startColumn):(u=n.range.startLineNumber,o=n.range.startColumn);let t;if(n.text.length>0){const h=n.eolCount+1;h===1?t=new L.$pt(u,o,u,o+n.firstLineLength):t=new L.$pt(u,o,u+h-1,n.lastLineLength+1)}else t=new L.$pt(u,o,u,o);w=t.endLineNumber,d=t.endColumn,y.push(t),g=n}return y}static u(m,y){const w=L.$pt.compareRangesUsingEnds(m.range,y.range);return w===0?m.sortIndex-y.sortIndex:w}static w(m,y){const w=L.$pt.compareRangesUsingEnds(m.range,y.range);return w===0?y.sortIndex-m.sortIndex:-w}}e.$PC=N}),define(ke[200],Se([1,0,14,130,199]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=void 0;class A{constructor($,S,N,C,m,y,w,d,g){this.a=$,this.b=S,this.c=N,this.d=C,this.e=m,this.f=y,this.g=w,this.h=d,this.j=g}k($){const S=this.c+this.d+this.e,N=this.c+this.e;return S===0?$===1?`
`:`\r
`:N>S/2?`\r
`:`
`}create($){const S=this.k($),N=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let m=0,y=N.length;m<y;m++){const w=N[m].buffer.replace(/\r\n|\r|\n/g,S),d=(0,M.$KC)(w);N[m]=new M.$NC(w,d)}const C=new L.$PC(N,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&l.$Tf($)&&(this.b=l.$Sf,$=$.substr(1));const S=$.charCodeAt($.length-1);S===13||S>=55296&&S<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=S):(this.m($,!1),this.c=!1,this.d=S)}m($,S){!S&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const S=(0,M.$LC)(this.e,$);this.a.push(new M.$NC($,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=l.$Jf($)),this.k||(this.k=l.$Mf($)))}finish($=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const S=(0,M.$KC)($.buffer);$.lineStarts=S,this.d===13&&this.f++}}}e.$QC=R}),define(ke[134],Se([1,0,21,11]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbb=$,e.$Qbb=N;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function A(C){for(let m=0,y=C.length;m<y;m+=4){const w=C[m+0],d=C[m+1],g=C[m+2],a=C[m+3];C[m+0]=a,C[m+1]=g,C[m+2]=d,C[m+3]=w}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return M.$D()||A(m),l.$De.wrap(m)}function b(C){const m=C.buffer;if(M.$D()||A(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const y=new Uint8Array(m.byteLength);return y.set(m),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function $(C){const m=new Uint32Array(S(C));let y=0;if(m[y++]=C.id,C.type==="full")m[y++]=1,m[y++]=C.data.length,m.set(C.data,y),y+=C.data.length;else{m[y++]=2,m[y++]=C.deltas.length;for(const w of C.deltas)m[y++]=w.start,m[y++]=w.deleteCount,w.data?(m[y++]=w.data.length,m.set(w.data,y),y+=w.data.length):m[y++]=0}return R(m)}function S(C){let m=0;if(m+=2,C.type==="full")m+=1+C.data.length;else{m+=1,m+=3*C.deltas.length;for(const y of C.deltas)y.data&&(m+=y.data.length)}return m}function N(C){const m=b(C);let y=0;const w=m[y++];if(m[y++]===1){const i=m[y++],n=m.subarray(y,y+i);return y+=i,{id:w,type:"full",data:n}}const g=m[y++],a=[];for(let i=0;i<g;i++){const n=m[y++],u=m[y++],o=m[y++];let t;o>0&&(t=m.subarray(y,y+o),y+=o),a[i]={start:n,deleteCount:u,data:t}}return{id:w,type:"delta",deltas:a}}}),define(ke[201],Se([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Se([1,0,19,24,11,177,129,201]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=i,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=k,e.filterValidationDecorations=we;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=S;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class C{constructor(ce,Ae,Ke,Re){this.id=ce,this.name=Ae,this.defaultValue=Ke,this.schema=Re}applyUpdate(ce,Ae){return y(ce,Ae)}compute(ce,Ae,Ke){return Ke}}class m{constructor(ce,Ae){this.newValue=ce,this.didChange=Ae}}e.ApplyUpdateResult=m;function y(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new m(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ke=Array.isArray(ae)&&Array.isArray(ce)&&l.$ub(ae,ce);return new m(ce,!Ke)}let Ae=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Re=y(ae[Ke],ce[Ke]);Re.didChange&&(ae[Ke]=Re.newValue,Ae=!0)}return new m(ae,Ae)}class w{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ae){return y(ce,Ae)}validate(ce){return this.defaultValue}}class d{constructor(ce,Ae,Ke,Re){this.id=ce,this.name=Ae,this.defaultValue=Ke,this.schema=Re}applyUpdate(ce,Ae){return y(ce,Ae)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ae,Ke){return Ke}}function g(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends d{constructor(ce,Ae,Ke,Re=void 0){typeof Re<"u"&&(Re.type="boolean",Re.default=Ke),super(ce,Ae,Ke,Re)}validate(ce){return g(ce,this.defaultValue)}}function i(ae,ce,Ae,Ke){if(typeof ae>"u")return ce;let Re=parseInt(ae,10);return isNaN(Re)?ce:(Re=Math.max(Ae,Re),Re=Math.min(Ke,Re),Re|0)}class n extends d{static clampedInt(ce,Ae,Ke,Re){return i(ce,Ae,Ke,Re)}constructor(ce,Ae,Ke,Re,tt,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ke,ht.minimum=Re,ht.maximum=tt),super(ce,Ae,Ke,ht),this.minimum=Re,this.maximum=tt}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function u(ae,ce,Ae,Ke){if(typeof ae>"u")return ce;const Re=o.float(ae,ce);return o.clamp(Re,Ae,Ke)}class o extends d{static clamp(ce,Ae,Ke){return ce<Ae?Ae:ce>Ke?Ke:ce}static float(ce,Ae){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ae;const Ke=parseFloat(ce);return isNaN(Ke)?Ae:Ke}constructor(ce,Ae,Ke,Re,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ke),super(ce,Ae,Ke,tt),this.validationFn=Re}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends d{static string(ce,Ae){return typeof ce!="string"?Ae:ce}constructor(ce,Ae,Ke,Re=void 0){typeof Re<"u"&&(Re.type="string",Re.default=Ke),super(ce,Ae,Ke,Re)}validate(ce){return t.string(ce,this.defaultValue)}}function h(ae,ce,Ae,Ke){return typeof ae!="string"?ce:Ke&&ae in Ke?Ke[ae]:Ae.indexOf(ae)===-1?ce:ae}class s extends d{constructor(ce,Ae,Ke,Re,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Re,tt.default=Ke),super(ce,Ae,Ke,tt),this.c=Re}validate(ce){return h(ce,this.defaultValue,this.c)}}class c extends C{constructor(ce,Ae,Ke,Re,tt,ht,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=tt,wt.default=Re),super(ce,Ae,Ke,wt),this.c=tt,this.d=ht}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function r(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ae,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class f extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{insertSpace:g(Ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function p(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(ae){switch(ae){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(ae){switch(ae){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class I extends w{constructor(){super(142)}compute(ce,Ae,Ke){const Re=["monaco-editor"];return Ae.get(39)&&Re.push(Ae.get(39)),ce.extraEditorClassName&&Re.push(ce.extraEditorClassName),Ae.get(74)==="default"?Re.push("mouse-default"):Ae.get(74)==="copy"&&Re.push("mouse-copy"),Ae.get(111)&&Re.push("showUnused"),Ae.get(140)&&Re.push("showDeprecated"),Re.join(" ")}}class T extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ae,Ke){return Ke&&ce.emptySelectionClipboard}}class j extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{cursorMoveOnType:g(Ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":h(Ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":h(Ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ae.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.TRANSLATE:ce:ce?O.TRANSLATE:O.OFF}compute(ce,Ae,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class F extends w{constructor(){super(50)}compute(ce,Ae,Ke){return ce.fontInfo}}class B extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ae=o.float(ce,this.defaultValue);return Ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ae,6,100)}compute(ce,Ae,Ke){return ce.fontInfo.fontSize}}class W extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class Z extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ae},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ae},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ae},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ae},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{multiple:h(Ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ae.multipleDefinitions??h(Ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ae.multipleTypeDefinitions??h(Ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ae.multipleDeclarations??h(Ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ae.multipleImplementations??h(Ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ae.multipleReferences??h(Ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ae.delay,this.defaultValue.delay,0,1e4),sticky:g(Ae.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ae.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ae.above,this.defaultValue.above)}}}var Y;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class x extends w{constructor(){super(145)}compute(ce,Ae,Ke){return x.computeLayout(Ae,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ae=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Re=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Re=Math.max(Re,Ae-1));const tt=(Ke+ce.viewLineCount+Re)/(ce.pixelRatio*ce.height),ht=Math.floor(ce.viewLineCount/tt);return{typicalViewportLineCount:Ae,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Re,desiredRatio:tt,minimapLineCount:ht}}static c(ce,Ae){const Ke=ce.outerWidth,Re=ce.outerHeight,tt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Re),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Re};const ht=Ae.stableMinimapLayoutInput,wt=ht&&ce.outerHeight===ht.outerHeight&&ce.lineHeight===ht.lineHeight&&ce.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ht.pixelRatio&&ce.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ce.paddingTop===ht.paddingTop&&ce.paddingBottom===ht.paddingBottom&&ce.minimap.enabled===ht.minimap.enabled&&ce.minimap.side===ht.minimap.side&&ce.minimap.size===ht.minimap.size&&ce.minimap.showSlider===ht.minimap.showSlider&&ce.minimap.renderCharacters===ht.minimap.renderCharacters&&ce.minimap.maxColumn===ht.minimap.maxColumn&&ce.minimap.scale===ht.minimap.scale&&ce.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ce.isViewportWrapping===ht.isViewportWrapping,Mt=ce.lineHeight,At=ce.typicalHalfwidthCharacterWidth,xt=ce.scrollBeyondLastLine,_t=ce.minimap.renderCharacters;let Pt=tt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const qt=ce.minimap.maxColumn,Zt=ce.minimap.size,et=ce.minimap.side,si=ce.verticalScrollbarWidth,Yt=ce.viewLineCount,dt=ce.remainingWidth,vt=ce.isViewportWrapping,ti=_t?2:3;let Xt=Math.floor(tt*Re);const zt=Xt/tt;let gt=!1,Ut=!1,Wt=ti*Pt,Ht=Pt/tt,Xe=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:Tt,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Kt,desiredRatio:ni,minimapLineCount:Ot}=x.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:xt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Re,lineHeight:Mt,pixelRatio:tt});if(Yt/Ot>1)gt=!0,Ut=!0,Pt=1,Wt=1,Ht=Pt/tt;else{let It=!1,St=Pt+1;if(Zt==="fit"){const pt=Math.ceil((ii+Yt+Kt)*Wt);vt&&wt&&dt<=Ae.stableFitRemainingWidth?(It=!0,St=Ae.stableFitMaxMinimapScale):It=pt>Xt}if(Zt==="fill"||It){gt=!0;const pt=Pt;Wt=Math.min(Mt*tt,Math.max(1,Math.floor(1/ni))),vt&&wt&&dt<=Ae.stableFitRemainingWidth&&(St=Ae.stableFitMaxMinimapScale),Pt=Math.min(St,Math.max(1,Math.floor(Wt/ti))),Pt>pt&&(Xe=Math.min(2,Pt/pt)),Ht=Pt/tt/Xe,Xt=Math.ceil(Math.max(Tt,ii+Yt+Kt)*Wt),vt?(Ae.stableMinimapLayoutInput=ce,Ae.stableFitRemainingWidth=dt,Ae.stableFitMaxMinimapScale=Pt):(Ae.stableMinimapLayoutInput=null,Ae.stableFitRemainingWidth=0)}}}const ui=Math.floor(qt*Ht),Gt=Math.min(ui,Math.max(0,Math.floor((dt-si-2)*Ht/(At+Ht)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(tt*Gt);const mt=Bt/tt;Bt=Math.floor(Bt*Xe);const Ft=_t?1:2,Rt=et==="left"?0:Ke-Gt-si;return{renderMinimap:Ft,minimapLeft:Rt,minimapWidth:Gt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:Pt,minimapLineHeight:Wt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:Xt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ce,Ae){const Ke=Ae.outerWidth|0,Re=Ae.outerHeight|0,tt=Ae.lineHeight|0,ht=Ae.lineNumbersDigitCount|0,wt=Ae.typicalHalfwidthCharacterWidth,Mt=Ae.maxDigitWidth,At=Ae.pixelRatio,xt=Ae.viewLineCount,_t=ce.get(137),Pt=_t==="inherit"?ce.get(136):_t,qt=Pt==="inherit"?ce.get(132):Pt,Zt=ce.get(135),et=Ae.isDominatedByLongLines,si=ce.get(57),Yt=ce.get(68).renderType!==0,dt=ce.get(69),vt=ce.get(105),ti=ce.get(84),Xt=ce.get(73),zt=ce.get(103),gt=zt.verticalScrollbarSize,Ut=zt.verticalHasArrows,Wt=zt.arrowSize,Ht=zt.horizontalScrollbarSize,Xe=ce.get(43),ui=ce.get(110)!=="never";let Gt=ce.get(66);Xe&&ui&&(Gt+=16);let Bt=0;if(Yt){const li=Math.max(ht,dt);Bt=Math.round(li*Mt)}let mt=0;si&&(mt=tt*Ae.glyphMarginDecorationLaneCount);let Ft=0,Rt=Ft+mt,Tt=Rt+Bt,ii=Tt+Gt;const Kt=Ke-mt-Bt-Gt;let ni=!1,Ot=!1,Nt=-1;Pt==="inherit"&&et?(ni=!0,Ot=!0):qt==="on"||qt==="bounded"?Ot=!0:qt==="wordWrapColumn"&&(Nt=Zt);const It=x.c({outerWidth:Ke,outerHeight:Re,lineHeight:tt,typicalHalfwidthCharacterWidth:wt,pixelRatio:At,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Xt,verticalScrollbarWidth:gt,viewLineCount:xt,remainingWidth:Kt,isViewportWrapping:Ot},Ae.memory||new N);It.renderMinimap!==0&&It.minimapLeft===0&&(Ft+=It.minimapWidth,Rt+=It.minimapWidth,Tt+=It.minimapWidth,ii+=It.minimapWidth);const St=Kt-It.minimapWidth,pt=Math.max(1,Math.floor((St-gt-2)/wt)),Ct=Ut?Wt:0;return Ot&&(Nt=Math.max(1,pt),qt==="bounded"&&(Nt=Math.min(Nt,Zt))),{width:Ke,height:Re,glyphMarginLeft:Ft,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Ae.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Bt,decorationsLeft:Tt,decorationsWidth:Gt,contentLeft:ii,contentWidth:St,minimap:It,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Ot,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Ht,overviewRuler:{top:Ct,width:gt,height:Re-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return h(ce,"simple",["simple","advanced"])}compute(ce,Ae,Ke){return Ae.get(2)===2?"advanced":Ke}}var ge;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class ue extends C{constructor(){const ce={enabled:ge.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:h(ce.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class ve extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ae.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Ae.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ae.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return typeof Ae.enabled=="boolean"&&(Ae.enabled=Ae.enabled?"on":"off"),{enabled:h(Ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily),padding:g(Ae.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ae,Ke){return Ke<0?n.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class _ extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Ae,Ke){return ce.fontInfo.lineHeight}}class pe extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),autohide:g(Ae.autohide,this.defaultValue.autohide),size:h(Ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ae.side,this.defaultValue.side,["right","left"]),showSlider:h(Ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ae.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ae.scale,1,1,3),maxColumn:n.clampedInt(Ae.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Ae.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Ae.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Ae.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(ae){return ae==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class se extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{top:n.clampedInt(Ae.top,0,0,1e3),bottom:n.clampedInt(Ae.bottom,0,0,1e3)}}}class re extends C{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),cycle:g(Ae.cycle,this.defaultValue.cycle)}}}class oe extends w{constructor(){super(143)}compute(ce,Ae,Ke){return ce.pixelRatio}}class K extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ae,default:ce.strings,description:b.localize(88,null)},comments:{anyOf:Ae,default:ce.comments,description:b.localize(89,null)},other:{anyOf:Ae,default:ce.other,description:b.localize(90,null)}},default:ce,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const At=ce?"on":"off";return{comments:At,strings:At,other:At}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ae,comments:Ke,strings:Re}=ce,tt=["on","inline","off"];let ht,wt,Mt;return typeof Ae=="boolean"?ht=Ae?"on":"off":ht=h(Ae,this.defaultValue.other,tt),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=h(Ke,this.defaultValue.comments,tt),typeof Re=="boolean"?Mt=Re?"on":"off":Mt=h(Re,this.defaultValue.strings,tt),{other:ht,comments:wt,strings:Mt}}}var ie;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class $e extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ce){let Ae=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ae=4,Ke=ce):ce==="interval"?Ae=3:ce==="relative"?Ae=2:ce==="on"?Ae=1:Ae=0),{renderType:Ae,renderFn:Ke}}}function we(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Ne extends C{constructor(){const ce=[],Ae={type:"number",description:b.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Ae,{type:["object"],properties:{column:Ae,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ce,description:b.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Ae=[];for(const Ke of ce)if(typeof Ke=="number")Ae.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Re=Ke;Ae.push({column:n.clampedInt(Re.column,0,0,1e4),color:Re.color})}return Ae.sort((Ke,Re)=>Ke.column-Re.column),Ae}return this.defaultValue}}class fe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce,Ke=n.clampedInt(Ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Re=n.clampedInt(Ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ae.vertical,this.defaultValue.vertical),horizontal:De(Ae.horizontal,this.defaultValue.horizontal),useShadows:g(Ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ae.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Re,verticalSliderSize:n.clampedInt(Ae.verticalSliderSize,Re,0,1e3),scrollByPage:g(Ae.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ae.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ce,Ae){let Ke=!1;Ae.allowedCharacters&&ce&&(M.$4n(ce.allowedCharacters,Ae.allowedCharacters)||(ce={...ce,allowedCharacters:Ae.allowedCharacters},Ke=!0)),Ae.allowedLocales&&ce&&(M.$4n(ce.allowedLocales,Ae.allowedLocales)||(ce={...ce,allowedLocales:Ae.allowedLocales},Ke=!0));const Re=super.applyUpdate(ce,Ae);return Ke?new m(Re.newValue,!0):Re}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{nonBasicASCII:he(Ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ae){if(typeof ce!="object"||!ce)return Ae;const Ke={};for(const[Re,tt]of Object.entries(ce))tt===!0&&(Ke[Re]=!0);return Ke}}class V extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),mode:h(Ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ae.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ae.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily)}}}class q extends C{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:b.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showToolbar:h(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Ae.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Ae.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends C{constructor(){const ce={enabled:A.$Zs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Zs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ce.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ce.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{bracketPairs:he(Ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Ae){const Ke=Ae.indexOf(ae);return Ke===-1?ce:Ae[Ke]}class be extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ce.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ce.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{insertMode:h(Ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ae.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ae.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ae.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ae.preview,this.defaultValue.preview),previewMode:h(Ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ae.showMethods,this.defaultValue.showMethods),showFunctions:g(Ae.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ae.showFields,this.defaultValue.showFields),showVariables:g(Ae.showVariables,this.defaultValue.showVariables),showClasses:g(Ae.showClasses,this.defaultValue.showClasses),showStructs:g(Ae.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ae.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ae.showModules,this.defaultValue.showModules),showProperties:g(Ae.showProperties,this.defaultValue.showProperties),showEvents:g(Ae.showEvents,this.defaultValue.showEvents),showOperators:g(Ae.showOperators,this.defaultValue.showOperators),showUnits:g(Ae.showUnits,this.defaultValue.showUnits),showValues:g(Ae.showValues,this.defaultValue.showValues),showConstants:g(Ae.showConstants,this.defaultValue.showConstants),showEnums:g(Ae.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ae.showKeywords,this.defaultValue.showKeywords),showWords:g(Ae.showWords,this.defaultValue.showWords),showColors:g(Ae.showColors,this.defaultValue.showColors),showFiles:g(Ae.showFiles,this.defaultValue.showFiles),showReferences:g(Ae.showReferences,this.defaultValue.showReferences),showFolders:g(Ae.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ae.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ae.showUsers,this.defaultValue.showUsers),showIssues:g(Ae.showIssues,this.defaultValue.showIssues)}}}class ze extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends C{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Ae=[];for(const Ke of ce)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Ae.push(Ke)}catch{}return Ae}return this.defaultValue}}var Ye;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class it extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ae,Ke){return Ae.get(2)===2?0:Ke}}class ot extends w{constructor(){super(146)}compute(ce,Ae,Ke){const Re=Ae.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Re.isWordWrapMinified,isViewportWrapping:Re.isViewportWrapping,wrappingColumn:Re.wrappingColumn}}}class nt extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showDropSelector:h(Ae.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showPasteSelector:h(Ae.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ce="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?Ge:Ce,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Ze;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Me(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Me(new v),accessibilityPageSize:Me(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Me(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Me(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Me(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Me(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Me(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Me(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Me(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Me(new a(13,"automaticLayout",!1)),autoSurround:Me(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Me(new J),bracketPairGuides:Me(new Q),stickyTabStops:Me(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Me(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Me(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Me(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Me(new s(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Me(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Me(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Me(new f),contextmenu:Me(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Me(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Me(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Me(new c(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(260,null)})),cursorSurroundingLines:Me(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Me(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Me(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Me(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(34,"domReadOnly",!1)),dragAndDrop:Me(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Me(new T),dropIntoEditor:Me(new nt),stickyScroll:Me(new ve),experimentalWhitespaceRendering:Me(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(271,null)})),find:Me(new j),fixedOverflowWidgets:Me(new a(42,"fixedOverflowWidgets",!1)),folding:Me(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Me(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Me(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Me(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Me(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Me(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Me(new F),fontLigatures2:Me(new z),fontSize:Me(new B),fontWeight:Me(new W),fontVariations:Me(new O),formatOnPaste:Me(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Me(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Me(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Me(new Z),hideCursorInOverviewRuler:Me(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Me(new X),inDiffEditor:Me(new a(61,"inDiffEditor",!1)),letterSpacing:Me(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:b.localize(285,null)})),lightbulb:Me(new ue),lineDecorationsWidth:Me(new U),lineHeight:Me(new _),lineNumbers:Me(new $e),lineNumbersMinChars:Me(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Me(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Me(new s(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Me(new pe),mouseStyle:Me(new s(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Me(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Me(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Me(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Me(new s(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Me(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Me(new s(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Me(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Me(new n(83,"overviewRulerLanes",3,0,3)),padding:Me(new se),pasteAs:Me(new st),parameterHints:Me(new re),peekWidgetDefaultFocus:Me(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Me(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Me(new K),quickSuggestionsDelay:Me(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Me(new a(91,"readOnly",!1)),readOnlyMessage:Me(new fe),renameOnType:Me(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Me(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Me(new s(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Me(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Me(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Me(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Me(new Ne),scrollbar:Me(new Ie),scrollBeyondLastColumn:Me(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Me(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Me(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Me(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:Me(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Me(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Me(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Me(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Me(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Me(new te),snippetSuggestions:Me(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Me(new ze),smoothScrolling:Me(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Me(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new be),inlineSuggest:Me(new V),inlineEdit:Me(new q),inlineCompletionsAccessibilityVerbose:Me(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Me(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Me(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Me(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Me(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Fe),unusualLineTerminators:Me(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Me(new a(127,"useShadowDOM",!0)),useTabStops:Me(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Me(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Me(new qe),wordSeparators:Me(new t(131,"wordSeparators",R.$1s,{description:b.localize(359,null)})),wordWrap:Me(new s(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Me(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Me(new s(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new s(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new I),defaultColorDecorators:Me(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Me(new oe),tabFocusMode:Me(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Me(new x),wrappingInfo:Me(new ot),wrappingIndent:Me(new it),wrappingStrategy:Me(new ne)}}),define(ke[202],Se([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,175,29,185,202]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$au=e.$_t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$$t=e.$0t=e.SymbolKinds=e.SymbolTag=e.$8t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$6t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$5t=e.$4t=e.$3t=void 0,e.$7t=h,e.$9t=c;class ${constructor(Z,X,Y){this.offset=Z,this.type=X,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$3t=$;class S{constructor(Z,X){this.tokens=Z,this.endState=X,this._tokenizationResultBrand=void 0}}e.$4t=S;class N{constructor(Z,X){this.tokens=Z,this.endState=X,this._encodedTokenizationResultBrand=void 0}}e.$5t=N;var C;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(W){const Z=new Map;Z.set(0,l.$Sj.symbolMethod),Z.set(1,l.$Sj.symbolFunction),Z.set(2,l.$Sj.symbolConstructor),Z.set(3,l.$Sj.symbolField),Z.set(4,l.$Sj.symbolVariable),Z.set(5,l.$Sj.symbolClass),Z.set(6,l.$Sj.symbolStruct),Z.set(7,l.$Sj.symbolInterface),Z.set(8,l.$Sj.symbolModule),Z.set(9,l.$Sj.symbolProperty),Z.set(10,l.$Sj.symbolEvent),Z.set(11,l.$Sj.symbolOperator),Z.set(12,l.$Sj.symbolUnit),Z.set(13,l.$Sj.symbolValue),Z.set(15,l.$Sj.symbolEnum),Z.set(14,l.$Sj.symbolConstant),Z.set(15,l.$Sj.symbolEnum),Z.set(16,l.$Sj.symbolEnumMember),Z.set(17,l.$Sj.symbolKeyword),Z.set(27,l.$Sj.symbolSnippet),Z.set(18,l.$Sj.symbolText),Z.set(19,l.$Sj.symbolColor),Z.set(20,l.$Sj.symbolFile),Z.set(21,l.$Sj.symbolReference),Z.set(22,l.$Sj.symbolCustomColor),Z.set(23,l.$Sj.symbolFolder),Z.set(24,l.$Sj.symbolTypeParameter),Z.set(25,l.$Sj.account),Z.set(26,l.$Sj.issues);function X(ne){let ge=Z.get(ne);return ge||(console.info("No codicon found for CompletionItemKind "+ne),ge=l.$Sj.symbolProperty),ge}W.toIcon=X;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function x(ne,ge){let ue=Y.get(ne);return typeof ue>"u"&&!ge&&(ue=9),ue}W.fromString=x})(m||(e.CompletionItemKinds=m={}));var y;(function(W){W[W.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var w;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(w||(e.CompletionItemInsertTextRule=w={}));var d;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(d||(e.PartialAcceptTriggerKind=d={}));var g;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var a;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(a||(e.InlineCompletionTriggerKind=a={}));class i{constructor(Z,X,Y,x){this.range=Z,this.text=X,this.completionKind=Y,this.isSnippetText=x}equals(Z){return A.$pt.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}e.$6t=i;var n;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var u;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(u||(e.DocumentPasteTriggerKind=u={}));var o;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function h(W){return W&&M.URI.isUri(W.uri)&&A.$pt.isIRange(W.range)&&(A.$pt.isIRange(W.originSelectionRange)||A.$pt.isIRange(W.targetSelectionRange))}var s;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.$8t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function c(W,Z){return(0,b.localize)(26,null,W,e.$8t[Z])}var r;(function(W){W[W.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var v;(function(W){const Z=new Map;Z.set(0,l.$Sj.symbolFile),Z.set(1,l.$Sj.symbolModule),Z.set(2,l.$Sj.symbolNamespace),Z.set(3,l.$Sj.symbolPackage),Z.set(4,l.$Sj.symbolClass),Z.set(5,l.$Sj.symbolMethod),Z.set(6,l.$Sj.symbolProperty),Z.set(7,l.$Sj.symbolField),Z.set(8,l.$Sj.symbolConstructor),Z.set(9,l.$Sj.symbolEnum),Z.set(10,l.$Sj.symbolInterface),Z.set(11,l.$Sj.symbolFunction),Z.set(12,l.$Sj.symbolVariable),Z.set(13,l.$Sj.symbolConstant),Z.set(14,l.$Sj.symbolString),Z.set(15,l.$Sj.symbolNumber),Z.set(16,l.$Sj.symbolBoolean),Z.set(17,l.$Sj.symbolArray),Z.set(18,l.$Sj.symbolObject),Z.set(19,l.$Sj.symbolKey),Z.set(20,l.$Sj.symbolNull),Z.set(21,l.$Sj.symbolEnumMember),Z.set(22,l.$Sj.symbolStruct),Z.set(23,l.$Sj.symbolEvent),Z.set(24,l.$Sj.symbolOperator),Z.set(25,l.$Sj.symbolTypeParameter);function X(Y){let x=Z.get(Y);return x||(console.info("No codicon found for SymbolKind "+Y),x=l.$Sj.symbolProperty),x}W.toIcon=X})(v||(e.SymbolKinds=v={}));class f{static asEditOperation(Z){return L.$qt.replace(A.$pt.lift(Z.range),Z.text)}}e.$0t=f;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(Z){switch(Z){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(Z)}constructor(Z){this.value=Z}}e.$$t=D;var p;(function(W){W[W.AIGenerated=1]="AIGenerated"})(p||(e.NewSymbolNameTag=p={}));var E;(function(W){function Z(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}W.is=Z})(E||(e.Command=E={}));var k;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var T;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(T||(e.CommentMode=T={}));var j;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(j||(e.CommentState=j={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$_t=O,e.$au=new R.$Rt;var F;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(F||(e.ExternalUriOpenerPriority=F={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Se([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Se([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Se([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Se([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Se([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Se([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Se([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Se([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Se([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Se([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Se([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Se([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Se([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[232],Se([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[233],Se([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[234],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[235],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[236],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[237],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[238],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[239],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[240],Se([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[241],Se([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[242],Se([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[243],Se([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[244],Se([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[245],Se([1,0,13,205]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...S){switch(S.length){case 1:return(0,M.localize)(0,null,S[0]);case 2:return(0,M.localize)(1,null,S[0],S[1]);case 3:return(0,M.localize)(2,null,S[0],S[1],S[2]);default:return}}const R=(0,M.localize)(3,null),b=(0,M.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const C=this.d,m=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:N}),this.f.push(y)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,C=!1,m=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(b);return}const w=this.c.charCodeAt(N);if(C)C=!1;else if(w===47&&!m){N++;break}else w===91?m=!0:w===92?C=!0:w===93&&(m=!1);N++}for(;N<this.c.length&&$.a.has(this.c.charCodeAt(N));)N++;this.e=N;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$oj=$}),define(ke[246],Se([1,0,23,41,208,395]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=$,e.$Ep=S,e.$Fp=N,e.$Gp=C,e.$Hp=m,e.$Ip=y,e.$Jp=w;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||R.test(a)}function S(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function N(a){if(!a)return null;const i=a.majorBase,n=a.majorMustEqual,u=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let h=a.patchMustEqual;a.hasCaret&&(i===0||(o=!1),h=!1);let s=0;if(a.preRelease){const c=b.exec(a.preRelease);if(c){const[,r,v,f]=c;s=Date.UTC(Number(r),Number(v)-1,Number(f))}}return{majorBase:i,majorMustEqual:n,minorBase:u,minorMustEqual:o,patchBase:t,patchMustEqual:h,isMinimum:a.hasGreaterEquals,notBefore:s}}function C(a,i,n){let u;typeof a=="string"?u=N(S(a)):u=a;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof n=="string"?t=N(S(n)):t=n,!u||!t)return!1;const h=u.majorBase,s=u.minorBase,c=u.patchBase;let r=t.majorBase,v=t.minorBase,f=t.patchBase;const D=t.notBefore;let p=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?h>r?!0:h<r?!1:s>v?!0:s<v||o&&o<D?!1:c>=f:(h===1&&r===0&&(!p||!E||!k)&&(r=1,v=0,f=0,p=!0,E=!1,k=!1),h<r?!1:h>r?!p:s<v?!1:s>v?!E:c<f?!1:c>f?!k:!(o&&o<D))}function m(a,i,n,u,o){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([M.default.Error,L.localize(0,null)]),t;if(typeof u.name!="string")return t.push([M.default.Error,L.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([M.default.Error,L.localize(2,null,"version")]),t;if(!u.engines)return t.push([M.default.Error,L.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([M.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!g(u.extensionDependencies))return t.push([M.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!g(u.activationEvents))return t.push([M.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([M.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([M.default.Warning,L.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([M.default.Error,L.localize(9,null,"main")]),t;{const c=(0,l.$7g)(n,u.main);(0,l.$1g)(c,n)||t.push([M.default.Warning,L.localize(10,null,c.path,n.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([M.default.Error,L.localize(11,null,"browser")]),t;{const c=(0,l.$7g)(n,u.browser);(0,l.$1g)(c,n)||t.push([M.default.Warning,L.localize(12,null,c.path,n.path)])}}if(!A.valid(u.version))return t.push([M.default.Error,L.localize(13,null)]),t;const h=[];if(!y(a,i,u,o,h))for(const c of h)t.push([M.default.Error,c]);return t}function y(a,i,n,u,o){return u||typeof n.main>"u"&&typeof n.browser>"u"?!0:d(a,i,n.engines.vscode,o)}function w(a,i,n){return a==="*"||d(i,n,a)}function d(a,i,n,u=[]){const o=N(S(n));if(!o)return u.push(L.localize(14,null,n)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return u.push(L.localize(15,null,n)),!1}else if(!o.majorMustEqual)return u.push(L.localize(16,null,n)),!1;return C(a,i,o)?!0:(u.push(L.localize(17,null,a,n)),!1)}function g(a){if(!Array.isArray(a))return!1;for(let i=0,n=a.length;i<n;i++)if(typeof a[i]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=void 0;class l{constructor(L,A=[],R=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$qi=l}),define(ke[84],Se([1,0,106]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ts=A,e.$us=R;const M=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(b,$,S){$ instanceof l.$qi||($=new l.$qi($,[],!!S)),M.push([b,$])}function R(){return M}}),define(ke[247],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;class l{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$0q=l;class M{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const b=this.lookupOrInsertNode(A),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let b=this.a.get(R);return b||(b=new l(R,A),this.a.set(R,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,b]of this.a)A.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const b=new Set([A]),$=this.c(R,b);if($)return $}}c(A,R){for(const[b,$]of A.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const S=this.c($,R);if(S)return S;R.delete(b)}}}e.$$q=M}),define(ke[5],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e._util=void 0,e.$ti=L,e.$ui=A;var l;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(l||(e._util=l={})),e.$si=L("instantiationService");function M(R,b,$){b[l.DI_TARGET]===b?b[l.DI_DEPENDENCIES].push({id:R,index:$}):(b[l.DI_DEPENDENCIES]=[{id:R,index:$}],b[l.DI_TARGET]=b)}function L(R){if(l.serviceIds.has(R))return l.serviceIds.get(R);const b=function($,S,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(b,$,N)};return b.toString=()=>R,l.serviceIds.set(R,b),b}function A(R){return R}}),define(ke[54],Se([1,0,18,2,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Zi=void 0,e.$1i=A,e.$2i=R,e.$3i=$,e.$4i=S,e.$5i=N,e.$6i=C,e.$7i=m,e.$8i=w,e.$9i=d,e.$0i=g,e.$Zi=(0,L.$ti)("configurationService");function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function N(a,i){const n=Object.create(null);for(const u in a)C(n,u,a[u],i);return n}function C(a,i,n,u){const o=i.split("."),t=o.pop();let h=a;for(let s=0;s<o.length;s++){const c=o[s];let r=h[c];switch(typeof r){case"undefined":r=h[c]=Object.create(null);break;case"object":if(r===null){u(`Ignoring ${i} as ${o.slice(0,s+1).join(".")} is null`);return}break;default:u(`Ignoring ${i} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}h=r}if(typeof h=="object"&&h!==null)try{h[t]=n}catch{u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}else u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}function m(a,i){const n=i.split(".");y(a,n)}function y(a,i){const n=i.shift();if(i.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const u=a[n];typeof u=="object"&&!Array.isArray(u)&&(y(u,i),Object.keys(u).length===0&&delete a[n])}}function w(a,i,n){function u(h,s){let c=h;for(const r of s){if(typeof c!="object"||c===null)return;c=c[r]}return c}const o=i.split("."),t=u(a,o);return typeof t>"u"?n:t}function d(a,i,n){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in a?l.$8f(a[u])&&l.$8f(i[u])?d(a[u],i[u],n):n&&(a[u]=i[u]):a[u]=i[u])})}function g(a){return a.replace(/[\[\]]/g,"")}}),define(ke[37],Se([1,0,11,14,245,5,204,13]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$rj=e.$qj=e.ContextKeyExprType=void 0,e.$pj=S,e.$sj=h,e.$tj=s,e.$Mj=ge;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",l.$j),$.set("isLinux",l.$k),$.set("isWindows",l.$i),$.set("isWeb",l.$o),$.set("isMacNative",l.$j&&!l.$o),$.set("isEdge",l.$H),$.set("isFirefox",l.$F),$.set("isChrome",l.$E),$.set("isSafari",l.$G);function S(te,U){if($.get(te)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(te,U)}const N=Object.prototype.hasOwnProperty;var C;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),w=(0,R.localize)(1,null),d=(0,R.localize)(2,null),g=(0,R.localize)(3,null),a=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),u=(0,R.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new L.$oj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),Pe=pe.type===17?i:void 0;throw this.h.push({message:a,offset:pe.offset,lexeme:L.$oj.getLexeme(pe),additionalInfo:Pe}),o.c}return _}catch(_){if(_!==o.c)throw _;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const _=this.o();U.push(_)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const _=this.s();U.push(_)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,g),_?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,g),_}case 17:{const _=U.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const se=Pe.lexeme,re=se.lastIndexOf("/"),oe=re===se.length-1?void 0:this.w(se.substring(re+1));let K;try{K=new RegExp(se.substring(1,re),oe)}catch{throw this.B("REGEX",Pe)}return F.create(_,K)}switch(Pe.type){case 10:case 19:{const se=[Pe.lexeme];this.z();let re=this.D(),oe=0;for(let Ne=0;Ne<Pe.lexeme.length;Ne++)Pe.lexeme.charCodeAt(Ne)===40?oe++:Pe.lexeme.charCodeAt(Ne)===41&&oe--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Ne=0;Ne<re.lexeme.length;Ne++)re.lexeme.charCodeAt(Ne)===40?oe++:Pe.lexeme.charCodeAt(Ne)===41&&oe--}if(oe<0)break;se.push(L.$oj.getLexeme(re)),this.z(),re=this.D()}const K=se.join(""),ie=K.lastIndexOf("/"),$e=ie===K.length-1?void 0:this.w(K.substring(ie+1));let we;try{we=new RegExp(K.substring(1,ie),$e)}catch{throw this.B("REGEX",Pe)}return t.regex(_,we)}case 18:{const se=Pe.lexeme;this.z();let re=null;if(!(0,M.$5e)(se)){const oe=se.indexOf("/"),K=se.lastIndexOf("/");if(oe!==K&&oe>=0){const ie=se.slice(oe+1,K),$e=se[K+1]==="i"?"i":"";try{re=new RegExp(ie,$e)}catch{throw this.B("REGEX",Pe)}}}if(re===null)throw this.B("REGEX",Pe);return F.create(_,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const Pe=this.u();return t.notIn(_,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(_,Pe);switch(Pe){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(_,Pe);switch(Pe){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Pe)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),O.create(_,this.u());case 7:return this.z(),T.create(_,this.u());case 8:return this.z(),j.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:u}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,_){if(this.C(U))return this.z();throw this.B(_,this.D())}B(U,_,pe){const Pe=(0,R.localize)(8,null,U,L.$oj.getLexeme(_)),se=_.offset,re=L.$oj.getLexeme(_);return this.h.push({message:Pe,offset:se,lexeme:re,additionalInfo:pe}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qj=o;class t{static false(){return r.INSTANCE}static true(){return v.INSTANCE}static has(U){return f.create(U)}static equals(U,_){return D.create(U,_)}static notEquals(U,_){return k.create(U,_)}static regex(U,_){return F.create(U,_)}static in(U,_){return p.create(U,_)}static notIn(U,_){return E.create(U,_)}static not(U){return P.create(U)}static and(...U){return Z.create(U,null,!0)}static or(...U){return X.create(U,null,!0)}static greater(U,_){return T.create(U,_)}static greaterEquals(U,_){return j.create(U,_)}static smaller(U,_){return z.create(U,_)}static smallerEquals(U,_){return O.create(U,_)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$rj=t;function h(te){const U=new o({regexParsingWithErrorRecovery:!1});return te.map(_=>(U.parse(_),U.lexingErrors.length>0?U.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,R.localize)(9,null,pe.additionalInfo):(0,R.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function s(te,U){const _=te?te.substituteConstants():void 0,pe=U?U.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}function c(te,U){return te.cmp(U)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$uj=r;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return r.INSTANCE}}e.$vj=v;class f{static create(U,_=null){const pe=$.get(U);return typeof pe=="boolean"?pe?v.INSTANCE:r.INSTANCE:new f(U,_)}constructor(U,_){this.key=U,this.c=_,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?v.INSTANCE:r.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$wj=f;class D{static create(U,_,pe=null){if(typeof _=="boolean")return _?f.create(U,pe):P.create(U,pe);const Pe=$.get(U);return typeof Pe=="boolean"?_===(Pe?"true":"false")?v.INSTANCE:r.INSTANCE:new D(U,_,pe)}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const _=U?"true":"false";return this.d===_?v.INSTANCE:r.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$xj=D;class p{static create(U,_){return new p(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const _=U.getValue(this.f),pe=U.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?N.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$yj=p;class E{static create(U,_){return new E(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=11,this.c=p.create(U,_)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zj=E;class k{static create(U,_,pe=null){if(typeof _=="boolean")return _?P.create(U,pe):f.create(U,pe);const Pe=$.get(U);return typeof Pe=="boolean"?_===(Pe?"true":"false")?r.INSTANCE:v.INSTANCE:new k(U,_,pe)}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const _=U?"true":"false";return this.d===_?r.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Aj=k;class P{static create(U,_=null){const pe=$.get(U);return typeof pe=="boolean"?pe?r.INSTANCE:v.INSTANCE:new P(U,_)}constructor(U,_){this.c=U,this.d=_,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?r.INSTANCE:v.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Bj=P;function I(te,U){if(typeof te=="string"){const _=parseFloat(te);isNaN(_)||(te=_)}return typeof te=="string"||typeof te=="number"?U(te):r.INSTANCE}class T{static create(U,_,pe=null){return I(_,Pe=>new T(U,Pe,pe))}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Cj=T;class j{static create(U,_,pe=null){return I(_,Pe=>new j(U,Pe,pe))}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Dj=j;class z{static create(U,_,pe=null){return I(_,Pe=>new z(U,Pe,pe))}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ej=z;class O{static create(U,_,pe=null){return I(_,Pe=>new O(U,Pe,pe))}constructor(U,_,pe){this.c=U,this.d=_,this.f=pe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Fj=O;class F{static create(U,_){return new F(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const _=this.f?this.f.source:"",pe=U.f?U.f.source:"";return _<pe?-1:_>pe?1:0}equals(U){if(U.type===this.type){const _=this.f?this.f.source:"",pe=U.f?U.f.source:"";return this.d===U.d&&_===pe}return!1}substituteConstants(){return this}evaluate(U){const _=U.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Gj=F;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Hj=B;function W(te){let U=null;for(let _=0,pe=te.length;_<pe;_++){const Pe=te[_].substituteConstants();if(te[_]!==Pe&&U===null){U=[];for(let se=0;se<_;se++)U[se]=te[se]}U!==null&&(U[_]=Pe)}return U===null?te:U}class Z{static create(U,_,pe){return Z.d(U,_,pe)}constructor(U,_){this.expr=U,this.c=_,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const Pe=c(this.expr[_],U.expr[_]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(U.expr[_]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(U))return!1;return!0}static d(U,_,pe){const Pe=[];let se=!1;for(const re of U)if(re){if(re.type===1){se=!0;continue}if(re.type===0)return r.INSTANCE;if(re.type===6){Pe.push(...re.expr);continue}Pe.push(re)}if(Pe.length===0&&se)return v.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(c);for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const re=Pe[Pe.length-1];if(re.type!==9)break;Pe.pop();const oe=Pe.pop(),K=Pe.length===0,ie=X.create(re.expr.map($e=>Z.create([$e,oe],null,pe)),null,K);ie&&(Pe.push(ie),Pe.sort(c))}if(Pe.length===1)return Pe[0];if(pe){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return r.INSTANCE;if(Pe.length===1)return Pe[0]}return new Z(Pe,_)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const _ of this.expr)U.push(..._.keys());return U}map(U){return new Z(this.expr.map(_=>_.map(U)),null)}negate(){if(!this.c){const U=[];for(const _ of this.expr)U.push(_.negate());this.c=X.create(U,this,!0)}return this.c}}e.$Ij=Z;class X{static create(U,_,pe){return X.d(U,_,pe)}constructor(U,_){this.expr=U,this.c=_,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const Pe=c(this.expr[_],U.expr[_]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(U.expr[_]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(U))return!0;return!1}static d(U,_,pe){let Pe=[],se=!1;if(U){for(let re=0,oe=U.length;re<oe;re++){const K=U[re];if(K){if(K.type===0){se=!0;continue}if(K.type===1)return v.INSTANCE;if(K.type===9){Pe=Pe.concat(K.expr);continue}Pe.push(K)}}if(Pe.length===0&&se)return r.INSTANCE;Pe.sort(c)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];if(pe){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return v.INSTANCE;if(Pe.length===1)return Pe[0]}return new X(Pe,_)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const _ of this.expr)U.push(..._.keys());return U}map(U){return new X(this.expr.map(_=>_.map(U)),null)}negate(){if(!this.c){const U=[];for(const _ of this.expr)U.push(_.negate());for(;U.length>1;){const _=U.shift(),pe=U.shift(),Pe=[];for(const se of ve(_))for(const re of ve(pe))Pe.push(Z.create([se,re],null,!1));U.unshift(X.create(Pe,null,!1))}this.c=X.create(U,this,!0)}return this.c}}e.$Jj=X;class Y extends f{static{this.d=[]}static all(){return Y.d.values()}constructor(U,_,pe){super(U,null),this.f=_,typeof pe=="object"?Y.d.push({...pe,key:U}):pe!==!0&&Y.d.push({key:U,description:pe,type:_!=null?typeof _:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$Kj=Y,e.$Lj=(0,A.$ti)("contextKeyService");function x(te,U){return te<U?-1:te>U?1:0}function ne(te,U,_,pe){return te<_?-1:te>_?1:U<pe?-1:U>pe?1:0}function ge(te,U){if(te.type===0||U.type===1)return!0;if(te.type===9)return U.type===9?ue(te.expr,U.expr):!1;if(U.type===9){for(const _ of U.expr)if(ge(te,_))return!0;return!1}if(te.type===6){if(U.type===6)return ue(U.expr,te.expr);for(const _ of te.expr)if(ge(_,U))return!0;return!1}return te.equals(U)}function ue(te,U){let _=0,pe=0;for(;_<te.length&&pe<U.length;){const Pe=te[_].cmp(U[pe]);if(Pe<0)return!1;Pe===0&&_++,pe++}return _===te.length}function ve(te){return te.type===9?te.expr:[te]}}),define(ke[248],Se([1,0,23,41,206,5,103,11,24]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Ew=e.$Dw=e.$Cw=void 0,e.$Fw=y,e.$Gw=w,e.$Cw=(0,A.$ti)("dialogService");var S;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(S||(S={}));class N{a(g){return this.d(g,S.Confirmation)}b(g){return this.d(g,S.Prompt)}c(g){return this.d(g,S.Input)}d(g,a){const i=[];switch(a){case S.Confirmation:{const n=g;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(1,null));break}case S.Prompt:{const n=g;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(u=>u.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,L.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,L.localize)(3,null))),i.length===0&&i.push((0,L.localize)(4,null));break}case S.Input:{const n=g;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(6,null));break}}return i}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===M.default.Info?"info":g===M.default.Error?"error":g===M.default.Warning?"warning":"none"}f(g,a,i){const n=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&n.push(g.cancelButton);let u=n[a]?.run({checkboxChecked:i});return u instanceof Promise||(u=Promise.resolve(u)),{result:u,checkboxChecked:i}}}e.$Dw=N,e.$Ew=(0,A.$ti)("fileDialogService");var C;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function y(d){const g=[];return g.push(...d.slice(0,m).map(a=>typeof a=="string"?a:(0,l.$4g)(a))),d.length>m&&(d.length-m===1?g.push((0,L.localize)(7,null)):g.push((0,L.localize)(8,null,d.length-m))),g.push(""),g.join(`
`)}function w(d,g){const a=(0,$.$Zn)(d);let i=(a.buttons??[]).map(t=>(0,R.$zw)(t)),n=(d.buttons||[]).map((t,h)=>h),u=0,o=a.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const h=n[o];n.splice(o,1),n.splice(1,0,h),o=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),u=i.length-1,typeof t=="string"&&(o=u-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const h=n[o];n.splice(o,1),n.push(h),o=i.length-1}}return a.buttons=i,a.defaultId=u,a.cancelId=o,a.noLink=!0,a.title=a.title||g.nameLong,{options:a,buttonIndeces:n}}}),define(ke[136],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=void 0,e.$Ai=(0,l.$ti)("environmentService"),e.$Bi=(0,l.$ui)(e.$Ai)}),define(ke[137],Se([1,0,207,5]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.ExtensionGalleryErrorCode=e.$4o=e.ExtensionManagementErrorCode=e.$3o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Wo=L,e.$Xo=A,e.$Yo=R,e.$Zo=b,e.$1o=$,e.$2o=S,e.$Qo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ro=new RegExp(e.$Qo),e.$So="__web_extension",e.$To="skipWalkthrough",e.$Uo="extensionsSync",e.$Vo="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,n){return n==="web"&&!i.includes("web")}function $(i,n,u){return b(n,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var N;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(i){i.Install="install",i.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var y;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$3o=(0,M.$ti)("extensionGalleryService");var w;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));class d extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$4o=d;var g;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class a extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$5o=a,e.$6o=(0,M.$ti)("extensionManagementService"),e.$7o="extensionsIdentifiers/disabled",e.$8o="extensionsIdentifiers/enabled",e.$9o=(0,M.$ti)("IGlobalExtensionEnablementService"),e.$0o=(0,M.$ti)("IExtensionTipsService"),e.$$o=(0,l.localize2)(0,"Extensions"),e.$_o=(0,l.localize2)(1,"Preferences")}),define(ke[249],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=void 0,e.$P6b=(0,l.$ti)("externalTerminal"),e.$Q6b="Terminal.app"}),define(ke[250],Se([1,0,53,55,15,17,11,102,32,105,209,249]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=void 0;const m=N.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends y{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(l,o,S.$lm(),t)}spawnTerminal(o,t,h,s){const c=t.windowsExec||w.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const r=A.$oc(c,".exe").toLowerCase();if(r==="cmder")return o.spawn(c,s?[s]:void 0),Promise.resolve(void 0);const v=["/c","start","/wait"];return c.indexOf(" ")>=0&&v.push('""'),v.push(c),r==="wt"&&v.push("-d ."),new Promise((f,D)=>{const p=a(process),E=o.spawn(h,v,{cwd:s,env:p,detached:!0});E.on("error",D),E.on("exit",()=>f())})}async runInTerminal(o,t,h,s,c){const r="windowsExec"in c&&c.windowsExec?c.windowsExec:w.getDefaultTerminalWindows(),v=await w.f();return new Promise((f,D)=>{const p=`"${t} - ${m}"`,E=`"${h.join('" "')}" & pause`,k=Object.assign({},a(process),s);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const P={cwd:t,env:k,windowsVerbatimArguments:!0};let I,T;A.$oc(r,".exe")==="wt"?(I=r,T=["-d",".",w.b,"/c",E]):v?(I=v,T=["-d",".",r,"/c",E]):(I=w.b,T=["/c","start",p,"/wait",r,"/c",`"${E}"`]),l.spawn(I,T,P).on("error",z=>{D(i(z))}),f(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const o=await S.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$Xbc=w,Je([M.$Xh],w,"f",null);class d extends y{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(l,o,t)}runInTerminal(o,t,h,s,c){const r=c.osxExec||C.$Q6b;return new Promise((v,f)=>{if(r===C.$Q6b||r==="iTerm.app"){const D=r===C.$Q6b?"TerminalHelper":"iTermHelper",E=[L.$Ng.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||m,"-w",t];for(const I of h)E.push("-a"),E.push(I);if(s){const I=Object.assign({},a(process),s);for(const T in I){const j=I[T];j===null?(E.push("-u"),E.push(T)):(E.push("-e"),E.push(`${T}=${j}`))}}let k="";const P=l.spawn(d.b,E);P.on("error",I=>{f(i(I))}),P.stderr.on("data",I=>{k+=I.toString()}),P.on("exit",I=>{if(I===0)v(void 0);else if(k){const T=k.split(`
`,1);f(new Error(T[0]))}else f(new Error(N.localize(1,null,D,I)))})}else f(new Error(N.localize(2,null,r)))})}spawnTerminal(o,t,h){const s=t.osxExec||C.$Q6b;return new Promise((c,r)=>{const v=["-a",s];h&&v.push(h);const f=a(process),D=o.spawn("/usr/bin/open",v,{cwd:h,env:f});D.on("error",r),D.on("exit",()=>c())})}}e.$Ybc=d;class g extends y{static{this.b=N.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(l,o,t)}runInTerminal(o,t,h,s,c){const r=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((v,f)=>{const D=[];r.then(p=>{p.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const E=`${n(h)}; echo; read -p "${g.b}" -n1;`;D.push(`''${E}''`);const k=Object.assign({},a(process),s);Object.keys(k).filter(j=>k[j]===null).forEach(j=>delete k[j]);const P={cwd:t,env:k};let I="";const T=l.spawn(p,D,P);T.on("error",j=>{f(i(j))}),T.stderr.on("data",j=>{I+=j.toString()}),T.on("exit",j=>{if(j===0)v(void 0);else if(I){const z=I.split(`
`,1);f(new Error(z[0]))}else f(new Error(N.localize(4,null,p,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!R.$k)g.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(o,t,h){const s=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,r)=>{s.then(v=>{const f=a(process),D=o.spawn(v,[],{cwd:h,env:f});D.on("error",r),D.on("exit",()=>c())})})}}e.$Zbc=g;function a(u){const o={...u.env};return(0,b.$jm)(o),o}function i(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(N.localize(5,null,u.path)):u}function n(u){let o="";for(const t of u)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[33],Se([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$sl=e.FileKind=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.FileOperationResult=e.$kl=e.$jl=e.$il=e.$gl=e.FileChangeType=e.$fl=e.FileOperation=e.$_k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Zk=void 0,e.$1k=m,e.$2k=g,e.$3k=i,e.$4k=n,e.$5k=u,e.$6k=o,e.$7k=t,e.$8k=h,e.$9k=s,e.$0k=c,e.$$k=r,e.$al=D,e.$bl=p,e.$cl=E,e.$dl=k,e.$el=P,e.$hl=O,e.$tl=Y,e.$ul=x,e.$wl=ge,e.$Zk=(0,$.$ti)("fileService");function m(ue){return ue.create===!0}var y;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var w;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var d;(function(ue){ue[ue.UPDATED=2]="UPDATED",ue[ue.ADDED=4]="ADDED",ue[ue.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function g(ue){const ve=ue;return!!ve&&typeof ve.onDidChange=="function"}var a;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function i(ue){return!!(ue.capabilities&2)}function n(ue){return!!(ue.capabilities&8)}function u(ue){return!!(ue.capabilities&131072)}function o(ue){return!!(ue.capabilities&4)}function t(ue){return!!(ue.capabilities&16)}function h(ue){return i(ue)?!!(ue.capabilities&16384):!1}function s(ue){return i(ue)?!!(ue.capabilities&32768):!1}function c(ue){return!!(ue.capabilities&65536)}function r(ue){return!!(ue.capabilities&2048)}var v;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(ve,te){const U=new f(ve.toString(),te);return E(U,te),U}constructor(ve,te){super(ve),this.code=te}}e.$_k=f;function D(ue,ve){return f.create(ue,ve)}function p(ue){return ue||D((0,b.localize)(0,null),v.Unknown)}function E(ue,ve){return ue.name=ve?`${ve} (FileSystemError)`:"FileSystemError",ue}function k(ue){if(!ue)return v.Unknown;if(ue instanceof f)return ue.code;const ve=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ve)return v.Unknown;switch(ve[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function P(ue){if(ue instanceof F)return ue.fileOperationResult;switch(k(ue)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var I;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class T{constructor(ve,te,U){this.resource=ve,this.operation=te,this.target=U}isOperation(ve){return this.operation===ve}}e.$fl=T;var j;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{static{this.a=null}constructor(ve,te){this.c=te,this.b=void 0,this.d=new C.$V(()=>{const U=l.$zi.forUris(()=>this.c);return U.fill(this.rawAdded.map(_=>[_,!0])),U}),this.f=new C.$V(()=>{const U=l.$zi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(_=>[_,!0])),U}),this.g=new C.$V(()=>{const U=l.$zi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(_=>[_,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ve){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==z.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ve,...te){return this.h(ve,{includeChildren:!1},...te)}affects(ve,...te){return this.h(ve,{includeChildren:!0},...te)}h(ve,te,...U){if(!ve)return!1;const _=U.length>0;return!!((!_||U.includes(1))&&(this.d.value.get(ve)||te.includeChildren&&this.d.value.findSuperstr(ve))||(!_||U.includes(0))&&(this.f.value.get(ve)||te.includeChildren&&this.f.value.findSuperstr(ve))||(!_||U.includes(2))&&(this.g.value.findSubstr(ve)||te.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$gl=z;function O(ue,ve,te){return!ue||!ve||ue===ve||ve.length>ue.length?!1:(ve.charAt(ve.length-1)!==M.sep&&(ve+=M.sep),te?(0,L.$wf)(ue,ve):ue.indexOf(ve)===0)}class F extends Error{constructor(ve,te,U){super(ve),this.fileOperationResult=te,this.options=U}}e.$il=F;class B extends F{constructor(ve,te,U,_){super(ve,te,_),this.fileOperationResult=te,this.size=U}}e.$jl=B;class W extends F{constructor(ve,te,U){super(ve,2,U),this.stat=te}}e.$kl=W;var Z;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$ll={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ml={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$nl="files.associations",e.$ol="files.exclude",e.$pl="files.readonlyInclude",e.$ql="files.readonlyExclude",e.$rl="files.readonlyFromPermissions";var X;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$sl="";function Y(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}async function x(ue,ve){if(!ve.hasProvider(R.URI.from({scheme:ue.scheme})))return new Promise(te=>{const U=ve.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ue.scheme&&_.added&&(U.dispose(),te())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(ve){return(0,A.$0f)(ve)||(ve=0),ve<ne.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<ne.MB?(0,b.localize)(2,null,(ve/ne.KB).toFixed(2)):ve<ne.GB?(0,b.localize)(3,null,(ve/ne.MB).toFixed(2)):ve<ne.TB?(0,b.localize)(4,null,(ve/ne.GB).toFixed(2)):(0,b.localize)(5,null,(ve/ne.TB).toFixed(2))}}e.$vl=ne;function ge(ue){const ve=typeof ue=="string"||ue?.scheme===N.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===N.Schemas.file?1024*ne.MB:ve?10*ne.MB:S.$o?50*ne.MB:1024*ne.MB}}),define(ke[251],Se([1,0,21,13,211,33]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=R;async function R(N,C,m,y,w,d){let g;try{await b(N,C,m,y,w,d)}catch(a){g=a}finally{g&&w.errorTransformer&&(g=w.errorTransformer(g)),typeof g<"u"&&m.error(g),m.end()}}async function b(N,C,m,y,w,d){$(d);const g=await N.open(C,{create:!1});try{$(d);let a=0,i=0,n=w&&typeof w.length=="number"?w.length:void 0,u=l.$De.alloc(Math.min(w.bufferSize,typeof n=="number"?n:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,t=0;do i=await N.read(g,o,u.buffer,t,u.byteLength-t),o+=i,t+=i,a+=i,typeof n=="number"&&(n-=i),t===u.byteLength&&(await m.write(y(u)),u=l.$De.alloc(Math.min(w.bufferSize,typeof n=="number"?n:w.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(d)&&S(a,w));if(t>0){let h=t;typeof n=="number"&&(h=Math.min(t,n)),m.write(y(u.slice(0,h)))}}catch(a){throw(0,A.$bl)(a)}finally{await N.close(g)}}function $(N){if(N.isCancellationRequested)throw(0,M.$6)();return!0}function S(N,C){if(typeof C?.limits?.size=="number"&&N>C.limits.size)throw(0,A.$al)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Se([1,0,35,3,17,11,2,33]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=void 0,e.$Gq=$,e.$Hq=S,e.$Lq=y,e.$Mq=w,e.$Nq=d,e.$Oq=g,e.$Pq=i,e.$Qq=n;function $(u){return typeof u.correlationId=="number"}function S(u){return u.recursive===!0}class N extends M.$Vc{static{this.a=5}constructor(o,t,h,s){super(),this.h=o,this.j=t,this.m=h,this.n=s,this.c=this.B(new M.$Wc),this.f=void 0,this.g=0}s(){const o=new M.$Uc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(t=>this.h(t))),o.add(this.b.onDidLogMessage(t=>this.j(t))),o.add(this.b.onDidError(t=>this.t(t)))}t(o){this.n.restartOnError?this.g<N.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Iq=N;class C extends N{constructor(o,t,h){super(o,t,h,{type:"node.js",restartOnError:!1})}}e.$Jq=C;class m extends N{constructor(o,t,h){super(o,t,h,{type:"universal",restartOnError:!0})}}e.$Kq=m;function y(u){return u.map(o=>({type:o.type,resource:R.URI.revive(o.resource),cId:o.cId}))}function w(u){const o=new a;for(const t of u)o.processEvent(t);return o.coalesce()}function d(u,o){return typeof o=="string"&&!o.startsWith(l.$jk)&&!(0,L.$jc)(o)?{base:u,pattern:o}:o}function g(u,o){const t=[];for(const h of o)t.push((0,l.$nk)(d(u,h)));return t}class a{constructor(){this.a=new Set,this.b=new Map}c(o){return A.$k?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let h=!1;if(t){const s=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?h=!0:s===1&&c===2?(this.b.delete(this.c(o)),this.a.delete(t)):s===2&&c===1?t.type=0:s===1&&c===0||(t.type=c)}else h=!0;h&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(h=>h.type!==2?(o.push(h),!1):!0).sort((h,s)=>h.resource.fsPath.length-s.resource.fsPath.length).filter(h=>t.some(s=>(0,b.$hl)(h.resource.fsPath,s,!A.$k))?!1:(t.push(h.resource.fsPath),!0)).concat(o)}}function i(u,o){if(typeof o=="number")switch(u.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function n(u){if(typeof u=="number"){const o=[];return u&4&&o.push("Added"),u&8&&o.push("Deleted"),u&2&&o.push("Updated"),o.length===0?"<all>":o.join(", ")}return"<none>"}}),define(ke[252],Se([1,0,52,3,65,4,2,8]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class $ extends M.$Vc{constructor(){super(),this.a=this.B(new A.$ce),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$ce),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$ce),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new M.$5c),this.m=new Set,this.n=5007,this.r=new b.$Qh,this.P=!1,this.B(this.f(N=>this.s(N)))}s(N){this.t(N)&&this.w(N)}t(N){return(0,L.$Gq)(N)}async watch(N){this.r.isSettled||this.r.complete(),this.r=new b.$Qh;try{this.h.clear(),this.g.clear();for(const C of N)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(N=>!this.j.has(N.correlationId))])}isSuspended(N){return typeof N.correlationId!="number"?!1:this.m.has(N.correlationId)?"polling":this.j.has(N.correlationId)}async w(N){if(this.j.has(N.correlationId))return;const C=new M.$Uc;this.j.set(N.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(N,C),this.u())}y(N){this.j.deleteAndDispose(N.correlationId),this.m.delete(N.correlationId),this.u()}z(N,C){this.C(N,C)?(this.N(`reusing an existing recursive watcher to monitor ${N.path}`),this.m.delete(N.correlationId)):(this.D(N,C),this.m.add(N.correlationId))}C(N,C){const m=this.M?.subscribe(N.path,(y,w)=>{C.isDisposed||(y?this.z(N,C):w?.type===1&&this.F(N))});return m?(C.add(m),!0):!1}D(N,C){let m=!1;const y=(w,d)=>{if(C.isDisposed)return;const g=this.G(w),a=this.G(d),i=m;m=g,!g&&(a||i)&&this.F(N)};this.N(`starting fs.watchFile() on ${N.path} (correlationId: ${N.correlationId})`);try{(0,l.watchFile)(N.path,{persistent:!1,interval:this.n},y)}catch(w){this.O(`fs.watchFile() failed with error ${w} on path ${N.path} (correlationId: ${N.correlationId})`)}C.add((0,M.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${N.path} (correlationId: ${N.correlationId})`);try{(0,l.unwatchFile)(N.path,y)}catch(w){this.O(`fs.unwatchFile() failed with error ${w} on path ${N.path} (correlationId: ${N.correlationId})`)}}))}F(N){this.N(`detected ${N.path} exists again, resuming watcher (correlationId: ${N.correlationId})`);const C={resource:R.URI.file(N.path),type:1,cId:N.correlationId};this.a.fire([C]),this.H(C,N),this.y(N)}G(N){return N.ctimeMs===0&&N.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(N,C){if(this.P){const m=` >> normalized ${N.type===1?"[ADDED]":N.type===2?"[DELETED]":"[CHANGED]"} ${N.resource.fsPath}`;this.I(m,C)}}I(N,C){this.P&&this.N(`${N}${typeof C.correlationId=="number"?` <${C.correlationId}> `:""}`)}J(N){return`${N.path} (excludes: ${N.excludes.length>0?N.excludes:"<none>"}, includes: ${N.includes&&N.includes.length>0?JSON.stringify(N.includes):"<all>"}, filter: ${(0,L.$Qq)(N.filter)}, correlationId: ${typeof N.correlationId=="number"?N.correlationId:"<none>"})`}async setVerboseLogging(N){this.P=N}}e.$Zq=$}),define(ke[253],Se([1,0,52,8,22,31,3,76,17,11,23,2,104,32,65]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0,e.$6q=g;class d extends R.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,n,u,o,t,h){super(),this.s=i,this.t=n,this.u=u,this.w=o,this.y=t,this.z=h,this.c=this.B(new M.$Ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new M.$Hh(s=>this.M(s),d.b)),this.g=(0,w.$Oq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,w.$Oq)(this.s.path,this.s.includes):void 0,this.j=(0,w.$Gq)(this.s)?this.s.filter:void 0,this.m=new L.$ne,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const n=await y.Promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$2q)(i.path,this.m.token)??i.path),i.path!==n&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async G(i,n){const u=new R.$Uc;return this.H(i,n,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,n,u)),u}H(i,n,u){if(n)return!1;const o=C.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(h,s)=>{if(!u.isDisposed)if(h){const c=await this.G(i,n);u.isDisposed?c.dispose():u.add(c)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:s.type,cId:this.s.correlationId},!0)});return t?(u.add(t),!0):!1}async I(i,n,u){if(S.$j&&(0,A.$sg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.$ne(this.m.token);u.add((0,R.$Tc)(()=>o.dispose(!0)));const t=new R.$Uc;u.add(t);try{const h=C.URI.file(this.s.path),s=(0,$.$oc)(i),c=(0,l.watch)(i);t.add((0,R.$Tc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${i}'`);const r=new Set;if(n)try{for(const f of await y.Promises.readdir(i))r.add(f)}catch(f){this.O(f)}if(o.token.isCancellationRequested)return;const v=new Map;t.add((0,R.$Tc)(()=>{for(const[,f]of v)f.dispose();v.clear()})),c.on("error",(f,D)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${f}, ${D})`),this.D())}),c.on("change",(f,D)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${D}`);let p="";if(D&&(p=D.toString(),S.$j&&(p=(0,b.$$l)(p))),!(!p||f!=="change"&&f!=="rename"))if(n)if(f==="rename"){v.get(p)?.dispose();const E=setTimeout(async()=>{if(v.delete(p),p===s&&!await y.Promises.exists(i)){this.J(h);return}if(o.token.isCancellationRequested)return;const k=await this.N((0,$.$kc)(i,p));if(o.token.isCancellationRequested)return;let P;k?r.has(p)?P=0:(P=1,r.add(p)):(r.delete(p),P=2),this.L({resource:(0,N.$7g)(h,p),type:P,cId:this.s.correlationId})},d.a);v.set(p,(0,R.$Tc)(()=>clearTimeout(E)))}else{let E;r.has(p)?E=0:(E=1,r.add(p)),this.L({resource:(0,N.$7g)(h,p),type:E,cId:this.s.correlationId})}else if(f==="rename"||p!==s){const E=setTimeout(async()=>{const k=await y.Promises.exists(i);o.token.isCancellationRequested||(k?(this.L({resource:h,type:0,cId:this.s.correlationId},!0),t.add(await this.G(i,!1))):this.J(h))},d.a);t.clear(),t.add((0,R.$Tc)(()=>clearTimeout(E)))}else this.L({resource:h,type:0,cId:this.s.correlationId},!0)})}catch(h){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${h.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,n=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(u=>u(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(u=>u(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const n=(0,w.$Mq)(i),u=[];for(const t of n){if((0,w.$Pq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}u.push(t)}if(u.length===0)return;if(this.z)for(const t of u)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(S.$k)return y.Promises.exists(i);try{const n=(0,$.$oc)(i);return(await y.Promises.readdir((0,$.$nc)(i))).some(o=>o===n)}catch(n){return this.Q(n),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$5q=d;async function g(a,i,n,u,o=512){const t=await y.Promises.open(a,"r"),h=Buffer.allocUnsafe(o),s=new L.$ne(u);let c,r=!1;const v={path:a,excludes:[],recursive:!1},f=new d(v,void 0,D=>{(async()=>{for(const{type:p}of D)if(p===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:E}=await y.Promises.read(t,h,0,o,null);if(!E||s.token.isCancellationRequested)break;i(h.slice(0,E))}}catch(E){c=new Error(E),s.dispose(!0)}finally{r=!1}}})()});return await f.ready,n(),new Promise((D,p)=>{s.token.onCancellationRequested(async()=>{f.dispose();try{await y.Promises.close(t)}catch(E){c=new Error(E)}c?p(c):D()})})}}),define(ke[254],Se([1,0,4,35,252,11,253,31]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class $ extends L.$Zq{constructor(N){super(),this.M=N,this.onDidError=l.Event.None,this.watchers=new Set}async L(N){N=this.X(N);const C=[],m=new Set(Array.from(this.watchers));for(const y of N){const w=this.S(y);w&&(0,M.$rk)(w.request.excludes,y.excludes)&&(0,M.$rk)(w.request.includes,y.includes)?m.delete(w):C.push(y)}C.length&&this.N(`Request to start watching: ${C.map(y=>this.J(y)).join(",")}`),m.size&&this.N(`Request to stop watching: ${Array.from(m).map(y=>this.J(y.request)).join(",")}`);for(const y of m)this.W(y);for(const y of C)this.U(y)}S(N){for(const C of this.watchers)if(typeof N.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===N.correlationId)return C}else if((0,b.$rg)(C.request.path,N.path,!A.$k))return C}U(N){const C=new R.$5q(N,this.M,y=>this.a.fire(y),()=>this.c.fire(N),y=>this.b.fire(y),this.P),m={request:N,instance:C};this.watchers.add(m)}async stop(){await super.stop();for(const N of this.watchers)this.W(N)}W(N){this.N("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}X(N){const C=new Map;for(const m of N){const y=A.$k?m.path:m.path.toLowerCase();let w=C.get(m.correlationId);w||(w=new Map,C.set(m.correlationId,w)),w.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(m)}`),w.set(y,m)}return Array.from(C.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const C of this.watchers)C.instance.setVerboseLogging(N)}N(N,C){this.P&&this.b.fire({type:"trace",message:this.$(N,C)})}O(N){this.b.fire({type:"warn",message:this.$(N)})}$(N,C){return C?`[File Watcher (node.js)] ${N} (${this.J(C.request)})`:`[File Watcher (node.js)] ${N}`}}e.$7q=$}),define(ke[255],Se([1,0,65,254]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class L extends l.$Jq{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new M.$7q(void 0))}}e.$8q=L}),define(ke[256],Se([1,0,15,81,194,65]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class R extends A.$Kq{constructor($,S,N){super($,S,N),this.s()}r($){const S=$.add(new L.$Xq(l.$Ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(S.onDidProcessExit(({code:N,signal:C})=>this.t(`terminated by itself with code ${N}, signal: ${C} (ETERM)`))),M.ProxyChannel.toService((0,M.$ai)(S.getChannel("watcher")))}}e.$Yq=R}),define(ke[107],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=void 0;class l{constructor(...L){this.a=new Map;for(const[A,R]of L)this.set(A,R)}set(L,A){const R=this.a.get(L);return this.a.set(L,A),R}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ri=l}),define(ke[257],Se([1,0,8,13,3,106,247,5,107,75]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;const N=!1;class C extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class m{constructor(g=new $.$ri,a=!1,i,n=N){this.i=g,this.j=a,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$si,this),this._globalGraph=n?i?._globalGraph??new R.$$q(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const a=new class extends m{dispose(){this.h.delete(a),super.dispose()}}(g,this.j,this,this.l);return this.h.add(a),a}invokeFunction(g,...a){this.m();const i=w.traceInvocation(this.l,g);let n=!1;try{return g({get:o=>{if(n)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{n=!0,i.stop()}}createInstance(g,...a){this.m();let i,n;return g instanceof A.$qi?(i=w.traceCreation(this.l,g.ctor),n=this.o(g.ctor,g.staticArguments.concat(a),i)):(i=w.traceCreation(this.l,g),n=this.o(g,a,i)),i.stop(),n}o(g,a=[],i){const n=b._util.getServiceDependencies(g).sort((t,h)=>t.index-h.index),u=[];for(const t of n){const h=this.s(t.id,i);h||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(h)}const o=n.length>0?n[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${g.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(g,a.concat(u))}q(g,a){if(this.i.get(g)instanceof A.$qi)this.i.set(g,a);else if(this.k)this.k.q(g,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const a=this.i.get(g);return!a&&this.k?this.k.r(g):a}s(g,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const i=this.r(g);return i instanceof A.$qi?this.u(g,i,a.branch(g,!0)):(a.branch(g,!1),i)}u(g,a,i){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,a,i)}finally{this.t.delete(g)}}v(g,a,i){const n=new R.$$q(t=>t.id.toString());let u=0;const o=[{id:g,desc:a,_trace:i}];for(;o.length;){const t=o.pop();if(n.lookupOrInsertNode(t),u++>1e3)throw new C(n);for(const h of b._util.getServiceDependencies(t.desc.ctor)){const s=this.r(h.id);if(s||this.y(`[createInstance] ${g} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),s instanceof A.$qi){const c={id:h.id,desc:s,_trace:t._trace.branch(h.id,!0)};n.insertEdge(t,c),o.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:h}of t){if(this.r(h.id)instanceof A.$qi){const c=this.w(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.q(h.id,c)}n.removeNode(h)}}return this.r(g)}w(g,a,i=[],n,u){if(this.i.get(g)instanceof A.$qi)return this.x(g,a,i,n,u,this.g);if(this.k)return this.k.w(g,a,i,n,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(g,a,i=[],n,u,o){if(n){const t=new m(void 0,this.j,this,this.l);t.c=String(g);const h=new Map,s=new l.$Mh(()=>{const c=t.o(a,i,u);for(const[r,v]of h){const f=c[r];if(typeof f=="function")for(const D of v)D.disposable=f.apply(c,D.listener)}return h.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let D=h.get(r);return D||(D=new S.$6c,h.set(r,D)),(E,k,P)=>{if(s.isInitialized)return s.value[r](E,k,P);{const I={listener:[E,k,P],disposable:void 0},T=D.push(I);return(0,L.$Tc)(()=>{T(),I.disposable?.dispose()})}}}if(r in c)return c[r];const v=s.value;let f=v[r];return typeof f!="function"||(f=f.bind(v),c[r]=f),f},set(c,r,v){return s.value[r]=v,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this.o(a,i,u);return o.add(t),t}}y(g,a){if(a&&console.warn(g),this.j)throw new Error(g)}}e.$_q=m;var y;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(y||(y={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,a){return g?new w(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(g,a){return g?new w(1,a.name):w.c}static{this.f=0}constructor(g,a){this.type=g,this.name=a,this.g=Date.now(),this.h=[]}branch(g,a){const i=new w(3,g.toString());return this.h.push([g,a,i]),i}stop(){const g=Date.now()-this.g;w.f+=g;let a=!1;function i(u,o){const t=[],h=new Array(u+1).join("	");for(const[s,c,r]of o.h)if(c&&r){a=!0,t.push(`${h}CREATES -> ${s}`);const v=i(u+1,r);v&&t.push(v)}else t.push(`${h}uses -> ${s}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(g>2||a)&&w.all.add(n.join(`
`))}}e.$ar=w}),define(ke[12],Se([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$3j=e.LogLevel=e.$1j=e.$Zj=void 0,e.$2j=d,e.log=a,e.$bk=f,e.$ck=D,e.$dk=p,e.$ek=E,e.$Zj=(0,y.$ti)("logService"),e.$1j=(0,y.$ti)("loggerService");function w(){return new Date().toISOString()}function d(k){return(0,N.$0f)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$3j=g.Info;function a(k,P,I){switch(P){case g.Trace:k.trace(I);break;case g.Debug:k.debug(I);break;case g.Info:k.info(I);break;case g.Warning:k.warn(I);break;case g.Error:k.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function i(k,P=!1){let I="";for(let T=0;T<k.length;T++){let j=k[T];if(j instanceof Error&&(j=(0,M.$ej)(j,P)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(T>0?" ":"")+j}return I}class n extends R.$Vc{constructor(){super(...arguments),this.b=e.$3j,this.c=this.B(new L.$ce),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$5j=n;class u extends n{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(g.Trace)&&this.g(g.Trace,i([P,...I],!0))}debug(P,...I){this.f(g.Debug)&&this.g(g.Debug,i([P,...I]))}info(P,...I){this.f(g.Info)&&this.g(g.Info,i([P,...I]))}warn(P,...I){this.f(g.Warning)&&this.g(g.Warning,i([P,...I]))}error(P,...I){if(this.f(g.Error))if(P instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=P.stack,this.g(g.Error,i(T))}else this.g(g.Error,i([P,...I]))}flush(){}}e.$6j=u;class o extends n{constructor(P=e.$3j){super(),this.setLevel(P),this.g=!$.$i}trace(P,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,P,...I):console.warn(`[main ${w()}]`,P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,P,...I):console.error(`[main ${w()}]`,P,...I))}flush(){}}e.$7j=o;class t extends n{constructor(P=e.$3j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$8j=t;class h extends n{constructor(P,I=e.$3j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...I])}debug(P,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...I])}info(P,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...I])}warn(P,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...I])}error(P,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,M.$ej)(P,this.f(g.Trace))}flush(){}}e.$9j=h;class s extends n{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const T of this.g)T.trace(P,...I)}debug(P,...I){for(const T of this.g)T.debug(P,...I)}info(P,...I){for(const T of this.g)T.info(P,...I)}warn(P,...I){for(const T of this.g)T.warn(P,...I)}error(P,...I){for(const T of this.g)T.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$0j=s;class c extends R.$Vc{constructor(P,I,T){if(super(),this.h=P,this.j=I,this.b=new b.$Bc,this.c=this.B(new L.$ce),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$ce),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$ce),this.onDidChangeVisibility=this.g.event,T)for(const j of T)this.b.set(j.resource,{logger:void 0,info:j})}m(P){return(0,N.$6f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const T=this.n(P),j=(0,N.$6f)(P)?P:I?.id??(0,A.$hj)(T.toString()).toString(16);let z=this.b.get(T)?.logger;const O=I?.logLevel==="always"?g.Trace:I?.logLevel;z||(z=this.s(T,O??this.getLogLevel(T)??this.h,{...I,id:j}));const F={logger:z,info:{resource:T,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(F.info),this.b.set(T,F),z}n(P){return(0,N.$6f)(P)?(0,S.$7g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const T=P,j=I,z=this.b.get(T);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([T,j]))}else{this.h=P;for(const[T,j]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const T=this.m(P);T&&I!==!T.info.hidden&&(T.info.hidden=!I,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$$j=c;class r{constructor(){this.onDidChangeLogLevel=new L.$ce().event}setLevel(P){}getLevel(){return g.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$_j=r;class v extends r{}e.$ak=v;function f(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const P=E(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$3j}function D(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function p(k){switch(k){case g.Trace:return{original:"Trace",value:l.localize(0,null)};case g.Debug:return{original:"Debug",value:l.localize(1,null)};case g.Info:return{original:"Info",value:l.localize(2,null)};case g.Warning:return{original:"Warning",value:l.localize(3,null)};case g.Error:return{original:"Error",value:l.localize(4,null)};case g.Off:return{original:"Off",value:l.localize(5,null)}}}function E(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$fk=new m.$Kj("logLevel",D(g.Info))}),define(ke[258],Se([1,0,19,8,13,4,31,3,17,65,12]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class C extends b.$Vc{constructor(y,w){super(),this.a=y,this.b=w,this.c=this.B(new A.$ce),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ce),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$rh(0)),this.w=[],this.y=this.B(new M.$rh(0))}watch(y,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(y,w):this.z(y,w)}n(y,w){const d={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},g=(0,l.$Ub)(this.j,d);return this.r(),(0,b.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,L.$1)(y))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,S.$Lq)(w)),w=>this.G(w),this.a.getLevel()===N.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===N.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const w of this.j)(0,S.$Hq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const w of this.j)(0,S.$Hq)(w)&&y.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,w){const d={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},g=(0,l.$Ub)(this.w,d);return this.C(),(0,b.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,L.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,S.$Lq)(y)),y=>this.G(y),this.a.getLevel()===N.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===N.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,$.$ic)(y.fsPath)}J(y){const w=this.I(y);return(0,R.$vg)(w)}}e.$Rq=C}),define(ke[259],Se([1,0,52,396,8,27,21,4,31,3,17,11,23,98,32,212,33,251,258,47,256,255]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0,(()=>{try{(0,M.gracefulify)(l)}catch(h){console.error(`Error enabling graceful-fs: ${(0,n.$ej)(h)}`)}})();class t extends i.$Rq{static{this.L=!1}constructor(s,c){super(s,c),this.onDidChangeCapabilities=b.Event.None,this.P=new A.$Bc(r=>m.$Xg.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,C.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:c,symbolicLink:r}=await w.SymlinkSupport.stat(this.I(s));return{type:this.O(c,r),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:g.FilePermission.Locked}}catch(c){throw this.hb(c)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const c=await w.Promises.readdir(this.I(s),{withFileTypes:!0}),r=[];return await Promise.all(c.map(async v=>{try{let f;v.isSymbolicLink()?f=(await this.stat((0,m.$7g)(s,v.name))).type:f=this.O(v),r.push([v.name,f])}catch(f){this.a.trace(f)}})),r}catch(c){throw this.hb(c)}}O(s,c){let r;return c?.dangling?r=g.FileType.Unknown:s.isFile()?r=g.FileType.File:s.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,c&&(r|=g.FileType.SymbolicLink),r}async Q(s){const c=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let r;for(;r=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await r.wait();const v=new L.$sh;return this.P.set(s,v),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,S.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.P.get(s)===v&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),v.open()})}async readFile(s,c){let r;try{c?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),r=await this.Q(s));const v=this.I(s);return await w.Promises.readFile(v)}catch(v){throw this.hb(v)}finally{r?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,c,r){const v=(0,y.$re)(f=>R.$De.concat(f.map(D=>R.$De.wrap(D))).buffer);return(0,a.$Eq)(this,s,v,f=>f.buffer,{...c,bufferSize:256*1024},r),v}async writeFile(s,c,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(s)?this.U(s,(0,m.$7g)((0,m.$6g)(s),`${(0,m.$4g)(s)}${r.atomic.postfix}`),c,r):this.W(s,c,r)}async S(s){try{const c=this.I(s),{symbolicLink:r}=await w.SymlinkSupport.stat(c);if(r)return!1}catch{}return!0}async U(s,c,r,v){const f=new S.$Uc;try{f.add(await this.Q(s)),f.add(await this.Q(c)),await this.W(c,r,v,!0);try{await this.rename(c,s,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{f.dispose()}}async W(s,c,r,v){let f;try{const D=this.I(s);if(!r.create||!r.overwrite){if(await w.Promises.exists(D)){if(!r.overwrite)throw(0,g.$al)((0,d.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.$al)((0,d.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:r.unlock},v),await this.write(f,0,c,0,c.byteLength)}catch(D){throw await this.ib(s,D)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,c,r){const v=this.I(s);let f;(0,g.$1k)(c)&&!r&&(f=await this.Q(s));let D;try{if((0,g.$1k)(c)&&c.unlock)try{const{stat:E}=await w.SymlinkSupport.stat(v);E.mode&128||await w.Promises.chmod(v,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let p;if((0,g.$1k)(c)){if(C.$i)try{await w.Promises.truncate(v,0),p="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}p||(p="w")}else p="r";D=await w.Promises.open(v,p)}catch(p){throw f?.dispose(),(0,g.$1k)(c)?await this.ib(s,p):this.hb(p)}if(this.X.set(D,0),(0,g.$1k)(c)&&this.Z.set(D,s),f){const p=this.Y.get(D);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${v})`),this.Y.set(D,f),p&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${v})`),p.dispose())}return D}async close(s){const c=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await w.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await w.Promises.close(s)}catch(r){throw this.hb(r)}finally{c&&(this.Y.get(s)===c&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),c.dispose())}}async read(s,c,r,v,f){const D=this.ab(s,c);let p=null;try{p=(await w.Promises.read(s,r,v,f,D)).bytesRead}catch(E){throw this.hb(E)}finally{this.bb(s,D,p)}return p}ab(s,c){return c===this.X.get(s)?null:c}bb(s,c,r){const v=this.X.get(s);typeof v=="number"&&(typeof c=="number"||(typeof r=="number"?this.X.set(s,v+r):this.X.delete(s)))}async write(s,c,r,v,f){return(0,L.$Nh)(()=>this.cb(s,c,r,v,f),100,3)}async cb(s,c,r,v,f){const D=this.ab(s,c);let p=null;try{p=(await w.Promises.write(s,r,v,f,D)).bytesWritten}catch(E){throw await this.ib(this.Z.get(s),E)}finally{this.bb(s,D,p)}return p}async mkdir(s){try{await w.Promises.mkdir(this.I(s))}catch(c){throw this.hb(c)}}async delete(s,c){try{const r=this.I(s);if(c.recursive){let v;c?.atomic!==!1&&c.atomic.postfix&&(v=(0,N.$kc)((0,N.$nc)(r),`${(0,N.$oc)(r)}${c.atomic.postfix}`)),await w.Promises.rm(r,w.RimRafMode.MOVE,v)}else try{await w.Promises.unlink(r)}catch(v){if(v.code==="EPERM"||v.code==="EISDIR"){let f=!1;try{const{stat:D,symbolicLink:p}=await w.SymlinkSupport.stat(r);f=D.isDirectory()&&!p}catch{}if(f)await w.Promises.rmdir(r);else throw v}else throw v}}catch(r){throw this.hb(r)}}async rename(s,c,r){const v=this.I(s),f=this.I(c);if(v!==f)try{await this.db(s,c,"move",r.overwrite),await w.Promises.rename(v,f)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,d.localize)(2,null,(0,N.$oc)(v),(0,N.$oc)((0,N.$nc)(f)),D.toString()))),this.hb(D)}}async copy(s,c,r){const v=this.I(s),f=this.I(c);if(v!==f)try{await this.db(s,c,"copy",r.overwrite),await w.Promises.copy(v,f,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,d.localize)(3,null,(0,N.$oc)(v),(0,N.$oc)((0,N.$nc)(f)),D.toString()))),this.hb(D)}}async db(s,c,r,v){const f=this.I(s),D=this.I(c);let p=!1;if(!!(this.capabilities&1024)||(p=(0,$.$rg)(f,D,!0)),p){if(r==="copy")throw(0,g.$al)((0,d.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const k=await this.N(s);if(!k)throw(0,g.$al)((0,d.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(c);if(P){if(!v)throw(0,g.$al)((0,d.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,c){return this.eb(s,c,!1)}async eb(s,c,r){const v=this.I(s),f=this.I(c),D=!!(this.capabilities&1024);if((0,$.$rg)(v,f,!D))return;const p=new S.$Uc;try{p.add(await this.Q(s)),p.add(await this.Q(c)),r&&await w.Promises.mkdir((0,N.$nc)(f),{recursive:!0}),await w.Promises.copyFile(v,f)}catch(E){if(E.code==="ENOENT"&&!r)return this.eb(s,c,!0);throw this.hb(E)}finally{p.dispose()}}t(s,c,r){return new u.$Yq(v=>s(v),v=>c(v),r)}F(s,c,r){return new o.$8q(v=>s(v),v=>c(v),r)}hb(s){if(s instanceof g.$_k)return s;let c=s,r;switch(s.code){case"ENOENT":r=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=g.FileSystemProviderErrorCode.Unknown;break;default:r=g.FileSystemProviderErrorCode.Unknown}return(0,g.$al)(c,r)}async ib(s,c){let r=this.hb(c);if(s&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await w.SymlinkSupport.stat(this.I(s));v.mode&128||(r=(0,g.$al)(c,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.a.trace(v)}return r}}e.$9q=t}),define(ke[260],Se([1,0,3,12]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=void 0;class L extends l.$Vc{constructor(R,b=[]){super(),this.a=new M.$0j([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$FQ=L}),define(ke[261],Se([1,0,33,12]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function A(S,N,C,m,y){try{const w=await new Promise((g,a)=>{le(["@vscode/spdlog"],g,a)});w.setFlushOn(L.Trace);const d=await w.createAsyncRotatingLogger(S,N,C,m);return y?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(w){console.error(w)}return null}function R(S,N,C){switch(N){case M.LogLevel.Trace:S.trace(C);break;case M.LogLevel.Debug:S.debug(C);break;case M.LogLevel.Info:S.info(C);break;case M.LogLevel.Warning:S.warn(C);break;case M.LogLevel.Error:S.error(C);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function b(S,N){switch(N){case M.LogLevel.Trace:S.setLevel(L.Trace);break;case M.LogLevel.Debug:S.setLevel(L.Debug);break;case M.LogLevel.Info:S.setLevel(L.Info);break;case M.LogLevel.Warning:S.setLevel(L.Warning);break;case M.LogLevel.Error:S.setLevel(L.Error);break;case M.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${N}`)}}class $ extends M.$6j{constructor(N,C,m,y,w){super(),this.m=[],this.setLevel(w),this.n=this.s(N,C,m,y),this.B(this.onDidChangeLogLevel(d=>{this.r&&b(this.r,d)}))}async s(N,C,m,y){const w=m?6:1,d=30/w*l.$vl.MB,g=await A(N,C,d,w,y);if(g){this.r=g,b(this.r,this.getLevel());for(const{level:a,message:i}of this.m)R(this.r,a,i);this.m=[]}}g(N,C){this.r?R(this.r,N,C):this.getLevel()<=N&&this.m.push({level:N,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$uQ=$}),define(ke[138],Se([1,0,41,214,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function S(w,d){return d-w}$.compare=S;const N=Object.create(null);N[$.Error]=(0,M.localize)(0,null),N[$.Warning]=(0,M.localize)(1,null),N[$.Info]=(0,M.localize)(2,null);function C(w){return N[w]||""}$.toString=C;function m(w){switch(w){case l.default.Error:return $.Error;case l.default.Warning:return $.Warning;case l.default.Info:return $.Info;case l.default.Ignore:return $.Hint}}$.fromSeverity=m;function y(w){switch(w){case $.Error:return l.default.Error;case $.Warning:return l.default.Warning;case $.Info:return l.default.Info;case $.Hint:return l.default.Ignore}}$.toSeverity=y}(R||(e.MarkerSeverity=R={}));var b;(function($){const S="";function N(m){return C(m,!0)}$.makeKey=N;function C(m,y){const w=[S];return m.source?w.push(m.source.replace("\xA6","\\\xA6")):w.push(S),m.code?typeof m.code=="string"?w.push(m.code.replace("\xA6","\\\xA6")):w.push(m.code.value.replace("\xA6","\\\xA6")):w.push(S),m.severity!==void 0&&m.severity!==null?w.push(R.toString(m.severity)):w.push(S),m.message&&y?w.push(m.message.replace("\xA6","\\\xA6")):w.push(S),m.startLineNumber!==void 0&&m.startLineNumber!==null?w.push(m.startLineNumber.toString()):w.push(S),m.startColumn!==void 0&&m.startColumn!==null?w.push(m.startColumn.toString()):w.push(S),m.endLineNumber!==void 0&&m.endLineNumber!==null?w.push(m.endLineNumber.toString()):w.push(S),m.endColumn!==void 0&&m.endColumn!==null?w.push(m.endColumn.toString()):w.push(S),w.push(S),w.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$Yt=(0,L.$ti)("markerService")}),define(ke[262],Se([1,0,4,41,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2v=e.$1v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Yv=e.Severity=void 0,e.$Zv=b,e.Severity=M.default,e.$Yv=(0,L.$ti)("notificationService");var A;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class S{constructor(){this.progress=new N,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$1v=S;class N{infinite(){}done(){}total(m){}worked(m){}}e.$2v=N}),define(ke[263],Se([1,0,51]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)M=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(M=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),!M.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(M,{version:A.version})}}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(ke[139],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$gk=(0,l.$ti)("productService"),e.$hk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(le,e){return function(l,M){e(l,M,le)}};define(ke[108],Se([1,0,8,22,3,5]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.ProgressLocation=e.$3v=void 0,e.$3v=(0,A.$ti)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$4v=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$5v=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const y=this.d;this.d=()=>{y?.(),m()}}):Promise.resolve()}}e.$6v=$;let S=class extends L.$Vc{constructor(m,y){super(),this.a=new l.$Qh,y.withProgress(m,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,L.$Tc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$7v=S,e.$7v=S=Je([Ve(1,e.$3v)],S);class N extends L.$Vc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new L.$Uc)}start(m){this.stop();const y=++this.a,w=new M.$ne;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,L.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Tc)(()=>w.cancel())),this.b.add((0,L.$Tc)(()=>this.c?this.c.done():void 0)),{id:y,token:w.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$8v=N,e.$9v=(0,A.$ti)("editorProgressService")}),define(ke[38],Se([1,0,62,18]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class L{constructor(){this.a=new Map}add(R,b){l.ok(M.$6f(R)),l.ok(M.$8f(b)),l.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$_n=new L}),define(ke[109],Se([1,0,4,38]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=void 0,e.$ao={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new l.$ce,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,S){this.a[L($)]=S,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;M.$_n.add(e.$ao.JSONContribution,R)}),define(ke[85],Se([1,0,19,4,18,203,54,109,38]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.ConfigurationScope=e.$eo=e.EditPresentationTypes=void 0,e.$po=d,e.$qo=g,e.$ro=a,e.$so=n,e.$to=u;var S;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$eo={Configuration:"base.contributions.configuration"};var N;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo="vscode://schemas/settings/resourceLanguage",e.$mo="vscode://schemas/settings/configurationDefaults";const C=$.$_n.as(b.$ao.JSONContribution);class m{constructor(){this.h=new Set,this.i=new M.$ce,this.onDidSchemaChange=this.i.event,this.j=new M.$ce,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$lo,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const s=new Set;this.n(t,h,s),C.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const h=new Set;this.o(t,h),C.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const s=new Set;this.o(h,s),this.n(t,!1,s),C.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const s=[];for(const{overrides:c,source:r}of t)for(const v in c)if(h.add(v),e.$oo.test(v)){const f=this.a.get(v),D=f?.valuesSources??new Map;if(r)for(const P of Object.keys(c[v]))D.set(P,r);const p={...f?.value||{},...c[v]};this.a.set(v,{source:r,value:p,valuesSources:D});const E=(0,R.$0i)(v),k={type:"object",default:p,description:A.localize(1,null,E),$ref:e.$lo,defaultDefaultValue:p,source:L.$6f(r)?void 0:r,defaultValueSource:r};s.push(...d(v)),this.d[v]=k,this.b.properties[v]=k}else{this.a.set(v,{value:c[v],source:r});const f=this.d[v];f&&(this.w(v,f),this.r(v,f))}this.m(s)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:s,source:c}of t)for(const r in s){const v=this.a.get(r),f=L.$6f(c)?c:c?.id,D=L.$6f(v?.source)?v?.source:v?.source?.id;if(f===D)if(h.add(r),this.a.delete(r),e.$oo.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}}this.u()}deltaConfiguration(t){let h=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,s){t.forEach(c=>{this.p(c,h,c.extensionInfo,c.restrictedProperties,void 0,s),this.c.push(c),this.q(c)})}o(t,h){const s=c=>{if(c.properties)for(const r in c.properties){h.add(r);const v=this.d[r];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[r],this.s(r,c.properties[r])}c.allOf?.forEach(r=>s(r))};for(const c of t){s(c);const r=this.c.indexOf(c);r!==-1&&this.c.splice(r,1)}}p(t,h=!0,s,c,r=3,v){r=L.$cg(t.scope)?r:t.scope;const f=t.properties;if(f)for(const p in f){const E=f[p];if(h&&n(p,E)){delete f[p];continue}if(E.source=s,E.defaultDefaultValue=f[p].default,this.w(p,E),e.$oo.test(p)?E.scope=void 0:(E.scope=L.$cg(E.scope)?r:E.scope,E.restricted=L.$cg(E.restricted)?!!c?.includes(p):E.restricted),f[p].hasOwnProperty("included")&&!f[p].included){this.f[p]=f[p],delete f[p];continue}else this.d[p]=f[p],f[p].policy?.name&&this.e.set(f[p].policy.name,p);!f[p].deprecationMessage&&f[p].markdownDeprecationMessage&&(f[p].deprecationMessage=f[p].markdownDeprecationMessage),v.add(p)}const D=t.allOf;if(D)for(const p of D)this.p(p,h,s,c,r,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=s=>{const c=s.properties;if(c)for(const v in c)this.r(v,c[v]);s.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$fo.properties[t]=h,h.scope){case 1:e.$go.properties[t]=h;break;case 2:e.$ho.properties[t]=h;break;case 6:e.$io.properties[t]=h;break;case 3:e.$jo.properties[t]=h;break;case 4:e.$ko.properties[t]=h;break;case 5:e.$ko.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$fo.properties[t],h.scope){case 1:delete e.$go.properties[t];break;case 2:delete e.$ho.properties[t];break;case 6:delete e.$io.properties[t];break;case 3:delete e.$jo.properties[t];break;case 4:case 5:delete e.$ko.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$lo};this.w(h,s),e.$fo.properties[h]=s,e.$go.properties[h]=s,e.$ho.properties[h]=s,e.$io.properties[h]=s,e.$jo.properties[h]=s,e.$ko.properties[h]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$lo};e.$fo.patternProperties[e.$no]=t,e.$go.patternProperties[e.$no]=t,e.$ho.patternProperties[e.$no]=t,e.$io.patternProperties[e.$no]=t,e.$jo.patternProperties[e.$no]=t,e.$ko.patternProperties[e.$no]=t,this.i.fire()}w(t,h){const s=this.a.get(t);let c=s?.value,r=s?.source;L.$ag(c)&&(c=h.defaultDefaultValue,r=void 0),L.$ag(c)&&(c=a(h.type)),h.default=c,h.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",w=new RegExp(y,"g");e.$no=`^(${y})+$`,e.$oo=new RegExp(e.$no);function d(o){const t=[];if(e.$oo.test(o)){let h=w.exec(o);for(;h?.length;){const s=h[1].trim();s&&t.push(s),h=w.exec(o)}}return(0,l.$Mb)(t)}function g(o){return o.reduce((t,h)=>`${t}[${h}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new m;$.$_n.add(e.$eo.Configuration,i);function n(o,t){return o.trim()?e.$oo.test(o)?A.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?A.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function u(){const o=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))o.push([h,t[h].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[264],Se([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$yo=n;function y(h){return Object.isFrozen(h)?h:b.$1n(h)}class w{static createEmptyModel(s){return new w({},[],[],void 0,s)}constructor(s,c,r,v,f){this.b=s,this.c=c,this.d=r,this.raw=v,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof w)return c;const r=new d("",this.f);return r.parseRaw(c),r.configurationModel});this.g=s.reduce((c,r)=>r===c?r:c.merge(r),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,N.$8i)(this.contents,s):this.contents}inspect(s,c){const r=this;return{get value(){return y(r.rawConfiguration.getValue(s))},get override(){return c?y(r.rawConfiguration.getOverrideValue(s,c)):void 0},get merged(){return y(c?r.rawConfiguration.override(c).getValue(s):r.rawConfiguration.getValue(s))},get overrides(){const v=[];for(const{contents:f,identifiers:D,keys:p}of r.rawConfiguration.overrides){const E=new w(f,p,[],void 0,r.f).getValue(s);E!==void 0&&v.push({identifiers:D,value:E})}return v.length?y(v):void 0}}}getOverrideValue(s,c){const r=this.j(c);return r?s?(0,N.$8i)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const r of this.overrides)r.identifiers.includes(s)&&c.push(...r.keys);return l.$Mb(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return l.$Mb(s)}override(s){let c=this.a.get(s);return c||(c=this.h(s),this.a.set(s,c)),c}merge(...s){const c=b.$Zn(this.contents),r=b.$Zn(this.overrides),v=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const D of s)if(f.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(c,D.contents);for(const p of D.overrides){const[E]=r.filter(k=>l.$ub(k.identifiers,p.identifiers));E?(this.i(E.contents,p.contents),E.keys.push(...p.keys),E.keys=l.$Mb(E.keys)):r.push(b.$Zn(p))}for(const p of D.keys)v.indexOf(p)===-1&&v.push(p)}return new w(c,v,r,f.every(D=>D instanceof w)?void 0:f,this.f)}h(s){const c=this.j(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const r={};for(const v of l.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let f=this.contents[v];const D=c[v];D&&(typeof f=="object"&&typeof D=="object"?(f=b.$Zn(f),this.i(f,D)):f=D),r[v]=f}return new w(r,this.keys,this.overrides,void 0,this.f)}i(s,c){for(const r of Object.keys(c)){if(r in s&&$.$8f(s[r])&&$.$8f(c[r])){this.i(s[r],c[r]);continue}s[r]=b.$Zn(c[r])}}j(s){let c=null,r=null;const v=f=>{f&&(r?this.i(r,f):r=b.$Zn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===s?c=f.contents:f.identifiers.includes(s)&&v(f.contents);return v(c),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.k(s,c,!0)}setValue(s,c){this.k(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,N.$7i)(this.contents,s),C.$oo.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>l.$ub(r.identifiers,(0,C.$po)(s))),1))}k(s,c,r){(0,N.$6i)(this.contents,s,c,v=>this.f.error(v)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),C.$oo.test(s)&&this.overrides.push({identifiers:(0,C.$po)(s),keys:Object.keys(this.contents[s]),contents:(0,N.$5i)(this.contents[s],v=>this.f.error(v))})}}e.$uo=w;class d{constructor(s,c){this.f=s,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||w.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!$.$cg(s)){const r=this.h(s);this.parseRaw(r,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:r,keys:v,overrides:f,restricted:D,hasExcludedProperties:p}=this.i(s,c);this.b=new w(r,v,f,p?[s]:void 0,this.g),this.c=D||[]}h(s){let c={},r=null,v=[];const f=[],D=[];function p(k){Array.isArray(v)?v.push(k):r!==null&&(v[r]=k)}const E={onObjectBegin:()=>{const k={};p(k),f.push(v),v=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const k=[];p(k),f.push(v),v=k,r=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:p,onError:(k,P,I)=>{D.push({error:k,offset:P,length:I})}};if(s)try{L.$Nn(s,E),c=v[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return c}i(s,c){const r=m.$_n.as(C.$eo.Configuration).getConfigurationProperties(),v=this.j(s,r,!0,c);s=v.raw;const f=(0,N.$5i)(s,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(s),p=this.l(s,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:f,keys:D,overrides:p,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}j(s,c,r,v){let f=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:f};const D={},p=[];for(const E in s)if(C.$oo.test(E)&&r){const k=this.j(s[E],c,!1,v);D[E]=k.raw,f=f||k.hasExcludedProperties,p.push(...k.restricted)}else{const k=c[E],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&p.push(E),!v.exclude?.includes(E)&&(v.include?.includes(E)||(P===void 0||v.scopes===void 0||v.scopes.includes(P))&&!(v.skipRestricted&&k?.restricted))?D[E]=s[E]:f=!0}return{raw:D,restricted:p,hasExcludedProperties:f}}l(s,c){const r=[];for(const v of Object.keys(s))if(C.$oo.test(v)){const f={};for(const D in s[v])f[D]=s[v][D];r.push({identifiers:(0,C.$po)(v),keys:Object.keys(f),contents:(0,N.$5i)(f,c)})}return r}}e.$vo=d;class g extends A.$Vc{constructor(s,c,r,v,f){super(),this.c=s,this.f=c,this.g=v,this.h=f,this.b=this.B(new M.$ce),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),f),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&r.isEqual(D.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return w.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$wo=g;class a{constructor(s,c,r,v,f,D,p,E,k,P,I,T,j){this.a=s,this.b=c,this.c=r,this.overrideIdentifiers=v,this.d=f,this.f=D,this.g=p,this.h=E,this.i=k,this.j=P,this.k=I,this.l=T,this.m=j}get value(){return y(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(s,c,r,v,f,D,p,E,k,P){this.j=s,this.l=c,this.m=r,this.n=v,this.p=f,this.q=D,this.r=p,this.s=E,this.t=k,this.u=P,this.h=null,this.i=new R.$Bc,this.v=null}getValue(s,c,r){return this.w(s,c,r).getValue(s)}updateValue(s,c,r={}){let v;r.resource?(v=this.t.get(r.resource),v||(v=w.createEmptyModel(this.u),this.t.set(r.resource,v))):v=this.s,c===void 0?v.removeValue(s):v.setValue(s,c),r.resource||(this.h=null)}inspect(s,c,r){const v=this.w(s,c,r),f=this.A(c.resource,r),D=c.resource?this.t.get(c.resource)||this.s:this.s,p=new Set;for(const E of v.overrides)for(const k of E.identifiers)v.getOverrideValue(s,k)!==void 0&&p.add(k);return new a(s,c,v.getValue(s),p.size?[...p]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,f||void 0,D)}keys(s){const c=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,c){this.r.set(s,c),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const r=[];if(!c){const{added:v,updated:f,removed:D}=o(this.j,s);c=[...v,...f,...D]}for(const v of c)for(const f of(0,C.$po)(v)){const D=this.j.getKeysForOverrideIdentifier(f),p=s.getKeysForOverrideIdentifier(f),E=[...p.filter(k=>D.indexOf(k)===-1),...D.filter(k=>p.indexOf(k)===-1),...D.filter(k=>!b.$4n(this.j.override(f).getValue(k),s.override(f).getValue(k)))];r.push([f,E])}return this.updateDefaultConfiguration(s),{keys:c,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:r,removed:v}=o(this.l,s),f=[...c,...r,...v];return f.length&&this.updatePolicyConfiguration(s),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:r,removed:v,overrides:f}=o(this.applicationConfiguration,s),D=[...c,...r,...v];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:f}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:r,removed:v,overrides:f}=o(this.localUserConfiguration,s),D=[...c,...r,...v];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:f}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:r,removed:v,overrides:f}=o(this.remoteUserConfiguration,s),D=[...c,...r,...v];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:f}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:r,removed:v,overrides:f}=o(this.workspaceConfiguration,s),D=[...c,...r,...v];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:f}}compareAndUpdateFolderConfiguration(s,c){const r=this.folderConfigurations.get(s),{added:v,updated:f,removed:D,overrides:p}=o(r,c),E=[...v,...f,...D];return(E.length||!r)&&this.updateFolderConfiguration(s,c),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(s){const c=this.folderConfigurations.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:v,removed:f,overrides:D}=o(c,void 0);return{keys:[...r,...v,...f],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,c,r){let v=this.x(c,r);return c.overrideIdentifier&&(v=v.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(v=v.merge(this.l)),v}x({resource:s},c){let r=this.y();if(c&&s){const v=c.getFolder(s);v&&(r=this.z(v.uri)||r);const f=this.t.get(s);f&&(r=r.merge(f))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let c=this.i.get(s);if(!c){const r=this.y(),v=this.r.get(s);v?(c=r.merge(v),this.i.set(s,c)):c=r}return c}A(s,c){if(c&&s){const r=c.getFolder(s);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,c)=>{const{contents:r,overrides:v,keys:f}=this.r.get(c);return s.push([c,{contents:r,overrides:v,keys:f}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.q.keys.forEach(c=>s.add(c)),this.r.forEach(c=>c.keys.forEach(r=>s.add(r))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}D(s){const c=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.q.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(v=>c.add(v))),[...c.values()]}static parse(s,c){const r=this.E(s.defaults,c),v=this.E(s.policy,c),f=this.E(s.application,c),D=this.E(s.user,c),p=this.E(s.workspace,c),E=s.folders.reduce((k,P)=>(k.set(S.URI.revive(P[0]),this.E(P[1],c)),k),new R.$Bc);return new i(r,v,f,D,w.createEmptyModel(c),p,E,w.createEmptyModel(c),new R.$Bc,c)}static E(s,c){return new w(s.contents,s.keys,s.overrides,void 0,c)}}e.$xo=i;function n(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,c=new Map;for(const v of h)v.keys.forEach(f=>s.add(f)),v.overrides.forEach(([f,D])=>{const p=(0,R.$yc)(c,f,new Set);D.forEach(E=>p.add(E))});const r=[];return c.forEach((v,f)=>r.push([f,[...v.values()]])),{keys:[...s.values()],overrides:r}}class u{constructor(s,c,r,v,f){this.change=s,this.f=c,this.g=r,this.h=v,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of s.keys)this.affectedKeys.add(D);for(const[,D]of s.overrides)for(const p of D)this.affectedKeys.add(p);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,c){const r=this.a+s,v=this.d.indexOf(r);if(v<0)return!1;const f=v+r.length;if(f>=this.d.length)return!1;const D=this.d.charCodeAt(f);if(D!==this.b&&D!==this.c)return!1;if(c){const p=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,E=this.g.getValue(s,c,this.h);return!b.$4n(p,E)}return!0}}e.$zo=u;function o(h,s){const{added:c,removed:r,updated:v}=t(s?.rawConfiguration,h?.rawConfiguration),f=[],D=h?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const E=p.filter(k=>!D.includes(k));for(const k of E)f.push([k,s.getKeysForOverrideIdentifier(k)])}if(h){const E=D.filter(k=>!p.includes(k));for(const k of E)f.push([k,h.getKeysForOverrideIdentifier(k)])}if(s&&h){for(const E of D)if(p.includes(E)){const k=t({contents:h.getOverrideValue(void 0,E)||{},keys:h.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});f.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:c,removed:r,updated:v,overrides:f}}function t(h,s){const c=h?s?h.keys.filter(f=>s.keys.indexOf(f)===-1):[...h.keys]:[],r=s?h?s.keys.filter(f=>h.keys.indexOf(f)===-1):[...s.keys]:[],v=[];if(h&&s){for(const f of s.keys)if(h.keys.indexOf(f)!==-1){const D=(0,N.$8i)(s.contents,f),p=(0,N.$8i)(h.contents,f);b.$4n(D,p)||v.push(f)}}return{added:c,removed:r,updated:v}}}),define(ke[265],Se([1,0,21,4,3,82]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsb=e.$Tsb=e.$Ssb=void 0,e.$Usb=b;const R=(S,N,C)=>{const m=new Uint8Array(16);for(let d=0;d<16;d++)m[d]=Math.round(Math.random()*256);const y=(0,l.$Xe)(l.$De.wrap(m));return[`GET ws://localhost${S}?${N}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Ssb=R,e.$Tsb=l.$De.fromString(`\r
\r
`);async function b(S,N,C,m,y){S.write(l.$De.fromString((0,e.$Ssb)(N,C,m)));const w=new L.$Uc;try{return await new Promise((d,g)=>{let a;w.add(S.onData(i=>{a?a=l.$De.concat([a,i],a.byteLength+i.byteLength):a=i;const n=a.indexOf(e.$Tsb);if(n===-1)return;d(S),S.pauseData();const u=a.slice(n+e.$Tsb.byteLength);u.byteLength&&y.onData.fire(u)})),w.add(S.onClose(i=>g(i??new Error("socket closed")))),w.add(S.onEnd(()=>g(new Error("socket ended"))))})}catch(d){throw S.dispose(),d}finally{w.dispose()}}class $ extends L.$Vc{constructor(N,C){super(),this.g=N,this.a=this.B(new M.$fe),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new M.$ce),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(N,C){A.SocketDiagnostics.traceSocketEvent(this,this.g,N,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Vsb=$}),define(ke[66],Se([1,0,13,5]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.RemoteAuthorityResolverErrorCode=e.$Gl=e.$Fl=e.RemoteConnectionType=e.$El=void 0,e.$Il=S,e.$El=(0,M.$ti)("remoteAuthorityResolverService");var L;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Fl=A;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Gl=R;var b;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends l.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,y){super(C),this._message=C,this._code=m,this._detail=y,this.isHandled=m===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Hl=$;function S(N){const C=N.indexOf("+");return C===-1?N:N.substring(0,C)}}),define(ke[266],Se([1,0,8,21,22,13,4,3,15,59,40,30,82,66]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Nl=D,e.$Ol=p,e.$Pl=k;const w=30*1e3;var d;(function(te){te[te.Management=1]="Management",te[te.ExtensionHost=2]="ExtensionHost",te[te.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function g(te){switch(te){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(te){const U=new L.$ne;return setTimeout(()=>U.cancel(),te),U.token}function i(te,U){if(te.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const _=new L.$ne;return te.onCancellationRequested(()=>_.cancel()),U.onCancellationRequested(()=>_.cancel()),_.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$mh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function u(te,U){const _=new n(U);return _.registerDisposable(te.onControlMessage(pe=>{const Pe=JSON.parse(pe.toString()),se=Y(Pe);se?_.reject(se):_.resolve(Pe)})),_.promise}function o(te,U,_,pe,Pe,se,re,oe){const K=new n(oe),ie=N.$$d.create(!1);return te.info(`Creating a socket (${re})...`),S.mark(`code/willCreateSocket/${se}`),U.connect(_,pe,Pe,re).then($e=>{K.didTimeout?(S.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(S.mark(`code/didCreateSocketOK/${se}`),te.info(`Creating a socket (${re}) was successful after ${ie.elapsed()} ms.`),K.resolve($e))},$e=>{S.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) returned an error after ${ie.elapsed()} ms.`),te.error($e),K.reject($e)}),K.promise}function t(te,U){const _=new n(U);return te.then(pe=>{_.didTimeout||_.resolve(pe)},pe=>{_.didTimeout||_.reject(pe)}),_.promise}async function h(te,U,_,pe){const Pe=ue(te,U);te.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let se;try{se=await o(te.logService,te.remoteSocketFactoryService,te.connectTo,$.$Gg.getServerRootPath(),`reconnectionToken=${te.reconnectionToken}&reconnection=${te.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${te.reconnectionToken}`,pe)}catch($e){throw te.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),te.logService.error($e),$e}te.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let re,oe;te.reconnectionProtocol?(te.reconnectionProtocol.beginAcceptReconnection(se,null),re=te.reconnectionProtocol,oe=!1):(re=new m.$hi({socket:se}),oe=!0),te.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const K=await t(te.signService.createNewMessage((0,C.$Pg)()),pe),ie={type:"auth",auth:te.connectionToken||"00000000000000000000",data:K.data};re.sendControl(M.$De.fromString(JSON.stringify(ie)));try{const $e=await u(re,i(pe,a(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(te.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(te.signService.validate(K,$e.signedData),pe)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ne=await t(te.signService.sign($e.data),pe),fe={type:"connectionType",commit:te.commit,signedData:Ne,desiredConnectionType:U};return _&&(fe.args=_),te.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(M.$De.fromString(JSON.stringify(fe))),{protocol:re,ownsProtocol:oe}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(te.logService.error(`${Pe} the handshake timed out. Error:`),te.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(te.logService.error(`${Pe} received error control message when negotiating connection. Error:`),te.logService.error($e)),oe&&X(re),$e}}async function s(te,U,_,pe){const Pe=Date.now(),se=ue(te,U),{protocol:re,ownsProtocol:oe}=await h(te,U,_,pe),K=new n(pe);return K.registerDisposable(re.onControlMessage(ie=>{const $e=JSON.parse(ie.toString()),we=Y($e);we?(te.logService.error(`${se} received error control message when negotiating connection. Error:`),te.logService.error(we),oe&&X(re),K.reject(we)):(te.reconnectionProtocol?.endAcceptReconnection(),te.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ve(Pe)}!`),K.resolve({protocol:re,firstMessage:$e}))})),K.promise}async function c(te,U){const{protocol:_}=await s(te,1,void 0,U);return{protocol:_}}async function r(te,U,_){const{protocol:pe,firstMessage:Pe}=await s(te,2,U,_),se=Pe&&Pe.debugPort;return{protocol:pe,debugPort:se}}async function v(te,U,_){const pe=Date.now(),Pe=ue(te,3),{protocol:se}=await h(te,3,U,_);return te.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${ve(pe)}!`),se}async function f(te,U,_){const{connectTo:pe,connectionToken:Pe}=await te.addressProvider.getAddress();return{commit:te.commit,quality:te.quality,connectTo:pe,connectionToken:Pe,reconnectionToken:U,reconnectionProtocol:_,remoteSocketFactoryService:te.remoteSocketFactoryService,signService:te.signService,logService:te.logService}}async function D(te,U,_){return E(te,async pe=>{const{protocol:Pe}=await c(pe,L.CancellationToken.None);return new W(te,U,_,pe.reconnectionToken,Pe)})}async function p(te,U){return E(te,async _=>{const{protocol:pe,debugPort:Pe}=await r(_,U,L.CancellationToken.None);return new Z(te,U,_.reconnectionToken,pe,Pe)})}async function E(te,U){for(let pe=1;;pe++)try{const Pe=(0,C.$Pg)(),se=await f(te,Pe,null);return await U(se)}catch(Pe){if(pe<5)te.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),te.logService.error(Pe);else throw te.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),te.logService.error(Pe),B.triggerPermanentFailure(0,0,y.$Hl.isHandled(Pe)),Pe}}async function k(te,U,_){const pe=await f(te,(0,C.$Pg)(),null);return await v(pe,{host:U,port:_},L.CancellationToken.None)}function P(te){return(0,l.$gh)(U=>new Promise((_,pe)=>{const Pe=setTimeout(_,te*1e3);U.onCancellationRequested(()=>{clearTimeout(Pe),_()})}))}var I;(function(te){te[te.ConnectionLost=0]="ConnectionLost",te[te.ReconnectionWait=1]="ReconnectionWait",te[te.ReconnectionRunning=2]="ReconnectionRunning",te[te.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",te[te.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class T{constructor(U,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.type=0}}e.$Ql=T;class j{constructor(U,_,pe,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.durationSeconds=pe,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Rl=j;class z{constructor(U,_,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=2}}e.$Sl=z;class O{constructor(U,_,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=4}}e.$Tl=O;class F{constructor(U,_,pe,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=pe,this.handled=Pe,this.type=3}}e.$Ul=F;class B extends b.$Vc{static triggerPermanentFailure(U,_,pe){this._permanentFailure=!0,this.f=U,this.g=_,this.h=pe,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,_,pe,Pe,se){super(),this.t=U,this.u=_,this.reconnectionToken=pe,this.protocol=Pe,this.w=se,this.m=this.B(new R.$ce),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(re=>{const oe=ge(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(re=>{const oe=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Tc)(()=>{const re=B.j.indexOf(this);re>=0&&B.j.splice(re,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const Pe=pe<_.length?_[pe]:_[_.length-1];try{if(Pe>0){const re=P(Pe);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,re)),this.u.logService.info(`${U} waiting for ${Pe} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${U} resolving connection...`);const se=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,a(w)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(y.$Hl.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,A.$4)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof y.$Hl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,y.$Hl.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(U,_,pe){this.w?B.triggerPermanentFailure(U,_,pe):this.D(U,_,pe)}D(U,_,pe){this.m.fire(new F(this.reconnectionToken,U,_,pe)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Vl=B;class W extends B{constructor(U,_,pe,Pe,se){super(1,U,Pe,se,!0),this.client=this.B(new m.$fi(se,{remoteAuthority:_,clientId:pe},U.ipcLogger))}async G(U,_){await c(U,_)}}e.$Wl=W;class Z extends B{constructor(U,_,pe,Pe,se){super(2,U,pe,Pe,!1),this.H=_,this.debugPort=se}async G(U,_){await r(U,this.H,_)}}e.$Xl=Z;function X(te){try{te.acceptDisconnect();const U=te.getSocket();te.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function Y(te){if(te&&te.type==="error"){const U=new Error(`Connection error: ${te.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(te,U){for(;te.length<U;)te+=" ";return te}function ne(te,U){return`[remote-connection][${x(g(te),13)}][${U.substr(0,5)}\u2026]`}function ge(te,U,_){return`${ne(te,U)}[${_?"reconnect":"initial"}]`}function ue(te,U){return`${ge(U,te.reconnectionToken,!!te.reconnectionProtocol)}[${te.connectTo}]`}function ve(te){return`${Date.now()-te} ms`}}),define(ke[86],Se([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=M,e.$Fm=L,e.$Gm=A,e.$Hm=R;function M($){return $.scheme===l.Schemas.vscodeRemote?$.authority:void 0}function L($){if(!$)return;const S=$.indexOf("+");return S<0?$:$.substr(0,S)}function A($){const{host:S,port:N}=b($);if(typeof N>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:N}}function R($,S){let{host:N,port:C}=b($);return typeof C>"u"&&(C=S),{host:N,port:C}}function b($){const S=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const N=$.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const C=$.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:$,port:void 0}}}),define(ke[25],Se([1,0,14,5,86]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Qm=e.$Pm=e.$Om=e.TargetPlatform=e.ExtensionType=e.$Nm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0,e.$Mm=A,e.$Rm=C,e.$Sm=m,e.$Tm=y,e.$Um=w,e.$Im="extensions.user.cache",e.$Jm="extensions.builtin.cache",e.$Km="undefined_publisher",e.$Lm=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Nm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g>"u"||g===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){const i=typeof g=="string"?g:g.value,n=typeof a=="string"?a:a.value;return l.$vf(i,n)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Om=$;class S{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const a of g)this.add(a)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$Pm=S;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,a){this.c.set($.toKey(g),a)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Qm=N;function C(d){return m(d)}function m(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function w(d,g){if(g){const a=`onResolveRemoteAuthority:${(0,L.$Fm)(g)}`;return!!d.activationEvents?.includes(a)}return!1}e.$Vm=(0,M.$ti)("IBuiltinExtensionsScannerService")}),define(ke[140],Se([1,0,13,25]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=e.$gG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const S=this.readActivationEvents($);S.length>0&&(b[M.$Om.toKey($.identifier)]=S)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${M.$Om.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const S=this.a.get($);if(!S)continue;const N=R.contributes[$],C=Array.isArray(N)?N:[N];try{S(C,b)}catch(m){(0,l.$1)(m)}}return b}}e.$gG=L,e.$hG=new L}),define(ke[267],Se([1,0,3,5]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0,e.$Jl=(0,M.$ti)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,l.$Tc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,S){const N=this.b(R);if(!N)throw new Error(`No socket factory found for ${R}`);return N.connect(R,b,$,S)}}e.$Kl=L}),define(ke[268],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const R=String(l.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const R=this.b.get(L.id);if(!R)return!1;this.b.delete(L.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$e$b=l}),define(ke[110],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0,e.$Ll="signService",e.$Ml=(0,l.$ti)(e.$Ll)}),define(ke[141],Se([1,0,268]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class M extends l.$e$b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>le(["vsda"],A,R))}}e.$adc=M}),define(ke[269],Se([1,0,11,51,30]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=R,e.$bp=b;function A($){if(l.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,S,N,C,m,y,w,d,g){const a=Object.create(null);a["common.machineId"]=y,a["common.sqmId"]=w,a.sessionID=(0,L.$Pg)()+Date.now(),a.commitHash=C,a.version=m,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,l.$h)(l.$u),a["common.nodePlatform"]=M.$ec,a["common.nodeArch"]=N,a["common.product"]=g||"desktop",d&&(a["common.msftInternal"]=d);let i=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),l.$l&&(a["common.snap"]="true");const u=A(S);return u&&(a["common.platformDetail"]=u),a}function b($){const S=M.env.USERDNSDOMAIN;if(!S)return!1;const N=S.toLowerCase();return $.some(C=>N===C)}}),define(ke[270],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0,e.$Yl=(0,l.$ti)("telemetryService"),e.$Zl=(0,l.$ti)("customEndpointTelemetryService"),e.$1l="telemetry.currentSessionDate",e.$2l="telemetry.firstSessionDate",e.$3l="telemetry.lastSessionDate",e.$4l="telemetry.machineId",e.$5l="telemetry.sqmId",e.$6l="telemetry",e.$7l="telemetry.telemetryLevel",e.$8l="telemetry.enableCrashReporter",e.$9l="telemetry.enableTelemetry";var M;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Se([1,0,24,18,86,269,270]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=N,e.$kp=C,e.$lp=m,e.$mp=y,e.$np=d,e.$op=a,e.$pp=i,e.$qp=o;class b{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$cp=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$dp=$,e.$ep=new $;class S{async publicLog(h,s,c){}async publicLogError(h,s,c){}}e.$fp=S,e.$gp="telemetry",e.$hp="extensionTelemetryLog",e.$ip={log:()=>null,flush:()=>Promise.resolve(null)};function N(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}function C(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function m(t){const h=t.getValue(R.$7l),s=t.getValue(R.$8l);if(t.getValue(R.$9l)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const h={},s={},c={};g(t,c);for(let r in c){r=r.length>150?r.substr(r.length-149):r;const v=c[r];typeof v=="number"?s[r]=v:typeof v=="boolean"?s[r]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${v.length}`),h[r]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(h[r]=v)}return{properties:h,measurements:s}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const h=(0,L.$Fm)(t);return w.has(h)?h:"other"}function g(t,h,s=0,c){if(t)for(const r of Object.getOwnPropertyNames(t)){const v=t[r],f=c?c+r:r;Array.isArray(v)?h[f]=(0,l.$5n)(v):v instanceof Date?h[f]=v.toISOString():(0,M.$8f)(v)?s<2?g(v,h,s+1,f+"."):h[f]=(0,l.$5n)(v):h[f]=v}}function a(t,h){const s=t.msftInternalDomains||[],c=h.getValue("telemetry.internalTesting");return(0,A.$bp)(s)||c}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const c=[];for(const D of h)for(;;){const p=D.exec(t);if(!p)break;c.push([p.index,D.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(s="";;){const D=v.exec(t);if(!D)break;const p=c.some(([E,k])=>D.index<k&&E<v.lastIndex);!r.test(D[0])&&!p&&(s+=t.substring(f,D.index)+"<REDACTED: user-file-path>",f=v.lastIndex)}return f<t.length&&(s+=t.substr(f)),s}function u(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of h)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function o(t,h){return(0,l.$2n)(t,s=>{if(s instanceof b||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let c=s.replaceAll("%20"," ");c=n(c,h);for(const r of h)c=c.replace(r,"");return c=u(c),c}})}}),define(ke[271],Se([1,0,14,137,25,11,2,13,51,87]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$sp=void 0,e.$rp=N,e.$tp=w,e.$up=d,e.$vp=g,e.$wp=a,e.$xp=i,e.$yp=n,e.$zp=u,e.$Bp=o,e.$Cp=h;function N(s,c){return s.uuid&&c.uuid?s.uuid===c.uuid:s.id===c.id?!0:(0,l.$qf)(s.id,c.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(c){const r=c.manifest?c.manifest.version:c.version,v=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new m(c.identifier,r,v)}static parse(c){const r=C.exec(c);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(c,r,v="undefined"){this.version=r,this.targetPlatform=v,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof m?N(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$sp=m;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(s){const c=y.exec(s);return c&&c[1]?[g(c[1]),c[2]]:[g(s),void 0]}function d(s,c){return`${s}.${c}`}function g(s){return s.toLowerCase()}function a(s,c){return g(d(s??L.$Km,c))}function i(s,c){const r=[],v=f=>{for(const D of r)if(D.some(p=>N(c(p),c(f))))return D;return null};for(const f of s){const D=v(f);D?D.push(f):r.push([f])}return r}function n(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function u(s){return{id:new S.$cp(s.identifier.id),name:new S.$cp(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Ap=new L.$Om("pprice.better-merge");function o(s,c){const r=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const f=v.shift();if(f&&r.every(D=>!N(D.identifier,{id:f}))){const D=s.filter(p=>N(p.identifier,{id:f}));D.length===1&&(r.push(D[0]),v.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(s,c){if(!A.$k)return!1;let r;try{r=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){c.debug("Error while getting the os-release file.",(0,b.$0)(f))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(s,c){const r=await t(s,c),v=(0,M.$Yo)(r?"alpine":A.$u,$.$fc);return c.debug("ComputeTargetPlatform:",v),v}}),define(ke[272],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=l,e.$is=M,e.$js=L,e.$ks=A,e.$ls=R,e.$ms=b;function l($){return[...$.entries()]}function M($){return $?[...$.entries()]:[]}function L($){return new Map($)}function A($){return new Map($??[])}function R($){return Array.from($.entries()).map(S=>[S[0],l(S[1].map),M(S[1].descriptionMap)])}function b($){return new Map($.map(S=>[S[0],{map:L(S[1]),descriptionMap:A(S[2])}]))}}),define(ke[273],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btb=void 0;class l{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,A,R=5){const b=A($=>{const S=typeof $=="string"?$:$.data;let N=this.a.get(L);if(N){N.data.push(S);return}const C=setTimeout(()=>this.flushBuffer(L),R);N={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),b.dispose()}},this.a.set(L,N)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const A=this.a.get(L);A&&(this.a.delete(L),this.b(L,A.data.join("")))}}e.$btb=l}),define(ke[274],Se([1,0,8,78,99,57,4,18,2,215,109,38]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bx=e.$ax=e.$_w=e.$$w=e.$0w=e.$9w=e.IconFontDefinition=e.IconContribution=e.$6w=void 0,e.$7w=g,e.$8w=a,e.$6w={IconContribution:"base.contributions.icons"};var m;(function(o){function t(h,s){let c=h.defaults;for(;A.ThemeIcon.isThemeIcon(c);){const r=d.getIcon(c.id);if(!r)return;c=r.defaults}return c}o.getDefinition=t})(m||(e.IconContribution=m={}));var y;(function(o){function t(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function h(s){const c=r=>(0,b.$6f)(r)?r:void 0;if(s&&Array.isArray(s.src)&&s.src.every(r=>(0,b.$6f)(r.format)&&(0,b.$6f)(r.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(r=>({format:r.format,location:$.URI.parse(r.location)}))}}o.fromJSONObject=h})(y||(e.IconFontDefinition=y={}));class w{constructor(){this.a=new R.$ce,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,h,s,c){const r=this.b[t];if(r){if(s&&!r.description){r.description=s,this.d.properties[t].markdownDescription=`${s} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=s),this.a.fire()}return r}const v={id:t,description:s,defaults:h,deprecationMessage:c};this.b[t]=v;const f={$ref:"#/definitions/icons"};return c&&(f.deprecationMessage=c),s&&(f.markdownDescription=`${s}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const h=this.e.enum.indexOf(t);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,h){const s=this.f[t];return s||(this.f[t]=h,this.a.fire(),h)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(r,v)=>r.id.localeCompare(v.id),h=r=>{for(;A.ThemeIcon.isThemeIcon(r.defaults);)r=this.b[r.defaults.id];return`codicon codicon-${r?r.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(r=>this.b[r]);for(const r of c.filter(v=>!!v.description).sort(t))s.push(`|<i class="${h(r)}"></i>|${r.id}|${A.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const r of c.filter(v=>!A.ThemeIcon.isThemeIcon(v.defaults)).sort(t))s.push(`|<i class="${h(r)}"></i>|${r.id}|`);return s.join(`
`)}}const d=new w;C.$_n.add(e.$6w.IconContribution,d);function g(o,t,h,s){return d.registerIcon(o,t,h,s)}function a(){return d}function i(){const o=(0,L.$Oj)();for(const t in o){const h="\\"+o[t].toString(16);d.registerIcon(t,{fontCharacter:h})}}i(),e.$9w="vscode://schemas/icons";const n=C.$_n.as(N.$ao.JSONContribution);n.registerSchema(e.$9w,d.getIconSchema());const u=new l.$Fh(()=>n.notifySchemaChanged(e.$9w),200);d.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$0w=g("widget-close",M.$Sj.close,(0,S.localize)(2,null)),e.$$w=g("goto-previous-location",M.$Sj.arrowUp,(0,S.localize)(3,null)),e.$_w=g("goto-next-location",M.$Sj.arrowDown,(0,S.localize)(4,null)),e.$ax=A.ThemeIcon.modify(M.$Sj.sync,"spin"),e.$bx=A.ThemeIcon.modify(M.$Sj.loading,"spin")}),define(ke[88],Se([1,0,4,2,54,5,12]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$ew=e.$cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$$v=e.$0v=void 0,e.$_v=S,e.$aw=C,e.$bw=m,e.$dw=y,e.$fw=w,e.$gw=d,e.$0v=(0,A.$ti)("tunnelService"),e.$$v=(0,A.$ti)("sharedTunnelsService");var b;(function(i){i.Http="http",i.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})($||(e.TunnelPrivacyId=$={}));function S(i){return!!i.forwardPort}var N;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function C(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function m(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const u of n){const o=u.split("=")[1];if(/^https?:/.exec(o)){const t=C(M.URI.parse(o));if(t)return t}}}e.$cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(i){return e.$cw.indexOf(i)>=0}e.$ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(i){return e.$ew.indexOf(i)>=0}function d(i,n,u,o){if(u===1)return!1;if(u===2&&w(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class g{constructor(n,u,o){this.remoteAddress=n,this.localAddress=u,this.b=o,this.a=new l.$ce,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$hw=g;let a=class{constructor(n,u){this.k=n,this.l=u,this.a=new l.$ce,this.onTunnelOpened=this.a.event,this.b=new l.$ce,this.onTunnelClosed=this.b.event,this.c=new l.$ce,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],u=Array.from(this.e.values());for(const o of u){const t=Array.from(o.values());for(const h of t){const s=await h.value;s&&typeof s!="string"&&n.push(s)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:u}of n.values())await u.then(o=>typeof o!="string"?o?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,u,o,t,h){this.q(n,u,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:u,localAddress:o,privacy:t,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,u){(w(n)||y(n))&&(n=e.$cw[0]);const o=this.s(n,u);if(o)return++o.refcount,o.value}openTunnel(n,u,o,t,h,s=!1,c,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${o} on local port ${h}.`);const v=this.f??n;if(!v)return;if(u||(u="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(v,u,o,t,h,s,c,r);return f?f.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(u,o),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(u,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(D);return(D.tunnelRemoteHost!==u||D.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&D.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const u=this.e.get(n.tunnelRemoteHost);if(u){const o=u.get(n.tunnelRemotePort);o&&(o.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,o))}}}}async p(n,u,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${u}.`);const t=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(u),t}}async closeTunnel(n,u){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${u} `);const o=this.e.get(n);if(o&&o.has(u)){const t=o.get(u);t.refcount=0,await this.p(n,u,t)}}q(n,u,o){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(u,{refcount:1,value:o})}async r(n,u){const o=this.e.get(n);if(o){const t=o.get(u),h=t?await t.value:void 0;(!h||typeof h=="string")&&o.delete(u),o.size===0&&this.e.delete(n)}}s(n,u){const o=[n];y(n)?(o.push(...e.$cw),o.push(...e.$ew)):w(n)&&o.push(...e.$ew);const t=o.map(h=>this.e.get(h));for(const h of t){const s=h?.get(u);if(s)return s}}canTunnel(n){return!!C(n)}u(n,u,o,t,h,s,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${o} on local port ${t}.`);const r=o;this.j.add(r);const v=t===void 0?o:t,f={elevationRequired:h?this.isPortPrivileged(v):!1},D={remoteAddress:{host:u,port:o},localAddressPort:t,privacy:s,public:s?s!==$.Private:void 0,protocol:c},p=n.forwardPort(D,f);return p?(this.q(u,o,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),p}};e.$iw=a,e.$iw=a=Je([Ve(0,R.$Zj),Ve(1,L.$Zi)],a)}),define(ke[275],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=void 0,e.$xl=(0,l.$ti)("IUriIdentityService")}),define(ke[276],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$jw=void 0,e.$jw=(0,l.$ti)("editSessionIdentityService");var M;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(ke[277],Se([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=M,e.$sM=L,e.$tM=A,e.$uM=R,e.$vM=b;function M($){return $.scheme!==l.Schemas.file&&$.scheme!==l.Schemas.vscodeRemote}function L($){if($.folders.length)return $.folders.every(S=>M(S.uri))?$.folders[0].uri:void 0;if($.configuration&&M($.configuration))return $.configuration}function A($){return L($)?.scheme}function R($){return L($)?.authority}function b($){return L($)!==void 0}}),define(ke[42],Se([1,0,217,17,77,23,2,5,15]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Ni=e.$Mi=e.WorkbenchState=e.$Gi=e.$Fi=e.$Ci=void 0,e.$Di=S,e.$Ei=N,e.$Hi=C,e.$Ii=m,e.$Ji=y,e.$Ki=d,e.$Li=g,e.$Oi=n,e.$Ti=u,e.$Ui=o,e.$Wi=t,e.$Xi=h,e.$Yi=s,e.$Ci=(0,b.$ti)("contextService");function S(c){const r=c;return typeof r?.id=="string"&&R.URI.isUri(r.uri)}function N(c){return typeof c?.id=="string"&&!S(c)&&!m(c)}e.$Fi={id:"ext-dev"},e.$Gi={id:"empty-window"};function C(c,r){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,M.$oc)(c)}:r?e.$Fi:e.$Gi;const v=c;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function m(c){const r=c;return typeof r?.id=="string"&&R.URI.isUri(r.configPath)}function y(c){const r=c;if(r?.uri)return{id:r.id,uri:R.URI.revive(r.uri)};const v=c;if(v?.configPath)return{id:v.id,configPath:R.URI.revive(v.configPath)};if(c?.id)return{id:c.id}}var w;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function d(c){const r=c;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function g(c){const r=c;return!!(r&&typeof r=="object"&&R.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class a{constructor(r,v,f,D,p){this.h=r,this.j=f,this.k=D,this.l=p,this.c=L.$zi.forUris(this.l,()=>!0),this.folders=v}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=L.$zi.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Mi=a;class i{constructor(r,v){this.raw=v,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.$7g)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ni=i;function n(c){return new i({uri:c,index:0,name:(0,A.$3g)(c)},{uri:c.toString()})}e.$Pi="code-workspace",e.$Qi=`.${e.$Pi}`,e.$Ri=[{name:(0,l.localize)(0,null),extensions:[e.$Pi]}],e.$Si="workspace.json";function u(c,r){return A.$Xg.isEqualOrParent(c,r.untitledWorkspacesHome)}function o(c){let r;return R.URI.isUri(c)?r=c:r=c.configuration,r?.scheme===$.Schemas.tmp}e.$Vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Vi}function h(c,r){return!u(c,r)&&!o(c)}function s(c){return(typeof c=="string"?(0,M.$pc)(c):(0,A.$5g)(c))===e.$Qi}}),define(ke[278],Se([1,0,56,4,3,23,2,216,136,33,5,12,42,27,275,8,30,14,18]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$zl=e.ProfileResourceType=void 0,e.$yl=u,e.$Al=o,e.$Bl=t;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function u(c){const r=c;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&R.URI.isUri(r.location)&&R.URI.isUri(r.globalStorageHome)&&R.URI.isUri(r.settingsResource)&&R.URI.isUri(r.keybindingsResource)&&R.URI.isUri(r.tasksResource)&&R.URI.isUri(r.snippetsHome)&&R.URI.isUri(r.extensionsResource))}e.$zl=(0,N.$ti)("IUserDataProfilesService");function o(c,r){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:R.URI.revive(c.location).with({scheme:r}),globalStorageHome:R.URI.revive(c.globalStorageHome).with({scheme:r}),settingsResource:R.URI.revive(c.settingsResource).with({scheme:r}),keybindingsResource:R.URI.revive(c.keybindingsResource).with({scheme:r}),tasksResource:R.URI.revive(c.tasksResource).with({scheme:r}),snippetsHome:R.URI.revive(c.snippetsHome).with({scheme:r}),extensionsResource:R.URI.revive(c.extensionsResource).with({scheme:r}),cacheHome:R.URI.revive(c.cacheHome).with({scheme:r}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,r,v,f,D,p){return{id:c,name:r,location:v,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:p&&D?.useDefaultFlags?.globalState?p.globalStorageHome:(0,A.$7g)(v,"globalStorage"),settingsResource:p&&D?.useDefaultFlags?.settings?p.settingsResource:(0,A.$7g)(v,"settings.json"),keybindingsResource:p&&D?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,A.$7g)(v,"keybindings.json"),tasksResource:p&&D?.useDefaultFlags?.tasks?p.tasksResource:(0,A.$7g)(v,"tasks.json"),snippetsHome:p&&D?.useDefaultFlags?.snippets?p.snippetsHome:(0,A.$7g)(v,"snippets"),extensionsResource:p&&D?.useDefaultFlags?.extensions?p.extensionsResource:(0,A.$7g)(v,"extensions.json"),cacheHome:(0,A.$7g)(f,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let h=class extends L.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,v,f,D){super(),this.t=r,this.u=v,this.w=f,this.y=D,this.f=!0,this.h=this.B(new M.$ce),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$ce),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$ce),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$ce),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$7g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$7g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),v=[r];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,i.$6f)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}v.push(t((0,A.$4g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},r))}}catch(p){this.y.error(p)}const f=new y.$Bc,D=new Map;if(v.length)try{const p=this.Q();if(p.workspaces)for(const[E,k]of Object.entries(p.workspaces)){const P=R.URI.parse(E),I=v.find(T=>T.id===k);I&&f.set(P,I)}if(p.emptyWindows)for(const[E,k]of Object.entries(p.emptyWindows)){const P=v.find(I=>I.id===k);P&&D.set(E,P)}}catch(p){this.y.error(p)}this.z={profiles:v,workspaces:f,emptyWindows:D}}return this.z}D(){const r=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const v="Temp",f=new RegExp(`${(0,a.$0e)(v)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const k=f.exec(E.name),P=k?parseInt(k[1]):0;D=P>D?P:D}const p=`${v} ${D+1}`;return this.createProfile((0,l.$hj)((0,g.$Pg)()).toString(16),p,{transient:!0},r)}async createNamedProfile(r,v,f){return this.createProfile((0,l.$hj)((0,g.$Pg)()).toString(16),r,v,f)}async createProfile(r,v,f,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(r,v,f);return D&&await this.setProfileForWorkspace(D,p),p}async F(r,v,f){if(!(0,i.$6f)(v)||!v)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(v);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===v||P.id===r))throw new Error(`Profile with ${v} name already exists`);const E=t(r,v,(0,A.$7g)(this.profilesHome,r),this.g,f,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(P){k.push(P)}}),await d.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete(v)}})(),this.r.set(v,D)),D}async updateProfile(r,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(D=>D.id===r.id);if(!f)throw new Error(`Profile '${r.name}' does not exist`);return f=t(f.id,v.name??f.name,f.location,this.g,{shortName:v.shortName??f.shortName,icon:v.icon===null?void 0:v.icon??f.icon,transient:v.transient??f.isTransient,useDefaultFlags:v.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const v=this.profiles.find(D=>D.id===r.id);if(!v)throw new Error(`Profile '${r.name}' does not exist`);const f=[];this.m.fire({profile:v,join(D){f.push(D)}});try{await Promise.allSettled(f)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])v.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])v.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[v],[]);try{await this.u.del(v.cacheHome,{recursive:!0})}catch(D){(0,S.$el)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(r,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(D=>D.id===v.id);if(!f)throw new Error(`Profile '${v.name}' does not exist`);this.L(r,f)}unsetWorkspace(r,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,v)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(v=>v.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,v.resource))).map(v=>this.u.del(v.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(v=>!this.H(v));await Promise.allSettled(r.map(v=>this.removeProfile(v)))}getProfileForWorkspace(r){const v=this.G(r);return R.URI.isUri(v)?this.s.workspaces.get(v)??this.C.workspaces.get(v):this.s.emptyWindows.get(v)??this.C.emptyWindows.get(v)}G(r){return(0,m.$Di)(r)?r.uri:(0,m.$Ii)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,r.location))||[...this.s.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,r.location))||[...this.C.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,r.location))||[...this.C.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,r.location)))}I(r,v,f){const D=[...this.profiles,...r],p=[];this.s.profiles=[];for(let E of D)E.isDefault||v.some(k=>E.id===k.id)||(E=f.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):p.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(p),this.z=void 0,this.J(r,v,f)}J(r,v,f){this.h.fire({added:r,removed:v,updated:f,all:this.profiles})}L(r,v,f){f=v?.isTransient?!0:f,f||this.L(r,void 0,!0);const D=this.G(r),p=f?this.s:this.C;R.URI.isUri(D)?(p.workspaces.delete(D),v&&p.workspaces.set(D,v)):(p.emptyWindows.delete(D),v&&p.emptyWindows.set(D,v)),f||this.M()}M(){const r={};for(const[f,D]of this.C.workspaces.entries())r[f.toString()]=D.id;const v={};for(const[f,D]of this.C.emptyWindows.entries())v[f.toString()]=D.id;this.R({workspaces:r,emptyWindows:v}),this.z=void 0}N(r){const v={},f=this.D();if(r.workspaces)for(const[p,E]of Object.entries(r.workspaces)){const k=R.URI.parse(E);v[p]=this.w.extUri.isEqual(k,f.location)?f.id:this.w.extUri.basename(k)}const D={};if(r.emptyWindows)for(const[p,E]of Object.entries(r.emptyWindows)){const k=R.URI.parse(E);D[p]=this.w.extUri.isEqual(k,f.location)?f.id:this.w.extUri.basename(k)}return{workspaces:v,emptyWindows:D}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Cl=h,e.$Cl=h=Je([Ve(0,$.$Ai),Ve(1,S.$Zk),Ve(2,w.$xl),Ve(3,C.$Zj)],h);class s extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Dl=s}),define(ke[279],Se([1,0,8,4,3,59,18,195,5,278]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Zp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Yp=y,e.$1p=d,e.$3p=a,e.$Vp="__$__isNewStorageMarker",e.$Wp="__$__targetStorageMarker",e.$Xp=(0,$.$ti)("storageService");var N;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(N||(e.WillSaveStateReason=N={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function y(i){const n=i.get(e.$Wp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class w extends L.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:w.a}){super(),this.m=n,this.b=this.B(new M.$fe),this.c=this.B(new M.$fe),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$ce),this.onWillSaveState=this.f.event,this.h=this.B(new l.$Fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,u,o){return M.Event.filter(this.b.event,t=>t.scope===n&&(u===void 0||t.key===u),o)}n(){this.j.value=(0,l.$Jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,u){const{key:o,external:t}=u;if(o===e.$Wp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:o,target:this.J(n)[o],external:t})}w(n){this.f.fire({reason:n})}get(n,u,o){return this.P(u)?.get(n,o)}getBoolean(n,u,o){return this.P(u)?.getBoolean(n,o)}getNumber(n,u,o){return this.P(u)?.getNumber(n,o)}getObject(n,u,o){return this.P(u)?.getObject(n,o)}storeAll(n,u){this.y(()=>{for(const o of n)this.store(o.key,o.value,o.scope,o.target,u)})}store(n,u,o,t,h=!1){if((0,R.$cg)(u)){this.remove(n,o,h);return}this.y(()=>{this.z(n,o,t),this.P(o)?.set(n,u,h)})}remove(n,u,o=!1){this.y(()=>{this.z(n,u,void 0),this.P(u)?.delete(n,o)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,u){const o=[],t=this.J(n);for(const h of Object.keys(t))t[h]===u&&o.push(h);return o}z(n,u,o,t=!1){const h=this.J(u);typeof o=="number"?h[n]!==o&&(h[n]=o,this.P(u)?.set(e.$Wp,JSON.stringify(h),t)):typeof h[n]=="number"&&(delete h[n],this.P(u)?.set(e.$Wp,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const u=this.P(n);return u?y(u):Object.create(null)}isNew(n){return this.getBoolean(e.$Vp,n)===!0}async flush(n=N.NONE){this.f.fire({reason:n});const u=this.P(-1),o=this.P(0),t=this.P(1);switch(n){case N.NONE:await l.Promises.settled([u?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case N.SHUTDOWN:await l.Promises.settled([u?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(n,u,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,u){return this.w(N.NONE),(0,S.$yl)(n)?this.R(n,u):this.S(n,u)}M(n,u){return!(n.id===u.id||d(u)&&d(n))}N(n,u,o){this.y(()=>{const t=new Set;for(const[h,s]of n)t.add(h),u.get(h)!==s&&this.u(o,{key:h,external:!0});for(const[h]of u.items)t.has(h)||this.u(o,{key:h,external:!0})})}}e.$Zp=w;function d(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class g extends w{constructor(){super(),this.U=this.B(new b.$Tp(new b.$Up,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Tp(new b.$Up,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Tp(new b.$Up,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$2p=g;async function a(i,n,u,o,t,h){const s=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,r=new Map;i.forEach((P,I)=>{c.set(I,P),r.set(I,s(P))});const v=new Map,f=new Map;n.forEach((P,I)=>{v.set(I,P),f.set(I,s(P))});const D=new Map,p=new Map;u.forEach((P,I)=>{D.set(I,P),p.set(I,s(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const E=[];if(c.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(r),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];v.forEach((I,T)=>{P.push({key:T,value:I})}),console.table(P),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${h})`);const k=[];D.forEach((P,I)=>{k.push({key:I,value:P})}),console.table(k),console.groupEnd(),console.log(p)}}),define(ke[111],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;class l{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const A=this.c++;return this.b.set(A,L),this.e(),A}get(L,A){return this.b.has(L)?this.b.get(L)[A]:void 0}delete(L){this.b.delete(L),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ckc=l}),define(ke[60],Se([1,0,15,23,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;class A{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new M.$Vg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Hkc=A,e.$Ikc=(0,L.$ti)("IExtHostFileSystemInfo")}),define(ke[28],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0,e.$xP=(0,l.$ti)("IExtHostInitDataService")}),define(ke[280],Se([1,0,222,12,260,28]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;let R=class extends L.$FQ{constructor($,S,N){const C=N.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=N.remote.isRemote?(0,l.localize)(0,null):$?(0,l.localize)(1,null):(0,l.localize)(2,null);super(S.createLogger(C,{name:m}))}};e.$Omc=R,e.$Omc=R=Je([Ve(1,M.$1j),Ve(2,A.$xP)],R)}),define(ke[281],Se([1,0,8]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$nlc=void 0;class M{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new l.$Fh(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of S.values())N.complete()}catch(N){for(const C of S.values())C.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const S=new l.$Qh;return this.h.set(R,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$nlc=M;class L extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$olc=L}),define(ke[282],Se([1,0,4,2]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class L{constructor(R){this.c=R,this.a=new l.$ce,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$ce,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,S){const C=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(b.value,$,S);this.b.fire(C)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$cmc=L}),define(ke[20],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0,e.$hP=(0,l.$ti)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$iP=M}),define(ke[283],Se([1,0,25,4]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class L{#e;constructor(R,b){this.b=new M.$ce,this.onDidChange=this.b.event,this.a=l.$Om.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$xlc=L}),define(ke[67],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,l.$ti)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Ykc=M}),define(ke[284],Se([1,0,21]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tob=L,e.$uob=R;class M{constructor(){this.buffers=[]}add($){let S=this.buffers.indexOf($);return S<0&&(S=this.buffers.length,this.buffers.push($)),S}}function L(b,$){if($.serializeBuffersForPostMessage){const S=new M,C=JSON.stringify(b,(y,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(w)};if(ArrayBuffer.isView(w)){const d=A(w);if(d)return{$$vscode_array_buffer_reference$$:!0,index:S.add(w.buffer),view:{type:d,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),m=S.buffers.map(y=>{const w=new Uint8Array(y);return l.$De.wrap(w)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const S=$.map(m=>{const y=new ArrayBuffer(m.byteLength);return new Uint8Array(y).set(m.buffer),y}),N=$.length?(m,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const w=y,{index:d}=w,g=S[d];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(b,N),arrayBuffers:S}}}),define(ke[285],Se([1,0,286,397,398,63,2,12,399]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=N;const S=!1;function N(n,u,o,t,h,s){const c=s.environment.useHostProxy,r=typeof c=="boolean"?c:!s.remote.isRemote,v={resolveProxy:p=>n.resolveProxy(p),lookupProxyAuthorization:g.bind(void 0,t,h,u,{},s.remote.isRemote),getProxyURL:()=>u.getConfiguration("http").get("proxy"),getProxySupport:()=>u.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(u),addCertificatesV2:()=>y(u),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return E(p)}function E(k){return t.error("Unknown log level",k),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,loadAdditionalCertificates:async()=>{const p=[];if(s.remote.isRemote&&p.push((0,$.loadSystemCertificates)({log:t})),r){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=n.loadCertificates();E.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),p.push(E)}return(await Promise.all(p)).flat()},env:process.env},f=(0,$.createProxyResolver)(v),D=C(v,f);return d(o,D)}function C(n,u){return{http:Object.assign(l,(0,$.createHttpPatch)(n,l,u)),https:Object.assign(M,(0,$.createHttpPatch)(n,M,u)),net:Object.assign(A,(0,$.createNetPatch)(n,A)),tls:Object.assign(L,(0,$.createTlsPatch)(n,L))}}function m(n){const u=n.getConfiguration("http");return!u.get("experimental.systemCertificatesV2",S)&&!!u.get("systemCertificates")}function y(n){const u=n.getConfiguration("http");return!!u.get("experimental.systemCertificatesV2",S)&&!!u.get("systemCertificates")}const w=new Map;function d(n,u){return n.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(c,r,v){if(c==="net")return u.net;if(c==="tls")return u.tls;if(c!=="http"&&c!=="https")return h.apply(this,arguments);const f=o.findSubstr(R.URI.file(r.filename));let D=w.get(f);if(D||w.set(f,D={}),!D[c]){const p=u[c];D[c]={...p}}return D[c]}})}async function g(n,u,o,t,h,s,c,r){const v=t[s];c&&(t[s]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${v}`);const f=c||v,D=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(i(u,D,h),D.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const p=await new Promise((T,j)=>{le(["kerberos"],T,j)}),E=new URL(s),k=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${k}`),"Negotiate "+await(await p.initializeClient(k)).step("")}catch(p){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let a=!1;function i(n,u,o){a||!u.length||(a=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:u.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[287],Se([1,0,133]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=L;function M(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function L(A){return new l.$vn(M(A))}}),define(ke[142],Se([1,0,232,18,2,3,5,38,33,15,47,187,41]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$FF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$wF=e.EditorInputCapabilities=e.$vF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=void 0,e.$mF=d,e.$nF=g,e.$oF=a,e.$pF=i,e.$qF=n,e.$rF=u,e.$sF=o,e.$tF=t,e.$uF=h,e.$xF=D,e.$yF=E,e.$zF=k,e.$AF=P,e.$BF=I,e.$CF=T,e.$DF=j,e.$EF=Z,e.$GF=x,e.$HF=ge,e.$IF=ue,e.$JF=ve,e.$hF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$iF={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$jF="workbench.editor.sidebysideEditor",e.$kF="workbench.editors.textDiffEditor",e.$lF="workbench.editors.binaryResourceDiffEditor";var y;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var w;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function d(te){const U=te;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(te){const U=te;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function a(te,U,_){for(const pe of _.visibleEditorPanes)if(pe.group.id===U&&te.matches(pe.input))return pe.getViewState()}function i(te){if(D(te))return!1;const U=te;return L.URI.isUri(U?.resource)}function n(te){if(D(te))return!1;const U=te;return U?.original!==void 0&&U.modified!==void 0}function u(te){if(D(te))return!1;const U=te;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function o(te){if(D(te)||n(te))return!1;const U=te;return U?.primary!==void 0&&U.secondary!==void 0}function t(te){if(D(te))return!1;const U=te;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function h(te){if(D(te))return!1;const U=te;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var s;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var c;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class r{constructor(){this.a=new Map}registerSource(U,_){let pe=this.a.get(U);return pe||(pe={source:U,label:_},this.a.set(U,pe)),pe.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$vF=new r;var v;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class f extends A.$Vc{}e.$wF=f;function D(te){return te instanceof f}function p(te){const U=te;return L.URI.isUri(U?.preferredResource)}function E(te){const U=te;return D(U?.primary)&&D(U?.secondary)}function k(te){const U=te;return D(U?.modified)&&D(U?.original)}function P(te,U,_,pe,Pe){return ve(pe,[(0,C.$dj)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const se={..._,limits:{size:Number.MAX_VALUE}};te.openEditor(U,se)}}),(0,C.$dj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function I(te){return D(te?.editor)}function T(te){const U=te;return I(te)&&U?.group!==void 0}function j(te){const U=te;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",te[te.EDITOR_STICKY=12]="EDITOR_STICKY",te[te.EDITOR_DIRTY=13]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var F;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class B{getOriginalUri(U,_){if(!U)return;if(h(U))return e.$FF.getOriginalUri(U.result,_);if(_?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(_?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===F.ANY)return this.getOriginalUri(Pe,{filterByScheme:_.filterByScheme})??this.getOriginalUri(se,{filterByScheme:_.filterByScheme});U=_.supportSideBySide===F.PRIMARY?Pe:se}}if(n(U)||u(U)||o(U)||h(U))return;const pe=p(U)?U.preferredResource:U.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}a(U){return E(U)||o(U)?{primary:U.primary,secondary:U.secondary}:k(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,_){if(!U)return;if(h(U))return e.$FF.getCanonicalUri(U.result,_);if(_?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(_?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===F.ANY)return this.getCanonicalUri(Pe,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:_.filterByScheme});U=_.supportSideBySide===F.PRIMARY?Pe:se}}if(n(U)||u(U)||o(U)||h(U))return;const pe=U.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}b(U,_){if(Array.isArray(_)){if(_.some(pe=>U.scheme===pe))return U}else if(_===U.scheme)return U}}var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Z(te,U,_,pe){if(!te.isSticky(U))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return _===W.MOUSE||_===W.KEYBOARD;case"mouse":return _===W.MOUSE;case"keyboard":return _===W.KEYBOARD}return!1}e.$FF=new B;var X;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(U){const _=this.a=U.get(R.$si);for(const[pe,Pe]of this.c)this.e(pe,Pe,_);this.c.clear()}e(U,_,pe){const Pe=pe.createInstance(_);this.d.set(U,Pe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,M.$eg)(this.b)}registerEditorSerializer(U,_){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,_,this.a):this.c.set(U,_),(0,A.$Tc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$_n.add(e.$hF.EditorFactory,new Y);async function x(te,U,_){return!te||!te.length?[]:await Promise.all(te.map(async pe=>{const Pe=L.URI.revive(pe.fileUri);if(!Pe){_.info("Cannot resolve the path because it is not valid.",pe);return}if(!await U.canHandleResource(Pe)){_.info("Cannot resolve the path because it cannot be handled",pe);return}let re=pe.exists,oe=pe.type;if(typeof re!="boolean"||typeof oe!="number")try{oe=(await U.stat(Pe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,re=!0}catch(ie){_.error(ie),re=!1}if(!re&&pe.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",pe);return}if(oe===$.FileType.Directory){_.info("Cannot resolve the path because it is a directory",pe);return}const K={...pe.options,pinned:!0};return re?{resource:Pe,options:K}:{resource:Pe,options:K,forceUntitled:!0}}))}var ne;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function ge(te){const U=te;if(!U)return!1;const _=U;if(_.modified)return ge(_.modified);const pe=U;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ue(te){return(0,N.$fj)(te)}function ve(te,U,_){const pe=(0,N.$gj)(te,U);return pe.forceMessage=_?.forceMessage,pe.forceSeverity=_?.forceSeverity,pe.allowDialog=_?.allowDialog,pe}}),define(ke[288],Se([1,0,4,233,5,3,27,38,19,24,78,274]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$PF=e.ViewContentGroups=e.$NF=e.ViewContainerLocation=e.Extensions=e.$MF=e.$LF=e.$KF=void 0,e.$OF=w,e.$KF="views",e.$LF=(0,M.localize)(0,null),e.$MF=(0,C.$7w)("default-view-icon",N.$Sj.window,(0,M.localize)(1,null));var m;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var y;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$NF=[0,1,2];function w(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class d extends A.$Vc{constructor(){super(...arguments),this.c=this.B(new l.$ce),this.onDidRegister=this.c.event,this.f=this.B(new l.$ce),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,c,r){const v=this.get(s.id);if(v)return v;const f=s;return f.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,R.$yc)(this.g,c,[]).push(f),r?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:c}),f}deregisterViewContainer(s){for(const c of this.g.keys()){const r=this.g.get(c),v=r?.indexOf(s);if(v!==-1){r?.splice(v,1),r.length===0&&this.g.delete(c),this.f.fire({viewContainer:s,viewContainerLocation:c});return}}}get(s){return this.all.filter(c=>c.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(r=>r?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(c=>this.getViewContainerLocation(c)===s)}}b.$_n.add(m.ViewContainersRegistry,new d);var g;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(g||(e.ViewContentGroups=g={}));function a(h,s){const c=h.group??g.More,r=s.group??g.More;return c!==r?c.localeCompare(r):(h.order??5)-(s.order??5)}class i extends A.$Vc{constructor(){super(...arguments),this.c=this.B(new l.$ce),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$ce),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$ce),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$ce),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Ic}registerViews(s,c){this.registerViews2([{views:s,viewContainer:c}])}registerViews2(s){s.forEach(({views:c,viewContainer:r})=>this.r(c,r)),this.c.fire(s)}deregisterViews(s,c){const r=this.s(s,c);r.length&&this.f.fire({views:r,viewContainer:c})}moveViews(s,c){for(const r of this.m.keys())if(r!==c){const v=this.s(s,r);v.length&&(this.r(v,c),this.g.fire({views:v,from:r,to:c}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const c of this.j){const r=(this.m.get(c)||[]).filter(v=>v.id===s)[0];if(r)return r}return null}getViewContainer(s){for(const c of this.j)if((this.m.get(c)||[]).filter(v=>v.id===s)[0])return c;return null}registerViewWelcomeContent(s,c){return this.n.add(s,c),this.h.fire(s),(0,A.$Tc)(()=>{this.n.delete(s,c),this.h.fire(s)})}registerViewWelcomeContent2(s,c){const r=new Map;for(const[v,f]of c)this.n.add(s,f),r.set(v,(0,A.$Tc)(()=>{this.n.delete(s,f),this.h.fire(s)}));return this.h.fire(s),r}getViewWelcomeContent(s){const c=[];return this.n.forEach(s,r=>c.push(r)),c.sort(a)}r(s,c){let r=this.m.get(c);r||(r=[],this.m.set(c,r),this.j.push(c));for(const v of s){if(this.getView(v.id)!==null)throw new Error((0,M.localize)(2,null,v.id));r.push(v)}}s(s,c){const r=this.m.get(c);if(!r)return[];const v=[],f=[];for(const D of r)s.includes(D)?v.push(D):f.push(D);return v.length&&(f.length?this.m.set(c,f):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),v}}b.$_n.add(m.ViewsRegistry,new i),e.$PF=(0,L.$ti)("viewDescriptorService");var n;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var u;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(u||(e.TreeItemCollapsibleState=u={}));class o{constructor(s,c){this.c=!1,this.d=!1,(0,S.$3n)(this,s),this.d=!!c,this.resolve=async r=>{if(c&&!this.c){const v=await c(r);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$QF=o;class t extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$RF=t}),define(ke[289],Se([1,0,234,37]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0,e.$VF=new M.$Kj("chatSessionResponseVote","",{type:"string",description:(0,l.localize)(0,null)}),e.$WF=new M.$Kj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,l.localize)(1,null)}),e.$XF=new M.$Kj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,l.localize)(2,null)}),e.$YF=new M.$Kj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,l.localize)(3,null)}),e.$ZF=new M.$Kj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,l.localize)(4,null)}),e.$1F=new M.$Kj("chatResponse",!1,{type:"boolean",description:(0,l.localize)(5,null)}),e.$2F=new M.$Kj("chatRequest",!1,{type:"boolean",description:(0,l.localize)(6,null)}),e.$3F=new M.$Kj("chatInputHasText",!1,{type:"boolean",description:(0,l.localize)(7,null)}),e.$4F=new M.$Kj("chatInputHasFocus",!1,{type:"boolean",description:(0,l.localize)(8,null)}),e.$5F=new M.$Kj("inChatInput",!1,{type:"boolean",description:(0,l.localize)(9,null)}),e.$6F=new M.$Kj("inChat",!1,{type:"boolean",description:(0,l.localize)(10,null)}),e.$7F=new M.$Kj("chatIsEnabled",!1,{type:"boolean",description:(0,l.localize)(11,null)}),e.$8F=new M.$Kj("chatCursorAtTop",!1),e.$9F=new M.$Kj("chatInputHasAgent",!1),e.$0F=new M.$Kj("chatLocation",void 0)}),define(ke[290],Se([1,0,4,39,3,37,5,289]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.$8G=e.ChatAgentLocation=void 0;var $;(function(C){C.Panel="panel",C.Terminal="terminal",C.Notebook="notebook",C.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(C){function m(y){switch(y){case"panel":return C.Panel;case"terminal":return C.Terminal;case"notebook":return C.Notebook;case"editor":return C.Editor}return C.Panel}C.fromRaw=m}($||(e.ChatAgentLocation=$={})),e.$8G=(0,R.$ti)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor(m){this.f=m,this.b=[],this.d=new l.$ce,this.onDidChangeAgents=this.d.event,this.e=b.$7F.bindTo(this.f)}registerAgent(m,y){if(this.getAgent(m))throw new Error(`Agent already registered: ${JSON.stringify(m)}`);const d=this,g=y.slashCommands;y={...y,get slashCommands(){return g.filter(i=>!i.when||d.f.contextMatchesRules(A.$rj.deserialize(i.when)))}};const a={data:y};return this.b.push(a),(0,L.$Tc)(()=>{this.b=this.b.filter(i=>i!==a),this.d.fire(void 0)})}registerAgentImplementation(m,y){const w=this.g(m);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(m)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(m)}`);return w.data.isDefault&&this.e.set(!0),w.impl=y,this.d.fire(new N(w.data,y)),(0,L.$Tc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(m,y){const w={data:m,impl:y};return this.b.push(w),this.d.fire(new N(m,y)),(0,L.$Tc)(()=>{this.b=this.b.filter(d=>d!==w),this.d.fire(void 0)})}updateAgent(m,y){const w=this.g(m);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(m)} registered`);w.data.metadata={...w.data.metadata,...y},this.d.fire(new N(w.data,w.impl))}getDefaultAgent(m){return this.getActivatedAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getContributedDefaultAgent(m){return this.getAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getSecondaryAgent(){return M.Iterable.find(this.b.values(),m=>!!m.data.metadata.isSecondary)?.data}g(m){return this.b.find(y=>y.data.id===m)}getAgent(m){return this.g(m)?.data}getAgents(){return this.b.map(m=>m.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(m=>!!m.impl).map(m=>new N(m.data,m.impl))}getAgentsByName(m){return this.getAgents().filter(y=>y.name===m)}async invokeAgent(m,y,w,d,g){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return await a.impl.invoke(y,w,d,g)}async getFollowups(m,y,w,d,g){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return a.impl?.provideFollowups?a.impl.provideFollowups(y,w,d,g):[]}};e.$9G=S,e.$9G=S=Je([Ve(0,A.$Lj)],S);class N{constructor(m,y){this.b=m,this.d=y}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(m,y,w,d){return this.d.invoke(m,y,w,d)}async provideFollowups(m,y,w,d){return this.d.provideFollowups?this.d.provideFollowups(m,y,w,d):[]}provideWelcomeMessage(m,y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(m,y)}provideSampleQuestions(m,y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(m,y)}}e.$0G=N}),define(ke[291],Se([1,0,2,29,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=e.$eG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$cG=A,e.$dG=R;function A(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof l.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(M.$pt.isIRange)}function R(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(A)}var b;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$eG=(0,L.$ti)("IChatService"),e.$fG="accessibility.voice.keywordActivation"}),define(ke[143],Se([1,0,4,8,235]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ob=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new l.$ce,this.o=new l.$ce,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,S,N){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.u("request",C),typeof N=="number"){const m=setTimeout(()=>{clearTimeout(m);const y=this.f.get(C.seq);if(y){this.f.delete(C.seq);const w={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,L.localize)(0,null,N,b)};y(w)}},N)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,M.$uh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,S=this.f.get($.request_seq);S&&(this.f.delete($.request_seq),S($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,S)=>b.set(S,$)),await(0,M.$uh)(500),b.forEach(($,S)=>{$({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$1ob=A}),define(ke[292],Se([1,0,2,236,37,5]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$nJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$lJ=e.MemoryRangeType=e.State=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=void 0,e.$kJ=$,e.$mJ=N,e.$$H="workbench.view.debug",e.$_H="workbench.debug.variablesView",e.$aI="workbench.debug.watchExpressionsView",e.$bI="workbench.debug.callStackView",e.$cI="workbench.debug.loadedScriptsView",e.$dI="workbench.debug.breakPointsView",e.$eI="workbench.debug.disassemblyView",e.$fI="workbench.panel.repl",e.$gI="workbench.panel.repl.view",e.$hI=new L.$Kj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$iI=new L.$Kj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$jI=new L.$Kj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$kI="debugUx",e.$lI=new L.$Kj(e.$kI,"default",{type:"string",description:M.localize(3,null)}),e.$mI=new L.$Kj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$nI=new L.$Kj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$oI=new L.$Kj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$pI=new L.$Kj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$qI=new L.$Kj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$rI=new L.$Kj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$sI=new L.$Kj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$tI=new L.$Kj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$uI=new L.$Kj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$vI=new L.$Kj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$wI=new L.$Kj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$xI=new L.$Kj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$yI=new L.$Kj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$zI=new L.$Kj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$AI=new L.$Kj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$BI=new L.$Kj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$CI=new L.$Kj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$DI=new L.$Kj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$EI=new L.$Kj("breakpointItemBytes",void 0,{type:"boolean",description:M.localize(22,null)}),e.$FI=new L.$Kj("breakpointHasModes",!1,{type:"boolean",description:M.localize(23,null)}),e.$GI=new L.$Kj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(24,null)}),e.$HI=new L.$Kj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(25,null)}),e.$II=new L.$Kj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(26,null)}),e.$JI=new L.$Kj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(27,null)}),e.$KI=new L.$Kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(28,null)}),e.$LI=new L.$Kj("stepBackSupported",!1,{type:"boolean",description:M.localize(29,null)}),e.$MI=new L.$Kj("restartFrameSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$NI=new L.$Kj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(31,null)}),e.$OI=new L.$Kj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(32,null)}),e.$PI=new L.$Kj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(33,null)}),e.$QI=new L.$Kj("breakpointsExist",!1,{type:"boolean",description:M.localize(34,null)}),e.$RI=new L.$Kj("debuggersAvailable",!1,{type:"boolean",description:M.localize(35,null)}),e.$SI=new L.$Kj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(36,null)}),e.$TI=new L.$Kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(37,null)}),e.$UI=new L.$Kj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$VI=new L.$Kj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$WI=new L.$Kj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$XI=new L.$Kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$YI=new L.$Kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$ZI=new L.$Kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(43,null)}),e.$1I=new L.$Kj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(44,null)}),e.$2I=new L.$Kj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(45,null)}),e.$3I=new L.$Kj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(46,null)}),e.$4I=new L.$Kj("variableIsReadonly",!1,{type:"boolean",description:M.localize(47,null)}),e.$5I=new L.$Kj("variableValue",!1,{type:"string",description:M.localize(48,null)}),e.$6I=new L.$Kj("variableType",!1,{type:"string",description:M.localize(49,null)}),e.$7I=new L.$Kj("variableInterfaces",!1,{type:"array",description:M.localize(50,null)}),e.$8I=new L.$Kj("variableName",!1,{type:"string",description:M.localize(51,null)}),e.$9I=new L.$Kj("variableLanguage",!1,{type:"string",description:M.localize(52,null)}),e.$0I=new L.$Kj("variableExtensionId",!1,{type:"string",description:M.localize(53,null)}),e.$$I=new L.$Kj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(54,null)}),e.$_I=new L.$Kj("multiSessionRepl",!1,{type:"boolean",description:M.localize(55,null)}),e.$aJ=new L.$Kj("multiSessionDebug",!1,{type:"boolean",description:M.localize(56,null)}),e.$bJ=new L.$Kj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(57,null)}),e.$cJ=new L.$Kj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(58,null)}),e.$dJ=new L.$Kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(59,null)}),e.$eJ=new L.$Kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(60,null)});const R=n=>M.localize(61,null,n);e.$fJ=R,e.$gJ="editor.contrib.debug",e.$hJ="editor.contrib.breakpoint",e.$iJ="debug",e.$jJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$lJ="vscode-debug-memory";function N(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var C;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var m;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var y;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$nJ=(0,A.$ti)("debugService");var w;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var d;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(d||(e.DebugVisualizationType=d={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var a;(function(n){n.deserialize=u=>u,n.serialize=u=>u})(a||(e.IDebugVisualizationTreeItem=a={}));var i;(function(n){n.deserialize=u=>({id:u.id,name:u.name,iconPath:u.iconPath&&{light:l.URI.revive(u.iconPath.light),dark:l.URI.revive(u.iconPath.dark)},iconClass:u.iconClass,visualization:u.visualization}),n.serialize=u=>u})(i||(e.IDebugVisualization=i={}))}),define(ke[293],Se([1,0,14,2,17,24,15,29,22,19]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=void 0,e.$aH=C,e.$bH=m,e.$cH=y,e.$dH=w,e.$eH=d,e.$fH=g,e.$gH=a,e.$hH=n,e.$iH=t,e.$jH=h,e.$kH=c,e.$lH=v;const N=/{([^}]+)}/g;function C(D,p,E){return D.replace(N,function(k,P){return p&&P.length>0&&P[0]!=="_"?k:E&&E.hasOwnProperty(P)?E[P]:k})}function m(D){const p={};for(const E of Object.keys(D))E.startsWith("!")||(p[E]=D[E]);return p}function y(D){return D.configuration.request==="attach"&&!w(D)&&(!D.parentSession||y(D.parentSession))}function w(D){let p=D.configuration.type;if(p)return p==="vslsShare"&&(p=D.configuration.adapterProxy.configuration.type),(0,l.$vf)(p,"extensionhost")||(0,l.$vf)(p,"pwa-extensionhost")?D:D.parentSession?w(D.parentSession):void 0}function d(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,p,E){let k,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=I.exec(D);){const j=T.index+1,z=j+T[0].length;if(j<=p&&z>=E){k=T[0],P=j;break}}if(k){const j=/\w+/g;let z=null;for(;(z=j.exec(k))&&!(z.index+1+P+z[0].length>=E););z&&(k=k.substring(0,j.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}async function a(D,p,E,k){if(D.evaluatableExpressionProvider.has(p)){const P=D.evaluatableExpressionProvider.ordered(p),I=(0,S.$Hb)(await Promise.all(P.map(async T=>{try{return await T.provideEvaluatableExpression(p,E,k??$.CancellationToken.None)}catch{return}})));if(I.length>0){let T=I[0].expression;const j=I[0].range;return T||(T=p.getLineContent(E.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:T}}}else{const P=p.getLineContent(E.lineNumber),{start:I,end:T}=g(P,E.column,E.column),j=P.substring(I-1,T);return{matchingExpression:j,range:new b.$pt(E.lineNumber,I,E.lineNumber,I+j.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}function u(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return M.URI.parse(D.path);if((0,L.$jc)(D.path))return M.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const p=M.URI.revive(D.path);if(p)return p.scheme===R.Schemas.file?p.fsPath:p.toString()}return D.path}function t(D,p){const E=p?u:o,k=(0,A.$Zn)(D);return s(k,(P,I)=>{P&&I&&(I.path=E(I))}),k}function h(D,p){const E=p?u:o,k=(0,A.$Zn)(D);return s(k,(P,I)=>{!P&&I&&(I.path=E(I))}),k}function s(D,p){switch(D.type){case"event":{const E=D;switch(E.event){case"output":p(!1,E.body.source);break;case"loadedSource":p(!1,E.body.source);break;case"breakpoint":p(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=D;switch(E.command){case"setBreakpoints":p(!0,E.arguments.source);break;case"breakpointLocations":p(!0,E.arguments.source);break;case"source":p(!0,E.arguments.source);break;case"gotoTargets":p(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>p(!1,k));break;default:break}break}case"response":{const E=D;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>p(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>p(!1,k));break;case"scopes":E.body.scopes.forEach(k=>p(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>p(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>p(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(P=>p(!1,P.location));break;default:break}break}}}function c(D){return D.filter(p=>!p.presentation?.hidden).sort((p,E)=>p.presentation?E.presentation?p.presentation.group?E.presentation.group?p.presentation.group!==E.presentation.group?p.presentation.group.localeCompare(E.presentation.group):r(p.presentation.order,E.presentation.order):-1:E.presentation.group?1:r(p.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function r(D,p){return typeof D!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:D-p}async function v(D,p){const E=D.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(E!=="none"&&(await p.saveAll(),E==="allEditorsInActiveGroup")){const k=p.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await p.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}const f=(D,p)=>!D||!p?D===p:D.name===p.name&&D.path===p.path&&D.sourceReference===p.sourceReference;e.$mH=f}),define(ke[294],Se([1,0,53,63,24,17,11,14,32,237,143]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=e.$Xmc=e.$Wmc=e.$Vmc=e.$Umc=void 0;class C extends N.$1ob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",n=>this.v(n))}sendMessage(a){if(this.l){const i=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(C.a);if(i!==-1){const u=this.p.toString("utf8",0,i).split(C.b);for(const o of u){const t=o.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+C.a.length);continue}}break}}}e.$Umc=C;class m extends C{startSession(){return new Promise((a,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",u=>{n?this.n.fire(u):i(u)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Vmc=m;class y extends m{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$Wmc=y;class w extends m{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.path,a)}}e.$Xmc=w;class d extends C{constructor(a,i){super(),this.y=a,this.z=i}async startSession(){const a=this.y.command,i=this.y.args,n=this.y.options||{};try{if(a)if(A.$jc(a)){if(!await $.Promises.exists(a))throw new Error(S.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let u=process.env;if(n.env&&Object.keys(n.env).length>0&&(u=L.$3n(L.$Zn(process.env),n.env)),a==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:u,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const h=l.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(S.localize(2,null,i[0]));this.x=h}else throw new Error(S.localize(3,null));else{const o={env:u};n.cwd&&(o.cwd=n.cwd),this.x=l.spawn(a,i,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(u){this.n.fire(u)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((a,i)=>{const n=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(u,o,t){if(u)return i(u)});n.on("exit",a),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,i){if(!a)return;const n=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?n.runtime=A.$kc(i,a.runtime):n.runtime=a.runtime),a.runtimeArgs&&(n.runtimeArgs=a.runtimeArgs),a.program&&(A.$jc(a.program)?n.program=a.program:n.program=A.$kc(i,a.program)),a.args&&(n.args=a.args);const u=a;return u.win&&(n.win=d.A(u.win,i)),u.winx86&&(n.winx86=d.A(u.winx86,i)),u.windows&&(n.windows=d.A(u.windows,i)),u.osx&&(n.osx=d.A(u.osx,i)),u.linux&&(n.linux=d.A(u.linux,i)),n}static platformAdapterExecutable(a,i){let n=Object.create(null);i=i.toLowerCase();for(const c of a)if(c.contributes){const r=c.contributes.debuggers;r&&r.length>0&&r.filter(v=>typeof v.type=="string"&&b.$vf(v.type,i)).forEach(v=>{const f=d.A(v,c.extensionLocation.fsPath);n=L.$3n(n,f,c.isBuiltin)})}let u;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=n.winx86||n.win||n.windows:R.$i?u=n.win||n.windows:R.$j?u=n.osx:R.$k&&(u=n.linux),u=u||n;const o=u.program||n.program,t=u.args||n.args,h=u.runtime||n.runtime,s=u.runtimeArgs||n.runtimeArgs;if(h)return{type:"executable",command:h,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Ymc=d}),define(ke[295],Se([1,0,53,31,11]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=R,e.$1mc=$;function A(S,N){return new Promise((C,m)=>{let y="";const w=l.spawn(S,N);w.pid&&w.stdout.on("data",d=>{y+=d.toString()}),w.on("error",d=>{m(d)}),w.on("close",d=>{C(y)})})}async function R(S){if(S)if(L.$i){const N=await new Promise((C,m)=>{le(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{N.getProcessTree(S,m=>{C(!!m&&m.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(S)]).then(N=>{const C=N.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},N=>!0);return Promise.resolve(!0)}var b;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(b||(b={}));function $(S,N,C,m,y){S=S.trim().toLowerCase();let w;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?w=1:S.indexOf("cmd.exe")>=0?w=0:S.indexOf("bash")>=0?w=2:L.$i?w=0:w=2;let d,g=" ";switch(w){case 1:if(d=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),m){const a=(0,M.$yg)(m);a&&(g+=`${a}:; `),g+=`cd ${d(m)}; `}if(y)for(const a in y){const i=y[a];i===null?g+=`Remove-Item env:${a}; `:g+=`\${env:${a}}='${i}'; `}if(N.length>0){const a=N.shift(),i=C?a:d(a);g+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of N)g+=n==="<"||n===">"||C?n:d(n),g+=" "}break;case 0:if(d=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),m){const a=(0,M.$yg)(m);a&&(g+=`${a}: && `),g+=`cd ${d(m)} && `}if(y){g+='cmd /C "';for(const a in y){let i=y[a];i===null?g+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),g+=`set "${a}=${i}" && `)}}for(const a of N)g+=a==="<"||a===">"||C?a:d(a),g+=" ";y&&(g+='"');break;case 2:{d=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(g+=`cd ${d(m)} ; `),y){g+="/usr/bin/env";for(const i in y){const n=y[i];n===null?g+=` -u ${a(i)}`:g+=` ${a(`${i}=${n}`)}`}g+=" "}for(const i of N)g+=i==="<"||i===">"||C?i:d(i),g+=" ";break}}return g}}),define(ke[296],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.CellExecutionUpdateType=void 0;var M;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$AK=(0,l.$ti)("INotebookExecutionService")}),define(ke[297],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uib=e.$Tib=e.ProxyKernelState=e.$Sib=void 0,e.$Sib=100;var M;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Tib=(0,l.$ti)("INotebookKernelService"),e.$Uib=(0,l.$ti)("INotebookKernelHistoryService")}),define(ke[298],Se([1,0,3,29,200,100]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MWb=void 0;class R extends l.$Vc{constructor($,S,N){super(),this._source=$,this.b=S,this.c=N,this.a=void 0}f($){const S=$.getLineCount();return new M.$pt(1,1,S,this.g($,S))}g($,S){if(S<1||S>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const $=new L.$QC;$.acceptChunk(this._source);const S=$.finish(!0),{textBuffer:N,disposable:C}=S.create(1);this.b=N,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const S=new L.$QC;S.acceptChunk($);const N=S.finish(!0),{textBuffer:C,disposable:m}=N.create(1);return this.B(m),C})),this.a}findInInputs($){const N=new A.$EC($,!1,!1,null).parseSearchRequest();if(!N)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,N,!0,5e3)}findInOutputs($){const N=new A.$EC($,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),N,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$MWb=R}),define(ke[68],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(A){A.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class L{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new L([b]);const S=[R.id];for(let N=$;N&&N.id!==b;N=N.parent)S.push(N.id);return S.push(b),new L(S.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new L(R.split("\0"))}static join(R,b){return new L([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:L.isChild(R,b)?2:L.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new L(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new L(this.path,R)}compare(R){if(typeof R=="string")return L.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$GL=L}),define(ke[89],Se([1,0,2,50,29,68]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$OL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$NL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ML=e.$LL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$KL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$JL=e.$IL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$HL=e.TestResultState=void 0;var R;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$HL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$IL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$JL=S;var N;(function(O){O.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),O.deserialize=(F,B)=>({range:L.$pt.lift(B.range),uri:F.asCanonicalUri(l.URI.revive(B.uri))})})(N||(e.IRichLocation=N={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&N.serialize(F.location)}),O.deserialize=(F,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&N.deserialize(F,B.location)})})(m||(e.ITestErrorMessage=m={}));const y=(O,F)=>`${F?"s":"e"}${O}`;e.$KL=y;var w;(function(O){O.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&N.serialize(F.location)}),O.deserialize=(F,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&N.deserialize(F,B.location)})})(w||(e.ITestOutputMessage=w={}));var d;(function(O){O.serialize=F=>F.type===0?m.serialize(F):w.serialize(F),O.deserialize=(F,B)=>B.type===0?m.deserialize(F,B):w.deserialize(F,B)})(d||(e.ITestMessage=d={}));var g;(function(O){O.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),O.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(d.serialize)}),O.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>d.deserialize(F,W))})})(g||(e.ITestTaskState=g={}));const a="\0",i=(O,F)=>O+a+F;e.$LL=i;const n=O=>{const F=O.indexOf(a);return{ctrlId:O.slice(0,F),tagId:O.slice(F+1)}};e.$ML=n;var u;(function(O){O.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),O.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(l.URI.revive(B.uri)):void 0,range:B.range?L.$pt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(u||(e.ITestItem=u={}));var o;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(O){O.serialize=F=>({expand:F.expand,item:u.serialize(F.item)}),O.deserialize=(F,B)=>({controllerId:A.$GL.root(B.item.extId),expand:B.expand,item:u.deserialize(F,B.item)})})(t||(e.InternalTestItem=t={}));var h;(function(O){O.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},O.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?L.$pt.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(h||(e.ITestItemUpdate=h={}));const s=(O,F)=>{F.expand!==void 0&&(O.expand=F.expand),F.item!==void 0&&(O.item=O.item?Object.assign(O.item,F.item):F.item)};e.$NL=s;var c;(function(O){O.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serializeWithoutMessages)}),O.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serialize)}),O.deserialize=(F,B)=>({...t.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>g.deserialize(F,W)),retired:!0})})(c||(e.TestResultItem=c={}));var r;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(r||(e.ICoverageCount=r={}));var v;(function(O){O.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),O.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:F.asCanonicalUri(l.URI.revive(B.uri))})})(v||(e.IFileCoverage=v={}));function f(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?M.$ot.isIPosition(O.location)?M.$ot.lift(O.location):L.$pt.lift(O.location):void 0,O}e.$OL=3;var p;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(p||(e.DetailType=p={}));var E;(function(O){O.serialize=F=>F.type===0?P.serialize(F):I.serialize(F),O.deserialize=F=>F.type===0?P.deserialize(F):I.deserialize(F)})(E||(e.CoverageDetails=E={}));var k;(function(O){O.serialize=f,O.deserialize=D})(k||(e.IBranchCoverage=k={}));var P;(function(O){O.serialize=f,O.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(O){O.serialize=F=>({...f(F),branches:F.branches?.map(k.serialize)}),O.deserialize=F=>({...D(F),branches:F.branches?.map(k.deserialize)})})(I||(e.IStatementCoverage=I={}));var T;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var j;(function(O){O.deserialize=(F,B)=>B.op===0?{op:B.op,item:t.deserialize(F,B.item)}:B.op===1?{op:B.op,item:h.deserialize(B.item)}:B.op===2?{op:B.op,uri:F.asCanonicalUri(l.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:h.serialize(F.item)}:F})(j||(e.TestsDiffOp=j={}));class z{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.v();for(const W of F)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(h.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(F,B){const W=A.$GL.parentId(F.item.extId)?.toString();let Z;if(!W)Z=this.w(F),this.g.add(Z),this.f.set(F.item.extId,Z);else if(this.f.has(W)){const X=this.f.get(W);X.children.add(F.item.extId),Z=this.w(F,X),this.f.set(F.item.extId,Z)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(Z),F.expand===2&&this.h++,Z}o(F,B){const W=this.f.get(F.extId);if(W)return F.expand!==void 0&&(W.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$NL)(W,F),B.update?.(W),W}p(F,B){const W=this.f.get(F);if(!W)return;const Z=A.$GL.parentId(W.item.extId)?.toString();Z?this.f.get(Z).children.delete(W.item.extId):this.g.delete(W);const X=[[F]];for(;X.length;)for(const Y of X.pop()){const x=this.f.get(Y);x&&(X.push(x.children),this.f.delete(Y),B.remove?.(x,x!==W),x.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$PL=z}),define(ke[112],Se([1,0,8,4,3,62,89,68]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const S=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:S,label:S,description:S,error:S,sortText:S,tags:(i,n)=>!(i.length!==n.length||i.some(u=>!n.includes(u)))}),m=(i,n)=>{let u;for(const[o,t]of C)t(i[o],n[o])||(u?u[o]=n[o]:u={[o]:n[o]});return u};class y extends L.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new l.$Fh(()=>this.flushDiff(),200)),this.g=this.B(new M.$ce),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===n.uri){u.docv=n.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===n.item.extId){(0,R.$NL)(u.item,n.item);return}if(u.op===0&&u.item.item.extId===n.item.extId){(0,R.$NL)(u.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,u){const o=this.tree.get(n);if(o){if((o.expandLevels===void 0||u>o.expandLevels)&&(o.expandLevels=u),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,u-1):t.wait().then(()=>this.L(o,u-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,u-1)):this.L(o,u-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,u){switch(u.op){case 3:this.O(b.$GL.joinToString(n.fullId,u.id));break;case 0:this.z(u.item,n);break;case 5:for(const o of u.ops)this.w(n,o);break;case 1:this.C(u.new,u.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:u.update}});break;case 6:this.y(n.actual.uri);break;default:(0,A.$dd)(u)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,u){const o=b.$GL.fromExtHostTestItem(n,this.root.id,u?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(n.id);let h=this.tree.get(o.toString());if(!h){h={fullId:o,actual:n,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(n,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(n)}}),this.I(n,h,u);return}if(h.actual===n){this.H(n,h,u);return}if(h.actual.uri?.toString()!==n.uri?.toString())return this.O(o.toString()),this.z(n,u);const s=this.s.getChildren(h.actual),c=h.actual,r=m(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,h.actual=n,h.resolveBarrier=void 0,h.expand=0,r&&(r.hasOwnProperty("tags")&&(this.C(n.tags,c.tags,o.toString()),delete r.tags),this.w(h,{op:4,update:r})),this.I(n,h,u);for(const[f,D]of s)this.s.getChildren(n).get(D.id)||this.O(b.$GL.joinToString(o,D.id));const v=h.expandLevels;v!==void 0&&queueMicrotask(()=>{h.expand===1&&(h.expandLevels=void 0,this.expand(o.toString(),v))}),this.y(h.actual.uri)}C(n,u,o){const t=new Set(u.map(h=>h.id));for(const h of n)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:o,item:{tags:n.map(h=>(0,R.$LL)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(n){const u=this.j.get(n.id);u?u.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$LL)(this.s.controllerId,n.id)}}))}F(n){const u=this.j.get(n);u&&!--u.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$LL)(this.s.controllerId,n)}))}G(n,u){this.s.getApiFor(n).parent=u&&u.actual!==this.root?u.actual:void 0}H(n,u,o){this.G(n,o);const t=this.s.getApiFor(n);t.parent=o?.actual,t.listener=h=>this.w(u,h),this.J(u)}I(n,u,o){this.H(n,u,o);for(const[t,h]of this.s.getChildren(n))this.z(h,u)}J(n){let u;this.h?n.resolveBarrier?u=n.resolveBarrier.isOpen()?3:2:u=n.actual.canResolveChildren?1:0:u=0,u!==n.expand&&(n.expand=u,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:u}}),u===1&&n.expandLevels!==void 0&&this.M(n))}L(n,u){if(u<0)return;const o=[];for(const[t,h]of this.s.getChildren(n.actual)){const s=this.expand(b.$GL.joinToString(n.fullId,h.id),u);(0,l.$fh)(s)&&o.push(s)}if(o.length)return Promise.all(o).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const h=new l.$sh;return h.open(),h}n.expand=2,this.N(n);const u=n.resolveBarrier=new l.$sh,o=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(h){o(h)}return(0,l.$fh)(t)?t.catch(o).then(()=>{u.open(),this.J(n)}):(u.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const u=this.tree.get(n);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const o=[u];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,s]of this.s.getChildren(t.actual))o.push(this.tree.get(b.$GL.joinToString(t.fullId,s.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$0O=y;class w extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$$O=w;class d extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_O=d;class g extends Error{constructor(n,u,o){super(`TestItem with ID "${n}" is from controller "${u}" and cannot be added as a child of an item from controller "${o}".`)}}e.$aP=g;const a=(i,n,u)=>{let o=new Map;return{get size(){return o.size},forEach(t,h){for(const s of o.values())t.call(h,s,this)},[Symbol.iterator](){return o.entries()},replace(t){const h=new Map,s=new Set(o.keys()),c={op:5,ops:[]};for(const r of t){if(!(r instanceof u))throw new d(r.id);const v=n(r).controllerId;if(v!==i.controllerId)throw new g(r.id,v,i.controllerId);if(h.has(r.id))throw new w(r.id);h.set(r.id,r),s.delete(r.id),c.ops.push({op:0,item:r})}for(const r of s.keys())c.ops.push({op:3,id:r});i.listener?.(c),o=h},add(t){if(!(t instanceof u))throw new d(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$bP=a}),define(ke[144],Se([1,0,112]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;const M=new WeakMap,L=(R,b)=>{const $={controllerId:b};return M.set(R,$),$};e.$cP=L;const A=R=>{const b=M.get(R);if(!b)throw new l.$_O(R?.id||"<unknown>");return b};e.$dP=A}),define(ke[113],Se([1,0,15,2]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iyb=e.$hyb=e.$gyb=void 0,e.$jyb=L,e.$kyb=R,e.$gyb="vscode-cdn.net",e.$hyb=`vscode-resource.${e.$gyb}`,e.$iyb=`'self' https://*.${e.$gyb}`;function L(b,$){return b.scheme===l.Schemas.http||b.scheme===l.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===l.Schemas.file&&(b=M.URI.from({scheme:l.Schemas.vscodeRemote,authority:$.authority,path:b.path})),M.URI.from({scheme:l.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.$hyb}`,path:b.path,fragment:b.fragment,query:b.query}))}function A(b){return b.replace(/./g,$=>{const S=$.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?$:"-"+S.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[299],Se([1,0,4,3,113]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class A{constructor(b,$,S){this.d=b,this.e=$,this.f=S,this.a=0,this.b=new M.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const N=$.getVisibleTextEditors();for(const C of this.c.values())N.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,S,N,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const y=this,w=this.a++,d=new l.$ce,g=new l.$ce,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,L.$jyb)(n,y.f)}get cspSource(){return L.$iyb}set options(n){this.b=n,y.d.$setOptions(w,n)}get options(){return this.b}set html(n){this.a=n,y.d.$setHtml(w,n)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(n){return y.d.$postMessage(w,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=S,this.webview=a,this.onDidDispose=g.event}dispose(){y.c.has(w)&&(y.c.delete(w),y.d.$disposeEditorInset(w),g.fire(),g.dispose(),d.dispose())}};return this.d.$createEditorInset(w,m.id,m.value.document.uri,$+1,S,N||{},C.identifier,C.extensionLocation),this.c.set(w,{editor:b,inset:i,onDidReceiveMessage:d}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Vkc=A}),define(ke[145],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.$WL=void 0,e.$WL="__",e.$XL=(0,l.$ti)("IAuthenticationService"),e.$YL=(0,l.$ti)("IAuthenticationExtensionsService")}),define(ke[300],Se([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.VariableKind=e.$6P=void 0,e.$6P=(0,l.$ti)("configurationResolverService");var M;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class L extends Error{constructor(R,b){super(b),this.variable=R}}e.$7P=L}),define(ke[301],Se([1,0,17,51,18,24,11,103,240,300,14]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,w,d,g){this.h=new Map,this.a=y,this.b=w,this.g=d,g&&(this.c=g.then(a=>this.i(a)))}i(y){if(R.$i){const w=Object.create(null);return Object.keys(y).forEach(d=>{w[d.toLowerCase()]=y[d]}),w}return y}resolveWithEnvironment(y,w,d){return this.l({env:this.i(y),userHome:void 0},w?w.uri:void 0,d)}async resolveAsync(y,w){const d={env:await this.c,userHome:await this.g};return this.l(d,y?y.uri:void 0,w)}async j(y,w,d,g){const a=A.$Zn(w);R.$i&&a.windows?Object.keys(a.windows).forEach(n=>a[n]=a.windows[n]):R.$j&&a.osx?Object.keys(a.osx).forEach(n=>a[n]=a.osx[n]):R.$k&&a.linux&&Object.keys(a.linux).forEach(n=>a[n]=a.linux[n]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,a,d,g)}async resolveAnyAsync(y,w,d){return this.j(y,w,d)}async resolveAnyMap(y,w,d){const g=new Map;return{newConfig:await this.j(y,w,d,g),resolvedVariables:g}}resolveWithInteractionReplace(y,w,d,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,w,d,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,w){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,w)}async l(y,w,d,g,a){if(L.$6f(d))return this.m(y,w,d,g,a);if(Array.isArray(d))return Promise.all(d.map(i=>this.l(y,w,i,g,a)));if(L.$8f(d)){const i=Object.create(null),n=await Promise.all(Object.keys(d).map(async u=>[await this.m(y,w,u,g,a),await this.l(y,w,d[u],g,a)]));for(const[u,o]of n)i[u]=o;return i}return d}m(y,w,d,g,a){return(0,N.$nf)(d,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let u=await this.o(y,i,n,w,g);return a?.set(n,u),u!==i&&L.$6f(u)&&u.match(C.VARIABLE_REGEXP)&&(u=await this.m(y,w,u,g,a)),u})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,w,d,g,a){let i;const n=d.split(":");n.length>1&&(d=n[0],i=n[1]);const u=h=>{const s=this.a.getFilePath();if(s)return(0,b.$tw)(s);throw new S.$7P(h,(0,$.localize)(0,null,w))},o=h=>{const s=u(h);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$tw)(c)}throw new S.$7P(h,(0,$.localize)(1,null,w,l.$oc(s)))},t=h=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new S.$7P(h,(0,$.localize)(2,null,w,i))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new S.$7P(h,(0,$.localize)(3,null,w)):new S.$7P(h,(0,$.localize)(4,null,w))};switch(d){case"env":if(i){if(y.env){const h=y.env[R.$i?i.toLowerCase():i];if(L.$6f(h))return h}return""}throw new S.$7P(S.VariableKind.Env,(0,$.localize)(5,null,w));case"config":if(i){const h=this.a.getConfigurationValue(g,i);if(L.$cg(h))throw new S.$7P(S.VariableKind.Config,(0,$.localize)(6,null,w,i));if(L.$8f(h))throw new S.$7P(S.VariableKind.Config,(0,$.localize)(7,null,w,i));return h}throw new S.$7P(S.VariableKind.Config,(0,$.localize)(8,null,w));case"command":return this.p(S.VariableKind.Command,w,i,a,"command");case"input":return this.p(S.VariableKind.Input,w,i,a,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new S.$7P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,w,i));return this.n(h.extensionLocation)}throw new S.$7P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,w));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,b.$tw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return g||i?(0,b.$tw)(this.n(t(S.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$tw)(l.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new S.$7P(S.VariableKind.UserHome,(0,$.localize)(11,null,w))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new S.$7P(S.VariableKind.LineNumber,(0,$.localize)(12,null,w))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new S.$7P(S.VariableKind.SelectedText,(0,$.localize)(13,null,w))}case"file":return u(S.VariableKind.File);case"fileWorkspaceFolder":return o(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$oc(o(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||i?l.$mc(this.n(t(S.VariableKind.RelativeFile)),u(S.VariableKind.RelativeFile)):u(S.VariableKind.RelativeFile);case"relativeFileDirname":{const h=l.$nc(u(S.VariableKind.RelativeFileDirname));if(g||i){const s=l.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),h);return s.length===0?".":s}return h}case"fileDirname":return l.$nc(u(S.VariableKind.FileDirname));case"fileExtname":return l.$pc(u(S.VariableKind.FileExtname));case"fileBasename":return l.$oc(u(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=l.$oc(u(S.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-l.$pc(h).length)}case"fileDirnameBasename":return l.$oc(l.$nc(u(S.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||w}case"execInstallFolder":{const h=this.a.getAppRoot();return h||w}case"pathSeparator":case"/":return l.sep;default:try{const h=i?`${d}:${i}`:d;return this.p(S.VariableKind.Unknown,w,h,a,void 0)}catch{return w}}}}p(y,w,d,g,a){if(d&&g){const i=a===void 0?g[d]:g[a+":"+d];if(typeof i=="string")return i;throw new S.$7P(y,(0,$.localize)(14,null,w))}return w}}e.$jQ=C}),define(ke[146],Se([1,0,5,142]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MD=void 0,e.$ND=S,e.$OD=m,e.$PD=y,e.$MD=(0,l.$ti)("editorGroupsService");var L;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var A;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function S(w){const d=w;return(0,M.$xF)(d?.editor)&&(0,M.$xF)(d?.replacement)}var N;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var C;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(w){const d=w;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}function y(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[302],Se([1,0,5,146]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=e.$SD=e.$RD=e.$QD=void 0,e.$UD=L,e.$QD=(0,l.$ti)("editorService"),e.$RD=-1,e.$SD=-2,e.$TD=-3;function L(A){const R=A;return typeof A=="number"||(0,M.$OD)(R)}}),define(ke[147],Se([1,0,5,136]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$fM=(0,l.$ui)(M.$Ai)}),define(ke[148],Se([1,0,25,4,17,3,8]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=e.$f_b=e.$e_b=e.$d_b=void 0;class b{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$d_b=b;class ${static isHostExtension(i,n,u){if(n.getExtensionDescription(i))return!1;const o=u.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,n){this.j=i,this.c=new M.$ce,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(d),this.f=new l.$Qm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const u of n)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=g(this.e,n),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=g(this.e,u.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,u)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const r=n.getArcs(s);for(let v=0;v<r.length;v++)if(!c.has(r[v]))return!1;return!0}getNodes(){return this.e}},u=new l.$Qm;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)n.addArc(l.$Om.toKey(s.identifier),l.$Om.toKey(c));const o=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>o.add(s));const t=n.getNodes().filter(s=>!o.has(s));let h;do{h=!1;for(let s=0;s<t.length;s++){const c=t[s];n.hasOnlyGoodArcs(c,o)&&(t.splice(s,1),s--,o.add(c),h=!0)}}while(h);return t.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$e_b=$;class S{constructor(i,n){this.versionId=i,this.extensions=n}}e.$f_b=S;class N{constructor(i){this.d=new y,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$g_b=N;class C extends A.$Vc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$h_b=C;class m{constructor(i){this.name=i;const n=(0,R.$mh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class y{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new m(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const u=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{n&&(clearTimeout(u),n=!1,this.d=!1,this.e())};i.resolve((0,A.$Tc)(o))}}var w;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(w||(w={}));function d(a,i){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==u)return n-u;const o=L.$hc.basename(a.extensionLocation.path),t=L.$hc.basename(i.extensionLocation.path);return o<t?-1:o>t?1:0}function g(a,i){const n=new l.$Pm(i);return a.filter(u=>!n.has(u.identifier))}}),define(ke[303],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.ExtHostConnectionType=void 0,e.$kn=b,e.$ln=$;var l;(function(N){N[N.IPC=1]="IPC",N[N.Socket=2]="Socket",N[N.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class M{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[M.ENV_KEY]=this.pipeName}}e.$hn=M;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$in=L;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[A.ENV_KEY]="1"}}e.$jn=A;function R(N){delete N[M.ENV_KEY],delete N[L.ENV_KEY],delete N[A.ENV_KEY]}function b(N,C){R(C),N.serialize(C)}function $(N){if(N[M.ENV_KEY])return S(N,new M(N[M.ENV_KEY]));if(N[L.ENV_KEY])return S(N,new L);if(N[A.ENV_KEY])return S(N,new A);throw new Error("No connection information defined in environment!")}function S(N,C){return R(N),C}}),define(ke[114],Se([1,0,21]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Wm=R,e.$Xm=b;var M;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(M||(e.UIKind=M={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var A;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(S){const N=l.$De.alloc(1);switch(S){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function b(S,N){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var $;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,12,28,114,86,87,24,2,3,225]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$zP=e.$yP=void 0,e.$AP=d;let y=class extends C.$Vc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new M.$ce),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$ce),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$hp,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$2j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,i,n){const u=this.getTelemetryDetails(),o=new w(i,n,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,n){this.f=a,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$Fm)((0,$.$np)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((n,u)=>{const o=n.filter(t=>!t.isDisposed);o.length===0?this.r.delete(u):this.r.set(u,o)}),this.r.forEach(n=>{for(const u of n)u.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const u=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(a.value),!1;let o=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.$yP=y,e.$yP=y=Je([Ve(0,A.$xP),Ve(1,L.$1j)],y);class w{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,n,u,o,t,h){this.g=n,this.h=u,this.i=o,this.j=t,this.a=new M.$ce,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,$.$qp)(i,[]),this.c&&(i=(0,S.$3n)(i,this.c)),this.b||(i=(0,S.$3n)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const n={name:a.name,message:a.message,stack:a.stack,cause:a.cause},u=(0,$.$qp)(n,[]),o=new Error(u.message,{cause:u.cause});o.stack=u.stack,o.name=u.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$zP=w;function d(g){const a=Date.now()-new Date(g).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$BP=(0,l.$ti)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,271,140,25,5]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.ActivationKind=e.$EG=e.$DG=e.$AG=e.ExtensionHostStartup=e.$zG=e.$yG=e.$xG=e.$wG=void 0,e.$BG=m,e.$CG=y,e.$FG=a,e.$GG=i,e.$wG=Object.freeze({identifier:new R.$Om("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xG="extensions.webWorker",e.$yG=(0,b.$ti)("extensionService");class ${constructor(o){this.dependency=o}}e.$zG=$;var S;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,h){this.c=o,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$hG.createActivationEventsMap(this.d)}}set(o,t,h){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const s=[],c=[],r=[],v=[],f=C(this.d),D=C(t),p=(T,j)=>T.extensionLocation.toString()===j.extensionLocation.toString()||T.isBuiltin===j.isBuiltin||T.isUserBuiltin===j.isUserBuiltin||T.isUnderDevelopment===j.isUnderDevelopment;for(const T of this.d){const j=D.get(T.identifier);if(!j){s.push(T.identifier),f.delete(T.identifier);continue}if(!p(T,j)){s.push(T.identifier),f.delete(T.identifier);continue}}for(const T of t){const j=f.get(T.identifier);if(!j){c.push(T);continue}if(!p(j,T)){s.push(j.identifier),f.delete(j.identifier);continue}}const E=new R.$Pm(this.e),k=new R.$Pm(h);for(const T of this.e)k.has(T)||r.push(T);for(const T of h)E.has(T)||v.push(T);const P=A.$hG.createActivationEventsMap(c),I={versionId:o,toRemove:s,toAdd:c,addActivationEvents:P,myToRemove:r,myToAdd:v};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:s,myToAdd:c}=o,r=new R.$Pm(t),v=new R.$Pm(s);for(let f=0;f<this.d.length;f++)r.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)v.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of h)this.d.push(f);for(const f of c)this.e.push(f);return this.f=null,o}containsExtension(o){for(const t of this.e)if(R.$Om.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=A.$hG.readActivationEvents(t);for(const s of h)o.add(s)}return o}}e.$AG=N;function C(u){const o=new R.$Qm;for(const t of u)o.set(t.identifier,t);return o}function m(u,o){return u.enabledApiProposals?u.enabledApiProposals.includes(o):!1}function y(u,o){if(!m(u,o))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}class w{constructor(o,t,h,s){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.$DG=w;class d{constructor(o,t){this.description=o,this.value=t}}e.$EG=d;var g;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function a(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,L.$wp)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}function i(u,o){return{identifier:new R.$Om((0,L.$up)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!o,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,publisherDisplayName:u.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HG=n}),define(ke[304],Se([1,0,13,148,25,26,12,8]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=e.$ilc=e.$hlc=e.$glc=e.$flc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,i,n,u){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=u}}e.$flc=$;class S{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$glc=S;class N{constructor(a,i,n,u,o,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=n,this.module=u,this.exports=o,this.subscriptions=t}}e.$hlc=N;class C extends N{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ilc=C;class m extends N{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$jlc=m;class y extends N{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(a,i,n,u){this.g=u,this.a=a,this.b=i,this.c=n,this.d=new L.$Qm,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(u=>({id:u.identifier,reason:{startup:i,extensionId:u.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(a){const i=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new y(o));return this.c.onExtensionActivationError(a.id,o,new A.$zG(a.id.value)),t}const n=[],u=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of u){if(this.m(o))continue;const t=this.d.get(o);if(t){n.push(t);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const h=this.a.getExtensionDescription(o);if(h){if(!h.main&&!h.browser)continue;n.push(this.j({id:h.identifier,reason:a.reason}));continue}const s=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${o}'`),r=this.k(a,i.displayName,[],new y(c));return this.c.onExtensionActivationError(i.identifier,c,new A.$zG(o)),r}return this.k(a,i.displayName,n,null)}k(a,i,n,u){const o=new d(a.id,i,a.reason,n,u,this.c,this.g);return this.d.set(a.id,o),o}l(a){return M.$e_b.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$klc=w,e.$klc=w=Je([Ve(3,R.$Zj)],w);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,n,u,o,t,h){this.c=a,this.d=i,this.f=n,this.g=u,this.h=o,this.j=t,this.k=h,this.a=new b.$sh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new y(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new y(i),this.b&&l.$4(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};d=Je([Ve(6,R.$Zj)],d)}),define(ke[305],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[306],Se([1,0,242,13,41,137,109,38,25,305,139,140]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0;const m=b.$_n.as(R.$ao.JSONContribution);class y{constructor(o,t,h){this.a=o,this.b=t,this.c=h}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(L.default.Error,o)}warn(o){this.d(L.default.Warning,o)}info(o){this.d(L.default.Info,o)}}e.$qG=y;class w{static a(o){const t=new $.$Pm;for(let h=0,s=o.length;h<s;h++)t.add(o[h].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new w(t,[]);if(!t||!t.length)return new w([],o);const h=this.a(o),s=this.a(t),c=t.filter(v=>!h.has(v.description.identifier)),r=o.filter(v=>!s.has(v.description.identifier));return new w(c,r)}constructor(o,t){this.added=o,this.removed=t}}e.$rG=w;class d{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=w.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,M.$1)(o)}}}e.$sG=d;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$tG={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Nm},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Qo}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Qo}},extensionKind:{description:l.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new d(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$hG.register(o.extensionPoint,o.activationEventsGenerator),e.$tG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,m.registerSchema(a,e.$tG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$uG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$_n.add(n.ExtensionsRegistry,new i),e.$vG=b.$_n.as(n.ExtensionsRegistry),m.registerSchema(a,e.$tG),m.registerSchema(N.$hk,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[307],Se([1,0,238,18,24,306,37,4]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var S;(function(m){function y(w,d,g){if(!w)return;const a=M.$6f(w.type)?w.type:void 0;if(!a||a.length===0){g.error(l.localize(3,null));return}const i=[];if(Array.isArray(w.required))for(const n of w.required)M.$6f(n)&&i.push(n);return{extensionId:d.value,taskType:a,required:i,properties:w.properties?L.$Zn(w.properties):{},when:w.when?R.$rj.deserialize(w.when):void 0}}m.from=y})(S||(S={}));const N=A.$vG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,y)=>{for(const w of m)w.type&&y.push(`onTaskType:${w.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$ce,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,w)=>{N.setHandler((d,g)=>{this.c=void 0;try{for(const a of g.removed){const i=a.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const a of g.added){const i=a.value;for(const n of i){const u=S.from(n,a.description.identifier,a.collector);u&&(this.a[u.taskType]=u)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const w of this.all()){const d={type:"object",additionalProperties:!1};w.required.length>0&&(d.required=w.required.slice(0)),w.properties!==void 0?d.properties=L.$Zn(w.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[w.taskType]},y.push(d)}this.c={oneOf:y}}return this.c}}e.$ZH=new C}),define(ke[308],Se([1,0,239,18,23,24,37,307]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$0H=e.JsonSchemaVersion=e.ExecutionEngine=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$4H=e.ShellQuoting=e.$3H=e.$2H=e.$1H=void 0,e.$1H="settings",e.$2H=new R.$Kj("taskRunning",!1,l.localize(0,null)),e.$3H=l.localize2(2,"Tasks");var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$4H="$customized",function(O){function F(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=F}($||(e.ShellQuoting=$={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var N;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(N||(e.RevealKind=N={})),function(O){function F(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=F}(N||(e.RevealKind=N={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function F(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=F}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function F(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=F}(m||(e.PanelKind=m={}));var y;(function(O){O.defaults={echo:!0,reveal:N.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var w;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(O){function F(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=F;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(w||(e.RuntimeType=w={}));var d;(function(O){function F(B){return M.$6f(B)?B:B.value}O.value=F})(d||(e.CommandString=d={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function F(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=F;function B(W){if(W!==void 0)return M.$6f(W)?F(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(g||(e.TaskGroup=g={}));var a;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function F(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(O){O.parallel="parallel",O.sequence="sequence"})(n||(e.DependsOrder=n={}));var u;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var o;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(F,B,W,Z,X,Y){this._label="",this._id=F,B&&(this._label=B),W&&(this.type=W),this.runOptions=Z,this.configurationProperties=X,this._source=Y}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,B=!1){if(F===void 0)return!1;if(M.$6f(F))return F===this._label||F===this.configurationProperties.identifier||B&&F===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$5H=t;class h extends t{constructor(F,B,W,Z,X,Y,x,ne){super(F,W,void 0,x,ne,B),this.command={},this._source=B,this.hasDefinedMatchers=Y,X&&(this.command=X)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case w.Shell:B="shell";break;case w.Process:B="process";break;case w.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$1H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const W={type:e.$4H,folder:F,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$4g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$6H=h;class s extends t{constructor(F,B,W,Z,X,Y,x){super(F,W,Z,Y,x,B),this._source=B,this.configures=X}static is(F){return F instanceof s}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$4g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$1H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const W={type:e.$4H,folder:F,id:B};return JSON.stringify(W)}}e.$7H=s;class c extends t{constructor(F,B,W,Z,X,Y,x,ne,ge){super(F,W,Z,ne,ge,B),this.defines=X,this.hasDefinedMatchers=x,this.command=Y,this.icon=ge.icon,this.hide=ge.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof c}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new c(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$8H=c;class r extends t{constructor(F,B,W,Z,X,Y){super(F,W,Z,X,Y,B),this._source=B}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new r(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$9H=r;var v;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(O){O._default=O.Terminal}(v||(e.ExecutionEngine=v={}));var f;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class D{constructor(F){this.c=new Map;for(let B=0;B<F.length;B++)this.c.set(F[B].uri.toString(),B)}compare(F,B){const W=F.getWorkspaceFolder(),Z=B.getWorkspaceFolder();if(W&&Z){let X=this.c.get(W.uri.toString());X=X===void 0?0:X+1;let Y=this.c.get(Z.uri.toString());return Y=Y===void 0?0:Y+1,X===Y?F._label.localeCompare(B._label):X-Y}else return!W&&Z?-1:W&&!Z?1:0}}e.$0H=D;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p||(e.TaskEventKind=p={}));var E;(function(O){O.SingleRun="singleRun",O.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(O){function F(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function B(ne,ge,ue){return{...F(ne),kind:"start",terminalId:ge,resolvedVariables:ue}}O.start=B;function W(ne,ge,ue){return{...F(ne),kind:"processStarted",terminalId:ge,processId:ue}}O.processStarted=W;function Z(ne,ge,ue){return{...F(ne),kind:"processEnded",terminalId:ge,exitCode:ue}}O.processEnded=Z;function X(ne,ge,ue){return{...F(ne),kind:"terminated",exitReason:ue,terminalId:ge}}O.terminated=X;function Y(ne,ge,ue){return{...F(ge),kind:ne,terminalId:ue}}O.general=Y;function x(){return{kind:"changed"}}O.changed=x})(P||(e.TaskEvent=P={}));var I;(function(O){function F(W){const Z=Object.keys(W).sort();let X="";for(const Y of Z){let x=W[Y];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),X+=Y+","+x+","}return X}function B(W){const X={_key:F(W),type:W.taskType};return Object.assign(X,W),X}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var T;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(T||(e.TaskSettingId=T={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(O){function F(B,W){const Z=b.$ZH.get(B.type);if(Z===void 0){const ne=A.$Zn(B);return delete ne._key,I.create(ne)}const X=Object.create(null);X.type=Z.taskType;const Y=new Set;Z.required.forEach(ne=>Y.add(ne));const x=Z.properties;for(const ne of Object.keys(x)){const ge=B[ne];if(ge!=null)X[ne]=ge;else if(Y.has(ne)){const ue=x[ne];if(ue.default!==void 0)X[ne]=A.$Zn(ue.default);else switch(ue.type){case"boolean":X[ne]=!1;break;case"number":case"integer":X[ne]=0;break;case"string":X[ne]="";break;default:W.error(l.localize(1,null,JSON.stringify(B,void 0,0),ne));return}}}return I.create(X)}O.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(ke[309],Se([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,l.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$i_b=M;class L extends M{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$j_b=L}),define(ke[48],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$nw=void 0,e.$ow=L,e.$pw=A;class l{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++l.count}}e.$nw=l;const M=[];function L(b){const $=new l(b);return M[$.nid]=$,$}function A(b){return M[b].sid}class R{constructor($){this.value=$}}e.$qw=R}),define(ke[6],Se([1,0,48]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$TM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var L;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput",d[d.ChatEditorInput=10]="ChatEditorInput",d[d.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var S;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var N;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class C{static{this.a=0}static mixin(g){return g._id=C.a++,g}}e.$TM=C;var m;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var y;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var w;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$UM={MainThreadAuthentication:(0,l.$ow)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$ow)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$ow)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,l.$ow)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$ow)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$ow)("MainThreadClipboard"),MainThreadCommands:(0,l.$ow)("MainThreadCommands"),MainThreadComments:(0,l.$ow)("MainThreadComments"),MainThreadConfiguration:(0,l.$ow)("MainThreadConfiguration"),MainThreadConsole:(0,l.$ow)("MainThreadConsole"),MainThreadDebugService:(0,l.$ow)("MainThreadDebugService"),MainThreadDecorations:(0,l.$ow)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$ow)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$ow)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$ow)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$ow)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$ow)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$ow)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$ow)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$ow)("MainThreadErrors"),MainThreadTreeViews:(0,l.$ow)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$ow)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$ow)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$ow)("MainThreadLanguages"),MainThreadLogger:(0,l.$ow)("MainThreadLogger"),MainThreadMessageService:(0,l.$ow)("MainThreadMessageService"),MainThreadOutputService:(0,l.$ow)("MainThreadOutputService"),MainThreadProgress:(0,l.$ow)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$ow)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$ow)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$ow)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$ow)("MainThreadSecretState"),MainThreadStorage:(0,l.$ow)("MainThreadStorage"),MainThreadSpeech:(0,l.$ow)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$ow)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$ow)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,l.$ow)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,l.$ow)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$ow)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$ow)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$ow)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$ow)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$ow)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$ow)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$ow)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$ow)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$ow)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$ow)("MainThreadExtensionService"),MainThreadSCM:(0,l.$ow)("MainThreadSCM"),MainThreadSearch:(0,l.$ow)("MainThreadSearch"),MainThreadShare:(0,l.$ow)("MainThreadShare"),MainThreadTask:(0,l.$ow)("MainThreadTask"),MainThreadWindow:(0,l.$ow)("MainThreadWindow"),MainThreadLabelService:(0,l.$ow)("MainThreadLabelService"),MainThreadNotebook:(0,l.$ow)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$ow)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$ow)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$ow)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$ow)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$ow)("MainThreadInteractive"),MainThreadInlineChat:(0,l.$ow)("MainThreadInlineChatShape"),MainThreadTheming:(0,l.$ow)("MainThreadTheming"),MainThreadTunnelService:(0,l.$ow)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$ow)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$ow)("MainThreadTimeline"),MainThreadTesting:(0,l.$ow)("MainThreadTesting"),MainThreadLocalization:(0,l.$ow)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$ow)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$ow)("MainThreadAiEmbeddingVector")},e.$VM={ExtHostCommands:(0,l.$ow)("ExtHostCommands"),ExtHostConfiguration:(0,l.$ow)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$ow)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$ow)("ExtHostDebugService"),ExtHostDecorations:(0,l.$ow)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$ow)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$ow)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$ow)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$ow)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$ow)("ExtHostEditors"),ExtHostTreeViews:(0,l.$ow)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$ow)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$ow)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$ow)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$ow)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$ow)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$ow)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$ow)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$ow)("ExtHostStatusBar"),ExtHostShare:(0,l.$ow)("ExtHostShare"),ExtHostExtensionService:(0,l.$ow)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$ow)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$ow)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,l.$ow)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,l.$ow)("ExtHostSCM"),ExtHostSearch:(0,l.$ow)("ExtHostSearch"),ExtHostTask:(0,l.$ow)("ExtHostTask"),ExtHostWorkspace:(0,l.$ow)("ExtHostWorkspace"),ExtHostWindow:(0,l.$ow)("ExtHostWindow"),ExtHostWebviews:(0,l.$ow)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$ow)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$ow)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$ow)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$ow)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$ow)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$ow)("ExtHostProgress"),ExtHostComments:(0,l.$ow)("ExtHostComments"),ExtHostSecretState:(0,l.$ow)("ExtHostSecretState"),ExtHostStorage:(0,l.$ow)("ExtHostStorage"),ExtHostUrls:(0,l.$ow)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$ow)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$ow)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$ow)("ExtHostOutputService"),ExtHostLabelService:(0,l.$ow)("ExtHostLabelService"),ExtHostNotebook:(0,l.$ow)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$ow)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$ow)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$ow)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$ow)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$ow)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$ow)("ExtHostInteractive"),ExtHostInlineChat:(0,l.$ow)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,l.$ow)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$ow)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$ow)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$ow)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,l.$ow)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$ow)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$ow)("ExtHostTheming"),ExtHostTunnelService:(0,l.$ow)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$ow)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$ow)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$ow)("ExtHostTimeline"),ExtHostTesting:(0,l.$ow)("ExtHostTesting"),ExtHostTelemetry:(0,l.$ow)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$ow)("ExtHostLocalization")}}),define(ke[91],Se([1,0,5,12,6,20]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=e.$Ekc=void 0,e.$Ekc=(0,l.$ti)("IExtHostApiDeprecationService");let R=class{constructor($,S){this.c=S,this.a=new Set,this.b=$.getProxy(L.$UM.MainThreadTelemetry)}report($,S,N){const C=this.d($,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:$}))}d($,S){return`${$}-${S.identifier.value}`}};e.$Fkc=R,e.$Fkc=R=Je([Ve(0,A.$hP),Ve(1,M.$Zj)],R),e.$Gkc=Object.freeze(new class{report(b,$,S){}})}),define(ke[310],Se([1,0,6]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class M{constructor(A){const R=A.getProxy(l.$UM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$Tkc=M}),define(ke[311],Se([1,0,24,6,28,20]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;let R=class{constructor(N,C){this.a=N.getProxy(M.$UM.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,C){const m=this,y=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){m.e(N,C,y,arguments)}})}e(N,C,m,y){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(y,this.b)}),this.c&&this.f(N,m,y)}};e.$Nmc=R,e.$Nmc=R=Je([Ve(0,A.$hP),Ve(1,L.$xP)],R);const b=1e5;function $(S,N){const C=[];if(S.length)for(let m=0;m<S.length;m++){let y=S[m];if(typeof y>"u")y="undefined";else if(y instanceof Error){const w=y;w.stack?y=w.stack:y=w.toString()}C.push(y)}if(N){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,l.$5n)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[312],Se([1,0,2,6,26]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class A{constructor(b){this.a=b.getProxy(M.$UM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,L.$CG)(b,"showLocal"),this.a.$showOpenDialog($).then(S=>S?S.map(N=>l.URI.revive(N)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?l.URI.revive($):void 0)}}e.$Qlc=A}),define(ke[313],Se([1,0,3,6]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class L{constructor(R){this.b=0,this.a=R.getProxy(M.$UM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,l.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$$lc=L}),define(ke[115],Se([1,0,11,14,2,5,12,6,28,20]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;let N=class{constructor(m,y,w){this.f=w,this.d=new Map,this.a=y.getProxy(b.$UM.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===l.$g}getMessage(m,y){const{message:w,args:d,comment:g}=y;if(this.c)return(0,M.$7e)(w,d??{});let a=w;g&&g.length>0&&(a+=`/${Array.isArray(g)?g.join(""):g}`);const i=this.d.get(m)?.contents[a];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,M.$7e)(i??w,d??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let y;const w=await this.g(m);if(!w){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(w),g=JSON.parse(d);y=m.isBuiltin?g.contents?.bundle:g}catch(d){this.f.error(`Failed to load translations for ${m.identifier.value} from ${w}: ${d.message}`);return}y&&this.d.set(m.identifier.value,{contents:y,uri:w})}async g(m){if(m.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return L.URI.revive(y)}return m.l10n?L.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ylc=N,e.$ylc=N=Je([Ve(0,$.$xP),Ve(1,S.$hP),Ve(2,R.$Zj)],N),e.$zlc=(0,A.$ti)("IExtHostLocalizationService")}),define(ke[149],Se([1,0,12,6,28,20,2,58]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;let $=class extends l.$$j{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(y=>(0,b.$3h)(y))),this.r=C.getProxy(M.$UM.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,y){return new S(this.r,C,m,y)}};e.$Mmc=$,e.$Mmc=$=Je([Ve(0,A.$hP),Ve(1,L.$xP)],$);class S extends l.$6j{constructor(C,m,y,w){super(w?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(m,w).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const y=[[C,m]];this.m?this.u(y):this.n.push(...y)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,21]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0,e.$Alc=(0,M.$ti)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(l.$UM.MainThreadManagedSockets)}setFactory(C,m){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,y=await this.c.makeConnection(),w=new L.$Uc;return this.d.set(m,new S(m,y,w)),w.add((0,L.$Tc)(()=>this.d.delete(m))),w.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),w.dispose()})),w.add(y.onDidClose(d=>{this.a.$onDidManagedSocketClose(m,d?.stack??d?.message),w.dispose()})),w.add(y.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(m,R.$De.wrap(d)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Blc=b,e.$Blc=b=Je([Ve(0,A.$hP)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class S extends L.$Vc{constructor(C,m,y){super(),this.socketId=C,this.actual=m,this.B(y)}}}),define(ke[314],Se([1,0,6,12,26]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;function A(b){return b&&b.title}let R=class{constructor($,S){this.b=S,this.a=$.getProxy(l.$UM.MainThreadMessageService)}showMessage($,S,N,C,m){const y={source:{identifier:$.identifier,label:$.displayName||$.name}};let w;typeof C=="string"||A(C)?w=[C,...m]:(y.modal=C?.modal,y.useCustom=C?.useCustom,y.detail=C?.detail,w=m),y.useCustom&&(0,L.$CG)($,"resolvers");const d=[];let g=!1;for(let a=0;a<w.length;a++){const i=w[a];if(typeof i=="string")d.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:u}=i;d.push({title:n,isCloseAffordance:!!u,handle:a}),u&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(S,N,y,d).then(a=>{if(typeof a=="number")return w[a]})}};e.$amc=R,e.$amc=R=Je([Ve(1,M.$Zj)],R)}),define(ke[315],Se([1,0,3,18,2,26,6]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class b{constructor(S){this.b=new Map,this.a=S.getProxy(R.$UM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,N,C){if((0,A.$CG)(S,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,C),this.a.$registerProfileContentHandler(N,C.name,C.description,S.identifier.value),(0,l.$Tc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(S,N,C,m){const y=this.b.get(S);if(!y)throw new Error(`Unknown handler with id: ${S}`);return y.saveProfile(N,C,m)}async $readProfile(S,N,C){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.readProfile((0,M.$6f)(N)?N:L.URI.revive(N),C)}}e.$jmc=b}),define(ke[117],Se([1,0,6,4,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;class A{constructor(b){this.b=new M.$ce,this.onDidChangePassword=this.b.event,this.a=b.getProxy(l.$UM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,S){return this.a.$setPassword(b,$,S)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$vlc=A,e.$wlc=(0,L.$ti)("IExtHostSecretState")}),define(ke[316],Se([1,0,22,3,6]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class A{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(L.$UM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,S){const N=this.c.get(b);if(!N)return;const C=new M.$Uc,m=new l.$ne;this.d.set($,m);const y=C.add(N.provideSpeechToTextSession(m.token,S?{language:S}:void 0));C.add(y.onDidChange(w=>{m.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,w)})),C.add(m.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,$){const S=this.c.get(b);if(!S)return;const N=new M.$Uc,C=new l.$ne;this.d.set($,C);const m=N.add(S.provideKeywordRecognitionSession(C.token));N.add(m.onDidChange(y=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,y)})),N.add(C.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,S){const N=A.a++;return this.c.set(N,S),this.b.$registerProvider(N,$,{extension:b,displayName:b.value}),(0,M.$Tc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$qmc=A}),define(ke[118],Se([1,0,6,4,5]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0;class A{constructor(b,$){this.c=$,this.b=new M.$ce,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(l.$UM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,S){const N=await this.a.$initializeExtensionStorage(b,$);let C;return N&&(C=this.d(b,$,N)),C||S}setValue(b,$,S){return this.a.$setValue(b,$,S)}$acceptValue(b,$,S){const N=this.d(b,$,S);N&&this.b.fire({shared:b,key:$,value:N})}d(b,$,S){try{return JSON.parse(S)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${N}`)}}}e.$llc=A,e.$mlc=(0,L.$ti)("IExtHostStorage")}),define(ke[317],Se([1,0,3,15,2,6]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(A.$UM.MainThreadUriOpeners)}registerExternalUriOpener($,S,N,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const m=C.schemes.find(y=>!R.a.has(y));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(S,N),this.b.$registerUriOpener(S,C.schemes,$,C.label),(0,l.$Tc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri($,S,N){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=L.URI.revive(S);return C.canOpenExternalUri(m,N)}async $openUri($,S,N){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},N)}}e.$Gmc=R}),define(ke[318],Se([1,0,6,2,3,13,25]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class b{static{this.a=0}constructor(S){this.c=new R.$Pm,this.d=new Map,this.b=S.getProxy(l.$UM.MainThreadUrls)}registerUriHandler(S,N){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,N),this.b.$registerUriHandler(m,C,S.displayName||S.name),(0,L.$Tc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(S,N){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(M.URI.revive(N))}catch(m){(0,A.$1)(m)}return Promise.resolve(void 0)}async createAppUri(S){return M.URI.revive(await this.b.$createAppUri(S))}}e.$Hmc=b}),define(ke[92],Se([1,0,4,3,15,24,2,246,284,113,6]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$9kc=void 0,e.$0kc=m,e.$_kc=d,e.$alc=g;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,o,t,h,s,c,r){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$ce,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$ce,this._onDidDispose=this.#h.event,this.#e=u,this.#t=o,this.#o=t,this.#n=h,this.#s=s,this.#r=c,this.#l=m(c),this.#d=y(c),this.#i=r}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,S.$jyb)(u,this.#n)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===L.Schemas.https||u.scheme===L.Schemas.http){let o=u.toString();return o.endsWith("/")||(o+="/"),o+" "+S.$iyb}return S.$iyb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),A.$4n(this.#o,u)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const o=(0,$.$tob)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,c,r,v,f)=>{const D=R.URI.from({scheme:r||"file",path:decodeURIComponent(v)}),p=(0,S.$jyb)(D,{isRemote:o,authority:t}).toString();return`${s}${p}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,c,r,v,f)=>{const D=R.URI.from({scheme:r||"file",path:decodeURIComponent(v)}),p=(0,S.$jyb)(D,{isRemote:o,authority:t}).toString();return`${s}${p}${f}`})}}e.$9kc=C;function m(n){try{const u=(0,b.$Fp)((0,b.$Ep)(n.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}function y(n){try{const u=(0,b.$Fp)((0,b.$Ep)(n.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class w extends M.$Vc{constructor(u,o,t,h,s){super(),this.c=o,this.f=t,this.g=h,this.h=s,this.b=new Map,this.a=u.getProxy(N.$UM.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,o,t){const h=this.j(u);if(h){const{message:s}=(0,$.$uob)(o,t.value);h._onMessageEmitter.fire(s)}}$onMissingCsp(u,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,o,t){const h=new C(u,this.a,a(o),this.c,this.f,t,this.h);this.b.set(u,h);const s=h._onDidDispose(()=>{s.dispose(),this.deleteWebview(u)});return h}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$$kc=w;function d(n){return{id:n.identifier,location:n.extensionLocation}}function g(n,u,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||i(n,u)}}function a(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(u=>R.URI.from(u))}}function i(n,u){return[...(u?.getWorkspaceFolders()||[]).map(o=>o.uri),n.extensionLocation]}}),define(ke[150],Se([1,0,4,15,14,2,5,20,6]),function(le,e,l,M,L,A,R,b,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;let N=class{static{S=this}static{this.a={focused:!0,active:!0}}getState(){const m=this.d;return{get focused(){return m.focused},get active(){return m.active}}}constructor(m){this.c=new l.$ce,this.onDidChangeWindowState=this.c.event,this.d=S.a,this.b=m.getProxy($.$UM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:w})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,y){y!==this.d[m]&&(this.d={...this.d,[m]:y},this.c.fire(this.d))}openUri(m,y){let w;if(typeof m=="string"){w=m;try{m=A.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,L.$5e)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this.b.$openUri(m,w,y)}async asExternalUri(m,y){if((0,L.$5e)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(m,y);return A.URI.from(w)}};e.$Jmc=N,e.$Jmc=N=S=Je([Ve(0,b.$hP)],N),e.$Kmc=(0,R.$ti)("IExtHostWindow")}),define(ke[319],Se([1,0,311,28,20]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;const A=1024*1024;let R=class extends l.$Nmc{constructor($,S){super($,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,S,N){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,N),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,S){const N=process[$],C=N.write;let m="";Object.defineProperty(N,"write",{set:()=>{},get:()=>(y,w,d)=>{if(!this.g){m+=y.toString(w);const g=m.length>A?m.length:m.lastIndexOf(`
`);g!==-1&&(console[S](m.slice(0,g)),m=m.slice(g+1))}C.call(N,y,w,d)}})}};e.$mnc=R,e.$mnc=R=Je([Ve(0,L.$hP),Ve(1,M.$xP)],R)}),define(ke[320],Se([1,0,149,15,261,30]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class R extends l.$Mmc{s($,S,N){return $.scheme===M.Schemas.file?new L.$uQ(N?.name||(0,A.$Pg)(),$.fsPath,!N?.donotRotate,!!N?.donotUseFormatters,S):super.s($,S,N)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$ync=R}),define(ke[321],Se([1,0,8,21,22,13,4,3,133,309,48]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$k_b=g,e.$l_b=a;function m(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const y="$$ref$$",w={[y]:-1};class d{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function g(k,P=null,I=!1){const T=[];return{jsonString:(I?m:JSON.stringify)(k,(z,O)=>{if(typeof O>"u")return w;if(typeof O=="object"){if(O instanceof M.$De){const F=T.push(O)-1;return{[y]:F}}if(P)return P(z,O)}return O}),referencedBuffers:T}}function a(k,P,I){return JSON.parse(k,(T,j)=>{if(j){const z=j[y];if(typeof z=="number")return P[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function i(k,P){return JSON.stringify(k,P)}function n(k){return k?(P,I)=>I&&I.$mid===1?k.transformOutgoing(I):I:null}var u;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var o;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class c extends b.$Vc{static{C=h}static{this.a=3*1e3}constructor(P,I=null,T=null){super(),this[C]=!0,this.b=this.B(new R.$ce),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=T,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=N.$nw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$Fh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$yn)(P,this.g):P}getProxy(P){const{nid:I,sid:T}=P;return this.s[I]||(this.s[I]=this.J(I,T)),this.s[I]}J(P,I){const T={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...O)=>this.U(P,z,O)),z===s?I:j[z])};return new Proxy(Object.create(null),T)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,T=P.length;I<T;I++){const j=P[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,T=v.read(P,0),j=T.readUInt8(),z=T.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:F,args:B}=D.deserializeRequestJSONArgs(T);this.g&&(B=(0,$.$yn)(B,this.g)),this.M(I,z,O,F,B,j===2);break}case 3:case 4:{let{rpcId:O,method:F,args:B}=D.deserializeRequestMixedArgs(T);this.g&&(B=(0,$.$yn)(B,this.g)),this.M(I,z,O,F,B,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(T);this.g&&(O=(0,$.$yn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(T,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(T);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(T);this.g&&(O=(0,$.$yn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,T,j,z,O){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,N.$pw)(T)}.${j}(`,z);const F=String(I);let B,W;if(O){const X=new L.$ne;z.push(X.token),B=this.Q(T,j,z),W=()=>X.cancel()}else B=this.Q(T,j,z),W=t;this.u[F]=W;const Z=D.serializeAcknowledged(I);this.f?.logOutgoing(Z.byteLength,I,1,"ack"),this.c.send(Z),B.then(X=>{delete this.u[F];const Y=D.serializeReplyOK(I,X,this.h);this.f?.logOutgoing(Y.byteLength,I,1,"reply:",X),this.c.send(Y)},X=>{delete this.u[F];const Y=D.serializeReplyErr(I,X);this.f?.logOutgoing(Y.byteLength,I,1,"replyErr:",X),this.c.send(Y)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const T=String(I);this.u[T]?.()}O(P,I,T){this.f?.logIncoming(P,I,0,"receiveReply:",T);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(T)}P(P,I,T){this.f?.logIncoming(P,I,0,"receiveReplyErr:",T);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let O;T&&(T.$isError?(O=new Error,O.name=T.name,O.message=T.message,O.stack=T.stack):O=T),z.resolveErr(O)}Q(P,I,T){try{return Promise.resolve(this.S(P,I,T))}catch(j){return Promise.reject(j)}}S(P,I,T){const j=this.m[P];if(!j)throw new Error("Unknown actor "+(0,N.$pw)(P));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,N.$pw)(P));return z.apply(j,T)}U(P,I,T){if(this.j)return new S.$j_b;let j=null;if(T.length>0&&L.CancellationToken.isCancellationToken(T[T.length-1])&&(j=T.pop()),j&&j.isCancellationRequested)return Promise.reject(A.$6());const z=D.serializeRequestArguments(T,this.h),O=++this.t,F=String(O),B=new S.$i_b,W=new b.$Uc;j&&W.add(j.onCancellationRequested(()=>{const X=D.serializeCancel(O);this.f?.logOutgoing(X.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[F]=new r(B,W),this.F(O);const Z=D.serializeRequest(O,P,I,z,!!j);return this.f?.logOutgoing(Z.byteLength,O,0,`request: ${(0,N.$pw)(P)}.${I}(`,T),this.c.send(Z),B}}e.$m_b=c;class r{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class v{static alloc(P,I,T){const j=new v(M.$De.alloc(T+1+4),0);return j.writeUInt8(P),j.writeUInt32(I),j}static read(P,I){return new v(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const T=this.a.slice(this.b,this.b+P).toString();return this.b+=P,T}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+P).toString();return this.b+=P,T}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let T=0,j=P.length;T<j;T++){const z=P[T];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,T=P.length;I<T;I++){const j=P[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let T=0;T<P;T++)switch(this.readUInt8()){case 1:I[T]=this.readLongString();break;case 2:I[T]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),F=[];for(let B=0;B<z;++B)F.push(this.readVSBuffer());I[T]=new N.$qw(a(O,F,null));break}case 4:I[T]=void 0;break}return I}}var f;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(f||(f={}));class D{static a(P){for(let I=0,T=P.length;I<T;I++)if(P[I]instanceof M.$De||P[I]instanceof N.$qw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const T=[];for(let j=0,z=P.length;j<z;j++){const O=P[j];if(O instanceof M.$De)T[j]={type:2,value:O};else if(typeof O>"u")T[j]={type:4};else if(O instanceof N.$qw){const{jsonString:F,referencedBuffers:B}=g(O.value,I);T[j]={type:3,value:M.$De.fromString(F),buffers:B}}else T[j]={type:1,value:M.$De.fromString(i(O,I))}}return{type:1,args:T}}return{type:0,args:i(P,I)}}static serializeRequest(P,I,T,j,z){switch(j.type){case 0:return this.b(P,I,T,j.args,z);case 1:return this.c(P,I,T,j.args,z)}}static b(P,I,T,j,z){const O=M.$De.fromString(T),F=M.$De.fromString(j);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString(O),B+=v.sizeLongString(F);const W=v.alloc(z?2:1,P,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(F),W.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),T=P.readShortString(),j=P.readLongString();return{rpcId:I,method:T,args:JSON.parse(j)}}static c(P,I,T,j,z){const O=M.$De.fromString(T);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(O),F+=v.sizeMixedArray(j);const B=v.alloc(z?4:3,P,F);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),T=P.readShortString(),j=P.readMixedArray(),z=new Array(j.length);for(let O=0,F=j.length;O<F;O++){const B=j[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:T,args:z}}static serializeAcknowledged(P){return v.alloc(5,P,0).buffer}static serializeCancel(P){return v.alloc(6,P,0).buffer}static serializeReplyOK(P,I,T){if(typeof I>"u")return this.d(P);if(I instanceof M.$De)return this.e(P,I);if(I instanceof N.$qw){const{jsonString:j,referencedBuffers:z}=g(I.value,T,!0);return this.g(P,j,z)}else return this.f(P,m(I,T))}static d(P){return v.alloc(7,P,0).buffer}static e(P,I){let T=0;T+=v.sizeVSBuffer(I);const j=v.alloc(8,P,T);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const T=M.$De.fromString(I);let j=0;j+=v.sizeLongString(T);const z=v.alloc(9,P,j);return z.writeLongString(T),z.buffer}static g(P,I,T){const j=M.$De.fromString(I);let z=0;z+=v.sizeUInt32,z+=v.sizeLongString(j);for(const F of T)z+=v.sizeVSBuffer(F);const O=v.alloc(10,P,z);O.writeUInt32(T.length),O.writeLongString(j);for(const F of T)O.writeBuffer(F);return O.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const T=P.readUInt32(),j=P.readLongString(),z=[];for(let O=0;O<T;++O)z.push(P.readVSBuffer());return new N.$qw(a(j,z,I))}static serializeReplyErr(P,I){const T=I?m(A.$3(I),null):void 0;if(typeof T!="string")return this.h(P);const j=M.$De.fromString(T);let z=0;z+=v.sizeLongString(j);const O=v.alloc(11,P,z);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return v.alloc(12,P,0).buffer}}var p;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(ke[322],Se([1,0,21,27,15,84,5]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$wK=void 0,e.$xK=N,e.$yK=C,e.$wK=(0,R.$ti)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),S=7;function N(y){if(y.scheme!==L.Schemas.vscodeNotebookCell)return;const w=y.fragment.indexOf("s");if(w<0)return;const d=parseInt(y.fragment.substring(0,w).replace($,""),S),g=(0,l.$We)(y.fragment.substring(w+1)).toString();if(!isNaN(d))return{handle:d,notebook:y.with({scheme:g,fragment:null})}}function C(y,w){const d=w.toString(S),a=`${d.length<b.length?b[d.length-1]:"z"}${d}s${(0,l.$Xe)(l.$De.fromString(y.scheme),!0,!0)}`;return y.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class m{constructor(){this.a=new M.$Bc}getNotebook(w){if(w.scheme===L.Schemas.vscodeNotebookCell){const d=N(w);if(d){const g=this.a.get(d.notebook);if(g)return g}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$zK=m,(0,A.$ts)(e.$wK,m,1)}),define(ke[119],Se([1,0,21,35,39,101,15,17,11,37,322]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$QK=e.CellStatusbarAlignment=e.$PK=e.NotebookEditorPriority=e.$MK=e.$LK=e.$JK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$IK=e.$HK=e.$GK=e.$FK=e.CellKind=e.$EK=e.$DK=e.$CK=void 0,e.$KK=h,e.$NK=c,e.$OK=r,e.$RK=D,e.$SK=E,e.$CK="workbench.editor.notebook",e.$DK="workbench.editor.notebookTextDiffEditor",e.$EK="workbench.editor.interactive";var C;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(C||(e.CellKind=C={})),e.$FK=["application/json","application/javascript","text/html","image/svg+xml",A.$Ms.latex,A.$Ms.markdown,"image/png","image/jpeg",A.$Ms.text],e.$GK=[A.$Ms.latex,A.$Ms.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$Ms.text],e.$HK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$IK="_notAvailable";var m;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var y;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var w;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var d;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var g;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var u;(function(B){B.scheme=R.Schemas.vscodeNotebookCell;function W(ge,ue){return(0,N.$yK)(ge,ue)}B.generate=W;function Z(ge){return(0,N.$xK)(ge)}B.parse=Z;function X(ge,ue){return ge.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${ge.scheme!==R.Schemas.file?ge.scheme:""}`})}B.generateCellOutputUri=X;function Y(ge){if(ge.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!ue)return;const ve=ue[1]&&ue[1]!==""?ue[1]:void 0,te=ue[2];return{outputId:ve,notebook:ge.with({scheme:te||R.Schemas.file,fragment:null})}}B.parseCellOutputUri=Y;function x(ge,ue,ve){return B.generate(ge,ue).with({scheme:ve})}B.generateCellPropertyUri=x;function ne(ge,ue){if(ge.scheme===ue)return B.parse(ge.with({scheme:B.scheme}))}B.parseCellPropertyUri=ne})(u||(e.CellUri=u={}));const o=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],Z=e.$FK){this.e=Z,this.d=[...new Set(W)].map(X=>({pattern:X,matches:M.$nk(o(X))}))}sort(W){const Z=new Map(L.Iterable.map(W,Y=>[Y,o(Y)]));let X=[];for(const{matches:Y}of this.d)for(const[x,ne]of Z)if(Y(ne)){X.push(x),Z.delete(x);break}return Z.size&&(X=X.concat([...Z.keys()].sort((Y,x)=>this.e.indexOf(Y)-this.e.indexOf(x)))),X}prioritize(W,Z){const X=this.f(W);if(X===-1){this.d.unshift({pattern:W,matches:M.$nk(o(W))});return}const Y=new Set(Z.map(ne=>this.f(ne,X)));Y.delete(-1);const x=Array.from(Y).sort();this.d.splice(X+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Z=this.d.length){const X=o(W);for(let Y=0;Y<Z;Y++)if(this.d[Y].matches(X))return Y;return-1}}e.$JK=t;function h(B,W,Z,X=(Y,x)=>Y===x){const Y=[];function x(ue,ve,te){if(ve===0&&te.length===0)return;const U=Y[Y.length-1];U&&U.start+U.deleteCount===ue?(U.deleteCount+=ve,U.toInsert.push(...te)):Y.push({start:ue,deleteCount:ve,toInsert:te})}let ne=0,ge=0;for(;;){if(ne===B.length){x(ne,0,W.slice(ge));break}if(ge===W.length){x(ne,B.length-ne,[]);break}const ue=B[ne],ve=W[ge];if(X(ue,ve)){ne+=1,ge+=1;continue}Z(ve)?(x(ne,1,[]),ne+=1):(x(ne,0,[ve]),ge+=1)}return Y}e.$LK=new S.$Kj("notebookEditorCursorAtBoundary","none"),e.$MK=new S.$Kj("notebookEditorCursorAtLineBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(B){const W=B;return!!((typeof W.include=="string"||M.$ok(W.include))&&(typeof W.exclude=="string"||M.$ok(W.exclude)))}function r(B,W,Z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const X=c(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Y=c(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(M.$mk(X,(0,b.$oc)(Z.fsPath).toLowerCase()))return!(Y&&M.$mk(Y,(0,b.$oc)(Z.fsPath).toLowerCase()))}return!1}e.$PK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var v;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class f{static{this.d="notebook/"}static create(W){return`${f.d}${W}`}static parse(W){if(W.startsWith(f.d))return W.substring(f.d.length)}}e.$QK=f;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const p=new TextDecoder;function E(B){const W=[];let Z=!1;for(const ne of B)(W.length===0||Z)&&(W.push(ne),Z=!0);let X=I(W);const Y=l.$De.concat(W.map(ne=>l.$De.wrap(ne))),x=F(Y);return X=X||x.byteLength!==Y.byteLength,{data:x,didCompression:X}}e.$TK="\x1B[A";const k=e.$TK.split("").map(B=>B.charCodeAt(0)),P=10;function I(B){let W=!1;return B.forEach((Z,X)=>{if(X===0||Z.length<e.$TK.length)return;const Y=B[X-1],x=Z.subarray(0,e.$TK.length);if(x[0]===k[0]&&x[1]===k[1]&&x[2]===k[2]){const ne=Y.lastIndexOf(P);if(ne===-1)return;W=!0,B[X-1]=Y.subarray(0,ne),B[X]=Z.subarray(e.$TK.length)}}),W}function T(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let Z=B.match(/\r+(.*)$/m)[1];Z=Z+W.slice(Z.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return B}const z=8,O=13;function F(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:l.$De.fromString(j(T(p.decode(B.buffer))))}}),define(ke[7],Se([1,0,19,13,80,27,101,14,18,2,30,25,33,66,119]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";var d,g,a,i,n,u,o,t,h,s,c,r,v,f,D,p,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$8O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$7O=e.$6O=e.$5O=e.$4O=e.ChatLocation=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$RO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$EO=e.$DO=e.$CO=e.$BO=e.$zO=e.$yO=e.$xO=e.$wO=e.TestRunProfileKind=e.TestResultState=e.$vO=e.$uO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$tO=e.NotebookVariablesRequestKind=e.$sO=e.$rO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$qO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.ColorThemeKind=e.$kO=e.$jO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$iO=e.$hO=e.DebugConsoleMode=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$bO=e.$aO=e.FileChangeType=e.$_N=e.NewSymbolNameTag=e.$$N=e.$0N=e.$9N=e.$8N=e.InlineCompletionTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$UN=e.ConfigurationTarget=e.$TN=e.$SN=e.$RN=e.$QN=e.DocumentPasteTriggerKind=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$JN=e.ViewBadge=e.ProgressLocation=e.$IN=e.$HN=e.TaskScope=e.ShellQuoting=e.$GN=e.$FN=e.$EN=e.TaskPanelKind=e.TaskRevealKind=e.$DN=e.TerminalLocation=e.$CN=e.$BN=e.$AN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$zN=e.$yN=e.$xN=e.$wN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$uN=e.$tN=e.$sN=e.$rN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$qN=e.$pN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.LanguageStatusSeverity=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.CodeActionTriggerKind=e.$dN=e.$cN=e.SymbolTag=e.SymbolKind=e.$bN=e.$aN=e.DocumentHighlightKind=e.$_M=e.$$M=e.$0M=e.$9M=e.DiagnosticSeverity=e.DiagnosticTag=e.$8M=e.$7M=e.FileEditType=e.$6M=e.$5M=e.$4M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$vN=ht,e.$VN=ee,e.$AO=Lt;function k(G){return Object.assign(G,{apply:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(G,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const[Oe,...xe]=me;return Reflect.construct(G,xe,Oe.constructor)}}})}var P;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let T=d=class{static from(...H){let me=H;return new d(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$WM=T,e.$WM=T=d=Je([k],T);let j=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Oe=1;Oe<H.length;Oe++){const xe=H[Oe];xe.isBefore(me)&&(me=xe)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Oe=1;Oe<H.length;Oe++){const xe=H[Oe];xe.isAfter(me)&&(me=xe)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Oe}=H;return typeof me=="number"&&typeof Oe=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,M.$7)("line must be non-negative");if(me<0)throw(0,M.$7)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,M.$7)();let Oe;return typeof H>"u"?Oe=0:typeof H=="number"?Oe=H:(Oe=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Oe===0&&me===0?this:new g(this.line+Oe,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,M.$7)();let Oe;return typeof H>"u"?Oe=this.line:typeof H=="number"?Oe=H:(Oe=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Oe===this.line&&me===this.character?this:new g(Oe,me)}toJSON(){return{line:this.line,character:this.character}}};e.$XM=j,e.$XM=j=g=Je([k],j);let z=a=class{static isRange(H){return H instanceof a?!0:H?j.isPosition(H.start)&&j.isPosition(H.end):!1}static of(H){if(H instanceof a)return H;if(this.isRange(H))return new a(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Oe,xe){let rt,ft;if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(H,me),ft=new j(Oe,xe)):j.isPosition(H)&&j.isPosition(me)&&(rt=j.of(H),ft=j.of(me)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(H){return a.isRange(H)?this.contains(H.start)&&this.contains(H.end):j.isPosition(H)?!(j.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=j.Max(H.start,this.c),Oe=j.Min(H.end,this.e);if(!me.isAfter(Oe))return new a(me,Oe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=j.Min(H.start,this.c),Oe=j.Max(H.end,this.end);return new a(me,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,M.$7)();let Oe;return H?j.isPosition(H)?Oe=H:(Oe=H.start||this.start,me=H.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&me.isEqual(this.end)?this:new a(Oe,me)}toJSON(){return[this.start,this.end]}};e.$YM=z,e.$YM=z=a=Je([k],z);let O=i=class extends z{static isSelection(H){return H instanceof i?!0:H?z.isRange(H)&&j.isPosition(H.anchor)&&j.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Oe,xe){let rt,ft;if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(H,me),ft=new j(Oe,xe)):j.isPosition(H)&&j.isPosition(me)&&(rt=j.of(H),ft=j.of(me)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$ZM=O,e.$ZM=O=i=Je([k],O);const F=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,M.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Oe){if(typeof H!="string"||H.length===0)throw(0,M.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,M.$7)("port");typeof Oe<"u"&&F(Oe),this.host=H,this.port=Math.round(me),this.connectionToken=Oe}}e.$1M=B;class W{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&F(me)}}e.$2M=W;class Z extends Error{static NotAvailable(H,me){return new Z(H,y.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new Z(H,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=y.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(H),this._message=H,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,Z.prototype)}}e.$3M=Z;var X;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var Y;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let x=n=class{static isTextEdit(H){return H instanceof n?!0:H?z.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new z(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new z(new j(0,0),new j(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!z.isRange(H))throw(0,M.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,M.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,M.$7)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$4M=x,e.$4M=x=n=Je([k],x);let ne=u=class{static isNotebookCellEdit(H){return H instanceof u?!0:H?at.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new u(H,me)}static insertCells(H,me){return new u(new at(H,H),me)}static deleteCells(H){return new u(H,[])}static updateCellMetadata(H,me){const Oe=new u(new at(H,H),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(H){const me=new u(new at(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$5M=ne,e.$5M=ne=u=Je([k],ne);class ge{static isSnippetTextEdit(H){return H instanceof ge?!0:H?z.isRange(H.range)&&te.isSnippetString(H.snippet):!1}static replace(H,me){return new ge(H,me)}static insert(H,me){return ge.replace(new z(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$6M=ge;var ue;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Oe,xe){this.c.push({_type:1,from:H,to:me,options:Oe,metadata:xe})}createFile(H,me,Oe){this.c.push({_type:1,from:void 0,to:H,options:me,metadata:Oe})}deleteFile(H,me,Oe){this.c.push({_type:1,from:H,to:void 0,options:me,metadata:Oe})}e(H,me,Oe){this.c.push({_type:3,metadata:Oe,uri:H,edit:{editType:5,metadata:me},notebookMetadata:me})}f(H,me,Oe,xe){const rt=me.start,ft=me.end;(rt!==ft||Oe.length>0)&&this.c.push({_type:5,uri:H,index:rt,count:ft-rt,cells:Oe,metadata:xe})}g(H,me,Oe,xe){this.c.push({_type:3,metadata:xe,uri:H,edit:{editType:3,index:me,metadata:Oe}})}replace(H,me,Oe,xe){this.c.push({_type:2,uri:H,edit:new x(me,Oe),metadata:xe})}insert(H,me,Oe,xe){this.replace(H,new z(me,me),Oe,xe)}delete(H,me,Oe){this.replace(H,me,"",Oe)}has(H){return this.c.some(me=>me._type===2&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Oe of me){if(!Oe)continue;let xe,rt;Array.isArray(Oe)?(xe=Oe[0],rt=Oe[1]):xe=Oe,ne.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(H,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(H,xe.newNotebookMetadata,rt):this.f(H,xe.range,xe.newCells,rt):ge.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:H,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:H,edit:xe,metadata:rt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const xe=this.c[Oe];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===H.toString()&&(this.c[Oe]=void 0);break}}(0,l.$Ib)(this.c)}}get(H){const me=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===H.toString()&&me.push(Oe.edit);return me}entries(){const H=new A.$Bc;for(const me of this.c)if(me._type===2){let Oe=H.get(me.uri);Oe||(Oe=[me.uri,[]],H.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$7M=ve,e.$7M=ve=Je([k],ve);let te=o=class{static isSnippetString(H){return H instanceof o?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=o.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Oe=new o;Oe.e=this.e,H(Oe),this.e=Oe.e,H=Oe.value}else H=o.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Oe=H.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Oe=new o;Oe.e=this.e,me(Oe),this.e=Oe.e,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$8M=te,e.$8M=te=o=Je([k],te);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var _;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=t=class{static isLocation(H){return H instanceof t?!0:H?z.isRange(H.range)&&S.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(z.isRange(me))this.range=z.of(me);else if(j.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$9M=pe,e.$9M=pe=t=Je([k],pe);let Pe=class{static is(H){return H?typeof H.message=="string"&&H.location&&z.isRange(H.location.range)&&S.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$0M=Pe,e.$0M=Pe=Je([k],Pe);let se=class{constructor(H,me,Oe=_.Error){if(!z.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Oe}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,l.$ub)(H.tags,me.tags)&&(0,l.$ub)(H.relatedInformation,me.relatedInformation,Pe.isEqual)}};e.$$M=se,e.$$M=se=Je([k],se);let re=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$_M=re,e.$_M=re=Je([k],re);var oe;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let K=class{constructor(H,me=oe.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$aN=K,e.$aN=K=Je([k],K);let ie=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$bN=ie,e.$bN=ie=Je([k],ie);var $e;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var we;(function(G){G[G.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ne=h=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Oe,xe,rt){this.name=H,this.kind=me,this.containerName=rt,typeof Oe=="string"&&(this.containerName=Oe),xe instanceof pe?this.location=xe:Oe instanceof z&&(this.location=new pe(xe,Oe)),h.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$cN=Ne,e.$cN=Ne=h=Je([k],Ne);let fe=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(s.validate)}constructor(H,me,Oe,xe,rt){this.name=H,this.detail=me,this.kind=Oe,this.range=xe,this.selectionRange=rt,this.children=[],s.validate(this)}};e.$dN=fe,e.$dN=fe=s=Je([k],fe);var De;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Ie=class{constructor(H,me){this.title=H,this.kind=me}};e.$eN=Ie,e.$eN=Ie=Je([k],Ie);let Fe=class{static{c=this}static{this.c="."}constructor(H){this.value=H}append(H){return new c(this.value?this.value+c.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+c.c)}};e.$fN=Fe,e.$fN=Fe=c=Je([k],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let V=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$gN=V,e.$gN=V=Je([k],V);class q{constructor(H,me,Oe,xe,rt,ft){this.kind=H,this.name=me,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$hN=q;class J{constructor(H,me){this.fromRanges=me,this.from=H}}e.$iN=J;class Q{constructor(H,me){this.fromRanges=me,this.to=H}}e.$jN=Q;var he;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let be=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$kN=be,e.$kN=be=Je([k],be);let ze=r=class{#e;static isMarkdownString(H){return H instanceof r?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new L.$Qk(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$lN=ze,e.$lN=ze=r=Je([k],ze);let qe=class{constructor(H,me){this.label=H,this.documentation=me}};e.$mN=qe,e.$mN=qe=Je([k],qe);let Ye=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$nN=Ye,e.$nN=Ye=Je([k],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$oN=it,e.$oN=it=Je([k],it);var ot;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var nt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let st=class{constructor(H){this.value=H}};e.$pN=st,e.$pN=st=Je([k],st);let Ce=class{constructor(H,me,Oe){this.position=H,this.label=me,this.kind=Oe}};e.$qN=Ce,e.$qN=Ce=Je([k],Ce);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Me;(function(G){G[G.Deprecated=1]="Deprecated"})(Me||(e.CompletionItemTag=Me={}));let Ze=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$rN=Ze,e.$rN=Ze=Je([k],Ze);let ae=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$sN=ae,e.$sN=ae=Je([k],ae);let ce=class{constructor(H,me,Oe){this.insertText=H,this.range=me,this.command=Oe}};e.$tN=ce,e.$tN=ce=Je([k],ce);let Ae=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$uN=Ae,e.$uN=Ae=Je([k],Ae);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var Re;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Re||(e.ViewColumn=Re={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function ht(G,H){return`${C.$Om.toKey(G)}.${H}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Mt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var At;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var xt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(G){function H(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(xt||(e.TextEditorSelectionChangeKind=xt={}));var qt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(G){function H(me){switch(me){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(qt||(e.SyntaxTokenType=qt={}));let Zt=class{constructor(H,me){if(me&&!S.URI.isUri(me))throw(0,M.$7)("target");if(!z.isRange(H)||H.isEmpty)throw(0,M.$7)("range");this.range=H,this.target=me}};e.$wN=Zt,e.$wN=Zt=Je([k],Zt);let et=class{constructor(H,me,Oe,xe){this.red=H,this.green=me,this.blue=Oe,this.alpha=xe}};e.$xN=et,e.$xN=et=Je([k],et);let si=class{constructor(H,me){if(me&&!(me instanceof et))throw(0,M.$7)("color");if(!z.isRange(H)||H.isEmpty)throw(0,M.$7)("range");this.range=H,this.color=me}};e.$yN=si,e.$yN=si=Je([k],si);let Yt=class{constructor(H){if(!H||typeof H!="string")throw(0,M.$7)("label");this.label=H}};e.$zN=Yt,e.$zN=Yt=Je([k],Yt);var dt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(dt||(e.ColorFormat=dt={}));var vt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Xt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(Xt||(e.TerminalShellExecutionCommandLineConfidence=Xt={}));class zt{constructor(H,me,Oe){if(this.startIndex=H,this.length=me,this.tooltip=Oe,typeof H!="number"||H<0)throw(0,M.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,M.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,M.$7)("tooltip")}}e.$AN=zt;class gt{constructor(H){this.uri=H}}e.$BN=gt;class Ut{constructor(H){this.terminalCommand=H}}e.$CN=Ut;var Wt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Ht{constructor(H){if(this.options=H,typeof H!="object")throw(0,M.$7)("options")}}e.$DN=Ht;var Xe;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Xe||(e.TaskRevealKind=Xe={}));var ui;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Gt=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(H){switch(H){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,M.$7)("name");this.c=H}get id(){return this.c}};e.$EN=Gt,e.$EN=Gt=v=Je([k],Gt);function Bt(G){let H="";for(let me=0;me<G.length;me++)H+=G[me].replace(/,/g,",,")+",";return H}let mt=class{constructor(H,me,Oe){if(typeof H!="string")throw(0,M.$7)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Oe):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,M.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Bt(H)}};e.$FN=mt,e.$FN=mt=Je([k],mt);let Ft=class{constructor(H,me,Oe){if(this.f=[],Array.isArray(me)){if(!H)throw(0,M.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,M.$7)("command");this.e=H,this.f=me,this.g=Oe}else{if(typeof H!="string")throw(0,M.$7)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,M.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,M.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Bt(H)}};e.$GN=Ft,e.$GN=Ft=Je([k],Ft);var Rt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var Tt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Tt||(e.TaskScope=Tt={}));class ii{constructor(H){this.c=H}computeId(){return"customExecution"+(0,N.$Pg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$HN=ii;let Kt=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Oe,xe,rt,ft){this.k=!1,this.l=this.definition=H;let $t;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Oe,this.execution=xe,$t=rt,this.k=!0):me===Tt.Global||me===Tt.Workspace?(this.target=me,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft):(this.target=me,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,N.$Pg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,M.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(f.g===me||f.e===me||f.f===me||f.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$IN=Kt,e.$IN=Kt=f=Je([k],Kt);var ni;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Ot;(function(G){function H(me){const Oe=me;return(0,$.$0f)(Oe.value)?Oe.tooltip&&!(0,$.$6f)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}G.isViewBadge=H})(Ot||(e.ViewBadge=Ot={}));let Nt=D=class{static isTreeItem(H,me){const Oe=H;if(Oe.checkboxState!==void 0){const xe=(0,$.$0f)(Oe.checkboxState)?Oe.checkboxState:(0,$.$8f)(Oe.checkboxState)&&(0,$.$0f)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,rt=!(0,$.$0f)(Oe.checkboxState)&&(0,$.$8f)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(xe===void 0||xe!==St.Checked&&xe!==St.Unchecked||rt!==void 0&&!(0,$.$6f)(rt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(H instanceof D)return!0;if(Oe.label!==void 0&&!(0,$.$6f)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,$.$6f)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,$.$6f)(Oe.iconPath)&&!S.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,$.$6f)(Oe.iconPath.id))){const xe=Oe.iconPath;if(!xe||!(0,$.$6f)(xe.light)&&!S.URI.isUri(xe.light)&&!(0,$.$6f)(xe.dark)&&!S.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,$.$6f)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!S.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,$.$6f)(Oe.tooltip)&&!(Oe.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<It.None&&Oe.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,$.$6f)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(H,me=It.None){this.collapsibleState=me,S.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$JN=Nt,e.$JN=Nt=D=Je([k],Nt);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$KN=pt,e.$KN=pt=Je([k],pt);class Ct extends pt{}e.$LN=Ct;class li extends Ct{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$MN=li;class Dt{constructor(H,me,Oe,xe){this.name=H,this.uri=me,this._itemId=Oe,this.c=xe}data(){return this.c()}}e.$NN=Dt;let hi=class{#e=new Map;constructor(H){for(const[me,Oe]of H??[]){const xe=this.#e.get(this.#t(me));xe?xe.push(Oe):this.#e.set(this.#t(me),[Oe])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Oe,xe]of this.#e)for(const rt of xe)H.call(me,rt,Oe,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Oe of me)yield[H,Oe]}#t(H){return H.toLowerCase()}};e.$ON=hi,e.$ON=hi=Je([k],hi);let Jt=class{constructor(H,me,Oe){this.insertText=H,this.title=me,this.kind=Oe}};e.$PN=Jt,e.$PN=Jt=Je([k],Jt);var wi;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ei{static{this.c="."}constructor(H){this.value=H}append(...H){return new ei((this.value?[this.value,...H]:H).join(ei.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+ei.c)}}e.$QN=ei,ei.Empty=new ei("");class vi{constructor(H,me,Oe){this.title=me,this.insertText=H,this.kind=Oe}}e.$RN=vi;let Et=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$SN=Et,e.$SN=Et=Je([k],Et),Et.File=new Et("file"),Et.Folder=new Et("folder");let $i=class{constructor(H){this.id=H}};e.$TN=$i,e.$TN=$i=Je([k],$i);var Le;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Le||(e.ConfigurationTarget=Le={}));let je=class{get base(){return this.c}set base(H){this.c=H,this.e=S.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!S.URI.isUri(H)&&!S.URI.isUri(H.uri)))throw(0,M.$7)("base");if(typeof me!="string")throw(0,M.$7)("pattern");typeof H=="string"?this.baseUri=S.URI.file(H):S.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$UN=je,e.$UN=je=Je([k],je);const Ee=new WeakMap;function ee(G,H){Ee.set(G,H)}let Te=class{constructor(H,me,Oe,xe,rt){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=Ee.get(this)??(0,N.$Pg)()),this.c}};e.$WN=Te,e.$WN=Te=Je([k],Te);let He=class extends Te{constructor(H,me,Oe,xe,rt,ft){if(super(me,Oe,xe,rt,ft),H===null)throw(0,M.$7)("location");this.location=H}};e.$XN=He,e.$XN=He=Je([k],He);let _e=class extends Te{constructor(H,me,Oe,xe,rt,ft){super(me,Oe,xe,rt,ft),this.functionName=H}};e.$YN=_e,e.$YN=_e=Je([k],_e);let Qe=class extends Te{constructor(H,me,Oe,xe,rt,ft,$t,Qt){if(super(xe,rt,ft,$t,Qt),!me)throw(0,M.$7)("dataId");this.label=H,this.dataId=me,this.canPersist=Oe}};e.$ZN=Qe,e.$ZN=Qe=Je([k],Qe);let lt=class{constructor(H,me,Oe){this.command=H,this.args=me||[],this.options=Oe}};e.$1N=lt,e.$1N=lt=Je([k],lt);let kt=class{constructor(H,me){this.port=H,this.host=me}};e.$2N=kt,e.$2N=kt=Je([k],kt);let jt=class{constructor(H){this.path=H}};e.$3N=jt,e.$3N=jt=Je([k],jt);let Vt=class{constructor(H){this.implementation=H}};e.$4N=Vt,e.$4N=Vt=Je([k],Vt);class ut{constructor(H,me,Oe){this.session=H,this.threadId=me,this.frameId=Oe}}e.$5N=ut;class ri{constructor(H,me){this.session=H,this.threadId=me}}e.$6N=ri;let di=class{constructor(H,me){this.range=H,this.expression=me}};e.$7N=di,e.$7N=di=Je([k],di);var pi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Di=class{constructor(H,me){this.range=H,this.text=me}};e.$8N=Di,e.$8N=Di=Je([k],Di);let Ai=class{constructor(H,me,Oe=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Oe}};e.$9N=Ai,e.$9N=Ai=Je([k],Ai);let Ri=class{constructor(H,me){this.range=H,this.expression=me}};e.$0N=Ri,e.$0N=Ri=Je([k],Ri);let Li=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$$N=Li,e.$$N=Li=Je([k],Li);var Mi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Mi||(e.NewSymbolNameTag=Mi={}));class cn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$_N=cn;var Oi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Fi=p=class extends Error{static FileExists(H){return new p(H,m.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(H){return new p(H,m.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(H){return new p(H,m.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(H){return new p(H,m.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(H){return new p(H,m.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(H){return new p(H,m.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(H,me=m.FileSystemProviderErrorCode.Unknown,Oe){super(S.URI.isUri(H)?H.toString(!0):H),this.code=Oe?.name??"Unknown",(0,m.$cl)(this,me),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$aO=Fi,e.$aO=Fi=p=Je([k],Fi);let yi=class{constructor(H,me,Oe){this.start=H,this.end=me,this.kind=Oe}};e.$bO=yi,e.$bO=yi=Je([k],yi);var Ci;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Gi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$cO=un;function Ti(G){return typeof G>"u"||(0,$.$7f)(G)}class ji{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Oe=H.tokenTypes.length;me<Oe;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Oe=H.tokenModifiers.length;me<Oe;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Oe,xe,rt){if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(H,me,Oe,xe,rt);if(z.isRange(H)&&typeof me=="string"&&Ti(Oe))return this.o(H,me,Oe);throw(0,M.$7)()}o(H,me,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const xe=H.start.line,rt=H.start.character,ft=H.end.character-H.start.character,$t=this.k.get(me);let Qt=0;if(Oe)for(const ci of Oe){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Qt|=1<<fi>>>0}this.q(xe,rt,ft,$t,Qt)}q(H,me,Oe,xe,rt){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Qt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Qt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ft=H,$t=me;this.f&&this.j>0&&(ft-=this.c,ft===0&&($t-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=$t,this.g[this.j++]=Oe,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=H,this.e=me}static r(H){const me=[],Oe=H.length/5|0;for(let $t=0;$t<Oe;$t++)me[$t]=$t;me.sort(($t,Qt)=>{const ci=H[5*$t],fi=H[5*Qt];if(ci===fi){const gi=H[5*$t+1],mi=H[5*Qt+1];return gi-mi}return ci-fi});const xe=new Uint32Array(H.length);let rt=0,ft=0;for(let $t=0;$t<Oe;$t++){const Qt=5*me[$t],ci=H[Qt+0],fi=H[Qt+1],gi=H[Qt+2],mi=H[Qt+3],qi=H[Qt+4],Rn=ci-rt,ur=Rn===0?fi-ft:fi,Hi=5*$t;xe[Hi+0]=Rn,xe[Hi+1]=ur,xe[Hi+2]=gi,xe[Hi+3]=mi,xe[Hi+4]=qi,rt=ci,ft=fi}return xe}build(H){return this.f?new Pi(new Uint32Array(this.g),H):new Pi(ji.r(this.g),H)}}e.$dO=ji;class Pi{constructor(H,me){this.resultId=me,this.data=H}}e.$eO=Pi;class ln{constructor(H,me,Oe){this.start=H,this.deleteCount=me,this.data=Oe}}e.$fO=ln;class Zi{constructor(H,me){this.resultId=me,this.edits=H}}e.$gO=Zi;var Yi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class hn{constructor(H){this.name=H}}e.$hO=hn;let zi=class{static{this.Back={iconPath:new Et("arrow-left")}}constructor(){}};e.$iO=zi,e.$iO=zi=Je([k],zi);var Xi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Ii;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Ii||(e.InputBoxValidationSeverity=Ii={}));var Bi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Bi||(e.ExtensionKind=Bi={}));class We{static validate(H){if(typeof H.badge=="string"){let me=(0,b.$Ff)(H.badge,0);if(me<H.badge.length&&(me+=(0,b.$Ff)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Et.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Oe){this.badge=H,this.tooltip=me,this.color=Oe}}e.$jO=We;let oi=class{constructor(H){this.kind=H}};e.$kO=oi,e.$kO=oi=Je([k],oi);var Ui;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class at{static isNotebookRange(H){return H instanceof at?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,M.$7)("start must be positive");if(me<0)throw(0,M.$7)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Oe=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Oe=H.end),me===this.c&&Oe===this.e?this:new at(me,Oe)}}e.$lO=at;class bt{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>bt.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Oe,xe,rt,ft,$t){this.kind=H,this.value=me,this.languageId=Oe,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=$t,bt.validate(this)}}e.$mO=bt;class dn{constructor(H){this.cells=H}}e.$nO=dn;class ai{static isNotebookCellOutputItem(H){return H instanceof ai?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return ai.json(me,"application/vnd.code.notebook.error")}static stdout(H){return ai.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return ai.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new ai(H,me)}static#e=new TextEncoder;static text(H,me=R.$Ms.text){const Oe=ai.#e.encode(String(H));return new ai(Oe,me)}static json(H,me="text/x-json"){const Oe=JSON.stringify(H,void 0,"	");return ai.text(Oe,me)}constructor(H,me){this.data=H,this.mime=me;const Oe=(0,R.$Qs)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$oO=ai;class Ei{static isNotebookCellOutput(H){return H instanceof Ei?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Oe=new Set,xe=new Set;for(let rt=0;rt<H.length;rt++){const ft=H[rt],$t=(0,R.$Qs)(ft.mime);if(!Oe.has($t)||(0,w.$RK)($t)){Oe.add($t);continue}xe.add(rt),me&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?H:H.filter((rt,ft)=>!xe.has(ft))}constructor(H,me,Oe){this.items=Ei.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,N.$Pg)(),this.metadata=me??Oe)}}e.$pO=Ei;var xi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var ki;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ki||(e.NotebookCellExecutionState=ki={}));var _i;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(H,me){this.text=H,this.alignment=me}}e.$qO=fn;var Wi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(H,me=[]){this.uri=H,this.provides=(0,l.$3b)(me)}}e.$rO=gn;class mn{constructor(H){this.label=H}}e.$sO=mn;var nn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$tO=Vi,e.$tO=Vi=Je([k],Vi);var rn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$uO=$n;class pn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$vO=pn;var an;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var de;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let ye=class{constructor(H=void 0,me=void 0,Oe=void 0,xe=!1){this.include=H,this.exclude=me,this.profile=Oe,this.continuous=xe}};e.$wO=ye,e.$wO=ye=Je([k],ye);let Ue=E=class{static diff(H,me,Oe){const xe=new E(H);return xe.expectedOutput=me,xe.actualOutput=Oe,xe}constructor(H){this.message=H}};e.$xO=Ue,e.$xO=Ue=E=Je([k],Ue);let ct=class{constructor(H){this.id=H}};e.$yO=ct,e.$yO=ct=Je([k],ct);class yt{constructor(H,me){this.covered=H,this.total=me,Lt(this)}}e.$zO=yt;function Lt(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class Si{static fromDetails(H,me){const Oe=new yt(0,0),xe=new yt(0,0),rt=new yt(0,0);for(const $t of me)if("branches"in $t){Oe.total+=1,Oe.covered+=$t.executed?1:0;for(const Qt of $t.branches)xe.total+=1,xe.covered+=Qt.executed?1:0}else rt.total+=1,rt.covered+=$t.executed?1:0;const ft=new Si(H,Oe,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=me,ft}constructor(H,me,Oe,xe){this.uri=H,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=xe}}e.$BO=Si;class Ln{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe=[]){this.executed=H,this.location=me,this.branches=Oe}}e.$CO=Ln;class Mn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe){this.executed=H,this.location=me,this.label=Oe}}e.$DO=Mn;class On{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe){this.name=H,this.executed=me,this.location=Oe}}e.$EO=On;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var wn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Fn{constructor(H,me,Oe,xe,rt,ft){this.kind=H,this.name=me,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$FO=Fn;class Tn{constructor(H){this.uri=H}}e.$GO=Tn;class jn{constructor(H,me){this.original=H,this.modified=me}}e.$HO=jn;class zn{constructor(H,me,Oe,xe){this.base=H,this.input1=me,this.input2=Oe,this.result=xe}}e.$IO=zn;class Bn{constructor(H,me){this.uri=H,this.viewType=me}}e.$JO=Bn;class Un{constructor(H){this.viewType=H}}e.$KO=Un;class Wn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$LO=Wn;class Vn{constructor(H,me,Oe){this.original=H,this.modified=me,this.notebookType=Oe}}e.$MO=Vn;class qn{constructor(){}}e.$NO=qn;class Hn{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$OO=Hn;class Gn{constructor(){}}e.$PO=Gn;class Kn{constructor(H){this.textDiffs=H}}e.$QO=Kn;var yn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var kn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Jn{constructor(H,me){this.label=H,this.values=me}}e.$RO=Jn;var Sn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Qn{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new ze(H):H}}e.$SO=Qn;class Zn{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new ze(H):H,this.vulnerabilities=me}}e.$TO=Zn;class Yn{constructor(H,me){this.participant=H,this.command=me}}e.$UO=Yn;class Xn{constructor(H,me){this.value=H,this.baseUri=me}}e.$VO=Xn;class xn{constructor(H,me){this.value=H,this.title=me}}e.$WO=xn;class _n{constructor(H){this.value=H}}e.$XO=_n;class er{constructor(H){this.value=H}}e.$YO=er;class tr{constructor(H){this.value=H}}e.$ZO=tr;class ir{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$1O=ir;class nr{constructor(H,me,Oe,xe){this.prompt=H,this.command=me,this.variables=Oe,this.participant=xe}}e.$2O=nr;class rr{constructor(H,me,Oe,xe){this.response=H,this.result=me,this.participant=Oe,this.command=xe}}e.$3O=rr;var Cn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class sr{constructor(H){this.content=H}}e.$4O=sr;class or{constructor(H,me){this.content=H,this.name=me}}e.$5O=or;class ar{constructor(H,me){this.content=H,this.name=me}}e.$6O=ar;class Ni extends Error{static NotFound(H){return new Ni(H,Ni.NotFound.name)}static NoPermissions(H){return new Ni(H,Ni.NoPermissions.name)}constructor(H,me,Oe){super(H,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.$7O=Ni;var Pn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var Nn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Nn||(e.KeywordRecognitionStatus=Nn={}));class cr{constructor(H,me){this.text=H,this.range=me}}e.$8O=cr;var An;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(ke[323],Se([1,0,6,7]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$UM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(R);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiRelatedInformationProvider(S,b),new M.$WM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$Dkc=L}),define(ke[120],Se([1,0,4,6,7,25,145,5,20]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=void 0,e.$Okc=(0,b.$ti)("IExtHostAuthentication");let S=class{constructor(m){this.b=new Map,this.c=new l.$ce,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=m.getProxy(M.$UM.MainThreadAuthentication)}async getSession(m,y,w,d={}){const g=A.$Om.toKey(m.identifier),a=[...w].sort().join(" ");return await this.d.getOrCreate(`${g} ${y} ${a}`,async()=>{await this.a.$ensureProvider(y);const i=m.displayName||m.name;return this.a.$getSession(y,w,g,i,d)})}async getSessions(m,y,w){const d=A.$Om.toKey(m.identifier),g=[...w].sort().join(" ");return await this.f.getOrCreate(`${d} ${g}`,async()=>{await this.a.$ensureProvider(y);const a=m.displayName||m.name;return this.a.$getSessions(y,w,d,a)})}async removeSession(m,y){const w=this.b.get(m);return w?w.provider.removeSession(y):this.a.$removeSession(m,y)}registerAuthenticationProvider(m,y,w,d){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:y,provider:w,options:d??{supportsMultipleAccounts:!1}});const g=w.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(m,a));return this.a.$registerAuthenticationProvider(m,y,d?.supportsMultipleAccounts??!1),new L.$WM(()=>{g.dispose(),this.b.delete(m),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,y,w){const d=this.b.get(m);if(d)return Promise.resolve(d.provider.createSession(y,w));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,y){const w=this.b.get(m);if(w)return Promise.resolve(w.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,y){const w=this.b.get(m);if(w)return Promise.resolve(w.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,y){return m.startsWith(R.$WL)||this.c.fire({provider:{id:m,label:y}}),Promise.resolve()}};e.$Pkc=S,e.$Pkc=S=Je([Ve(0,$.$hP)],S);class N{constructor(){this.a=new Map}getOrCreate(m,y){const w=this.a.get(m);if(w)return w;const d=y().finally(()=>this.a.delete(m));return this.a.set(m,d),d}}}),define(ke[151],Se([1,0,2,6,7,5,20,12,19,14,17,26]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0;let y=class{static{m=this}static{this.c=0}static{this.d=250}constructor(d,g){this.h=g,this.f=new Map,this.g=d.getProxy(M.$UM.MainThreadDecorations)}registerFileDecorationProvider(d,g){const a=m.c++;this.f.set(a,{provider:d,extensionDescription:g}),this.g.$registerDecorationProvider(a,g.identifier.value);const i=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(a,null);return}const u=(0,$.$3b)(n);if(u.length<=m.d){this.g.$onDidChange(a,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,u.length);const o=u.map(s=>({uri:s,rank:(0,S.$$e)(s.path,"/")})),t=(0,$.$zb)(o,(s,c)=>s.rank-c.rank||(0,S.$of)(s.uri.path,c.uri.path)),h=[];e:for(const s of t){let c;for(const r of s){const v=(0,N.$nc)(r.uri.path);if(c!==v&&(c=v,h.push(r.uri)>=m.d))break e}}this.g.$onDidChange(a,h)});return new L.$WM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(d,g,a){if(!this.f.has(d))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:u}=this.f.get(d);return await Promise.all(g.map(async o=>{try{const{uri:t,id:h}=o,s=await Promise.resolve(n.provideFileDecoration(l.URI.revive(t),a));if(!s)return;try{L.$jO.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$CG)(u,"codiconDecoration"),i[h]=[s.propagate,s.tooltip,s.badge,s.color]}catch(c){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),i}};e.$Olc=y,e.$Olc=y=m=Je([Ve(0,R.$hP),Ve(1,b.$Zj)],y),e.$Plc=(0,A.$ti)("IExtHostDecorations")}),define(ke[324],Se([1,0,13,2,7,6,15,22,14]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class S{static{this.a=0}constructor(C,m,y){this.d=m,this.e=y,this.b=new Map,this.c=C.getProxy(A.$UM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const y=S.a++;this.b.set(y,m),this.c.$registerTextContentProvider(y,C);let w;if(typeof m.onDidChange=="function"){let d;w=m.onDidChange(async g=>{if(g.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;d&&await d;const a=this.$provideTextDocumentContent(y,g).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(g);if(!n)return;const u=(0,$.$if)(i);if(!n.equalLines(u))return this.c.$onVirtualDocumentChange(g,i)}).catch(l.$1).finally(()=>{d===a&&(d=void 0)});d=a})}return new L.$WM(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(C,m){const y=this.b.get(C);return y?Promise.resolve(y.provideTextDocumentContent(M.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$Rlc=S}),define(ke[152],Se([1,0,62,15,14,183,129,7,19]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0,e.$jP=N;const S=new Map;function N(w,d){d?S.set(w,d):S.delete(w)}function C(w){return S.get(w)}class m extends A.$Uv{constructor(d,g,a,i,n,u,o){super(g,a,i,n),this.c=d,this.m=u,this.q=o,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,$.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===M.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(g){return g?d.s(g):d.getText()},get eol(){return d.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(g){return d.t(g)},offsetAt(g){return d.u(g)},positionAt(g){return d.v(g)},validateRange(g){return d.w(g)},validatePosition(g){return d.x(g)},getWordRangeAtPosition(g,a){return d.y(g,a)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,l.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,l.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const g=this.w(d);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const a=this.g,i=g.start.line,n=g.end.line,u=[];u.push(this.f[i].substring(g.start.character));for(let o=i+1;o<n;o++)u.push(this.f[o]);return u.push(this.f[n].substring(0,g.end.character)),u.join(a)}t(d){let g;if(d instanceof b.$XM?g=d.line:typeof d=="number"&&(g=d),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.f[g],g===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const g=this.j.getIndexOf(d),a=this.f[g.index].length;return new b.$XM(g.index,Math.min(g.remainder,a))}w(d){if(!(d instanceof b.$YM))throw new Error("Invalid argument");const g=this.x(d.start),a=this.x(d.end);return g===d.start&&a===d.end?d:new b.$YM(g.line,g.character,a.line,a.character)}x(d){if(!(d instanceof b.$XM))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:g,character:a}=d,i=!1;if(g<0)g=0,a=0,i=!0;else if(g>=this.f.length)g=this.f.length-1,a=this.f[g].length,i=!0;else{const n=this.f[g].length;a<0?(a=0,i=!0):a>n&&(a=n,i=!0)}return i?new b.$XM(g,a):d}y(d,g){const a=this.x(d);if(!g)g=C(this.m);else if((0,L.$hf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const i=(0,R.$5s)(a.character+1,(0,R.$3s)(g),this.f[a.line],0);if(i)return new b.$YM(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.$kP=m;class y{constructor(d,g,a){this.a=d,this.b=g,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$YM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$YM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lP=y}),define(ke[325],Se([1,0,6,7]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$UM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(R);if(!S)throw new Error("Embedding vector provider not found");const N=await S.provideEmbeddingVector(b,$);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(R,b,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiEmbeddingVectorProvider(b,S),new M.$WM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$Tlc=L}),define(ke[69],Se([1,0,6,33,7,21,5,20,60,3,8,23,15]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=void 0;let w=y=class{constructor(g,a){this.b=new Map,this.c=new N.$Ch,this.a=g.getProxy(l.$UM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let u;const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),u=await o.impl.stat(n)):u=await i.a.$stat(n),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===M.FilePermission.Readonly?1:void 0}}catch(u){y.e(u)}},async readDirectory(n){try{const u=i.b.get(n.scheme);return u?(await i.a.$ensureActivation(n.scheme),(await u.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(u){return y.e(u)}},async createDirectory(n){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(u.impl,u.extUri,n)):await i.a.$mkdir(n)}catch(u){return y.e(u)}},async readFile(n){try{const u=i.b.get(n.scheme);return u?(await i.a.$ensureActivation(n.scheme),(await u.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(u){return y.e(u)}},async writeFile(n,u){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,o.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(o.impl.writeFile(n,u,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$De.wrap(u))}catch(o){return y.e(o)}},async delete(n,u){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly&&!u?.useTrash?(await i.a.$ensureActivation(n.scheme),await o.impl.delete(n,{recursive:!1,...u})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(o){return y.e(o)}},async rename(n,u,o){try{return await i.a.$rename(n,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},async copy(n,u,o){try{return await i.a.$copy(n,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},isWritableFileSystem(n){const u=a.getCapabilities(n);if(typeof u=="number")return!(u&2048)}})}async d(g,a,i){const n=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await g.stat(i)).type&M.FileType.Directory))throw L.$aO.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(M.$dl(u)!==M.FileSystemProviderErrorCode.FileNotFound)throw u;n.push(a.basename(i)),i=a.dirname(i)}for(let u=n.length-1;u>=0;u--){i=a.joinPath(i,n[u]);try{await g.createDirectory(i)}catch(o){if(M.$dl(o)!==M.FileSystemProviderErrorCode.FileExists)throw o}}}static e(g){if(g instanceof L.$aO)throw g;if(g instanceof M.$_k)switch(g.code){case M.FileSystemProviderErrorCode.FileExists:throw L.$aO.FileExists(g.message);case M.FileSystemProviderErrorCode.FileNotFound:throw L.$aO.FileNotFound(g.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw L.$aO.FileNotADirectory(g.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw L.$aO.FileIsADirectory(g.message);case M.FileSystemProviderErrorCode.NoPermissions:throw L.$aO.NoPermissions(g.message);case M.FileSystemProviderErrorCode.Unavailable:throw L.$aO.Unavailable(g.message);default:throw new L.$aO(g.message,g.name)}if(!(g instanceof Error))throw new L.$aO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw L.$aO.Unavailable(g.message);switch(g.name){case M.FileSystemProviderErrorCode.FileExists:throw L.$aO.FileExists(g.message);case M.FileSystemProviderErrorCode.FileNotFound:throw L.$aO.FileNotFound(g.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw L.$aO.FileNotADirectory(g.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw L.$aO.FileIsADirectory(g.message);case M.FileSystemProviderErrorCode.NoPermissions:throw L.$aO.NoPermissions(g.message);case M.FileSystemProviderErrorCode.Unavailable:throw L.$aO.Unavailable(g.message);default:throw new L.$aO(g.message,g.name)}}addFileSystemProvider(g,a,i){return this.b.set(g,{impl:a,extUri:i?.isCaseSensitive?C.$Wg:C.$Yg,isReadonly:!!i?.isReadonly}),(0,S.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??C.$Wg}};e.$5kc=w,e.$5kc=w=y=Je([Ve(0,b.$hP),Ve(1,$.$Ikc)],w),e.$6kc=(0,R.$ti)("IExtHostConsumerFileSystem")}),define(ke[93],Se([1,0,5,28,12,69,2]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=void 0,e.$7kc=(0,l.$ti)("IExtensionStoragePaths");let b=class{constructor(S,N,C){this.d=N,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(S){return R.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,N=await this.g(S);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(R.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return R.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return R.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$8kc=b,e.$8kc=b=Je([Ve(0,M.$xP),Ve(1,L.$Zj),Ve(2,A.$6kc)],b)}),define(ke[326],Se([1,0,7,20,4]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;let A=class{constructor(b){this.a=new l.$kO(l.ColorThemeKind.Dark),this.b=new L.$ce}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=l.ColorThemeKind.Light;break;case"hcDark":$=l.ColorThemeKind.HighContrast;break;case"hcLight":$=l.ColorThemeKind.HighContrastLight;break;default:$=l.ColorThemeKind.Dark}this.a=new l.$kO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Cmc=A,e.$Cmc=A=Je([Ve(0,M.$hP)],A)}),define(ke[70],Se([1,0,22,4,3,228,5,12,88,6,28,20,7]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Cb=e.$ZCb=e.TunnelDtoConverter=void 0;class y extends $.$hw{}var w;(function(g){function a(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}g.fromApiTunnel=a;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}g.fromServiceTunnel=i})(w||(e.TunnelDtoConverter=w={})),e.$ZCb=(0,R.$ti)("IExtHostTunnelService");let d=class extends L.$Vc{constructor(a,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$ce,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(S.$UM.MainThreadTunnelService)}async openTunnel(a,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,a.displayName);if(n){const u=new y(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,i){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:a,provider:i}),this.a.$registerPortsAttributesProvider(a,n),new m.$WM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(a,i,n,u,o){const t=[];for(const s of a){const c=this.r.get(s);if(!c)return[];t.push(...await Promise.all(i.map(async r=>{let v;try{v=await c.provider.providePortAttributes({port:r,pid:n,commandLine:u},o)}catch{v=await c.provider.providePortAttributes(r,n,u,o)}return{providedAttributes:v,port:r}})))}const h=t.filter(s=>!!s.providedAttributes);return h.length>0?h.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,o)=>await a.provideTunnel(u,o,l.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,L.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const n=a.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let u=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,L.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,i){if(this.g.has(a.host)){const n=this.g.get(a.host);n.has(a.port)&&(i&&n.get(a.port).disposeListener.dispose(),await n.get(a.port).tunnel.dispose(),n.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(a,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const u=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:u,disposeListener:o}),w.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(u=>this.f(u.host,u.port,u.detail??""))),n=a.filter((u,o)=>i[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(u=>u.port).join(", ")} to ${n.map(u=>u.port).join(", ")}`),n}};e.$1Cb=d,e.$1Cb=d=Je([Ve(0,C.$hP),Ve(1,N.$xP),Ve(2,b.$Zj)],d)}),define(ke[16],Se([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,290,119,68,89,302,7]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$eP=F,e.$fP=W,e.$gP=Z;var v;(function(Le){function je(ee){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Qe}=ee,lt=new r.$XM(Te-1,He-1),kt=new r.$XM(_e-1,Qe-1);return new r.$ZM(lt,kt)}Le.to=je;function Ee(ee){const{anchor:Te,active:He}=ee;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ee})(v||(e.Selection=v={}));var f;(function(Le){function je(ee){if(!ee)return;const{start:Te,end:He}=ee;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=je;function Ee(ee){if(!ee)return;const{startLineNumber:Te,startColumn:He,endLineNumber:_e,endColumn:Qe}=ee;return new r.$YM(Te-1,He-1,_e-1,Qe-1)}Le.to=Ee})(f||(e.Range=f={}));var D;(function(Le){function je(ee){return{uri:ee.uri,range:f.from(ee.range)}}Le.from=je;function Ee(ee){return new r.$9M(d.URI.revive(ee.uri),f.to(ee.range))}Le.to=Ee})(D||(e.Location=D={}));var p;(function(Le){function je(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Le.to=je})(p||(e.TokenType=p={}));var E;(function(Le){function je(ee){return new r.$XM(ee.lineNumber-1,ee.column-1)}Le.to=je;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Le.from=Ee})(E||(e.Position=E={}));var k;(function(Le){function je(Te,He,_e){return(0,l.$Hb)((0,l.$3b)(Te).map(Qe=>Ee(Qe,He,_e)))}Le.from=je;function Ee(Te,He,_e){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:_e?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ee(Te.scheme,He),pattern:ce.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(k||(e.DocumentSelector=k={}));var P;(function(Le){function je(ee){switch(ee){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Le.from=je;function Ee(ee){switch(ee){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Le.to=Ee})(P||(e.DiagnosticTag=P={}));var I;(function(Le){function je(ee){let Te;return ee.code&&((0,w.$6f)(ee.code)||(0,w.$0f)(ee.code)?Te=String(ee.code):Te={value:String(ee.code.value),target:ee.code.target}),{...f.from(ee.range),message:ee.message,source:ee.source,code:Te,severity:j.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(T.from),tags:Array.isArray(ee.tags)?(0,l.$Hb)(ee.tags.map(P.from)):void 0}}Le.from=je;function Ee(ee){const Te=new r.$$M(f.to(ee),ee.message,j.to(ee.severity));return Te.source=ee.source,Te.code=(0,w.$6f)(ee.code)?ee.code:ee.code?.value,Te.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(T.to),Te.tags=ee.tags&&(0,l.$Hb)(ee.tags.map(P.to)),Te}Le.to=Ee})(I||(e.Diagnostic=I={}));var T;(function(Le){function je(ee){return{...f.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Le.from=je;function Ee(ee){return new r.$0M(new r.$9M(ee.resource,f.to(ee)),ee.message)}Le.to=Ee})(T||(e.DiagnosticRelatedInformation=T={}));var j;(function(Le){function je(ee){switch(ee){case r.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Le.from=je;function Ee(ee){switch(ee){case i.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Le.to=Ee})(j||(e.DiagnosticSeverity=j={}));var z;(function(Le){function je(ee){return typeof ee=="number"&&ee>=r.ViewColumn.One?ee-1:ee===r.ViewColumn.Beside?c.$SD:c.$RD}Le.from=je;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ee})(z||(e.ViewColumn=z={}));function O(Le){return typeof Le.range<"u"}function F(Le){return Le.length===0?!0:!!O(Le[0])}var B;(function(Le){function je(Qe){return Qe.map(Le.from)}Le.fromMany=je;function Ee(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let lt;if(Ee(Qe)){const{language:ut,value:ri}=Qe;lt={value:"```"+ut+`
`+ri+"\n```\n"}}else r.$lN.isMarkdownString(Qe)?lt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?lt={value:Qe}:lt={value:""};const kt=Object.create(null);lt.uris=kt;const jt=ut=>{try{let ri=d.URI.parse(ut,!0);ri=ri.with({query:Te(ri.query,kt)}),kt[ut]=ri}catch{}return""},Vt=new $.marked.Renderer;return Vt.link=jt,Vt.image=ut=>typeof ut=="string"?jt(R.$Yk(ut).href):"",(0,$.marked)(lt.value,{renderer:Vt}),lt}Le.from=ee;function Te(Qe,lt){if(!Qe)return Qe;let kt;try{kt=(0,S.$2h)(Qe)}catch{}if(!kt)return Qe;let jt=!1;return kt=(0,C.$2n)(kt,Vt=>{if(d.URI.isUri(Vt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ut]=Vt,jt=!0,ut}else return}),jt?JSON.stringify(kt):Qe}function He(Qe){const lt=new r.$lN(Qe.value,Qe.supportThemeIcons);return lt.isTrusted=Qe.isTrusted,lt.supportHtml=Qe.supportHtml,lt.baseUri=Qe.baseUri?d.URI.from(Qe.baseUri):void 0,lt}Le.to=He;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Le.from(Qe)}Le.fromStrict=_e})(B||(e.MarkdownString=B={}));function W(Le){return F(Le)?Le.map(je=>({range:f.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?B.fromMany(je.hoverMessage):je.hoverMessage?B.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Le.map(je=>({range:f.from(je)}))}function Z(Le){return typeof Le>"u"?Le:typeof Le=="string"?d.URI.file(Le):Le}var X;(function(Le){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?Z(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Le.from=je})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var Y;(function(Le){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Z(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?X.from(Ee.before):void 0,after:Ee.after?X.from(Ee.after):void 0}}Le.from=je})(Y||(e.ThemableDecorationRenderOptions=Y={}));var x;(function(Le){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=je})(x||(e.DecorationRangeBehavior=x={}));var ne;(function(Le){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?x.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?Y.from(Ee.light):void 0,dark:Ee.dark?Y.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Z(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?X.from(Ee.before):void 0,after:Ee.after?X.from(Ee.after):void 0}}Le.from=je})(ne||(e.DecorationRenderOptions=ne={}));var ge;(function(Le){function je(ee){return{text:ee.newText,eol:ee.newEol&&Be.from(ee.newEol),range:f.from(ee.range)}}Le.from=je;function Ee(ee){const Te=new r.$4M(f.to(ee.range),ee.text);return Te.newEol=typeof ee.eol>"u"?void 0:Be.to(ee.eol),Te}Le.to=Ee})(ge||(e.TextEdit=ge={}));var ue;(function(Le){function je(ee,Te){const He={edits:[]};if(ee instanceof r.$7M){const _e=new b.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&d.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let lt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?lt={type:"base64",value:(0,M.$Xe)(M.$De.wrap(Qe.options.contents))}:lt={type:"dataTransferItem",id:Qe.options.contents._itemId}),He.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:lt},metadata:Qe.metadata})}else Qe._type===2?He.edits.push({resource:Qe.uri,textEdit:ge.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?He.edits.push({resource:Qe.uri,textEdit:{range:f.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?He.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&He.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return He}Le.from=je;function Ee(ee){const Te=new r.$7M,He=new b.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,lt=d.URI.revive(Qe.resource),kt=f.to(Qe.textEdit.range),jt=Qe.textEdit.text,Vt=Qe.textEdit.insertAsSnippet;let ut;Vt?ut=r.$6M.replace(kt,new r.$8M(jt)):ut=r.$4M.replace(kt,jt);const ri=He.get(lt);ri?ri.push(ut):He.set(lt,[ut])}else Te.renameFile(d.URI.revive(_e.oldResource),d.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of He)Te.set(_e,Qe);return Te}Le.to=Ee})(ue||(e.WorkspaceEdit=ue={}));var ve;(function(Le){const je=Object.create(null);je[r.SymbolKind.File]=0,je[r.SymbolKind.Module]=1,je[r.SymbolKind.Namespace]=2,je[r.SymbolKind.Package]=3,je[r.SymbolKind.Class]=4,je[r.SymbolKind.Method]=5,je[r.SymbolKind.Property]=6,je[r.SymbolKind.Field]=7,je[r.SymbolKind.Constructor]=8,je[r.SymbolKind.Enum]=9,je[r.SymbolKind.Interface]=10,je[r.SymbolKind.Function]=11,je[r.SymbolKind.Variable]=12,je[r.SymbolKind.Constant]=13,je[r.SymbolKind.String]=14,je[r.SymbolKind.Number]=15,je[r.SymbolKind.Boolean]=16,je[r.SymbolKind.Array]=17,je[r.SymbolKind.Object]=18,je[r.SymbolKind.Key]=19,je[r.SymbolKind.Null]=20,je[r.SymbolKind.EnumMember]=21,je[r.SymbolKind.Struct]=22,je[r.SymbolKind.Event]=23,je[r.SymbolKind.Operator]=24,je[r.SymbolKind.TypeParameter]=25;function Ee(Te){return typeof je[Te]=="number"?je[Te]:6}Le.from=Ee;function ee(Te){for(const He in je)if(je[He]===Te)return Number(He);return r.SymbolKind.Property}Le.to=ee})(ve||(e.SymbolKind=ve={}));var te;(function(Le){function je(ee){switch(ee){case r.SymbolTag.Deprecated:return 1}}Le.from=je;function Ee(ee){switch(ee){case 1:return r.SymbolTag.Deprecated}}Le.to=Ee})(te||(e.SymbolTag=te={}));var U;(function(Le){function je(ee){return{name:ee.name,kind:ve.from(ee.kind),tags:ee.tags&&ee.tags.map(te.from),containerName:ee.containerName,location:re.from(ee.location)}}Le.from=je;function Ee(ee){const Te=new r.$cN(ee.name,ve.to(ee.kind),ee.containerName,re.to(ee.location));return Te.tags=ee.tags&&ee.tags.map(te.to),Te}Le.to=Ee})(U||(e.WorkspaceSymbol=U={}));var _;(function(Le){function je(ee){const Te={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),kind:ve.from(ee.kind),tags:ee.tags?.map(te.from)??[]};return ee.children&&(Te.children=ee.children.map(je)),Te}Le.from=je;function Ee(ee){const Te=new r.$dN(ee.name,ee.detail,ve.to(ee.kind),f.to(ee.range),f.to(ee.selectionRange));return(0,l.$Lb)(ee.tags)&&(Te.tags=ee.tags.map(te.to)),ee.children&&(Te.children=ee.children.map(Ee)),Te}Le.to=Ee})(_||(e.DocumentSymbol=_={}));var pe;(function(Le){function je(ee){const Te=new r.$hN(ve.to(ee.kind),ee.name,ee.detail||"",d.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Te._sessionId=ee._sessionId,Te._itemId=ee._itemId,Te}Le.to=je;function Ee(ee,Te,He){if(Te=Te??ee._sessionId,He=He??ee._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:ee.name,detail:ee.detail,kind:ve.from(ee.kind),uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(te.from)}}Le.from=Ee})(pe||(e.CallHierarchyItem=pe={}));var Pe;(function(Le){function je(Ee){return new r.$iN(pe.to(Ee.from),Ee.fromRanges.map(ee=>f.to(ee)))}Le.to=je})(Pe||(e.CallHierarchyIncomingCall=Pe={}));var se;(function(Le){function je(Ee){return new r.$jN(pe.to(Ee.to),Ee.fromRanges.map(ee=>f.to(ee)))}Le.to=je})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Le){function je(ee){return{range:ee.range&&f.from(ee.range),uri:ee.uri}}Le.from=je;function Ee(ee){return new r.$9M(d.URI.revive(ee.uri),f.to(ee.range))}Le.to=Ee})(re||(e.location=re={}));var oe;(function(Le){function je(ee){const Te=ee,He=ee;return{originSelectionRange:Te.originSelectionRange?f.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:f.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?f.from(Te.targetSelectionRange):void 0}}Le.from=je;function Ee(ee){return{targetUri:d.URI.revive(ee.uri),targetRange:f.to(ee.range),targetSelectionRange:ee.targetSelectionRange?f.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?f.to(ee.originSelectionRange):void 0}}Le.to=Ee})(oe||(e.DefinitionLink=oe={}));var K;(function(Le){function je(ee){return{range:f.from(ee.range),contents:B.fromMany(ee.contents)}}Le.from=je;function Ee(ee){return new r.$_M(ee.contents.map(B.to),f.to(ee.range))}Le.to=Ee})(K||(e.Hover=K={}));var ie;(function(Le){function je(ee){return{range:f.from(ee.range),expression:ee.expression}}Le.from=je;function Ee(ee){return new r.$7N(f.to(ee.range),ee.expression)}Le.to=Ee})(ie||(e.EvaluatableExpression=ie={}));var $e;(function(Le){function je(ee){if(ee instanceof r.$8N)return{type:"text",range:f.from(ee.range),text:ee.text};if(ee instanceof r.$9N)return{type:"variable",range:f.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof r.$0N)return{type:"expression",range:f.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=je;function Ee(ee){switch(ee.type){case"text":return{range:f.to(ee.range),text:ee.text};case"variable":return{range:f.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:f.to(ee.range),expression:ee.expression}}}Le.to=Ee})($e||(e.InlineValue=$e={}));var we;(function(Le){function je(ee){return{frameId:ee.frameId,stoppedLocation:f.from(ee.stoppedLocation)}}Le.from=je;function Ee(ee){return new r.$$N(ee.frameId,f.to(ee.stoppedLocation))}Le.to=Ee})(we||(e.InlineValueContext=we={}));var Ne;(function(Le){function je(ee){return{range:f.from(ee.range),kind:ee.kind}}Le.from=je;function Ee(ee){return new r.$aN(f.to(ee.range),ee.kind)}Le.to=Ee})(Ne||(e.DocumentHighlight=Ne={}));var fe;(function(Le){function je(ee){return{uri:ee.uri,highlights:ee.highlights.map(Ne.from)}}Le.from=je;function Ee(ee){return new r.$bN(d.URI.revive(ee.uri),ee.highlights.map(Ne.to))}Le.to=Ee})(fe||(e.MultiDocumentHighlight=fe={}));var De;(function(Le){function je(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Le.to=je})(De||(e.CompletionTriggerKind=De={}));var Ie;(function(Le){function je(Ee){return{triggerKind:De.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Le.to=je})(Ie||(e.CompletionContext=Ie={}));var Fe;(function(Le){function je(ee){switch(ee){case r.CompletionItemTag.Deprecated:return 1}}Le.from=je;function Ee(ee){switch(ee){case 1:return r.CompletionItemTag.Deprecated}}Le.to=Ee})(Fe||(e.CompletionItemTag=Fe={}));var V;(function(Le){const je=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee(He){return je.get(He)??9}Le.from=Ee;const ee=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(He){return ee.get(He)??r.CompletionItemKind.Property}Le.to=Te})(V||(e.CompletionItemKind=V={}));var q;(function(Le){function je(Ee,ee){const Te=new r.$rN(Ee.label);return Te.insertText=Ee.insertText,Te.kind=V.to(Ee.kind),Te.tags=Ee.tags?.map(Fe.to),Te.detail=Ee.detail,Te.documentation=R.$Sk(Ee.documentation)?B.to(Ee.documentation):Ee.documentation,Te.sortText=Ee.sortText,Te.filterText=Ee.filterText,Te.preselect=Ee.preselect,Te.commitCharacters=Ee.commitCharacters,g.$pt.isIRange(Ee.range)?Te.range=f.to(Ee.range):typeof Ee.range=="object"&&(Te.range={inserting:f.to(Ee.range.insert),replacing:f.to(Ee.range.replace)}),Te.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Te.insertText=new r.$8M(Ee.insertText):(Te.insertText=Ee.insertText,Te.textEdit=Te.range instanceof r.$YM?new r.$4M(Te.range,Te.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ee.additionalTextEdits.map(He=>ge.to(He))),Te.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Te}Le.to=je})(q||(e.CompletionItem=q={}));var J;(function(Le){function je(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:B.fromStrict(ee.documentation)}}Le.from=je;function Ee(ee){return{label:ee.label,documentation:R.$Sk(ee.documentation)?B.to(ee.documentation):ee.documentation}}Le.to=Ee})(J||(e.ParameterInformation=J={}));var Q;(function(Le){function je(ee){return{label:ee.label,documentation:B.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.from):[],activeParameter:ee.activeParameter}}Le.from=je;function Ee(ee){return{label:ee.label,documentation:R.$Sk(ee.documentation)?B.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.to):[],activeParameter:ee.activeParameter}}Le.to=Ee})(Q||(e.SignatureInformation=Q={}));var he;(function(Le){function je(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.from):[]}}Le.from=je;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.to):[]}}Le.to=Ee})(he||(e.SignatureHelp=he={}));var be;(function(Le){function je(Ee,ee){const Te=new r.$qN(E.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ze.to.bind(void 0,Ee)),ee.kind&&qe.to(ee.kind));return Te.textEdits=ee.textEdits&&ee.textEdits.map(ge.to),Te.tooltip=R.$Sk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,Te.paddingLeft=ee.paddingLeft,Te.paddingRight=ee.paddingRight,Te}Le.to=je})(be||(e.InlayHint=be={}));var ze;(function(Le){function je(Ee,ee){const Te=new r.$pN(ee.label);return Te.tooltip=R.$Sk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,a.Command.is(ee.command)&&(Te.command=Ee.fromInternal(ee.command)),ee.location&&(Te.location=re.to(ee.location)),Te}Le.to=je})(ze||(e.InlayHintLabelPart=ze={}));var qe;(function(Le){function je(ee){return ee}Le.from=je;function Ee(ee){return ee}Le.to=Ee})(qe||(e.InlayHintKind=qe={}));var Ye;(function(Le){function je(ee){return{range:f.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Le.from=je;function Ee(ee){let Te;if(ee.url)try{Te=typeof ee.url=="string"?d.URI.parse(ee.url,!0):d.URI.revive(ee.url)}catch{}return new r.$wN(f.to(ee.range),Te)}Le.to=Ee})(Ye||(e.DocumentLink=Ye={}));var it;(function(Le){function je(ee){const Te=new r.$zN(ee.label);return ee.textEdit&&(Te.textEdit=ge.to(ee.textEdit)),ee.additionalTextEdits&&(Te.additionalTextEdits=ee.additionalTextEdits.map(He=>ge.to(He))),Te}Le.to=je;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?ge.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Te=>ge.from(Te)):void 0}}Le.from=Ee})(it||(e.ColorPresentation=it={}));var ot;(function(Le){function je(ee){return new r.$xN(ee[0],ee[1],ee[2],ee[3])}Le.to=je;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Le.from=Ee})(ot||(e.Color=ot={}));var nt;(function(Le){function je(ee){return{range:f.from(ee.range)}}Le.from=je;function Ee(ee){return new r.$gN(f.to(ee.range))}Le.to=Ee})(nt||(e.SelectionRange=nt={}));var st;(function(Le){function je(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Le.to=je})(st||(e.TextDocumentSaveReason=st={}));var Ce;(function(Le){function je(ee){switch(ee){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.Interval:return 3;case r.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=je;function Ee(ee){switch(ee){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 3:return r.TextEditorLineNumbersStyle.Interval;case 1:default:return r.TextEditorLineNumbersStyle.On}}Le.to=Ee})(Ce||(e.TextEditorLineNumbersStyle=Ce={}));var Be;(function(Le){function je(ee){if(ee===r.EndOfLine.CRLF)return 1;if(ee===r.EndOfLine.LF)return 0}Le.from=je;function Ee(ee){if(ee===1)return r.EndOfLine.CRLF;if(ee===0)return r.EndOfLine.LF}Le.to=Ee})(Be||(e.EndOfLine=Be={}));var Ge;(function(Le){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=je})(Ge||(e.ProgressLocation=Ge={}));var Me;(function(Le){function je(ee){const Te={start:ee.start+1,end:ee.end+1};return ee.kind&&(Te.kind=Ze.from(ee.kind)),Te}Le.from=je;function Ee(ee){const Te={start:ee.start-1,end:ee.end-1};return ee.kind&&(Te.kind=Ze.to(ee.kind)),Te}Le.to=Ee})(Me||(e.FoldingRange=Me={}));var Ze;(function(Le){function je(ee){if(ee)switch(ee){case r.FoldingRangeKind.Comment:return a.$$t.Comment;case r.FoldingRangeKind.Imports:return a.$$t.Imports;case r.FoldingRangeKind.Region:return a.$$t.Region}}Le.from=je;function Ee(ee){if(ee)switch(ee.value){case a.$$t.Comment.value:return r.FoldingRangeKind.Comment;case a.$$t.Imports.value:return r.FoldingRangeKind.Imports;case a.$$t.Region.value:return r.FoldingRangeKind.Region}}Le.to=Ee})(Ze||(e.FoldingRangeKind=Ze={}));var ae;(function(Le){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?f.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?u.$iF.id:void 0}}Le.from=je})(ae||(e.TextEditorOpenOptions=ae={}));var ce;(function(Le){function je(He){return He instanceof r.$UN?He.toJSON():typeof He=="string"?He:Ee(He)||ee(He)?new r.$UN(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=je;function Ee(He){const _e=He;return _e?d.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new r.$UN(d.URI.revive(He.baseUri),He.pattern)}Le.to=Te})(ce||(e.GlobPattern=ce={}));var Ae;(function(Le){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Le.from=je})(Ae||(e.LanguageSelector=Ae={}));var Ke;(function(Le){function je(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Te=>Array.isArray(Te)&&Te.every(He=>He&&typeof He=="object"&&"uri"in He&&d.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(_e=>_e instanceof r.$YM)))}Le.is=je;function Ee(ee){return{documents:ee.documents.map(Te=>Te.map(He=>({uri:d.URI.from(He.uri),version:He.version,ranges:He.ranges.map(_e=>f.from(_e))})))}}Le.from=Ee})(Ke||(e.MappedEditsContext=Ke={}));var Re;(function(Le){function je(ee){return{start:ee.start,end:ee.end}}Le.from=je;function Ee(ee){return new r.$lO(ee.start,ee.end)}Le.to=Ee})(Re||(e.NotebookRange=Re={}));var tt;(function(Le){function je(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Le.to=je;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Le.from=Ee})(tt||(e.NotebookCellExecutionSummary=tt={}));var ht;(function(Le){function je(Ee){if(Ee===t.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===t.NotebookCellExecutionState.Pending)return;if(Ee===t.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Le.to=je})(ht||(e.NotebookCellExecutionState=ht={}));var wt;(function(Le){function je(ee){switch(ee){case r.NotebookCellKind.Markup:return t.CellKind.Markup;case r.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=je;function Ee(ee){switch(ee){case t.CellKind.Markup:return r.NotebookCellKind.Markup;case t.CellKind.Code:default:return r.NotebookCellKind.Code}}Le.to=Ee})(wt||(e.NotebookCellKind=wt={}));var Mt;(function(Le){function je(ee){const Te={metadata:ee.metadata??Object.create(null),cells:[]};for(const He of ee.cells)r.$mO.validate(He),Te.cells.push(At.from(He));return Te}Le.from=je;function Ee(ee){const Te=new r.$nO(ee.cells.map(At.to));return(0,w.$gg)(ee.metadata)||(Te.metadata=ee.metadata),Te}Le.to=Ee})(Mt||(e.NotebookData=Mt={}));var At;(function(Le){function je(ee){return{cellKind:wt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:tt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(_t.from):[]}}Le.from=je;function Ee(ee){return new r.$mO(wt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(_t.to):void 0,ee.metadata,ee.internalMetadata?tt.to(ee.internalMetadata):void 0)}Le.to=Ee})(At||(e.NotebookCellData=At={}));var xt;(function(Le){function je(ee){return{mime:ee.mime,valueBytes:M.$De.wrap(ee.data)}}Le.from=je;function Ee(ee){return new r.$oO(ee.valueBytes.buffer,ee.mime)}Le.to=Ee})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(Le){function je(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Le.from=je;function Ee(ee){const Te=ee.items.map(xt.to);return new r.$pO(Te,ee.outputId,ee.metadata)}Le.to=Ee})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(Le){function je(Te){return ee(Te)?{include:ce.from(Te.include)??void 0,exclude:ce.from(Te.exclude)??void 0}:ce.from(Te)??void 0}Le.from=je;function Ee(Te){return ee(Te)?{include:ce.to(Te.include),exclude:ce.to(Te.exclude)}:ce.to(Te)}Le.to=Ee;function ee(Te){const He=Te;return He?!(0,w.$cg)(He.include)&&!(0,w.$cg)(He.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var qt;(function(Le){function je(Ee,ee,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(He,Te),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Le.from=je})(qt||(e.NotebookStatusBarItem=qt={}));var Zt;(function(Le){function je(Ee,ee,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(He,Te),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Le.from=je})(Zt||(e.NotebookKernelSourceAction=Zt={}));var et;(function(Le){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Le.from=je})(et||(e.NotebookDocumentContentOptions=et={}));var si;(function(Le){function je(ee){return{uri:ee.uri,provides:ee.provides}}Le.from=je;function Ee(ee){return new r.$rO(d.URI.revive(ee.uri),ee.provides)}Le.to=Ee})(si||(e.NotebookRendererScript=si={}));var Yt;(function(Le){function je(ee){return{message:B.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:f.from(ee.location.range),uri:ee.location.uri}}}Le.from=je;function Ee(ee){const Te=new r.$xO(typeof ee.message=="string"?ee.message:B.to(ee.message));return Te.actualOutput=ee.actual,Te.expectedOutput=ee.expected,Te.contextValue=ee.contextValue,Te.location=ee.location?re.to(ee.location):void 0,Te}Le.to=Ee})(Yt||(e.TestMessage=Yt={}));var dt;(function(Le){Le.namespace=s.$LL,Le.denamespace=s.$ML})(dt||(e.TestTag=dt={}));var vt;(function(Le){function je(ee){const Te=(0,n.$dP)(ee).controllerId;return{extId:h.$GL.fromExtHostTestItem(ee,Te).toString(),label:ee.label,uri:d.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(He=>dt.namespace(Te,He.id)),range:g.$pt.lift(f.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&B.fromStrict(ee.error)||null}}Le.from=je;function Ee(ee){return{parent:void 0,error:void 0,id:h.$GL.fromString(ee.extId).localId,label:ee.label,uri:d.URI.revive(ee.uri),tags:(ee.tags||[]).map(Te=>{const{tagId:He}=dt.denamespace(Te);return new r.$yO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:f.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Le.toPlain=Ee})(vt||(e.TestItem=vt={})),function(Le){function je(ee){return{id:ee.id}}Le.from=je;function Ee(ee){return new r.$yO(ee.id)}Le.to=Ee}(dt||(e.TestTag=dt={}));var ti;(function(Le){const je=(ee,Te)=>{const He=ee.value;if(!He)return;const _e={...vt.toPlain(He.item),parent:Te,taskStates:He.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(lt=>lt.type===0).map(Yt.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const lt=je(Qe,_e);lt&&_e.children.push(lt)}return _e};function Ee(ee){const Te=new m.$9O;for(const Qe of ee.items)Te.insert(h.$GL.fromString(Qe.item.extId).path,Qe);const He=[Te.nodes],_e=[];for(;He.length;)for(const Qe of He.pop())Qe.value?_e.push(Qe):Qe.children&&He.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>je(Qe)).filter(w.$bg)}}Le.to=Ee})(ti||(e.TestResults=ti={}));var Xt;(function(Le){function je(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?E.from(He):f.from(He)}function ee(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:He.name,count:He.executed,location:Ee(He.location)}}Le.fromDetails=ee;function Te(He,_e){return r.$AO(_e.statementCoverage),r.$AO(_e.branchCoverage),r.$AO(_e.declarationCoverage),{id:He,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Le.fromFile=Te})(Xt||(e.TestCoverage=Xt={}));var zt;(function(Le){function je(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Le.to=je})(zt||(e.CodeActionTriggerKind=zt={}));var gt;(function(Le){function je(ee){const Te=new r.$FO(ve.to(ee.kind),ee.name,ee.detail||"",d.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Te._sessionId=ee._sessionId,Te._itemId=ee._itemId,Te}Le.to=je;function Ee(ee,Te,He){if(Te=Te??ee._sessionId,He=He??ee._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:ve.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(te.from)}}Le.from=Ee})(gt||(e.TypeHierarchyItem=gt={}));var Ut;(function(Le){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Le.from=je})(Ut||(e.ViewBadge=Ut={}));var Wt;(function(Le){function je(He,_e,Qe){const lt=_e.fileData;return lt?new r.$MN(new r.$NN(lt.name,d.URI.revive(lt.uri),lt.id,(0,A.$db)(()=>Qe(lt.id)))):He===N.$Ms.uriList&&_e.uriListData?new r.$LN(Te(_e.uriListData)):new r.$LN(_e.asString)}Le.to=je;async function Ee(He,_e){const Qe=await _e.asString();if(He===N.$Ms.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const lt=_e.asFile();return{asString:Qe,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Le.from=Ee;function ee(He){return L.$Pt.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return d.URI.parse(_e)}catch{}return _e})}function Te(He){return L.$Pt.create(He.map(_e=>typeof _e=="string"?_e:d.URI.revive(_e)))}})(Wt||(e.DataTransferItem=Wt={}));var Ht;(function(Le){function je(ee,Te){const He=ee.items.map(([_e,Qe])=>[_e,Wt.to(_e,Qe,Te)]);return new r.$ON(He)}Le.toDataTransfer=je;async function Ee(ee){const Te={items:[]},He=[];for(const[_e,Qe]of ee)He.push((async()=>{Te.items.push([_e,await Wt.from(_e,Qe)])})());return await Promise.all(He),Te}Le.from=Ee})(Ht||(e.DataTransfer=Ht={}));var Xe;(function(Le){function je(ee,Te){return{kind:"reply",agentId:ee.participant??Te?.agentId??"",subCommand:ee.command??Te?.command,message:ee.prompt,title:ee.label}}Le.from=je;function Ee(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Le.to=Ee})(Xe||(e.ChatFollowup=Xe={}));var ui;(function(Le){function je(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Le.from=je})(ui||(e.ChatInlineFollowup=ui={}));var Gt;(function(Le){function je(ee){switch(ee.role){case 0:return new r.$4O(ee.content);case 1:return new r.$5O(ee.content);case 2:return new r.$6O(ee.content)}}Le.to=je;function Ee(ee){if(ee instanceof r.$4O)return{role:0,content:ee.content};if(ee instanceof r.$5O)return{role:1,content:ee.content};if(ee instanceof r.$6O)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Le.from=Ee})(Gt||(e.LanguageModelMessage=Gt={}));var Bt;(function(Le){function je(Te){const He={};for(const _e of Object.keys(Te))He[_e]=Te[_e].map(Le.to);return He}Le.objectTo=je;function Ee(Te){return{level:mt.to(Te.level),kind:Te.kind,value:(0,d.$wc)(Te.value)?d.URI.revive(Te.value):Te.value,description:Te.description}}Le.to=Ee;function ee(Te){return{level:mt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Le.from=ee})(Bt||(e.ChatVariable=Bt={}));var mt;(function(Le){function je(ee){switch(ee){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Le.to=je;function Ee(ee){switch(ee){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Le.from=Ee})(mt||(e.ChatVariableLevel=mt={}));var Ft;(function(Le){function je(Ee){switch(Ee){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=je})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Rt;(function(Le){function je(ee){return{kind:"markdownContent",content:B.from(ee.value)}}Le.from=je;function Ee(ee){return new r.$SO(B.to(ee.content))}Le.to=Ee})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Tt;(function(Le){function je(ee){return{kind:"markdownVuln",content:B.from(ee.value),vulnerabilities:ee.vulnerabilities}}Le.from=je;function Ee(ee){return new r.$TO(B.to(ee.content),ee.vulnerabilities)}Le.to=Ee})(Tt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Tt={}));var ii;(function(Le){function je(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Le.from=je;function Ee(ee){return new r.$UO(ee.agentId,ee.command)}Le.to=Ee})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Kt;(function(Le){function je(ee){const{value:Te,baseUri:He}=ee;function _e(Qe,lt){return Qe.map(kt=>{const jt=d.URI.joinPath(lt,kt.name);return{label:kt.name,uri:jt,children:kt.children&&_e(kt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,y.$4g)(He),uri:He,children:_e(Te,He)}}}Le.from=je;function Ee(ee){const Te=(0,S.$3h)(ee.treeData);function He(lt){return lt.map(kt=>({name:kt.label,children:kt.children&&He(kt.children)}))}const _e=Te.uri,Qe=Te.children?He(Te.children):[];return new r.$VO(Qe,_e)}Le.to=Ee})(Kt||(e.ChatResponseFilesPart=Kt={}));var ni;(function(Le){function je(ee){return{kind:"inlineReference",name:ee.title,inlineReference:d.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=je;function Ee(ee){const Te=(0,S.$3h)(ee);return new r.$WO(d.URI.isUri(Te.inlineReference)?Te.inlineReference:D.to(Te.inlineReference),ee.name)}Le.to=Ee})(ni||(e.ChatResponseAnchorPart=ni={}));var Ot;(function(Le){function je(ee){return{kind:"progressMessage",content:B.from(ee.value)}}Le.from=je;function Ee(ee){return new r.$XO(ee.content.value)}Le.to=Ee})(Ot||(e.ChatResponseProgressPart=Ot={}));var Nt;(function(Le){function je(ee,Te,He){return{kind:"command",command:Te.toInternal(ee.value,He)??{command:ee.value.command,title:ee.value.title}}}Le.from=je;function Ee(ee,Te){return new r.$YO(Te.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Le.to=Ee})(Nt||(e.ChatResponseCommandButtonPart=Nt={}));var It;(function(Le){function je(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Te=>ge.from(Te))}}Le.from=je;function Ee(ee){return new r.$1O(d.URI.revive(ee.uri),ee.edits.map(Te=>ge.to(Te)))}Le.to=Ee})(It||(e.ChatResponseTextEditPart=It={}));var St;(function(Le){function je(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:d.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:D.from(ee.value.value)}}:{kind:"reference",reference:d.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=je;function Ee(ee){const Te=(0,S.$3h)(ee),He=_e=>d.URI.isUri(_e)?_e:D.to(_e);return new r.$ZO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&He(Te.reference.value)}:He(Te.reference))}Le.to=Ee})(St||(e.ChatResponseReferencePart=St={}));var pt;(function(Le){function je(Te,He,_e){return Te instanceof r.$SO?Rt.from(Te):Te instanceof r.$WO?ni.from(Te):Te instanceof r.$ZO?St.from(Te):Te instanceof r.$XO?Ot.from(Te):Te instanceof r.$VO?Kt.from(Te):Te instanceof r.$YO?Nt.from(Te,He,_e):Te instanceof r.$1O?It.from(Te):Te instanceof r.$TO?Tt.from(Te):Te instanceof r.$UO?ii.from(Te):{kind:"markdownContent",content:B.from("")}}Le.from=je;function Ee(Te,He){switch(Te.kind){case"reference":return St.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Te,He)}}Le.to=Ee;function ee(Te,He){switch(Te.kind){case"markdownContent":return Rt.to(Te);case"inlineReference":return ni.to(Te);case"progressMessage":return;case"treeData":return Kt.to(Te);case"command":return Nt.to(Te,He)}}Le.toContent=ee})(pt||(e.ChatResponsePart=pt={}));var Ct;(function(Le){function je(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,variables:Ee.variables.variables.map(Dt.to),location:li.to(Ee.location)}}Le.to=je})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Le){function je(Ee){switch(Ee){case o.ChatAgentLocation.Notebook:return r.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return r.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return r.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return r.ChatLocation.Editor}}Le.to=je})(li||(e.ChatLocation=li={}));var Dt;(function(Le){function je(Ee){return{name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(Bt.to)}}Le.to=je})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(Le){function je(Ee,ee,Te){return{label:Ee.label,values:Ee.values.map(Bt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:ee.toInternal(Ee.command,Te)}}Le.from=je})(hi||(e.ChatAgentCompletionItem=hi={}));var Jt;(function(Le){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Le.to=je})(Jt||(e.ChatAgentResult=Jt={}));var wi;(function(Le){function je(Ee,ee,Te){if(ee.action.kind==="vote")return;const He=Jt.to(Ee);if(ee.action.kind==="command"){const _e=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:He}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:Xe.to(ee.action.followup)},result:He}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:He}:{action:ee.action,result:He}}Le.to=je})(wi||(e.ChatAgentUserActionEvent=wi={}));var ei;(function(Le){function je(Ee,ee,Te){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ee.toInternal(Ee,Te)}Le.from=je})(ei||(e.TerminalQuickFix=ei={}));var vi;(function(Le){function je(Ee){return{kind:Et.to(Ee.kind)}}Le.to=je})(vi||(e.PartialAcceptInfo=vi={}));var Et;(function(Le){function je(Ee){switch(Ee){case 0:return r.PartialAcceptTriggerKind.Word;case 1:return r.PartialAcceptTriggerKind.Line;case 2:return r.PartialAcceptTriggerKind.Suggest;default:return r.PartialAcceptTriggerKind.Unknown}}Le.to=je})(Et||(e.PartialAcceptTriggerKind=Et={}));var $i;(function(Le){function je(Ee,ee){return{id:ee,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Le.from=je})($i||(e.DebugTreeItem=$i={}))}),define(ke[327],Se([1,0,6,20,16,48]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;let R=class{constructor($,S){this.a=$.getProxy(l.$UM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>S.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,S,N){const C=new A.$qw(L.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,N?.isRefactoring??!1)}};e.$Qkc=R,e.$Qkc=R=Je([Ve(0,M.$hP)],R)}),define(ke[328],Se([1,0,19,8,47,4,39,3,40,18,2,25,6,16,7,291,26]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class a{constructor(o,t,h,s,c){this.j=o,this.k=t,this.l=h,this.m=s,this.n=c,this.b=$.$$d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(s){if(o.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,s),c}};const o=this;this.b.reset();const h=s=>{typeof this.d>"u"&&"content"in s&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,s)};this.g={markdown(s){t(this.markdown);const c=new w.$SO(s),r=y.ChatResponseMarkdownPart.from(c);return h(r),this},markdownWithVulnerabilities(s,c){t(this.markdown),c&&(0,g.$CG)(o.j,"chatParticipantAdditions");const r=new w.$TO(s,c),v=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(r);return h(v),this},filetree(s,c){t(this.filetree);const r=new w.$VO(s,c),v=y.ChatResponseFilesPart.from(r);return h(v),this},anchor(s,c){t(this.anchor);const r=new w.$WO(s,c),v=y.ChatResponseAnchorPart.from(r);return h(v),this},button(s){t(this.anchor);const c=new w.$YO(s),r=y.ChatResponseCommandButtonPart.from(c,o.m,o.n);return h(r),this},progress(s){t(this.progress);const c=new w.$XO(s),r=y.ChatResponseProgressPart.from(c);return h(r),this},reference(s){if(t(this.reference),"variableName"in s&&!s.value){const c=o.k.variables.variables.find(r=>r.name===s.variableName);if(c){let r;if(c.references?.length)r=c.references.map(v=>({kind:"reference",reference:{variableName:s.variableName,value:v.reference}}));else{const v=new w.$ZO(s);r=[y.ChatResponseReferencePart.from(v)]}return r.forEach(v=>h(v)),this}}else{const c=new w.$ZO(s),r=y.ChatResponseReferencePart.from(c);h(r)}return this},textEdit(s,c){t(this.textEdit),(0,g.$CG)(o.j,"chatParticipantAdditions");const r=new w.$1O(s,c),v=y.ChatResponseTextEditPart.from(r);return h(v),this},detectedParticipant(s,c){t(this.detectedParticipant),(0,g.$CG)(o.j,"chatParticipantAdditions");const r=new w.$UO(s,c),v=y.ChatResponseDetectedParticipantPart.from(r);return h(v),this},push(s){if(t(this.push),(s instanceof w.$1O||s instanceof w.$TO||s instanceof w.$UO)&&(0,g.$CG)(o.j,"chatParticipantAdditions"),s instanceof w.$ZO)this.reference(s.value);else{const c=y.ChatResponsePart.from(s,o.m,o.n);h(c)}return this}}}return this.g}}class i extends b.$Vc{static{this.b=0}constructor(o,t,h){super(),this.n=t,this.s=h,this.c=new Map,this.j=this.B(new b.$5c),this.m=this.B(new b.$Uc),this.g=o.getProxy(m.$UM.MainThreadChatAgents2)}transferActiveChat(o){this.g.$transferActiveChatSession(o)}createChatAgent(o,t,h){const s=i.b++,c=new n(o,t,this.g,s,h);return this.c.set(s,c),this.g.$registerAgent(s,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,h,s,c){const r=i.b++,v=new n(o,t,this.g,r,c);return this.c.set(r,v),this.g.$registerAgent(r,o.identifier,t,{isSticky:!0},{name:h,description:s}),v.apiAgent}async $invokeAgent(o,t,h,s){const c=this.c.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let r=this.j.get(t.sessionId);r||(r=new b.$Uc,this.j.set(t.sessionId,r));const v=new a(c.extension,t,this.g,this.s.converter,r);try{const f=await this.t(t.agentId,h),D=c.invoke(y.ChatAgentRequest.to(t),{history:f},v.apiObject,s);return await(0,M.$hh)(Promise.resolve(D).then(p=>{if(p?.metadata)try{JSON.stringify(p.metadata)}catch(E){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${k}`,c.extension),{errorDetails:{message:k},timings:v.timings}}return{errorDetails:p?.errorDetails,timings:v.timings,metadata:p?.metadata}}),s)}catch(f){return this.n.error(f,c.extension),{errorDetails:{message:(0,L.$ej)(f),responseIsIncomplete:!0}}}finally{v.close()}}async t(o,t){const h=[];for(const s of t.history){const c=y.ChatAgentResult.to(s.result),r=o===s.request.agentId?c:{...c,metadata:void 0};h.push(new w.$2O(s.request.message,s.request.command,s.request.variables.variables.map(y.ChatAgentResolvedVariable.to),s.request.agentId));const v=(0,l.$Hb)(s.response.map(f=>y.ChatResponsePart.toContent(f,this.s.converter)));h.push(new w.$3O(v,r,s.request.agentId,s.request.command))}return h}$releaseSession(o){this.j.deleteAndDispose(o)}async $provideFollowups(o,t,h,s,c){const r=this.c.get(t);if(!r)return Promise.resolve([]);const v=await this.t(r.id,s),f=y.ChatAgentResult.to(h);return(await r.provideFollowups(f,{history:v},c)).filter(D=>{const p=!D.participant||R.Iterable.some(this.c.values(),E=>E.id===D.participant&&C.$Om.equals(E.extension.identifier,r.extension.identifier));return p||this.n.warn(`[@${r.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),p}).map(D=>y.ChatFollowup.from(D,o))}$acceptFeedback(o,t,h,s){const c=this.c.get(o);if(!c)return;const r=y.ChatAgentResult.to(t);let v;switch(h){case d.InteractiveSessionVoteDirection.Down:v=w.ChatResultFeedbackKind.Unhelpful;break;case d.InteractiveSessionVoteDirection.Up:v=w.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(s?{result:r,kind:v,reportIssue:s}:{result:r,kind:v}))}$acceptAction(o,t,h){const s=this.c.get(o);if(!s||h.action.kind==="vote")return;const c=y.ChatAgentUserActionEvent.to(t,h,this.s.converter);c&&s.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,h){const s=this.c.get(o);return s?(await s.invokeCompletionProvider(t,h)).map(r=>y.ChatAgentCompletionItem.from(r,this.s.converter,this.m)):[]}async $provideWelcomeMessage(o,t,h){const s=this.c.get(o);if(s)return await s.provideWelcomeMessage(y.ChatLocation.to(t),h)}async $provideSampleQuestions(o,t,h){const s=this.c.get(o);if(s)return(await s.provideSampleQuestions(y.ChatLocation.to(t),h)).map(c=>y.ChatFollowup.from(c,void 0))}}e.$Rkc=i;class n{constructor(o,t,h,s,c){this.extension=o,this.id=t,this.u=h,this.w=s,this.x=c,this.n=new A.$ce,this.o=new A.$ce}acceptFeedback(o){this.n.fire(o)}acceptAction(o){this.o.fire(o)}async invokeCompletionProvider(o,t){return this.q?await this.q.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,h){if(!this.b)return[];const s=await this.b.provideFollowups(o,t,h);return s?s.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this.s)return[];const h=await this.s.provideWelcomeMessage(o,t);return h?h.map(s=>typeof s=="string"?s:y.MarkdownString.from(s)):[]}async provideSampleQuestions(o,t){if(!this.s||!this.s.provideSampleQuestions)return[];const h=await this.s.provideSampleQuestions(o,t);return h||[]}get apiAgent(){let o=!1,t=!1;const h=()=>{o||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof N.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof w.$SN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},s=this;return{get id(){return s.id},get fullName(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.c??s.extension.displayName??s.extension.name},set fullName(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.c=c,h()},get iconPath(){return s.d},set iconPath(c){s.d=c,h()},get requestHandler(){return s.x},set requestHandler(c){(0,S.$dg)(typeof c=="function","Invalid request handler"),s.x=c},get followupProvider(){return s.b},set followupProvider(c){s.b=c,h()},get isDefault(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.g},set isDefault(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.g=c,h()},get helpTextPrefix(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.j},set helpTextPrefix(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.j=c,h()},get helpTextVariablesPrefix(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.k},set helpTextVariablesPrefix(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.k=c,h()},get helpTextPostfix(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.l},set helpTextPostfix(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.l=c,h()},get isSecondary(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.m},set isSecondary(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.m=c,h()},get supportIssueReporting(){return(0,g.$CG)(s.extension,"chatParticipantAdditions"),s.p},set supportIssueReporting(c){(0,g.$CG)(s.extension,"chatParticipantAdditions"),s.p=c,h()},get onDidReceiveFeedback(){return s.n.event},set participantVariableProvider(c){if((0,g.$CG)(s.extension,"chatParticipantAdditions"),s.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");s.u.$registerAgentCompletionsProvider(s.w,c.triggerCharacters)}else s.u.$unregisterAgentCompletionsProvider(s.w)},get participantVariableProvider(){return(0,g.$CG)(s.extension,"chatParticipantAdditions"),s.q},set welcomeMessageProvider(c){(0,g.$CG)(s.extension,"defaultChatParticipant"),s.s=c,h()},get welcomeMessageProvider(){return(0,g.$CG)(s.extension,"defaultChatParticipant"),s.s},onDidPerformAction:(0,g.$BG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){s.t=c,h()},get requester(){return s.t},dispose(){o=!0,s.b=void 0,s.n.dispose(),s.u.$unregisterAgent(s.w)}}}invoke(o,t,h,s){return this.x(o,t,h,s)}}}),define(ke[329],Se([1,0,13,3,6,16,7,26]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class ${static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$UM.MainThreadChatVariables)}async $resolveVariable(C,m,y,w){const d=this.b.get(C);if(d)try{if(d.resolver.resolve2){(0,b.$CG)(d.extension,"chatParticipantAdditions");const g=new S(m,this.c),a=await d.resolver.resolve2(d.data.name,{prompt:y},g.apiObject,w);if(a)return a.map(A.ChatVariable.from)}else{const g=await d.resolver.resolve(d.data.name,{prompt:y},w);if(g)return g.map(A.ChatVariable.from)}}catch(g){(0,l.$2)(g)}}registerVariableResolver(C,m,y,w){const d=$.a++;return this.b.set(d,{extension:C,data:{name:m,description:y},resolver:w}),this.c.$registerVariable(d,{name:m,description:y}),(0,M.$Tc)(()=>{this.b.delete(d),this.c.$unregisterVariable(d)})}}e.$Skc=$;class S{constructor(C,m){this.c=C,this.d=m,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let m=function(w){if(C.a){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,w),d}};const C=this,y=w=>{this.d.$handleProgressChunk(this.c,w)};this.b={progress(w){m(this.progress);const d=new R.$XO(w),g=A.ChatResponseProgressPart.from(d);return y(g),this},reference(w){m(this.reference);const d=new R.$ZO(w),g=A.ChatResponseReferencePart.from(d);return y(g),this},push(w){return m(this.push),w instanceof R.$ZO?y(A.ChatResponseReferencePart.from(w)):w instanceof R.$XO&&y(A.ChatResponseProgressPart.from(w)),this}}}return this.b}}}),define(ke[330],Se([1,0,8,55,4,3,2,83,25,16,7,6,26]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=y;function y(w,d,g){const a=w.getProxy(C.$UM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Qm,d.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const D=this.b.get(f.handle);return D?D.value:f}else if(f&&f.$mid===7){const D=f,p=this.b.get(D.commentControlHandle);if(!p)return D;const E=p.getCommentThread(D.commentThreadHandle);return E?E.value:D}else if(f&&(f.$mid===9||f.$mid===8)){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const p=D.getCommentThread(f.thread.commentThreadHandle);return p?f.$mid===8?p.value:{thread:p.value,text:f.text}:f}else if(f&&f.$mid===10){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const p=D.getCommentThread(f.thread.commentThreadHandle);if(!p)return f;const E=f.commentUniqueId,k=p.getCommentByUniqueId(E);return k||f}else if(f&&f.$mid===11){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const p=D.getCommentThread(f.thread.commentThreadHandle);if(!p)return f;const E=f.text,k=f.commentUniqueId,P=p.getCommentByUniqueId(k);return P?(typeof P.body=="string"?P.body=E:P.body=new N.$lN(E),P):f}return f}})}createCommentController(f,D,p){const E=i.a++,k=new u(f,E,D,p);this.b.set(k.handle,k);const P=this.c.get(f.identifier)||[];return P.push(k),this.c.set(f.identifier,P),k.value}async $createCommentThreadTemplate(f,D,p){const E=this.b.get(f);E&&E.$createCommentThreadTemplate(D,p)}async $setActiveComment(f,D){const p=this.b.get(f);p&&p.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(f,D,p){const E=this.b.get(f);E&&E.$updateCommentThreadTemplate(D,p)}$deleteCommentThread(f,D){this.b.get(f)?.$deleteCommentThread(D)}async $provideCommentingRanges(f,D,p){const E=this.b.get(f);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await g.ensureDocumentData(R.URI.revive(D));return(0,l.$lh)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(k.document,p);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(T=>S.Range.from(T)),fileComments:P.fileComments}),I})}$toggleReaction(f,D,p,E,k){const P=this.b.get(f);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,l.$lh)(()=>{const I=P.getCommentThread(D);if(I){const T=I.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&T&&P.reactionHandler)return P.reactionHandler(T,h(k))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,m.$CG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,D,p,E,k,P,I,T){this.m=D,this.n=p,this.o=E,this.p=k,this.q=P,this.extensionDescription=I,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$ce,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Wc,this.l.value=new A.$Uc,this.n===void 0&&(this.n=`${f}.${this.handle}`),a.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Uc);const f=p=>Object.prototype.hasOwnProperty.call(this.b,p),D={};f("range")&&(D.range=S.Range.from(this.p)),f("label")&&(D.label=this.label),f("contextValue")&&(D.contextValue=this.contextValue??null),f("comments")&&(D.comments=this.q.map(p=>o(this,p,this.k,this.extensionDescription))),f("collapsibleState")&&(D.collapseState=s(this.g)),f("canReply")&&(D.canReply=this.canReply),f("state")&&(D.state=c(this.h)),f("applicability")&&(D.applicability=r(this.h)),f("isTemplate")&&(D.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(f){for(const D of this.k){const p=D[0],E=D[1];if(f===E)return p}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,M.$Yh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,m.$CG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$CG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$CG)(this.h,"activeComment"),this.f}constructor(f,D,p,E){this.h=f,this.i=D,this.j=p,this.k=E,this.a=new Map,a.$registerCommentController(this.handle,p,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},get activeCommentThread(){return k.activeCommentThread},createCommentThread(P,I,T){return k.createCommentThread(P,I,T).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,D,p){D===void 0&&(0,m.$CG)(this.h,"fileComments");const E=new n(this.id,this.handle,void 0,f,D,p,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const D=this.a.get(f.commentThreadHandle);D&&(this.e=f.uniqueIdInThread?D.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(f,D){const p=new n(this.id,this.handle,void 0,R.URI.revive(f),S.Range.to(D),[],this.h,!0);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(f,D){const p=this.a.get(f);p&&(p.range=S.Range.to(D))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function o(v,f,D,p){let E=D.get(f);return E||(E=++v.commentHandle,D.set(f,E)),f.state!==void 0&&(0,m.$CG)(p,"commentsDraftState"),f.reactions?.some(k=>k.reactors!==void 0)&&(0,m.$CG)(p,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:E,body:typeof f.body=="string"?f.body:S.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(k=>t(k)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?S.$gP(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(f=>f.name):v.reactors}}function h(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(f=>({name:f}))}}function s(v){if(v!==void 0)switch(v){case N.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(v){let f;if(typeof v=="object"?f=v.resolved:f=v,f!==void 0)switch(f){case N.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function r(v){let f;if(typeof v=="object"&&(f=v.applicability),f!==void 0)switch(f){case N.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(ke[331],Se([1,0,22,56,3,15,23,2,16,92,111,6,7]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class y{constructor(h,s){this.document=h,this.b=s,this.a=1,this.c=new N.$Ckc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,s){await this.f(h).undo(),s||this.disposeBackup()}async redo(h,s){await this.f(h).redo(),s||this.disposeBackup()}disposeEdits(h){for(const s of h)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=o(this.document.uri)+this.a++;return(0,R.$7g)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const s=this.c.get(h,0);if(!s)throw new Error("No edit found");return s}}class w{constructor(){this.a=new Map}get(h,s){return this.a.get(this.b(h,s))}add(h,s,c){const r=this.b(h,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${h} resource:${s.uri}`);const v=new y(s,c);return this.a.set(r,v),v}delete(h,s){const c=this.b(h,s.uri);this.a.delete(c)}b(h,s){return`${h}@@@${s}`}}var d;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(d||(d={}));class g{constructor(){this.a=new Map}addTextProvider(h,s,c){return this.b(0,h,s,c)}addCustomProvider(h,s,c){return this.b(1,h,s,c)}get(h){return this.a.get(h)}b(h,s,c,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:h,extension:c,provider:r}),new m.$WM(()=>this.a.delete(s))}}class a{constructor(h,s,c,r,v){this.d=s,this.f=c,this.g=r,this.h=v,this.b=new g,this.c=new w,this.a=h.getProxy(C.$UM.MainThreadCustomEditors)}registerCustomEditorProvider(h,s,c,r){const v=new L.$Uc;return n(c)?(v.add(this.b.addTextProvider(s,h,c)),this.a.$registerTextEditorProvider((0,S.$_kc)(h),s,r.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,S.$0kc)(h))):(v.add(this.b.addCustomProvider(s,h,c)),i(c)&&v.add(c.onDidChangeCustomDocument(f=>{const D=this.i(s,f.document.uri);if(u(f)){const p=D.addEdit(f);this.a.$onDidEdit(f.document.uri,s,p,f.label)}else this.a.$onContentChange(f.document.uri,s)})),this.a.$registerCustomEditorProvider((0,S.$_kc)(h),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,S.$0kc)(h))),m.$WM.from(v,new m.$WM(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(h,s,c,r,v){const f=this.b.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${s}'`);const D=b.URI.revive(h),p=await f.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:r?.buffer},v);let E;return i(f.provider)&&this.f&&(E=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(s,p,E),{editable:i(f.provider)}}async $disposeCustomDocument(h,s){const c=this.b.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=b.URI.revive(h),{document:v}=this.i(s,r);this.c.delete(s,v),v.dispose()}async $resolveCustomEditor(h,s,c,r,v,f){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const p=$.ViewColumn.to(v),E=this.g.createNewWebview(s,r.contentOptions,D.extension),k=this.h.createNewWebviewPanel(s,c,r.title,p,r.options,E,r.active),P=b.URI.revive(h);switch(D.type){case 1:{const{document:I}=this.i(c,P);return D.provider.resolveCustomEditor(I,k,f)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,k,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,s,c){this.i(s,h).disposeEdits(c)}async $onMoveCustomEditor(h,s,c){const r=this.b.get(c);if(!r)throw new Error(`No provider found for '${c}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const v=this.h.getWebviewPanel(h);if(!v)throw new Error("No webview found");const f=b.URI.revive(s),D=this.d.getDocument(f);await r.provider.moveCustomTextEditor(D,v,l.CancellationToken.None)}async $undo(h,s,c,r){return this.i(s,h).undo(c,r)}async $redo(h,s,c,r){return this.i(s,h).redo(c,r)}async $revert(h,s,c){const r=this.i(s,h);await this.j(s).revertCustomDocument(r.document,c),r.disposeBackup()}async $onSave(h,s,c){const r=this.i(s,h);await this.j(s).saveCustomDocument(r.document,c),r.disposeBackup()}async $onSaveAs(h,s,c,r){const v=this.i(s,h);return this.j(s).saveCustomDocumentAs(v.document,b.URI.revive(c),r)}async $backup(h,s,c){const r=this.i(s,h),f=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},c);return r.updateBackup(f),f.id}i(h,s){const c=this.c.get(h,b.URI.revive(s));if(!c)throw new Error("No custom document found");return c}j(h){const c=this.b.get(h)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.$clc=a;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const h=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,M.$hj)(h)+""}}),define(ke[332],Se([1,0,218,138,2,6,7,16,4,12,27,60]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class y{#e;#t;#i;constructor(g,a,i,n,u,o,t,h){this.d=g,this.e=a,this.f=i,this.g=n,this.h=u,this.c=!1,this.f=Math.max(n,i),this.#i=new N.$Bc(s=>o.getComparisonKey(s)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,a){if(!g){this.clear();return}this.j();let i=[];if(L.URI.isUri(g)){if(!a){this.delete(g);return}this.#i.set(g,a.slice()),i=[g]}else if(Array.isArray(g)){i=[];let o;g=[...g].sort(y.k);for(const t of g){const[h,s]=t;if((!o||h.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=h,i.push(h),this.#i.set(h,[])),s)this.#i.get(h)?.push(...s);else{const c=this.#i.get(h);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let u=0;for(const o of i){let t=[];const h=this.#i.get(o);if(h)if(h.length>this.g){t=[];const s=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const r of h)if(r.severity===s[c]&&t.push({...b.Diagnostic.from(r),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,l.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(s=>({...b.Diagnostic.from(s),modelVersionId:this.h(o)}));if(n.push([o,t]),u+=t.length,u>this.f)break}this.#e.$changeMany(this.e,n)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,a){this.j();for(const[i,n]of this)g.call(a,i,n,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const a=this.#i.get(g);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,a){return g[0].toString()<a[0].toString()?-1:g[0].toString()>a[0].toString()?1:0}}e.$Jkc=y;let w=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(g){const a=new N.$Bc;for(const i of g)a.set(i,i);return{uris:Object.freeze(Array.from(a.values()))}}constructor(g,a,i,n){this.j=a,this.k=i,this.l=n,this.g=new Map,this.h=new $.$ge({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=g.getProxy(A.$UM.MainThreadDiagnostics)}createDiagnosticCollection(g,a){const{g:i,f:n,h:u,j:o,k:t,l:h}=this,s=new class{$changeMany(v,f){n.$changeMany(v,f),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,v,f.length===0?"CLEARING":f)}$clear(v){n.$clear(v),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,v)}dispose(){n.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+m.c++,c=a;else if(!i.has(a))c=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+m.c++;while(i.has(c))}return new class extends y{constructor(){super(a,c,m.e,m.d,v=>h.getDocument(v)?.version,t.extUri,s,u),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(g){if(g)return this.m(g);{const a=new Map,i=[];for(const n of this.g.values())n.forEach((u,o)=>{let t=a.get(u.toString());typeof t>"u"&&(t=i.length,a.set(u.toString(),t),i.push([u,[]])),i[t][1]=i[t][1].concat(...o)});return i}}m(g){let a=[];for(const i of this.g.values())i.has(g)&&(a=a.concat(i.get(g)));return a}$acceptMarkersChange(g){if(!this.n){const a="_generated_mirror",i=new y(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(a,i),this.n=i}for(const[a,i]of g)this.n.set(L.URI.revive(a),i.map(b.Diagnostic.to))}};e.$Kkc=w,e.$Kkc=w=m=Je([Ve(1,S.$Zj),Ve(2,C.$Ikc)],w)}),define(ke[333],Se([1,0,2,13,7,16,75,48]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class ${constructor(N,C,m,y={timeout:1500,errors:3}){this.c=N,this.d=C,this.f=m,this.g=y,this.a=new R.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(C,m,y)=>{const d={dispose:this.a.push([C,m,N])};return Array.isArray(y)&&y.push(d),d}}async $participateInSave(N,C){const m=l.URI.revive(N);let y=!1;const w=setTimeout(()=>y=!0,this.g.timeout),d=[];try{for(const g of[...this.a]){if(y)break;const a=this.d.getDocument(m),i=await this.h(g,{document:a,reason:A.TextDocumentSaveReason.to(C)});d.push(i)}}finally{clearTimeout(w)}return d}h([N,C,m],y){const w=this.b.get(N);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(m,N,C,y).then(()=>!0,d=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this.c.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const g=this.b.get(N);this.b.set(N,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,C,m,y){const w=[],d=Date.now(),{document:g,reason:a}=y,{version:i}=g,n=Object.freeze({document:g,reason:a,waitUntil(u){if(Object.isFrozen(w))throw(0,M.$8)("waitUntil can not be called async");w.push(Promise.resolve(u))}});try{C.apply(m,[n])}catch(u){return Promise.reject(u)}return Object.freeze(w),new Promise((u,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(h=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(t),u(h)}).catch(h=>{clearTimeout(t),o(h)})}).then(u=>{const o={edits:[]};for(const t of u)if(Array.isArray(t)&&t.every(h=>h instanceof L.$4M))for(const{newText:h,newEol:s,range:c}of t)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:h,eol:s&&A.EndOfLine.from(s)}});if(o.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(new b.$qw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$Slc=$}),define(ke[334],Se([1,0,4,3,2,6,152,16,18,24,7]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class C{constructor(y,w){this.a=new l.$ce,this.b=new l.$ce,this.c=new l.$ce,this.d=new l.$ce,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Uc,this.h=new Map,this.f=y.getProxy(A.$UM.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(d=>{for(const g of d)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const g of d)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const w=this.g.getDocument(y);if(w)return w}getDocument(y){const w=this.getDocumentData(y);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return w.document}ensureDocumentData(y){const w=this.g.getDocument(y);if(w)return Promise.resolve(w);let d=this.h.get(y.toString());return d||(d=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const a=L.URI.revive(g);return(0,$.$eg)(this.g.getDocument(a))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),d)),d}createDocumentData(y){return this.f.$tryCreateDocument(y).then(w=>L.URI.revive(w))}$acceptModelLanguageChanged(y,w){const d=L.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(w),this.a.fire(g.document)}$acceptModelSaved(y){const w=L.URI.revive(y),d=this.g.getDocument(w);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(y,w){const d=L.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,w,d){const g=L.URI.revive(y),a=this.g.getDocument(g);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(w);let i;w.isUndoing?i=N.TextDocumentChangeReason.Undo:w.isRedoing&&(i=N.TextDocumentChangeReason.Redo),this.c.fire((0,S.$1n)({document:a.document,contentChanges:w.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(y,w){(0,R.$jP)(y,w)}}e.$Lkc=C}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,16,7]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0,e.$dlc=(0,R.$ti)("IExtHostEditorTabs");class C{constructor(g,a,i){this.e=i,this.d=a,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$GO(A.URI.revive(this.b.input.uri));case 2:return new N.$HO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new N.$IO(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new N.$JO(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$KO(this.b.input.viewType);case 4:return new N.$LO(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$MO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$NO;case 9:return new N.$OO(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$PO;case 11:return new N.$QO(this.b.input.diffEditors.map(g=>new N.$HO(A.URI.revive(g.original),A.URI.revive(g.modified))));default:return}}}class m{constructor(g,a){this.c=[],this.d="",this.b=g,this.e=a;for(const i of g.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return S.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(i=>i.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(i=>i.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const i=new C(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,i),g.tabDto.isActive&&(this.d=i.tabId),i}else if(g.kind===1){const i=this.c.splice(g.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(g.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,i),i}const a=this.c.find(i=>i.tabId===g.tabDto.id);if(!a)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(g.tabDto),a}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new M.$ce,this.c=new M.$ce,this.e=[],this.a=g.getProxy(b.$UM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,a={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(i=>i.apiObject))},get activeTabGroup(){const i=g.d;return(0,L.$eg)(g.e.find(u=>u.groupId===i)?.apiObject)},close:async(i,n)=>{const u=Array.isArray(i)?i:[i];return u.length?w(u[0])?this.j(u,n):this.i(u,n):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(g){const a=new Set(this.e.map(s=>s.groupId)),i=new Set(g.map(s=>s.groupId)),n=(0,l.$L)(a,i),u=this.e.filter(s=>n.removed.includes(s.groupId)).map(s=>s.apiObject),o=[],t=[];this.e=g.map(s=>{const c=new m(s,()=>this.d);return n.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const h=(0,L.$eg)(g.find(s=>s.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:o,closed:u,changed:t}))}$acceptTabGroupUpdate(g){const a=this.e.find(i=>i.groupId===g.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const a=this.e.find(n=>n.groupId===g.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(g){for(const a of this.e)for(const i of a.tabs)if(i.apiObject===g)return i}h(g){return this.e.find(a=>a.apiObject===g)}async i(g,a){const i=[];for(const n of g){const u=this.g(n);if(!u)throw new Error("Tab close: Invalid tab not found!");i.push(u.tabId)}return this.a.$closeTab(i,a)}async j(g,a){const i=[];for(const n of g){const u=this.h(n);if(!u)throw new Error("Group close: Invalid group not found!");i.push(u.groupId)}return this.a.$closeGroup(i,a)}};e.$elc=y,e.$elc=y=Je([Ve(0,$.$hP)],y);function w(d){return d.tabs!==void 0}}),define(ke[335],Se([1,0,2,6,3,7,16,180,14,21,26,80]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=void 0;class m{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const g=this.a.indexOf(d);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),g=[];let a,i,n=14,u=14;for(const o of d){let t=a?(0,$.$xf)(a,o):0;for(t===0?i=1:i=u;t<o.length;t++)t+1===o.length?(n=u,u=9):u+=1,g.push([i,o.toUpperCase().charCodeAt(t),u]),g.push([i,o.toLowerCase().charCodeAt(t),u]),i=u;a=o,u=n}g.push([9,58,10]),g.push([10,47,12]),this.b=new b.$82(g)}}provideDocumentLinks(d){this.c();const g=[],a=b.$92.computeLinks({getLineContent(i){return d.lineAt(i-1).text},getLineCount(){return d.lineCount}},this.b);for(const i of a){const n=R.DocumentLink.to(i);n.target&&g.push(n)}return g}}class y{constructor(d,g){this.i=g,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(M.$UM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,g,a,i={}){if(y.j(a),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const n=this.h++;this.b.add(g),this.d.add(g),this.c.set(n,a);let u=2;i.isCaseSensitive&&(u+=1024),i.isReadonly&&(u+=2048),typeof a.copy=="function"&&(u+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,N.$CG)(d,"fsChunks"),u+=4);let o;i.isReadonly&&(0,C.$Sk)(i.isReadonly)&&i.isReadonly.value!==""&&(o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,g,u,o).catch(h=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${g}`),console.error(h)});const t=a.onDidChangeFile(h=>{const s=[];for(const c of h){const{uri:r,type:v}=c;if(r.scheme!==g)continue;let f;switch(v){case A.FileChangeType.Changed:f=0;break;case A.FileChangeType.Created:f=1;break;case A.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:r,type:f})}this.a.$onFileSystemChange(n,s)});return(0,L.$Tc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:g,ctime:a,mtime:i,size:n,permissions:u}=d;return{type:g,ctime:a,mtime:i,size:n,permissions:u}}$stat(d,g){return Promise.resolve(this.l(d).stat(l.URI.revive(g))).then(a=>y.k(a))}$readdir(d,g){return Promise.resolve(this.l(d).readDirectory(l.URI.revive(g)))}$readFile(d,g){return Promise.resolve(this.l(d).readFile(l.URI.revive(g))).then(a=>S.$De.wrap(a))}$writeFile(d,g,a,i){return Promise.resolve(this.l(d).writeFile(l.URI.revive(g),a.buffer,i))}$delete(d,g,a){return Promise.resolve(this.l(d).delete(l.URI.revive(g),a))}$rename(d,g,a,i){return Promise.resolve(this.l(d).rename(l.URI.revive(g),l.URI.revive(a),i))}$copy(d,g,a,i){const n=this.l(d);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(l.URI.revive(g),l.URI.revive(a),i))}$mkdir(d,g){return Promise.resolve(this.l(d).createDirectory(l.URI.revive(g)))}$watch(d,g,a,i){const n=this.l(d).watch(l.URI.revive(a),i);this.f.set(g,n)}$unwatch(d,g){const a=this.f.get(g);a&&(a.dispose(),this.f.delete(g))}$open(d,g,a){const i=this.l(d);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(l.URI.revive(g),a))}$close(d,g){const a=this.l(d);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(g))}$read(d,g,a,i){const n=this.l(d);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const u=S.$De.alloc(i);return Promise.resolve(n.read(g,a,u.buffer,0,i)).then(o=>u.slice(0,o))}$write(d,g,a,i){const n=this.l(d);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(g,a,i.buffer,0,i.byteLength))}l(d){const g=this.c.get(d);if(!g){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return g}}e.$Ulc=y}),define(ke[336],Se([1,0,4,35,2,6,16,7,46]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,w,d,g,a,i){this.a=Math.random(),this.b=new l.$ce,this.c=new l.$ce,this.d=new l.$ce,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,M.$nk)(a),u=typeof a=="string",o=i?.correlate,t=g(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(o&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const c=L.URI.revive(s);n(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.b.fire(c)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const c=L.URI.revive(s);n(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.c.fire(c)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const c=L.URI.revive(s);n(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$WM.from(this.i(y,d,a,i,i?.correlate),this.b,this.c,this.d,t)}i(y,w,d,g,a){const i=b.$WM.from();if(typeof d=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return i;const n=y.getProxy(A.$UM.MainThreadFileSystemEventService);let u=!1;(d.pattern.includes(M.$jk)||d.pattern.includes(M.$kk))&&(u=!0);let o;return a&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(o=14,g?.ignoreChangeEvents&&(o&=-3),g?.ignoreCreateEvents&&(o&=-5),g?.ignoreDeleteEvents&&(o&=-9)),n.$watch(w.identifier.value,this.a,d.baseUri,{recursive:u,excludes:g?.excludes??[],filter:o},!!a),b.$WM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(y){this.a=y,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(L.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(y,w,d){this.j=y,this.k=w,this.l=d,this.a=new l.$ce,this.b=new l.$ce,this.c=new l.$ce,this.d=new l.$ce,this.g=new l.$ee,this.h=new l.$ee,this.i=new l.$ee,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,w,d,g){return new S(this.j,y,w,this.a.event,R.GlobPattern.from(d),g)}$onFileEvent(y){this.a.fire(new N(y))}$onDidRunFileOperation(y,w){switch(y){case 2:this.b.fire(Object.freeze({files:w.map(d=>({oldUri:L.URI.revive(d.source),newUri:L.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(d=>L.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(d=>L.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,w){return(d,g,a)=>{const i=function(u){d.call(g,u)};return i.extension=y,w.event(i,void 0,a)}}async $onWillRunFileOperation(y,w,d,g){switch(y){case 2:return await this.n(this.g,{files:w.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},d,g);case 1:return await this.n(this.i,{files:w.map(a=>L.URI.revive(a.target))},d,g);case 0:case 3:return await this.n(this.h,{files:w.map(a=>L.URI.revive(a.target))},d,g)}}async n(y,w,d,g){const a=new Set,i=[];if(await y.fireAsync(w,g,async(u,o)=>{const t=Date.now(),h=await Promise.resolve(u);h instanceof b.$7M&&(i.push([o.extension,h]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>d&&this.k.warn("SLOW file-participant",o.extension.identifier)}),g.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,u]of i){const{edits:o}=R.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(a)}}}e.$Vlc=C}),define(ke[337],Se([1,0,19,8,22,13,124,3,24,40,14,18,2,29,176,83,134,220,25,16,7,26,111,6]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class s{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const J=this.d.getDocument(V),Q=await this.e.provideDocumentSymbols(J,q);if(!(0,l.$Kb)(Q))return Q[0]instanceof u.$dN?Q.map(n.DocumentSymbol.from):s.f(Q)}static f(V){V=V.slice(0).sort((Q,he)=>{let be=Q.location.range.start.compareTo(he.location.range.start);return be===0&&(be=he.location.range.end.compareTo(Q.location.range.end)),be});const q=[],J=[];for(const Q of V){const he={name:Q.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Q.kind),tags:Q.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:n.Range.from(Q.location.range),selectionRange:n.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(he),q.push(he);break}const be=J[J.length-1];if(y.$pt.containsRange(be.range,he.range)&&!y.$pt.equalsRange(be.range,he.range)){be.children?.push(he),J.push(he);break}J.pop()}}return q}}class c{constructor(V,q,J,Q,he,be){this.f=V,this.g=q,this.h=J,this.j=Q,this.k=he,this.l=be,this.d=new t.$Ckc("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const J=this.f.getDocument(V),Q=await this.h.provideCodeLenses(J,q);if(!Q||q.isCancellationRequested)return;const he=this.d.add(Q),be=new b.$Uc;this.e.set(he,be);const ze={cacheId:he,lenses:[]};for(let qe=0;qe<Q.length;qe++)ze.lenses.push({cacheId:[he,qe],range:n.Range.from(Q[qe].range),command:this.g.toInternal(Q[qe].command,be)});return ze}async resolveCodeLens(V,q){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let Q;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.h.resolveCodeLens(J,q),Q||(Q=J),q.isCancellationRequested)return;const he=V.cacheId&&this.e.get(V.cacheId[0]);if(he){if(!Q.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return V.command=this.g.toInternal(Q.command,he),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function r(Fe){return Array.isArray(Fe)?Fe.map(n.DefinitionLink.from):Fe?[n.DefinitionLink.from(Fe)]:[]}class v{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideDefinition(Q,he,J);return r(be)}}class f{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideDeclaration(Q,he,J);return r(be)}}class D{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideImplementation(Q,he,J);return r(be)}}class p{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideTypeDefinition(Q,he,J);return r(be)}}class E{constructor(V,q){this.d=V,this.e=q}async provideHover(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideHover(Q,he,J);if(!(!be||(0,l.$Kb)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(he)),be.range||(be.range=new u.$YM(he,he)),n.Hover.from(be)}}class k{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideEvaluatableExpression(Q,he,J);if(be)return n.EvaluatableExpression.from(be)}}class P{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,J,Q){const he=this.d.getDocument(V),be=await this.e.provideInlineValues(he,n.Range.to(q),n.InlineValueContext.to(J),Q);if(Array.isArray(be))return be.map(ze=>n.InlineValue.from(ze))}}class I{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideDocumentHighlights(Q,he,J);if(Array.isArray(be))return be.map(n.DocumentHighlight.from)}}class T{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,J,Q){const he=this.d.getDocument(V),be=J.map(Ye=>this.d.getDocument(Ye)),ze=n.Position.to(q),qe=await this.e.provideMultiDocumentHighlights(he,ze,be,Q);if(Array.isArray(qe))return qe.map(n.MultiDocumentHighlight.from)}}class j{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,J){const Q=this.d.getDocument(V),he=n.Position.to(q),be=await this.e.provideLinkedEditingRanges(Q,he,J);if(be&&Array.isArray(be.ranges))return{ranges:(0,l.$Hb)(be.ranges.map(n.Range.from)),wordPattern:be.wordPattern}}}class z{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,J,Q){const he=this.d.getDocument(V),be=n.Position.to(q),ze=await this.e.provideReferences(he,be,J,Q);if(Array.isArray(ze))return ze.map(n.location.from)}}class O{static{this.d=1e3}constructor(V,q,J,Q,he,be,ze){this.g=V,this.h=q,this.j=J,this.k=Q,this.l=he,this.m=be,this.n=ze,this.e=new t.$Ckc("CodeAction"),this.f=new Map}async provideCodeActions(V,q,J,Q){const he=this.g.getDocument(V),be=w.$rt.isISelection(q)?n.Selection.to(q):n.Range.to(q),ze=[];for(const st of this.j.getDiagnostics(V))if(be.intersection(st.range)&&ze.push(st)>O.d)break;const qe={diagnostics:ze,only:J.only?new u.$fN(J.only):void 0,triggerKind:n.CodeActionTriggerKind.to(J.trigger)},Ye=await this.k.provideCodeActions(he,be,qe,Q);if(!(0,l.$Lb)(Ye)||Q.isCancellationRequested)return;const it=this.e.add(Ye),ot=new b.$Uc;this.f.set(it,ot);const nt=[];for(let st=0;st<Ye.length;st++){const Ce=Ye[st];if(Ce)if(O.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,ot)});else{qe.only&&(Ce.kind?qe.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ce.ranges??[];nt.push({cacheId:[it,st],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,ot),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(n.Diagnostic.from),edit:Ce.edit&&n.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,o.$BG)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,o.$BG)(this.m,"codeActionRanges")?(0,l.$Hb)(Be.map(n.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:it,actions:nt}}async resolveCodeAction(V,q){const[J,Q]=V,he=this.e.get(J,Q);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(he,q)??he;let ze;be.edit&&(ze=n.WorkspaceEdit.from(be.edit,void 0));let qe;if(be.command){const Ye=this.f.get(J);Ye&&(qe=this.h.toInternal(be.command,Ye))}return{edit:ze,command:qe}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class F{constructor(V,q,J,Q,he){this.e=V,this.f=q,this.g=J,this.h=Q,this.j=he,this.d=new t.$Ckc("DocumentPasteEdit")}async prepareDocumentPaste(V,q,J,Q){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(V),be=q.map(Ye=>n.Range.to(Ye)),ze=n.DataTransfer.toDataTransfer(J,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(he,be,ze,Q),Q.isCancellationRequested)return;const qe=Array.from(ze).filter(([,Ye])=>!(Ye instanceof u.$LN));return n.DataTransfer.from(qe)}async providePasteEdits(V,q,J,Q,he,be){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(q),qe=J.map(nt=>n.Range.to(nt)),Ye=n.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),it=await this.g.provideDocumentPasteEdits(ze,qe,Ye,{only:he.only?new u.$QN(he.only):void 0,triggerKind:he.triggerKind},be);if(!it||be.isCancellationRequested)return[];const ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[J,Q]=V,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(he,q)??he;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,J){const Q=this.d.getDocument(V),he=await this.e.provideDocumentFormattingEdits(Q,q,J);if(Array.isArray(he))return he.map(n.TextEdit.from)}}class W{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,J,Q){const he=this.d.getDocument(V),be=n.Range.to(q),ze=await this.e.provideDocumentRangeFormattingEdits(he,be,J,Q);if(Array.isArray(ze))return ze.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,J,Q){(0,C.$dg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(V),be=q.map(n.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,be,J,Q);if(Array.isArray(ze))return ze.map(n.TextEdit.from)}}class Z{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,J,Q,he){const be=this.d.getDocument(V),ze=n.Position.to(q),qe=await this.e.provideOnTypeFormattingEdits(be,ze,J,Q,he);if(Array.isArray(qe))return qe.map(n.TextEdit.from)}}class X{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Ckc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const J=await this.e.provideWorkspaceSymbols(V,q);if(!(0,l.$Lb)(J))return{symbols:[]};const Q=this.d.add(J),he={cacheId:Q,symbols:[]};for(let be=0;be<J.length;be++){const ze=J[be];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...n.WorkspaceSymbol.from(ze),cacheId:[Q,be]})}return he}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,q);return Q&&(0,$.$3n)(V,n.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class Y{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,J){this.d=V,this.e=q,this.f=J}async provideRenameEdits(V,q,J,Q){const he=this.d.getDocument(V),be=n.Position.to(q);try{const ze=await this.e.provideRenameEdits(he,be,J,Q);return ze?n.WorkspaceEdit.from(ze):void 0}catch(ze){const qe=Y.g(ze);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(V,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(V),he=n.Position.to(q);try{const be=await this.e.prepareRename(Q,he,J);let ze,qe;if(u.$YM.isRange(be)?(ze=be,qe=Q.getText(be)):(0,C.$8f)(be)&&(ze=be.range,qe=be.placeholder),!ze||!qe)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(ze),text:qe}}catch(be){const ze=Y.g(be);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(be)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{constructor(V,q,J){this.d=V,this.e=q,this.f=J}async provideNewSymbolNames(V,q,J){const Q=this.d.getDocument(V),he=n.Range.to(q);try{const be=await this.e.provideNewSymbolNames(Q,he,J);return be?be.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(be){this.f.error(x.g(be)??JSON.stringify(be,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ne{constructor(V,q){this.resultId=V,this.tokens=q}}class ge{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,J){const Q=this.f.getDocument(V),he=q!==0?this.d.get(q):null;let be=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,he.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return he&&this.d.delete(q),be?(be=ge.h(be),this.o(ge.n(he,be),be)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ge.j(V)?ge.k(V)?V:new u.$eO(new Uint32Array(V.data),V.resultId):ge.l(V)?ge.m(V)?V:new u.$gO(V.edits.map(q=>new u.$fO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!ge.j(q)||!V||!V.tokens)return q;const J=V.tokens,Q=J.length,he=q.data,be=he.length;let ze=0;const qe=Math.min(Q,be);for(;ze<qe&&J[ze]===he[ze];)ze++;if(ze===Q&&ze===be)return new u.$gO([],q.resultId);let Ye=0;const it=qe-ze;for(;Ye<it&&J[Q-Ye-1]===he[be-Ye-1];)Ye++;return new u.$gO([{start:ze,deleteCount:Q-ze-Ye,data:he.subarray(ze,be-Ye)}],q.resultId)}o(V,q){if(ge.j(V)){const J=this.e++;return this.d.set(J,new ne(V.resultId,V.data)),(0,g.$Pbb)({id:J,type:"full",data:V.data})}if(ge.l(V)){const J=this.e++;return ge.j(q)?this.d.set(J,new ne(q.resultId,q.data)):this.d.set(J,new ne(V.resultId)),(0,g.$Pbb)({id:J,type:"delta",deltas:(V.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ue{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,J){const Q=this.d.getDocument(V),he=await this.e.provideDocumentRangeSemanticTokens(Q,n.Range.to(q),J);return he?this.f(he):null}f(V){return(0,g.$Pbb)({id:0,type:"full",data:V.data})}}class ve{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,J,Q,he){this.f=V,this.g=q,this.h=J,this.j=Q,this.k=he,this.d=new t.$Ckc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,J,Q){const he=this.f.getDocument(V),be=n.Position.to(q),ze=he.getWordRangeAtPosition(be)||new u.$YM(be,be),qe=ze.with({end:be}),Ye=new S.$$d,it=await this.h.provideCompletionItems(he,be,Q,n.CompletionContext.to(J));if(!it||Q.isCancellationRequested)return;const ot=Array.isArray(it)?new u.$sN(it):it,nt=ve.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new b.$Uc;this.e.set(nt,st);const Ce=[],Be={x:nt,b:Ce,a:{replace:n.Range.from(ze),insert:n.Range.from(qe)},c:ot.isIncomplete||void 0,d:Ye.elapsed()};for(let Ge=0;Ge<ot.items.length;Ge++){const Me=ot.items[Ge],Ze=this.l(Me,[nt,Ge],qe,ze);Ce.push(Ze)}return Be}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const Q=this.l(J,V),he=await this.h.resolveCompletionItem(J,q);if(!he)return;const be=this.l(he,V);return(Q.h!==be.h||Q.i!==be.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==be.n||Q.o!==be.o||!(0,$.$4n)(Q.p,be.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:be.d,c:be.c,l:be.l,h:be.h,i:be.i,n:be.n,o:be.o,p:be.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,J,Q){const he=this.e.get(q[0]);if(!he)throw Error("DisposableStore is missing...");const be=this.g.toInternal(V.command,he),ze={x:q,a:V.label,b:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(n.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=V.textEdit.newText):typeof V.insertText=="string"?ze.h=V.insertText:V.insertText instanceof u.$8M&&(ze.h=V.insertText.value,ze.i|=4);let qe;return V.textEdit?qe=V.textEdit.range:V.range&&(qe=V.range),u.$YM.isRange(qe)?ze.j=n.Range.from(qe):qe&&(!J?.isEqual(qe.inserting)||!Q?.isEqual(qe.replacing))&&(ze.j={insert:n.Range.from(qe.inserting),replace:n.Range.from(qe.replacing)}),ze}}class te{async provideInlineCompletions(V,q,J,Q){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,J){}handlePartialAccept(V,q,J,Q){}}class U extends te{constructor(V,q,J,Q){super(),this.f=V,this.g=q,this.h=J,this.j=Q,this.d=new pe,this.e=(0,o.$BG)(this.f,"inlineCompletionsAdditions"),this.k={[d.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[d.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$BG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,J,Q){const he=this.g.getDocument(V),be=n.Position.to(q),ze=await this.h.provideInlineCompletionItems(he,be,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ze||Q.isCancellationRequested)return;const qe=Array.isArray(ze)?ze:ze.items,Ye=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],it=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:qe}),items:qe.map((st,Ce)=>{let Be;st.command&&(ot||(ot=new b.$Uc),Be=this.j.toInternal(st.command,ot));const Ge=st.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:st.filterText,range:st.range?n.Range.from(st.range):void 0,command:Be,idx:Ce,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ye.map(st=>(ot||(ot=new b.$Uc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,J){const Q=this.d.get(V)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(V,q,J,Q){const he=this.d.get(V)?.items[q];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,n.PartialAcceptInfo.to(Q)))}}class _{async provideInlineEdits(V,q,J){const Q=this.f.getDocument(V),he=await this.g.provideInlineEdit(Q,{triggerKind:this.e[q.triggerKind]},J);if(!he||J.isCancellationRequested)return;let be;const ze=this.d.createReferenceId({dispose(){be?.dispose()},item:he});let qe;he.accepted&&(be||(be=new b.$Uc),qe=this.h.toInternal(he.accepted,be));let Ye;return he.rejected&&(be||(be=new b.$Uc),Ye=this.h.toInternal(he.rejected,be)),{pid:ze,text:he.text,range:n.Range.from(he.range),accepted:qe,rejected:Ye}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,J,Q){this.f=q,this.g=J,this.h=Q,this.d=new pe,this.e={[d.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[d.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class Pe{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Ckc("SignatureHelp")}async provideSignatureHelp(V,q,J,Q){const he=this.e.getDocument(V),be=n.Position.to(q),ze=this.g(J),qe=await this.f.provideSignatureHelp(he,be,Q,ze);if(qe){const Ye=this.d.add([qe]);return{...n.SignatureHelp.from(qe),id:Ye}}}g(V){let q;if(V.activeSignatureHelp){const J=n.SignatureHelp.to(V.activeSignatureHelp),Q=this.d.get(V.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class se{constructor(V,q,J,Q,he){this.f=V,this.g=q,this.h=J,this.j=Q,this.k=he,this.d=new t.$Ckc("InlayHints"),this.e=new Map}async provideInlayHints(V,q,J){const Q=this.f.getDocument(V),he=n.Range.to(q),be=await this.h.provideInlayHints(Q,he,J);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(J.isCancellationRequested)return;const ze=this.d.add(be);this.e.set(ze,new b.$Uc);const qe={hints:[],cacheId:ze};for(let Ye=0;Ye<be.length;Ye++)this.l(be[Ye],he)&&qe.hints.push(this.m(be[Ye],[ze,Ye]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),qe}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const Q=await this.h.resolveInlayHint(J,q);if(Q&&this.l(Q))return this.m(Q,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")Q.label=V.label;else{const he=[];Q.label=he;for(const be of V.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:be.value,tooltip:n.MarkdownString.fromStrict(be.tooltip)};u.$9M.isLocation(be.location)&&(ze.location=n.location.from(be.location)),be.command&&(ze.command=this.g.toInternal(be.command,J)),he.push(ze)}}return Q}}class re{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Ckc("DocumentLink")}async provideLinks(V,q){const J=this.e.getDocument(V),Q=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(re.g).map(n.DocumentLink.from)};{const he=this.d.add(Q),be={links:[],cacheId:he};for(let ze=0;ze<Q.length;ze++){if(!re.g(Q[ze]))continue;const qe=n.DocumentLink.from(Q[ze]);qe.cacheId=[he,ze],be.links.push(qe)}return be}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const Q=await this.f.resolveDocumentLink(J,q);if(!(!Q||!re.g(Q)))return n.DocumentLink.from(Q)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const J=this.d.getDocument(V),Q=await this.e.provideDocumentColors(J,q);return Array.isArray(Q)?Q.map(be=>({color:n.Color.from(be.color),range:n.Range.from(be.range)})):[]}async provideColorPresentations(V,q,J){const Q=this.d.getDocument(V),he=n.Range.to(q.range),be=n.Color.to(q.color),ze=await this.e.provideColorPresentations(be,{document:Q,range:he},J);if(Array.isArray(ze))return ze.map(n.ColorPresentation.from)}}class K{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,J){const Q=this.d.getDocument(V),he=await this.e.provideFoldingRanges(Q,q,J);if(Array.isArray(he))return he.map(n.FoldingRange.from)}}class ie{constructor(V,q,J){this.d=V,this.e=q,this.f=J}async provideSelectionRanges(V,q,J){const Q=this.d.getDocument(V),he=q.map(n.Position.to),be=await this.e.provideSelectionRanges(Q,he,J);if(!(0,l.$Lb)(be))return[];if(be.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let qe=0;qe<he.length;qe++){const Ye=[];ze.push(Ye);let it=he[qe],ot=be[qe];for(;;){if(!ot.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(n.SelectionRange.from(ot)),!ot.parent)break;it=ot.range,ot=ot.parent}}return ze}}class $e{constructor(V,q){this.f=V,this.g=q,this.d=new R.$mP(""),this.e=new Map}async prepareSession(V,q,J){const Q=this.f.getDocument(V),he=n.Position.to(q),be=await this.g.prepareCallHierarchy(Q,he,J);if(!be)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(be)?be.map(qe=>this.h(ze,qe)):[this.h(ze,be)]}async provideCallsTo(V,q,J){const Q=this.j(V,q);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(he)return he.map(be=>({from:this.h(V,be.from),fromRanges:be.fromRanges.map(ze=>n.Range.from(ze))}))}async provideCallsFrom(V,q,J){const Q=this.j(V,q);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(he)return he.map(be=>({to:this.h(V,be.to),fromRanges:be.fromRanges.map(ze=>n.Range.from(ze))}))}releaseSession(V){this.e.delete(V)}h(V,q){const J=this.e.get(V),Q=n.CallHierarchyItem.from(q,V,J.size.toString(36));return J.set(Q._itemId,q),Q}j(V,q){return this.e.get(V)?.get(q)}}class we{constructor(V,q){this.f=V,this.g=q,this.d=new R.$mP(""),this.e=new Map}async prepareSession(V,q,J){const Q=this.f.getDocument(V),he=n.Position.to(q),be=await this.g.prepareTypeHierarchy(Q,he,J);if(!be)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(be)?be.map(qe=>this.h(ze,qe)):[this.h(ze,be)]}async provideSupertypes(V,q,J){const Q=this.j(V,q);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Q,J);if(he)return he.map(be=>this.h(V,be))}async provideSubtypes(V,q,J){const Q=this.j(V,q);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Q,J);if(he)return he.map(be=>this.h(V,be))}releaseSession(V){this.e.delete(V)}h(V,q){const J=this.e.get(V),Q=n.TypeHierarchyItem.from(q,V,J.size.toString(36));return J.set(Q._itemId,q),Q}j(V,q){return this.e.get(V)?.get(q)}}class Ne{constructor(V,q,J,Q,he){this.e=V,this.f=q,this.g=J,this.h=Q,this.j=he,this.d=new t.$Ckc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,q,J,Q,he){const be=this.f.getDocument(q),ze=n.Position.to(J),qe=n.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Ye=await this.g.provideDocumentDropEdits(be,ze,qe,he);if(!Ye)return;const it=(0,l.$3b)(Ye),ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,q){const[J,Q]=V,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(he,q)??he;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class fe{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,J,Q){const he=m.URI.revive(V),be=this.d.getDocument(he),ze=J.documents.map(it=>it.map(ot=>({uri:m.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(nt=>n.Range.to(nt))}))),qe={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(be,q,qe,Q);return Ye?n.WorkspaceEdit.from(Ye):null}}class De{constructor(V,q){this.adapter=V,this.extension=q}}class Ie{static{this.d=0}constructor(V,q,J,Q,he,be,ze,qe){this.g=q,this.h=J,this.j=Q,this.k=he,this.l=be,this.m=ze,this.n=qe,this.f=new Map,this.e=V.getProxy(h.$UM.MainThreadLanguageFeatures)}o(V,q){return n.DocumentSelector.from(V,this.g,q)}p(V){return new u.$WM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ie.d++}async s(V,q,J,Q,he,be=!1){const ze=this.f.get(V);if(!ze||!(ze.adapter instanceof q))return Q;const qe=Date.now();be||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ye=J(ze.adapter,ze.extension);return Promise.resolve(Ye).catch(it=>{(0,A.$4)(it)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(ze.extension.identifier,it))}).finally(()=>{be||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,M.$ih)(Ye,he):Ye}t(V,q){const J=this.q();return this.f.set(J,new De(V,q)),J}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,q,J,Q){const he=this.t(new s(this.h,J),V),be=Q&&Q.label||Ie.u(V);return this.e.$registerDocumentSymbolProvider(he,this.o(q,V),be),this.p(he)}$provideDocumentSymbols(V,q,J){return this.s(V,s,Q=>Q.provideDocumentSymbols(m.URI.revive(q),J),void 0,J)}registerCodeLensProvider(V,q,J){const Q=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new De(new c(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(Q,this.o(q,V),he);let be=this.p(Q);if(he!==void 0){const ze=J.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(he));be=u.$WM.from(be,ze)}return be}$provideCodeLenses(V,q,J){return this.s(V,c,Q=>Q.provideCodeLenses(m.URI.revive(q),J),void 0,J)}$resolveCodeLens(V,q,J){return this.s(V,c,Q=>Q.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,c,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,J){const Q=this.t(new v(this.h,J),V);return this.e.$registerDefinitionSupport(Q,this.o(q,V)),this.p(Q)}$provideDefinition(V,q,J,Q){return this.s(V,v,he=>he.provideDefinition(m.URI.revive(q),J,Q),[],Q)}registerDeclarationProvider(V,q,J){const Q=this.t(new f(this.h,J),V);return this.e.$registerDeclarationSupport(Q,this.o(q,V)),this.p(Q)}$provideDeclaration(V,q,J,Q){return this.s(V,f,he=>he.provideDeclaration(m.URI.revive(q),J,Q),[],Q)}registerImplementationProvider(V,q,J){const Q=this.t(new D(this.h,J),V);return this.e.$registerImplementationSupport(Q,this.o(q,V)),this.p(Q)}$provideImplementation(V,q,J,Q){return this.s(V,D,he=>he.provideImplementation(m.URI.revive(q),J,Q),[],Q)}registerTypeDefinitionProvider(V,q,J){const Q=this.t(new p(this.h,J),V);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,V)),this.p(Q)}$provideTypeDefinition(V,q,J,Q){return this.s(V,p,he=>he.provideTypeDefinition(m.URI.revive(q),J,Q),[],Q)}registerHoverProvider(V,q,J,Q){const he=this.t(new E(this.h,J),V);return this.e.$registerHoverProvider(he,this.o(q,V)),this.p(he)}$provideHover(V,q,J,Q){return this.s(V,E,he=>he.provideHover(m.URI.revive(q),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(V,q,J,Q){const he=this.t(new k(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(he,this.o(q,V)),this.p(he)}$provideEvaluatableExpression(V,q,J,Q){return this.s(V,k,he=>he.provideEvaluatableExpression(m.URI.revive(q),J,Q),void 0,Q)}registerInlineValuesProvider(V,q,J,Q){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new P(this.h,J),V);this.e.$registerInlineValuesProvider(be,this.o(q,V),he);let ze=this.p(be);if(he!==void 0){const qe=J.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(he));ze=u.$WM.from(ze,qe)}return ze}$provideInlineValues(V,q,J,Q,he){return this.s(V,P,be=>be.provideInlineValues(m.URI.revive(q),J,Q,he),void 0,he)}registerDocumentHighlightProvider(V,q,J){const Q=this.t(new I(this.h,J),V);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,V)),this.p(Q)}registerMultiDocumentHighlightProvider(V,q,J){const Q=this.t(new T(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(q,V)),this.p(Q)}$provideDocumentHighlights(V,q,J,Q){return this.s(V,I,he=>he.provideDocumentHighlights(m.URI.revive(q),J,Q),void 0,Q)}$provideMultiDocumentHighlights(V,q,J,Q,he){return this.s(V,T,be=>be.provideMultiDocumentHighlights(m.URI.revive(q),J,Q.map(ze=>m.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(V,q,J){const Q=this.t(new j(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,V)),this.p(Q)}$provideLinkedEditingRanges(V,q,J,Q){return this.s(V,j,async he=>{const be=await he.provideLinkedEditingRanges(m.URI.revive(q),J,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ie.w(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(V,q,J){const Q=this.t(new z(this.h,J),V);return this.e.$registerReferenceSupport(Q,this.o(q,V)),this.p(Q)}$provideReferences(V,q,J,Q,he){return this.s(V,z,be=>be.provideReferences(m.URI.revive(q),J,Q,he),void 0,he)}registerCodeActionProvider(V,q,J,Q){const he=new b.$Uc,be=this.t(new O(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(be,this.o(q,V),{providedKinds:Q?.providedCodeActionKinds?.map(ze=>ze.value),documentation:Q?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ie.u(V),!!J.resolveCodeAction),he.add(this.p(be)),he}$provideCodeActions(V,q,J,Q,he){return this.s(V,O,be=>be.provideCodeActions(m.URI.revive(q),J,Q,he),void 0,he)}$resolveCodeAction(V,q,J){return this.s(V,O,Q=>Q.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(V,q){this.s(V,O,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,J){const Q=this.t(new B(this.h,J),V);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,V),V.identifier,V.displayName||V.name),this.p(Q)}$provideDocumentFormattingEdits(V,q,J,Q){return this.s(V,B,he=>he.provideDocumentFormattingEdits(m.URI.revive(q),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(V,q,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,J),V);return this.e.$registerRangeFormattingSupport(he,this.o(q,V),V.identifier,V.displayName||V.name,Q),this.p(he)}$provideDocumentRangeFormattingEdits(V,q,J,Q,he){return this.s(V,W,be=>be.provideDocumentRangeFormattingEdits(m.URI.revive(q),J,Q,he),void 0,he)}$provideDocumentRangesFormattingEdits(V,q,J,Q,he){return this.s(V,W,be=>be.provideDocumentRangesFormattingEdits(m.URI.revive(q),J,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(V,q,J,Q){const he=this.t(new Z(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(he,this.o(q,V),Q,V.identifier),this.p(he)}$provideOnTypeFormattingEdits(V,q,J,Q,he,be){return this.s(V,Z,ze=>ze.provideOnTypeFormattingEdits(m.URI.revive(q),J,Q,he,be),void 0,be)}registerWorkspaceSymbolProvider(V,q){const J=this.t(new X(q,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,q,J){return this.s(V,X,Q=>Q.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,q,J){return this.s(V,X,Q=>Q.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,X,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,J){const Q=this.t(new Y(this.h,J,this.l),V);return this.e.$registerRenameSupport(Q,this.o(q,V),Y.supportsResolving(J)),this.p(Q)}$provideRenameEdits(V,q,J,Q,he){return this.s(V,Y,be=>be.provideRenameEdits(m.URI.revive(q),J,Q,he),void 0,he)}$resolveRenameLocation(V,q,J,Q){return this.s(V,Y,he=>he.resolveRenameLocation(m.URI.revive(q),J,Q),void 0,Q)}registerNewSymbolNamesProvider(V,q,J){const Q=this.t(new x(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(Q,this.o(q,V)),this.p(Q)}$provideNewSymbolNames(V,q,J,Q){return this.s(V,x,he=>he.provideNewSymbolNames(m.URI.revive(q),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(V,q,J,Q){const he=this.t(new ge(this.h,J),V),be=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(q,V),Q,be);let ze=this.p(he);if(be){const qe=J.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(be));ze=u.$WM.from(ze,qe)}return ze}$provideDocumentSemanticTokens(V,q,J,Q){return this.s(V,ge,he=>he.provideDocumentSemanticTokens(m.URI.revive(q),J,Q),null,Q)}$releaseDocumentSemanticTokens(V,q){this.s(V,ge,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,J,Q){const he=this.t(new ue(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(q,V),Q),this.p(he)}$provideDocumentRangeSemanticTokens(V,q,J,Q){return this.s(V,ue,he=>he.provideDocumentRangeSemanticTokens(m.URI.revive(q),J,Q),null,Q)}registerCompletionItemProvider(V,q,J,Q){const he=this.t(new ve(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(he,this.o(q,V),Q,ve.supportsResolving(J),V.identifier),this.p(he)}$provideCompletionItems(V,q,J,Q,he){return this.s(V,ve,be=>be.provideCompletionItems(m.URI.revive(q),J,Q,he),void 0,he)}$resolveCompletionItem(V,q,J){return this.s(V,ve,Q=>Q.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(V,q){this.s(V,ve,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,J,Q){const he=new U(V,this.h,J,this.j.converter),be=this.t(he,V);return this.e.$registerInlineCompletionsSupport(be,this.o(q,V),he.supportsHandleEvents,i.$Om.toKey(V.identifier.value),Q?.yieldTo?.map(ze=>i.$Om.toKey(ze))||[]),this.p(be)}$provideInlineCompletions(V,q,J,Q,he){return this.s(V,te,be=>be.provideInlineCompletions(m.URI.revive(q),J,Q,he),void 0,he)}$handleInlineCompletionDidShow(V,q,J,Q){this.s(V,te,async he=>{he.handleDidShowCompletionItem(q,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,J,Q,he){this.s(V,te,async be=>{be.handlePartialAccept(q,J,Q,he)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,te,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,J){const Q=new _(V,this.h,J,this.j.converter),he=this.t(Q,V);return this.e.$registerInlineEditProvider(he,this.o(q,V),V.identifier),this.p(he)}$provideInlineEdit(V,q,J,Q){return this.s(V,_,he=>he.provideInlineEdits(m.URI.revive(q),J,Q),void 0,Q)}$freeInlineEdit(V,q){this.s(V,_,async J=>{J.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,J,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this.t(new Pe(this.h,J),V);return this.e.$registerSignatureHelpProvider(be,this.o(q,V),he),this.p(be)}$provideSignatureHelp(V,q,J,Q,he){return this.s(V,Pe,be=>be.provideSignatureHelp(m.URI.revive(q),J,Q,he),void 0,he)}$releaseSignatureHelp(V,q){this.s(V,Pe,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new se(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(he,this.o(q,V),typeof J.resolveInlayHint=="function",Q,Ie.u(V));let be=this.p(he);if(Q!==void 0){const ze=J.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(Q));be=u.$WM.from(be,ze)}return be}$provideInlayHints(V,q,J,Q){return this.s(V,se,he=>he.provideInlayHints(m.URI.revive(q),J,Q),void 0,Q)}$resolveInlayHint(V,q,J){return this.s(V,se,Q=>Q.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(V,q){this.s(V,se,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,J){const Q=this.t(new re(this.h,J),V);return this.e.$registerDocumentLinkProvider(Q,this.o(q,V),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(V,q,J){return this.s(V,re,Q=>Q.provideLinks(m.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(V,q,J){return this.s(V,re,Q=>Q.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,re,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,J){const Q=this.t(new oe(this.h,J),V);return this.e.$registerDocumentColorProvider(Q,this.o(q,V)),this.p(Q)}$provideDocumentColors(V,q,J){return this.s(V,oe,Q=>Q.provideColors(m.URI.revive(q),J),[],J)}$provideColorPresentations(V,q,J,Q){return this.s(V,oe,he=>he.provideColorPresentations(m.URI.revive(q),J,Q),void 0,Q)}registerFoldingRangeProvider(V,q,J){const Q=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new De(new K(this.h,J),V)),this.e.$registerFoldingRangeProvider(Q,this.o(q,V),V.identifier,he);let be=this.p(Q);if(he!==void 0){const ze=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));be=u.$WM.from(be,ze)}return be}$provideFoldingRanges(V,q,J,Q){return this.s(V,K,he=>he.provideFoldingRanges(m.URI.revive(q),J,Q),void 0,Q)}registerSelectionRangeProvider(V,q,J){const Q=this.t(new ie(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(Q,this.o(q,V)),this.p(Q)}$provideSelectionRanges(V,q,J,Q){return this.s(V,ie,he=>he.provideSelectionRanges(m.URI.revive(q),J,Q),[],Q)}registerCallHierarchyProvider(V,q,J){const Q=this.t(new $e(this.h,J),V);return this.e.$registerCallHierarchyProvider(Q,this.o(q,V)),this.p(Q)}$prepareCallHierarchy(V,q,J,Q){return this.s(V,$e,he=>Promise.resolve(he.prepareSession(m.URI.revive(q),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(V,q,J,Q){return this.s(V,$e,he=>he.provideCallsTo(q,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(V,q,J,Q){return this.s(V,$e,he=>he.provideCallsFrom(q,J,Q),void 0,Q)}$releaseCallHierarchy(V,q){this.s(V,$e,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,J){const Q=this.t(new we(this.h,J),V);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,V)),this.p(Q)}$prepareTypeHierarchy(V,q,J,Q){return this.s(V,we,he=>Promise.resolve(he.prepareSession(m.URI.revive(q),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(V,q,J,Q){return this.s(V,we,he=>he.provideSupertypes(q,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(V,q,J,Q){return this.s(V,we,he=>he.provideSubtypes(q,J,Q),void 0,Q)}$releaseTypeHierarchy(V,q){this.s(V,we,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,J,Q){const he=this.q();return this.f.set(he,new De(new Ne(this.e,this.h,J,he,V),V)),this.e.$registerDocumentOnDropEditProvider(he,this.o(q,V),(0,o.$BG)(V,"documentPaste")&&Q?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(V,q,J,Q,he,be){return this.s(V,Ne,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(q,m.URI.revive(J),Q,he,be)),void 0,void 0)}$resolveDropEdit(V,q,J){return this.s(V,Ne,Q=>Q.resolveDropEdit(q,J),{},void 0)}$releaseDropEdits(V,q){this.s(V,Ne,J=>Promise.resolve(J.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(V,q,J){const Q=this.t(new fe(this.h,J),V);return this.e.$registerMappedEditsProvider(Q,this.o(q,V)),this.p(Q)}$provideMappedEdits(V,q,J,Q,he){return this.s(V,fe,be=>Promise.resolve(be.provideMappedEdits(q,J,Q,he)),null,he)}registerDocumentPasteEditProvider(V,q,J,Q){const he=this.q();return this.f.set(he,new De(new F(this.e,this.h,J,he,V),V)),this.e.$registerPasteEditProvider(he,this.o(q,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(V,q,J,Q,he){return this.s(V,F,be=>be.prepareDocumentPaste(m.URI.revive(q),J,Q,he),void 0,he)}$providePasteEdits(V,q,J,Q,he,be,ze){return this.s(V,F,qe=>qe.providePasteEdits(q,m.URI.revive(J),Q,he,be,ze),void 0,ze)}$resolvePasteEdit(V,q,J){return this.s(V,F,Q=>Q.resolvePasteEdit(q,J),{},void 0)}$releasePasteEdits(V,q){this.s(V,F,J=>Promise.resolve(J.releasePasteEdits(q)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ie.w(V.decreaseIndentPattern),increaseIndentPattern:Ie.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ie.w(V.beforeText),afterText:V.afterText?Ie.w(V.afterText):void 0,previousLineText:V.previousLineText?Ie.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ie.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>u.SyntaxTokenType.toString(q)):void 0}}static D(V){return V.map(Ie.C)}setLanguageConfiguration(V,q,J){const{wordPattern:Q}=J;if(Q&&(0,N.$hf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const he=this.q(),be={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,q,be),this.p(he)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Mkc=Ie}),define(ke[121],Se([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12,39]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,y.$ti)("IExtHostLanguageModels");class n{constructor(h,s){this.option=h,this.stream=new $.$Wh,this.stream=s??new $.$Wh}}class u{constructor(){this.a=new Map,this.b=new $.$Wh,this.c=!1,this.d=!1;const h=this;this.apiObject={stream:h.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;this.d=!0;let s=this.a.get(h.index);s||(this.a.size===0?s=new n(h.index,this.b):s=new n(h.index),this.a.set(h.index,s)),s.stream.emitOne(h.part)}get isStreaming(){return this.d}reject(h){this.c=!0;for(const s of this.f())s.reject(h)}resolve(){this.c=!0;for(const h of this.f())h.resolve()}}let o=class{static{i=this}static{this.a=1}constructor(h,s,c){this.j=s,this.k=c,this.c=new S.$ce,this.d=new S.$ce,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Qm,this.i=new Map,this.o=new Set,this.b=h.getProxy(M.$UM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,s,c,r){const v=i.a++;this.f.set(v,{extension:h.identifier,provider:c,languageModelId:s});let f;return r.auth&&(f={providerLabel:h.displayName||h.name,accountLabel:typeof r.auth=="object"?r.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,s,{extension:h.identifier,identifier:s,name:r.name??"",version:r.version,tokens:r.tokens,auth:f}),(0,l.$Tc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(h,s,c,r,v,f){const D=this.f.get(h);if(!D)return;const p=new R.$5v(async E=>{if(f.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:E.index,part:E.part})});return D.provider.provideLanguageModelResponse2(r.map(L.LanguageModelMessage.to),v,b.$Om.toKey(c),p,f)}$provideTokenLength(h,s,c){const r=this.f.get(h);return r?Promise.resolve(r.provider.provideTokenCount(s,c)):Promise.resolve(0)}$updateLanguageModels(h){const s=[],c=[];if(h.added)for(const r of h.added)this.g.set(r.identifier,r),s.push(r.identifier);if(h.removed)for(const r of h.removed){this.g.delete(r),c.push(r);for(const[v,f]of this.i)f.languageModelId===r&&(f.res.reject(new m.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(s),removed:Object.freeze(c)})),h.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(h){const s=new Array;for(const{from:c,to:r,enabled:v}of h){const f=this.h.get(c)??new b.$Pm;if(f.has(r)!==v){v?f.add(r):f.delete(r),this.h.set(c,f);const p={from:c,to:r};s.push(p),this.c.fire(p)}}}async sendChatRequest(h,s,c,r,v){const f=h.identifier,D=await this.b.$prepareChatAccess(f,s,r.justification);if(!D||!this.g.has(s))throw A.$7O.NotFound(`Language model '${s}' is unknown.`);if(this.m(f,D)&&(!await this.l(h,{identifier:D.extension,displayName:D.auth.providerLabel},r.justification,r.silent)||!this.h.get(f)?.has(D.extension)))throw A.$7O.NoPermissions(`Language model '${s}' cannot be used by '${f.value}'.`);const p=Math.random()*1e6|0,E=this.b.$fetchResponse(f,s,p,c.map(L.LanguageModelMessage.from),r.modelOptions??{},v),k=new $.$sh,P=new u;this.i.set(p,{languageModelId:s,res:P});let I;if(E.catch(T=>{k.isOpen()?P.reject(T):I=T}).finally(()=>{this.i.delete(p),P.resolve(),k.open()}),await k.wait(),I)throw new A.$7O(`Language model '${s}' errored, check cause for more details`,"Unknown",I);return P.apiObject}async $handleResponseFragment(h,s){const c=this.i.get(h);c&&c.res.handleFragment(s)}async l(h,s,c,r){const v=C.$WL+s.identifier.value;if(await this.k.getSession(h,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:s.identifier,enabled:!0}]),!0;if(r)return!1;try{const D=c?(0,N.localize)(0,null,s.displayName,c):(0,N.localize)(1,null,s.displayName);return await this.k.getSession(h,v,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:h.identifier,to:s.identifier,enabled:!0}]),!0}catch{return!1}}m(h,s){return!!s.auth&&!b.$Om.equals(s.extension,h)}async n(h){for(const s of this.o)try{await this.l(s,{identifier:h.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}async computeTokenLength(h,s,c){const r=this.g.get(h);if(!r)throw A.$7O.NotFound(`Language model '${h}' is unknown.`);const v=a.Iterable.find(this.f.values(),f=>f.languageModelId===h);return v?v.provider.provideTokenCount(s,c):this.b.$countTokens(r.identifier,typeof s=="string"?s:L.LanguageModelMessage.from(s),c)}getLanguageModelInfo(h){const s=this.g.get(h);if(s)return{id:s.identifier,name:s.name,version:s.version,tokens:s.tokens}}createLanguageModelAccessInformation(h){this.o.add(h);const s=this,c=S.Event.signal(S.Event.filter(this.c.event,v=>b.$Om.equals(v.from,h.identifier))),r=S.Event.signal(this.d.event);return{get onDidChange(){return S.Event.any(c,r)},canSendRequest(v){const f=s.g.get(v);if(!f)return;if(!s.m(h.identifier,f))return!0;const D=s.h.get(h.identifier);if(D)return D.has(f.extension)}}}};e.$ulc=o,e.$ulc=o=i=Je([Ve(0,w.$hP),Ve(1,g.$Zj),Ve(2,d.$Okc)],o)}),define(ke[338],Se([1,0,6,16,7,41,8,3,26]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class S{constructor(C,m,y,w){this.c=m,this.d=y,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(l.$UM.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const y=this.c.getDocumentData(C);if(!y)throw new Error(`document '${C.toString()}' NOT found`);return y.document}async tokenAtPosition(C,m){const y=C.version,w=M.Position.from(m),d=await this.a.$tokensAtPosition(C.uri,w),g={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new L.$YM(m.line,m.character,m.line,m.character)};if(!d)return g;const a={range:M.Range.to(d.range),type:M.TokenType.to(d.type)};return!a.range.contains(m)||y!==C.version?g:a}createLanguageStatusItem(C,m,y){const w=this.f++,d=this.a,g=this.g,a=`${C.identifier.value}/${m}`;if(g.has(a))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);g.add(a);const i={selector:y,id:m,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const u=new b.$Uc,o=()=>{if(n?.dispose(),!g.has(a)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$vh)(()=>{u.clear(),this.a.$setLanguageStatus(w,{id:a,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===L.LanguageStatusSeverity.Error?A.default.Error:i.severity===L.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,u),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){u.dispose(),n?.dispose(),d.$removeLanguageStatus(w),g.delete(a)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,o()},get selector(){return i.selector},set selector(h){i.selector=h,o()},get text(){return i.text},set text(h){i.text=h,o()},set text2(h){(0,$.$CG)(C,"languageStatusText"),i.text=h,o()},get text2(){return(0,$.$CG)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,o()},get severity(){return i.severity},set severity(h){i.severity=h,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,o()},get command(){return i.command},set command(h){i.command=h,o()},get busy(){return i.busy},set busy(h){i.busy=h,o()}};return o(),t}}e.$_lc=S}),define(ke[339],Se([1,0,15,2,16,7,119]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=void 0;class b{constructor(C,m,y,w){this.start=C,this.deletedCount=m,this.deletedItems=y,this.items=w}asApiEvent(){return{range:new A.$lO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,m,y){this.notebook=C,this.h=m,this.j=y,this.handle=y.handle,this.uri=M.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(L.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(w){C.g=w},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(y)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,m,y){const w=y.map(L.NotebookCellOutputItem.to),d=this.a.find(g=>g.id===C);if(d&&(m||(d.items.length=0),d.items.push(...w),d.items.length>1&&d.items.every(g=>R.$RK(g.mime)))){const g=new Map,a=[];d.items.forEach(i=>{let n;g.has(i.mime)?n=g.get(i.mime):(n=[],g.set(i.mime,n),a.push(i.mime)),n.push(i.data)}),d.items.length=0,a.forEach(i=>{const n=R.$SK(g.get(i));d.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Xlc=$;class S{static{this.a=0}constructor(C,m,y,w,d){this.k=C,this.l=m,this.m=y,this.uri=w,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===l.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(y){return y=C.n(y),C.b[y].apiCell},getCells(y){return(y?C.p(y):C.b).map(d=>d.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,y){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:y});const w={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},d=[];for(const a of C.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,w.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,w.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),d.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),d.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const g=new Map;for(let a=0;a<d.length;a++){const i=d[a],n=g.get(i.cell);if(n===void 0){const u=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});g.set(i.cell,u-1)}else w.cellChanges[n]={...w.cellChanges[n],...i}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,y=C.end|0;return m<0&&(m=0),y>this.b.length&&(y=this.b.length),C.with({start:m,end:y})}p(C){C=this.o(C);const m=[];for(let y=C.start;y<C.end;y++)m.push(this.b[y]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,y){if(this.j)return;const w=[],d=[],g=[];if(C.reverse().forEach(a=>{const n=a[2].map(t=>{const h=new $(this,this.l,t);return m||d.push($.asModelAddData(t)),h}),u=new b(a[0],a[1],[],n),o=this.b.splice(a[0],a[1],...n);for(const t of o)g.push(t.uri),u.deletedItems.push(t.apiCell);w.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:g}),y)for(const a of w)y.push(a.asApiEvent())}s(C,m,y,w){const d=this.b.splice(C,m);this.b.splice(y,0,...d);const g=[new b(C,m,d.map(a=>a.apiCell),[]),new b(y,0,[],d)];for(const a of g)w.push(a.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,y,w){this.b[C].setOutputItems(m,y,w)}v(C,m){const y=this.b[C];y.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(y.uri,m)}w(C,m){const y=this.b[C];y.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Ylc=S}),define(ke[340],Se([1,0,4,2,16,7,48]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;class b{constructor(S,N,C,m={timeout:1500,errors:3}){this.b=S,this.c=N,this.d=C,this.f=m,this.a=new l.$ee}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(N,C,m)=>{const y=function(d){N.call(C,d)};return y.extension=S,this.a.event(y,void 0,m)}}async $participateInSave(S,N,C){const m=M.URI.revive(S),y=this.c.getNotebookDocument(m);if(!y)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:L.TextDocumentSaveReason.to(N)},C,async(g,a)=>{const i=Date.now(),n=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!C.isCancellationRequested&&n&&(n instanceof A.$7M?w.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(w.length===0)return!0;const d={edits:[]};for(const g of w){const{edits:a}=L.WorkspaceEdit.from(g);d.edits=d.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new R.$qw(d))}}e.$bmc=b}),define(ke[153],Se([1,0,13,16,7]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,S,N,C,m){this.id=b,this.f=$,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=N,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(L.$lO.isNotebookRange))throw(0,l.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,S){b.f.$tryRevealRange(b.id,M.NotebookRange.from($),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(M.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Zlc=A}),define(ke[341],Se([1,0,4,12,16]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let A=class{constructor(b,$){this.c=b,this.d=$,this.a=new l.$ce,this.b=new l.$ce,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const S=this.d.getEditorById(b);$.visibleRanges&&S._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&S._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(b[$]))}};e.$dmc=A,e.$dmc=A=Je([Ve(0,M.$Zj)],A)}),define(ke[342],Se([1,0,4,6,153]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class A{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(M.$UM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,S){const N=this.c.getEditorById(b);this.a.get($)?.fire({editor:N.apiEditor,message:S})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(N=>N.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(N,C,m)=>this.d($).event(N,C,m),postMessage:(N,C)=>{L.$Zlc.apiEditorsToExtHost.has(N)&&([N,C]=[C,N]);const m=C&&L.$Zlc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,N)}}}d(b){let $=this.a.get(b);return $||($=new l.$ce({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$gmc=A}),define(ke[343],Se([1,0,16,108,22,55,13]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,y){const w=this.b++,{title:d,location:g,cancellable:a}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(w,{location:l.ProgressLocation.from(g),title:d,source:i,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(w,y,!!a)}d(C,m,y){let w;y&&(w=new L.$ne,this.c.set(C,w));const d=a=>{this.a.$progressEnd(a),this.c.delete(a),w?.dispose()};let g;try{g=m(new S(this.a,C),y&&w?w.token:L.CancellationToken.None)}catch(a){throw d(C),a}return g.then(a=>d(C),a=>d(C)),g}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$kmc=b;function $(N,C){return N.message=C.message,typeof C.increment=="number"&&(typeof N.increment=="number"?N.increment+=C.increment:N.increment=C.increment),N}class S extends M.$5v{constructor(C,m){super(y=>this.throttledReport(y)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Je([(0,A.$Zh)(100,(N,C)=>$(N,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[344],Se([1,0,2,6,8,16]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class R{static{this.a=0}constructor($,S){this.d=S,this.c=new Map,this.b=$.getProxy(M.$UM.MainThreadQuickDiff)}$provideOriginalResource($,S,N){const C=l.URI.revive(S),m=this.c.get($);return m?(0,L.$lh)(()=>m.provideOriginalResource(C,N)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider($,S,N,C){const m=R.a++;return this.c.set(m,S),this.b.$registerQuickDiffProvider(m,A.DocumentSelector.from($,this.d),N,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$lmc=R}),define(ke[345],Se([1,0,22,4,3,6,2,7,13,19,41,57,26,16]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=w;function w(d,g,a){const i=d.getProxy(A.$UM.MainThreadQuickOpen);class n{constructor(f,D){this.e=new Map,this.f=0,this.a=f,this.b=D}showQuickPick(f,D,p,E=l.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,I=i.$show(P,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},E),T={},j=I.then(()=>T);return Promise.race([j,k]).then(z=>{if(z===T)return;const O=(0,m.$BG)(f,"quickPickItemTooltip");return k.then(F=>{const B=[];for(let W=0;W<F.length;W++){const Z=F[W];if(typeof Z=="string")B.push({label:Z,handle:W});else if(Z.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:Z.label});else{Z.tooltip&&!O&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const X=Z.iconPath?s(Z.iconPath):void 0;B.push({label:Z.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:O?y.MarkdownString.fromStrict(Z.tooltip):void 0,handle:W})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=W=>{p.onDidSelectItem(F[W])}),i.$setItems(P,B),I.then(W=>{if(typeof W=="number")return F[W];if(Array.isArray(W))return W.map(Z=>F[Z])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return i.$setError(P,z),Promise.reject(z)})}$onItemSelected(f){this.c?.(f)}showInput(f,D=l.CancellationToken.None){return this.d=f?.validateInput,i.$input(f,typeof this.d=="function",D).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(f){if(!this.d)return;const D=await this.d(f);if(!D||typeof D=="string")return D;let p;switch(D.severity){case b.InputBoxValidationSeverity.Info:p=N.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=N.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=N.default.Error;break;default:p=D.message?N.default.Error:N.default.Ignore;break}return{content:D.message,severity:p}}async showWorkspaceFolderPick(f,D=l.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!p)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===p.uri.toString())}createQuickPick(f){const D=new c(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(f){const D=new r(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(f,D){this.e.get(f)?._fireDidChangeValue(D)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,D){const p=this.e.get(f);p instanceof c&&p._fireDidChangeActive(D)}$onDidChangeSelection(f,D){const p=this.e.get(f);p instanceof c&&p._fireDidChangeSelection(D)}$onDidTriggerButton(f,D){this.e.get(f)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(f,D,p){const E=this.e.get(f);E instanceof c&&E._fireDidTriggerItemButton(D,p)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class u{static{this.a=1}constructor(f,D){this.x=f,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$ce,this.q=new M.$ce,this.r=new M.$ce,this.s=new M.$ce,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((D,p)=>{const E=D===b.$iO.Back?-1:p;this.o.set(E,D)}),this.z({buttons:f.map((D,p)=>({...s(D.iconPath),tooltip:D.tooltip,handle:D===b.$iO.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const D=this.o.get(f);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(f){if(!this.v){for(const D of Object.keys(f)){const p=f[D];this.u[D]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function o(v){if(v instanceof b.$SN)return{id:v.id};const f=h(v),D=t(v);return{dark:typeof f=="string"?R.URI.file(f):f,light:typeof D=="string"?R.URI.file(D):D}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function h(v){return typeof v=="object"&&"dark"in v?v.dark:v}function s(v){const f=o(v);let D,p;return"id"in f?p=C.ThemeIcon.asClassName(f):D=f,{iconPath:D,iconClass:p}}class c extends u{constructor(f,D){super(f.identifier,D),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$ce,this.L=[],this.M=new M.$ce,this.N=new M.$ce,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const D=(0,m.$BG)(this.O,"quickPickItemTooltip"),p=[];for(let E=0;E<f.length;E++){const k=f[E];if(k.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?s(k.iconPath):void 0;p.push({handle:E,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((I,T)=>({...s(I.iconPath),tooltip:I.tooltip,handle:T}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(f){const D=(0,S.$Hb)(f.map(p=>this.C.get(p)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(f){const D=(0,S.$Hb)(f.map(p=>this.C.get(p)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(f,D){const p=this.C.get(f);if(!p||!p.buttons||!p.buttons.length)return;const E=p.buttons[D];E&&this.N.fire({button:E,item:p})}}class r extends u{constructor(f,D){super(f.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:N.default.Error}):this.z({validationMessage:f.message,severity:f.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new n(g,a)}}),define(ke[346],Se([1,0,2,4,55,3,8,6,19,131,12,25,57,16,26,15,11]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0;function i(P){return P instanceof l.URI}function n(P,I){return P.scheme===d.Schemas.file&&I.scheme===d.Schemas.file&&g.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function u(P){if(P)return typeof P.iconPath=="string"?l.URI.file(P.iconPath):l.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function o(P){if(P.icon){if(l.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const T=typeof P.iconPath=="string"?P.iconPath:l.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:l.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$nr)(T,j)}function h(P,I){let T=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(T=t(P,I),T!==0)return T;if(P.light&&I.light)T=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(T!==0)return T;if(P.dark&&I.dark)T=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return T}function s(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let T=0;T<P.arguments.length;T++){const j=P.arguments[T],z=I.arguments[T];if(j!==z&&!(i(j)&&i(z)&&n(j,z)))return j<z?-1:1}return 0}function c(P,I){let T=(0,S.$nr)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(T!==0)return T;if(P.command&&I.command)T=s(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(T!==0)return T;if(P.decorations&&I.decorations)T=h(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)T=(0,S.$nr)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)T=(0,S.$nr)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return T}function r(P,I){for(let T=0;T<P.length;T++)if(P[T]!==I[T])return!1;return!0}function v(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?r(P.arguments,I.arguments):P.arguments===I.arguments)}function f(P,I){return(0,$.$ub)(P,I,v)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,w.$CG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,w.$CG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,w.$CG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,T,j,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new M.$ce,this.f="",this.h=!0,this.j=!0,this.#t=T,this.#e=j}showValidationMessage(I,T){(0,w.$CG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,T)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$nmc=D;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,T,j,z,O,F,B){this.q=I,this.s=T,this.t=j,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=F,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$ce,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$ce,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,T){const j=this.h.get(I);return j?(0,R.$lh)(()=>this.s.executeCommand(j.command,...j.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(c),j=(0,$.$Db)(this.o,I,c).map(F=>{const B=F.toInsert.map(W=>{const Z=this.e++;this.g.set(Z,W);const X=W.resourceUri;let Y;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const oe=new A.$Uc;Y=this.s.converter.toInternal(W.command,oe),this.j.set(Z,oe)}else this.h.set(Z,W.command);const x=(0,w.$BG)(this.w,"scmMultiDiffEditor"),ne=x?W.multiDiffEditorOriginalUri:void 0,ge=x?W.multiFileDiffEditorModifiedUri:void 0,ue=u(W.decorations),ve=W.decorations&&u(W.decorations.light)||ue,te=W.decorations&&u(W.decorations.dark)||ue,U=[ve,te],_=W.decorations&&W.decorations.tooltip||"",pe=W.decorations&&!!W.decorations.strikeThrough,Pe=W.decorations&&!!W.decorations.faded,se=W.contextValue||"";return{rawResource:[Z,X,U,_,pe,Pe,se,Y,ne,ge],handle:Z}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),z=j.map(({start:F,deleteCount:B,toInsert:W})=>[F,B,W.map(Z=>Z.rawResource)]),O=j.reverse();for(const{start:F,deleteCount:B,toInsert:W}of O){const Z=W.map(Y=>Y.handle),X=this.n.splice(F,B,...Z);for(const Y of X)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let T;(0,w.$BG)(this.x,"quickDiffProvider")&&(T=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:T})}get historyProvider(){return(0,w.$CG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,w.$CG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new A.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new A.$Uc,this.o=I;const T=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:T})}get actionButton(){return(0,w.$CG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,w.$CG)(this.x,"scmActionButton"),this.p.value=new A.$Uc,this.q=I;const T=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:T??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&f(this.t,I))return;this.s.value=new A.$Uc,this.t=I;const T=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:T})}get selected(){return this.u}constructor(I,T,j,z,O,F,B){this.x=I,this.y=z,this.z=O,this.A=F,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Wc,this.m=void 0,this.n=new A.$Wc,this.o=void 0,this.p=new A.$Wc,this.s=new A.$Wc,this.t=void 0,this.u=!1,this.v=new M.$ce,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=j;const W=l.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,T,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,F,B,W)}createResourceGroup(I,T,j){const z=(0,w.$BG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new p(this.#e,this.y,this.w,I,T,z,this.x),F=M.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,F),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],T=[];for(const[j,z]of this.C){z.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});M.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const F=j._takeResourceStateSnapshot();F.length>0&&T.push([j.handle,F]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,T),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(T=>{const j=T._takeResourceStateSnapshot();j.length!==0&&I.push([T.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Yh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Yh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,T,j,z){this.l=T,this.m=j,this.n=z,this.g=new Map,this.h=new C.$Qm,this.j=new M.$ce,this.e=I.getProxy(b.$UM.MainThreadSCM),this.f=I.getProxy(b.$UM.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const F=this.g.get(O.sourceControlHandle);if(!F)return O;const B=F.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const F=this.g.get(O.sourceControlHandle);return F?F.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const F=this.g.get(O.handle);return F||O}return O}})}createSourceControl(I,T,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,T,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=a.d++,F=new E(I,this.m,this.e,this.l,T,j,z);this.g.set(O,F);const B=this.h.get(I.identifier)||[];return B.push(F),this.h.set(I.identifier,B),F}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const T=this.h.get(I.identifier),j=T&&T[T.length-1];return j&&j.inputBox}$provideOriginalResource(I,T,j){const z=l.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$lh)(()=>O.quickDiffProvider.provideOriginalResource(z,j)).then(F=>F||null)}$onInputBoxValueChange(I,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(I,T,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,T,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const F=O.getResourceGroup(T);return F?F.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,T,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$lh)(()=>z.inputBox.validateInput(T,j)).then(O=>{if(!O)return Promise.resolve(void 0);const F=y.MarkdownString.fromStrict(O.message);return F?Promise.resolve([F,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,T,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,j,z)??void 0}async $provideHistoryItems(I,T,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(T,j,z))?.map(B=>({...B,icon:o(B)}))??void 0}async $provideHistoryItemSummary(I,T,j,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const F=await O.provideHistoryItemSummary(T,j,z);return F?{...F,icon:o(F)}:void 0}async $provideHistoryItemChanges(I,T,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(T,j,z)??void 0}};e.$omc=k,e.$omc=k=a=Je([Ve(3,N.$Zj)],k)}),define(ke[347],Se([1,0,6,16,2]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;class A{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(l.$UM.MainThreadShare)}async $provideShare(b,$,S){return await this.c.get(b)?.provideShare({selection:M.Range.to($.selection),resourceUri:L.URI.revive($.resourceUri)},S)??void 0}registerShareProvider(b,$){const S=A.a++;return this.c.set(S,$),this.b.$registerShareProvider(S,M.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$pmc=A}),define(ke[348],Se([1,0,7,6,224,3,16,18]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$TN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$TN("statusBarItem.warningForeground")]])}#e;#t;constructor(m,y,w,d,g,a=l.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Uc,this.#e=m,this.#t=y,g&&d){this.c=(0,l.$vN)(d.identifier,g);const n=w.get(this.c);n&&(a=n.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=d,this.f=g,this.g=a,this.h=this.u(i)}u(m){if((0,b.$0f)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new A.$Uc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let y;this.m?y=this.m:y=(0,L.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=$.b.get(this.o.id));const d=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,y,this.k,d,this.r?.internal,w,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$rmc=$;class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const y={message:m};return this.b.unshift(y),this.c(),new l.$WM(()=>{const w=this.b.indexOf(y);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(m,y){this.e=new Map,this.a=m.getProxy(M.$UM.MainThreadStatusBar),this.b=y,this.c=new S(this)}$acceptStaticEntries(m){for(const y of m)this.e.set(y.entryId,y)}createStatusBarEntry(m,y,w,d){return new $(this.a,this.b,this.e,m,y,w,d)}setStatusBarMessage(m,y){const w=this.c.setMessage(m);let d;return typeof y=="number"?d=setTimeout(()=>w.dispose(),y):typeof y<"u"&&y.then(()=>w.dispose(),()=>w.dispose()),new l.$WM(()=>{w.dispose(),clearTimeout(d)})}}e.$smc=N}),define(ke[154],Se([1,0,29,144,68,112,89,16,2]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=e.$uP=e.$tP=void 0;const S=(n,u,o,t)=>{let h=u;return{enumerable:!0,configurable:!1,get(){return h},set(s){if(!o(h,s)){const c=h;h=s,n.listener?.(t(s,c))}}}},N=(n,u)=>n===u,C={range:(n,u)=>n===u?!0:!n||!u?!1:n.isEqual(u),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,u)=>!(n.length!==u.length||n.some(o=>!u.find(t=>o.id===t.id)))},m=n=>u=>({op:4,update:n(u)}),y=(n,u)=>({range:(()=>{let o;const t=m(h=>({range:l.$pt.lift(b.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return o},set(h){n.listener?.({op:6}),C.range(o,h)||(o=h,n.listener?.(t(h)))}}})(),label:S(n,u,C.label,m(o=>({label:o}))),description:S(n,void 0,C.description,m(o=>({description:o}))),sortText:S(n,void 0,C.sortText,m(o=>({sortText:o}))),canResolveChildren:S(n,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:S(n,!1,C.busy,m(o=>({busy:o}))),error:S(n,void 0,C.error,m(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:S(n,[],C.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),w=n=>{const u=L.$GL.fromString(n.extId),o=new g(u.controllerId,u.localId,n.label,$.URI.revive(n.uri)||void 0);return o.range=b.Range.to(n.range||void 0),o.description=n.description||void 0,o.sortText=n.sortText||void 0,o.tags=n.tags.map(t=>b.TestTag.to({id:(0,R.$ML)(t).tagId})),o},d=n=>{let u;for(const o of n.tests){const t=w(o.item);(0,M.$dP)(t).parent=u,u=t}return u};e.$tP=d;class g{constructor(u,o,t,h){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const s=(0,M.$cP)(this,u);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,A.$bP)(s,M.$dP,g),enumerable:!0,writable:!1},...y(s,t)})}}e.$uP=g;class a extends g{constructor(u,o){super(u,u,o,void 0),this._isRoot=!0}}e.$vP=a;class i extends A.$0O{constructor(u,o,t){super({controllerId:u,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:M.$dP,getChildren:h=>h.children,root:new a(u,o),toITestItem:b.TestItem.from})}}e.$wP=i}),define(ke[34],Se([1,0,18,7,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,40,87,90,30]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=void 0;let s=class{#e;#t;#i;constructor(p,E,k){this.b=new Map,this.c=new Map,this.#e=p.getProxy(R.$UM.MainThreadCommands),this.d=E,this.#i=k,this.#t=p.getProxy(R.$UM.MainThreadTelemetry),this.converter=new c(this,P=>{const I=this.c.get(P);return I?.result===v.Void?I:void 0},E),this.f=[{processArgument(P){return(0,S.$3h)(P)}},{processArgument(P){return(0,A.$2n)(P,function(I){if(N.$pt.isIRange(I))return L.Range.to(I);if(C.$ot.isIPosition(I))return L.Position.to(I);if(N.$pt.isIRange(I.range)&&m.URI.isUri(I.uri))return L.location.to(I);if(I instanceof a.$De)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const E=this.registerCommand(!1,p.id,async(...k)=>{const P=p.args.map((T,j)=>{if(!T.validate(k[j]))throw new Error(`Invalid argument '${T.name}' when running '${p.id}', received: ${typeof k[j]=="object"?JSON.stringify(k[j],null,"	"):k[j]} `);return T.convert(k[j])}),I=await this.executeCommand(p.internalId,...P);return p.result.convert(I,k,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new M.$WM(()=>{E.dispose(),this.c.delete(p.id)})}registerCommand(p,E,k,P,I,T){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:P,metadata:I,extension:T}),p&&this.#e.$registerCommand(E),new M.$WM(()=>{this.b.delete(E)&&p&&this.#e.$unregisterCommand(E)})}executeCommand(p,...E){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,E,!0)}async g(p,E,k){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,E,!1);{let P=!1;const I=(0,A.$2n)(E,function(T){if(T instanceof M.$XM)return L.Position.from(T);if(T instanceof M.$YM)return L.Range.from(T);if(T instanceof M.$9M)return L.location.from(T);if(M.$lO.isNotebookRange(T))return L.NotebookRange.from(T);if(T instanceof ArrayBuffer)return P=!0,a.$De.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return P=!0,a.$De.wrap(T);if(T instanceof a.$De)return P=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(p,P?new i.$qw(I):I,k);return(0,S.$3h)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(p,E,!1);throw T}}}async h(p,E,k){const P=this.b.get(p);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:T,metadata:j}=P;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,l.$kg)(E[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const z=u.$$d.create();try{return await I.apply(T,E)}catch(O){if(p===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...E);F&&(p=F.command)}if(this.d.error(O,p,P.extension?.identifier),!k)throw O;if(P.extension?.identifier){const F=this.#i.onExtensionError(P.extension.identifier,O);this.d.trace("forwarded error to extension?",F,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$ej)(O)),this.id=p,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,p,z.elapsed())}}j(p,E,k){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new o.$cp(E),duration:k})}$executeContributedCommand(p,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const k=this.b.get(p);return k?(E=E.map(P=>this.f.reduce((I,T)=>T.processArgument(I,k.extension?.identifier),P)),this.h(p,E,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(E=>(p&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[E,k]of this.b){const{metadata:P}=k;P&&(p[E]=P)}return Promise.resolve(p)}};e.$CP=s,e.$CP=s=Je([Ve(0,d.$hP),Ve(1,$.$Zj),Ve(2,t.$BP)],s),e.$DP=(0,w.$ti)("IExtHostCommands");class c{constructor(p,E,k){this.d=p,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,h.$Pg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,E){if(!p)return;const k={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return k;const P=this.f(p.command);if(P)k.id=P.internalId,k.arguments=P.args.map((I,T)=>I.convert(p.arguments&&p.arguments[T]));else if((0,b.$Lb)(p.arguments)){const I=`${p.command} /${++this.c}`;this.b.set(I,p),E.add((0,y.$Tc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),k.$ident=I,k.id=this.delegatingCommandId,k.arguments=[I],this.g.trace("CommandsConverter#CREATE",p.command,I)}return k}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const E=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$EP=c;class r{static{this.Uri=new r("uri","Uri of a text document",p=>m.URI.isUri(p),p=>p)}static{this.Position=new r("position","A position in a text document",p=>M.$XM.isPosition(p),L.Position.from)}static{this.Range=new r("range","A range in a text document",p=>M.$YM.isRange(p),L.Range.from)}static{this.Selection=new r("selection","A selection in a text document",p=>M.$ZM.isSelection(p),L.Selection.from)}static{this.Number=new r("number","",p=>typeof p=="number",p=>p)}static{this.String=new r("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=r.Arr(r.String)}static Arr(p){return new r(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,E=>Array.isArray(E)&&E.every(k=>p.validate(k)),E=>E.map(k=>p.convert(k)))}static{this.CallHierarchyItem=new r("item","A call hierarchy item",p=>p instanceof M.$hN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new r("item","A type hierarchy item",p=>p instanceof M.$FO,L.TypeHierarchyItem.from)}static{this.TestItem=new r("testItem","A VS Code TestItem",p=>p instanceof g.$uP,L.TestItem.from)}constructor(p,E,k,P){this.name=p,this.description=E,this.validate=k,this.convert=P}optional(){return new r(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,E){return new r(p??this.name,E??this.description,this.validate,this.convert)}}e.$FP=r;class v{static{this.Void=new v("no result",p=>p)}constructor(p,E){this.description=p,this.convert=E}}e.$GP=v;class f{constructor(p,E,k,P,I){this.id=p,this.internalId=E,this.description=k,this.args=P,this.result=I}}e.$HP=f}),define(ke[349],Se([1,0,19,15,2,83,134,37,34,16,7]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;const C=[new $.$HP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of DocumentHighlight-instances.",y(S.DocumentHighlight.to))),new $.$HP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$FP.Uri],new $.$GP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,g)=>{if((0,l.$Kb)(d))return;class a extends N.$cN{static to(n){const u=new a(n.name,S.SymbolKind.to(n.kind),n.containerName||"",new N.$9M(g[0],S.Range.to(n.range)));return u.detail=n.detail,u.range=u.location.range,u.selectionRange=S.Range.to(n.selectionRange),u.children=n.children?n.children.map(a.to):[],u}}return d.map(a.to)})),new $.$HP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$FP.Uri,new $.$FP("options","Formatting options",d=>!0,d=>d)],new $.$GP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$HP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$FP.Uri,$.$FP.Range,new $.$FP("options","Formatting options",d=>!0,d=>d)],new $.$GP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$HP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$FP.Uri,$.$FP.Position,new $.$FP("ch","Trigger character",d=>typeof d=="string",d=>d),new $.$FP("options","Formatting options",d=>!0,d=>d)],new $.$GP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$HP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Location or LocationLink instances.",w)),new $.$HP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Location or LocationLink instances.",w)),new $.$HP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Location or LocationLink instances.",w)),new $.$HP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Location or LocationLink instances.",w)),new $.$HP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Location-instances.",y(S.location.to))),new $.$HP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of Hover-instances.",y(S.Hover.to))),new $.$HP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$FP.Uri,new $.$FP("position","A position in a text document",d=>Array.isArray(d)&&d.every(g=>N.$XM.isPosition(g)),d=>d.map(S.Position.from))],new $.$GP("A promise that resolves to an array of ranges.",d=>d.map(g=>{let a;for(const i of g.reverse())a=new N.$gN(S.Range.to(i),a);return a}))),new $.$HP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$FP.String.with("query","Search string")],new $.$GP("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(S.WorkspaceSymbol.to))),new $.$HP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(S.CallHierarchyItem.to))),new $.$HP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$FP.CallHierarchyItem],new $.$GP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(S.CallHierarchyIncomingCall.to))),new $.$HP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$FP.CallHierarchyItem],new $.$GP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(S.CallHierarchyOutgoingCall.to))),new $.$HP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:S.Range.to(d.range),placeholder:d.text}})),new $.$HP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$FP.Uri,$.$FP.Position,$.$FP.String.with("newName","The new symbol name")],new $.$GP("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return S.WorkspaceEdit.to(d)}})),new $.$HP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$FP.Uri,$.$FP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$GP("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(S.DocumentLink.to))),new $.$HP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$FP.Uri],new $.$GP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new N.$cO(d.tokenTypes,d.tokenModifiers)})),new $.$HP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$FP.Uri],new $.$GP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,R.$Qbb)(d);if(g.type==="full")return new N.$eO(g.data,void 0)})),new $.$HP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$FP.Uri,$.$FP.Range.optional()],new $.$GP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new N.$cO(d.tokenTypes,d.tokenModifiers)})),new $.$HP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$FP.Uri,$.$FP.Range],new $.$GP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,R.$Qbb)(d);if(g.type==="full")return new N.$eO(g.data,void 0)})),new $.$HP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$FP.Uri,$.$FP.Position,$.$FP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$FP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$GP("A promise that resolves to a CompletionList-instance.",(d,g,a)=>{if(!d)return new N.$sN([]);const i=d.suggestions.map(n=>S.CompletionItem.to(n,a));return new N.$sN(i,d.incomplete)})),new $.$HP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$FP.Uri,$.$FP.Position,$.$FP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$GP("A promise that resolves to SignatureHelp.",d=>{if(d)return S.SignatureHelp.to(d)})),new $.$HP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$FP.Uri,$.$FP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$GP("A promise that resolves to an array of CodeLens-instances.",(d,g,a)=>y(i=>new N.$kN(S.Range.to(i.range),i.command&&a.fromInternal(i.command)))(d))),new $.$HP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$FP.Uri,new $.$FP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>N.$YM.isRange(d),d=>N.$ZM.isSelection(d)?S.Selection.from(d):S.Range.from(d)),$.$FP.String.with("kind","Code action kind to return code actions for").optional(),$.$FP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$GP("A promise that resolves to an array of Command-instances.",(d,g,a)=>y(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const n=new N.$eN(i.title,i.kind?new N.$fN(i.kind):void 0);return i.edit&&(n.edit=S.WorkspaceEdit.to(i.edit)),i.command&&(n.command=a.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(d))),new $.$HP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$FP.Uri],new $.$GP("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(g=>new N.$yN(S.Range.to(g.range),S.Color.to(g.color))):[])),new $.$HP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$FP("color","The color to show and insert",d=>d instanceof N.$xN,S.Color.from),new $.$FP("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:S.Range.from(d.range)}))],new $.$GP("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(S.ColorPresentation.to):[])),new $.$HP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$FP.Uri,$.$FP.Range],new $.$GP("A promise that resolves to an array of Inlay objects",(d,g,a)=>d.map(S.InlayHint.to.bind(void 0,a)))),new $.$HP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$FP.Uri],new $.$GP("A promise that resolves to an array of FoldingRange objects",(d,g)=>{if(d)return d.map(S.FoldingRange.to)})),new $.$HP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$GP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(g=>S.NotebookExclusiveDocumentPattern.to(g))})))),new $.$HP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$FP.Uri,$.$FP.Range,new $.$FP("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof N.$YM,d=>S.InlineValueContext.from(d))],new $.$GP("A promise that resolves to an array of InlineValue objects",d=>d.map(S.InlineValue.to))),new $.$HP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$FP("uriOrString","Uri-instance or string (only http/https)",d=>L.URI.isUri(d)||typeof d=="string"&&(0,M.$Dg)(d,M.Schemas.http,M.Schemas.https),d=>d),new $.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[S.ViewColumn.from(d),void 0]:[S.ViewColumn.from(d.viewColumn),S.TextEditorOpenOptions.from(d)])).optional(),$.$FP.String.with("label","").optional()],$.$GP.Void),new $.$HP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$FP.Uri.with("resource","Resource to open"),$.$FP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[S.ViewColumn.from(d),void 0]:[S.ViewColumn.from(d.viewColumn),S.TextEditorOpenOptions.from(d)])).optional()],$.$GP.Void),new $.$HP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$FP.Uri.with("left","Left-hand side resource of the diff editor"),$.$FP.Uri.with("right","Right-hand side resource of the diff editor"),$.$FP.String.with("title","Human readable title for the diff editor").optional(),new $.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[S.ViewColumn.from(d.viewColumn),S.TextEditorOpenOptions.from(d)]).optional()],$.$GP.Void),new $.$HP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$FP.String.with("title","Human readable title for the changes editor"),new $.$FP("resourceList","List of resources to compare",d=>{for(const g of d){if(g.length!==3)return!1;const[a,i,n]=g;if(!L.URI.isUri(a)||!L.URI.isUri(i)&&i!==void 0&&i!==null||!L.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},d=>d)],$.$GP.Void),new $.$HP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$FP.Uri,$.$FP.Position],new $.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(S.TypeHierarchyItem.to))),new $.$HP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$FP.TypeHierarchyItem],new $.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(S.TypeHierarchyItem.to))),new $.$HP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$FP.TypeHierarchyItem],new $.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(S.TypeHierarchyItem.to))),new $.$HP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$FP.TestItem],$.$GP.Void),new $.$HP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$FP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$GP.Void),new $.$HP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$FP.String.with("name","The context key name"),new $.$FP("value","The context key value",()=>!0,d=>d)],$.$GP.Void),new $.$HP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$FP.Uri,$.$FP.StringArray,new $.$FP("MappedEditsContext","Mapped Edits Context",d=>S.MappedEditsContext.is(d),d=>S.MappedEditsContext.from(d))],new $.$GP("A promise that resolves to a workspace edit or null",d=>d?S.WorkspaceEdit.to(d):null))];class m{static register(g){C.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",b.$sj)}}e.$Nkc=m;function y(d){return g=>{if(Array.isArray(g))return g.map(d)}}function w(d){if(!Array.isArray(d))return;const g=[];for(const a of d)A.$7t(a)?g.push(S.DefinitionLink.to(a)):g.push(S.location.to(a));return g}}),define(ke[350],Se([1,0,8,3,2,6,34,16,7]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class S{static{this.a=0}constructor(y,w){this.extension=y,this.provider=w,this.handle=S.a++}}class N{constructor(y){this.session=y,this.responses=[]}}class C{static{this.a=0}constructor(y,w,d,g){this.f=d,this.g=g,this.b=new Map,this.d=new Map,this.e=y.getProxy(A.$UM.MainThreadInlineChat),w.registerApiCommand(new R.$HP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$FP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:$.$ZM.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],R.$GP.Void))}registerProvider(y,w,d){const g=new S(y,w);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,d?.label??y.displayName??y.name,y.identifier,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",d?.supportReportIssue??!1),(0,M.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(y,w,d,g){const a=this.b.get(y);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(L.URI.revive(w)),n=b.Selection.to(d),u=await a.provider.prepareInteractiveEditorSession({document:i,selection:n},g);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new N(u)),{id:o,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(u.wholeRange),message:u.message}}async $provideResponse(y,w,d,g){const a=this.b.get(y);if(!a)return;const i=this.d.get(w.id);if(!i)return;const n={prompt:d.prompt,selection:b.Selection.to(d.selection),wholeRange:b.Range.to(d.wholeRange),attempt:d.attempt,live:d.live,previewDocument:this.f.getDocument(L.URI.revive(d.previewDocument)),withIntentDetection:d.withIntentDetection};let u=!1;const o={report:async D=>{if(!d.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||g.isCancellationRequested||await this.e.$handleProgressChunk(d.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$lN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,n,o,g));let h;try{h=await(0,l.$hh)(t,g)}finally{u=!0}if(!h)return;const s=i.responses.push(h)-1,c={wholeRange:b.Range.from(h.wholeRange),placeholder:h.placeholder};if(!C.h(h))return{...c,id:s,type:"editorEdit",message:b.MarkdownString.from(h.contents),edits:[]};const{edits:r,contents:v}=h,f=v!==void 0?b.MarkdownString.from(v):void 0;return r instanceof $.$7M?{...c,id:s,type:"bulkEdit",edits:b.WorkspaceEdit.from(r),message:f}:{...c,id:s,type:"editorEdit",edits:r.map(b.TextEdit.from),message:f}}async $provideFollowups(y,w,d,g){const a=this.b.get(y),i=this.d.get(w),n=i?.responses[d];if(a&&n&&a.provider.provideFollowups){const u=Promise.resolve(a.provider.provideFollowups(i.session,n,g));return(await(0,l.$hh)(u,g))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(y,w,d,g){const a=this.b.get(y),i=this.d.get(w),n=i?.responses[d];if(a&&n){const u=b.InteractiveEditorResponseFeedbackKind.to(g);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,u)}}$releaseSession(y,w){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$Wlc=C}),define(ke[351],Se([1,0,2,34]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class L{constructor(R,b,$,S,N){this.a=b,this.b=$,this.c=S;const C=new M.$HP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$FP("showOptions","Show Options",m=>!0,m=>m),new M.$FP("resource","Interactive resource Uri",m=>!0,m=>m),new M.$FP("controllerId","Notebook controller Id",m=>!0,m=>m),new M.$FP("title","Interactive editor title",m=>!0,m=>m)],new M.$GP("Notebook and input URI",m=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const y=this.a.getEditorById(m.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:l.URI.revive(m.notebookUri),inputUri:l.URI.revive(m.inputUri),notebookEditor:y.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:l.URI.revive(m.notebookUri),inputUri:l.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,b,$,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$0lc=L}),define(ke[352],Se([1,0,19,8,22,4,3,27,2,25,12,6,34,16,7,113,296,26,48,297]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0,e.$fmc=r;let u=class{constructor(f,D,p,E,k){this.m=D,this.n=p,this.o=E,this.q=k,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$ce,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(C.$UM.MainThreadNotebookKernels);const P=new m.$HP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$FP("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const j=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:j}}else if(T&&"notebookEditor"in T){const j=this.n.getIdByEditor(T.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return T})],m.$GP.Void),I=new m.$HP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[m.$FP.Uri],new m.$GP("A promise that resolves to an array of variables",(T,j)=>T.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(f,D,p,E,k,P){for(const ue of this.j.values())if(ue.controller.id===D&&S.$Om.equals(f.identifier,ue.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,T=this;this.q.trace(`NotebookController[${I}], CREATED by ${f.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${f.identifier}'`);let z=!1;const O=new A.$ce,F=new A.$ce,B={id:r(f.identifier,D),notebookType:p,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:E||f.identifier.value,preloads:P?P.map(y.NotebookRendererScript.from):[]};let W=k??j,Z,X;this.a.$addKernel(I,B).catch(ue=>{console.log(ue),z=!0});let Y=0;const x=()=>{if(z)return;const ue=++Y;Promise.resolve().then(()=>{ue===Y&&this.a.$updateKernel(I,B)})},ne=new b.$Bc,ge={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(ue){B.label=ue??f.displayName??f.name,x()},get detail(){return B.detail??""},set detail(ue){B.detail=ue,x()},get description(){return B.description??""},set description(ue){B.description=ue,x()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ue){B.supportedLanguages=ue,x()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){B.supportsExecutionOrder=ue,x()},get rendererScripts(){return B.preloads?B.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ue){W=ue??j},get interruptHandler(){return Z},set interruptHandler(ue){Z=ue,B.supportsInterrupt=!!ue,x()},set variableProvider(ue){(0,a.$CG)(f,"notebookVariableProvider"),X=ue,B.hasVariableProvider=!!ue,ue?.onDidChangeVariables(ve=>T.a.$variablesUpdated(ve.uri)),x()},get variableProvider(){return X},createNotebookCellExecution(ue){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ue.notebook.uri))throw T.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return T._createNotebookCellExecution(ue,r(f.identifier,this.id))},createNotebookExecution(ue){if((0,a.$CG)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ue.uri))throw T.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return T._createNotebookExecution(ue,r(f.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),F.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ue,ve){ve===w.NotebookControllerAffinity2.Hidden&&(0,a.$CG)(f,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(I,ue.uri,ve)},onDidReceiveMessage:F.event,postMessage(ue,ve){return(0,a.$CG)(f,"notebookMessaging"),T.a.$postMessage(I,ve&&T.n.getIdByEditor(ve),ue)},asWebviewUri(ue){return(0,a.$CG)(f,"notebookMessaging"),(0,d.$jyb)(ue,T.m.remote)}};return this.j.set(I,{extensionId:f.identifier,controller:ge,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:ne}),ge}getIdByController(f){for(const[D,p]of this.j)if(p.controller===f)return r(p.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const p=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(p,D);const k={dispose:()=>{this.f.delete(p),E.a.$removeKernelDetectionTask(p)}};return this.f.set(p,k),k}registerKernelSourceActionProvider(f,D,p){const E=this.i++,k=typeof p.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,p),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,D);let I;return k!==void 0&&(I=p.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),I?.dispose()}}}async $provideKernelSourceActions(f,D){const p=this.h.get(f);if(p){const E=new R.$Uc;return(await p.provideNotebookKernelSourceActions(D)??[]).map(P=>y.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(f,D,p){const E=this.j.get(f);if(E){const k=this.n.getNotebookDocument($.URI.revive(D));p?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,k.uri.toString(),p),E.onDidChangeSelection.fire({selected:p,notebook:k.apiNotebook})}}async $executeCells(f,D,p){const E=this.j.get(f);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(D)),P=[];for(const I of p){const T=k.getCell(I);T&&P.push(T.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,k.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,k.apiNotebook,E.controller)}catch(I){this.q.error(`NotebookController[${f}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(f,D,p){const E=this.j.get(f);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(D));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const P of p){const I=k.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(k.uri);p.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(f,D,p,E,k,P,I){const T=this.j.get(f);if(!T)return;const j=this.n.getNotebookDocument($.URI.revive(p)),z=T.controller.variableProvider;if(!z)return;let O;if(E!==void 0){if(O=this.s[E],!O)return}else this.s={};const F=k==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,O,F,P,I);let W=0;for await(const Z of B){if(I.isCancellationRequested)return;const X={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,interfaces:Z.variable.interfaces,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[X.id]=Z.variable,this.a.$receiveVariable(D,X),W++>=n.$Sib)return}}$acceptKernelMessageFromRenderer(f,D,p){const E=this.j.get(f);if(!E)return;const k=this.n.getEditorById(D);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:p}))}$cellExecutionChanged(f,D,p){const k=this.n.getNotebookDocument($.URI.revive(f)).getCell(D);if(k){const P=p?y.NotebookCellExecutionState.to(p):w.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new t(D,E,this.a);this.b.set(E.uri,k);const P=k.onDidChangeState(()=>{k.state===o.Resolved&&(k.dispose(),P.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(f,D){const p=this.n.getNotebookDocument(f.uri),E=f.getCells().find(I=>{const T=p.getCellFromApiCell(I);return T&&this.b.has(T.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const k=new s(D,p,this.a),P=k.onDidChangeState(()=>{k.state===h.Resolved&&(k.dispose(),P.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[k,P]),k.asApiObject()}};e.$emc=u,e.$emc=u=Je([Ve(4,N.$Zj)],u);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class t extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(f,D,p){super(),this.m=D,this.n=p,this.b=t.a++,this.c=new A.$ce,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new L.$ne),this.h=new c(10,E=>this.s(E)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new i.$qw(D))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const p=w.$pO.ensureUniqueMimeTypes(D.items,!0);return p===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:p,id:D.id,metadata:D.metadata})})}async z(f,D,p){const E=this.w(D),k=this.y((0,l.$3b)(f));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:E,append:p,outputs:k})}async C(f,D,p){return f=w.$pO.ensureUniqueMimeTypes((0,l.$3b)(f),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:f.map(y.NotebookCellOutputItem.from),outputId:D.id,append:p})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(p){f.j=p,f.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(p){if(f.f===o.Resolved||f.f===o.Started)throw new Error("Cannot call start again");f.f=o.Started,f.c.fire(),f.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,E,k){if(f.f===o.Resolved)throw new Error("Cannot call resolve twice");f.f=o.Resolved,f.c.fire(),f.h.flush();const P=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;f.n.$completeExecution(f.b,new i.$qw({runEndTime:E,lastRunSuccess:p,error:P}))},clearOutput(p){return f.t(),f.z([],p,!1)},appendOutput(p,E){return f.t(),f.z(p,E,!0)},replaceOutput(p,E){return f.t(),f.z(p,E,!1)},appendOutputItems(p,E){return f.t(),f.C(p,E,!0)},replaceOutputItems(p,E){return f.t(),f.C(p,E,!1)}})}}var h;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(h||(h={}));class s extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(f,D,p){super(),this.h=D,this.j=p,this.b=s.a++,this.c=new A.$ce,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new L.$ne),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new M.$Qh,this.b=Date.now(),(0,M.$uh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function r(v,f){return`${v.value}/${f}`}}),define(ke[43],Se([1,0,4,6,5,2,20,3,7,226,13,272,22,30,273,57,8,16,34]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=e.$qlc=e.$plc=void 0,e.$plc=(0,L.$ti)("IExtHostTerminalService");class n extends b.$Vc{constructor(p,E,k,P){super(),this.u=p,this._id=E,this.w=k,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new l.$ce),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(T=>this.g=T);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(T,j=!0){I.C(),I.u.$sendText(I._id,T,j)},show(T){I.C(),I.u.$show(I._id,T)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??E?.cwd??void 0,env:p.env??void 0,icon:r(p.iconPath)??void 0,color:d.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(p.location,E?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,E,k,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:d.ThemeColor.isThemeColor(I)?I.id:void 0,location:E?.location||this.z(p,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,E){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in p?{viewColumn:a.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,E){this.j=Object.freeze({code:p,reason:E})}setDimensions(p,E){return p===this.f&&E===this.h||p===0||E===0?!1:(this.f=p,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(E=>{E!==p&&(this.b=Promise.resolve(p))})}}e.$qlc=n;class u{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new l.$ce,this.onProcessData=this.a.event,this.b=new l.$ce,this.d=new l.$ce,this.onDidChangeProperty=this.d.event,this.f=new l.$ce,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,E){this.g.setDimensions?.({columns:p,rows:E})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$ce,this.onDidCloseTerminal=this.H.event,this.I=new l.$ce,this.onDidOpenTerminal=this.I.event,this.J=new l.$ce,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$ce,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$ce,this.onDidChangeTerminalState=this.M.event,this.N=new l.$ce,this.onDidChangeShell=this.N.event,this.O=new l.$ce({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$ce({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(M.$UM.MainThreadTerminalService),this.y=new w.$btb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:P=>{const I=T=>{const j=T;return this.getTerminalById(j.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let T=0;T<P.length&&P[T].$mid===15;T++)P[T]=I(P[T]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,E){const k=new n(this.a,(0,y.$Pg)(),p,p.name),P=new u(p.pty);return k.createExtensionTerminal(p.location,E,this.R(p,E).resolvedExtHostIdentifier,r(p.iconPath),v(p.color)).then(I=>{const T=this.S(I,P);this.h[I]=T}),this.f.push(k),k.value}R(p,E){if(E=E||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const k=p.location.parentTerminal;if(k){const P=this.f.find(I=>I.value===k);P&&(E.resolvedExtHostIdentifier=P._id)}}else p.location&&typeof p.location!="object"?E.location=p.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(p,E){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const P=new u(E),I=this.S(p,P);this.h[p]=I}async $acceptActiveTerminalChanged(p){const E=this.b;if(p===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(p);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,E){const k=this.getTerminalById(p);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(p,E,k){const P=this.getTerminalById(p);P&&P.setDimensions(E,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(p,E){const k=this.getTerminalById(p);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(p,E,k){this.g.get(p)?.resize(E,k)}async $acceptTerminalTitleChange(p,E){const k=this.getTerminalById(p);k&&(k.name=E)}async $acceptTerminalClosed(p,E,k){const P=this.X(this.f,p);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(E,k),this.H.fire(I.value)}}$acceptTerminalOpened(p,E,k,P){if(E){const j=this.X(this.f,E);if(j!==null){this.f[j]._id=p,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},T=new n(this.a,p,I,k);this.f.push(T),this.I.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(p,E){this.getTerminalById(p)?._setProcessId(E)}async $startExtensionTerminal(p,E){const k=this.getTerminalById(p);if(!k)return{message:(0,S.localize)(0,null,p)};k.isOpen||await new Promise(I=>{const T=this.onDidOpenTerminal(async j=>{j===k.value&&(T.dispose(),I())})});const P=this.g.get(p);P?P.startSendingEvents(E):this.j[p]={initialDimensions:E}}S(p,E){const k=new b.$Uc;k.add(E.onProcessReady(I=>this.a.$sendProcessReady(p,I.pid,I.cwd,I.windowsPty))),k.add(E.onDidChangeProperty(I=>this.a.$sendProcessProperty(p,I))),this.y.startBuffering(p,E.onProcessData),k.add(E.onProcessExit(I=>this.U(p,I))),this.g.set(p,E);const P=this.j[p];return P&&E instanceof u&&(E.startSendingEvents(P.initialDimensions),delete this.j[p]),k}$acceptProcessAckDataEvent(p,E){this.g.get(p)?.acknowledgeDataEvent(E)}$acceptProcessInput(p,E){this.g.get(p)?.input(E)}$acceptTerminalInteraction(p){const E=this.getTerminalById(p);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(p,E){this.getTerminalById(p)?.setSelection(E)}$acceptProcessResize(p,E,k){try{this.g.get(p)?.resize(E,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(p,E){this.g.get(p)?.shutdown(E)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(E=>this.a.$sendProcessProperty(p,{type:"cwd",value:E}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$WM(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,p.identifier.value),new $.$WM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(p,E,k){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,k),this.a.$registerQuickFixProvider(p,E),new $.$WM(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,E){const k=new m.$ne().token;if(k.isCancellationRequested)return;const P=this.D.get(p);if(!P)return;const I=await P.provideTerminalQuickFixes(E,k);if(I===null||Array.isArray(I)&&I.length===0)return;const T=new b.$Uc;if(this.w.value=T,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,T):void 0;const j=[];for(const z of I){const O=a.TerminalQuickFix.from(z,this.Q.converter,T);O&&j.push(O)}return j}async $createContributedProfileTerminal(p,E){const k=new m.$ne().token;let P=await this.C.get(p)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(p,E){const k=this.getTerminalById(p);if(!k)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const I=new m.$ne;this.G.set(p,I);const T=[],j={terminal:k.value,line:E},z=[];for(const B of this.z)z.push(g.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const Z=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:Z})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const F=new Map;for(const B of O)B&&B.links.length>0&&T.push(...B.links.map(W=>{const Z={id:o++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return F.set(Z.id,{provider:B.provider,link:W}),Z}));return this.F.set(p,F),T}$activateLink(p,E){const k=this.F.get(p)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(p,E){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const k=this.h[p];k&&(k.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,E)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const E=this.f.findIndex(k=>k.value===p);return E>=0?E:null}W(p,E){const k=this.X(p,E);return k!==null?p[k]:null}X(p,E){const k=p.findIndex(P=>P._id===E);return k>=0?k:null}getEnvironmentVariableCollection(p){let E=this.n.get(p.identifier.value);return E||(E=new h,this.Z(p.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(p,E){const k=(0,C.$hs)(E.map),P=(0,C.$is)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(p,E.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(p){p.forEach(E=>{const k=E[0],P=new h(E[1]);this.Z(k,P)})}$acceptDefaultProfile(p,E){const k=this.s;this.s=p,this.u=E,k?.path!==p.path&&this.N.fire(p.path)}Z(p,E){this.n.set(p,E),E.onDidChangeCollection(()=>{this.Y(p,E)})}};e.$rlc=t,e.$rlc=t=Je([Ve(1,i.$DP),Ve(2,R.$hP)],t);class h{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$ce,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const E=this.h(p);let k=this.a.get(E);return k||(k=new s(this,p),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(p,E,k,P){this.f(p,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(p,E,k,P){this.f(p,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(p,E,k,P){this.f(p,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(p,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(p,E.scope),P=this.map.get(k),I=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const T=this.g(p,E.scope),j={variable:p,...E,options:I};this.map.set(T,j),this.d.fire()}}get(p,E){const k=this.g(p,E),P=this.map.get(k);return P?f(P):void 0}g(p,E){const k=this.h(E);return k.length?`${p}:::${k}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const E=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(p)&&E.set(P.variable,f(P));return E}delete(p,E){const k=this.g(p,E);this.map.delete(k),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(E);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,E){const k=this.h(E),P=this.descriptionMap.get(k);if(!P||P.description!==p){let I;typeof p=="string"?I=p:I=p?.value.split(`

`)[0];const T={description:I,scope:E};this.descriptionMap.set(k,T),this.d.fire()}}getDescription(p){const E=this.h(p);return this.descriptionMap.get(E)?.description}k(p){const E=this.h(p);this.descriptionMap.delete(E)}}class s{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,E){this.b=p,this.d=E,this.a=new l.$ce}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,E,k){this.b.replace(p,E,k,this.d)}append(p,E,k){this.b.append(p,E,k,this.d)}prepend(p,E,k){this.b.prepend(p,E,k,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,E){this.b.getVariableMap(this.d).forEach((k,P)=>p.call(E,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(p,E){super(!1,p,E)}createTerminal(p,E,k){throw new N.$_}createTerminalFromOptions(p,E){throw new N.$_}};e.$slc=c,e.$slc=c=Je([Ve(0,i.$DP),Ve(1,R.$hP)],c);function r(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function v(D){return d.ThemeColor.isThemeColor(D)?D:void 0}function f(D){const p={...D};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[155],Se([1,0,7,3,5,6,20,43,4,2,8]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=void 0,e.$wmc=(0,L.$ti)("IExtHostTerminalShellIntegration");let C=class extends M.$Vc{constructor(g,a){super(),this.h=a,this.b=new Map,this.c=new $.$ce,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$ce,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$ce,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(A.$UM.MainThreadTerminalShellIntegration),this.B((0,M.$Tc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(g){const a=this.h.getTerminalById(g);if(!a)return;const i=a.value;let n=this.b.get(g);n||(n=new m(a.value,this.f),this.b.set(g,n),n.store.add(a.onWillDispose(()=>this.b.get(g)?.dispose())),n.store.add(n.onDidRequestShellExecution(u=>this.a.$executeCommand(g,u))),n.store.add(n.onDidRequestEndExecution(u=>this.g.fire(u))),n.store.add(n.onDidRequestChangeShellIntegration(u=>this.c.fire(u))),a.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(g,a,i,n,u){this.b.has(g)||this.$shellIntegrationChange(g);const o={value:a,confidence:i,isTrusted:n};this.b.get(g)?.startShellExecution(o,u)}$shellExecutionEnd(g,a,i,n,u){const o={value:a,confidence:i,isTrusted:n};this.b.get(g)?.endShellExecution(o,u)}$shellExecutionData(g,a){this.b.get(g)?.emitData(a)}$cwdChange(g,a){this.b.get(g)?.setCwd((0,S.$wc)(a)?S.URI.revive(a):a)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$xmc=C,e.$xmc=C=Je([Ve(0,R.$hP),Ve(1,b.$plc)],C);class m extends M.$Vc{get currentExecution(){return this.a}constructor(g,a){super(),this.j=g,this.m=a,this.b=!1,this.store=this.B(new M.$Uc),this.f=this.B(new $.$ce),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$ce),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$ce),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,u){let o=n;u&&(o+=` "${u.map(s=>`${s.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(o);const t={value:o,confidence:l.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},h=i.startShellExecution(t,i.c,!0).value;return i.b=!0,h}}}startShellExecution(g,a,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new y(g,a);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,a){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(g){let a=!1;S.URI.isUri(this.c)?a=!S.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(a=!0),a&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(g,a){this.c=g,this.cwd=a,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return N.$Th.EMPTY;this.a=new w}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends M.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new N.$sh);const g=this.a;return new N.$Th(async i=>{this.b.push(i),await g.wait()})}emitData(g){for(const a of this.b)a.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[353],Se([1,0,8,21,22,4,74,56,3,18,30,12,6,20,154,16,7,68,112,89]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=e.$zmc=e.$ymc=void 0;let u=class extends $.$Vc{constructor(I,T,j,z){super(),this.w=z,this.f=this.B(new A.$ce),this.g=new Map,this.s=this.B(new A.$ce),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(m.$UM.MainThreadTesting),this.m=new D(this.h),this.j=new s(this.h,T),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const F=O,B=F.tests[F.tests.length-1].item.extId;return this.g.get(a.$GL.root(B))?.collection.tree.get(B)?.actual??(0,w.$tP)(O)}case 18:{const{test:F,message:B}=O,W=F.item.extId;return{test:this.g.get(a.$GL.root(W))?.collection.tree.get(W)?.actual??(0,w.$tP)({$mid:16,tests:[F]}),message:d.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),F=B=>{const W=this.g.get(a.$GL.root(B));if(W)return a.$GL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(F).filter(S.$bg)||[],exclude:O?.exclude.map(F).filter(S.$bg)||[]}})}createTestController(I,T,j,z){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const O=new $.$Uc,F=O.add(new w.$wP(T,j,this.w));F.root.label=j;const B=new Map,W=new Set,Z=this.h,X={items:F.root.children,get label(){return j},set label(x){j=x,F.root.label=x,Z.$updateController(T,{label:j})},get refreshHandler(){return z},set refreshHandler(x){z=x,Z.$updateController(T,{canRefresh:!!x})},get id(){return T},createRunProfile:(x,ne,ge,ue,ve,te)=>{let U=(0,b.$hj)(x);for(;B.has(U);)U++;return new E(this.h,B,W,this.s.event,T,U,x,ne,ge,ue,ve,te)},createTestItem(x,ne,ge){return new w.$uP(T,x,ne,ge)},createTestRun:(x,ne,ge=!0)=>this.j.createTestRun(T,F,x,ne,ge),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(ge=>a.$GL.fromExtHostTestItem(ge,T).toString()))}},set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{O.dispose()}};Z.$registerTestController(T,j,!!z),O.add((0,$.$Tc)(()=>Z.$unregisterTestController(T)));const Y={controller:X,collection:F,profiles:B,extension:I,activeProfiles:W};return this.g.set(T,Y),O.add((0,$.$Tc)(()=>this.g.delete(T))),O.add(F.onDidGenerateDiff(x=>Z.$publishDiff(T,x.map(n.TestsDiffOp.serialize)))),X}createTestObserver(){return this.m.checkout()}async runTests(I,T=L.CancellationToken.None){const j=c(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>a.$GL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:k[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},T)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,T){return(await this.j.getCoverageDetails(I,T))?.map(d.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,T){this.g.get(I)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(I){const T=new Map;for(const[j,z]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const F=new Map,B=z.filter(Z=>!O.activeProfiles.has(Z)),W=[...O.activeProfiles].filter(Z=>!z.includes(Z));for(const Z of B)F.set(Z,!0),O.activeProfiles.add(Z);for(const Z of W)F.set(Z,!1),O.activeProfiles.delete(Z);F.size&&T.set(j,F)}this.s.fire(T)}async $refreshTests(I,T){await this.g.get(I)?.controller.refreshHandler?.(T)}$publishTestResults(I){this.results=Object.freeze(I.map(d.TestResults.to).concat(this.results).sort((T,j)=>j.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,T){const j=this.g.get(a.$GL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,T<0?1/0:T),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(T=>n.TestsDiffOp.deserialize({asCanonicalUri:j=>j},T)))}async $runControllerTests(I,T){return Promise.all(I.map(j=>this.y(j,!1,T)))}async $startContinuousRun(I,T){const j=new L.$ne(T),z=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!T.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>T.onCancellationRequested(O)),j.dispose(!0),z}async y(I,T,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:F}=z,B=F.get(I.profileId);if(!B)return{};const W=I.testIds.map(x=>O.tree.get(x)).filter(S.$bg),Z=I.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(S.$bg).filter(x=>W.some(ne=>ne.fullId.compare(x.fullId)===2));if(!W.length)return{};const X=new g.$wO(W.some(x=>x.actual instanceof w.$vP)?void 0:W.map(x=>x.actual),Z.map(x=>x.actual),B,T),Y=(0,n.$JL)(I)&&this.j.prepareForMainThreadTestRun(X,r.fromInternal(I,z.collection),B,j);try{return await B.runHandler(X,j),{}}catch(x){return{error:String(x)}}finally{Y&&Y.hasRunningTasks&&!j.isCancellationRequested&&await A.Event.toPromise(Y.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$ymc=u,e.$ymc=u=Je([Ve(0,y.$hP),Ve(1,C.$Zj)],u);const o=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class h extends $.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,T,j,z,O){super(),this.y=I,this.z=T,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$ce),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$ne(O));const F=this.B(new l.$Fh(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>F.schedule()));const B=new A.$ce;this.s=B.event,this.B((0,$.$Tc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,T){const[,j,z]=a.$GL.fromString(I).path,O=this.w.get(z);if(!O)return[];const F=this.g.get(j);if(!F)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(F.run,O,T)??[]}createRun(I){const T=this.y.id,j=this.y.controllerId,z=(0,N.$Pg)(),O=Z=>(X,...Y)=>{if(B){this.C.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}this.y.isIncluded(X)&&(this.H(X),Z(X,...Y))},F=(Z,X)=>{const Y=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(Z.uri&&Z.range){const x={range:d.Range.from(Z.range),uri:Z.uri};for(const ne of Y)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),Y)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:Z=>{const X=Z.uri.toString(),Y=new a.$GL([T,z,X]).toString();this.w.set(X,Z),this.z.$appendCoverage(T,z,d.TestCoverage.fromFile(Y,Z))},enqueued:O(Z=>{this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),1)}),skipped:O(Z=>{this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),5)}),started:O(Z=>{this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),2)}),errored:O((Z,X,Y)=>{F(Z,X),this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),6,Y)}),failed:O((Z,X,Y)=>{F(Z,X),this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,j).toString(),4,Y)}),passed:O((Z,X)=>{this.z.$updateTestStateInRun(T,z,a.$GL.fromExtHostTestItem(Z,this.y.controllerId).toString(),3,X)}),appendOutput:(Z,X,Y)=>{B||(Y&&(this.y.isIncluded(Y)?this.H(Y):Y=void 0),this.z.$appendOutputToRun(T,z,M.$De.fromString(Z),X&&d.location.from(X),Y&&a.$GL.fromExtHostTestItem(Y,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(T,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(T,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof w.$uP))throw new i.$_O(I.id);if(this.h.has(a.$GL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const T=[],j=this.y.colllection.root;for(;;){const z=d.TestItem.from(I);if(T.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,T)}dispose(){this.G(),super.dispose()}}class s{get trackers(){return this.c.values()}constructor(I,T){this.g=I,this.h=T,this.c=new Map,this.f=new Map}getCoverageDetails(I,T){const j=a.$GL.root(I);return this.f.get(j)?.getCoverageDetails(I,T)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[T,{id:j}]of this.c)j===I&&this.c.delete(T)}prepareForMainThreadTestRun(I,T,j,z){return this.j(I,T,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,T,j,z,O){const F=this.c.get(j);if(F)return F.createRun(z);const B=r.fromPublic(I,T,j,O),W=c(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:W&&{group:k[W.kind],id:W.profileId},exclude:j.exclude?.map(X=>a.$GL.fromExtHostTestItem(X,T.root.id).toString())??[],id:B.id,include:j.include?.map(X=>a.$GL.fromExtHostTestItem(X,T.root.id).toString())??[T.root.id],persist:O});const Z=this.j(j,B,j.profile);return A.Event.once(Z.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),Z.createRun(z)}j(I,T,j,z){const O=new h(T,this.g,this.h,j,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$zmc=s;const c=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class r{static fromPublic(I,T,j,z){return new r(I,(0,N.$Pg)(),j.include?.map(O=>a.$GL.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>a.$GL.fromExtHostTestItem(O,I).toString())??[],z,T)}static fromInternal(I,T){return new r(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,T)}constructor(I,T,j,z,O,F){this.controllerId=I,this.id=T,this.isPersisted=O,this.colllection=F,this.c=j.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const T=a.$GL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(T===j||T.startsWith(j))return!1;for(const j of this.c)if(T===j||T.startsWith(j))return!0;return!1}}e.$Amc=r;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,d.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const T=a.$GL.parentId(I.item.extId);if(T&&this.h.has(T.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:T,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...T].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends n.$PL{constructor(){super(...arguments),this.s=new A.$ce,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,T){return{...I,revived:d.TestItem.toPlain(I.item),depth:T?T.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(T=>T.revived)},dispose:(0,R.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new f({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const p=(P,I,T,j)=>{T?Object.assign(T,j):I.$updateTestRunConfig(P.controllerId,P.profileId,j)};class E{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,p(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,p(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),p(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,p(this,this.#e,this.#n,{tag:I?d.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,p(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return A.Event.chain(this.#i,I=>I.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(S.$bg))}constructor(I,T,j,z,O,F,B,W,Z,X=!1,Y=void 0,x=!1){this.controllerId=O,this.profileId=F,this.f=B,this.kind=W,this.runHandler=Z,this._tag=Y,this.g=x,this.#e=I,this.#s=T,this.#t=j,this.#i=z,T.set(F,this);const ne=k[W];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);X&&j.add(F),this.#n={profileId:F,controllerId:O,tag:Y?d.TestTag.namespace(this.controllerId,Y.id):null,label:B,group:ne,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bmc=E;const k={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ke[156],Se([1,0,62,13,124,16,7]),function(le,e,l,M,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=e.$oP=void 0;class b{static{this.c=new L.$mP("TextEditorDecorationType")}constructor(m,y,w){const d=b.c.nextId();m.$registerTextEditorDecorationType(y.identifier,d,A.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:d,dispose(){m.$removeTextEditorDecorationType(d)}})}}e.$oP=b;class ${constructor(m,y){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,y){this.k();let w=null;if(m instanceof R.$XM)w=new R.$YM(m,m);else if(m instanceof R.$YM)w=m;else throw new Error("Unrecognized location");this.l(w,y,!1)}insert(m,y){this.k(),this.l(new R.$YM(m,m),y,!0)}delete(m){this.k();let y=null;if(m instanceof R.$YM)y=m;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(m,y,w){const d=this.c.validateRange(m);this.g.push({range:d,text:y,forceMoveMarkers:w})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=m}}class S{constructor(m,y,w,d){this.c=m,this.d=y,this._accept(w),this.e=d;const g=this;this.value={get tabSize(){return g.f},set tabSize(a){g.n(a)},get indentSize(){return g.g},set indentSize(a){g.p(a)},get insertSpaces(){return g.j},set insertSpaces(a){g.s(a)},get cursorStyle(){return g.k},set cursorStyle(a){g.t(a)},get lineNumbers(){return g.l},set lineNumbers(a){g.u(a)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}n(m){const y=this.m(m);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}p(m){const y=this.o(m);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const y=this.q(m);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(m)})))}assign(m){const y={};let w=!1;if(typeof m.tabSize<"u"){const d=this.m(m.tabSize);d==="auto"?(w=!0,y.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,w=!0,y.tabSize=d)}if(typeof m.indentSize<"u"){const d=this.o(m.indentSize);d==="tabSize"?(w=!0,y.indentSize=d):typeof d=="number"&&this.h!==d&&(this.g=d,this.h=d,w=!0,y.indentSize=d)}if(typeof m.insertSpaces<"u"){const d=this.q(m.insertSpaces);d==="auto"?(w=!0,y.insertSpaces=d):this.j!==d&&(this.j=d,w=!0,y.insertSpaces=d)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,w=!0,y.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,w=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(m.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(m,y){y.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(w)})}}e.$pP=S;class N{constructor(m,y,w,d,g,a,i,n){this.id=m,this.j=y,this.k=w,this.g=!1,this.h=new Set,this.c=g,this.d=new S(this.j,this.id,a,w),this.e=i,this.f=n;const u=this;this.value=Object.freeze({get document(){return d.value},set document(o){throw new M.$9("document")},get selection(){return u.c&&u.c[0]},set selection(o){if(!(o instanceof R.$ZM))throw(0,M.$7)("selection");u.c=[o],u.l()},get selections(){return u.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof R.$ZM)))throw(0,M.$7)("selections");u.c=o,u.l()},get visibleRanges(){return u.e},set visibleRanges(o){throw new M.$9("visibleRanges")},get options(){return u.d.value},set options(o){u.g||u.d.assign(o)},get viewColumn(){return u.f},set viewColumn(o){throw new M.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new $(d.value,t);return o(h),u.m(h)},insertSnippet(o,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u.c.map(c=>A.Range.from(c));else if(t instanceof R.$XM){const{lineNumber:c,column:r}=A.Position.from(t);s=[{startLineNumber:c,startColumn:r,endLineNumber:c,endColumn:r}]}else if(t instanceof R.$YM)s=[A.Range.from(t)];else{s=[];for(const c of t)if(c instanceof R.$YM)s.push(A.Range.from(c));else{const{lineNumber:r,column:v}=A.Position.from(c);s.push({startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v})}}return y.$tryInsertSnippet(m,d.value.version,o.value,s,h)},setDecorations(o,t){const h=t.length===0;h&&!u.h.has(o.key)||(h?u.h.delete(o.key):u.h.add(o.key),u.n(()=>{if(A.$eP(t))return y.$trySetDecorations(m,o.key,A.$fP(t));{const s=new Array(4*t.length);for(let c=0,r=t.length;c<r;c++){const v=t[c];s[4*c]=v.start.line+1,s[4*c+1]=v.start.character+1,s[4*c+2]=v.end.line+1,s[4*c+3]=v.end.character+1}return y.$trySetDecorationsFast(m,o.key,s)}}))},revealRange(o,t){u.n(()=>y.$tryRevealRange(m,A.Range.from(o),t||R.TextEditorRevealType.Default))},show(o){y.$tryShowEditor(m,A.ViewColumn.from(o))},hide(){y.$tryHideEditor(m)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,l.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,l.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,l.ok)(!this.g),this.f=m}_acceptSelections(m){(0,l.ok)(!this.g),this.c=m}async l(){const m=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const y=m.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const w=y.edits.map(g=>g.range);w.sort((g,a)=>g.end.line===a.end.line?g.end.character===a.end.character?g.start.line===a.start.line?g.start.character-a.start.character:g.start.line-a.start.line:g.end.character-a.end.character:g.end.line-a.end.line);for(let g=0,a=w.length-1;g<a;g++){const i=w[g].end;if(w[g+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,d,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$qP=N}),define(ke[72],Se([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,39,46]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0;class a{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(u,o){this.h=u,this.i=o,this.a=null,this.b=new Map,this.c=new y.$Bc,this.d=new M.$ce,this.e=new M.$ce,this.f=new M.$ce,this.g=new M.$ce,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const o=[],t=[],h=[];if(u.removedDocuments)for(const s of u.removedDocuments){const c=A.URI.revive(s),r=this.c.get(c);r?.unref()&&(this.c.delete(c),o.push(r.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const c=A.URI.revive(s.uri);let r=this.c.get(c);if(r&&c.scheme!==w.Schemas.vscodeNotebookCell&&c.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);r||(r=new a(new $.$kP(this.h.getProxy(b.$UM.MainThreadDocuments),c,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty)),this.c.set(c,r),t.push(r.value)),r.ref()}if(u.removedEditors)for(const s of u.removedEditors){const c=this.b.get(s);this.b.delete(s),c&&h.push(c)}if(u.addedEditors)for(const s of u.addedEditors){const c=A.URI.revive(s.documentUri);l.ok(this.c.has(c),`document '${c}' does not exist`),l.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(c).value,v=new N.$qP(s.id,this.h.getProxy(b.$UM.MainThreadTextEditors),this.i,new g.$V(()=>r.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(f=>C.Range.to(f)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,v)}u.newActiveEditor!==void 0&&(l.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,L.$Qc)(o),(0,L.$Qc)(h),u.removedDocuments&&this.e.fire(o),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return d.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const o=this.b.get(this.a);return u?o:o?.value}allEditors(){return[...this.b.values()]}};e.$rP=i,e.$rP=i=Je([Ve(0,S.$hP),Ve(1,m.$Zj)],i),e.$sP=(0,R.$ti)("IExtHostDocumentsAndEditors")}),define(ke[354],Se([1,0,19,4,6,156,16,7]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class ${constructor(N,C){this.i=C,this.a=new M.$ce,this.b=new M.$ce,this.c=new M.$ce,this.d=new M.$ce,this.f=new M.$ce,this.g=new M.$ce,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(L.$UM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const C=this.i.allEditors();return N?C:C.map(m=>m.value)}async showTextDocument(N,C,m){let y;typeof C=="number"?y={position:R.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?y={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:y={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(N.uri,y),d=w&&this.i.getEditor(w);if(d)return d.value;throw w?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,C){return new A.$oP(this.h,N,C).value}$acceptEditorPropertiesChanged(N,C){const m=this.i.getEditor(N);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const y=C.selections.selections.map(R.Selection.to);m._acceptSelections(y)}if(C.visibleRanges){const y=l.$Hb(C.visibleRanges.map(R.Range.to));m._acceptVisibleRanges(y)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const y=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),w=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:m.value,selections:w,kind:y})}if(C.visibleRanges){const y=l.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:m.value,visibleRanges:y})}}$acceptEditorPositionData(N){for(const C in N){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const y=R.ViewColumn.to(N[C]);m.value.viewColumn!==y&&(m._acceptViewColumn(y),this.d.fire({textEditor:m.value,viewColumn:y}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$Ukc=$}),define(ke[355],Se([1,0,2,5,6,3,7,16,25,18]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=void 0,e.$Dmc=(0,M.$ti)("IExtHostTimeline");class N{constructor(y,w){this.b=new Map,this.c=new Map,this.a=y.getProxy(L.$UM.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(d,g)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&$.$Om.equals(g,this.b.get(d.source)?.extension)){const a=d.uri===void 0?void 0:l.URI.revive(d.uri);return this.c.get(d.source)?.get(C(a))?.get(d.handle)}else return;return d}})}async $getTimeline(y,w,d,g){return this.b.get(y)?.provider.provideTimeline(l.URI.revive(w),d,g)}registerTimelineProvider(y,w,d,g){const a=new A.$Uc,i=this.d(w.id,g,a).bind(this);let n;w.onDidChange&&(n=w.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:w.id}),this));const u=this.c;return this.f({...w,scheme:y,onDidChange:void 0,async provideTimeline(o,t,h){t?.resetCache&&(a.clear(),u.get(w.id)?.clear());const s=await w.provideTimeline(o,t,h);if(s==null)return;const c=i(o,t);return{...s,source:w.id,items:s.items.map(c)}},dispose(){for(const o of u.values())o.get(w.id)?.clear();n?.dispose(),a.dispose()}},d)}d(y,w,d){return(g,a)=>{let i;if(a?.cacheResults){let n=this.c.get(y);n===void 0&&(n=new Map,this.c.set(y,n));const u=C(g);i=n.get(u),i===void 0&&(i=new Map,n.set(u,i))}return n=>{const{iconPath:u,...o}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let h,s,c;n.iconPath&&(u instanceof R.$SN?c={id:u.id,color:u.color}:l.URI.isUri(u)?(h=u,s=u):{light:h,dark:s}=u);let r;return R.$lN.isMarkdownString(o.tooltip)?r=b.MarkdownString.from(o.tooltip):(0,S.$6f)(o.tooltip)?r=o.tooltip:R.$lN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=b.MarkdownString.from(o.detail)):(0,S.$6f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=o.detail),{...o,id:o.id??void 0,handle:t,source:y,command:n.command?w.toInternal(n.command,d):void 0,icon:h,iconDark:s,themeIcon:c,tooltip:r,accessibilityInformation:n.accessibilityInformation}}}}f(y,w){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:w}),(0,A.$Tc)(()=>{for(const g of this.c.values())g.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Emc=N;function C(m){return m?.toString()}}),define(ke[356],Se([1,0,227,23,2,4,3,288,8,7,18,19,16,80,22,184,26]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;function a(u,o){if((0,N.$6f)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class i extends R.$Vc{constructor(o,t,h){super(),this.f=o,this.g=t,this.h=h,this.a=new Map,this.b=new d.$x9;function s(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>s(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(r=>s(r)?this.r(r):r):c})}registerTreeDataProvider(o,t,h){const s=this.createTreeView(o,{treeDataProvider:t},h);return{dispose:()=>s.dispose()}}createTreeView(o,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,f=this.m(o,t,h),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:c,hasHandleDrag:r,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(o,D),E={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,g.$CG)(h,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,g.$CG)(h,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(k){(0,y.$Sk)(k)&&(0,g.$CG)(h,"treeViewMarkdownMessage"),f.message=k},get title(){return f.title},set title(k){f.title=k},get description(){return f.description},set description(k){f.description=k},get badge(){return f.badge},set badge(k){k!==void 0&&S.ViewBadge.isViewBadge(k)?f.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(f.badge=void 0)},reveal:(k,P)=>f.reveal(k,P),dispose:async()=>{await p,this.a.delete(o),f.dispose()}};return this.B(E),E}$getChildren(o,t){const h=this.a.get(o);return h?h.getChildren(t):Promise.reject(new b.$RF(o))}async $handleDrop(o,t,h,s,c,r,v,f){const D=this.a.get(o);if(!D)return Promise.reject(new b.$RF(o));const p=m.DataTransfer.toDataTransfer(h,async E=>(await this.f.$resolveDropFileData(o,t,E)).buffer);return v===o&&f&&await this.j(p,D,f,c,r),D.onDrop(p,s,c)}async j(o,t,h,s,c){const r=this.b.removeDragOperationTransfer(c);if(r)(await r)?.forEach((v,f)=>{v&&o.set(f,v)});else if(c&&t.handleDrag){const v=t.handleDrag(h,o,s);this.b.addDragOperationTransfer(c,v),await v}return o}async $handleDrag(o,t,h,s){const c=this.a.get(o);if(!c)return Promise.reject(new b.$RF(o));const r=await this.j(new S.$ON,c,t,s,h);if(!(!r||s.isCancellationRequested))return m.DataTransfer.from(r)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new b.$RF(o);return t.hasResolve}$resolve(o,t,h){const s=this.a.get(o);if(!s)throw new b.$RF(o);return s.resolveTreeItem(t,h)}$setExpanded(o,t,h){const s=this.a.get(o);if(!s)throw new b.$RF(o);s.setExpanded(t,h)}$setSelectionAndFocus(o,t,h){const s=this.a.get(o);if(!s)throw new b.$RF(o);s.setSelectionAndFocus(t,h)}$setVisible(o,t){const h=this.a.get(o);if(!h){if(!t)return;throw new b.$RF(o)}h.setVisible(t)}$changeCheckboxState(o,t){const h=this.a.get(o);if(!h)throw new b.$RF(o);h.setCheckboxState(t)}m(o,t,h){const s=this.B(new n(o,t,this.f,this.g.converter,this.h,h));return this.a.set(o,s),s}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$Fmc=i;class n extends R.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,N.$cg)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,h,s,c,r){if(super(),this.I=o,this.J=h,this.L=s,this.M=c,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$ce),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$ce),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$ce),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$ce),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$ce),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$ce),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$ce),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$ne,r.contributes&&r.contributes.views)for(const p in r.contributes.views)for(const E of r.contributes.views[p])E.id===o&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let v,f;const D=A.Event.debounce(this.F.event,(p,E)=>(p||(p={message:!1,elements:[]}),E.element!==!1&&(v||(v=new Promise(k=>f=k),this.G=this.G.then(()=>v)),Array.isArray(E.element)?p.elements.push(...E.element):p.elements.push(E.element)),E.message&&(p.message=!0),p),200,!0);this.B(D(({message:p,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=f;return v=null,this.$(E).then(()=>k())})),p&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let h=this.X(o);return h||(h=await this.Y(t)),h?h.map(s=>s.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const h=(0,N.$cg)(t.select)?!0:t.select,s=(0,N.$cg)(t.focus)?!1:t.focus,c=(0,N.$cg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(r=>this.W(o,r[r.length-1]).then(v=>this.J.$reveal(this.I,{item:v.item,parentChain:r.map(f=>f.item)},{select:h,focus:s,expand:c})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:h,focus:s,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=m.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const h=this.getExtensionElement(o);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(o,t){const h=!(0,C.$ub)(this.s,o);this.s=o;const s=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async h=>{const s=this.getExtensionElement(h.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:h.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(o,t,h){const s=[];for(const c of o){const r=this.getExtensionElement(c);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,h){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$lh)(()=>this.g?.handleDrop?this.g.handleDrop(s,o,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(o);if(h){const s=this.m.get(h);if(s){const c=await this.f.resolveTreeItem(s.extensionItem,h,t)??s.extensionItem;return this.hb(c),s.item.tooltip=this.eb(c.tooltip),s.item.command=this.fb(s.disposableStore,c.command),s.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(s=>(h.push(s),h))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$lh)(()=>this.f.getParent(o))}W(o,t){const h=this.m.get(o);return h?Promise.resolve(h):(0,$.$lh)(()=>this.f.getTreeItem(o)).then(s=>this.kb(o,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(s);if(c){const r=this.m.get(c);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const h=this.getExtensionElement(o);t=h?this.m.get(h):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new w.$ne(this.Z.token);try{const h=o?this.m.get(o):void 0,s=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,C.$Hb)(s||[]),r=await Promise.all((0,C.$Hb)(c).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const v=r.map((f,D)=>f?this.db(c[D],f,h):null);return(0,C.$Hb)(v)}finally{t.dispose()}}$(o){if(o.some(h=>!h))return this.Z.dispose(!0),this.Z=new w.$ne,this.tb(),this.J.$refresh(this.I);{const h=this.ab(o);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(o){const t=new Set,h=o.map(c=>this.m.get(c));for(const c of h)if(c&&!t.has(c.item.handle)){let r=c;for(;r&&r.parent&&h.findIndex(v=>r&&r.parent&&v&&v.item.handle===r.parent.item.handle)===-1;){const v=this.j.get(r.parent.item.handle);r=v?this.m.get(v):void 0}r&&!r.parent&&t.add(c.item.handle)}const s=[];return t.forEach(c=>{const r=this.j.get(c);if(r){const v=this.m.get(r);v&&(!v.parent||!t.has(v.parent.item.handle))&&s.push(c)}}),s}bb(o){const t={};return Promise.all(o.map(h=>this.cb(h).then(s=>{s&&(t[h]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,$.$lh)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const c=this.ib(t,s,h.parent);return this.pb(t,c,h,h.parent),h.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,h){const s=this.ib(o,t,h);if(t.id&&this.j.has(s.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(o,s),this.qb(s,h),s}eb(o){return S.$lN.isMarkdownString(o)?m.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,h,s;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,h=o.checkboxState.tooltip,s=o.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:s}}hb(o){if(!S.$JN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,h){this.hb(t);const s=this.B(new R.$Uc),c=this.kb(o,t,h),r=this.lb(t);return{item:{handle:c,parentHandle:h?h.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,N.$cg)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(o){return o.iconPath instanceof S.$SN?o.iconPath:void 0}kb(o,{id:t,label:h,resourceUri:s},c,r){if(t)return`${n.b}/${t}`;const v=a(h,this.N),f=c?c.item.handle:n.a;let D=v?v.label:s?(0,M.$4g)(s):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const p=this.m.has(o)?this.m.get(o).item.handle:void 0,E=this.X(c)||[];let k,P=0;do{if(k=`${f}/${P}:${D}`,r||!this.j.has(k)||p===k)break;P++}while(P<=E.length);return k}lb(o){if(o.iconPath&&!(o.iconPath instanceof S.$SN))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof S.$SN)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return L.URI.isUri(o)?o:L.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,h,s){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(o,t);const c=this.X(s)||[],r=c.filter(v=>v.item.handle===h.item.handle)[0];r&&c.splice(c.indexOf(r),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[357],Se([1,0,4,3,2,30,16,92,6,7]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class N extends M.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(w,d,g,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$ce),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$ce),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=d,this.#n=g,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,L.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:R.ViewColumn.from(w),preserveFocus:!!d})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends M.$Vc{static c(){return(0,A.$Pg)()}constructor(w,d,g){super(),this.j=d,this.m=g,this.g=new Map,this.h=new Map,this.f=w.getProxy($.$UM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,d,g,a,i={}){const n=typeof a=="object"?a.viewColumn:a,u={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.$0kc)(w),t=C.c();this.f.$createWebviewPanel((0,b.$_kc)(w),t,d,{title:g,panelOptions:m(i),webviewOptions:(0,b.$alc)(w,this.m,i),serializeBuffersForPostMessage:o},u);const h=this.j.createNewWebview(t,i,w);return this.createNewWebviewPanel(t,d,g,n,i,h,!0)}$onDidChangeWebviewPanelViewStates(w){const d=Object.keys(w);d.sort((g,a)=>{const i=w[g],n=w[a];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const g of d){const a=this.getWebviewPanel(g);if(!a)continue;const i=w[g];a._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,d,g){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:g,extension:w}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,b.$0kc)(w)}),new S.$WM(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(w,d,g,a){const i=this.h.get(d);if(!i)throw new Error(`No serializer found for '${d}'`);const{serializer:n,extension:u}=i,o=this.j.createNewWebview(w,g.webviewOptions,u),t=this.createNewWebviewPanel(w,d,g.title,a,g.panelOptions,o,g.active);await n.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(w,d,g,a,i,n,u){const o=new N(w,this.f,n,{viewType:d,title:g,viewColumn:a,panelOptions:i,active:u});return this.g.set(w,o),o}getWebviewPanel(w){return this.g.get(w)}}e.$blc=C;function m(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[358],Se([1,0,4,3,92,16,6,7]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class $ extends M.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,m,y,w,d,g){super(),this.#s=!1,this.#u=this.B(new l.$ce),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$ce),this.onDidDispose=this.#l.event,this.#i=y,this.#a=w,this.#e=C,this.#t=m,this.#n=d,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$UM.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,y,w){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:y,extension:C}),this.a.$registerWebviewViewProvider((0,L.$_kc)(C),m,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$0kc)(C)}),new b.$WM(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,y,w,d){const g=this.b.get(m);if(!g)throw new Error(`No view provider found for '${m}'`);const{provider:a,extension:i}=g,n=this.d.createNewWebview(C,{},i),u=new $(C,this.a,m,y,n,!0);this.c.set(C,u),await a.resolveWebviewView(u,{state:w},d)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$Imc=S}),define(ke[359],Se([1,0,69,15,12,259,33,11]),function(le,e,l,M,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(M.Schemas.file,new S(m),{isCaseSensitive:b.$k})}};e.$nnc=$,e.$nnc=$=Je([Ve(0,l.$6kc),Ve(1,L.$Zj)],$);class S{constructor(C){this.b=C,this.a=new A.$9q(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,y){return this.a.writeFile(C,m,{...y,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,y){return this.a.rename(C,m,y)}copy(C,m,y){return this.a.copy(C,m,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[360],Se([1,0,17,64,30,34,3,6,2,20]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;let N=class extends R.$Vc{constructor(m,y){super();const w=m.getProxy(b.$UM.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async d=>{const g=$.URI.file((0,l.$kc)((0,M.tmpdir)(),(0,L.$Pg)()));return await w.$download(d,g),g})}};e.$lnc=N,e.$lnc=N=Je([Ve(0,S.$hP),Ve(1,A.$DP)],N)}),define(ke[361],Se([1,0,52,17,2,93,3,15,8,32]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class N extends A.$8kc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==b.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const s=h.fsPath;let c=0;do{let r;c===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${c}`:`${s}-${c}`,await C(r);const v=M.$kc(r,"vscode.lock"),f=await d(this.d,v,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),L.URI.file(r);c++}while(c<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$xnc=N;async function C(o){try{await S.Promises.stat(o);return}catch{}try{await S.Promises.mkdir(o,{recursive:!0})}catch{}}const m=1e3,y=10*60*1e3;class w extends R.$Vc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new $.$Eh),this.a.cancelAndSet(async()=>{const s=await g(t,h);(!s||s.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(h,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${h}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function d(o,t,h){try{const c={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const s=await g(o,t);return!s||s.pid!==process.pid?h?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new w(o,t))}async function g(o,t){let h;try{h=await S.Promises.readFile(t)}catch(s){return o.error(s),null}try{return JSON.parse(String(h))}catch(s){return o.error(s),null}}async function a(o,t){let h;try{h=await S.Promises.stat(t)}catch(s){return o.error(s),0}return h.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function n(o,t){const h=await g(o,t);if(!h)return o.info(`Lock '${t}': Could not read pid of lock holder.`),u(o,t);if(h.willReleaseAt){let f=h.willReleaseAt-Date.now();if(f<5e3){for(f>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,$.$uh)(Math.min(100,f)),await a(o,t)===0)return u(o,t);f=h.willReleaseAt-Date.now()}return u(o,t)}}if(!i(h.pid))return o.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),u(o,t);const s=await a(o,t),c=Date.now()-s;if(c<=y)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$uh)(2e3);const r=await a(o,t),v=Date.now()-r;return v<=y?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),u(o,t))}async function u(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return d(o,t,!0)}}),define(ke[362],Se([1,0,30,20,43,34]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;let R=class extends L.$rlc{constructor($,S){super(!0,$,S)}createTerminal($,S,N){return this.createTerminalFromOptions({name:$,shellPath:S,shellArgs:N})}createTerminalFromOptions($,S){const N=new L.$qlc(this.a,(0,l.$Pg)(),$,$.name);return this.f.push(N),N.create($,this.R($,S)),N.value}};e.$Smc=R,e.$Smc=R=Je([Ve(0,A.$DP),Ve(1,M.$hP)],R)}),define(ke[363],Se([1,0,4,38,37,5]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.OutputChannelUpdateMode=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=void 0,e.$3L="text/x-code-output",e.$4L="output",e.$5L="Log",e.$6L="text/x-code-log-output",e.$7L="log",e.$8L="workbench.panel.output",e.$9L=new L.$Kj("inOutput",!1),e.$0L=new L.$Kj("activeLogOutput",!1),e.$$L=new L.$Kj("activeLogOutput.levelSettable",!1),e.$_L=new L.$Kj("activeLogOutput.level",""),e.$aM=new L.$Kj("activeLogOutput.levelIsDefault",!1),e.$bM=new L.$Kj("outputView.scrollLock",!1),e.$cM=(0,A.$ti)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$dM={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new l.$ce,this.onDidRegisterChannel=this.b.event,this.c=new l.$ce,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(N=>S.push(N)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}M.$_n.add(e.$dM.OutputChannels,new b),e.$eM=new L.$Kj("activeOutputChannel","")}),define(ke[157],Se([1,0,6,5,20,25,12,363,69,28,60,189,21,18,33,4,3]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$hmc=void 0;class a extends R.$6j{get disposed(){return this.n}constructor(o,t,h,s,c){super(),this.id=o,this.name=t,this.r=h,this.s=s,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=m.$De.fromString(t).byteLength,(0,R.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends a{appendLine(o){this.append(o)}}let n=class{constructor(o,t,h,s,c,r){this.i=t,this.j=h,this.k=s,this.l=c,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(l.$UM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(o,t,h){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,c=(0,y.$6f)(t)?t:void 0;if((0,y.$6f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const v=this.i.environment.extensionLogLevel?.find(([D])=>A.$Om.equals(h.identifier,D))?.[1];v&&(r=(0,R.$ek)(v));const f=s?this.o(o,r,h):this.n(o,c,h);return f.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),s?this.r(o,r??this.m.getLevel(),f):this.q(o,f)}async n(o,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,c=this.k.extUri.joinPath(s,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(o,c,t,h.identifier.value);return new a(v,o,r,this.a,h)}async o(o,t,h){const s=await this.p(h),c=o.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(s,`${c}.log`),v=`${h.identifier.value}.${c}`,f=this.l.createLogger(r,{id:v,name:o,logLevel:t,extensionId:h.identifier.value});return new i(v,o,f,this.a,h)}p(o){let t=this.d.get(o.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(s){if((0,w.$dl)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}return h})())}return t}q(o,t){let h=!1;const s=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return o},append(c){s(),t.then(r=>r.append(c))},appendLine(c){s(),t.then(r=>r.appendLine(c))},clear(){s(),t.then(c=>c.clear())},replace(c){s(),t.then(r=>r.replace(c))},show(c,r){s(),t.then(v=>v.show(c,r))},hide(){s(),t.then(c=>c.hide())},dispose(){h=!0,t.then(c=>c.dispose())}}}r(o,t,h){const s=new g.$Uc,c=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new d.$ce);function v(f){t=f,r.fire(f)}return h.then(f=>{s.add(f),f.logLevel!==t&&v(f.logLevel),s.add(f.onDidChangeLogLevel(D=>v(D)))}),{...this.q(o,h),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(f,...D){c(),h.then(p=>p.trace(f,...D))},debug(f,...D){c(),h.then(p=>p.debug(f,...D))},info(f,...D){c(),h.then(p=>p.info(f,...D))},warn(f,...D){c(),h.then(p=>p.warn(f,...D))},error(f,...D){c(),h.then(p=>p.error(f,...D))},dispose(){s.dispose()}}}};e.$hmc=n,e.$hmc=n=Je([Ve(0,L.$hP),Ve(1,S.$xP),Ve(2,$.$6kc),Ve(3,N.$Ikc),Ve(4,R.$1j),Ve(5,R.$Zj)],n),e.$imc=(0,M.$ti)("IExtHostOutputService")}),define(ke[158],Se([1,0,5,8]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=void 0,e.$dn=(0,l.$ti)("remoteAgentService"),e.$en=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await L.getRoundTripTime();if($===void 0)return;A=Math.min(A,$/2),await(0,M.$uh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[364],Se([1,0,231,85,38,42,54,3,4,158,11,24,8]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=void 0,e.$vJ=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$wJ=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$xJ=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$yJ=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$zJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new $.$ce,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const w=new y;L.$_n.add(e.$zJ.ConfigurationMigration,w);let d=class extends b.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const o of u.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(u=>this.g(u,i?.uri))])}async g(i,n){const u=this.a.inspect(i.key,{resource:n}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,h]of o){const s=u[t];if(!s)continue;const c=[];if(s.value!==void 0){const r=await this.h(i,t,s.value,n,void 0);for(const v of r??[])c.push([v,[]])}for(const{identifiers:r,value:v}of s.overrides??[])if(v!==void 0){const f=await this.h(i,t,v,n,r);for(const D of f??[])c.push([D,r])}c.length&&await Promise.allSettled(c.map(async([[r,v],f])=>this.a.updateValue(r,v.value,{resource:n,overrideIdentifiers:f},h)))}}async h(i,n,u,o,t){const h=c=>{const v=this.a.inspect(c,{resource:o})[n];if(v)return t?v.overrides?.find(({identifiers:f})=>(0,C.$4n)(f,t))?.value:v.value},s=await i.migrateFn(u,h);return Array.isArray(s)?s:[[i.key,s]]}};e.$AJ=d,e.$AJ=d=Je([Ve(0,R.$Zi),Ve(1,A.$Ci)],d);let g=class extends b.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new m.$Qh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$_n.as(M.$eo.Configuration).registerConfiguration({...e.$xJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$BJ=g,e.$BJ=g=Je([Ve(0,S.$dn)],g)}),define(ke[365],Se([1,0,35,15,17,23,241,364,85,5,38]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Sgb=e.$Rgb=void 0,e.$Tgb=d,e.$Ugb=g,e.$Rgb=(0,S.$ti)("editorResolverService"),e.$Sgb="workbench.editorAssociations";const C=N.$_n.as($.$eo.Configuration),m={...b.$wJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var y;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(y||(e.RegisteredEditorPriority=y={}));var w;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function d(a){switch(a){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function g(a,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.$hc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$4g)(i);return l.$mk(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[366],Se([1,0,31,15,17,11,23,2,5,277,42,147,158]),function(le,e,l,M,L,A,R,b,$,S,N,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0,e.$wM=(0,$.$ti)("pathService");let w=y=class{constructor(g,a,i,n){this.d=g,this.e=a,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??g})()}hasValidBasename(g,a,i){return typeof a=="string"||typeof a>"u"?this.a.then(n=>this.h(g,n,a)):this.h(g,a,i)}h(g,a,i){return g.scheme===M.Schemas.file||g.scheme===M.Schemas.vscodeRemote?(0,l.$qg)(i??(0,R.$4g)(g),a===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,a){if(g.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,S.$tM)(a.getWorkspace());if(i)return i;const n=a.getWorkspace().folders[0];if(n)return n.uri.scheme;const u=a.getWorkspace().configuration;return u?u.scheme:M.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?L.$gc:L.$hc)}async fileURI(g){let a="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const n=g.indexOf("/",2);n===-1?(a=g.substring(2),g="/"):(a=g.substring(2,n),g=g.substring(n)||"/")}return b.URI.from({scheme:M.Schemas.file,authority:a,path:g,query:"",fragment:""})}};e.$xM=w,e.$xM=w=y=Je([Ve(1,m.$dn),Ve(2,C.$fM),Ve(3,N.$Ci)],w)}),define(ke[367],Se([1,0,243,19,55,4,56,3,2,54,248,12,66,279,88,42,147,26,22,18,24,37]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.OnPortForward=e.$kM=e.$jM=e.TunnelSource=e.TunnelCloseReason=e.$hM=e.$gM=void 0,e.$iM=r,e.$lM=D,e.$mM=p,e.$nM=E,e.$oM=P;const t=10*1e3,h="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.$gM="onTunnel",e.$hM=new o.$Kj("forwardedPortsViewEnabled",!1,l.localize(0,null));function r(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var v;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(v||(e.TunnelCloseReason=v={}));var f;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$jM={source:f.User,description:l.localize(1,null)},e.$kM={source:f.Auto,description:l.localize(2,null)};function D(j,z,O){const F=j.get(E(z,O));if(F)return F;if((0,w.$dw)(z))for(const B of w.$cw){const W=E(B,O);if(j.has(W))return j.get(W)}else if((0,w.$fw)(z))for(const B of w.$ew){const W=E(B,O);if(j.has(W))return j.get(W)}}function p(j,z,O){const F=D(j,z,O);if(F)return F;const B=(0,w.$fw)(z)?"localhost":(0,w.$dw)(z)?"0.0.0.0":void 0;if(B)return D(j,B,O)}function E(j,z){return j+":"+z}var k;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(k||(e.OnPortForward=k={}));function P(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new A.$ce,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,F){let B=this.w(z,O,F,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Z=this.j[B];Z.key===z?(W.onAutoForward=Z.onAutoForward??W.onAutoForward,W.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:W.elevateIfNeeded,W.label=Z.label??W.label,W.requireLocalPort=Z.requireLocalPort,W.protocol=Z.protocol):(W.onAutoForward=W.onAutoForward??Z.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:Z.elevateIfNeeded,W.label=W.label??Z.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??Z.protocol),B=this.w(z,O,F,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$6f)(z.host)&&(0,n.$0f)(z.port)}w(z,O,F,B,W){if(W>=B.length)return-1;const Z=!(0,w.$dw)(O)&&!(0,w.$fw)(O),Y=B.slice(W).findIndex(x=>(0,n.$0f)(x.key)?Z?!1:x.key===z:this.t(x.key)?Z?!1:z>=x.key.start&&z<=x.key.end:this.u(x.key)?z===x.key.port&&O===x.key.host:F?x.key.test(F):!1);return Y>=0?Y+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,n.$8f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let Z;if(Number(B))Z=Number(B);else if((0,n.$6f)(B))if(I.g.test(B)){const X=B.match(I.g);Z={start:Number(X[1]),end:Number(X[2])}}else if(I.h.test(B)){const X=B.match(I.h);Z={host:X[1],port:Number(X[2])}}else{let X;try{X=RegExp(B)}catch{}X&&(Z=X)}Z&&O.push({key:Z,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const F=this.r.getValue(I.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(O)}z(z){function O(F,B){return(0,n.$0f)(F.key)?F.key:B.t(F.key)?F.key.start:B.u(F.key)?F.key.port:Number.MAX_VALUE}return z.sort((F,B)=>O(F,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case w.ProvidedOnAutoForward.Notify:return k.Notify;case w.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case w.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case w.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case w.ProvidedOnAutoForward.Silent:return k.Silent;case w.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(z,O,F){const W=this.r.inspect(I.c).userRemoteValue;let Z;!W||!(0,n.$8f)(W)?Z={}:Z=(0,u.$Zn)(W),Z[`${z}`]||(Z[`${z}`]={});for(const X in O)Z[`${z}`][X]=O[X];return this.r.updateValue(I.c,Z,F)}}e.$pM=I;let T=class extends b.$Vc{constructor(z,O,F,B,W,Z,X,Y,x,ne){super(),this.H=z,this.I=O,this.J=F,this.L=B,this.M=W,this.N=Z,this.O=X,this.P=Y,this.Q=x,this.R=ne,this.c=new Map,this.g=new A.$ce,this.onForwardPort=this.g.event,this.h=new A.$ce,this.onClosePort=this.h.event,this.j=new A.$ce,this.onPortName=this.j.event,this.n=new A.$ce,this.onCandidatesChanged=this.n.event,this.t=new A.$ce,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$ce,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(F),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ge=>{const ue=await this.getAttributes(ge.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of ge)if(ve.localAddress){const te=E(ve.tunnelRemoteHost,ve.tunnelRemotePort),U=p(this.m??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(te,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:ue?.get(ve.tunnelRemotePort)?.protocol??w.TunnelProtocol.Http,localUri:await this.X(ve.localAddress,ue?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ve.privacy,source:e.$jM}),this.f.set(te,ve)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ge=>{const ue=E(ge.tunnelRemoteHost,ge.tunnelRemotePort);if(!p(this.forwarded,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&!p(this.detected,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&!p(this.c,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&ge.localAddress){const ve=p(this.m??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort),te=(await this.getAttributes([{port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost}]))?.get(ge.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ge.tunnelRemoteHost,remotePort:ge.tunnelRemotePort,localAddress:ge.localAddress,protocol:te?.protocol??w.TunnelProtocol.Http,localUri:await this.X(ge.localAddress,te),localPort:ge.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:ge.privacy,source:e.$jM})}await this.cb(),this.f.set(ue,ge),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ge=>this.W(ge,v.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$gM))?(this.R.createKey(e.$hM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const F=E(z.host,z.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return $.URI.parse(z);const F=O?.protocol??"http";return $.URI.parse(`${F}://${z}`)}async Y(z){const O=this.N.getWorkspace(),F=O.configuration?(0,R.$hj)(O.configuration.path):O.folders.length>0?(0,R.$hj)(O.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${F}`}async Z(){return this.Y(h)}async $(){return this.Y(s)}async ab(){const z=this.I.get(h,1);if(z)return this.I.remove(h,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(F=>F.remotePort).join(", ")}`);for(const F of O){const B=p(this.detected,F.remoteHost,F.remotePort);F.source.source!==f.Extension&&!B||F.source.source===f.Extension&&B?await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,elevateIfNeeded:!0,source:F.source}):F.source.source===f.Extension&&!B&&this.D.set(E(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new b.$Uc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(s));for(const O of z){const F=this.I.getNumber(O,0);if(F&&F<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(s,h);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let F;z.length>0&&(F=JSON.stringify(O));const B=await this.Z(),W=await this.$();!F&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):F!==this.y&&B&&W&&(this.I.store(B,F,0,0),this.I.store(W,Date.now()+c,0,0)),this.y=F}}async eb(z,O,F){if(!z.tunnelLocalPort||!F?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=l.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$gM);const F=p(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(F)return this.hb(F,z,O);{const Z=this.L.remoteAuthority,X=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,Y=E(z.remote.host,z.remote.port);this.c.set(Y,!0),z=this.gb(Y,z);const x=await this.H.openTunnel(X,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof x=="string")W=x;else if(x&&x.localAddress){const ne=p(this.m??new Map,z.remote.host,z.remote.port),ge=x.protocol?x.protocol===w.TunnelProtocol.Https?w.TunnelProtocol.Https:w.TunnelProtocol.Http:O?.protocol??w.TunnelProtocol.Http,ue={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:x.localAddress,protocol:ge,localUri:await this.X(x.localAddress,O),runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,source:z.source??e.$jM,privacy:x.privacy};return this.forwarded.set(Y,ue),this.f.set(Y,x),this.c.delete(Y),await this.cb(),await this.eb(x,B,O),this.g.fire(ue),x}this.c.delete(Y)}return W}gb(z,O){const F=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(F){const B=F.get(z);F.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,F){const B=F?.label??O.name;let W;(function(X){X[X.None=0]="None",X[X.Fire=1]="Fire",X[X.Reopen=2]="Reopen"})(W||(W={}));let Z=W.None;switch(B!==z.name&&(z.name=B,Z=W.Fire),(F?.protocol||z.protocol!==w.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&(O.source=z.source,Z=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(Z=W.Reopen),Z){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,v.User),await this.fb(O,F)}return p(this.f,O.remote.host,O.remote.port)}async name(z,O,F){const B=p(this.forwarded,z,O),W=E(z,O);if(B){B.name=F,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=F,this.j.fire({host:z,port:O}))}async close(z,O,F){const B=E(z,O),W=this.forwarded.get(B);return F===v.AutoForwardEnd&&W&&W.source.source===f.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},F)}address(z,O){const F=E(z,O);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const F=p(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:E(O.localAddress.host,O.localAddress.port);this.detected.set(E(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:w.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:w.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,w.TunnelPrivacyId.ConstantPrivate,w.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const F=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(B=>B.port).join(", ")}`),this.n.fire(F)}ib(z){const O=this.m??new Map,F=new Map;return this.m=F,z.forEach(B=>{const W=E(B.host,B.port);F.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const Z=p(this.forwarded,B.host,B.port);Z&&(Z.runningProcess=B.detail,Z.hasRunningProcess=!0,Z.pid=B.pid)}),O.forEach((B,W)=>{const Z=r(W);if(!Z)return;const X=p(this.forwarded,Z.host,Z.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0);const Y=p(this.detected,Z.host,Z.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(O)for(const F of z){const B=O.get(F.remotePort);(B?.protocol||F.protocol!==w.TunnelProtocol.Http)&&B?.protocol!==F.protocol&&await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},B),B&&B.label&&B.label!==F.name&&await this.name(F.remoteHost,F.remotePort,B.label)}}async getAttributes(z,O=!0){const F=new Map,B=new Map;z.forEach(x=>{const ne=p(this.m??new Map,w.$cw[0],x.port)??x;if(ne){F.set(x.port,ne);const ge=P(ne)?ne.pid:void 0;B.has(ge)||B.set(ge,[]),B.get(ge)?.push(x.port)}});const W=new Map;if(z.forEach(x=>{const ne=this.configPortsAttributes.getAttributes(x.port,x.host,F.get(x.port)?.detail);ne&&W.set(x.port,ne)}),this.G.length===0||!O)return W.size>0?W:void 0;const Z=await Promise.all((0,M.$Rb)(this.G.map(x=>Array.from(B.entries()).map(ne=>{const ge=ne[1],ue=F.get(ge[0]);return x.providePortAttributes(ge,ue?.pid,ue?.detail,i.CancellationToken.None)})))),X=new Map;if(Z.forEach(x=>x.forEach(ne=>{ne&&X.set(ne.port,ne)})),!W&&!X)return;const Y=new Map;return z.forEach(x=>{const ne=W.get(x.port),ge=X.get(x.port);Y.set(x.port,{elevateIfNeeded:ne?.elevateIfNeeded,label:ne?.label,onAutoForward:ne?.onAutoForward??I.providedActionToAction(ge?.autoForwardAction),requireLocalPort:ne?.requireLocalPort,protocol:ne?.protocol})}),Y}addAttributesProvider(z){this.G.push(z)}};e.$qM=T,Je([(0,L.$Yh)(1e3)],T.prototype,"cb",null),e.$qM=T=Je([Ve(0,w.$0v),Ve(1,y.$Xp),Ve(2,S.$Zi),Ve(3,g.$fM),Ve(4,m.$El),Ve(5,d.$Ci),Ve(6,C.$Zj),Ve(7,N.$Cw),Ve(8,a.$yG),Ve(9,o.$Lj)],T)}),define(ke[94],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$3K=e.$2K=void 0;class l{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new l(0,0)}with(R){return new l(0,0)}}e.$2K=l;class M{constructor(R,b,$,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(R,b),this.end=new l($,S)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$3K=M;var L;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Se([1,0,19,35,24,31,14,5,17,13,94,8]),function(le,e,l,M,L,A,R,b,$,S,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$nL=e.$gL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$dL=e.$cL=e.$bL=e.$aL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TextSearchCompleteMessageType=void 0,e.$0K=a,e.$$K=i,e.$_K=n,e.$eL=f,e.$fL=D,e.$hL=k,e.$iL=P,e.$jL=I,e.$kL=T,e.$lL=j,e.$mL=z,e.$oL=F,e.$qL=Z,e.$rL=X,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$4K="workbench.view.search",e.$5K="workbench.panel.search",e.$6K="workbench.view.search",e.$7K="search-result",e.$8K="search.exclude";const m="\u27EA ",y=" characters skipped \u27EB",w=(m.length+y.length+5)*2;e.$9K=(0,b.$ti)("searchService");var d;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(d||(e.SearchProviderType=d={}));var g;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(g||(e.QueryType=g={}));function a(x){return!!x.preview}function i(x){return!!x.resource}function n(x){return!!x.message}var u;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class o{constructor(ne){this.resource=ne,this.results=[]}}e.$aL=o;class t{constructor(ne,ge,ue,ve){this.ranges=ge,this.webviewIndex=ve;const te=Array.isArray(ge)?ge:[ge];if(ue&&ue.matchLines===1&&h(te)){ne=(0,R.$Yf)(ne,ue.matchLines);let U="",_=0,pe=0;const Pe=Math.floor(ue.charsPerLine/5),se=[];for(const re of te){const oe=Math.max(re.startColumn-Pe,0),K=re.startColumn+ue.charsPerLine;if(oe>pe+Pe+w){const ie=m+(oe-pe)+y;U+=ie+ne.slice(oe,K),_+=oe-(pe+ie.length)}else U+=ne.slice(pe,K);se.push(new c(0,re.startColumn-_,re.endColumn-_)),pe=K}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ne,matches:(0,l.$2b)(ge,_=>new s(_.startLineNumber-U,_.startColumn,_.endLineNumber-U,_.endColumn))}}}}e.$bL=t;function h(x){const ne=x[0].startLineNumber;for(const ge of x)if(ge.startLineNumber!==ne||ge.endLineNumber!==ne)return!1;return!0}class s{constructor(ne,ge,ue,ve){this.startLineNumber=ne,this.startColumn=ge,this.endLineNumber=ue,this.endColumn=ve}}e.$cL=s;class c extends s{constructor(ne,ge,ue){super(ne,ge,ne,ue)}}e.$dL=c;var r;(function(x){x.List="list",x.Tree="tree"})(r||(e.ViewMode=r={}));var v;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function f(x,ne=!0){const ge=x&&x.files&&x.files.exclude,ue=ne&&x&&x.search&&x.search.exclude;if(!ge&&!ue)return;if(!ge||!ue)return ge||ue;let ve=Object.create(null);return ve=L.$3n(ve,L.$Zn(ge)),ve=L.$3n(ve,L.$Zn(ue),!0),ve}function D(x,ne){return x.excludePattern&&M.$mk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&M.$mk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(ge=>{const ue=ge.folder.fsPath;if(A.$sg(ne,ue)){const ve=$.$mc(ue,ne);return!ge.includePattern||!!M.$mk(ge.includePattern,ve)}else return!1}):!1:!0}var p;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class E extends Error{constructor(ne,ge){super(ne),this.code=ge}}e.$gL=E;function k(x){const ne=x.message;if((0,S.$4)(x))return new E(ne,p.canceled);try{const ge=JSON.parse(ne);return new E(ge.message,ge.code)}catch{return new E(ne,p.other)}}function P(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function I(x){return x.type==="error"?!0:x.type==="success"}function T(x){return x.type==="success"}function j(x){return!!x.path}function z(x,ne,ge=!0){const ue=x.searchPath?x.searchPath:x.relativePath;return ge?(0,R.$Vf)(ue,ne):M.$mk(ne,ue)}class O{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$nL=O;function F(x,ne){const ge={...x||{},...ne||{}};return Object.keys(ge).filter(ue=>{const ve=ge[ue];return typeof ve=="boolean"&&ve})}class B{constructor(ne,ge){this.c=null,this.a={...ne.excludePattern||{},...ge.excludePattern||{}},this.b=M.$nk(this.a);let ue=ne.includePattern;ge.includePattern&&(ue?ue={...ue,...ge.includePattern}:ue=ge.includePattern),ue&&(this.c=M.$nk(ue))}matchesExcludesSync(ne,ge,ue){return!!(this.b&&this.b(ne,ge,ue))}includedInQuerySync(ne,ge,ue){return!(this.b&&this.b(ne,ge,ue)||this.c&&!this.c(ne,ge,ue))}includedInQuery(ne,ge,ue){const ve=this.b(ne,ge,ue),te=()=>this.c?!!this.c(ne,ge,ue):!0;return(0,C.$fh)(ve)?ve.then(U=>U?!1:te()):te()}hasSiblingExcludeClauses(){return W(this.a)}}e.$pL=B;function W(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function Z(x){if(!x)return;let ne;return ge=>(ne||(ne=(x()||Promise.resolve([])).then(ue=>ue?Y(ue):{})),ne.then(ue=>!!ue[ge]))}function X(x){if(!x)return;let ne;return ge=>{if(!ne){const ue=x();ne=ue?Y(ue):{}}return!!ne[ge]}}function Y(x){const ne={};for(const ge of x)ne[ge]=!0;return ne}}),define(ke[44],Se([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,262,42,60,28,20,16,7,67,36,6,58]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Zkc=void 0;function v(T,j,z){return new N.$Vg(O=>E(O,z)).isEqual(T,j)}function f(T,j,z){return v(T.uri,j.uri,z)?0:(0,C.$of)(T.uri.toString(),j.uri.toString())}function D(T,j,z){return T.index!==j.index?T.index<j.index?-1:1:v(T.uri,j.uri,z)?(0,C.$of)(T.name,j.name):(0,C.$of)(T.uri.toString(),j.uri.toString())}function p(T,j,z,O){const F=T.slice(0).sort((W,Z)=>z(W,Z,O)),B=j.slice(0).sort((W,Z)=>z(W,Z,O));return(0,l.$Eb)(F,B,(W,Z)=>z(W,Z,O))}function E(T,j){const z=j.getCapabilities(T.scheme);return!(z&&z&1024)}class k extends a.$Mi{static toExtHostWorkspace(j,z,O,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Z,configuration:X,transient:Y,isUntitled:x}=j,ne=[],ge=z;z?Z.forEach((U,_)=>{const pe=m.URI.revive(U.uri),Pe=k.o(O||z,pe,F);Pe?(Pe.name=U.name,Pe.index=U.index,ne.push(Pe)):ne.push({uri:pe,name:U.name,index:_})}):ne.push(...Z.map(({uri:U,name:_,index:pe})=>({uri:m.URI.revive(U),name:_,index:pe}))),ne.sort((U,_)=>U.index<_.index?-1:1);const ue=new k(B,W,ne,!!Y,X?m.URI.revive(X):null,!!x,U=>E(U,F)),{added:ve,removed:te}=p(ge?ge.workspaceFolders:[],ue.workspaceFolders,f,F);return{workspace:ue,added:ve,removed:te}}static o(j,z,O){for(let F=0;F<j.folders.length;F++){const B=j.workspaceFolders[F];if(v(B.uri,z,O))return B}}constructor(j,z,O,F,B,W,Z){super(j,O.map(X=>new a.$Ni(X)),F,B,Z),this.t=z,this.u=W,this.q=[],this.s=b.$zi.forUris(Z),O.forEach(X=>{this.q.push(X),this.s.set(X.uri,X)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,N.$6g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let P=class{constructor(j,z,O,F,B){this.c=new A.$ce,this.onDidChangeWorkspace=this.c.event,this.g=new A.$ce,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$ee,this.C=new Map,this.h=F,this.s=O,this.t=B,this.j=new S.$Am,this.k=new M.$sh,this.o=j.getProxy(c.$UM.MainThreadWorkspace),this.q=j.getProxy(c.$UM.MainThreadMessageService);const W=z.workspace;this.l=W?new k(W.id,W.name,[],!!W.transient,W.configuration?m.URI.revive(W.configuration):null,!!W.isUntitled,Z=>E(Z,O)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,N.$4g)((0,N.$6g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,O,...F){const B=[];if(Array.isArray(F)&&F.forEach(x=>{m.URI.isUri(x.uri)&&!B.some(ne=>v(ne.uri,x.uri,this.s))&&B.push({uri:x.uri,name:x.name||(0,N.$3g)(x.uri)})}),this.n||[z,O].some(x=>typeof x!="number"||x<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const Z=W.slice(0);Z.splice(z,O,...B.map(x=>({uri:x.uri,name:x.name||(0,N.$3g)(x.uri),index:void 0})));for(let x=0;x<Z.length;x++){const ne=Z[x];if(Z.some((ge,ue)=>ue!==x&&v(ne.uri,ge.uri,this.s)))return!1}Z.forEach((x,ne)=>x.index=ne);const{added:X,removed:Y}=p(W,Z,D,this.s);if(X.length===0&&Y.length===0)return!1;if(this.o){const x=j.displayName||j.name;this.o.$updateWorkspaceFolders(x,z,O,B).then(void 0,ne=>{this.n=void 0;const ge={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(g.Severity.Error,(0,y.localize)(0,null,x,ne.toString()),ge,[])})}return this.y(Z),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let O,F="";if(typeof j=="string"?(O=m.URI.file(j),F=j):typeof j<"u"&&(O=j,F=j.fsPath),!O)return F;const B=this.getWorkspaceFolder(O,!0);if(!B)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,N.$9g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(j){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:O,removed:F}=k.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:F}))}findFiles(j,z,O,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let W="",Z=!0;return z===null?Z=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(j,void 0,{exclude:W,maxResults:O,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},O,F=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,z,F)}async z(j,z,O,F=L.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let Z;if(j){const{includePattern:X,folder:Y}=I(o.GlobPattern.from(j));Z=Y,W.includePattern=X}else{const{includePattern:X,folder:Y}=I(o.GlobPattern.from(z));Z=Y,W.filePattern=X}return this.o.$startFileSearch(Z??null,W,F).then(X=>Array.isArray(X)?X.map(Y=>m.URI.revive(Y)):[])}async findTextInFiles(j,z,O,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),Z=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:X,folder:Y}=I(o.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:Z,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:X,excludePattern:x},ge=!1;if(this.u[W]=ue=>{if(ge)return;const ve=m.URI.revive(ue.resource);ue.results.forEach(te=>{const U=(0,r.$3h)(te);(0,s.$0K)(U)?O({uri:ve,preview:{text:U.preview.text,matches:(0,l.$2b)(U.preview.matches,_=>new t.$YM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,l.$2b)(U.ranges,_=>new t.$YM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):O({uri:ve,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(j,Y??null,ne,W,B);return delete this.u[W],ue||{}}catch(ue){throw delete this.u[W],ue}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return m.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return m.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const O=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,O),(0,R.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const F=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!F),!F)return;const B=await F.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,O,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Z=await W.provideEditSessionIdentityMatch?.(z,O,F);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(j){return(z,O,F)=>{const B=function(Z){z.call(O,Z)};return B.extension=j,this.B.event(B,void 0,F)}}async $onWillCreateEditSessionIdentity(j,z,O){const F=await this.resolveWorkspaceFolder(m.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},z,async(B,W)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const O=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,O),(0,R.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,z,O){const F=this.C.get(j.scheme);if(!F)return;const B=await F.provideCanonicalUri?.(m.URI.revive(j),z,O);if(B)return B}async $provideCanonicalUri(j,z,O){return this.provideCanonicalUri(m.URI.revive(j),{targetScheme:z},O)}};e.$Zkc=P,e.$Zkc=P=Je([Ve(0,u.$hP),Ve(1,n.$xP),Ve(2,i.$Ikc),Ve(3,d.$Zj),Ve(4,h.$Xkc)],P),e.$1kc=(0,w.$ti)("IExtHostWorkspace");function I(T){let j,z;return T&&(typeof T=="string"?j=T:(j=T.pattern,z=m.URI.revive(T.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],Se([1,0,24,4,44,6,7,264,85,18,8,5,20,12,2]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=e.$2kc=void 0;function d(h,s){if(s){const c=s.split(".");let r=h;for(let v=0;r&&v<c.length;v++)r=r[c[v]];return r}}function g(h){return h instanceof w.URI}function a(h){return h&&h.uri instanceof w.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&h.uri instanceof w.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function u(h){if(g(h))return{resource:h};if(a(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(n(h))return{resource:h.uri};if(h===null)return{resource:null}}let o=class{constructor(s,c,r){this.a=s.getProxy(A.$UM.MainThreadConfiguration),this.c=c,this.b=r,this.d=new N.$sh,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,c){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,c))}};e.$2kc=o,e.$2kc=o=Je([Ve(0,m.$hP),Ve(1,L.$1kc),Ve(2,y.$Zj)],o);class t{constructor(s,c,r,v){this.a=new M.$ce,this.b=s,this.f=v,this.c=c,this.e=b.$xo.parse(r,v),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,c){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$xo.parse(s,this.f),this.d=this.k(s.configurationScopes),this.a.fire(this.j(c,r))}getConfiguration(s,c,r){const v=u(c)||{},f=this.g(s?d(this.e.getValue(void 0,v,this.c.workspace),s):this.e.getValue(void 0,v,this.c.workspace));s&&this.h(s,v,r?.identifier);function D(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(E){return typeof d(f,E)<"u"},get:(E,k)=>{this.h(s?`${s}.${E}`:E,v,r?.identifier);let P=d(f,E);if(typeof P>"u")P=k;else{let I;const T=(j,z)=>{if((0,S.$8f)(j)){let O;const F=()=>{I=I||(0,l.$Zn)(f),O=O||d(I,z)};return new Proxy(j,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return F(),()=>O;if(I)return O=O||d(I,z),O[W];const Z=B[W];return typeof W=="string"?T(Z,`${z}.${W}`):Z},set:(B,W,Z)=>(F(),O&&(O[W]=Z),!0),deleteProperty:(B,W)=>(F(),O&&delete O[W],!0),defineProperty:(B,W,Z)=>(F(),O&&Object.defineProperty(O,W,Z),!0)})}return Array.isArray(j)?(0,l.$Zn)(j):j};P=T(P,E)}return P},update:(E,k,P,I)=>{E=s?`${s}.${E}`:E;const T=D(P);return k!==void 0?this.b.$updateConfigurationOption(T,E,k,v,I):this.b.$removeConfigurationOption(T,E,v,I)},inspect:E=>{E=s?`${s}.${E}`:E;const k=this.e.inspect(E,v,this.c.workspace);if(k)return{key:E,defaultValue:(0,l.$Zn)(k.policy?.value??k.default?.value),globalValue:(0,l.$Zn)(k.user?.value??k.application?.value),workspaceValue:(0,l.$Zn)(k.workspace?.value),workspaceFolderValue:(0,l.$Zn)(k.workspaceFolder?.value),defaultLanguageValue:(0,l.$Zn)(k.default?.override),globalLanguageValue:(0,l.$Zn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,l.$Zn)(k.workspace?.override),workspaceFolderLanguageValue:(0,l.$Zn)(k.workspaceFolder?.override),languageIds:(0,l.$Zn)(k.overrideIdentifiers)}}};return typeof f=="object"&&(0,l.$3n)(p,f,!1),Object.freeze(p)}g(s){const c=r=>(0,S.$8f)(r)?new Proxy(r,{get:(v,f)=>c(v[f]),set:(v,f,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(v,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(v,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return c(s)}h(s,c,r){const v=$.$oo.test(s)?4:this.d.get(s),f=r?`[${r.value}] `:"";if(v===4){typeof c?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){c?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,c){const r=new b.$zo(s,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(v,f)=>r.affectsConfiguration(v,u(f))})}k(s){return s.reduce((c,r)=>(c.set(r[0],r[1]),c),new Map)}}e.$3kc=t,e.$4kc=(0,C.$ti)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,8,4,6,7,44,72,45,22,43,20,28,5,15,11,12,91,308,13]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=e.$tmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(o||(o={}));var t;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(t||(t={}));var h;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(h||(h={}));var s;(function(T){function j(F){if(F){const B=F;return B&&!!B.process}else return!1}T.is=j;function z(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=h.from(F.options)),B}T.from=z;function O(F){if(F!=null)return new R.$FN(F.process,F.args,F.options)}T.to=O})(s||(s={}));var c;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(c||(c={}));var r;(function(T){function j(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}T.is=j;function z(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=c.from(F.options)),B}T.from=z;function O(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$GN(F.commandLine,F.options):new R.$GN(F.command,F.args?F.args:[],F.options)}T.to=O})(r||(r={}));var v;(function(T){function j(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}T.is=j;function z(F){return{customExecution:"customExecution"}}T.from=z;function O(F,B){return B.get(F)}T.to=O})(v||(e.CustomExecutionDTO=v={}));var f;(function(T){function j(z,O){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?F=O.workspaceFile:F=n.$1H),{id:z._id,workspaceFolder:F}}T.from=j})(f||(e.TaskHandleDTO=f={}));var D;(function(T){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}T.from=j})(D||(D={}));var p;(function(T){function j(F,B){if(F==null)return[];const W=[];for(const Z of F){const X=z(Z,B);X&&W.push(X)}return W}T.fromMany=j;function z(F,B){if(F==null)return;let W;F.execution instanceof R.$FN?W=s.from(F.execution):F.execution instanceof R.$GN?W=r.from(F.execution):F.execution&&F.execution instanceof R.$HN&&(W=v.from(F.execution));const Z=o.from(F.definition);let X;return F.scope?typeof F.scope=="number"?X=F.scope:X=F.scope.uri:X=R.TaskScope.Workspace,!Z||!X?void 0:{_id:F._id,definition:Z,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:X},execution:W,isBackground:F.isBackground,group:D.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}T.from=z;async function O(F,B,W){if(F==null)return;let Z;s.is(F.execution)?Z=s.to(F.execution):r.is(F.execution)?Z=r.to(F.execution):v.is(F.execution)&&(Z=v.to(F._id,W));const X=o.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await B.resolveWorkspaceFolder(l.URI.revive(F.source.scope)):Y=R.TaskScope.Workspace),!X||!Y)return;const x=new R.$IN(X,Y,F.name,F.source.label,Z,F.problemMatchers);return F.isBackground!==void 0&&(x.isBackground=F.isBackground),F.group!==void 0&&(x.group=R.$EN.from(F.group._id),x.group&&F.group.isDefault&&(x.group=new R.$EN(x.group.id,x.group.label),F.group.isDefault===!0&&(x.group.isDefault=F.group.isDefault))),F.presentationOptions&&(x.presentationOptions=t.to(F.presentationOptions)),F._id&&(x._id=F._id),F.detail&&(x.detail=F.detail),x}T.to=O})(p||(e.TaskDTO=p={}));var E;(function(T){function j(O){return O}T.from=j;function z(O){if(O)return Object.assign(Object.create(null),O)}T.to=z})(E||(E={}));class k{#e;constructor(j,z,O){this._id=z,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let P=class{constructor(j,z,O,F,B,W,Z,X){this.q=new L.$ce,this.r=new L.$ce,this.s=new L.$ce,this.u=new L.$ce,this.a=j.getProxy(A.$UM.MainThreadTask),this.b=O,this.c=F,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,O){if(!O)return new R.$WM(()=>{});const F=this.x();return this.j.set(F,{type:z,provider:O,extension:j}),this.a.$registerTaskProvider(F,z),new R.$WM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(E.from(j)).then(async z=>{const O=[];for(const F of z){const B=await p.to(F,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,O){const F=this.m.get(j.id);F&&(this.o.set(j.id,F),this.e.attachPtyToTerminal(z,await F.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const F=[],B=(0,M.$lh)(()=>O.provider.provideTasks(N.CancellationToken.None)).then(W=>this.v(z,F,O,W));return new Promise(W=>{B.then(Z=>{Promise.all(F).then(()=>{W(Z)})})})}async $resolveTask(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const F=await p.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(F,N.CancellationToken.None);if(!B)return;this.A(B,O);const W=p.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(j,z,O){const F=await this.a.$createTaskId(j);!O&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new u.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let F;return z?F=Promise.resolve(new k(this,j.id,z)):F=p.to(j.task,this.b,this.m).then(B=>{if(!B)throw new u.$bb("Unexpected: Task does not exist.");return new k(this,j.id,B)}),this.l.set(j.id,F),F.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let F=O.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=O.next()}};e.$tmc=P,e.$tmc=P=Je([Ve(0,m.$hP),Ve(1,y.$xP),Ve(2,b.$1kc),Ve(3,$.$sP),Ve(4,S.$4kc),Ve(5,C.$plc),Ve(6,a.$Zj),Ve(7,i.$Ekc)],P);let I=class extends P{constructor(j,z,O,F,B,W,Z,X){super(j,z,O,F,B,W,Z,X),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=p.from(z,j);if(O===void 0)throw new Error("Task is not valid");if(v.is(O.execution))await this.y(O,z,!1);else throw new u.$_;const F=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),F}v(j,z,O,F){const B=[];if(F)for(const W of F){if(this.A(W,O),!W.definition||!j[W.definition.type]){const X=W.source?W.source:"No task source";this.f.warn(`The task [${X}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=p.from(W,O.extension);Z&&v.is(Z.execution)?(B.push(Z),z.push(this.y(Z,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(v.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,O){}};e.$umc=I,e.$umc=I=Je([Ve(0,m.$hP),Ve(1,y.$xP),Ve(2,b.$1kc),Ve(3,$.$sP),Ve(4,S.$4kc),Ve(5,C.$plc),Ve(6,a.$Zj),Ve(7,i.$Ekc)],I),e.$vmc=(0,w.$ti)("IExtHostTask")}),define(ke[368],Se([1,0,36,29]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=void 0,e.$xL=L,e.$zL=A;function L(R){return"cellResults"in R}e.$yL="rawCell#";function A(R,b){let $=-1;const S=[];let N=[];return R.forEach(m=>{m.range.startLineNumber!==$&&N.length>0&&(S.push([...N]),N=[]),N.push(m),$=m.range.endLineNumber}),N.length>0&&S.push([...N]),S.map(m=>{const y=[],w=m[0].range.startLineNumber,d=m[m.length-1].range.endLineNumber;for(let g=w;g<=d;g++)y.push(b.getLineContent(g));return new l.$bL(y.join(`
`)+`
`,m.map(g=>new M.$pt(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ke[369],Se([1,0,223,21,4,3,27,14,18,2,33,111,6,34,16,7,48,339,153,24,15,298,368,365]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,v,f,D,p,E){this.q=f,this.r=D,this.s=p,this.t=E,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new L.$ce,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$ce,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$ce,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$ce,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Ckc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=r.getProxy(m.$UM.MainThreadNotebook),this.c=r.getProxy(m.$UM.MainThreadNotebookDocuments),this.d=r.getProxy(m.$UM.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,I=k.cell.handle,j=this.g.get(P)?.getCell(I);if(j)return j.apiCell}if(k&&k.$mid===14){const P=k.uri,I=this.g.get(P);if(I)return I.apiNotebook}return k}}),s.B(v)}getEditorById(r){const v=this.h.get(r);if(!v)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(r){for(const[v,f]of this.h)if(f.apiEditor===r)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,v){const f=this.g.get(r);if(!f&&!v)throw new Error(`NO notebook document for '${r}'`);return f}static u(r,v){if(!v)return;const f=v.filenamePattern.map(D=>w.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(v.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:v.displayName,filenamePattern:f,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,v,f){const D=s.a++,p=typeof f.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(D,f),this.b.$registerNotebookCellStatusBarItemProvider(D,p,v);let E;return p!==void 0&&(E=f.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(p))),new d.$WM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,p),E?.dispose()})}async createNotebookDocument(r){const v=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&w.NotebookData.from(r.content)});return S.URI.revive(v)}async openNotebookDocument(r){const v=this.g.get(r);if(v)return v.apiNotebook;const f=await this.c.$tryOpenNotebook(r),D=this.g.get(S.URI.revive(f));return(0,$.$eg)(D?.apiNotebook)}async showNotebookDocument(r,v){S.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let f;typeof v=="object"?f={position:w.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(w.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:f={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,f),p=D&&this.h.get(D)?.apiEditor;if(p)return p;throw D?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,v,f,D){const p=this.f.get(r),E=S.URI.revive(v),k=this.g.get(E);if(!k||!p)return;const P=k.getCellFromIndex(f);if(!P)return;const I=await p.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const T=new A.$Uc,j=this.p.add([T]),O=(Array.isArray(I)?I:[I]).map(F=>w.NotebookStatusBarItem.from(F,this.i,T));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,v,f,D,p){if((0,b.$5e)(v))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:v,serializer:f,options:D}),this.b.$registerNotebookSerializer(E,{id:r.identifier,location:r.extensionLocation},v,w.NotebookDocumentContentOptions.from(D),s.u(r,p)),(0,A.$Tc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(r,v,f){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.deserializeNotebook(v.buffer,f);return new g.$qw(w.NotebookData.from(p))}async $notebookToData(r,v,f){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.serializeNotebook(w.NotebookData.to(v.value),f);return M.$De.wrap(p)}async $saveNotebook(r,v,f,D,p){const E=S.URI.revive(v),k=this.x.get(r);if(!k)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new N.$il((0,l.localize)(0,null,this.z(E)),6);await this.y(E,D);const I={metadata:(0,n.$8n)(P.apiNotebook.metadata,F=>!(k.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of P.apiNotebook.getCells()){const B=new d.$mO(F.kind,F.document.getText(),F.document.languageId,F.mime,k.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);B.metadata=(0,n.$8n)(F.metadata,W=>!(k.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const T=await k.serializer.serializeNotebook(I,p);await this.s.value.writeFile(E,T);const j=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:j.basename(E),isFile:(z.type&N.FileType.File)!==0,isDirectory:(z.type&N.FileType.Directory)!==0,isSymbolicLink:(z.type&N.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&N.FilePermission.Locked),etag:N.$tl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(r,v,f,D,p){const E=this.x.get(r)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new R.$Cc;await(async(z,O,F)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const Z={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(Z,O,X=>{X.forEach(Y=>{k.has(Y)||D.some(ne=>B.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ge=>(0,h.$Ugb)(ge,Y)))||k.add(Y)})}).catch(X=>{if(X.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw X})}))))})(f,p,v);const I=new R.$Bc;let T=!1;const j=Array.from(k).map(async z=>{const O=[];try{if(p.isCancellationRequested)return;if(v.maxResults&&[...I.values()].reduce((Z,X)=>Z+X.cellResults.length,0)>v.maxResults){T=!0;return}const F=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(X=>F.push({input:X.document.getText(),outputs:X.outputs.flatMap(Y=>Y.items.map(x=>x.data.toString()))}));else{const Z=await this.s.value.readFile(z),X=M.$De.fromString(Z.toString()),Y=await E.deserializeNotebook(X.buffer,p);if(p.isCancellationRequested)return;w.NotebookData.from(Y).cells.forEach(ne=>F.push({input:ne.source,outputs:ne.outputs.flatMap(ge=>ge.items.map(ue=>ue.valueBytes.toString()))}))}if(p.isCancellationRequested)return;F.forEach((Z,X)=>{const Y=v.contentPattern.pattern,x=new o.$MWb(Z.input,void 0,Z.outputs),ne=x.findInInputs(Y),ge=x.findInOutputs(Y),ue=ge.flatMap(ve=>(0,t.$zL)(ve.matches,ve.textBuffer)).map((ve,te)=>(ve.webviewIndex=te,ve));if(ne.length>0||ge.length>0){const ve={index:X,contentResults:(0,t.$zL)(ne,x.inputTextBuffer),webviewResults:ue};O.push(ve)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(j),{limitHit:T,results:[...I.values()]}}async y(r,v){const f=await this.s.value.stat(r);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==N.$sl&&typeof f.mtime=="number"&&typeof f.size=="number"&&v.mtime<f.mtime&&v.etag!==N.$tl({mtime:v.mtime,size:f.size}))throw new N.$il((0,l.localize)(1,null),3,v)}z(r){return r.scheme===u.Schemas.file?r.fsPath:r.toString()}A(r,v,f){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const D=new i.$Zlc(v,this.d,r,f.visibleRanges.map(w.NotebookRange.to),f.selections.map(w.NotebookRange.to),typeof f.viewColumn=="number"?w.ViewColumn.to(f.viewColumn):void 0);this.h.set(v,D)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const f of r.value.removedDocuments){const D=S.URI.revive(f),p=this.g.get(D);p&&(p.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(p.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===D.toString()&&this.h.delete(E.id)}if(r.value.addedDocuments){const f=[];for(const D of r.value.addedDocuments){const p=S.URI.revive(D.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const E=new a.$Ylc(this.c,this.q,this.r,p,D);f.push(...D.cells.map(k=>a.$Xlc.asModelAddData(k))),this.g.get(p)?.dispose(),this.g.set(p,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(E.apiNotebook)}}if(r.value.addedEditors)for(const f of r.value.addedEditors){if(this.h.has(f.id))return;const D=S.URI.revive(f.documentUri),p=this.g.get(D);p&&this.A(p,f.id,f)}const v=[];if(r.value.removedEditors)for(const f of r.value.removedEditors){const D=this.h.get(f);D&&(this.h.delete(f),this.k?.id===D.id&&(this.k=void 0),v.push(D))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const f=new Set;this.l.forEach(D=>f.add(D.id));for(const D of this.h.values()){const p=f.has(D.id);D._acceptVisibility(p)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(r){const v=y.$FP.String.with("notebookType","A notebook type"),f=new y.$HP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new y.$FP("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>M.$De.wrap(p))],new y.$GP("Notebook Data",p=>w.NotebookData.to(p.value))),D=new y.$HP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new y.$FP("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new g.$qw(w.NotebookData.from(p)))],new y.$GP("Bytes",p=>p.buffer));r.registerApiCommand(f),r.registerApiCommand(D)}}e.$9lc=s}),define(ke[370],Se([1,0,17,22,47,35,23,40,36]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class S{constructor(m,y,w){this.k=m,this.l=y,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&A.$nk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&A.$nk(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const y=this.k.folderQueries||[];return new Promise((w,d)=>{const g=a=>{this.f++,m(a)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const i=a.toString(),n=l.$oc(i);this.j&&this.j(i,n)||this.v(g,{base:a,basename:n})}),Promise.all(y.map(a=>this.p(a,g))).then(a=>{w({limitHit:this.e,stats:a[0]||void 0})},a=>{d(new Error((0,L.$ej)(a)))})})}async p(m,y){const w=new M.$ne,d=this.q(m),g=this.r(),a=new $.$pL(this.k,m),i=!a.hasSiblingExcludeClauses();let n;try{this.h.add(w),n=b.$$d.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,w.token),o=n.elapsed(),t=b.$$d.create();return this.g&&!this.e||(u&&u.forEach(h=>{const s=l.$hc.relative(m.folder.path,h.path);if(i){const c=l.$oc(h.path);this.v(y,{base:m.folder,relativePath:s,basename:c});return}this.s(g,m.folder,s,y)}),this.g&&!this.e)?null:(this.u(g,a,y),{providerTime:o,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(m){const y=(0,$.$oL)(this.k.includePattern,m.includePattern),w=(0,$.$oL)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:w,includes:y,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},y,w,d){if(w===this.a){const a=l.$oc(this.a);this.v(d,{base:y,relativePath:this.a,basename:a})}function g(a){const i=l.$oc(a),n=l.$nc(a);let u=m[n];u||(u=m[n]=[],g(n)),u.push({base:y,relativePath:a,basename:i})}g(w)}u({rootEntries:m,pathToEntries:y},w,d){const g=this,a=this.a;function i(n){const u=(0,$.$rL)(()=>n.map(o=>o.basename));for(let o=0,t=n.length;o<t;o++){const h=n[o],{relativePath:s,basename:c}=h;if(w.matchesExcludesSync(s,c,a!==c?u:void 0))continue;const r=y[s];if(r)i(r);else{if(s===a)continue;g.v(d,h)}if(g.e)break}}i(m)}v(m,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(y))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,y,w,d){const g=this.c(m.cacheKey),a=new S(m,y,g&&g.token);let i=0;const n=u=>{i+=u.length,w(u.map(o=>this.d(o)))};return this.e(a,N.a,n,d).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:u.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new M.$ne),this.b.get(m)}d(m){return m.relativePath?{resource:R.$7g(m.base,m.relativePath)}:{resource:m.base}}e(m,y,w,d){const g=d.onCancellationRequested(()=>{m.cancel()}),a=n=>{n&&(i.push(n),y>0&&i.length>=y&&(w(i),i=[]))};let i=[];return m.search(a).then(n=>(i.length&&w(i),g.dispose(),n),n=>(i.length&&w(i),g.dispose(),Promise.reject(n)))}}e.$1lc=N}),define(ke[371],Se([1,0,19,73,35,103,27,15,17,23,14,18,2,100,244,54,12,42,146,366,36]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=void 0,e.$zM=D;let o=class{constructor(E,k,P,I,T){this.a=E,this.b=k,this.c=P,this.d=I,this.e=T}text(E,k,P={}){E=this.f(E,P);const I=this.a.getValue(),T=k&&k.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(k?.map(a.$Oi),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||T||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,k){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const I={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,k)&&(I.isCaseSensitive=!0),this.k(E)&&(I.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),I}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map(r):r(E),k?this.parseSearchPaths(E):{pattern:h(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),I=this.g(k.excludePattern,k.expandPatterns),T=E.length>1,j=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(F=>this.q(F,k,I)):E.map(F=>this.r(F,k,I,T))).filter(F=>!!F),z={_reason:k._reason,folderQueries:j,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=l.$Hb(l.$Rb(this.c.groups.map(Z=>Z.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(Z=>(0,u.$fL)(z,Z.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=k.extraFileResources&&k.extraFileResources.filter(F=>(0,u.$fL)(z,F.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(E){const k=[],P=new R.$Bc,I={};let T=!1;return E.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,S.$$g)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$nc(j.fsPath)});let F=P.get(O);F||(T=!0,F={folder:O,includePattern:{}},k.push(F),P.set(O,F));const B=$.$mc(O.fsPath,j.fsPath);(0,C.$eg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(T=!0,I[j.fsPath]=!0)}),{folderQueries:k,includePattern:I,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(N.$Wf(E.pattern,!0))return!0}else if(N.$Wf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,y.$FC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(E)?E:s(E)).map(W=>{const Z=this.e.resolvedUserHome;return Z?(0,A.$vw)(W,Z.scheme===b.Schemas.file?Z.fsPath:Z.path):W}),T=M.$K(I,W=>k(W)?"searchPaths":"exprSegments"),j=(T.exprSegments||[]).map(W=>N.$df(W,"/")).map(W=>N.$df(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),c(W))),z={},O=this.m(T.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const F=l.$Rb(j),B=h(...F);return B&&(z.pattern=B),z}l(E,k){return k.disregardExcludeSettings?void 0:(0,u.$eL)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(I=>{let{pathPortion:T,globPortion:j}=t(I);return j&&(j=v(j)),this.n(T).flatMap(O=>this.o(O,j))}),P=new Map;return k.forEach(I=>{const T=I.searchPath.toString(),j=P.get(T);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):P.set(T,{searchPath:I.searchPath,pattern:I.pattern?h(I.pattern):void 0})}),Array.from(P.values())}n(E){if($.$jc(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:m.URI.file($.$ic(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=r(E),E.startsWith("../")||E===".."){const I=$.$hc.resolve(k.path,E);return[{searchPath:k.with({path:I})}]}const P=v(E);return[{searchPath:k,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(T=>{const j=k.match(new RegExp(`^${N.$0e(T.name)}(?:/(.*)|$)`));return j?{match:j,folder:T}:null}).filter(C.$bg);if(I.length)return I.map(T=>{const j=T.match[1];return{searchPath:T.folder.uri,pattern:j&&v(j)}});{const T=E.match(/\.[\/\\](.+)[\/\\]?/),j=T?T[1]:E,z=w.localize(0,null,j);throw new Error(z)}}}}o(E,k){const P=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,I=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:E.searchPath,pattern:P+"/**"}),I}q(E,k,P){const I=this.r((0,a.$Oi)(E.searchPath),k,P,!1);return I?{...I,includePattern:E.pattern}:null}r(E,k,P,I){let T;const j=m.URI.isUri(E)?E:E.uri;if(P.searchPaths){const W=P.searchPaths.filter(Z=>(0,S.$Zg)(Z.searchPath,j))[0];if(W&&!W.pattern)return null;W&&(T=W.pattern)}const z=this.a.getValue({resource:j}),F={...this.l(z,k)||{},...T||{}},B=m.URI.isUri(E)?(0,S.$4g)(E):E.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!z.search.followSymlinks}}};e.$yM=o,e.$yM=o=Je([Ve(0,d.$Zi),Ve(1,a.$Ci),Ve(2,i.$MD),Ve(3,g.$Zj),Ve(4,n.$wM)],o);function t(p){const E=p.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,P=p.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let I=p.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((P.index||0)+1)}}}return{pathPortion:p}}function h(...p){return p.length?p.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function s(p){return L.$lk(p,",").map(E=>E.trim()).filter(E=>!!E.length)}function c(p){return[`**/${p}/**`,`**/${p}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function v(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(p){return p.replace(/([?*[\]])/g,"[$1]")}function D(p,E){p=l.$Mb(p,I=>I.toString());const k=[],P=E.getWorkspace();return p&&p.forEach(I=>{let T;if(E.getWorkbenchState()===2)T=(0,S.$9g)(P.folders[0].uri,I),T&&T!=="."&&(T="./"+T);else{const j=E.getWorkspaceFolder(I);if(j){const z=j.name;if(P.folders.filter(F=>F.name===z).length===1){const F=(0,S.$9g)(j.uri,I);F===""?T=`./${j.name}`:T=`./${j.name}/${F}`}else T=I.fsPath}}T&&k.push(f(T))}),k}}),define(ke[372],Se([1,0,23,2,22,13,5,371,36,42,8]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Utb=m,e.$Vtb=d;const C=7e3;function m(g,a){const i=a.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],u=[];for(const r of i)if(/^workspaceContains:/.test(r)){const v=r.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||g.forceUsingSearch?u.push(v):n.push(v)}if(n.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,N.$mh)(),h=r=>t({activationEvent:r}),s=Promise.all(n.map(r=>y(g,r,h))).then(()=>{}),c=w(g,a.identifier,u,h);return Promise.all([s,c]).then(()=>{t(void 0)}),o}async function y(g,a,i){for(const n of g.folders)if(await g.exists(l.$7g(M.URI.revive(n),a))){i(`workspaceContains:${a}`);return}}async function w(g,a,i,n){if(i.length===0)return Promise.resolve(void 0);const u=new L.$ne,o=g.checkExists(g.folders,i,u.token),t=setTimeout(async()=>{u.cancel(),g.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let h=!1;try{h=await o}catch(s){A.$4(s)||A.$1(s)}u.dispose(),clearTimeout(t),h&&n(`workspaceContains:${i.join(",")}`)}function d(g,a,i,n){const u=g.get(R.$si),o=g.get($.$9K),h=u.createInstance(b.$yM).file(a.map(s=>(0,S.$Oi)(M.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(h,n).then(s=>!!s.limitHit,s=>A.$4(s)?!1:Promise.reject(s))}}),define(ke[49],Se([1,0,219,17,59,23,8,3,77,2,12,6,45,304,118,44,26,148,13,25,21,281,7,66,5,28,93,20,107,70,43,121,4,372,117,283,15,115,40,11,116]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s,c,r,v,f,D,p,E,k,P,I,T,j,z,O,F,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=e.$Elc=e.$Dlc=e.$Clc=void 0,e.$Clc=(0,s.$ti)("IHostUtils");let Z=W=class extends b.$Vc{constructor(U,_,pe,Pe,se,re,oe,K,ie,$e,we,Ne,fe){super(),this.Y=Ne,this.Z=fe,this.a=this.B(new k.$ce),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=pe,this.f=oe,this.j=Pe,this.m=se,this.s=re,this.t=ie,this.u=$e,this.w=we,this.y=this.g.getProxy(C.$UM.MainThreadWorkspace),this.z=this.g.getProxy(C.$UM.MainThreadTelemetry),this.C=this.g.getProxy(C.$UM.MainThreadExtensionService),this.D=new R.$sh,this.F=new R.$sh,this.G=new R.$sh,this.H=new R.$sh,this.I=new ve(this.f.extensions.activationEvents),this.L=new a.$e_b(this.I,this.f.extensions.allExtensions);const De=new n.$Pm(this.f.extensions.myExtensions);this.J=new a.$e_b(this.I,ge(this.L,De)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new w.$llc(this.g,this.s),this.N=new I.$vlc(this.g),this.O=K,this.h=U.createChild(new f.$ri([w.$mlc,this.M],[I.$wlc,this.N])),this.P=this.B(new y.$klc(this.J,this.L,{onExtensionActivationError:(Ie,Fe,V)=>{this.C.$onExtensionActivationError(Ie,i.$3(Fe),V)},actualActivateExtension:async(Ie,Fe)=>{if(a.$e_b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Fe),new y.$jlc;const V=this.J.getExtensionDescription(Ie);return this.fb(V,Fe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){i.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.eb(se))}catch{}await Promise.all(U)}terminate(U,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const pe=this.$();Promise.race([(0,R.$uh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const _=await this.C.$getExtension(U);return _&&{..._,identifier:new n.$Om(_.identifier.value),extensionLocation:S.URI.revive(_.extensionLocation)}}ab(U,_){return this.P.activateByEvent(U,_)}bb(U,_){return this.P.activateById(U,_)}activateByIdWithErrors(U,_){return this.bb(U,_).then(()=>{const pe=this.P.getActivatedExtension(U);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const _=U.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const pe=await this.R.get(_);return S.URI.file(pe)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new ue(U))),this.Q}async db(U){const _=$.$zi.forUris(pe=>A.$Xg.ignorePathCasing(pe));return await Promise.all(U.map(async pe=>{if(this.wb(pe)){const Pe=await this.cb(pe.extensionLocation);_.set(Pe,pe)}})),_}eb(U){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return _;const pe=this.P.getActivatedExtension(U);if(!pe)return _;try{typeof pe.module.deactivate=="function"&&(_=Promise.resolve(pe.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Pe)}try{(0,b.$Qc)(pe.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Pe)}return _}async fb(U,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,_).then(pe=>{const Pe=pe.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,_),this.gb(U,_,"success",Pe),pe},pe=>{throw this.gb(U,_,"failure"),pe})}gb(U,_,pe,Pe){const se=Y(U,_);this.z.$publicLog2("extensionActivationTimes",{...se,...Pe||{},outcome:pe})}hb(U,_){const pe=Y(U,_);this.z.$publicLog2("activatePlugin",pe);const Pe=this.wb(U);if(!Pe)return Promise.resolve(new y.$ilc(y.$flc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${U.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const se=new y.$glc(_.startup);return Promise.all([this.xb(U,(0,A.$7g)(U.extensionLocation,Pe),se),this.ib(U)]).then(re=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,re[0],re[1],se))).then(re=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}ib(U){const _=this.Z.createLanguageModelAccessInformation(U),pe=new o.$olc(U,this.M),Pe=new o.$nlc(U.identifier.value,!1,this.M),se=new T.$xlc(U,this.N),re=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([pe.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const K=this;let ie,$e;const we=(0,g.$BG)(U,"ipc")?this.f.messagePorts?.get(n.$Om.toKey(U.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Pe,secrets:se,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ne){return M.$kc(U.extensionLocation.fsPath,Ne)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return M.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return re},get extension(){return ie===void 0&&(ie=new ne(K,U.identifier,U,oe,!1)),ie},get extensionRuntime(){return(0,g.$CG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!$e){if(!we)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(we,"message",fe=>fe.data));we.start(),$e={onDidReceiveMessage:Ne,postMessage:we.postMessage.bind(we)}}return $e}})})}static jb(U,_,pe,Pe,se){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(U,_,pe,Pe,se).then(re=>new y.$hlc(!1,null,se.build(),pe,re,Pe.subscriptions))}static kb(U,_,pe,Pe,se){if(typeof pe.activate=="function")try{se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${_.value}`);const re=typeof global=="object"?global:self,oe=pe.activate.apply(re,[Pe]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(oe).then(K=>(se.activateResolveStop(),K))}catch(re){return Promise.reject(re)}else return Promise.resolve(pe)}lb(U,_){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:_}).then(void 0,pe=>{this.s.error(pe)})}mb(U,_=0){const Pe=Date.now();(0,F.$B)(()=>{for(let se=_;se<U.length;se+=1){const re=U[se];for(const oe of re.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Pe>50){this.mb(U,se);break}else this.lb(re,oe)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const _=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(_)this.mb(pe);else for(const Pe of pe)if(Pe.activationEvents)for(const se of Pe.activationEvents)se==="onStartupFinished"&&this.lb(Pe,se)})}ob(){const U=this.ab("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.pb(re.added)));const _=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(_),Pe=this.rb(),se=Promise.all([Pe,U,pe]).then(()=>{});return Promise.race([se,(0,R.$uh)(1e4)]).then(()=>{this.nb()}),se}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(U,_))).then(()=>{})}async qb(U,_){if(this.isActivated(_.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:U.map(re=>re.uri),forceUsingSearch:pe||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,oe,K)=>this.y.$checkExists(re,oe,K)},se=await(0,P.$Utb)(Pe,_);if(se)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:_}=this.f.environment;if(!U||!_)throw new Error(l.localize(0,null));const pe=await this.xb(null,_,new y.$glc(!1));if(!pe||typeof pe.run!="function")throw new Error(l.localize(1,null,_.toString()));return new Promise((Pe,se)=>{const re=(ie,$e)=>{ie?(F.$t&&this.s.error("Test runner called back with error",ie),se(ie)):(F.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof $e=="number"&&$e>0?1:0))},oe=(0,A.$Ug)(_),K=pe.run(oe,re);K&&K.then&&K.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(ie=>{F.$t&&this.s.error("Test runner finished with error",ie),se(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$uh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,_){return this.S[U]=_,(0,b.$Tc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:_}=await this.ub(U);return _?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const _=U.indexOf("+");if(_===-1)throw new t.$3M("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=U.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(U,_){const pe=O.$$d.create(!1),Pe=()=>`[resolveAuthority(${(0,h.$Il)(U)},${_})][${pe.elapsed()}ms] `,se=q=>this.s.info(`${Pe()}${q}`),re=q=>this.s.warn(`${Pe()}${q}`),oe=(q,J=void 0)=>this.s.error(`${Pe()}${q}`,J),K=q=>{if(q instanceof t.$3M)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},ie=async q=>{se(`activating resolver for ${q}...`);const{resolver:J,authorityPrefix:Q}=await this.ub(q);if(!J)throw oe(`no resolver for ${Q}`),new t.$3M(`No remote extension installed to resolve ${Q}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Q,remoteAuthority:q}},$e=U.split(/@|%40/g).reverse();se(`activating remote resolvers ${$e.join(" -> ")}`);let we;try{we=await Promise.all($e.map(ie)).catch(async q=>{if(!(q instanceof t.$3M)||q._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return re(`resolving nested authorities failed: ${q.message}`),[await ie(U)]})}catch(q){return K(q)}const Ne=new R.$Eh;Ne.cancelAndSet(()=>se("waiting..."),1e3);let fe,De;for(const[q,{authorityPrefix:J,resolver:Q,remoteAuthority:he}]of we.entries())try{if(q===we.length-1)se("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${J}`),fe=await Q.resolve(he,{resolveAttempt:_,execServer:De}),L.mark(`code/extHost/didResolveAuthorityOK/${J}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$2M.isManagedResolvedAuthority(fe)?fe:void 0));else{if(se(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${J}`),De=await Q.resolveExecServer?.(he,{resolveAttempt:_,execServer:De}),!De)throw new t.$3M(`Exec server was not available for ${he}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(be){return L.mark(`code/extHost/didResolveAuthorityError/${J}`),oe("returned an error",be),Ne.dispose(),K(be)}Ne.dispose();const Ie={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$2M.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let V;if(t.$2M.isManagedResolvedAuthority(fe)){const q=_;this.Y.setFactory(q,fe.makeConnection),V={authority:U,connectTo:new h.$Fl(q),connectionToken:fe.connectionToken}}else V={authority:U,connectTo:new h.$Gl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:V,options:Fe,tunnelInformation:Ie}}}async $getCanonicalURI(U,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$Il)(U)})`);const{resolver:pe}=await this.ub(U);if(!pe)return null;const Pe=S.URI.revive(_);if(typeof pe.getCanonicalURI>"u")return Pe;const se=await(0,R.$lh)(()=>pe.getCanonicalURI(Pe));return se||Pe}async $startExtensionHost(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:_,myExtensions:pe}=X(this.I,this.L,this.J,U),Pe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(U,_){return _===1?this.D.wait().then(pe=>this.ab(U,!1)):this.G.wait().then(pe=>this.ab(U,!1))}async $activate(U,_){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,_),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:_,myExtensions:pe}=X(this.I,this.L,this.J,U),Pe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const _=u.$De.alloc(U),pe=Math.random()%256;for(let Pe=0;Pe<U;Pe++)_.writeUInt8(pe,Pe);return _}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$Dlc=Z,e.$Dlc=Z=W=Je([Ve(0,s.$si),Ve(1,e.$Clc),Ve(2,v.$hP),Ve(3,d.$1kc),Ve(4,m.$4kc),Ve(5,N.$Zj),Ve(6,c.$xP),Ve(7,r.$7kc),Ve(8,D.$ZCb),Ve(9,p.$plc),Ve(10,z.$zlc),Ve(11,B.$Alc),Ve(12,E.$tlc)],Z);function X(te,U,_,pe){te.addActivationEvents(pe.addActivationEvents);const Pe=new a.$e_b(te,U.getAllExtensionDescriptions());Pe.deltaExtensions(pe.toAdd,pe.toRemove);const se=new n.$Pm(_.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of pe.myToRemove)se.delete(oe);for(const oe of pe.myToAdd)se.add(oe);const re=ge(Pe,se);return{globalRegistry:Pe,myExtensions:re}}function Y(te,U){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function x(te){return te.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$Elc=(0,s.$ti)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(U,_,pe,Pe,se){this.#e=U,this.#t=_,this.#i=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=M.$ic((0,A.$Ug)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Pe,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Flc=ne;function ge(te,U){return te.getAllExtensionDescriptions().filter(_=>U.has(_.identifier))}class ue{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$Glc=ue;class ve{constructor(U){this.a=new n.$Qm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const _ of Object.keys(U))this.a.set(_,U[_])}}}),define(ke[373],Se([1,0,59,2,6,45,26,25,20,28,5,49,12,14]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;let d=class{constructor(u,o,t,h,s,c,r){this.c=u,this.d=o,this.e=t,this.f=h,this.g=s,this.h=c,this.i=r,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,u,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,o,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const o of u.nodeModuleName)this.a.set(o,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(o=>u.alternativeModuleName(o))}};e.$Pmc=d,e.$Pmc=d=Je([Ve(2,N.$si),Ve(3,A.$4kc),Ve(4,C.$Elc),Ve(5,S.$xP),Ve(6,m.$Zj)],d);let g=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&w.a.size){const o=(0,y.$0e)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${s}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const o=this.b.exec(this.c(u));if(!o)return;const[,t,h,s]=o,c=w.a.get(h);if(c!==void 0)return console.warn(`${h} as been renamed to ${c}, please update your imports`),t+c+s}c(u){return u.replace(/\\/g,"/")}};g=w=Je([Ve(0,S.$xP)],g);class a{constructor(u,o,t,h,s){this.c=u,this.d=o,this.e=t,this.f=h,this.g=s,this.nodeModuleName="vscode",this.a=new b.$Qm}load(u,o){const t=this.d.findSubstr(o);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((s,c)=>h+=`	${c} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${h}`),this.b=this.c(R.$wG,this.e,this.f)}return this.b}}let i=class{constructor(u,o,t){this.e=u,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$UM.MainThreadTelemetry);const h=t.getProxy(L.$UM.MainThreadWindow);this.c=(s,c)=>{const r=M.URI.parse(s);return c?this.g(s,c):r.scheme==="http"||r.scheme==="https"?h.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?h.$openUri(r,s,{}):this.g(s,c)}}load(u,o,t){const h=this.e.findSubstr(o);return h&&(this.a=h.identifier.value,this.h()),this.b=t(u),this.c}g(u,o){return this.i(),this.b(u,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([Ve(2,$.$hP)],i)}),define(ke[61],Se([1,0,46,3,17,51,5,72,71,49,7,44,301,45]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=void 0,e.$Hlc=(0,R.$ti)("IExtHostVariableResolverProvider");class w extends m.$jQ{constructor(a,i,n,u,o,t,h){function s(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const r=u.tabGroups.all.find(v=>v.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof N.$HO||r.input instanceof N.$MO)return r.input.modified;if(r.input instanceof N.$GO||r.input instanceof N.$LO||r.input instanceof N.$JO)return r.input.uri}}}super({getFolderUri:c=>{const r=t.folders.filter(v=>v.name===c);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,r)=>o.getConfiguration(void 0,c).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=s();if(c)return L.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=s();if(c){const r=i.getWorkspaceFolder(c);if(r)return L.$ic(r.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(A.env))}}let d=class extends M.$Vc{constructor(a,i,n,u,o){super(),this.b=a,this.c=i,this.g=n,this.h=u,this.j=o,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ilc=d,e.$Ilc=d=Je([Ve(0,S.$Elc),Ve(1,C.$1kc),Ve(2,b.$sP),Ve(3,y.$4kc),Ve(4,$.$dlc)],d)}),define(ke[96],Se([1,0,8,4,2,25,5,6,71,49,20,7,44,143,293,45,61,3,57,34,16]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=e.$Llc=e.$Klc=e.$Jlc=void 0,e.$Jlc=(0,R.$ti)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,D,p,E,k,P,I){this.N=D,this.O=p,this.P=E,this.Q=k,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$ce,this.o=new M.$ce,this.q=new M.$ce,this.w=new M.$ce,this.l=f.getProxy(b.$UM.MainThreadDebugService),this.A=new M.$ce,this.C=new M.$ce,this.y=new h(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(j=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(f,D){const p=this.W(D);if(!p)return;const E=await this.H.get(f)?.getTreeItem?.(p);return E?this.U(f,E):void 0}registerDebugVisualizationTree(f,D,p){const E=A.$Om.toKey(f.identifier),k=this.jb(E,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,p),this.l.$registerDebugVisualizerTree(k,!!p.editItem),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren(f,D){const p=this.J.get(D)?.item;return p?(await this.H.get(f)?.getChildren?.(p))?.map(k=>this.U(f,k))||[]:[]}async $editVisualizerTreeItem(f,D){const p=this.J.get(f);if(!p)return;const E=await this.H.get(p.provider)?.editItem?.(p.item,D);return this.U(p.provider,E||p.item)}$disposeVisualizedTree(f){const D=this.J.get(f);if(!D)return;const p=[D.children];for(const E of p)if(E)for(const k of E)p.push(this.J.get(k)?.children),this.J.delete(k)}U(f,D){let p=this.I.get(D);return p||(p=this.F++,this.I.set(D,p),this.J.set(p,{provider:f,item:D})),u.DebugTreeItem.from(D,p)}asDebugSourceUri(f,D){const p=f;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let E=`debug:${encodeURIComponent(p.path||"")}`,k="?";return D&&(E+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),E+=`${k}ref=${p.sourceReference}`,L.URI.parse(E)}else{if(p.path)return L.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const D=[];for(const p of f.getAllExtensionDescriptions())if(p.contributes){const E=p.contributes.debuggers;if(E&&E.length>0)for(const k of E)(0,w.$eH)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(D=>f.push(D)),f}async $resolveDebugVisualizer(f,D){const p=this.L.get(f);if(!p)throw new Error(`No debug visualizer found with id '${f}'`);let{v:E,provider:k,extensionId:P}=p;if(E.visualization||(E=await k.resolveDebugVisualization?.(E,D)||E,p.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(P,E.visualization)}async $executeDebugVisualizerCommand(f){const D=this.L.get(f);if(!D)throw new Error(`No debug visualizer found with id '${f}'`);const p=D.v.visualization;p&&"command"in p&&this.S.executeCommand(p.command,...p.arguments||[])}W(f){const D=this.m.get(f.sessionId);return D&&{session:D.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,D,p,E){const k=this.W(p),P=this.jb(f,D),I=this.G.get(P);if(!k||!I)return[];const T=await I.provideDebugVisualization(k,E);return T?T.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:f});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(f,j.visualization)}}):[]}$disposeDebugVisualizers(f){for(const D of f)this.L.delete(D)}registerDebugVisualizationProvider(f,D,p){if(!f.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const E=A.$Om.toKey(f.identifier),k=this.jb(E,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,p),this.l.$registerDebugVisualizer(E,D),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizer(E,D),this.G.delete(D)})}addBreakpoints(f){const D=f.filter(k=>{const P=k.id;return this.z.has(P)?!1:(this.z.set(P,k),!0)});this.gb(D,[],[]);const p=[],E=new Map;for(const k of D)if(k instanceof C.$XN){let P=E.get(k.location.uri.toString());P||(P={type:"sourceMulti",uri:k.location.uri,lines:[]},E.set(k.location.uri.toString(),P),p.push(P)),P.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof C.$YN&&p.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(p)}removeBreakpoints(f){const D=f.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const p=D.filter(P=>P instanceof C.$XN).map(P=>P.id),E=D.filter(P=>P instanceof C.$YN).map(P=>P.id),k=D.filter(P=>P instanceof C.$ZN).map(P=>P.id);return this.l.$unregisterBreakpoints(p,E,k)}startDebugging(f,D,p){return this.l.$startDebugging(f?f.uri:void 0,D,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,D,p){if(!D)return new C.$WM(()=>{});const E=this.d++;return this.f.push({type:f,handle:E,provider:D}),this.l.$registerDebugConfigurationProvider(f,p,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,E),new C.$WM(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(f,D,p){if(!p)return new C.$WM(()=>{});if(!this.cb(f,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:D,handle:E,factory:p}),this.l.$registerDebugAdapterDescriptorFactory(D,E),new C.$WM(()=>{this.h=this.h.filter(k=>k.factory!==p),this.l.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(f,D){if(!D)return new C.$WM(()=>{});const p=this.j++;return this.k.push({type:f,handle:p,factory:D}),new C.$WM(()=>{this.k=this.k.filter(E=>E.factory!==D)})}async $runInTerminal(f,D){return Promise.resolve(void 0)}async $substituteVariables(f,D){let p;const E=await this.ib(f);return E&&(p={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(p,D)}X(f,D){if(f.type==="implementation")return new c(f.implementation)}Y(){}async $startDASession(f,D){const p=this,E=await this.hb(D);return this.eb(this.$(E.type),E).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const P=this.Z(k),I=this.X(P,E);if(!I)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const T=I;return this.D.set(f,T),this.db(E).then(j=>(j&&this.E.set(f,j),T.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,F={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);F.body={signature:B},T.sendResponse(F)}else throw new Error("no signer")}catch(B){F.success=!1,F.message=B.message,T.sendResponse(F)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,w.$jH)(z,!0),p.l.$acceptDAMessage(f,z)}),T.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(f,z.name,z.message,z.stack)}),T.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(f,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),T.startSession()))})}$sendDAMessage(f,D){D=(0,w.$iH)(D,!1);const p=this.E.get(f);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(D),this.D.get(f)?.sendMessage(D)}$stopDASession(f){const D=this.E.get(f);this.E.delete(f),D&&D.onWillStopSession&&D.onWillStopSession();const p=this.D.get(f);return this.D.delete(f),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const D=[],p=[],E=[];if(f.added)for(const k of f.added){const P=k.id;if(P&&!this.z.has(P)){let I;if(k.type==="function")I=new C.$YN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")I=new C.$ZN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const T=L.URI.revive(k.uri);I=new C.$XN(new C.$9M(T,new C.$XM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,C.$VN)(I,P),this.z.set(P,I),D.push(I)}}if(f.removed)for(const k of f.removed){const P=this.z.get(k);P&&(this.z.delete(k),p.push(P))}if(f.changed){for(const k of f.changed)if(k.id){const P=this.z.get(k.id);if(P){if(P instanceof C.$YN&&k.type==="function"){const I=P;I.enabled=k.enabled,I.condition=k.condition,I.hitCondition=k.hitCondition,I.logMessage=k.logMessage,I.functionName=k.functionName}else if(P instanceof C.$XN&&k.type==="source"){const I=P;I.enabled=k.enabled,I.condition=k.condition,I.hitCondition=k.hitCondition,I.logMessage=k.logMessage,I.location=new C.$9M(L.URI.revive(k.uri),new C.$XM(k.line,k.character))}E.push(P)}}}this.gb(D,p,E)}async $acceptStackFrameFocus(f){let D;if(f){const p=await this.hb(f.sessionId);f.kind==="thread"?D=new C.$6N(p.api,f.threadId):D=new C.$5N(p.api,f.threadId,f.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(f,D,p){return(0,l.$lh)(async()=>{const E=this.bb(f);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return E.provideDebugConfigurations(k,p)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(f,D,p,E){return(0,l.$lh)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return k.resolveDebugConfiguration(P,p,E)})}$resolveDebugConfigurationWithSubstitutedVariables(f,D,p,E){return(0,l.$lh)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(P,p,E)})}async $provideDebugAdapter(f,D){const p=this.ab(f);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.hb(D);return this.eb(p,E).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(f){const D=await this.hb(f);this.n.fire(D.api)}async $acceptDebugSessionTerminated(f){const D=await this.hb(f);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,D){(await this.hb(f))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(f,D){const E={session:(await this.hb(f)).api,event:D.event,body:D.body};this.w.fire(E)}Z(f){if(f instanceof C.$1N)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof C.$2N)return{type:"server",port:f.port,host:f.host};if(f instanceof C.$3N)return{type:"pipeServer",path:f.path};if(f instanceof C.$4N)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const D=this.h.filter(p=>p.type===f);if(D.length>0)return D[0].factory}ab(f){const D=this.h.filter(p=>p.handle===f);if(D.length>0)return D[0].factory}bb(f){const D=this.f.filter(p=>p.handle===f);if(D.length>0)return D[0].provider}cb(f,D){if(f.contributes){const p=f.contributes.debuggers;if(p&&p.length>0){for(const E of p)if(E.label&&E.type&&E.type===D)return!0}}return!1}db(f){const p=f.configuration.type,E=this.k.filter(k=>k.type===p||k.type==="*").map(k=>(0,l.$lh)(()=>k.factory.createDebugAdapterTracker(f.api)).then(P=>P,P=>null));return Promise.race([Promise.all(E).then(k=>{const P=k.filter(I=>!!I);if(P.length>0)return new s(P)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(f,D){const p=D.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new C.$2N(p));if(f){const k=await this.O.getExtensionRegistry();return(0,l.$lh)(()=>f.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(P=>{if(P)return P})}const E=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,E))}fb(f,D){}gb(f,D,p){(f.length>0||D.length>0||p.length>0)&&this.A.fire(Object.freeze({added:f,removed:D,changed:p}))}async hb(f){if(f)if(typeof f=="string"){const D=this.m.get(f);if(D)return D}else{let D=this.m.get(f.id);if(!D){const p=await this.ib(f.folderUri),E=f.parent?this.m.get(f.parent):void 0;D=new t(this.l,f.id,f.type,f.name,p,f.configuration,E?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(f){if(f){const D=L.URI.revive(f);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(f,D){return`${f}\0${D}`}kb(f,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${f}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const D=this.mb(f);let p,E;return"id"in D?E=i.ThemeIcon.asClassName(D):p=D,{iconPath:p,iconClass:E}}mb(f){if(f instanceof C.$SN)return{id:f.id};const D=typeof f=="object"&&"dark"in f?f.dark:f,p=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof p=="string"?L.URI.file(p):p}}};e.$Klc=o,e.$Klc=o=Je([Ve(0,N.$hP),Ve(1,m.$1kc),Ve(2,S.$Elc),Ve(3,d.$4kc),Ve(4,$.$dlc),Ve(5,g.$Hlc),Ve(6,n.$DP)],o);class t{constructor(f,D,p,E,k,P,I){this.f=f,this.g=D,this.h=p,this.j=E,this.k=k,this.l=P,this.m=I}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(D){f.j=D,f.f.$setDebugSessionName(f.g,D)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(D,p){return f.f.$customDebugAdapterRequest(f.g,D,p)},getDebugProtocolBreakpoint(D){return f.f.$getDebugProtocolBreakpoint(f.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Llc=t;class h{constructor(f){this.value=Object.freeze({append(D){f.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Mlc=h;class s{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(D=>D.onError?D.onError(f):void 0)}onExit(f,D){this.d.forEach(p=>p.onExit?p.onExit(f,D):void 0)}}class c extends y.$1ob{constructor(f){super(),this.h=f,f.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(f,D,p,E,k,P,I){super(f,D,p,E,k,P,I)}};e.$Nlc=r,e.$Nlc=r=Je([Ve(0,N.$hP),Ve(1,m.$1kc),Ve(2,S.$Elc),Ve(3,d.$4kc),Ve(4,$.$dlc),Ve(5,g.$Hlc),Ve(6,n.$DP)],r)}),define(ke[374],Se([1,0,13,59,2,6,321,12,84,107,28,257,20,67,49,90]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0;class g{static async installEarlyHandler(n){Error.stackTraceLimit=100;const u=n.get(b.$Zj),t=n.get(m.$hP).getProxy(A.$UM.MainThreadErrors);l.setUnexpectedErrorHandler(h=>{u.error(h);const s=l.$3(h);t.$onUnexpectedError(s)})}static async installFullHandler(n){const u=n.get(b.$Zj),o=n.get(m.$hP),t=n.get(w.$Elc),h=n.get(d.$BP),s=o.getProxy(A.$UM.MainThreadExtensionService),c=o.getProxy(A.$UM.MainThreadErrors),r=await t.getExtensionPathIndex(),v=new WeakMap;function f(E,k){if(v.has(E))return v.get(E).stack;let P="",I,T;for(const z of k)P+=`
	at ${z.toString()}`,T=z.getFileName(),!I&&T&&(I=r.findSubstr(L.URI.file(T)));const j=`${E.name||"Error"}: ${E.message||""}${P}`;return v.set(E,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let p=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(E){if(E===f||!E||E[D]){p=E||f;return}p=function(k,P){return f(k,P),E.call(Error,k,P)},Object.assign(p,{[D]:!0})}}),l.setUnexpectedErrorHandler(E=>{u.error(E);const k=l.$3(E),P=v.get(E);if(!P?.extensionIdentifier){c.$onUnexpectedError(k);return}s.$onExtensionRuntimeError(P.extensionIdentifier,k);const I=h.onExtensionError(P.extensionIdentifier,E);u.trace("forwarded error to extension?",I,P)})}}e.$Qmc=g;class a{constructor(n,u,o,t,h){this.a=o,this.b=new R.$m_b(n,null,t),u=a.e(u,this.b);const s=new S.$ri(...(0,$.$us)());s.set(N.$xP,{_serviceBrand:void 0,...u,messagePorts:h}),s.set(m.$hP,new m.$iP(this.b)),s.set(y.$Xkc,new y.$Ykc(t)),s.set(w.$Clc,o);const c=new C.$_q(s,!0);c.invokeFunction(g.installEarlyHandler),this.d=c.invokeFunction(r=>r.get(b.$Zj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=c.invokeFunction(r=>r.get(w.$Elc)),this.c.initialize(),c.invokeFunction(g.installFullHandler)}async asBrowserUri(n){const u=this.b.getProxy(A.$UM.MainThreadExtensionService);return L.URI.revive(await u.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,u){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=L.URI.revive(u.transformIncomingURIs(n.environment.appRoot));const o=n.environment.extensionDevelopmentLocationURI;return o&&(n.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(u.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=L.URI.revive(u.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=L.URI.revive(u.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=L.URI.revive(u.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=L.URI.revive(u.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=L.URI.revive(u.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=L.URI.revive(u.transformIncomingURIs(n.logsLocation)),n.workspace=u.transformIncomingURIs(n.workspace),n}}e.$Rmc=a}),define(ke[375],Se([1,0,8,11,230,250,141,96,71,49,20,43,7,61,44,294,295,45,34]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;let n=class extends b.$Klc{constructor(s,c,r,v,f,D,p,E){super(s,c,r,v,D,p,E),this.pb=f,this.nb=new t}X(s,c){switch(s.type){case"server":return new d.$Wmc(s);case"pipeServer":return new d.$Xmc(s);case"executable":return new d.$Ymc(s,c.type)}return super.X(s,c)}fb(s,c){const r=d.$Ymc.platformAdapterExecutable(c.getAllExtensionDescriptions(),s.type);if(r)return new m.$1N(r.command,r.args,r.options)}Y(){return new R.$adc}async $runInTerminal(s,c){if(s.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const r=await this.P.getConfigProvider(),v=this.pb.getDefaultShell(!0),f=this.pb.getDefaultShellArgs(!0),D=s.title||L.localize(0,null),p=JSON.stringify({shell:v,shellArgs:f});let E=await this.nb.checkout(p,D),k,P=!1;if(E)k=s.cwd;else{const z={shellPath:v,shellArgs:f,cwd:s.cwd,name:D,iconPath:new m.$SN("debug")};P=!0,E=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(E,p)}E.show(!0);const I=await E.processId;P?await new Promise(z=>setTimeout(z,1e3)):(E.state.isInteractedWith&&E.sendText(""),r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?E.sendText("cls"):v.indexOf("bash")>=0?E.sendText("clear"):M.$i?E.sendText("cls"):E.sendText("clear")));const T=(0,g.$1mc)(v,s.args,!!s.argsCanBeInterpretedByShell,k,s.env);E.sendText(T);const j=this.onDidTerminateDebugSession(z=>{z.id===c&&(this.nb.free(E),j.dispose())});return I}else if(s.kind==="external")return o(s,await this.P.getConfigProvider());return super.$runInTerminal(s,c)}};e.$2mc=n,e.$2mc=n=Je([Ve(0,N.$hP),Ve(1,w.$1kc),Ve(2,S.$Elc),Ve(3,a.$4kc),Ve(4,C.$plc),Ve(5,$.$dlc),Ve(6,y.$Hlc),Ve(7,i.$DP)],n);let u;function o(h,s){if(!u)if(M.$i)u=new A.$Xbc;else if(M.$j)u=new A.$Ybc;else if(M.$k)u=new A.$Zbc;else throw new Error("external terminals not supported on this platform");const c=s.getConfiguration("terminal");return u.runInTerminal(h.title,h.cwd,h.args,h.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,c,r=!1){const f=[...this.b.entries()].map(([D,p])=>(0,l.$gh)(async E=>{if(D.name!==c||p.lastUsedAt!==-1&&await(0,g.$Zmc)(await D.processId))return null;const k=Date.now();return p.lastUsedAt+t.a>k||E.isCancellationRequested?null:p.config!==s?(r&&D.dispose(),null):(p.lastUsedAt=k,D)}));return await(0,l.$yh)(f,D=>!!D)}insert(s,c){this.b.set(s,{lastUsedAt:Date.now(),config:c})}free(s){const c=this.b.get(s);c&&(c.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[376],Se([1,0,17,2,105,44,72,45,42,43,20,28,95,15,12,91,23,64,61]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;let n=class extends m.$tmc{constructor(o,t,h,s,c,r,v,f,D){super(o,t,h,s,c,r,v,f),this.C=h,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const s=m.TaskHandleDTO.from(h,this.C),c=await this.a.$getTaskExecution(s);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.z(c,t);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=m.TaskDTO.from(t,o);if(s===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const c=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),c}}v(o,t,h,s){const c=[];if(s)for(const r of s){this.A(r,h),(!r.definition||!o[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const v=m.TaskDTO.from(r,h.extension);v&&(c.push(v),m.CustomExecutionDTO.is(v.execution)&&t.push(this.y(v,r,!0)))}return{tasks:c,extension:h.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const h=M.URI.file((0,a.homedir)());t=new $.$Ni({uri:h,name:g.$4g(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const h=M.URI.revive(o),s={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(h),r=await this.b.getWorkspaceFolders2()??[],v=await this.D.getResolver(),f=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(r);for(const D of t.variables)s.variables[D]=await v.resolveAsync(f,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(l.$uc);for(let p=0;p<D.length;p++)D[p]=await v.resolveAsync(f,D[p])}s.process=await L.win32.findExecutable(await v.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(f,t.process.cwd):void 0,D)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,h){return L.win32.findExecutable(o,t,h)}};e.$Tmc=n,e.$Tmc=n=Je([Ve(0,N.$hP),Ve(1,C.$xP),Ve(2,A.$1kc),Ve(3,R.$sP),Ve(4,b.$4kc),Ve(5,S.$plc),Ve(6,w.$Zj),Ve(7,d.$Ekc),Ve(8,i.$Hlc)],n)}),define(ke[377],Se([1,0,64,61]),function(le,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class L extends M.$Ilc{m(){return(0,l.homedir)()}}e.$znc=L}),define(ke[159],Se([1,0,19,8,22,47,15,17,23,2,36]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$3lc=e.$2lc=void 0,e.$4lc=d;class C{constructor(i,n,u){this.d=i,this.e=n,this.f=u,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const u=this.g.folderQueries||[],o=new L.$ne(n);return new Promise((t,h)=>{this.a=new y(i);let s=!1;const c=(r,v)=>{if(!s&&!this.b){const f=this.h(r);d(r)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,s=!0,o.cancel(),r=this.j(r,this.g.maxResults-this.c));const D=this.h(r);this.c+=D,(D>0||!d(r))&&this.a.add(r,v)}};Promise.all(u.map((r,v)=>this.k(r,f=>c(f,v),o.token))).then(r=>{o.dispose(),this.a.flush();const v=r.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||v,messages:(0,l.$Rb)(r.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},r=>{o.dispose();const v=(0,A.$ej)(r);h(new Error(v))})})}h(i){return d(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const u=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:u.slice(0,n),preview:{matches:o.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,u){const o=new N.$pL(this.g,i),t=[],h={report:r=>{if(!this.l(r))return;const v=i.folder.scheme===R.Schemas.file?(0,N.$qL)(()=>this.e.readdir($.$6g(r.uri))):void 0,f=$.$9g(i.folder,r.uri);if(f){const D=o.includedInQuery(f,b.$oc(f),v);(0,M.$fh)(D)?t.push(D.then(p=>{p&&n(r)})):D&&n(r)}}},s=this.n(i);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,s,h,u):c=await this.d.provider.provideTextSearchResults(m(this.d.query.contentPattern),s,h,u),t.length&&await Promise.all(t),c}l(i){if(d(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,N.$oL)(this.g.includePattern,i.includePattern),u=(0,N.$oL)(this.g.excludePattern,i.excludePattern),o={folder:S.URI.from(i.folder),excludes:u,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$2lc=C;function m(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new g(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$Zg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(w(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$3lc=y;function w(a){return d(a)?{preview:{matches:(0,l.$2b)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,l.$2b)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}class g{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$5lc=g}),define(ke[97],Se([1,0,3,6,5,370,20,67,12,2,159]),function(le,e,l,M,L,A,R,b,$,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0,e.$8lc=m,e.$6lc=(0,L.$ti)("IExtHostSearch");let C=class{constructor(d,g,a){this.n=d,this.o=g,this.q=a,this.c=this.n.getProxy(M.$UM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$1lc}s(d){return this.o.transformOutgoingScheme(d)}registerTextSearchProvider(d,g){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const a=this.d++;return this.e.set(a,g),this.c.$registerTextSearchProvider(a,this.s(d)),(0,l.$Tc)(()=>{this.g.delete(d),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(d,g){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const a=this.d++;return this.h.set(a,g),this.c.$registerAITextSearchProvider(a,this.s(d)),(0,l.$Tc)(()=>{this.i.delete(d),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(d,g){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const a=this.d++;return this.j.set(a,g),this.c.$registerFileSearchProvider(a,this.s(d)),(0,l.$Tc)(()=>{this.k.delete(d),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(d,g,a,i){const n=m(a),u=this.j.get(d);if(u)return this.l.fileSearch(n,u,o=>{this.c.$handleFileMatch(d,g,o.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,g,a){return{messages:[]}}$clearCache(d){return this.l.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,g,a,i){const n=this.e.get(d);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${d}`);const u=m(a);return this.t(u,n).search(t=>this.c.$handleTextMatch(d,g,t),i)}$provideAITextSearchResults(d,g,a,i){const n=this.h.get(d);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${d}`);const u=m(a);return this.v(u,n).search(t=>this.c.$handleTextMatch(d,g,t),i)}$enableExtensionHostSearch(){}t(d,g){return new N.$2lc({query:d,provider:g},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(d,g){return new N.$2lc({query:d,provider:g},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$7lc=C,e.$7lc=C=Je([Ve(0,R.$hP),Ve(1,b.$Xkc),Ve(2,$.$Zj)],C);function m(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(y),extraFileResources:w.extraFileResources&&w.extraFileResources.map(d=>S.URI.revive(d))}}function y(w){return{...w,folder:S.URI.revive(w.folder)}}}),define(ke[378],Se([1,0,22,13,4,3,15,41,2,135,198,179,79,25,33,12,86,87,276,6,323,349,91,120,327,328,329,310,299,34,330,45,331,96,151,332,312,324,333,334,72,71,325,49,335,69,336,60,28,350,351,313,337,121,338,115,116,314,369,340,282,341,352,342,157,315,343,344,345,20,346,97,117,347,316,348,118,93,95,90,43,155,353,354,326,355,356,70,16,7,317,67,318,92,357,358,150,44,292,114,26,94]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s,c,r,v,f,D,p,E,k,P,I,T,j,z,O,F,B,W,Z,X,Y,x,ne,ge,ue,ve,te,U,_,pe,Pe,se,re,oe,K,ie,$e,we,Ne,fe,De,Ie,Fe,V,q,J,Q,he,be,ze,qe,Ye,it,ot,nt,st,Ce,Be,Ge,Me,Ze,ae,ce,Ae,Ke,Re,tt,ht,wt,Mt,At,xt,_t,Pt,qt,Zt,et,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=Yt;function Yt(dt){const vt=dt.get(ue.$xP),ti=dt.get(ge.$Ikc),Xt=dt.get(x.$6kc),zt=dt.get(X.$Elc),gt=dt.get(Pt.$1kc),Ut=dt.get(st.$BP),Wt=dt.get(E.$4kc),Ht=dt.get(ht.$Xkc),Xe=dt.get(J.$hP),ui=dt.get(it.$mlc),Gt=dt.get(ot.$7kc),Bt=dt.get(d.$1j),mt=dt.get(d.$Zj),Ft=dt.get(Ae.$ZCb),Rt=dt.get(t.$Ekc),Tt=dt.get(_t.$Kmc),ii=dt.get(be.$wlc),Kt=dt.get(W.$dlc),ni=dt.get(re.$Alc),Ot=dt.get(h.$Okc),Nt=dt.get(pe.$tlc);Xe.set(n.$VM.ExtHostFileSystemInfo,ti),Xe.set(n.$VM.ExtHostLogLevelServiceShape,Bt),Xe.set(n.$VM.ExtHostWorkspace,gt),Xe.set(n.$VM.ExtHostConfiguration,Wt),Xe.set(n.$VM.ExtHostExtensionService,zt),Xe.set(n.$VM.ExtHostStorage,ui),Xe.set(n.$VM.ExtHostTunnelService,Ft),Xe.set(n.$VM.ExtHostWindow,Tt),Xe.set(n.$VM.ExtHostSecretState,ii),Xe.set(n.$VM.ExtHostTelemetry,Ut),Xe.set(n.$VM.ExtHostEditorTabs,Kt),Xe.set(n.$VM.ExtHostManagedSockets,ni),Xe.set(n.$VM.ExtHostAuthentication,Ot),Xe.set(n.$VM.ExtHostChatProvider,Nt);const It=Xe.set(n.$VM.ExtHostDecorations,dt.get(I.$Plc)),St=Xe.set(n.$VM.ExtHostDocumentsAndEditors,dt.get(B.$sP)),pt=Xe.set(n.$VM.ExtHostCommands,dt.get(D.$DP)),Ct=Xe.set(n.$VM.ExtHostTerminalService,dt.get(Ce.$plc)),li=Xe.set(n.$VM.ExtHostTerminalShellIntegration,dt.get(Be.$wmc)),Dt=Xe.set(n.$VM.ExtHostDebugService,dt.get(P.$Jlc)),hi=Xe.set(n.$VM.ExtHostSearch,dt.get(he.$6lc)),Jt=Xe.set(n.$VM.ExtHostTask,dt.get(nt.$vmc)),wi=Xe.set(n.$VM.ExtHostOutputService,dt.get(De.$imc)),ei=Xe.set(n.$VM.ExtHostLocalization,dt.get(se.$zlc)),vi=Xe.set(n.$VM.ExtHostUrls,new wt.$Hmc(Xe)),Et=Xe.set(n.$VM.ExtHostDocuments,new F.$Lkc(Xe,St)),$i=Xe.set(n.$VM.ExtHostDocumentContentProviders,new z.$Rlc(Xe,St,mt)),Le=Xe.set(n.$VM.ExtHostDocumentSaveParticipant,new O.$Slc(mt,Et,Xe.getProxy(n.$UM.MainThreadBulkEdits))),je=Xe.set(n.$VM.ExtHostNotebook,new K.$9lc(Xe,pt,St,Et,Xt,hi)),Ee=Xe.set(n.$VM.ExtHostNotebookDocuments,new $e.$cmc(je)),ee=Xe.set(n.$VM.ExtHostNotebookEditors,new we.$dmc(mt,je)),Te=Xe.set(n.$VM.ExtHostNotebookKernels,new Ne.$emc(Xe,vt,je,pt,mt)),He=Xe.set(n.$VM.ExtHostNotebookRenderers,new fe.$gmc(Xe,je)),_e=Xe.set(n.$VM.ExtHostNotebookDocumentSaveParticipant,new ie.$bmc(mt,je,Xe.getProxy(n.$UM.MainThreadBulkEdits))),Qe=Xe.set(n.$VM.ExtHostEditors,new Me.$Ukc(Xe,St)),lt=Xe.set(n.$VM.ExtHostTreeViews,new ce.$Fmc(Xe.getProxy(n.$UM.MainThreadTreeViews),pt,mt)),kt=Xe.set(n.$VM.ExtHostEditorInsets,new f.$Vkc(Xe.getProxy(n.$UM.MainThreadEditorInsets),Qe,vt.remote)),jt=Xe.set(n.$VM.ExtHostDiagnostics,new T.$Kkc(Xe,mt,ti,St)),Vt=Xe.set(n.$VM.ExtHostLanguages,new Pe.$_lc(Xe,Et,pt.converter,Ht)),ut=Xe.set(n.$VM.ExtHostLanguageFeatures,new _.$Mkc(Xe,Ht,Et,pt,jt,mt,Rt,Ut)),ri=Xe.set(n.$VM.ExtHostFileSystem,new Y.$Ulc(Xe,ut)),di=Xe.set(n.$VM.ExtHostFileSystemEventService,new ne.$Vlc(Xe,mt,St)),pi=Xe.set(n.$VM.ExtHostQuickOpen,(0,q.$mmc)(Xe,gt,pt)),Di=Xe.set(n.$VM.ExtHostSCM,new Q.$omc(Xe,pt,Et,mt)),Ai=Xe.set(n.$VM.ExtHostQuickDiff,new V.$lmc(Xe,Ht)),Ri=Xe.set(n.$VM.ExtHostShare,new ze.$pmc(Xe,Ht)),Li=Xe.set(n.$VM.ExtHostComments,(0,p.$Wkc)(Xe,pt,Et)),Mi=Xe.set(n.$VM.ExtHostProgress,new Fe.$kmc(Xe.getProxy(n.$UM.MainThreadProgress))),cn=Xe.set(n.$VM.ExtHostLabelService,new U.$$lc(Xe)),Oi=Xe.set(n.$VM.ExtHostTheming,new Ze.$Cmc(Xe)),Fi=Xe.set(n.$VM.ExtHostTimeline,new ae.$Emc(Xe,pt)),yi=Xe.set(n.$VM.ExtHostWebviews,new Mt.$$kc(Xe,vt.remote,gt,mt,Rt)),Ci=Xe.set(n.$VM.ExtHostWebviewPanels,new At.$blc(Xe,yi,gt)),Gi=Xe.set(n.$VM.ExtHostCustomEditors,new k.$clc(Xe,Et,Gt,yi,Ci)),Ki=Xe.set(n.$VM.ExtHostWebviewViews,new xt.$Imc(Xe,yi)),bi=Xe.set(n.$VM.ExtHostTesting,new Ge.$ymc(Xe,mt,pt,St)),Ji=Xe.set(n.$VM.ExtHostUriOpeners,new tt.$Gmc(Xe)),Qi=Xe.set(n.$VM.ExtHostProfileContentHandlers,new Ie.$jmc(Xe));Xe.set(n.$VM.ExtHostInteractive,new te.$0lc(Xe,je,St,pt,mt));const un=Xe.set(n.$VM.ExtHostInlineChat,new ve.$Wlc(Xe,pt,Et,mt)),Ti=Xe.set(n.$VM.ExtHostChatAgents2,new c.$Rkc(Xe,mt,pt)),ji=Xe.set(n.$VM.ExtHostChatVariables,new r.$Skc(Xe)),Pi=Xe.set(n.$VM.ExtHostAiRelatedInformation,new u.$Dkc(Xe)),ln=Xe.set(n.$VM.ExtHostAiEmbeddingVector,new Z.$Tlc(Xe)),Zi=Xe.set(n.$VM.ExtHostStatusBar,new Ye.$smc(Xe,pt.converter)),Yi=Xe.set(n.$VM.ExtHostSpeech,new qe.$qmc(Xe)),hn=Object.values(n.$VM);Xe.assertRegistered(hn);const zi=new s.$Qkc(Xe,St),Xi=new v.$Tkc(Xe),Ii=new oe.$amc(Xe,mt),Bi=new j.$Qlc(Xe);return o.$Nkc.register(pt),function(We,oi,Ui){function at(de){return(ye,Ue,ct)=>{const yt=de(Lt=>{try{ye.call(Ue,Lt)}catch(Si){M.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ut.onExtensionError(We.identifier,Si)}});return ct?.push(yt),yt}}const bt=function(){let de=!We.isUnderDevelopment;function ye(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ye();else{const yt=ct;typeof yt.scheme>"u"&&ye(),typeof yt.exclusive=="boolean"&&(0,et.$CG)(We,"documentFiltersExclusive")}return ct}}(),dn={getSession(de,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$CG)(We,"authLearnMore"),Ot.getSession(We,de,ye,Ue)},getSessions(de,ye){return(0,et.$CG)(We,"authGetSessions"),Ot.getSessions(We,de,ye)},async hasSession(de,ye){return(0,et.$CG)(We,"authSession"),!!await Ot.getSession(We,de,ye,{silent:!0})},get onDidChangeSessions(){return at(Ot.onDidChangeSessions)},registerAuthenticationProvider(de,ye,Ue,ct){return Ot.registerAuthenticationProvider(de,ye,Ue,ct)}},ai={registerCommand(de,ye,Ue){return pt.registerCommand(!0,de,ye,Ue,void 0,We)},registerTextEditorCommand(de,ye,Ue){return pt.registerCommand(!0,de,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Lt=>{ye.apply(Ue,[yt,Lt,...ct])}).then(Lt=>{Lt||mt.warn("Edits from command "+de+" were not applied.")},Lt=>{mt.warn("An error occurred while running command "+de,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ye,Ue)=>((0,et.$CG)(We,"diffCommand"),pt.registerCommand(!0,de,async(...ct)=>{const yt=St.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Lt=await Qe.getDiffInformation(yt.id);ye.apply(Ue,[Lt,...ct])},void 0,void 0,We)),executeCommand(de,...ye){return pt.executeCommand(de,...ye)},getCommands(de=!1){return pt.getCommands(de)}},Ei={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Xi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$CG)(We,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$CG)(We,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$AP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ye){return st.$zP.validateSender(de),Ut.instantiateLogger(We,de,ye)},openExternal(de,ye){return Tt.openUri(de,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===vt.environment.appUriScheme)return vi.createAppUri(de);try{return await Tt.asExternalUri(de,{allowTunneling:!!vt.remote.authority})}catch(ye){if((0,R.$Cg)(de,R.Schemas.http)||(0,R.$Cg)(de,R.Schemas.https))return de;throw ye}},get remoteName(){return(0,g.$Fm)(vt.remote.authority)},get remoteAuthority(){return(0,et.$CG)(We,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$CG)(We,"resolvers"),vt.quality},get appCommit(){return(0,et.$CG)(We,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ei);const xi={createTestController(de,ye,Ue){return bi.createTestController(We,de,ye,Ue)},createTestObserver(){return(0,et.$CG)(We,"testObserver"),bi.createTestObserver()},runTests(de){return(0,et.$CG)(We,"testObserver"),bi.runTests(de)},get onDidChangeTestResults(){return(0,et.$CG)(We,"testObserver"),at(bi.onResultsChanged)},get testResults(){return(0,et.$CG)(We,"testObserver"),bi.results}},ki=vt.remote.isRemote?Re.ExtensionKind.Workspace:Re.ExtensionKind.UI,_i={getExtension(de,ye){(0,et.$BG)(We,"extensionsAny")||(ye=!1);const Ue=oi.mine.getExtensionDescription(de);if(Ue)return new X.$Flc(zt,We.identifier,Ue,ki,!1);if(ye){const ct=oi.all.getExtensionDescription(de);if(ct)return new X.$Flc(zt,We.identifier,ct,ki,!0)}},get all(){const de=[];for(const ye of oi.mine.getAllExtensionDescriptions())de.push(new X.$Flc(zt,We.identifier,ye,ki,!1));return de},get allAcrossExtensionHosts(){(0,et.$CG)(We,"extensionsAny");const de=new y.$Pm(oi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of oi.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ye.push(new X.$Flc(zt,We.identifier,Ue,ki,ct))}return ye},get onDidChange(){return(0,et.$BG)(We,"extensionsAny")?at(L.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):at(oi.mine.onDidChange)}},en={createDiagnosticCollection(de){return jt.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:de=>jt.getDiagnostics(de),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(de,ye){return Vt.changeLanguage(de.uri,ye)},match(de,ye){const Ue=Ke.LanguageSelector.from(de);let ct;return(0,N.$1t)(Ue)&&(ct=je.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Lt=>Lt.document===ye))?.apiNotebook),(0,N.$Zt)(Ue,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ye,Ue){return ut.registerCodeActionProvider(We,bt(de),ye,Ue)},registerDocumentPasteEditProvider(de,ye,Ue){return(0,et.$CG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,bt(de),ye,Ue)},registerCodeLensProvider(de,ye){return ut.registerCodeLensProvider(We,bt(de),ye)},registerDefinitionProvider(de,ye){return ut.registerDefinitionProvider(We,bt(de),ye)},registerDeclarationProvider(de,ye){return ut.registerDeclarationProvider(We,bt(de),ye)},registerImplementationProvider(de,ye){return ut.registerImplementationProvider(We,bt(de),ye)},registerTypeDefinitionProvider(de,ye){return ut.registerTypeDefinitionProvider(We,bt(de),ye)},registerHoverProvider(de,ye){return ut.registerHoverProvider(We,bt(de),ye,We.identifier)},registerEvaluatableExpressionProvider(de,ye){return ut.registerEvaluatableExpressionProvider(We,bt(de),ye,We.identifier)},registerInlineValuesProvider(de,ye){return ut.registerInlineValuesProvider(We,bt(de),ye,We.identifier)},registerDocumentHighlightProvider(de,ye){return ut.registerDocumentHighlightProvider(We,bt(de),ye)},registerMultiDocumentHighlightProvider(de,ye){return ut.registerMultiDocumentHighlightProvider(We,bt(de),ye)},registerLinkedEditingRangeProvider(de,ye){return ut.registerLinkedEditingRangeProvider(We,bt(de),ye)},registerReferenceProvider(de,ye){return ut.registerReferenceProvider(We,bt(de),ye)},registerRenameProvider(de,ye){return ut.registerRenameProvider(We,bt(de),ye)},registerNewSymbolNamesProvider(de,ye){return(0,et.$CG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,bt(de),ye)},registerDocumentSymbolProvider(de,ye,Ue){return ut.registerDocumentSymbolProvider(We,bt(de),ye,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ye){return ut.registerDocumentFormattingEditProvider(We,bt(de),ye)},registerDocumentRangeFormattingEditProvider(de,ye){return ut.registerDocumentRangeFormattingEditProvider(We,bt(de),ye)},registerOnTypeFormattingEditProvider(de,ye,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,bt(de),ye,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentSemanticTokensProvider(We,bt(de),ye,Ue)},registerDocumentRangeSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,bt(de),ye,Ue)},registerSignatureHelpProvider(de,ye,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,bt(de),ye,Ue):ut.registerSignatureHelpProvider(We,bt(de),ye,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ye,...Ue){return ut.registerCompletionItemProvider(We,bt(de),ye,Ue)},registerInlineCompletionItemProvider(de,ye,Ue){return ye.handleDidShowCompletionItem&&(0,et.$CG)(We,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$CG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$CG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,bt(de),ye,Ue)},registerInlineEditProvider(de,ye){return(0,et.$CG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,bt(de),ye)},registerDocumentLinkProvider(de,ye){return ut.registerDocumentLinkProvider(We,bt(de),ye)},registerColorProvider(de,ye){return ut.registerColorProvider(We,bt(de),ye)},registerFoldingRangeProvider(de,ye){return ut.registerFoldingRangeProvider(We,bt(de),ye)},registerSelectionRangeProvider(de,ye){return ut.registerSelectionRangeProvider(We,de,ye)},registerCallHierarchyProvider(de,ye){return ut.registerCallHierarchyProvider(We,de,ye)},registerTypeHierarchyProvider(de,ye){return ut.registerTypeHierarchyProvider(We,de,ye)},setLanguageConfiguration:(de,ye)=>ut.setLanguageConfiguration(We,de,ye),getTokenInformationAtPosition(de,ye){return(0,et.$CG)(We,"tokenInformation"),Vt.tokenAtPosition(de,ye)},registerInlayHintsProvider(de,ye){return ut.registerInlayHintsProvider(We,de,ye)},createLanguageStatusItem(de,ye){return Vt.createLanguageStatusItem(We,de,ye)},registerDocumentDropEditProvider(de,ye,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ye,(0,et.$BG)(We,"documentPaste")?Ue:void 0)}},fn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(de,ye,Ue){$.URI.isUri(de)&&de.scheme===R.Schemas.vscodeRemote&&!de.authority&&Rt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(de)?Promise.resolve(Wi.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ye,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ye,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ye,Ue)},onDidChangeVisibleTextEditors(de,ye,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ye,Ue)},onDidChangeTextEditorSelection(de,ye,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ye,Ue)},onDidChangeTextEditorOptions(de,ye,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ye,Ue)},onDidChangeTextEditorVisibleRanges(de,ye,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ye,Ue)},onDidChangeTextEditorViewColumn(de,ye,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ye,Ue)},onDidCloseTerminal(de,ye,Ue){return at(Ct.onDidCloseTerminal)(de,ye,Ue)},onDidOpenTerminal(de,ye,Ue){return at(Ct.onDidOpenTerminal)(de,ye,Ue)},onDidChangeActiveTerminal(de,ye,Ue){return at(Ct.onDidChangeActiveTerminal)(de,ye,Ue)},onDidChangeTerminalDimensions(de,ye,Ue){return(0,et.$CG)(We,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(de,ye,Ue)},onDidChangeTerminalState(de,ye,Ue){return at(Ct.onDidChangeTerminalState)(de,ye,Ue)},onDidWriteTerminalData(de,ye,Ue){return(0,et.$CG)(We,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(de,ye,Ue)},onDidExecuteTerminalCommand(de,ye,Ue){return(0,et.$CG)(We,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(de,ye,Ue)},onDidChangeTerminalShellIntegration(de,ye,Ue){return(0,et.$CG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ye,Ue)},onDidStartTerminalShellExecution(de,ye,Ue){return(0,et.$CG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ye,Ue)},onDidEndTerminalShellExecution(de,ye,Ue){return(0,et.$CG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ye,Ue)},get state(){return Tt.getState()},onDidChangeWindowState(de,ye,Ue){return at(Tt.onDidChangeWindowState)(de,ye,Ue)},showInformationMessage(de,...ye){return Ii.showMessage(We,b.default.Info,de,ye[0],ye.slice(1))},showWarningMessage(de,...ye){return Ii.showMessage(We,b.default.Warning,de,ye[0],ye.slice(1))},showErrorMessage(de,...ye){return Ii.showMessage(We,b.default.Error,de,ye[0],ye.slice(1))},showQuickPick(de,ye,Ue){return pi.showQuickPick(We,de,ye,Ue)},showWorkspaceFolderPick(de){return pi.showWorkspaceFolderPick(de)},showInputBox(de,ye){return pi.showInput(de,ye)},showOpenDialog(de){return Bi.showOpenDialog(We,de)},showSaveDialog(de){return Bi.showSaveDialog(de)},createStatusBarItem(de,ye,Ue){let ct,yt,Lt;return typeof de=="string"?(ct=de,yt=ye,Lt=Ue):(yt=de,Lt=ye),Zi.createStatusBarEntry(We,ct,yt,Lt)},setStatusBarMessage(de,ye){return Zi.setStatusBarMessage(de,ye)},withScmProgress(de){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Mi.withProgress(We,{location:Re.ProgressLocation.SourceControl},(ye,Ue)=>de({report(ct){}}))},withProgress(de,ye){return Mi.withProgress(We,de,ye)},createOutputChannel(de,ye){return wi.createOutputChannel(de,ye,We)},createWebviewPanel(de,ye,Ue,ct){return Ci.createWebviewPanel(We,de,ye,Ue,ct)},createWebviewTextEditorInset(de,ye,Ue,ct){return(0,et.$CG)(We,"editorInsets"),kt.createWebviewEditorInset(de,ye,Ue,ct,We)},createTerminal(de,ye,Ue){return typeof de=="object"?"pty"in de?Ct.createExtensionTerminal(de):Ct.createTerminalFromOptions(de):Ct.createTerminal(de,ye,Ue)},registerTerminalLinkProvider(de){return Ct.registerLinkProvider(de)},registerTerminalProfileProvider(de,ye){return Ct.registerProfileProvider(We,de,ye)},registerTerminalQuickFixProvider(de,ye){return(0,et.$CG)(We,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(de,We.identifier.value,ye)},registerTreeDataProvider(de,ye){return lt.registerTreeDataProvider(de,ye,We)},createTreeView(de,ye){return lt.createTreeView(de,ye,We)},registerWebviewPanelSerializer:(de,ye)=>Ci.registerWebviewPanelSerializer(We,de,ye),registerCustomEditorProvider:(de,ye,Ue={})=>Gi.registerCustomEditorProvider(We,de,ye,Ue),registerFileDecorationProvider(de){return It.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vi.registerUriHandler(We,de)},createQuickPick(){return pi.createQuickPick(We)},createInputBox(){return pi.createInputBox(We)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(de,ye,Ue){return at(Oi.onDidChangeActiveColorTheme)(de,ye,Ue)},registerWebviewViewProvider(de,ye,Ue){return Ki.registerWebviewViewProvider(We,de,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return je.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ye,Ue){return at(je.onDidChangeActiveNotebookEditor)(de,ye,Ue)},get visibleNotebookEditors(){return je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ye,Ue){return at(ee.onDidChangeNotebookEditorSelection)(de,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ye,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(de,ye,Ue)},showNotebookDocument(de,ye){return je.showNotebookDocument(de,ye)},registerExternalUriOpener(de,ye,Ue){return(0,et.$CG)(We,"externalUriOpener"),Ji.registerExternalUriOpener(We.identifier,de,ye,Ue)},registerProfileContentHandler(de,ye){return(0,et.$CG)(We,"profileContentHandlers"),Qi.registerProfileContentHandler(We,de,ye)},registerQuickDiffProvider(de,ye,Ue,ct){return(0,et.$CG)(We,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt(de),ye,Ue,ct)},get tabGroups(){return Kt.tabGroups},registerShareProvider(de,ye){return(0,et.$CG)(We,"shareProvider"),Ri.registerShareProvider(bt(de),ye)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new M.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new M.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(de,ye,...Ue)=>gt.updateWorkspaceFolders(We,de,ye||0,...Ue),onDidChangeWorkspaceFolders:function(de,ye,Ue){return at(gt.onDidChangeWorkspace)(de,ye,Ue)},asRelativePath:(de,ye)=>gt.getRelativePath(de,ye),findFiles:(de,ye,Ue,ct)=>gt.findFiles(de,ye,Ue,We.identifier,ct),findFiles2:(de,ye,Ue)=>((0,et.$CG)(We,"findFiles2"),gt.findFiles2(de,ye,We.identifier,Ue)),findTextInFiles:(de,ye,Ue,ct)=>{(0,et.$CG)(We,"findTextInFiles");let yt,Lt;return typeof ye=="object"?(yt=ye,Lt=Ue):(yt={},Lt=ye,ct=Ue),gt.findTextInFiles(de,yt||{},Lt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ye){return zi.applyWorkspaceEdit(de,We,ye)},createFileSystemWatcher:(de,ye,Ue,ct)=>{let yt;return typeof ye=="boolean"?yt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,et.$CG)(We,"createFileSystemWatcher"),yt={...ye,correlate:!0}),di.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return Et.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new M.$9("textDocuments")},openTextDocument(de){let ye;const Ue=de;if(typeof de=="string")ye=Promise.resolve($.URI.file(de));else if($.URI.isUri(de))ye=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ye=Et.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Et.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ye,Ue)=>at(Et.onDidAddDocument)(de,ye,Ue),onDidCloseTextDocument:(de,ye,Ue)=>at(Et.onDidRemoveDocument)(de,ye,Ue),onDidChangeTextDocument:(de,ye,Ue)=>at(Et.onDidChangeDocument)(de,ye,Ue),onDidSaveTextDocument:(de,ye,Ue)=>at(Et.onDidSaveDocument)(de,ye,Ue),onWillSaveTextDocument:(de,ye,Ue)=>at(Le.getOnWillSaveTextDocumentEvent(We))(de,ye,Ue),get notebookDocuments(){return je.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ye){let Ue;if($.URI.isUri(de))Ue=de,await je.openNotebookDocument(de);else if(typeof de=="string")Ue=$.URI.revive(await je.createNotebookDocument({viewType:de,content:ye}));else throw new Error("Invalid arguments");return je.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ye,Ue){return at(Ee.onDidSaveNotebookDocument)(de,ye,Ue)},onDidChangeNotebookDocument(de,ye,Ue){return at(Ee.onDidChangeNotebookDocument)(de,ye,Ue)},onWillSaveNotebookDocument(de,ye,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ye,Ue)},get onDidOpenNotebookDocument(){return at(je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(je.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ye,Ue,ct){return je.registerNotebookSerializer(We,de,ye,Ue,(0,et.$BG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ye,Ue)=>at(Ui.onDidChangeConfiguration)(de,ye,Ue),getConfiguration(de,ye){return ye=arguments.length===1?void 0:ye,Ui.getConfiguration(de,ye,We)},registerTextDocumentContentProvider(de,ye){return $i.registerTextDocumentContentProvider(de,ye)},registerTaskProvider:(de,ye)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(We,de,ye)),registerFileSystemProvider(de,ye,Ue){return(0,A.$Sc)(ri.registerFileSystemProvider(We,de,ye,Ue),Xt.addFileSystemProvider(de,ye,Ue))},get fs(){return Xt.value},registerFileSearchProvider:(de,ye)=>((0,et.$CG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ye)),registerTextSearchProvider:(de,ye)=>((0,et.$CG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ye)),registerAITextSearchProvider:(de,ye)=>((0,et.$CG)(We,"aiTextSearchProvider"),(0,et.$CG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ye)),registerRemoteAuthorityResolver:(de,ye)=>((0,et.$CG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ye)),registerResourceLabelFormatter:de=>((0,et.$CG)(We,"resolvers"),cn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$CG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ye,Ue)=>at(di.onDidCreateFile)(de,ye,Ue),onDidDeleteFiles:(de,ye,Ue)=>at(di.onDidDeleteFile)(de,ye,Ue),onDidRenameFiles:(de,ye,Ue)=>at(di.onDidRenameFile)(de,ye,Ue),onWillCreateFiles:(de,ye,Ue)=>at(di.getOnWillCreateFileEvent(We))(de,ye,Ue),onWillDeleteFiles:(de,ye,Ue)=>at(di.getOnWillDeleteFileEvent(We))(de,ye,Ue),onWillRenameFiles:(de,ye,Ue)=>at(di.getOnWillRenameFileEvent(We))(de,ye,Ue),openTunnel:de=>((0,et.$CG)(We,"tunnels"),Ft.openTunnel(We,de).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$CG)(We,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(de,ye,Ue)=>((0,et.$CG)(We,"tunnels"),at(Ft.onDidChangeTunnels)(de,ye,Ue)),registerPortAttributesProvider:(de,ye)=>((0,et.$CG)(We,"portsAttributes"),Ft.registerPortsAttributesProvider(de,ye)),registerTunnelProvider:(de,ye)=>((0,et.$CG)(We,"tunnelFactory"),Ft.registerTunnelProvider(de,ye)),registerTimelineProvider:(de,ye)=>((0,et.$CG)(We,"timeline"),Fi.registerTimelineProvider(de,ye,We.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$CG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ye,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ye,Ue),registerEditSessionIdentityProvider:(de,ye)=>((0,et.$CG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ye)),onWillCreateEditSessionIdentity:(de,ye,Ue)=>((0,et.$CG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ye,Ue)),registerCanonicalUriProvider:(de,ye)=>((0,et.$CG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ye)),getCanonicalUri:(de,ye,Ue)=>((0,et.$CG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ye,Ue))},tn={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(de,ye,Ue){return Di.createSourceControl(We,de,ye,Ue)}},gn={createCommentController(de,ye){return Li.createCommentController(We,de,ye)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$BG)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(de,ye){return(0,et.$CG)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,de,ye)},registerDebugVisualizationTreeProvider(de,ye){return(0,et.$CG)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,de,ye)},onDidStartDebugSession(de,ye,Ue){return at(Dt.onDidStartDebugSession)(de,ye,Ue)},onDidTerminateDebugSession(de,ye,Ue){return at(Dt.onDidTerminateDebugSession)(de,ye,Ue)},onDidChangeActiveDebugSession(de,ye,Ue){return at(Dt.onDidChangeActiveDebugSession)(de,ye,Ue)},onDidReceiveDebugSessionCustomEvent(de,ye,Ue){return at(Dt.onDidReceiveDebugSessionCustomEvent)(de,ye,Ue)},onDidChangeBreakpoints(de,ye,Ue){return at(Dt.onDidChangeBreakpoints)(de,ye,Ue)},onDidChangeActiveStackItem(de,ye,Ue){return(0,et.$CG)(We,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(de,ye,Ue)},registerDebugConfigurationProvider(de,ye,Ue){return Dt.registerDebugConfigurationProvider(de,ye,Ue||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ye){return Dt.registerDebugAdapterDescriptorFactory(We,de,ye)},registerDebugAdapterTrackerFactory(de,ye){return Dt.registerDebugAdapterTrackerFactory(de,ye)},startDebugging(de,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,ye,{parentSession:Ue}):Dt.startDebugging(de,ye,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,ye){return Dt.asDebugSourceUri(de,ye)}},nn={registerTaskProvider:(de,ye)=>Jt.registerTaskProvider(We,de,ye),fetchTasks:de=>Jt.fetchTasks(de),executeTask:de=>Jt.executeTask(We,de),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(de,ye,Ue)=>at(Jt.onDidStartTask)(de,ye,Ue),onDidEndTask:(de,ye,Ue)=>at(Jt.onDidEndTask)(de,ye,Ue),onDidStartTaskProcess:(de,ye,Ue)=>at(Jt.onDidStartTaskProcess)(de,ye,Ue),onDidEndTaskProcess:(de,ye,Ue)=>at(Jt.onDidEndTaskProcess)(de,ye,Ue)},Vi={createNotebookController(de,ye,Ue,ct,yt){return Te.createNotebookController(We,de,ye,Ue,ct,(0,et.$BG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ye)=>je.registerNotebookCellStatusBarItemProvider(We,de,ye),createRendererMessaging(de){return He.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$CG)(We,"notebookKernelSource"),Te.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ye){return(0,et.$CG)(We,"notebookKernelSource"),Te.registerKernelSourceActionProvider(We,de,ye)},onDidChangeNotebookCellExecutionState(de,ye,Ue){return(0,et.$CG)(We,"notebookCellExecutionState"),at(Te.onDidChangeNotebookCellExecutionState)(de,ye,Ue)}},rn={t(...de){if(typeof de[0]=="string"){const ye=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return ei.getMessage(We.identifier.value,{message:ye,args:Ue})}return ei.getMessage(We.identifier.value,de[0])},get bundle(){return ei.getBundle(We.identifier.value)},get uri(){return ei.getBundleUri(We.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(de,ye){return(0,et.$CG)(We,"interactive"),un.registerProvider(We,de,ye)},transferActiveChat(de){return(0,et.$CG)(We,"interactive"),Ti.transferActiveChat(de)}},on={getRelatedInformation(de,ye){return(0,et.$CG)(We,"aiRelatedInformation"),Pi.getRelatedInformation(We,de,ye)},registerRelatedInformationProvider(de,ye){return(0,et.$CG)(We,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(We,de,ye)},registerEmbeddingVectorProvider(de,ye){return(0,et.$CG)(We,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(We,de,ye)}},$n={registerChatResponseProvider(de,ye,Ue){return(0,et.$CG)(We,"chatProvider"),Nt.registerLanguageModel(We,de,ye,Ue)},registerChatVariableResolver(de,ye,Ue){return(0,et.$CG)(We,"chatVariableResolver"),ji.registerVariableResolver(We,de,ye,Ue)},registerMappedEditsProvider(de,ye){return(0,et.$CG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ye)},createChatParticipant(de,ye){return(0,et.$CG)(We,"chatParticipant"),Ti.createChatAgent(We,de,ye)},createDynamicChatParticipant(de,ye,Ue,ct){return(0,et.$CG)(We,"chatParticipantAdditions"),Ti.createDynamicChatAgent(We,de,ye,Ue,ct)}},pn={get languageModels(){return(0,et.$CG)(We,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(de,ye,Ue)=>((0,et.$CG)(We,"languageModels"),Nt.onDidChangeProviders(de,ye,Ue)),sendChatRequest(de,ye,Ue,ct){return(0,et.$CG)(We,"languageModels"),Nt.sendChatRequest(We,de,ye,Ue,ct)},computeTokenLength(de,ye,Ue){return(0,et.$CG)(We,"languageModels"),Ue??=l.CancellationToken.None,Nt.computeTokenLength(de,ye,Ue)},getLanguageModelInformation(de){return(0,et.$CG)(We,"languageModels"),Nt.getLanguageModelInfo(de)}},an={registerSpeechProvider(de,ye){return(0,et.$CG)(We,"speech"),Yi.registerProvider(We.identifier,de,ye)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:Ei,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:Re.$WN,TerminalOutputAnchor:Re.TerminalOutputAnchor,ChatResultFeedbackKind:Re.ChatResultFeedbackKind,ChatVariableLevel:Re.ChatVariableLevel,ChatCompletionItem:Re.$RO,CallHierarchyIncomingCall:Re.$iN,CallHierarchyItem:Re.$hN,CallHierarchyOutgoingCall:Re.$jN,CancellationError:M.$5,CancellationTokenSource:l.$ne,CandidatePortSource:n.CandidatePortSource,CodeAction:Re.$eN,CodeActionKind:Re.$fN,CodeActionTriggerKind:Re.CodeActionTriggerKind,CodeLens:Re.$kN,Color:Re.$xN,ColorInformation:Re.$yN,ColorPresentation:Re.$zN,ColorThemeKind:Re.ColorThemeKind,CommentMode:Re.CommentMode,CommentState:Re.CommentState,CommentThreadCollapsibleState:Re.CommentThreadCollapsibleState,CommentThreadState:Re.CommentThreadState,CommentThreadApplicability:Re.CommentThreadApplicability,CompletionItem:Re.$rN,CompletionItemKind:Re.CompletionItemKind,CompletionItemTag:Re.CompletionItemTag,CompletionList:Re.$sN,CompletionTriggerKind:Re.CompletionTriggerKind,ConfigurationTarget:Re.ConfigurationTarget,CustomExecution:Re.$HN,DebugAdapterExecutable:Re.$1N,DebugAdapterInlineImplementation:Re.$4N,DebugAdapterNamedPipeServer:Re.$3N,DebugAdapterServer:Re.$2N,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Re.DebugConsoleMode,DebugVisualization:Re.$hO,DecorationRangeBehavior:Re.DecorationRangeBehavior,Diagnostic:Re.$$M,DiagnosticRelatedInformation:Re.$0M,DiagnosticSeverity:Re.DiagnosticSeverity,DiagnosticTag:Re.DiagnosticTag,Disposable:Re.$WM,DocumentHighlight:Re.$aN,DocumentHighlightKind:Re.DocumentHighlightKind,MultiDocumentHighlight:Re.$bN,DocumentLink:Re.$wN,DocumentSymbol:Re.$dN,EndOfLine:Re.EndOfLine,EnvironmentVariableMutatorType:Re.EnvironmentVariableMutatorType,EvaluatableExpression:Re.$7N,InlineValueText:Re.$8N,InlineValueVariableLookup:Re.$9N,InlineValueEvaluatableExpression:Re.$0N,InlineCompletionTriggerKind:Re.InlineCompletionTriggerKind,EventEmitter:L.$ce,ExtensionKind:Re.ExtensionKind,ExtensionMode:Re.ExtensionMode,ExternalUriOpenerPriority:Re.ExternalUriOpenerPriority,FileChangeType:Re.FileChangeType,FileDecoration:Re.$jO,FileDecoration2:Re.$jO,FileSystemError:Re.$aO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Re.$bO,FoldingRangeKind:Re.FoldingRangeKind,FunctionBreakpoint:Re.$YN,InlineCompletionItem:Re.$tN,InlineCompletionList:Re.$uN,Hover:Re.$_M,IndentAction:C.IndentAction,Location:Re.$9M,MarkdownString:Re.$lN,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Re.$mN,PortAutoForwardAction:Re.PortAutoForwardAction,Position:Re.$XM,ProcessExecution:Re.$FN,ProgressLocation:Re.ProgressLocation,QuickInputButtons:Re.$iO,Range:Re.$YM,RelativePattern:Re.$UN,Selection:Re.$ZM,SelectionRange:Re.$gN,SemanticTokens:Re.$eO,SemanticTokensBuilder:Re.$dO,SemanticTokensEdit:Re.$fO,SemanticTokensEdits:Re.$gO,SemanticTokensLegend:Re.$cO,ShellExecution:Re.$GN,ShellQuoting:Re.ShellQuoting,SignatureHelp:Re.$oN,SignatureHelpTriggerKind:Re.SignatureHelpTriggerKind,SignatureInformation:Re.$nN,SnippetString:Re.$8M,SourceBreakpoint:Re.$XN,StandardTokenType:Re.StandardTokenType,StatusBarAlignment:Re.StatusBarAlignment,SymbolInformation:Re.$cN,SymbolKind:Re.SymbolKind,SymbolTag:Re.SymbolTag,Task:Re.$IN,TaskGroup:Re.$EN,TaskPanelKind:Re.TaskPanelKind,TaskRevealKind:Re.TaskRevealKind,TaskScope:Re.TaskScope,TerminalLink:Re.$AN,TerminalQuickFixTerminalCommand:Re.$CN,TerminalQuickFixOpener:Re.$BN,TerminalLocation:Re.TerminalLocation,TerminalProfile:Re.$DN,TerminalExitReason:Re.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Re.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Re.TextDocumentSaveReason,TextEdit:Re.$4M,SnippetTextEdit:Re.$6M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Re.TextEditorLineNumbersStyle,TextEditorRevealType:Re.TextEditorRevealType,TextEditorSelectionChangeKind:Re.TextEditorSelectionChangeKind,SyntaxTokenType:Re.SyntaxTokenType,TextDocumentChangeReason:Re.TextDocumentChangeReason,ThemeColor:Re.$TN,ThemeIcon:Re.$SN,TreeItem:Re.$JN,TreeItemCheckboxState:Re.TreeItemCheckboxState,TreeItemCollapsibleState:Re.TreeItemCollapsibleState,TypeHierarchyItem:Re.$FO,UIKind:Zt.UIKind,Uri:$.URI,ViewColumn:Re.ViewColumn,WorkspaceEdit:Re.$7M,DocumentPasteTriggerKind:Re.DocumentPasteTriggerKind,DocumentDropEdit:Re.$PN,DocumentDropOrPasteEditKind:Re.$QN,DocumentPasteEdit:Re.$RN,InlayHint:Re.$qN,InlayHintLabelPart:Re.$pN,InlayHintKind:Re.InlayHintKind,RemoteAuthorityResolverError:Re.$3M,ResolvedAuthority:Re.$1M,ManagedResolvedAuthority:Re.$2M,SourceControlInputBoxValidationType:Re.SourceControlInputBoxValidationType,ExtensionRuntime:Re.ExtensionRuntime,TimelineItem:Re.$tO,NotebookRange:Re.$lO,NotebookCellKind:Re.NotebookCellKind,NotebookCellExecutionState:Re.NotebookCellExecutionState,NotebookCellData:Re.$mO,NotebookData:Re.$nO,NotebookRendererScript:Re.$rO,NotebookCellStatusBarAlignment:Re.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Re.NotebookEditorRevealType,NotebookCellOutput:Re.$pO,NotebookCellOutputItem:Re.$oO,NotebookCellStatusBarItem:Re.$qO,NotebookControllerAffinity:Re.NotebookControllerAffinity,NotebookControllerAffinity2:Re.NotebookControllerAffinity2,NotebookEdit:Re.$5M,NotebookKernelSourceAction:Re.$sO,NotebookVariablesRequestKind:Re.NotebookVariablesRequestKind,PortAttributes:Re.$vO,LinkedEditingRanges:Re.$uO,TestResultState:Re.TestResultState,TestRunRequest:Re.$wO,TestMessage:Re.$xO,TestTag:Re.$yO,TestRunProfileKind:Re.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:Re.$ON,DataTransferItem:Re.$KN,TestCoverageCount:Re.$zO,FileCoverage:Re.$BO,StatementCoverage:Re.$CO,BranchCoverage:Re.$DO,DeclarationCoverage:Re.$EO,WorkspaceTrustState:Re.WorkspaceTrustState,LanguageStatusSeverity:Re.LanguageStatusSeverity,QuickPickItemKind:Re.QuickPickItemKind,InputBoxValidationSeverity:Re.InputBoxValidationSeverity,TabInputText:Re.$GO,TabInputTextDiff:Re.$HO,TabInputTextMerge:Re.$IO,TabInputCustom:Re.$JO,TabInputNotebook:Re.$LO,TabInputNotebookDiff:Re.$MO,TabInputWebview:Re.$KO,TabInputTerminal:Re.$NO,TabInputInteractiveWindow:Re.$OO,TabInputChat:Re.$PO,TabInputTextMultiDiff:Re.$QO,TelemetryTrustedValue:a.$cp,LogLevel:d.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Re.InteractiveSessionVoteDirection,ChatCopyKind:Re.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Re.InteractiveEditorResponseFeedbackKind,StackFrame:Re.$5N,Thread:Re.$6N,RelatedInformationType:Re.RelatedInformationType,SpeechToTextStatus:Re.SpeechToTextStatus,PartialAcceptTriggerKind:Re.PartialAcceptTriggerKind,KeywordRecognitionStatus:Re.KeywordRecognitionStatus,ChatResponseMarkdownPart:Re.$SO,ChatResponseFileTreePart:Re.$VO,ChatResponseAnchorPart:Re.$WO,ChatResponseProgressPart:Re.$XO,ChatResponseReferencePart:Re.$ZO,ChatResponseTextEditPart:Re.$1O,ChatResponseMarkdownWithVulnerabilitiesPart:Re.$TO,ChatResponseCommandButtonPart:Re.$YO,ChatResponseDetectedParticipantPart:Re.$UO,ChatRequestTurn:Re.$2O,ChatResponseTurn:Re.$3O,ChatLocation:Re.ChatLocation,LanguageModelChatSystemMessage:Re.$4O,LanguageModelChatUserMessage:Re.$5O,LanguageModelChatAssistantMessage:Re.$6O,LanguageModelSystemMessage:Re.$4O,LanguageModelUserMessage:Re.$5O,LanguageModelAssistantMessage:Re.$6O,LanguageModelError:Re.$7O,NewSymbolName:Re.$_N,NewSymbolNameTag:Re.NewSymbolNameTag,InlineEdit:Re.$8O,InlineEditTriggerKind:Re.InlineEditTriggerKind}}}}),define(ke[379],Se([1,0,84,157,44,151,45,34,72,43,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s,c,r,v,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$ts)(c.$zlc,c.$ylc,1),(0,l.$ts)(h.$1j,t.$Mmc,1),(0,l.$ts)(d.$Ekc,d.$Fkc,1),(0,l.$ts)(b.$DP,b.$CP,0),(0,l.$ts)(v.$Okc,v.$Pkc,0),(0,l.$ts)(f.$tlc,f.$ulc,0),(0,l.$ts)(R.$4kc,R.$2kc,0),(0,l.$ts)(a.$6kc,a.$5kc,0),(0,l.$ts)(C.$Jlc,C.$Nlc,0),(0,l.$ts)(A.$Plc,A.$Olc,0),(0,l.$ts)($.$sP,$.$rP,0),(0,l.$ts)(r.$Alc,r.$Blc,0),(0,l.$ts)(i.$Ikc,i.$Hkc,0),(0,l.$ts)(M.$imc,M.$hmc,1),(0,l.$ts)(m.$6lc,m.$7lc,0),(0,l.$ts)(y.$mlc,y.$llc,0),(0,l.$ts)(N.$vmc,N.$umc,0),(0,l.$ts)(S.$plc,S.$slc,0),(0,l.$ts)(D.$wmc,D.$xmc,0),(0,l.$ts)(w.$ZCb,w.$1Cb,0),(0,l.$ts)(g.$Kmc,g.$Jmc,0),(0,l.$ts)(L.$1kc,L.$Zkc,0),(0,l.$ts)(n.$wlc,n.$vlc,0),(0,l.$ts)(u.$BP,u.$yP,0),(0,l.$ts)(o.$dlc,o.$elc,0),(0,l.$ts)(s.$Hlc,s.$Ilc,0)}),define(ke[122],Se([1,0,19,12,36,94]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0,e.$3mc=R,e.$4mc=b;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function b(C,m,y,w){const d=(0,l.$2b)(y,$),g=new L.$bL(m,d,w),a=g.preview.matches;return{ranges:(0,l.$2b)(d,S),uri:C,preview:{text:g.preview.text,matches:(0,l.$2b)(a,S)}}}function $(C){return new L.$cL(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new A.$3K(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let N=class{constructor(m,y){this.a=m,this.b=y}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$5mc=N,e.$5mc=N=Je([Ve(1,M.$Zj)],N)}),define(ke[380],Se([1,0,53,17,76,31,11,14,122,381]),function(le,e,l,M,L,A,R,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=C,e.$7mc=g,e.$8mc=i;const N=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,u,o,t){const h=m(n,u,o,t),s=u.folder.fsPath;return{cmd:l.spawn(N,h.args,{cwd:s}),rgDiskPath:N,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}function m(n,u,o,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];w([u],o,!1).forEach(c=>{const r=(0,$.$3mc)(c);if(h.push("-g",r),R.$j){const v=(0,L.$_l)(r);v!==r&&h.push("-g",v)}});const s=y([u],t,void 0,!1);return s.globArgs.forEach(c=>{const r=`!${(0,$.$3mc)(c)}`;if(h.push("-g",r),R.$j){const v=(0,L.$_l)(r);v!==r&&h.push("-g",v)}}),u.disregardIgnoreFiles!==!1?h.push("--no-ignore"):u.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),u.ignoreSymlinks||h.push("--follow"),n.exists&&h.push("--quiet"),h.push("--no-config"),u.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function y(n,u,o,t=!0){const h=[];let s={};return n.forEach(c=>{const r=Object.assign({},c.excludePattern||{},u||{}),v=d(r,t?c.folder.fsPath:void 0,o);h.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:h,siblingClauses:s}}function w(n,u,o=!0){const t=[];return n.forEach(h=>{const s=Object.assign({},u||{},h.includePattern||{}),c=d(s,o?h.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function d(n,u,o){const t=[],h={};return Object.keys(n).forEach(s=>{if(o&&o.has(s)||!s)return;const c=n[s];s=a(u?g(u,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof c=="boolean"&&c?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):c&&c.when&&(h[s]=c)}),{globArgs:t,siblingClauses:h}}function g(n,u){return M.$jc(u)?u:M.$kc(n,u)}function a(n){return n=b.$df(n,"\\"),b.$df(n,"/")}function i(n){return A.$og(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(ke[382],Se([1,0,53,52,17,383,19,47,35,76,31,11,40,14,18,32,36,380,132]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(s=>s())});class u{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&$.$nk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,i.$ur)(this.b).normalizedLowercase),this.u=c.excludePattern&&$.$nk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(r=>{const v=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),f=r.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==f).forEach(D=>{(0,N.$sg)(D,f)&&(v[L.$mc(f,D)]=!0)}),this.t.set(f,new t(v,f))})}cancel(){this.l=!0,n.forEach(c=>c())}walk(c,r,v,f,D){if(this.m=m.$$d.create(!1),this.l)return D(null,this.j);r.forEach(p=>{const E=L.$oc(p.fsPath);this.u&&this.u(p.fsPath,E)||this.J(v,{relativePath:p.fsPath,searchPath:void 0})}),this.r=m.$$d.create(!1),this.w(c,(p,E)=>{this.x(this.y,this,p,v,f,k=>{if(k){const P=(0,b.$ej)(k);console.error(P),this.q.push(P),E(k,void 0)}else E(null,void 0)})},(p,E)=>{this.m.stop();const k=p?R.$Hb(p)[0]:null;D(k,this.j)})}w(c,r,v){const f=new Array(c.length),D=new Array(c.length);let p=!1,E=0;if(c.length===0)return v(null,[]);c.forEach((k,P)=>{r(k,(I,T)=>{if(I?(p=!0,f[P]=null,D[P]=I):(f[P]=T,D[P]=null),++E===c.length)return v(p?D:null,f)})})}x(c,r,...v){try{c.apply(r,v)}catch(f){v[v.length-1](f)}}y(c,r,v,f){const D=c.folder.fsPath,p=C.$j,E=()=>j&&j.kill();n.add(E);let k=B=>{n.delete(E),k=()=>{},f(B)},P="";const I=this.D(),T=(0,a.$6mc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),j=T.cmd,z=!Object.keys(T.siblingClauses).length,O=T.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let F=`${T.rgDiskPath} ${O}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),v({message:F}),this.s=0,this.z(j,"utf8",v,(B,W,Z)=>{if(B){k(B);return}if(this.j){k();return}const Y=(P+(p?S.$$l(W||""):W)).split(`
`);if(Z){const x=Y.length;Y[x-1]=Y[x-1].trim(),Y[x-1]||Y.pop()}else P=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Y.length,z){for(const x of Y)if(this.J(r,{base:D,relativePath:x,searchPath:this.N(c,x)}),this.j){E();break}(Z||this.j)&&k();return}this.G(c,I,D,Y,r),Z&&(this.H(I,D,r),k())})}spawnFindCmd(c){const r=this.t.get(c.folder.fsPath),v=r.getBasenameTerms(),f=r.getPathTerms(),D=["-L","."];if(v.length||f.length){D.push("-not","(","(");for(const p of v)D.push("-name",p),D.push("-o");for(const p of f)D.push("-path",p),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),l.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,r,v){let f="";this.z(c,r,()=>{},(D,p,E)=>{if(D){v(D);return}f+=p,E&&v(null,f)})}z(c,r,v,f){let D=(k,P,I)=>{(k||I)&&(D=()=>{},this.r?.stop()),f(k,P,I)},p=!1;c.stdout?(this.A(c.stdout,r,D),c.stdout.once("data",()=>p=!0)):v({message:"stdout is null"});let E;c.stderr?E=this.B(c.stderr):v({message:"stderr is null"}),c.on("error",k=>{D(k)}),c.on("close",k=>{let P;!p&&(P=this.C(E,r))&&h(P)?D(new Error(`command failed with error code ${k}: ${this.C(E,r)}`)):(this.g&&k===0&&(this.j=!0),D(null,"",!0))})}A(c,r,v){const f=new A.StringDecoder(r);return c.on("data",D=>{v(null,f.write(D))}),f}B(c){const r=[];return c.on("data",v=>{r.push(v)}),r}C(c,r){const v=new A.StringDecoder(r);return c.map(f=>v.write(f)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:r},v,f,D){f.indexOf(this.b)!==-1&&this.J(D,{base:v,relativePath:this.b,searchPath:this.N(c,this.b)});const p=E=>{const k=L.$oc(E),P=L.$nc(E);let I=r[P];I||(I=r[P]=[],p(P)),I.push({base:v,relativePath:E,basename:k,searchPath:this.N(c,E)})};f.forEach(p)}H({rootEntries:c,pathToEntries:r},v,f){const D=this,p=this.t.get(v),E=this.b;function k(P){D.o++;const I=(0,g.$rL)(()=>P.map(T=>T.basename));for(let T=0,j=P.length;T<j;T++){const z=P[T],{relativePath:O,basename:F}=z;if(p.test(O,F,E!==F?I:void 0))continue;const B=r[O];if(B)k(B);else{if(D.p++,O===E)continue;D.J(f,z)}if(D.j)break}}k(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,r,v,f,D){const p=c.folder,E=(0,g.$rL)(()=>v);this.w(v,(k,P)=>{if(this.l||this.j)return P(null);const I=r?[r,k].join(L.sep):k;if(this.t.get(c.folder.fsPath).test(I,k,this.a.filePattern!==k?E:void 0))return P(null);const T=[p.fsPath,I].join(L.sep);M.lstat(T,(j,z)=>{if(j||this.l||this.j)return P(null);this.L(T,z,(O,F)=>O||this.l||this.j?P(null):F.isDirectory()?(this.o++,this.M(T,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?P(null):(this.v[W]=!0,d.Promises.readdir(T).then(Z=>{if(this.l||this.j)return P(null);this.I(c,I,Z,f,X=>P(X||null))},Z=>{P(null)})))):(this.p++,I===this.b||this.h&&w.$0f(F.size)&&F.size>this.h||this.J(f,{base:p.fsPath,relativePath:I,searchPath:this.N(c,I)}),P(null,void 0)))})},k=>{const P=k&&R.$Hb(k);return D(P&&P.length>0?P[0]:void 0)})}J(c,r){this.K(r)&&(!this.d||this.d(r.relativePath,L.$oc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(r))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$mL)(c,this.c);if(this.b)return(0,g.$mL)(c,this.b,!1)}return!0}L(c,r,v){return r.isSymbolicLink()?M.stat(c,v):v(null,r)}M(c,r,v){return r.isSymbolicLink()?M.realpath(c,(f,D)=>f?v(f):v(null,D)):v(null,c)}N(c,r){return c.folderName?L.$kc(c.folderName,r):r}}e.$9mc=u;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new u(c)}search(c,r,v){this.c.walk(this.a,this.b,c,r,(f,D)=>{v(f,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$0mc=o;class t{constructor(c,r){this.expression=c,this.c=r,this.d(c)}d(c){let r,v;Object.keys(c).filter(f=>c[f]).forEach(f=>{L.$jc(f)?(r=r||$.$ik(),r[f]=c[f]):(v=v||$.$ik(),v[f]=c[f])}),this.a=r&&$.$nk(r,{trimForExclusions:!0}),this.b=v&&$.$nk(v,{trimForExclusions:!0})}test(c,r,v){return this.b&&this.b(c,r,v)||this.a&&this.a(L.$kc(this.c,c),r,v)}getBasenameTerms(){const c=[];return this.a&&c.push(...$.$pk(this.a)),this.b&&c.push(...$.$pk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...$.$qk(this.a)),this.b&&c.push(...$.$qk(this.b)),c}}function h(s){const c=s.trim().split(`
`),r=c[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return y.$Xf(c[c.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ke[384],Se([1,0,98,21,193,22]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aE=e.$5D=e.DecodeStreamErrorKind=e.$4D=e.$3D=e.$2D=e.$ZD=e.$YD=e.$XD=e.$WD=void 0,e.$1D=R,e.$6D=w,e.$7D=d,e.$8D=g,e.$9D=a,e.$0D=i,e.$$D=s,e.$_D=c,e.$WD="utf8",e.$XD="utf8bom",e.$YD="utf16be",e.$ZD="utf16le";function R(r){return[e.$WD,e.$XD,e.$YD,e.$ZD].some(v=>v===r)}e.$2D=[254,255],e.$3D=[255,254],e.$4D=[239,187,191];const b=512,$=512,S=512*8,N=512*128;var C;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(v,f){super(v),this.decodeStreamErrorKind=f}}e.$5D=m;class y{static async create(v){let f;if(v!==e.$WD)f=(await(0,L.$VD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(v));else{const D=new TextDecoder;f={write(p){return D.decode(p,{stream:!0})},end(){return D.decode()}}}return new y(f)}constructor(v){this.a=v}write(v){return this.a.write(v)}end(){return this.a.end()}}function w(r,v){const f=v.minBytesRequiredForDetection??v.guessEncoding?S:$;return new Promise((D,p)=>{const E=(0,l.$re)(z=>z.join("")),k=[];let P=0,I;const T=new A.$ne,j=async()=>{try{const z=await c({buffer:M.$De.concat(k),bytesRead:P},v.guessEncoding);if(z.seemsBinary&&v.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);z.encoding=await v.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const O=I.write(M.$De.concat(k).buffer);E.write(O),k.length=0,P=0,D({stream:E,detected:z})}catch(z){T.cancel(),E.destroy(),p(z)}};(0,l.$ve)(r,{onData:async z=>{I?E.write(I.write(z.buffer)):(k.push(z),P+=z.byteLength,P>=f&&(r.pause(),await j(),setTimeout(()=>r.resume())))},onError:z=>E.error(z),onEnd:async()=>{I||await j(),E.end(I?.end())}},T.token)})}async function d(r,v,f){const p=(await(0,L.$VD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(v),f);let E=!1,k=!1;return{read(){if(k)return null;const P=r.read();if(typeof P!="string"){if(k=!0,!E&&f?.addBOM)switch(v){case e.$WD:case e.$XD:return M.$De.wrap(Uint8Array.from(e.$4D));case e.$YD:return M.$De.wrap(Uint8Array.from(e.$2D));case e.$ZD:return M.$De.wrap(Uint8Array.from(e.$3D))}const I=p.end();return I&&I.length>0?(E=!0,M.$De.wrap(I)):null}return E=!0,M.$De.wrap(p.write(P))}}}async function g(r){return(await(0,L.$VD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(r))}function a(r){return r===e.$XD||r===null?e.$WD:r}function i(r,v){if(!r||v<e.$2D.length)return null;const f=r.readUInt8(0),D=r.readUInt8(1);if(f===e.$2D[0]&&D===e.$2D[1])return e.$YD;if(f===e.$3D[0]&&D===e.$3D[1])return e.$ZD;if(v<e.$4D.length)return null;const p=r.readUInt8(2);return f===e.$4D[0]&&D===e.$4D[1]&&p===e.$4D[2]?e.$XD:null}const n=["ascii","utf-16","utf-32"];async function u(r){const v=await(0,L.$VD)("jschardet","dist/jschardet.min.js"),f=r.slice(0,N),D=h(f.buffer),p=v.detect(D);if(!p||!p.encoding)return null;const E=p.encoding.toLowerCase();return 0<=n.indexOf(E)?null:t(p.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(r){const v=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[v]||v}function h(r){let v="";for(let f=0;f<r.length;f++)v+=String.fromCharCode(r[f]);return v}function s(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const v=r.match(/windows(\d+)/);return v?"windows-"+v[1]:r}}}function c({buffer:r,bytesRead:v},f){let D=i(r,v),p=!1;if(D!==e.$YD&&D!==e.$ZD&&r){let E=!0,k=!0,P=!1;for(let I=0;I<v&&I<b;I++){const T=I%2===1,j=r.readUInt8(I)===0;if(j&&(P=!0),E&&(T&&!j||!T&&j)&&(E=!1),k&&(T&&j||!T&&!j)&&(k=!1),j&&!E&&!k)break}P&&(E?D=e.$ZD:k?D=e.$YD:p=!0)}return f&&!p&&!D&&r?u(r.slice(0,v)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:p,encoding:D}}e.$aE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Se([1,0,384,32,159]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class A extends L.$2lc{constructor(b,$,S=M,N="searchProcess"){super({query:b,provider:$},{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,l.$$D)(C)},N)}}e.$fnc=A}),define(ke[161],Se([1,0,53,400,383,19,73,35,14,2,36,94,401,381,122]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0,e.$anc=t,e.$bnc=s,e.$cnc=r,e.$dnc=v,e.$enc=D;const d=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(E){this.a=E}provideTextSearchResults(E,k,P,I){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((T,j)=>{I.onCancellationRequested(()=>Y());const z=t(E,k),O=k.folder.fsPath,F=z.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${d} ${F}
 - cwd: ${O}`);let B=l.spawn(d,z,{cwd:O});B.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),j((0,N.$iL)(new N.$gL(ve&&ve.message,N.SearchErrorCode.rgProcessError)))});let W=!1;const Z=new n(k.maxResults,k.folder,k.previewOptions);Z.on("result",ve=>{W=!0,ne="",P.report(ve)});let X=!1;const Y=()=>{X=!0,B?.kill(),Z?.cancel()};let x=!1;Z.on("hitLimit",()=>{x=!0,Y()});let ne="";B.stdout.on("data",ve=>{Z.handleData(ve),W||(ne+=ve)});let ge=!1;B.stdout.once("data",()=>ge=!0);let ue="";B.stderr.on("data",ve=>{const te=ve.toString();this.a.appendLine(te),ue.length+te.length<1e6&&(ue+=te)}),B.on("close",()=>{if(this.a.appendLine(ge?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),X)T({limitHit:x});else{Z.flush(),B=null;let ve;ue&&!ge&&(ve=a(ue))?j((0,N.$iL)(new N.$gL(ve.message,ve.code))):T({limitHit:x})}})})}}e.$$mc=g;function a(p){const E=p.split(`
`),k=E[0].trim();if(E.some(I=>I.startsWith("regex parse error")))return new N.$gL(i(E),N.SearchErrorCode.regexParseError);const P=k.match(/grep config error: unknown encoding: (.*)/);if(P)return new N.$gL(`Unknown encoding: ${P[1]}`,N.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new N.$gL(k.charAt(0).toUpperCase()+k.substr(1),N.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new N.$gL(k.charAt(0).toUpperCase()+k.substr(1),N.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new N.$gL(k,N.SearchErrorCode.regexParseError)}function i(p){const E=["Regex parse error"],k=p.filter(P=>P.startsWith("PCRE2:"));if(k.length>=1){const P=k[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];E.push(":"+I)}}return E.join("")}class n extends M.EventEmitter{constructor(E,k,P){super(),this.g=E,this.h=k,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,k){return super.on(E,k),this}handleData(E){if(this.b)return;const k=typeof E=="string"?E:this.d.write(E);this.k(k)}k(E){let k=E.indexOf(`
`);const P=this.a+E;if(k>=0)k+=this.a.length;else{this.a=P;return}let I=0;for(;k>=0;)this.m(P.substring(I,k).trim()),I=k+1,k=P.indexOf(`
`,I);this.a=P.substring(I)}m(E){if(this.b||!E)return;let k;try{k=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(k.type==="match"){const P=u(k.data.path),I=S.URI.joinPath(this.h,P),T=this.n(k.data,I);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const P=u(k.data.path),I=S.URI.joinPath(this.h,P);this.o(k.data,I).forEach(j=>this.p(j))}}n(E,k){const P=E.line_number-1,I=u(E.lines),T=Buffer.from(I);let j=0,z=0,O=P;E.submatches.length===0&&E.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.$Hb)(E.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=u(B.match),X=T.slice(j,B.start).toString(),Y=o(X),x=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+z,ne=o(Z),ge=Y.numLines+O,ue=ne.numLines+ge,ve=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return j=B.end,z=ve,O=ue,new C.$3K(ge,x,ue,ve)}));return(0,w.$4mc)(k,I,F,this.j)}o(E,k){const P=u(E.lines),I=E.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((T,j)=>({text:T,uri:k,lineNumber:I+j}))}p(E){this.emit("result",E)}}e.$_mc=n;function u(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function o(p){const E=/\n/g;let k=0,P=-1,I;for(;I=E.exec(p);)k++,P=I.index;const T=P>=0?p.length-P-1:p.length;return{numLines:k,lastLineLength:T}}function t(p,E){const k=["--hidden","--no-require-git"];k.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,R.$K)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),k.push("-g","!*"),j.forEach(z=>{h(z).map(w.$3mc).forEach(O=>{k.push("-g",O)})})}P&&P.length&&P.forEach(j=>{k.push("-g",j)}),E.excludes.map(w.$3mc).forEach(j=>k.push("-g",`!${j}`)),E.maxFileSize&&k.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),E.followSymlinks&&k.push("--follow"),E.encoding&&E.encoding!=="utf8"&&k.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,$.$0e)(p.pattern),p.isRegExp=!0),E.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),p.isRegExp&&(p.pattern=s(p.pattern),k.push("--engine","auto"));let T;if(p.isWordMatch){const z=(0,$.$gf)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",z)}else if(p.isRegExp){let j=r(p.pattern);j=v(j),k.push("--regexp",j)}else T=p.pattern,k.push("--fixed-strings");return k.push("--no-config"),E.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),p.isMultiline&&k.push("--multiline"),E.beforeContext&&k.push("--before-context",E.beforeContext+""),E.afterContext&&k.push("--after-context",E.afterContext+""),k.push("--"),T&&k.push(T),k.push("."),k}function h(p){return D(p).flatMap(k=>{const P=(0,b.$lk)(k,"/");return P.map((I,T)=>P.slice(0,T+1).join("/"))})}function s(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");return p}const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function r(p){let E;try{E=new m.RegExpParser().parsePattern(p)}catch{return p}let k="",P=0;const I=(z,O,F)=>{k+=p.slice(P,z)+F,P=O},T=[];return new m.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=T[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!T.some(c))if(O.type==="CharacterClass")if(O.negate){const F=p.slice(O.start+2,z.start)+p.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,F?`[^${F}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=p.slice(O.start+1,z.start)+p.slice(z.end,O.end-1);I(O.start,O.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){T.unshift(z)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(z){T.unshift(z)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(z){T.unshift(z)},onCharacterClassLeave(){T.shift()},onAssertionEnter(z){c(z)&&T.push(z)},onAssertionLeave(z){T[0]===z&&T.shift()}}).visit(E),k+=p.slice(P),k}function v(p){return p.replace(/\n/g,"\\r?\\n")}function f(p){let E=!1,k=!1,P="",I="";for(let T=0;T<p.length;T++){const j=p[T];switch(j){case"\\":k?(E?I+="\\"+j:P+="\\"+j,k=!1):k=!0;break;case"{":if(k)E?I+=j:P+=j,k=!1;else{if(E)return{strInBraces:P+"{"+I+"{"+p.substring(T+1)};E=!0}break;case"}":if(k)E?I+=j:P+=j,k=!1;else{if(E)return{fixedStart:P,strInBraces:I,fixedEnd:p.substring(T+1)};P+=j}break;default:E?I+=(k?"\\":"")+j:P+=(k?"\\":"")+j,k=!1;break}}return{strInBraces:P+(E?"{"+I:"")}}function D(p){const{fixedStart:E,strInBraces:k,fixedEnd:P}=f(p);if(E===void 0||P===void 0)return[k];let I=(0,b.$lk)(k,",");I.length||(I=[""]);const T=D(P);return I.flatMap(j=>{const z=E+j;return T.map(O=>z+O)})}}),define(ke[385],Se([1,0,22,161,108,15]),function(le,e,l,M,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class R{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,N,C,m){const y=new M.$$mc(this.b);if(N.folder.scheme===A.Schemas.vscodeUserData){const w={...N,folder:N.folder.with({scheme:A.Schemas.file})},d=new L.$5v(g=>C.report({...g,uri:g.uri.with({scheme:N.folder.scheme})}));return this.c(m,g=>y.provideTextSearchResults(S,w,d,g))}else return this.c(m,w=>y.provideTextSearchResults(S,N,C,w))}async c(S,N){const C=b(S);this.a.add(C);const m=await N(C.token);return this.a.delete(C),m}d(){this.a.forEach(S=>S.cancel())}}e.$inc=R;function b($){const S=new l.$ne;return $.onCancellationRequested(()=>S.cancel()),S}}),define(ke[386],Se([1,0,32,161,160]),function(le,e,l,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class A{constructor($){this.a=$}search($,S,N){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(y){N({message:y})}},m=new L.$fnc(this.a,new M.$$mc(C),l);return new Promise((y,w)=>m.search(d=>{S(d.map(R))},$).then(d=>y({limitHit:d.limitHit,type:"success",stats:d.stats}),w))}}e.$gnc=A;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,S)=>{if(S.ranges){const N=S;return $+(Array.isArray(N.ranges)?N.ranges.length:1)}else return $+1},0)}}}),define(ke[387],Se([1,0,19,8,13,4,132,17,40,2,33,36,382,386]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class w{static{this.a=512}constructor(u="searchProcess"){this.d=u,this.b=Object.create(null)}fileSearch(u){let o;const t=a(u),h=new A.$ce({onDidAddFirstListener:()=>{o=(0,M.$gh)(s=>this.doFileSearchWithEngine(m.$0mc,t,c=>h.fire(c),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}textSearch(u){let o;const t=a(u),h=new A.$ce({onDidAddFirstListener:()=>{o=(0,M.$gh)(s=>this.f(t,c=>h.fire(c),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}f(u,o,t){return u.maxFileSize=this.g().maxFileSize,new y.$gnc(u).search(t,o,o)}g(){return{maxFileSize:16*N.$vl.GB}}doFileSearch(u,o,t){return this.doFileSearchWithEngine(m.$0mc,u,o,t)}doFileSearchWithEngine(u,o,t,h,s=w.a){let c=0;const r=f=>{Array.isArray(f)?(c+=f.length,t(f.map(D=>this.h(D)))):f.relativePath?(c++,t(this.h(f))):t(f)};if(o.sortByScore){let f=this.l(o,r,h);if(!f){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,p=new u(D);f=this.j(p,o,t,r,h)}return new Promise((D,p)=>{f.then(([E,k])=>{const P=k.map(I=>this.h(I));this.o(P,t,s),D(E)},p)})}const v=new u(o);return this.r(v,r,s,h).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(u){return{path:u.base?(0,b.$kc)(u.base,u.relativePath):u.relativePath}}j(u,o,t,h,s){const c=new A.$ce;let r=(0,M.$gh)(f=>{let D=[];const p=E=>{Array.isArray(E)?D=E:(h(E),c.fire(E))};return this.r(u,p,-1,f).then(E=>[E,D])}),v;if(o.cacheKey){v=this.k(o.cacheKey);const f={promise:r,event:c.event,resolved:!1};v.resultsToSearchCache[o.filePattern||""]=f,r.then(()=>{f.resolved=!0},D=>{delete v.resultsToSearchCache[o.filePattern||""]}),r=this.s(r)}return r.then(([f,D])=>{const p=v?v.scorerCache:Object.create(null),E=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$$d.create(!1);return this.n(o,D,p,s).then(k=>{const P=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:k.length},messages:f.messages,limitHit:f.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},k]})})}k(u){const o=this.b[u];return o||(this.b[u]=new d)}l(u,o,t){const h=u.cacheKey&&this.b[u.cacheKey];if(!h)return;const s=this.q(h,u.filePattern||"",o,t);if(s)return s.then(([c,r,v])=>{const f=$.$$d.create(!1);return this.n(u,r,h.scorerCache,t).then(D=>{const p=f.elapsed(),E={fromCache:!0,detailStats:v,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:c.limitHit||typeof u.maxResults=="number"&&r.length>u.maxResults,stats:E},D]})})}n(u,o,t,h){const s=(0,R.$ur)(u.filePattern||""),c=(v,f)=>(0,R.$tr)(v,f,s,!0,g,t),r=typeof u.maxResults=="number"?u.maxResults:Number.MAX_VALUE;return l.$Gb(o,c,r,1e4,h)}o(u,o,t){if(t&&t>0)for(let h=0;h<u.length;h+=t)o(u.slice(h,h+t));else o(u)}q(u,o,t,h){const s=$.$$d.create(!1),c=o.indexOf(b.sep)>=0;let r;for(const p in u.resultsToSearchCache)if(o.startsWith(p)){if(c&&p.indexOf(b.sep)<0&&p!=="")continue;const E=u.resultsToSearchCache[p];r={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!r)return null;const v=s.elapsed(),f=$.$$d.create(!1),D=r.event(t);return h&&h.onCancellationRequested(()=>{D.dispose()}),r.promise.then(([p,E])=>{if(h&&h.isCancellationRequested)throw(0,L.$6)();const k=[],P=(0,R.$ur)(o).normalizedLowercase;for(const I of E)(0,C.$mL)(I,P)&&k.push(I);return[p,k,{cacheWasResolved:r.resolved,cacheLookupTime:v,cacheFilterTime:f.elapsed(),cacheEntryCount:E.length}]})}r(u,o,t,h){return new Promise((s,c)=>{let r=[];h?.onCancellationRequested(()=>u.cancel()),u.search(v=>{v&&(t?(r.push(v),t>0&&r.length>=t&&(o(r),r=[])):o(v))},v=>{o(v)},(v,f)=>{r.length&&o(r),v?(o({message:"Search finished. Error: "+v.message}),c(v)):(o({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),s(f))})})}clearCache(u){return delete this.b[u],Promise.resolve(void 0)}s(u){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return u.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return u.finally(o)}}}}e.$hnc=w;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(n){return(0,b.$oc)(n.relativePath)}getItemDescription(n){return(0,b.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function a(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(u=>S.URI.revive(u))}}function i(n){return{...n,folder:S.URI.revive(n.folder)}}}),define(ke[388],Se([1,0,3,15,2,32,12,28,20,97,67,36,387,385,122,160]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;let g=class extends S.$7lc{constructor(i,n,u,o){super(i,u,o),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Uc;const t=new w.$5mc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new y.$inc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new w.$5mc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(M.Schemas.file,new y.$inc(i))),this.A.add(this.C(M.Schemas.file,new m.$hnc("fileSearchProvider")))}C(i,n){const u=this.d++;return this.y=n,this.x=u,this.c.$registerFileSearchProvider(u,this.s(i)),(0,l.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(u)})}$provideFileSearchResults(i,n,u,o){const t=(0,S.$8lc)(u);if(i===this.x){const h=Date.now();return this.D(i,n,t,o).then(s=>{const c=Date.now()-h;return this.q.debug(`Ext host file search time: ${c}ms`),s})}return super.$provideFileSearchResults(i,n,u,o)}doInternalFileSearchWithCustomCallback(i,n,u){const o=t=>{if((0,C.$lL)(t)&&(t=[t]),Array.isArray(t)){u(t.map(h=>L.URI.file(h.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,o,n)}async D(i,n,u,o){return this.doInternalFileSearchWithCustomCallback(u,o,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new d.$fnc(i,n,void 0,"textSearchProvider")}};e.$jnc=g,e.$jnc=g=Je([Ve(0,$.$hP),Ve(1,b.$xP),Ve(2,N.$Xkc),Ve(3,R.$Zj)],g)}),define(ke[123],Se([1,0,402,63,64,403,21,13,4,3,17,11,30,81,82]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$ki=e.$ji=e.$ii=void 0,e.$li=s,e.$mi=c,e.$oi=f,e.$pi=D;class d{traceSocketEvent(E,k){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,k)}constructor(E,k=""){this.f=!0,this.debugLabel=k,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const k=P=>{this.traceSocketEvent("read",P),E(R.$De.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(E){const k=P=>{E({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(E){const k=()=>{E()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$ii=d;var g;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var a;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(a||(a={}));class i extends S.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,k){this.socket.traceSocketEvent(E,k)}constructor(E,k,P,I){super(),this.f=this.B(new $.$ce),this.g=this.B(new $.$ce),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new n(this,k,P,I,this.f,(T,j)=>this.m(T,j))),this.B(this.a.onError(T=>{console.error(T),(0,b.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new w.$di,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let k=0;for(;k<E.byteLength;)this.a.writeMessage(E.slice(k,Math.min(k+262144,E.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(E,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let I=2;E.byteLength<126?I+=0:E.byteLength<2**16?I+=2:I+=8;const T=R.$De.alloc(I),j=k?64:0,z=P&15;if(T.writeUInt8(128|j|z,0),E.byteLength<126)T.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(E.byteLength>>>8&255,++O),T.writeUInt8(E.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(E.byteLength>>>24&255,++O),T.writeUInt8(E.byteLength>>>16&255,++O),T.writeUInt8(E.byteLength>>>8&255,++O),T.writeUInt8(E.byteLength>>>0&255,++O)}this.socket.write(R.$De.concat([T,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),I=(P&128)>>>7,T=(P&64)>>>6,j=P&15,z=k.readUInt8(1),O=(z&128)>>>7,F=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),I=(P&128)>>>7;let T=P&127,j=1;T===126?T=k.readUInt8(++j)*2**8+k.readUInt8(++j):T===127&&(T=k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*2**24+k.readUInt8(++j)*2**16+k.readUInt8(++j)*2**8+k.readUInt8(++j));let z=0;I&&(z=k.readUInt8(++j)*2**24+k.readUInt8(++j)*2**16+k.readUInt8(++j)*2**8+k.readUInt8(++j)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ji=i;class n extends S.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$De.alloc(0)}constructor(E,k,P,I,T,j){super(),this.n=E,this.r=T,this.s=j,this.a=this.B(new $.$ce),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$ce),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$ce),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new u(this.n,I,P,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,k){this.g.push({data:E,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,E);this.s(P,k)}else this.s(E,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,k){return new Promise((P,I)=>{E.write(k),E.flush(T=>P(T))})}acceptFrame(E,k,P){this.h.push({data:E,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const k=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,k,P){return new Promise((I,T)=>{E.write(k),P&&E.write(R.$De.fromByteArray([0,0,255,255])),E.flush(j=>I(j))})}}class u extends S.$Vc{get recordedInflateBytes(){return this.j?R.$De.concat(this.f):R.$De.alloc(0)}constructor(E,k,P,I){super(),this.h=E,this.j=k,this.a=this.B(new $.$ce),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(I),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(R.$De.wrap(T))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=R.$De.concat(this.g);this.g.length=0,E(k)})}}class o extends S.$Vc{constructor(E,k){super(),this.g=E,this.a=this.B(new $.$ce),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$De.wrap(P))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=R.$De.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),E(k)})}}function t(p,E){if(E===0)return;const k=p.byteLength>>>2;for(let O=0;O<k;O++){const F=p.readUInt32BE(O*4);p.writeUInt32BE(F^E,O*4)}const P=k*4,I=p.byteLength-P,T=E>>>24&255,j=E>>>16&255,z=E>>>8&255;I>=1&&p.writeUInt8(p.readUInt8(P)^T,P),I>=2&&p.writeUInt8(p.readUInt8(P+1)^j,P+1),I>=3&&p.writeUInt8(p.readUInt8(P+2)^z,P+2)}e.$ki=process.env.XDG_RUNTIME_DIR;const h={2:107,1:103};function s(){const p=(0,m.$Pg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const E=process.platform!=="darwin"&&e.$ki?e.$ki:(0,L.tmpdir)(),k=(0,N.$kc)(E,`vscode-ipc-${p}.sock`);return r(k),k}function c(p,E,k){const I=(0,l.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${k}-${E}-sock`;const T=k.substr(0,4),j=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$ki&&!process.env.VSCODE_PORTABLE?z=(0,N.$kc)(e.$ki,`vscode-${I}-${T}-${j}.sock`):z=(0,N.$kc)(p,`${T}-${j}.sock`),r(z),z}function r(p){const E=h[C.$u];typeof E=="number"&&p.length>=E&&console.warn(`WARNING: IPC handle "${p}" is longer than ${E} chars, try a shorter --user-data-dir`)}class v extends y.$0h{static b(E){const k=$.Event.fromNodeEventEmitter(E,"connection");return $.Event.map(k,P=>({protocol:new w.$ei(new d(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(E){super(v.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ni=v;function f(p){return new Promise((E,k)=>{const P=(0,M.createServer)();P.on("error",k),P.listen(p,()=>{P.removeListener("error",k),E(new v(P))})})}function D(p,E){return new Promise((k,P)=>{const I=(0,M.createConnection)(p,()=>{I.removeListener("error",P),k(w.$fi.fromSocket(new d(I,`ipc-client${E}`),E))});I.once("error",P)})}}),define(ke[389],Se([1,0,63,64,173,123,8,3,11,54,12,139,266,267,110,88,21]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=e.$9cc=e.$8cc=void 0;async function a(t,h,s,c,r){let v;for(let f=3;f&&(v?.dispose(),v=await new i(t,h,s,c,r).waitForReady(),!(r&&L.$Sg[r]||!L.$Sg[v.tunnelLocalPort]));f--);return v}class i extends b.$Vc{constructor(h,s,c,r,v){super(),this.m=s,this.n=v,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=l.createServer(),this.c=new R.$sh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,s=(0,d.$fw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,L.$Tg)(h,2,1e3,s),r=null;return this.b.listen(c,this.m),await this.c.wait(),r=this.b.address(),r||(c=0,this.b.listen(c,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(h){h.pause();const s=(0,d.$dw)(this.tunnelRemoteHost)||(0,d.$fw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,m.$Pl)(this.a,s,this.tunnelRemotePort),r=c.getSocket(),v=c.readEntireBuffer();c.dispose(),v.byteLength>0&&h.write(v.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),r.end()}),h.on("close",()=>r.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),r instanceof A.$ii?r.socket.destroy():r.end()}),r instanceof A.$ii?this.t(h,r):this.s(h,r),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),r.end()})}s(h,s){s.onClose(()=>h.destroy()),s.onEnd(()=>h.end()),s.onData(c=>h.write(c.buffer)),h.on("data",c=>s.write(g.$De.wrap(c))),h.resume()}t(h,s){const c=s.socket;c.on("end",()=>h.end()),c.on("close",()=>h.end()),c.on("error",()=>{h.destroy()}),c.pipe(h),h.pipe(c)}}e.$8cc=i;let n=class extends d.$iw{constructor(h,s,c,r,v){super(s,v),this.v=h,this.w=c,this.y=r}isPortPrivileged(h){return(0,d.$gw)(h,this.m,$.OS,M.release())}t(h,s,c,r,v,f,D,p){const E=this.s(s,c);if(E)return++E.refcount,E.value;if((0,d.$_v)(h))return this.u(h,s,c,v,f,D,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${c} on local port ${v}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=a(k,r,s,c,v);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,c,P),P}}};e.$9cc=n,e.$9cc=n=Je([Ve(0,y.$Jl),Ve(1,N.$Zj),Ve(2,w.$Ml),Ve(3,C.$gk),Ve(4,S.$Zi)],n);let u=class extends n{constructor(h,s,c,r,v){super(h,s,c,r,v)}};e.$0cc=u,e.$0cc=u=Je([Ve(0,y.$Jl),Ve(1,N.$Zj),Ve(2,w.$Ml),Ve(3,C.$gk),Ve(4,S.$Zi)],u);let o=class extends b.$Vc{constructor(h,s,c,r,v){super(),this.b=h,this.c=s,this.f=c,this.g=r,this.h=v,this.a=new Map}async openTunnel(h,s,c,r,v,f,D,p,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${r} on local port ${f}.`),!this.a.has(h)){const k=new u(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(h,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(s,c,r,v,f,D,p,E)}};e.$$cc=o,e.$$cc=o=Je([Ve(0,y.$Jl),Ve(1,N.$Zj),Ve(2,C.$gk),Ve(3,w.$Ml),Ve(4,S.$Zi)],o)}),define(ke[390],Se([1,0,123,286,52,34,2,12,42]),function(le,e,l,M,L,A,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=e.$IP=void 0;class S{constructor(m,y,w){this.b=m,this.c=y,this.f=w,this.a=M.createServer((d,g)=>this.h(d,g)),this.g().catch(d=>(y.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,y){const w=(g,a)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(a||null),i=>i&&this.c.error(i))},d=[];m.setEncoding("utf8"),m.on("data",g=>d.push(g)),m.on("end",async()=>{try{const g=JSON.parse(d.join(""));let a;switch(g.type){case"open":a=await this.i(g);break;case"openExternal":a=await this.j(g);break;case"status":a=await this.l(g);break;case"extensionManagement":a=await this.k(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,a)}catch(g){const a=g instanceof Error?g.message:JSON.stringify(g);w(500,a),this.c.error("Error while processing pipe request",g)}})}async i(m){const{fileURIs:y,folderURIs:w,forceNewWindow:d,diffMode:g,mergeMode:a,addMode:i,forceReuseWindow:n,gotoLineMode:u,waitMarkerFilePath:o,remoteAuthority:t}=m,h=[];if(Array.isArray(w))for(const v of w)try{h.push({folderUri:R.URI.parse(v)})}catch{}if(Array.isArray(y))for(const v of y)try{(0,$.$Yi)(v)?h.push({workspaceUri:R.URI.parse(v)}):h.push({fileUri:R.URI.parse(v)})}catch{}const s=o?R.URI.file(o):void 0,r={forceNewWindow:d,diffMode:g,mergeMode:a,addMode:i,gotoLineMode:u,forceReuseWindow:n,preferNewWindow:!n&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,r)}async j(m){for(const y of m.uris){const w=R.URI.parse(y),d=w.scheme==="file"?w:y;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(m){const y=d=>d?.map(g=>/\.vsix$/i.test(g)?R.URI.parse(g):g),w={list:m.list,install:y(m.install),uninstall:y(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$IP=S;let N=class extends S{constructor(m,y){super(m,y,(0,l.$li)())}};e.$JP=N,e.$JP=N=Je([Ve(0,A.$DP),Ve(1,b.$Zj)],N)}),define(ke[391],Se([1,0,59,378,373,285,49,360,2,15,7,390,104,319,359]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0;class d extends L.$Pmc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,u=n._load;n._load=function(s,c,r){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,m.$4q)(c.filename)),v=>u.apply(this,[v,c,r])):u.apply(this,arguments)};const o=n._resolveLookupPaths;n._resolveLookupPaths=(h,s)=>o.call(this,t(h),s);const t=h=>{for(const s of i.b){const c=s(h);if(c){h=c;break}}return h}}}class g extends R.$Dlc{constructor(){super(...arguments),this.extensionRuntime=N.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$mnc);const i=this.h.invokeFunction(M.$Lmc);if(this.h.createInstance(b.$lnc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$JP);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(w.$nnc),await this.h.createInstance(d,i,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const u=await this.m.getConfigProvider();await(0,A.$knc)(this.j,u,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}wb(i){return i.main}async xb(i,n,u){if(n.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let o=null;u.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),o=le.__$__nodeRequire(n.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}return o}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const u=i[n];u===null?delete process.env[n]:process.env[n]=u}}}e.$onc=g}),define(ke[392],Se([1,0,53,21,4,3,125,11,23,2,32,12,265,66,110,88,389,28,20,70,367]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0,e.$pnc=o,e.$qnc=t,e.$rnc=h,e.$snc=s,e.$tnc=r,e.$unc=v,e.$vnc=f;function o(E){const k=E.trim().split(`
`),P=[];return k.forEach(T=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);j&&j.length>=3&&P.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),P.reduce((T,j)=>(T[j.socket]=j,T),{})}function t(...E){const k=[].concat(...E.map(s));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:h(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function h(E){let k="";if(E.length===8)for(let P=E.length-2;P>=0;P-=2)k+=parseInt(E.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<E.length;P+=8){const I=E.substring(P,P+8);let T="";for(let j=8;j>=2;j-=2)T+=I.substring(j-2,j),(j===6||j===2)&&(T=parseInt(T,16).toString(16),k+=`${T}`,T="",P+j!==E.length-6&&(k+=":"))}return k}function s(E){const k=E.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return k.map(T=>T.trim().split(/\s+/).reduce((j,z,O)=>(j[P[O]||O]=z,j),{}))}function c(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function r(E){const k=E.trim().split(`
`),P=[];return k.forEach(I=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);T&&T.length>=4&&P.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),P}async function v(E,k,P){const I=P.reduce((j,z)=>(j[z.pid]=z,j),{}),T=[];return E.forEach(({socket:j,ip:z,port:O})=>{const F=k[j]?k[j].pid:void 0,B=F?I[F]?.cmd:void 0;F&&B&&!c(B)&&T.push({host:z,port:O,detail:B,pid:F})}),T}function f(E,k,P){const I=new Map,T=r(k);for(const j of E){const z=P.get(j.port);if(z){I.set(j.port,z);continue}const O=T.find(F=>F.cmd.includes(`${j.port}`));if(O){let F=O,B;do B=T.find(W=>W.ppid===F.pid),B&&(F=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends n.$1Cb{constructor(k,P,I,T){super(k,P,I),this.D=P,this.F=T,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new R.$Bm;let T=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,d.$dw)(B.host)||(0,d.$fw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),T++>3&&I.update(O),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const F=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(B=>setTimeout(()=>B(),F))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await N.Promises.readFile("/proc/net/tcp","utf8"),P=await N.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(k,P),T=await new Promise(X=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,x,ne)=>{X(x)})}),j=o(T),z=await N.Promises.readdir("/proc"),O=[];for(const X of z)try{const Y=Number(X),x=$.$7g(S.URI.file("/proc"),X);if((await N.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Y)){const ge=await N.Promises.readlink($.$7g(x,"cwd").fsPath),ue=await N.Promises.readFile($.$7g(x,"cmdline").fsPath,"utf8");O.push({pid:Y,cwd:ge,cmd:ue})}}catch{}const F=[],B=I.filter(X=>{const Y=j[X.socket];return Y||F.push(X),Y}),W=v(B,j,O);let Z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const X=await new Promise(Y=>{(0,l.exec)("ps -F -A -l | grep root",(x,ne,ge)=>{Y(ne)})});this.z=f(F,X,this.z),Z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Z.map(Y=>Y.port).join(", ")}`)}return W.then(X=>Z?X.concat(Z):X)}w(k){return async P=>{const I=new g.$8cc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,O,F){const B=await k.makeConnection();return p.connect(B,z,O,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Fl(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const T=new L.$ce;return{localAddress:(0,u.$iM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:T.event,dispose:()=>{I.dispose(),T.fire(),T.dispose()}}}}};e.$wnc=D,e.$wnc=D=Je([Ve(0,i.$hP),Ve(1,a.$xP),Ve(2,C.$Zj),Ve(3,w.$Ml)],D);class p extends m.$Vsb{static connect(k,P,I,T){const j=new A.$Uc,z={onClose:j.add(new L.$ce),onData:j.add(new L.$ce),onEnd:j.add(new L.$ce)};j.add(k.onDidReceiveMessage(F=>z.onData.fire(M.$De.wrap(F)))),j.add(k.onDidEnd(()=>z.onEnd.fire())),j.add(k.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const O=new p(k,T,z);return O.B(j),(0,m.$Usb)(O,P,I,T,z)}constructor(k,P,I){super(P,I),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[393],Se([1,0,84,362,376,375,388,391,392,96,49,97,95,43,70,93,361,320,12,377,61,280,106,110,141]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a,i,n,u,o,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$ts)(N.$Elc,b.$onc,0),(0,l.$ts)(i.$1j,a.$ync,1),(0,l.$ts)(i.$Zj,new t.$qi(o.$Omc,[!1],!0)),(0,l.$ts)(h.$Ml,s.$adc,1),(0,l.$ts)(d.$7kc,g.$xnc,0),(0,l.$ts)(S.$Jlc,A.$2mc,0),(0,l.$ts)(C.$6lc,R.$jnc,0),(0,l.$ts)(m.$vmc,L.$Tmc,0),(0,l.$ts)(y.$plc,M.$Smc,0),(0,l.$ts)(w.$ZCb,$.$wnc,0),(0,l.$ts)(u.$Hlc,n.$znc,0)}),define(ke[404],Se([1,0,63,405,59,13,82,123,263,114,374,21,32,104,8,135,287,303,379,393]),function(le,e,l,M,L,A,R,b,$,S,N,C,m,y,w,d,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const i=M(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const v=globalThis._VSCODE_NODE_MODULES.module,f=v._load;v._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const n=process.exit.bind(process),u=process.on.bind(process);function o(v){process.exit=function(f){if(v)n(f);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(f,D){f==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),u(f,D)}}let t=function(v){n()};function h(){const v=(0,a.$ln)(process.env);if(v.type===3)return new Promise((f,D)=>{const p=E=>{const k=E[0],P=new R.$gi;k.on("message",I=>P.fire(C.$De.wrap(I.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),f({onMessage:P.event,send:I=>k.postMessage(I.buffer)})};process.parentPort.on("message",E=>p(E.ports))});if(v.type===2)return new Promise((f,D)=>{let p=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,P=3e5,I=new w.$Gh(()=>t("renderer disconnected for too long (1)"),k),T=new w.$Gh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const F=C.$De.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new b.$ii(O,"extHost-socket");else{const W=C.$De.wrap(Buffer.from(z.inflateBytes,"base64"));B=new b.$ji(new b.$ii(O,"extHost-socket"),z.permessageDeflate,W,!1)}p?(I.cancel(),T.cancel(),p.beginAcceptReconnection(B,F),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(E),p=new R.$hi({socket:B,initialChunk:F}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),f(p),p.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;I.isScheduled()&&T.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const f=v.pipeName;return new Promise((D,p)=>{const E=l.createConnection(f,()=>{E.removeListener("error",p);const k=new R.$hi({socket:new b.$ii(E,"extHost-renderer")});k.sendResume(),D(k)});E.once("error",p),E.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const v=await h();return new class{constructor(){this.a=new R.$gi,this.onMessage=this.a.event,this.b=!1,v.onMessage(f=>{(0,S.$Xm)(f,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||v.send(f)}async drain(){if(v.drain)return v.drain()}}}function c(v){return new Promise(f=>{const D=v.onMessage(p=>{D.dispose();const E=JSON.parse(p.toString()),k=E.commit,P=$.default.commit;if(k&&P&&k!==P&&n(55),E.parentPid){let I=0;setInterval(function(){try{process.kill(E.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start(E.parentPid)}catch(j){(0,A.$1)(j)}}v.send((0,S.$Wm)(0)),f({protocol:v,initData:E})});v.send((0,S.$Wm)(1))})}async function r(){const v=[];process.on("unhandledRejection",(I,T)=>{v.push(T),setTimeout(()=>{const j=v.indexOf(T);j>=0&&T.catch(z=>{v.splice(j,1),(0,A.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,A.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const T=v.indexOf(I);T>=0&&v.splice(T,1)}),process.on("uncaughtException",function(I){(0,A.$Z)(I)||(0,A.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const f=await s();L.mark("code/extHost/didConnectToRenderer");const D=await c(f);L.mark("code/extHost/didWaitForInitData");const{initData:p}=D;o(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,d.boolean)(i.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(T){n(T)}fsExists(T){return m.Promises.exists(T)}fsRealpath(T){return(0,y.$3q)(T)}};let k=null;p.remote.authority&&i.transformURIs&&(k=(0,g.$xs)(p.remote.authority));const P=new N.$Rmc(D.protocol,p,E,k);t=I=>P.terminate(I)}r().catch(v=>console.log(v))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/59d84c5c8cecf22b24e316c5443dc3ec49462589/core/vs/workbench/api/node/extensionHostProcess.js.map
