/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],S=0,F=ge.length;S<F;S++)e[S]=Pe[ge[S]];return e};define(Pe[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=F,e.$Yh=R,e.$Zh=O;function S(M){return(p,g,k)=>{let N=null,y=null;if(typeof k.value=="function"?(N="value",y=k.value):typeof k.get=="function"&&(N="get",y=k.get),!y)throw new Error("not supported");k[N]=M(y,g)}}function F(M,p,g){let k=null,N=null;if(typeof g.value=="function"?(k="value",N=g.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(k="get",N=g.get),!N)throw new Error("not supported");const y=`$memoize$${p}`;g[k]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,l)}),this[y]}}function R(M,p,g){return S((k,N)=>{const y=`$debounce$${N}`,l=`$debounce$result$${N}`;return function(...b){this[l]||(this[l]=g?g():void 0),clearTimeout(this[y]),p&&(this[l]=p(this[l],...b),b=[this[l]]),this[y]=setTimeout(()=>{k.apply(this,b),this[l]=g?g():void 0},M)}})}function O(M,p,g){return S((k,N)=>{const y=`$throttle$timer$${N}`,l=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...s){if(this[l]||(this[l]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),p&&(this[l]=p(this[l],...s)),this[m])return;const o=this[b]+M;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[l]]),this[l]=g?g():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),k.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}}),define(Pe[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class S{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$mP=S,e.$nP=new S("id#")}),define(Pe[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$En=M,e.$Fn=y,e.$Gn=l,e.$Hn=b,e.$In=m,e.$Jn=s,e.$Kn=o,e.$Ln=r,e.$Mn=t,e.$Nn=n,e.$On=c,e.$Pn=h;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(i,$=!1){let a=0;const v=i.length;let d="",P=0,u=16,E=0;function f(q){let A=0,j=0;for(;A<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;a++,A++}return A<q&&(j=-1),j}function D(q){a=q,d="",P=0,u=16,E=0}function w(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&k(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&k(i.charCodeAt(a)))for(a++;a<i.length&&k(i.charCodeAt(a));)a++;else return E=3,i.substring(q,a);let A=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&k(i.charCodeAt(a))){for(a++;a<i.length&&k(i.charCodeAt(a));)a++;A=a}else E=3;return i.substring(q,A)}function C(){let q="",A=a;for(;;){if(a>=v){q+=i.substring(A,a),E=2;break}const j=i.charCodeAt(a);if(j===34){q+=i.substring(A,a),a++;break}if(j===92){if(q+=i.substring(A,a),a++,a>=v){E=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const re=f(4);re>=0?q+=String.fromCharCode(re):E=4;break}default:E=5}A=a;continue}if(j>=0&&j<=31)if(g(j)){q+=i.substring(A,a),E=2;break}else E=6;a++}return q}function I(){if(d="",E=0,P=a,a>=v)return P=v,u=17;let q=i.charCodeAt(a);if(p(q)){do a++,d+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return u=15}if(g(q))return a++,d+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,d+=`
`),u=14;switch(q){case 123:return a++,u=1;case 125:return a++,u=2;case 91:return a++,u=3;case 93:return a++,u=4;case 58:return a++,u=6;case 44:return a++,u=5;case 34:return a++,d=C(),u=10;case 47:{const A=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<v&&!g(i.charCodeAt(a));)a++;return d=i.substring(A,a),u=12}if(i.charCodeAt(a+1)===42){a+=2;const j=v-1;let K=!1;for(;a<j;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,E=1),d=i.substring(A,a),u=13}return d+=String.fromCharCode(q),a++,u=16}case 45:if(d+=String.fromCharCode(q),a++,a===v||!k(i.charCodeAt(a)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=w(),u=11;default:for(;a<v&&W(q);)a++,q=i.charCodeAt(a);if(P!==a){switch(d=i.substring(P,a),d){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return d+=String.fromCharCode(q),a++,u=16}}function W(q){if(p(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=I();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:$?V:I,getToken:()=>u,getTokenValue:()=>d,getTokenOffset:()=>P,getTokenLength:()=>a-P,getTokenError:()=>E}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function y(i,$){const a=[],v=new Object;let d;const P={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function E(f,D,w,C){P.value=f,P.offset=D,P.length=w,P.type=C,P.colonOffset=void 0,d=P}try{n(i,{onObjectBegin:(f,D)=>{if($<=f)throw v;d=void 0,u=$>f,a.push("")},onObjectProperty:(f,D,w)=>{if($<D||(E(f,D,w,"property"),a[a.length-1]=f,$<=D+w))throw v},onObjectEnd:(f,D)=>{if($<=f)throw v;d=void 0,a.pop()},onArrayBegin:(f,D)=>{if($<=f)throw v;d=void 0,a.push(0)},onArrayEnd:(f,D)=>{if($<=f)throw v;d=void 0,a.pop()},onLiteralValue:(f,D,w)=>{if($<D||(E(f,D,w,h(f)),$<=D+w))throw v},onSeparator:(f,D,w)=>{if($<=D)throw v;if(f===":"&&d&&d.type==="property")d.colonOffset=D,u=!1,d=void 0;else if(f===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(u=!0,a[a.length-1]=""),d=void 0}}})}catch(f){if(f!==v)throw f}return{path:a,previousNode:d,isAtPropertyKey:u,matches:f=>{let D=0;for(let w=0;D<f.length&&w<a.length;w++)if(f[D]===a[w]||f[D]==="*")D++;else if(f[D]!=="**")return!1;return D===f.length}}}function l(i,$=[],a=O.DEFAULT){let v=null,d=[];const P=[];function u(f){Array.isArray(d)?d.push(f):v!==null&&(d[v]=f)}return n(i,{onObjectBegin:()=>{const f={};u(f),P.push(d),d=f,v=null},onObjectProperty:f=>{v=f},onObjectEnd:()=>{d=P.pop()},onArrayBegin:()=>{const f=[];u(f),P.push(d),d=f,v=null},onArrayEnd:()=>{d=P.pop()},onLiteralValue:u,onError:(f,D,w)=>{$.push({error:f,offset:D,length:w})}},a),d[0]}function b(i,$=[],a=O.DEFAULT){let v={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(f){v.type==="property"&&(v.length=f-v.offset,v=v.parent)}function P(f){return v.children.push(f),f}n(i,{onObjectBegin:f=>{v=P({type:"object",offset:f,length:-1,parent:v,children:[]})},onObjectProperty:(f,D,w)=>{v=P({type:"property",offset:D,length:-1,parent:v,children:[]}),v.children.push({type:"string",value:f,offset:D,length:w,parent:v})},onObjectEnd:(f,D)=>{v.length=f+D-v.offset,v=v.parent,d(f+D)},onArrayBegin:(f,D)=>{v=P({type:"array",offset:f,length:-1,parent:v,children:[]})},onArrayEnd:(f,D)=>{v.length=f+D-v.offset,v=v.parent,d(f+D)},onLiteralValue:(f,D,w)=>{P({type:h(f),offset:D,length:w,parent:v,value:f}),d(D+w)},onSeparator:(f,D,w)=>{v.type==="property"&&(f===":"?v.colonOffset=D:f===","&&d(D))},onError:(f,D,w)=>{$.push({error:f,offset:D,length:w})}},a);const E=v.children[0];return E&&delete E.parent,E}function m(i,$){if(!i)return;let a=i;for(const v of $)if(typeof v=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let d=!1;for(const P of a.children)if(Array.isArray(P.children)&&P.children[0].value===v){a=P.children[1],d=!0;break}if(!d)return}else{const d=v;if(a.type!=="array"||d<0||!Array.isArray(a.children)||d>=a.children.length)return;a=a.children[d]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const $=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;$.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&$.push(a)}return $}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const $=Object.create(null);for(const a of i.children){const v=a.children[1];v&&($[a.children[0].value]=o(v))}return $}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function r(i,$,a=!1){return $>=i.offset&&$<i.offset+i.length||a&&$===i.offset+i.length}function t(i,$,a=!1){if(r(i,$,a)){const v=i.children;if(Array.isArray(v))for(let d=0;d<v.length&&v[d].offset<=$;d++){const P=t(v[d],$,a);if(P)return P}return i}}function n(i,$,a=O.DEFAULT){const v=M(i,!1);function d(Me){return Me?()=>Me(v.getTokenOffset(),v.getTokenLength()):()=>!0}function P(Me){return Me?ce=>Me(ce,v.getTokenOffset(),v.getTokenLength()):()=>!0}const u=d($.onObjectBegin),E=P($.onObjectProperty),f=d($.onObjectEnd),D=d($.onArrayBegin),w=d($.onArrayEnd),C=P($.onLiteralValue),I=P($.onSeparator),W=d($.onComment),V=P($.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function j(){for(;;){const Me=v.scan();switch(v.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Me){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Me}}}function K(Me,ce=[],Re=[]){if(V(Me),ce.length+Re.length>0){let ie=v.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){j();break}else if(Re.indexOf(ie)!==-1)break;ie=j()}}}function re(Me){const ce=v.getTokenValue();return Me?C(ce):E(ce),j(),!0}function ae(){switch(v.getToken()){case 11:{let Me=0;try{Me=JSON.parse(v.getTokenValue()),typeof Me!="number"&&(K(2),Me=0)}catch{K(2)}C(Me);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function be(){return v.getToken()!==10?(K(3,[],[2,5]),!1):(re(!1),v.getToken()===6?(I(":"),j(),me()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){u(),j();let Me=!1;for(;v.getToken()!==2&&v.getToken()!==17;){if(v.getToken()===5){if(Me||K(4,[],[]),I(","),j(),v.getToken()===2&&A)break}else Me&&K(6,[],[]);be()||K(4,[],[2,5]),Me=!0}return f(),v.getToken()!==2?K(7,[2],[]):j(),!0}function de(){D(),j();let Me=!1;for(;v.getToken()!==4&&v.getToken()!==17;){if(v.getToken()===5){if(Me||K(4,[],[]),I(","),j(),v.getToken()===4&&A)break}else Me&&K(6,[],[]);me()||K(4,[],[4,5]),Me=!0}return w(),v.getToken()!==4?K(8,[4],[]):j(),!0}function me(){switch(v.getToken()){case 3:return de();case 1:return Ie();case 10:return re(!0);default:return ae()}}return j(),v.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):me()?(v.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,$){const a=M(i),v=[];let d,P=0,u;do switch(u=a.getPosition(),d=a.scan(),d){case 12:case 13:case 17:P!==u&&v.push(i.substring(P,u)),$!==void 0&&v.push(a.getTokenValue().replace(/[^\r\n]/g,$)),P=a.getPosition();break}while(d!==17);return v.join("")}function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ke,pe){for(var fe=0;fe<pe.length;fe++){var Q=pe[fe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ke,Q.key,Q)}}function S(ke,pe,fe){return pe&&e(ke.prototype,pe),fe&&e(ke,fe),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function F(ke,pe){if(ke){if(typeof ke=="string")return R(ke,pe);var fe=Object.prototype.toString.call(ke).slice(8,-1);if(fe==="Object"&&ke.constructor&&(fe=ke.constructor.name),fe==="Map"||fe==="Set")return Array.from(ke);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(ke,pe)}}function R(ke,pe){(pe==null||pe>ke.length)&&(pe=ke.length);for(var fe=0,Q=new Array(pe);fe<pe;fe++)Q[fe]=ke[fe];return Q}function O(ke,pe){var fe=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(fe)return(fe=fe.call(ke)).next.bind(fe);if(Array.isArray(ke)||(fe=F(ke))||pe&&ke&&typeof ke.length=="number"){fe&&(ke=fe);var Q=0;return function(){return Q>=ke.length?{done:!0}:{done:!1,value:ke[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(ke){ge.defaults=ke}var g=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(pe){return l[pe]};function m(ke,pe){if(pe){if(g.test(ke))return ke.replace(k,b)}else if(N.test(ke))return ke.replace(y,b);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(s,function(pe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var r=/(^|[^\[])\^/g;function t(ke,pe){ke=typeof ke=="string"?ke:ke.source,pe=pe||"";var fe={replace:function(X,le){return le=le.source||le,le=le.replace(r,"$1"),ke=ke.replace(X,le),fe},getRegex:function(){return new RegExp(ke,pe)}};return fe}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,pe,fe){if(ke){var Q;try{Q=decodeURIComponent(o(fe)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}pe&&!c.test(fe)&&(fe=d(pe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},$=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,v=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(ke,pe){i[" "+ke]||($.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=f(ke,"/",!0)),ke=i[" "+ke];var fe=ke.indexOf(":")===-1;return pe.substring(0,2)==="//"?fe?pe:ke.replace(a,"$1")+pe:pe.charAt(0)==="/"?fe?pe:ke.replace(v,"$1")+pe:ke+pe}var P={exec:function(){}};function u(ke){for(var pe=1,fe,Q;pe<arguments.length;pe++){fe=arguments[pe];for(Q in fe)Object.prototype.hasOwnProperty.call(fe,Q)&&(ke[Q]=fe[Q])}return ke}function E(ke,pe){var fe=ke.replace(/\|/g,function(le,ue,Ne){for(var he=!1,Ce=ue;--Ce>=0&&Ne[Ce]==="\\";)he=!he;return he?"|":" |"}),Q=fe.split(/ \|/),X=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>pe)Q.splice(pe);else for(;Q.length<pe;)Q.push("");for(;X<Q.length;X++)Q[X]=Q[X].trim().replace(/\\\|/g,"|");return Q}function f(ke,pe,fe){var Q=ke.length;if(Q===0)return"";for(var X=0;X<Q;){var le=ke.charAt(Q-X-1);if(le===pe&&!fe)X++;else if(le!==pe&&fe)X++;else break}return ke.slice(0,Q-X)}function D(ke,pe){if(ke.indexOf(pe[1])===-1)return-1;for(var fe=ke.length,Q=0,X=0;X<fe;X++)if(ke[X]==="\\")X++;else if(ke[X]===pe[0])Q++;else if(ke[X]===pe[1]&&(Q--,Q<0))return X;return-1}function w(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ke,pe){if(pe<1)return"";for(var fe="";pe>1;)pe&1&&(fe+=ke),pe>>=1,ke+=ke;return fe+ke}function I(ke,pe,fe,Q){var X=pe.href,le=pe.title?m(pe.title):null,ue=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:fe,href:X,title:le,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Ne}return{type:"image",raw:fe,href:X,title:le,text:m(ue)}}function W(ke,pe){var fe=ke.match(/^(\s+)(?:```)/);if(fe===null)return pe;var Q=fe[1];return pe.split(`
`).map(function(X){var le=X.match(/^\s+/);if(le===null)return X;var ue=le[0];return ue.length>=Q.length?X.slice(Q.length):X}).join(`
`)}var V=function(){function ke(fe){this.options=fe||ge.defaults}var pe=ke.prototype;return pe.space=function(Q){var X=this.rules.block.newline.exec(Q);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},pe.code=function(Q){var X=this.rules.block.code.exec(Q);if(X){var le=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},pe.fences=function(Q){var X=this.rules.block.fences.exec(Q);if(X){var le=X[0],ue=W(le,X[3]||"");return{type:"code",raw:le,lang:X[2]?X[2].trim():X[2],text:ue}}},pe.heading=function(Q){var X=this.rules.block.heading.exec(Q);if(X){var le=X[2].trim();if(/#$/.test(le)){var ue=f(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:le,tokens:this.lexer.inline(le)}}},pe.hr=function(Q){var X=this.rules.block.hr.exec(Q);if(X)return{type:"hr",raw:X[0]}},pe.blockquote=function(Q){var X=this.rules.block.blockquote.exec(Q);if(X){var le=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},pe.list=function(Q){var X=this.rules.block.list.exec(Q);if(X){var le,ue,Ne,he,Ce,Fe,ze,U,z,H,G,ee,ne=X[1].trim(),Oe=ne.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ne.slice(0,-1):"",loose:!1,items:[]};ne=Oe?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=Oe?ne:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(X=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if(le=X[0],Q=Q.substring(le.length),U=X[2].split(`
`,1)[0],z=Q.split(`
`,1)[0],this.options.pedantic?(he=2,G=U.trimLeft()):(he=X[2].search(/[^ ]/),he=he>4?1:he,G=U.slice(he),he+=X[1].length),Fe=!1,!U&&/^ *$/.test(z)&&(le+=z+`
`,Q=Q.substring(z.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(H=Q.split(`
`,1)[0],U=H,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(U)||it.test(U)||_e.test(U)||et.test(Q)));){if(U.search(/[^ ]/)>=he||!U.trim())G+=`
`+U.slice(he);else if(!Fe)G+=`
`+U;else break;!Fe&&!U.trim()&&(Fe=!0),le+=H+`
`,Q=Q.substring(H.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(G),ue&&(Ne=ue[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!ue,checked:Ne,loose:!1,text:G}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=G.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var at=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),mt=at.every(function(je){for(var st=je.raw.split(""),Y=0,Z=O(st),$e;!($e=Z()).done;){var Ge=$e.value;if(Ge===`
`&&(Y+=1),Y>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},pe.html=function(Q){var X=this.rules.block.html.exec(Q);if(X){var le={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},pe.def=function(Q){var X=this.rules.block.def.exec(Q);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var le=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:X[0],href:X[2],title:X[3]}}},pe.table=function(Q){var X=this.rules.block.table.exec(Q);if(X){var le={type:"table",header:E(X[1]).map(function(ze){return{text:ze}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=X[0];var ue=le.align.length,Ne,he,Ce,Fe;for(Ne=0;Ne<ue;Ne++)/^ *-+: *$/.test(le.align[Ne])?le.align[Ne]="right":/^ *:-+: *$/.test(le.align[Ne])?le.align[Ne]="center":/^ *:-+ *$/.test(le.align[Ne])?le.align[Ne]="left":le.align[Ne]=null;for(ue=le.rows.length,Ne=0;Ne<ue;Ne++)le.rows[Ne]=E(le.rows[Ne],le.header.length).map(function(ze){return{text:ze}});for(ue=le.header.length,he=0;he<ue;he++)le.header[he].tokens=this.lexer.inline(le.header[he].text);for(ue=le.rows.length,he=0;he<ue;he++)for(Fe=le.rows[he],Ce=0;Ce<Fe.length;Ce++)Fe[Ce].tokens=this.lexer.inline(Fe[Ce].text);return le}}},pe.lheading=function(Q){var X=this.rules.block.lheading.exec(Q);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},pe.paragraph=function(Q){var X=this.rules.block.paragraph.exec(Q);if(X){var le=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:le,tokens:this.lexer.inline(le)}}},pe.text=function(Q){var X=this.rules.block.text.exec(Q);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},pe.escape=function(Q){var X=this.rules.inline.escape.exec(Q);if(X)return{type:"escape",raw:X[0],text:m(X[1])}},pe.tag=function(Q){var X=this.rules.inline.tag.exec(Q);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]):X[0]}},pe.link=function(Q){var X=this.rules.inline.link.exec(Q);if(X){var le=X[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=f(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var Ne=D(X[2],"()");if(Ne>-1){var he=X[0].indexOf("!")===0?5:4,Ce=he+X[1].length+Ne;X[2]=X[2].substring(0,Ne),X[0]=X[0].substring(0,Ce).trim(),X[3]=""}}var Fe=X[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Fe);U&&(Fe=U[1],ze=U[3])}else ze=X[3]?X[3].slice(1,-1):"";return Fe=Fe.trim(),/^</.test(Fe)&&(this.options.pedantic&&!/>$/.test(le)?Fe=Fe.slice(1):Fe=Fe.slice(1,-1)),I(X,{href:Fe&&Fe.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},pe.reflink=function(Q,X){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=X[ue.toLowerCase()],!ue||!ue.href){var Ne=le[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return I(le,ue,le[0],this.lexer)}},pe.emStrong=function(Q,X,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=ue[1]||ue[2]||"";if(!Ne||Ne&&(le===""||this.rules.inline.punctuation.exec(le))){var he=ue[0].length-1,Ce,Fe,ze=he,U=0,z=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,X=X.slice(-1*Q.length+he);(ue=z.exec(X))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Fe=Ce.length,ue[3]||ue[4]){ze+=Fe;continue}else if((ue[5]||ue[6])&&he%3&&!((he+Fe)%3)){U+=Fe;continue}if(ze-=Fe,!(ze>0)){if(Fe=Math.min(Fe,Fe+ze+U),Math.min(he,Fe)%2){var H=Q.slice(1,he+ue.index+Fe);return{type:"em",raw:Q.slice(0,he+ue.index+Fe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var G=Q.slice(2,he+ue.index+Fe-1);return{type:"strong",raw:Q.slice(0,he+ue.index+Fe+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},pe.codespan=function(Q){var X=this.rules.inline.code.exec(Q);if(X){var le=X[2].replace(/\n/g," "),ue=/[^ ]/.test(le),Ne=/^ /.test(le)&&/ $/.test(le);return ue&&Ne&&(le=le.substring(1,le.length-1)),le=m(le,!0),{type:"codespan",raw:X[0],text:le}}},pe.br=function(Q){var X=this.rules.inline.br.exec(Q);if(X)return{type:"br",raw:X[0]}},pe.del=function(Q){var X=this.rules.inline.del.exec(Q);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},pe.autolink=function(Q,X){var le=this.rules.inline.autolink.exec(Q);if(le){var ue,Ne;return le[2]==="@"?(ue=m(this.options.mangle?X(le[1]):le[1]),Ne="mailto:"+ue):(ue=m(le[1]),Ne=ue),{type:"link",raw:le[0],text:ue,href:Ne,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(Q,X){var le;if(le=this.rules.inline.url.exec(Q)){var ue,Ne;if(le[2]==="@")ue=m(this.options.mangle?X(le[0]):le[0]),Ne="mailto:"+ue;else{var he;do he=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(he!==le[0]);ue=m(le[0]),le[1]==="www."?Ne="http://"+ue:Ne=ue}return{type:"link",raw:le[0],text:ue,href:Ne,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(Q,X){var le=this.rules.inline.text.exec(Q);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]:ue=m(this.options.smartypants?X(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:P,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=t(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=t(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=t(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=t(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=t(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=t(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=u({},q),q.gfm=u({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=t(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=t(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=u({},q.normal,{html:t(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,paragraph:t(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:P,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:P,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=t(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=t(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=t(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=t(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=t(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=t(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=t(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=t(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=t(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=t(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=t(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=u({},A),A.pedantic=u({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:t(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:t(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=u({},A.normal,{escape:t(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=t(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=u({},A.gfm,{br:t(A.br).replace("{2,}","*").getRegex(),text:t(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var pe="",fe,Q,X=ke.length;for(fe=0;fe<X;fe++)Q=ke.charCodeAt(fe),Math.random()>.5&&(Q="x"+Q.toString(16)),pe+="&#"+Q+";";return pe}var re=function(){function ke(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}ke.lex=function(Q,X){var le=new ke(X);return le.lex(Q)},ke.lexInline=function(Q,X){var le=new ke(X);return le.inlineTokens(Q)};var pe=ke.prototype;return pe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},pe.blockTokens=function(Q,X){var le=this;X===void 0&&(X=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(ze,U,z){return U+"    ".repeat(z.length)});for(var ue,Ne,he,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ue=ze.call({lexer:le},Q,X))?(Q=Q.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Ne=X[X.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):X.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Ne=X[X.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=Q.slice(1),z=void 0;le.options.extensions.startBlock.forEach(function(H){z=H.call({lexer:this},U),typeof z=="number"&&z>=0&&(ze=Math.min(ze,z))}),ze<1/0&&ze>=0&&(he=Q.substring(0,ze+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(he))){Ne=X[X.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):X.push(ue),Ce=he.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Ne=X[X.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+ue.raw,Ne.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):X.push(ue);continue}if(Q){var Fe="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return this.state.top=!0,X},pe.inline=function(Q,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:Q,tokens:X}),X},pe.inlineTokens=function(Q,X){var le=this;X===void 0&&(X=[]);var ue,Ne,he,Ce=Q,Fe,ze,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Fe=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)z.includes(Fe[0].slice(Fe[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Fe.index)+"["+C("a",Fe[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Fe=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Fe.index)+"["+C("a",Fe[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Fe=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Fe.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(ue=G.call({lexer:le},Q,X))?(Q=Q.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Ne=X[X.length-1],Ne&&ue.type==="text"&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Ne=X[X.length-1],Ne&&ue.type==="text"&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,U)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,ee=Q.slice(1),ne=void 0;le.options.extensions.startInline.forEach(function(Oe){ne=Oe.call({lexer:this},ee),typeof ne=="number"&&ne>=0&&(G=Math.min(G,ne))}),G<1/0&&G>=0&&(he=Q.substring(0,G+1))}(),ue=this.tokenizer.inlineText(he,j)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),ze=!0,Ne=X[X.length-1],Ne&&Ne.type==="text"?(Ne.raw+=ue.raw,Ne.text+=ue.text):X.push(ue);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return X},S(ke,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),ke}(),ae=function(){function ke(fe){this.options=fe||ge.defaults}var pe=ke.prototype;return pe.code=function(Q,X,le){var ue=(X||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,ue);Ne!=null&&Ne!==Q&&(le=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+m(ue,!0)+'">'+(le?Q:m(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:m(Q,!0))+`</code></pre>
`},pe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},pe.html=function(Q){return Q},pe.heading=function(Q,X,le,ue){if(this.options.headerIds){var Ne=this.options.headerPrefix+ue.slug(le);return"<h"+X+' id="'+Ne+'">'+Q+"</h"+X+`>
`}return"<h"+X+">"+Q+"</h"+X+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Q,X,le){var ue=X?"ol":"ul",Ne=X&&le!==1?' start="'+le+'"':"";return"<"+ue+Ne+`>
`+Q+"</"+ue+`>
`},pe.listitem=function(Q){return"<li>"+Q+`</li>
`},pe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Q){return"<p>"+Q+`</p>
`},pe.table=function(Q,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+X+`</table>
`},pe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},pe.tablecell=function(Q,X){var le=X.header?"th":"td",ue=X.align?"<"+le+' align="'+X.align+'">':"<"+le+">";return ue+Q+("</"+le+`>
`)},pe.strong=function(Q){return"<strong>"+Q+"</strong>"},pe.em=function(Q){return"<em>"+Q+"</em>"},pe.codespan=function(Q){return"<code>"+Q+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Q){return"<del>"+Q+"</del>"},pe.link=function(Q,X,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ue='<a href="'+m(Q)+'"';return X&&(ue+=' title="'+X+'"'),ue+=">"+le+"</a>",ue},pe.image=function(Q,X,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ue='<img src="'+Q+'" alt="'+le+'"';return X&&(ue+=' title="'+X+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(Q){return Q},ke}(),be=function(){function ke(){}var pe=ke.prototype;return pe.strong=function(Q){return Q},pe.em=function(Q){return Q},pe.codespan=function(Q){return Q},pe.del=function(Q){return Q},pe.html=function(Q){return Q},pe.text=function(Q){return Q},pe.link=function(Q,X,le){return""+le},pe.image=function(Q,X,le){return""+le},pe.br=function(){return""},ke}(),Ie=function(){function ke(){this.seen={}}var pe=ke.prototype;return pe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Q,X){var le=Q,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[Q];do ue++,le=Q+"-"+ue;while(this.seen.hasOwnProperty(le))}return X||(this.seen[Q]=ue,this.seen[le]=0),le},pe.slug=function(Q,X){X===void 0&&(X={});var le=this.serialize(Q);return this.getNextSafeSlug(le,X.dryrun)},ke}(),de=function(){function ke(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Ie}ke.parse=function(Q,X){var le=new ke(X);return le.parse(Q)},ke.parseInline=function(Q,X){var le=new ke(X);return le.parseInline(Q)};var pe=ke.prototype;return pe.parse=function(Q,X){X===void 0&&(X=!0);var le="",ue,Ne,he,Ce,Fe,ze,U,z,H,G,ee,ne,Oe,Be,Qe,_e,et,tt,it,nt=Q.length;for(ue=0;ue<nt;ue++){if(G=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(it=this.options.extensions.renderers[G.type].call({parser:this},G),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){le+=it||"";continue}switch(G.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(G.tokens),G.depth,o(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(z="",U="",Ce=G.header.length,Ne=0;Ne<Ce;Ne++)U+=this.renderer.tablecell(this.parseInline(G.header[Ne].tokens),{header:!0,align:G.align[Ne]});for(z+=this.renderer.tablerow(U),H="",Ce=G.rows.length,Ne=0;Ne<Ce;Ne++){for(ze=G.rows[Ne],U="",Fe=ze.length,he=0;he<Fe;he++)U+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:G.align[he]});H+=this.renderer.tablerow(U)}le+=this.renderer.table(z,H);continue}case"blockquote":{H=this.parse(G.tokens),le+=this.renderer.blockquote(H);continue}case"list":{for(ee=G.ordered,ne=G.start,Oe=G.loose,Ce=G.items.length,H="",Ne=0;Ne<Ce;Ne++)Qe=G.items[Ne],_e=Qe.checked,et=Qe.task,Be="",Qe.task&&(tt=this.renderer.checkbox(_e),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=tt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=tt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Qe.tokens,Oe),H+=this.renderer.listitem(Be,et,_e);le+=this.renderer.list(H,ee,ne);continue}case"html":{le+=this.renderer.html(G.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(H=G.tokens?this.parseInline(G.tokens):G.text;ue+1<nt&&Q[ue+1].type==="text";)G=Q[++ue],H+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);le+=X?this.renderer.paragraph(H):H;continue}default:{var at='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return le},pe.parseInline=function(Q,X){X=X||this.renderer;var le="",ue,Ne,he,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Ne=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(he=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){le+=he||"";continue}switch(Ne.type){case"escape":{le+=X.text(Ne.text);break}case"html":{le+=X.html(Ne.text);break}case"link":{le+=X.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,X));break}case"image":{le+=X.image(Ne.href,Ne.title,Ne.text);break}case"strong":{le+=X.strong(this.parseInline(Ne.tokens,X));break}case"em":{le+=X.em(this.parseInline(Ne.tokens,X));break}case"codespan":{le+=X.codespan(Ne.text);break}case"br":{le+=X.br();break}case"del":{le+=X.del(this.parseInline(Ne.tokens,X));break}case"text":{le+=X.text(Ne.text);break}default:{var Fe='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return le},ke}();function me(ke,pe,fe){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof pe=="function"&&(fe=pe,pe=null),pe=u({},me.defaults,pe||{}),w(pe),fe){var Q=pe.highlight,X;try{X=re.lex(ke,pe)}catch(Ce){return fe(Ce)}var le=function(Fe){var ze;if(!Fe)try{pe.walkTokens&&me.walkTokens(X,pe.walkTokens),ze=de.parse(X,pe)}catch(U){Fe=U}return pe.highlight=Q,Fe?fe(Fe):fe(null,ze)};if(!Q||Q.length<3||(delete pe.highlight,!X.length))return le();var ue=0;me.walkTokens(X,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Fe,ze){if(Fe)return le(Fe);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Ce.message+"",!0)+"</pre>";throw Ce}try{var he=re.lex(ke,pe);if(pe.walkTokens){if(pe.async)return Promise.all(me.walkTokens(he,pe.walkTokens)).then(function(){return de.parse(he,pe)}).catch(Ne);me.walkTokens(he,pe.walkTokens)}return de.parse(he,pe)}catch(Ce){Ne(Ce)}}me.options=me.setOptions=function(ke){return u(me.defaults,ke),p(me.defaults),me},me.getDefaults=M,me.defaults=ge.defaults,me.use=function(){for(var ke=arguments.length,pe=new Array(ke),fe=0;fe<ke;fe++)pe[fe]=arguments[fe];var Q=u.apply(void 0,[{}].concat(pe)),X=me.defaults.extensions||{renderers:{},childTokens:{}},le;pe.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=X.renderers?X.renderers[he.name]:null;Ce?X.renderers[he.name]=function(){for(var Fe=arguments.length,ze=new Array(Fe),U=0;U<Fe;U++)ze[U]=arguments[U];var z=he.renderer.apply(this,ze);return z===!1&&(z=Ce.apply(this,ze)),z}:X.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[he.level]?X[he.level].unshift(he.tokenizer):X[he.level]=[he.tokenizer],he.start&&(he.level==="block"?X.startBlock?X.startBlock.push(he.start):X.startBlock=[he.start]:he.level==="inline"&&(X.startInline?X.startInline.push(he.start):X.startInline=[he.start]))}he.childTokens&&(X.childTokens[he.name]=he.childTokens)})),ue.renderer&&function(){var he=me.defaults.renderer||new ae,Ce=function(U){var z=he[U];he[U]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var ne=ue.renderer[U].apply(he,G);return ne===!1&&(ne=z.apply(he,G)),ne}};for(var Fe in ue.renderer)Ce(Fe);Q.renderer=he}(),ue.tokenizer&&function(){var he=me.defaults.tokenizer||new V,Ce=function(U){var z=he[U];he[U]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var ne=ue.tokenizer[U].apply(he,G);return ne===!1&&(ne=z.apply(he,G)),ne}};for(var Fe in ue.tokenizer)Ce(Fe);Q.tokenizer=he}(),ue.walkTokens){var Ne=me.defaults.walkTokens;Q.walkTokens=function(he){var Ce=[];return Ce.push(ue.walkTokens.call(this,he)),Ne&&(Ce=Ce.concat(Ne.call(this,he))),Ce}}le&&(Q.extensions=X),me.setOptions(Q)})},me.walkTokens=function(ke,pe){for(var fe=[],Q=function(){var Ne=le.value;switch(fe=fe.concat(pe.call(me,Ne)),Ne.type){case"table":{for(var he=O(Ne.header),Ce;!(Ce=he()).done;){var Fe=Ce.value;fe=fe.concat(me.walkTokens(Fe.tokens,pe))}for(var ze=O(Ne.rows),U;!(U=ze()).done;)for(var z=U.value,H=O(z),G;!(G=H()).done;){var ee=G.value;fe=fe.concat(me.walkTokens(ee.tokens,pe))}break}case"list":{fe=fe.concat(me.walkTokens(Ne.items,pe));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[Ne.type]?me.defaults.extensions.childTokens[Ne.type].forEach(function(ne){fe=fe.concat(me.walkTokens(Ne[ne],pe))}):Ne.tokens&&(fe=fe.concat(me.walkTokens(Ne.tokens,pe)))}},X=O(ke),le;!(le=X()).done;)Q();return fe},me.parseInline=function(ke,pe){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");pe=u({},me.defaults,pe||{}),w(pe);try{var fe=re.lexInline(ke,pe);return pe.walkTokens&&me.walkTokens(fe,pe.walkTokens),de.parseInline(fe,pe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Q.message+"",!0)+"</pre>";throw Q}},me.Parser=de,me.parser=de.parse,me.Renderer=ae,me.TextRenderer=be,me.Lexer=re,me.lexer=re.lex,me.Tokenizer=V,me.Slugger=Ie,me.parse=me;var Me=me.options,ce=me.setOptions,Re=me.use,ie=me.walkTokens,L=me.parseInline,x=me,ve=de.parse,Te=re.lex;ge.Lexer=re,ge.Parser=de,ge.Renderer=ae,ge.Slugger=Ie,ge.TextRenderer=be,ge.Tokenizer=V,ge.getDefaults=M,ge.lexer=Te,ge.marked=me,ge.options=Me,ge.parse=x,ge.parseInline=L,ge.parser=ve,ge.setOptions=ce,ge.use=Re,ge.walkTokens=ie,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=S;function S(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let F=0;const R=new Uint32Array(10);function O(s){if(F=0,M(s,y,4352),F>0||(M(s,l,4449),F>0)||(M(s,b,4520),F>0)||(M(s,m,12593),F))return R.subarray(0,F);if(s>=44032&&s<=55203){const o=s-44032,r=o%588,t=Math.floor(o/588),n=Math.floor(r/28),c=r%28-1;if(t<y.length?M(t,y,0):4352+t-12593<m.length&&M(4352+t,m,12593),n<l.length?M(n,l,0):4449+n-12593<m.length&&M(4449+n-12593,m,12593),c>=0&&(c<b.length?M(c,b,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),F>0)return R.subarray(0,F)}}function M(s,o,r){s>=r&&s<r+o.length&&p(o[s-r])}function p(s){s!==0&&(R[F++]=s&255,s>>8&&(R[F++]=s>>8&255),s>>16&&(R[F++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0,e.$ym=S,e.rot=F;function S(p,g,k){return Math.min(Math.max(p,g),k)}function F(p,g){return(g+p%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Am=R;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Bm=O;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const k=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Cm=M}),function(){function ge(R){const O=[];typeof R=="number"&&O.push("code/timeOrigin",R);function M(g){O.push(g,Date.now())}function p(){const g=[];for(let k=0;k<O.length;k+=2)g.push({name:O[k],startTime:O[k+1]});return g}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(R+M.startTime)});return O}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function S(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),define(Pe[127],Ae([1,0,40]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=void 0;const F=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||S.Iterable.empty()}insert(g,k,N){this.d(g,y=>y._value=k,N)}mutate(g,k){this.d(g,N=>N._value=k(N._value===F?void 0:N._value))}delete(g){const k=this.c(g);if(!k)return;let N=k.length-1;const y=k[N].node._value;if(y!==F){for(this.b--,k[N].node._value=F;N>0;N--){const{node:l,part:b}=k[N];if(l.children?.size||l._value!==F)break;k[N-1].node.children.delete(b)}return y}}*deleteRecursive(g){const k=this.c(g);if(!k)return;const N=k[k.length-1].node;for(let y=k.length-1;y>0;y--){const l=k[y-1];if(l.node.children.delete(k[y].part),l.node.children.size>0||l.node._value!==F)break}for(const y of O(N))y._value!==F&&(this.b--,yield y._value)}find(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return;k=y}return k._value===F?void 0:k._value}hasKeyOrParent(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;if(y._value!==F)return!0;k=y}return!1}hasKeyOrChildren(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return!0}hasKey(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return k._value!==F}c(g){const k=[{part:"",node:this.a}];let N=0;for(const y of g){const l=k[N].node.children?.get(y);if(!l)return;k.push({part:y,node:l}),N++}return k}d(g,k,N){let y=this.a;for(const m of g){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}N?.(y)}const l=y._value===F?0:1;k(y);const b=y._value===F?0:1;this.b+=b-l}*values(){for(const{_value:g}of O(this.a))g!==F&&(yield g)}}e.$9O=R;function*O(p){const g=[p];for(;g.length>0;){const k=g.pop();if(yield k,k.children)for(const N of k.children.values())g.push(N)}}class M{constructor(){this._value=F}get value(){return this._value===F?void 0:this._value}set value(g){this._value=g===void 0?F:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:ge)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function S(F){if(e[F])return e[F].exports;var R=e[F]={i:F,l:!1,exports:{}};return ge[F].call(R.exports,R,R.exports,S),R.l=!0,R.exports}return S.m=ge,S.c=e,S.d=function(F,R,O){S.o(F,R)||Object.defineProperty(F,R,{enumerable:!0,get:O})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,R){if(1&R&&(F=S(F)),8&R||4&R&&typeof F=="object"&&F&&F.__esModule)return F;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:F}),2&R&&typeof F!="string")for(var M in F)S.d(O,M,function(p){return F[p]}.bind(null,M));return O},S.n=function(F){var R=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(R,"a",R),R},S.o=function(F,R){return Object.prototype.hasOwnProperty.call(F,R)},S.p="",S(S.s=0)}([function(ge,e,S){(function(F){var R;e=ge.exports=Re,R=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],g=e.src=[],k=0,N=k++;g[N]="0|[1-9]\\d*";var y=k++;g[y]="[0-9]+";var l=k++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;g[b]="("+g[N]+")\\.("+g[N]+")\\.("+g[N]+")";var m=k++;g[m]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var s=k++;g[s]="(?:"+g[N]+"|"+g[l]+")";var o=k++;g[o]="(?:"+g[y]+"|"+g[l]+")";var r=k++;g[r]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var t=k++;g[t]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var n=k++;g[n]="[0-9A-Za-z-]+";var c=k++;g[c]="(?:\\+("+g[n]+"(?:\\."+g[n]+")*))";var h=k++,i="v?"+g[b]+g[r]+"?"+g[c]+"?";g[h]="^"+i+"$";var $="[v=\\s]*"+g[m]+g[t]+"?"+g[c]+"?",a=k++;g[a]="^"+$+"$";var v=k++;g[v]="((?:<|>)?=?)";var d=k++;g[d]=g[y]+"|x|X|\\*";var P=k++;g[P]=g[N]+"|x|X|\\*";var u=k++;g[u]="[v=\\s]*("+g[P]+")(?:\\.("+g[P]+")(?:\\.("+g[P]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var E=k++;g[E]="[v=\\s]*("+g[d]+")(?:\\.("+g[d]+")(?:\\.("+g[d]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var f=k++;g[f]="^"+g[v]+"\\s*"+g[u]+"$";var D=k++;g[D]="^"+g[v]+"\\s*"+g[E]+"$";var w=k++;g[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;g[C]="(?:~>?)";var I=k++;g[I]="(\\s*)"+g[C]+"\\s+",p[I]=new RegExp(g[I],"g");var W=k++;g[W]="^"+g[C]+g[u]+"$";var V=k++;g[V]="^"+g[C]+g[E]+"$";var q=k++;g[q]="(?:\\^)";var A=k++;g[A]="(\\s*)"+g[q]+"\\s+",p[A]=new RegExp(g[A],"g");var j=k++;g[j]="^"+g[q]+g[u]+"$";var K=k++;g[K]="^"+g[q]+g[E]+"$";var re=k++;g[re]="^"+g[v]+"\\s*("+$+")$|^$";var ae=k++;g[ae]="^"+g[v]+"\\s*("+i+")$|^$";var be=k++;g[be]="(\\s*)"+g[v]+"\\s*("+$+"|"+g[u]+")",p[be]=new RegExp(g[be],"g");var Ie=k++;g[Ie]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var de=k++;g[de]="^\\s*("+g[E]+")\\s+-\\s+("+g[E]+")\\s*$";var me=k++;g[me]="(<|>)?=?\\s*\\*";for(var Me=0;Me<35;Me++)R(Me,g[Me]),p[Me]||(p[Me]=new RegExp(g[Me]));function ce(z,H){if(z instanceof Re)return z;if(typeof z!="string"||z.length>O||!(H?p[a]:p[h]).test(z))return null;try{return new Re(z,H)}catch{return null}}function Re(z,H){if(z instanceof Re){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Re))return new Re(z,H);R("SemVer",z,H),this.loose=H;var G=z.trim().match(H?p[a]:p[h]);if(!G)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var ne=+ee;if(ne>=0&&ne<M)return ne}return ee}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=ce,e.valid=function(z,H){var G=ce(z,H);return G?G.version:null},e.clean=function(z,H){var G=ce(z.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=Re,Re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Re.prototype.toString=function(){return this.version},Re.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof Re||(z=new Re(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Re.prototype.compareMain=function(z){return z instanceof Re||(z=new Re(z,this.loose)),L(this.major,z.major)||L(this.minor,z.minor)||L(this.patch,z.patch)},Re.prototype.comparePre=function(z){if(z instanceof Re||(z=new Re(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],ee=z.prerelease[H];if(R("prerelease compare",H,G,ee),G===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(G===void 0)return-1;if(G!==ee)return L(G,ee)}while(++H)},Re.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,G,ee){typeof G=="string"&&(ee=G,G=void 0);try{return new Re(z,G).inc(H,ee).version}catch{return null}},e.diff=function(z,H){if(ke(z,H))return null;var G=ce(z),ee=ce(H);if(G.prerelease.length||ee.prerelease.length){for(var ne in G)if((ne==="major"||ne==="minor"||ne==="patch")&&G[ne]!==ee[ne])return"pre"+ne;return"prerelease"}for(var ne in G)if((ne==="major"||ne==="minor"||ne==="patch")&&G[ne]!==ee[ne])return ne},e.compareIdentifiers=L;var ie=/^[0-9]+$/;function L(z,H){var G=ie.test(z),ee=ie.test(H);return G&&ee&&(z=+z,H=+H),G&&!ee?-1:ee&&!G?1:z<H?-1:z>H?1:0}function x(z,H,G){return new Re(z,G).compare(new Re(H,G))}function ve(z,H,G){return x(z,H,G)>0}function Te(z,H,G){return x(z,H,G)<0}function ke(z,H,G){return x(z,H,G)===0}function pe(z,H,G){return x(z,H,G)!==0}function fe(z,H,G){return x(z,H,G)>=0}function Q(z,H,G){return x(z,H,G)<=0}function X(z,H,G,ee){var ne;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),ne=z===G;break;case"!==":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),ne=z!==G;break;case"":case"=":case"==":ne=ke(z,G,ee);break;case"!=":ne=pe(z,G,ee);break;case">":ne=ve(z,G,ee);break;case">=":ne=fe(z,G,ee);break;case"<":ne=Te(z,G,ee);break;case"<=":ne=Q(z,G,ee);break;default:throw new TypeError("Invalid operator: "+H)}return ne}function le(z,H){if(z instanceof le){if(z.loose===H)return z;z=z.value}if(!(this instanceof le))return new le(z,H);R("comparator",z,H),this.loose=H,this.parse(z),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,H){return L(H,z)},e.major=function(z,H){return new Re(z,H).major},e.minor=function(z,H){return new Re(z,H).minor},e.patch=function(z,H){return new Re(z,H).patch},e.compare=x,e.compareLoose=function(z,H){return x(z,H,!0)},e.rcompare=function(z,H,G){return x(H,z,G)},e.sort=function(z,H){return z.sort(function(G,ee){return e.compare(G,ee,H)})},e.rsort=function(z,H){return z.sort(function(G,ee){return e.rcompare(G,ee,H)})},e.gt=ve,e.lt=Te,e.eq=ke,e.neq=pe,e.gte=fe,e.lte=Q,e.cmp=X,e.Comparator=le;var ue={};function Ne(z,H){if(z instanceof Ne)return z.loose===H?z:new Ne(z.raw,H);if(z instanceof le)return new Ne(z.value,H);if(!(this instanceof Ne))return new Ne(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ce(z,H,G,ee,ne,Oe,Be,Qe,_e,et,tt,it,nt){return((H=he(G)?"":he(ee)?">="+G+".0.0":he(ne)?">="+G+"."+ee+".0":">="+H)+" "+(Qe=he(_e)?"":he(et)?"<"+(+_e+1)+".0.0":he(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Qe)).trim()}function Fe(z,H){for(var G=0;G<z.length;G++)if(!z[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<z.length;G++)if(R(z[G].semver),z[G].semver!==ue&&z[G].semver.prerelease.length>0){var ee=z[G].semver;if(ee.major===H.major&&ee.minor===H.minor&&ee.patch===H.patch)return!0}return!1}return!0}function ze(z,H,G){try{H=new Ne(H,G)}catch{return!1}return H.test(z)}function U(z,H,G,ee){var ne,Oe,Be,Qe,_e;switch(z=new Re(z,ee),H=new Ne(H,ee),G){case">":ne=ve,Oe=Q,Be=Te,Qe=">",_e=">=";break;case"<":ne=Te,Oe=fe,Be=ve,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,H,ee))return!1;for(var et=0;et<H.set.length;++et){var tt=H.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===ue&&(at=new le(">=0.0.0")),it=it||at,nt=nt||at,ne(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Qe||it.operator===_e||(!nt.operator||nt.operator===Qe)&&Oe(z,nt.semver)||nt.operator===_e&&Be(z,nt.semver))return!1}return!0}le.prototype.parse=function(z){var H=this.loose?p[re]:p[ae],G=z.match(H);if(!G)throw new TypeError("Invalid comparator: "+z);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Re(G[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===ue||(typeof z=="string"&&(z=new Re(z,this.loose)),X(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Ne(z.value,H),ze(this.value,G,H);if(z.operator==="")return G=new Ne(this.value,H),ze(z.semver,G,H);var ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ne=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Qe=X(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),_e=X(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ee||ne||Oe&&Be||Qe||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),R("range",z,H);var G=H?p[de]:p[Ie];z=z.replace(G,Ce),R("hyphen replace",z),z=z.replace(p[be],"$1$2$3"),R("comparator trim",z,p[be]),z=(z=(z=z.replace(p[I],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var ee=H?p[re]:p[ae],ne=z.split(" ").map(function(Oe){return function(Be,Qe){return R("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){R("caret",it,nt);var at=nt?p[K]:p[j];return it.replace(at,function(mt,je,st,Y,Z){var $e;return R("caret",it,mt,je,st,Y,Z),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Y)?$e=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Y+Z+" <"+je+"."+st+"."+(+Y+1):">="+je+"."+st+"."+Y+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Y+Z+" <"+(+je+1)+".0.0"):(R("no pr"),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Y+" <"+je+"."+st+"."+(+Y+1):">="+je+"."+st+"."+Y+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Y+" <"+(+je+1)+".0.0"),R("caret return",$e),$e})}(tt,et)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[V]:p[W];return it.replace(at,function(mt,je,st,Y,Z){var $e;return R("tilde",it,mt,je,st,Y,Z),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Y)?$e=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),$e=">="+je+"."+st+"."+Y+Z+" <"+je+"."+(+st+1)+".0"):$e=">="+je+"."+st+"."+Y+" <"+je+"."+(+st+1)+".0",R("tilde return",$e),$e})}(tt,et)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(_e,et){return R("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[D]:p[f];return it.replace(at,function(mt,je,st,Y,Z,$e){R("xRange",it,mt,je,st,Y,Z,$e);var Ge=he(st),ye=Ge||he(Y),ot=ye||he(Z);return je==="="&&ot&&(je=""),Ge?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(Y=0),ot&&(Z=0),je===">"?(je=">=",ye?(st=+st+1,Y=0,Z=0):ot&&(Y=+Y+1,Z=0)):je==="<="&&(je="<",ye?st=+st+1:Y=+Y+1),mt=je+st+"."+Y+"."+Z):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+Y+".0 <"+st+"."+(+Y+1)+".0"),R("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(_e,et){return R("replaceStars",_e,et),_e.trim().replace(p[me],"")}(Be,Qe),R("stars",Be),Be}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(ne=ne.filter(function(Oe){return!!Oe.match(ee)})),ne=ne.map(function(Oe){return new le(Oe,H)})},Ne.prototype.intersects=function(z,H){if(!(z instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ee){return z.set.some(function(ne){return ne.every(function(Oe){return ee.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new Ne(z,H).set.map(function(G){return G.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Re(z,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],z))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(z,H,G){var ee=null,ne=null;try{var Oe=new Ne(H,G)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==-1||(ne=new Re(ee=Be,G)))}),ee},e.minSatisfying=function(z,H,G){var ee=null,ne=null;try{var Oe=new Ne(H,G)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==1||(ne=new Re(ee=Be,G)))}),ee},e.validRange=function(z,H){try{return new Ne(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,G){return U(z,H,"<",G)},e.gtr=function(z,H,G){return U(z,H,">",G)},e.outside=U,e.prerelease=function(z,H){var G=ce(z,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(z,H,G){return z=new Ne(z,G),H=new Ne(H,G),z.intersects(H)},e.coerce=function(z){if(z instanceof Re)return z;if(typeof z!="string")return null;var H=z.match(p[w]);return H==null?null:ce((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(ge,e){var S,F,R=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(S===setTimeout)return setTimeout(o,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(o,0);try{return S(o,0)}catch{try{return S.call(null,o,0)}catch{return S.call(this,o,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{F=typeof clearTimeout=="function"?clearTimeout:M}catch{F=M}})();var g,k=[],N=!1,y=-1;function l(){N&&g&&(N=!1,g.length?k=g.concat(k):y=-1,k.length&&b())}function b(){if(!N){var o=p(l);N=!0;for(var r=k.length;r;){for(g=k,k=[];++y<r;)g&&g[y].run();y=-1,r=k.length}g=null,N=!1,function(t){if(F===clearTimeout)return clearTimeout(t);if((F===M||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(t);try{F(t)}catch{try{return F.call(null,t)}catch{return F.call(this,t)}}}(o)}}function m(o,r){this.fun=o,this.array=r}function s(){}R.nextTick=function(o){var r=new Array(arguments.length-1);if(arguments.length>1)for(var t=1;t<arguments.length;t++)r[t-1]=arguments[t];k.push(new m(o,r)),k.length!==1||N||p(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Pe[128],Ae([1,0,14,6]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=R,e.$pe=O,e.$qe=M,e.$re=p,e.$se=k,e.$te=N,e.$ue=y,e.$ve=l,e.$we=b,e.$xe=m,e.$ye=s,e.$ze=o,e.$Ae=r,e.$Be=t,e.$Ce=n;function R(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}function M(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function p(c,h){return new g(c,h)}class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let $;switch(h){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const a=$.indexOf(i);a>=0&&$.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach($=>$())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,h){const i=[];let $;for(;($=c.read())!==null;)i.push($);return h(i)}function N(c,h,i){const $=[];let a;for(;(a=c.read())!==null&&$.length<i;)$.push(a);return a===null&&$.length>0?h($):{read:()=>{if($.length>0)return $.shift();if(typeof a<"u"){const v=a;return a=void 0,v}return c.read()}}}function y(c,h){return new Promise((i,$)=>{const a=[];l(c,{onData:v=>{h&&a.push(v)},onError:v=>{h?$(v):i(void 0)},onEnd:()=>{i(h?h(a):void 0)}})})}function l(c,h,i){c.on("error",$=>{i?.isCancellationRequested||h.onError($)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",$=>{i?.isCancellationRequested||h.onData($)})}function b(c,h){return new Promise((i,$)=>{const a=new F.$Uc,v=[],d=E=>{if(v.push(E),v.length>h)return a.dispose(),c.pause(),i({stream:c,buffer:v,ended:!1})},P=E=>(a.dispose(),$(E)),u=()=>(a.dispose(),i({stream:c,buffer:v,ended:!0}));a.add((0,F.$Tc)(()=>c.removeListener("error",P))),c.on("error",P),a.add((0,F.$Tc)(()=>c.removeListener("end",u))),c.on("end",u),a.add((0,F.$Tc)(()=>c.removeListener("data",d))),c.on("data",d)})}function m(c,h){const i=p(h);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function r(c,h,i){const $=p(i);return l(c,{onData:a=>$.write(h.data(a)),onError:a=>$.error(h.error?h.error(a):a),onEnd:()=>$.end()}),$}function t(c,h,i){let $=!1;return{read:()=>{const a=h.read();return $?a:($=!0,a!==null?i([c,a]):c)}}}function n(c,h,i){let $=!1;const a=p(i);return l(h,{onData:v=>$?a.write(v):($=!0,a.write(i([c,v]))),onError:v=>a.error(v),onEnd:()=>{$||($=!0,a.write(c)),a.end()}}),a}}),define(Pe[22],Ae([1,0,41,128]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=void 0,e.$Ee=k,e.$Fe=N,e.$Ge=y,e.$He=l,e.$Ie=b,e.$Je=m,e.$Ke=s,e.$Le=o,e.$Me=r,e.$Ne=t,e.$Oe=n,e.$Pe=c,e.$Qe=h,e.$Re=i,e.$Se=$,e.$Te=a,e.$Ue=v,e.$Ve=d,e.$We=P,e.$Xe=f;const R=typeof Buffer<"u",O=new S.$V(()=>new Uint8Array(256));let M,p;class g{static alloc(w){return R?new g(Buffer.allocUnsafe(w)):new g(new Uint8Array(w))}static wrap(w){return R&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new g(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(w)):(M||(M=new TextEncoder),new g(M.encode(w)))}static fromByteArray(w){const C=g.alloc(w.length);for(let I=0,W=w.length;I<W;I++)C.buffer[I]=w[I];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let V=0,q=w.length;V<q;V++)C+=w[V].byteLength}const I=g.alloc(C);let W=0;for(let V=0,q=w.length;V<q;V++){const A=w[V];I.set(A,W),W+=A.byteLength}return I}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=g.alloc(this.byteLength);return w.set(this),w}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(w,C){return new g(this.buffer.subarray(w,C))}set(w,C){if(w instanceof g)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return l(this.buffer,w)}writeUInt32BE(w,C){b(this.buffer,w,C)}readUInt32LE(w){return m(this.buffer,w)}writeUInt32LE(w,C){s(this.buffer,w,C)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,C){r(this.buffer,w,C)}indexOf(w,C=0){return k(this.buffer,w instanceof g?w.buffer:w,C)}}e.$De=g;function k(D,w,C=0){const I=w.byteLength,W=D.byteLength;if(I===0)return 0;if(I===1)return D.indexOf(w[0]);if(I>W-C)return-1;const V=O.value;V.fill(w.length);for(let K=0;K<w.length;K++)V[w[K]]=w.length-K-1;let q=C+w.length-1,A=q,j=-1;for(;q<W;)if(D[q]===w[A]){if(A===0){j=q;break}q--,A--}else q+=Math.max(w.length-A,V[D[q]]),A=w.length-1;return j}function N(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0}function y(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255}function l(D,w){return D[w]*2**24+D[w+1]*2**16+D[w+2]*2**8+D[w+3]}function b(D,w,C){D[C+3]=w,w=w>>>8,D[C+2]=w,w=w>>>8,D[C+1]=w,w=w>>>8,D[C]=w}function m(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0|D[w+2]<<16>>>0|D[w+3]<<24>>>0}function s(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255,w=w>>>8,D[C+2]=w&255,w=w>>>8,D[C+3]=w&255}function o(D,w){return D[w]}function r(D,w,C){D[C]=w}function t(D){return F.$se(D,w=>g.concat(w))}function n(D){return F.$ze(D)}function c(D){return F.$ue(D,w=>g.concat(w))}async function h(D){return D.ended?g.concat(D.buffer):g.concat([...D.buffer,await c(D.stream)])}function i(D){return F.$xe(D,w=>g.concat(w))}function $(D){return F.$Ae(D,{data:w=>typeof w=="string"?g.fromString(w):g.wrap(w)},w=>g.concat(w))}function a(D){return F.$re(w=>g.concat(w),D)}function v(D,w){return F.$Be(D,w,C=>g.concat(C))}function d(D,w){return F.$Ce(D,w,C=>g.concat(C))}function P(D){let w=0,C=0,I=0;const W=new Uint8Array(Math.floor(D.length/4*3)),V=A=>{switch(C){case 3:W[I++]=w|A,C=0;break;case 2:W[I++]=w|A>>>2,w=A<<6,C=3;break;case 1:W[I++]=w|A>>>4,w=A<<4,C=2;break;default:w=A<<2,C=1}};for(let A=0;A<D.length;A++){const j=D.charCodeAt(A);if(j>=65&&j<=90)V(j-65);else if(j>=97&&j<=122)V(j-97+26);else if(j>=48&&j<=57)V(j-48+52);else if(j===43||j===45)V(62);else if(j===47||j===95)V(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${D[A]}`)}}const q=I;for(;C>0;)V(0);return g.wrap(W).slice(0,q)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:D},w=!0,C=!1){const I=C?E:u;let W="";const V=D.byteLength%3;let q=0;for(;q<D.byteLength-V;q+=3){const A=D[q+0],j=D[q+1],K=D[q+2];W+=I[A>>>2],W+=I[(A<<4|j>>>4)&63],W+=I[(j<<2|K>>>6)&63],W+=I[K&63]}if(V===1){const A=D[q+0];W+=I[A>>>2],W+=I[A<<4&63],w&&(W+="==")}else if(V===2){const A=D[q+0],j=D[q+1];W+=I[A>>>2],W+=I[(A<<4|j>>>4)&63],W+=I[j<<2&63],w&&(W+="=")}return W}}),define(Pe[129],Ae([1,0,28,125,15]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.FuzzyScore=e.$vk=e.$uk=void 0,e.or=O,e.$wk=p,e.$xk=g,e.$yk=y,e.$zk=P,e.$Ak=u,e.$Bk=I,e.$Ck=W,e.$Dk=V,e.$Ek=q,e.$Fk=x,e.$Hk=pe,e.$Ik=X,e.$Jk=le;function O(...he){return function(Ce,Fe){for(let ze=0,U=he.length;ze<U;ze++){const z=he[ze](Ce,Fe);if(z)return z}return null}}e.$uk=M.bind(void 0,!1),e.$vk=M.bind(void 0,!0);function M(he,Ce,Fe){if(!Fe||Fe.length<Ce.length)return null;let ze;return he?ze=R.$wf(Fe,Ce):ze=Fe.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(he,Ce){const Fe=Ce.toLowerCase().indexOf(he.toLowerCase());return Fe===-1?null:[{start:Fe,end:Fe+he.length}]}function g(he,Ce){return k(he.toLowerCase(),Ce.toLowerCase(),0,0)}function k(he,Ce,Fe,ze){if(Fe===he.length)return[];if(ze===Ce.length)return null;if(he[Fe]===Ce[ze]){let U=null;return(U=k(he,Ce,Fe+1,ze+1))?c({start:ze,end:ze+1},U):null}return k(he,Ce,Fe,ze+1)}function N(he){return 97<=he&&he<=122}function y(he){return 65<=he&&he<=90}function l(he){return 48<=he&&he<=57}function b(he){return he===32||he===9||he===10||he===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>m.add(he.charCodeAt(0)));function s(he){return b(he)||m.has(he)}function o(he,Ce){return he===Ce||s(he)&&s(Ce)}const r=new Map;function t(he){if(r.has(he))return r.get(he);let Ce;const Fe=(0,F.$sk)(he);return Fe&&(Ce=Fe),r.set(he,Ce),Ce}function n(he){return N(he)||y(he)||l(he)}function c(he,Ce){return Ce.length===0?Ce=[he]:he.end===Ce[0].start?Ce[0].start=he.start:Ce.unshift(he),Ce}function h(he,Ce){for(let Fe=Ce;Fe<he.length;Fe++){const ze=he.charCodeAt(Fe);if(y(ze)||l(ze)||Fe>0&&!n(he.charCodeAt(Fe-1)))return Fe}return he.length}function i(he,Ce,Fe,ze){if(Fe===he.length)return[];if(ze===Ce.length)return null;if(he[Fe]!==Ce[ze].toLowerCase())return null;{let U=null,z=ze+1;for(U=i(he,Ce,Fe+1,ze+1);!U&&(z=h(Ce,z))<Ce.length;)U=i(he,Ce,Fe+1,z),z++;return U===null?null:c({start:ze,end:ze+1},U)}}function $(he){let Ce=0,Fe=0,ze=0,U=0,z=0;for(let Oe=0;Oe<he.length;Oe++)z=he.charCodeAt(Oe),y(z)&&Ce++,N(z)&&Fe++,n(z)&&ze++,l(z)&&U++;const H=Ce/he.length,G=Fe/he.length,ee=ze/he.length,ne=U/he.length;return{upperPercent:H,lowerPercent:G,alphaPercent:ee,numericPercent:ne}}function a(he){const{upperPercent:Ce,lowerPercent:Fe}=he;return Fe===0&&Ce>.6}function v(he){const{upperPercent:Ce,lowerPercent:Fe,alphaPercent:ze,numericPercent:U}=he;return Fe>.2&&Ce<.8&&ze>.6&&U<.2}function d(he){let Ce=0,Fe=0,ze=0,U=0;for(let z=0;z<he.length;z++)ze=he.charCodeAt(z),y(ze)&&Ce++,N(ze)&&Fe++,b(ze)&&U++;return(Ce===0||Fe===0)&&U===0?he.length<=30:Ce<=5}function P(he,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!d(he))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Fe=$(Ce);if(!v(Fe)){if(!a(Fe))return null;Ce=Ce.toLowerCase()}let ze=null,U=0;for(he=he.toLowerCase();U<Ce.length&&(ze=i(he,Ce,0,U))===null;)U=h(Ce,U+1);return ze}function u(he,Ce,Fe=!1){if(!Ce||Ce.length===0)return null;let ze=null,U=0;for(he=he.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(ze=E(he,Ce,0,U,Fe),ze===null);)U=f(Ce,U+1);return ze}function E(he,Ce,Fe,ze,U){let z=0;if(Fe===he.length)return[];if(ze===Ce.length)return null;if(!o(he.charCodeAt(Fe),Ce.charCodeAt(ze))){const ee=t(he.charCodeAt(Fe));if(!ee)return null;for(let ne=0;ne<ee.length;ne++)if(!o(ee[ne],Ce.charCodeAt(ze+ne)))return null;z+=ee.length-1}let H=null,G=ze+z+1;if(H=E(he,Ce,Fe+1,G,U),!U)for(;!H&&(G=f(Ce,G))<Ce.length;)H=E(he,Ce,Fe+1,G,U),G++;if(!H)return null;if(he.charCodeAt(Fe)!==Ce.charCodeAt(ze)){const ee=t(he.charCodeAt(Fe));if(!ee)return H;for(let ne=0;ne<ee.length;ne++)if(ee[ne]!==Ce.charCodeAt(ze+ne))return H}return c({start:ze,end:ze+z+1},H)}function f(he,Ce){for(let Fe=Ce;Fe<he.length;Fe++)if(s(he.charCodeAt(Fe))||Fe>0&&s(he.charCodeAt(Fe-1)))return Fe;return he.length}const D=O(e.$vk,P,p),w=O(e.$vk,P,g),C=new S.$Ec(1e4);function I(he,Ce,Fe=!1){if(typeof he!="string"||typeof Ce!="string")return null;let ze=C.get(he);ze||(ze=new RegExp(R.$ef(he),"i"),C.set(he,ze));const U=ze.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Fe?w(he,Ce):D(he,Ce)}function W(he,Ce){const Fe=pe(he,he.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Fe?q(Fe):null}function V(he,Ce,Fe,ze,U,z){const H=Math.min(13,he.length);for(;Fe<H;Fe++){const G=pe(he,Ce,Fe,ze,U,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,z]}function q(he){if(typeof he>"u")return[];const Ce=[],Fe=he[1];for(let ze=he.length-1;ze>1;ze--){const U=he[ze]+Fe,z=Ce[Ce.length-1];z&&z.end===U?z.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const A=128;function j(){const he=[],Ce=[];for(let Fe=0;Fe<=A;Fe++)Ce[Fe]=0;for(let Fe=0;Fe<=A;Fe++)he.push(Ce.slice(0));return he}function K(he){const Ce=[];for(let Fe=0;Fe<=he;Fe++)Ce[Fe]=0;return Ce}const re=K(2*A),ae=K(2*A),be=j(),Ie=j(),de=j(),me=!1;function Me(he,Ce,Fe,ze,U){function z(G,ee,ne=" "){for(;G.length<ee;)G=ne+G;return G}let H=` |   |${ze.split("").map(G=>z(G,3)).join("|")}
`;for(let G=0;G<=Fe;G++)G===0?H+=" |":H+=`${Ce[G-1]}|`,H+=he[G].slice(0,U+1).map(ee=>z(ee.toString(),3)).join("|")+`
`;return H}function ce(he,Ce,Fe,ze){he=he.substr(Ce),Fe=Fe.substr(ze),console.log(Me(Ie,he,he.length,Fe,Fe.length)),console.log(Me(de,he,he.length,Fe,Fe.length)),console.log(Me(be,he,he.length,Fe,Fe.length))}function Re(he,Ce){if(Ce<0||Ce>=he.length)return!1;const Fe=he.codePointAt(Ce);switch(Fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Of(Fe)}}function ie(he,Ce){if(Ce<0||Ce>=he.length)return!1;switch(he.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function L(he,Ce,Fe){return Ce[he]!==Fe[he]}function x(he,Ce,Fe,ze,U,z,H=!1){for(;Ce<Fe&&U<z;)he[Ce]===ze[U]&&(H&&(re[Ce]=U),Ce+=1),U+=1;return Ce===Fe}var ve;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Te;(function(he){he.Default=[-100,0];function Ce(Fe){return!Fe||Fe.length===2&&Fe[0]===-100&&Fe[1]===0}he.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Fe){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Fe}}e.$Gk=ke;function pe(he,Ce,Fe,ze,U,z,H=ke.default){const G=he.length>A?A:he.length,ee=ze.length>A?A:ze.length;if(Fe>=G||z>=ee||G-Fe>ee-z||!x(Ce,Fe,G,U,z,ee,!0))return;fe(G,ee,Fe,z,Ce,U);let ne=1,Oe=1,Be=Fe,Qe=z;const _e=[!1];for(ne=1,Be=Fe;Be<G;ne++,Be++){const at=re[Be],mt=ae[Be],je=Be+1<G?ae[Be+1]:ee;for(Oe=at-z+1,Qe=at;Qe<je;Oe++,Qe++){let st=Number.MIN_SAFE_INTEGER,Y=!1;Qe<=mt&&(st=Q(he,Ce,Be,Fe,ze,U,Qe,ee,z,be[ne-1][Oe-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(Y=!0,Z=st+Ie[ne-1][Oe-1]);const $e=Qe>at,Ge=$e?Ie[ne][Oe-1]+(be[ne][Oe-1]>0?-5:0):0,ye=Qe>at+1&&be[ne][Oe-1]>0,ot=ye?Ie[ne][Oe-2]+(be[ne][Oe-2]>0?-5:0):0;if(ye&&(!$e||ot>=Ge)&&(!Y||ot>=Z))Ie[ne][Oe]=ot,de[ne][Oe]=3,be[ne][Oe]=0;else if($e&&(!Y||Ge>=Z))Ie[ne][Oe]=Ge,de[ne][Oe]=2,be[ne][Oe]=0;else if(Y)Ie[ne][Oe]=Z,de[ne][Oe]=1,be[ne][Oe]=be[ne-1][Oe-1]+1;else throw new Error("not possible")}}if(me&&ce(he,Fe,ze,z),!_e[0]&&!H.firstMatchCanBeWeak)return;ne--,Oe--;const et=[Ie[ne][Oe],z];let tt=0,it=0;for(;ne>=1;){let at=Oe;do{const mt=de[ne][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Ce[Fe+ne-1]===U[z+Oe-1]&&!L(at+z-1,ze,U)&&tt+1>be[ne][at]&&(at=Oe),at===Oe?tt++:tt=1,it||(it=at),ne--,Oe=at-1,et.push(Oe)}ee===G&&H.boostFullMatch&&(et[0]+=2);const nt=it-G;return et[0]-=nt,et}function fe(he,Ce,Fe,ze,U,z){let H=he-1,G=Ce-1;for(;H>=Fe&&G>=ze;)U[H]===z[G]&&(ae[H]=G,H--),G--}function Q(he,Ce,Fe,ze,U,z,H,G,ee,ne,Oe){if(Ce[Fe]!==z[H])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return H===Fe-ze?Be=he[Fe]===U[H]?7:5:L(H,U,z)&&(H===0||!L(H-1,U,z))?(Be=he[Fe]===U[H]?7:5,Qe=!0):Re(z,H)&&(H===0||!Re(z,H-1))?Be=5:(Re(z,H-1)||ie(z,H-1))&&(Be=5,Qe=!0),Be>1&&Fe===ze&&(Oe[0]=!0),Qe||(Qe=L(H,U,z)||Re(z,H-1)||ie(z,H-1)),Fe===ze?H>ee&&(Be-=Qe?3:5):ne?Be+=Qe?2:0:Be+=Qe?0:1,H+1===G&&(Be-=Qe?3:5),Be}function X(he,Ce,Fe,ze,U,z,H){return ue(he,Ce,Fe,ze,U,z,!0,H)}function le(he,Ce,Fe,ze,U,z,H){return ue(he,Ce,Fe,ze,U,z,!1,H)}function ue(he,Ce,Fe,ze,U,z,H,G){let ee=pe(he,Ce,Fe,ze,U,z,G);if(ee&&!H)return ee;if(he.length>=3){const ne=Math.min(7,he.length-1);for(let Oe=Fe+1;Oe<ne;Oe++){const Be=Ne(he,Oe);if(Be){const Qe=pe(Be,Be.toLowerCase(),Fe,ze,U,z,G);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Ne(he,Ce){if(Ce+1>=he.length)return;const Fe=he[Ce],ze=he[Ce+1];if(Fe!==ze)return he.slice(0,Ce)+ze+Fe+he.slice(Ce+2)}}),define(Pe[33],Ae([1,0,15]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(F||(F={})),function(R){const O="error",M="warning",p="warn",g="info",k="ignore";function N(l){return l?S.$vf(O,l)?R.Error:S.$vf(M,l)||S.$vf(p,l)?R.Warning:S.$vf(g,l)?R.Info:R.Ignore:R.Ignore}R.fromValue=N;function y(l){switch(l){case R.Error:return O;case R.Warning:return M;case R.Info:return g;default:return k}}R.toString=y}(F||(F={})),e.default=F}),define(Pe[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0,e.$_d=Symbol("MicrotaskDelay")}),define(Pe[52],Ae([1,0,18,15]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class R{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$vi=R;class O{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$pf)(b,this.b,0,b.length,this.c,this.d):(0,F.$rf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$wi=O;class M{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$pf)(b,this.b,0,b.length,this.d,this.e):(0,F.$rf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$xi=M;var p;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$qf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$qf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$of)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$of)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$yi=g;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(N||(N={}));class y{static forUris(b=()=>!1,m=()=>!1){return new y(new g(b,m))}static forPaths(b=!1){return new y(new M(void 0,!b))}static forStrings(){return new y(new R)}static forConfigKeys(){return new y(new O)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const s=m.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o,b)}else{const s=b.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(b,m){const s=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=s.value());const r=[];for(o=this.c;;){const n=s.cmp(o.segment);if(n>0)o.left||(o.left=new k,o.left.segment=s.value()),r.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new k,o.right.segment=s.value()),r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),r.push([0,o]),o=o.mid;else break}const t=o.value;o.value=m,o.key=b;for(let n=r.length-1;n>=0;n--){const c=r[n][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=r[n][0],$=r[n+1][0];if(i===1&&$===1)r[n][1]=c.rotateLeft();else if(i===-1&&$===-1)r[n][1]=c.rotateRight();else if(i===1&&$===-1)c.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=c.rotateLeft();else if(i===-1&&$===1)c.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return t}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const s=this.b.reset(b),o=[];let r=this.c;for(;r;){const t=s.cmp(r.segment);if(t>0)o.push([-1,r]),r=r.left;else if(t<0)o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),o.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const t=this.f(r.right);if(t.key){const{key:n,value:c,segment:h}=t;this.e(t.key,!1),r.key=n,r.value=c,r.segment=h}}else{const t=r.left??r.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=t;break;case 0:c.mid=t;break;case 1:c.right=t;break}}else this.c=t}for(let t=o.length-1;t>=0;t--){const n=o[t][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[t][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[t][1]=n.rotateRight()),t>0)switch(o[t-1][0]){case-1:o[t-1][1].left=o[t][1];break;case 1:o[t-1][1].right=o[t][1];break;case 0:o[t-1][1].mid=o[t][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let s=this.c,o;for(;s;){const r=m.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(b){return this.g(b,!1)}g(b,m){const s=this.b.reset(b);let o=this.c;for(;o;){const r=s.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,s]of this)b(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){b&&(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.$zi=y}),define(Pe[42],Ae([1,0,91]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Tj=R;var F;(function(M){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=p})(F||(e.ThemeColor=F={}));function R(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(t){const n=p.exec(t.id);if(!n)return g(S.$Sj.error);const[,c,h]=n,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}M.asClassNameArray=g;function k(t){return g(t).join(" ")}M.asClassName=k;function N(t){return"."+g(t).join(".")}M.asCSSSelector=N;function y(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color>"u"||F.isThemeColor(t.color))}M.isThemeIcon=y;const l=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function b(t){const n=l.exec(t);if(!n)return;const[,c]=n;return{id:c}}M.fromString=b;function m(t){return{id:t}}M.fromId=m;function s(t,n){let c=t.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),n&&(c=`${c}~${n}`),{id:c}}M.modify=s;function o(t){const n=t.id.lastIndexOf("~");if(n!==-1)return t.id.substring(n+1)}M.getModifier=o;function r(t,n){return t.id===n.id&&t.color?.id===n.color?.id}M.isEqual=r})(O||(e.ThemeIcon=O={}))}),define(Pe[131],Ae([1,0,129,15,42]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=g,e.$Lk=N,e.$Mk=l,e.$Nk=b,e.$Ok=s,e.$Pk=o;const O="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function g(r){return r.replace(p,(t,n)=>n?t:`\\${t}`)}const k=new RegExp(`\\\\${M.source}`,"g");function N(r){return r.replace(k,t=>`\\${t}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(r){return r.indexOf(O)===-1?r:r.replace(y,(t,n,c,h)=>c?t:n||h||"")}function b(r){return r?r.replace(/\$\((.*?)\)/g,(t,n)=>` ${n} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){m.lastIndex=0;let t="";const n=[];let c=0;for(;;){const h=m.lastIndex,i=m.exec(r),$=r.substring(h,i?.index);if($.length>0){t+=$;for(let a=0;a<$.length;a++)n.push(c)}if(!i)break;c+=i[0].length}return{text:t,iconOffsets:n}}function o(r,t,n=!1){const{text:c,iconOffsets:h}=t;if(!h||h.length===0)return(0,S.$Bk)(r,c,n);const i=(0,F.$cf)(c," "),$=c.length-i.length,a=(0,S.$Bk)(r,i,n);if(a)for(const v of a){const d=h[v.start+$]+$;v.start+=d,v.end+=d}return a}}),define(Pe[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=F;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(R){return S.test(R)}e.$Pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){R(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,k="";return k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k}}()}),define(Pe[132],Ae([1,0,18,40,35]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.$Nt=void 0,e.$Lt=O,e.$Mt=M,e.$Ot=k;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,l,b){const m={id:(0,R.$Pg)(),name:y,uri:l,data:b};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return F.Iterable.some(this,([m,s])=>s.asFile())&&b.push("files"),N(g(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const m=this.a.get(l);m?m.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const m of b)yield[l,m]}b(l){return g(l)}}e.$Nt=p;function g(y){return y.toLowerCase()}function k(y,l){return N(g(y),l.map(g))}function N(y,l){if(y==="*/*")return l.length>0;if(l.includes(y))return!0;const b=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[m,s,o]=b;return o==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$Pt=Object.freeze({create:y=>(0,S.$Mb)(y.map(l=>l.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Pt.split(y).filter(l=>!l.startsWith("#"))})}),define(Pe[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$St=F;var S;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(R){let O=0,M=0,p=0,g=0;for(let k=0,N=R.length;k<N;k++){const y=R.charCodeAt(k);y===13?(O===0&&(M=k),O++,k+1<N&&R.charCodeAt(k+1)===10?(g|=2,k++):g|=3,p=k+1):y===10&&(g|=1,O===0&&(M=k),O++,p=k+1)}return O===0&&(M=R.length),[O,M,R.length-p,g]}}),define(Pe[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Zs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.$fu=e.IndentAction=void 0;var S;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let g=0,k=p.notIn.length;g<k;g++)switch(p.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,g){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset(g-2),N=p.getStandardTokenType(k);return this.isOK(N)}g(p,g){for(let k=p;k<=g;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$fu=F;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of p)O(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),O(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),O(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),O(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&O(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$gu=R;function O(M,p,g){M.has(p)?M.get(p).push(g):M.set(p,[g])}}),define(Pe[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.NodeColor=e.$uC=void 0,e.$wC=R,e.$xC=O,e.$yC=k,e.$zC=N,e.$AC=y,e.$BC=l,e.$CC=b,e.$DC=m;class S{constructor(o,r){this.piece=o,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$vC)return R(this.right);let o=this;for(;o.parent!==e.$vC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$vC?e.$vC:o.parent}prev(){if(this.left!==e.$vC)return O(this.left);let o=this;for(;o.parent!==e.$vC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$vC?e.$vC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$uC=S;var F;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$vC=new S(null,0),e.$vC.parent=e.$vC,e.$vC.left=e.$vC,e.$vC.right=e.$vC,e.$vC.color=0;function R(s){for(;s.left!==e.$vC;)s=s.left;return s}function O(s){for(;s.right!==e.$vC;)s=s.right;return s}function M(s){return s===e.$vC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$vC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function g(){e.$vC.parent=e.$vC}function k(s,o){const r=o.right;r.size_left+=o.size_left+(o.piece?o.piece.length:0),r.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=r.left,r.left!==e.$vC&&(r.left.parent=o),r.parent=o.parent,o.parent===e.$vC?s.root=r:o.parent.left===o?o.parent.left=r:o.parent.right=r,r.left=o,o.parent=r}function N(s,o){const r=o.left;o.left=r.right,r.right!==e.$vC&&(r.right.parent=o),r.parent=o.parent,o.size_left-=r.size_left+(r.piece?r.piece.length:0),o.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),o.parent===e.$vC?s.root=r:o===o.parent.right?o.parent.right=r:o.parent.left=r,r.right=o,o.parent=r}function y(s,o){let r,t;if(o.left===e.$vC?(t=o,r=t.right):o.right===e.$vC?(t=o,r=t.left):(t=R(o.right),r=t.right),t===s.root){s.root=r,r.color=0,o.detach(),g(),s.root.parent=e.$vC;return}const n=t.color===1;if(t===t.parent.left?t.parent.left=r:t.parent.right=r,t===o?(r.parent=t.parent,m(s,r)):(t.parent===o?r.parent=t:r.parent=t.parent,m(s,r),t.left=o.left,t.right=o.right,t.parent=o.parent,t.color=o.color,o===s.root?s.root=t:o===o.parent.left?o.parent.left=t:o.parent.right=t,t.left!==e.$vC&&(t.left.parent=t),t.right!==e.$vC&&(t.right.parent=t),t.size_left=o.size_left,t.lf_left=o.lf_left,m(s,t)),o.detach(),r.parent.left===r){const h=M(r),i=p(r);if(h!==r.parent.size_left||i!==r.parent.lf_left){const $=h-r.parent.size_left,a=i-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=i,b(s,r.parent,$,a)}}if(m(s,r.parent),n){g();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,k(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,k(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,N(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,N(s,r.parent),r=s.root));r.color=0,g()}function l(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const r=o.parent.parent.right;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(s,o)),o.parent.color=0,o.parent.parent.color=1,N(s,o.parent.parent))}else{const r=o.parent.parent.left;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,N(s,o)),o.parent.color=0,o.parent.parent.color=1,k(s,o.parent.parent))}s.root.color=0}function b(s,o,r,t){for(;o!==s.root&&o!==e.$vC;)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=t),o=o.parent}function m(s,o){let r=0,t=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,r=M(o.left)-o.size_left,t=p(o.left)-o.lf_left,o.size_left+=r,o.lf_left+=t;o!==s.root&&(r!==0||t!==0);)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=t),o=o.parent}}}),define(Pe[92],Ae([1,0,93,29,94,136,95]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=e.$NC=e.$MC=void 0,e.$KC=N,e.$LC=y;const p=65535;function g(r){let t;return r[r.length-1]<65536?t=new Uint16Array(r.length):t=new Uint32Array(r.length),t.set(r,0),t}class k{constructor(t,n,c,h,i){this.lineStarts=t,this.cr=n,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function N(r,t=!0){const n=[0];let c=1;for(let h=0,i=r.length;h<i;h++){const $=r.charCodeAt(h);$===13?h+1<i&&r.charCodeAt(h+1)===10?(n[c++]=h+2,h++):n[c++]=h+1:$===10&&(n[c++]=h+1)}return t?g(n):n}function y(r,t){r.length=0,r[0]=0;let n=1,c=0,h=0,i=0,$=!0;for(let v=0,d=t.length;v<d;v++){const P=t.charCodeAt(v);P===13?v+1<d&&t.charCodeAt(v+1)===10?(i++,r[n++]=v+2,v++):(c++,r[n++]=v+1):P===10?(h++,r[n++]=v+1):$&&P!==9&&(P<32||P>126)&&($=!1)}const a=new k(g(r),c,h,i,$);return r.length=0,a}class l{constructor(t,n,c,h,i){this.bufferIndex=t,this.start=n,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$MC=l;class b{constructor(t,n){this.buffer=t,this.lineStarts=n}}e.$NC=b;class m{constructor(t,n){this.a=[],this.c=t,this.d=n,this.b=0,t.root!==O.$vC&&t.iterate(t.root,c=>(c!==O.$vC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(t){this.a=t,this.b=[]}get(t){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=t&&c.nodeStartOffset+c.node.piece.length>=t)return c}return null}get2(t){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<t&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=t)return c}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let n=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=t){c[h]=null,n=!0;continue}}if(n){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(t,n,c){this.create(t,n,c)}create(t,n,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=O.$vC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let h=null;for(let i=0,$=t.length;i<$;i++)if(t[i].buffer.length>0){t[i].lineStarts||(t[i].lineStarts=N(t[i].buffer));const a=new l(i+1,{line:0,column:0},{line:t[i].lineStarts.length-1,column:t[i].buffer.length-t[i].lineStarts[t[i].lineStarts.length-1]},t[i].lineStarts.length-1,t[i].buffer.length);this.a.push(t[i]),h=this.S(h,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const n=p,c=n-Math.floor(n/3),h=c*2;let i="",$=0;const a=[];if(this.iterate(this.root,v=>{const d=this.R(v),P=d.length;if($<=c||$+P<h)return i+=d,$+=P,!0;const u=i.replace(/\r\n|\r|\n/g,t);return a.push(new b(u,N(u))),i=d,$=P,!0}),$>0){const v=i.replace(/\r\n|\r|\n/g,t);a.push(new b(v,N(v)))}this.create(a,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new m(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===O.$vC)return!0;const i=this.R(h),$=i.length,a=t.G(n),v=t.G(n+$),d=t.getValueInRange2(a,v);return n+=$,i===d})}getOffsetAt(t,n){let c=0,h=this.root;for(;h!==O.$vC;)if(h.left!==O.$vC&&h.lf_left+1>=t)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=t){c+=h.size_left;const i=this.B(h,t-h.lf_left-2);return c+=i+n-1}else t-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let n=this.root,c=0;const h=t;for(;n!==O.$vC;)if(n.size_left!==0&&n.size_left>=t)n=n.left;else if(n.size_left+n.piece.length>=t){const i=this.A(n,t-n.size_left);if(c+=n.lf_left+i.index,i.index===0){const $=this.getOffsetAt(c+1,1),a=h-$;return new S.$ot(c+1,a+1)}return new S.$ot(c+1,i.remainder+1)}else if(t-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.$vC){const i=this.getOffsetAt(c+1,1),$=h-t-i;return new S.$ot(c+1,$+1)}else n=n.right;return new S.$ot(1,1)}getValueInRange(t,n){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const c=this.H(t.startLineNumber,t.startColumn),h=this.H(t.endLineNumber,t.endColumn),i=this.getValueInRange2(c,h);return n?n!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,n):i}getValueInRange2(t,n){if(t.node===n.node){const a=t.node,v=this.a[a.piece.bufferIndex].buffer,d=this.u(a.piece.bufferIndex,a.piece.start);return v.substring(d+t.remainder,d+n.remainder)}let c=t.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let $=h.substring(i+t.remainder,i+c.piece.length);for(c=c.next();c!==O.$vC;){const a=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){$+=a.substring(v,v+n.remainder);break}else $+=a.substr(v,c.piece.length);c=c.next()}return $}getLinesContent(){const t=[];let n=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===O.$vC)return!0;const $=i.piece;let a=$.length;if(a===0)return!0;const v=this.a[$.bufferIndex].buffer,d=this.a[$.bufferIndex].lineStarts,P=$.start.line,u=$.end.line;let E=d[P]+$.start.column;if(h&&(v.charCodeAt(E)===10&&(E++,a--),t[n++]=c,c="",h=!1,a===0))return!0;if(P===u)return!this.f&&v.charCodeAt(E+a-1)===13?(h=!0,c+=v.substr(E,a-1)):c+=v.substr(E,a),!0;c+=this.f?v.substring(E,Math.max(E,d[P+1]-this.e)):v.substring(E,d[P+1]).replace(/(\r\n|\r|\n)$/,""),t[n++]=c;for(let f=P+1;f<u;f++)c=this.f?v.substring(d[f],d[f+1]-this.e):v.substring(d[f],d[f+1]).replace(/(\r\n|\r|\n)$/,""),t[n++]=c;return!this.f&&v.charCodeAt(d[u]+$.end.column-1)===13?(h=!0,$.end.column===0?n--:c=v.substr(d[u],$.end.column-1)):c=v.substr(d[u],$.end.column),!0}),h&&(t[n++]=c,c=""),t[n++]=c,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const n=t.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(h)}else{const n=this.a[t.node.piece.bufferIndex],h=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(t,n){const c=this.H(t,n+1);return this.l(c)}getLineLength(t){if(t===this.getLineCount()){const n=this.getOffsetAt(t,1);return this.getLength()-n}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const n=this.G(t);return this.l(n)}findMatchesInNode(t,n,c,h,i,$,a,v,d,P,u){const E=this.a[t.piece.bufferIndex],f=this.u(t.piece.bufferIndex,t.piece.start),D=this.u(t.piece.bufferIndex,i),w=this.u(t.piece.bufferIndex,$);let C;const I={line:0,column:0};let W,V;n._wordSeparators?(W=E.buffer.substring(D,w),V=q=>q+D,n.reset(0)):(W=E.buffer,V=q=>q,n.reset(D));do if(C=n.next(W),C){if(V(C.index)>=w)return P;this.s(t,V(C.index)-f,I);const q=this.t(t.piece.bufferIndex,i,I),A=I.line===i.line?I.column-i.column+h:I.column+1,j=A+C[0].length;if(u[P++]=(0,M.$GC)(new F.$pt(c+q,A,c+q,j),C,v),V(C.index)+C[0].length>=w||P>=d)return P}while(C);return P}findMatchesLineByLine(t,n,c,h){const i=[];let $=0;const a=new M.$JC(n.wordSeparators,n.regex);let v=this.H(t.startLineNumber,t.startColumn);if(v===null)return[];const d=this.H(t.endLineNumber,t.endColumn);if(d===null)return[];let P=this.s(v.node,v.remainder);const u=this.s(d.node,d.remainder);if(v.node===d.node)return this.findMatchesInNode(v.node,a,t.startLineNumber,t.startColumn,P,u,n,c,h,$,i),i;let E=t.startLineNumber,f=v.node;for(;f!==d.node;){const w=this.t(f.piece.bufferIndex,P,f.piece.end);if(w>=1){const I=this.a[f.piece.bufferIndex].lineStarts,W=this.u(f.piece.bufferIndex,f.piece.start),V=I[P.line+w],q=E===t.startLineNumber?t.startColumn:1;if($=this.findMatchesInNode(f,a,E,q,P,this.s(f,V-W),n,c,h,$,i),$>=h)return i;E+=w}const C=E===t.startLineNumber?t.startColumn-1:0;if(E===t.endLineNumber){const I=this.getLineContent(E).substring(C,t.endColumn-1);return $=this.n(n,a,I,t.endLineNumber,C,$,i,c,h),i}if($=this.n(n,a,this.getLineContent(E).substr(C),E,C,$,i,c,h),$>=h)return i;E++,v=this.H(E,1),f=v.node,P=this.s(v.node,v.remainder)}if(E===t.endLineNumber){const w=E===t.startLineNumber?t.startColumn-1:0,C=this.getLineContent(E).substring(w,t.endColumn-1);return $=this.n(n,a,C,t.endLineNumber,w,$,i,c,h),i}const D=E===t.startLineNumber?t.startColumn:1;return $=this.findMatchesInNode(d.node,a,E,D,P,u,n,c,h,$,i),i}n(t,n,c,h,i,$,a,v,d){const P=t.wordSeparators;if(!v&&t.simpleSearch){const E=t.simpleSearch,f=E.length,D=c.length;let w=-f;for(;(w=c.indexOf(E,w+f))!==-1;)if((!P||(0,M.$IC)(P,c,D,w,f))&&(a[$++]=new R.$Av(new F.$pt(h,w+1+i,h,w+1+f+i),null),$>=d))return $;return $}let u;n.reset(0);do if(u=n.next(c),u&&(a[$++]=(0,M.$GC)(new F.$pt(h,u.index+1+i,h,u.index+1+u[0].length+i),u,v),$>=d))return $;while(u);return $}insert(t,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$vC){const{node:h,remainder:i,nodeStartOffset:$}=this.G(t),a=h.piece,v=a.bufferIndex,d=this.s(h,i);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&$+a.length===t&&n.length<p){this.F(h,n),this.y();return}if($===t)this.o(n,h),this.h.validate(t);else if($+h.piece.length>t){const P=[];let u=new l(a.bufferIndex,d,a.end,this.t(a.bufferIndex,d,a.end),this.u(v,a.end)-this.u(v,d));if(this.K()&&this.M(n)&&this.I(h,i)===10){const w={line:u.start.line+1,column:0};u=new l(u.bufferIndex,w,u.end,this.t(u.bufferIndex,w,u.end),u.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,i-1)===13){const w=this.s(h,i-1);this.C(h,w),n="\r"+n,h.piece.length===0&&P.push(h)}else this.C(h,d);else this.C(h,d);const E=this.w(n);u.length>0&&this.S(h,u);let f=h;for(let D=0;D<E.length;D++)f=this.S(f,E[D]);this.v(P)}else this.q(n,h)}else{const h=this.w(n);let i=this.T(null,h[0]);for(let $=1;$<h.length;$++)i=this.S(i,h[$])}this.y()}delete(t,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===O.$vC)return;const c=this.G(t),h=this.G(t+n),i=c.node,$=h.node;if(i===$){const E=this.s(i,c.remainder),f=this.s(i,h.remainder);if(c.nodeStartOffset===t){if(n===i.piece.length){const D=i.next();(0,O.$AC)(this,i),this.N(D),this.y();return}this.D(i,f),this.h.validate(t),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===t+n){this.C(i,E),this.O(i),this.y();return}this.E(i,E,f),this.y();return}const a=[],v=this.s(i,c.remainder);this.C(i,v),this.h.validate(t),i.piece.length===0&&a.push(i);const d=this.s($,h.remainder);this.D($,d),$.piece.length===0&&a.push($);const P=i.next();for(let E=P;E!==O.$vC&&E!==$;E=E.next())a.push(E);const u=i.piece.length===0?i.prev():i;this.v(a),this.O(u),this.y()}o(t,n){const c=[];if(this.K()&&this.M(t)&&this.L(n)){const $=n.piece,a={line:$.start.line+1,column:0},v=new l($.bufferIndex,a,$.end,this.t($.bufferIndex,a,$.end),$.length-1);n.piece=v,t+=`
`,(0,O.$CC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const h=this.w(t);let i=this.T(n,h[h.length-1]);for(let $=h.length-2;$>=0;$--)i=this.T(i,h[$]);this.N(i),this.v(c)}q(t,n){this.Q(t,n)&&(t+=`
`);const c=this.w(t),h=this.S(n,c[0]);let i=h;for(let $=1;$<c.length;$++)i=this.S(i,c[$]);this.N(h)}s(t,n,c){const h=t.piece,i=t.piece.bufferIndex,$=this.a[i].lineStarts,v=$[h.start.line]+h.start.column+n;let d=h.start.line,P=h.end.line,u=0,E=0,f=0;for(;d<=P&&(u=d+(P-d)/2|0,f=$[u],u!==P);)if(E=$[u+1],v<f)P=u-1;else if(v>=E)d=u+1;else break;return c?(c.line=u,c.column=v-f,null):{line:u,column:v-f}}t(t,n,c){if(c.column===0)return c.line-n.line;const h=this.a[t].lineStarts;if(c.line===h.length-1)return c.line-n.line;const i=h[c.line+1],$=h[c.line]+c.column;if(i>$+1)return c.line-n.line;const a=$-1;return this.a[t].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(t,n){return this.a[t].lineStarts[n.line]+n.column}v(t){for(let n=0;n<t.length;n++)(0,O.$AC)(this,t[n])}w(t){if(t.length>p){const P=[];for(;t.length>p;){const E=t.charCodeAt(p-1);let f;E===13||E>=55296&&E<=56319?(f=t.substring(0,p-1),t=t.substring(p-1)):(f=t.substring(0,p),t=t.substring(p));const D=N(f);P.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:f.length-D[D.length-1]},D.length-1,f.length)),this.a.push(new b(f,D))}const u=N(t);return P.push(new l(this.a.length,{line:0,column:0},{line:u.length-1,column:t.length-u[u.length-1]},u.length-1,t.length)),this.a.push(new b(t,u)),P}let n=this.a[0].buffer.length;const c=N(t,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let P=0;P<c.length;P++)c[P]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+t,n+=1}else{if(n!==0)for(let P=0;P<c.length;P++)c[P]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=t}const i=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[$],v={line:$,column:a},d=new l(0,h,v,this.t(0,h,v),i-n);return this.g=v,[d]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,n=0){let c=this.root,h="";const i=this.h.get2(t);if(i){c=i.node;const $=this.B(c,t-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===t)h=a.substring(v+$,v+c.piece.length);else{const d=this.B(c,t-i.nodeStartLineNumber);return a.substring(v+$,v+d-n)}}else{let $=0;const a=t;for(;c!==O.$vC;)if(c.left!==O.$vC&&c.lf_left>=t-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>t-1){const v=this.B(c,t-c.lf_left-2),d=this.B(c,t-c.lf_left-1),P=this.a[c.piece.bufferIndex].buffer,u=this.u(c.piece.bufferIndex,c.piece.start);return $+=c.size_left,this.h.set({node:c,nodeStartOffset:$,nodeStartLineNumber:a-(t-1-c.lf_left)}),P.substring(u+v,u+d-n)}else if(c.lf_left+c.piece.lineFeedCnt===t-1){const v=this.B(c,t-c.lf_left-2),d=this.a[c.piece.bufferIndex].buffer,P=this.u(c.piece.bufferIndex,c.piece.start);h=d.substring(P+v,P+c.piece.length);break}else t-=c.lf_left+c.piece.lineFeedCnt,$+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$vC;){const $=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),v=this.u(c.piece.bufferIndex,c.piece.start);return h+=$.substring(v,v+a-n),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=$.substr(a,c.piece.length)}c=c.next()}return h}y(){let t=this.root,n=1,c=0;for(;t!==O.$vC;)n+=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;this.b=n,this.c=c,this.h.validate(this.c)}A(t,n){const c=t.piece,h=this.s(t,n),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const $=this.t(t.piece.bufferIndex,c.start,h);if($!==i)return{index:$,remainder:0}}return{index:i,remainder:h.column}}B(t,n){if(n<0)return 0;const c=t.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+n+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(t,n){const c=t.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),$=n,a=this.u(c.bufferIndex,$),v=this.t(c.bufferIndex,c.start,$),d=v-h,P=a-i,u=c.length+P;t.piece=new l(c.bufferIndex,c.start,$,v,u),(0,O.$CC)(this,t,P,d)}D(t,n){const c=t.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),$=n,a=this.t(c.bufferIndex,$,c.end),v=this.u(c.bufferIndex,$),d=a-h,P=i-v,u=c.length+P;t.piece=new l(c.bufferIndex,$,c.end,a,u),(0,O.$CC)(this,t,P,d)}E(t,n,c){const h=t.piece,i=h.start,$=h.end,a=h.length,v=h.lineFeedCnt,d=n,P=this.t(h.bufferIndex,h.start,d),u=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,i);t.piece=new l(h.bufferIndex,h.start,d,P,u),(0,O.$CC)(this,t,u-a,P-v);const E=new l(h.bufferIndex,c,$,this.t(h.bufferIndex,c,$),this.u(h.bufferIndex,$)-this.u(h.bufferIndex,c)),f=this.S(t,E);this.N(f)}F(t,n){this.Q(n,t)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(t),h=this.a[0].buffer.length;this.a[0].buffer+=n;const i=N(n,!1);for(let f=0;f<i.length;f++)i[f]+=h;if(c){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const $=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[$],v={line:$,column:a},d=t.piece.length+n.length,P=t.piece.lineFeedCnt,u=this.t(0,t.piece.start,v),E=u-P;t.piece=new l(t.piece.bufferIndex,t.piece.start,v,u,d),this.g=v,(0,O.$CC)(this,t,n.length,E)}G(t){let n=this.root;const c=this.h.get(t);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:t-c.nodeStartOffset};let h=0;for(;n!==O.$vC;)if(n.size_left>t)n=n.left;else if(n.size_left+n.piece.length>=t){h+=n.size_left;const i={node:n,remainder:t-n.size_left,nodeStartOffset:h};return this.h.set(i),i}else t-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(t,n){let c=this.root,h=0;for(;c!==O.$vC;)if(c.left!==O.$vC&&c.lf_left>=t-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>t-1){const i=this.B(c,t-c.lf_left-2),$=this.B(c,t-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+n-1,$),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===t-1){const i=this.B(c,t-c.lf_left-2);if(i+n-1<=c.piece.length)return{node:c,remainder:i+n-1,nodeStartOffset:h};n-=c.piece.length-i;break}else t-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$vC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),$=this.J(c);return{node:c,remainder:Math.min(n-1,i),nodeStartOffset:$}}else if(c.piece.length>=n-1){const i=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:i}}else n-=c.piece.length;c=c.next()}return null}I(t,n){if(t.piece.lineFeedCnt<1)return-1;const c=this.a[t.piece.bufferIndex],h=this.u(t.piece.bufferIndex,t.piece.start)+n;return c.buffer.charCodeAt(h)}J(t){if(!t)return 0;let n=t.size_left;for(;t!==this.root;)t.parent.right===t&&(n+=t.parent.size_left+t.parent.piece.length),t=t.parent;return n}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===O.$vC||t.piece.lineFeedCnt===0)return!1;const n=t.piece,c=this.a[n.bufferIndex].lineStarts,h=n.start.line,i=c[h]+n.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(i)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===O.$vC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const n=t.prev();this.M(n)&&this.P(n,t)}}O(t){if(this.K()&&this.M(t)){const n=t.next();this.L(n)&&this.P(t,n)}}P(t,n){const c=[],h=this.a[t.piece.bufferIndex].lineStarts;let i;t.piece.end.column===0?i={line:t.piece.end.line-1,column:h[t.piece.end.line]-h[t.piece.end.line-1]-1}:i={line:t.piece.end.line,column:t.piece.end.column-1};const $=t.piece.length-1,a=t.piece.lineFeedCnt-1;t.piece=new l(t.piece.bufferIndex,t.piece.start,i,a,$),(0,O.$CC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const v={line:n.piece.start.line+1,column:0},d=n.piece.length-1,P=this.t(n.piece.bufferIndex,v,n.piece.end);n.piece=new l(n.piece.bufferIndex,v,n.piece.end,P,d),(0,O.$CC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const u=this.w(`\r
`);this.S(t,u[0]);for(let E=0;E<c.length;E++)(0,O.$AC)(this,c[E])}Q(t,n){if(this.K()&&this.M(t)){const c=n.next();if(this.L(c)){if(t+=`
`,c.piece.length===1)(0,O.$AC)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},$=h.length-1,a=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,a,$),(0,O.$CC)(this,c,-1,-1)}return!0}}return!1}iterate(t,n){if(t===O.$vC)return n(O.$vC);const c=this.iterate(t.left,n);return c&&n(t)&&this.iterate(t.right,n)}R(t){if(t===O.$vC)return"";const n=this.a[t.piece.bufferIndex],c=t.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return n.buffer.substring(h,i)}getPieceContent(t){const n=this.a[t.bufferIndex],c=this.u(t.bufferIndex,t.start),h=this.u(t.bufferIndex,t.end);return n.buffer.substring(c,h)}S(t,n){const c=new O.$uC(n,1);if(c.left=O.$vC,c.right=O.$vC,c.parent=O.$vC,c.size_left=0,c.lf_left=0,this.root===O.$vC)this.root=c,c.color=0;else if(t.right===O.$vC)t.right=c,c.parent=t;else{const i=(0,O.$wC)(t.right);i.left=c,c.parent=i}return(0,O.$BC)(this,c),c}T(t,n){const c=new O.$uC(n,1);if(c.left=O.$vC,c.right=O.$vC,c.parent=O.$vC,c.size_left=0,c.lf_left=0,this.root===O.$vC)this.root=c,c.color=0;else if(t.left===O.$vC)t.left=c,c.parent=t;else{const h=(0,O.$xC)(t.left);h.right=c,c.parent=h}return(0,O.$BC)(this,c),c}U(t){let n="";return this.iterate(t,c=>(n+=this.R(c),!0)),n}}e.$OC=o}),define(Pe[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9=e.$x9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$x9=S;class F{constructor(O){this.identifier=O}}e.$y9=F}),define(Pe[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[139],Ae([1,0,5,6,138]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=void 0,e.$dj=N;class O extends F.$Vc{constructor(l,b="",m="",s=!0,o){super(),this.h=this.B(new S.$ce),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$$i=O;class M extends F.$Vc{constructor(){super(...arguments),this.f=this.B(new S.$ce),this.onWillRun=this.f.event,this.m=this.B(new S.$ce),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let m;try{await this.u(l,b)}catch(s){m=s}this.m.fire({action:l,error:m})}async u(l,b){await l.run(b)}}e.$_i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const m of l)m.length&&(b.length?b=[...b,new p,...m]:b=m);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$aj=p;class g{get actions(){return this.a}constructor(l,b,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=s,this.a=m}async run(){}}e.$bj=g;class k extends O{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,R.localize(0,null),void 0,!1)}}e.$cj=k;function N(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...l)=>y.run(...l),tooltip:y.label}}}),define(Pe[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[141],Ae([1,0,140]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=k,e.$Zm=N,e.$1m=y;const F=60,R=F*60,O=R*24,M=O*7,p=O*30,g=O*365;function k(l,b,m,s){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,S.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,S.localize)(1,null);let r;return o<F?(r=o,b?r===1?m?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):m?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?m?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):m?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):o<R?(r=Math.floor(o/F),b?r===1?m?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):m?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?m?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):m?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):o<O?(r=Math.floor(o/R),b?r===1?m?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):m?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?m?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):m?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):o<M?(r=Math.floor(o/O),b?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):o<p?(r=Math.floor(o/M),b?r===1?m?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):m?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?m?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):m?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):o<g?(r=Math.floor(o/p),b?r===1?m?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):m?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?m?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):m?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(o/g),b?r===1?m?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):m?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?m?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):m?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}function N(l,b){const m=Math.abs(l/1e3);return m<1?b?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):m<F?b?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):m<R?b?(0,S.localize)(58,null,Math.round(l/(1e3*F))):(0,S.localize)(59,null,Math.round(l/(1e3*F))):m<O?b?(0,S.localize)(60,null,Math.round(l/(1e3*R))):(0,S.localize)(61,null,Math.round(l/(1e3*R))):(0,S.localize)(62,null,Math.round(l/(1e3*O)))}function y(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[43],Ae([1,0,18,17,142]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=g,e.$fj=k,e.$gj=N;function O(y,l){return l&&(y.stack||y.stacktrace)?R.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function g(y=null,l=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const b=S.$Hb(y),m=g(b[0],l);return b.length>1?R.localize(4,null,m,b.length):m}if(F.$6f(y))return y;if(y.detail){const b=y.detail;if(b.error)return O(b.error,l);if(b.exception)return O(b.exception,l)}return y.stack?O(y,l):y.message?y.message:R.localize(5,null)}function k(y){const l=y;return l instanceof Error&&Array.isArray(l.actions)}function N(y,l){let b;return typeof y=="string"?b=new Error(y):b=y,b.actions=l,b}}),define(Pe[143],Ae([1,0,41,19]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=p,e.$er=g,e.$fr=k,e.$gr=N,e.$hr=y,e.$ir=l,e.$jr=b,e.$kr=m,e.$lr=s,e.$mr=o,e.$nr=d,e.$or=P,e.$pr=u;const R=new S.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),O=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,f,D=!1){const w=E||"",C=f||"",I=R.value.collator.compare(w,C);return R.value.collatorIsNumeric&&I===0&&w!==C?w<C?-1:1:I}function g(E,f){const D=O.value.collator;return E=E||"",f=f||"",c(D,E,f)}function k(E,f){const D=O.value.collator;return E=E||"",f=f||"",a(E,f)||c(D,E,f)}function N(E,f){const D=O.value.collator;return E=E||"",f=f||"",$(E,f)||c(D,E,f)}function y(E,f){return E=E||"",f=f||"",E===f?0:E<f?-1:1}function l(E,f){const[D,w]=t(E),[C,I]=t(f);let W=R.value.collator.compare(w,I);if(W===0){if(R.value.collatorIsNumeric&&w!==I)return w<I?-1:1;if(W=R.value.collator.compare(D,C),R.value.collatorIsNumeric&&W===0&&D!==C)return D<C?-1:1}return W}function b(E,f){E=E||"",f=f||"";const D=n(E),w=n(f),C=O.value.collator,I=M.value.collator;return c(I,D,w)||c(C,E,f)}function m(E,f){E=E||"",f=f||"";const D=n(E),w=n(f),C=O.value.collator,I=M.value.collator;return c(I,D,w)||a(E,f)||c(C,E,f)}function s(E,f){E=E||"",f=f||"";const D=n(E),w=n(f),C=O.value.collator,I=M.value.collator;return c(I,D,w)||$(E,f)||c(C,E,f)}function o(E,f){E=E||"",f=f||"";const D=n(E).toLowerCase(),w=n(f).toLowerCase();return D!==w?D<w?-1:1:E!==f?E<f?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function t(E,f=!1){const D=E?r.exec(E):[];let w=[D&&D[1]||"",D&&D[3]||""];return f&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function n(E){const f=E?r.exec(E):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function c(E,f,D){const w=E.compare(f,D);return w!==0?w:f.length!==D.length?f.length<D.length?-1:1:0}function h(E){const f=E.charAt(0);return f.toLocaleUpperCase()!==f}function i(E){const f=E.charAt(0);return f.toLocaleLowerCase()!==f}function $(E,f){return h(E)&&i(f)?-1:i(E)&&h(f)?1:0}function a(E,f){return i(E)&&h(f)?-1:h(E)&&i(f)?1:0}function v(E,f,D=!1){return D||(E=E&&E.toLowerCase(),f=f&&f.toLowerCase()),E===f?0:E<f?-1:1}function d(E,f,D=!1){const w=E.split(F.sep),C=f.split(F.sep),I=w.length-1,W=C.length-1;let V,q;for(let A=0;;A++){if(V=I===A,q=W===A,V&&q)return p(w[A],C[A],D);if(V)return-1;if(q)return 1;const j=v(w[A],C[A],D);if(j!==0)return j}}function P(E,f,D){const w=E.toLowerCase(),C=f.toLowerCase(),I=u(E,f,D);if(I)return I;const W=w.endsWith(D),V=C.endsWith(D);if(W!==V)return W?-1:1;const q=p(w,C);return q!==0?q:w.localeCompare(C)}function u(E,f,D){const w=E.toLowerCase(),C=f.toLowerCase(),I=w.startsWith(D),W=C.startsWith(D);if(I!==W)return I?-1:1;if(I&&W){if(w.length<C.length)return-1;if(w.length>C.length)return 1}return 0}}),define(Pe[47],Ae([1,0,19,21,15,17]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=M,e.$mg=p,e.$ng=g,e.$og=k,e.$pg=N,e.$qg=m,e.$rg=s,e.$sg=o,e.$tg=r,e.$ug=t,e.$vg=n,e.$wg=c,e.$xg=h,e.$yg=i,e.$zg=$,e.$Ag=a,e.$Bg=P;function M(u){return u===47||u===92}function p(u){return u.replace(/[\\/]/g,S.$hc.sep)}function g(u){return u.indexOf("/")===-1&&(u=p(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function k(u,E=S.$hc.sep){if(!u)return"";const f=u.length,D=u.charCodeAt(0);if(M(D)){if(M(u.charCodeAt(1))&&!M(u.charCodeAt(2))){let C=3;const I=C;for(;C<f&&!M(u.charCodeAt(C));C++);if(I!==C&&!M(u.charCodeAt(C+1))){for(C+=1;C<f;C++)if(M(u.charCodeAt(C)))return u.slice(0,C+1).replace(/[\\/]/g,E)}}return E}else if(r(D)&&u.charCodeAt(1)===58)return M(u.charCodeAt(2))?u.slice(0,2)+E:u.slice(0,2);let w=u.indexOf("://");if(w!==-1){for(w+=3;w<f;w++)if(M(u.charCodeAt(w)))return u.slice(0,w+1)}return""}function N(u){if(!F.$i||!u||u.length<5)return!1;let E=u.charCodeAt(0);if(E!==92||(E=u.charCodeAt(1),E!==92))return!1;let f=2;const D=f;for(;f<u.length&&(E=u.charCodeAt(f),E!==92);f++);return!(D===f||(E=u.charCodeAt(f+1),isNaN(E)||E===92))}const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,E=F.$i){const f=E?y:l;return!(!u||u.length===0||/^\s+$/.test(u)||(f.lastIndex=0,f.test(u))||E&&b.test(u)||u==="."||u===".."||E&&u[u.length-1]==="."||E&&u.length!==u.trim().length||u.length>255)}function s(u,E,f){const D=u===E;return!f||D?D:!u||!E?!1:(0,R.$vf)(u,E)}function o(u,E,f,D=S.sep){if(u===E)return!0;if(!u||!E||E.length>u.length)return!1;if(f){if(!(0,R.$wf)(u,E))return!1;if(E.length===u.length)return!0;let C=E.length;return E.charAt(E.length-1)===D&&C--,u.charAt(C)===D}return E.charAt(E.length-1)!==D&&(E+=D),u.indexOf(E)===0}function r(u){return u>=65&&u<=90||u>=97&&u<=122}function t(u,E){return F.$i&&u.endsWith(":")&&(u+=S.sep),(0,S.$jc)(u)||(u=(0,S.$kc)(E,u)),u=(0,S.$ic)(u),n(u)}function n(u){return F.$i?(u=(0,R.$df)(u,S.sep),u.endsWith(":")&&(u+=S.sep)):(u=(0,R.$df)(u,S.sep),u||(u=S.sep)),u}function c(u){const E=(0,S.$ic)(u);return F.$i?u.length>3?!1:h(E)&&(u.length===2||E.charCodeAt(2)===92):E===S.$hc.sep}function h(u,E=F.$i){return E?r(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function i(u,E=F.$i){return h(u,E)?u[0]:void 0}function $(u,E,f){return E.length>u.length?-1:u===E?0:(f&&(u=u.toLowerCase(),E=E.toLowerCase()),u.indexOf(E))}function a(u){const E=u.split(":");let f,D,w;for(const C of E){const I=Number(C);(0,O.$0f)(I)?D===void 0?D=I:w===void 0&&(w=I):f=f?[f,C].join(":"):C}if(!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:D!==void 0?D:void 0,column:w!==void 0?w:D!==void 0?1:void 0}}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(u,E,f=8){let D="";for(let C=0;C<f;C++){let I;C===0&&F.$i&&!E&&(f===3||f===4)?I=d:I=v,D+=I.charAt(Math.floor(Math.random()*I.length))}let w;return E?w=`${E}-${D}`:w=D,u?(0,S.$kc)(u,w):w}}),define(Pe[69],Ae([1,0,19]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ns=O,e.$Os=M,e.$Ps=p,e.$Qs=k,e.$Ms=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(N){const y=(0,S.$pc)(N),l=F[y.toLowerCase()];return l!==void 0?l:M(N)}function M(N){const y=(0,S.$pc)(N);return R[y.toLowerCase()]}function p(N){for(const y in R)if(R[y]===N)return y}const g=/^(.+)\/(.+?)(;.+)?$/;function k(N,y){const l=g.exec(N);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:y?void 0:N}}),define(Pe[53],Ae([1,0,22,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=R,e.$2h=O,e.$3h=p;function R(g){return JSON.stringify(g,M)}function O(g){let k=JSON.parse(g);return k=p(k),k}function M(g,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p(g,k=0){if(!g||k>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return F.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof S.$De||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let N=0;N<g.length;++N)g[N]=p(g[N],k+1);else for(const N in g)Object.hasOwnProperty.call(g,N)&&(g[N]=p(g[N],k+1))}return g}}),define(Pe[12],Ae([1,0,14,21,15,2,19]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Gg=e.$Fg=e.$Eg=e.Schemas=void 0,e.$Cg=g,e.$Dg=k,e.$Hg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function g(m,s){return O.URI.isUri(m)?(0,R.$vf)(m.scheme,s):(0,R.$wf)(m,s+":")}function k(m,...s){return s.some(o=>g(m,o))}e.$Eg="vscode-tkn",e.$Fg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,r){this.a[s]=o,this.b[s]=r}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(h){return S.$1(h),s}const o=s.authority;let r=this.a[o];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const t=this.b[o],n=this.c[o];let c=`path=${encodeURIComponent(s.path)}`;return typeof n=="string"&&(c+=`&${e.$Fg}=${encodeURIComponent(n)}`),O.URI.from({scheme:F.$o?this.d:p.vscodeRemoteResource,authority:`${r}:${t}`,path:this.g,query:c})}}e.$Gg=new N;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Ig="vs/../../extensions",e.$Jg="vs/../../node_modules",e.$Kg="vs/../../node_modules.asar",e.$Lg="vs/../../node_modules.asar.unpacked",e.$Mg="vscode-app";class l{static{this.a=e.$Mg}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Gg.rewrite(s):s.scheme===p.file&&(F.$m||F.$q===`${p.vscodeFileResource}://${l.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}e.$Ng=new l;var b;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function r(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const h=c?.get(o);if(h)return s.get(h)}m.getHeadersFromQuery=r;function t(n,c,h){if(!globalThis.crossOriginIsolated)return;const i=c&&h?"3":h?"2":"1";n instanceof URLSearchParams?n.set(o,i):n[o]=i}m.addSearchParam=t})(b||(e.COI=b={}))}),define(Pe[23],Ae([1,0,47,12,19,21,15,2]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0,e.$Ug=g,e.$dh=N,e.$eh=l;function g(b){return(0,p.$xc)(b,!0)}class k{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$of)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===F.Schemas.file)return S.$sg(g(m),g(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$_g)(m.authority,s.authority))return S.$sg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$4g)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===F.Schemas.file?s=p.URI.file(R.$nc(g(m))).path:(s=R.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===F.Schemas.file?s=p.URI.file(R.$ic(g(m))).path:s=R.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$_g)(m.authority,s.authority))return;if(m.scheme===F.Schemas.file){const t=R.$mc(g(m),g(s));return O.$i?S.$mg(t):t}let o=m.path||"/";const r=s.path||"/";if(this.a(m)){let t=0;for(const n=Math.min(o.length,r.length);t<n&&!(o.charCodeAt(t)!==r.charCodeAt(t)&&o.charAt(t).toLowerCase()!==r.charAt(t).toLowerCase());t++);o=r.substr(0,t)+o.substr(t)}return R.$hc.relative(o,r)}resolvePath(m,s){if(m.scheme===F.Schemas.file){const o=p.URI.file(R.$lc(g(m),s));return m.with({authority:o.authority,path:o.path})}return s=S.$ng(s),m.with({path:R.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$vf)(m,s)}hasTrailingPathSeparator(m,s=R.sep){if(m.scheme===F.Schemas.file){const o=g(m);return o.length>S.$og(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=R.sep){return(0,e.$ah)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=R.sep){let o=!1;if(m.scheme===F.Schemas.file){const r=g(m);o=r!==void 0&&r.length===S.$og(r).length&&r[r.length-1]===s}else{s="/";const r=m.path;o=r.length===1&&r.charCodeAt(r.length-1)===47}return!o&&!(0,e.$ah)(m,s)?m.with({path:m.path+"/"}):m}}e.$Vg=k,e.$Wg=new k(()=>!1),e.$Xg=new k(b=>b.scheme===F.Schemas.file?!O.$k:!0),e.$Yg=new k(b=>!0),e.$Zg=e.$Wg.isEqual.bind(e.$Wg),e.$1g=e.$Wg.isEqualOrParent.bind(e.$Wg),e.$2g=e.$Wg.getComparisonKey.bind(e.$Wg),e.$3g=e.$Wg.basenameOrAuthority.bind(e.$Wg),e.$4g=e.$Wg.basename.bind(e.$Wg),e.$5g=e.$Wg.extname.bind(e.$Wg),e.$6g=e.$Wg.dirname.bind(e.$Wg),e.$7g=e.$Wg.joinPath.bind(e.$Wg),e.$8g=e.$Wg.normalizePath.bind(e.$Wg),e.$9g=e.$Wg.relativePath.bind(e.$Wg),e.$0g=e.$Wg.resolvePath.bind(e.$Wg),e.$$g=e.$Wg.isAbsolutePath.bind(e.$Wg),e.$_g=e.$Wg.isEqualAuthority.bind(e.$Wg),e.$ah=e.$Wg.hasTrailingPathSeparator.bind(e.$Wg),e.$bh=e.$Wg.removeTrailingPathSeparator.bind(e.$Wg),e.$ch=e.$Wg.addTrailingPathSeparator.bind(e.$Wg);function N(b,m){const s=[];for(let o=0;o<b.length;o++){const r=m(b[o]);b.some((t,n)=>n===o?!1:(0,e.$1g)(r,m(t)))||s.push(b[o])}return s}var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,h]=n.split(":");c&&h&&o.set(c,h)});const t=s.path.substring(0,s.path.indexOf(";"));return t&&o.set(b.META_DATA_MIME,t),o}b.parseMetaData=m})(y||(e.DataUri=y={}));function l(b,m,s){if(m){let o=b.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),b.with({scheme:s,authority:m,path:o})}return b.with({scheme:s})}}),define(Pe[11],Ae([1,0,24,14,5,6,23,21,130,41]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.Promises=e.$Qh=e.$Ph=e.$Oh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0,e.$fh=N,e.$gh=y,e.$hh=l,e.$ih=b,e.$jh=m,e.$kh=s,e.$lh=o,e.$mh=r,e.$uh=P,e.$vh=u,e.$wh=E,e.$xh=f,e.$yh=D,e.$Nh=Ie,e.$Vh=ke;function N(fe){return!!fe&&typeof fe.then=="function"}function y(fe){const Q=new S.$ne,X=fe(Q.token),le=new Promise((ue,Ne)=>{const he=Q.token.onCancellationRequested(()=>{he.dispose(),Ne(new F.$5)});Promise.resolve(X).then(Ce=>{he.dispose(),Q.dispose(),ue(Ce)},Ce=>{he.dispose(),Q.dispose(),Ne(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Ne){return le.then(ue,Ne)}catch(ue){return this.then(void 0,ue)}finally(ue){return le.finally(ue)}}}function l(fe,Q,X){return new Promise((le,ue)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),le(X)});fe.then(le,ue).finally(()=>Ne.dispose())})}function b(fe,Q){return new Promise((X,le)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),le(new F.$5)});fe.then(X,le).finally(()=>ue.dispose())})}async function m(fe){let Q=-1;const X=fe.map((le,ue)=>le.then(Ne=>(Q=ue,Ne)));try{return await Promise.race(X)}finally{fe.forEach((le,ue)=>{ue!==Q&&le.cancel()})}}function s(fe,Q,X){let le;const ue=setTimeout(()=>{le?.(void 0),X?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(ue)),new Promise(Ne=>le=Ne)])}function o(fe){return new Promise((Q,X)=>{const le=fe();N(le)?le.then(Q,X):Q(le)})}function r(){let fe,Q;return{promise:new Promise((le,ue)=>{fe=le,Q=ue}),resolve:fe,reject:Q}}class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const X=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(X,X).then(le)})}return new Promise((X,le)=>{this.b.then(X,le)})}return this.a=Q(),new Promise((X,le)=>{this.a.then(ue=>{this.a=null,X(ue)},ue=>{this.a=null,le(ue)})})}dispose(){this.f=!0}}e.$nh=t;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$oh=n;class c{constructor(){this.a=new Map}queue(Q,X){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$ph=c;const h=(fe,Q)=>{let X=!0;const le=setTimeout(()=>{X=!1,Q()},fe);return{isTriggered:()=>X,dispose:()=>{clearTimeout(le),X=!1}}},i=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class ${constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,X=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Ne)=>{this.d=ue,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=X===g.$_d?i(le):h(X,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qh=$;class a{constructor(Q){this.a=new $(Q),this.b=new t}trigger(Q,X){return this.a.trigger(()=>this.b.queue(Q),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rh=a;class v{constructor(){this.a=!1,this.b=new Promise((Q,X)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sh=v;class d extends v{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$th=d;function P(fe,Q){return Q?new Promise((X,le)=>{const ue=setTimeout(()=>{Ne.dispose(),X()},fe),Ne=Q.onCancellationRequested(()=>{clearTimeout(ue),Ne.dispose(),le(new F.$5)})}):y(X=>P(fe,X))}function u(fe,Q=0,X){const le=setTimeout(()=>{fe(),X&&ue.dispose()},Q),ue=(0,O.$Tc)(()=>{clearTimeout(le),X?.deleteAndLeak(ue)});return X?.add(ue),ue}function E(fe){const Q=[];let X=0;const le=fe.length;function ue(){return X<le?fe[X++]():null}function Ne(he){he!=null&&Q.push(he);const Ce=ue();return Ce?Ce.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function f(fe,Q=le=>!!le,X=null){let le=0;const ue=fe.length,Ne=()=>{if(le>=ue)return Promise.resolve(X);const he=fe[le++];return Promise.resolve(he()).then(Fe=>Q(Fe)?Promise.resolve(Fe):Ne())};return Ne()}function D(fe,Q=le=>!!le,X=null){if(fe.length===0)return Promise.resolve(X);let le=fe.length;const ue=()=>{le=-1;for(const Ne of fe)Ne.cancel?.()};return new Promise((Ne,he)=>{for(const Ce of fe)Ce.then(Fe=>{--le>=0&&Q(Fe)?(ue(),Ne(Fe)):le===0&&Ne(X)}).catch(Fe=>{--le>=0&&(ue(),he(Fe))})})}class w{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$ce}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,le)=>{this.g.push({factory:Q,c:X,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const X=Q.factory();X.then(Q.c,Q.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$zh=w;class C extends w{constructor(){super(1)}}e.$Ah=C;class I{constructor(){this.a=new de,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Bh=I;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ce;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,X=M.$Wg){const le=X.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,X,le=M.$Wg){const ue=le.getComparisonKey(Q);let Ne=this.a.get(ue);if(!Ne){Ne=new C;const he=this.f++,Ce=R.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(he,Ce),this.a.set(ue,Ne)}return Ne.queue(X)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ch=W;class V{constructor(Q,X){this.a=-1,typeof Q=="function"&&typeof X=="number"&&this.setIfNotSet(Q,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},X)}setIfNotSet(Q,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},X))}}e.$Dh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,X,le=globalThis){this.cancel();const ue=le.setInterval(()=>{Q()},X);this.d=(0,O.$Tc)(()=>{le.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Eh=q;class A{constructor(Q,X){this.b=-1,this.a=Q,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Fh=A;class j{constructor(Q,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=Q,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Gh=j;class K extends A{constructor(Q,X){super(Q,X),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Hh=K;class re extends O.$Vc{constructor(Q,X){super(),this.g=Q,this.h=X,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of Q)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ih=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Kh=(fe,Q)=>{(0,p.$B)(()=>{if(X)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$Kh=(fe,Q,X)=>{const le=fe.requestIdleCallback(Q,typeof X=="number"?{timeout:X}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,fe.cancelIdleCallback(le))}}},e.$Jh=fe=>(0,e.$Kh)(globalThis,fe)}();class ae{constructor(Q,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Kh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Lh=ae;class be extends ae{constructor(Q){super(globalThis,Q)}}e.$Mh=be;async function Ie(fe,Q,X){let le;for(let ue=0;ue<X;ue++)try{return await fe()}catch(Ne){le=Ne,await P(Q)}throw le}class de{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,X,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:X},X.then(()=>this.d(Q),()=>this.d(Q)),X}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:X,resolve:le,reject:ue}=r();this.b={run:Q,promise:X,promiseResolve:le,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Oh=de;class me{constructor(Q,X=()=>Date.now()){this.d=Q,this.f=X,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Ph=me;var Me;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(Me||(Me={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,X)=>{this.a=Q,this.b=X})}complete(Q){return new Promise(X=>{this.a(Q),this.d={outcome:0,value:Q},X()})}error(Q){return new Promise(X=>{this.b(Q),this.d={outcome:1,value:Q},X()})}cancel(){return this.error(new F.$5)}}e.$Qh=ce;var Re;(function(fe){async function Q(le){let ue;const Ne=await Promise.all(le.map(he=>he.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Ne}fe.settled=Q;function X(le){return new Promise(async(ue,Ne)=>{try{await le(ue,Ne)}catch(he){Ne(he)}})}fe.withAsyncBody=X})(Re||(e.Promises=Re={}));class ie{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Rh=ie;class L{constructor(Q){this.b=Q,this.a=new k.$V(()=>new ie(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Sh=L;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(X=>{X.emitMany(Q)})}static fromPromise(Q){return new ve(async X=>{X.emitMany(await Q)})}static fromPromises(Q){return new ve(async X=>{await Promise.all(Q.map(async le=>X.emitOne(await le)))})}static merge(Q){return new ve(async X=>{await Promise.all(Q.map(async le=>{for await(const ue of le)X.emitOne(ue)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,X){this.a=0,this.b=[],this.d=null,this.f=X,this.g=new R.$ce,queueMicrotask(async()=>{const le={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(le)),this.k()}catch(ue){this.l(ue)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,X){return new ve(async le=>{for await(const ue of Q)le.emitOne(X(ue))})}map(Q){return ve.map(this,Q)}static filter(Q,X){return new ve(async le=>{for await(const ue of Q)X(ue)&&le.emitOne(ue)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,X=>!!X)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const X=[];for await(const le of Q)X.push(le);return X}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Th=ve;class Te extends ve{constructor(Q,X){super(X),this.m=Q}cancel(){this.m.cancel()}}e.$Uh=Te;function ke(fe){const Q=new S.$ne,X=fe(Q.token);return new Te(Q,async le=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),le.reject(new F.$5)});try{for await(const Ne of X){if(Q.token.isCancellationRequested)return;le.emitOne(Ne)}ue.dispose(),Q.dispose()}catch(Ne){ue.dispose(),Q.dispose(),le.reject(Ne)}})}class pe{constructor(Q){this.a=new ce,this.b=new ve(ue=>{if(X){ue.reject(X);return}return le&&ue.emitMany(le),this.d=Ne=>ue.reject(Ne),this.f=Ne=>ue.emitOne(Ne),this.a.p},Q);let X,le;this.f=ue=>{le||(le=[]),le.push(ue)},this.d=ue=>{X||(X=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Wh=pe}),define(Pe[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$ik=k,e.$lk=m,e.$mk=C,e.$nk=I,e.$ok=W,e.$pk=V,e.$qk=q,e.$rk=re;function k(){return Object.create(null)}e.$jk="**",e.$kk="/";const N="[/\\\\]",y="[^/\\\\]",l=/\//g;function b(ae,be){switch(ae){case 0:return"";case 1:return`${y}*?`;default:return`(?:${N}|${y}+${N}${be?`|${N}${y}+`:""})*?`}}function m(ae,be){if(!ae)return[];const Ie=[];let de=!1,me=!1,Me="";for(const ce of ae){switch(ce){case be:if(!de&&!me){Ie.push(Me),Me="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":me=!0;break;case"]":me=!1;break}Me+=ce}return Me&&Ie.push(Me),Ie}function s(ae){if(!ae)return"";let be="";const Ie=m(ae,e.$kk);if(Ie.every(de=>de===e.$jk))be=".*";else{let de=!1;Ie.forEach((me,Me)=>{if(me===e.$jk){if(de)return;be+=b(2,Me===Ie.length-1)}else{let ce=!1,Re="",ie=!1,L="";for(const x of me){if(x!=="}"&&ce){Re+=x;continue}if(ie&&(x!=="]"||!L)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!L?ve="^":x===e.$kk?ve="":ve=(0,g.$0e)(x),L+=ve;continue}switch(x){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const Te=`(?:${m(Re,",").map(ke=>s(ke)).join("|")})`;be+=Te,ce=!1,Re="";break}case"]":{be+="["+L+"]",ie=!1,L="";break}case"?":be+=y;continue;case"*":be+=b(1);continue;default:be+=(0,g.$0e)(x)}}Me<Ie.length-1&&(Ie[Me+1]!==e.$jk||Me+2<Ie.length)&&(be+=N)}de=me===e.$jk})}return be}const o=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Ec(1e4),$=function(){return!1},a=function(){return null};function v(ae,be){if(!ae)return a;let Ie;typeof ae!="string"?Ie=ae.pattern:Ie=ae,Ie=Ie.trim();const de=`${Ie}_${!!be.trimForExclusions}`;let me=i.get(de);if(me)return d(me,ae);let Me;return o.test(Ie)?me=u(Ie.substr(4),Ie):(Me=r.exec(P(Ie,be)))?me=E(Me[1],Ie):(be.trimForExclusions?n:t).test(Ie)?me=f(Ie,be):(Me=c.exec(P(Ie,be)))?me=D(Me[1].substr(1),Ie,!0):(Me=h.exec(P(Ie,be)))?me=D(Me[1],Ie,!1):me=w(Ie),i.set(de,me),d(me,ae)}function d(ae,be){if(typeof be=="string")return ae;const Ie=function(de,me){return(0,R.$sg)(de,be.base,!p.$k)?ae((0,g.$cf)(de.substr(be.base.length),M.sep),me):null};return Ie.allBasenames=ae.allBasenames,Ie.allPaths=ae.allPaths,Ie.basenames=ae.basenames,Ie.patterns=ae.patterns,Ie}function P(ae,be){return be.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function u(ae,be){return function(Ie,de){return typeof Ie=="string"&&Ie.endsWith(ae)?be:null}}function E(ae,be){const Ie=`/${ae}`,de=`\\${ae}`,me=function(ce,Re){return typeof ce!="string"?null:Re?Re===ae?be:null:ce===ae||ce.endsWith(Ie)||ce.endsWith(de)?be:null},Me=[ae];return me.basenames=Me,me.patterns=[be],me.allBasenames=Me,me}function f(ae,be){const Ie=K(ae.slice(1,-1).split(",").map(Re=>v(Re,be)).filter(Re=>Re!==a),ae),de=Ie.length;if(!de)return a;if(de===1)return Ie[0];const me=function(Re,ie){for(let L=0,x=Ie.length;L<x;L++)if(Ie[L](Re,ie))return ae;return null},Me=Ie.find(Re=>!!Re.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Re,ie)=>ie.allPaths?Re.concat(ie.allPaths):Re,[]);return ce.length&&(me.allPaths=ce),me}function D(ae,be,Ie){const de=M.sep===M.$hc.sep,me=de?ae:ae.replace(l,M.sep),Me=M.sep+me,ce=M.$hc.sep+ae;let Re;return Ie?Re=function(ie,L){return typeof ie=="string"&&(ie===me||ie.endsWith(Me)||!de&&(ie===ae||ie.endsWith(ce)))?be:null}:Re=function(ie,L){return typeof ie=="string"&&(ie===me||!de&&ie===ae)?be:null},Re.allPaths=[(Ie?"*/":"./")+ae],Re}function w(ae){try{const be=new RegExp(`^${s(ae)}$`);return function(Ie){return be.lastIndex=0,typeof Ie=="string"&&be.test(Ie)?ae:null}}catch{return a}}function C(ae,be,Ie){return!ae||typeof be!="string"?!1:I(ae)(be,void 0,Ie)}function I(ae,be={}){if(!ae)return $;if(typeof ae=="string"||W(ae)){const Ie=v(ae,be);if(Ie===a)return $;const de=function(me,Me){return!!Ie(me,Me)};return Ie.allBasenames&&(de.allBasenames=Ie.allBasenames),Ie.allPaths&&(de.allPaths=Ie.allPaths),de}return A(ae,be)}function W(ae){const be=ae;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}function V(ae){return ae.allBasenames||[]}function q(ae){return ae.allPaths||[]}function A(ae,be){const Ie=K(Object.getOwnPropertyNames(ae).map(Re=>j(Re,ae[Re],be)).filter(Re=>Re!==a)),de=Ie.length;if(!de)return a;if(!Ie.some(Re=>!!Re.requiresSiblings)){if(de===1)return Ie[0];const Re=function(x,ve){let Te;for(let ke=0,pe=Ie.length;ke<pe;ke++){const fe=Ie[ke](x,ve);if(typeof fe=="string")return fe;(0,F.$fh)(fe)&&(Te||(Te=[]),Te.push(fe))}return Te?(async()=>{for(const ke of Te){const pe=await ke;if(typeof pe=="string")return pe}return null})():null},ie=Ie.find(x=>!!x.allBasenames);ie&&(Re.allBasenames=ie.allBasenames);const L=Ie.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return L.length&&(Re.allPaths=L),Re}const me=function(Re,ie,L){let x,ve;for(let Te=0,ke=Ie.length;Te<ke;Te++){const pe=Ie[Te];pe.requiresSiblings&&L&&(ie||(ie=(0,M.$oc)(Re)),x||(x=ie.substr(0,ie.length-(0,M.$pc)(Re).length)));const fe=pe(Re,ie,x,L);if(typeof fe=="string")return fe;(0,F.$fh)(fe)&&(ve||(ve=[]),ve.push(fe))}return ve?(async()=>{for(const Te of ve){const ke=await Te;if(typeof ke=="string")return ke}return null})():null},Me=Ie.find(Re=>!!Re.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Re,ie)=>ie.allPaths?Re.concat(ie.allPaths):Re,[]);return ce.length&&(me.allPaths=ce),me}function j(ae,be,Ie){if(be===!1)return a;const de=v(ae,Ie);if(de===a)return a;if(typeof be=="boolean")return de;if(be){const me=be.when;if(typeof me=="string"){const Me=(ce,Re,ie,L)=>{if(!L||!de(ce,Re))return null;const x=me.replace("$(basename)",()=>ie),ve=L(x);return(0,F.$fh)(ve)?ve.then(Te=>Te?ae:null):ve?ae:null};return Me.requiresSiblings=!0,Me}}return de}function K(ae,be){const Ie=ae.filter(Re=>!!Re.basenames);if(Ie.length<2)return ae;const de=Ie.reduce((Re,ie)=>{const L=ie.basenames;return L?Re.concat(L):Re},[]);let me;if(be){me=[];for(let Re=0,ie=de.length;Re<ie;Re++)me.push(be)}else me=Ie.reduce((Re,ie)=>{const L=ie.patterns;return L?Re.concat(L):Re},[]);const Me=function(Re,ie){if(typeof Re!="string")return null;if(!ie){let x;for(x=Re.length;x>0;x--){const ve=Re.charCodeAt(x-1);if(ve===47||ve===92)break}ie=Re.substr(x)}const L=de.indexOf(ie);return L!==-1?me[L]:null};Me.basenames=de,Me.patterns=me,Me.allBasenames=de;const ce=ae.filter(Re=>!Re.basenames);return ce.push(Me),ce}function re(ae,be){return(0,S.$ub)(ae,be,(Ie,de)=>typeof Ie=="string"&&typeof de=="string"?Ie===de:typeof Ie!="string"&&typeof de!="string"?Ie.base===de.base&&Ie.pattern===de.pattern:!1)}}),define(Pe[54],Ae([1,0,14,131,23,15,2]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.MarkdownStringTextNewlineStyle=void 0,e.$Rk=k,e.$Sk=N,e.$Tk=y,e.$Uk=l,e.$Vk=b,e.$Wk=m,e.$Xk=s,e.$Yk=o;var p;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class g{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,F.$Kk)(t):t).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+=`
${b(n,t)}
`,this}appendLink(t,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(t,n){const c=new RegExp((0,O.$0e)(n),"g");return t.replace(c,(h,i)=>t.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$Qk=g;function k(r){return N(r)?!r.value:Array.isArray(r)?r.every(k):!0}function N(r){return r instanceof g?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function y(r,t){return r===t?!0:!r||!t?!1:r.value===t.value&&r.isTrusted===t.isTrusted&&r.supportThemeIcons===t.supportThemeIcons&&r.supportHtml===t.supportHtml&&(r.baseUri===t.baseUri||!!r.baseUri&&!!t.baseUri&&(0,R.$Zg)(M.URI.from(r.baseUri),M.URI.from(t.baseUri)))}function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(r,t){const n=r.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${t}`,r,`${"`".repeat(c)}`].join(`
`)}function m(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(r){const t=[],n=r.split("|").map(h=>h.trim());r=n[0];const c=n[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),$=h?h[1]:"",a=i?i[1]:"",v=isFinite(parseInt(a)),d=isFinite(parseInt($));v&&t.push(`width="${a}"`),d&&t.push(`height="${$}"`)}return{href:r,dimensions:t}}}),define(Pe[96],Ae([1,0,18,47,19,21,23,15]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=g,e.$tw=N,e.$uw=l,e.$vw=b,e.$ww=r,e.$xw=n,e.$yw=c,e.$zw=h,e.$Aw=i,e.$Bw=$;function g(v,d){const{os:P,tildify:u,relative:E}=d;if(E){const w=k(v,E,P);if(typeof w=="string")return w}let f=v.fsPath;if(P===1&&!O.$i?f=f.replace(/\//g,"\\"):P!==1&&O.$i&&(f=f.replace(/\\/g,"/")),P!==1&&u?.userHome){const w=u.userHome.fsPath;let C;v.scheme!==u.userHome.scheme&&v.path[0]===R.$hc.sep&&v.path[1]!==R.$hc.sep?C=u.userHome.with({path:v.path}).fsPath:C=f,f=l(C,w,P)}return(P===1?R.$gc:R.$hc).normalize(N(f,P===1))}function k(v,d,P){const u=P===1?R.$gc:R.$hc,E=P===3?M.$Wg:M.$Yg,f=d.getWorkspace(),D=(0,S.$Ob)(f.folders);if(!D)return;v.scheme!==D.uri.scheme&&v.path[0]===R.$hc.sep&&v.path[1]!==R.$hc.sep&&(v=D.uri.with({path:v.path}));const w=d.getWorkspaceFolder(v);if(!w)return;let C;if(E.isEqual(w.uri,v)?C="":C=E.relativePath(w.uri,v)??"",C&&(C=u.normalize(C)),f.folders.length>1&&!d.noPrefix){const I=w.name?w.name:E.basenameOrAuthority(w.uri);C=C?`${I} \u2022 ${C}`:I}return C}function N(v,d=O.$i){return(0,F.$xg)(v,d)?v.charAt(0).toUpperCase()+v.slice(1):v}let y=Object.create(null);function l(v,d,P=O.OS){if(P===1||!v||!d)return v;let u=y.original===d?y.normalized:void 0;u||(u=d,O.$i&&(u=(0,F.$mg)(u)),u=`${(0,p.$df)(u,R.$hc.sep)}${R.$hc.sep}`,y={original:d,normalized:u});let E=v;return O.$i&&(E=(0,F.$mg)(E)),(P===3?E.startsWith(u):(0,p.$wf)(E,u))?`~/${E.substr(u.length)}`:v}function b(v,d){return v.replace(/^~($|\/|\\)/,`${d}$1`)}const m="\u2026",s="\\\\",o="~";function r(v,d=R.sep){const P=new Array(v.length);let u=!1;for(let E=0;E<v.length;E++){const f=v[E];if(f===""){P[E]=`.${d}`;continue}if(!f){P[E]=f;continue}u=!0;let D="",w=f;w.indexOf(s)===0?(D=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(d)===0?(D=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length)):w.indexOf(o)===0&&(D=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const C=w.split(d);for(let I=1;u&&I<=C.length;I++)for(let W=C.length-I;u&&W>=0;W--){u=!1;let V=C.slice(W,W+I).join(d);for(let q=0;!u&&q<v.length;q++)if(q!==E&&v[q]&&v[q].indexOf(V)>-1){const A=W+I===C.length,j=W>0&&v[q].indexOf(d)>-1?d+V:V,K=v[q].endsWith(j);u=!A||K}if(!u){let q="";(C[0].endsWith(":")||D!=="")&&(W===1&&(W=0,I++,V=C[0]+d+V),W>0&&(q=C[0]+d),q=D+q),W>0&&(q=q+m+d),q=q+V,W+I<C.length&&(q=q+d+m),P[E]=q}}u&&(P[E]=f)}return P}var t;(function(v){v[v.TEXT=0]="TEXT",v[v.VARIABLE=1]="VARIABLE",v[v.SEPARATOR=2]="SEPARATOR"})(t||(t={}));function n(v,d=Object.create(null)){const P=[];let u=!1,E="";for(const f of v)if(f==="$"||u&&f==="{")E&&P.push({value:E,type:t.TEXT}),E="",u=!0;else if(f==="}"&&u){const D=d[E];if(typeof D=="string")D.length&&P.push({value:D,type:t.VARIABLE});else if(D){const w=P[P.length-1];(!w||w.type!==t.SEPARATOR)&&P.push({value:D.label,type:t.SEPARATOR})}E="",u=!1}else E+=f;return E&&!u&&P.push({value:E,type:t.TEXT}),P.filter((f,D)=>{if(f.type===t.SEPARATOR){const w=P[D-1],C=P[D+1];return[w,C].every(I=>I&&(I.type===t.VARIABLE||I.type===t.TEXT)&&I.value.length>0)}return!0}).map(f=>f.value).join("")}function c(v,d){return O.$j||d?v.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):v.replace(/&&|&/g,P=>P==="&"?"&&":"&")}function h(v,d){return O.$j||d?v.replace(/\(&&\w\)|&&/g,""):O.$i?v.replace(/&&|&/g,P=>P==="&"?"&&":"&"):v.replace(/&&/g,"_")}function i(v){return v.replace(/&/g,"&&")}function $(v){if(v.endsWith("]")){const d=v.lastIndexOf(" [",v.length-2);if(d!==-1){const P=a(v.substring(0,d)),u=v.substring(d);return{name:P.name+u,parentPath:P.parentPath}}}return a(v)}function a(v){const d=v.indexOf("/")!==-1?R.$hc:R.$gc,P=d.basename(v),u=d.dirname(v);return P.length?{name:P,parentPath:u}:{name:u,parentPath:""}}}),define(Pe[144],Ae([1,0,22,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=void 0,e.$xn=p,e.$yn=k,e.$zn=N;function R(y){return y.toJSON()}class O{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:R(F.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:R(F.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:F.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$vn=O,e.$wn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,l,b){if(!y||b>200)return null;if(typeof y=="object"){if(y instanceof F.URI)return l.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],l,b+1);s!==null&&(y[m]=s)}}return null}function p(y,l){const b=M(y,l,0);return b===null?y:b}function g(y,l,b,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return b?F.URI.revive(l.transformIncoming(y)):l.transformIncoming(y);if(y instanceof S.$De)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=g(y[s],l,b,m+1);o!==null&&(y[s]=o)}}return null}function k(y,l){const b=g(y,l,!1,0);return b===null?y:b}function N(y,l){const b=g(y,l,!0,0);return b===null?y:b}}),define(Pe[145],Ae([1,0,15,21,22]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0,e.$yt=N,e.$zt=y;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function g(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function N(){return k||(k=F.$D()?M():g()),k}function y(m,s,o){const r=new Uint16Array(m.buffer,s,o);return o>0&&(r[0]===65279||r[0]===65534)?l(m,s,o):M().decode(r)}function l(m,s,o){const r=[];let t=0;for(let n=0;n<o;n++){const c=R.$Fe(m,s);s+=2,r[t++]=String.fromCharCode(c)}return r.join("")}class b{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||S.$zf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<o;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$At=b}),define(Pe[146],Ae([1,0,22,145]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0,e.$Ct=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,N,y,l){this.oldPosition=k,this.oldText=N,this.newPosition=y,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,N,y){const l=N.length;S.$Ie(k,l,y),y+=4;for(let b=0;b<l;b++)S.$Ge(k,N.charCodeAt(b),y),y+=2;return y}static d(k,N){const y=S.$He(k,N);return N+=4,(0,F.$zt)(k,N,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(k,N){return S.$Ie(k,this.oldPosition,N),N+=4,S.$Ie(k,this.newPosition,N),N+=4,N=O.c(k,this.oldText,N),N=O.c(k,this.newText,N),N}static read(k,N,y){const l=S.$He(k,N);N+=4;const b=S.$He(k,N);N+=4;const m=O.d(k,N);N+=O.a(m);const s=O.d(k,N);return N+=O.a(s),y.push(new O(l,m,b,s)),N}}e.$Bt=O;function M(g,k){return g===null||g.length===0?k:new p(g,k).compress()}class p{constructor(k,N){this.a=k,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,N=0,y=this.n(k),l=this.l(N);for(;k<this.f||N<this.h;){if(y===null){this.k(l),l=this.l(++N);continue}if(l===null){this.m(y),y=this.n(++k);continue}if(l.oldEnd<=y.newPosition){this.k(l),l=this.l(++N);continue}if(y.newEnd<=l.oldPosition){this.m(y),y=this.n(++k);continue}if(l.oldPosition<y.newPosition){const[r,t]=p.r(l,y.newPosition-l.oldPosition);this.k(r),l=t;continue}if(y.newPosition<l.oldPosition){const[r,t]=p.q(y,l.oldPosition-y.newPosition);this.m(r),y=t;continue}let s,o;if(l.oldEnd===y.newEnd)s=y,o=l,y=this.n(++k),l=this.l(++N);else if(l.oldEnd<y.newEnd){const[r,t]=p.q(y,l.oldLength);s=r,o=l,y=t,l=this.l(++N)}else{const[r,t]=p.r(l,y.newLength);s=y,o=r,y=this.n(++k),l=t}this.d[this.e++]=new O(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const b=p.s(this.d);return p.t(b)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,N){return new O(N.oldPosition-k,N.oldText,N.newPosition,N.newText)}static p(k,N){return new O(N.oldPosition,N.oldText,N.newPosition+k,N.newText)}static q(k,N){const y=k.newText.substr(0,N),l=k.newText.substr(N);return[new O(k.oldPosition,k.oldText,k.newPosition,y),new O(k.oldEnd,"",k.newPosition+N,l)]}static r(k,N){const y=k.oldText.substr(0,N),l=k.oldText.substr(N);return[new O(k.oldPosition,y,k.newPosition,k.newText),new O(k.oldPosition+N,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const N=[];let y=0,l=k[0];for(let b=1;b<k.length;b++){const m=k[b];l.oldEnd===m.oldPosition?l=new O(l.oldPosition,l.oldText+m.oldText,l.newPosition,l.newText+m.newText):(N[y++]=l,l=m)}return N[y++]=l,N}static t(k){if(k.length===0)return k;const N=[];let y=0;for(let l=0;l<k.length;l++){const b=k[l];b.oldText!==b.newText&&(N[y++]=b)}return N}}}),define(Pe[147],Ae([1,0,36,19]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=R,e.$1t=O;function R(M,p,g,k,N,y){if(Array.isArray(M)){let l=0;for(const b of M){const m=R(b,p,g,k,N,y);if(m===10)return m;m>l&&(l=m)}return l}else{if(typeof M=="string")return k?M==="*"?5:M===g?10:0:0;if(M){const{language:l,pattern:b,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!k&&!s)return 0;o&&N&&(p=N);let r=0;if(m)if(m===p.scheme)r=10;else if(m==="*")r=5;else return 0;if(l)if(l===g)r=10;else if(l==="*")r=Math.max(r,5);else return 0;if(o)if(o===y)r=10;else if(o==="*"&&y!==void 0)r=Math.max(r,5);else return 0;if(b){let t;if(typeof b=="string"?t=b:t={...b,base:(0,F.$ic)(b.base)},t===p.fsPath||(0,S.$mk)(t,p.fsPath))r=10;else return 0}return r}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Pe[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=void 0;class N extends k.$Vc{constructor(l,b,m,s,o,r,t){super(),this.m=this.B(new S.$ce),this.onDidChangeContent=this.m.event,this.f=b,this.j=!r,this.g=s,this.h=o,this.c=new M.$OC(l,m,t)}equals(l){return!(l instanceof N)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const m=l+b,s=this.getPositionAt(l),o=this.getPositionAt(m);return new R.$pt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const m=this.n(b);return this.c.getValueInRange(l,m)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const m=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const r=this.n(b),t=this.getEOL();if(r.length!==t.length){const n=r.length-t.length,c=l.endLineNumber-l.startLineNumber;o=n*c}return s-m+o}getCharacterCountInRange(l,b=0){if(this.j){let m=0;const s=l.startLineNumber,o=l.endLineNumber;for(let r=s;r<=o;r++){const t=this.getLineContent(r),n=r===s?l.startColumn-1:0,c=r===o?l.endColumn-1:t.length;for(let h=n;h<c;h++)F.$zf(t.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(b).length*(o-s),m}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=F.$kf(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=F.$mf(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,m){let s=this.g,o=this.h,r=this.j,t=!0,n=[];for(let d=0;d<l.length;d++){const P=l[d];t&&P._isTracked&&(t=!1);const u=P.range;if(P.text){let C=!0;r||(C=!F.$Kf(P.text),r=C),!s&&C&&(s=F.$Jf(P.text)),!o&&C&&(o=F.$Mf(P.text))}let E="",f=0,D=0,w=0;if(P.text){let C;[f,D,w,C]=(0,p.$St)(P.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?E=P.text:E=P.text.replace(/\r\n|\r|\n/g,I)}n[d]={sortIndex:d,identifier:P.identifier||null,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u),text:E,eolCount:f,firstLineLength:D,lastLineLength:w,forceMoveMarkers:!!P.forceMoveMarkers,isAutoWhitespaceEdit:P.isAutoWhitespaceEdit||!1}}n.sort(N.u);let c=!1;for(let d=0,P=n.length-1;d<P;d++){const u=n[d].range.getEndPosition(),E=n[d+1].range.getStartPosition();if(E.isBeforeOrEqual(u)){if(E.isBefore(u))throw new Error("Overlapping ranges are not allowed!");c=!0}}t&&(n=this.s(n));const h=m||b?N._getInverseEditRanges(n):[],i=[];if(b)for(let d=0;d<n.length;d++){const P=n[d],u=h[d];if(P.isAutoWhitespaceEdit&&P.range.isEmpty())for(let E=u.startLineNumber;E<=u.endLineNumber;E++){let f="";E===u.startLineNumber&&(f=this.getLineContent(P.range.startLineNumber),F.$kf(f)!==-1)||i.push({lineNumber:E,oldContent:f})}}let $=null;if(m){let d=0;$=[];for(let P=0;P<n.length;P++){const u=n[P],E=h[P],f=this.getValueInRange(u.range),D=u.rangeOffset+d;d+=u.text.length-f.length,$[P]={sortIndex:u.sortIndex,identifier:u.identifier,range:E,text:f,textChange:new g.$Bt(u.rangeOffset,f,D,u.text)}}c||$.sort((P,u)=>P.sortIndex-u.sortIndex)}this.g=s,this.h=o,this.j=r;const a=this.t(n);let v=null;if(b&&i.length>0){i.sort((d,P)=>P.lineNumber-d.lineNumber),v=[];for(let d=0,P=i.length;d<P;d++){const u=i[d].lineNumber;if(d>0&&i[d-1].lineNumber===u)continue;const E=i[d].oldContent,f=this.getLineContent(u);f.length===0||f===E||F.$kf(f)!==-1||v.push(u)}}return this.m.fire(),new O.$Ev($,a,v)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const m=l[0].range,s=l[l.length-1].range,o=new R.$pt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let r=m.startLineNumber,t=m.startColumn;const n=[];for(let a=0,v=l.length;a<v;a++){const d=l[a],P=d.range;b=b||d.forceMoveMarkers,n.push(this.getValueInRange(new R.$pt(r,t,P.startLineNumber,P.startColumn))),d.text.length>0&&n.push(d.text),r=P.endLineNumber,t=P.endColumn}const c=n.join(""),[h,i,$]=(0,p.$St)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:$,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(N.w);const b=[];for(let m=0;m<l.length;m++){const s=l[m],o=s.range.startLineNumber,r=s.range.startColumn,t=s.range.endLineNumber,n=s.range.endColumn;if(o===t&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new R.$pt(o,r,t,n);b.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,m,s){return this.c.findMatchesLineByLine(l,b,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const m=l.startLineNumber,s=l.startColumn,[o,r,t]=(0,p.$St)(b);let n;if(b.length>0){const c=o+1;c===1?n=new R.$pt(m,s,m,s+r):n=new R.$pt(m,s,m+c-1,t+1)}else n=new R.$pt(m,s,m,s);return n}static _getInverseEditRanges(l){const b=[];let m=0,s=0,o=null;for(let r=0,t=l.length;r<t;r++){const n=l[r];let c,h;o?o.range.endLineNumber===n.range.startLineNumber?(c=m,h=s+(n.range.startColumn-o.range.endColumn)):(c=m+(n.range.startLineNumber-o.range.endLineNumber),h=n.range.startColumn):(c=n.range.startLineNumber,h=n.range.startColumn);let i;if(n.text.length>0){const $=n.eolCount+1;$===1?i=new R.$pt(c,h,c,h+n.firstLineLength):i=new R.$pt(c,h,c+$-1,n.lastLineLength+1)}else i=new R.$pt(c,h,c,h);m=i.endLineNumber,s=i.endColumn,b.push(i),o=n}return b}static u(l,b){const m=R.$pt.compareRangesUsingEnds(l.range,b.range);return m===0?l.sortIndex-b.sortIndex:m}static w(l,b){const m=R.$pt.compareRangesUsingEnds(l.range,b.range);return m===0?b.sortIndex-l.sortIndex:-m}}e.$PC=N}),define(Pe[149],Ae([1,0,15,92,148]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=void 0;class O{constructor(g,k,N,y,l,b,m,s,o){this.a=g,this.b=k,this.c=N,this.d=y,this.e=l,this.f=b,this.g=m,this.h=s,this.j=o}k(g){const k=this.c+this.d+this.e,N=this.c+this.e;return k===0?g===1?`
`:`\r
`:N>k/2?`\r
`:`
`}create(g){const k=this.k(g),N=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,b=N.length;l<b;l++){const m=N[l].buffer.replace(/\r\n|\r|\n/g,k),s=(0,F.$KC)(m);N[l]=new F.$NC(m,s)}const y=new R.$PC(N,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&S.$Tf(g)&&(this.b=S.$Sf,g=g.substr(1));const k=g.charCodeAt(g.length-1);k===13||k>=55296&&k<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=k):(this.m(g,!1),this.c=!1,this.d=k)}m(g,k){!k&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const k=(0,F.$LC)(this.e,g);this.a.push(new F.$NC(g,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=S.$Jf(g)),this.k||(this.k=S.$Mf(g)))}finish(g=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const k=(0,F.$KC)(g.buffer);g.lineStarts=k,this.d===13&&this.f++}}}e.$QC=M}),define(Pe[97],Ae([1,0,22,21]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbb=g,e.$Qbb=N;var R;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(R||(R={}));function O(y){for(let l=0,b=y.length;l<b;l+=4){const m=y[l+0],s=y[l+1],o=y[l+2],r=y[l+3];y[l+0]=r,y[l+1]=o,y[l+2]=s,y[l+3]=m}}function M(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return F.$D()||O(l),S.$De.wrap(l)}function p(y){const l=y.buffer;if(F.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function g(y){const l=new Uint32Array(k(y));let b=0;if(l[b++]=y.id,y.type==="full")l[b++]=1,l[b++]=y.data.length,l.set(y.data,b),b+=y.data.length;else{l[b++]=2,l[b++]=y.deltas.length;for(const m of y.deltas)l[b++]=m.start,l[b++]=m.deleteCount,m.data?(l[b++]=m.data.length,l.set(m.data,b),b+=m.data.length):l[b++]=0}return M(l)}function k(y){let l=0;if(l+=2,y.type==="full")l+=1+y.data.length;else{l+=1,l+=3*y.deltas.length;for(const b of y.deltas)b.data&&(l+=b.data.length)}return l}function N(y){const l=p(y);let b=0;const m=l[b++];if(l[b++]===1){const t=l[b++],n=l.subarray(b,b+t);return b+=t,{id:m,type:"full",data:n}}const o=l[b++],r=[];for(let t=0;t<o;t++){const n=l[b++],c=l[b++],h=l[b++];let i;h>0&&(i=l.subarray(b,b+h),b+=h),r[t]={start:n,deleteCount:c,data:i}}return{id:m,type:"delta",deltas:r}}}),define(Pe[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[151],Ae([1,0,18,25,21,134,152,150]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=t,e.clampedFloat=c,e.stringSet=$,e.cursorStyleToString=w,e.filterValidationDecorations=ue;var g;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class y{constructor(Z,$e,Ge,ye){this.id=Z,this.name=$e,this.defaultValue=Ge,this.schema=ye}applyUpdate(Z,$e){return b(Z,$e)}compute(Z,$e,Ge){return Ge}}class l{constructor(Z,$e){this.newValue=Z,this.didChange=$e}}e.ApplyUpdateResult=l;function b(Y,Z){if(typeof Y!="object"||typeof Z!="object"||!Y||!Z)return new l(Z,Y!==Z);if(Array.isArray(Y)||Array.isArray(Z)){const Ge=Array.isArray(Y)&&Array.isArray(Z)&&S.$ub(Y,Z);return new l(Z,!Ge)}let $e=!1;for(const Ge in Z)if(Z.hasOwnProperty(Ge)){const ye=b(Y[Ge],Z[Ge]);ye.didChange&&(Y[Ge]=ye.newValue,$e=!0)}return new l(Y,$e)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,$e){return b(Z,$e)}validate(Z){return this.defaultValue}}class s{constructor(Z,$e,Ge,ye){this.id=Z,this.name=$e,this.defaultValue=Ge,this.schema=ye}applyUpdate(Z,$e){return b(Z,$e)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,$e,Ge){return Ge}}function o(Y,Z){return typeof Y>"u"?Z:Y==="false"?!1:!!Y}class r extends s{constructor(Z,$e,Ge,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=Ge),super(Z,$e,Ge,ye)}validate(Z){return o(Z,this.defaultValue)}}function t(Y,Z,$e,Ge){if(typeof Y>"u")return Z;let ye=parseInt(Y,10);return isNaN(ye)?Z:(ye=Math.max($e,ye),ye=Math.min(Ge,ye),ye|0)}class n extends s{static clampedInt(Z,$e,Ge,ye){return t(Z,$e,Ge,ye)}constructor(Z,$e,Ge,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ge,dt.minimum=ye,dt.maximum=ot),super(Z,$e,Ge,dt),this.minimum=ye,this.maximum=ot}validate(Z){return n.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(Y,Z,$e,Ge){if(typeof Y>"u")return Z;const ye=h.float(Y,Z);return h.clamp(ye,$e,Ge)}class h extends s{static clamp(Z,$e,Ge){return Z<$e?$e:Z>Ge?Ge:Z}static float(Z,$e){if(typeof Z=="number")return Z;if(typeof Z>"u")return $e;const Ge=parseFloat(Z);return isNaN(Ge)?$e:Ge}constructor(Z,$e,Ge,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ge),super(Z,$e,Ge,ot),this.validationFn=ye}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class i extends s{static string(Z,$e){return typeof Z!="string"?$e:Z}constructor(Z,$e,Ge,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=Ge),super(Z,$e,Ge,ye)}validate(Z){return i.string(Z,this.defaultValue)}}function $(Y,Z,$e,Ge){return typeof Y!="string"?Z:Ge&&Y in Ge?Ge[Y]:$e.indexOf(Y)===-1?Z:Y}class a extends s{constructor(Z,$e,Ge,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=Ge),super(Z,$e,Ge,ot),this.c=ye}validate(Z){return $(Z,this.defaultValue,this.c)}}class v extends y{constructor(Z,$e,Ge,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Z,$e,Ge,It),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function d(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class P extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,$e,Ge){return Ge===0?Z.accessibilitySupport:Ge}}class u extends y{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function f(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function w(Y){switch(Y){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(Y){switch(Y){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class I extends m{constructor(){super(142)}compute(Z,$e,Ge){const ye=["monaco-editor"];return $e.get(39)&&ye.push($e.get(39)),Z.extraEditorClassName&&ye.push(Z.extraEditorClassName),$e.get(74)==="default"?ye.push("mouse-default"):$e.get(74)==="copy"&&ye.push("mouse-copy"),$e.get(111)&&ye.push("showUnused"),$e.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class W extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,$e,Ge){return Ge&&Z.emptySelectionClipboard}}class V extends y{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":$($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":$($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,$e,Ge){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class j extends m{constructor(){super(50)}compute(Z,$e,Ge){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const $e=h.float(Z,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(Z,$e,Ge){return Z.fontInfo.fontSize}}class re extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(n.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ae extends y{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{multiple:$($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??$($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??$($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??$($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??$($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??$($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends y{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:n.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var Ie;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class de extends m{constructor(){super(145)}compute(Z,$e,Ge){return de.computeLayout($e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const $e=Z.height/Z.lineHeight,Ge=Math.floor(Z.paddingTop/Z.lineHeight);let ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ye=Math.max(ye,$e-1));const ot=(Ge+Z.viewLineCount+ye)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Z,$e){const Ge=Z.outerWidth,ye=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=$e.stableMinimapLayoutInput,It=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Qt=Z.lineHeight,Ut=Z.typicalHalfwidthCharacterWidth,xt=Z.scrollBeyondLastLine,_t=Z.minimap.renderCharacters;let Ct=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Wt=Z.minimap.maxColumn,Zt=Z.minimap.size,Ye=Z.minimap.side,si=Z.verticalScrollbarWidth,Yt=Z.viewLineCount,lt=Z.remainingWidth,bt=Z.isViewportWrapping,ti=_t?2:3;let Xt=Math.floor(ot*ye);const Lt=Xt/ot;let ft=!1,jt=!1,Bt=ti*Ct,qt=Ct/ot,He=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Ht,desiredRatio:ni,minimapLineCount:Ft}=de.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ye,lineHeight:Qt,pixelRatio:ot});if(Yt/Ft>1)ft=!0,jt=!0,Ct=1,Bt=1,qt=Ct/ot;else{let Pt=!1,Et=Ct+1;if(Zt==="fit"){const pt=Math.ceil((ii+Yt+Ht)*Bt);bt&&It&&lt<=$e.stableFitRemainingWidth?(Pt=!0,Et=$e.stableFitMaxMinimapScale):Pt=pt>Xt}if(Zt==="fill"||Pt){ft=!0;const pt=Ct;Bt=Math.min(Qt*ot,Math.max(1,Math.floor(1/ni))),bt&&It&&lt<=$e.stableFitRemainingWidth&&(Et=$e.stableFitMaxMinimapScale),Ct=Math.min(Et,Math.max(1,Math.floor(Bt/ti))),Ct>pt&&(He=Math.min(2,Ct/pt)),qt=Ct/ot/He,Xt=Math.ceil(Math.max(Ot,ii+Yt+Ht)*Bt),bt?($e.stableMinimapLayoutInput=Z,$e.stableFitRemainingWidth=lt,$e.stableFitMaxMinimapScale=Ct):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Wt*qt),Gt=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(Ut+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Gt);const gt=zt/ot;zt=Math.floor(zt*He);const Nt=_t?1:2,At=Ye==="left"?0:Ge-Gt-si;return{renderMinimap:Nt,minimapLeft:At,minimapWidth:Gt,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Ct,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Xt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,$e){const Ge=$e.outerWidth|0,ye=$e.outerHeight|0,ot=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,It=$e.typicalHalfwidthCharacterWidth,Qt=$e.maxDigitWidth,Ut=$e.pixelRatio,xt=$e.viewLineCount,_t=Z.get(137),Ct=_t==="inherit"?Z.get(136):_t,Wt=Ct==="inherit"?Z.get(132):Ct,Zt=Z.get(135),Ye=$e.isDominatedByLongLines,si=Z.get(57),Yt=Z.get(68).renderType!==0,lt=Z.get(69),bt=Z.get(105),ti=Z.get(84),Xt=Z.get(73),Lt=Z.get(103),ft=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,He=Z.get(43),ui=Z.get(110)!=="never";let Gt=Z.get(66);He&&ui&&(Gt+=16);let zt=0;if(Yt){const li=Math.max(dt,lt);zt=Math.round(li*Qt)}let gt=0;si&&(gt=ot*$e.glyphMarginDecorationLaneCount);let Nt=0,At=Nt+gt,Ot=At+zt,ii=Ot+Gt;const Ht=Ge-gt-zt-Gt;let ni=!1,Ft=!1,Rt=-1;Ct==="inherit"&&Ye?(ni=!0,Ft=!0):Wt==="on"||Wt==="bounded"?Ft=!0:Wt==="wordWrapColumn"&&(Rt=Zt);const Pt=de.c({outerWidth:Ge,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:bt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Xt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Ht,isViewportWrapping:Ft},$e.memory||new N);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Nt+=Pt.minimapWidth,At+=Pt.minimapWidth,Ot+=Pt.minimapWidth,ii+=Pt.minimapWidth);const Et=Ht-Pt.minimapWidth,pt=Math.max(1,Math.floor((Et-ft-2)/It)),St=jt?Bt:0;return Ft&&(Rt=Math.max(1,pt),Wt==="bounded"&&(Rt=Math.min(Rt,Zt))),{width:Ge,height:ye,glyphMarginLeft:Nt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:zt,decorationsLeft:Ot,decorationsWidth:Gt,contentLeft:ii,contentWidth:Et,minimap:Pt,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Ft,wrappingColumn:Rt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=de;class me extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return $(Z,"simple",["simple","advanced"])}compute(Z,$e,Ge){return $e.get(2)===2?"advanced":Ge}}var Me;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class ce extends y{constructor(){const Z={enabled:Me.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:$(Z.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class Re extends y{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends y{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:$($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class L extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):n.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,$e,Ge){return Ge<0?n.clampedInt(-Ge*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,$e,Ge){return Z.fontInfo.lineHeight}}class ve extends y{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:$($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:$($e.side,this.defaultValue.side,["right","left"]),showSlider:$($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt($e.scale,1,1,3),maxColumn:n.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Te(Y){return Y==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class ke extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{top:n.clampedInt($e.top,0,0,1e3),bottom:n.clampedInt($e.bottom,0,0,1e3)}}}class pe extends y{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(143)}compute(Z,$e,Ge){return Z.pixelRatio}}class Q extends y{constructor(){const Z={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:$e,default:Z.comments,description:p.localize(89,null)},other:{anyOf:$e,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ut=Z?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:$e,comments:Ge,strings:ye}=Z,ot=["on","inline","off"];let dt,It,Qt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=$($e,this.defaultValue.other,ot),typeof Ge=="boolean"?It=Ge?"on":"off":It=$(Ge,this.defaultValue.comments,ot),typeof ye=="boolean"?Qt=ye?"on":"off":Qt=$(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Qt}}}var X;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class le extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let $e=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?($e=4,Ge=Z):Z==="interval"?$e=3:Z==="relative"?$e=2:Z==="on"?$e=1:$e=0),{renderType:$e,renderFn:Ge}}}function ue(Y){const Z=Y.get(98);return Z==="editable"?Y.get(91):Z!=="on"}class Ne extends y{constructor(){const Z=[],$e={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const $e=[];for(const Ge of Z)if(typeof Ge=="number")$e.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const ye=Ge;$e.push({column:n.clampedInt(ye.column,0,0,1e4),color:ye.color})}return $e.sort((Ge,ye)=>Ge.column-ye.column),$e}return this.defaultValue}}class he extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(Y,Z){if(typeof Y!="string")return Z;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Fe extends y{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z,Ge=n.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=n.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt($e.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:n.clampedInt($e.verticalSliderSize,ye,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,$e){let Ge=!1;$e.allowedCharacters&&Z&&(F.$4n(Z.allowedCharacters,$e.allowedCharacters)||(Z={...Z,allowedCharacters:$e.allowedCharacters},Ge=!0)),$e.allowedLocales&&Z&&(F.$4n(Z.allowedLocales,$e.allowedLocales)||(Z={...Z,allowedLocales:$e.allowedLocales},Ge=!0));const ye=super.applyUpdate(Z,$e);return Ge?new l(ye.newValue,!0):ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,$e){if(typeof Z!="object"||!Z)return $e;const Ge={};for(const[ye,ot]of Object.entries(Z))ot===!0&&(Ge[ye]=!0);return Ge}}class U extends y{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:$($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily)}}}class z extends y{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends y{constructor(){const Z={enabled:O.$Zs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Zs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends y{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Y,Z,$e){const Ge=$e.indexOf(Y);return Ge===-1?Z:$e[Ge]}class ne extends y{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertMode:$($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:$($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Oe extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const $e=[];for(const Ge of Z)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&$e.push(Ge)}catch{}return $e}return this.defaultValue}}var Qe;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,$e,Ge){return $e.get(2)===2?0:Ge}}class et extends m{constructor(){super(146)}compute(Z,$e,Ge){const ye=$e.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:$($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:$($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?mt:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSegmenterLocales=130]="wordSegmenterLocales",Y[Y.wordSeparators=131]="wordSeparators",Y[Y.wordWrap=132]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=135]="wordWrapColumn",Y[Y.wordWrapOverride1=136]="wordWrapOverride1",Y[Y.wordWrapOverride2=137]="wordWrapOverride2",Y[Y.wrappingIndent=138]="wrappingIndent",Y[Y.wrappingStrategy=139]="wrappingStrategy",Y[Y.showDeprecated=140]="showDeprecated",Y[Y.inlayHints=141]="inlayHints",Y[Y.editorClassName=142]="editorClassName",Y[Y.pixelRatio=143]="pixelRatio",Y[Y.tabFocusMode=144]="tabFocusMode",Y[Y.layoutInfo=145]="layoutInfo",Y[Y.wrappingInfo=146]="wrappingInfo",Y[Y.defaultColorDecorators=147]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new P),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new v(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new H),bracketPairGuides:je(new G),stickyTabStops:je(new r(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new r(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new u),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new v(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new v(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new tt),stickyScroll:je(new Re),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:p.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new j),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new re),fontVariations:je(new A),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ae),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new be),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:p.localize(285,null)})),lightbulb:je(new ce),lineDecorationsWidth:je(new L),lineHeight:je(new x),lineNumbers:je(new le),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new r(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new r(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new r(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new v(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new r(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new ke),pasteAs:je(new it),parameterHints:je(new pe),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new r(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new r(91,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new r(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new r(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Ne),scrollbar:je(new Fe),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new r(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new r(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new r(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:je(new r(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new r(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new r(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ie),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Oe),smoothScrolling:je(new r(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new ne),inlineSuggest:je(new U),inlineEdit:je(new z),inlineCompletionsAccessibilityVerbose:je(new r(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new r(127,"useShadowDOM",!0)),useTabStops:je(new r(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new i(131,"wordSeparators",M.$1s,{description:p.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new I),defaultColorDecorators:je(new r(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new r(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new de),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new me)}}),define(Pe[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Pe[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Pe[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[187],Ae([1,0,14,155]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.TokenType=void 0;var R;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...k){switch(k.length){case 1:return(0,F.localize)(0,null,k[0]);case 2:return(0,F.localize)(1,null,k[0],k[1]);case 3:return(0,F.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,F.localize)(3,null),p=(0,F.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const y=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:y,lexeme:l,additionalInfo:N}),this.f.push(b)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const y=this.c.substring(this.d,this.e),l=g.b.get(y);l?this.k(l):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,y=!1,l=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(p);return}const m=this.c.charCodeAt(N);if(y)y=!1;else if(m===47&&!l){N++;break}else m===91?l=!0:m===92?y=!0:m===93&&(l=!1);N++}for(;N<this.c.length&&g.a.has(this.c.charCodeAt(N));)N++;this.e=N;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$oj=g}),define(Pe[188],Ae([1,0,23,33,157,300]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=g,e.$Ep=k,e.$Fp=N,e.$Gp=y,e.$Hp=l,e.$Ip=b,e.$Jp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function g(r){return r=r.trim(),r==="*"||M.test(r)}function k(r){if(!g(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(M);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function N(r){if(!r)return null;const t=r.majorBase,n=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const i=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(h=!1),$=!1);let a=0;if(r.preRelease){const v=p.exec(r.preRelease);if(v){const[,d,P,u]=v;a=Date.UTC(Number(d),Number(P)-1,Number(u))}}return{majorBase:t,majorMustEqual:n,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:a}}function y(r,t,n){let c;typeof r=="string"?c=N(k(r)):c=r;let h;t instanceof Date?h=t.getTime():typeof t=="string"&&(h=new Date(t).getTime());let i;if(typeof n=="string"?i=N(k(n)):i=n,!c||!i)return!1;const $=c.majorBase,a=c.minorBase,v=c.patchBase;let d=i.majorBase,P=i.minorBase,u=i.patchBase;const E=i.notBefore;let f=i.majorMustEqual,D=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?$>d?!0:$<d?!1:a>P?!0:a<P||h&&h<E?!1:v>=u:($===1&&d===0&&(!f||!D||!w)&&(d=1,P=0,u=0,f=!0,D=!1,w=!1),$<d?!1:$>d?!f:a<P?!1:a>P?!D:v<u?!1:v>u?!w:!(h&&h<E))}function l(r,t,n,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([F.default.Error,R.localize(0,null)]),i;if(typeof c.name!="string")return i.push([F.default.Error,R.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([F.default.Error,R.localize(2,null,"version")]),i;if(!c.engines)return i.push([F.default.Error,R.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([F.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([F.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([F.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([F.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([F.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([F.default.Error,R.localize(9,null,"main")]),i;{const v=(0,S.$7g)(n,c.main);(0,S.$1g)(v,n)||i.push([F.default.Warning,R.localize(10,null,v.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([F.default.Error,R.localize(11,null,"browser")]),i;{const v=(0,S.$7g)(n,c.browser);(0,S.$1g)(v,n)||i.push([F.default.Warning,R.localize(12,null,v.path,n.path)])}}if(!O.valid(c.version))return i.push([F.default.Error,R.localize(13,null)]),i;const $=[];if(!b(r,t,c,h,$))for(const v of $)i.push([F.default.Error,v]);return i}function b(r,t,n,c,h){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,t,n.engines.vscode,h)}function m(r,t,n){return r==="*"||s(t,n,r)}function s(r,t,n,c=[]){const h=N(k(n));if(!h)return c.push(R.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(R.localize(15,null,n)),!1}else if(!h.majorMustEqual)return c.push(R.localize(16,null,n)),!1;return y(r,t,h)?!0:(c.push(R.localize(17,null,r,n)),!1)}function o(r){if(!Array.isArray(r))return!1;for(let t=0,n=r.length;t<n;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Pe[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=void 0;class S{constructor(R,O=[],M=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$qi=S}),define(Pe[55],Ae([1,0,70]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ts=O,e.$us=M;const F=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function O(p,g,k){g instanceof S.$qi||(g=new S.$qi(g,[],!!k)),F.push([p,g])}function M(){return F}}),define(Pe[189],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;class S{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$0q=S;class F{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const p=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);p.outgoing.set(g.key,g),g.incoming.set(p.key,p)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let p=this.a.get(M);return p||(p=new S(M,O),this.a.set(M,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,p]of this.a)O.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const p=new Set([O]),g=this.c(M,p);if(g)return g}}c(O,M){for(const[p,g]of O.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const k=this.c(g,M);if(k)return k;M.delete(p)}}}e.$$q=F}),define(Pe[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e._util=void 0,e.$ti=R,e.$ui=O;var S;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(S||(e._util=S={})),e.$si=R("instantiationService");function F(M,p,g){p[S.DI_TARGET]===p?p[S.DI_DEPENDENCIES].push({id:M,index:g}):(p[S.DI_DEPENDENCIES]=[{id:M,index:g}],p[S.DI_TARGET]=p)}function R(M){if(S.serviceIds.has(M))return S.serviceIds.get(M);const p=function(g,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(p,g,N)};return p.toString=()=>M,S.serviceIds.set(M,p),p}function O(M){return M}}),define(Pe[48],Ae([1,0,17,2,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Zi=void 0,e.$1i=O,e.$2i=M,e.$3i=g,e.$4i=k,e.$5i=N,e.$6i=y,e.$7i=l,e.$8i=m,e.$9i=s,e.$0i=o,e.$Zi=(0,R.$ti)("configurationService");function O(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof F.URI)}function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof F.URI)}var p;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function g(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function N(r,t){const n=Object.create(null);for(const c in r)y(n,c,r[c],t);return n}function y(r,t,n,c){const h=t.split("."),i=h.pop();let $=r;for(let a=0;a<h.length;a++){const v=h[a];let d=$[v];switch(typeof d){case"undefined":d=$[v]=Object.create(null);break;case"object":if(d===null){c(`Ignoring ${t} as ${h.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${t} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(d)}`);return}$=d}if(typeof $=="object"&&$!==null)try{$[i]=n}catch{c(`Ignoring ${t} as ${h.join(".")} is ${JSON.stringify($)}`)}else c(`Ignoring ${t} as ${h.join(".")} is ${JSON.stringify($)}`)}function l(r,t){const n=t.split(".");b(r,n)}function b(r,t){const n=t.shift();if(t.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const c=r[n];typeof c=="object"&&!Array.isArray(c)&&(b(c,t),Object.keys(c).length===0&&delete r[n])}}function m(r,t,n){function c($,a){let v=$;for(const d of a){if(typeof v!="object"||v===null)return;v=v[d]}return v}const h=t.split("."),i=c(r,h);return typeof i>"u"?n:i}function s(r,t,n){Object.keys(t).forEach(c=>{c!=="__proto__"&&(c in r?S.$8f(r[c])&&S.$8f(t[c])?s(r[c],t[c],n):n&&(r[c]=t[c]):r[c]=t[c])})}function o(r){return r.replace(/[\[\]]/g,"")}}),define(Pe[31],Ae([1,0,21,15,187,3,154,14]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$rj=e.$qj=e.ContextKeyExprType=void 0,e.$pj=k,e.$sj=$,e.$tj=a,e.$Mj=Me;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",S.$j),g.set("isLinux",S.$k),g.set("isWindows",S.$i),g.set("isWeb",S.$o),g.set("isMacNative",S.$j&&!S.$o),g.set("isEdge",S.$H),g.set("isFirefox",S.$F),g.set("isChrome",S.$E),g.set("isSafari",S.$G);function k(ie,L){if(g.get(ie)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ie,L)}const N=Object.prototype.hasOwnProperty;var y;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const l={regexParsingWithErrorRecovery:!0},b=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),r=(0,M.localize)(4,null),t=(0,M.localize)(5,null),n=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=l){this.k=L,this.d=new R.$oj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Te=ve.type===17?t:void 0;throw this.h.push({message:r,offset:ve.offset,lexeme:R.$oj.getLexeme(ve),additionalInfo:Te}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const x=this.o();L.push(x)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const x=this.s();L.push(x)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),d.INSTANCE;case 12:return this.z(),P.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=L.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const ke=Te.lexeme,pe=ke.lastIndexOf("/"),fe=pe===ke.length-1?void 0:this.w(ke.substring(pe+1));let Q;try{Q=new RegExp(ke.substring(1,pe),fe)}catch{throw this.B("REGEX",Te)}return j.create(x,Q)}switch(Te.type){case 10:case 19:{const ke=[Te.lexeme];this.z();let pe=this.D(),fe=0;for(let Ne=0;Ne<Te.lexeme.length;Ne++)Te.lexeme.charCodeAt(Ne)===40?fe++:Te.lexeme.charCodeAt(Ne)===41&&fe--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Ne=0;Ne<pe.lexeme.length;Ne++)pe.lexeme.charCodeAt(Ne)===40?fe++:Te.lexeme.charCodeAt(Ne)===41&&fe--}if(fe<0)break;ke.push(R.$oj.getLexeme(pe)),this.z(),pe=this.D()}const Q=ke.join(""),X=Q.lastIndexOf("/"),le=X===Q.length-1?void 0:this.w(Q.substring(X+1));let ue;try{ue=new RegExp(Q.substring(1,X),le)}catch{throw this.B("REGEX",Te)}return i.regex(x,ue)}case 18:{const ke=Te.lexeme;this.z();let pe=null;if(!(0,F.$5e)(ke)){const fe=ke.indexOf("/"),Q=ke.lastIndexOf("/");if(fe!==Q&&fe>=0){const X=ke.slice(fe+1,Q),le=ke[Q+1]==="i"?"i":"";try{pe=new RegExp(X,le)}catch{throw this.B("REGEX",Te)}}}if(pe===null)throw this.B("REGEX",Te);return j.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Te=this.u();return i.notIn(x,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return i.equals(x,Te);switch(Te){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return i.notEquals(x,Te);switch(Te){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Te)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:n,offset:L.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,x){if(this.C(L))return this.z();throw this.B(x,this.D())}B(L,x,ve){const Te=(0,M.localize)(8,null,L,R.$oj.getLexeme(x)),ke=x.offset,pe=R.$oj.getLexeme(x);return this.h.push({message:Te,offset:ke,lexeme:pe,additionalInfo:ve}),h.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qj=h;class i{static false(){return d.INSTANCE}static true(){return P.INSTANCE}static has(L){return u.create(L)}static equals(L,x){return E.create(L,x)}static notEquals(L,x){return w.create(L,x)}static regex(L,x){return j.create(L,x)}static in(L,x){return f.create(L,x)}static notIn(L,x){return D.create(L,x)}static not(L){return C.create(L)}static and(...L){return ae.create(L,null,!0)}static or(...L){return be.create(L,null,!0)}static greater(L,x){return W.create(L,x)}static greaterEquals(L,x){return V.create(L,x)}static smaller(L,x){return q.create(L,x)}static smallerEquals(L,x){return A.create(L,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$rj=i;function $(ie){const L=new h({regexParsingWithErrorRecovery:!1});return ie.map(x=>(L.parse(x),L.lexingErrors.length>0?L.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,M.localize)(9,null,ve.additionalInfo):(0,M.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ie,L){const x=ie?ie.substituteConstants():void 0,ve=L?L.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function v(ie,L){return ie.cmp(L)}class d{static{this.INSTANCE=new d}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return P.INSTANCE}}e.$uj=d;class P{static{this.INSTANCE=new P}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return d.INSTANCE}}e.$vj=P;class u{static create(L,x=null){const ve=g.get(L);return typeof ve=="boolean"?ve?P.INSTANCE:d.INSTANCE:new u(L,x)}constructor(L,x){this.key=L,this.c=x,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:de(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=g.get(this.key);return typeof L=="boolean"?L?P.INSTANCE:d.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$wj=u;class E{static create(L,x,ve=null){if(typeof x=="boolean")return x?u.create(L,ve):C.create(L,ve);const Te=g.get(L);return typeof Te=="boolean"?x===(Te?"true":"false")?P.INSTANCE:d.INSTANCE:new E(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=g.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?P.INSTANCE:d.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$xj=E;class f{static create(L,x){return new f(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:me(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.f),ve=L.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?N.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$yj=f;class D{static create(L,x){return new D(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=11,this.c=f.create(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zj=D;class w{static create(L,x,ve=null){if(typeof x=="boolean")return x?C.create(L,ve):u.create(L,ve);const Te=g.get(L);return typeof Te=="boolean"?x===(Te?"true":"false")?d.INSTANCE:P.INSTANCE:new w(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=g.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?d.INSTANCE:P.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Aj=w;class C{static create(L,x=null){const ve=g.get(L);return typeof ve=="boolean"?ve?d.INSTANCE:P.INSTANCE:new C(L,x)}constructor(L,x){this.c=L,this.d=x,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=g.get(this.c);return typeof L=="boolean"?L?d.INSTANCE:P.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Bj=C;function I(ie,L){if(typeof ie=="string"){const x=parseFloat(ie);isNaN(x)||(ie=x)}return typeof ie=="string"||typeof ie=="number"?L(ie):d.INSTANCE}class W{static create(L,x,ve=null){return I(x,Te=>new W(L,Te,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Cj=W;class V{static create(L,x,ve=null){return I(x,Te=>new V(L,Te,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Dj=V;class q{static create(L,x,ve=null){return I(x,Te=>new q(L,Te,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ej=q;class A{static create(L,x,ve=null){return I(x,Te=>new A(L,Te,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Fj=A;class j{static create(L,x){return new j(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return x<ve?-1:x>ve?1:0}equals(L){if(L.type===this.type){const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return this.d===L.d&&x===ve}return!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Gj=j;class K{static create(L){return new K(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new K(this.c.map(L))}negate(){return this.c}}e.$Hj=K;function re(ie){let L=null;for(let x=0,ve=ie.length;x<ve;x++){const Te=ie[x].substituteConstants();if(ie[x]!==Te&&L===null){L=[];for(let ke=0;ke<x;ke++)L[ke]=ie[ke]}L!==null&&(L[x]=Te)}return L===null?ie:L}class ae{static create(L,x,ve){return ae.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Te=v(this.expr[x],L.expr[x]);if(Te!==0)return Te}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:ae.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(L))return!1;return!0}static d(L,x,ve){const Te=[];let ke=!1;for(const pe of L)if(pe){if(pe.type===1){ke=!0;continue}if(pe.type===0)return d.INSTANCE;if(pe.type===6){Te.push(...pe.expr);continue}Te.push(pe)}if(Te.length===0&&ke)return P.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(v);for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];for(;Te.length>1;){const pe=Te[Te.length-1];if(pe.type!==9)break;Te.pop();const fe=Te.pop(),Q=Te.length===0,X=be.create(pe.expr.map(le=>ae.create([le,fe],null,ve)),null,Q);X&&(Te.push(X),Te.sort(v))}if(Te.length===1)return Te[0];if(ve){for(let pe=0;pe<Te.length;pe++)for(let fe=pe+1;fe<Te.length;fe++)if(Te[pe].negate().equals(Te[fe]))return d.INSTANCE;if(Te.length===1)return Te[0]}return new ae(Te,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new ae(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());this.c=be.create(L,this,!0)}return this.c}}e.$Ij=ae;class be{static create(L,x,ve){return be.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Te=v(this.expr[x],L.expr[x]);if(Te!==0)return Te}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:be.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(L))return!0;return!1}static d(L,x,ve){let Te=[],ke=!1;if(L){for(let pe=0,fe=L.length;pe<fe;pe++){const Q=L[pe];if(Q){if(Q.type===0){ke=!0;continue}if(Q.type===1)return P.INSTANCE;if(Q.type===9){Te=Te.concat(Q.expr);continue}Te.push(Q)}}if(Te.length===0&&ke)return d.INSTANCE;Te.sort(v)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];if(ve){for(let pe=0;pe<Te.length;pe++)for(let fe=pe+1;fe<Te.length;fe++)if(Te[pe].negate().equals(Te[fe]))return P.INSTANCE;if(Te.length===1)return Te[0]}return new be(Te,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new be(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());for(;L.length>1;){const x=L.shift(),ve=L.shift(),Te=[];for(const ke of Re(x))for(const pe of Re(ve))Te.push(ae.create([ke,pe],null,!1));L.unshift(be.create(Te,null,!1))}this.c=be.create(L,this,!0)}return this.c}}e.$Jj=be;class Ie extends u{static{this.d=[]}static all(){return Ie.d.values()}constructor(L,x,ve){super(L,null),this.f=x,typeof ve=="object"?Ie.d.push({...ve,key:L}):ve!==!0&&Ie.d.push({key:L,description:ve,type:x!=null?typeof x:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return E.create(this.key,L)}notEqualsTo(L){return w.create(this.key,L)}}e.$Kj=Ie,e.$Lj=(0,O.$ti)("contextKeyService");function de(ie,L){return ie<L?-1:ie>L?1:0}function me(ie,L,x,ve){return ie<x?-1:ie>x?1:L<ve?-1:L>ve?1:0}function Me(ie,L){if(ie.type===0||L.type===1)return!0;if(ie.type===9)return L.type===9?ce(ie.expr,L.expr):!1;if(L.type===9){for(const x of L.expr)if(Me(ie,x))return!0;return!1}if(ie.type===6){if(L.type===6)return ce(L.expr,ie.expr);for(const x of ie.expr)if(Me(x,L))return!0;return!1}return ie.equals(L)}function ce(ie,L){let x=0,ve=0;for(;x<ie.length&&ve<L.length;){const Te=ie[x].cmp(L[ve]);if(Te<0)return!1;Te===0&&x++,ve++}return x===ie.length}function Re(ie){return ie.type===9?ie.expr:[ie]}}),define(Pe[190],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=void 0,e.$Ai=(0,S.$ti)("environmentService"),e.$Bi=(0,S.$ui)(e.$Ai)}),define(Pe[98],Ae([1,0,156,3]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.ExtensionGalleryErrorCode=e.$4o=e.ExtensionManagementErrorCode=e.$3o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Wo=R,e.$Xo=O,e.$Yo=M,e.$Zo=p,e.$1o=g,e.$2o=k,e.$Qo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ro=new RegExp(e.$Qo),e.$So="__web_extension",e.$To="skipWalkthrough",e.$Uo="extensionsSync",e.$Vo="dependecyOrPackExtensionInstall";function R(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,n){return n==="web"&&!t.includes("web")}function g(t,n,c){return p(n,c)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===c}function k(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var N;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$3o=(0,F.$ti)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$4o=s;var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$5o=r,e.$6o=(0,F.$ti)("extensionManagementService"),e.$7o="extensionsIdentifiers/disabled",e.$8o="extensionsIdentifiers/enabled",e.$9o=(0,F.$ti)("IGlobalExtensionEnablementService"),e.$0o=(0,F.$ti)("IExtensionTipsService"),e.$$o=(0,S.localize2)(0,"Extensions"),e.$_o=(0,S.localize2)(1,"Preferences")}),define(Pe[44],Ae([1,0,52,19,15,17,2,158,3,21,12,41]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$sl=e.FileKind=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.FileOperationResult=e.$kl=e.$jl=e.$il=e.$gl=e.FileChangeType=e.$fl=e.FileOperation=e.$_k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Zk=void 0,e.$1k=l,e.$2k=o,e.$3k=t,e.$4k=n,e.$5k=c,e.$6k=h,e.$7k=i,e.$8k=$,e.$9k=a,e.$0k=v,e.$$k=d,e.$al=E,e.$bl=f,e.$cl=D,e.$dl=w,e.$el=C,e.$hl=A,e.$tl=Ie,e.$ul=de,e.$wl=Me,e.$Zk=(0,g.$ti)("fileService");function l(ce){return ce.create===!0}var b;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var m;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})(m||(e.FilePermission=m={}));var s;(function(ce){ce[ce.UPDATED=2]="UPDATED",ce[ce.ADDED=4]="ADDED",ce[ce.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function o(ce){const Re=ce;return!!Re&&typeof Re.onDidChange=="function"}var r;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(r||(e.FileSystemProviderCapabilities=r={}));function t(ce){return!!(ce.capabilities&2)}function n(ce){return!!(ce.capabilities&8)}function c(ce){return!!(ce.capabilities&131072)}function h(ce){return!!(ce.capabilities&4)}function i(ce){return!!(ce.capabilities&16)}function $(ce){return t(ce)?!!(ce.capabilities&16384):!1}function a(ce){return t(ce)?!!(ce.capabilities&32768):!1}function v(ce){return!!(ce.capabilities&65536)}function d(ce){return!!(ce.capabilities&2048)}var P;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(P||(e.FileSystemProviderErrorCode=P={}));class u extends Error{static create(Re,ie){const L=new u(Re.toString(),ie);return D(L,ie),L}constructor(Re,ie){super(Re),this.code=ie}}e.$_k=u;function E(ce,Re){return u.create(ce,Re)}function f(ce){return ce||E((0,p.localize)(0,null),P.Unknown)}function D(ce,Re){return ce.name=Re?`${Re} (FileSystemError)`:"FileSystemError",ce}function w(ce){if(!ce)return P.Unknown;if(ce instanceof u)return ce.code;const Re=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!Re)return P.Unknown;switch(Re[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}function C(ce){if(ce instanceof j)return ce.fileOperationResult;switch(w(ce)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 9;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileTooLarge:return 7;default:return 10}}var I;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class W{constructor(Re,ie,L){this.resource=Re,this.operation=ie,this.target=L}isOperation(Re){return this.operation===Re}}e.$fl=W;var V;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Re,ie){this.c=ie,this.b=void 0,this.d=new y.$V(()=>{const L=S.$zi.forUris(()=>this.c);return L.fill(this.rawAdded.map(x=>[x,!0])),L}),this.f=new y.$V(()=>{const L=S.$zi.forUris(()=>this.c);return L.fill(this.rawUpdated.map(x=>[x,!0])),L}),this.g=new y.$V(()=>{const L=S.$zi.forUris(()=>this.c);return L.fill(this.rawDeleted.map(x=>[x,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of Re){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==q.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Re,...ie){return this.h(Re,{includeChildren:!1},...ie)}affects(Re,...ie){return this.h(Re,{includeChildren:!0},...ie)}h(Re,ie,...L){if(!Re)return!1;const x=L.length>0;return!!((!x||L.includes(1))&&(this.d.value.get(Re)||ie.includeChildren&&this.d.value.findSuperstr(Re))||(!x||L.includes(0))&&(this.f.value.get(Re)||ie.includeChildren&&this.f.value.findSuperstr(Re))||(!x||L.includes(2))&&(this.g.value.findSubstr(Re)||ie.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$gl=q;function A(ce,Re,ie){return!ce||!Re||ce===Re||Re.length>ce.length?!1:(Re.charAt(Re.length-1)!==F.sep&&(Re+=F.sep),ie?(0,R.$wf)(ce,Re):ce.indexOf(Re)===0)}class j extends Error{constructor(Re,ie,L){super(Re),this.fileOperationResult=ie,this.options=L}}e.$il=j;class K extends j{constructor(Re,ie,L,x){super(Re,ie,x),this.fileOperationResult=ie,this.size=L}}e.$jl=K;class re extends j{constructor(Re,ie,L){super(Re,2,L),this.stat=ie}}e.$kl=re;var ae;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$ll={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ml={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$nl="files.associations",e.$ol="files.exclude",e.$pl="files.readonlyInclude",e.$ql="files.readonlyExclude",e.$rl="files.readonlyFromPermissions";var be;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(be||(e.FileKind=be={})),e.$sl="";function Ie(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}async function de(ce,Re){if(!Re.hasProvider(M.URI.from({scheme:ce.scheme})))return new Promise(ie=>{const L=Re.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ce.scheme&&x.added&&(L.dispose(),ie())})})}class me{static{this.KB=1024}static{this.MB=me.KB*me.KB}static{this.GB=me.MB*me.KB}static{this.TB=me.GB*me.KB}static formatSize(Re){return(0,O.$0f)(Re)||(Re=0),Re<me.KB?(0,p.localize)(1,null,Re.toFixed(0)):Re<me.MB?(0,p.localize)(2,null,(Re/me.KB).toFixed(2)):Re<me.GB?(0,p.localize)(3,null,(Re/me.MB).toFixed(2)):Re<me.TB?(0,p.localize)(4,null,(Re/me.GB).toFixed(2)):(0,p.localize)(5,null,(Re/me.TB).toFixed(2))}}e.$vl=me;function Me(ce){const Re=typeof ce=="string"||ce?.scheme===N.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===N.Schemas.file?1024*me.MB:Re?10*me.MB:k.$o?50*me.MB:1024*me.MB}}),define(Pe[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=void 0;class S{constructor(...R){this.a=new Map;for(const[O,M]of R)this.set(O,M)}set(R,O){const M=this.a.get(R);return this.a.set(R,O),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ri=S}),define(Pe[191],Ae([1,0,11,14,6,70,189,3,71,192]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;const N=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$ri,r=!1,t,n=N){this.i=o,this.j=r,this.k=t,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$si,this),this._globalGraph=n?t?._globalGraph??new M.$$q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const r=new class extends l{dispose(){this.h.delete(r),super.dispose()}}(o,this.j,this,this.l);return this.h.add(r),r}invokeFunction(o,...r){this.m();const t=m.traceInvocation(this.l,o);let n=!1;try{return o({get:h=>{if(n)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(h,t);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...r)}finally{n=!0,t.stop()}}createInstance(o,...r){this.m();let t,n;return o instanceof O.$qi?(t=m.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(r),t)):(t=m.traceCreation(this.l,o),n=this.o(o,r,t)),t.stop(),n}o(o,r=[],t){const n=p._util.getServiceDependencies(o).sort((i,$)=>i.index-$.index),c=[];for(const i of n){const $=this.s(i.id,t);$||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push($)}const h=n.length>0?n[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${r.length} static arguments`);const i=h-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,h)}return Reflect.construct(o,r.concat(c))}q(o,r){if(this.i.get(o)instanceof O.$qi)this.i.set(o,r);else if(this.k)this.k.q(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const r=this.i.get(o);return!r&&this.k?this.k.r(o):r}s(o,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const t=this.r(o);return t instanceof O.$qi?this.u(o,t,r.branch(o,!0)):(r.branch(o,!1),t)}u(o,r,t){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,r,t)}finally{this.t.delete(o)}}v(o,r,t){const n=new M.$$q(i=>i.id.toString());let c=0;const h=[{id:o,desc:r,_trace:t}];for(;h.length;){const i=h.pop();if(n.lookupOrInsertNode(i),c++>1e3)throw new y(n);for(const $ of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r($.id);if(a||this.y(`[createInstance] ${o} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String($.id)),a instanceof O.$qi){const v={id:$.id,desc:a,_trace:i._trace.branch($.id,!0)};n.insertEdge(i,v),h.push(v)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new y(n);break}for(const{data:$}of i){if(this.r($.id)instanceof O.$qi){const v=this.w($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.q($.id,v)}n.removeNode($)}}return this.r(o)}w(o,r,t=[],n,c){if(this.i.get(o)instanceof O.$qi)return this.x(o,r,t,n,c,this.g);if(this.k)return this.k.w(o,r,t,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}x(o,r,t=[],n,c,h){if(n){const i=new l(void 0,this.j,this,this.l);i.c=String(o);const $=new Map,a=new S.$Mh(()=>{const v=i.o(r,t,c);for(const[d,P]of $){const u=v[d];if(typeof u=="function")for(const E of P)E.disposable=u.apply(v,E.listener)}return $.clear(),h.add(v),v});return new Proxy(Object.create(null),{get(v,d){if(!a.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let E=$.get(d);return E||(E=new k.$6c,$.set(d,E)),(D,w,C)=>{if(a.isInitialized)return a.value[d](D,w,C);{const I={listener:[D,w,C],disposable:void 0},W=E.push(I);return(0,R.$Tc)(()=>{W(),I.disposable?.dispose()})}}}if(d in v)return v[d];const P=a.value;let u=P[d];return typeof u!="function"||(u=u.bind(P),v[d]=u),u},set(v,d,P){return a.value[d]=P,!0},getPrototypeOf(v){return r.prototype}})}else{const i=this.o(r,t,c);return h.add(i),i}}y(o,r){if(r&&console.warn(o),this.j)throw new Error(o)}}e.$_q=l;var b;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(b||(b={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,r){return o?new m(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,r){return o?new m(1,r.name):m.c}static{this.f=0}constructor(o,r){this.type=o,this.name=r,this.g=Date.now(),this.h=[]}branch(o,r){const t=new m(3,o.toString());return this.h.push([o,r,t]),t}stop(){const o=Date.now()-this.g;m.f+=o;let r=!1;function t(c,h){const i=[],$=new Array(c+1).join("	");for(const[a,v,d]of h.h)if(v&&d){r=!0,i.push(`${$}CREATES -> ${a}`);const P=t(c+1,d);P&&i.push(P)}else i.push(`${$}uses -> ${a}`);return i.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${t(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||r)&&m.all.add(n.join(`
`))}}e.$ar=m}),define(Pe[13],Ae([1,0,159,43,5,99,6,28,21,23,17,2,31,3]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$3j=e.LogLevel=e.$1j=e.$Zj=void 0,e.$2j=s,e.log=r,e.$bk=u,e.$ck=E,e.$dk=f,e.$ek=D,e.$Zj=(0,b.$ti)("logService"),e.$1j=(0,b.$ti)("loggerService");function m(){return new Date().toISOString()}function s(w){return(0,N.$0f)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$3j=o.Info;function r(w,C,I){switch(C){case o.Trace:w.trace(I);break;case o.Debug:w.debug(I);break;case o.Info:w.info(I);break;case o.Warning:w.warn(I);break;case o.Error:w.error(I);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function t(w,C=!1){let I="";for(let W=0;W<w.length;W++){let V=w[W];if(V instanceof Error&&(V=(0,F.$ej)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(W>0?" ":"")+V}return I}class n extends M.$Vc{constructor(){super(...arguments),this.b=e.$3j,this.c=this.B(new R.$ce),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$5j=n;class c extends n{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(o.Trace)&&this.g(o.Trace,t([C,...I],!0))}debug(C,...I){this.f(o.Debug)&&this.g(o.Debug,t([C,...I]))}info(C,...I){this.f(o.Info)&&this.g(o.Info,t([C,...I]))}warn(C,...I){this.f(o.Warning)&&this.g(o.Warning,t([C,...I]))}error(C,...I){if(this.f(o.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(o.Error,t(W))}else this.g(o.Error,t([C,...I]))}flush(){}}e.$6j=c;class h extends n{constructor(C=e.$3j){super(),this.setLevel(C),this.g=!g.$i}trace(C,...I){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...I):console.log(`[main ${m()}]`,C,...I))}debug(C,...I){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...I):console.log(`[main ${m()}]`,C,...I))}info(C,...I){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...I):console.log(`[main ${m()}]`,C,...I))}warn(C,...I){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...I):console.warn(`[main ${m()}]`,C,...I))}error(C,...I){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...I):console.error(`[main ${m()}]`,C,...I))}flush(){}}e.$7j=h;class i extends n{constructor(C=e.$3j,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$8j=i;class $ extends n{constructor(C,I=e.$3j){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...I])}debug(C,...I){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...I])}info(C,...I){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...I])}warn(C,...I){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...I])}error(C,...I){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,F.$ej)(C,this.f(o.Trace))}flush(){}}e.$9j=$;class a extends n{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const W of this.g)W.trace(C,...I)}debug(C,...I){for(const W of this.g)W.debug(C,...I)}info(C,...I){for(const W of this.g)W.info(C,...I)}warn(C,...I){for(const W of this.g)W.warn(C,...I)}error(C,...I){for(const W of this.g)W.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$0j=a;class v extends M.$Vc{constructor(C,I,W){if(super(),this.h=C,this.j=I,this.b=new p.$Bc,this.c=this.B(new R.$ce),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$ce),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$ce),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,N.$6f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const W=this.n(C),V=(0,N.$6f)(C)?C:I?.id??(0,O.$hj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=I?.logLevel==="always"?o.Trace:I?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...I,id:V}));const j={logger:q,info:{resource:W,id:V,logLevel:A,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(j.info),this.b.set(W,j),q}n(C){return(0,N.$6f)(C)?(0,k.$7g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(y.URI.isUri(C)){const W=C,V=I,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const W=this.m(C);W&&I!==!W.info.hidden&&(W.info.hidden=!I,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$$j=v;class d{constructor(){this.onDidChangeLogLevel=new R.$ce().event}setLevel(C){}getLevel(){return o.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$_j=d;class P extends d{}e.$ak=P;function u(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const C=D(w.logLevel.toLowerCase());if(C!==void 0)return C}return e.$3j}function E(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(w){switch(w){case o.Trace:return{original:"Trace",value:S.localize(0,null)};case o.Debug:return{original:"Debug",value:S.localize(1,null)};case o.Info:return{original:"Info",value:S.localize(2,null)};case o.Warning:return{original:"Warning",value:S.localize(3,null)};case o.Error:return{original:"Error",value:S.localize(4,null)};case o.Off:return{original:"Off",value:S.localize(5,null)}}}function D(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$fk=new l.$Kj("logLevel",E(o.Info))}),define(Pe[193],Ae([1,0,6,13]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=void 0;class R extends S.$Vc{constructor(M,p=[]){super(),this.a=new F.$0j([M,...p]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$FQ=R}),define(Pe[100],Ae([1,0,33,160,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function k(m,s){return s-m}g.compare=k;const N=Object.create(null);N[g.Error]=(0,F.localize)(0,null),N[g.Warning]=(0,F.localize)(1,null),N[g.Info]=(0,F.localize)(2,null);function y(m){return N[m]||""}g.toString=y;function l(m){switch(m){case S.default.Error:return g.Error;case S.default.Warning:return g.Warning;case S.default.Info:return g.Info;case S.default.Ignore:return g.Hint}}g.fromSeverity=l;function b(m){switch(m){case g.Error:return S.default.Error;case g.Warning:return S.default.Warning;case g.Info:return S.default.Info;case g.Hint:return S.default.Ignore}}g.toSeverity=b}(M||(e.MarkerSeverity=M={}));var p;(function(g){const k="";function N(l){return y(l,!0)}g.makeKey=N;function y(l,b){const m=[k];return l.source?m.push(l.source.replace("\xA6","\\\xA6")):m.push(k),l.code?typeof l.code=="string"?m.push(l.code.replace("\xA6","\\\xA6")):m.push(l.code.value.replace("\xA6","\\\xA6")):m.push(k),l.severity!==void 0&&l.severity!==null?m.push(M.toString(l.severity)):m.push(k),l.message&&b?m.push(l.message.replace("\xA6","\\\xA6")):m.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?m.push(l.startLineNumber.toString()):m.push(k),l.startColumn!==void 0&&l.startColumn!==null?m.push(l.startColumn.toString()):m.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?m.push(l.endLineNumber.toString()):m.push(k),l.endColumn!==void 0&&l.endColumn!==null?m.push(l.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}g.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$Yt=(0,R.$ti)("markerService")}),define(Pe[194],Ae([1,0,5,33,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2v=e.$1v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Yv=e.Severity=void 0,e.$Zv=p,e.Severity=F.default,e.$Yv=(0,R.$ti)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const l=y;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var g;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class k{constructor(){this.progress=new N,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$1v=k;class N{infinite(){}done(){}total(l){}worked(l){}}e.$2v=N}),define(Pe[195],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$gk=(0,S.$ti)("productService"),e.$hk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,S,F){var R=arguments.length,O=R<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,S,F);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(O=(R<3?M(O):R>3?M(e,S,O):M(e,S))||O);return R>3&&O&&Object.defineProperty(e,S,O),O},We=this&&this.__param||function(ge,e){return function(S,F){e(S,F,ge)}};define(Pe[101],Ae([1,0,11,24,6,3]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.ProgressLocation=e.$3v=void 0,e.$3v=(0,O.$ti)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$4v=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$5v=p;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$6v=g;let k=class extends R.$Vc{constructor(l,b){super(),this.a=new S.$Qh,b.withProgress(l,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Tc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$7v=k,e.$7v=k=Je([We(1,e.$3v)],k);class N extends R.$Vc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new R.$Uc)}start(l){this.stop();const b=++this.a,m=new F.$ne;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,R.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Tc)(()=>m.cancel())),this.b.add((0,R.$Tc)(()=>this.c?this.c.done():void 0)),{id:b,token:m.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$8v=N,e.$9v=(0,O.$ti)("editorProgressService")}),define(Pe[30],Ae([1,0,56,17]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class R{constructor(){this.a=new Map}add(M,p){S.ok(F.$6f(M)),S.ok(F.$8f(p)),S.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$_n=new R}),define(Pe[72],Ae([1,0,5,30]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=void 0,e.$ao={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new S.$ce,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,k){this.a[R(g)]=k,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;F.$_n.add(e.$ao.JSONContribution,M)}),define(Pe[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.ConfigurationScope=e.$eo=e.EditPresentationTypes=void 0,e.$po=s,e.$qo=o,e.$ro=r,e.$so=n,e.$to=c;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$eo={Configuration:"base.contributions.configuration"};var N;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo="vscode://schemas/settings/resourceLanguage",e.$mo="vscode://schemas/settings/configurationDefaults";const y=g.$_n.as(p.$ao.JSONContribution);class l{constructor(){this.h=new Set,this.i=new F.$ce,this.onDidSchemaChange=this.i.event,this.j=new F.$ce,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$lo,this.g),this.v()}registerConfiguration(i,$=!0){this.registerConfigurations([i],$)}registerConfigurations(i,$=!0){const a=new Set;this.n(i,$,a),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const $=new Set;this.o(i,$),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:$})}updateConfigurations({add:i,remove:$}){const a=new Set;this.o($,a),this.n(i,!1,a),y.registerSchema(e.$lo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const $=new Set;this.k(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}k(i,$){const a=[];for(const{overrides:v,source:d}of i)for(const P in v)if($.add(P),e.$oo.test(P)){const u=this.a.get(P),E=u?.valuesSources??new Map;if(d)for(const C of Object.keys(v[P]))E.set(C,d);const f={...u?.value||{},...v[P]};this.a.set(P,{source:d,value:f,valuesSources:E});const D=(0,M.$0i)(P),w={type:"object",default:f,description:O.localize(1,null,D),$ref:e.$lo,defaultDefaultValue:f,source:R.$6f(d)?void 0:d,defaultValueSource:d};a.push(...s(P)),this.d[P]=w,this.b.properties[P]=w}else{this.a.set(P,{value:v[P],source:d});const u=this.d[P];u&&(this.w(P,u),this.r(P,u))}this.m(a)}deregisterDefaultConfigurations(i){const $=new Set;this.l(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}l(i,$){for(const{overrides:a,source:v}of i)for(const d in a){const P=this.a.get(d),u=R.$6f(v)?v:v?.id,E=R.$6f(P?.source)?P?.source:P?.source?.id;if(u===E)if($.add(d),this.a.delete(d),e.$oo.test(d))delete this.d[d],delete this.b.properties[d];else{const f=this.d[d];f&&(this.w(d,f),this.r(d,f))}}this.u()}deltaConfiguration(i){let $=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),$=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),$=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:$})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const $ of i)this.h.add($);this.u()}n(i,$,a){i.forEach(v=>{this.p(v,$,v.extensionInfo,v.restrictedProperties,void 0,a),this.c.push(v),this.q(v)})}o(i,$){const a=v=>{if(v.properties)for(const d in v.properties){$.add(d);const P=this.d[d];P?.policy?.name&&this.e.delete(P.policy.name),delete this.d[d],this.s(d,v.properties[d])}v.allOf?.forEach(d=>a(d))};for(const v of i){a(v);const d=this.c.indexOf(v);d!==-1&&this.c.splice(d,1)}}p(i,$=!0,a,v,d=3,P){d=R.$cg(i.scope)?d:i.scope;const u=i.properties;if(u)for(const f in u){const D=u[f];if($&&n(f,D)){delete u[f];continue}if(D.source=a,D.defaultDefaultValue=u[f].default,this.w(f,D),e.$oo.test(f)?D.scope=void 0:(D.scope=R.$cg(D.scope)?d:D.scope,D.restricted=R.$cg(D.restricted)?!!v?.includes(f):D.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.f[f]=u[f],delete u[f];continue}else this.d[f]=u[f],u[f].policy?.name&&this.e.set(u[f].policy.name,f);!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),P.add(f)}const E=i.allOf;if(E)for(const f of E)this.p(f,$,a,v,d,P)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const $=a=>{const v=a.properties;if(v)for(const P in v)this.r(P,v[P]);a.allOf?.forEach($)};$(i)}r(i,$){switch(e.$fo.properties[i]=$,$.scope){case 1:e.$go.properties[i]=$;break;case 2:e.$ho.properties[i]=$;break;case 6:e.$io.properties[i]=$;break;case 3:e.$jo.properties[i]=$;break;case 4:e.$ko.properties[i]=$;break;case 5:e.$ko.properties[i]=$,this.g.properties[i]=$;break}}s(i,$){switch(delete e.$fo.properties[i],$.scope){case 1:delete e.$go.properties[i];break;case 2:delete e.$ho.properties[i];break;case 6:delete e.$io.properties[i];break;case 3:delete e.$jo.properties[i];break;case 4:case 5:delete e.$ko.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const $=`[${i}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$lo};this.w($,a),e.$fo.properties[$]=a,e.$go.properties[$]=a,e.$ho.properties[$]=a,e.$io.properties[$]=a,e.$jo.properties[$]=a,e.$ko.properties[$]=a}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$lo};e.$fo.patternProperties[e.$no]=i,e.$go.patternProperties[e.$no]=i,e.$ho.patternProperties[e.$no]=i,e.$io.patternProperties[e.$no]=i,e.$jo.patternProperties[e.$no]=i,e.$ko.patternProperties[e.$no]=i,this.i.fire()}w(i,$){const a=this.a.get(i);let v=a?.value,d=a?.source;R.$ag(v)&&(v=$.defaultDefaultValue,d=void 0),R.$ag(v)&&(v=r($.type)),$.default=v,$.defaultValueSource=d}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.$no=`^(${b})+$`,e.$oo=new RegExp(e.$no);function s(h){const i=[];if(e.$oo.test(h)){let $=m.exec(h);for(;$?.length;){const a=$[1].trim();a&&i.push(a),$=m.exec(h)}}return(0,S.$Mb)(i)}function o(h){return h.reduce((i,$)=>`${i}[${$}]`,"")}function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const t=new l;g.$_n.add(e.$eo.Configuration,t);function n(h,i){return h.trim()?e.$oo.test(h)?O.localize(7,null,h):t.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&t.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,t.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function c(){const h=[],i=t.getConfigurationProperties();for(const $ of Object.keys(i))h.push([$,i[$].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[196],Ae([1,0,18,5,123,6,28,25,17,2,48,57,30]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$yo=n;function b($){return Object.isFrozen($)?$:p.$1n($)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,v,d,P,u){this.b=a,this.c=v,this.d=d,this.raw=P,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(v=>{if(v instanceof m)return v;const d=new s("",this.f);return d.parseRaw(v),d.configurationModel});this.g=a.reduce((v,d)=>d===v?d:v.merge(d),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,N.$8i)(this.contents,a):this.contents}inspect(a,v){const d=this;return{get value(){return b(d.rawConfiguration.getValue(a))},get override(){return v?b(d.rawConfiguration.getOverrideValue(a,v)):void 0},get merged(){return b(v?d.rawConfiguration.override(v).getValue(a):d.rawConfiguration.getValue(a))},get overrides(){const P=[];for(const{contents:u,identifiers:E,keys:f}of d.rawConfiguration.overrides){const D=new m(u,f,[],void 0,d.f).getValue(a);D!==void 0&&P.push({identifiers:E,value:D})}return P.length?b(P):void 0}}}getOverrideValue(a,v){const d=this.j(v);return d?a?(0,N.$8i)(d,a):d:void 0}getKeysForOverrideIdentifier(a){const v=[];for(const d of this.overrides)d.identifiers.includes(a)&&v.push(...d.keys);return S.$Mb(v)}getAllOverrideIdentifiers(){const a=[];for(const v of this.overrides)a.push(...v.identifiers);return S.$Mb(a)}override(a){let v=this.a.get(a);return v||(v=this.h(a),this.a.set(a,v)),v}merge(...a){const v=p.$Zn(this.contents),d=p.$Zn(this.overrides),P=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const E of a)if(u.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.i(v,E.contents);for(const f of E.overrides){const[D]=d.filter(w=>S.$ub(w.identifiers,f.identifiers));D?(this.i(D.contents,f.contents),D.keys.push(...f.keys),D.keys=S.$Mb(D.keys)):d.push(p.$Zn(f))}for(const f of E.keys)P.indexOf(f)===-1&&P.push(f)}return new m(v,P,d,u.every(E=>E instanceof m)?void 0:u,this.f)}h(a){const v=this.j(a);if(!v||typeof v!="object"||!Object.keys(v).length)return this;const d={};for(const P of S.$Mb([...Object.keys(this.contents),...Object.keys(v)])){let u=this.contents[P];const E=v[P];E&&(typeof u=="object"&&typeof E=="object"?(u=p.$Zn(u),this.i(u,E)):u=E),d[P]=u}return new m(d,this.keys,this.overrides,void 0,this.f)}i(a,v){for(const d of Object.keys(v)){if(d in a&&g.$8f(a[d])&&g.$8f(v[d])){this.i(a[d],v[d]);continue}a[d]=p.$Zn(v[d])}}j(a){let v=null,d=null;const P=u=>{u&&(d?this.i(d,u):d=p.$Zn(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===a?v=u.contents:u.identifiers.includes(a)&&P(u.contents);return P(v),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,v){this.k(a,v,!0)}setValue(a,v){this.k(a,v,!1)}removeValue(a){const v=this.keys.indexOf(a);v!==-1&&(this.keys.splice(v,1),(0,N.$7i)(this.contents,a),y.$oo.test(a)&&this.overrides.splice(this.overrides.findIndex(d=>S.$ub(d.identifiers,(0,y.$po)(a))),1))}k(a,v,d){(0,N.$6i)(this.contents,a,v,P=>this.f.error(P)),d=d||this.keys.indexOf(a)===-1,d&&this.keys.push(a),y.$oo.test(a)&&this.overrides.push({identifiers:(0,y.$po)(a),keys:Object.keys(this.contents[a]),contents:(0,N.$5i)(this.contents[a],P=>this.f.error(P))})}}e.$uo=m;class s{constructor(a,v){this.f=a,this.g=v,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,v){if(!g.$cg(a)){const d=this.h(a);this.parseRaw(d,v)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,v){this.a=a;const{contents:d,keys:P,overrides:u,restricted:E,hasExcludedProperties:f}=this.i(a,v);this.b=new m(d,P,u,f?[a]:void 0,this.g),this.c=E||[]}h(a){let v={},d=null,P=[];const u=[],E=[];function f(w){Array.isArray(P)?P.push(w):d!==null&&(P[d]=w)}const D={onObjectBegin:()=>{const w={};f(w),u.push(P),P=w,d=null},onObjectProperty:w=>{d=w},onObjectEnd:()=>{P=u.pop()},onArrayBegin:()=>{const w=[];f(w),u.push(P),P=w,d=null},onArrayEnd:()=>{P=u.pop()},onLiteralValue:f,onError:(w,C,I)=>{E.push({error:w,offset:C,length:I})}};if(a)try{R.$Nn(a,D),v=P[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return v}i(a,v){const d=l.$_n.as(y.$eo.Configuration).getConfigurationProperties(),P=this.j(a,d,!0,v);a=P.raw;const u=(0,N.$5i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),E=Object.keys(a),f=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:u,keys:E,overrides:f,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(a,v,d,P){let u=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:u};const E={},f=[];for(const D in a)if(y.$oo.test(D)&&d){const w=this.j(a[D],v,!1,P);E[D]=w.raw,u=u||w.hasExcludedProperties,f.push(...w.restricted)}else{const w=v[D],C=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&f.push(D),!P.exclude?.includes(D)&&(P.include?.includes(D)||(C===void 0||P.scopes===void 0||P.scopes.includes(C))&&!(P.skipRestricted&&w?.restricted))?E[D]=a[D]:u=!0}return{raw:E,restricted:f,hasExcludedProperties:u}}l(a,v){const d=[];for(const P of Object.keys(a))if(y.$oo.test(P)){const u={};for(const E in a[P])u[E]=a[P][E];d.push({identifiers:(0,y.$po)(P),keys:Object.keys(u),contents:(0,N.$5i)(u,v)})}return d}}e.$vo=s;class o extends O.$Vc{constructor(a,v,d,P,u){super(),this.c=a,this.f=v,this.g=P,this.h=u,this.b=this.B(new F.$ce),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),u),this.B(this.g.watch(d.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&d.isEqual(E.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$wo=o;class r{constructor(a,v,d,P,u,E,f,D,w,C,I,W,V){this.a=a,this.b=v,this.c=d,this.overrideIdentifiers=P,this.d=u,this.f=E,this.g=f,this.h=D,this.i=w,this.j=C,this.k=I,this.l=W,this.m=V}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(a,v,d,P,u,E,f,D,w,C){this.j=a,this.l=v,this.m=d,this.n=P,this.p=u,this.q=E,this.r=f,this.s=D,this.t=w,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,v,d){return this.w(a,v,d).getValue(a)}updateValue(a,v,d={}){let P;d.resource?(P=this.t.get(d.resource),P||(P=m.createEmptyModel(this.u),this.t.set(d.resource,P))):P=this.s,v===void 0?P.removeValue(a):P.setValue(a,v),d.resource||(this.h=null)}inspect(a,v,d){const P=this.w(a,v,d),u=this.A(v.resource,d),E=v.resource?this.t.get(v.resource)||this.s:this.s,f=new Set;for(const D of P.overrides)for(const w of D.identifiers)P.getOverrideValue(a,w)!==void 0&&f.add(w);return new r(a,v,P.getValue(a),f.size?[...f]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this.q:void 0,u||void 0,E)}keys(a){const v=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:v?v.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,v){this.r.set(a,v),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,v){const d=[];if(!v){const{added:P,updated:u,removed:E}=h(this.j,a);v=[...P,...u,...E]}for(const P of v)for(const u of(0,y.$po)(P)){const E=this.j.getKeysForOverrideIdentifier(u),f=a.getKeysForOverrideIdentifier(u),D=[...f.filter(w=>E.indexOf(w)===-1),...E.filter(w=>f.indexOf(w)===-1),...E.filter(w=>!p.$4n(this.j.override(u).getValue(w),a.override(u).getValue(w)))];d.push([u,D])}return this.updateDefaultConfiguration(a),{keys:v,overrides:d}}compareAndUpdatePolicyConfiguration(a){const{added:v,updated:d,removed:P}=h(this.l,a),u=[...v,...d,...P];return u.length&&this.updatePolicyConfiguration(a),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:v,updated:d,removed:P,overrides:u}=h(this.applicationConfiguration,a),E=[...v,...d,...P];return E.length&&this.updateApplicationConfiguration(a),{keys:E,overrides:u}}compareAndUpdateLocalUserConfiguration(a){const{added:v,updated:d,removed:P,overrides:u}=h(this.localUserConfiguration,a),E=[...v,...d,...P];return E.length&&this.updateLocalUserConfiguration(a),{keys:E,overrides:u}}compareAndUpdateRemoteUserConfiguration(a){const{added:v,updated:d,removed:P,overrides:u}=h(this.remoteUserConfiguration,a),E=[...v,...d,...P];return E.length&&this.updateRemoteUserConfiguration(a),{keys:E,overrides:u}}compareAndUpdateWorkspaceConfiguration(a){const{added:v,updated:d,removed:P,overrides:u}=h(this.workspaceConfiguration,a),E=[...v,...d,...P];return E.length&&this.updateWorkspaceConfiguration(a),{keys:E,overrides:u}}compareAndUpdateFolderConfiguration(a,v){const d=this.folderConfigurations.get(a),{added:P,updated:u,removed:E,overrides:f}=h(d,v),D=[...P,...u,...E];return(D.length||!d)&&this.updateFolderConfiguration(a,v),{keys:D,overrides:f}}compareAndDeleteFolderConfiguration(a){const v=this.folderConfigurations.get(a);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:d,updated:P,removed:u,overrides:E}=h(v,void 0);return{keys:[...d,...P,...u],overrides:E}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,v,d){let P=this.x(v,d);return v.overrideIdentifier&&(P=P.override(v.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(P=P.merge(this.l)),P}x({resource:a},v){let d=this.y();if(v&&a){const P=v.getFolder(a);P&&(d=this.z(P.uri)||d);const u=this.t.get(a);u&&(d=d.merge(u))}return d}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let v=this.i.get(a);if(!v){const d=this.y(),P=this.r.get(a);P?(v=d.merge(P),this.i.set(a,v)):v=d}return v}A(a,v){if(v&&a){const d=v.getFolder(a);if(d)return this.r.get(d.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,v)=>{const{contents:d,overrides:P,keys:u}=this.r.get(v);return a.push([v,{contents:d,overrides:P,keys:u}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(v=>a.add(v)),this.userConfiguration.keys.forEach(v=>a.add(v)),this.q.keys.forEach(v=>a.add(v)),this.r.forEach(v=>v.keys.forEach(d=>a.add(d))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.userConfiguration.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.q.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.r.forEach(v=>v.getAllOverrideIdentifiers().forEach(d=>a.add(d))),[...a.values()]}D(a){const v=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.q.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.r.forEach(d=>d.getKeysForOverrideIdentifier(a).forEach(P=>v.add(P))),[...v.values()]}static parse(a,v){const d=this.E(a.defaults,v),P=this.E(a.policy,v),u=this.E(a.application,v),E=this.E(a.user,v),f=this.E(a.workspace,v),D=a.folders.reduce((w,C)=>(w.set(k.URI.revive(C[0]),this.E(C[1],v)),w),new M.$Bc);return new t(d,P,u,E,m.createEmptyModel(v),f,D,m.createEmptyModel(v),new M.$Bc,v)}static E(a,v){return new m(a.contents,a.keys,a.overrides,void 0,v)}}e.$xo=t;function n(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const a=new Set,v=new Map;for(const P of $)P.keys.forEach(u=>a.add(u)),P.overrides.forEach(([u,E])=>{const f=(0,M.$yc)(v,u,new Set);E.forEach(D=>f.add(D))});const d=[];return v.forEach((P,u)=>d.push([u,[...P.values()]])),{keys:[...a.values()],overrides:d}}class c{constructor(a,v,d,P,u){this.change=a,this.f=v,this.g=d,this.h=P,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const E of a.keys)this.affectedKeys.add(E);for(const[,E]of a.overrides)for(const f of E)this.affectedKeys.add(f);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,v){const d=this.a+a,P=this.d.indexOf(d);if(P<0)return!1;const u=P+d.length;if(u>=this.d.length)return!1;const E=this.d.charCodeAt(u);if(E!==this.b&&E!==this.c)return!1;if(v){const f=this.previousConfiguration?this.previousConfiguration.getValue(a,v,this.f?.workspace):void 0,D=this.g.getValue(a,v,this.h);return!p.$4n(f,D)}return!0}}e.$zo=c;function h($,a){const{added:v,removed:d,updated:P}=i(a?.rawConfiguration,$?.rawConfiguration),u=[],E=$?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const D=f.filter(w=>!E.includes(w));for(const w of D)u.push([w,a.getKeysForOverrideIdentifier(w)])}if($){const D=E.filter(w=>!f.includes(w));for(const w of D)u.push([w,$.getKeysForOverrideIdentifier(w)])}if(a&&$){for(const D of E)if(f.includes(D)){const w=i({contents:$.getOverrideValue(void 0,D)||{},keys:$.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});u.push([D,[...w.added,...w.removed,...w.updated]])}}return{added:v,removed:d,updated:P,overrides:u}}function i($,a){const v=$?a?$.keys.filter(u=>a.keys.indexOf(u)===-1):[...$.keys]:[],d=a?$?a.keys.filter(u=>$.keys.indexOf(u)===-1):[...a.keys]:[],P=[];if($&&a){for(const u of a.keys)if($.keys.indexOf(u)!==-1){const E=(0,N.$8i)(a.contents,u),f=(0,N.$8i)($.contents,u);p.$4n(E,f)||P.push(u)}}return{added:v,removed:d,updated:P}}}),define(Pe[102],Ae([1,0,14,3]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.RemoteAuthorityResolverErrorCode=e.$Gl=e.$Fl=e.RemoteConnectionType=e.$El=void 0,e.$Il=k,e.$El=(0,F.$ti)("remoteAuthorityResolverService");var R;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Fl=O;class M{constructor(y,l){this.host=y,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Gl=M;var p;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class g extends S.$bb{static isNotAvailable(y){return y instanceof g&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof g&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof g&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof g&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof g&&y.isHandled}constructor(y,l=p.Unknown,b){super(y),this._message=y,this._code=l,this._detail=b,this.isHandled=l===p.NotAvailable&&b===!0,Object.setPrototypeOf(this,g.prototype)}}e.$Hl=g;function k(N){const y=N.indexOf("+");return y===-1?N:N.substring(0,y)}}),define(Pe[58],Ae([1,0,12]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=F,e.$Fm=R,e.$Gm=O,e.$Hm=M;function F(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const k=g.indexOf("+");return k<0?g:g.substr(0,k)}function O(g){const{host:k,port:N}=p(g);if(typeof N>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:N}}function M(g,k){let{host:N,port:y}=p(g);return typeof y>"u"&&(y=k),{host:N,port:y}}function p(g){const k=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const N=g.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(Pe[20],Ae([1,0,15,3,58]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Qm=e.$Pm=e.$Om=e.TargetPlatform=e.ExtensionType=e.$Nm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0,e.$Mm=O,e.$Rm=y,e.$Sm=l,e.$Tm=b,e.$Um=m,e.$Im="extensions.user.cache",e.$Jm="extensions.builtin.cache",e.$Km="undefined_publisher",e.$Lm=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Nm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o>"u"||o===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){const t=typeof o=="string"?o:o.value,n=typeof r=="string"?r:r.value;return S.$vf(t,n)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Om=g;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const r of o)this.add(r)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Pm=k;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,r){this.c.set(g.toKey(o),r)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Qm=N;function y(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function b(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const r=`onResolveRemoteAuthority:${(0,R.$Fm)(o)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Vm=(0,F.$ti)("IBuiltinExtensionsScannerService")}),define(Pe[103],Ae([1,0,14,20]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=e.$gG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const g of M){const k=this.readActivationEvents(g);k.length>0&&(p[F.$Om.toKey(g.identifier)]=k)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<p.length;g++)p[g]==="onUri"&&(p[g]=`onUri:${F.$Om.toKey(M.identifier)}`);if(!M.contributes)return p;for(const g in M.contributes){const k=this.a.get(g);if(!k)continue;const N=M.contributes[g],y=Array.isArray(N)?N:[N];try{k(y,p)}catch(l){(0,S.$1)(l)}}return p}}e.$gG=R,e.$hG=new R}),define(Pe[197],Ae([1,0,21,73,35]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=M,e.$bp=p;function O(g){if(S.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,k,N,y,l,b,m,s,o){const r=Object.create(null);r["common.machineId"]=b,r["common.sqmId"]=m,r.sessionID=(0,R.$Pg)()+Date.now(),r.commitHash=y,r.version=l,r["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=F.$ec,r["common.nodeArch"]=N,r["common.product"]=o||"desktop",s&&(r["common.msftInternal"]=s);let t=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const c=O(k);return c&&(r["common.platformDetail"]=c),r}function p(g){const k=F.env.USERDNSDOMAIN;if(!k)return!1;const N=k.toLowerCase();return g.some(y=>N===y)}}),define(Pe[198],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0,e.$Yl=(0,S.$ti)("telemetryService"),e.$Zl=(0,S.$ti)("customEndpointTelemetryService"),e.$1l="telemetry.currentSessionDate",e.$2l="telemetry.firstSessionDate",e.$3l="telemetry.lastSessionDate",e.$4l="telemetry.machineId",e.$5l="telemetry.sqmId",e.$6l="telemetry",e.$7l="telemetry.telemetryLevel",e.$8l="telemetry.enableCrashReporter",e.$9l="telemetry.enableTelemetry";var F;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var R;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Pe[59],Ae([1,0,25,17,58,197,198]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=N,e.$kp=y,e.$lp=l,e.$mp=b,e.$np=s,e.$op=r,e.$pp=t,e.$qp=h;class p{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$cp=p;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$dp=g,e.$ep=new g;class k{async publicLog($,a,v){}async publicLogError($,a,v){}}e.$fp=k,e.$gp="telemetry",e.$hp="extensionTelemetryLog",e.$ip={log:()=>null,flush:()=>Promise.resolve(null)};function N(i,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!i.enableTelemetry)}function y(i,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const $=i.getValue(M.$7l),a=i.getValue(M.$8l);if(i.getValue(M.$9l)===!1||a===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(i){const $={},a={},v={};o(i,v);for(let d in v){d=d.length>150?d.substr(d.length-149):d;const P=v[d];typeof P=="number"?a[d]=P:typeof P=="boolean"?a[d]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${P.length}`),$[d]=P.substring(0,8191)):typeof P<"u"&&P!==null&&($[d]=P)}return{properties:$,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const $=(0,R.$Fm)(i);return m.has($)?$:"other"}function o(i,$,a=0,v){if(i)for(const d of Object.getOwnPropertyNames(i)){const P=i[d],u=v?v+d:d;Array.isArray(P)?$[u]=(0,S.$5n)(P):P instanceof Date?$[u]=P.toISOString():(0,F.$8f)(P)?a<2?o(P,$,a+1,u+"."):$[u]=(0,S.$5n)(P):$[u]=P}}function r(i,$){const a=i.msftInternalDomains||[],v=$.getValue("telemetry.internalTesting");return(0,O.$bp)(a)||v}function t(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,$){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const v=[];for(const E of $)for(;;){const f=E.exec(i);if(!f)break;v.push([f.index,E.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(a="";;){const E=P.exec(i);if(!E)break;const f=v.some(([D,w])=>E.index<w&&D<P.lastIndex);!d.test(E[0])&&!f&&(a+=i.substring(u,E.index)+"<REDACTED: user-file-path>",u=P.lastIndex)}return u<i.length&&(a+=i.substr(u)),a}function c(i){if(!i)return i;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of $)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function h(i,$){return(0,S.$2n)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let v=a.replaceAll("%20"," ");v=n(v,$);for(const d of $)v=v.replace(d,"");return v=c(v),v}})}}),define(Pe[199],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$sp=void 0,e.$rp=N,e.$tp=m,e.$up=s,e.$vp=o,e.$wp=r,e.$xp=t,e.$yp=n,e.$zp=c,e.$Bp=h,e.$Cp=$;function N(a,v){return a.uuid&&v.uuid?a.uuid===v.uuid:a.id===v.id?!0:(0,S.$qf)(a.id,v.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(v){const d=v.manifest?v.manifest.version:v.version,P=v.manifest?v.targetPlatform:v.properties.targetPlatform;return new l(v.identifier,d,P)}static parse(v){const d=y.exec(v);return d&&d[1]&&d[2]?new l({id:d[1]},d[2],d[4]||void 0):null}constructor(v,d,P="undefined"){this.version=d,this.targetPlatform=P,this.id=v.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(v){return v instanceof l?N(this,v)&&this.version===v.version&&this.targetPlatform===v.targetPlatform:!1}}e.$sp=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const v=b.exec(a);return v&&v[1]?[o(v[1]),v[2]]:[o(a),void 0]}function s(a,v){return`${a}.${v}`}function o(a){return a.toLowerCase()}function r(a,v){return o(s(a??R.$Km,v))}function t(a,v){const d=[],P=u=>{for(const E of d)if(E.some(f=>N(v(f),v(u))))return E;return null};for(const u of a){const E=P(u);E?E.push(u):d.push([u])}return d}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new k.$cp(a.identifier.id),name:new k.$cp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Ap=new R.$Om("pprice.better-merge");function h(a,v){const d=[],P=v.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const u=P.shift();if(u&&d.every(E=>!N(E.identifier,{id:u}))){const E=a.filter(f=>N(f.identifier,{id:u}));E.length===1&&(d.push(E[0]),P.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function i(a,v){if(!O.$k)return!1;let d;try{d=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){v.debug("Error while getting the os-release file.",(0,p.$0)(u))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function $(a,v){const d=await i(a,v),P=(0,F.$Yo)(d?"alpine":O.$u,g.$fc);return v.debug("ComputeTargetPlatform:",P),P}}),define(Pe[200],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=S,e.$is=F,e.$js=R,e.$ks=O,e.$ls=M,e.$ms=p;function S(g){return[...g.entries()]}function F(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function O(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(k=>[k[0],S(k[1].map),F(k[1].descriptionMap)])}function p(g){return new Map(g.map(k=>[k[0],{map:R(k[1]),descriptionMap:O(k[2])}]))}}),define(Pe[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btb=void 0;class S{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,O,M=5){const p=O(g=>{const k=typeof g=="string"?g:g.data;let N=this.a.get(R);if(N){N.data.push(k);return}const y=setTimeout(()=>this.flushBuffer(R),M);N={data:[k],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(R),p.dispose()}},this.a.set(R,N)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const O=this.a.get(R);O&&(this.a.delete(R),this.b(R,O.data.join("")))}}e.$btb=S}),define(Pe[202],Ae([1,0,11,91,301,42,5,17,2,161,72,30]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bx=e.$ax=e.$_w=e.$$w=e.$0w=e.$9w=e.IconFontDefinition=e.IconContribution=e.$6w=void 0,e.$7w=o,e.$8w=r,e.$6w={IconContribution:"base.contributions.icons"};var l;(function(h){function i($,a){let v=$.defaults;for(;O.ThemeIcon.isThemeIcon(v);){const d=s.getIcon(v.id);if(!d)return;v=d.defaults}return v}h.getDefinition=i})(l||(e.IconContribution=l={}));var b;(function(h){function i(a){return{weight:a.weight,style:a.style,src:a.src.map(v=>({format:v.format,location:v.location.toString()}))}}h.toJSONObject=i;function $(a){const v=d=>(0,p.$6f)(d)?d:void 0;if(a&&Array.isArray(a.src)&&a.src.every(d=>(0,p.$6f)(d.format)&&(0,p.$6f)(d.location)))return{weight:v(a.weight),style:v(a.style),src:a.src.map(d=>({format:d.format,location:g.URI.parse(d.location)}))}}h.fromJSONObject=$})(b||(e.IconFontDefinition=b={}));class m{constructor(){this.a=new M.$ce,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,$,a,v){const d=this.b[i];if(d){if(a&&!d.description){d.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const E=this.e.enum.indexOf(i);E!==-1&&(this.e.enumDescriptions[E]=a),this.a.fire()}return d}const P={id:i,description:a,defaults:$,deprecationMessage:v};this.b[i]=P;const u={$ref:"#/definitions/icons"};return v&&(u.deprecationMessage=v),a&&(u.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=u,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const $=this.e.enum.indexOf(i);$!==-1&&(this.e.enum.splice($,1),this.e.enumDescriptions.splice($,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,$){const a=this.f[i];return a||(this.f[i]=$,this.a.fire(),$)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(d,P)=>d.id.localeCompare(P.id),$=d=>{for(;O.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const v=Object.keys(this.b).map(d=>this.b[d]);for(const d of v.filter(P=>!!P.description).sort(i))a.push(`|<i class="${$(d)}"></i>|${d.id}|${O.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const d of v.filter(P=>!O.ThemeIcon.isThemeIcon(P.defaults)).sort(i))a.push(`|<i class="${$(d)}"></i>|${d.id}|`);return a.join(`
`)}}const s=new m;y.$_n.add(e.$6w.IconContribution,s);function o(h,i,$,a){return s.registerIcon(h,i,$,a)}function r(){return s}function t(){const h=(0,R.$Oj)();for(const i in h){const $="\\"+h[i].toString(16);s.registerIcon(i,{fontCharacter:$})}}t(),e.$9w="vscode://schemas/icons";const n=y.$_n.as(N.$ao.JSONContribution);n.registerSchema(e.$9w,s.getIconSchema());const c=new S.$Fh(()=>n.notifySchemaChanged(e.$9w),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$0w=o("widget-close",F.$Sj.close,(0,k.localize)(2,null)),e.$$w=o("goto-previous-location",F.$Sj.arrowUp,(0,k.localize)(3,null)),e.$_w=o("goto-next-location",F.$Sj.arrowDown,(0,k.localize)(4,null)),e.$ax=O.ThemeIcon.modify(F.$Sj.sync,"spin"),e.$bx=O.ThemeIcon.modify(F.$Sj.loading,"spin")}),define(Pe[203],Ae([1,0,5,2,48,3,13]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$ew=e.$cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$$v=e.$0v=void 0,e.$_v=k,e.$aw=y,e.$bw=l,e.$dw=b,e.$fw=m,e.$gw=s,e.$0v=(0,O.$ti)("tunnelService"),e.$$v=(0,O.$ti)("sharedTunnelsService");var p;(function(t){t.Http="http",t.Https="https"})(p||(e.TunnelProtocol=p={}));var g;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(g||(e.TunnelPrivacyId=g={}));function k(t){return!!t.forwardPort}var N;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function y(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}function l(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const n=t.query.split("&");for(const c of n){const h=c.split("=")[1];if(/^https?:/.exec(h)){const i=y(F.URI.parse(h));if(i)return i}}}e.$cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.$cw.indexOf(t)>=0}e.$ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(t){return e.$ew.indexOf(t)>=0}function s(t,n,c,h){if(c===1)return!1;if(c===2&&m(n)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(i?.length===4&&parseInt(i[1])>=18)return!1}return t<1024}class o{constructor(n,c,h){this.remoteAddress=n,this.localAddress=c,this.b=h,this.a=new S.$ce,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$hw=o;let r=class{constructor(n,c){this.k=n,this.l=c,this.a=new S.$ce,this.onTunnelOpened=this.a.event,this.b=new S.$ce,this.onTunnelClosed=this.b.event,this.c=new S.$ce,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const h of c){const i=Array.from(h.values());for(const $ of i){const a=await $.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,h,i,$){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:h,privacy:i,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(m(n)||b(n))&&(n=e.$cw[0]);const h=this.s(n,c);if(h)return++h.refcount,h.value}openTunnel(n,c,h,i,$,a=!1,v,d){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${$}.`);const P=this.f??n;if(!P)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(P,c,h,i,$,a,v,d);return u?u.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(E);return(E.tunnelRemoteHost!==c||E.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),v&&E.privacy!==v&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const h=c.get(n.tunnelRemotePort);h&&(h.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async p(n,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const i=h.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),i}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const h=this.e.get(n);if(h&&h.has(c)){const i=h.get(c);i.refcount=0,await this.p(n,c,i)}}q(n,c,h){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:h})}async r(n,c){const h=this.e.get(n);if(h){const i=h.get(c),$=i?await i.value:void 0;(!$||typeof $=="string")&&h.delete(c),h.size===0&&this.e.delete(n)}}s(n,c){const h=[n];b(n)?(h.push(...e.$cw),h.push(...e.$ew)):m(n)&&h.push(...e.$ew);const i=h.map($=>this.e.get($));for(const $ of i){const a=$?.get(c);if(a)return a}}canTunnel(n){return!!y(n)}u(n,c,h,i,$,a,v){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${i}.`);const d=h;this.j.add(d);const P=i===void 0?h:i,u={elevationRequired:$?this.isPortPrivileged(P):!1},E={remoteAddress:{host:c,port:h},localAddressPort:i,privacy:a,public:a?a!==g.Private:void 0,protocol:v},f=n.forwardPort(E,u);return f?(this.q(c,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(d)})):this.j.delete(d),f}};e.$iw=r,e.$iw=r=Je([We(0,M.$Zj),We(1,R.$Zi)],r)}),define(Pe[204],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$jw=void 0,e.$jw=(0,S.$ti)("editSessionIdentityService");var F;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Pe[205],Ae([1,0,12]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=F,e.$sM=R,e.$tM=O,e.$uM=M,e.$vM=p;function F(g){return g.scheme!==S.Schemas.file&&g.scheme!==S.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(k=>F(k.uri))?g.folders[0].uri:void 0;if(g.configuration&&F(g.configuration))return g.configuration}function O(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function p(g){return R(g)!==void 0}}),define(Pe[49],Ae([1,0,162,19,52,23,2,3,12]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Ni=e.$Mi=e.WorkbenchState=e.$Gi=e.$Fi=e.$Ci=void 0,e.$Di=k,e.$Ei=N,e.$Hi=y,e.$Ii=l,e.$Ji=b,e.$Ki=s,e.$Li=o,e.$Oi=n,e.$Ti=c,e.$Ui=h,e.$Wi=i,e.$Xi=$,e.$Yi=a,e.$Ci=(0,p.$ti)("contextService");function k(v){const d=v;return typeof d?.id=="string"&&M.URI.isUri(d.uri)}function N(v){return typeof v?.id=="string"&&!k(v)&&!l(v)}e.$Fi={id:"ext-dev"},e.$Gi={id:"empty-window"};function y(v,d){if(typeof v=="string"||typeof v>"u")return typeof v=="string"?{id:(0,F.$oc)(v)}:d?e.$Fi:e.$Gi;const P=v;return P.configuration?{id:P.id,configPath:P.configuration}:P.folders.length===1?{id:P.id,uri:P.folders[0].uri}:{id:P.id}}function l(v){const d=v;return typeof d?.id=="string"&&M.URI.isUri(d.configPath)}function b(v){const d=v;if(d?.uri)return{id:d.id,uri:M.URI.revive(d.uri)};const P=v;if(P?.configPath)return{id:P.id,configPath:M.URI.revive(P.configPath)};if(v?.id)return{id:v.id}}var m;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s(v){const d=v;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function o(v){const d=v;return!!(d&&typeof d=="object"&&M.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class r{constructor(d,P,u,E,f){this.h=d,this.j=u,this.k=E,this.l=f,this.c=R.$zi.forUris(this.l,()=>!0),this.folders=P}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=R.$zi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Mi=r;class t{constructor(d,P){this.raw=P,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,O.$7g)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ni=t;function n(v){return new t({uri:v,index:0,name:(0,O.$3g)(v)},{uri:v.toString()})}e.$Pi="code-workspace",e.$Qi=`.${e.$Pi}`,e.$Ri=[{name:(0,S.localize)(0,null),extensions:[e.$Pi]}],e.$Si="workspace.json";function c(v,d){return O.$Xg.isEqualOrParent(v,d.untitledWorkspacesHome)}function h(v){let d;return M.URI.isUri(v)?d=v:d=v.configuration,d?.scheme===g.Schemas.tmp}e.$Vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(v){return v.id===e.$Vi}function $(v,d){return!c(v,d)&&!h(v)}function a(v){return(typeof v=="string"?(0,F.$pc)(v):(0,O.$5g)(v))===e.$Qi}}),define(Pe[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;class S{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const O=this.c++;return this.b.set(O,R),this.e(),O}get(R,O){return this.b.has(R)?this.b.get(R)[O]:void 0}delete(R){this.b.delete(R),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ckc=S}),define(Pe[45],Ae([1,0,12,23,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;class O{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Vg(p=>{const g=this.b.get(p.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(p,g){g===null?this.b.delete(p.scheme):this.b.set(p.scheme,g)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Hkc=O,e.$Ikc=(0,R.$ti)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0,e.$xP=(0,S.$ti)("IExtHostInitDataService")}),define(Pe[206],Ae([1,0,167,13,193,27]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;let M=class extends R.$FQ{constructor(g,k,N){const y=N.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=N.remote.isRemote?(0,S.localize)(0,null):g?(0,S.localize)(1,null):(0,S.localize)(2,null);super(k.createLogger(y,{name:l}))}};e.$Omc=M,e.$Omc=M=Je([We(1,F.$1j),We(2,O.$xP)],M)}),define(Pe[207],Ae([1,0,11]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$nlc=void 0;class F{constructor(M,p,g){this.h=new Map,this.a=M,this.b=p,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new S.$Fh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const y of k.values())y.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let g=this.f[M];return typeof g>"u"&&(g=p),g}update(M,p){this.f[M]=p;const g=this.h.get(M);if(g!==void 0)return g.p;const k=new S.$Qh;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$nlc=F;class R extends F{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$olc=R}),define(Pe[208],Ae([1,0,5,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class R{constructor(M){this.c=M,this.a=new S.$ce,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$ce,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,g,k){const y=this.c.getNotebookDocument(F.URI.revive(M)).acceptModelChanged(p.value,g,k);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(F.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(F.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$cmc=R}),define(Pe[16],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0,e.$hP=(0,S.$ti)("IExtHostRpcService");class F{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$iP=F}),define(Pe[209],Ae([1,0,20,5]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class R{#e;constructor(M,p){this.b=new F.$ce,this.onDidChange=this.b.event,this.a=S.$Om.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$xlc=R}),define(Pe[60],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,S.$ti)("IURITransformerService");class F{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Ykc=F}),define(Pe[210],Ae([1,0,22]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tob=R,e.$uob=M;class F{constructor(){this.buffers=[]}add(g){let k=this.buffers.indexOf(g);return k<0&&(k=this.buffers.length,this.buffers.push(g)),k}}function R(p,g){if(g.serializeBuffersForPostMessage){const k=new F,y=JSON.stringify(p,(b,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m)};if(ArrayBuffer.isView(m)){const s=O(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),l=k.buffers.map(b=>{const m=new Uint8Array(b);return S.$De.wrap(m)});return{message:y,buffers:l}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,g){const k=g.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),N=g.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:s}=m,o=k[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(p,N),arrayBuffers:k}}}),define(Pe[104],Ae([1,0,176,17,2,6,3,30,44,12,43,139,33]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$FF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$wF=e.EditorInputCapabilities=e.$vF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=void 0,e.$mF=s,e.$nF=o,e.$oF=r,e.$pF=t,e.$qF=n,e.$rF=c,e.$sF=h,e.$tF=i,e.$uF=$,e.$xF=E,e.$yF=D,e.$zF=w,e.$AF=C,e.$BF=I,e.$CF=W,e.$DF=V,e.$EF=ae,e.$GF=de,e.$HF=Me,e.$IF=ce,e.$JF=Re,e.$hF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$iF={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$jF="workbench.editor.sidebysideEditor",e.$kF="workbench.editors.textDiffEditor",e.$lF="workbench.editors.binaryResourceDiffEditor";var b;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var m;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ie){const L=ie;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(ie){const L=ie;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function r(ie,L,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===L&&ie.matches(ve.input))return ve.getViewState()}function t(ie){if(E(ie))return!1;const L=ie;return R.URI.isUri(L?.resource)}function n(ie){if(E(ie))return!1;const L=ie;return L?.original!==void 0&&L.modified!==void 0}function c(ie){if(E(ie))return!1;const L=ie;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function h(ie){if(E(ie)||n(ie))return!1;const L=ie;return L?.primary!==void 0&&L.secondary!==void 0}function i(ie){if(E(ie))return!1;const L=ie;return L?L.resource===void 0||L.resource.scheme===k.Schemas.untitled||L.forceUntitled===!0:!1}function $(ie){if(E(ie))return!1;const L=ie;return R.URI.isUri(L?.base?.resource)&&R.URI.isUri(L?.input1?.resource)&&R.URI.isUri(L?.input2?.resource)&&R.URI.isUri(L?.result?.resource)}var a;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var v;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v||(e.SaveReason=v={}));class d{constructor(){this.a=new Map}registerSource(L,x){let ve=this.a.get(L);return ve||(ve={source:L,label:x},this.a.set(L,ve)),ve.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$vF=new d;var P;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad"})(P||(e.EditorInputCapabilities=P={}));class u extends O.$Vc{}e.$wF=u;function E(ie){return ie instanceof u}function f(ie){const L=ie;return R.URI.isUri(L?.preferredResource)}function D(ie){const L=ie;return E(L?.primary)&&E(L?.secondary)}function w(ie){const L=ie;return E(L?.modified)&&E(L?.original)}function C(ie,L,x,ve,Te){return Re(ve,[(0,y.$dj)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ie.openEditor(L,ke)}}),(0,y.$dj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function I(ie){return E(ie?.editor)}function W(ie){const L=ie;return I(ie)&&L?.group!==void 0}function V(ie){const L=ie;return typeof L?.groupId=="number"&&E(L.editor)}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var j;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(L,x){if(!L)return;if($(L))return e.$FF.getOriginalUri(L.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:ke}=this.a(L);if(Te&&ke){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Te:ke}}if(n(L)||c(L)||h(L)||$(L))return;const ve=f(L)?L.preferredResource:L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(L){return D(L)||h(L)?{primary:L.primary,secondary:L.secondary}:w(L)||n(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,x){if(!L)return;if($(L))return e.$FF.getCanonicalUri(L.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:ke}=this.a(L);if(Te&&ke){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Te:ke}}if(n(L)||c(L)||h(L)||$(L))return;const ve=L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(L,x){if(Array.isArray(x)){if(x.some(ve=>L.scheme===ve))return L}else if(x===L.scheme)return L}}var re;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function ae(ie,L,x,ve){if(!ie.isSticky(L))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===re.MOUSE||x===re.KEYBOARD;case"mouse":return x===re.MOUSE;case"keyboard":return x===re.KEYBOARD}return!1}e.$FF=new K;var be;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(be||(e.CloseDirection=be={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(L){const x=this.a=L.get(M.$si);for(const[ve,Te]of this.c)this.e(ve,Te,x);this.c.clear()}e(L,x,ve){const Te=ve.createInstance(x);this.d.set(L,Te)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,F.$eg)(this.b)}registerEditorSerializer(L,x){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,x,this.a):this.c.set(L,x),(0,O.$Tc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}p.$_n.add(e.$hF.EditorFactory,new Ie);async function de(ie,L,x){return!ie||!ie.length?[]:await Promise.all(ie.map(async ve=>{const Te=R.URI.revive(ve.fileUri);if(!Te){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await L.canHandleResource(Te)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let pe=ve.exists,fe=ve.type;if(typeof pe!="boolean"||typeof fe!="number")try{fe=(await L.stat(Te)).isDirectory?g.FileType.Directory:g.FileType.Unknown,pe=!0}catch(X){x.error(X),pe=!1}if(!pe&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return pe?{resource:Te,options:Q}:{resource:Te,options:Q,forceUntitled:!0}}))}var me;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function Me(ie){const L=ie;if(!L)return!1;const x=L;if(x.modified)return Me(x.modified);const ve=L;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ce(ie){return(0,N.$fj)(ie)}function Re(ie,L,x){const ve=(0,N.$gj)(ie,L);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Pe[211],Ae([1,0,5,177,3,6,28,30,18,25,91,202]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$PF=e.ViewContentGroups=e.$NF=e.ViewContainerLocation=e.Extensions=e.$MF=e.$LF=e.$KF=void 0,e.$OF=m,e.$KF="views",e.$LF=(0,F.localize)(0,null),e.$MF=(0,y.$7w)("default-view-icon",N.$Sj.window,(0,F.localize)(1,null));var l;(function($){$.ViewContainersRegistry="workbench.registry.view.containers",$.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var b;(function($){$[$.Sidebar=0]="Sidebar",$[$.Panel=1]="Panel",$[$.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$NF=[0,1,2];function m($){switch($){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new S.$ce),this.onDidRegister=this.c.event,this.f=this.B(new S.$ce),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(a,v,d){const P=this.get(a.id);if(P)return P;const u=a;return u.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,M.$yc)(this.g,v,[]).push(u),d?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:v}),u}deregisterViewContainer(a){for(const v of this.g.keys()){const d=this.g.get(v),P=d?.indexOf(a);if(P!==-1){d?.splice(P,1),d.length===0&&this.g.delete(v),this.f.fire({viewContainer:a,viewContainerLocation:v});return}}}get(a){return this.all.filter(v=>v.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(v=>this.getViewContainers(v).filter(d=>d?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(v=>this.getViewContainerLocation(v)===a)}}p.$_n.add(l.ViewContainersRegistry,new s);var o;(function($){$.Open="2_open",$.Debug="4_debug",$.SCM="5_scm",$.More="9_more"})(o||(e.ViewContentGroups=o={}));function r($,a){const v=$.group??o.More,d=a.group??o.More;return v!==d?v.localeCompare(d):($.order??5)-(a.order??5)}class t extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new S.$ce),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$ce),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$ce),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$ce),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Ic}registerViews(a,v){this.registerViews2([{views:a,viewContainer:v}])}registerViews2(a){a.forEach(({views:v,viewContainer:d})=>this.r(v,d)),this.c.fire(a)}deregisterViews(a,v){const d=this.s(a,v);d.length&&this.f.fire({views:d,viewContainer:v})}moveViews(a,v){for(const d of this.m.keys())if(d!==v){const P=this.s(a,d);P.length&&(this.r(P,v),this.g.fire({views:P,from:d,to:v}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const v of this.j){const d=(this.m.get(v)||[]).filter(P=>P.id===a)[0];if(d)return d}return null}getViewContainer(a){for(const v of this.j)if((this.m.get(v)||[]).filter(P=>P.id===a)[0])return v;return null}registerViewWelcomeContent(a,v){return this.n.add(a,v),this.h.fire(a),(0,O.$Tc)(()=>{this.n.delete(a,v),this.h.fire(a)})}registerViewWelcomeContent2(a,v){const d=new Map;for(const[P,u]of v)this.n.add(a,u),d.set(P,(0,O.$Tc)(()=>{this.n.delete(a,u),this.h.fire(a)}));return this.h.fire(a),d}getViewWelcomeContent(a){const v=[];return this.n.forEach(a,d=>v.push(d)),v.sort(r)}r(a,v){let d=this.m.get(v);d||(d=[],this.m.set(v,d),this.j.push(v));for(const P of a){if(this.getView(P.id)!==null)throw new Error((0,F.localize)(2,null,P.id));d.push(P)}}s(a,v){const d=this.m.get(v);if(!d)return[];const P=[],u=[];for(const E of d)a.includes(E)?P.push(E):u.push(E);return P.length&&(u.length?this.m.set(v,u):(this.m.delete(v),this.j.splice(this.j.indexOf(v),1))),P}}p.$_n.add(l.ViewsRegistry,new t),e.$PF=(0,R.$ti)("viewDescriptorService");var n;(function($){$[$.Default=0]="Default",$[$.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,v){this.c=!1,this.d=!1,(0,k.$3n)(this,a),this.d=!!v,this.resolve=async d=>{if(v&&!this.c){const P=await v(d);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$QF=h;class i extends Error{constructor(a){super((0,F.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$RF=i}),define(Pe[212],Ae([1,0,178,31]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0,e.$VF=new F.$Kj("chatSessionResponseVote","",{type:"string",description:(0,S.localize)(0,null)}),e.$WF=new F.$Kj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,S.localize)(1,null)}),e.$XF=new F.$Kj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,S.localize)(2,null)}),e.$YF=new F.$Kj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,S.localize)(3,null)}),e.$ZF=new F.$Kj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,S.localize)(4,null)}),e.$1F=new F.$Kj("chatResponse",!1,{type:"boolean",description:(0,S.localize)(5,null)}),e.$2F=new F.$Kj("chatRequest",!1,{type:"boolean",description:(0,S.localize)(6,null)}),e.$3F=new F.$Kj("chatInputHasText",!1,{type:"boolean",description:(0,S.localize)(7,null)}),e.$4F=new F.$Kj("chatInputHasFocus",!1,{type:"boolean",description:(0,S.localize)(8,null)}),e.$5F=new F.$Kj("inChatInput",!1,{type:"boolean",description:(0,S.localize)(9,null)}),e.$6F=new F.$Kj("inChat",!1,{type:"boolean",description:(0,S.localize)(10,null)}),e.$7F=new F.$Kj("chatIsEnabled",!1,{type:"boolean",description:(0,S.localize)(11,null)}),e.$8F=new F.$Kj("chatCursorAtTop",!1),e.$9F=new F.$Kj("chatInputHasAgent",!1),e.$0F=new F.$Kj("chatLocation",void 0)}),define(Pe[213],Ae([1,0,5,40,6,31,3,212]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.$8G=e.ChatAgentLocation=void 0;var g;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(y){function l(b){switch(b){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=l}(g||(e.ChatAgentLocation=g={})),e.$8G=(0,M.$ti)("chatAgentService");let k=class{static{this.AGENT_LEADER="@"}constructor(l){this.f=l,this.b=[],this.d=new S.$ce,this.onDidChangeAgents=this.d.event,this.e=p.$7F.bindTo(this.f)}registerAgent(l,b){if(this.getAgent(l))throw new Error(`Agent already registered: ${JSON.stringify(l)}`);const s=this,o=b.slashCommands;b={...b,get slashCommands(){return o.filter(t=>!t.when||s.f.contextMatchesRules(O.$rj.deserialize(t.when)))}};const r={data:b};return this.b.push(r),(0,R.$Tc)(()=>{this.b=this.b.filter(t=>t!==r),this.d.fire(void 0)})}registerAgentImplementation(l,b){const m=this.g(l);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(l)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(l)}`);return m.data.isDefault&&this.e.set(!0),m.impl=b,this.d.fire(new N(m.data,b)),(0,R.$Tc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(l,b){const m={data:l,impl:b};return this.b.push(m),this.d.fire(new N(l,b)),(0,R.$Tc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(l,b){const m=this.g(l);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(l)} registered`);m.data.metadata={...m.data.metadata,...b},this.d.fire(new N(m.data,m.impl))}getDefaultAgent(l){return this.getActivatedAgents().find(b=>!!b.isDefault&&b.locations.includes(l))}getContributedDefaultAgent(l){return this.getAgents().find(b=>!!b.isDefault&&b.locations.includes(l))}getSecondaryAgent(){return F.Iterable.find(this.b.values(),l=>!!l.data.metadata.isSecondary)?.data}g(l){return this.b.find(b=>b.data.id===l)}getAgent(l){return this.g(l)?.data}getAgents(){return this.b.map(l=>l.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(l=>!!l.impl).map(l=>new N(l.data,l.impl))}getAgentsByName(l){return this.getAgents().filter(b=>b.name===l)}async invokeAgent(l,b,m,s,o){const r=this.g(l);if(!r?.impl)throw new Error(`No activated agent with id ${l}`);return await r.impl.invoke(b,m,s,o)}async getFollowups(l,b,m,s,o){const r=this.g(l);if(!r?.impl)throw new Error(`No activated agent with id ${l}`);return r.impl?.provideFollowups?r.impl.provideFollowups(b,m,s,o):[]}};e.$9G=k,e.$9G=k=Je([We(0,O.$Lj)],k);class N{constructor(l,b){this.b=l,this.d=b}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(l,b,m,s){return this.d.invoke(l,b,m,s)}async provideFollowups(l,b,m,s){return this.d.provideFollowups?this.d.provideFollowups(l,b,m,s):[]}provideWelcomeMessage(l,b){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(l,b)}provideSampleQuestions(l,b){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(l,b)}}e.$0G=N}),define(Pe[214],Ae([1,0,2,29,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=e.$eG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$cG=O,e.$dG=M;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof S.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(F.$pt.isIRange)}function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var g;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$eG=(0,R.$ti)("IChatService"),e.$fG="accessibility.voice.keywordActivation"}),define(Pe[215],Ae([1,0,5,11,179]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ob=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new S.$ce,this.o=new S.$ce,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,g,k,N){const y={command:p};if(g&&Object.keys(g).length>0&&(y.arguments=g),this.u("request",y),typeof N=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(y.seq);if(b){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,R.localize)(0,null,N,p)};b(m)}},N)}return k&&this.f.set(y.seq,k),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,g){return p.type!=="event"||g.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,F.$uh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const g=p,k=this.f.get(g.request_seq);k&&(this.f.delete(g.request_seq),k(g));break}}}}u(p,g){g.type=p,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((g,k)=>p.set(k,g)),await(0,F.$uh)(500),p.forEach((g,k)=>{g({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$1ob=O}),define(Pe[216],Ae([1,0,2,180,31,3]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$nJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$lJ=e.MemoryRangeType=e.State=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=void 0,e.$kJ=g,e.$mJ=N,e.$$H="workbench.view.debug",e.$_H="workbench.debug.variablesView",e.$aI="workbench.debug.watchExpressionsView",e.$bI="workbench.debug.callStackView",e.$cI="workbench.debug.loadedScriptsView",e.$dI="workbench.debug.breakPointsView",e.$eI="workbench.debug.disassemblyView",e.$fI="workbench.panel.repl",e.$gI="workbench.panel.repl.view",e.$hI=new R.$Kj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$iI=new R.$Kj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$jI=new R.$Kj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$kI="debugUx",e.$lI=new R.$Kj(e.$kI,"default",{type:"string",description:F.localize(3,null)}),e.$mI=new R.$Kj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$nI=new R.$Kj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$oI=new R.$Kj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$pI=new R.$Kj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$qI=new R.$Kj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$rI=new R.$Kj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$sI=new R.$Kj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$tI=new R.$Kj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$uI=new R.$Kj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$vI=new R.$Kj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$wI=new R.$Kj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$xI=new R.$Kj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$yI=new R.$Kj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$zI=new R.$Kj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$AI=new R.$Kj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$BI=new R.$Kj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$CI=new R.$Kj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$DI=new R.$Kj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$EI=new R.$Kj("breakpointItemBytes",void 0,{type:"boolean",description:F.localize(22,null)}),e.$FI=new R.$Kj("breakpointHasModes",!1,{type:"boolean",description:F.localize(23,null)}),e.$GI=new R.$Kj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(24,null)}),e.$HI=new R.$Kj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(25,null)}),e.$II=new R.$Kj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(26,null)}),e.$JI=new R.$Kj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(27,null)}),e.$KI=new R.$Kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(28,null)}),e.$LI=new R.$Kj("stepBackSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$MI=new R.$Kj("restartFrameSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$NI=new R.$Kj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(31,null)}),e.$OI=new R.$Kj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$PI=new R.$Kj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(33,null)}),e.$QI=new R.$Kj("breakpointsExist",!1,{type:"boolean",description:F.localize(34,null)}),e.$RI=new R.$Kj("debuggersAvailable",!1,{type:"boolean",description:F.localize(35,null)}),e.$SI=new R.$Kj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(36,null)}),e.$TI=new R.$Kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(37,null)}),e.$UI=new R.$Kj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$VI=new R.$Kj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$WI=new R.$Kj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$XI=new R.$Kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$YI=new R.$Kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$ZI=new R.$Kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$1I=new R.$Kj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(44,null)}),e.$2I=new R.$Kj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(45,null)}),e.$3I=new R.$Kj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(46,null)}),e.$4I=new R.$Kj("variableIsReadonly",!1,{type:"boolean",description:F.localize(47,null)}),e.$5I=new R.$Kj("variableValue",!1,{type:"string",description:F.localize(48,null)}),e.$6I=new R.$Kj("variableType",!1,{type:"string",description:F.localize(49,null)}),e.$7I=new R.$Kj("variableInterfaces",!1,{type:"array",description:F.localize(50,null)}),e.$8I=new R.$Kj("variableName",!1,{type:"string",description:F.localize(51,null)}),e.$9I=new R.$Kj("variableLanguage",!1,{type:"string",description:F.localize(52,null)}),e.$0I=new R.$Kj("variableExtensionId",!1,{type:"string",description:F.localize(53,null)}),e.$$I=new R.$Kj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(54,null)}),e.$_I=new R.$Kj("multiSessionRepl",!1,{type:"boolean",description:F.localize(55,null)}),e.$aJ=new R.$Kj("multiSessionDebug",!1,{type:"boolean",description:F.localize(56,null)}),e.$bJ=new R.$Kj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(57,null)}),e.$cJ=new R.$Kj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(58,null)}),e.$dJ=new R.$Kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(59,null)}),e.$eJ=new R.$Kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(60,null)});const M=n=>F.localize(61,null,n);e.$fJ=M,e.$gJ="editor.contrib.debug",e.$hJ="editor.contrib.breakpoint",e.$iJ="debug",e.$jJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(62,null)};var p;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(p||(e.State=p={}));function g(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$lJ="vscode-debug-memory";function N(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var y;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var b;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$nJ=(0,O.$ti)("debugService");var m;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var r;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(r||(e.IDebugVisualizationTreeItem=r={}));var t;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(t||(e.IDebugVisualization=t={}))}),define(Pe[217],Ae([1,0,15,2,19,25,12,29,24,18]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=void 0,e.$aH=y,e.$bH=l,e.$cH=b,e.$dH=m,e.$eH=s,e.$fH=o,e.$gH=r,e.$hH=n,e.$iH=i,e.$jH=$,e.$kH=v,e.$lH=P;const N=/{([^}]+)}/g;function y(E,f,D){return E.replace(N,function(w,C){return f&&C.length>0&&C[0]!=="_"?w:D&&D.hasOwnProperty(C)?D[C]:w})}function l(E){const f={};for(const D of Object.keys(E))D.startsWith("!")||(f[D]=E[D]);return f}function b(E){return E.configuration.request==="attach"&&!m(E)&&(!E.parentSession||b(E.parentSession))}function m(E){let f=E.configuration.type;if(f)return f==="vslsShare"&&(f=E.configuration.adapterProxy.configuration.type),(0,S.$vf)(f,"extensionhost")||(0,S.$vf)(f,"pwa-extensionhost")?E:E.parentSession?m(E.parentSession):void 0}function s(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,f,D){let w,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=I.exec(E);){const V=W.index+1,q=V+W[0].length;if(V<=f&&q>=D){w=W[0],C=V;break}}if(w){const V=/\w+/g;let q=null;for(;(q=V.exec(w))&&!(q.index+1+C+q[0].length>=D););q&&(w=w.substring(0,V.lastIndex))}return w?{start:C,end:C+w.length-1}:{start:0,end:0}}async function r(E,f,D,w){if(E.evaluatableExpressionProvider.has(f)){const C=E.evaluatableExpressionProvider.ordered(f),I=(0,k.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(f,D,w??g.CancellationToken.None)}catch{return}})));if(I.length>0){let W=I[0].expression;const V=I[0].range;return W||(W=f.getLineContent(D.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=f.getLineContent(D.lineNumber),{start:I,end:W}=o(C,D.column,D.column),V=C.substring(I-1,W);return{matchingExpression:V,range:new p.$pt(D.lineNumber,I,D.lineNumber,I+V.length)}}return null}const t=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(E){return!!(E&&E.match(t))}function c(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(n(E.path))return F.URI.parse(E.path);if((0,R.$jc)(E.path))return F.URI.file(E.path)}return E.path}function h(E){if(typeof E.path=="object"){const f=F.URI.revive(E.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return E.path}function i(E,f){const D=f?c:h,w=(0,O.$Zn)(E);return a(w,(C,I)=>{C&&I&&(I.path=D(I))}),w}function $(E,f){const D=f?c:h,w=(0,O.$Zn)(E);return a(w,(C,I)=>{!C&&I&&(I.path=D(I))}),w}function a(E,f){switch(E.type){case"event":{const D=E;switch(D.event){case"output":f(!1,D.body.source);break;case"loadedSource":f(!1,D.body.source);break;case"breakpoint":f(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=E;switch(D.command){case"setBreakpoints":f(!0,D.arguments.source);break;case"breakpointLocations":f(!0,D.arguments.source);break;case"source":f(!0,D.arguments.source);break;case"gotoTargets":f(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(w=>f(!1,w));break;default:break}break}case"response":{const D=E;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(w=>f(!1,w.source));break;case"loadedSources":D.body.sources.forEach(w=>f(!1,w));break;case"scopes":D.body.scopes.forEach(w=>f(!1,w.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(w=>f(!1,w.source));break;case"setBreakpoints":D.body.breakpoints.forEach(w=>f(!1,w.source));break;case"disassemble":D.body?.instructions.forEach(C=>f(!1,C.location));break;default:break}break}}}function v(E){return E.filter(f=>!f.presentation?.hidden).sort((f,D)=>f.presentation?D.presentation?f.presentation.group?D.presentation.group?f.presentation.group!==D.presentation.group?f.presentation.group.localeCompare(D.presentation.group):d(f.presentation.order,D.presentation.order):-1:D.presentation.group?1:d(f.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function d(E,f){return typeof E!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:E-f}async function P(E,f){const D=E.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(D!=="none"&&(await f.saveAll(),D==="allEditorsInActiveGroup")){const w=f.activeEditorPane;w&&w.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:w.input,groupId:w.group.id})}await E.reloadConfiguration()}const u=(E,f)=>!E||!f?E===f:E.name===f.name&&E.path===f.path&&E.sourceReference===f.sourceReference;e.$mH=u}),define(Pe[218],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.CellExecutionUpdateType=void 0;var F;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$AK=(0,S.$ti)("INotebookExecutionService")}),define(Pe[219],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uib=e.$Tib=e.ProxyKernelState=e.$Sib=void 0,e.$Sib=100;var F;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$Tib=(0,S.$ti)("INotebookKernelService"),e.$Uib=(0,S.$ti)("INotebookKernelHistoryService")}),define(Pe[220],Ae([1,0,6,29,149,95]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MWb=void 0;class M extends S.$Vc{constructor(g,k,N){super(),this._source=g,this.b=k,this.c=N,this.a=void 0}f(g){const k=g.getLineCount();return new F.$pt(1,1,k,this.g(g,k))}g(g,k){if(k<1||k>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const g=new R.$QC;g.acceptChunk(this._source);const k=g.finish(!0),{textBuffer:N,disposable:y}=k.create(1);this.b=N,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const k=new R.$QC;k.acceptChunk(g);const N=k.finish(!0),{textBuffer:y,disposable:l}=N.create(1);return this.B(l),y})),this.a}findInInputs(g){const N=new O.$EC(g,!1,!1,null).parseSearchRequest();if(!N)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,N,!0,5e3)}findInOutputs(g){const N=new O.$EC(g,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(y=>{const l=y.findMatchesLineByLine(this.f(y),N,!0,5e3);if(l.length!==0)return{textBuffer:y,matches:l}}).filter(y=>!!y):[]}}e.$MWb=M}),define(Pe[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class R{static fromExtHostTestItem(M,p,g=M.parent){if(M._isRoot)return new R([p]);const k=[M.id];for(let N=g;N&&N.id!==p;N=N.parent)k.push(N.id);return k.push(p),new R(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new R(M.split("\0"))}static join(M,p){return new R([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:R.isChild(M,p)?2:R.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$GL=R}),define(Pe[61],Ae([1,0,2,93,29,50]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$OL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$NL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ML=e.$LL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$KL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$JL=e.$IL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$HL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$HL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$IL=[2,4,8,16,32,64];const k=A=>"runId"in A;e.$JL=k;var N;(function(A){A.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({range:R.$pt.lift(K.range),uri:j.asCanonicalUri(S.URI.revive(K.uri))})})(N||(e.IRichLocation=N={}));var y;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(y||(e.TestMessageType=y={}));var l;(function(A){A.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&N.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&N.deserialize(j,K.location)})})(l||(e.ITestErrorMessage=l={}));const b=(A,j)=>`${j?"s":"e"}${A}`;e.$KL=b;var m;(function(A){A.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&N.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&N.deserialize(j,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(A){A.serialize=j=>j.type===0?l.serialize(j):m.serialize(j),A.deserialize=(j,K)=>K.type===0?l.deserialize(j,K):m.deserialize(j,K)})(s||(e.ITestMessage=s={}));var o;(function(A){A.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),A.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(s.serialize)}),A.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(re=>s.deserialize(j,re))})})(o||(e.ITestTaskState=o={}));const r="\0",t=(A,j)=>A+r+j;e.$LL=t;const n=A=>{const j=A.indexOf(r);return{ctrlId:A.slice(0,j),tagId:A.slice(j+1)}};e.$ML=n;var c;(function(A){A.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),A.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(S.URI.revive(K.uri)):void 0,range:K.range?R.$pt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(A){A.serialize=j=>({expand:j.expand,item:c.serialize(j.item)}),A.deserialize=(j,K)=>({controllerId:O.$GL.root(K.item.extId),expand:K.expand,item:c.deserialize(j,K.item)})})(i||(e.InternalTestItem=i={}));var $;(function(A){A.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},A.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?R.$pt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})($||(e.ITestItemUpdate=$={}));const a=(A,j)=>{j.expand!==void 0&&(A.expand=j.expand),j.item!==void 0&&(A.item=A.item?Object.assign(A.item,j.item):j.item)};e.$NL=a;var v;(function(A){A.serializeWithoutMessages=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),A.serialize=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),A.deserialize=(j,K)=>({...i.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(re=>o.deserialize(j,re)),retired:!0})})(v||(e.TestResultItem=v={}));var d;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(d||(e.ICoverageCount=d={}));var P;(function(A){A.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(S.URI.revive(K.uri))})})(P||(e.IFileCoverage=P={}));function u(A){return{...A,location:A.location?.toJSON()}}function E(A){return A.location=A.location?F.$ot.isIPosition(A.location)?F.$ot.lift(A.location):R.$pt.lift(A.location):void 0,A}e.$OL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var D;(function(A){A.serialize=j=>j.type===0?C.serialize(j):I.serialize(j),A.deserialize=j=>j.type===0?C.deserialize(j):I.deserialize(j)})(D||(e.CoverageDetails=D={}));var w;(function(A){A.serialize=u,A.deserialize=E})(w||(e.IBranchCoverage=w={}));var C;(function(A){A.serialize=u,A.deserialize=E})(C||(e.IDeclarationCoverage=C={}));var I;(function(A){A.serialize=j=>({...u(j),branches:j.branches?.map(w.serialize)}),A.deserialize=j=>({...E(j),branches:j.branches?.map(w.deserialize)})})(I||(e.IStatementCoverage=I={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(j,K)=>K.op===0?{op:K.op,item:i.deserialize(j,K.item)}:K.op===1?{op:K.op,item:$.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(S.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=j=>j.op===0?{op:j.op,item:i.serialize(j.item)}:j.op===1?{op:j.op,item:$.serialize(j.item)}:j})(V||(e.TestsDiffOp=V={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const re of j)switch(re.op){case 0:this.l(i.deserialize(this.k,re.item),K);break;case 1:this.o($.deserialize(re.item),K);break;case 3:this.p(re.itemId,K);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}K.complete?.()}l(j,K){const re=O.$GL.parentId(j.item.extId)?.toString();let ae;if(!re)ae=this.w(j),this.g.add(ae),this.f.set(j.item.extId,ae);else if(this.f.has(re)){const be=this.f.get(re);be.children.add(j.item.extId),ae=this.w(j,be),this.f.set(j.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ae),j.expand===2&&this.h++,ae}o(j,K){const re=this.f.get(j.extId);if(re)return j.expand!==void 0&&(re.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$NL)(re,j),K.update?.(re),re}p(j,K){const re=this.f.get(j);if(!re)return;const ae=O.$GL.parentId(re.item.extId)?.toString();ae?this.f.get(ae).children.delete(re.item.extId):this.g.delete(re);const be=[[j]];for(;be.length;)for(const Ie of be.pop()){const de=this.f.get(Ie);de&&(be.push(de.children),this.f.delete(Ie),K.remove?.(de,de!==re),de.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$PL=q}),define(Pe[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestItemEventOp=void 0;var g;(function(t){t[t.Upsert=0]="Upsert",t[t.SetTags=1]="SetTags",t[t.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",t[t.RemoveChild=3]="RemoveChild",t[t.SetProp=4]="SetProp",t[t.Bulk=5]="Bulk",t[t.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const k=(t,n)=>t===n,y=Object.entries({range:(t,n)=>t===n?!0:!t||!n?!1:t.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(t,n)=>!(t.length!==n.length||t.some(c=>!n.includes(c)))}),l=(t,n)=>{let c;for(const[h,i]of y)i(t[h],n[h])||(c?c[h]=n[h]:c={[h]:n[h]});return c};class b extends R.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$Fh(()=>this.flushDiff(),200)),this.g=this.B(new F.$ce),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,M.$NL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,M.$NL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(p.$GL.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const h of c.ops)this.w(n,h);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,O.$dd)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const h=p.$GL.fromExtHostTestItem(n,this.root.id,c?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(n.id);let $=this.tree.get(h.toString());if(!$){$={fullId:h,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set($.fullId.toString(),$),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:$.expand,item:this.s.toITestItem(n)}}),this.I(n,$,c);return}if($.actual===n){this.H(n,$,c);return}if($.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,c);const a=this.s.getChildren($.actual),v=$.actual,d=l(this.s.toITestItem(v),this.s.toITestItem(n));this.s.getApiFor(v).listener=void 0,$.actual=n,$.resolveBarrier=void 0,$.expand=0,d&&(d.hasOwnProperty("tags")&&(this.C(n.tags,v.tags,h.toString()),delete d.tags),this.w($,{op:4,update:d})),this.I(n,$,c);for(const[u,E]of a)this.s.getChildren(n).get(E.id)||this.O(p.$GL.joinToString(h,E.id));const P=$.expandLevels;P!==void 0&&queueMicrotask(()=>{$.expand===1&&($.expandLevels=void 0,this.expand(h.toString(),P))}),this.y($.actual.uri)}C(n,c,h){const i=new Set(c.map($=>$.id));for(const $ of n)i.delete($.id)||this.D($);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map($=>(0,M.$LL)(this.s.controllerId,$.id))}}}),i.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$LL)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$LL)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,h){this.G(n,h);const i=this.s.getApiFor(n);i.parent=h?.actual,i.listener=$=>this.w(c,$),this.J(c)}I(n,c,h){this.H(n,c,h);for(const[i,$]of this.s.getChildren(n))this.z($,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const h=[];for(const[i,$]of this.s.getChildren(n.actual)){const a=this.expand(p.$GL.joinToString(n.fullId,$.id),c);(0,S.$fh)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const $=new S.$sh;return $.open(),$}n.expand=2,this.N(n);const c=n.resolveBarrier=new S.$sh,h=$=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,$)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch($){h($)}return(0,S.$fh)(i)?i.catch(h).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const $ of i.actual.tags)this.F($.id);this.tree.delete(i.fullId.toString());for(const[$,a]of this.s.getChildren(i.actual))h.push(this.tree.get(p.$GL.joinToString(i.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$0O=b;class m extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$$O=m;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_O=s;class o extends Error{constructor(n,c,h){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$aP=o;const r=(t,n,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,$){for(const a of h.values())i.call($,a,this)},[Symbol.iterator](){return h.entries()},replace(i){const $=new Map,a=new Set(h.keys()),v={op:5,ops:[]};for(const d of i){if(!(d instanceof c))throw new s(d.id);const P=n(d).controllerId;if(P!==t.controllerId)throw new o(d.id,P,t.controllerId);if($.has(d.id))throw new m(d.id);$.set(d.id,d),a.delete(d.id),v.ops.push({op:0,item:d})}for(const d of a.keys())v.ops.push({op:3,id:d});t.listener?.(v),h=$},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),t.listener?.({op:0,item:i})},delete(i){h.delete(i)&&t.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$bP=r}),define(Pe[105],Ae([1,0,75]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;const F=new WeakMap,R=(M,p)=>{const g={controllerId:p};return F.set(M,g),g};e.$cP=R;const O=M=>{const p=F.get(M);if(!p)throw new S.$_O(M?.id||"<unknown>");return p};e.$dP=O}),define(Pe[76],Ae([1,0,12,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iyb=e.$hyb=e.$gyb=void 0,e.$jyb=R,e.$kyb=M,e.$gyb="vscode-cdn.net",e.$hyb=`vscode-resource.${e.$gyb}`,e.$iyb=`'self' https://*.${e.$gyb}`;function R(p,g){return p.scheme===S.Schemas.http||p.scheme===S.Schemas.https?p:(g&&g.authority&&g.isRemote&&p.scheme===S.Schemas.file&&(p=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:g.authority,path:p.path})),F.URI.from({scheme:S.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$hyb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,g=>{const k=g.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?g:"-"+k.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(g,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Pe[221],Ae([1,0,5,6,76]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class O{constructor(p,g,k){this.d=p,this.e=g,this.f=k,this.a=0,this.b=new F.$Uc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const N=g.getVisibleTextEditors();for(const y of this.c.values())N.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,g,k,N,y){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){l=n;break}if(!l)throw new Error("not a visible editor");const b=this,m=this.a++,s=new S.$ce,o=new S.$ce,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,R.$jyb)(n,b.f)}get cspSource(){return R.$iyb}set options(n){this.b=n,b.d.$setOptions(m,n)}get options(){return this.b}set html(n){this.a=n,b.d.$setHtml(m,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return b.d.$postMessage(m,n)}},t=new class{constructor(){this.editor=p,this.line=g,this.height=k,this.webview=r,this.onDidDispose=o.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,l.id,l.value.document.uri,g+1,k,N||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:t,onDidReceiveMessage:s}),t}$onDidDispose(p){const g=this.c.get(p);g&&g.inset.dispose()}$onDidReceiveMessage(p,g){this.c.get(p)?.onDidReceiveMessage.fire(g)}}e.$Vkc=O}),define(Pe[106],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.$WL=void 0,e.$WL="__",e.$XL=(0,S.$ti)("IAuthenticationService"),e.$YL=(0,S.$ti)("IAuthenticationExtensionsService")}),define(Pe[222],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.VariableKind=e.$6P=void 0,e.$6P=(0,S.$ti)("configurationResolverService");var F;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class R extends Error{constructor(M,p){super(p),this.variable=M}}e.$7P=R}),define(Pe[223],Ae([1,0,19,73,17,25,21,96,183,222,15]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,m,s,o){this.h=new Map,this.a=b,this.b=m,this.g=s,o&&(this.c=o.then(r=>this.i(r)))}i(b){if(M.$i){const m=Object.create(null);return Object.keys(b).forEach(s=>{m[s.toLowerCase()]=b[s]}),m}return b}resolveWithEnvironment(b,m,s){return this.l({env:this.i(b),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(b,m){const s={env:await this.c,userHome:await this.g};return this.l(s,b?b.uri:void 0,m)}async j(b,m,s,o){const r=O.$Zn(m);M.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):M.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):M.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const t={env:await this.c,userHome:await this.g};return this.l(t,b?b.uri:void 0,r,s,o)}async resolveAnyAsync(b,m,s){return this.j(b,m,s)}async resolveAnyMap(b,m,s){const o=new Map;return{newConfig:await this.j(b,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(b,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,m)}async l(b,m,s,o,r){if(R.$6f(s))return this.m(b,m,s,o,r);if(Array.isArray(s))return Promise.all(s.map(t=>this.l(b,m,t,o,r)));if(R.$8f(s)){const t=Object.create(null),n=await Promise.all(Object.keys(s).map(async c=>[await this.m(b,m,c,o,r),await this.l(b,m,s[c],o,r)]));for(const[c,h]of n)t[c]=h;return t}return s}m(b,m,s,o,r){return(0,N.$nf)(s,y.VARIABLE_REGEXP,async(t,n)=>{if(n.includes(y.VARIABLE_LHS))return t;let c=await this.o(b,t,n,m,o);return r?.set(n,c),c!==t&&R.$6f(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.m(b,m,c,o,r)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,m,s,o,r){let t;const n=s.split(":");n.length>1&&(s=n[0],t=n[1]);const c=$=>{const a=this.a.getFilePath();if(a)return(0,p.$tw)(a);throw new k.$7P($,(0,g.localize)(0,null,m))},h=$=>{const a=c($);if(this.a.getWorkspaceFolderPathForFile){const v=this.a.getWorkspaceFolderPathForFile();if(v)return(0,p.$tw)(v)}throw new k.$7P($,(0,g.localize)(1,null,m,S.$oc(a)))},i=$=>{if(t){const a=this.a.getFolderUri(t);if(a)return a;throw new k.$7P($,(0,g.localize)(2,null,m,t))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$7P($,(0,g.localize)(3,null,m)):new k.$7P($,(0,g.localize)(4,null,m))};switch(s){case"env":if(t){if(b.env){const $=b.env[M.$i?t.toLowerCase():t];if(R.$6f($))return $}return""}throw new k.$7P(k.VariableKind.Env,(0,g.localize)(5,null,m));case"config":if(t){const $=this.a.getConfigurationValue(o,t);if(R.$cg($))throw new k.$7P(k.VariableKind.Config,(0,g.localize)(6,null,m,t));if(R.$8f($))throw new k.$7P(k.VariableKind.Config,(0,g.localize)(7,null,m,t));return $}throw new k.$7P(k.VariableKind.Config,(0,g.localize)(8,null,m));case"command":return this.p(k.VariableKind.Command,m,t,r,"command");case"input":return this.p(k.VariableKind.Input,m,t,r,"input");case"extensionInstallFolder":if(t){const $=await this.a.getExtension(t);if(!$)throw new k.$7P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,m,t));return this.n($.extensionLocation)}throw new k.$7P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$tw)(this.n(i(k.VariableKind.WorkspaceFolder)));case"cwd":return o||t?(0,p.$tw)(this.n(i(k.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$tw)(S.$oc(this.n(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.$7P(k.VariableKind.UserHome,(0,g.localize)(11,null,m))}case"lineNumber":{const $=this.a.getLineNumber();if($)return $;throw new k.$7P(k.VariableKind.LineNumber,(0,g.localize)(12,null,m))}case"selectedText":{const $=this.a.getSelectedText();if($)return $;throw new k.$7P(k.VariableKind.SelectedText,(0,g.localize)(13,null,m))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||t?S.$mc(this.n(i(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const $=S.$nc(c(k.VariableKind.RelativeFileDirname));if(o||t){const a=S.$mc(this.n(i(k.VariableKind.RelativeFileDirname)),$);return a.length===0?".":a}return $}case"fileDirname":return S.$nc(c(k.VariableKind.FileDirname));case"fileExtname":return S.$pc(c(k.VariableKind.FileExtname));case"fileBasename":return S.$oc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const $=S.$oc(c(k.VariableKind.FileBasenameNoExtension));return $.slice(0,$.length-S.$pc($).length)}case"fileDirnameBasename":return S.$oc(S.$nc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const $=this.a.getExecPath();return $||m}case"execInstallFolder":{const $=this.a.getAppRoot();return $||m}case"pathSeparator":case"/":return S.sep;default:try{const $=t?`${s}:${t}`:s;return this.p(k.VariableKind.Unknown,m,$,r,void 0)}catch{return m}}}}p(b,m,s,o,r){if(s&&o){const t=r===void 0?o[s]:o[r+":"+s];if(typeof t=="string")return t;throw new k.$7P(b,(0,g.localize)(14,null,m))}return m}}e.$jQ=y}),define(Pe[107],Ae([1,0,3,104]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MD=void 0,e.$ND=k,e.$OD=l,e.$PD=b,e.$MD=(0,S.$ti)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var g;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function k(m){const s=m;return(0,F.$xF)(s?.editor)&&(0,F.$xF)(s?.replacement)}var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function l(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[224],Ae([1,0,3,107]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=e.$SD=e.$RD=e.$QD=void 0,e.$UD=R,e.$QD=(0,S.$ti)("editorService"),e.$RD=-1,e.$SD=-2,e.$TD=-3;function R(O){const M=O;return typeof O=="number"||(0,F.$OD)(M)}}),define(Pe[225],Ae([1,0,3,190]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$fM=(0,S.$ui)(F.$Ai)}),define(Pe[108],Ae([1,0,20,5,19,6,11]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=e.$f_b=e.$e_b=e.$d_b=void 0;class p{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$d_b=p;class g{static isHostExtension(t,n,c){if(n.getExtensionDescription(t))return!1;const h=c.getExtensionDescription(t);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(t,n){this.j=t,this.c=new F.$ce,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$Qm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=o(this.e,n),this.e=this.e.concat(t);const c=g.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,v){this.addNode(a),this.addNode(v),this.c.has(a)?this.c.get(a).push(v):this.c.set(a,[v])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,v){const d=n.getArcs(a);for(let P=0;P<d.length;P++)if(!v.has(d[P]))return!1;return!0}getNodes(){return this.e}},c=new S.$Qm;for(const a of t)if(c.set(a.identifier,a),a.extensionDependencies)for(const v of a.extensionDependencies)n.addArc(S.$Om.toKey(a.identifier),S.$Om.toKey(v));const h=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>h.add(a));const i=n.getNodes().filter(a=>!h.has(a));let $;do{$=!1;for(let a=0;a<i.length;a++){const v=i[a];n.hasOnlyGoodArcs(v,h)&&(i.splice(a,1),a--,h.add(v),$=!0)}}while($);return i.map(a=>c.get(a))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$e_b=g;class k{constructor(t,n){this.versionId=t,this.extensions=n}}e.$f_b=k;class N{constructor(t){this.d=new b,this.c=new g(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new y(this,n)}deltaExtensions(t,n,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$g_b=N;class y extends O.$Vc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$h_b=y;class l{constructor(t){this.name=t;const n=(0,M.$mh)();this.promise=n.promise,this.c=n.resolve}resolve(t){this.c(t)}}class b{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new l(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};t.resolve((0,O.$Tc)(h))}}var m;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(m||(m={}));function s(r,t){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==c)return n-c;const h=R.$hc.basename(r.extensionLocation.path),i=R.$hc.basename(t.extensionLocation.path);return h<i?-1:h>i?1:0}function o(r,t){const n=new S.$Pm(t);return r.filter(c=>!n.has(c.identifier))}}),define(Pe[77],Ae([1,0,22]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Wm=M,e.$Xm=p;var F;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(F||(e.UIKind=F={}));var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var O;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(k){const N=S.$De.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function p(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var g;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[62],Ae([1,0,3,5,13,27,77,58,59,25,2,6,170]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$zP=e.$yP=void 0,e.$AP=s;let b=class extends y.$Vc{constructor(r,t){super(),this.s=r,this.t=t,this.a=this.B(new F.$ce),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$ce),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:g.$hp,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(n=>{(0,R.$2j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,t,n){const c=this.getTelemetryDetails(),h=new m(t,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,t,n){this.f=r,this.g=t,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const t=Object.create(null);switch(t["common.extname"]=`${r.publisher}.${r.name}`,t["common.extversion"]=r.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:t["common.uikind"]="web";break;case M.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,p.$Fm)((0,g.$np)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const t=this.getTelemetryDetails();this.r.forEach((n,c)=>{const h=n.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,t){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(t),h=!0);return h}};e.$yP=b,e.$yP=b=Je([We(0,O.$xP),We(1,R.$1j)],b);class m{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,t,n,c,h,i,$){this.g=n,this.h=c,this.i=h,this.j=i,this.a=new F.$ce,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(r,t){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let t="properties"in r?r.properties??{}:r;return t=(0,g.$qp)(t,[]),this.c&&(t=(0,k.$3n)(t,this.c)),this.b||(t=(0,k.$3n)(t,this.j)),"properties"in r?r.properties=t:r=t,r}k(r,t){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(r,t),this.h.trace(r,t))}logUsage(r,t){this.d.isUsageEnabled&&this.k(r,t)}logError(r,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,t);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,g.$qp)(n,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(h,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const r=this,t={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$zP=m;function s(o){const r=Date.now()-new Date(o).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$BP=(0,S.$ti)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,199,103,20,3]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.ActivationKind=e.$EG=e.$DG=e.$AG=e.ExtensionHostStartup=e.$zG=e.$yG=e.$xG=e.$wG=void 0,e.$BG=l,e.$CG=b,e.$FG=r,e.$GG=t,e.$wG=Object.freeze({identifier:new M.$Om("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xG="extensions.webWorker",e.$yG=(0,p.$ti)("extensionService");class g{constructor(h){this.dependency=h}}e.$zG=g;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,$){this.c=h,this.d=i.slice(0),this.e=$.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$hG.createActivationEventsMap(this.d)}}set(h,i,$){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],v=[],d=[],P=[],u=y(this.d),E=y(i),f=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=E.get(W.identifier);if(!V){a.push(W.identifier),u.delete(W.identifier);continue}if(!f(W,V)){a.push(W.identifier),u.delete(W.identifier);continue}}for(const W of i){const V=u.get(W.identifier);if(!V){v.push(W);continue}if(!f(V,W)){a.push(V.identifier),u.delete(V.identifier);continue}}const D=new M.$Pm(this.e),w=new M.$Pm($);for(const W of this.e)w.has(W)||d.push(W);for(const W of $)D.has(W)||P.push(W);const C=O.$hG.createActivationEventsMap(v),I={versionId:h,toRemove:a,toAdd:v,addActivationEvents:C,myToRemove:d,myToAdd:P};return this.delta(I),I}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:$,myToRemove:a,myToAdd:v}=h,d=new M.$Pm(i),P=new M.$Pm(a);for(let u=0;u<this.d.length;u++)d.has(this.d[u].identifier)&&(this.d.splice(u,1),u--);for(let u=0;u<this.e.length;u++)P.has(this.e[u])&&(this.e.splice(u,1),u--);for(const u of $)this.d.push(u);for(const u of v)this.e.push(u);return this.f=null,h}containsExtension(h){for(const i of this.e)if(M.$Om.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const $=O.$hG.readActivationEvents(i);for(const a of $)h.add(a)}return h}}e.$AG=N;function y(c){const h=new M.$Qm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function b(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(h,i,$,a){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=$,this.activationReason=a}}e.$DG=m;class s{constructor(h,i){this.description=h,this.value=i}}e.$EG=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$wp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function t(c,h){return{identifier:new M.$Om((0,R.$up)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HG=n}),define(Pe[226],Ae([1,0,14,108,20,26,13,11]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=e.$ilc=e.$hlc=e.$glc=e.$flc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(r,t,n,c){this.startup=r,this.codeLoadingTime=t,this.activateCallTime=n,this.activateResolvedTime=c}}e.$flc=g;class k{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,t){return r===-1||t===-1?-1:t-r}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$glc=k;class N{constructor(r,t,n,c,h,i){this.activationFailed=r,this.activationFailedError=t,this.activationTimes=n,this.module=c,this.exports=h,this.subscriptions=i}}e.$hlc=N;class y extends N{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ilc=y;class l extends N{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$jlc=l;class b extends N{constructor(r){super(!0,r,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(r,t,n,c){this.g=c,this.a=r,this.b=t,this.c=n,this.d=new R.$Qm,this.f=Object.create(null)}dispose(){for(const[r,t]of this.d)t.dispose()}async waitForActivatingExtensions(){const r=[];for(const[t,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const t=this.d.get(r);return!!(t&&t.value)}getActivatedExtension(r){const t=this.d.get(r);if(!t||!t.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return t.value}async activateByEvent(r,t){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(c=>({id:c.identifier,reason:{startup:t,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,t){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r.value}' is not known`);return this.h([{id:n.identifier,reason:t}])}async h(r){const t=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(t.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const t=this.a.getExtensionDescription(r.id);if(!t){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new b(h));return this.c.onExtensionActivationError(r.id,h,new O.$zG(r.id.value)),i}const n=[],c=typeof t.extensionDependencies>"u"?[]:t.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){n.push(i);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const $=this.a.getExtensionDescription(h);if($){if(!$.main&&!$.browser)continue;n.push(this.j({id:$.identifier,reason:r.reason}));continue}const a=t.displayName||t.identifier.value,v=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),d=this.k(r,t.displayName,[],new b(v));return this.c.onExtensionActivationError(t.identifier,v,new O.$zG(h)),d}return this.k(r,t.displayName,n,null)}k(r,t,n,c){const h=new s(r.id,t,r.reason,n,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return F.$e_b.isHostExtension(r,this.a,this.b)}m(r){const t=this.b.getExtensionDescription(r);return t?!t.main&&!t.browser:!1}};e.$klc=m,e.$klc=m=Je([We(3,M.$Zj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,t,n,c,h,i,$){this.c=r,this.d=t,this.f=n,this.g=c,this.h=h,this.j=i,this.k=$,this.a=new p.$sh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const t=this.g[r];if(t.value&&!t.value.activationFailed){this.g.splice(r,1),r--;continue}if(t.value&&t.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${t.friendlyName}' failed to activate`);n.detail=t.value.activationFailedError,this.h=new b(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const t=new Error;if(r&&r.name&&(t.name=r.name),r&&r.message?t.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:t.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(t.stack=r.stack),this.h=new b(t),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,t,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([We(6,M.$Zj)],s)}),define(Pe[227],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[228],Ae([1,0,185,14,33,98,72,30,20,227,195,103]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0;const l=p.$_n.as(M.$ao.JSONContribution);class b{constructor(h,i,$){this.a=h,this.b=i,this.c=$}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$qG=b;class m{static a(h){const i=new g.$Pm;for(let $=0,a=h.length;$<a;$++)i.add(h[$].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new m(i,[]);if(!i||!i.length)return new m([],h);const $=this.a(h),a=this.a(i),v=i.filter(P=>!$.has(P.description.identifier)),d=h.filter(P=>!a.has(P.description.identifier));return new m(v,d)}constructor(h,i){this.added=h,this.removed=i}}e.$rG=m;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$sG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$tG={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Nm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Qo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Qo}},extensionKind:{description:S.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class t{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&y.$hG.register(h.extensionPoint,h.activationEventsGenerator),e.$tG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$tG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$uG=t;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$_n.add(n.ExtensionsRegistry,new t),e.$vG=p.$_n.as(n.ExtensionsRegistry),l.registerSchema(r,e.$tG),l.registerSchema(N.$hk,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Pe[229],Ae([1,0,181,17,25,228,31,5]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var k;(function(l){function b(m,s,o){if(!m)return;const r=F.$6f(m.type)?m.type:void 0;if(!r||r.length===0){o.error(S.localize(3,null));return}const t=[];if(Array.isArray(m.required))for(const n of m.required)F.$6f(n)&&t.push(n);return{extensionId:s.value,taskType:r,required:t,properties:m.properties?R.$Zn(m.properties):{},when:m.when?M.$rj.deserialize(m.when):void 0}}l.from=b})(k||(k={}));const N=O.$vG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const m of l)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:g}});class y{constructor(){this.d=new p.$ce,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{N.setHandler((s,o)=>{this.c=void 0;try{for(const r of o.removed){const t=r.value;for(const n of t)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of o.added){const t=r.value;for(const n of t){const c=k.from(n,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=R.$Zn(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},b.push(s)}this.c={oneOf:b}}return this.c}}e.$ZH=new y}),define(Pe[230],Ae([1,0,182,17,23,25,31,229]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$0H=e.JsonSchemaVersion=e.ExecutionEngine=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$4H=e.ShellQuoting=e.$3H=e.$2H=e.$1H=void 0,e.$1H="settings",e.$2H=new M.$Kj("taskRunning",!1,S.localize(0,null)),e.$3H=S.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$4H="$customized",function(A){function j(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=j}(g||(e.ShellQuoting=g={}));var k;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var N;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(N||(e.RevealKind=N={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=j}(N||(e.RevealKind=N={}));var y;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=j}(y||(e.RevealProblemKind=y={}));var l;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(l||(e.PanelKind=l={})),function(A){function j(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=j}(l||(e.PanelKind=l={}));var b;(function(A){A.defaults={echo:!0,reveal:N.Always,revealProblems:y.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var m;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(A){function j(re){switch(re.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=j;function K(re){switch(re){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(m||(e.RuntimeType=m={}));var s;(function(A){function j(K){return F.$6f(K)?K:K.value}A.value=j})(s||(e.CommandString=s={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function j(re){return re===A.Clean._id||re===A.Build._id||re===A.Rebuild._id||re===A.Test._id}A.is=j;function K(re){if(re!==void 0)return F.$6f(re)?j(re)?{_id:re,isDefault:!1}:void 0:re}A.from=K})(o||(e.TaskGroup=o={}));var r;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var t;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function j(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=j})(t||(e.TaskSourceKind=t={}));var n;(function(A){A.parallel="parallel",A.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(j,K,re,ae,be,Ie){this._label="",this._id=j,K&&(this._label=K),re&&(this.type=re),this.runOptions=ae,this.configurationProperties=be,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(F.$6f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$5H=i;class $ extends i{constructor(j,K,re,ae,be,Ie,de,me){super(j,re,void 0,de,me,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,be&&(this.command=be)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof $}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$1H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(K+=this._source.kind);const re={type:e.$4H,folder:j,id:K};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$4g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new $(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$6H=$;class a extends i{constructor(j,K,re,ae,be,Ie,de){super(j,re,ae,Ie,de,K),this._source=K,this.configures=be}static is(j){return j instanceof a}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$4g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$1H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(K+=this._source.kind);const re={type:e.$4H,folder:j,id:K};return JSON.stringify(re)}}e.$7H=a;class v extends i{constructor(j,K,re,ae,be,Ie,de,me,Me){super(j,re,ae,me,Me,K),this.defines=be,this.hasDefinedMatchers=de,this.command=Ie,this.icon=Me.icon,this.hide=Me.hide}clone(){return new v(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof v}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new v(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$8H=v;class d extends i{constructor(j,K,re,ae,be,Ie){super(j,re,ae,be,Ie,K),this._source=K}clone(){return new d(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof d}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new d(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$9H=d;var P;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(P||(e.ExecutionEngine=P={})),function(A){A._default=A.Terminal}(P||(e.ExecutionEngine=P={}));var u;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class E{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const re=j.getWorkspaceFolder(),ae=K.getWorkspaceFolder();if(re&&ae){let be=this.c.get(re.uri.toString());be=be===void 0?0:be+1;let Ie=this.c.get(ae.uri.toString());return Ie=Ie===void 0?0:Ie+1,be===Ie?j._label.localeCompare(K._label):be-Ie}else return!re&&ae?-1:re&&!ae?1:0}}e.$0H=E;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var D;(function(A){A.SingleRun="singleRun",A.Background="background"})(D||(e.TaskRunType=D={}));var w;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var C;(function(A){function j(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function K(me,Me,ce){return{...j(me),kind:"start",terminalId:Me,resolvedVariables:ce}}A.start=K;function re(me,Me,ce){return{...j(me),kind:"processStarted",terminalId:Me,processId:ce}}A.processStarted=re;function ae(me,Me,ce){return{...j(me),kind:"processEnded",terminalId:Me,exitCode:ce}}A.processEnded=ae;function be(me,Me,ce){return{...j(me),kind:"terminated",exitReason:ce,terminalId:Me}}A.terminated=be;function Ie(me,Me,ce){return{...j(Me),kind:me,terminalId:ce}}A.general=Ie;function de(){return{kind:"changed"}}A.changed=de})(C||(e.TaskEvent=C={}));var I;(function(A){function j(re){const ae=Object.keys(re).sort();let be="";for(const Ie of ae){let de=re[Ie];de instanceof Object?de=j(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),be+=Ie+","+de+","}return be}function K(re){const be={_key:j(re),type:re.taskType};return Object.assign(be,re),be}A.create=K})(I||(e.KeyedTaskIdentifier=I={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function j(K,re){const ae=p.$ZH.get(K.type);if(ae===void 0){const me=O.$Zn(K);return delete me._key,I.create(me)}const be=Object.create(null);be.type=ae.taskType;const Ie=new Set;ae.required.forEach(me=>Ie.add(me));const de=ae.properties;for(const me of Object.keys(de)){const Me=K[me];if(Me!=null)be[me]=Me;else if(Ie.has(me)){const ce=de[me];if(ce.default!==void 0)be[me]=O.$Zn(ce.default);else switch(ce.type){case"boolean":be[me]=!1;break;case"number":case"integer":be[me]=0;break;case"string":be[me]="";break;default:re.error(S.localize(1,null,JSON.stringify(K,void 0,0),me));return}}}return I.create(be)}A.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Pe[231],Ae([1,0,14]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,S.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$i_b=F;class R extends F{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$j_b=R}),define(Pe[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$nw=void 0,e.$ow=R,e.$pw=O;class S{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++S.count}}e.$nw=S;const F=[];function R(p){const g=new S(p);return F[g.nid]=g,g}function O(p){return F[p].sid}class M{constructor(g){this.value=g}}e.$qw=M}),define(Pe[4],Ae([1,0,34]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$TM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$TM=y;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$UM={MainThreadAuthentication:(0,S.$ow)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$ow)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$ow)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$ow)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$ow)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$ow)("MainThreadClipboard"),MainThreadCommands:(0,S.$ow)("MainThreadCommands"),MainThreadComments:(0,S.$ow)("MainThreadComments"),MainThreadConfiguration:(0,S.$ow)("MainThreadConfiguration"),MainThreadConsole:(0,S.$ow)("MainThreadConsole"),MainThreadDebugService:(0,S.$ow)("MainThreadDebugService"),MainThreadDecorations:(0,S.$ow)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$ow)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$ow)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$ow)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$ow)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$ow)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$ow)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$ow)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$ow)("MainThreadErrors"),MainThreadTreeViews:(0,S.$ow)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$ow)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$ow)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$ow)("MainThreadLanguages"),MainThreadLogger:(0,S.$ow)("MainThreadLogger"),MainThreadMessageService:(0,S.$ow)("MainThreadMessageService"),MainThreadOutputService:(0,S.$ow)("MainThreadOutputService"),MainThreadProgress:(0,S.$ow)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$ow)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$ow)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$ow)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$ow)("MainThreadSecretState"),MainThreadStorage:(0,S.$ow)("MainThreadStorage"),MainThreadSpeech:(0,S.$ow)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$ow)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$ow)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,S.$ow)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,S.$ow)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$ow)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$ow)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$ow)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$ow)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$ow)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$ow)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$ow)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$ow)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$ow)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$ow)("MainThreadExtensionService"),MainThreadSCM:(0,S.$ow)("MainThreadSCM"),MainThreadSearch:(0,S.$ow)("MainThreadSearch"),MainThreadShare:(0,S.$ow)("MainThreadShare"),MainThreadTask:(0,S.$ow)("MainThreadTask"),MainThreadWindow:(0,S.$ow)("MainThreadWindow"),MainThreadLabelService:(0,S.$ow)("MainThreadLabelService"),MainThreadNotebook:(0,S.$ow)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$ow)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$ow)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$ow)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$ow)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$ow)("MainThreadInteractive"),MainThreadInlineChat:(0,S.$ow)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$ow)("MainThreadTheming"),MainThreadTunnelService:(0,S.$ow)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$ow)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$ow)("MainThreadTimeline"),MainThreadTesting:(0,S.$ow)("MainThreadTesting"),MainThreadLocalization:(0,S.$ow)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$ow)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$ow)("MainThreadAiEmbeddingVector")},e.$VM={ExtHostCommands:(0,S.$ow)("ExtHostCommands"),ExtHostConfiguration:(0,S.$ow)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$ow)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$ow)("ExtHostDebugService"),ExtHostDecorations:(0,S.$ow)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$ow)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$ow)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$ow)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$ow)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$ow)("ExtHostEditors"),ExtHostTreeViews:(0,S.$ow)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$ow)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$ow)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$ow)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$ow)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$ow)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$ow)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$ow)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$ow)("ExtHostStatusBar"),ExtHostShare:(0,S.$ow)("ExtHostShare"),ExtHostExtensionService:(0,S.$ow)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$ow)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$ow)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,S.$ow)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,S.$ow)("ExtHostSCM"),ExtHostSearch:(0,S.$ow)("ExtHostSearch"),ExtHostTask:(0,S.$ow)("ExtHostTask"),ExtHostWorkspace:(0,S.$ow)("ExtHostWorkspace"),ExtHostWindow:(0,S.$ow)("ExtHostWindow"),ExtHostWebviews:(0,S.$ow)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$ow)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$ow)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$ow)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$ow)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$ow)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$ow)("ExtHostProgress"),ExtHostComments:(0,S.$ow)("ExtHostComments"),ExtHostSecretState:(0,S.$ow)("ExtHostSecretState"),ExtHostStorage:(0,S.$ow)("ExtHostStorage"),ExtHostUrls:(0,S.$ow)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$ow)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$ow)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$ow)("ExtHostOutputService"),ExtHostLabelService:(0,S.$ow)("ExtHostLabelService"),ExtHostNotebook:(0,S.$ow)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$ow)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$ow)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$ow)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$ow)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$ow)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$ow)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$ow)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,S.$ow)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$ow)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$ow)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$ow)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$ow)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$ow)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$ow)("ExtHostTheming"),ExtHostTunnelService:(0,S.$ow)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$ow)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$ow)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$ow)("ExtHostTimeline"),ExtHostTesting:(0,S.$ow)("ExtHostTesting"),ExtHostTelemetry:(0,S.$ow)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$ow)("ExtHostLocalization")}}),define(Pe[78],Ae([1,0,3,13,4,16]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=e.$Ekc=void 0,e.$Ekc=(0,S.$ti)("IExtHostApiDeprecationService");let M=class{constructor(g,k){this.c=k,this.a=new Set,this.b=g.getProxy(R.$UM.MainThreadTelemetry)}report(g,k,N){const y=this.d(g,k);this.a.has(y)||(this.a.add(y),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:g}))}d(g,k){return`${g}-${k.identifier.value}`}};e.$Fkc=M,e.$Fkc=M=Je([We(0,O.$hP),We(1,F.$Zj)],M),e.$Gkc=Object.freeze(new class{report(p,g,k){}})}),define(Pe[232],Ae([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class F{constructor(O){const M=O.getProxy(S.$UM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$Tkc=F}),define(Pe[233],Ae([1,0,25,4,27,16]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;let M=class{constructor(N,y){this.a=N.getProxy(F.$UM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,y){const l=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){l.e(N,y,b,arguments)}})}e(N,y,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:g(b,this.b)}),this.c&&this.f(N,l,b)}};e.$Nmc=M,e.$Nmc=M=Je([We(0,O.$hP),We(1,R.$xP)],M);const p=1e5;function g(k,N){const y=[];if(k.length)for(let l=0;l<k.length;l++){let b=k[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}y.push(b)}if(N){const l=new Error().stack;l&&y.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$5n)(y);return l.length>p?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[234],Ae([1,0,2,4,26]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class O{constructor(p){this.a=p.getProxy(F.$UM.MainThreadDialogs)}showOpenDialog(p,g){return g?.allowUIResources&&(0,R.$CG)(p,"showLocal"),this.a.$showOpenDialog(g).then(k=>k?k.map(N=>S.URI.revive(N)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(g=>g?S.URI.revive(g):void 0)}}e.$Qlc=O}),define(Pe[235],Ae([1,0,6,4]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(F.$UM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,S.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$$lc=R}),define(Pe[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;let N=class{constructor(l,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(p.$UM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,b){const{message:m,args:s,comment:o}=b;if(this.c)return(0,F.$7e)(m,s??{});let r=m;o&&o.length>0&&(r+=`/${Array.isArray(o)?o.join(""):o}`);const t=this.d.get(l)?.contents[r];return t||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,F.$7e)(t??m,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const m=await this.g(l);if(!m){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);b=l.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${m}: ${s.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:m})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return R.URI.revive(b)}return l.l10n?R.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ylc=N,e.$ylc=N=Je([We(0,g.$xP),We(1,k.$hP),We(2,M.$Zj)],N),e.$zlc=(0,O.$ti)("IExtHostLocalizationService")}),define(Pe[236],Ae([1,0,13,4,27,16,2,53]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;let g=class extends S.$$j{constructor(y,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,p.$3h)(b))),this.r=y.getProxy(F.$UM.MainThreadLogger)}$setLogLevel(y,l){l?this.setLogLevel(M.URI.revive(l),y):this.setLogLevel(y)}setVisibility(y,l){super.setVisibility(y,l),this.r.$setVisibility(y,l)}s(y,l,b){return new k(this.r,y,l,b)}};e.$Mmc=g,e.$Mmc=g=Je([We(0,O.$hP),We(1,R.$xP)],g);class k extends S.$6j{constructor(y,l,b,m){super(m?.logLevel==="always"),this.r=y,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,m).then(()=>{this.u(this.n),this.m=!0})}g(y,l){const b=[[y,l]];this.m?this.u(b):this.n.push(...b)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Ae([1,0,4,3,6,16,22]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0,e.$Alc=(0,F.$ti)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(S.$UM.MainThreadManagedSockets)}setFactory(y,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(y,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const l=++this.b,b=await this.c.makeConnection(),m=new R.$Uc;return this.d.set(l,new k(l,b,m)),m.add((0,R.$Tc)(()=>this.d.delete(l))),m.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),m.dispose()})),m.add(b.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),m.dispose()})),m.add(b.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,M.$De.wrap(s)))),l}$remoteSocketWrite(y,l){this.d.get(y)?.actual.send(l.buffer)}$remoteSocketEnd(y){const l=this.d.get(y);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Blc=p,e.$Blc=p=Je([We(0,O.$hP)],p);class g{constructor(y,l){this.socketFactoryId=y,this.makeConnection=l}}class k extends R.$Vc{constructor(y,l,b){super(),this.socketId=y,this.actual=l,this.B(b)}}}),define(Pe[237],Ae([1,0,4,13,26]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;function O(p){return p&&p.title}let M=class{constructor(g,k){this.b=k,this.a=g.getProxy(S.$UM.MainThreadMessageService)}showMessage(g,k,N,y,l){const b={source:{identifier:g.identifier,label:g.displayName||g.name}};let m;typeof y=="string"||O(y)?m=[y,...l]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,m=l),b.useCustom&&(0,R.$CG)(g,"resolvers");const s=[];let o=!1;for(let r=0;r<m.length;r++){const t=m[r];if(typeof t=="string")s.push({title:t,handle:r,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:c}=t;s.push({title:n,isCloseAffordance:!!c,handle:r}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,t):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,t)}return this.a.$showMessage(k,N,b,s).then(r=>{if(typeof r=="number")return m[r]})}};e.$amc=M,e.$amc=M=Je([We(1,F.$Zj)],M)}),define(Pe[238],Ae([1,0,6,17,2,26,4]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(M.$UM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,N,y){if((0,O.$CG)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,y),this.a.$registerProfileContentHandler(N,y.name,y.description,k.identifier.value),(0,S.$Tc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,y,l){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(N,y,l)}async $readProfile(k,N,y){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,F.$6f)(N)?N:R.URI.revive(N),y)}}e.$jmc=p}),define(Pe[81],Ae([1,0,4,5,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;class O{constructor(p){this.b=new F.$ce,this.onDidChangePassword=this.b.event,this.a=p.getProxy(S.$UM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,g){return this.a.$getPassword(p,g)}store(p,g,k){return this.a.$setPassword(p,g,k)}delete(p,g){return this.a.$deletePassword(p,g)}}e.$vlc=O,e.$wlc=(0,R.$ti)("IExtHostSecretState")}),define(Pe[239],Ae([1,0,24,6,4]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class O{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(R.$UM.MainThreadSpeech)}async $createSpeechToTextSession(p,g,k){const N=this.c.get(p);if(!N)return;const y=new F.$Uc,l=new S.$ne;this.d.set(g,l);const b=y.add(N.provideSpeechToTextSession(l.token,k?{language:k}:void 0));y.add(b.onDidChange(m=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,m)})),y.add(l.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,g){const k=this.c.get(p);if(!k)return;const N=new F.$Uc,y=new S.$ne;this.d.set(g,y);const l=N.add(k.provideKeywordRecognitionSession(y.token));N.add(l.onDidChange(b=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,b)})),N.add(y.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,g,k){const N=O.a++;return this.c.set(N,k),this.b.$registerProvider(N,g,{extension:p,displayName:p.value}),(0,F.$Tc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$qmc=O}),define(Pe[82],Ae([1,0,4,5,3]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0;class O{constructor(p,g){this.c=g,this.b=new F.$ce,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(S.$UM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,g){this.a.$registerExtensionStorageKeysToSync(p,g)}async initializeExtensionStorage(p,g,k){const N=await this.a.$initializeExtensionStorage(p,g);let y;return N&&(y=this.d(p,g,N)),y||k}setValue(p,g,k){return this.a.$setValue(p,g,k)}$acceptValue(p,g,k){const N=this.d(p,g,k);N&&this.b.fire({shared:p,key:g,value:N})}d(p,g,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${p}): ${N}`)}}}e.$llc=O,e.$mlc=(0,R.$ti)("IExtHostStorage")}),define(Pe[240],Ae([1,0,6,12,2,4]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class M{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(O.$UM.MainThreadUriOpeners)}registerExternalUriOpener(g,k,N,y){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=y.schemes.find(b=>!M.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,y.schemes,g,y.label),(0,S.$Tc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener with id: ${g}`);const l=R.URI.revive(k);return y.canOpenExternalUri(l,N)}async $openUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener id: '${g}'`);return y.openExternalUri(R.URI.revive(k.resolvedUri),{sourceUri:R.URI.revive(k.sourceUri)},N)}}e.$Gmc=M}),define(Pe[241],Ae([1,0,4,2,6,14,20]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class p{static{this.a=0}constructor(k){this.c=new M.$Pm,this.d=new Map,this.b=k.getProxy(S.$UM.MainThreadUrls)}registerUriHandler(k,N){const y=k.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const l=p.a++;return this.c.add(y),this.d.set(l,N),this.b.$registerUriHandler(l,y,k.displayName||k.name),(0,R.$Tc)(()=>{this.c.delete(y),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,N){const y=this.d.get(k);if(!y)return Promise.resolve(void 0);try{y.handleUri(F.URI.revive(N))}catch(l){(0,O.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this.b.$createAppUri(k))}}e.$Hmc=p}),define(Pe[63],Ae([1,0,5,6,12,25,2,188,210,76,4]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$9kc=void 0,e.$0kc=l,e.$_kc=s,e.$alc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,i,$,a,v,d){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$ce,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$ce,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=i,this.#n=$,this.#s=a,this.#r=v,this.#l=l(v),this.#d=b(v),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$jyb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$iyb}return k.$iyb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$4n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$tob)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,v,d,P,u)=>{const E=M.URI.from({scheme:d||"file",path:decodeURIComponent(P)}),f=(0,k.$jyb)(E,{isRemote:h,authority:i}).toString();return`${a}${f}${u}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,v,d,P,u)=>{const E=M.URI.from({scheme:d||"file",path:decodeURIComponent(P)}),f=(0,k.$jyb)(E,{isRemote:h,authority:i}).toString();return`${a}${f}${u}`})}}e.$9kc=y;function l(n){try{const c=(0,p.$Fp)((0,p.$Ep)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(n){try{const c=(0,p.$Fp)((0,p.$Ep)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends F.$Vc{constructor(c,h,i,$,a){super(),this.c=h,this.f=i,this.g=$,this.h=a,this.b=new Map,this.a=c.getProxy(N.$UM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const $=this.j(c);if($){const{message:a}=(0,g.$uob)(h,i.value);$._onMessageEmitter.fire(a)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const $=new y(c,this.a,r(h),this.c,this.f,i,this.h);this.b.set(c,$);const a=$._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return $}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$$kc=m;function s(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(n,c)}}function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>M.URI.from(c))}}function t(n,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),n.extensionLocation]}}),define(Pe[109],Ae([1,0,5,12,15,2,3,16,4]),function(ge,e,S,F,R,O,M,p,g){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;let N=class{static{k=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new S.$ce,this.onDidChangeWindowState=this.c.event,this.d=k.a,this.b=l.getProxy(g.$UM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:m})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,b){b!==this.d[l]&&(this.d={...this.d,[l]:b},this.c.fire(this.d))}openUri(l,b){let m;if(typeof l=="string"){m=l;try{l=O.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,R.$5e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,m,b)}async asExternalUri(l,b){if((0,R.$5e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this.b.$asExternalUri(l,b);return O.URI.from(m)}};e.$Jmc=N,e.$Jmc=N=k=Je([We(0,p.$hP)],N),e.$Kmc=(0,M.$ti)("IExtHostWindow")}),define(Pe[242],Ae([1,0,233,27,16]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;let O=class extends S.$Nmc{constructor(p,g){super(p,g)}f(p,g,k){g.apply(console,k)}};e.$Voc=O,e.$Voc=O=Je([We(0,R.$hP),We(1,F.$xP)],O)}),define(Pe[243],Ae([1,0,11,22,24,14,5,6,144,231,34]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$k_b=o,e.$l_b=r;function l(w,C){try{return JSON.stringify(w,C)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class s{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function o(w,C=null,I=!1){const W=[];return{jsonString:(I?l:JSON.stringify)(w,(q,A)=>{if(typeof A>"u")return m;if(typeof A=="object"){if(A instanceof F.$De){const j=W.push(A)-1;return{[b]:j}}if(C)return C(q,A)}return A}),referencedBuffers:W}}function r(w,C,I){return JSON.parse(w,(W,V)=>{if(V){const q=V[b];if(typeof q=="number")return C[q];if(I&&V.$mid===1)return I.transformIncoming(V)}return V})}function t(w,C){return JSON.stringify(w,C)}function n(w){return w?(C,I)=>I&&I.$mid===1?w.transformOutgoing(I):I:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},$=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class v extends p.$Vc{static{y=$}static{this.a=3*1e3}constructor(C,I=null,W=null){super(),this[y]=!0,this.b=this.B(new M.$ce),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=N.$nw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$Fh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+v.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+v.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,g.$yn)(C,this.g):C}getProxy(C){const{nid:I,sid:W}=C;return this.s[I]||(this.s[I]=this.J(I,W)),this.s[I]}J(C,I){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(C,q,A)),q===a?I:V[q])};return new Proxy(Object.create(null),W)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,W=C.length;I<W;I++){const V=C[I];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,W=P.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:j,args:K}=E.deserializeRequestJSONArgs(W);this.g&&(K=(0,g.$yn)(K,this.g)),this.M(I,q,A,j,K,V===2);break}case 3:case 4:{let{rpcId:A,method:j,args:K}=E.deserializeRequestMixedArgs(W);this.g&&(K=(0,g.$yn)(K,this.g)),this.M(I,q,A,j,K,V===4);break}case 5:{this.f?.logIncoming(I,q,0,"ack"),this.G(q);break}case 6:{this.N(I,q);break}case 7:{this.O(I,q,void 0);break}case 9:{let A=E.deserializeReplyOKJSON(W);this.g&&(A=(0,g.$yn)(A,this.g)),this.O(I,q,A);break}case 10:{const A=E.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(I,q,A);break}case 8:{const A=E.deserializeReplyOKVSBuffer(W);this.O(I,q,A);break}case 11:{let A=E.deserializeReplyErrError(W);this.g&&(A=(0,g.$yn)(A,this.g)),this.P(I,q,A);break}case 12:{this.P(I,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,W,V,q,A){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,N.$pw)(W)}.${V}(`,q);const j=String(I);let K,re;if(A){const be=new R.$ne;q.push(be.token),K=this.Q(W,V,q),re=()=>be.cancel()}else K=this.Q(W,V,q),re=i;this.u[j]=re;const ae=E.serializeAcknowledged(I);this.f?.logOutgoing(ae.byteLength,I,1,"ack"),this.c.send(ae),K.then(be=>{delete this.u[j];const Ie=E.serializeReplyOK(I,be,this.h);this.f?.logOutgoing(Ie.byteLength,I,1,"reply:",be),this.c.send(Ie)},be=>{delete this.u[j];const Ie=E.serializeReplyErr(I,be);this.f?.logOutgoing(Ie.byteLength,I,1,"replyErr:",be),this.c.send(Ie)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const W=String(I);this.u[W]?.()}O(C,I,W){this.f?.logIncoming(C,I,0,"receiveReply:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,I,W){this.f?.logIncoming(C,I,0,"receiveReplyErr:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(C,I,W){try{return Promise.resolve(this.S(C,I,W))}catch(V){return Promise.reject(V)}}S(C,I,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,N.$pw)(C));const q=V[I];if(typeof q!="function")throw new Error("Unknown method "+I+" on actor "+(0,N.$pw)(C));return q.apply(V,W)}U(C,I,W){if(this.j)return new k.$j_b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$6());const q=E.serializeRequestArguments(W,this.h),A=++this.t,j=String(A),K=new k.$i_b,re=new p.$Uc;V&&re.add(V.onCancellationRequested(()=>{const be=E.serializeCancel(A);this.f?.logOutgoing(be.byteLength,A,0,"cancel"),this.c.send(E.serializeCancel(A))})),this.w[j]=new d(K,re),this.F(A);const ae=E.serializeRequest(A,C,I,q,!!V);return this.f?.logOutgoing(ae.byteLength,A,0,`request: ${(0,N.$pw)(C)}.${I}(`,W),this.c.send(ae),K}}e.$m_b=v;class d{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class P{static alloc(C,I,W){const V=new P(F.$De.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(I),V}static read(C,I){return new P(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(I+=1,q.type){case 1:I+=this.sizeLongString(q.value);break;case 2:I+=this.sizeVSBuffer(q.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)I+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,W=C.length;I<W;I++){const V=C[I];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:I[W]=this.readLongString();break;case 2:I[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());I[W]=new N.$qw(r(A,j,null));break}case 4:I[W]=void 0;break}return I}}var u;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(u||(u={}));class E{static a(C){for(let I=0,W=C.length;I<W;I++)if(C[I]instanceof F.$De||C[I]instanceof N.$qw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const A=C[V];if(A instanceof F.$De)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof N.$qw){const{jsonString:j,referencedBuffers:K}=o(A.value,I);W[V]={type:3,value:F.$De.fromString(j),buffers:K}}else W[V]={type:1,value:F.$De.fromString(t(A,I))}}return{type:1,args:W}}return{type:0,args:t(C,I)}}static serializeRequest(C,I,W,V,q){switch(V.type){case 0:return this.b(C,I,W,V.args,q);case 1:return this.c(C,I,W,V.args,q)}}static b(C,I,W,V,q){const A=F.$De.fromString(W),j=F.$De.fromString(V);let K=0;K+=P.sizeUInt8(),K+=P.sizeShortString(A),K+=P.sizeLongString(j);const re=P.alloc(q?2:1,C,K);return re.writeUInt8(I),re.writeShortString(A),re.writeLongString(j),re.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:I,method:W,args:JSON.parse(V)}}static c(C,I,W,V,q){const A=F.$De.fromString(W);let j=0;j+=P.sizeUInt8(),j+=P.sizeShortString(A),j+=P.sizeMixedArray(V);const K=P.alloc(q?4:3,C,j);return K.writeUInt8(I),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let A=0,j=V.length;A<j;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:I,method:W,args:q}}static serializeAcknowledged(C){return P.alloc(5,C,0).buffer}static serializeCancel(C){return P.alloc(6,C,0).buffer}static serializeReplyOK(C,I,W){if(typeof I>"u")return this.d(C);if(I instanceof F.$De)return this.e(C,I);if(I instanceof N.$qw){const{jsonString:V,referencedBuffers:q}=o(I.value,W,!0);return this.g(C,V,q)}else return this.f(C,l(I,W))}static d(C){return P.alloc(7,C,0).buffer}static e(C,I){let W=0;W+=P.sizeVSBuffer(I);const V=P.alloc(8,C,W);return V.writeVSBuffer(I),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const W=F.$De.fromString(I);let V=0;V+=P.sizeLongString(W);const q=P.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,I,W){const V=F.$De.fromString(I);let q=0;q+=P.sizeUInt32,q+=P.sizeLongString(V);for(const j of W)q+=P.sizeVSBuffer(j);const A=P.alloc(10,C,q);A.writeUInt32(W.length),A.writeLongString(V);for(const j of W)A.writeBuffer(j);return A.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let A=0;A<W;++A)q.push(C.readVSBuffer());return new N.$qw(r(V,q,I))}static serializeReplyErr(C,I){const W=I?l(O.$3(I),null):void 0;if(typeof W!="string")return this.h(C);const V=F.$De.fromString(W);let q=0;q+=P.sizeLongString(V);const A=P.alloc(11,C,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return P.alloc(12,C,0).buffer}}var f;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var D;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(D||(D={}))}),define(Pe[244],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0;const S=function(O){const M=p=>{globalThis.removeEventListener("message",M);const g=p.data;Object.defineProperties(globalThis,{postMessage:{value(k,N){g.postMessage(k,N)}},onmessage:{get(){return g.onmessage},set(k){g.onmessage=k}}}),g.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class F extends EventTarget{constructor(O,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${S})('${M}'))`,k=new Blob([g],{type:"application/javascript"}),N=URL.createObjectURL(k),y=new MessageChannel,l=N,b={type:"_newWorker",id:l,port:y.port2,url:N,options:p};O(b,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:l}),URL.revokeObjectURL(N),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$Xoc=F}),define(Pe[245],Ae([1,0,22,28,12,55,3]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$wK=void 0,e.$xK=N,e.$yK=y,e.$wK=(0,M.$ti)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${p.join("")}]+`),k=7;function N(b){if(b.scheme!==R.Schemas.vscodeNotebookCell)return;const m=b.fragment.indexOf("s");if(m<0)return;const s=parseInt(b.fragment.substring(0,m).replace(g,""),k),o=(0,S.$We)(b.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:b.with({scheme:o,fragment:null})}}function y(b,m){const s=m.toString(k),r=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,S.$Xe)(S.$De.fromString(b.scheme),!0,!0)}`;return b.with({scheme:R.Schemas.vscodeNotebookCell,fragment:r})}class l{constructor(){this.a=new F.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const s=N(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$zK=l,(0,O.$ts)(e.$wK,l,1)}),define(Pe[83],Ae([1,0,22,36,40,69,12,19,21,31,245]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$QK=e.CellStatusbarAlignment=e.$PK=e.NotebookEditorPriority=e.$MK=e.$LK=e.$JK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$IK=e.$HK=e.$GK=e.$FK=e.CellKind=e.$EK=e.$DK=e.$CK=void 0,e.$KK=$,e.$NK=v,e.$OK=d,e.$RK=E,e.$SK=D,e.$CK="workbench.editor.notebook",e.$DK="workbench.editor.notebookTextDiffEditor",e.$EK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$FK=["application/json","application/javascript","text/html","image/svg+xml",O.$Ms.latex,O.$Ms.markdown,"image/png","image/jpeg",O.$Ms.text],e.$GK=[O.$Ms.latex,O.$Ms.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ms.text],e.$HK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$IK="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var r;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var t;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function re(Me,ce){return(0,N.$yK)(Me,ce)}K.generate=re;function ae(Me){return(0,N.$xK)(Me)}K.parse=ae;function be(Me,ce){return Me.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${Me.scheme!==M.Schemas.file?Me.scheme:""}`})}K.generateCellOutputUri=be;function Ie(Me){if(Me.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Me.fragment);if(!ce)return;const Re=ce[1]&&ce[1]!==""?ce[1]:void 0,ie=ce[2];return{outputId:Re,notebook:Me.with({scheme:ie||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function de(Me,ce,Re){return K.generate(Me,ce).with({scheme:Re})}K.generateCellPropertyUri=de;function me(Me,ce){if(Me.scheme===ce)return K.parse(Me.with({scheme:K.scheme}))}K.parseCellPropertyUri=me})(c||(e.CellUri=c={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class i{constructor(re=[],ae=e.$FK){this.e=ae,this.d=[...new Set(re)].map(be=>({pattern:be,matches:F.$nk(h(be))}))}sort(re){const ae=new Map(R.Iterable.map(re,Ie=>[Ie,h(Ie)]));let be=[];for(const{matches:Ie}of this.d)for(const[de,me]of ae)if(Ie(me)){be.push(de),ae.delete(de);break}return ae.size&&(be=be.concat([...ae.keys()].sort((Ie,de)=>this.e.indexOf(Ie)-this.e.indexOf(de)))),be}prioritize(re,ae){const be=this.f(re);if(be===-1){this.d.unshift({pattern:re,matches:F.$nk(h(re))});return}const Ie=new Set(ae.map(me=>this.f(me,be)));Ie.delete(-1);const de=Array.from(Ie).sort();this.d.splice(be+1,0,...de.map(me=>this.d[me]));for(let me=de.length-1;me>=0;me--)this.d.splice(de[me],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ae=this.d.length){const be=h(re);for(let Ie=0;Ie<ae;Ie++)if(this.d[Ie].matches(be))return Ie;return-1}}e.$JK=i;function $(K,re,ae,be=(Ie,de)=>Ie===de){const Ie=[];function de(ce,Re,ie){if(Re===0&&ie.length===0)return;const L=Ie[Ie.length-1];L&&L.start+L.deleteCount===ce?(L.deleteCount+=Re,L.toInsert.push(...ie)):Ie.push({start:ce,deleteCount:Re,toInsert:ie})}let me=0,Me=0;for(;;){if(me===K.length){de(me,0,re.slice(Me));break}if(Me===re.length){de(me,K.length-me,[]);break}const ce=K[me],Re=re[Me];if(be(ce,Re)){me+=1,Me+=1;continue}ae(Re)?(de(me,1,[]),me+=1):(de(me,0,[Re]),Me+=1)}return Ie}e.$LK=new k.$Kj("notebookEditorCursorAtBoundary","none"),e.$MK=new k.$Kj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function v(K){const re=K;return!!((typeof re.include=="string"||F.$ok(re.include))&&(typeof re.exclude=="string"||F.$ok(re.exclude)))}function d(K,re,ae){if(Array.isArray(K.viewType)&&K.viewType.indexOf(re)>=0||K.viewType===re)return!0;if(K.filenamePattern){const be=v(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=v(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(F.$mk(be,(0,p.$oc)(ae.fsPath).toLowerCase()))return!(Ie&&F.$mk(Ie,(0,p.$oc)(ae.fsPath).toLowerCase()))}return!1}e.$PK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var P;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(P||(e.CellStatusbarAlignment=P={}));class u{static{this.d="notebook/"}static create(re){return`${u.d}${re}`}static parse(re){if(re.startsWith(u.d))return re.substring(u.d.length)}}e.$QK=u;function E(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function D(K){const re=[];let ae=!1;for(const me of K)(re.length===0||ae)&&(re.push(me),ae=!0);let be=I(re);const Ie=S.$De.concat(re.map(me=>S.$De.wrap(me))),de=j(Ie);return be=be||de.byteLength!==Ie.byteLength,{data:de,didCompression:be}}e.$TK="\x1B[A";const w=e.$TK.split("").map(K=>K.charCodeAt(0)),C=10;function I(K){let re=!1;return K.forEach((ae,be)=>{if(be===0||ae.length<e.$TK.length)return;const Ie=K[be-1],de=ae.subarray(0,e.$TK.length);if(de[0]===w[0]&&de[1]===w[1]&&de[2]===w[2]){const me=Ie.lastIndexOf(C);if(me===-1)return;re=!0,K[be-1]=Ie.subarray(0,me),K[be]=ae.subarray(e.$TK.length)}}),re}function W(K){let re=K;do K=re,re=K.replace(/[^\n]\x08/gm,"");while(re.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const re=K.match(/^(.*)\r+/m)[1];let ae=K.match(/\r+(.*)$/m)[1];ae=ae+re.slice(ae.length,re.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return K}const q=8,A=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:S.$De.fromString(V(W(f.decode(K.buffer))))}}),define(Pe[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m){"use strict";var s,o,r,t,n,c,h,i,$,a,v,d,P,u,E,f,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$8O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$7O=e.$6O=e.$5O=e.$4O=e.ChatLocation=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$RO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$EO=e.$DO=e.$CO=e.$BO=e.$zO=e.$yO=e.$xO=e.$wO=e.TestRunProfileKind=e.TestResultState=e.$vO=e.$uO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$tO=e.NotebookVariablesRequestKind=e.$sO=e.$rO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$qO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.ColorThemeKind=e.$kO=e.$jO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$iO=e.$hO=e.DebugConsoleMode=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$bO=e.$aO=e.FileChangeType=e.$_N=e.NewSymbolNameTag=e.$$N=e.$0N=e.$9N=e.$8N=e.InlineCompletionTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$UN=e.ConfigurationTarget=e.$TN=e.$SN=e.$RN=e.$QN=e.DocumentPasteTriggerKind=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$JN=e.ViewBadge=e.ProgressLocation=e.$IN=e.$HN=e.TaskScope=e.ShellQuoting=e.$GN=e.$FN=e.$EN=e.TaskPanelKind=e.TaskRevealKind=e.$DN=e.TerminalLocation=e.$CN=e.$BN=e.$AN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$zN=e.$yN=e.$xN=e.$wN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$uN=e.$tN=e.$sN=e.$rN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$qN=e.$pN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.LanguageStatusSeverity=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.CodeActionTriggerKind=e.$dN=e.$cN=e.SymbolTag=e.SymbolKind=e.$bN=e.$aN=e.DocumentHighlightKind=e.$_M=e.$$M=e.$0M=e.$9M=e.DiagnosticSeverity=e.DiagnosticTag=e.$8M=e.$7M=e.FileEditType=e.$6M=e.$5M=e.$4M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$vN=dt,e.$VN=J,e.$AO=Mt;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ke]=te;return Reflect.construct(B,Ke,Ee.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let W=s=class{static from(...T){let te=T;return new s(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$WM=W,e.$WM=W=s=Je([w],W);let V=o=class{static Min(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Ee=1;Ee<T.length;Ee++){const Ke=T[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Ee=1;Ee<T.length;Ee++){const Ke=T[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(T){if(!T)return!1;if(T instanceof o)return!0;const{line:te,character:Ee}=T;return typeof te=="number"&&typeof Ee=="number"}static of(T){if(T instanceof o)return T;if(this.isPosition(T))return new o(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,te){if(T<0)throw(0,F.$7)("line must be non-negative");if(te<0)throw(0,F.$7)("character must be non-negative");this.c=T,this.e=te}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,te=0){if(T===null||te===null)throw(0,F.$7)();let Ee;return typeof T>"u"?Ee=0:typeof T=="number"?Ee=T:(Ee=typeof T.lineDelta=="number"?T.lineDelta:0,te=typeof T.characterDelta=="number"?T.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(T,te=this.character){if(T===null||te===null)throw(0,F.$7)();let Ee;return typeof T>"u"?Ee=this.line:typeof T=="number"?Ee=T:(Ee=typeof T.line=="number"?T.line:this.line,te=typeof T.character=="number"?T.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$XM=V,e.$XM=V=o=Je([w],V);let q=r=class{static isRange(T){return T instanceof r?!0:T?V.isPosition(T.start)&&V.isPosition(T.end):!1}static of(T){if(T instanceof r)return T;if(this.isRange(T))return new r(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,te,Ee,Ke){let Xe,ht;if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Xe=new V(T,te),ht=new V(Ee,Ke)):V.isPosition(T)&&V.isPosition(te)&&(Xe=V.of(T),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");Xe.isBefore(ht)?(this.c=Xe,this.e=ht):(this.c=ht,this.e=Xe)}contains(T){return r.isRange(T)?this.contains(T.start)&&this.contains(T.end):V.isPosition(T)?!(V.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const te=V.Max(T.start,this.c),Ee=V.Min(T.end,this.e);if(!te.isAfter(Ee))return new r(te,Ee)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const te=V.Min(T.start,this.c),Ee=V.Max(T.end,this.end);return new r(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,te=this.end){if(T===null||te===null)throw(0,F.$7)();let Ee;return T?V.isPosition(T)?Ee=T:(Ee=T.start||this.start,te=T.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};e.$YM=q,e.$YM=q=r=Je([w],q);let A=t=class extends q{static isSelection(T){return T instanceof t?!0:T?q.isRange(T)&&V.isPosition(T.anchor)&&V.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,te,Ee,Ke){let Xe,ht;if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Xe=new V(T,te),ht=new V(Ee,Ke)):V.isPosition(T)&&V.isPosition(te)&&(Xe=V.of(T),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");super(Xe,ht),this.f=Xe,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$ZM=A,e.$ZM=A=t=Je([w],A);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class K{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te,Ee){if(typeof T!="string"||T.length===0)throw(0,F.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,F.$7)("port");typeof Ee<"u"&&j(Ee),this.host=T,this.port=Math.round(te),this.connectionToken=Ee}}e.$1M=K;class re{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te){this.makeConnection=T,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$2M=re;class ae extends Error{static NotAvailable(T,te){return new ae(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(T){return new ae(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,te=b.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(T),this._message=T,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ae.prototype)}}e.$3M=ae;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let de=n=class{static isTextEdit(T){return T instanceof n?!0:T?q.isRange(T)&&typeof T.newText=="string":!1}static replace(T,te){return new n(T,te)}static insert(T,te){return n.replace(new q(T,T),te)}static delete(T){return n.replace(T,"")}static setEndOfLine(T){const te=new n(new q(new V(0,0),new V(0,0)),"");return te.newEol=T,te}get range(){return this.c}set range(T){if(T&&!q.isRange(T))throw(0,F.$7)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,F.$7)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,F.$7)("newEol");this.f=T}constructor(T,te){this.c=T,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$4M=de,e.$4M=de=n=Je([w],de);let me=c=class{static isNotebookCellEdit(T){return T instanceof c?!0:T?xe.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,te){return new c(T,te)}static insertCells(T,te){return new c(new xe(T,T),te)}static deleteCells(T){return new c(T,[])}static updateCellMetadata(T,te){const Ee=new c(new xe(T,T),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(T){const te=new c(new xe(0,0),[]);return te.newNotebookMetadata=T,te}constructor(T,te){this.range=T,this.newCells=te}};e.$5M=me,e.$5M=me=c=Je([w],me);class Me{static isSnippetTextEdit(T){return T instanceof Me?!0:T?q.isRange(T.range)&&ie.isSnippetString(T.snippet):!1}static replace(T,te){return new Me(T,te)}static insert(T,te){return Me.replace(new q(T,T),te)}constructor(T,te){this.range=T,this.snippet=te}}e.$6M=Me;var ce;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,te,Ee,Ke){this.c.push({_type:1,from:T,to:te,options:Ee,metadata:Ke})}createFile(T,te,Ee){this.c.push({_type:1,from:void 0,to:T,options:te,metadata:Ee})}deleteFile(T,te,Ee){this.c.push({_type:1,from:T,to:void 0,options:te,metadata:Ee})}e(T,te,Ee){this.c.push({_type:3,metadata:Ee,uri:T,edit:{editType:5,metadata:te},notebookMetadata:te})}f(T,te,Ee,Ke){const Xe=te.start,ht=te.end;(Xe!==ht||Ee.length>0)&&this.c.push({_type:5,uri:T,index:Xe,count:ht-Xe,cells:Ee,metadata:Ke})}g(T,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:T,edit:{editType:3,index:te,metadata:Ee}})}replace(T,te,Ee,Ke){this.c.push({_type:2,uri:T,edit:new de(te,Ee),metadata:Ke})}insert(T,te,Ee,Ke){this.replace(T,new q(te,te),Ee,Ke)}delete(T,te,Ee){this.replace(T,te,"",Ee)}has(T){return this.c.some(te=>te._type===2&&te.uri.toString()===T.toString())}set(T,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Xe;Array.isArray(Ee)?(Ke=Ee[0],Xe=Ee[1]):Ke=Ee,me.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(T,Ke.range.start,Ke.newCellMetadata,Xe):Ke.newNotebookMetadata?this.e(T,Ke.newNotebookMetadata,Xe):this.f(T,Ke.range,Ke.newCells,Xe):Me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:T,range:Ke.range,edit:Ke.snippet,metadata:Xe}):this.c.push({_type:2,uri:T,edit:Ke,metadata:Xe})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===T.toString()&&(this.c[Ee]=void 0);break}}(0,S.$Ib)(this.c)}}get(T){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===T.toString()&&te.push(Ee.edit);return te}entries(){const T=new O.$Bc;for(const te of this.c)if(te._type===2){let Ee=T.get(te.uri);Ee||(Ee=[te.uri,[]],T.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$7M=Re,e.$7M=Re=Je([w],Re);let ie=h=class{static isSnippetString(T){return T instanceof h?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=h.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,te=this.e++){if(typeof T=="function"){const Ee=new h;Ee.e=this.e,T(Ee),this.e=Ee.e,T=Ee.value}else T=h.c(T);return this.value+="${",this.value+=te,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,te=this.e++){const Ee=T.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(T,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$8M=ie,e.$8M=ie=h=Je([w],ie);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=i=class{static isLocation(T){return T instanceof i?!0:T?q.isRange(T.range)&&k.URI.isUri(T.uri):!1}constructor(T,te){if(this.uri=T,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$9M=ve,e.$9M=ve=i=Je([w],ve);let Te=class{static is(T){return T?typeof T.message=="string"&&T.location&&q.isRange(T.location.range)&&k.URI.isUri(T.location.uri):!1}constructor(T,te){this.location=T,this.message=te}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.location.range.isEqual(te.location.range)&&T.location.uri.toString()===te.location.uri.toString()}};e.$0M=Te,e.$0M=Te=Je([w],Te);let ke=class{constructor(T,te,Ee=x.Error){if(!q.isRange(T))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=T,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.severity===te.severity&&T.code===te.code&&T.severity===te.severity&&T.source===te.source&&T.range.isEqual(te.range)&&(0,S.$ub)(T.tags,te.tags)&&(0,S.$ub)(T.relatedInformation,te.relatedInformation,Te.isEqual)}};e.$$M=ke,e.$$M=ke=Je([w],ke);let pe=class{constructor(T,te){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=te}};e.$_M=pe,e.$_M=pe=Je([w],pe);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let Q=class{constructor(T,te=fe.Text){this.range=T,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$aN=Q,e.$aN=Q=Je([w],Q);let X=class{constructor(T,te){this.uri=T,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(T=>T.toJSON())}}};e.$bN=X,e.$bN=X=Je([w],X);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var ue;(function(B){B[B.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let Ne=$=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,te,Ee,Ke,Xe){this.name=T,this.kind=te,this.containerName=Xe,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ve?this.location=Ke:Ee instanceof q&&(this.location=new ve(Ke,Ee)),$.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$cN=Ne,e.$cN=Ne=$=Je([w],Ne);let he=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(a.validate)}constructor(T,te,Ee,Ke,Xe){this.name=T,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Xe,this.children=[],a.validate(this)}};e.$dN=he,e.$dN=he=a=Je([w],he);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Fe=class{constructor(T,te){this.title=T,this.kind=te}};e.$eN=Fe,e.$eN=Fe=Je([w],Fe);let ze=class{static{v=this}static{this.c="."}constructor(T){this.value=T}append(T){return new v(this.value?this.value+v.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+v.c)}};e.$fN=ze,e.$fN=ze=v=Je([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let U=class{constructor(T,te){if(this.range=T,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$gN=U,e.$gN=U=Je([w],U);class z{constructor(T,te,Ee,Ke,Xe,ht){this.kind=T,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Xe,this.selectionRange=ht}}e.$hN=z;class H{constructor(T,te){this.fromRanges=te,this.from=T}}e.$iN=H;class G{constructor(T,te){this.fromRanges=te,this.to=T}}e.$jN=G;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let ne=class{constructor(T,te){this.range=T,this.command=te}get isResolved(){return!!this.command}};e.$kN=ne,e.$kN=ne=Je([w],ne);let Oe=d=class{#e;static isMarkdownString(T){return T instanceof d?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,te=!1){this.#e=new R.$Qk(T,{supportThemeIcons:te})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,te){return this.#e.appendCodeblock(te??"",T),this}};e.$lN=Oe,e.$lN=Oe=d=Je([w],Oe);let Be=class{constructor(T,te){this.label=T,this.documentation=te}};e.$mN=Be,e.$mN=Be=Je([w],Be);let Qe=class{constructor(T,te){this.label=T,this.documentation=te,this.parameters=[]}};e.$nN=Qe,e.$nN=Qe=Je([w],Qe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$oN=_e,e.$oN=_e=Je([w],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(T){this.value=T}};e.$pN=it,e.$pN=it=Je([w],it);let nt=class{constructor(T,te,Ee){this.position=T,this.label=te,this.kind=Ee}};e.$qN=nt,e.$qN=nt=Je([w],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(T,te){this.label=T,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$rN=st,e.$rN=st=Je([w],st);let Y=class{constructor(T=[],te=!1){this.items=T,this.isIncomplete=te}};e.$sN=Y,e.$sN=Y=Je([w],Y);let Z=class{constructor(T,te,Ee){this.insertText=T,this.range=te,this.command=Ee}};e.$tN=Z,e.$tN=Z=Je([w],Z);let $e=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$uN=$e,e.$uN=$e=Je([w],$e);var Ge;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,T){return`${y.$Om.toKey(B)}.${T}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var Ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Ct;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(B){function T(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=T}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function T(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=T}(Wt||(e.SyntaxTokenType=Wt={}));let Zt=class{constructor(T,te){if(te&&!k.URI.isUri(te))throw(0,F.$7)("target");if(!q.isRange(T)||T.isEmpty)throw(0,F.$7)("range");this.range=T,this.target=te}};e.$wN=Zt,e.$wN=Zt=Je([w],Zt);let Ye=class{constructor(T,te,Ee,Ke){this.red=T,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$xN=Ye,e.$xN=Ye=Je([w],Ye);let si=class{constructor(T,te){if(te&&!(te instanceof Ye))throw(0,F.$7)("color");if(!q.isRange(T)||T.isEmpty)throw(0,F.$7)("range");this.range=T,this.color=te}};e.$yN=si,e.$yN=si=Je([w],si);let Yt=class{constructor(T){if(!T||typeof T!="string")throw(0,F.$7)("label");this.label=T}};e.$zN=Yt,e.$zN=Yt=Je([w],Yt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var bt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(bt||(e.SourceControlInputBoxValidationType=bt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Xt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Xt||(e.TerminalShellExecutionCommandLineConfidence=Xt={}));class Lt{constructor(T,te,Ee){if(this.startIndex=T,this.length=te,this.tooltip=Ee,typeof T!="number"||T<0)throw(0,F.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,F.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,F.$7)("tooltip")}}e.$AN=Lt;class ft{constructor(T){this.uri=T}}e.$BN=ft;class jt{constructor(T){this.terminalCommand=T}}e.$CN=jt;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(T){if(this.options=T,typeof T!="object")throw(0,F.$7)("options")}}e.$DN=qt;var He;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(He||(e.TaskRevealKind=He={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Gt=class{static{P=this}static{this.Clean=new P("clean","Clean")}static{this.Build=new P("build","Build")}static{this.Rebuild=new P("rebuild","Rebuild")}static{this.Test=new P("test","Test")}static from(T){switch(T){case"clean":return P.Clean;case"build":return P.Build;case"rebuild":return P.Rebuild;case"test":return P.Test;default:return}}constructor(T,te){if(this.label=te,typeof T!="string"||typeof te!="string")throw(0,F.$7)("name");this.c=T}get id(){return this.c}};e.$EN=Gt,e.$EN=Gt=P=Je([w],Gt);function zt(B){let T="";for(let te=0;te<B.length;te++)T+=B[te].replace(/,/g,",,")+",";return T}let gt=class{constructor(T,te,Ee){if(typeof T!="string")throw(0,F.$7)("process");this.e=[],this.c=T,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,F.$7)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const te of this.e)T.push(te);return zt(T)}};e.$FN=gt,e.$FN=gt=Je([w],gt);let Nt=class{constructor(T,te,Ee){if(this.f=[],Array.isArray(te)){if(!T)throw(0,F.$7)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$7)("command");this.e=T,this.f=te,this.g=Ee}else{if(typeof T!="string")throw(0,F.$7)("commandLine");this.c=T,this.g=te}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,F.$7)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$7)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)T.push(typeof te=="string"?te:te.value);return zt(T)}};e.$GN=Nt,e.$GN=Nt=Je([w],Nt);var At;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ot||(e.TaskScope=Ot={}));class ii{constructor(T){this.c=T}computeId(){return"customExecution"+(0,N.$Pg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$HN=ii;let Ht=class{static{u=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,te,Ee,Ke,Xe,ht){this.k=!1,this.l=this.definition=T;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,$t=Xe,this.k=!0):te===Ot.Global||te===Ot.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Xe,$t=ht):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Xe,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(T){this.j=T}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:u.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:u.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:u.c,id:this.q.computeId()}:this.l={type:u.g,id:(0,N.$Pg)()}}get definition(){return this.l}set definition(T){if(T==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=T}get scope(){return this.m}set target(T){this.B(),this.m=T}get name(){return this.o}set name(T){if(typeof T!="string")throw(0,F.$7)("name");this.B(),this.o=T}get execution(){return this.q}set execution(T){T===null&&(T=void 0),this.B(),this.q=T;const te=this.l.type;(u.g===te||u.e===te||u.f===te||u.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(T){if(Array.isArray(T))this.B(),this.r=T,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.B(),this.u=T}get source(){return this.w}set source(T){if(typeof T!="string"||T.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=T}get group(){return this.x}set group(T){T===null&&(T=void 0),this.B(),this.x=T}get detail(){return this.A}set detail(T){T===null&&(T=void 0),this.A=T}get presentationOptions(){return this.y}set presentationOptions(T){T==null&&(T=Object.create(null)),this.B(),this.y=T}get runOptions(){return this.z}set runOptions(T){T==null&&(T=Object.create(null)),this.B(),this.z=T}};e.$IN=Ht,e.$IN=Ht=u=Je([w],Ht);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Ft;(function(B){function T(te){const Ee=te;return(0,g.$0f)(Ee.value)?Ee.tooltip&&!(0,g.$6f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=T})(Ft||(e.ViewBadge=Ft={}));let Rt=E=class{static isTreeItem(T,te){const Ee=T;if(Ee.checkboxState!==void 0){const Ke=(0,g.$0f)(Ee.checkboxState)?Ee.checkboxState:(0,g.$8f)(Ee.checkboxState)&&(0,g.$0f)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Xe=!(0,g.$0f)(Ee.checkboxState)&&(0,g.$8f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||Xe!==void 0&&!(0,g.$6f)(Xe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(T instanceof E)return!0;if(Ee.label!==void 0&&!(0,g.$6f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,g.$6f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,g.$6f)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,g.$6f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,g.$6f)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,g.$6f)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,g.$6f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,g.$6f)(Ee.tooltip)&&!(Ee.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<Pt.None&&Ee.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,g.$6f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(T,te=Pt.None){this.collapsibleState=te,k.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$JN=Rt,e.$JN=Rt=E=Je([w],Rt);var Pt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var Et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$KN=pt,e.$KN=pt=Je([w],pt);class St extends pt{}e.$LN=St;class li extends St{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$MN=li;class Dt{constructor(T,te,Ee,Ke){this.name=T,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$NN=Dt;let hi=class{#e=new Map;constructor(T){for(const[te,Ee]of T??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,te){this.#e.set(this.#t(T),[te])}forEach(T,te){for(const[Ee,Ke]of this.#e)for(const Xe of Ke)T.call(te,Xe,Ee,this)}*[Symbol.iterator](){for(const[T,te]of this.#e)for(const Ee of te)yield[T,Ee]}#t(T){return T.toLowerCase()}};e.$ON=hi,e.$ON=hi=Je([w],hi);let Kt=class{constructor(T,te,Ee){this.insertText=T,this.title=te,this.kind=Ee}};e.$PN=Kt,e.$PN=Kt=Je([w],Kt);var bi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class ei{static{this.c="."}constructor(T){this.value=T}append(...T){return new ei((this.value?[this.value,...T]:T).join(ei.c))}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+ei.c)}}e.$QN=ei,ei.Empty=new ei("");class wi{constructor(T,te,Ee){this.title=te,this.insertText=T,this.kind=Ee}}e.$RN=wi;let yt=class{constructor(T,te){this.id=T,this.color=te}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$SN=yt,e.$SN=yt=Je([w],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(T){this.id=T}};e.$TN=$i,e.$TN=$i=Je([w],$i);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Se=class{get base(){return this.c}set base(T){this.c=T,this.e=k.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,te){if(typeof T!="string"&&(!T||!k.URI.isUri(T)&&!k.URI.isUri(T.uri)))throw(0,F.$7)("base");if(typeof te!="string")throw(0,F.$7)("pattern");typeof T=="string"?this.baseUri=k.URI.file(T):k.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$UN=Se,e.$UN=Se=Je([w],Se);const oe=new WeakMap;function J(B,T){oe.set(B,T)}let De=class{constructor(T,te,Ee,Ke,Xe){this.enabled=typeof T=="boolean"?T:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Xe=="string"&&(this.mode=Xe)}get id(){return this.c||(this.c=oe.get(this)??(0,N.$Pg)()),this.c}};e.$WN=De,e.$WN=De=Je([w],De);let Ve=class extends De{constructor(T,te,Ee,Ke,Xe,ht){if(super(te,Ee,Ke,Xe,ht),T===null)throw(0,F.$7)("location");this.location=T}};e.$XN=Ve,e.$XN=Ve=Je([w],Ve);let Ze=class extends De{constructor(T,te,Ee,Ke,Xe,ht){super(te,Ee,Ke,Xe,ht),this.functionName=T}};e.$YN=Ze,e.$YN=Ze=Je([w],Ze);let qe=class extends De{constructor(T,te,Ee,Ke,Xe,ht,$t,Jt){if(super(Ke,Xe,ht,$t,Jt),!te)throw(0,F.$7)("dataId");this.label=T,this.dataId=te,this.canPersist=Ee}};e.$ZN=qe,e.$ZN=qe=Je([w],qe);let ut=class{constructor(T,te,Ee){this.command=T,this.args=te||[],this.options=Ee}};e.$1N=ut,e.$1N=ut=Je([w],ut);let kt=class{constructor(T,te){this.port=T,this.host=te}};e.$2N=kt,e.$2N=kt=Je([w],kt);let Tt=class{constructor(T){this.path=T}};e.$3N=Tt,e.$3N=Tt=Je([w],Tt);let Vt=class{constructor(T){this.implementation=T}};e.$4N=Vt,e.$4N=Vt=Je([w],Vt);class ct{constructor(T,te,Ee){this.session=T,this.threadId=te,this.frameId=Ee}}e.$5N=ct;class ri{constructor(T,te){this.session=T,this.threadId=te}}e.$6N=ri;let di=class{constructor(T,te){this.range=T,this.expression=te}};e.$7N=di,e.$7N=di=Je([w],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(T,te){this.range=T,this.text=te}};e.$8N=Si,e.$8N=Si=Je([w],Si);let Ai=class{constructor(T,te,Ee=!0){this.range=T,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$9N=Ai,e.$9N=Ai=Je([w],Ai);let Mi=class{constructor(T,te){this.range=T,this.expression=te}};e.$0N=Mi,e.$0N=Mi=Je([w],Mi);let Fi=class{constructor(T,te){this.frameId=T,this.stoppedLocation=te}};e.$$N=Fi,e.$$N=Fi=Je([w],Fi);var Ni;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(T,te){this.newSymbolName=T,this.tags=te}}e.$_N=cn;var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ti=f=class extends Error{static FileExists(T){return new f(T,l.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(T){return new f(T,l.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(T){return new f(T,l.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(T){return new f(T,l.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(T){return new f(T,l.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(T){return new f(T,l.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(T,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(T)?T.toString(!0):T),this.code=Ee?.name??"Unknown",(0,l.$cl)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$aO=Ti,e.$aO=Ti=f=Je([w],Ti);let yi=class{constructor(T,te,Ee){this.start=T,this.end=te,this.kind=Ee}};e.$bO=yi,e.$bO=yi=Je([w],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Hi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var vi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(vi||(e.CommentState=vi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(T,te=[]){this.tokenTypes=T,this.tokenModifiers=te}}e.$cO=un;function Li(B){return typeof B>"u"||(0,g.$7f)(B)}class zi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,T){this.m=!0;for(let te=0,Ee=T.tokenTypes.length;te<Ee;te++)this.k.set(T.tokenTypes[te],te);for(let te=0,Ee=T.tokenModifiers.length;te<Ee;te++)this.l.set(T.tokenModifiers[te],te)}}push(T,te,Ee,Ke,Xe){if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.q(T,te,Ee,Ke,Xe);if(q.isRange(T)&&typeof te=="string"&&Li(Ee))return this.o(T,te,Ee);throw(0,F.$7)()}o(T,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=T.start.line,Xe=T.start.character,ht=T.end.character-T.start.character,$t=this.k.get(te);let Jt=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Xe,ht,$t,Jt)}q(T,te,Ee,Ke,Xe){if(this.f&&(T<this.c||T===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=T,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Xe,this.c=T,this.e=te}static r(T){const te=[],Ee=T.length/5|0;for(let $t=0;$t<Ee;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=T[5*$t],fi=T[5*Jt];if(ci===fi){const gi=T[5*$t+1],mi=T[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(T.length);let Xe=0,ht=0;for(let $t=0;$t<Ee;$t++){const Jt=5*te[$t],ci=T[Jt+0],fi=T[Jt+1],gi=T[Jt+2],mi=T[Jt+3],qi=T[Jt+4],Mn=ci-Xe,ur=Mn===0?fi-ht:fi,Gi=5*$t;Ke[Gi+0]=Mn,Ke[Gi+1]=ur,Ke[Gi+2]=gi,Ke[Gi+3]=mi,Ke[Gi+4]=qi,Xe=ci,ht=fi}return Ke}build(T){return this.f?new Ci(new Uint32Array(this.g),T):new Ci(zi.r(this.g),T)}}e.$dO=zi;class Ci{constructor(T,te){this.resultId=te,this.data=T}}e.$eO=Ci;class ln{constructor(T,te,Ee){this.start=T,this.deleteCount=te,this.data=Ee}}e.$fO=ln;class Zi{constructor(T,te){this.resultId=te,this.edits=T}}e.$gO=Zi;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class hn{constructor(T){this.name=T}}e.$hO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$iO=Ui,e.$iO=Ui=Je([w],Ui);var Xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Pi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Pi||(e.InputBoxValidationSeverity=Pi={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(T){if(typeof T.badge=="string"){let te=(0,p.$Ff)(T.badge,0);if(te<T.badge.length&&(te+=(0,p.$Ff)(T.badge,te)),T.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!yt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,te,Ee){this.badge=T,this.tooltip=te,this.color=Ee}}e.$jO=Ue;let oi=class{constructor(T){this.kind=T}};e.$kO=oi,e.$kO=oi=Je([w],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(T){return T instanceof xe?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,te){if(T<0)throw(0,F.$7)("start must be positive");if(te<0)throw(0,F.$7)("end must be positive");T<=te?(this.c=T,this.e=te):(this.c=te,this.e=T)}with(T){let te=this.c,Ee=this.e;return T.start!==void 0&&(te=T.start),T.end!==void 0&&(Ee=T.end),te===this.c&&Ee===this.e?this:new xe(te,Ee)}}e.$lO=xe;class vt{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(te=>vt.isNotebookCellData(te))}static isNotebookCellData(T){return!0}constructor(T,te,Ee,Ke,Xe,ht,$t){this.kind=T,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Xe??[],this.metadata=ht,this.executionSummary=$t,vt.validate(this)}}e.$mO=vt;class dn{constructor(T){this.cells=T}}e.$nO=dn;class ai{static isNotebookCellOutputItem(T){return T instanceof ai?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const te={name:T.name,message:T.message,stack:T.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(T){return ai.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return ai.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,te="application/octet-stream"){return new ai(T,te)}static#e=new TextEncoder;static text(T,te=M.$Ms.text){const Ee=ai.#e.encode(String(T));return new ai(Ee,te)}static json(T,te="text/x-json"){const Ee=JSON.stringify(T,void 0,"	");return ai.text(Ee,te)}constructor(T,te){this.data=T,this.mime=te;const Ee=(0,M.$Qs)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$oO=ai;class ki{static isNotebookCellOutput(T){return T instanceof ki?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,te=!1){const Ee=new Set,Ke=new Set;for(let Xe=0;Xe<T.length;Xe++){const ht=T[Xe],$t=(0,M.$Qs)(ht.mime);if(!Ee.has($t)||(0,m.$RK)($t)){Ee.add($t);continue}Ke.add(Xe),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?T:T.filter((Xe,ht)=>!Ke.has(ht))}constructor(T,te,Ee){this.items=ki.ensureUniqueMimeTypes(T,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,N.$Pg)(),this.metadata=te??Ee)}}e.$pO=ki;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(T,te){this.text=T,this.alignment=te}}e.$qO=fn;var Vi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Vi||(e.NotebookControllerAffinity=Vi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(T,te=[]){this.uri=T,this.provides=(0,S.$3b)(te)}}e.$rO=gn;class mn{constructor(T){this.label=T}}e.$sO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Wi=class{constructor(T,te){this.label=T,this.timestamp=te}};e.$tO=Wi,e.$tO=Wi=Je([w],Wi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(T,te){this.ranges=T,this.wordPattern=te}}e.$uO=$n;class pn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$vO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let se=class{constructor(T=void 0,te=void 0,Ee=void 0,Ke=!1){this.include=T,this.exclude=te,this.profile=Ee,this.continuous=Ke}};e.$wO=se,e.$wO=se=Je([w],se);let Le=D=class{static diff(T,te,Ee){const Ke=new D(T);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(T){this.message=T}};e.$xO=Le,e.$xO=Le=D=Je([w],Le);let rt=class{constructor(T){this.id=T}};e.$yO=rt,e.$yO=rt=Je([w],rt);class wt{constructor(T,te){this.covered=T,this.total=te,Mt(this)}}e.$zO=wt;function Mt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Di{static fromDetails(T,te){const Ee=new wt(0,0),Ke=new wt(0,0),Xe=new wt(0,0);for(const $t of te)if("branches"in $t){Ee.total+=1,Ee.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Xe.total+=1,Xe.covered+=$t.executed?1:0;const ht=new Di(T,Ee,Ke.total>0?Ke:void 0,Xe.total>0?Xe:void 0);return ht.detailedCoverage=te,ht}constructor(T,te,Ee,Ke){this.uri=T,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$BO=Di;class Fn{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee=[]){this.executed=T,this.location=te,this.branches=Ee}}e.$CO=Fn;class Nn{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee){this.executed=T,this.location=te,this.label=Ee}}e.$DO=Nn;class On{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee){this.name=T,this.executed=te,this.location=Ee}}e.$EO=On;var vn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var bn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(bn||(e.WorkspaceTrustState=bn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class Tn{constructor(T,te,Ee,Ke,Xe,ht){this.kind=T,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Xe,this.selectionRange=ht}}e.$FO=Tn;class Ln{constructor(T){this.uri=T}}e.$GO=Ln;class zn{constructor(T,te){this.original=T,this.modified=te}}e.$HO=zn;class Un{constructor(T,te,Ee,Ke){this.base=T,this.input1=te,this.input2=Ee,this.result=Ke}}e.$IO=Un;class jn{constructor(T,te){this.uri=T,this.viewType=te}}e.$JO=jn;class Bn{constructor(T){this.viewType=T}}e.$KO=Bn;class Vn{constructor(T,te){this.uri=T,this.notebookType=te}}e.$LO=Vn;class Wn{constructor(T,te,Ee){this.original=T,this.modified=te,this.notebookType=Ee}}e.$MO=Wn;class qn{constructor(){}}e.$NO=qn;class Gn{constructor(T,te){this.uri=T,this.inputBoxUri=te}}e.$OO=Gn;class Hn{constructor(){}}e.$PO=Hn;class Kn{constructor(T){this.textDiffs=T}}e.$QO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(T,te){this.label=T,this.values=te}}e.$RO=Jn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Qn{constructor(T){if(typeof T!="string"&&T.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof T=="string"?new Oe(T):T}}e.$SO=Qn;class Zn{constructor(T,te){if(typeof T!="string"&&T.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof T=="string"?new Oe(T):T,this.vulnerabilities=te}}e.$TO=Zn;class Yn{constructor(T,te){this.participant=T,this.command=te}}e.$UO=Yn;class Xn{constructor(T,te){this.value=T,this.baseUri=te}}e.$VO=Xn;class xn{constructor(T,te){this.value=T,this.title=te}}e.$WO=xn;class _n{constructor(T){this.value=T}}e.$XO=_n;class er{constructor(T){this.value=T}}e.$YO=er;class tr{constructor(T){this.value=T}}e.$ZO=tr;class ir{constructor(T,te){this.uri=T,this.edits=Array.isArray(te)?te:[te]}}e.$1O=ir;class nr{constructor(T,te,Ee,Ke){this.prompt=T,this.command=te,this.variables=Ee,this.participant=Ke}}e.$2O=nr;class rr{constructor(T,te,Ee,Ke){this.response=T,this.result=te,this.participant=Ee,this.command=Ke}}e.$3O=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(T){this.content=T}}e.$4O=sr;class or{constructor(T,te){this.content=T,this.name=te}}e.$5O=or;class ar{constructor(T,te){this.content=T,this.name=te}}e.$6O=ar;class Ri extends Error{static NotFound(T){return new Ri(T,Ri.NotFound.name)}static NoPermissions(T){return new Ri(T,Ri.NoPermissions.name)}constructor(T,te,Ee){super(T,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$7O=Ri;var Cn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Pn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Pn||(e.SpeechToTextStatus=Pn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class cr{constructor(T,te){this.text=T,this.range=te}}e.$8O=cr;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Pe[246],Ae([1,0,4,7]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(S.$UM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,g){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,g)??[]}getRelatedInformation(M,p,g){return this.c.$getAiRelatedInformation(p,g)}registerRelatedInformationProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiRelatedInformationProvider(k,p),new F.$WM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Dkc=R}),define(Pe[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=void 0,e.$Okc=(0,p.$ti)("IExtHostAuthentication");let k=class{constructor(l){this.b=new Map,this.c=new S.$ce,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=l.getProxy(F.$UM.MainThreadAuthentication)}async getSession(l,b,m,s={}){const o=O.$Om.toKey(l.identifier),r=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${r}`,async()=>{await this.a.$ensureProvider(b);const t=l.displayName||l.name;return this.a.$getSession(b,m,o,t,s)})}async getSessions(l,b,m){const s=O.$Om.toKey(l.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(b);const r=l.displayName||l.name;return this.a.$getSessions(b,m,s,r)})}async removeSession(l,b){const m=this.b.get(l);return m?m.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,m,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(l,r));return this.a.$registerAuthenticationProvider(l,b,s?.supportsMultipleAccounts??!1),new R.$WM(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,b,m){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(b,m));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,b){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,b){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(M.$WL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$Pkc=k,e.$Pkc=k=Je([We(0,g.$hP)],k);class N{constructor(){this.a=new Map}getOrCreate(l,b){const m=this.a.get(l);if(m)return m;const s=b().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Pe[110],Ae([1,0,2,4,7,3,16,13,18,15,19,26]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(F.$UM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(r,o.identifier.value);const t=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const c=(0,g.$3b)(n);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,k.$$e)(a.path,"/")})),i=(0,g.$zb)(h,(a,v)=>a.rank-v.rank||(0,k.$of)(a.uri.path,v.uri.path)),$=[];e:for(const a of i){let v;for(const d of a){const P=(0,N.$nc)(d.uri.path);if(v!==P&&(v=P,$.push(d.uri)>=l.d))break e}}this.g.$onDidChange(r,$)});return new R.$WM(()=>{t?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,o,r){if(!this.f.has(s))return Object.create(null);const t=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async h=>{try{const{uri:i,id:$}=h,a=await Promise.resolve(n.provideFileDecoration(S.URI.revive(i),r));if(!a)return;try{R.$jO.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.$CG)(c,"codiconDecoration"),t[$]=[a.propagate,a.tooltip,a.badge,a.color]}catch(v){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${v}`)}}catch(i){this.h.error(i)}})),t}};e.$Olc=b,e.$Olc=b=l=Je([We(0,M.$hP),We(1,p.$Zj)],b),e.$Plc=(0,O.$ti)("IExtHostDecorations")}),define(Pe[247],Ae([1,0,14,2,7,4,12,24,15]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class k{static{this.a=0}constructor(y,l,b){this.d=l,this.e=b,this.b=new Map,this.c=y.getProxy(O.$UM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=k.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,y);let m;if(typeof l.onDidChange=="function"){let s;m=l.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const r=this.$provideTextDocumentContent(b,o).then(async t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(o);if(!n)return;const c=(0,g.$if)(t);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(o,t)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new R.$WM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,l){const b=this.b.get(y);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(l),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Rlc=k}),define(Pe[111],Ae([1,0,56,12,15,302,152,7,18]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0,e.$jP=N;const k=new Map;function N(m,s){s?k.set(m,s):k.delete(m)}function y(m){return k.get(m)}class l extends O.$Uv{constructor(s,o,r,t,n,c,h){super(o,r,t,n),this.c=s,this.m=c,this.q=h,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===F.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,r){return s.y(o,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const r=this.g,t=o.start.line,n=o.end.line,c=[];c.push(this.f[t].substring(o.start.character));for(let h=t+1;h<n;h++)c.push(this.f[h]);return c.push(this.f[n].substring(0,o.end.character)),c.join(r)}t(s){let o;if(s instanceof p.$XM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),r=this.f[o.index].length;return new p.$XM(o.index,Math.min(o.remainder,r))}w(s){if(!(s instanceof p.$YM))throw new Error("Invalid argument");const o=this.x(s.start),r=this.x(s.end);return o===s.start&&r===s.end?s:new p.$YM(o.line,o.character,r.line,r.character)}x(s){if(!(s instanceof p.$XM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:r}=s,t=!1;if(o<0)o=0,r=0,t=!0;else if(o>=this.f.length)o=this.f.length-1,r=this.f[o].length,t=!0;else{const n=this.f[o].length;r<0?(r=0,t=!0):r>n&&(r=n,t=!0)}return t?new p.$XM(o,r):s}y(s,o){const r=this.x(s);if(!o)o=y(this.m);else if((0,R.$hf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const t=(0,M.$5s)(r.character+1,(0,M.$3s)(o),this.f[r.line],0);if(t)return new p.$YM(r.line,t.startColumn-1,r.line,t.endColumn-1)}}e.$kP=l;class b{constructor(s,o,r){this.a=s,this.b=o,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$YM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$YM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lP=b}),define(Pe[248],Ae([1,0,4,7]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(S.$UM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const N=await k.provideEmbeddingVector(p,g);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiEmbeddingVectorProvider(p,k),new F.$WM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Tlc=R}),define(Pe[64],Ae([1,0,4,44,7,22,3,16,45,6,11,23,12]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=void 0;let m=b=class{constructor(o,r){this.b=new Map,this.c=new N.$Ch,this.a=o.getProxy(S.$UM.MainThreadFileSystem);const t=this;this.value=Object.freeze({async stat(n){try{let c;const h=t.b.get(n.scheme);return h?(await t.a.$ensureActivation(n.scheme),c=await h.impl.stat(n)):c=await t.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===F.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(n){try{const c=t.b.get(n.scheme);return c?(await t.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await t.a.$readdir(n)}catch(c){return b.e(c)}},async createDirectory(n){try{const c=t.b.get(n.scheme);return c&&!c.isReadonly?(await t.a.$ensureActivation(n.scheme),await t.d(c.impl,c.extUri,n)):await t.a.$mkdir(n)}catch(c){return b.e(c)}},async readFile(n){try{const c=t.b.get(n.scheme);return c?(await t.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await t.a.$readFile(n)).buffer}catch(c){return b.e(c)}},async writeFile(n,c){try{const h=t.b.get(n.scheme);return h&&!h.isReadonly?(await t.a.$ensureActivation(n.scheme),await t.d(h.impl,h.extUri,h.extUri.dirname(n)),await t.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await t.a.$writeFile(n,O.$De.wrap(c))}catch(h){return b.e(h)}},async delete(n,c){try{const h=t.b.get(n.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await t.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...c})):await t.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return b.e(h)}},async rename(n,c,h){try{return await t.a.$rename(n,c,{overwrite:!1,...h})}catch(i){return b.e(i)}},async copy(n,c,h){try{return await t.a.$copy(n,c,{overwrite:!1,...h})}catch(i){return b.e(i)}},isWritableFileSystem(n){const c=r.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(o,r,t){const n=[];for(;!r.isEqual(t,r.dirname(t));)try{if(!((await o.stat(t)).type&F.FileType.Directory))throw R.$aO.FileExists(`Unable to create folder '${t.scheme===l.Schemas.file?t.fsPath:t.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(F.$dl(c)!==F.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(t)),t=r.dirname(t)}for(let c=n.length-1;c>=0;c--){t=r.joinPath(t,n[c]);try{await o.createDirectory(t)}catch(h){if(F.$dl(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$aO)throw o;if(o instanceof F.$_k)switch(o.code){case F.FileSystemProviderErrorCode.FileExists:throw R.$aO.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw R.$aO.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw R.$aO.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw R.$aO.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw R.$aO.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw R.$aO.Unavailable(o.message);default:throw new R.$aO(o.message,o.name)}if(!(o instanceof Error))throw new R.$aO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$aO.Unavailable(o.message);switch(o.name){case F.FileSystemProviderErrorCode.FileExists:throw R.$aO.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw R.$aO.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw R.$aO.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw R.$aO.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw R.$aO.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw R.$aO.Unavailable(o.message);default:throw new R.$aO(o.message,o.name)}}addFileSystemProvider(o,r,t){return this.b.set(o,{impl:r,extUri:t?.isCaseSensitive?y.$Wg:y.$Yg,isReadonly:!!t?.isReadonly}),(0,k.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Wg}};e.$5kc=m,e.$5kc=m=b=Je([We(0,p.$hP),We(1,g.$Ikc)],m),e.$6kc=(0,M.$ti)("IExtHostConsumerFileSystem")}),define(Pe[85],Ae([1,0,3,27,13,64,2]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=void 0,e.$7kc=(0,S.$ti)("IExtensionStoragePaths");let p=class{constructor(k,N,y){this.d=N,this.f=y,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(M.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$8kc=p,e.$8kc=p=Je([We(0,F.$xP),We(1,R.$Zj),We(2,O.$6kc)],p)}),define(Pe[249],Ae([1,0,7,16,5]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;let O=class{constructor(p){this.a=new S.$kO(S.ColorThemeKind.Dark),this.b=new R.$ce}get activeColorTheme(){return this.a}$onColorThemeChange(p){let g;switch(p){case"light":g=S.ColorThemeKind.Light;break;case"hcDark":g=S.ColorThemeKind.HighContrast;break;case"hcLight":g=S.ColorThemeKind.HighContrastLight;break;default:g=S.ColorThemeKind.Dark}this.a=new S.$kO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Cmc=O,e.$Cmc=O=Je([We(0,F.$hP)],O)}),define(Pe[86],Ae([1,0,24,5,6,173,3,13,203,4,27,16,7]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Cb=e.$ZCb=e.TunnelDtoConverter=void 0;class b extends g.$hw{}var m;(function(o){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=r;function t(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==g.TunnelPrivacyId.ConstantPrivate&&n.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=t})(m||(e.TunnelDtoConverter=m={})),e.$ZCb=(0,M.$ti)("IExtHostTunnelService");let s=class extends R.$Vc{constructor(r,t,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$ce,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(k.$UM.MainThreadTunnelService)}async openTunnel(r,t){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${t.remoteAddress.host}:${t.remoteAddress.port}.`);const n=await this.a.$openTunnel(t,r.displayName);if(n){const c=new b(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,t){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:r,provider:t}),this.a.$registerPortsAttributesProvider(r,n),new l.$WM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,t,n,c,h){const i=[];for(const a of r){const v=this.r.get(a);if(!v)return[];i.push(...await Promise.all(t.map(async d=>{let P;try{P=await v.provider.providePortAttributes({port:d,pid:n,commandLine:c},h)}catch{P=await v.provider.providePortAttributes(d,n,c,h)}return{providedAttributes:P,port:d}})))}const $=i.filter(a=>!!a.providedAttributes);return $.length>0?$.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,t){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,S.CancellationToken.None)??void 0;const n=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,privacyOptions:t.tunnelFeatures?.privacyOptions,protocol:t.tunnelFeatures.protocol===void 0?!0:t.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,R.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,t){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(t?this.w(t):void 0);if(n){this.b=n;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Tc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,t){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(t&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,t){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,t);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const t=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),n=r.filter((c,h)=>t[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$1Cb=s,e.$1Cb=s=Je([We(0,y.$hP),We(1,N.$xP),We(2,p.$Zj)],s)}),define(Pe[8],Ae([1,0,18,22,132,250,54,28,124,53,69,25,127,23,17,2,29,87,100,105,104,213,83,50,61,224,7]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$,a,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$eP=j,e.$fP=re,e.$gP=ae;var P;(function(we){function Se(J){const{selectionStartLineNumber:De,selectionStartColumn:Ve,positionLineNumber:Ze,positionColumn:qe}=J,ut=new d.$XM(De-1,Ve-1),kt=new d.$XM(Ze-1,qe-1);return new d.$ZM(ut,kt)}we.to=Se;function oe(J){const{anchor:De,active:Ve}=J;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}we.from=oe})(P||(e.Selection=P={}));var u;(function(we){function Se(J){if(!J)return;const{start:De,end:Ve}=J;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}we.from=Se;function oe(J){if(!J)return;const{startLineNumber:De,startColumn:Ve,endLineNumber:Ze,endColumn:qe}=J;return new d.$YM(De-1,Ve-1,Ze-1,qe-1)}we.to=oe})(u||(e.Range=u={}));var E;(function(we){function Se(J){return{uri:J.uri,range:u.from(J.range)}}we.from=Se;function oe(J){return new d.$9M(s.URI.revive(J.uri),u.to(J.range))}we.to=oe})(E||(e.Location=E={}));var f;(function(we){function Se(oe){switch(oe){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}we.to=Se})(f||(e.TokenType=f={}));var D;(function(we){function Se(J){return new d.$XM(J.lineNumber-1,J.column-1)}we.to=Se;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=oe})(D||(e.Position=D={}));var w;(function(we){function Se(De,Ve,Ze){return(0,S.$Hb)((0,S.$3b)(De).map(qe=>oe(qe,Ve,Ze)))}we.from=Se;function oe(De,Ve,Ze){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Ze?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:J(De.scheme,Ve),pattern:Z.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Ze?.isBuiltin}}function J(De,Ve){return Ve&&typeof De=="string"?Ve.transformOutgoingScheme(De):De}})(w||(e.DocumentSelector=w={}));var C;(function(we){function Se(J){switch(J){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}we.from=Se;function oe(J){switch(J){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}we.to=oe})(C||(e.DiagnosticTag=C={}));var I;(function(we){function Se(J){let De;return J.code&&((0,m.$6f)(J.code)||(0,m.$0f)(J.code)?De=String(J.code):De={value:String(J.code.value),target:J.code.target}),{...u.from(J.range),message:J.message,source:J.source,code:De,severity:V.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,S.$Hb)(J.tags.map(C.from)):void 0}}we.from=Se;function oe(J){const De=new d.$$M(u.to(J),J.message,V.to(J.severity));return De.source=J.source,De.code=(0,m.$6f)(J.code)?J.code:J.code?.value,De.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),De.tags=J.tags&&(0,S.$Hb)(J.tags.map(C.to)),De}we.to=oe})(I||(e.Diagnostic=I={}));var W;(function(we){function Se(J){return{...u.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Se;function oe(J){return new d.$0M(new d.$9M(J.resource,u.to(J)),J.message)}we.to=oe})(W||(e.DiagnosticRelatedInformation=W={}));var V;(function(we){function Se(J){switch(J){case d.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}we.from=Se;function oe(J){switch(J){case t.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}we.to=oe})(V||(e.DiagnosticSeverity=V={}));var q;(function(we){function Se(J){return typeof J=="number"&&J>=d.ViewColumn.One?J-1:J===d.ViewColumn.Beside?v.$SD:v.$RD}we.from=Se;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(q||(e.ViewColumn=q={}));function A(we){return typeof we.range<"u"}function j(we){return we.length===0?!0:!!A(we[0])}var K;(function(we){function Se(qe){return qe.map(we.from)}we.fromMany=Se;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else d.$lN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Tt=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:De(ri.query,kt)}),kt[ct]=ri}catch{}return""},Vt=new g.marked.Renderer;return Vt.link=Tt,Vt.image=ct=>typeof ct=="string"?Tt(M.$Yk(ct).href):"",(0,g.marked)(ut.value,{renderer:Vt}),ut}we.from=J;function De(qe,ut){if(!qe)return qe;let kt;try{kt=(0,k.$2h)(qe)}catch{}if(!kt)return qe;let Tt=!1;return kt=(0,y.$2n)(kt,Vt=>{if(s.URI.isUri(Vt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Vt,Tt=!0,ct}else return}),Tt?JSON.stringify(kt):qe}function Ve(qe){const ut=new d.$lN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}we.to=Ve;function Ze(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ze})(K||(e.MarkdownString=K={}));function re(we){return j(we)?we.map(Se=>({range:u.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:u.from(Se)}))}function ae(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var be;(function(we){function Se(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ae(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Se})(be||(e.ThemableDecorationAttachmentRenderOptions=be={}));var Ie;(function(we){function Se(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?be.from(oe.before):void 0,after:oe.after?be.from(oe.after):void 0}}we.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var de;(function(we){function Se(oe){if(typeof oe>"u")return oe;switch(oe){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(de||(e.DecorationRangeBehavior=de={}));var me;(function(we){function Se(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?de.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?Ie.from(oe.light):void 0,dark:oe.dark?Ie.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?be.from(oe.before):void 0,after:oe.after?be.from(oe.after):void 0}}we.from=Se})(me||(e.DecorationRenderOptions=me={}));var Me;(function(we){function Se(J){return{text:J.newText,eol:J.newEol&&at.from(J.newEol),range:u.from(J.range)}}we.from=Se;function oe(J){const De=new d.$4M(u.to(J.range),J.text);return De.newEol=typeof J.eol>"u"?void 0:at.to(J.eol),De}we.to=oe})(Me||(e.TextEdit=Me={}));var ce;(function(we){function Se(J,De){const Ve={edits:[]};if(J instanceof d.$7M){const Ze=new p.$Cc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,F.$Xe)(F.$De.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Me.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:u.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ut.from)}})}return Ve}we.from=Se;function oe(J){const De=new d.$7M,Ve=new p.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const qe=Ze,ut=s.URI.revive(qe.resource),kt=u.to(qe.textEdit.range),Tt=qe.textEdit.text,Vt=qe.textEdit.insertAsSnippet;let ct;Vt?ct=d.$6M.replace(kt,new d.$8M(Tt)):ct=d.$4M.replace(kt,Tt);const ri=Ve.get(ut);ri?ri.push(ct):Ve.set(ut,[ct])}else De.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of Ve)De.set(Ze,qe);return De}we.to=oe})(ce||(e.WorkspaceEdit=ce={}));var Re;(function(we){const Se=Object.create(null);Se[d.SymbolKind.File]=0,Se[d.SymbolKind.Module]=1,Se[d.SymbolKind.Namespace]=2,Se[d.SymbolKind.Package]=3,Se[d.SymbolKind.Class]=4,Se[d.SymbolKind.Method]=5,Se[d.SymbolKind.Property]=6,Se[d.SymbolKind.Field]=7,Se[d.SymbolKind.Constructor]=8,Se[d.SymbolKind.Enum]=9,Se[d.SymbolKind.Interface]=10,Se[d.SymbolKind.Function]=11,Se[d.SymbolKind.Variable]=12,Se[d.SymbolKind.Constant]=13,Se[d.SymbolKind.String]=14,Se[d.SymbolKind.Number]=15,Se[d.SymbolKind.Boolean]=16,Se[d.SymbolKind.Array]=17,Se[d.SymbolKind.Object]=18,Se[d.SymbolKind.Key]=19,Se[d.SymbolKind.Null]=20,Se[d.SymbolKind.EnumMember]=21,Se[d.SymbolKind.Struct]=22,Se[d.SymbolKind.Event]=23,Se[d.SymbolKind.Operator]=24,Se[d.SymbolKind.TypeParameter]=25;function oe(De){return typeof Se[De]=="number"?Se[De]:6}we.from=oe;function J(De){for(const Ve in Se)if(Se[Ve]===De)return Number(Ve);return d.SymbolKind.Property}we.to=J})(Re||(e.SymbolKind=Re={}));var ie;(function(we){function Se(J){switch(J){case d.SymbolTag.Deprecated:return 1}}we.from=Se;function oe(J){switch(J){case 1:return d.SymbolTag.Deprecated}}we.to=oe})(ie||(e.SymbolTag=ie={}));var L;(function(we){function Se(J){return{name:J.name,kind:Re.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:pe.from(J.location)}}we.from=Se;function oe(J){const De=new d.$cN(J.name,Re.to(J.kind),J.containerName,pe.to(J.location));return De.tags=J.tags&&J.tags.map(ie.to),De}we.to=oe})(L||(e.WorkspaceSymbol=L={}));var x;(function(we){function Se(J){const De={name:J.name||"!!MISSING: name!!",detail:J.detail,range:u.from(J.range),selectionRange:u.from(J.selectionRange),kind:Re.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(De.children=J.children.map(Se)),De}we.from=Se;function oe(J){const De=new d.$dN(J.name,J.detail,Re.to(J.kind),u.to(J.range),u.to(J.selectionRange));return(0,S.$Lb)(J.tags)&&(De.tags=J.tags.map(ie.to)),J.children&&(De.children=J.children.map(oe)),De}we.to=oe})(x||(e.DocumentSymbol=x={}));var ve;(function(we){function Se(J){const De=new d.$hN(Re.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),u.to(J.range),u.to(J.selectionRange));return De._sessionId=J._sessionId,De._itemId=J._itemId,De}we.to=Se;function oe(J,De,Ve){if(De=De??J._sessionId,Ve=Ve??J._itemId,De===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ve,name:J.name,detail:J.detail,kind:Re.from(J.kind),uri:J.uri,range:u.from(J.range),selectionRange:u.from(J.selectionRange),tags:J.tags?.map(ie.from)}}we.from=oe})(ve||(e.CallHierarchyItem=ve={}));var Te;(function(we){function Se(oe){return new d.$iN(ve.to(oe.from),oe.fromRanges.map(J=>u.to(J)))}we.to=Se})(Te||(e.CallHierarchyIncomingCall=Te={}));var ke;(function(we){function Se(oe){return new d.$jN(ve.to(oe.to),oe.fromRanges.map(J=>u.to(J)))}we.to=Se})(ke||(e.CallHierarchyOutgoingCall=ke={}));var pe;(function(we){function Se(J){return{range:J.range&&u.from(J.range),uri:J.uri}}we.from=Se;function oe(J){return new d.$9M(s.URI.revive(J.uri),u.to(J.range))}we.to=oe})(pe||(e.location=pe={}));var fe;(function(we){function Se(J){const De=J,Ve=J;return{originSelectionRange:De.originSelectionRange?u.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Ve.uri,range:u.from(De.targetRange?De.targetRange:Ve.range),targetSelectionRange:De.targetSelectionRange?u.from(De.targetSelectionRange):void 0}}we.from=Se;function oe(J){return{targetUri:s.URI.revive(J.uri),targetRange:u.to(J.range),targetSelectionRange:J.targetSelectionRange?u.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?u.to(J.originSelectionRange):void 0}}we.to=oe})(fe||(e.DefinitionLink=fe={}));var Q;(function(we){function Se(J){return{range:u.from(J.range),contents:K.fromMany(J.contents)}}we.from=Se;function oe(J){return new d.$_M(J.contents.map(K.to),u.to(J.range))}we.to=oe})(Q||(e.Hover=Q={}));var X;(function(we){function Se(J){return{range:u.from(J.range),expression:J.expression}}we.from=Se;function oe(J){return new d.$7N(u.to(J.range),J.expression)}we.to=oe})(X||(e.EvaluatableExpression=X={}));var le;(function(we){function Se(J){if(J instanceof d.$8N)return{type:"text",range:u.from(J.range),text:J.text};if(J instanceof d.$9N)return{type:"variable",range:u.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof d.$0N)return{type:"expression",range:u.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function oe(J){switch(J.type){case"text":return{range:u.to(J.range),text:J.text};case"variable":return{range:u.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:u.to(J.range),expression:J.expression}}}we.to=oe})(le||(e.InlineValue=le={}));var ue;(function(we){function Se(J){return{frameId:J.frameId,stoppedLocation:u.from(J.stoppedLocation)}}we.from=Se;function oe(J){return new d.$$N(J.frameId,u.to(J.stoppedLocation))}we.to=oe})(ue||(e.InlineValueContext=ue={}));var Ne;(function(we){function Se(J){return{range:u.from(J.range),kind:J.kind}}we.from=Se;function oe(J){return new d.$aN(u.to(J.range),J.kind)}we.to=oe})(Ne||(e.DocumentHighlight=Ne={}));var he;(function(we){function Se(J){return{uri:J.uri,highlights:J.highlights.map(Ne.from)}}we.from=Se;function oe(J){return new d.$bN(s.URI.revive(J.uri),J.highlights.map(Ne.to))}we.to=oe})(he||(e.MultiDocumentHighlight=he={}));var Ce;(function(we){function Se(oe){switch(oe){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}we.to=Se})(Ce||(e.CompletionTriggerKind=Ce={}));var Fe;(function(we){function Se(oe){return{triggerKind:Ce.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Se})(Fe||(e.CompletionContext=Fe={}));var ze;(function(we){function Se(J){switch(J){case d.CompletionItemTag.Deprecated:return 1}}we.from=Se;function oe(J){switch(J){case 1:return d.CompletionItemTag.Deprecated}}we.to=oe})(ze||(e.CompletionItemTag=ze={}));var U;(function(we){const Se=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function oe(Ve){return Se.get(Ve)??9}we.from=oe;const J=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function De(Ve){return J.get(Ve)??d.CompletionItemKind.Property}we.to=De})(U||(e.CompletionItemKind=U={}));var z;(function(we){function Se(oe,J){const De=new d.$rN(oe.label);return De.insertText=oe.insertText,De.kind=U.to(oe.kind),De.tags=oe.tags?.map(ze.to),De.detail=oe.detail,De.documentation=M.$Sk(oe.documentation)?K.to(oe.documentation):oe.documentation,De.sortText=oe.sortText,De.filterText=oe.filterText,De.preselect=oe.preselect,De.commitCharacters=oe.commitCharacters,o.$pt.isIRange(oe.range)?De.range=u.to(oe.range):typeof oe.range=="object"&&(De.range={inserting:u.to(oe.range.insert),replacing:u.to(oe.range.replace)}),De.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?De.insertText=new d.$8M(oe.insertText):(De.insertText=oe.insertText,De.textEdit=De.range instanceof d.$YM?new d.$4M(De.range,De.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(De.additionalTextEdits=oe.additionalTextEdits.map(Ve=>Me.to(Ve))),De.command=J&&oe.command?J.fromInternal(oe.command):void 0,De}we.to=Se})(z||(e.CompletionItem=z={}));var H;(function(we){function Se(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:K.fromStrict(J.documentation)}}we.from=Se;function oe(J){return{label:J.label,documentation:M.$Sk(J.documentation)?K.to(J.documentation):J.documentation}}we.to=oe})(H||(e.ParameterInformation=H={}));var G;(function(we){function Se(J){return{label:J.label,documentation:K.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}we.from=Se;function oe(J){return{label:J.label,documentation:M.$Sk(J.documentation)?K.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}we.to=oe})(G||(e.SignatureInformation=G={}));var ee;(function(we){function Se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(G.from):[]}}we.from=Se;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(G.to):[]}}we.to=oe})(ee||(e.SignatureHelp=ee={}));var ne;(function(we){function Se(oe,J){const De=new d.$qN(D.to(J.position),typeof J.label=="string"?J.label:J.label.map(Oe.to.bind(void 0,oe)),J.kind&&Be.to(J.kind));return De.textEdits=J.textEdits&&J.textEdits.map(Me.to),De.tooltip=M.$Sk(J.tooltip)?K.to(J.tooltip):J.tooltip,De.paddingLeft=J.paddingLeft,De.paddingRight=J.paddingRight,De}we.to=Se})(ne||(e.InlayHint=ne={}));var Oe;(function(we){function Se(oe,J){const De=new d.$pN(J.label);return De.tooltip=M.$Sk(J.tooltip)?K.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(De.command=oe.fromInternal(J.command)),J.location&&(De.location=pe.to(J.location)),De}we.to=Se})(Oe||(e.InlayHintLabelPart=Oe={}));var Be;(function(we){function Se(J){return J}we.from=Se;function oe(J){return J}we.to=oe})(Be||(e.InlayHintKind=Be={}));var Qe;(function(we){function Se(J){return{range:u.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Se;function oe(J){let De;if(J.url)try{De=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new d.$wN(u.to(J.range),De)}we.to=oe})(Qe||(e.DocumentLink=Qe={}));var _e;(function(we){function Se(J){const De=new d.$zN(J.label);return J.textEdit&&(De.textEdit=Me.to(J.textEdit)),J.additionalTextEdits&&(De.additionalTextEdits=J.additionalTextEdits.map(Ve=>Me.to(Ve))),De}we.to=Se;function oe(J){return{label:J.label,textEdit:J.textEdit?Me.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(De=>Me.from(De)):void 0}}we.from=oe})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(J){return new d.$xN(J[0],J[1],J[2],J[3])}we.to=Se;function oe(J){return[J.red,J.green,J.blue,J.alpha]}we.from=oe})(et||(e.Color=et={}));var tt;(function(we){function Se(J){return{range:u.from(J.range)}}we.from=Se;function oe(J){return new d.$gN(u.to(J.range))}we.to=oe})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Se(oe){switch(oe){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}we.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(we){function Se(J){switch(J){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.Interval:return 3;case d.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function oe(J){switch(J){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 3:return d.TextEditorLineNumbersStyle.Interval;case 1:default:return d.TextEditorLineNumbersStyle.On}}we.to=oe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(we){function Se(J){if(J===d.EndOfLine.CRLF)return 1;if(J===d.EndOfLine.LF)return 0}we.from=Se;function oe(J){if(J===1)return d.EndOfLine.CRLF;if(J===0)return d.EndOfLine.LF}we.to=oe})(at||(e.EndOfLine=at={}));var mt;(function(we){function Se(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(we){function Se(J){const De={start:J.start+1,end:J.end+1};return J.kind&&(De.kind=st.from(J.kind)),De}we.from=Se;function oe(J){const De={start:J.start-1,end:J.end-1};return J.kind&&(De.kind=st.to(J.kind)),De}we.to=oe})(je||(e.FoldingRange=je={}));var st;(function(we){function Se(J){if(J)switch(J){case d.FoldingRangeKind.Comment:return r.$$t.Comment;case d.FoldingRangeKind.Imports:return r.$$t.Imports;case d.FoldingRangeKind.Region:return r.$$t.Region}}we.from=Se;function oe(J){if(J)switch(J.value){case r.$$t.Comment.value:return d.FoldingRangeKind.Comment;case r.$$t.Imports.value:return d.FoldingRangeKind.Imports;case r.$$t.Region.value:return d.FoldingRangeKind.Region}}we.to=oe})(st||(e.FoldingRangeKind=st={}));var Y;(function(we){function Se(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?u.from(oe.selection):void 0,override:typeof oe.override=="boolean"?c.$iF.id:void 0}}we.from=Se})(Y||(e.TextEditorOpenOptions=Y={}));var Z;(function(we){function Se(Ve){return Ve instanceof d.$UN?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new d.$UN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}we.from=Se;function oe(Ve){const Ze=Ve;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ve){const Ze=Ve;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function De(Ve){return typeof Ve=="string"?Ve:new d.$UN(s.URI.revive(Ve.baseUri),Ve.pattern)}we.to=De})(Z||(e.GlobPattern=Z={}));var $e;(function(we){function Se(oe){if(oe){if(Array.isArray(oe))return oe.map(Se);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:Z.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Se})($e||(e.LanguageSelector=$e={}));var Ge;(function(we){function Se(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(De=>Array.isArray(De)&&De.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ze=>Ze instanceof d.$YM)))}we.is=Se;function oe(J){return{documents:J.documents.map(De=>De.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ze=>u.from(Ze))})))}}we.from=oe})(Ge||(e.MappedEditsContext=Ge={}));var ye;(function(we){function Se(J){return{start:J.start,end:J.end}}we.from=Se;function oe(J){return new d.$lO(J.start,J.end)}we.to=oe})(ye||(e.NotebookRange=ye={}));var ot;(function(we){function Se(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Se;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=oe})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(we){function Se(oe){if(oe===i.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(oe===i.NotebookCellExecutionState.Pending)return;if(oe===i.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(we){function Se(J){switch(J){case d.NotebookCellKind.Markup:return i.CellKind.Markup;case d.NotebookCellKind.Code:default:return i.CellKind.Code}}we.from=Se;function oe(J){switch(J){case i.CellKind.Markup:return d.NotebookCellKind.Markup;case i.CellKind.Code:default:return d.NotebookCellKind.Code}}we.to=oe})(It||(e.NotebookCellKind=It={}));var Qt;(function(we){function Se(J){const De={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)d.$mO.validate(Ve),De.cells.push(Ut.from(Ve));return De}we.from=Se;function oe(J){const De=new d.$nO(J.cells.map(Ut.to));return(0,m.$gg)(J.metadata)||(De.metadata=J.metadata),De}we.to=oe})(Qt||(e.NotebookData=Qt={}));var Ut;(function(we){function Se(J){return{cellKind:It.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ot.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(_t.from):[]}}we.from=Se;function oe(J){return new d.$mO(It.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(_t.to):void 0,J.metadata,J.internalMetadata?ot.to(J.internalMetadata):void 0)}we.to=oe})(Ut||(e.NotebookCellData=Ut={}));var xt;(function(we){function Se(J){return{mime:J.mime,valueBytes:F.$De.wrap(J.data)}}we.from=Se;function oe(J){return new d.$oO(J.valueBytes.buffer,J.mime)}we.to=oe})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(we){function Se(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}we.from=Se;function oe(J){const De=J.items.map(xt.to);return new d.$pO(De,J.outputId,J.metadata)}we.to=oe})(_t||(e.NotebookCellOutput=_t={}));var Ct;(function(we){function Se(De){return J(De)?{include:Z.from(De.include)??void 0,exclude:Z.from(De.exclude)??void 0}:Z.from(De)??void 0}we.from=Se;function oe(De){return J(De)?{include:Z.to(De.include),exclude:Z.to(De.exclude)}:Z.to(De)}we.to=oe;function J(De){const Ve=De;return Ve?!(0,m.$cg)(Ve.include)&&!(0,m.$cg)(Ve.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var Wt;(function(we){function Se(oe,J,De){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,De),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Se})(Wt||(e.NotebookStatusBarItem=Wt={}));var Zt;(function(we){function Se(oe,J,De){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,De),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Se})(Zt||(e.NotebookKernelSourceAction=Zt={}));var Ye;(function(we){function Se(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Se})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var si;(function(we){function Se(J){return{uri:J.uri,provides:J.provides}}we.from=Se;function oe(J){return new d.$rO(s.URI.revive(J.uri),J.provides)}we.to=oe})(si||(e.NotebookRendererScript=si={}));var Yt;(function(we){function Se(J){return{message:K.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:u.from(J.location.range),uri:J.location.uri}}}we.from=Se;function oe(J){const De=new d.$xO(typeof J.message=="string"?J.message:K.to(J.message));return De.actualOutput=J.actual,De.expectedOutput=J.expected,De.contextValue=J.contextValue,De.location=J.location?pe.to(J.location):void 0,De}we.to=oe})(Yt||(e.TestMessage=Yt={}));var lt;(function(we){we.namespace=a.$LL,we.denamespace=a.$ML})(lt||(e.TestTag=lt={}));var bt;(function(we){function Se(J){const De=(0,n.$dP)(J).controllerId;return{extId:$.$GL.fromExtHostTestItem(J,De).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>lt.namespace(De,Ve.id)),range:o.$pt.lift(u.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&K.fromStrict(J.error)||null}}we.from=Se;function oe(J){return{parent:void 0,error:void 0,id:$.$GL.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(De=>{const{tagId:Ve}=lt.denamespace(De);return new d.$yO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=oe})(bt||(e.TestItem=bt={})),function(we){function Se(J){return{id:J.id}}we.from=Se;function oe(J){return new d.$yO(J.id)}we.to=oe}(lt||(e.TestTag=lt={}));var ti;(function(we){const Se=(J,De)=>{const Ve=J.value;if(!Ve)return;const Ze={...bt.toPlain(Ve.item),parent:De,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Yt.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Se(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function oe(J){const De=new l.$9O;for(const qe of J.items)De.insert($.$GL.fromString(qe.item.extId).path,qe);const Ve=[De.nodes],Ze=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Ze.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Ze.map(qe=>Se(qe)).filter(m.$bg)}}we.to=oe})(ti||(e.TestResults=ti={}));var Xt;(function(we){function Se(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?D.from(Ve):u.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&oe(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}we.fromDetails=J;function De(Ve,Ze){return d.$AO(Ze.statementCoverage),d.$AO(Ze.branchCoverage),d.$AO(Ze.declarationCoverage),{id:Ve,uri:Ze.uri,statement:Se(Ze.statementCoverage),branch:Ze.branchCoverage&&Se(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Se(Ze.declarationCoverage)}}we.fromFile=De})(Xt||(e.TestCoverage=Xt={}));var Lt;(function(we){function Se(oe){switch(oe){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}we.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(we){function Se(J){const De=new d.$FO(Re.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),u.to(J.range),u.to(J.selectionRange));return De._sessionId=J._sessionId,De._itemId=J._itemId,De}we.to=Se;function oe(J,De,Ve){if(De=De??J._sessionId,Ve=Ve??J._itemId,De===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ve,kind:Re.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:u.from(J.range),selectionRange:u.from(J.selectionRange),tags:J.tags?.map(ie.from)}}we.from=oe})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(we){function Se(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Se})(jt||(e.ViewBadge=jt={}));var Bt;(function(we){function Se(Ve,Ze,qe){const ut=Ze.fileData;return ut?new d.$MN(new d.$NN(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):Ve===N.$Ms.uriList&&Ze.uriListData?new d.$LN(De(Ze.uriListData)):new d.$LN(Ze.asString)}we.to=Se;async function oe(Ve,Ze){const qe=await Ze.asString();if(Ve===N.$Ms.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=oe;function J(Ve){return R.$Pt.split(Ve).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function De(Ve){return R.$Pt.create(Ve.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(we){function Se(J,De){const Ve=J.items.map(([Ze,qe])=>[Ze,Bt.to(Ze,qe,De)]);return new d.$ON(Ve)}we.toDataTransfer=Se;async function oe(J){const De={items:[]},Ve=[];for(const[Ze,qe]of J)Ve.push((async()=>{De.items.push([Ze,await Bt.from(Ze,qe)])})());return await Promise.all(Ve),De}we.from=oe})(qt||(e.DataTransfer=qt={}));var He;(function(we){function Se(J,De){return{kind:"reply",agentId:J.participant??De?.agentId??"",subCommand:J.command??De?.command,message:J.prompt,title:J.label}}we.from=Se;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}we.to=oe})(He||(e.ChatFollowup=He={}));var ui;(function(we){function Se(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}we.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Gt;(function(we){function Se(J){switch(J.role){case 0:return new d.$4O(J.content);case 1:return new d.$5O(J.content);case 2:return new d.$6O(J.content)}}we.to=Se;function oe(J){if(J instanceof d.$4O)return{role:0,content:J.content};if(J instanceof d.$5O)return{role:1,content:J.content};if(J instanceof d.$6O)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}we.from=oe})(Gt||(e.LanguageModelMessage=Gt={}));var zt;(function(we){function Se(De){const Ve={};for(const Ze of Object.keys(De))Ve[Ze]=De[Ze].map(we.to);return Ve}we.objectTo=Se;function oe(De){return{level:gt.to(De.level),kind:De.kind,value:(0,s.$wc)(De.value)?s.URI.revive(De.value):De.value,description:De.description}}we.to=oe;function J(De){return{level:gt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=J})(zt||(e.ChatVariable=zt={}));var gt;(function(we){function Se(J){switch(J){case"short":return d.ChatVariableLevel.Short;case"medium":return d.ChatVariableLevel.Medium;case"full":default:return d.ChatVariableLevel.Full}}we.to=Se;function oe(J){switch(J){case d.ChatVariableLevel.Short:return"short";case d.ChatVariableLevel.Medium:return"medium";case d.ChatVariableLevel.Full:default:return"full"}}we.from=oe})(gt||(e.ChatVariableLevel=gt={}));var Nt;(function(we){function Se(oe){switch(oe){case 1:return d.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return d.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return d.InteractiveEditorResponseFeedbackKind.Undone;case 3:return d.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return d.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var At;(function(we){function Se(J){return{kind:"markdownContent",content:K.from(J.value)}}we.from=Se;function oe(J){return new d.$SO(K.to(J.content))}we.to=oe})(At||(e.ChatResponseMarkdownPart=At={}));var Ot;(function(we){function Se(J){return{kind:"markdownVuln",content:K.from(J.value),vulnerabilities:J.vulnerabilities}}we.from=Se;function oe(J){return new d.$TO(K.to(J.content),J.vulnerabilities)}we.to=oe})(Ot||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ot={}));var ii;(function(we){function Se(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}we.from=Se;function oe(J){return new d.$UO(J.agentId,J.command)}we.to=oe})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Ht;(function(we){function Se(J){const{value:De,baseUri:Ve}=J;function Ze(qe,ut){return qe.map(kt=>{const Tt=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Tt,children:kt.children&&Ze(kt.children,Tt)}})}return{kind:"treeData",treeData:{label:(0,b.$4g)(Ve),uri:Ve,children:Ze(De,Ve)}}}we.from=Se;function oe(J){const De=(0,k.$3h)(J.treeData);function Ve(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&Ve(kt.children)}))}const Ze=De.uri,qe=De.children?Ve(De.children):[];return new d.$VO(qe,Ze)}we.to=oe})(Ht||(e.ChatResponseFilesPart=Ht={}));var ni;(function(we){function Se(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:E.from(J.value)}}we.from=Se;function oe(J){const De=(0,k.$3h)(J);return new d.$WO(s.URI.isUri(De.inlineReference)?De.inlineReference:E.to(De.inlineReference),J.name)}we.to=oe})(ni||(e.ChatResponseAnchorPart=ni={}));var Ft;(function(we){function Se(J){return{kind:"progressMessage",content:K.from(J.value)}}we.from=Se;function oe(J){return new d.$XO(J.content.value)}we.to=oe})(Ft||(e.ChatResponseProgressPart=Ft={}));var Rt;(function(we){function Se(J,De,Ve){return{kind:"command",command:De.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}we.from=Se;function oe(J,De){return new d.$YO(De.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.to=oe})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var Pt;(function(we){function Se(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(De=>Me.from(De))}}we.from=Se;function oe(J){return new d.$1O(s.URI.revive(J.uri),J.edits.map(De=>Me.to(De)))}we.to=oe})(Pt||(e.ChatResponseTextEditPart=Pt={}));var Et;(function(we){function Se(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:E.from(J.value.value)}}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:E.from(J.value)}}we.from=Se;function oe(J){const De=(0,k.$3h)(J),Ve=Ze=>s.URI.isUri(Ze)?Ze:E.to(Ze);return new d.$ZO("variableName"in De.reference?{variableName:De.reference.variableName,value:De.reference.value&&Ve(De.reference.value)}:Ve(De.reference))}we.to=oe})(Et||(e.ChatResponseReferencePart=Et={}));var pt;(function(we){function Se(De,Ve,Ze){return De instanceof d.$SO?At.from(De):De instanceof d.$WO?ni.from(De):De instanceof d.$ZO?Et.from(De):De instanceof d.$XO?Ft.from(De):De instanceof d.$VO?Ht.from(De):De instanceof d.$YO?Rt.from(De,Ve,Ze):De instanceof d.$1O?Pt.from(De):De instanceof d.$TO?Ot.from(De):De instanceof d.$UO?ii.from(De):{kind:"markdownContent",content:K.from("")}}we.from=Se;function oe(De,Ve){switch(De.kind){case"reference":return Et.to(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(De,Ve)}}we.to=oe;function J(De,Ve){switch(De.kind){case"markdownContent":return At.to(De);case"inlineReference":return ni.to(De);case"progressMessage":return;case"treeData":return Ht.to(De);case"command":return Rt.to(De,Ve)}}we.toContent=J})(pt||(e.ChatResponsePart=pt={}));var St;(function(we){function Se(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,variables:oe.variables.variables.map(Dt.to),location:li.to(oe.location)}}we.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Se(oe){switch(oe){case h.ChatAgentLocation.Notebook:return d.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return d.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return d.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return d.ChatLocation.Editor}}we.to=Se})(li||(e.ChatLocation=li={}));var Dt;(function(we){function Se(oe){return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],values:oe.values.map(zt.to)}}we.to=Se})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(we){function Se(oe,J,De){return{label:oe.label,values:oe.values.map(zt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,De)}}we.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(we){function Se(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var bi;(function(we){function Se(oe,J,De){if(J.action.kind==="vote")return;const Ve=Kt.to(oe);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:De.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:He.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}we.to=Se})(bi||(e.ChatAgentUserActionEvent=bi={}));var ei;(function(we){function Se(oe,J,De){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,De)}we.from=Se})(ei||(e.TerminalQuickFix=ei={}));var wi;(function(we){function Se(oe){return{kind:yt.to(oe.kind)}}we.to=Se})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(we){function Se(oe){switch(oe){case 0:return d.PartialAcceptTriggerKind.Word;case 1:return d.PartialAcceptTriggerKind.Line;case 2:return d.PartialAcceptTriggerKind.Suggest;default:return d.PartialAcceptTriggerKind.Unknown}}we.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(we){function Se(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Pe[251],Ae([1,0,4,16,8,34]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;let M=class{constructor(g,k){this.a=g.getProxy(S.$UM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>k.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,k,N){const y=new O.$qw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,N?.isRefactoring??!1)}};e.$Qkc=M,e.$Qkc=M=Je([We(0,F.$hP)],M)}),define(Pe[252],Ae([1,0,18,11,43,5,40,6,65,17,2,20,4,8,7,214,26]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class r{constructor(h,i,$,a,v){this.j=h,this.k=i,this.l=$,this.m=a,this.n=v,this.b=g.$$d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(h.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,a),v}};const h=this;this.b.reset();const $=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){i(this.markdown);const v=new m.$SO(a),d=b.ChatResponseMarkdownPart.from(v);return $(d),this},markdownWithVulnerabilities(a,v){i(this.markdown),v&&(0,o.$CG)(h.j,"chatParticipantAdditions");const d=new m.$TO(a,v),P=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(d);return $(P),this},filetree(a,v){i(this.filetree);const d=new m.$VO(a,v),P=b.ChatResponseFilesPart.from(d);return $(P),this},anchor(a,v){i(this.anchor);const d=new m.$WO(a,v),P=b.ChatResponseAnchorPart.from(d);return $(P),this},button(a){i(this.anchor);const v=new m.$YO(a),d=b.ChatResponseCommandButtonPart.from(v,h.m,h.n);return $(d),this},progress(a){i(this.progress);const v=new m.$XO(a),d=b.ChatResponseProgressPart.from(v);return $(d),this},reference(a){if(i(this.reference),"variableName"in a&&!a.value){const v=h.k.variables.variables.find(d=>d.name===a.variableName);if(v){let d;if(v.references?.length)d=v.references.map(P=>({kind:"reference",reference:{variableName:a.variableName,value:P.reference}}));else{const P=new m.$ZO(a);d=[b.ChatResponseReferencePart.from(P)]}return d.forEach(P=>$(P)),this}}else{const v=new m.$ZO(a),d=b.ChatResponseReferencePart.from(v);$(d)}return this},textEdit(a,v){i(this.textEdit),(0,o.$CG)(h.j,"chatParticipantAdditions");const d=new m.$1O(a,v),P=b.ChatResponseTextEditPart.from(d);return $(P),this},detectedParticipant(a,v){i(this.detectedParticipant),(0,o.$CG)(h.j,"chatParticipantAdditions");const d=new m.$UO(a,v),P=b.ChatResponseDetectedParticipantPart.from(d);return $(P),this},push(a){if(i(this.push),(a instanceof m.$1O||a instanceof m.$TO||a instanceof m.$UO)&&(0,o.$CG)(h.j,"chatParticipantAdditions"),a instanceof m.$ZO)this.reference(a.value);else{const v=b.ChatResponsePart.from(a,h.m,h.n);$(v)}return this}}}return this.g}}class t extends p.$Vc{static{this.b=0}constructor(h,i,$){super(),this.n=i,this.s=$,this.c=new Map,this.j=this.B(new p.$5c),this.m=this.B(new p.$Uc),this.g=h.getProxy(l.$UM.MainThreadChatAgents2)}transferActiveChat(h){this.g.$transferActiveChatSession(h)}createChatAgent(h,i,$){const a=t.b++,v=new n(h,i,this.g,a,$);return this.c.set(a,v),this.g.$registerAgent(a,h.identifier,i,{},void 0),v.apiAgent}createDynamicChatAgent(h,i,$,a,v){const d=t.b++,P=new n(h,i,this.g,d,v);return this.c.set(d,P),this.g.$registerAgent(d,h.identifier,i,{isSticky:!0},{name:$,description:a}),P.apiAgent}async $invokeAgent(h,i,$,a){const v=this.c.get(h);if(!v)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let d=this.j.get(i.sessionId);d||(d=new p.$Uc,this.j.set(i.sessionId,d));const P=new r(v.extension,i,this.g,this.s.converter,d);try{const u=await this.t(i.agentId,$),E=v.invoke(b.ChatAgentRequest.to(i),{history:u},P.apiObject,a);return await(0,F.$hh)(Promise.resolve(E).then(f=>{if(f?.metadata)try{JSON.stringify(f.metadata)}catch(D){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${v.extension.identifier.value}] [@${v.id}] ${w}`,v.extension),{errorDetails:{message:w},timings:P.timings}}return{errorDetails:f?.errorDetails,timings:P.timings,metadata:f?.metadata}}),a)}catch(u){return this.n.error(u,v.extension),{errorDetails:{message:(0,R.$ej)(u),responseIsIncomplete:!0}}}finally{P.close()}}async t(h,i){const $=[];for(const a of i.history){const v=b.ChatAgentResult.to(a.result),d=h===a.request.agentId?v:{...v,metadata:void 0};$.push(new m.$2O(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentResolvedVariable.to),a.request.agentId));const P=(0,S.$Hb)(a.response.map(u=>b.ChatResponsePart.toContent(u,this.s.converter)));$.push(new m.$3O(P,d,a.request.agentId,a.request.command))}return $}$releaseSession(h){this.j.deleteAndDispose(h)}async $provideFollowups(h,i,$,a,v){const d=this.c.get(i);if(!d)return Promise.resolve([]);const P=await this.t(d.id,a),u=b.ChatAgentResult.to($);return(await d.provideFollowups(u,{history:P},v)).filter(E=>{const f=!E.participant||M.Iterable.some(this.c.values(),D=>D.id===E.participant&&y.$Om.equals(D.extension.identifier,d.extension.identifier));return f||this.n.warn(`[@${d.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),f}).map(E=>b.ChatFollowup.from(E,h))}$acceptFeedback(h,i,$,a){const v=this.c.get(h);if(!v)return;const d=b.ChatAgentResult.to(i);let P;switch($){case s.InteractiveSessionVoteDirection.Down:P=m.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:P=m.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(a?{result:d,kind:P,reportIssue:a}:{result:d,kind:P}))}$acceptAction(h,i,$){const a=this.c.get(h);if(!a||$.action.kind==="vote")return;const v=b.ChatAgentUserActionEvent.to(i,$,this.s.converter);v&&a.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(h,i,$){const a=this.c.get(h);return a?(await a.invokeCompletionProvider(i,$)).map(d=>b.ChatAgentCompletionItem.from(d,this.s.converter,this.m)):[]}async $provideWelcomeMessage(h,i,$){const a=this.c.get(h);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(i),$)}async $provideSampleQuestions(h,i,$){const a=this.c.get(h);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(i),$)).map(v=>b.ChatFollowup.from(v,void 0))}}e.$Rkc=t;class n{constructor(h,i,$,a,v){this.extension=h,this.id=i,this.u=$,this.w=a,this.x=v,this.n=new O.$ce,this.o=new O.$ce}acceptFeedback(h){this.n.fire(h)}acceptAction(h){this.o.fire(h)}async invokeCompletionProvider(h,i){return this.q?await this.q.provider.provideCompletionItems(h,i)??[]:[]}async provideFollowups(h,i,$){if(!this.b)return[];const a=await this.b.provideFollowups(h,i,$);return a?a.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(h,i){if(!this.s)return[];const $=await this.s.provideWelcomeMessage(h,i);return $?$.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(h,i){if(!this.s||!this.s.provideSampleQuestions)return[];const $=await this.s.provideSampleQuestions(h,i);return $||[]}get apiAgent(){let h=!1,i=!1;const $=()=>{h||i||(i=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof N.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$SN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:b.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),i=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.c=v,$()},get iconPath(){return a.d},set iconPath(v){a.d=v,$()},get requestHandler(){return a.x},set requestHandler(v){(0,k.$dg)(typeof v=="function","Invalid request handler"),a.x=v},get followupProvider(){return a.b},set followupProvider(v){a.b=v,$()},get isDefault(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.g=v,$()},get helpTextPrefix(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.j=v,$()},get helpTextVariablesPrefix(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.k=v,$()},get helpTextPostfix(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.l=v,$()},get isSecondary(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.m=v,$()},get supportIssueReporting(){return(0,o.$CG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(v){(0,o.$CG)(a.extension,"chatParticipantAdditions"),a.p=v,$()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(v){if((0,o.$CG)(a.extension,"chatParticipantAdditions"),a.q=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,v.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$CG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(v){(0,o.$CG)(a.extension,"defaultChatParticipant"),a.s=v,$()},get welcomeMessageProvider(){return(0,o.$CG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$BG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(v){a.t=v,$()},get requester(){return a.t},dispose(){h=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(h,i,$,a){return this.x(h,i,$,a)}}}),define(Pe[253],Ae([1,0,14,6,4,8,7,26]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class g{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(R.$UM.MainThreadChatVariables)}async $resolveVariable(y,l,b,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$CG)(s.extension,"chatParticipantAdditions");const o=new k(l,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:b},o.apiObject,m);if(r)return r.map(O.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:b},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,S.$2)(o)}}registerVariableResolver(y,l,b,m){const s=g.a++;return this.b.set(s,{extension:y,data:{name:l,description:b},resolver:m}),this.c.$registerVariable(s,{name:l,description:b}),(0,F.$Tc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Skc=g;class k{constructor(y,l){this.c=y,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,b=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){l(this.progress);const s=new M.$XO(m),o=O.ChatResponseProgressPart.from(s);return b(o),this},reference(m){l(this.reference);const s=new M.$ZO(m),o=O.ChatResponseReferencePart.from(s);return b(o),this},push(m){return l(this.push),m instanceof M.$ZO?b(O.ChatResponseReferencePart.from(m)):m instanceof M.$XO&&b(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Pe[254],Ae([1,0,11,68,5,6,2,87,20,8,7,4,26]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=b;function b(m,s,o){const r=m.getProxy(y.$UM.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Qm,s.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const E=this.b.get(u.handle);return E?E.value:u}else if(u&&u.$mid===7){const E=u,f=this.b.get(E.commentControlHandle);if(!f)return E;const D=f.getCommentThread(E.commentThreadHandle);return D?D.value:E}else if(u&&(u.$mid===9||u.$mid===8)){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const f=E.getCommentThread(u.thread.commentThreadHandle);return f?u.$mid===8?f.value:{thread:f.value,text:u.text}:u}else if(u&&u.$mid===10){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const f=E.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const D=u.commentUniqueId,w=f.getCommentByUniqueId(D);return w||u}else if(u&&u.$mid===11){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const f=E.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const D=u.text,w=u.commentUniqueId,C=f.getCommentByUniqueId(w);return C?(typeof C.body=="string"?C.body=D:C.body=new N.$lN(D),C):u}return u}})}createCommentController(u,E,f){const D=t.a++,w=new c(u,D,E,f);this.b.set(w.handle,w);const C=this.c.get(u.identifier)||[];return C.push(w),this.c.set(u.identifier,C),w.value}async $createCommentThreadTemplate(u,E,f){const D=this.b.get(u);D&&D.$createCommentThreadTemplate(E,f)}async $setActiveComment(u,E){const f=this.b.get(u);f&&f.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(u,E,f){const D=this.b.get(u);D&&D.$updateCommentThreadTemplate(E,f)}$deleteCommentThread(u,E){this.b.get(u)?.$deleteCommentThread(E)}async $provideCommentingRanges(u,E,f){const D=this.b.get(u);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(M.URI.revive(E));return(0,S.$lh)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(w.document,f);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(W=>k.Range.from(W)),fileComments:C.fileComments}),I})}$toggleReaction(u,E,f,D,w){const C=this.b.get(u);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,S.$lh)(()=>{const I=C.getCommentThread(E);if(I){const W=I.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,$(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,typeof u=="object"?((0,l.$CG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=u.resolved,this.b.applicability=u.applicability):this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,E,f,D,w,C,I,W){this.m=E,this.n=f,this.o=D,this.p=w,this.q=C,this.extensionDescription=I,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$ce,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${u}.${this.handle}`),r.$createCommentThread(E,this.handle,this.n,this.o,k.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{r.$deleteCommentThread(E,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const u=f=>Object.prototype.hasOwnProperty.call(this.b,f),E={};u("range")&&(E.range=k.Range.from(this.p)),u("label")&&(E.label=this.label),u("contextValue")&&(E.contextValue=this.contextValue??null),u("comments")&&(E.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),u("collapsibleState")&&(E.collapseState=a(this.g)),u("canReply")&&(E.canReply=this.canReply),u("state")&&(E.state=v(this.h)),u("applicability")&&(E.applicability=d(this.h)),u("isTemplate")&&(E.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(u){for(const E of this.k){const f=E[0],D=E[1];if(u===D)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Je([(0,F.$Yh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,u?.resourceHints&&(0,l.$CG)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,u?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$CG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$CG)(this.h,"activeComment"),this.f}constructor(u,E,f,D){this.h=u,this.i=E,this.j=f,this.k=D,this.a=new Map,r.$registerCommentController(this.handle,f,D,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(C){w.options=C},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(C){w.commentingRangeProvider=C},get reactionHandler(){return w.reactionHandler},set reactionHandler(C){w.reactionHandler=C},get activeCommentThread(){return w.activeCommentThread},createCommentThread(C,I,W){return w.createCommentThread(C,I,W).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(u,E,f){E===void 0&&(0,l.$CG)(this.h,"fileComments");const D=new n(this.id,this.handle,void 0,u,E,f,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(u){if(!u){this.e=void 0,this.f=void 0;return}const E=this.a.get(u.commentThreadHandle);E&&(this.e=u.uniqueIdInThread?E.getCommentByUniqueId(u.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(u,E){const f=new n(this.id,this.handle,void 0,M.URI.revive(u),k.Range.to(E),[],this.h,!0);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(u,E){const f=this.a.get(u);f&&(f.range=k.Range.to(E))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.g.forEach(u=>u.dispose())}}function h(P,u,E,f){let D=E.get(u);return D||(D=++P.commentHandle,E.set(u,D)),u.state!==void 0&&(0,l.$CG)(f,"commentsDraftState"),u.reactions?.some(w=>w.reactors!==void 0)&&(0,l.$CG)(f,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:D,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(w=>i(w)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function i(P){return{label:P.label,iconPath:P.iconPath?k.$gP(P.iconPath):void 0,count:P.count,hasReacted:P.authorHasReacted,reactors:P.reactors&&P.reactors.length>0&&typeof P.reactors[0]!="string"?P.reactors.map(u=>u.name):P.reactors}}function $(P){return{label:P.label||"",count:P.count||0,iconPath:P.iconPath?M.URI.revive(P.iconPath):"",authorHasReacted:P.hasReacted||!1,reactors:P.reactors?.map(u=>({name:u}))}}function a(P){if(P!==void 0)switch(P){case N.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function v(P){let u;if(typeof P=="object"?u=P.resolved:u=P,u!==void 0)switch(u){case N.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function d(P){let u;if(typeof P=="object"&&(u=P.applicability),u!==void 0)switch(u){case N.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new t}}),define(Pe[255],Ae([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class b{constructor($,a){this.document=$,this.b=a,this.a=1,this.c=new N.$Ckc("custom documents")}addEdit($){return this.c.add([$])}async undo($,a){await this.f($).undo(),a||this.disposeBackup()}async redo($,a){await this.f($).redo(),a||this.disposeBackup()}disposeEdits($){for(const a of $)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const $=h(this.document.uri)+this.a++;return(0,M.$7g)(this.b,$)}updateBackup($){this.d?.delete(),this.d=$}disposeBackup(){this.d?.delete(),this.d=void 0}f($){const a=this.c.get($,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get($,a){return this.a.get(this.b($,a))}add($,a,v){const d=this.b($,a.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${$} resource:${a.uri}`);const P=new b(a,v);return this.a.set(d,P),P}delete($,a){const v=this.b($,a.uri);this.a.delete(v)}b($,a){return`${$}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider($,a,v){return this.b(0,$,a,v)}addCustomProvider($,a,v){return this.b(1,$,a,v)}get($){return this.a.get($)}b($,a,v,d){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:$,extension:v,provider:d}),new l.$WM(()=>this.a.delete(a))}}class r{constructor($,a,v,d,P){this.d=a,this.f=v,this.g=d,this.h=P,this.b=new o,this.c=new m,this.a=$.getProxy(y.$UM.MainThreadCustomEditors)}registerCustomEditorProvider($,a,v,d){const P=new R.$Uc;return n(v)?(P.add(this.b.addTextProvider(a,$,v)),this.a.$registerTextEditorProvider((0,k.$_kc)($),a,d.webviewOptions||{},{supportsMove:!!v.moveCustomTextEditor},(0,k.$0kc)($))):(P.add(this.b.addCustomProvider(a,$,v)),t(v)&&P.add(v.onDidChangeCustomDocument(u=>{const E=this.i(a,u.document.uri);if(c(u)){const f=E.addEdit(u);this.a.$onDidEdit(u.document.uri,a,f,u.label)}else this.a.$onContentChange(u.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.$_kc)($),a,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,k.$0kc)($))),l.$WM.from(P,new l.$WM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument($,a,v,d,P){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${a}'`);const E=p.URI.revive($),f=await u.provider.openCustomDocument(E,{backupId:v,untitledDocumentData:d?.buffer},P);let D;return t(u.provider)&&this.f&&(D=this.f.workspaceValue(u.extension)??this.f.globalValue(u.extension)),this.c.add(a,f,D),{editable:t(u.provider)}}async $disposeCustomDocument($,a){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provider type for '${a}'`);const d=p.URI.revive($),{document:P}=this.i(a,d);this.c.delete(a,P),P.dispose()}async $resolveCustomEditor($,a,v,d,P,u){const E=this.b.get(v);if(!E)throw new Error(`No provider found for '${v}'`);const f=g.ViewColumn.to(P),D=this.g.createNewWebview(a,d.contentOptions,E.extension),w=this.h.createNewWebviewPanel(a,v,d.title,f,d.options,D,d.active),C=p.URI.revive($);switch(E.type){case 1:{const{document:I}=this.i(v,C);return E.provider.resolveCustomEditor(I,w,u)}case 0:{const I=this.d.getDocument(C);return E.provider.resolveCustomTextEditor(I,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits($,a,v){this.i(a,$).disposeEdits(v)}async $onMoveCustomEditor($,a,v){const d=this.b.get(v);if(!d)throw new Error(`No provider found for '${v}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${v}'`);const P=this.h.getWebviewPanel($);if(!P)throw new Error("No webview found");const u=p.URI.revive(a),E=this.d.getDocument(u);await d.provider.moveCustomTextEditor(E,P,S.CancellationToken.None)}async $undo($,a,v,d){return this.i(a,$).undo(v,d)}async $redo($,a,v,d){return this.i(a,$).redo(v,d)}async $revert($,a,v){const d=this.i(a,$);await this.j(a).revertCustomDocument(d.document,v),d.disposeBackup()}async $onSave($,a,v){const d=this.i(a,$);await this.j(a).saveCustomDocument(d.document,v),d.disposeBackup()}async $onSaveAs($,a,v,d){const P=this.i(a,$);return this.j(a).saveCustomDocumentAs(P.document,p.URI.revive(v),d)}async $backup($,a,v){const d=this.i(a,$),u=await this.j(a).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},v);return d.updateBackup(u),u.id}i($,a){const v=this.c.get($,p.URI.revive(a));if(!v)throw new Error("No custom document found");return v}j($){const v=this.b.get($)?.provider;if(!v||!t(v))throw new Error("Custom document is not editable");return v}}e.$clc=r;function t(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const $=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,F.$hj)($)+""}}),define(Pe[256],Ae([1,0,163,100,2,4,7,8,5,13,28,45]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class b{#e;#t;#i;constructor(o,r,t,n,c,h,i,$){this.d=o,this.e=r,this.f=t,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,t),this.#i=new N.$Bc(a=>h.getComparisonKey(a)),this.#e=i,this.#t=$}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,r){if(!o){this.clear();return}this.j();let t=[];if(R.URI.isUri(o)){if(!r){this.delete(o);return}this.#i.set(o,r.slice()),t=[o]}else if(Array.isArray(o)){t=[];let h;o=[...o].sort(b.k);for(const i of o){const[$,a]=i;if((!h||$.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=$,t.push($),this.#i.set($,[])),a)this.#i.get($)?.push(...a);else{const v=this.#i.get($);v&&(v.length=0)}}}if(this.#t.fire(t),!this.#e)return;const n=[];let c=0;for(const h of t){let i=[];const $=this.#i.get(h);if($)if($.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const d of $)if(d.severity===a[v]&&i.push({...p.Diagnostic.from(d),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,$.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=$.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(h)}));if(n.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,r){this.j();for(const[t,n]of this)o.call(r,t,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const r=this.#i.get(o);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,r){return o[0].toString()<r[0].toString()?-1:o[0].toString()>r[0].toString()?1:0}}e.$Jkc=b;let m=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const r=new N.$Bc;for(const t of o)r.set(t,t);return{uris:Object.freeze(Array.from(r.values()))}}constructor(o,r,t,n){this.j=r,this.k=t,this.l=n,this.g=new Map,this.h=new g.$ge({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(O.$UM.MainThreadDiagnostics)}createDiagnosticCollection(o,r){const{g:t,f:n,h:c,j:h,k:i,l:$}=this,a=new class{$changeMany(P,u){n.$changeMany(P,u),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,P,u.length===0?"CLEARING":u)}$clear(P){n.$clear(P),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,P)}dispose(){n.dispose()}};let v;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,v=r;else if(!t.has(r))v=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do v=r+l.c++;while(t.has(v))}return new class extends b{constructor(){super(r,v,l.e,l.d,P=>$.getDocument(P)?.version,i.extUri,a,c),t.set(v,this)}dispose(){super.dispose(),t.delete(v)}}}getDiagnostics(o){if(o)return this.m(o);{const r=new Map,t=[];for(const n of this.g.values())n.forEach((c,h)=>{let i=r.get(c.toString());typeof i>"u"&&(i=t.length,r.set(c.toString(),i),t.push([c,[]])),t[i][1]=t[i][1].concat(...h)});return t}}m(o){let r=[];for(const t of this.g.values())t.has(o)&&(r=r.concat(t.get(o)));return r}$acceptMarkersChange(o){if(!this.n){const r="_generated_mirror",t=new b(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,t),this.n=t}for(const[r,t]of o)this.n.set(R.URI.revive(r),t.map(p.Diagnostic.to))}};e.$Kkc=m,e.$Kkc=m=l=Je([We(1,k.$Zj),We(2,y.$Ikc)],m)}),define(Pe[257],Ae([1,0,2,14,7,8,192,34]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class g{constructor(N,y,l,b={timeout:1500,errors:3}){this.c=N,this.d=y,this.f=l,this.g=b,this.a=new M.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(y,l,b)=>{const s={dispose:this.a.push([y,l,N])};return Array.isArray(b)&&b.push(s),s}}async $participateInSave(N,y){const l=S.URI.revive(N);let b=!1;const m=setTimeout(()=>b=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(b)break;const r=this.d.getDocument(l),t=await this.h(o,{document:r,reason:O.TextDocumentSaveReason.to(y)});s.push(t)}}finally{clearTimeout(m)}return s}h([N,y,l],b){const m=this.b.get(N);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(l,N,y,b).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(N);this.b.set(N,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,y,l,b){const m=[],s=Date.now(),{document:o,reason:r}=b,{version:t}=o,n=Object.freeze({document:o,reason:r,waitUntil(c){if(Object.isFrozen(m))throw(0,F.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(l,[n])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const i=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then($=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c($)}).catch($=>{clearTimeout(i),h($)})}).then(c=>{const h={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every($=>$ instanceof R.$4M))for(const{newText:$,newEol:a,range:v}of i)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:v&&O.Range.from(v),text:$,eol:a&&O.EndOfLine.from(a)}});if(h.edits.length!==0)return t===o.version?this.f.$tryApplyWorkspaceEdit(new p.$qw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$Slc=g}),define(Pe[258],Ae([1,0,5,6,2,4,111,8,17,25,7]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class y{constructor(b,m){this.a=new S.$ce,this.b=new S.$ce,this.c=new S.$ce,this.d=new S.$ce,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Uc,this.h=new Map,this.f=b.getProxy(O.$UM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const r=R.URI.revive(o);return(0,g.$eg)(this.g.getDocument(r))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(b,m){const s=R.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(b){const m=R.URI.revive(b),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,m){const s=R.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,s){const o=R.URI.revive(b),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(m);let t;m.isUndoing?t=N.TextDocumentChangeReason.Undo:m.isRedoing&&(t=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.$1n)({document:r.document,contentChanges:m.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:t}))}setWordDefinitionFor(b,m){(0,M.$jP)(b,m)}}e.$Lkc=y}),define(Pe[66],Ae([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0,e.$dlc=(0,M.$ti)("IExtHostEditorTabs");class y{constructor(o,r,t){this.e=t,this.d=r,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$GO(O.URI.revive(this.b.input.uri));case 2:return new N.$HO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new N.$IO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new N.$JO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$KO(this.b.input.viewType);case 4:return new N.$LO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$MO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$NO;case 9:return new N.$OO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$PO;case 11:return new N.$QO(this.b.input.diffEditors.map(o=>new N.$HO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class l{constructor(o,r){this.c=[],this.d="",this.b=o,this.e=r;for(const t of o.tabs)t.isActive&&(this.d=t.id),this.c.push(new y(t,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(t=>t.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(t=>t.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const t=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,t),o.tabDto.isActive&&(this.d=t.tabId),t}else if(o.kind===1){const t=this.c.splice(o.index,1)[0];if(!t)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return t.tabId===this.d&&(this.d=""),t}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const t=this.c.splice(o.oldIndex,1)[0];if(!t)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,t),t}const r=this.c.find(t=>t.tabId===o.tabDto.id);if(!r)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(o.tabDto),r}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new F.$ce,this.c=new F.$ce,this.e=[],this.a=o.getProxy(p.$UM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,r={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(t=>t.apiObject))},get activeTabGroup(){const t=o.d;return(0,R.$eg)(o.e.find(c=>c.groupId===t)?.apiObject)},close:async(t,n)=>{const c=Array.isArray(t)?t:[t];return c.length?m(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(o){const r=new Set(this.e.map(a=>a.groupId)),t=new Set(o.map(a=>a.groupId)),n=(0,S.$L)(r,t),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],i=[];this.e=o.map(a=>{const v=new l(a,()=>this.d);return n.added.includes(v.groupId)?h.push(v.apiObject):i.push(v.apiObject),v});const $=(0,R.$eg)(o.find(a=>a.isActive===!0)?.groupId);$!==void 0&&this.d!==$&&(this.d=$),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const r=this.e.find(t=>t.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const r=this.e.find(n=>n.groupId===o.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const t=r.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[t.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[t.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[t.apiObject]}));return}}g(o){for(const r of this.e)for(const t of r.tabs)if(t.apiObject===o)return t}h(o){return this.e.find(r=>r.apiObject===o)}async i(o,r){const t=[];for(const n of o){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");t.push(c.tabId)}return this.a.$closeTab(t,r)}async j(o,r){const t=[];for(const n of o){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");t.push(c.groupId)}return this.a.$closeGroup(t,r)}};e.$elc=b,e.$elc=b=Je([We(0,g.$hP)],b);function m(s){return s.tabs!==void 0}}),define(Pe[260],Ae([1,0,2,4,6,7,8,303,15,22,26,54]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let r,t,n=14,c=14;for(const h of s){let i=r?(0,g.$xf)(r,h):0;for(i===0?t=1:t=c;i<h.length;i++)i+1===h.length?(n=c,c=9):c+=1,o.push([t,h.toUpperCase().charCodeAt(i),c]),o.push([t,h.toLowerCase().charCodeAt(i),c]),t=c;r=h,c=n}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$82(o)}}provideDocumentLinks(s){this.c();const o=[],r=p.$92.computeLinks({getLineContent(t){return s.lineAt(t-1).text},getLineCount(){return s.lineCount}},this.b);for(const t of r){const n=M.DocumentLink.to(t);n.target&&o.push(n)}return o}}class b{constructor(s,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(F.$UM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,r,t={}){if(b.j(r),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(o),this.d.add(o),this.c.set(n,r);let c=2;t.isCaseSensitive&&(c+=1024),t.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,N.$CG)(s,"fsChunks"),c+=4);let h;t.isReadonly&&(0,y.$Sk)(t.isReadonly)&&t.isReadonly.value!==""&&(h={value:t.isReadonly.value,isTrusted:t.isReadonly.isTrusted,supportThemeIcons:t.isReadonly.supportThemeIcons,supportHtml:t.isReadonly.supportHtml,baseUri:t.isReadonly.baseUri,uris:t.isReadonly.uris}),this.a.$registerFileSystemProvider(n,o,c,h).catch($=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error($)});const i=r.onDidChangeFile($=>{const a=[];for(const v of $){const{uri:d,type:P}=v;if(d.scheme!==o)continue;let u;switch(P){case O.FileChangeType.Changed:u=0;break;case O.FileChangeType.Created:u=1;break;case O.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:d,type:u})}this.a.$onFileSystemChange(n,a)});return(0,R.$Tc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:r,mtime:t,size:n,permissions:c}=s;return{type:o,ctime:r,mtime:t,size:n,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(S.URI.revive(o))).then(r=>b.k(r))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(S.URI.revive(o))).then(r=>k.$De.wrap(r))}$writeFile(s,o,r,t){return Promise.resolve(this.l(s).writeFile(S.URI.revive(o),r.buffer,t))}$delete(s,o,r){return Promise.resolve(this.l(s).delete(S.URI.revive(o),r))}$rename(s,o,r,t){return Promise.resolve(this.l(s).rename(S.URI.revive(o),S.URI.revive(r),t))}$copy(s,o,r,t){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(o),S.URI.revive(r),t))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(o)))}$watch(s,o,r,t){const n=this.l(s).watch(S.URI.revive(r),t);this.f.set(o,n)}$unwatch(s,o){const r=this.f.get(o);r&&(r.dispose(),this.f.delete(o))}$open(s,o,r){const t=this.l(s);if(!t.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(t.open(S.URI.revive(o),r))}$close(s,o){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(o))}$read(s,o,r,t){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$De.alloc(t);return Promise.resolve(n.read(o,r,c.buffer,0,t)).then(h=>c.slice(0,h))}$write(s,o,r,t){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,r,t.buffer,0,t.byteLength))}l(s){const o=this.c.get(s);if(!o){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return o}}e.$Ulc=b}),define(Pe[261],Ae([1,0,5,36,2,4,8,7,41]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,m,s,o,r,t){this.a=Math.random(),this.b=new S.$ce,this.c=new S.$ce,this.d=new S.$ce,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$nk)(r),c=typeof r=="string",h=t?.correlate,i=o($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(h&&typeof $.session>"u")){if(!t?.ignoreCreateEvents)for(const a of $.created){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.b.fire(v)}if(!t?.ignoreChangeEvents)for(const a of $.changed){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.c.fire(v)}if(!t?.ignoreDeleteEvents)for(const a of $.deleted){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.d.fire(v)}}});this.g=p.$WM.from(this.i(b,s,r,t,t?.correlate),this.b,this.c,this.d,i)}i(b,m,s,o,r){const t=p.$WM.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return t;const n=b.getProxy(O.$UM.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(F.$jk)||s.pattern.includes(F.$kk))&&(c=!0);let h;return r&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(h=14,o?.ignoreChangeEvents&&(h&=-3),o?.ignoreCreateEvents&&(h&=-5),o?.ignoreDeleteEvents&&(h&=-9)),n.$watch(m.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[],filter:h},!!r),p.$WM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(b){this.a=b,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(b,m,s){this.j=b,this.k=m,this.l=s,this.a=new S.$ce,this.b=new S.$ce,this.c=new S.$ce,this.d=new S.$ce,this.g=new S.$ee,this.h=new S.$ee,this.i=new S.$ee,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,m,s,o){return new k(this.j,b,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(b){this.a.fire(new N(b))}$onDidRunFileOperation(b,m){switch(b){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,m){return(s,o,r)=>{const t=function(c){s.call(o,c)};return t.extension=b,m.event(t,void 0,r)}}async $onWillRunFileOperation(b,m,s,o){switch(b){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(r=>R.URI.revive(r.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(r=>R.URI.revive(r.target))},s,o)}}async n(b,m,s,o){const r=new Set,t=[];if(await b.fireAsync(m,o,async(c,h)=>{const i=Date.now(),$=await Promise.resolve(c);$ instanceof p.$7M&&(t.push([h.extension,$]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||t.length===0)return;const n={edits:[]};for(const[,c]of t){const{edits:h}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(r)}}}e.$Vlc=y}),define(Pe[262],Ae([1,0,18,11,24,14,90,6,25,65,15,17,2,29,304,87,97,165,20,8,7,26,74,4]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class a{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const H=this.d.getDocument(U),G=await this.e.provideDocumentSymbols(H,z);if(!(0,S.$Kb)(G))return G[0]instanceof c.$dN?G.map(n.DocumentSymbol.from):a.f(G)}static f(U){U=U.slice(0).sort((G,ee)=>{let ne=G.location.range.start.compareTo(ee.location.range.start);return ne===0&&(ne=ee.location.range.end.compareTo(G.location.range.end)),ne});const z=[],H=[];for(const G of U){const ee={name:G.name||"!!MISSING: name!!",kind:n.SymbolKind.from(G.kind),tags:G.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:n.Range.from(G.location.range),selectionRange:n.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),z.push(ee);break}const ne=H[H.length-1];if(b.$pt.containsRange(ne.range,ee.range)&&!b.$pt.equalsRange(ne.range,ee.range)){ne.children?.push(ee),H.push(ee);break}H.pop()}}return z}}class v{constructor(U,z,H,G,ee,ne){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.l=ne,this.d=new i.$Ckc("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const H=this.f.getDocument(U),G=await this.h.provideCodeLenses(H,z);if(!G||z.isCancellationRequested)return;const ee=this.d.add(G),ne=new p.$Uc;this.e.set(ee,ne);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<G.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:n.Range.from(G[Be].range),command:this.g.toInternal(G[Be].command,ne)});return Oe}async resolveCodeLens(U,z){const H=U.cacheId&&this.d.get(...U.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,z),G||(G=H),z.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!G.command){const ne=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ne),this.l.error(ne);return}return U.command=this.g.toInternal(G.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function d(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class P{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDefinition(G,ee,H);return d(ne)}}class u{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDeclaration(G,ee,H);return d(ne)}}class E{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideImplementation(G,ee,H);return d(ne)}}class f{constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideTypeDefinition(G,ee,H);return d(ne)}}class D{constructor(U,z){this.d=U,this.e=z}async provideHover(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideHover(G,ee,H);if(!(!ne||(0,S.$Kb)(ne.contents)))return ne.range||(ne.range=G.getWordRangeAtPosition(ee)),ne.range||(ne.range=new c.$YM(ee,ee)),n.Hover.from(ne)}}class w{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideEvaluatableExpression(G,ee,H);if(ne)return n.EvaluatableExpression.from(ne)}}class C{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,H,G){const ee=this.d.getDocument(U),ne=await this.e.provideInlineValues(ee,n.Range.to(z),n.InlineValueContext.to(H),G);if(Array.isArray(ne))return ne.map(Oe=>n.InlineValue.from(Oe))}}class I{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(ne))return ne.map(n.DocumentHighlight.from)}}class W{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,H,G){const ee=this.d.getDocument(U),ne=H.map(Qe=>this.d.getDocument(Qe)),Oe=n.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,ne,G);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class V{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideLinkedEditingRanges(G,ee,H);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,S.$Hb)(ne.ranges.map(n.Range.from)),wordPattern:ne.wordPattern}}}class q{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Position.to(z),Oe=await this.e.provideReferences(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class A{static{this.d=1e3}constructor(U,z,H,G,ee,ne,Oe){this.g=U,this.h=z,this.j=H,this.k=G,this.l=ee,this.m=ne,this.n=Oe,this.e=new i.$Ckc("CodeAction"),this.f=new Map}async provideCodeActions(U,z,H,G){const ee=this.g.getDocument(U),ne=m.$rt.isISelection(z)?n.Selection.to(z):n.Range.to(z),Oe=[];for(const it of this.j.getDiagnostics(U))if(ne.intersection(it.range)&&Oe.push(it)>A.d)break;const Be={diagnostics:Oe,only:H.only?new c.$fN(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(ee,ne,Be,G);if(!(0,S.$Lb)(Qe)||G.isCancellationRequested)return;const _e=this.e.add(Qe),et=new p.$Uc;this.f.set(_e,et);const tt=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(n.Diagnostic.from),edit:nt.edit&&n.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$BG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$BG)(this.m,"codeActionRanges")?(0,S.$Hb)(at.map(n.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(U,z){const[H,G]=U,ee=this.e.get(H,G);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ne=await this.k.resolveCodeAction(ee,z)??ee;let Oe;ne.edit&&(Oe=n.WorkspaceEdit.from(ne.edit,void 0));let Be;if(ne.command){const Qe=this.f.get(H);Qe&&(Be=this.h.toInternal(ne.command,Qe))}return{edit:Oe,command:Be}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class j{constructor(U,z,H,G,ee){this.e=U,this.f=z,this.g=H,this.h=G,this.j=ee,this.d=new i.$Ckc("DocumentPasteEdit")}async prepareDocumentPaste(U,z,H,G){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),ne=z.map(Qe=>n.Range.to(Qe)),Oe=n.DataTransfer.toDataTransfer(H,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,ne,Oe,G),G.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof c.$LN));return n.DataTransfer.from(Be)}async providePasteEdits(U,z,H,G,ee,ne){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(z),Be=H.map(tt=>n.Range.to(tt)),Qe=n.DataTransfer.toDataTransfer(G,async tt=>(await this.e.$resolvePasteFileData(this.h,U,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,Qe,{only:ee.only?new c.$QN(ee.only):void 0,triggerKind:ee.triggerKind},ne);if(!_e||ne.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[H,G]=U,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const ne=await this.g.resolveDocumentPasteEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(G,z,H);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class re{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,H,G){(0,y.$dg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),ne=z.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class ae{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,H,G,ee){const ne=this.d.getDocument(U),Oe=n.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(ne,Oe,H,G,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class be{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Ckc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const H=await this.e.provideWorkspaceSymbols(U,z);if(!(0,S.$Lb)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let ne=0;ne<H.length;ne++){const Oe=H[ne];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[G,ne]})}return ee}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const H=this.d.get(...U.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,z);return G&&(0,g.$3n)(U,n.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Ie{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideRenameEdits(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Position.to(z);try{const Oe=await this.e.provideRenameEdits(ee,ne,H,G);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Ie.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(U,z,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(U),ee=n.Position.to(z);try{const ne=await this.e.prepareRename(G,ee,H);let Oe,Be;if(c.$YM.isRange(ne)?(Oe=ne,Be=G.getText(ne)):(0,y.$8f)(ne)&&(Oe=ne.range,Be=ne.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Be}}catch(ne){const Oe=Ie.g(ne);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(ne)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class de{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideNewSymbolNames(U,z,H){const G=this.d.getDocument(U),ee=n.Range.to(z);try{const ne=await this.e.provideNewSymbolNames(G,ee,H);return ne?ne.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(ne){this.f.error(de.g(ne)??JSON.stringify(ne,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class me{constructor(U,z){this.resultId=U,this.tokens=z}}class Me{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,H){const G=this.f.getDocument(U),ee=z!==0?this.d.get(z):null;let ne=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(z),ne?(ne=Me.h(ne),this.o(Me.n(ee,ne),ne)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Me.j(U)?Me.k(U)?U:new c.$eO(new Uint32Array(U.data),U.resultId):Me.l(U)?Me.m(U)?U:new c.$gO(U.edits.map(z=>new c.$fO(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!Me.j(z)||!U||!U.tokens)return z;const H=U.tokens,G=H.length,ee=z.data,ne=ee.length;let Oe=0;const Be=Math.min(G,ne);for(;Oe<Be&&H[Oe]===ee[Oe];)Oe++;if(Oe===G&&Oe===ne)return new c.$gO([],z.resultId);let Qe=0;const _e=Be-Oe;for(;Qe<_e&&H[G-Qe-1]===ee[ne-Qe-1];)Qe++;return new c.$gO([{start:Oe,deleteCount:G-Oe-Qe,data:ee.subarray(Oe,ne-Qe)}],z.resultId)}o(U,z){if(Me.j(U)){const H=this.e++;return this.d.set(H,new me(U.resultId,U.data)),(0,o.$Pbb)({id:H,type:"full",data:U.data})}if(Me.l(U)){const H=this.e++;return Me.j(z)?this.d.set(H,new me(z.resultId,z.data)):this.d.set(H,new me(U.resultId)),(0,o.$Pbb)({id:H,type:"delta",deltas:(U.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ce{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(G,n.Range.to(z),H);return ee?this.f(ee):null}f(U){return(0,o.$Pbb)({id:0,type:"full",data:U.data})}}class Re{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,H,G,ee){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.d=new i.$Ckc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,H,G){const ee=this.f.getDocument(U),ne=n.Position.to(z),Oe=ee.getWordRangeAtPosition(ne)||new c.$YM(ne,ne),Be=Oe.with({end:ne}),Qe=new k.$$d,_e=await this.h.provideCompletionItems(ee,ne,G,n.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const et=Array.isArray(_e)?new c.$sN(_e):_e,tt=Re.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Uc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:n.Range.from(Oe),insert:n.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let mt=0;mt<et.items.length;mt++){const je=et.items[mt],st=this.l(je,[tt,mt],Be,Oe);nt.push(st)}return at}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...U);if(!H)return;const G=this.l(H,U),ee=await this.h.resolveCompletionItem(H,z);if(!ee)return;const ne=this.l(ee,U);return(G.h!==ne.h||G.i!==ne.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==ne.n||G.o!==ne.o||!(0,g.$4n)(G.p,ne.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:ne.d,c:ne.c,l:ne.l,h:ne.h,i:ne.i,n:ne.n,o:ne.o,p:ne.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,H,G){const ee=this.e.get(z[0]);if(!ee)throw Error("DisposableStore is missing...");const ne=this.g.toInternal(U.command,ee),Oe={x:z,a:U.label,b:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(n.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),n:ne?.$ident,o:ne?.id,p:ne?.$ident?void 0:ne?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof c.$8M&&(Oe.h=U.insertText.value,Oe.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.$YM.isRange(Be)?Oe.j=n.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!G?.isEqual(Be.replacing))&&(Oe.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Oe}}class ie{async provideInlineCompletions(U,z,H,G){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,H){}handlePartialAccept(U,z,H,G){}}class L extends ie{constructor(U,z,H,G){super(),this.f=U,this.g=z,this.h=H,this.j=G,this.d=new ve,this.e=(0,h.$BG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$BG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,H,G){const ee=this.g.getDocument(U),ne=n.Position.to(z),Oe=await this.h.provideInlineCompletionItems(ee,ne,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Oe||G.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Uc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?n.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new p.$Uc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,H){const G=this.d.get(U)?.items[z];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(U,z,H,G){const ee=this.d.get(U)?.items[z];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,H),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(G)))}}class x{async provideInlineEdits(U,z,H){const G=this.f.getDocument(U),ee=await this.g.provideInlineEdit(G,{triggerKind:this.e[z.triggerKind]},H);if(!ee||H.isCancellationRequested)return;let ne;const Oe=this.d.createReferenceId({dispose(){ne?.dispose()},item:ee});let Be;ee.accepted&&(ne||(ne=new p.$Uc),Be=this.h.toInternal(ee.accepted,ne));let Qe;return ee.rejected&&(ne||(ne=new p.$Uc),Qe=this.h.toInternal(ee.rejected,ne)),{pid:Oe,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,H,G){this.f=z,this.g=H,this.h=G,this.d=new ve,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class Te{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Ckc("SignatureHelp")}async provideSignatureHelp(U,z,H,G){const ee=this.e.getDocument(U),ne=n.Position.to(z),Oe=this.g(H),Be=await this.f.provideSignatureHelp(ee,ne,G,Oe);if(Be){const Qe=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Qe}}}g(U){let z;if(U.activeSignatureHelp){const H=n.SignatureHelp.to(U.activeSignatureHelp),G=this.d.get(U.activeSignatureHelp.id,0);G?(z=G,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class ke{constructor(U,z,H,G,ee){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.d=new i.$Ckc("InlayHints"),this.e=new Map}async provideInlayHints(U,z,H){const G=this.f.getDocument(U),ee=n.Range.to(z),ne=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(ne)||ne.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(H.isCancellationRequested)return;const Oe=this.d.add(ne);this.e.set(Oe,new p.$Uc);const Be={hints:[],cacheId:Oe};for(let Qe=0;Qe<ne.length;Qe++)this.l(ne[Qe],ee)&&Be.hints.push(this.m(ne[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...U);if(!H)return;const G=await this.h.resolveInlayHint(H,z);if(G&&this.l(G))return this.m(G,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const H=this.e.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:z,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")G.label=U.label;else{const ee=[];G.label=ee;for(const ne of U.label){if(!ne.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:ne.value,tooltip:n.MarkdownString.fromStrict(ne.tooltip)};c.$9M.isLocation(ne.location)&&(Oe.location=n.location.from(ne.location)),ne.command&&(Oe.command=this.g.toInternal(ne.command,H)),ee.push(Oe)}}return G}}class pe{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Ckc("DocumentLink")}async provideLinks(U,z){const H=this.e.getDocument(U),G=await this.f.provideDocumentLinks(H,z);if(!(!Array.isArray(G)||G.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(n.DocumentLink.from)};{const ee=this.d.add(G),ne={links:[],cacheId:ee};for(let Oe=0;Oe<G.length;Oe++){if(!pe.g(G[Oe]))continue;const Be=n.DocumentLink.from(G[Oe]);Be.cacheId=[ee,Oe],ne.links.push(Be)}return ne}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...U);if(!H)return;const G=await this.f.resolveDocumentLink(H,z);if(!(!G||!pe.g(G)))return n.DocumentLink.from(G)}releaseLinks(U){this.d.delete(U)}}class fe{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const H=this.d.getDocument(U),G=await this.e.provideDocumentColors(H,z);return Array.isArray(G)?G.map(ne=>({color:n.Color.from(ne.color),range:n.Range.from(ne.range)})):[]}async provideColorPresentations(U,z,H){const G=this.d.getDocument(U),ee=n.Range.to(z.range),ne=n.Color.to(z.color),Oe=await this.e.provideColorPresentations(ne,{document:G,range:ee},H);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class Q{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(G,z,H);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class X{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideSelectionRanges(U,z,H){const G=this.d.getDocument(U),ee=z.map(n.Position.to),ne=await this.e.provideSelectionRanges(G,ee,H);if(!(0,S.$Lb)(ne))return[];if(ne.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Oe.push(Qe);let _e=ee[Be],et=ne[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(n.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Oe}}class le{constructor(U,z){this.f=U,this.g=z,this.d=new M.$mP(""),this.e=new Map}async prepareSession(U,z,H){const G=this.f.getDocument(U),ee=n.Position.to(z),ne=await this.g.prepareCallHierarchy(G,ee,H);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideCallsTo(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(ee)return ee.map(ne=>({from:this.h(U,ne.from),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(ee)return ee.map(ne=>({to:this.h(U,ne.to),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),G=n.CallHierarchyItem.from(z,U,H.size.toString(36));return H.set(G._itemId,z),G}j(U,z){return this.e.get(U)?.get(z)}}class ue{constructor(U,z){this.f=U,this.g=z,this.d=new M.$mP(""),this.e=new Map}async prepareSession(U,z,H){const G=this.f.getDocument(U),ee=n.Position.to(z),ne=await this.g.prepareTypeHierarchy(G,ee,H);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideSupertypes(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(ee)return ee.map(ne=>this.h(U,ne))}async provideSubtypes(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(ee)return ee.map(ne=>this.h(U,ne))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),G=n.TypeHierarchyItem.from(z,U,H.size.toString(36));return H.set(G._itemId,z),G}j(U,z){return this.e.get(U)?.get(z)}}class Ne{constructor(U,z,H,G,ee){this.e=U,this.f=z,this.g=H,this.h=G,this.j=ee,this.d=new i.$Ckc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,z,H,G,ee){const ne=this.f.getDocument(z),Oe=n.Position.to(H),Be=n.DataTransfer.toDataTransfer(G,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,tt)).buffer),Qe=await this.g.provideDocumentDropEdits(ne,Oe,Be,ee);if(!Qe)return;const _e=(0,S.$3b)(Qe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,z){const[H,G]=U,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentDropEdit)return{};const ne=await this.g.resolveDocumentDropEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class he{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,H,G){const ee=l.URI.revive(U),ne=this.d.getDocument(ee),Oe=H.documents.map(_e=>_e.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>n.Range.to(tt))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ne,z,Be,G);return Qe?n.WorkspaceEdit.from(Qe):null}}class Ce{constructor(U,z){this.adapter=U,this.extension=z}}class Fe{static{this.d=0}constructor(U,z,H,G,ee,ne,Oe,Be){this.g=z,this.h=H,this.j=G,this.k=ee,this.l=ne,this.m=Oe,this.n=Be,this.f=new Map,this.e=U.getProxy($.$UM.MainThreadLanguageFeatures)}o(U,z){return n.DocumentSelector.from(U,this.g,z)}p(U){return new c.$WM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Fe.d++}async s(U,z,H,G,ee,ne=!1){const Oe=this.f.get(U);if(!Oe||!(Oe.adapter instanceof z))return G;const Be=Date.now();ne||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{ne||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,F.$ih)(Qe,ee):Qe}t(U,z){const H=this.q();return this.f.set(H,new Ce(U,z)),H}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,z,H,G){const ee=this.t(new a(this.h,H),U),ne=G&&G.label||Fe.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(z,U),ne),this.p(ee)}$provideDocumentSymbols(U,z,H){return this.s(U,a,G=>G.provideDocumentSymbols(l.URI.revive(z),H),void 0,H)}registerCodeLensProvider(U,z,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Ce(new v(this.h,this.j.converter,H,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(G,this.o(z,U),ee);let ne=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));ne=c.$WM.from(ne,Oe)}return ne}$provideCodeLenses(U,z,H){return this.s(U,v,G=>G.provideCodeLenses(l.URI.revive(z),H),void 0,H)}$resolveCodeLens(U,z,H){return this.s(U,v,G=>G.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,v,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,H){const G=this.t(new P(this.h,H),U);return this.e.$registerDefinitionSupport(G,this.o(z,U)),this.p(G)}$provideDefinition(U,z,H,G){return this.s(U,P,ee=>ee.provideDefinition(l.URI.revive(z),H,G),[],G)}registerDeclarationProvider(U,z,H){const G=this.t(new u(this.h,H),U);return this.e.$registerDeclarationSupport(G,this.o(z,U)),this.p(G)}$provideDeclaration(U,z,H,G){return this.s(U,u,ee=>ee.provideDeclaration(l.URI.revive(z),H,G),[],G)}registerImplementationProvider(U,z,H){const G=this.t(new E(this.h,H),U);return this.e.$registerImplementationSupport(G,this.o(z,U)),this.p(G)}$provideImplementation(U,z,H,G){return this.s(U,E,ee=>ee.provideImplementation(l.URI.revive(z),H,G),[],G)}registerTypeDefinitionProvider(U,z,H){const G=this.t(new f(this.h,H),U);return this.e.$registerTypeDefinitionSupport(G,this.o(z,U)),this.p(G)}$provideTypeDefinition(U,z,H,G){return this.s(U,f,ee=>ee.provideTypeDefinition(l.URI.revive(z),H,G),[],G)}registerHoverProvider(U,z,H,G){const ee=this.t(new D(this.h,H),U);return this.e.$registerHoverProvider(ee,this.o(z,U)),this.p(ee)}$provideHover(U,z,H,G){return this.s(U,D,ee=>ee.provideHover(l.URI.revive(z),H,G),void 0,G)}registerEvaluatableExpressionProvider(U,z,H,G){const ee=this.t(new w(this.h,H),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(z,U)),this.p(ee)}$provideEvaluatableExpression(U,z,H,G){return this.s(U,w,ee=>ee.provideEvaluatableExpression(l.URI.revive(z),H,G),void 0,G)}registerInlineValuesProvider(U,z,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ne=this.t(new C(this.h,H),U);this.e.$registerInlineValuesProvider(ne,this.o(z,U),ee);let Oe=this.p(ne);if(ee!==void 0){const Be=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Oe=c.$WM.from(Oe,Be)}return Oe}$provideInlineValues(U,z,H,G,ee){return this.s(U,C,ne=>ne.provideInlineValues(l.URI.revive(z),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(U,z,H){const G=this.t(new I(this.h,H),U);return this.e.$registerDocumentHighlightProvider(G,this.o(z,U)),this.p(G)}registerMultiDocumentHighlightProvider(U,z,H){const G=this.t(new W(this.h,H),U);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(z,U)),this.p(G)}$provideDocumentHighlights(U,z,H,G){return this.s(U,I,ee=>ee.provideDocumentHighlights(l.URI.revive(z),H,G),void 0,G)}$provideMultiDocumentHighlights(U,z,H,G,ee){return this.s(U,W,ne=>ne.provideMultiDocumentHighlights(l.URI.revive(z),H,G.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,z,H){const G=this.t(new V(this.h,H),U);return this.e.$registerLinkedEditingRangeProvider(G,this.o(z,U)),this.p(G)}$provideLinkedEditingRanges(U,z,H,G){return this.s(U,V,async ee=>{const ne=await ee.provideLinkedEditingRanges(l.URI.revive(z),H,G);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Fe.w(ne.wordPattern):void 0}},void 0,G)}registerReferenceProvider(U,z,H){const G=this.t(new q(this.h,H),U);return this.e.$registerReferenceSupport(G,this.o(z,U)),this.p(G)}$provideReferences(U,z,H,G,ee){return this.s(U,q,ne=>ne.provideReferences(l.URI.revive(z),H,G,ee),void 0,ee)}registerCodeActionProvider(U,z,H,G){const ee=new p.$Uc,ne=this.t(new A(this.h,this.j.converter,this.k,H,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ne,this.o(z,U),{providedKinds:G?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:G?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Fe.u(U),!!H.resolveCodeAction),ee.add(this.p(ne)),ee}$provideCodeActions(U,z,H,G,ee){return this.s(U,A,ne=>ne.provideCodeActions(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveCodeAction(U,z,H){return this.s(U,A,G=>G.resolveCodeAction(z,H),{},void 0)}$releaseCodeActions(U,z){this.s(U,A,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,H){const G=this.t(new K(this.h,H),U);return this.e.$registerDocumentFormattingSupport(G,this.o(z,U),U.identifier,U.displayName||U.name),this.p(G)}$provideDocumentFormattingEdits(U,z,H,G){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(z),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(U,z,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",ee=this.t(new re(this.h,H),U);return this.e.$registerRangeFormattingSupport(ee,this.o(z,U),U.identifier,U.displayName||U.name,G),this.p(ee)}$provideDocumentRangeFormattingEdits(U,z,H,G,ee){return this.s(U,re,ne=>ne.provideDocumentRangeFormattingEdits(l.URI.revive(z),H,G,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,z,H,G,ee){return this.s(U,re,ne=>ne.provideDocumentRangesFormattingEdits(l.URI.revive(z),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,z,H,G){const ee=this.t(new ae(this.h,H),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(z,U),G,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,z,H,G,ee,ne){return this.s(U,ae,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(z),H,G,ee,ne),void 0,ne)}registerWorkspaceSymbolProvider(U,z){const H=this.t(new be(z,this.l),U);return this.e.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(U,z,H){return this.s(U,be,G=>G.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(U,z,H){return this.s(U,be,G=>G.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,be,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,H){const G=this.t(new Ie(this.h,H,this.l),U);return this.e.$registerRenameSupport(G,this.o(z,U),Ie.supportsResolving(H)),this.p(G)}$provideRenameEdits(U,z,H,G,ee){return this.s(U,Ie,ne=>ne.provideRenameEdits(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveRenameLocation(U,z,H,G){return this.s(U,Ie,ee=>ee.resolveRenameLocation(l.URI.revive(z),H,G),void 0,G)}registerNewSymbolNamesProvider(U,z,H){const G=this.t(new de(this.h,H,this.l),U);return this.e.$registerNewSymbolNamesProvider(G,this.o(z,U)),this.p(G)}$provideNewSymbolNames(U,z,H,G){return this.s(U,de,ee=>ee.provideNewSymbolNames(l.URI.revive(z),H,G),void 0,G)}registerDocumentSemanticTokensProvider(U,z,H,G){const ee=this.t(new Me(this.h,H),U),ne=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(z,U),G,ne);let Oe=this.p(ee);if(ne){const Be=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ne));Oe=c.$WM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(U,z,H,G){return this.s(U,Me,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(z),H,G),null,G)}$releaseDocumentSemanticTokens(U,z){this.s(U,Me,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,H,G){const ee=this.t(new ce(this.h,H),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(z,U),G),this.p(ee)}$provideDocumentRangeSemanticTokens(U,z,H,G){return this.s(U,ce,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(z),H,G),null,G)}registerCompletionItemProvider(U,z,H,G){const ee=this.t(new Re(this.h,this.j.converter,H,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(z,U),G,Re.supportsResolving(H),U.identifier),this.p(ee)}$provideCompletionItems(U,z,H,G,ee){return this.s(U,Re,ne=>ne.provideCompletionItems(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveCompletionItem(U,z,H){return this.s(U,Re,G=>G.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(U,z){this.s(U,Re,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,H,G){const ee=new L(U,this.h,H,this.j.converter),ne=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(ne,this.o(z,U),ee.supportsHandleEvents,t.$Om.toKey(U.identifier.value),G?.yieldTo?.map(Oe=>t.$Om.toKey(Oe))||[]),this.p(ne)}$provideInlineCompletions(U,z,H,G,ee){return this.s(U,ie,ne=>ne.provideInlineCompletions(l.URI.revive(z),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(U,z,H,G){this.s(U,ie,async ee=>{ee.handleDidShowCompletionItem(z,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,H,G,ee){this.s(U,ie,async ne=>{ne.handlePartialAccept(z,H,G,ee)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,ie,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,H){const G=new x(U,this.h,H,this.j.converter),ee=this.t(G,U);return this.e.$registerInlineEditProvider(ee,this.o(z,U),U.identifier),this.p(ee)}$provideInlineEdit(U,z,H,G){return this.s(U,x,ee=>ee.provideInlineEdits(l.URI.revive(z),H,G),void 0,G)}$freeInlineEdit(U,z){this.s(U,x,async H=>{H.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,ne=this.t(new Te(this.h,H),U);return this.e.$registerSignatureHelpProvider(ne,this.o(z,U),ee),this.p(ne)}$provideSignatureHelp(U,z,H,G,ee){return this.s(U,Te,ne=>ne.provideSignatureHelp(l.URI.revive(z),H,G,ee),void 0,ee)}$releaseSignatureHelp(U,z){this.s(U,Te,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,H,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(z,U),typeof H.resolveInlayHint=="function",G,Fe.u(U));let ne=this.p(ee);if(G!==void 0){const Oe=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(G));ne=c.$WM.from(ne,Oe)}return ne}$provideInlayHints(U,z,H,G){return this.s(U,ke,ee=>ee.provideInlayHints(l.URI.revive(z),H,G),void 0,G)}$resolveInlayHint(U,z,H){return this.s(U,ke,G=>G.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(U,z){this.s(U,ke,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,H){const G=this.t(new pe(this.h,H),U);return this.e.$registerDocumentLinkProvider(G,this.o(z,U),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(U,z,H){return this.s(U,pe,G=>G.provideLinks(l.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(U,z,H){return this.s(U,pe,G=>G.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,pe,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,H){const G=this.t(new fe(this.h,H),U);return this.e.$registerDocumentColorProvider(G,this.o(z,U)),this.p(G)}$provideDocumentColors(U,z,H){return this.s(U,fe,G=>G.provideColors(l.URI.revive(z),H),[],H)}$provideColorPresentations(U,z,H,G){return this.s(U,fe,ee=>ee.provideColorPresentations(l.URI.revive(z),H,G),void 0,G)}registerFoldingRangeProvider(U,z,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Ce(new Q(this.h,H),U)),this.e.$registerFoldingRangeProvider(G,this.o(z,U),U.identifier,ee);let ne=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ne=c.$WM.from(ne,Oe)}return ne}$provideFoldingRanges(U,z,H,G){return this.s(U,Q,ee=>ee.provideFoldingRanges(l.URI.revive(z),H,G),void 0,G)}registerSelectionRangeProvider(U,z,H){const G=this.t(new X(this.h,H,this.l),U);return this.e.$registerSelectionRangeProvider(G,this.o(z,U)),this.p(G)}$provideSelectionRanges(U,z,H,G){return this.s(U,X,ee=>ee.provideSelectionRanges(l.URI.revive(z),H,G),[],G)}registerCallHierarchyProvider(U,z,H){const G=this.t(new le(this.h,H),U);return this.e.$registerCallHierarchyProvider(G,this.o(z,U)),this.p(G)}$prepareCallHierarchy(U,z,H,G){return this.s(U,le,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(U,z,H,G){return this.s(U,le,ee=>ee.provideCallsTo(z,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(U,z,H,G){return this.s(U,le,ee=>ee.provideCallsFrom(z,H,G),void 0,G)}$releaseCallHierarchy(U,z){this.s(U,le,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,H){const G=this.t(new ue(this.h,H),U);return this.e.$registerTypeHierarchyProvider(G,this.o(z,U)),this.p(G)}$prepareTypeHierarchy(U,z,H,G){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),H,G)),void 0,G)}$provideTypeHierarchySupertypes(U,z,H,G){return this.s(U,ue,ee=>ee.provideSupertypes(z,H,G),void 0,G)}$provideTypeHierarchySubtypes(U,z,H,G){return this.s(U,ue,ee=>ee.provideSubtypes(z,H,G),void 0,G)}$releaseTypeHierarchy(U,z){this.s(U,ue,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,H,G){const ee=this.q();return this.f.set(ee,new Ce(new Ne(this.e,this.h,H,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(z,U),(0,h.$BG)(U,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,z,H,G,ee,ne){return this.s(U,Ne,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,l.URI.revive(H),G,ee,ne)),void 0,void 0)}$resolveDropEdit(U,z,H){return this.s(U,Ne,G=>G.resolveDropEdit(z,H),{},void 0)}$releaseDropEdits(U,z){this.s(U,Ne,H=>Promise.resolve(H.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(U,z,H){const G=this.t(new he(this.h,H),U);return this.e.$registerMappedEditsProvider(G,this.o(z,U)),this.p(G)}$provideMappedEdits(U,z,H,G,ee){return this.s(U,he,ne=>Promise.resolve(ne.provideMappedEdits(z,H,G,ee)),null,ee)}registerDocumentPasteEditProvider(U,z,H,G){const ee=this.q();return this.f.set(ee,new Ce(new j(this.e,this.h,H,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(z,U),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(ne=>ne.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,z,H,G,ee){return this.s(U,j,ne=>ne.prepareDocumentPaste(l.URI.revive(z),H,G,ee),void 0,ee)}$providePasteEdits(U,z,H,G,ee,ne,Oe){return this.s(U,j,Be=>Be.providePasteEdits(z,l.URI.revive(H),G,ee,ne,Oe),void 0,Oe)}$resolvePasteEdit(U,z,H){return this.s(U,j,G=>G.resolvePasteEdit(z,H),{},void 0)}$releasePasteEdits(U,z){this.s(U,j,H=>Promise.resolve(H.releasePasteEdits(z)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Fe.w(U.decreaseIndentPattern),increaseIndentPattern:Fe.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Fe.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Fe.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Fe.w(U.beforeText),afterText:U.afterText?Fe.w(U.afterText):void 0,previousLineText:U.previousLineText?Fe.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Fe.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>c.SyntaxTokenType.toString(z)):void 0}}static D(U){return U.map(Fe.C)}setLanguageConfiguration(U,z,H){const{wordPattern:G}=H;if(G&&(0,N.$hf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(z,G):this.h.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),ne={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Fe.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Fe.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Fe.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Fe.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,z,ne),this.p(ee)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Mkc=Fe}),define(Pe[88],Ae([1,0,6,4,8,7,101,20,11,5,166,106,14,3,16,84,13,40]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,b.$ti)("IExtHostLanguageModels");class n{constructor($,a){this.option=$,this.stream=new g.$Wh,this.stream=a??new g.$Wh}}class c{constructor(){this.a=new Map,this.b=new g.$Wh,this.c=!1,this.d=!1;const $=this;this.apiObject={stream:$.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;this.d=!0;let a=this.a.get($.index);a||(this.a.size===0?a=new n($.index,this.b):a=new n($.index),this.a.set($.index,a)),a.stream.emitOne($.part)}get isStreaming(){return this.d}reject($){this.c=!0;for(const a of this.f())a.reject($)}resolve(){this.c=!0;for(const $ of this.f())$.resolve()}}let h=class{static{t=this}static{this.a=1}constructor($,a,v){this.j=a,this.k=v,this.c=new k.$ce,this.d=new k.$ce,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Qm,this.i=new Map,this.o=new Set,this.b=$.getProxy(F.$UM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,a,v,d){const P=t.a++;this.f.set(P,{extension:$.identifier,provider:v,languageModelId:a});let u;return d.auth&&(u={providerLabel:$.displayName||$.name,accountLabel:typeof d.auth=="object"?d.auth.label:void 0}),this.b.$registerLanguageModelProvider(P,a,{extension:$.identifier,identifier:a,name:d.name??"",version:d.version,tokens:d.tokens,auth:u}),(0,S.$Tc)(()=>{this.f.delete(P),this.b.$unregisterProvider(P)})}async $provideLanguageModelResponse($,a,v,d,P,u){const E=this.f.get($);if(!E)return;const f=new M.$5v(async D=>{if(u.isCancellationRequested){this.j.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:D.index,part:D.part})});return E.provider.provideLanguageModelResponse2(d.map(R.LanguageModelMessage.to),P,p.$Om.toKey(v),f,u)}$provideTokenLength($,a,v){const d=this.f.get($);return d?Promise.resolve(d.provider.provideTokenCount(a,v)):Promise.resolve(0)}$updateLanguageModels($){const a=[],v=[];if($.added)for(const d of $.added)this.g.set(d.identifier,d),a.push(d.identifier);if($.removed)for(const d of $.removed){this.g.delete(d),v.push(d);for(const[P,u]of this.i)u.languageModelId===d&&(u.res.reject(new l.$5),this.i.delete(P))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(v)})),$.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist($){const a=new Array;for(const{from:v,to:d,enabled:P}of $){const u=this.h.get(v)??new p.$Pm;if(u.has(d)!==P){P?u.add(d):u.delete(d),this.h.set(v,u);const f={from:v,to:d};a.push(f),this.c.fire(f)}}}async sendChatRequest($,a,v,d,P){const u=$.identifier,E=await this.b.$prepareChatAccess(u,a,d.justification);if(!E||!this.g.has(a))throw O.$7O.NotFound(`Language model '${a}' is unknown.`);if(this.m(u,E)&&(!await this.l($,{identifier:E.extension,displayName:E.auth.providerLabel},d.justification,d.silent)||!this.h.get(u)?.has(E.extension)))throw O.$7O.NoPermissions(`Language model '${a}' cannot be used by '${u.value}'.`);const f=Math.random()*1e6|0,D=this.b.$fetchResponse(u,a,f,v.map(R.LanguageModelMessage.from),d.modelOptions??{},P),w=new g.$sh,C=new c;this.i.set(f,{languageModelId:a,res:C});let I;if(D.catch(W=>{w.isOpen()?C.reject(W):I=W}).finally(()=>{this.i.delete(f),C.resolve(),w.open()}),await w.wait(),I)throw new O.$7O(`Language model '${a}' errored, check cause for more details`,"Unknown",I);return C.apiObject}async $handleResponseFragment($,a){const v=this.i.get($);v&&v.res.handleFragment(a)}async l($,a,v,d){const P=y.$WL+a.identifier.value;if(await this.k.getSession($,P,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0;if(d)return!1;try{const E=v?(0,N.localize)(0,null,a.displayName,v):(0,N.localize)(1,null,a.displayName);return await this.k.getSession($,P,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m($,a){return!!a.auth&&!p.$Om.equals(a.extension,$)}async n($){for(const a of this.o)try{await this.l(a,{identifier:$.extension,displayName:""},void 0,!0)}catch(v){this.j.error("Fake Auth request failed"),this.j.error(v)}}async computeTokenLength($,a,v){const d=this.g.get($);if(!d)throw O.$7O.NotFound(`Language model '${$}' is unknown.`);const P=r.Iterable.find(this.f.values(),u=>u.languageModelId===$);return P?P.provider.provideTokenCount(a,v):this.b.$countTokens(d.identifier,typeof a=="string"?a:R.LanguageModelMessage.from(a),v)}getLanguageModelInfo($){const a=this.g.get($);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation($){this.o.add($);const a=this,v=k.Event.signal(k.Event.filter(this.c.event,P=>p.$Om.equals(P.from,$.identifier))),d=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(v,d)},canSendRequest(P){const u=a.g.get(P);if(!u)return;if(!a.m($.identifier,u))return!0;const E=a.h.get($.identifier);if(E)return E.has(u.extension)}}}};e.$ulc=h,e.$ulc=h=t=Je([We(0,m.$hP),We(1,o.$Zj),We(2,s.$Okc)],h)}),define(Pe[263],Ae([1,0,4,8,7,33,11,6,26]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class k{constructor(y,l,b,m){this.c=l,this.d=b,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(S.$UM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,l){await this.a.$changeLanguage(y,l);const b=this.c.getDocumentData(y);if(!b)throw new Error(`document '${y.toString()}' NOT found`);return b.document}async tokenAtPosition(y,l){const b=y.version,m=F.Position.from(l),s=await this.a.$tokensAtPosition(y.uri,m),o={type:R.StandardTokenType.Other,range:y.getWordRangeAtPosition(l)??new R.$YM(l.line,l.character,l.line,l.character)};if(!s)return o;const r={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!r.range.contains(l)||b!==y.version?o:r}createLanguageStatusItem(y,l,b){const m=this.f++,s=this.a,o=this.g,r=`${y.identifier.value}/${l}`;if(o.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(r);const t={selector:b,id:l,name:y.displayName??y.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new p.$Uc,h=()=>{if(n?.dispose(),!o.has(r)){console.warn(`LanguageStatusItem (${l}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$vh)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:r,name:t.name??y.displayName??y.name,source:y.displayName??y.name,selector:F.DocumentSelector.from(t.selector,this.e),label:t.text,detail:t.detail??"",severity:t.severity===R.LanguageStatusSeverity.Error?O.default.Error:t.severity===R.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:t.command&&this.d.toInternal(t.command,c),accessibilityInfo:t.accessibilityInformation,busy:t.busy})},0)},i={dispose(){c.dispose(),n?.dispose(),s.$removeLanguageStatus(m),o.delete(r)},get id(){return t.id},get name(){return t.name},set name($){t.name=$,h()},get selector(){return t.selector},set selector($){t.selector=$,h()},get text(){return t.text},set text($){t.text=$,h()},set text2($){(0,g.$CG)(y,"languageStatusText"),t.text=$,h()},get text2(){return(0,g.$CG)(y,"languageStatusText"),t.text},get detail(){return t.detail},set detail($){t.detail=$,h()},get severity(){return t.severity},set severity($){t.severity=$,h()},get accessibilityInformation(){return t.accessibilityInformation},set accessibilityInformation($){t.accessibilityInformation=$,h()},get command(){return t.command},set command($){t.command=$,h()},get busy(){return t.busy},set busy($){t.busy=$,h()}};return h(),i}}e.$_lc=k}),define(Pe[264],Ae([1,0,12,2,8,7,83]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=void 0;class p{constructor(y,l,b,m){this.start=y,this.deletedCount=l,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new O.$lO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,l,b){this.notebook=y,this.h=l,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(R.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(b)}return this.f}setOutputs(y){this.a=y.map(R.NotebookCellOutput.to)}setOutputItems(y,l,b){const m=b.map(R.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(l||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$RK(o.mime)))){const o=new Map,r=[];s.items.forEach(t=>{let n;o.has(t.mime)?n=o.get(t.mime):(n=[],o.set(t.mime,n),r.push(t.mime)),n.push(t.data)}),s.items.length=0,r.forEach(t=>{const n=M.$SK(o.get(t));s.items.push({mime:t,data:n.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Xlc=g;class k{static{this.a=0}constructor(y,l,b,m,s){this.k=y,this.l=l,this.m=b,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,l={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===S.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(b){return b=y.n(b),y.b[b].apiCell},getCells(b){return(b?y.p(b):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,l,b){this.g=y.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},s=[];for(const r of y.rawEvents)r.kind===M.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,m.contentChanges):r.kind===M.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,m.contentChanges):r.kind===M.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const o=new Map;for(let r=0;r<s.length;r++){const t=s[r],n=o.get(t.cell);if(n===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...t});o.set(t.cell,c-1)}else m.cellChanges[n]={...m.cellChanges[n],...t}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let l=y.start|0,b=y.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),y.with({start:l,end:b})}p(y){y=this.o(y);const l=[];for(let b=y.start;b<y.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,l,b){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(r=>{const n=r[2].map(i=>{const $=new g(this,this.l,i);return l||s.push(g.asModelAddData(i)),$}),c=new p(r[0],r[1],[],n),h=this.b.splice(r[0],r[1],...n);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),b)for(const r of m)b.push(r.asApiEvent())}s(y,l,b,m){const s=this.b.splice(y,l);this.b.splice(b,0,...s);const o=[new p(y,l,s.map(r=>r.apiCell),[]),new p(b,0,[],s)];for(const r of o)m.push(r.asApiEvent())}t(y,l){this.b[y].setOutputs(l)}u(y,l,b,m){this.b[y].setOutputItems(l,b,m)}v(y,l){const b=this.b[y];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(y,l){const b=this.b[y];b.apiCell.mime=l}x(y,l){this.b[y].setMetadata(l)}y(y,l){this.b[y].setInternalMetadata(l)}getCellFromApiCell(y){return this.b.find(l=>l.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(l=>l.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Ylc=k}),define(Pe[265],Ae([1,0,5,2,8,7,34]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;class p{constructor(k,N,y,l={timeout:1500,errors:3}){this.b=k,this.c=N,this.d=y,this.f=l,this.a=new S.$ee}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(N,y,l)=>{const b=function(s){N.call(y,s)};return b.extension=k,this.a.event(b,void 0,l)}}async $participateInSave(k,N,y){const l=F.URI.revive(k),b=this.c.getNotebookDocument(l);if(!b)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:R.TextDocumentSaveReason.to(N)},y,async(o,r)=>{const t=Date.now(),n=await await Promise.resolve(o);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!y.isCancellationRequested&&n&&(n instanceof O.$7M?m.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:r}=R.WorkspaceEdit.from(o);s.edits=s.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(new M.$qw(s))}}e.$bmc=p}),define(Pe[112],Ae([1,0,14,8,7]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,g,k,N,y,l){this.id=p,this.f=g,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=N,this.c=l}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(g){this.selections=[g]},get selections(){return p.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$lO.isNotebookRange))throw(0,S.$7)("selections");p.a=g,p.g(g)},get visibleRanges(){return p.b},revealRange(g,k){p.f.$tryRevealRange(p.id,F.NotebookRange.from(g),k??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(F.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Zlc=O}),define(Pe[266],Ae([1,0,5,13,8]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let O=class{constructor(p,g){this.c=p,this.d=g,this.a=new S.$ce,this.b=new S.$ce,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,g);const k=this.d.getEditorById(p);g.visibleRanges&&k._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&k._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const g in p)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(p[g]))}};e.$dmc=O,e.$dmc=O=Je([We(0,F.$Zj)],O)}),define(Pe[267],Ae([1,0,5,4,112]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class O{constructor(p,g){this.c=g,this.a=new Map,this.b=p.getProxy(F.$UM.MainThreadNotebookRenderers)}$postRendererMessage(p,g,k){const N=this.c.getEditorById(p);this.a.get(g)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(p,g){if(!p.contributes?.notebookRenderer?.some(N=>N.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(N,y,l)=>this.d(g).event(N,y,l),postMessage:(N,y)=>{R.$Zlc.apiEditorsToExtHost.has(N)&&([N,y]=[y,N]);const l=y&&R.$Zlc.apiEditorsToExtHost.get(y);return this.b.$postMessage(l?.id,g,N)}}}d(p){let g=this.a.get(p);return g||(g=new S.$ce({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(p)}}),this.a.set(p,g),g)}}e.$gmc=O}),define(Pe[268],Ae([1,0,8,101,24,68,14]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,l,b){const m=this.b++,{title:s,location:o,cancellable:r}=l,t={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:S.ProgressLocation.from(o),title:s,source:t,cancellable:r},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,b,!!r)}d(y,l,b){let m;b&&(m=new R.$ne,this.c.set(y,m));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),m?.dispose()};let o;try{o=l(new k(this.a,y),b&&m?m.token:R.CancellationToken.None)}catch(r){throw s(y),r}return o.then(r=>s(y),r=>s(y)),o}$acceptProgressCanceled(y){const l=this.c.get(y);l&&(l.cancel(),this.c.delete(y))}}e.$kmc=p;function g(N,y){return N.message=y.message,typeof y.increment=="number"&&(typeof N.increment=="number"?N.increment+=y.increment:N.increment=y.increment),N}class k extends F.$5v{constructor(y,l){super(b=>this.throttledReport(b)),this.c=y,this.d=l}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$Zh)(100,(N,y)=>g(N,y),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Pe[269],Ae([1,0,2,4,11,8]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class M{static{this.a=0}constructor(g,k){this.d=k,this.c=new Map,this.b=g.getProxy(F.$UM.MainThreadQuickDiff)}$provideOriginalResource(g,k,N){const y=S.URI.revive(k),l=this.c.get(g);return l?(0,R.$lh)(()=>l.provideOriginalResource(y,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(g,k,N,y){const l=M.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from(g,this.d),N,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$lmc=M}),define(Pe[270],Ae([1,0,24,5,6,4,2,7,14,18,33,42,26,8]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=m;function m(s,o,r){const t=s.getProxy(O.$UM.MainThreadQuickOpen);class n{constructor(u,E){this.e=new Map,this.f=0,this.a=u,this.b=E}showQuickPick(u,E,f,D=S.CancellationToken.None){this.c=void 0;const w=Promise.resolve(E),C=++this.f,I=t.$show(C,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},D),W={},V=I.then(()=>W);return Promise.race([V,w]).then(q=>{if(q===W)return;const A=(0,l.$BG)(u,"quickPickItemTooltip");return w.then(j=>{const K=[];for(let re=0;re<j.length;re++){const ae=j[re];if(typeof ae=="string")K.push({label:ae,handle:re});else if(ae.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ae.label});else{ae.tooltip&&!A&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const be=ae.iconPath?a(ae.iconPath):void 0;K.push({label:ae.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:A?b.MarkdownString.fromStrict(ae.tooltip):void 0,handle:re})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=re=>{f.onDidSelectItem(j[re])}),t.$setItems(C,K),I.then(re=>{if(typeof re=="number")return j[re];if(Array.isArray(re))return re.map(ae=>j[ae])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return t.$setError(C,q),Promise.reject(q)})}$onItemSelected(u){this.c?.(u)}showInput(u,E=S.CancellationToken.None){return this.d=u?.validateInput,t.$input(u,typeof this.d=="function",E).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(u){if(!this.d)return;const E=await this.d(u);if(!E||typeof E=="string")return E;let f;switch(E.severity){case p.InputBoxValidationSeverity.Info:f=N.default.Info;break;case p.InputBoxValidationSeverity.Warning:f=N.default.Warning;break;case p.InputBoxValidationSeverity.Error:f=N.default.Error;break;default:f=E.message?N.default.Error:N.default.Ignore;break}return{content:E.message,severity:f}}async showWorkspaceFolderPick(u,E=S.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!f)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(u){const E=new v(u,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(u){const E=new d(u,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(u,E){this.e.get(u)?._fireDidChangeValue(E)}$onDidAccept(u){this.e.get(u)?._fireDidAccept()}$onDidChangeActive(u,E){const f=this.e.get(u);f instanceof v&&f._fireDidChangeActive(E)}$onDidChangeSelection(u,E){const f=this.e.get(u);f instanceof v&&f._fireDidChangeSelection(E)}$onDidTriggerButton(u,E){this.e.get(u)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(u,E,f){const D=this.e.get(u);D instanceof v&&D._fireDidTriggerItemButton(E,f)}$onDidHide(u){this.e.get(u)?._fireDidHide()}}class c{static{this.a=1}constructor(u,E){this.x=u,this.y=E,this._id=v.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$ce,this.q=new F.$ce,this.r=new F.$ce,this.s=new F.$ce,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(u){this.b=u,this.z({title:u})}get step(){return this.c}set step(u){this.c=u,this.z({step:u})}get totalSteps(){return this.d}set totalSteps(u){this.d=u,this.z({totalSteps:u})}get enabled(){return this.g}set enabled(u){this.g=u,this.z({enabled:u})}get busy(){return this.j}set busy(u){this.j=u,this.z({busy:u})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(u){this.k=u,this.z({ignoreFocusOut:u})}get value(){return this.l}set value(u){this.l=u,this.z({value:u})}get placeholder(){return this.m}set placeholder(u){this.m=u,this.z({placeholder:u})}get buttons(){return this.n}set buttons(u){this.n=u.slice(),this.o.clear(),u.forEach((E,f)=>{const D=E===p.$iO.Back?-1:f;this.o.set(D,E)}),this.z({buttons:u.map((E,f)=>({...a(E.iconPath),tooltip:E.tooltip,handle:E===p.$iO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(u){this.l=u,this.q.fire(u)}_fireDidTriggerButton(u){const E=this.o.get(u);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),t.$dispose(this._id))}z(u){if(!this.v){for(const E of Object.keys(u)){const f=u[E];this.u[E]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){t.$createOrUpdate(this.u),this.u={id:this._id}}}function h(P){if(P instanceof p.$SN)return{id:P.id};const u=$(P),E=i(P);return{dark:typeof u=="string"?M.URI.file(u):u,light:typeof E=="string"?M.URI.file(E):E}}function i(P){return typeof P=="object"&&"light"in P?P.light:P}function $(P){return typeof P=="object"&&"dark"in P?P.dark:P}function a(P){const u=h(P);let E,f;return"id"in u?f=y.ThemeIcon.asClassName(u):E=u,{iconPath:E,iconClass:f}}class v extends c{constructor(u,E){super(u.identifier,E),this.O=u,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$ce,this.L=[],this.M=new F.$ce,this.N=new F.$ce,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(u){this.B=u.slice(),this.C.clear(),this.D.clear(),u.forEach((D,w)=>{this.C.set(w,D),this.D.set(D,w)});const E=(0,l.$BG)(this.O,"quickPickItemTooltip"),f=[];for(let D=0;D<u.length;D++){const w=u[D];if(w.kind===p.QuickPickItemKind.Separator)f.push({type:"separator",label:w.label});else{w.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=w.iconPath?a(w.iconPath):void 0;f.push({handle:D,label:w.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:E?b.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((I,W)=>({...a(I.iconPath),tooltip:I.tooltip,handle:W}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(u){this.E=u,this.z({canSelectMany:u})}get matchOnDescription(){return this.F}set matchOnDescription(u){this.F=u,this.z({matchOnDescription:u})}get matchOnDetail(){return this.G}set matchOnDetail(u){this.G=u,this.z({matchOnDetail:u})}get sortByLabel(){return this.H}set sortByLabel(u){this.H=u,this.z({sortByLabel:u})}get keepScrollPosition(){return this.I}set keepScrollPosition(u){this.I=u,this.z({keepScrollPosition:u})}get activeItems(){return this.J}set activeItems(u){this.J=u.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(u){this.L=u.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(u){const E=(0,k.$Hb)(u.map(f=>this.C.get(f)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(u){const E=(0,k.$Hb)(u.map(f=>this.C.get(f)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(u,E){const f=this.C.get(u);if(!f||!f.buttons||!f.buttons.length)return;const D=f.buttons[E];D&&this.N.fire({button:D,item:f})}}class d extends c{constructor(u,E){super(u.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(u){this.B=u,this.z({password:u})}get prompt(){return this.C}set prompt(u){this.C=u,this.z({prompt:u})}get valueSelection(){return this.D}set valueSelection(u){this.D=u,this.z({valueSelection:u})}get validationMessage(){return this.E}set validationMessage(u){this.E=u,u?typeof u=="string"?this.z({validationMessage:u,severity:N.default.Error}):this.z({validationMessage:u.message,severity:u.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new n(o,r)}}),define(Pe[271],Ae([1,0,2,5,68,6,11,4,18,143,13,20,42,8,26,12,21]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0;function t(C){return C instanceof S.URI}function n(C,I){return C.scheme===s.Schemas.file&&I.scheme===s.Schemas.file&&o.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?S.URI.file(C.iconPath):S.URI.isUri(C.iconPath)||l.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(S.URI.isUri(C.icon))return C.icon;if(l.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function i(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:S.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof I.iconPath=="string"?I.iconPath:S.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,k.$nr)(W,V)}function $(C,I){let W=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(W=i(C,I),W!==0)return W;if(C.light&&I.light)W=i(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(W!==0)return W;if(C.dark&&I.dark)W=i(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return W}function a(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=I.arguments[W];if(V!==q&&!(t(V)&&t(q)&&n(V,q)))return V<q?-1:1}return 0}function v(C,I){let W=(0,k.$nr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&I.command)W=a(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(W!==0)return W;if(C.decorations&&I.decorations)W=$(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)W=(0,k.$nr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)W=(0,k.$nr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return W}function d(C,I){for(let W=0;W<C.length;W++)if(C[W]!==I[W])return!1;return!0}function P(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?d(C.arguments,I.arguments):C.arguments===I.arguments)}function u(C,I){return(0,g.$ub)(C,I,P)}class E{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,m.$CG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,m.$CG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,m.$CG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,W,V,q,A){this.k=I,this.l=q,this.m=A,this.d="",this.e=new F.$ce,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(I,W){(0,m.$CG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,W)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$nmc=E;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,W,V,q,A,j,K){this.q=I,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$ce,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$ce,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,W){const V=this.h.get(I);return V?(0,M.$lh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(v),V=(0,g.$Db)(this.o,I,v).map(j=>{const K=j.toInsert.map(re=>{const ae=this.e++;this.g.set(ae,re);const be=re.resourceUri;let Ie;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const fe=new O.$Uc;Ie=this.s.converter.toInternal(re.command,fe),this.j.set(ae,fe)}else this.h.set(ae,re.command);const de=(0,m.$BG)(this.w,"scmMultiDiffEditor"),me=de?re.multiDiffEditorOriginalUri:void 0,Me=de?re.multiFileDiffEditorModifiedUri:void 0,ce=c(re.decorations),Re=re.decorations&&c(re.decorations.light)||ce,ie=re.decorations&&c(re.decorations.dark)||ce,L=[Re,ie],x=re.decorations&&re.decorations.tooltip||"",ve=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,ke=re.contextValue||"";return{rawResource:[ae,be,L,x,ve,Te,ke,Ie,me,Me],handle:ae}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=V.map(({start:j,deleteCount:K,toInsert:re})=>[j,K,re.map(ae=>ae.rawResource)]),A=V.reverse();for(const{start:j,deleteCount:K,toInsert:re}of A){const ae=re.map(Ie=>Ie.handle),be=this.n.splice(j,K,...ae);for(const Ie of be)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=I,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let W;(0,m.$BG)(this.x,"quickDiffProvider")&&(W=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:W})}get historyProvider(){return(0,m.$CG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,m.$CG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new O.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new O.$Uc,this.o=I;const W=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,m.$CG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,m.$CG)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=I;const W=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&u(this.t,I))return;this.s.value=new O.$Uc,this.t=I;const W=(I||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(I,W,V,q,A,j,K){this.x=I,this.y=q,this.z=A,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new F.$ce,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=V;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new E(I,W,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,A,j,K,re)}createResourceGroup(I,W,V){const q=(0,m.$BG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,I,W,q,this.x),j=F.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,j),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const I=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});F.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),I.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const j=V._takeResourceStateSnapshot();j.length>0&&W.push([V.handle,j]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,I,W),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&I.push([W.handle,V])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Yh)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Yh)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new y.$Qm,this.j=new F.$ce,this.e=I.getProxy(p.$UM.MainThreadSCM),this.f=I.getProxy(p.$UM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const j=this.g.get(A.sourceControlHandle);if(!j)return A;const K=j.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const j=this.g.get(A.sourceControlHandle);return j?j.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const j=this.g.get(A.handle);return j||A}return A}})}createSourceControl(I,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const A=r.d++,j=new D(I,this.m,this.e,this.l,W,V,q);this.g.set(A,j);const K=this.h.get(I.identifier)||[];return K.push(j),this.h.set(I.identifier,K),j}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const W=this.h.get(I.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(I,W,V){const q=S.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",I,q.toString());const A=this.g.get(I);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$lh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(j=>j||null)}$onInputBoxValueChange(I,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const V=this.g.get(I);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(I,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",I,W,V);const A=this.g.get(I);if(!A)return Promise.resolve(void 0);const j=A.getResourceGroup(W);return j?j.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(I,W,V){this.n.trace("ExtHostSCM#$validateInput",I);const q=this.g.get(I);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$lh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const j=b.MarkdownString.fromStrict(A.message);return j?Promise.resolve([j,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,W,V,q){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(I,W,V,q){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(I,W,V,q){const A=this.g.get(I)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const j=await A.provideHistoryItemSummary(W,V,q);return j?{...j,icon:h(j)}:void 0}async $provideHistoryItemChanges(I,W,V,q){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$omc=w,e.$omc=w=r=Je([We(3,N.$Zj)],w)}),define(Pe[272],Ae([1,0,4,8,2]),function(ge,e,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;class O{static{this.a=0}constructor(p,g){this.d=g,this.c=new Map,this.b=p.getProxy(S.$UM.MainThreadShare)}async $provideShare(p,g,k){return await this.c.get(p)?.provideShare({selection:F.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},k)??void 0}registerShareProvider(p,g){const k=O.a++;return this.c.set(k,g),this.b.$registerShareProvider(k,F.DocumentSelector.from(p,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$pmc=O}),define(Pe[273],Ae([1,0,7,4,169,6,8,17]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$TN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$TN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,m,s,o,r=S.StatusBarAlignment.Left,t){if(this.i=!1,this.k="",this.q=new O.$Uc,this.#e=l,this.#t=b,o&&s){this.c=(0,S.$vN)(s.identifier,o);const n=m.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,t=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=r,this.h=this.u(t)}u(l){if((0,p.$0f)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=g.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,s,this.r?.internal,m,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$rmc=g;class k{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new S.$WM(()=>{const m=this.b.indexOf(b);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(l,b){this.e=new Map,this.a=l.getProxy(F.$UM.MainThreadStatusBar),this.b=b,this.c=new k(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,m,s){return new g(this.a,this.b,this.e,l,b,m,s)}setStatusBarMessage(l,b){const m=this.c.setMessage(l);let s;return typeof b=="number"?s=setTimeout(()=>m.dispose(),b):typeof b<"u"&&b.then(()=>m.dispose(),()=>m.dispose()),new S.$WM(()=>{m.dispose(),clearTimeout(s)})}}e.$smc=N}),define(Pe[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=e.$uP=e.$tP=void 0;const k=(n,c,h,i)=>{let $=c;return{enumerable:!0,configurable:!1,get(){return $},set(a){if(!h($,a)){const v=$;$=a,n.listener?.(i(a,v))}}}},N=(n,c)=>n===c,y={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,c)=>!(n.length!==c.length||n.some(h=>!c.find(i=>h.id===i.id)))},l=n=>c=>({op:4,update:n(c)}),b=(n,c)=>({range:(()=>{let h;const i=l($=>({range:S.$pt.lift(p.Range.from($))}));return{enumerable:!0,configurable:!1,get(){return h},set($){n.listener?.({op:6}),y.range(h,$)||(h=$,n.listener?.(i($)))}}})(),label:k(n,c,y.label,l(h=>({label:h}))),description:k(n,void 0,y.description,l(h=>({description:h}))),sortText:k(n,void 0,y.sortText,l(h=>({sortText:h}))),canResolveChildren:k(n,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:k(n,!1,y.busy,l(h=>({busy:h}))),error:k(n,void 0,y.error,l(h=>({error:p.MarkdownString.fromStrict(h)||null}))),tags:k(n,[],y.tags,(h,i)=>({op:1,new:h.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=n=>{const c=R.$GL.fromString(n.extId),h=new o(c.controllerId,c.localId,n.label,g.URI.revive(n.uri)||void 0);return h.range=p.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(i=>p.TestTag.to({id:(0,M.$ML)(i).tagId})),h},s=n=>{let c;for(const h of n.tests){const i=m(h.item);(0,F.$dP)(i).parent=c,c=i}return c};e.$tP=s;class o{constructor(c,h,i,$){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,F.$cP)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:$,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,O.$bP)(a,F.$dP,o),enumerable:!0,writable:!1},...b(a,i)})}}e.$uP=o;class r extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$vP=r;class t extends O.$0O{constructor(c,h,i){super({controllerId:c,getDocumentVersion:$=>$&&i.getDocument($)?.version,getApiFor:F.$dP,getChildren:$=>$.children,root:new r(c,h),toITestItem:p.TestItem.from})}}e.$wP=t}),define(Pe[32],Ae([1,0,17,7,8,25,4,18,13,53,29,93,2,6,3,16,113,22,34,43,65,59,62,35]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=void 0;let a=class{#e;#t;#i;constructor(f,D,w){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$UM.MainThreadCommands),this.d=D,this.#i=w,this.#t=f.getProxy(M.$UM.MainThreadTelemetry),this.converter=new v(this,C=>{const I=this.c.get(C);return I?.result===P.Void?I:void 0},D),this.f=[{processArgument(C){return(0,k.$3h)(C)}},{processArgument(C){return(0,O.$2n)(C,function(I){if(N.$pt.isIRange(I))return R.Range.to(I);if(y.$ot.isIPosition(I))return R.Position.to(I);if(N.$pt.isIRange(I.range)&&l.URI.isUri(I.uri))return R.location.to(I);if(I instanceof r.$De)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const D=this.registerCommand(!1,f.id,async(...w)=>{const C=f.args.map((W,V)=>{if(!W.validate(w[V]))throw new Error(`Invalid argument '${W.name}' when running '${f.id}', received: ${typeof w[V]=="object"?JSON.stringify(w[V],null,"	"):w[V]} `);return W.convert(w[V])}),I=await this.executeCommand(f.internalId,...C);return f.result.convert(I,w,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new F.$WM(()=>{D.dispose(),this.c.delete(f.id)})}registerCommand(f,D,w,C,I,W){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:w,thisArg:C,metadata:I,extension:W}),f&&this.#e.$registerCommand(D),new F.$WM(()=>{this.b.delete(D)&&f&&this.#e.$unregisterCommand(D)})}executeCommand(f,...D){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,D,!0)}async g(f,D,w){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,D,!1);{let C=!1;const I=(0,O.$2n)(D,function(W){if(W instanceof F.$XM)return R.Position.from(W);if(W instanceof F.$YM)return R.Range.from(W);if(W instanceof F.$9M)return R.location.from(W);if(F.$lO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,r.$De.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,r.$De.wrap(W);if(W instanceof r.$De)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(f,C?new t.$qw(I):I,w);return(0,k.$3h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(f,D,!1);throw W}}}async h(f,D,w){const C=this.b.get(f);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:W,metadata:V}=C;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,S.$kg)(D[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=c.$$d.create();try{return await I.apply(W,D)}catch(A){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...D);j&&(f=j.command)}if(this.d.error(A,f,C.extension?.identifier),!w)throw A;if(C.extension?.identifier){const j=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$ej)(A)),this.id=f,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,f,q.elapsed())}}j(f,D,w){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$cp(D),duration:w})}$executeContributedCommand(f,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const w=this.b.get(f);return w?(D=D.map(C=>this.f.reduce((I,W)=>W.processArgument(I,w.extension?.identifier),C)),this.h(f,D,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(D=>(f&&(D=D.filter(w=>w[0]!=="_")),D))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[D,w]of this.b){const{metadata:C}=w;C&&(f[D]=C)}return Promise.resolve(f)}};e.$CP=a,e.$CP=a=Je([We(0,s.$hP),We(1,g.$Zj),We(2,i.$BP)],a),e.$DP=(0,m.$ti)("IExtHostCommands");class v{constructor(f,D,w){this.d=f,this.f=D,this.g=w,this.delegatingCommandId=`__vsc${(0,$.$Pg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,D){if(!f)return;const w={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return w;const C=this.f(f.command);if(C)w.id=C.internalId,w.arguments=C.args.map((I,W)=>I.convert(f.arguments&&f.arguments[W]));else if((0,p.$Lb)(f.arguments)){const I=`${f.command} /${++this.c}`;this.b.set(I,f),D.add((0,b.$Tc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),w.$ident=I,w.id=this.delegatingCommandId,w.arguments=[I],this.g.trace("CommandsConverter#CREATE",f.command,I)}return w}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const D=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$EP=v;class d{static{this.Uri=new d("uri","Uri of a text document",f=>l.URI.isUri(f),f=>f)}static{this.Position=new d("position","A position in a text document",f=>F.$XM.isPosition(f),R.Position.from)}static{this.Range=new d("range","A range in a text document",f=>F.$YM.isRange(f),R.Range.from)}static{this.Selection=new d("selection","A selection in a text document",f=>F.$ZM.isSelection(f),R.Selection.from)}static{this.Number=new d("number","",f=>typeof f=="number",f=>f)}static{this.String=new d("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=d.Arr(d.String)}static Arr(f){return new d(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,D=>Array.isArray(D)&&D.every(w=>f.validate(w)),D=>D.map(w=>f.convert(w)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",f=>f instanceof F.$hN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",f=>f instanceof F.$FO,R.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",f=>f instanceof o.$uP,R.TestItem.from)}constructor(f,D,w,C){this.name=f,this.description=D,this.validate=w,this.convert=C}optional(){return new d(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,D){return new d(f??this.name,D??this.description,this.validate,this.convert)}}e.$FP=d;class P{static{this.Void=new P("no result",f=>f)}constructor(f,D){this.description=f,this.convert=D}}e.$GP=P;class u{constructor(f,D,w,C,I){this.id=f,this.internalId=D,this.description=w,this.args=C,this.result=I}}e.$HP=u}),define(Pe[274],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;const y=[new g.$HP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new g.$HP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$FP.Uri],new g.$GP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,S.$Kb)(s))return;class r extends N.$cN{static to(n){const c=new r(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new N.$9M(o[0],k.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=k.Range.to(n.selectionRange),c.children=n.children?n.children.map(r.to):[],c}}return s.map(r.to)})),new g.$HP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$FP.Uri,new g.$FP("options","Formatting options",s=>!0,s=>s)],new g.$GP("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new g.$HP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$FP.Uri,g.$FP.Range,new g.$FP("options","Formatting options",s=>!0,s=>s)],new g.$GP("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new g.$HP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$FP.Uri,g.$FP.Position,new g.$FP("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$FP("options","Formatting options",s=>!0,s=>s)],new g.$GP("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new g.$HP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$HP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$HP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$HP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$HP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Location-instances.",b(k.location.to))),new g.$HP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new g.$HP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$FP.Uri,new g.$FP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>N.$XM.isPosition(o)),s=>s.map(k.Position.from))],new g.$GP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let r;for(const t of o.reverse())r=new N.$gN(k.Range.to(t),r);return r}))),new g.$HP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$FP.String.with("query","Search string")],new g.$GP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new g.$HP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new g.$HP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$FP.CallHierarchyItem],new g.$GP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new g.$HP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$FP.CallHierarchyItem],new g.$GP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new g.$HP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new g.$HP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$FP.Uri,g.$FP.Position,g.$FP.String.with("newName","The new symbol name")],new g.$GP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new g.$HP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$FP.Uri,g.$FP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$GP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new g.$HP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$FP.Uri],new g.$GP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$cO(s.tokenTypes,s.tokenModifiers)})),new g.$HP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$FP.Uri],new g.$GP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Qbb)(s);if(o.type==="full")return new N.$eO(o.data,void 0)})),new g.$HP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$FP.Uri,g.$FP.Range.optional()],new g.$GP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$cO(s.tokenTypes,s.tokenModifiers)})),new g.$HP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$FP.Uri,g.$FP.Range],new g.$GP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Qbb)(s);if(o.type==="full")return new N.$eO(o.data,void 0)})),new g.$HP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$FP.Uri,g.$FP.Position,g.$FP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$FP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$GP("A promise that resolves to a CompletionList-instance.",(s,o,r)=>{if(!s)return new N.$sN([]);const t=s.suggestions.map(n=>k.CompletionItem.to(n,r));return new N.$sN(t,s.incomplete)})),new g.$HP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$FP.Uri,g.$FP.Position,g.$FP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$GP("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new g.$HP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$FP.Uri,g.$FP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$GP("A promise that resolves to an array of CodeLens-instances.",(s,o,r)=>b(t=>new N.$kN(k.Range.to(t.range),t.command&&r.fromInternal(t.command)))(s))),new g.$HP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$FP.Uri,new g.$FP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$YM.isRange(s),s=>N.$ZM.isSelection(s)?k.Selection.from(s):k.Range.from(s)),g.$FP.String.with("kind","Code action kind to return code actions for").optional(),g.$FP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$GP("A promise that resolves to an array of Command-instances.",(s,o,r)=>b(t=>{if(t._isSynthetic){if(!t.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(t.command)}else{const n=new N.$eN(t.title,t.kind?new N.$fN(t.kind):void 0);return t.edit&&(n.edit=k.WorkspaceEdit.to(t.edit)),t.command&&(n.command=r.fromInternal(t.command)),n.isPreferred=t.isPreferred,n}})(s))),new g.$HP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$FP.Uri],new g.$GP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new N.$yN(k.Range.to(o.range),k.Color.to(o.color))):[])),new g.$HP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$FP("color","The color to show and insert",s=>s instanceof N.$xN,k.Color.from),new g.$FP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new g.$GP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new g.$HP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$FP.Uri,g.$FP.Range],new g.$GP("A promise that resolves to an array of Inlay objects",(s,o,r)=>s.map(k.InlayHint.to.bind(void 0,r)))),new g.$HP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$FP.Uri],new g.$GP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(k.FoldingRange.to)})),new g.$HP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$GP("A promise that resolves to an array of NotebookContentProvider static info objects.",b(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new g.$HP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$FP.Uri,g.$FP.Range,new g.$FP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$YM,s=>k.InlineValueContext.from(s))],new g.$GP("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new g.$HP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$FP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,F.$Dg)(s,F.Schemas.http,F.Schemas.https),s=>s),new g.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),g.$FP.String.with("label","").optional()],g.$GP.Void),new g.$HP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$FP.Uri.with("resource","Resource to open"),g.$FP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],g.$GP.Void),new g.$HP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$FP.Uri.with("left","Left-hand side resource of the diff editor"),g.$FP.Uri.with("right","Right-hand side resource of the diff editor"),g.$FP.String.with("title","Human readable title for the diff editor").optional(),new g.$FP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],g.$GP.Void),new g.$HP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$FP.String.with("title","Human readable title for the changes editor"),new g.$FP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[r,t,n]=o;if(!R.URI.isUri(r)||!R.URI.isUri(t)&&t!==void 0&&t!==null||!R.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],g.$GP.Void),new g.$HP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$FP.Uri,g.$FP.Position],new g.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$HP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$FP.TypeHierarchyItem],new g.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$HP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$FP.TypeHierarchyItem],new g.$GP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$HP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$FP.TestItem],g.$GP.Void),new g.$HP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$FP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$GP.Void),new g.$HP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$FP.String.with("name","The context key name"),new g.$FP("value","The context key value",()=>!0,s=>s)],g.$GP.Void),new g.$HP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$FP.Uri,g.$FP.StringArray,new g.$FP("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new g.$GP("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class l{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$sj)}}e.$Nkc=l;function b(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const r of s)O.$7t(r)?o.push(k.DefinitionLink.to(r)):o.push(k.location.to(r));return o}}),define(Pe[275],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class k{static{this.a=0}constructor(b,m){this.extension=b,this.provider=m,this.handle=k.a++}}class N{constructor(b){this.session=b,this.responses=[]}}class y{static{this.a=0}constructor(b,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(O.$UM.MainThreadInlineChat),m.registerApiCommand(new M.$HP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$FP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?p.Range.from(r.initialRange):void 0,initialSelection:g.$ZM.isSelection(r.initialSelection)?p.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?p.Position.from(r.position):void 0}})],M.$GP.Void))}registerProvider(b,m,s){const o=new k(b,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??b.displayName??b.name,b.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,F.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,m,s,o){const r=this.b.get(b);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.f.getDocument(R.URI.revive(m)),n=p.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:t,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new N(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(b,m,s,o){const r=this.b.get(b);if(!r)return;const t=this.d.get(m.id);if(!t)return;const n={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(R.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async E=>{if(!s.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:g.$lN.isMarkdownString(E.content)?E.content.value:E.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(t.session,n,h,o));let $;try{$=await(0,S.$hh)(i,o)}finally{c=!0}if(!$)return;const a=t.responses.push($)-1,v={wholeRange:p.Range.from($.wholeRange),placeholder:$.placeholder};if(!y.h($))return{...v,id:a,type:"editorEdit",message:p.MarkdownString.from($.contents),edits:[]};const{edits:d,contents:P}=$,u=P!==void 0?p.MarkdownString.from(P):void 0;return d instanceof g.$7M?{...v,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(d),message:u}:{...v,id:a,type:"editorEdit",edits:d.map(p.TextEdit.from),message:u}}async $provideFollowups(b,m,s,o){const r=this.b.get(b),t=this.d.get(m),n=t?.responses[s];if(r&&n&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(t.session,n,o));return(await(0,S.$hh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(b,m,s,o){const r=this.b.get(b),t=this.d.get(m),n=t?.responses[s];if(r&&n){const c=p.InteractiveEditorResponseFeedbackKind.to(o);r.provider.handleInteractiveEditorResponseFeedback?.(t.session,n,c)}}$releaseSession(b,m){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$Wlc=y}),define(Pe[276],Ae([1,0,2,32]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class R{constructor(M,p,g,k,N){this.a=p,this.b=g,this.c=k;const y=new F.$HP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$FP("showOptions","Show Options",l=>!0,l=>l),new F.$FP("resource","Interactive resource Uri",l=>!0,l=>l),new F.$FP("controllerId","Notebook controller Id",l=>!0,l=>l),new F.$FP("title","Interactive editor title",l=>!0,l=>l)],new F.$GP("Notebook and input URI",l=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,g,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$0lc=R}),define(Pe[277],Ae([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,218,26,34,219]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0,e.$fmc=d;let c=class{constructor(u,E,f,D,w){this.m=E,this.n=f,this.o=D,this.q=w,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ce,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=u.getProxy(y.$UM.MainThreadNotebookKernels);const C=new l.$HP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$FP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],l.$GP.Void),I=new l.$HP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$FP.Uri],new l.$GP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(u,E,f,D,w,C){for(const ce of this.j.values())if(ce.controller.id===E&&k.$Om.equals(u.identifier,ce.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const I=this.k++,W=this;this.q.trace(`NotebookController[${I}], CREATED by ${u.identifier.value}, ${E}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${u.identifier}'`);let q=!1;const A=new O.$ce,j=new O.$ce,K={id:d(u.identifier,E),notebookType:f,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:D||u.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let re=w??V,ae,be;this.a.$addKernel(I,K).catch(ce=>{console.log(ce),q=!0});let Ie=0;const de=()=>{if(q)return;const ce=++Ie;Promise.resolve().then(()=>{ce===Ie&&this.a.$updateKernel(I,K)})},me=new p.$Bc,Me={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(ce){K.label=ce??u.displayName??u.name,de()},get detail(){return K.detail??""},set detail(ce){K.detail=ce,de()},get description(){return K.description??""},set description(ce){K.description=ce,de()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ce){K.supportedLanguages=ce,de()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){K.supportsExecutionOrder=ce,de()},get rendererScripts(){return K.preloads?K.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ce){re=ce??V},get interruptHandler(){return ae},set interruptHandler(ce){ae=ce,K.supportsInterrupt=!!ce,de()},set variableProvider(ce){(0,r.$CG)(u,"notebookVariableProvider"),be=ce,K.hasVariableProvider=!!ce,ce?.onDidChangeVariables(Re=>W.a.$variablesUpdated(Re.uri)),de()},get variableProvider(){return be},createNotebookCellExecution(ce){if(q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.notebook.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return W._createNotebookCellExecution(ce,d(u.identifier,this.id))},createNotebookExecution(ce){if((0,r.$CG)(u,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return W._createNotebookExecution(ce,d(u.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${I}], DISPOSED`),q=!0,this.j.delete(I),A.dispose(),j.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ce,Re){Re===m.NotebookControllerAffinity2.Hidden&&(0,r.$CG)(u,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(I,ce.uri,Re)},onDidReceiveMessage:j.event,postMessage(ce,Re){return(0,r.$CG)(u,"notebookMessaging"),W.a.$postMessage(I,Re&&W.n.getIdByEditor(Re),ce)},asWebviewUri(ce){return(0,r.$CG)(u,"notebookMessaging"),(0,s.$jyb)(ce,W.m.remote)}};return this.j.set(I,{extensionId:u.identifier,controller:Me,onDidReceiveMessage:j,onDidChangeSelection:A,associatedNotebooks:me}),Me}getIdByController(u){for(const[E,f]of this.j)if(f.controller===u)return d(f.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,E){const f=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(f,E);const w={dispose:()=>{this.f.delete(f),D.a.$removeKernelDetectionTask(f)}};return this.f.set(f,w),w}registerKernelSourceActionProvider(u,E,f){const D=this.i++,w=typeof f.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,f),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,E);let I;return w!==void 0&&(I=f.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),I?.dispose()}}}async $provideKernelSourceActions(u,E){const f=this.h.get(u);if(f){const D=new M.$Uc;return(await f.provideNotebookKernelSourceActions(E)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(u,E,f){const D=this.j.get(u);if(D){const w=this.n.getNotebookDocument(g.URI.revive(E));f?D.associatedNotebooks.set(w.uri,!0):D.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${u}] ASSOCIATE notebook`,w.uri.toString(),f),D.onDidChangeSelection.fire({selected:f,notebook:w.apiNotebook})}}async $executeCells(u,E,f){const D=this.j.get(u);if(!D)return;const w=this.n.getNotebookDocument(g.URI.revive(E)),C=[];for(const I of f){const W=w.getCell(I);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${u}] EXECUTE cells`,w.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,w.apiNotebook,D.controller)}catch(I){this.q.error(`NotebookController[${u}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(u,E,f){const D=this.j.get(u);if(!D)return;const w=this.n.getNotebookDocument(g.URI.revive(E));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,w.apiNotebook);else for(const C of f){const I=w.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(w.uri);f.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(u,E,f,D,w,C,I){const W=this.j.get(u);if(!W)return;const V=this.n.getNotebookDocument(g.URI.revive(f)),q=W.controller.variableProvider;if(!q)return;let A;if(D!==void 0){if(A=this.s[D],!A)return}else this.s={};const j=w==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,j,C,I);let re=0;for await(const ae of K){if(I.isCancellationRequested)return;const be={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[be.id]=ae.variable,this.a.$receiveVariable(E,be),re++>=n.$Sib)return}}$acceptKernelMessageFromRenderer(u,E,f){const D=this.j.get(u);if(!D)return;const w=this.n.getEditorById(E);D.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:f}))}$cellExecutionChanged(u,E,f){const w=this.n.getNotebookDocument(g.URI.revive(u)).getCell(E);if(w){const C=f?b.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:w.apiCell,state:C})}}_createNotebookCellExecution(u,E){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const w=new i(E,D,this.a);this.b.set(D.uri,w);const C=w.onDidChangeState(()=>{w.state===h.Resolved&&(w.dispose(),C.dispose(),this.b.delete(D.uri))});return w.asApiObject()}_createNotebookExecution(u,E){const f=this.n.getNotebookDocument(u.uri),D=u.getCells().find(I=>{const W=f.getCellFromApiCell(I);return W&&this.b.has(W.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const w=new a(E,f,this.a),C=w.onDidChangeState(()=>{w.state===$.Resolved&&(w.dispose(),C.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[w,C]),w.asApiObject()}};e.$emc=c,e.$emc=c=Je([We(4,N.$Zj)],c);var h;(function(P){P[P.Init=0]="Init",P[P.Started=1]="Started",P[P.Resolved=2]="Resolved"})(h||(h={}));class i extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(u,E,f){super(),this.m=E,this.n=f,this.b=i.a++,this.c=new O.$ce,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$ne),this.h=new v(10,D=>this.s(D)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const E=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new t.$qw(E))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let E=this.m;if(u&&(E=this.m.notebook.getCellFromApiCell(u)),!E)throw new Error("INVALID cell");return E.handle}y(u){return u.map(E=>{const f=m.$pO.ensureUniqueMimeTypes(E.items,!0);return f===E.items?b.NotebookCellOutput.from(E):b.NotebookCellOutput.from({items:f,id:E.id,metadata:E.metadata})})}async z(u,E,f){const D=this.w(E),w=this.y((0,S.$3b)(u));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:D,append:f,outputs:w})}async C(u,E,f){return u=m.$pO.ensureUniqueMimeTypes((0,S.$3b)(u),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:u.map(b.NotebookCellOutputItem.from),outputId:E.id,append:f})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(f){u.j=f,u.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(f){if(u.f===h.Resolved||u.f===h.Started)throw new Error("Cannot call start again");u.f=h.Started,u.c.fire(),u.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,D,w){if(u.f===h.Resolved)throw new Error("Cannot call resolve twice");u.f=h.Resolved,u.c.fire(),u.h.flush();const C=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;u.n.$completeExecution(u.b,new t.$qw({runEndTime:D,lastRunSuccess:f,error:C}))},clearOutput(f){return u.t(),u.z([],f,!1)},appendOutput(f,D){return u.t(),u.z(f,D,!0)},replaceOutput(f,D){return u.t(),u.z(f,D,!1)},appendOutputItems(f,D){return u.t(),u.C(f,D,!0)},replaceOutputItems(f,D){return u.t(),u.C(f,D,!1)}})}}var $;(function(P){P[P.Init=0]="Init",P[P.Started=1]="Started",P[P.Resolved=2]="Resolved"})($||($={}));class a extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(u,E,f){super(),this.h=E,this.j=f,this.b=a.a++,this.c=new O.$ce,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new R.$ne),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===$.Resolved||this.f===$.Started)throw new Error("Cannot call start again");this.f=$.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===$.Resolved)throw new Error("Cannot call resolve twice");this.f=$.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class v{constructor(u,E){this.f=u,this.g=E,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new F.$Qh,this.b=Date.now(),(0,F.$uh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>u.complete())}}function d(P,u){return`${P.value}/${u}`}}),define(Pe[51],Ae([1,0,5,4,3,2,16,6,7,171,14,200,24,35,201,42,11,8,32]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=e.$qlc=e.$plc=void 0,e.$plc=(0,R.$ti)("IExtHostTerminalService");class n extends p.$Vc{constructor(f,D,w,C){super(),this.u=f,this._id=D,this.w=w,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new S.$ce),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(W,V=!0){I.C(),I.u.$sendText(I._id,W,V)},show(W){I.C(),I.u.$show(I._id,W)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??D?.cwd??void 0,env:f.env??void 0,icon:d(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(f.location,D?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,D,w,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:s.ThemeColor.isThemeColor(I)?I.id:void 0,location:D?.location||this.z(f,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,D){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in f?{viewColumn:r.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,D){this.j=Object.freeze({code:f,reason:D})}setDimensions(f,D){return f===this.f&&D===this.h||f===0||D===0?!1:(this.f=f,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(D=>{D!==f&&(this.b=Promise.resolve(f))})}}e.$qlc=n;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new S.$ce,this.onProcessData=this.a.event,this.b=new S.$ce,this.d=new S.$ce,this.onDidChangeProperty=this.d.event,this.f=new S.$ce,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,D){this.g.setDimensions?.({columns:f,rows:D})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends p.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,D,w){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$ce,this.onDidCloseTerminal=this.H.event,this.I=new S.$ce,this.onDidOpenTerminal=this.I.event,this.J=new S.$ce,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$ce,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$ce,this.onDidChangeTerminalState=this.M.event,this.N=new S.$ce,this.onDidChangeShell=this.N.event,this.O=new S.$ce({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$ce({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(F.$UM.MainThreadTerminalService),this.y=new m.$btb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:C=>{const I=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=I(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,D){const w=new n(this.a,(0,b.$Pg)(),f,f.name),C=new c(f.pty);return w.createExtensionTerminal(f.location,D,this.R(f,D).resolvedExtHostIdentifier,d(f.iconPath),P(f.color)).then(I=>{const W=this.S(I,C);this.h[I]=W}),this.f.push(w),w.value}R(f,D){if(D=D||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const w=f.location.parentTerminal;if(w){const C=this.f.find(I=>I.value===w);C&&(D.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?D.location=f.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(f,D){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new c(D),I=this.S(f,C);this.h[f]=I}async $acceptActiveTerminalChanged(f){const D=this.b;if(f===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const w=this.getTerminalById(f);w&&(this.b=w,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,D){const w=this.getTerminalById(f);w&&this.O.fire({terminal:w.value,data:D})}async $acceptTerminalDimensions(f,D,w){const C=this.getTerminalById(f);C&&C.setDimensions(D,w)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(f,D){const w=this.getTerminalById(f);w&&this.P.fire({terminal:w.value,...D})}async $acceptTerminalMaximumDimensions(f,D,w){this.g.get(f)?.resize(D,w)}async $acceptTerminalTitleChange(f,D){const w=this.getTerminalById(f);w&&(w.name=D)}async $acceptTerminalClosed(f,D,w){const C=this.X(this.f,f);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(D,w),this.H.fire(I.value)}}$acceptTerminalOpened(f,D,w,C){if(D){const V=this.X(this.f,D);if(V!==null){this.f[V]._id=f,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new n(this.a,f,I,w);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,D){this.getTerminalById(f)?._setProcessId(D)}async $startExtensionTerminal(f,D){const w=this.getTerminalById(f);if(!w)return{message:(0,k.localize)(0,null,f)};w.isOpen||await new Promise(I=>{const W=this.onDidOpenTerminal(async V=>{V===w.value&&(W.dispose(),I())})});const C=this.g.get(f);C?C.startSendingEvents(D):this.j[f]={initialDimensions:D}}S(f,D){const w=new p.$Uc;w.add(D.onProcessReady(I=>this.a.$sendProcessReady(f,I.pid,I.cwd,I.windowsPty))),w.add(D.onDidChangeProperty(I=>this.a.$sendProcessProperty(f,I))),this.y.startBuffering(f,D.onProcessData),w.add(D.onProcessExit(I=>this.U(f,I))),this.g.set(f,D);const C=this.j[f];return C&&D instanceof c&&(D.startSendingEvents(C.initialDimensions),delete this.j[f]),w}$acceptProcessAckDataEvent(f,D){this.g.get(f)?.acknowledgeDataEvent(D)}$acceptProcessInput(f,D){this.g.get(f)?.input(D)}$acceptTerminalInteraction(f){const D=this.getTerminalById(f);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(f,D){this.getTerminalById(f)?.setSelection(D)}$acceptProcessResize(f,D,w){try{this.g.get(f)?.resize(D,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,D){this.g.get(f)?.shutdown(D)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(D=>this.a.$sendProcessProperty(f,{type:"cwd",value:D}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$WM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,D,w){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,w),this.a.$registerProfileProvider(D,f.identifier.value),new g.$WM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(f,D,w){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,w),this.a.$registerQuickFixProvider(f,D),new g.$WM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,D){const w=new l.$ne().token;if(w.isCancellationRequested)return;const C=this.D.get(f);if(!C)return;const I=await C.provideTerminalQuickFixes(D,w);if(I===null||Array.isArray(I)&&I.length===0)return;const W=new p.$Uc;if(this.w.value=W,!Array.isArray(I))return I?r.TerminalQuickFix.from(I,this.Q.converter,W):void 0;const V=[];for(const q of I){const A=r.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal(f,D){const w=new l.$ne().token;let C=await this.C.get(f)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(f,D){const w=this.getTerminalById(f);if(!w)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const I=new l.$ne;this.G.set(f,I);const W=[],V={terminal:w.value,line:D},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async re=>{I.token.onCancellationRequested(()=>re({provider:K,links:[]}));const ae=await K.provideTerminalLinks(V,I.token)||[];I.token.isCancellationRequested||re({provider:K,links:ae})}));const A=await Promise.all(q);if(I.token.isCancellationRequested)return[];const j=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(re=>{const ae={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return j.set(ae.id,{provider:K.provider,link:re}),ae}));return this.F.set(f,j),W}$activateLink(f,D){const w=this.F.get(f)?.get(D);w&&w.provider.handleTerminalLink(w.link)}U(f,D){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const w=this.h[f];w&&(w.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,D)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const D=this.f.findIndex(w=>w.value===f);return D>=0?D:null}W(f,D){const w=this.X(f,D);return w!==null?f[w]:null}X(f,D){const w=f.findIndex(C=>C._id===D);return w>=0?w:null}getEnvironmentVariableCollection(f){let D=this.n.get(f.identifier.value);return D||(D=new $,this.Z(f.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(f,D){const w=(0,y.$hs)(D.map),C=(0,y.$is)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(f,D.persistent,w.length===0?void 0:w,C)}$initEnvironmentVariableCollections(f){f.forEach(D=>{const w=D[0],C=new $(D[1]);this.Z(w,C)})}$acceptDefaultProfile(f,D){const w=this.s;this.s=f,this.u=D,w?.path!==f.path&&this.N.fire(f.path)}Z(f,D){this.n.set(f,D),D.onDidChangeCollection(()=>{this.Y(f,D)})}};e.$rlc=i,e.$rlc=i=Je([We(1,t.$DP),We(2,M.$hP)],i);class ${get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$ce,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const D=this.h(f);let w=this.a.get(D);return w||(w=new a(this,f),this.a.set(D,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:C})}append(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:C})}prepend(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:C})}f(f,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(f,D.scope),C=this.map.get(w),I=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const W=this.g(f,D.scope),V={variable:f,...D,options:I};this.map.set(W,V),this.d.fire()}}get(f,D){const w=this.g(f,D),C=this.map.get(w);return C?u(C):void 0}g(f,D){const w=this.h(D);return w.length?`${f}:::${w}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const D=new Map;for(const[w,C]of this.map)this.h(C.scope)===this.h(f)&&D.set(C.variable,u(C));return D}delete(f,D){const w=this.g(f,D);this.map.delete(w),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[D,w]of this.map)w.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(D);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,D){const w=this.h(D),C=this.descriptionMap.get(w);if(!C||C.description!==f){let I;typeof f=="string"?I=f:I=f?.value.split(`

`)[0];const W={description:I,scope:D};this.descriptionMap.set(w,W),this.d.fire()}}getDescription(f){const D=this.h(f);return this.descriptionMap.get(D)?.description}k(f){const D=this.h(f);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,D){this.b=f,this.d=D,this.a=new S.$ce}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,D,w){this.b.replace(f,D,w,this.d)}append(f,D,w){this.b.append(f,D,w,this.d)}prepend(f,D,w){this.b.prepend(f,D,w,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,D){this.b.getVariableMap(this.d).forEach((w,C)=>f.call(D,C,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let v=class extends i{constructor(f,D){super(!1,f,D)}createTerminal(f,D,w){throw new N.$_}createTerminalFromOptions(f,D){throw new N.$_}};e.$slc=v,e.$slc=v=Je([We(0,t.$DP),We(1,M.$hP)],v);function d(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function P(E){return s.ThemeColor.isThemeColor(E)?E:void 0}function u(E){const f={...E};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Pe[114],Ae([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=void 0,e.$wmc=(0,R.$ti)("IExtHostTerminalShellIntegration");let y=class extends F.$Vc{constructor(o,r){super(),this.h=r,this.b=new Map,this.c=new g.$ce,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$ce,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$ce,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$UM.MainThreadTerminalShellIntegration),this.B((0,F.$Tc)(()=>{for(const[t,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const r=this.h.getTerminalById(o);if(!r)return;const t=r.value;let n=this.b.get(o);n||(n=new l(r.value,this.f),this.b.set(o,n),n.store.add(r.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),r.shellIntegration=n.value),this.c.fire({terminal:t,shellIntegration:n.value})}$shellExecutionStart(o,r,t,n,c){this.b.has(o)||this.$shellIntegrationChange(o);const h={value:r,confidence:t,isTrusted:n};this.b.get(o)?.startShellExecution(h,c)}$shellExecutionEnd(o,r,t,n,c){const h={value:r,confidence:t,isTrusted:n};this.b.get(o)?.endShellExecution(h,c)}$shellExecutionData(o,r){this.b.get(o)?.emitData(r)}$cwdChange(o,r){this.b.get(o)?.setCwd((0,k.$wc)(r)?k.URI.revive(r):r)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$xmc=y,e.$xmc=y=Je([We(0,M.$hP),We(1,p.$plc)],y);class l extends F.$Vc{get currentExecution(){return this.a}constructor(o,r){super(),this.j=o,this.m=r,this.b=!1,this.store=this.B(new F.$Uc),this.f=this.B(new g.$ce),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$ce),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$ce),this.onDidRequestEndExecution=this.h.event;const t=this;this.value={get cwd(){return t.c},executeCommand(n,c){let h=n;c&&(h+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),t.g.fire(h);const i={value:h,confidence:S.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},$=t.startShellExecution(i,t.c,!0).value;return t.b=!0,$}}}startShellExecution(o,r,t){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new b(o,r);t?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,r){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:r}),this.a=void 0)}setCwd(o){let r=!1;k.URI.isUri(this.c)?r=!k.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(r=!0),r&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(o,r){this.c=o,this.cwd=r,this.b=!1;const t=this;this.value={get commandLine(){return t.c},get cwd(){return t.cwd},read(){return t.d()}}}d(){if(!this.a){if(this.b)return N.$Th.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends F.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new N.$sh);const o=this.a;return new N.$Th(async t=>{this.b.push(t),await o.wait()})}emitData(o){for(const r of this.b)r.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Pe[278],Ae([1,0,11,22,24,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=e.$zmc=e.$ymc=void 0;let c=class extends g.$Vc{constructor(I,W,V,q){super(),this.w=q,this.f=this.B(new O.$ce),this.g=new Map,this.s=this.B(new O.$ce),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(l.$UM.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const j=A,K=j.tests[j.tests.length-1].item.extId;return this.g.get(r.$GL.root(K))?.collection.tree.get(K)?.actual??(0,m.$tP)(A)}case 18:{const{test:j,message:K}=A,re=j.item.extId;return{test:this.g.get(r.$GL.root(re))?.collection.tree.get(re)?.actual??(0,m.$tP)({$mid:16,tests:[j]}),message:s.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),j=K=>{const re=this.g.get(r.$GL.root(K));if(re)return r.$GL.isRoot(K)?re.controller:re.collection.tree.get(K)?.actual};return{include:A?.include.map(j).filter(k.$bg)||[],exclude:A?.exclude.map(j).filter(k.$bg)||[]}})}createTestController(I,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new g.$Uc,j=A.add(new m.$wP(W,V,this.w));j.root.label=V;const K=new Map,re=new Set,ae=this.h,be={items:j.root.children,get label(){return V},set label(de){V=de,j.root.label=de,ae.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(de){q=de,ae.$updateController(W,{canRefresh:!!de})},get id(){return W},createRunProfile:(de,me,Me,ce,Re,ie)=>{let L=(0,p.$hj)(de);for(;K.has(L);)L++;return new D(this.h,K,re,this.s.event,W,L,de,me,Me,ce,Re,ie)},createTestItem(de,me,Me){return new m.$uP(W,de,me,Me)},createTestRun:(de,me,Me=!0)=>this.j.createTestRun(W,j,de,me,Me),invalidateTestResults:de=>{if(de===void 0)this.h.$markTestRetired(void 0);else{const me=de instanceof Array?de:[de];this.h.$markTestRetired(me.map(Me=>r.$GL.fromExtHostTestItem(Me,W).toString()))}},set resolveHandler(de){j.resolveHandler=de},get resolveHandler(){return j.resolveHandler},dispose:()=>{A.dispose()}};ae.$registerTestController(W,V,!!q),A.add((0,g.$Tc)(()=>ae.$unregisterTestController(W)));const Ie={controller:be,collection:j,profiles:K,extension:I,activeProfiles:re};return this.g.set(W,Ie),A.add((0,g.$Tc)(()=>this.g.delete(W))),A.add(j.onDidGenerateDiff(de=>ae.$publishDiff(W,de.map(n.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(I,W=R.CancellationToken.None){const V=v(I);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(A=>r.$GL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:w[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:I.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,W){return(await this.j.getCoverageDetails(I,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,W){this.g.get(I)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(I){const W=new Map;for(const[V,q]of Object.entries(I)){const A=this.g.get(V);if(!A)continue;const j=new Map,K=q.filter(ae=>!A.activeProfiles.has(ae)),re=[...A.activeProfiles].filter(ae=>!q.includes(ae));for(const ae of K)j.set(ae,!0),A.activeProfiles.add(ae);for(const ae of re)j.set(ae,!1),A.activeProfiles.delete(ae);j.size&&W.set(V,j)}this.s.fire(W)}async $refreshTests(I,W){await this.g.get(I)?.controller.refreshHandler?.(W)}$publishTestResults(I){this.results=Object.freeze(I.map(s.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,W){const V=this.g.get(r.$GL.fromString(I).controllerId)?.collection;V&&(await V.expand(I,W<0?1/0:W),V.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(I,W){return Promise.all(I.map(V=>this.y(V,!1,W)))}async $startContinuousRun(I,W){const V=new R.$ne(W),q=await Promise.all(I.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(I,W,V){const q=this.g.get(I.controllerId);if(!q)return{};const{collection:A,profiles:j}=q,K=j.get(I.profileId);if(!K)return{};const re=I.testIds.map(de=>A.tree.get(de)).filter(k.$bg),ae=I.excludeExtIds.map(de=>q.collection.tree.get(de)).filter(k.$bg).filter(de=>re.some(me=>me.fullId.compare(de.fullId)===2));if(!re.length)return{};const be=new o.$wO(re.some(de=>de.actual instanceof m.$vP)?void 0:re.map(de=>de.actual),ae.map(de=>de.actual),K,W),Ie=(0,n.$JL)(I)&&this.j.prepareForMainThreadTestRun(be,d.fromInternal(I,q.collection),K,V);try{return await K.runHandler(be,V),{}}catch(de){return{error:String(de)}}finally{Ie&&Ie.hasRunningTasks&&!V.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$ymc=c,e.$ymc=c=Je([We(0,b.$hP),We(1,y.$Zj)],c);const h=1e4;var i;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(i||(i={}));class $ extends g.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,W,V,q,A){super(),this.y=I,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ce),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$ne(A));const j=this.B(new S.$Fh(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new O.$ce;this.s=K.event,this.B((0,g.$Tc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,W){const[,V,q]=r.$GL.fromString(I).path,A=this.w.get(q);if(!A)return[];const j=this.g.get(V);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,A,W)??[]}createRun(I){const W=this.y.id,V=this.y.controllerId,q=(0,N.$Pg)(),A=ae=>(be,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.y.isIncluded(be)&&(this.H(be),ae(be,...Ie))},j=(ae,be)=>{const Ie=be instanceof Array?be.map(s.TestMessage.from):[s.TestMessage.from(be)];if(ae.uri&&ae.range){const de={range:s.Range.from(ae.range),uri:ae.uri};for(const me of Ie)me.location=me.location||de}this.z.$appendTestMessagesInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),Ie)};let K=!1;const re={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ae=>{const be=ae.uri.toString(),Ie=new r.$GL([W,q,be]).toString();this.w.set(be,ae),this.z.$appendCoverage(W,q,s.TestCoverage.fromFile(Ie,ae))},enqueued:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),1)}),skipped:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),5)}),started:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),2)}),errored:A((ae,be,Ie)=>{j(ae,be),this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),6,Ie)}),failed:A((ae,be,Ie)=>{j(ae,be),this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,V).toString(),4,Ie)}),passed:A((ae,be)=>{this.z.$updateTestStateInRun(W,q,r.$GL.fromExtHostTestItem(ae,this.y.controllerId).toString(),3,be)}),appendOutput:(ae,be,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(W,q,F.$De.fromString(ae),be&&s.location.from(be),Ie&&r.$GL.fromExtHostTestItem(Ie,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:re}),this.z.$startedTestRunTask(W,{id:q,name:I,running:!0}),re}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof m.$uP))throw new t.$_O(I.id);if(this.h.has(r.$GL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=s.TestItem.from(I);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),I===V))break;I=I.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(I,W){this.g=I,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(I,W){const V=r.$GL.root(I);return this.f.get(V)?.getCoverageDetails(I,W)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[W,{id:V}]of this.c)V===I&&this.c.delete(W)}prepareForMainThreadTestRun(I,W,V,q){return this.j(I,W,V,q)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,W,V,q,A){const j=this.c.get(V);if(j)return j.createRun(q);const K=d.fromPublic(I,W,V,A),re=v(V);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!V.continuous,profile:re&&{group:w[re.kind],id:re.profileId},exclude:V.exclude?.map(be=>r.$GL.fromExtHostTestItem(be,W.root.id).toString())??[],id:K.id,include:V.include?.map(be=>r.$GL.fromExtHostTestItem(be,W.root.id).toString())??[W.root.id],persist:A});const ae=this.j(V,K,V.profile);return O.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ae.createRun(q)}j(I,W,V,q){const A=new $(W,this.g,this.h,V,q);return this.c.set(I,A),this.f.set(A.id,A),A}}e.$zmc=a;const v=C=>{if(C.profile){if(!(C.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class d{static fromPublic(I,W,V,q){return new d(I,(0,N.$Pg)(),V.include?.map(A=>r.$GL.fromExtHostTestItem(A,I).toString())??[I],V.exclude?.map(A=>r.$GL.fromExtHostTestItem(A,I).toString())??[],q,W)}static fromInternal(I,W){return new d(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,W)}constructor(I,W,V,q,A,j){this.controllerId=I,this.id=W,this.isPersisted=A,this.colllection=j,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(I){const W=r.$GL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$Amc=d;class P{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,s.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const W=r.$GL.parentId(I.item.extId);if(W&&this.h.has(W.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:W,g:V}=this;return{get added(){return[...I].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class u extends n.$PL{constructor(){super(...arguments),this.s=new O.$ce,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,W){return{...I,revived:s.TestItem.toPlain(I.item),depth:W?W.depth+1:0,children:new Set}}v(){return new P(this.s)}}class E{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new u({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const f=(C,I,W,V)=>{W?Object.assign(W,V):I.$updateTestRunConfig(C.controllerId,C.profileId,V)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,f(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,f(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,f(this,this.#e,this.#n,{tag:I?s.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,f(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return O.Event.chain(this.#i,I=>I.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(k.$bg))}constructor(I,W,V,q,A,j,K,re,ae,be=!1,Ie=void 0,de=!1){this.controllerId=A,this.profileId=j,this.f=K,this.kind=re,this.runHandler=ae,this._tag=Ie,this.g=de,this.#e=I,this.#s=W,this.#t=V,this.#i=q,W.set(j,this);const me=w[re];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);be&&V.add(j),this.#n={profileId:j,controllerId:A,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:me,isDefault:be,hasConfigurationHandler:!1,supportsContinuousRun:de},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bmc=D;const w={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[115],Ae([1,0,56,14,90,8,7]),function(ge,e,S,F,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=e.$oP=void 0;class p{static{this.c=new R.$mP("TextEditorDecorationType")}constructor(l,b,m){const s=p.c.nextId();l.$registerTextEditorDecorationType(b.identifier,s,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$oP=p;class g{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let m=null;if(l instanceof M.$XM)m=new M.$YM(l,l);else if(l instanceof M.$YM)m=l;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(l,b){this.k(),this.l(new M.$YM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof M.$YM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,m){const s=this.c.validateRange(l);this.g.push({range:s,text:b,forceMoveMarkers:m})}setEndOfLine(l){if(this.k(),l!==M.EndOfLine.LF&&l!==M.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=l}}class k{constructor(l,b,m,s){this.c=l,this.d=b,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(r){o.n(r)},get indentSize(){return o.g},set indentSize(r){o.p(r)},get insertSpaces(){return o.j},set insertSpaces(r){o.s(r)},get cursorStyle(){return o.k},set cursorStyle(r){o.t(r)},get lineNumbers(){return o.l},set lineNumbers(r){o.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let m=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(m=!0,b.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,b.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(m=!0,b.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,b.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(m=!0,b.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,b.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,m=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,m=!0,b.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(m)})}}e.$pP=k;class N{constructor(l,b,m,s,o,r,t,n){this.id=l,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,r,m),this.e=t,this.f=n;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new F.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof M.$ZM))throw(0,F.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof M.$ZM)))throw(0,F.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const $=new g(s.value,i);return h($),c.m($)},insertSnippet(h,i,$={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map(v=>O.Range.from(v));else if(i instanceof M.$XM){const{lineNumber:v,column:d}=O.Position.from(i);a=[{startLineNumber:v,startColumn:d,endLineNumber:v,endColumn:d}]}else if(i instanceof M.$YM)a=[O.Range.from(i)];else{a=[];for(const v of i)if(v instanceof M.$YM)a.push(O.Range.from(v));else{const{lineNumber:d,column:P}=O.Position.from(v);a.push({startLineNumber:d,startColumn:P,endLineNumber:d,endColumn:P})}}return b.$tryInsertSnippet(l,s.value.version,h.value,a,$)},setDecorations(h,i){const $=i.length===0;$&&!c.h.has(h.key)||($?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$eP(i))return b.$trySetDecorations(l,h.key,O.$fP(i));{const a=new Array(4*i.length);for(let v=0,d=i.length;v<d;v++){const P=i[v];a[4*v]=P.start.line+1,a[4*v+1]=P.start.character+1,a[4*v+2]=P.end.line+1,a[4*v+3]=P.end.character+1}return b.$trySetDecorationsFast(l,h.key,a)}}))},revealRange(h,i){c.n(()=>b.$tryRevealRange(l,O.Range.from(h),i||M.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(l,O.ViewColumn.from(h))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(o=>o.range);m.sort((o,r)=>o.end.line===r.end.line?o.end.character===r.end.character?o.start.line===r.start.line?o.start.character-r.start.character:o.start.line-r.start.line:o.end.character-r.end.character:o.end.line-r.end.line);for(let o=0,r=m.length-1;o<r;o++){const t=m[o].end;if(m[o+1].start.isBefore(t))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=b.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,s,{setEndOfLine:typeof b.setEndOfLine=="number"?O.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$qP=N}),define(Pe[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let t=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new F.$ce,this.e=new F.$ce,this.f=new F.$ce,this.g=new F.$ce,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],$=[];if(c.removedDocuments)for(const a of c.removedDocuments){const v=O.URI.revive(a),d=this.c.get(v);d?.unref()&&(this.c.delete(v),h.push(d.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const v=O.URI.revive(a.uri);let d=this.c.get(v);if(d&&v.scheme!==m.Schemas.vscodeNotebookCell&&v.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${v} already exists!'`);d||(d=new r(new g.$kP(this.h.getProxy(p.$UM.MainThreadDocuments),v,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(v,d),i.push(d.value)),d.ref()}if(c.removedEditors)for(const a of c.removedEditors){const v=this.b.get(a);this.b.delete(a),v&&$.push(v)}if(c.addedEditors)for(const a of c.addedEditors){const v=O.URI.revive(a.documentUri);S.ok(this.c.has(v),`document '${v}' does not exist`),S.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const d=this.c.get(v).value,P=new N.$qP(a.id,this.h.getProxy(p.$UM.MainThreadTextEditors),this.i,new o.$V(()=>d.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(u=>y.Range.to(u)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,P)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Qc)(h),(0,R.$Qc)($),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$rP=t,e.$rP=t=Je([We(0,k.$hP),We(1,l.$Zj)],t),e.$sP=(0,M.$ti)("IExtHostDocumentsAndEditors")}),define(Pe[279],Ae([1,0,18,5,4,115,8,7]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class g{constructor(N,y){this.i=y,this.a=new F.$ce,this.b=new F.$ce,this.c=new F.$ce,this.d=new F.$ce,this.f=new F.$ce,this.g=new F.$ce,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(R.$UM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const y=this.i.allEditors();return N?y:y.map(l=>l.value)}async showTextDocument(N,y,l){let b;typeof y=="number"?b={position:M.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?b={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,b),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,y){return new O.$oP(this.h,N,y).value}$acceptEditorPropertiesChanged(N,y){const l=this.i.getEditor(N);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(M.Selection.to);l._acceptSelections(b)}if(y.visibleRanges){const b=S.$Hb(y.visibleRanges.map(M.Range.to));l._acceptVisibleRanges(b)}if(y.options&&this.b.fire({textEditor:l.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:l.value,selections:m,kind:b})}if(y.visibleRanges){const b=S.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const y in N){const l=this.i.getEditor(y);if(!l)throw new Error("Unknown text editor");const b=M.ViewColumn.to(N[y]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$Ukc=g}),define(Pe[280],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=void 0,e.$Dmc=(0,F.$ti)("IExtHostTimeline");class N{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$UM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$Om.equals(o,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(y(r))?.get(s.handle)}else return;return s}})}async $getTimeline(b,m,s,o){return this.b.get(b)?.provider.provideTimeline(S.URI.revive(m),s,o)}registerTimelineProvider(b,m,s,o){const r=new O.$Uc,t=this.d(m.id,o,r).bind(this);let n;m.onDidChange&&(n=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const c=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(h,i,$){i?.resetCache&&(r.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(h,i,$);if(a==null)return;const v=t(h,i);return{...a,source:m.id,items:a.items.map(v)}},dispose(){for(const h of c.values())h.get(m.id)?.clear();n?.dispose(),r.dispose()}},s)}d(b,m,s){return(o,r)=>{let t;if(r?.cacheResults){let n=this.c.get(b);n===void 0&&(n=new Map,this.c.set(b,n));const c=y(o);t=n.get(c),t===void 0&&(t=new Map,n.set(c,t))}return n=>{const{iconPath:c,...h}=n,i=`${b}|${n.id??n.timestamp}`;t?.set(i,n);let $,a,v;n.iconPath&&(c instanceof M.$SN?v={id:c.id,color:c.color}:S.URI.isUri(c)?($=c,a=c):{light:$,dark:a}=c);let d;return M.$lN.isMarkdownString(h.tooltip)?d=p.MarkdownString.from(h.tooltip):(0,k.$6f)(h.tooltip)?d=h.tooltip:M.$lN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=p.MarkdownString.from(h.detail)):(0,k.$6f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=h.detail),{...h,id:h.id??void 0,handle:i,source:b,command:n.command?m.toInternal(n.command,s):void 0,icon:$,iconDark:a,themeIcon:v,tooltip:d,accessibilityInformation:n.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,O.$Tc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Emc=N;function y(l){return l?.toString()}}),define(Pe[281],Ae([1,0,172,23,2,5,6,211,11,7,17,18,8,54,24,137,26]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;function r(c,h){if((0,N.$6f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter($=>$.length===2&&typeof $[0]=="number"&&typeof $[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class t extends M.$Vc{constructor(h,i,$){super(),this.f=h,this.g=i,this.h=$,this.a=new Map,this.b=new s.$x9;function a(v){return v&&v.$treeViewId&&(v.$treeItemHandle||v.$selectedTreeItems||v.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:v=>a(v)?this.r(v):Array.isArray(v)&&v.length>0?v.map(d=>a(d)?this.r(d):d):v})}registerTreeDataProvider(h,i,$){const a=this.createTreeView(h,{treeDataProvider:i},$);return{dispose:()=>a.dispose()}}createTreeView(h,i,$){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],v=i.dragAndDropController?.dragMimeTypes??[],d=!!i.dragAndDropController?.handleDrag,P=!!i.dragAndDropController?.handleDrop,u=this.m(h,i,$),E={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:v,hasHandleDrag:d,hasHandleDrop:P,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,E),D={get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get activeItem(){return(0,o.$CG)($,"treeViewActiveItem"),u.focusedElement},get onDidChangeActiveItem(){return(0,o.$CG)($,"treeViewActiveItem"),u.onDidChangeActiveItem},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return u.onDidChangeCheckboxState},get message(){return u.message},set message(w){(0,b.$Sk)(w)&&(0,o.$CG)($,"treeViewMarkdownMessage"),u.message=w},get title(){return u.title},set title(w){u.title=w},get description(){return u.description},set description(w){u.description=w},get badge(){return u.badge},set badge(w){w!==void 0&&k.ViewBadge.isViewBadge(w)?u.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(u.badge=void 0)},reveal:(w,C)=>u.reveal(w,C),dispose:async()=>{await f,this.a.delete(h),u.dispose()}};return this.B(D),D}$getChildren(h,i){const $=this.a.get(h);return $?$.getChildren(i):Promise.reject(new p.$RF(h))}async $handleDrop(h,i,$,a,v,d,P,u){const E=this.a.get(h);if(!E)return Promise.reject(new p.$RF(h));const f=l.DataTransfer.toDataTransfer($,async D=>(await this.f.$resolveDropFileData(h,i,D)).buffer);return P===h&&u&&await this.j(f,E,u,v,d),E.onDrop(f,a,v)}async j(h,i,$,a,v){const d=this.b.removeDragOperationTransfer(v);if(d)(await d)?.forEach((P,u)=>{P&&h.set(u,P)});else if(v&&i.handleDrag){const P=i.handleDrag($,h,a);this.b.addDragOperationTransfer(v,P),await P}return h}async $handleDrag(h,i,$,a){const v=this.a.get(h);if(!v)return Promise.reject(new p.$RF(h));const d=await this.j(new k.$ON,v,i,a,$);if(!(!d||a.isCancellationRequested))return l.DataTransfer.from(d)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new p.$RF(h);return i.hasResolve}$resolve(h,i,$){const a=this.a.get(h);if(!a)throw new p.$RF(h);return a.resolveTreeItem(i,$)}$setExpanded(h,i,$){const a=this.a.get(h);if(!a)throw new p.$RF(h);a.setExpanded(i,$)}$setSelectionAndFocus(h,i,$){const a=this.a.get(h);if(!a)throw new p.$RF(h);a.setSelectionAndFocus(i,$)}$setVisible(h,i){const $=this.a.get(h);if(!$){if(!i)return;throw new p.$RF(h)}$.setVisible(i)}$changeCheckboxState(h,i){const $=this.a.get(h);if(!$)throw new p.$RF(h);$.setCheckboxState(i)}m(h,i,$){const a=this.B(new n(h,i,this.f,this.g.converter,this.h,$));return this.a.set(h,a),a}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Fmc=t;class n extends M.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,N.$cg)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,$,a,v,d){if(super(),this.I=h,this.J=$,this.L=a,this.M=v,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ce),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ce),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ce),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ce),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ce),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ce),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ce),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$ne,d.contributes&&d.contributes.views)for(const f in d.contributes.views)for(const D of d.contributes.views[f])D.id===h&&(this.P=D.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let P,u;const E=O.Event.debounce(this.F.event,(f,D)=>(f||(f={message:!1,elements:[]}),D.element!==!1&&(P||(P=new Promise(w=>u=w),this.G=this.G.then(()=>P)),Array.isArray(D.element)?f.elements.push(...D.element):f.elements.push(D.element)),D.message&&(f.message=!0),f),200,!0);this.B(E(({message:f,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const w=u;return P=null,this.$(D).then(()=>w())})),f&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let $=this.X(h);return $||($=await this.Y(i)),$?$.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const $=(0,N.$cg)(i.select)?!0:i.select,a=(0,N.$cg)(i.focus)?!1:i.focus,v=(0,N.$cg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(d=>this.W(h,d[d.length-1]).then(P=>this.J.$reveal(this.I,{item:P.item,parentChain:d.map(u=>u.item)},{select:$,focus:a,expand:v})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:$,focus:a,expand:v})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const $=this.getExtensionElement(h);$&&(i?this.u.fire(Object.freeze({element:$})):this.w.fire(Object.freeze({element:$})))}setSelectionAndFocus(h,i){const $=!(0,y.$ub)(this.s,h);this.s=h;const a=this.t!==i;this.t=i,$&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async $=>{const a=this.getExtensionElement($.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter($=>$!==void 0);i.forEach($=>{$.treeItem.checkboxState=$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map($=>[$.extensionItem,$.newState])})}async handleDrag(h,i,$){const a=[];for(const v of h){const d=this.getExtensionElement(v);d&&a.push(d)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,$),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,$){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,g.$lh)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,$):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const $=this.j.get(h);if($){const a=this.m.get($);if(a){const v=await this.f.resolveTreeItem(a.extensionItem,$,i)??a.extensionItem;return this.hb(v),a.item.tooltip=this.eb(v.tooltip),a.item.command=this.fb(a.disposableStore,v.command),a.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then($=>this.W(i,$[$.length-1]).then(a=>($.push(a),$))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$lh)(()=>this.f.getParent(h))}W(h,i){const $=this.m.get(h);return $?Promise.resolve($):(0,g.$lh)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const v=this.getExtensionElement(a);if(v){const d=this.m.get(v);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const $=this.getExtensionElement(h);i=$?this.m.get($):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new m.$ne(this.Z.token);try{const $=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const v=(0,y.$Hb)(a||[]),d=await Promise.all((0,y.$Hb)(v).map(u=>this.f.getTreeItem(u)));if(i.token.isCancellationRequested)return;const P=d.map((u,E)=>u?this.db(v[E],u,$):null);return(0,y.$Hb)(P)}finally{i.dispose()}}$(h){if(h.some($=>!$))return this.Z.dispose(!0),this.Z=new m.$ne,this.tb(),this.J.$refresh(this.I);{const $=this.ab(h);if($.length)return this.bb($)}return Promise.resolve(void 0)}ab(h){const i=new Set,$=h.map(v=>this.m.get(v));for(const v of $)if(v&&!i.has(v.item.handle)){let d=v;for(;d&&d.parent&&$.findIndex(P=>d&&d.parent&&P&&P.item.handle===d.parent.item.handle)===-1;){const P=this.j.get(d.parent.item.handle);d=P?this.m.get(P):void 0}d&&!d.parent&&i.add(v.item.handle)}const a=[];return i.forEach(v=>{const d=this.j.get(v);if(d){const P=this.m.get(d);P&&(!P.parent||!i.has(P.parent.item.handle))&&a.push(v)}}),a}bb(h){const i={};return Promise.all(h.map($=>this.cb($).then(a=>{a&&(i[$]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const $=this.m.get(i);if($)return this.rb(i),(0,g.$lh)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const v=this.ib(i,a,$.parent);return this.pb(i,v,$,$.parent),$.dispose(),v}return null})}return Promise.resolve(null)}db(h,i,$){const a=this.ib(h,i,$);if(i.id&&this.j.has(a.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.ob(h,a),this.qb(a,$),a}eb(h){return k.$lN.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,$,a;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,$=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:i===k.TreeItemCheckboxState.Checked,tooltip:$,accessibilityInformation:a}}hb(h){if(!k.$JN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,$){this.hb(i);const a=this.B(new M.$Uc),v=this.kb(h,i,$),d=this.lb(i);return{item:{handle:v,parentHandle:$?$.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:d,iconDark:this.mb(i)||d,themeIcon:this.jb(i),collapsibleState:(0,N.$cg)(i.collapsibleState)?k.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:$,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof k.$SN?h.iconPath:void 0}kb(h,{id:i,label:$,resourceUri:a},v,d){if(i)return`${n.b}/${i}`;const P=r($,this.N),u=v?v.item.handle:n.a;let E=P?P.label:a?(0,F.$4g)(a):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,D=this.X(v)||[];let w,C=0;do{if(w=`${u}/${C}:${E}`,d||!this.j.has(w)||f===w)break;C++}while(C<=D.length);return w}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$SN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$SN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,$,a){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==$.item.handle&&this.j.delete($.item.handle),this.ob(h,i);const v=this.X(a)||[],d=v.filter(P=>P.item.handle===$.item.handle)[0];d&&v.splice(v.indexOf(d),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[282],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,S,F,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class N extends F.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$ce),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$ce),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends F.$Vc{static c(){return(0,O.$Pg)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(g.$UM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,r,t={}){const n=typeof r=="object"?r.viewColumn:r,c={viewColumn:M.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,p.$0kc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$_kc)(m),i,s,{title:o,panelOptions:l(t),webviewOptions:(0,p.$alc)(m,this.m,t),serializeBuffersForPostMessage:h},c);const $=this.j.createNewWebview(i,t,m);return this.createNewWebviewPanel(i,s,o,n,t,$,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,r)=>{const t=m[o],n=m[r];return t.active?1:n.active?-1:+t.visible-+n.visible});for(const o of s){const r=this.getWebviewPanel(o);if(!r)continue;const t=m[o];r._updateViewState({active:t.active,visible:t.visible,viewColumn:M.ViewColumn.to(t.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$0kc)(m)}),new k.$WM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,r){const t=this.h.get(s);if(!t)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:c}=t,h=this.j.createNewWebview(m,o.webviewOptions,c),i=this.createNewWebviewPanel(m,s,o.title,r,o.panelOptions,h,o.active);await n.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,r,t,n,c){const h=new N(m,this.f,n,{viewType:s,title:o,viewColumn:r,panelOptions:t,active:c});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$blc=y;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[283],Ae([1,0,5,6,63,8,4,7]),function(ge,e,S,F,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class g extends F.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,l,b,m,s,o){super(),this.#s=!1,this.#u=this.B(new S.$ce),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$ce),this.onDidDispose=this.#l.event,this.#i=b,this.#a=m,this.#e=y,this.#t=l,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(y,l){this.d=l,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$UM.MainThreadWebviewViews)}registerWebviewViewProvider(y,l,b,m){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:y}),this.a.$registerWebviewViewProvider((0,R.$_kc)(y),l,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$0kc)(y)}),new p.$WM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(y,l,b,m,s){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:t}=o,n=this.d.createNewWebview(y,{},t),c=new g(y,this.a,l,b,n,!0);this.c.set(y,c),await r.resolveWebviewView(c,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,l){this.e(y)._setVisible(l)}async $disposeWebviewView(y){const l=this.e(y);this.c.delete(y),l.dispose(),this.d.deleteWebview(y)}e(y){const l=this.c.get(y);if(!l)throw new Error("No webview found");return l}}e.$Imc=k}),define(Pe[284],Ae([1,0,5,30,31,3]),function(ge,e,S,F,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.OutputChannelUpdateMode=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=void 0,e.$3L="text/x-code-output",e.$4L="output",e.$5L="Log",e.$6L="text/x-code-log-output",e.$7L="log",e.$8L="workbench.panel.output",e.$9L=new R.$Kj("inOutput",!1),e.$0L=new R.$Kj("activeLogOutput",!1),e.$$L=new R.$Kj("activeLogOutput.levelSettable",!1),e.$_L=new R.$Kj("activeLogOutput.level",""),e.$aM=new R.$Kj("activeLogOutput.levelIsDefault",!1),e.$bM=new R.$Kj("outputView.scrollLock",!1),e.$cM=(0,O.$ti)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$dM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new S.$ce,this.onDidRegisterChannel=this.b.event,this.c=new S.$ce,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}F.$_n.add(e.$dM.OutputChannels,new p),e.$eM=new R.$Kj("activeOutputChannel","")}),define(Pe[116],Ae([1,0,4,3,16,20,13,284,64,27,45,141,22,17,44,5,6]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$hmc=void 0;class r extends M.$6j{get disposed(){return this.n}constructor(h,i,$,a,v){super(),this.id=h,this.name=i,this.r=$,this.s=a,this.extension=v,this.m=0,this.n=!1,this.visible=!1,this.setLevel($.getLevel()),this.B($.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$De.fromString(i).byteLength,(0,M.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class t extends r{appendLine(h){this.append(h)}}let n=class{constructor(h,i,$,a,v,d){this.i=i,this.j=$,this.k=a,this.l=v,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$UM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,$]of this.g)$.visible=i===this.h}createOutputChannel(h,i,$){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,v=(0,b.$6f)(i)?i:void 0;if((0,b.$6f)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const P=this.i.environment.extensionLogLevel?.find(([E])=>O.$Om.equals($.identifier,E))?.[1];P&&(d=(0,M.$ek)(P));const u=a?this.o(h,d,$):this.n(h,v,$);return u.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),a?this.r(h,d??this.m.getLevel(),u):this.q(h,u)}async n(h,i,$){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,v=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(v,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),P=await this.a.$register(h,v,i,$.identifier.value);return new r(P,h,d,this.a,$)}async o(h,i,$){const a=await this.p($),v=h.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(a,`${v}.log`),P=`${$.identifier.value}.${v}`,u=this.l.createLogger(d,{id:P,name:h,logLevel:i,extensionId:$.identifier.value});return new t(P,h,u,this.a,$)}p(h){let i=this.d.get(h.identifier.value);if(!i){const $=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory($)}catch(a){if((0,m.$dl)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return $})())}return i}q(h,i){let $=!1;const a=()=>{if($)throw new Error("Channel has been closed")};return{get name(){return h},append(v){a(),i.then(d=>d.append(v))},appendLine(v){a(),i.then(d=>d.appendLine(v))},clear(){a(),i.then(v=>v.clear())},replace(v){a(),i.then(d=>d.replace(v))},show(v,d){a(),i.then(P=>P.show(v,d))},hide(){a(),i.then(v=>v.hide())},dispose(){$=!0,i.then(v=>v.dispose())}}}r(h,i,$){const a=new o.$Uc,v=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},d=a.add(new s.$ce);function P(u){i=u,d.fire(u)}return $.then(u=>{a.add(u),u.logLevel!==i&&P(u.logLevel),a.add(u.onDidChangeLogLevel(E=>P(E)))}),{...this.q(h,$),get logLevel(){return i},onDidChangeLogLevel:d.event,trace(u,...E){v(),$.then(f=>f.trace(u,...E))},debug(u,...E){v(),$.then(f=>f.debug(u,...E))},info(u,...E){v(),$.then(f=>f.info(u,...E))},warn(u,...E){v(),$.then(f=>f.warn(u,...E))},error(u,...E){v(),$.then(f=>f.error(u,...E))},dispose(){a.dispose()}}}};e.$hmc=n,e.$hmc=n=Je([We(0,R.$hP),We(1,k.$xP),We(2,g.$6kc),We(3,N.$Ikc),We(4,M.$1j),We(5,M.$Zj)],n),e.$imc=(0,F.$ti)("IExtHostOutputService")}),define(Pe[117],Ae([1,0,3,11]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=void 0,e.$dn=(0,S.$ti)("remoteAgentService"),e.$en=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const g=await R.getRoundTripTime();if(g===void 0)return;O=Math.min(O,g/2),await(0,F.$uh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((p,g)=>p+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((p,g)=>p+g,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[285],Ae([1,0,175,57,30,49,48,6,5,117,21,25,11]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=void 0,e.$vJ=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$wJ=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$xJ=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$yJ=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$zJ={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new g.$ce,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const m=new b;R.$_n.add(e.$zJ.ConfigurationMigration,m);let s=class extends p.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(c=>this.g(c,t?.uri))])}async g(t,n){const c=this.a.inspect(t.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,$]of h){const a=c[i];if(!a)continue;const v=[];if(a.value!==void 0){const d=await this.h(t,i,a.value,n,void 0);for(const P of d??[])v.push([P,[]])}for(const{identifiers:d,value:P}of a.overrides??[])if(P!==void 0){const u=await this.h(t,i,P,n,d);for(const E of u??[])v.push([E,d])}v.length&&await Promise.allSettled(v.map(async([[d,P],u])=>this.a.updateValue(d,P.value,{resource:n,overrideIdentifiers:u},$)))}}async h(t,n,c,h,i){const $=v=>{const P=this.a.inspect(v,{resource:h})[n];if(P)return i?P.overrides?.find(({identifiers:u})=>(0,y.$4n)(u,i))?.value:P.value},a=await t.migrateFn(c,$);return Array.isArray(a)?a:[[t.key,a]]}};e.$AJ=s,e.$AJ=s=Je([We(0,M.$Zi),We(1,O.$Ci)],s);let o=class extends p.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(t){super(),this.b=t,this.a=new l.$Qh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$_n.as(F.$eo.Configuration).registerConfiguration({...e.$xJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$BJ=o,e.$BJ=o=Je([We(0,k.$dn)],o)}),define(Pe[286],Ae([1,0,36,12,19,23,184,285,57,3,30]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Sgb=e.$Rgb=void 0,e.$Tgb=s,e.$Ugb=o,e.$Rgb=(0,k.$ti)("editorResolverService"),e.$Sgb="workbench.editorAssociations";const y=N.$_n.as(g.$eo.Configuration),l={...p.$wJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(l);var b;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(b||(e.RegisteredEditorPriority=b={}));var m;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(r){switch(r){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(r,t){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(t.scheme))return!1;const h=typeof r=="string"&&r.indexOf(R.$hc.sep)>=0?`${t.scheme}:${t.path}`:(0,O.$4g)(t);return S.$mk(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}}),define(Pe[287],Ae([1,0,47,12,19,21,23,2,3,205,49,225,117]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0,e.$wM=(0,g.$ti)("pathService");let m=b=class{constructor(o,r,t,n){this.d=o,this.e=r,this.f=t,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,r,t){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(o,n,r)):this.h(o,r,t)}h(o,r,t){return o.scheme===F.Schemas.file||o.scheme===F.Schemas.vscodeRemote?(0,S.$qg)(t??(0,M.$4g)(o),r===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,r){if(o.remoteAuthority)return F.Schemas.vscodeRemote;const t=(0,k.$tM)(r.getWorkspace());if(t)return t;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:F.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let r="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(r=o.substring(2),o="/"):(r=o.substring(2,n),o=o.substring(n)||"/")}return p.URI.from({scheme:F.Schemas.file,authority:r,path:o,query:"",fragment:""})}};e.$xM=m,e.$xM=m=b=Je([We(1,l.$dn),We(2,y.$fM),We(3,N.$Ci)],m)}),define(Pe[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$3K=e.$2K=void 0;class S{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new S(0,0)}with(M){return new S(0,0)}}e.$2K=S;class F{constructor(M,p,g,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(M,p),this.end=new S(g,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new F(0,0,0,0)}with(M){return new F(0,0,0,0)}}e.$3K=F;var R;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Pe[46],Ae([1,0,18,36,25,47,15,3,19,14,118,11]),function(ge,e,S,F,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$nL=e.$gL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$dL=e.$cL=e.$bL=e.$aL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TextSearchCompleteMessageType=void 0,e.$0K=r,e.$$K=t,e.$_K=n,e.$eL=u,e.$fL=E,e.$hL=w,e.$iL=C,e.$jL=I,e.$kL=W,e.$lL=V,e.$mL=q,e.$oL=j,e.$qL=ae,e.$rL=be,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$4K="workbench.view.search",e.$5K="workbench.panel.search",e.$6K="workbench.view.search",e.$7K="search-result",e.$8K="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",m=(l.length+b.length+5)*2;e.$9K=(0,p.$ti)("searchService");var s;(function(de){de[de.file=0]="file",de[de.text=1]="text",de[de.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text",de[de.aiText=3]="aiText"})(o||(e.QueryType=o={}));function r(de){return!!de.preview}function t(de){return!!de.resource}function n(de){return!!de.message}var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(me){this.resource=me,this.results=[]}}e.$aL=h;class i{constructor(me,Me,ce,Re){this.ranges=Me,this.webviewIndex=Re;const ie=Array.isArray(Me)?Me:[Me];if(ce&&ce.matchLines===1&&$(ie)){me=(0,M.$Yf)(me,ce.matchLines);let L="",x=0,ve=0;const Te=Math.floor(ce.charsPerLine/5),ke=[];for(const pe of ie){const fe=Math.max(pe.startColumn-Te,0),Q=pe.startColumn+ce.charsPerLine;if(fe>ve+Te+m){const X=l+(fe-ve)+b;L+=X+me.slice(fe,Q),x+=fe-(ve+X.length)}else L+=me.slice(ve,Q);ke.push(new v(0,pe.startColumn-x,pe.endColumn-x)),ve=Q}this.preview={text:L,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const L=Array.isArray(Me)?Me[0].startLineNumber:Me.startLineNumber;this.preview={text:me,matches:(0,S.$2b)(Me,x=>new a(x.startLineNumber-L,x.startColumn,x.endLineNumber-L,x.endColumn))}}}}e.$bL=i;function $(de){const me=de[0].startLineNumber;for(const Me of de)if(Me.startLineNumber!==me||Me.endLineNumber!==me)return!1;return!0}class a{constructor(me,Me,ce,Re){this.startLineNumber=me,this.startColumn=Me,this.endLineNumber=ce,this.endColumn=Re}}e.$cL=a;class v extends a{constructor(me,Me,ce){super(me,Me,me,ce)}}e.$dL=v;var d;(function(de){de.List="list",de.Tree="tree"})(d||(e.ViewMode=d={}));var P;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(P||(e.SearchSortOrder=P={}));function u(de,me=!0){const Me=de&&de.files&&de.files.exclude,ce=me&&de&&de.search&&de.search.exclude;if(!Me&&!ce)return;if(!Me||!ce)return Me||ce;let Re=Object.create(null);return Re=R.$3n(Re,R.$Zn(Me)),Re=R.$3n(Re,R.$Zn(ce),!0),Re}function E(de,me){return de.excludePattern&&F.$mk(de.excludePattern,me)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&F.$mk(de.includePattern,me)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(Me=>{const ce=Me.folder.fsPath;if(O.$sg(me,ce)){const Re=g.$mc(ce,me);return!Me.includePattern||!!F.$mk(Me.includePattern,Re)}else return!1}):!1:!0}var f;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class D extends Error{constructor(me,Me){super(me),this.code=Me}}e.$gL=D;function w(de){const me=de.message;if((0,k.$4)(de))return new D(me,f.canceled);try{const Me=JSON.parse(me);return new D(Me.message,Me.code)}catch{return new D(me,f.other)}}function C(de){const me={message:de.message,code:de.code};return new Error(JSON.stringify(me))}function I(de){return de.type==="error"?!0:de.type==="success"}function W(de){return de.type==="success"}function V(de){return!!de.path}function q(de,me,Me=!0){const ce=de.searchPath?de.searchPath:de.relativePath;return Me?(0,M.$Vf)(ce,me):F.$mk(me,ce)}class A{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$nL=A;function j(de,me){const Me={...de||{},...me||{}};return Object.keys(Me).filter(ce=>{const Re=Me[ce];return typeof Re=="boolean"&&Re})}class K{constructor(me,Me){this.c=null,this.a={...me.excludePattern||{},...Me.excludePattern||{}},this.b=F.$nk(this.a);let ce=me.includePattern;Me.includePattern&&(ce?ce={...ce,...Me.includePattern}:ce=Me.includePattern),ce&&(this.c=F.$nk(ce))}matchesExcludesSync(me,Me,ce){return!!(this.b&&this.b(me,Me,ce))}includedInQuerySync(me,Me,ce){return!(this.b&&this.b(me,Me,ce)||this.c&&!this.c(me,Me,ce))}includedInQuery(me,Me,ce){const Re=this.b(me,Me,ce),ie=()=>this.c?!!this.c(me,Me,ce):!0;return(0,y.$fh)(Re)?Re.then(L=>L?!1:ie()):ie()}hasSiblingExcludeClauses(){return re(this.a)}}e.$pL=K;function re(de){for(const me in de)if(typeof de[me]!="boolean")return!0;return!1}function ae(de){if(!de)return;let me;return Me=>(me||(me=(de()||Promise.resolve([])).then(ce=>ce?Ie(ce):{})),me.then(ce=>!!ce[Me]))}function be(de){if(!de)return;let me;return Me=>{if(!me){const ce=de();me=ce?Ie(ce):{}}return!!me[Me]}}function Ie(de){const me={};for(const Me of de)me[Me]=!0;return me}}),define(Pe[37],Ae([1,0,18,11,24,5,6,52,12,126,23,15,2,174,3,13,194,49,45,27,16,8,7,60,46,4,53]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$,a,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Zkc=void 0;function P(W,V,q){return new N.$Vg(A=>D(A,q)).isEqual(W,V)}function u(W,V,q){return P(W.uri,V.uri,q)?0:(0,y.$of)(W.uri.toString(),V.uri.toString())}function E(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:P(W.uri,V.uri,q)?(0,y.$of)(W.name,V.name):(0,y.$of)(W.uri.toString(),V.uri.toString())}function f(W,V,q,A){const j=W.slice(0).sort((re,ae)=>q(re,ae,A)),K=V.slice(0).sort((re,ae)=>q(re,ae,A));return(0,S.$Eb)(j,K,(re,ae)=>q(re,ae,A))}function D(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class w extends r.$Mi{static toExtHostWorkspace(V,q,A,j){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:re,folders:ae,configuration:be,transient:Ie,isUntitled:de}=V,me=[],Me=q;q?ae.forEach((L,x)=>{const ve=l.URI.revive(L.uri),Te=w.o(A||q,ve,j);Te?(Te.name=L.name,Te.index=L.index,me.push(Te)):me.push({uri:ve,name:L.name,index:x})}):me.push(...ae.map(({uri:L,name:x,index:ve})=>({uri:l.URI.revive(L),name:x,index:ve}))),me.sort((L,x)=>L.index<x.index?-1:1);const ce=new w(K,re,me,!!Ie,be?l.URI.revive(be):null,!!de,L=>D(L,j)),{added:Re,removed:ie}=f(Me?Me.workspaceFolders:[],ce.workspaceFolders,u,j);return{workspace:ce,added:Re,removed:ie}}static o(V,q,A){for(let j=0;j<V.folders.length;j++){const K=V.workspaceFolders[j];if(P(K.uri,q,A))return K}}constructor(V,q,A,j,K,re,ae){super(V,A.map(be=>new r.$Ni(be)),j,K,ae),this.t=q,this.u=re,this.q=[],this.s=p.$zi.forUris(ae),A.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,N.$6g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,A,j,K){this.c=new O.$ce,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ce,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ee,this.C=new Map,this.h=j,this.s=A,this.t=K,this.j=new k.$Am,this.k=new F.$sh,this.o=V.getProxy(v.$UM.MainThreadWorkspace),this.q=V.getProxy(v.$UM.MainThreadMessageService);const re=q.workspace;this.l=re?new w(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ae=>D(ae,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,N.$4g)((0,N.$6g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...j){const K=[];if(Array.isArray(j)&&j.forEach(de=>{l.URI.isUri(de.uri)&&!K.some(me=>P(me.uri,de.uri,this.s))&&K.push({uri:de.uri,name:de.name||(0,N.$3g)(de.uri)})}),this.n||[q,A].some(de=>typeof de!="number"||de<0)||A===0&&K.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(q+A>re.length)return!1;const ae=re.slice(0);ae.splice(q,A,...K.map(de=>({uri:de.uri,name:de.name||(0,N.$3g)(de.uri),index:void 0})));for(let de=0;de<ae.length;de++){const me=ae[de];if(ae.some((Me,ce)=>ce!==de&&P(me.uri,Me.uri,this.s)))return!1}ae.forEach((de,me)=>de.index=me);const{added:be,removed:Ie}=f(re,ae,E,this.s);if(be.length===0&&Ie.length===0)return!1;if(this.o){const de=V.displayName||V.name;this.o.$updateWorkspaceFolders(de,q,A,K).then(void 0,me=>{this.n=void 0;const Me={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,de,me.toString()),Me,[])})}return this.y(ae),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,j="";if(typeof V=="string"?(A=l.URI.file(V),j=V):typeof V<"u"&&(A=V,j=V.fsPath),!A)return j;const K=this.getWorkspaceFolder(A,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let re=(0,N.$9g)(K.uri,A);return q&&K.name&&(re=`${K.name}/${re}`),re}y(V){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:j}=w.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:j}))}findFiles(V,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let re="",ae=!0;return q===null?ae=!1:q!==void 0&&(typeof q=="string"?re=q:re=q.pattern),this.z(V,void 0,{exclude:re,maxResults:A,useDefaultExcludes:ae,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,j=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,j)}async z(V,q,A,j=R.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,re={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ae;if(V){const{includePattern:be,folder:Ie}=I(h.GlobPattern.from(V));ae=Ie,re.includePattern=be}else{const{includePattern:be,folder:Ie}=I(h.GlobPattern.from(q));ae=Ie,re.filePattern=be}return this.o.$startFileSearch(ae??null,re,j).then(be=>Array.isArray(be)?be.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(V,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ae=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:be,folder:Ie}=I(h.GlobPattern.from(q.include)),de=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,me={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ae,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:be,excludePattern:de},Me=!1;if(this.u[re]=ce=>{if(Me)return;const Re=l.URI.revive(ce.resource);ce.results.forEach(ie=>{const L=(0,d.$3h)(ie);(0,a.$0K)(L)?A({uri:Re,preview:{text:L.preview.text,matches:(0,S.$2b)(L.preview.matches,x=>new i.$YM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,S.$2b)(L.ranges,x=>new i.$YM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Re,text:L.text,lineNumber:L.lineNumber})})},K.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(V,Ie??null,me,re,K);return delete this.u[re],ce||{}}catch(ce){throw delete this.u[re],ce}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return l.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return l.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,A),(0,M.$Tc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const j=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const re=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!re),!re)return;const ae=await re.provideEditSessionIdentityMatch?.(q,A,j);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,j)=>{const K=function(ae){q.call(A,ae)};return K.extension=V,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(V,q,A){const j=await this.resolveWorkspaceFolder(l.URI.revive(V));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,re)=>{const ae=Date.now();await Promise.resolve(K),Date.now()-ae>A&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerCanonicalUriProvider(j,A),(0,M.$Tc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(V,q,A){const j=this.C.get(V.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(l.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:q},A)}};e.$Zkc=C,e.$Zkc=C=Je([We(0,c.$hP),We(1,n.$xP),We(2,t.$Ikc),We(3,s.$Zj),We(4,$.$Xkc)],C),e.$1kc=(0,m.$ti)("IExtHostWorkspace");function I(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Pe[38],Ae([1,0,25,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=e.$2kc=void 0;function s($,a){if(a){const v=a.split(".");let d=$;for(let P=0;d&&P<v.length;P++)d=d[v[P]];return d}}function o($){return $ instanceof m.URI}function r($){return $&&$.uri instanceof m.URI&&$.languageId&&typeof $.languageId=="string"}function t($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&$.uri instanceof m.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function c($){if(o($))return{resource:$};if(r($))return{resource:$.uri,overrideIdentifier:$.languageId};if(t($))return{overrideIdentifier:$.languageId};if(n($))return{resource:$.uri};if($===null)return{resource:null}}let h=class{constructor(a,v,d){this.a=a.getProxy(O.$UM.MainThreadConfiguration),this.c=v,this.b=d,this.d=new N.$sh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,v){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(a,v))}};e.$2kc=h,e.$2kc=h=Je([We(0,l.$hP),We(1,R.$1kc),We(2,b.$Zj)],h);class i{constructor(a,v,d,P){this.a=new F.$ce,this.b=a,this.f=P,this.c=v,this.e=p.$xo.parse(d,P),this.d=this.k(d.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,v){const d={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$xo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(v,d))}getConfiguration(a,v,d){const P=c(v)||{},u=this.g(a?s(this.e.getValue(void 0,P,this.c.workspace),a):this.e.getValue(void 0,P,this.c.workspace));a&&this.h(a,P,d?.identifier);function E(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(D){return typeof s(u,D)<"u"},get:(D,w)=>{this.h(a?`${a}.${D}`:D,P,d?.identifier);let C=s(u,D);if(typeof C>"u")C=w;else{let I;const W=(V,q)=>{if((0,k.$8f)(V)){let A;const j=()=>{I=I||(0,S.$Zn)(u),A=A||s(I,q)};return new Proxy(V,{get:(K,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return j(),()=>A;if(I)return A=A||s(I,q),A[re];const ae=K[re];return typeof re=="string"?W(ae,`${q}.${re}`):ae},set:(K,re,ae)=>(j(),A&&(A[re]=ae),!0),deleteProperty:(K,re)=>(j(),A&&delete A[re],!0),defineProperty:(K,re,ae)=>(j(),A&&Object.defineProperty(A,re,ae),!0)})}return Array.isArray(V)?(0,S.$Zn)(V):V};C=W(C,D)}return C},update:(D,w,C,I)=>{D=a?`${a}.${D}`:D;const W=E(C);return w!==void 0?this.b.$updateConfigurationOption(W,D,w,P,I):this.b.$removeConfigurationOption(W,D,P,I)},inspect:D=>{D=a?`${a}.${D}`:D;const w=this.e.inspect(D,P,this.c.workspace);if(w)return{key:D,defaultValue:(0,S.$Zn)(w.policy?.value??w.default?.value),globalValue:(0,S.$Zn)(w.user?.value??w.application?.value),workspaceValue:(0,S.$Zn)(w.workspace?.value),workspaceFolderValue:(0,S.$Zn)(w.workspaceFolder?.value),defaultLanguageValue:(0,S.$Zn)(w.default?.override),globalLanguageValue:(0,S.$Zn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,S.$Zn)(w.workspace?.override),workspaceFolderLanguageValue:(0,S.$Zn)(w.workspaceFolder?.override),languageIds:(0,S.$Zn)(w.overrideIdentifiers)}}};return typeof u=="object"&&(0,S.$3n)(f,u,!1),Object.freeze(f)}g(a){const v=d=>(0,k.$8f)(d)?new Proxy(d,{get:(P,u)=>v(P[u]),set:(P,u,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(P,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(P,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:P=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return v(a)}h(a,v,d){const P=g.$oo.test(a)?4:this.d.get(a),u=d?`[${d.value}] `:"";if(P===4){typeof v?.resource>"u"&&this.f.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(P===3){v?.resource&&this.f.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,v){const d=new p.$zo(a,v,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(P,u)=>d.affectsConfiguration(P,c(u))})}k(a){return a.reduce((v,d)=>(v.set(d[0],d[1]),v),new Map)}}e.$3kc=i,e.$4kc=(0,y.$ti)("IExtHostConfiguration")}),define(Pe[119],Ae([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,230,14]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=e.$tmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(h||(h={}));var i;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(i||(i={}));var $;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})($||($={}));var a;(function(W){function V(j){if(j){const K=j;return K&&!!K.process}else return!1}W.is=V;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=$.from(j.options)),K}W.from=q;function A(j){if(j!=null)return new M.$FN(j.process,j.args,j.options)}W.to=A})(a||(a={}));var v;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(v||(v={}));var d;(function(W){function V(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=v.from(j.options)),K}W.from=q;function A(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$GN(j.commandLine,j.options):new M.$GN(j.command,j.args?j.args:[],j.options)}W.to=A})(d||(d={}));var P;(function(W){function V(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(j){return{customExecution:"customExecution"}}W.from=q;function A(j,K){return K.get(j)}W.to=A})(P||(e.CustomExecutionDTO=P={}));var u;(function(W){function V(q,A){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?j=A.workspaceFile:j=n.$1H),{id:q._id,workspaceFolder:j}}W.from=V})(u||(e.TaskHandleDTO=u={}));var E;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(E||(E={}));var f;(function(W){function V(j,K){if(j==null)return[];const re=[];for(const ae of j){const be=q(ae,K);be&&re.push(be)}return re}W.fromMany=V;function q(j,K){if(j==null)return;let re;j.execution instanceof M.$FN?re=a.from(j.execution):j.execution instanceof M.$GN?re=d.from(j.execution):j.execution&&j.execution instanceof M.$HN&&(re=P.from(j.execution));const ae=h.from(j.definition);let be;return j.scope?typeof j.scope=="number"?be=j.scope:be=j.scope.uri:be=M.TaskScope.Workspace,!ae||!be?void 0:{_id:j._id,definition:ae,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:be},execution:re,isBackground:j.isBackground,group:E.from(j.group),presentationOptions:i.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}W.from=q;async function A(j,K,re){if(j==null)return;let ae;a.is(j.execution)?ae=a.to(j.execution):d.is(j.execution)?ae=d.to(j.execution):P.is(j.execution)&&(ae=P.to(j._id,re));const be=h.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(S.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!be||!Ie)return;const de=new M.$IN(be,Ie,j.name,j.source.label,ae,j.problemMatchers);return j.isBackground!==void 0&&(de.isBackground=j.isBackground),j.group!==void 0&&(de.group=M.$EN.from(j.group._id),de.group&&j.group.isDefault&&(de.group=new M.$EN(de.group.id,de.group.label),j.group.isDefault===!0&&(de.group.isDefault=j.group.isDefault))),j.presentationOptions&&(de.presentationOptions=i.to(j.presentationOptions)),j._id&&(de._id=j._id),j.detail&&(de.detail=j.detail),de}W.to=A})(f||(e.TaskDTO=f={}));var D;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(D||(D={}));class w{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,A,j,K,re,ae,be){this.q=new R.$ce,this.r=new R.$ce,this.s=new R.$ce,this.u=new R.$ce,this.a=V.getProxy(O.$UM.MainThreadTask),this.b=A,this.c=j,this.d=K,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new M.$WM(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(j,q),new M.$WM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(D.from(V)).then(async q=>{const A=[];for(const j of q){const K=await f.to(j,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const j=this.m.get(V.id);j&&(this.o.set(V.id,j),this.e.attachPtyToTerminal(q,await j.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const j=[],K=(0,F.$lh)(()=>A.provider.provideTasks(N.CancellationToken.None)).then(re=>this.v(q,j,A,re));return new Promise(re=>{K.then(ae=>{Promise.all(j).then(()=>{re(ae)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const j=await f.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(j,N.CancellationToken.None);if(!K)return;this.A(K,A);const re=f.from(K,A.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return P.is(re.execution)&&await this.y(re,K,!0),await this.w(re)}x(){return this.h++}async y(V,q,A){const j=await this.a.$createTaskId(V);!A&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let j;return q?j=Promise.resolve(new w(this,V.id,q)):j=f.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,V.id,K)}),this.l.set(V.id,j),j.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let j=A.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=A.next()}};e.$tmc=C,e.$tmc=C=Je([We(0,l.$hP),We(1,b.$xP),We(2,p.$1kc),We(3,g.$sP),We(4,k.$4kc),We(5,y.$plc),We(6,r.$Zj),We(7,t.$Ekc)],C);let I=class extends C{constructor(V,q,A,j,K,re,ae,be){super(V,q,A,j,K,re,ae,be),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,V);if(A===void 0)throw new Error("Task is not valid");if(P.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const j=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),j}v(V,q,A,j){const K=[];if(j)for(const re of j){if(this.A(re,A),!re.definition||!V[re.definition.type]){const be=re.source?re.source:"No task source";this.f.warn(`The task [${be}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=f.from(re,A.extension);ae&&P.is(ae.execution)?(K.push(ae),q.push(this.y(ae,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if(P.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$umc=I,e.$umc=I=Je([We(0,l.$hP),We(1,b.$xP),We(2,p.$1kc),We(3,g.$sP),We(4,k.$4kc),We(5,y.$plc),We(6,r.$Zj),We(7,t.$Ekc)],I),e.$vmc=(0,m.$ti)("IExtHostTask")}),define(Pe[288],Ae([1,0,46,29]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=void 0,e.$xL=R,e.$zL=O;function R(M){return"cellResults"in M}e.$yL="rawCell#";function O(M,p){let g=-1;const k=[];let N=[];return M.forEach(l=>{l.range.startLineNumber!==g&&N.length>0&&(k.push([...N]),N=[]),N.push(l),g=l.range.endLineNumber}),N.length>0&&k.push([...N]),k.map(l=>{const b=[],m=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let o=m;o<=s;o++)b.push(p.getLineContent(o));return new S.$bL(b.join(`
`)+`
`,l.map(o=>new F.$pt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[289],Ae([1,0,168,22,5,6,28,15,17,2,44,74,4,32,8,7,34,264,112,25,12,220,288,286]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(d=>d.apiEditor)}constructor(d,P,u,E,f,D){this.q=u,this.r=E,this.s=f,this.t=D,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$ce,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$ce,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$ce,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$ce,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$Ckc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=d.getProxy(l.$UM.MainThreadNotebook),this.c=d.getProxy(l.$UM.MainThreadNotebookDocuments),this.d=d.getProxy(l.$UM.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const C=w.notebookEditor?.notebookUri,I=w.cell.handle,V=this.g.get(C)?.getCell(I);if(V)return V.apiCell}if(w&&w.$mid===14){const C=w.uri,I=this.g.get(C);if(I)return I.apiNotebook}return w}}),a.B(P)}getEditorById(d){const P=this.h.get(d);if(!P)throw new Error(`unknown text editor: ${d}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(d){for(const[P,u]of this.h)if(u.apiEditor===d)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(d,P){const u=this.g.get(d);if(!u&&!P)throw new Error(`NO notebook document for '${d}'`);return u}static u(d,P){if(!P)return;const u=P.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(P.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:P.displayName,filenamePattern:u,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,P,u){const E=a.a++,f=typeof u.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(E,u),this.b.$registerNotebookCellStatusBarItemProvider(E,f,P);let D;return f!==void 0&&(D=u.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(f))),new s.$WM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,f),D?.dispose()})}async createNotebookDocument(d){const P=await this.c.$tryCreateNotebook({viewType:d.viewType,content:d.content&&m.NotebookData.from(d.content)});return k.URI.revive(P)}async openNotebookDocument(d){const P=this.g.get(d);if(P)return P.apiNotebook;const u=await this.c.$tryOpenNotebook(d),E=this.g.get(k.URI.revive(u));return(0,g.$eg)(E?.apiNotebook)}async showNotebookDocument(d,P){k.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let u;typeof P=="object"?u={position:m.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(m.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:u={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(d.uri,d.notebookType,u),f=E&&this.h.get(E)?.apiEditor;if(f)return f;throw E?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,P,u,E){const f=this.f.get(d),D=k.URI.revive(P),w=this.g.get(D);if(!w||!f)return;const C=w.getCellFromIndex(u);if(!C)return;const I=await f.provideCellStatusBarItems(C.apiCell,E);if(!I)return;const W=new O.$Uc,V=this.p.add([W]),A=(Array.isArray(I)?I:[I]).map(j=>m.NotebookStatusBarItem.from(j,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(d){this.p.delete(d)}registerNotebookSerializer(d,P,u,E,f){if((0,p.$5e)(P))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:P,serializer:u,options:E}),this.b.$registerNotebookSerializer(D,{id:d.identifier,location:d.extensionLocation},P,m.NotebookDocumentContentOptions.from(E),a.u(d,f)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(d,P,u){const E=this.x.get(d);if(!E)throw new Error("NO serializer found");const f=await E.serializer.deserializeNotebook(P.buffer,u);return new o.$qw(m.NotebookData.from(f))}async $notebookToData(d,P,u){const E=this.x.get(d);if(!E)throw new Error("NO serializer found");const f=await E.serializer.serializeNotebook(m.NotebookData.to(P.value),u);return F.$De.wrap(f)}async $saveNotebook(d,P,u,E,f){const D=k.URI.revive(P),w=this.x.get(d);if(!w)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==u)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new N.$il((0,S.localize)(0,null,this.z(D)),6);await this.y(D,E);const I={metadata:(0,n.$8n)(C.apiNotebook.metadata,j=>!(w.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const K=new s.$mO(j.kind,j.document.getText(),j.document.languageId,j.mime,w.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,n.$8n)(j.metadata,re=>!(w.options?.transientCellMetadata??{})[re]),I.cells.push(K)}const W=await w.serializer.serializeNotebook(I,f);await this.s.value.writeFile(D,W);const V=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:V.basename(D),isFile:(q.type&N.FileType.File)!==0,isDirectory:(q.type&N.FileType.Directory)!==0,isSymbolicLink:(q.type&N.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&N.FilePermission.Locked),etag:N.$tl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(d,P,u,E,f){const D=this.x.get(d)?.serializer;if(!D)return{limitHit:!1,results:[]};const w=new M.$Cc;await(async(q,A,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(re=>{const ae={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ae,A,be=>{be.forEach(Ie=>{w.has(Ie)||E.some(me=>K.isFromSettings&&!me.isFromSettings?!1:me.filenamePatterns.some(Me=>(0,$.$Ugb)(Me,Ie)))||w.add(Ie)})}).catch(be=>{if(be.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw be})}))))})(u,f,P);const I=new M.$Bc;let W=!1;const V=Array.from(w).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if(P.maxResults&&[...I.values()].reduce((ae,be)=>ae+be.cellResults.length,0)>P.maxResults){W=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(be=>j.push({input:be.document.getText(),outputs:be.outputs.flatMap(Ie=>Ie.items.map(de=>de.data.toString()))}));else{const ae=await this.s.value.readFile(q),be=F.$De.fromString(ae.toString()),Ie=await D.deserializeNotebook(be.buffer,f);if(f.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(me=>j.push({input:me.source,outputs:me.outputs.flatMap(Me=>Me.items.map(ce=>ce.valueBytes.toString()))}))}if(f.isCancellationRequested)return;j.forEach((ae,be)=>{const Ie=P.contentPattern.pattern,de=new h.$MWb(ae.input,void 0,ae.outputs),me=de.findInInputs(Ie),Me=de.findInOutputs(Ie),ce=Me.flatMap(Re=>(0,i.$zL)(Re.matches,Re.textBuffer)).map((Re,ie)=>(Re.webviewIndex=ie,Re));if(me.length>0||Me.length>0){const Re={index:be,contentResults:(0,i.$zL)(me,de.inputTextBuffer),webviewResults:ce};A.push(Re)}});const re={resource:q,cellResults:A};I.set(q,re);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...I.values()]}}async y(d,P){const u=await this.s.value.stat(d);if(typeof P?.mtime=="number"&&typeof P.etag=="string"&&P.etag!==N.$sl&&typeof u.mtime=="number"&&typeof u.size=="number"&&P.mtime<u.mtime&&P.etag!==N.$tl({mtime:P.mtime,size:u.size}))throw new N.$il((0,S.localize)(1,null),3,P)}z(d){return d.scheme===c.Schemas.file?d.fsPath:d.toString()}A(d,P,u){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const E=new t.$Zlc(P,this.d,d,u.visibleRanges.map(m.NotebookRange.to),u.selections.map(m.NotebookRange.to),typeof u.viewColumn=="number"?m.ViewColumn.to(u.viewColumn):void 0);this.h.set(P,E)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const u of d.value.removedDocuments){const E=k.URI.revive(u),f=this.g.get(E);f&&(f.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(f.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===E.toString()&&this.h.delete(D.id)}if(d.value.addedDocuments){const u=[];for(const E of d.value.addedDocuments){const f=k.URI.revive(E.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const D=new r.$Ylc(this.c,this.q,this.r,f,E);u.push(...E.cells.map(w=>r.$Xlc.asModelAddData(w))),this.g.get(f)?.dispose(),this.g.set(f,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this.m.fire(D.apiNotebook)}}if(d.value.addedEditors)for(const u of d.value.addedEditors){if(this.h.has(u.id))return;const E=k.URI.revive(u.documentUri),f=this.g.get(E);f&&this.A(f,u.id,u)}const P=[];if(d.value.removedEditors)for(const u of d.value.removedEditors){const E=this.h.get(u);E&&(this.h.delete(u),this.k?.id===E.id&&(this.k=void 0),P.push(E))}if(d.value.visibleEditors){this.l=d.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const u=new Set;this.l.forEach(E=>u.add(E.id));for(const E of this.h.values()){const f=u.has(E.id);E._acceptVisibility(f)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this.k=void 0:d.value.newActiveEditor&&(this.h.get(d.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${d.value.newActiveEditor}`),this.k=this.h.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(d){const P=b.$FP.String.with("notebookType","A notebook type"),u=new b.$HP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new b.$FP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>F.$De.wrap(f))],new b.$GP("Notebook Data",f=>m.NotebookData.to(f.value))),E=new b.$HP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new b.$FP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$qw(m.NotebookData.from(f)))],new b.$GP("Bytes",f=>f.buffer));d.registerApiCommand(u),d.registerApiCommand(E)}}e.$9lc=a}),define(Pe[290],Ae([1,0,19,24,43,36,23,65,46]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class k{constructor(l,b,m){this.k=l,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$nk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$nk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((m,s)=>{const o=r=>{this.f++,l(r)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const t=r.toString(),n=S.$oc(t);this.j&&this.j(t,n)||this.v(o,{base:r,basename:n})}),Promise.all(b.map(r=>this.p(r,o))).then(r=>{m({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,R.$ej)(r)))})})}async p(l,b){const m=new F.$ne,s=this.q(l),o=this.r(),r=new g.$pL(this.k,l),t=!r.hasSiblingExcludeClauses();let n;try{this.h.add(m),n=p.$$d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),h=n.elapsed(),i=p.$$d.create();return this.g&&!this.e||(c&&c.forEach($=>{const a=S.$hc.relative(l.folder.path,$.path);if(t){const v=S.$oc($.path);this.v(b,{base:l.folder,relativePath:a,basename:v});return}this.s(o,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(o,r,b),{providerTime:h,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(l){const b=(0,g.$oL)(this.k.includePattern,l.includePattern),m=(0,g.$oL)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:m,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,m,s){if(m===this.a){const r=S.$oc(this.a);this.v(s,{base:b,relativePath:this.a,basename:r})}function o(r){const t=S.$oc(r),n=S.$nc(r);let c=l[n];c||(c=l[n]=[],o(n)),c.push({base:b,relativePath:r,basename:t})}o(m)}u({rootEntries:l,pathToEntries:b},m,s){const o=this,r=this.a;function t(n){const c=(0,g.$rL)(()=>n.map(h=>h.basename));for(let h=0,i=n.length;h<i;h++){const $=n[h],{relativePath:a,basename:v}=$;if(m.matchesExcludesSync(a,v,r!==v?c:void 0))continue;const d=b[a];if(d)t(d);else{if(a===r)continue;o.v(s,$)}if(o.e)break}}t(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,m,s){const o=this.c(l.cacheKey),r=new k(l,b,o&&o.token);let t=0;const n=c=>{t+=c.length,m(c.map(h=>this.d(h)))};return this.e(r,N.a,n,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:t,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new F.$ne),this.b.get(l)}d(l){return l.relativePath?{resource:M.$7g(l.base,l.relativePath)}:{resource:l.base}}e(l,b,m,s){const o=s.onCancellationRequested(()=>{l.cancel()}),r=n=>{n&&(t.push(n),b>0&&t.length>=b&&(m(t),t=[]))};let t=[];return l.search(r).then(n=>(t.length&&m(t),o.dispose(),n),n=>(t.length&&m(t),o.dispose(),Promise.reject(n)))}}e.$1lc=N}),define(Pe[291],Ae([1,0,18,259,36,96,28,12,19,23,15,17,2,95,186,48,13,49,107,287,46]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=void 0,e.$zM=E;let h=class{constructor(D,w,C,I,W){this.a=D,this.b=w,this.c=C,this.d=I,this.e=W}text(D,w,C={}){D=this.f(D,C);const I=this.a.getValue(),W=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(r.$Oi),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,w){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const I={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,w)&&(I.isCaseSensitive=!0),this.k(D)&&(I.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),I}file(D,w={}){return{...this.h(D,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(D,w){return D?(D=Array.isArray(D)?D.map(d):d(D),w?this.parseSearchPaths(D):{pattern:$(...Array.isArray(D)?D:[D])}):{}}h(D=[],w={}){const C=this.g(w.includePattern,w.expandPatterns),I=this.g(w.excludePattern,w.expandPatterns),W=D.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,w,I)):D.map(j=>this.r(j,w,I,W))).filter(j=>!!j),q={_reason:w._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const j=S.$Hb(S.$Rb(this.c.groups.map(ae=>ae.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ae=>(0,c.$fL)(q,ae.fsPath)),re=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...q,...re}}const A=w.extraFileResources&&w.extraFileResources.filter(j=>(0,c.$fL)(q,j.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(D){const w=[],C=new M.$Bc,I={};let W=!1;return D.forEach(V=>{if(V.scheme===p.Schemas.walkThrough)return;if((0,k.$$g)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:g.$nc(V.fsPath)});let j=C.get(A);j||(W=!0,j={folder:A,includePattern:{}},w.push(j),C.set(A,j));const K=g.$mc(A.fsPath,V.fsPath);(0,y.$eg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,I[V.fsPath]=!0)}),{folderQueries:w,includePattern:I,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(D,w){if(w.isSmartCase){if(D.isRegExp){if(N.$Wf(D.pattern,!0))return!0}else if(N.$Wf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,b.$FC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const w=re=>g.$jc(re)||/^\.\.?([\/\\]|$)/.test(re),I=(Array.isArray(D)?D:a(D)).map(re=>{const ae=this.e.resolvedUserHome;return ae?(0,O.$vw)(re,ae.scheme===p.Schemas.file?ae.fsPath:ae.path):re}),W=F.$K(I,re=>w(re)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(re=>N.$df(re,"/")).map(re=>N.$df(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),v(re))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const j=S.$Rb(V),K=$(...j);return K&&(q.pattern=K),q}l(D,w){return w.disregardExcludeSettings?void 0:(0,c.$eL)(D,!w.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const w=D.flatMap(I=>{let{pathPortion:W,globPortion:V}=i(I);return V&&(V=P(V)),this.n(W).flatMap(A=>this.o(A,V))}),C=new Map;return w.forEach(I=>{const W=I.searchPath.toString(),V=C.get(W);V?I.pattern&&(V.pattern=V.pattern||{},V.pattern[I.pattern]=!0):C.set(W,{searchPath:I.searchPath,pattern:I.pattern?$(I.pattern):void 0})}),Array.from(C.values())}n(D){if(g.$jc(D)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==p.Schemas.file?[{searchPath:w[0].uri.with({path:D})}]:[{searchPath:l.URI.file(g.$ic(D))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(D=d(D),D.startsWith("../")||D===".."){const I=g.$hc.resolve(w.path,D);return[{searchPath:w.with({path:I})}]}const C=P(D);return[{searchPath:w,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const w=D.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(W=>{const V=w.match(new RegExp(`^${N.$0e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(y.$bg);if(I.length)return I.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&P(V)}});{const W=D.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:D,q=m.localize(0,null,V);throw new Error(q)}}}}o(D,w){const C=D.pattern&&w?`${D.pattern}/${w}`:D.pattern||w,I=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:D.searchPath,pattern:C+"/**"}),I}q(D,w,C){const I=this.r((0,r.$Oi)(D.searchPath),w,C,!1);return I?{...I,includePattern:D.pattern}:null}r(D,w,C,I){let W;const V=l.URI.isUri(D)?D:D.uri;if(C.searchPaths){const re=C.searchPaths.filter(ae=>(0,k.$Zg)(ae.searchPath,V))[0];if(re&&!re.pattern)return null;re&&(W=re.pattern)}const q=this.a.getValue({resource:V}),j={...this.l(q,w)||{},...W||{}},K=l.URI.isUri(D)?(0,k.$4g)(D):D.name;return{folder:V,folderName:I?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};e.$yM=h,e.$yM=h=Je([We(0,s.$Zi),We(1,r.$Ci),We(2,t.$MD),We(3,o.$Zj),We(4,n.$wM)],h);function i(f){const D=f.match(/[\*\{\}\(\)\[\]\?]/);if(D){const w=D.index,C=f.substr(0,w).match(/[/|\\][^/\\]*$/);if(C){let I=f.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:f.substr((C.index||0)+1)}}}return{pathPortion:f}}function $(...f){return f.length?f.reduce((D,w)=>(D[w]=!0,D),Object.create(null)):void 0}function a(f){return R.$lk(f,",").map(D=>D.trim()).filter(D=>!!D.length)}function v(f){return[`**/${f}/**`,`**/${f}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function d(f){return f.replace(/\\/g,"/")}function P(f){return d(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(f){return f.replace(/([?*[\]])/g,"[$1]")}function E(f,D){f=S.$Mb(f,I=>I.toString());const w=[],C=D.getWorkspace();return f&&f.forEach(I=>{let W;if(D.getWorkbenchState()===2)W=(0,k.$9g)(C.folders[0].uri,I),W&&W!=="."&&(W="./"+W);else{const V=D.getWorkspaceFolder(I);if(V){const q=V.name;if(C.folders.filter(j=>j.name===q).length===1){const j=(0,k.$9g)(V.uri,I);j===""?W=`./${V.name}`:W=`./${V.name}/${j}`}else W=I.fsPath}}W&&w.push(u(W))}),w}}),define(Pe[292],Ae([1,0,23,2,24,14,3,291,46,49,11]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Utb=l,e.$Vtb=s;const y=7e3;function l(o,r){const t=r.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],c=[];for(const d of t)if(/^workspaceContains:/.test(d)){const P=d.substr(18);P.indexOf("*")>=0||P.indexOf("?")>=0||o.forceUsingSearch?c.push(P):n.push(P)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:i}=(0,N.$mh)(),$=d=>i({activationEvent:d}),a=Promise.all(n.map(d=>b(o,d,$))).then(()=>{}),v=m(o,r.identifier,c,$);return Promise.all([a,v]).then(()=>{i(void 0)}),h}async function b(o,r,t){for(const n of o.folders)if(await o.exists(S.$7g(F.URI.revive(n),r))){t(`workspaceContains:${r}`);return}}async function m(o,r,t,n){if(t.length===0)return Promise.resolve(void 0);const c=new R.$ne,h=o.checkExists(o.folders,t,c.token),i=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},y);let $=!1;try{$=await h}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(i),$&&n(`workspaceContains:${t.join(",")}`)}function s(o,r,t,n){const c=o.get(M.$si),h=o.get(g.$9K),$=c.createInstance(p.$yM).file(r.map(a=>(0,k.$Oi)(F.URI.revive(a))),{_reason:"checkExists",includePattern:t,exists:!0});return h.fileSearch($,n).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Pe[39],Ae([1,0,164,19,89,23,11,6,52,2,13,4,38,226,82,37,26,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$,a,v,d,P,u,E,f,D,w,C,I,W,V,q,A,j,K){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=e.$Elc=e.$Dlc=e.$Clc=void 0,e.$Clc=(0,a.$ti)("IHostUtils");let ae=re=class extends p.$Vc{constructor(L,x,ve,Te,ke,pe,fe,Q,X,le,ue,Ne,he){super(),this.Y=Ne,this.Z=he,this.a=this.B(new w.$ce),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=fe,this.j=Te,this.m=ke,this.s=pe,this.t=X,this.u=le,this.w=ue,this.y=this.g.getProxy(y.$UM.MainThreadWorkspace),this.z=this.g.getProxy(y.$UM.MainThreadTelemetry),this.C=this.g.getProxy(y.$UM.MainThreadExtensionService),this.D=new M.$sh,this.F=new M.$sh,this.G=new M.$sh,this.H=new M.$sh,this.I=new Re(this.f.extensions.activationEvents),this.L=new r.$e_b(this.I,this.f.extensions.allExtensions);const Ce=new n.$Pm(this.f.extensions.myExtensions);this.J=new r.$e_b(this.I,Me(this.L,Ce)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${de(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${de(this.J)}`)),this.M=new m.$llc(this.g,this.s),this.N=new I.$vlc(this.g),this.O=Q,this.h=L.createChild(new u.$ri([m.$mlc,this.M],[I.$wlc,this.N])),this.P=this.B(new b.$klc(this.J,this.L,{onExtensionActivationError:(Fe,ze,U)=>{this.C.$onExtensionActivationError(Fe,t.$3(ze),U)},actualActivateExtension:async(Fe,ze)=>{if(r.$e_b.isHostExtension(Fe,this.J,this.L))return await this.C.$activateExtension(Fe,ze),new b.$jlc;const U=this.J.getExtensionDescription(Fe);return this.fb(U,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){t.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(L)}terminate(L,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),t.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const ve=this.$();Promise.race([(0,M.$uh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const x=await this.C.$getExtension(L);return x&&{...x,identifier:new n.$Om(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation)}}ab(L,x){return this.P.activateByEvent(L,x)}bb(L,x){return this.P.activateById(L,x)}activateByIdWithErrors(L,x){return this.bb(L,x).then(()=>{const ve=this.P.getActivatedExtension(L);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const x=L.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return k.URI.file(ve)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new ce(L))),this.Q}async db(L){const x=g.$zi.forUris(ve=>O.$Xg.ignorePathCasing(ve));return await Promise.all(L.map(async ve=>{if(this.wb(ve)){const Te=await this.cb(ve.extensionLocation);x.set(Te,ve)}})),x}eb(L){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return x;const ve=this.P.getActivatedExtension(L);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Te)}try{(0,p.$Qc)(ve.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Te)}return x}async fb(L,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,x).then(ve=>{const Te=ve.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,x),this.gb(L,x,"success",Te),ve},ve=>{throw this.gb(L,x,"failure"),ve})}gb(L,x,ve,Te){const ke=Ie(L,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Te||{},outcome:ve})}hb(L,x){const ve=Ie(L,x);this.z.$publicLog2("activatePlugin",ve);const Te=this.wb(L);if(!Te)return Promise.resolve(new b.$ilc(b.$flc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${L.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new b.$glc(x.startup);return Promise.all([this.xb(L,(0,O.$7g)(L.extensionLocation,Te),ke),this.ib(L)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),re.jb(this.s,L.identifier,pe[0],pe[1],ke))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const x=this.Z.createLanguageModelAccessInformation(L),ve=new h.$olc(L,this.M),Te=new h.$nlc(L.identifier.value,!1,this.M),ke=new W.$xlc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([ve.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const Q=this;let X,le;const ue=(0,o.$BG)(L,"ipc")?this.f.messagePorts?.get(n.$Om.toKey(L.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Te,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ne){return F.$kc(L.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return Q.O.globalValue(L).fsPath},get logPath(){return F.$kc(Q.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(Q.f.logsLocation,L.identifier.value)},get storageUri(){return Q.O.workspaceValue(L)},get globalStorageUri(){return Q.O.globalValue(L)},get extensionMode(){return pe},get extension(){return X===void 0&&(X=new me(Q,L.identifier,L,fe,!1)),X},get extensionRuntime(){return(0,o.$CG)(L,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!le){if(!ue)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(ue,"message",he=>he.data));ue.start(),le={onDidReceiveMessage:Ne,postMessage:ue.postMessage.bind(ue)}}return le}})})}static jb(L,x,ve,Te,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(L,x,ve,Te,ke).then(pe=>new b.$hlc(!1,null,ke.build(),ve,pe,Te.subscriptions))}static kb(L,x,ve,Te,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,fe=ve.activate.apply(pe,[Te]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(fe).then(Q=>(ke.activateResolveStop(),Q))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(ve)}lb(L,x){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(L,x=0){const Te=Date.now();(0,j.$B)(()=>{for(let ke=x;ke<L.length;ke+=1){const pe=L[ke];for(const fe of pe.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Te>50){this.mb(L,ke);break}else this.lb(pe,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(L=>{const x=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Te of ve)if(Te.activationEvents)for(const ke of Te.activationEvents)ke==="onStartupFinished"&&this.lb(Te,ke)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Te=this.rb(),ke=Promise.all([Te,L,ve]).then(()=>{});return Promise.race([ke,(0,M.$uh)(1e4)]).then(()=>{this.nb()}),ke}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(L,x))).then(()=>{})}async qb(L,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:ve||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,fe,Q)=>this.y.$checkExists(pe,fe,Q)},ke=await(0,C.$Utb)(Te,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:x}=this.f.environment;if(!L||!x)throw new Error(S.localize(0,null));const ve=await this.xb(null,x,new b.$glc(!1));if(!ve||typeof ve.run!="function")throw new Error(S.localize(1,null,x.toString()));return new Promise((Te,ke)=>{const pe=(X,le)=>{X?(j.$t&&this.s.error("Test runner called back with error",X),ke(X)):(j.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof le=="number"&&le>0?1:0))},fe=(0,O.$Ug)(x),Q=ve.run(fe,pe);Q&&Q.then&&Q.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(X=>{j.$t&&this.s.error("Test runner finished with error",X),ke(X instanceof Error&&X.stack?X.stack:String(X))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$uh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,x){return this.S[L]=x,(0,p.$Tc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:x}=await this.ub(L);return x?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const x=L.indexOf("+");if(x===-1)throw new i.$3M("Not an authority that can be resolved!",$.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=L.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(L,x){const ve=A.$$d.create(!1),Te=()=>`[resolveAuthority(${(0,$.$Il)(L)},${x})][${ve.elapsed()}ms] `,ke=z=>this.s.info(`${Te()}${z}`),pe=z=>this.s.warn(`${Te()}${z}`),fe=(z,H=void 0)=>this.s.error(`${Te()}${z}`,H),Q=z=>{if(z instanceof i.$3M)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},X=async z=>{ke(`activating resolver for ${z}...`);const{resolver:H,authorityPrefix:G}=await this.ub(z);if(!H)throw fe(`no resolver for ${G}`),new i.$3M(`No remote extension installed to resolve ${G}.`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:z}},le=L.split(/@|%40/g).reverse();ke(`activating remote resolvers ${le.join(" -> ")}`);let ue;try{ue=await Promise.all(le.map(X)).catch(async z=>{if(!(z instanceof i.$3M)||z._code!==$.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return pe(`resolving nested authorities failed: ${z.message}`),[await X(L)]})}catch(z){return Q(z)}const Ne=new M.$Eh;Ne.cancelAndSet(()=>ke("waiting..."),1e3);let he,Ce;for(const[z,{authorityPrefix:H,resolver:G,remoteAuthority:ee}]of ue.entries())try{if(z===ue.length-1)ke("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${H}`),he=await G.resolve(ee,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${H}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,i.$2M.isManagedResolvedAuthority(he)?he:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${H}`),Ce=await G.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new i.$3M(`Exec server was not available for ${ee}`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ne){return R.mark(`code/extHost/didResolveAuthorityError/${H}`),fe("returned an error",ne),Ne.dispose(),Q(ne)}Ne.dispose();const Fe={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${i.$2M.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let U;if(i.$2M.isManagedResolvedAuthority(he)){const z=x;this.Y.setFactory(z,he.makeConnection),U={authority:L,connectTo:new $.$Fl(z),connectionToken:he.connectionToken}}else U={authority:L,connectTo:new $.$Gl(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Fe}}}async $getCanonicalURI(L,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,$.$Il)(L)})`);const{resolver:ve}=await this.ub(L);if(!ve)return null;const Te=k.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Te;const ke=await(0,M.$lh)(()=>ve.getCanonicalURI(Te));return ke||Te}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=be(this.I,this.L,this.J,L),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${de(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${de(this.J)}`)),this.tb()}$activateByEvent(L,x){return x===1?this.D.wait().then(ve=>this.ab(L,!1)):this.G.wait().then(ve=>this.ab(L,!1))}async $activate(L,x){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,x),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=be(this.I,this.L,this.J,L),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${de(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${de(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const x=c.$De.alloc(L),ve=Math.random()%256;for(let Te=0;Te<L;Te++)x.writeUInt8(ve,Te);return x}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$Dlc=ae,e.$Dlc=ae=re=Je([We(0,a.$si),We(1,e.$Clc),We(2,P.$hP),We(3,s.$1kc),We(4,l.$4kc),We(5,N.$Zj),We(6,v.$xP),We(7,d.$7kc),We(8,E.$ZCb),We(9,f.$plc),We(10,q.$zlc),We(11,K.$Alc),We(12,D.$tlc)],ae);function be(ie,L,x,ve){ie.addActivationEvents(ve.addActivationEvents);const Te=new r.$e_b(ie,L.getAllExtensionDescriptions());Te.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new n.$Pm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of ve.myToRemove)ke.delete(fe);for(const fe of ve.myToAdd)ke.add(fe);const pe=Me(Te,ke);return{globalRegistry:Te,myExtensions:pe}}function Ie(ie,L){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function de(ie){return ie.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$Elc=(0,a.$ti)("IExtHostExtensionService");class me{#e;#t;#i;constructor(L,x,ve,Te,ke){this.#e=L,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=F.$ic((0,O.$Ug)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Te,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Flc=me;function Me(ie,L){return ie.getAllExtensionDescriptions().filter(x=>L.has(x.identifier))}class ce{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$Glc=ce;class Re{constructor(L){this.a=new n.$Qm,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const x of Object.keys(L))this.a.set(x,L[x])}}}),define(Pe[293],Ae([1,0,89,2,4,38,26,20,16,27,3,39,13,15]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;let s=class{constructor(c,h,i,$,a,v,d){this.c=c,this.d=h,this.e=i,this.f=$,this.g=a,this.h=v,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(t,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Pmc=s,e.$Pmc=s=Je([We(2,N.$si),We(3,O.$4kc),We(4,y.$Elc),We(5,k.$xP),We(6,l.$Zj)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const h=(0,b.$0e)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",$=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${$})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,$,a]=h,v=m.a.get($);if(v!==void 0)return console.warn(`${$} as been renamed to ${v}, please update your imports`),i+v+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([We(0,k.$xP)],o);class r{constructor(c,h,i,$,a){this.c=c,this.d=h,this.e=i,this.f=$,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Qm}load(c,h){const i=this.d.findSubstr(h);if(i){let $=this.a.get(i.identifier);return $||($=this.c(i,this.e,this.f),this.a.set(i.identifier,$)),$}if(!this.b){let $="";this.d.forEach((a,v)=>$+=`	${v} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${$}`),this.b=this.c(M.$wG,this.e,this.f)}return this.b}}let t=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(R.$UM.MainThreadTelemetry);const $=i.getProxy(R.$UM.MainThreadWindow);this.c=(a,v)=>{const d=F.URI.parse(a);return v?this.g(a,v):d.scheme==="http"||d.scheme==="https"?$.$openUri(d,a,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?$.$openUri(d,a,{}):this.g(a,v)}}load(c,h,i){const $=this.e.findSubstr(h);return $&&(this.a=$.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};t=Je([We(2,g.$hP)],t)}),define(Pe[120],Ae([1,0,41,6,19,73,3,67,66,39,7,37,223,38]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=void 0,e.$Hlc=(0,M.$ti)("IExtHostVariableResolverProvider");class m extends l.$jQ{constructor(r,t,n,c,h,i,$){function a(){if(n){const v=n.activeEditor();if(v)return v.document.uri;const d=c.tabGroups.all.find(P=>P.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof N.$HO||d.input instanceof N.$MO)return d.input.modified;if(d.input instanceof N.$GO||d.input instanceof N.$LO||d.input instanceof N.$JO)return d.input.uri}}}super({getFolderUri:v=>{const d=i.folders.filter(P=>P.name===v);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(v,d)=>h.getConfiguration(void 0,v).get(d),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const v=a();if(v)return R.$ic(v.fsPath)},getWorkspaceFolderPathForFile:()=>{if(t){const v=a();if(v){const d=t.getWorkspaceFolder(v);if(d)return R.$ic(d.uri.fsPath)}}},getSelectedText:()=>{if(n){const v=n.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(n){const v=n.activeEditor();if(v)return String(v.selection.end.line+1)}},getExtension:v=>r.getExtension(v)},void 0,$?Promise.resolve($):void 0,Promise.resolve(O.env))}}let s=class extends F.$Vc{constructor(r,t,n,c,h){super(),this.b=r,this.c=t,this.g=n,this.h=c,this.j=h,this.a=new S.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async v=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ilc=s,e.$Ilc=s=Je([We(0,k.$Elc),We(1,y.$1kc),We(2,p.$sP),We(3,b.$4kc),We(4,g.$dlc)],s)}),define(Pe[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,215,217,38,120,6,42,32,8]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=e.$Llc=e.$Klc=e.$Jlc=void 0,e.$Jlc=(0,M.$ti)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(u,E,f,D,w,C,I){this.N=E,this.O=f,this.P=D,this.Q=w,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$ce,this.o=new F.$ce,this.q=new F.$ce,this.w=new F.$ce,this.l=u.getProxy(p.$UM.MainThreadDebugService),this.A=new F.$ce,this.C=new F.$ce,this.y=new $(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(u,E){const f=this.W(E);if(!f)return;const D=await this.H.get(u)?.getTreeItem?.(f);return D?this.U(u,D):void 0}registerDebugVisualizationTree(u,E,f){const D=O.$Om.toKey(u.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(w,f),this.l.$registerDebugVisualizerTree(w,!!f.editItem),(0,r.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(E)})}async $getVisualizerTreeItemChildren(u,E){const f=this.J.get(E)?.item;return f?(await this.H.get(u)?.getChildren?.(f))?.map(w=>this.U(u,w))||[]:[]}async $editVisualizerTreeItem(u,E){const f=this.J.get(u);if(!f)return;const D=await this.H.get(f.provider)?.editItem?.(f.item,E);return this.U(f.provider,D||f.item)}$disposeVisualizedTree(u){const E=this.J.get(u);if(!E)return;const f=[E.children];for(const D of f)if(D)for(const w of D)f.push(this.J.get(w)?.children),this.J.delete(w)}U(u,E){let f=this.I.get(E);return f||(f=this.F++,this.I.set(E,f),this.J.set(f,{provider:u,item:E})),c.DebugTreeItem.from(E,f)}asDebugSourceUri(u,E){const f=u;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let D=`debug:${encodeURIComponent(f.path||"")}`,w="?";return E&&(D+=`${w}session=${encodeURIComponent(E.id)}`,w="&"),D+=`${w}ref=${f.sourceReference}`,R.URI.parse(D)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(u){const E=[];for(const f of u.getAllExtensionDescriptions())if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0)for(const w of D)(0,m.$eH)(w)&&E.push(w.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const u=[];return this.z.forEach(E=>u.push(E)),u}async $resolveDebugVisualizer(u,E){const f=this.L.get(u);if(!f)throw new Error(`No debug visualizer found with id '${u}'`);let{v:D,provider:w,extensionId:C}=f;if(D.visualization||(D=await w.resolveDebugVisualization?.(D,E)||D,f.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(C,D.visualization)}async $executeDebugVisualizerCommand(u){const E=this.L.get(u);if(!E)throw new Error(`No debug visualizer found with id '${u}'`);const f=E.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(u){const E=this.m.get(u.sessionId);return E&&{session:E.api,variable:u.variable,containerId:u.containerId,frameId:u.frameId,threadId:u.threadId}}async $provideDebugVisualizers(u,E,f,D){const w=this.W(f),C=this.jb(u,E),I=this.G.get(C);if(!w||!I)return[];const W=await I.provideDebugVisualization(w,D);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:I,extensionId:u});const A=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(u,V.visualization)}}):[]}$disposeDebugVisualizers(u){for(const E of u)this.L.delete(E)}registerDebugVisualizationProvider(u,E,f){if(!u.contributes?.debugVisualizers?.some(C=>C.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const D=O.$Om.toKey(u.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(w,f),this.l.$registerDebugVisualizer(D,E),(0,r.$Tc)(()=>{this.l.$unregisterDebugVisualizer(D,E),this.G.delete(E)})}addBreakpoints(u){const E=u.filter(w=>{const C=w.id;return this.z.has(C)?!1:(this.z.set(C,w),!0)});this.gb(E,[],[]);const f=[],D=new Map;for(const w of E)if(w instanceof y.$XN){let C=D.get(w.location.uri.toString());C||(C={type:"sourceMulti",uri:w.location.uri,lines:[]},D.set(w.location.uri.toString(),C),f.push(C)),C.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof y.$YN&&f.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(u){const E=u.filter(C=>this.z.delete(C.id));this.gb([],E,[]);const f=E.filter(C=>C instanceof y.$XN).map(C=>C.id),D=E.filter(C=>C instanceof y.$YN).map(C=>C.id),w=E.filter(C=>C instanceof y.$ZN).map(C=>C.id);return this.l.$unregisterBreakpoints(f,D,w)}startDebugging(u,E,f){return this.l.$startDebugging(u?u.uri:void 0,E,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(u){return this.l.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,E,f){if(!E)return new y.$WM(()=>{});const D=this.d++;return this.f.push({type:u,handle:D,provider:E}),this.l.$registerDebugConfigurationProvider(u,f,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,D),new y.$WM(()=>{this.f=this.f.filter(w=>w.provider!==E),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(u,E,f){if(!f)return new y.$WM(()=>{});if(!this.cb(u,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:E,handle:D,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(E,D),new y.$WM(()=>{this.h=this.h.filter(w=>w.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(u,E){if(!E)return new y.$WM(()=>{});const f=this.j++;return this.k.push({type:u,handle:f,factory:E}),new y.$WM(()=>{this.k=this.k.filter(D=>D.factory!==E)})}async $runInTerminal(u,E){return Promise.resolve(void 0)}async $substituteVariables(u,E){let f;const D=await this.ib(u);return D&&(f={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,E)}X(u,E){if(u.type==="implementation")return new v(u.implementation)}Y(){}async $startDASession(u,E){const f=this,D=await this.hb(E);return this.eb(this.$(D.type),D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const C=this.Z(w),I=this.X(C,D);if(!I)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const W=I;return this.D.set(u,W),this.db(D).then(V=>(V&&this.E.set(u,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,j={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);j.body={signature:K},W.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,W.sendResponse(j)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,m.$jH)(q,!0),f.l.$acceptDAMessage(u,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(u,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(u,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(u,E){E=(0,m.$iH)(E,!1);const f=this.E.get(u);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(E),this.D.get(u)?.sendMessage(E)}$stopDASession(u){const E=this.E.get(u);this.E.delete(u),E&&E.onWillStopSession&&E.onWillStopSession();const f=this.D.get(u);return this.D.delete(u),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const E=[],f=[],D=[];if(u.added)for(const w of u.added){const C=w.id;if(C&&!this.z.has(C)){let I;if(w.type==="function")I=new y.$YN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")I=new y.$ZN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const W=R.URI.revive(w.uri);I=new y.$XN(new y.$9M(W,new y.$XM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,y.$VN)(I,C),this.z.set(C,I),E.push(I)}}if(u.removed)for(const w of u.removed){const C=this.z.get(w);C&&(this.z.delete(w),f.push(C))}if(u.changed){for(const w of u.changed)if(w.id){const C=this.z.get(w.id);if(C){if(C instanceof y.$YN&&w.type==="function"){const I=C;I.enabled=w.enabled,I.condition=w.condition,I.hitCondition=w.hitCondition,I.logMessage=w.logMessage,I.functionName=w.functionName}else if(C instanceof y.$XN&&w.type==="source"){const I=C;I.enabled=w.enabled,I.condition=w.condition,I.hitCondition=w.hitCondition,I.logMessage=w.logMessage,I.location=new y.$9M(R.URI.revive(w.uri),new y.$XM(w.line,w.character))}D.push(C)}}}this.gb(E,f,D)}async $acceptStackFrameFocus(u){let E;if(u){const f=await this.hb(u.sessionId);u.kind==="thread"?E=new y.$6N(f.api,u.threadId):E=new y.$5N(f.api,u.threadId,u.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(u,E,f){return(0,S.$lh)(async()=>{const D=this.bb(u);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(E);return D.provideDebugConfigurations(w,f)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(u,E,f,D){return(0,S.$lh)(async()=>{const w=this.bb(u);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(E);return w.resolveDebugConfiguration(C,f,D)})}$resolveDebugConfigurationWithSubstitutedVariables(u,E,f,D){return(0,S.$lh)(async()=>{const w=this.bb(u);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(E);return w.resolveDebugConfigurationWithSubstitutedVariables(C,f,D)})}async $provideDebugAdapter(u,E){const f=this.ab(u);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(E);return this.eb(f,D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted(u){const E=await this.hb(u);this.n.fire(E.api)}async $acceptDebugSessionTerminated(u){const E=await this.hb(u);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(u){this.u=u?await this.hb(u):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(u,E){(await this.hb(u))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(u,E){const D={session:(await this.hb(u)).api,event:E.event,body:E.body};this.w.fire(D)}Z(u){if(u instanceof y.$1N)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof y.$2N)return{type:"server",port:u.port,host:u.host};if(u instanceof y.$3N)return{type:"pipeServer",path:u.path};if(u instanceof y.$4N)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}$(u){const E=this.h.filter(f=>f.type===u);if(E.length>0)return E[0].factory}ab(u){const E=this.h.filter(f=>f.handle===u);if(E.length>0)return E[0].factory}bb(u){const E=this.f.filter(f=>f.handle===u);if(E.length>0)return E[0].provider}cb(u,E){if(u.contributes){const f=u.contributes.debuggers;if(f&&f.length>0){for(const D of f)if(D.label&&D.type&&D.type===E)return!0}}return!1}db(u){const f=u.configuration.type,D=this.k.filter(w=>w.type===f||w.type==="*").map(w=>(0,S.$lh)(()=>w.factory.createDebugAdapterTracker(u.api)).then(C=>C,C=>null));return Promise.race([Promise.all(D).then(w=>{const C=w.filter(I=>!!I);if(C.length>0)return new a(C)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb(u,E){const f=E.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.$2N(f));if(u){const w=await this.O.getExtensionRegistry();return(0,S.$lh)(()=>u.createDebugAdapterDescriptor(E.api,this.fb(E,w))).then(C=>{if(C)return C})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,D))}fb(u,E){}gb(u,E,f){(u.length>0||E.length>0||f.length>0)&&this.A.fire(Object.freeze({added:u,removed:E,changed:f}))}async hb(u){if(u)if(typeof u=="string"){const E=this.m.get(u);if(E)return E}else{let E=this.m.get(u.id);if(!E){const f=await this.ib(u.folderUri),D=u.parent?this.m.get(u.parent):void 0;E=new i(this.l,u.id,u.type,u.name,f,u.configuration,D?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(u){if(u){const E=R.URI.revive(u);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(u,E){return`${u}\0${E}`}kb(u,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${u}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(u){const E=this.mb(u);let f,D;return"id"in E?D=t.ThemeIcon.asClassName(E):f=E,{iconPath:f,iconClass:D}}mb(u){if(u instanceof y.$SN)return{id:u.id};const E=typeof u=="object"&&"dark"in u?u.dark:u,f=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof f=="string"?R.URI.file(f):f}}};e.$Klc=h,e.$Klc=h=Je([We(0,N.$hP),We(1,l.$1kc),We(2,k.$Elc),We(3,s.$4kc),We(4,g.$dlc),We(5,o.$Hlc),We(6,n.$DP)],h);class i{constructor(u,E,f,D,w,C,I){this.f=u,this.g=E,this.h=f,this.j=D,this.k=w,this.l=C,this.m=I}get api(){const u=this;return this.d??=Object.freeze({id:u.g,type:u.h,get name(){return u.j},set name(E){u.j=E,u.f.$setDebugSessionName(u.g,E)},parentSession:u.m,workspaceFolder:u.k,configuration:u.l,customRequest(E,f){return u.f.$customDebugAdapterRequest(u.g,E,f)},getDebugProtocolBreakpoint(E){return u.f.$getDebugProtocolBreakpoint(u.g,E.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(u){this.j=u}get configuration(){return this.l}}e.$Llc=i;class ${constructor(u){this.value=Object.freeze({append(E){u.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$Mlc=$;class a{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(E=>E.onError?E.onError(u):void 0)}onExit(u,E){this.d.forEach(f=>f.onExit?f.onExit(u,E):void 0)}}class v extends b.$1ob{constructor(u){super(),this.h=u,u.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends h{constructor(u,E,f,D,w,C,I){super(u,E,f,D,w,C,I)}};e.$Nlc=d,e.$Nlc=d=Je([We(0,N.$hP),We(1,l.$1kc),We(2,k.$Elc),We(3,s.$4kc),We(4,g.$dlc),We(5,o.$Hlc),We(6,n.$DP)],d)}),define(Pe[294],Ae([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(p.$Zj),i=n.get(l.$hP).getProxy(O.$UM.MainThreadErrors);S.setUnexpectedErrorHandler($=>{c.error($);const a=S.$3($);i.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(p.$Zj),h=n.get(l.$hP),i=n.get(m.$Elc),$=n.get(s.$BP),a=h.getProxy(O.$UM.MainThreadExtensionService),v=h.getProxy(O.$UM.MainThreadErrors),d=await i.getExtensionPathIndex(),P=new WeakMap;function u(D,w){if(P.has(D))return P.get(D).stack;let C="",I,W;for(const q of w)C+=`
	at ${q.toString()}`,W=q.getFileName(),!I&&W&&(I=d.findSubstr(R.URI.file(W)));const V=`${D.name||"Error"}: ${D.message||""}${C}`;return P.set(D,{extensionIdentifier:I?.identifier,stack:V}),V}const E=Symbol("prepareStackTrace wrapped");let f=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(D){if(D===u||!D||D[E]){f=D||u;return}f=function(w,C){return u(w,C),D.call(Error,w,C)},Object.assign(f,{[E]:!0})}}),S.setUnexpectedErrorHandler(D=>{c.error(D);const w=S.$3(D),C=P.get(D);if(!C?.extensionIdentifier){v.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(C.extensionIdentifier,w);const I=$.onExtensionError(C.extensionIdentifier,D);c.trace("forwarded error to extension?",I,C)})}}e.$Qmc=o;class r{constructor(n,c,h,i,$){this.a=h,this.b=new M.$m_b(n,null,i),c=r.e(c,this.b);const a=new k.$ri(...(0,g.$us)());a.set(N.$xP,{_serviceBrand:void 0,...c,messagePorts:$}),a.set(l.$hP,new l.$iP(this.b)),a.set(b.$Xkc,new b.$Ykc(i)),a.set(m.$Clc,h);const v=new y.$_q(a,!0);v.invokeFunction(o.installEarlyHandler),this.d=v.invokeFunction(d=>d.get(p.$Zj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=v.invokeFunction(d=>d.get(m.$Elc)),this.c.initialize(),v.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(O.$UM.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=R.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=R.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(i=>R.URI.revive(c.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=R.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$Rmc=r}),define(Pe[295],Ae([1,0,18,11,24,43,12,19,23,2,46]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$3lc=e.$2lc=void 0,e.$4lc=s;class y{constructor(t,n,c){this.d=t,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(t,n){const c=this.g.folderQueries||[],h=new R.$ne(n);return new Promise((i,$)=>{this.a=new b(t);let a=!1;const v=(d,P)=>{if(!a&&!this.b){const u=this.h(d);s(d)&&typeof this.g.maxResults=="number"&&this.c+u>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),d=this.j(d,this.g.maxResults-this.c));const E=this.h(d);this.c+=E,(E>0||!s(d))&&this.a.add(d,P)}};Promise.all(c.map((d,P)=>this.k(d,u=>v(u,P),h.token))).then(d=>{h.dispose(),this.a.flush();const P=d.some(u=>!!u&&!!u.limitHit);i({limitHit:this.b||P,messages:(0,S.$Rb)(d.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.f}})},d=>{h.dispose();const P=(0,O.$ej)(d);$(new Error(P))})})}h(t){return s(t)?Array.isArray(t.ranges)?t.ranges.length:1:0}j(t,n){const c=Array.isArray(t.ranges)?t.ranges:[t.ranges],h=Array.isArray(t.preview.matches)?t.preview.matches:[t.preview.matches];return{ranges:c.slice(0,n),preview:{matches:h.slice(0,n),text:t.preview.text},uri:t.uri}}async k(t,n,c){const h=new N.$pL(this.g,t),i=[],$={report:d=>{if(!this.l(d))return;const P=t.folder.scheme===M.Schemas.file?(0,N.$qL)(()=>this.e.readdir(g.$6g(d.uri))):void 0,u=g.$9g(t.folder,d.uri);if(u){const E=h.includedInQuery(u,p.$oc(u),P);(0,F.$fh)(E)?i.push(E.then(f=>{f&&n(d)})):E&&n(d)}}},a=this.n(t);let v;return this.d.query.type===3?v=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,$,c):v=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,$,c),i.length&&await Promise.all(i),v}l(t){if(s(t)){if(Array.isArray(t.ranges)){if(!Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(t.preview.matches.length!==t.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(t){const n=(0,N.$oL)(this.g.includePattern,t.includePattern),c=(0,N.$oL)(this.g.excludePattern,t.excludePattern),h={folder:k.URI.from(t.folder),excludes:c,includes:n,useIgnoreFiles:!t.disregardIgnoreFiles,useGlobalIgnoreFiles:!t.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!t.disregardParentIgnoreFiles,followSymlinks:!t.ignoreSymlinks,encoding:t.fileEncoding&&this.e.toCanonicalName(t.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$2lc=y;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class b{constructor(t){this.e=t,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(t,n){this.d&&(this.b!==n||!g.$Zg(this.c,t.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:t.uri,results:[]}),this.d.results.push(m(t))}f(){const t=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,t)}flush(){this.f(),this.a.flush()}g(t){this.e(t)}}e.$3lc=b;function m(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class o{static{this.a=4e3}static{this.b=50}constructor(t,n){this.g=t,this.h=n,this.c=0,this.d=[],this.e=0}addItem(t,n){t&&this.j(t,n)}addItems(t,n){t&&this.k(t,n)}j(t,n){this.d.push(t),this.e+=n,this.l()}k(t,n){this.d=this.d.concat(t),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$5lc=o}),define(Pe[122],Ae([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0,e.$8lc=l,e.$6lc=(0,R.$ti)("IExtHostSearch");let y=class{constructor(s,o,r){this.n=s,this.o=o,this.q=r,this.c=this.n.getProxy(F.$UM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$1lc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,o),this.c.$registerTextSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,o),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,o),this.c.$registerFileSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,o,r,t){const n=l(r),c=this.j.get(s);if(c)return this.l.fileSearch(n,c,h=>{this.c.$handleFileMatch(s,o,h.map(i=>i.resource))},t);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,r,t){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(r);return this.t(c,n).search(i=>this.c.$handleTextMatch(s,o,i),t)}$provideAITextSearchResults(s,o,r,t){const n=this.h.get(s);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(r);return this.v(c,n).search(i=>this.c.$handleTextMatch(s,o,i),t)}$enableExtensionHostSearch(){}t(s,o){return new N.$2lc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,o){return new N.$2lc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$7lc=y,e.$7lc=y=Je([We(0,M.$hP),We(1,p.$Xkc),We(2,g.$Zj)],y);function l(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>k.URI.revive(s))}}function b(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Pe[296],Ae([1,0,24,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,204,4,246,274,78,84,251,252,253,232,221,32,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,45,27,275,276,235,262,88,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,114,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,216,77,26,118]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$,a,v,d,P,u,E,f,D,w,C,I,W,V,q,A,j,K,re,ae,be,Ie,de,me,Me,ce,Re,ie,L,x,ve,Te,ke,pe,fe,Q,X,le,ue,Ne,he,Ce,Fe,ze,U,z,H,G,ee,ne,Oe,Be,Qe,_e,et,tt,it,nt,at,mt,je,st,Y,Z,$e,Ge,ye,ot,dt,It,Qt,Ut,xt,_t,Ct,Wt,Zt,Ye,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=Yt;function Yt(lt){const bt=lt.get(ce.$xP),ti=lt.get(Me.$Ikc),Xt=lt.get(de.$6kc),Lt=lt.get(be.$Elc),ft=lt.get(Ct.$1kc),jt=lt.get(it.$BP),Bt=lt.get(D.$4kc),qt=lt.get(dt.$Xkc),He=lt.get(H.$hP),ui=lt.get(_e.$mlc),Gt=lt.get(et.$7kc),zt=lt.get(s.$1j),gt=lt.get(s.$Zj),Nt=lt.get($e.$ZCb),At=lt.get(i.$Ekc),Ot=lt.get(_t.$Kmc),ii=lt.get(ne.$wlc),Ht=lt.get(re.$dlc),ni=lt.get(pe.$Alc),Ft=lt.get($.$Okc),Rt=lt.get(ve.$tlc);He.set(n.$VM.ExtHostFileSystemInfo,ti),He.set(n.$VM.ExtHostLogLevelServiceShape,zt),He.set(n.$VM.ExtHostWorkspace,ft),He.set(n.$VM.ExtHostConfiguration,Bt),He.set(n.$VM.ExtHostExtensionService,Lt),He.set(n.$VM.ExtHostStorage,ui),He.set(n.$VM.ExtHostTunnelService,Nt),He.set(n.$VM.ExtHostWindow,Ot),He.set(n.$VM.ExtHostSecretState,ii),He.set(n.$VM.ExtHostTelemetry,jt),He.set(n.$VM.ExtHostEditorTabs,Ht),He.set(n.$VM.ExtHostManagedSockets,ni),He.set(n.$VM.ExtHostAuthentication,Ft),He.set(n.$VM.ExtHostChatProvider,Rt);const Pt=He.set(n.$VM.ExtHostDecorations,lt.get(I.$Plc)),Et=He.set(n.$VM.ExtHostDocumentsAndEditors,lt.get(K.$sP)),pt=He.set(n.$VM.ExtHostCommands,lt.get(E.$DP)),St=He.set(n.$VM.ExtHostTerminalService,lt.get(nt.$plc)),li=He.set(n.$VM.ExtHostTerminalShellIntegration,lt.get(at.$wmc)),Dt=He.set(n.$VM.ExtHostDebugService,lt.get(C.$Jlc)),hi=He.set(n.$VM.ExtHostSearch,lt.get(ee.$6lc)),Kt=He.set(n.$VM.ExtHostTask,lt.get(tt.$vmc)),bi=He.set(n.$VM.ExtHostOutputService,lt.get(Ce.$imc)),ei=He.set(n.$VM.ExtHostLocalization,lt.get(ke.$zlc)),wi=He.set(n.$VM.ExtHostUrls,new It.$Hmc(He)),yt=He.set(n.$VM.ExtHostDocuments,new j.$Lkc(He,Et)),$i=He.set(n.$VM.ExtHostDocumentContentProviders,new q.$Rlc(He,Et,gt)),we=He.set(n.$VM.ExtHostDocumentSaveParticipant,new A.$Slc(gt,yt,He.getProxy(n.$UM.MainThreadBulkEdits))),Se=He.set(n.$VM.ExtHostNotebook,new Q.$9lc(He,pt,Et,yt,Xt,hi)),oe=He.set(n.$VM.ExtHostNotebookDocuments,new le.$cmc(Se)),J=He.set(n.$VM.ExtHostNotebookEditors,new ue.$dmc(gt,Se)),De=He.set(n.$VM.ExtHostNotebookKernels,new Ne.$emc(He,bt,Se,pt,gt)),Ve=He.set(n.$VM.ExtHostNotebookRenderers,new he.$gmc(He,Se)),Ze=He.set(n.$VM.ExtHostNotebookDocumentSaveParticipant,new X.$bmc(gt,Se,He.getProxy(n.$UM.MainThreadBulkEdits))),qe=He.set(n.$VM.ExtHostEditors,new je.$Ukc(He,Et)),ut=He.set(n.$VM.ExtHostTreeViews,new Z.$Fmc(He.getProxy(n.$UM.MainThreadTreeViews),pt,gt)),kt=He.set(n.$VM.ExtHostEditorInsets,new u.$Vkc(He.getProxy(n.$UM.MainThreadEditorInsets),qe,bt.remote)),Tt=He.set(n.$VM.ExtHostDiagnostics,new W.$Kkc(He,gt,ti,Et)),Vt=He.set(n.$VM.ExtHostLanguages,new Te.$_lc(He,yt,pt.converter,qt)),ct=He.set(n.$VM.ExtHostLanguageFeatures,new x.$Mkc(He,qt,yt,pt,Tt,gt,At,jt)),ri=He.set(n.$VM.ExtHostFileSystem,new Ie.$Ulc(He,ct)),di=He.set(n.$VM.ExtHostFileSystemEventService,new me.$Vlc(He,gt,Et)),pi=He.set(n.$VM.ExtHostQuickOpen,(0,z.$mmc)(He,ft,pt)),Si=He.set(n.$VM.ExtHostSCM,new G.$omc(He,pt,yt,gt)),Ai=He.set(n.$VM.ExtHostQuickDiff,new U.$lmc(He,qt)),Mi=He.set(n.$VM.ExtHostShare,new Oe.$pmc(He,qt)),Fi=He.set(n.$VM.ExtHostComments,(0,f.$Wkc)(He,pt,yt)),Ni=He.set(n.$VM.ExtHostProgress,new ze.$kmc(He.getProxy(n.$UM.MainThreadProgress))),cn=He.set(n.$VM.ExtHostLabelService,new L.$$lc(He)),Oi=He.set(n.$VM.ExtHostTheming,new st.$Cmc(He)),Ti=He.set(n.$VM.ExtHostTimeline,new Y.$Emc(He,pt)),yi=He.set(n.$VM.ExtHostWebviews,new Qt.$$kc(He,bt.remote,ft,gt,At)),Ii=He.set(n.$VM.ExtHostWebviewPanels,new Ut.$blc(He,yi,ft)),Hi=He.set(n.$VM.ExtHostCustomEditors,new w.$clc(He,yt,Gt,yi,Ii)),Ki=He.set(n.$VM.ExtHostWebviewViews,new xt.$Imc(He,yi)),vi=He.set(n.$VM.ExtHostTesting,new mt.$ymc(He,gt,pt,Et)),Ji=He.set(n.$VM.ExtHostUriOpeners,new ot.$Gmc(He)),Qi=He.set(n.$VM.ExtHostProfileContentHandlers,new Fe.$jmc(He));He.set(n.$VM.ExtHostInteractive,new ie.$0lc(He,Se,Et,pt,gt));const un=He.set(n.$VM.ExtHostInlineChat,new Re.$Wlc(He,pt,yt,gt)),Li=He.set(n.$VM.ExtHostChatAgents2,new v.$Rkc(He,gt,pt)),zi=He.set(n.$VM.ExtHostChatVariables,new d.$Skc(He)),Ci=He.set(n.$VM.ExtHostAiRelatedInformation,new c.$Dkc(He)),ln=He.set(n.$VM.ExtHostAiEmbeddingVector,new ae.$Tlc(He)),Zi=He.set(n.$VM.ExtHostStatusBar,new Qe.$smc(He,pt.converter)),Yi=He.set(n.$VM.ExtHostSpeech,new Be.$qmc(He)),hn=Object.values(n.$VM);He.assertRegistered(hn);const Ui=new a.$Qkc(He,Et),Xi=new P.$Tkc(He),Pi=new fe.$amc(He,gt),ji=new V.$Qlc(He);return h.$Nkc.register(pt),function(Ue,oi,Bi){function xe(_){return(se,Le,rt)=>{const wt=_(Mt=>{try{se.call(Le,Mt)}catch(Di){F.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),jt.onExtensionError(Ue.identifier,Di)}});return rt?.push(wt),wt}}const vt=function(){let _=!Ue.isUnderDevelopment;function se(){_||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")se();else{const wt=rt;typeof wt.scheme>"u"&&se(),typeof wt.exclusive=="boolean"&&(0,Ye.$CG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$CG)(Ue,"authLearnMore"),Ft.getSession(Ue,_,se,Le)},getSessions(_,se){return(0,Ye.$CG)(Ue,"authGetSessions"),Ft.getSessions(Ue,_,se)},async hasSession(_,se){return(0,Ye.$CG)(Ue,"authSession"),!!await Ft.getSession(Ue,_,se,{silent:!0})},get onDidChangeSessions(){return xe(Ft.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,rt){return Ft.registerAuthenticationProvider(_,se,Le,rt)}},ai={registerCommand(_,se,Le){return pt.registerCommand(!0,_,se,Le,void 0,Ue)},registerTextEditorCommand(_,se,Le){return pt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(Mt=>{se.apply(Le,[wt,Mt,...rt])}).then(Mt=>{Mt||gt.warn("Edits from command "+_+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+_,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,se,Le)=>((0,Ye.$CG)(Ue,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const wt=Et.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Mt=await qe.getDiffInformation(wt.id);se.apply(Le,[Mt,...rt])},void 0,void 0,Ue)),executeCommand(_,...se){return pt.executeCommand(_,...se)},getCommands(_=!1){return pt.getCommands(_)}},ki={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Xi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$CG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$CG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$AP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return it.$zP.validateSender(_),jt.instantiateLogger(Ue,_,se)},openExternal(_,se){return Ot.openUri(_,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===bt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!bt.remote.authority})}catch(se){if((0,M.$Cg)(_,M.Schemas.http)||(0,M.$Cg)(_,M.Schemas.https))return _;throw se}},get remoteName(){return(0,o.$Fm)(bt.remote.authority)},get remoteAuthority(){return(0,Ye.$CG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$CG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,Ye.$CG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(_,se,Le){return vi.createTestController(Ue,_,se,Le)},createTestObserver(){return(0,Ye.$CG)(Ue,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ye.$CG)(Ue,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ye.$CG)(Ue,"testObserver"),xe(vi.onResultsChanged)},get testResults(){return(0,Ye.$CG)(Ue,"testObserver"),vi.results}},Ei=bt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,se){(0,Ye.$BG)(Ue,"extensionsAny")||(se=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new be.$Flc(Lt,Ue.identifier,Le,Ei,!1);if(se){const rt=oi.all.getExtensionDescription(_);if(rt)return new be.$Flc(Lt,Ue.identifier,rt,Ei,!0)}},get all(){const _=[];for(const se of oi.mine.getAllExtensionDescriptions())_.push(new be.$Flc(Lt,Ue.identifier,se,Ei,!1));return _},get allAcrossExtensionHosts(){(0,Ye.$CG)(Ue,"extensionsAny");const _=new b.$Pm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);se.push(new be.$Flc(Lt,Ue.identifier,Le,Ei,rt))}return se},get onDidChange(){return(0,Ye.$BG)(Ue,"extensionsAny")?xe(R.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Tt.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return xe(Tt.onDidChangeDiagnostics)},getDiagnostics:_=>Tt.getDiagnostics(_),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(_,se){return Vt.changeLanguage(_.uri,se)},match(_,se){const Le=Ge.LanguageSelector.from(_);let rt;return(0,N.$1t)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Mt=>Mt.document===se))?.apiNotebook),(0,N.$Zt)(Le,se.uri,se.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,se,Le){return ct.registerCodeActionProvider(Ue,vt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Ye.$CG)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,vt(_),se,Le)},registerCodeLensProvider(_,se){return ct.registerCodeLensProvider(Ue,vt(_),se)},registerDefinitionProvider(_,se){return ct.registerDefinitionProvider(Ue,vt(_),se)},registerDeclarationProvider(_,se){return ct.registerDeclarationProvider(Ue,vt(_),se)},registerImplementationProvider(_,se){return ct.registerImplementationProvider(Ue,vt(_),se)},registerTypeDefinitionProvider(_,se){return ct.registerTypeDefinitionProvider(Ue,vt(_),se)},registerHoverProvider(_,se){return ct.registerHoverProvider(Ue,vt(_),se,Ue.identifier)},registerEvaluatableExpressionProvider(_,se){return ct.registerEvaluatableExpressionProvider(Ue,vt(_),se,Ue.identifier)},registerInlineValuesProvider(_,se){return ct.registerInlineValuesProvider(Ue,vt(_),se,Ue.identifier)},registerDocumentHighlightProvider(_,se){return ct.registerDocumentHighlightProvider(Ue,vt(_),se)},registerMultiDocumentHighlightProvider(_,se){return ct.registerMultiDocumentHighlightProvider(Ue,vt(_),se)},registerLinkedEditingRangeProvider(_,se){return ct.registerLinkedEditingRangeProvider(Ue,vt(_),se)},registerReferenceProvider(_,se){return ct.registerReferenceProvider(Ue,vt(_),se)},registerRenameProvider(_,se){return ct.registerRenameProvider(Ue,vt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Ye.$CG)(Ue,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(Ue,vt(_),se)},registerDocumentSymbolProvider(_,se,Le){return ct.registerDocumentSymbolProvider(Ue,vt(_),se,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,se){return ct.registerDocumentFormattingEditProvider(Ue,vt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return ct.registerDocumentRangeFormattingEditProvider(Ue,vt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,vt(_),se,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,se,Le){return ct.registerDocumentSemanticTokensProvider(Ue,vt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,vt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,vt(_),se,Le):ct.registerSignatureHelpProvider(Ue,vt(_),se,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,se,...Le){return ct.registerCompletionItemProvider(Ue,vt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Ye.$CG)(Ue,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$CG)(Ue,"inlineCompletionsAdditions"),Le&&(0,Ye.$CG)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,vt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Ye.$CG)(Ue,"inlineEdit"),ct.registerInlineEditProvider(Ue,vt(_),se)},registerDocumentLinkProvider(_,se){return ct.registerDocumentLinkProvider(Ue,vt(_),se)},registerColorProvider(_,se){return ct.registerColorProvider(Ue,vt(_),se)},registerFoldingRangeProvider(_,se){return ct.registerFoldingRangeProvider(Ue,vt(_),se)},registerSelectionRangeProvider(_,se){return ct.registerSelectionRangeProvider(Ue,_,se)},registerCallHierarchyProvider(_,se){return ct.registerCallHierarchyProvider(Ue,_,se)},registerTypeHierarchyProvider(_,se){return ct.registerTypeHierarchyProvider(Ue,_,se)},setLanguageConfiguration:(_,se)=>ct.setLanguageConfiguration(Ue,_,se),getTokenInformationAtPosition(_,se){return(0,Ye.$CG)(Ue,"tokenInformation"),Vt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return ct.registerInlayHintsProvider(Ue,_,se)},createLanguageStatusItem(_,se){return Vt.createLanguageStatusItem(Ue,_,se)},registerDocumentDropEditProvider(_,se,Le){return ct.registerDocumentOnDropEditProvider(Ue,_,se,(0,Ye.$BG)(Ue,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,se,Le){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&At.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(Vi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,se,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,se,Le){return xe(qe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return xe(qe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return xe(qe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return xe(St.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return xe(St.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return xe(St.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Ye.$CG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return xe(St.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Ye.$CG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Ye.$CG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Ye.$CG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Ye.$CG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Ye.$CG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Ot.getState()},onDidChangeWindowState(_,se,Le){return xe(Ot.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return Pi.showMessage(Ue,p.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return Pi.showMessage(Ue,p.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return Pi.showMessage(Ue,p.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return pi.showQuickPick(Ue,_,se,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,se){return pi.showInput(_,se)},showOpenDialog(_){return ji.showOpenDialog(Ue,_)},showSaveDialog(_){return ji.showSaveDialog(_)},createStatusBarItem(_,se,Le){let rt,wt,Mt;return typeof _=="string"?(rt=_,wt=se,Mt=Le):(wt=_,Mt=se),Zi.createStatusBarEntry(Ue,rt,wt,Mt)},setStatusBarMessage(_,se){return Zi.setStatusBarMessage(_,se)},withScmProgress(_){return At.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ni.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(se,Le)=>_({report(rt){}}))},withProgress(_,se){return Ni.withProgress(Ue,_,se)},createOutputChannel(_,se){return bi.createOutputChannel(_,se,Ue)},createWebviewPanel(_,se,Le,rt){return Ii.createWebviewPanel(Ue,_,se,Le,rt)},createWebviewTextEditorInset(_,se,Le,rt){return(0,Ye.$CG)(Ue,"editorInsets"),kt.createWebviewEditorInset(_,se,Le,rt,Ue)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return St.registerProfileProvider(Ue,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Ye.$CG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,se)},registerTreeDataProvider(_,se){return ut.registerTreeDataProvider(_,se,Ue)},createTreeView(_,se){return ut.createTreeView(_,se,Ue)},registerWebviewPanelSerializer:(_,se)=>Ii.registerWebviewPanelSerializer(Ue,_,se),registerCustomEditorProvider:(_,se,Le={})=>Hi.registerCustomEditorProvider(Ue,_,se,Le),registerFileDecorationProvider(_){return Pt.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return wi.registerUriHandler(Ue,_)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return xe(Oi.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Ki.registerWebviewViewProvider(Ue,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return xe(J.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return xe(J.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return Se.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Ye.$CG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Ye.$CG)(Ue,"profileContentHandlers"),Qi.registerProfileContentHandler(Ue,_,se)},registerQuickDiffProvider(_,se,Le,rt){return(0,Ye.$CG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(vt(_),se,Le,rt)},get tabGroups(){return Ht.tabGroups},registerShareProvider(_,se){return(0,Ye.$CG)(Ue,"shareProvider"),Mi.registerShareProvider(vt(_),se)}},Vi={get rootPath(){return At.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new F.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new F.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>ft.updateWorkspaceFolders(Ue,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return xe(ft.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>ft.getRelativePath(_,se),findFiles:(_,se,Le,rt)=>ft.findFiles(_,se,Le,Ue.identifier,rt),findFiles2:(_,se,Le)=>((0,Ye.$CG)(Ue,"findFiles2"),ft.findFiles2(_,se,Ue.identifier,Le)),findTextInFiles:(_,se,Le,rt)=>{(0,Ye.$CG)(Ue,"findTextInFiles");let wt,Mt;return typeof se=="object"?(wt=se,Mt=Le):(wt={},Mt=se,rt=Le),ft.findTextInFiles(_,wt||{},Mt,Ue.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,se){return Ui.applyWorkspaceEdit(_,Ue,se)},createFileSystemWatcher:(_,se,Le,rt)=>{let wt;return typeof se=="boolean"?wt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:se&&((0,Ye.$CG)(Ue,"createFileSystemWatcher"),wt={...se,correlate:!0}),di.createFileSystemWatcher(ft,Ue,_,wt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new F.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,se,Le)=>xe(yt.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>xe(yt.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>xe(yt.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>xe(yt.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>xe(we.getOnWillSaveTextDocumentEvent(Ue))(_,se,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(g.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=g.URI.revive(await Se.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return xe(oe.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return xe(oe.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return xe(Ze.getOnWillSaveNotebookDocumentEvent(Ue))(_,se,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,rt){return Se.registerNotebookSerializer(Ue,_,se,Le,(0,Ye.$BG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,se,Le)=>xe(Bi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Bi.getConfiguration(_,se,Ue)},registerTextDocumentContentProvider(_,se){return $i.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(At.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,_,se)),registerFileSystemProvider(_,se,Le){return(0,O.$Sc)(ri.registerFileSystemProvider(Ue,_,se,Le),Xt.addFileSystemProvider(_,se,Le))},get fs(){return Xt.value},registerFileSearchProvider:(_,se)=>((0,Ye.$CG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Ye.$CG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Ye.$CG)(Ue,"aiTextSearchProvider"),(0,Ye.$CG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Ye.$CG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Ye.$CG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ye.$CG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>xe(di.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>xe(di.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>xe(di.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>xe(di.getOnWillCreateFileEvent(Ue))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>xe(di.getOnWillDeleteFileEvent(Ue))(_,se,Le),onWillRenameFiles:(_,se,Le)=>xe(di.getOnWillRenameFileEvent(Ue))(_,se,Le),openTunnel:_=>((0,Ye.$CG)(Ue,"tunnels"),Nt.openTunnel(Ue,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ye.$CG)(Ue,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Ye.$CG)(Ue,"tunnels"),xe(Nt.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Ye.$CG)(Ue,"portsAttributes"),Nt.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Ye.$CG)(Ue,"tunnelFactory"),Nt.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Ye.$CG)(Ue,"timeline"),Ti.registerTimelineProvider(_,se,Ue.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ye.$CG)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Ye.$CG)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Ye.$CG)(Ue,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Ye.$CG)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Ye.$CG)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(_,se,Le))},tn={get inputBox(){return At.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(_,se,Le){return Si.createSourceControl(Ue,_,se,Le)}},gn={createCommentController(_,se){return Fi.createCommentController(Ue,_,se)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,Ye.$BG)(Ue,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Ye.$CG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ue,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Ye.$CG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationTree(Ue,_,se)},onDidStartDebugSession(_,se,Le){return xe(Dt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return xe(Dt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return xe(Dt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return xe(Dt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return xe(Dt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return(0,Ye.$CG)(Ue,"debugFocus"),xe(Dt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return Dt.registerDebugConfigurationProvider(_,se,Le||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return Dt.registerDebugAdapterDescriptorFactory(Ue,_,se)},registerDebugAdapterTrackerFactory(_,se){return Dt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Dt.startDebugging(_,se,{parentSession:Le}):Dt.startDebugging(_,se,Le||{})},stopDebugging(_){return Dt.stopDebugging(_)},addBreakpoints(_){return Dt.addBreakpoints(_)},removeBreakpoints(_){return Dt.removeBreakpoints(_)},asDebugSourceUri(_,se){return Dt.asDebugSourceUri(_,se)}},nn={registerTaskProvider:(_,se)=>Kt.registerTaskProvider(Ue,_,se),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(Ue,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,se,Le)=>xe(Kt.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>xe(Kt.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>xe(Kt.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>xe(Kt.onDidEndTaskProcess)(_,se,Le)},Wi={createNotebookController(_,se,Le,rt,wt){return De.createNotebookController(Ue,_,se,Le,rt,(0,Ye.$BG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>Se.registerNotebookCellStatusBarItemProvider(Ue,_,se),createRendererMessaging(_){return Ve.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Ye.$CG)(Ue,"notebookKernelSource"),De.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,se){return(0,Ye.$CG)(Ue,"notebookKernelSource"),De.registerKernelSourceActionProvider(Ue,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Ye.$CG)(Ue,"notebookCellExecutionState"),xe(De.onDidChangeNotebookCellExecutionState)(_,se,Le)}},rn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(Ue.identifier.value,{message:se,args:Le})}return ei.getMessage(Ue.identifier.value,_[0])},get bundle(){return ei.getBundle(Ue.identifier.value)},get uri(){return ei.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,se){return(0,Ye.$CG)(Ue,"interactive"),un.registerProvider(Ue,_,se)},transferActiveChat(_){return(0,Ye.$CG)(Ue,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,se){return(0,Ye.$CG)(Ue,"aiRelatedInformation"),Ci.getRelatedInformation(Ue,_,se)},registerRelatedInformationProvider(_,se){return(0,Ye.$CG)(Ue,"aiRelatedInformation"),Ci.registerRelatedInformationProvider(Ue,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Ye.$CG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,_,se)}},$n={registerChatResponseProvider(_,se,Le){return(0,Ye.$CG)(Ue,"chatProvider"),Rt.registerLanguageModel(Ue,_,se,Le)},registerChatVariableResolver(_,se,Le){return(0,Ye.$CG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,_,se,Le)},registerMappedEditsProvider(_,se){return(0,Ye.$CG)(Ue,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ue,_,se)},createChatParticipant(_,se){return(0,Ye.$CG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,_,se)},createDynamicChatParticipant(_,se,Le,rt){return(0,Ye.$CG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,_,se,Le,rt)}},pn={get languageModels(){return(0,Ye.$CG)(Ue,"languageModels"),Rt.getLanguageModelIds()},onDidChangeLanguageModels:(_,se,Le)=>((0,Ye.$CG)(Ue,"languageModels"),Rt.onDidChangeProviders(_,se,Le)),sendChatRequest(_,se,Le,rt){return(0,Ye.$CG)(Ue,"languageModels"),Rt.sendChatRequest(Ue,_,se,Le,rt)},computeTokenLength(_,se,Le){return(0,Ye.$CG)(Ue,"languageModels"),Le??=S.CancellationToken.None,Rt.computeTokenLength(_,se,Le)},getLanguageModelInformation(_){return(0,Ye.$CG)(Ue,"languageModels"),Rt.getLanguageModelInfo(_)}},an={registerSpeechProvider(_,se){return(0,Ye.$CG)(Ue,"speech"),Yi.registerProvider(Ue.identifier,_,se)}};return{version:bt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Wi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Vi,Breakpoint:ye.$WN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$RO,CallHierarchyIncomingCall:ye.$iN,CallHierarchyItem:ye.$hN,CallHierarchyOutgoingCall:ye.$jN,CancellationError:F.$5,CancellationTokenSource:S.$ne,CandidatePortSource:n.CandidatePortSource,CodeAction:ye.$eN,CodeActionKind:ye.$fN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$kN,Color:ye.$xN,ColorInformation:ye.$yN,ColorPresentation:ye.$zN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$rN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$sN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$HN,DebugAdapterExecutable:ye.$1N,DebugAdapterInlineImplementation:ye.$4N,DebugAdapterNamedPipeServer:ye.$3N,DebugAdapterServer:ye.$2N,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$hO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$$M,DiagnosticRelatedInformation:ye.$0M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$WM,DocumentHighlight:ye.$aN,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$bN,DocumentLink:ye.$wN,DocumentSymbol:ye.$dN,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$7N,InlineValueText:ye.$8N,InlineValueVariableLookup:ye.$9N,InlineValueEvaluatableExpression:ye.$0N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:R.$ce,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$jO,FileDecoration2:ye.$jO,FileSystemError:ye.$aO,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$bO,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$YN,InlineCompletionItem:ye.$tN,InlineCompletionList:ye.$uN,Hover:ye.$_M,IndentAction:y.IndentAction,Location:ye.$9M,MarkdownString:ye.$lN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:ye.$mN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$XM,ProcessExecution:ye.$FN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$iO,Range:ye.$YM,RelativePattern:ye.$UN,Selection:ye.$ZM,SelectionRange:ye.$gN,SemanticTokens:ye.$eO,SemanticTokensBuilder:ye.$dO,SemanticTokensEdit:ye.$fO,SemanticTokensEdits:ye.$gO,SemanticTokensLegend:ye.$cO,ShellExecution:ye.$GN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$oN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$nN,SnippetString:ye.$8M,SourceBreakpoint:ye.$XN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$cN,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$IN,TaskGroup:ye.$EN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$AN,TerminalQuickFixTerminalCommand:ye.$CN,TerminalQuickFixOpener:ye.$BN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$DN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$4M,SnippetTextEdit:ye.$6M,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$TN,ThemeIcon:ye.$SN,TreeItem:ye.$JN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$FO,UIKind:Zt.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$7M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$PN,DocumentDropOrPasteEditKind:ye.$QN,DocumentPasteEdit:ye.$RN,InlayHint:ye.$qN,InlayHintLabelPart:ye.$pN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$3M,ResolvedAuthority:ye.$1M,ManagedResolvedAuthority:ye.$2M,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$tO,NotebookRange:ye.$lO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$mO,NotebookData:ye.$nO,NotebookRendererScript:ye.$rO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$pO,NotebookCellOutputItem:ye.$oO,NotebookCellStatusBarItem:ye.$qO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$5M,NotebookKernelSourceAction:ye.$sO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$vO,LinkedEditingRanges:ye.$uO,TestResultState:ye.TestResultState,TestRunRequest:ye.$wO,TestMessage:ye.$xO,TestTag:ye.$yO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$ON,DataTransferItem:ye.$KN,TestCoverageCount:ye.$zO,FileCoverage:ye.$BO,StatementCoverage:ye.$CO,BranchCoverage:ye.$DO,DeclarationCoverage:ye.$EO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$GO,TabInputTextDiff:ye.$HO,TabInputTextMerge:ye.$IO,TabInputCustom:ye.$JO,TabInputNotebook:ye.$LO,TabInputNotebookDiff:ye.$MO,TabInputWebview:ye.$KO,TabInputTerminal:ye.$NO,TabInputInteractiveWindow:ye.$OO,TabInputChat:ye.$PO,TabInputTextMultiDiff:ye.$QO,TelemetryTrustedValue:r.$cp,LogLevel:s.LogLevel,EditSessionIdentityMatch:t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$5N,Thread:ye.$6N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$SO,ChatResponseFileTreePart:ye.$VO,ChatResponseAnchorPart:ye.$WO,ChatResponseProgressPart:ye.$XO,ChatResponseReferencePart:ye.$ZO,ChatResponseTextEditPart:ye.$1O,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$TO,ChatResponseCommandButtonPart:ye.$YO,ChatResponseDetectedParticipantPart:ye.$UO,ChatRequestTurn:ye.$2O,ChatResponseTurn:ye.$3O,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$4O,LanguageModelChatUserMessage:ye.$5O,LanguageModelChatAssistantMessage:ye.$6O,LanguageModelSystemMessage:ye.$4O,LanguageModelUserMessage:ye.$5O,LanguageModelAssistantMessage:ye.$6O,LanguageModelError:ye.$7O,NewSymbolName:ye.$_N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$8O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Pe[297],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,S,F,R,O,M,p,g,k,N,y,l,b,m,s,o,r,t,n,c,h,i,$,a,v,d,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$ts)(v.$zlc,v.$ylc,1),(0,S.$ts)($.$1j,i.$Mmc,1),(0,S.$ts)(s.$Ekc,s.$Fkc,1),(0,S.$ts)(p.$DP,p.$CP,0),(0,S.$ts)(P.$Okc,P.$Pkc,0),(0,S.$ts)(u.$tlc,u.$ulc,0),(0,S.$ts)(M.$4kc,M.$2kc,0),(0,S.$ts)(r.$6kc,r.$5kc,0),(0,S.$ts)(y.$Jlc,y.$Nlc,0),(0,S.$ts)(O.$Plc,O.$Olc,0),(0,S.$ts)(g.$sP,g.$rP,0),(0,S.$ts)(d.$Alc,d.$Blc,0),(0,S.$ts)(t.$Ikc,t.$Hkc,0),(0,S.$ts)(F.$imc,F.$hmc,1),(0,S.$ts)(l.$6lc,l.$7lc,0),(0,S.$ts)(b.$mlc,b.$llc,0),(0,S.$ts)(N.$vmc,N.$umc,0),(0,S.$ts)(k.$plc,k.$slc,0),(0,S.$ts)(E.$wmc,E.$xmc,0),(0,S.$ts)(m.$ZCb,m.$1Cb,0),(0,S.$ts)(o.$Kmc,o.$Jmc,0),(0,S.$ts)(R.$1kc,R.$Zkc,0),(0,S.$ts)(n.$wlc,n.$vlc,0),(0,S.$ts)(c.$BP,c.$yP,0),(0,S.$ts)(h.$dlc,h.$elc,0),(0,S.$ts)(a.$Hlc,a.$Ilc,0)}),define(Pe[298],Ae([1,0,296,39,2,293,7,11,242]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class k extends O.$Pmc{j(){}getModule(b,m){for(const s of this.b){const o=s(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends F.$Dlc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$Voc);const b=this.h.invokeFunction(S.$Lmc);this.r=this.h.createInstance(k,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,m,s){m=m.with({path:y(m.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const r=R.URI.revive(await this.C.$asBrowserUri(m)),t=await fetch(r.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),t.status!==200)throw new Error(t.statusText);const n=await t.text(),c=`${m.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(d){throw console.error(o?`Loading code for extension ${o} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${m.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}b&&await this.w.initializeLocalizedMessages(b);const $={},a={exports:$},v=d=>{const P=this.r.getModule(d,m);if(P===void 0)throw new Error(`Cannot load module '${d}'`);return P};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,$,v),a.exports!==$?a.exports:$}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$uh)(10)}}e.$Woc=N;function y(l,b){return l.endsWith(b)?l:l+b}}),define(Pe[299],Ae([1,0,70,55,13,39,206,85,298]),function(ge,e,S,F,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$ts)(R.$Zj,new S.$qi(M.$Omc,[!0],!0)),(0,F.$ts)(O.$Elc,g.$Woc,0),(0,F.$ts)(p.$7kc,p.$8kc,0)}),define(Pe[305],Ae([1,0,22,5,77,294,244,19,89,12,2,297,299]),function(ge,e,S,F,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function($,a){return $ instanceof Request||b(String($))&&($=(await i(N.URI.parse(String($)))).toString(!0)),m($,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,a,v,d,P){(async()=>(b(a.toString())&&(a=(await i(N.URI.parse(a.toString()))).toString(!0)),super.open($,a,v??!0,d,P)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function($,a){if(/^file:/i.test($.toString()))$=k.$Ng.uriToBrowserUri(N.URI.parse($.toString())).toString(!0);else if(/^vscode-remote:/i.test($.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(f){function D(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const w=fetch.bind(self);self.fetch=function(I,W){return I instanceof Request?w(I,W):w(D(I),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,W,V,q,A){return super.open(I,D(W),V??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...I)=>{C(...I.map(D))},C(f)}.toString()}('${$}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$oc($.toString())}`;const P=new Blob([d],{type:"application/javascript"}),u=URL.createObjectURL(P);return new i(u,a)}}else self.Worker=class extends M.$Xoc{constructor(i,$){super(l,i,{name:p.$oc(i.toString()),...$})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class r{constructor(){const $=new MessageChannel,a=new F.$ce;let v=!1;l($.port2,[$.port2]),$.port1.onmessage=d=>{const{data:P}=d;if(!(P instanceof ArrayBuffer)){console.warn("UNKNOWN data received",P);return}const u=S.$De.wrap(new Uint8Array(P,0,P.byteLength));if((0,R.$Xm)(u,2)){v=!0,n("received terminate message from renderer");return}a.fire(u)},this.protocol={onMessage:a.event,send:d=>{if(!v){const P=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);$.port1.postMessage(P,[P])}}}}}function t(i){return new Promise($=>{const a=i.onMessage(v=>{a.dispose();const d=JSON.parse(v.toString());i.send((0,R.$Wm)(0)),$({protocol:i,initData:d})});i.send((0,R.$Wm)(1))})}let n=i=>y();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage($){c($)&&t(i.protocol).then(a=>{g.mark("code/extHost/didWaitForInitData");const v=new O.$Rmc(a.protocol,a.initData,o,null,$.data);s(d=>v.asBrowserUri(d)),n=d=>v.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/59d84c5c8cecf22b24e316c5443dc3ec49462589/core/vs/workbench/api/worker/extensionHostWorker.js.map
